--- 本地通讯命令的抽象类
local T=Class.AbstractLocalCommand()

function T:def()
--通道(频道,端口)
-- self.channel=nil;

--完成后的回调
-- self._completeCallback=nil;
end

--- 构造函数
function T:ctor(channel)
	self.channel=channel
end

--- 封装数据
function T:encode()

end

--- 解析数据
function T:decode(data)

end

--- 通讯完成,执行回调
function T:complete(...)
	if self._completeCallback then
		self._completeCallback(...)

		self._completeCallback=nil
	end
end

--- 执行
function T:exec(callback)
	self._completeCallback=callback

	Adapter_local:send(
		self:encode(),
		self.channel,
		function(data)
			self:complete(self:decode(data))
		end
	)
end

--- 不编解码传输数据
function T:execNoCode(data,callback)
	Adapter_local:send(
		data,
		self.channel,
		callback
	)
end

return T
