--- 本地通讯转发器(模拟服务器实现,以便代码向服务器移植)
local T=Class.Adapter_local()

--- 广播处理器列表
T.broadcastChannelHandlers={}

--- 频道处理器列表
T.channelHandlers={}

--- 添加广播侦听器
-- @param channel 频道
-- @param handler 处理函数
function T:addBroadcastChannelListener(channel,handler)
    self.broadcastChannelHandlers[channel]=handler
end

--- 发送信息
-- @param data 数据
-- @param channel 频道
-- @param completeCallback 完成请求后的回调
function T:send(data,channel,completeCallback)
    local handlers=self.channelHandlers
    if handlers[channel] then
        if completeCallback then
            completeCallback(handlers[channel](data))
        else
            handlers[channel](data)
        end
    end
end

--- 写入数据(到客户端)
function T:write(channel,data)
    local method=self.broadcastChannelHandlers[channel]
    if method then
        method(data)
    end
end

--- 添加从客户端收到数据的处理函数
function T:addChannel(channel,handler)
    self.channelHandlers[channel]=handler
end

--- 移除从客户端收到数据的处理函数
function T:rmChannel(channel)
	self.channelHandlers[channel]=nil
end

return T
