--- 初始化通讯配置
local InitCommunication={}

function InitCommunication:exec(adapter)
	ChannelIds=require("src.app.communication.ChannelIds")
	ReturnCode=require("src.app.communication.ReturnCode")
	ErrorCode=require("src.app.communication.ErrorCode")

	local CommunicationWaitingMask=require("src.app.uiScript.components.common.CommunicationWaitingMask")

	AbstractC2SCommand:setStaticInitAdapter(adapter)
	AbstractC2SCommand:setStaticUiMask(CommunicationWaitingMask())

	AbstractC2SCommand1:setStaticInitAdapter(adapter)
	AbstractC2SCommand1:setStaticUiMask(CommunicationWaitingMask())

	-------------------- 广播 ------------------------------------------
	S2CDataUpdate=require("src.app.communication.broadcast.S2CDataUpdate")
	--------------------------------------------------------------------

	BroadcastRegister=require("src.app.communication.BroadcastRegister")
	BroadcastRegister:setStaticAdapter(adapter)
	BroadcastRegister:regBroadcast()

	-------------------- 本地广播 --------------------------------------
	Local_BroadcastFight=require("src.app.communication.broadcast.Local_BroadcastFight")
	--------------------------------------------------------------------

	--- 本地模拟通讯转发器
	Adapter_local=require("src.app.communication.Adapter_local")
	BroadcastRegister:regLocalBroadcast()


	-------------------- 建筑物升级相关命令 ---------------------------------

	CancleUpgradeCommand = require("src.app.communication.buildingUpgrade.CancleUpgradeCommand")
	SpeedUpgradeCommand = require("src.app.communication.buildingUpgrade.SpeedUpgradeCommand")
	UpgradeCommand = require("src.app.communication.buildingUpgrade.UpgradeCommand")
	UpgradeImmediatelyCommand = require("src.app.communication.buildingUpgrade.UpgradeImmediatelyCommand")
	ConstructCommand = require("src.app.communication.buildingUpgrade.ConstructCommand")
	BuyBuildingQueueCommand = require("src.app.communication.buildingUpgrade.BuyBuildingQueueCommand")

	-------------------- 建筑物升级相关命令 ---------------------------------

	-------------------- 科研中心研究升级相关命令 ---------------------------------

	CancelLevelUpTechnologyCommand = require("src.app.communication.scienceUpgrade.CancelLevelUpTechnologyCommand")
	ClearTechnologyTimeCammand = require("src.app.communication.scienceUpgrade.ClearTechnologyTimeCammand")
	LevelUpTechnologyCommand = require("src.app.communication.scienceUpgrade.LevelUpTechnologyCommand")

	-------------------- 科研中心研究升级相关命令 ---------------------------------

	WorldMapScoutComman = require("src.app.communication.worldMap.WorldMapScoutComman")

	--- 技能升级命令
	SkillLevelUpCommand = require("src.app.communication.playerInfo.SkillLevelUpCommand")
	--- 技能重置命令
	SkillResetCommand = require("src.app.communication.playerInfo.SkillResetCommand")
	--- 买能量
	BuyEnergyCommand = require("src.app.communication.playerInfo.BuyEnergyCommand")
	--- 指挥升级
	DominanceLevelUpCommand = require("src.app.communication.playerInfo.DominanceLevelUpCommand")
	--- 增加声望
	ReputationAddCommand = require("src.app.communication.playerInfo.ReputationAddCommand")
	--- 钻石增加声望
	BuyReputationCommand = require("src.app.communication.playerInfo.BuyReputationCommand")
	--- 改变头像
	ChangeHeadCommand = require("src.app.communication.playerInfo.ChangeHeadCommand")

	--------------------任务相关命令------------------------
	GetTaskCommand = require("src.app.communication.task.GetTaskCommand")
	FinishTaskCommand = require("src.app.communication.task.FinishTaskCommand")

	StartDailyTaskCommand = require("src.app.communication.task.StartDailyTaskCommand")
	FinishDailyTaskCommand = require("src.app.communication.task.FinishDailyTaskCommand")
	FreshDailyTaskCommand = require("src.app.communication.task.FreshDailyTaskCommand")
	SpeedDailyTaskCommand = require("src.app.communication.task.SpeedDailyTaskCommand")

	--------------------活动相关命令------------------------
	CheckMysteriousGiftCommand = require("src.app.communication.activity.CheckMysteriousGiftCommand")
	GetMysteriousGiftCommand = require("src.app.communication.activity.GetMysteriousGiftCommand")

	CheckReinforceCommand = require("src.app.communication.reinforce.CheckReinforceCommand")
	GetReinforceCommand = require("src.app.communication.reinforce.GetReinforceCommand")

	---------------------道具相关命令---------------------------

	UseAndBuyPropCommand = require("src.app.communication.prop.UseAndBuyPropCommand")
	UsePropCommand = require("src.app.communication.prop.UsePropCommand")
	BuyPropCommand = require("src.app.communication.prop.BuyPropCommand")
	---------------------道具相关命令---------------------------

	---------------------招募或者改造相关命令---------------------------
	CancleRecruitCommand = require("src.app.communication.aircraftFactory.CancleRecruitCommand")
	GemsRecruitCommand = require("src.app.communication.aircraftFactory.GemsRecruitCommand")
	RecruitCommand = require("src.app.communication.aircraftFactory.RecruitCommand")
	SpeedRecruitCommand = require("src.app.communication.aircraftFactory.SpeedRecruitCommand")


	---------------------招募或者改造道具相关命令---------------------------

	---------------------邮件相关命令---------------------------

	DeleteAllMailCommand = require("src.app.communication.mail.DeleteAllMailCommand")
	DeleteMailCommand = require("src.app.communication.mail.DeleteMailCommand")
	GetSysAwardCommand = require("src.app.communication.mail.GetSysAwardCommand")
	PlayBackCommand = require("src.app.communication.mail.PlayBackCommand")
	PlayBackOtherCommand = require("src.app.communication.mail.PlayBackOtherCommand")
	ReadMailCommand = require("src.app.communication.mail.ReadMailCommand")
	SendMailCommand = require("src.app.communication.mail.SendMailCommand")
	GetTenMailCommand = require("src.app.communication.mail.GetTenMailCommand")
	ReadOtherReportCommand = require("src.app.communication.mail.ReadOtherReportCommand")
	RevengeCommand = require("src.app.communication.mail.RevengeCommand")
	RevengeCommand = require("src.app.communication.mail.RevengeCommand")
	SendAllianceMailCommand = require("src.app.communication.alliance.SendAllianceMailCommand")
	BatchDeleteMailCommand = require("src.app.communication.mail.BatchDeleteMailCommand")

	---------------------邮件相关命令---------------------------


	---------------------聊天相关命令---------------------------

	WorldChatCommand = require("src.app.communication.chat.WorldChatCommand")
	GroupChatCommand = require("src.app.communication.chat.GroupChatCommand")
	PrivateChatCommand = require("src.app.communication.chat.PrivateChatCommand")
	ShareReportCommand = require("src.app.communication.chat.ShareReportCommand")

	---------------------聊天相关命令---------------------------


	---------------------社交相关命令---------------------------

	CheckChatInfoCommand = require("src.app.communication.socialContact.CheckChatInfoCommand")
	AddBlackListCommand = require("src.app.communication.socialContact.AddBlackListCommand")
	AddFriendCommand = require("src.app.communication.socialContact.AddFriendCommand")
	DeleteBlackListCommand = require("src.app.communication.socialContact.DeleteBlackListCommand")
	DeleteFriendCommand = require("src.app.communication.socialContact.DeleteFriendCommand")


	---------------------社交相关命令---------------------------

	---------------------部队任务相关命令---------------------------

	SendArmyCommand = require("src.app.communication.army.SendArmyCommand")
	SpeedCollectCommand = require("src.app.communication.army.SpeedCollectCommand")
	WithdrawCommand = require("src.app.communication.army.WithdrawCommand")

	SetDefenceCommand = require("src.app.communication.army.SetDefenceCommand")


	RepairAllArmyCommand = require("src.app.communication.army.RepairAllArmyCommand")
	RepairSingleArmyCommand = require("src.app.communication.army.RepairSingleArmyCommand")


	---------------------部队任务相关命令---------------------------



	---------------------排行榜相关命令---------------------------

	SendRankCommand = require("src.app.communication.rank.SendRankCommand")

	---------------------排行榜相关命令---------------------------


	---------------------活动相关命令---------------------------

	-- 每日签到
	DailyAttendanceCommand = require("src.app.communication.allActivity.sign.DailyAttendanceCommand")
	-- 连续签到
	ContinueAttendanceCommand = require("src.app.communication.allActivity.sign.ContinueAttendanceCommand")
	-- 购买成长计划
	BuyGrowthPlanCommand = require("src.app.communication.allActivity.fixAndDynamic.growthPlan.BuyGrowthPlanCommand")
	-- 得到成长计划钻石
	GetGrowthPlanAwardCommand = require("src.app.communication.allActivity.fixAndDynamic.growthPlan.GetGrowthPlanAwardCommand")
	-- 领取等级礼包奖励
	GetGradePackageAwardCommand = require("src.app.communication.allActivity.fixAndDynamic.gradePackage.GetGradePackageAwardCommand")
	-- 领取开服豪礼奖励
	GetOpenServerAwardCommand = require("src.app.communication.allActivity.fixAndDynamic.openServer.GetOpenServerAwardCommand")
	-- 动态活动相关
	GetDynamicDataCommand = require("src.app.communication.allActivity.fixAndDynamic.dynamic.GetDynamicDataCommand")    -- 领取开服豪礼奖励
	JoinDynamicCommand = require("src.app.communication.allActivity.fixAndDynamic.dynamic.JoinDynamicCommand")

	-- 购买瓶盖命令
	BuyBottleCapCommand = require("src.app.communication.allActivity.luckyLottery.BuyBottleCapCommand")
	-- 幸运抽奖命令
	LotteryCommand = require("src.app.communication.allActivity.luckyLottery.LotteryCommand")


	---------------------活动相关命令---------------------------

	--- 建筑时间完成，生产和改造飞机，科研完成，分别发送以上3个消息到后台（除了一键秒以外）

	SendAircraftQueueCommand = require("src.app.communication.army.SendAircraftQueueCommand")
	SendBuildQueueCommand = require("src.app.communication.army.SendBuildQueueCommand")
	SendScienceQueueCommand = require("src.app.communication.army.SendScienceQueueCommand")


	---------------------内购相关命令---------------------------
	if CUR_SDK then
		if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
			GetGoodsListInfoCommand = require("src.app.communication.iap.GetGoodsListInfoCommand_enjoyGame")
		elseif CUR_SDK == SDKType.PLATFORM_TENGLONG_1 then
			GetGoodsListInfoCommand = require("src.app.communication.iap.GetGoodsListInfoCommand_1")
		elseif CUR_SDK == SDKType.PLATFORM_UC then
			GetGoodsListInfoCommand = require("src.app.communication.iap.GetGoodsListInfoCommand_uc")
		elseif CUR_SDK == SDKType.PLATFORM_HUA_WEI then
			GetGoodsListInfoCommand = require("src.app.communication.iap.GetGoodsListInfoCommand_huaWei")
		elseif CUR_SDK == SDKType.PLATFORM_VIVO then
			GetGoodsListInfoCommand = require("src.app.communication.iap.GetGoodsListInfoCommand_vivo")
		end
	else
		GetGoodsListInfoCommand = require("src.app.communication.iap.GetGoodsListInfoCommand")
	end
	PayGoodsCommand = require("src.app.communication.iap.PayGoodsCommand")
	GetNewRechargeCommand = require("src.app.communication.iap.GetNewRechargeCommand")

	---------------------内购相关命令---------------------------




	---------------------配件系统相关命令---------------------------
	InstallAccessoryCommand = require("src.app.communication.accessory.InstallAccessoryCommand")
	UnloadAccessoryCommand = require("src.app.communication.accessory.UnloadAccessoryCommand")
	LevelUpAccessoryCommand = require("src.app.communication.accessory.LevelUpAccessoryCommand")
	ReformAccessoryCommand = require("src.app.communication.accessory.ReformAccessoryCommand")
	DecomposeAccessoryCommand = require("src.app.communication.accessory.DecomposeAccessoryCommand")
	DecomposeBluePrintCommand = require("src.app.communication.accessory.DecomposeBluePrintCommand")
	ExchangeBluePrintCommand = require("src.app.communication.accessory.ExchangeBluePrintCommand")
	BatchDecomposeAccessoryCommand = require("src.app.communication.accessory.BatchDecomposeAccessoryCommand")
	MakeAccessoryCommand = require("src.app.communication.accessory.MakeAccessoryCommand")
	MakeAndInstallAccessoryCommand = require("src.app.communication.accessory.MakeAndInstallAccessoryCommand")

	---------------------配件系统相关命令---------------------------


	AccessoryDrawCardCommand = require("src.app.communication.accessoryDrawCard.AccessoryDrawCardCommand")



end


return InitCommunication
