--[[
    批量分解模块
]]
local T = extend(AbstractC2SCommand)

T.type = 8

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    local qualityValue = AccessorySystemManager:getAccessoryBox():getBatchDecomposeAccQuality(self.quality) -- 这是那个算法
    data:writeInt(qualityValue)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then
        -- 移除对应品质的所有没使用的配件
        AccessorySystemManager:getAccessoryBox():batchDecomposeAccessoryByQuality(self.quality)

        awardData = self.AwardDataDecoder:decode(data)  -- 这里获得的蓝图发放就行了
        self.AwardDataDecoder:addAWard(awardData) -- 发放
    end
    
    return state,awardData
end

function T:exec(quality,callback) -- quality是一个表,调用接口，有个算法就行了
    self.quality = quality
    self.super.exec(self,callback)
end

return T
