--[[
    挑战补给线
]]
local T = extend(AbstractC2SCommand1)

T.type = 10

--- 战斗初始化数据解码器
T.FightInitDataDecoder=require("src.app.communication.fight.FightInitDataDecoder")

--- 奖励数据解析
T.AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")

function T:ctor()
    AbstractC2SCommand1.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeByte(self.sid)

    local aircraftList=self.aircraftList
    for i=1,6,1 do
    	local item=aircraftList[i]
    	if item then
    		data:writeShort(item.sid)
    		data:writeShort(item.count)
    	else
    		data:writeShort(0)
    	end
    end

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then
        local r={}
    
    	r.fightInitData=self.FightInitDataDecoder:decode(data)
        r.endData={}
    	r.endData.isWinner=data:readBoolean()
    	if r.endData.isWinner then
            r.endData.starNum = data:readUnsignedByte()
    		r.endData.awardData=self.AwardDataDecoder:decode(data)

            SupplyLineManager:setSupplyInfoBySid(self.sid,r.endData.starNum)
    	end
   
        return state,r
    end

    return state
end

function T:exec(sid,aircraftList,callback)
    self.sid = sid
    self.aircraftList = aircraftList
    self.super.exec(self,callback)
end

return T
