--[[
    分解配件
]]
local T = extend(AbstractC2SCommand)

T.type = 5

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.id)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then
        AccessorySystemManager:getAccessoryBox():decomposeAccessory(self.id)

        awardData = self.AwardDataDecoder:decode(data)
        self.AwardDataDecoder:addAWard(awardData) -- 发放
    end
    
    return state,awardData
end

function T:exec(id,callback)
    self.id = id
    self.super.exec(self,callback)
end

return T
