--[[
    分解蓝图
]]
local T = extend(AbstractC2SCommand)

T.type = 6

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.sid)
    data:writeInt(self.num)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then
        PropsInfoMgr:reducePlayerPropByID(self.sid,self.num)

        awardData = self.AwardDataDecoder:decode(data)  -- 这里获得的蓝图碎片发放就行了
        self.AwardDataDecoder:addAWard(awardData) -- 发放
    end
    
    return state,awardData
end

function T:exec(sid,num,callback)
    self.sid = sid
    self.num = num
    self.super.exec(self,callback)
end

return T
