--[[
    兑换蓝图，得到蓝图(用碎片兑换)
]]
local T = extend(AbstractC2SCommand)

T.type = 7

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.sid)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then
        local newData = PropsInfoMgr:exchangeBluePrint(self.sid)
        if newData then
            PropsInfoMgr:reducePlayerPropByID(newData.sid,newData.num)
        end

        awardData = self.AwardDataDecoder:decode(data)  -- 这里获得的蓝图发放就行了
        self.AwardDataDecoder:addAWard(awardData) -- 发放
    end
    
    return state,awardData
end

function T:exec(sid,callback) -- 所要兑换的蓝图sid,每次只兑换1个就行了
    self.sid = sid
    self.super.exec(self,callback)
end

return T
