--[[
    升级配件
]]
local T = extend(AbstractC2SCommand)

T.type = 3

function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.id)
    data:writeByte(self.levelUpType)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local levelUpSuccess = nil
    if state == ReturnCode.SUCCESS then
        PlayerInstance:setGold(data:readInt())
        PlayerInstance:setDiamond(data:readInt())

        -- 如果升级的类型是道具的话，这里要扣除道具的数量
       if self.levelUpType == 1 then
            local lastNum = PropsInfoMgr:getPlayerPropByID(209)
            local costNum = AccessorySystemManager:getAccessoryBox().accessoryInfos[self.id]:levelUpCostAccessoryPropNums()
            PropsInfoMgr:setPlayerPropByID(209,lastNum - costNum)
       end

        levelUpSuccess = data:readBoolean()
        if levelUpSuccess then
            AccessorySystemManager:getAccessoryBox().accessoryInfos[self.id]:levelUpSuccess()
        end




    end
    
    return state,levelUpSuccess
end

function T:exec(levelUpType,id,callback) -- 升级类型，0是金币升级，1是道具
    self.levelUpType = levelUpType
    self.id = id
    self.super.exec(self,callback)
end

return T
