--[[
    制造并且安装配件
]]
local T = extend(AbstractC2SCommand)

T.type = 13

function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.sid)
    data:writeByte(self.airType)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then
        local id = AccessorySystemManager:getAccessoryBox():refreshOneAccessoryAndGetId(data)
        AccessorySystemManager:getSlotBox():installAccessory(id,self.airType,self.slotType)

        PropsInfoMgr:reducePlayerPropByID(self.sid,1)

    end
    
    return state
end

function T:exec(sid,airType,slotType,callback) -- 蓝图sid，战机类型，槽位类型（位置）
    self.sid = sid
    self.airType = airType
    self.slotType = slotType

    self.super.exec(self,callback)
end

return T
