--[[
    改造配件
]]
local T = extend(AbstractC2SCommand)

T.type = 4

function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.id)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then
        local info = AccessorySystemManager:getAccessoryBox().accessoryInfos[self.id]

        -- 更新蓝图数量
        local costCount = info:reformCost()
        local sid = Accessory_temp[info.sid].bluePrintSid
        PropsInfoMgr:reducePlayerPropByID(sid,costCount)

        -- 改造成功
        info:reformSuccess()


    end
    
    return state
end

function T:exec(id,callback)
    self.id = id
    self.super.exec(self,callback)
end

return T
