--[[
    配件抽卡命令
]]
local T = extend(AbstractC2SCommand)

T.type = 12

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


function T:ctor()
    self.super.ctor(self,ChannelIds.ACCESSORY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)

    data:writeByte(self.sid)
    data:writeBoolean(self.useGems)
    data:writeBoolean(self.ten)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then
        PlayerInstance:setDiamond(data:readInt())

        -- 最新免费时间刷过来
        local freeTime = data:readInt()


        SetStates.accessoryDrawCardState:setFreeTimeBySid(self.sid,freeTime)

        awardData = self.AwardDataDecoder:decode(data)  -- 这里获得的蓝图碎片发放就行了
        self.AwardDataDecoder:addAWard(awardData) -- 发放
    end
    
    return state,awardData
end

function T:exec(sid,useGems,ten,callback) -- sid:抽奖类型,useGems:是否使用钻石,ten: 是否十连
    self.sid = sid
    self.useGems = useGems
    self.ten = ten
    self.super.exec(self,callback)
end

return T
