--Author    : YuDing
--Date      : 2015/3/6
--Introduce : 获取神秘礼物

local TEMPLATE = extend(AbstractC2SCommand)

TEMPLATE.type = 4

TEMPLATE.AwardDataDecoder = require"src.app.communication.award.AwardDataDecoder"

--- 构造函数
function TEMPLATE:ctor()
	self.super.ctor(self, ChannelIds.NORMAL_ACTIVITY)
end

--- 封装发送的数据
function TEMPLATE:encode()
	local data = ByteArray:new()
	data:writeByte(self.type)

	return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
	local state = data:readUnsignedByte()--是否处理成功

	local awardData = nil
	if state == ReturnCode.SUCCESS then -- 处理消息成功
		local time = GameUtils:modifyTimeZone(data:readUnsignedInt())
		SetStates.giftState:setTime(time)
		awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
		SetStates.giftState:setGift(nil)

		MUIAlter_singleLine.show({
			info = self.AwardDataDecoder:award2HTML(awardData),
			showSecond = 1,
			popSnd=SoundRes.SND_SND_GET_AWARD
		})

		self.AwardDataDecoder:addAWard(awardData)

	else
		MUIAlter_singleLine.show( {info = Language:get("uy131"),showSecond = 1 } ) -- 领取失败
	end

	return state
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(callback)
	self.super.exec(self, callback)
end

return TEMPLATE


