--[[
    普通生产或者改造命令
]]
local TEMPLATE=extend(AbstractC2SCommand)

TEMPLATE.type = nil -- 1是生产，5是改造

function TEMPLATE:ctor()
    self.super.ctor(self,ChannelIds.RECRUIT)
end

function TEMPLATE:encode()
    local data = ByteArray:new()
    if self.recruitType == 1 then
        self.type = 5
        data:writeByte(self.type)
    else
        self.type = 1
        data:writeByte(self.type)
    end
    
    data:writeShort(self.sid)
    data:writeInt(self.bid)
    data:writeShort(self.num)
    return data
end

function TEMPLATE:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then
        local qid = data:readInt()
        local endTime = GameUtils:modifyTimeZone(data:readInt())

        -- 加入到招募对列中去
        local queueItem = require("src.app.model2.aircraftFactory.AircraftProduceQueueItem")()
        queueItem.id = qid
        queueItem.endTimeSec = endTime
        queueItem.bid = self.bid
        queueItem.unitType = self.sid
        queueItem.unitNum = self.num
        queueItem.recruitType = self.recruitType

        AircraftProduceQueueMgr:addItem(queueItem)  -- 必须要调用才行的
    end

    return state
end

function TEMPLATE:exec(sid,bid,num,recruitType,callback)
    self.sid = sid
    self.bid = bid
    self.num = num
    self.recruitType = recruitType
    self.super.exec(self,callback)
end

return TEMPLATE
