--[[
    挑战运输线命令
]]
--- 获取运输线战斗数据
local T = Class.GetTransInfoCommand(AbstractC2SCommand1)

--- 战斗初始化数据解码器
T.FightInitDataDecoder=require("src.app.communication.fight.FightInitDataDecoder")

--- 奖励数据解析
T.AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")

T.type = 3

function T:ctor()
    AbstractC2SCommand1.ctor(self,ChannelIds.AIRCRAFTSTRENGTH,true)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeByte(self.id)

    local aircraftList=self.aircraftList
    for i=1,6,1 do
    	local item=aircraftList[i]
    	if item then
    		data:writeShort(item.sid)
    		data:writeShort(item.count)
    	else
    		data:writeShort(0)
    	end
    end


    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()--是否处理成功
    if state == ReturnCode.SUCCESS then
    	local r={}
    
    	r.fightInitData=self.FightInitDataDecoder:decode(data)
        r.endData={}
    	r.endData.isWinner=data:readBoolean()
        print("<运输线战斗>:","是否胜利=",tostring(r.isWinner))
    	if r.endData.isWinner then
    		r.endData.awardData=self.AwardDataDecoder:decode(data)
    	end
    
        return state,r
    end
    
    return state
end

function T:exec(id,aircraftList,callback)  -- id 为运输线的id
    self.id = id
    self.aircraftList = aircraftList

    AbstractC2SCommand1.exec(self,callback)
end

return T
