--[[
    得到挑战运输线数据命令
]]
local T = extend(AbstractC2SCommand)

T.type = 2

function T:ctor()
    self.super.ctor(self,ChannelIds.AIRCRAFTSTRENGTH)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local transData = nil
    if state == ReturnCode.SUCCESS then   
        transData = {}
        -- 解析数据
        local modelData = {}

        local length = data:readUnsignedByte()
        for i = 1,length,1 do
            local modelData = {}

            modelData.hasChallengeCount = data:readUnsignedByte()       -- 今日已挑战次数
            modelData.id = data:readUnsignedByte()                      -- 运输线id,  1,2,3
            modelData.limitLevel = data:readUnsignedByte()              -- 限制等级
            modelData.maxNum = data:readUnsignedByte()                  -- 每日最大挑战次数

            transData[modelData.id] = modelData

            TransportLineManager:setHasChallengeCount(modelData.id,modelData.hasChallengeCount)
        end

    end

    return state,transData
end

function T:exec(callback)
    self.super.exec(self,callback)
end

return T
