--[[
    升级飞机属性
]]
local T = extend(AbstractC2SCommand)

T.type = 1

function T:ctor()
    self.super.ctor(self,ChannelIds.AIRCRAFTSTRENGTH)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeByte(self.fighterLevel)
    data:writeByte(self.fighterAttr)
    data:writeBoolean(self.isUseGems)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then
        PlayerInstance:setDiamond(data:readInt())   
        local info = AircraftStrengManager.aircraftStrengBox:getStrengInfo(self.fighterLevel)
        if self.fighterAttr == 0 then
            info:levelUPAttack()
        else
            info:levelUPHp()
        end
    end

    return state
end

function T:exec(fighterLevel,fighterAttr,isUseGems,callback)  -- fighterLevel(1,2,3,4) ,fighterAttr(0:攻击，1：血量)，是否使用钻石
    self.fighterLevel = fighterLevel
    self.fighterAttr = fighterAttr
    self.isUseGems = isUseGems

    self.super.exec(self,callback)
end

return T
