--[[
    参加活动(转动抽奖)
]]
local T = extend(AbstractC2SCommand)

T.type = 3

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

function T:ctor()
	self.super.ctor(self,ChannelIds.SPECIAL_ACTIVITY)
end

function T:encode()
	local data = ByteArray:new()
	data:writeByte(self.type)
	data:writeShort(self.sid)
	if self.joinSid then
		if self.sid == 102 then
			data:writeShort(self.joinSid.sid)
		elseif self.sid == 103 then
			data:writeByte(self.joinSid)
		elseif self.sid == 105 then
			data:writeByte(self.joinSid)
		elseif self.sid == 106 then
			data:writeByte(self.joinSid.index) -- 资源类型，分别1,2,3,4,5
			data:writeByte(self.joinSid.awardIndex) -- 对应奖励下标，0,1,2,3
        elseif self.sid == 107 then
			data:writeByte(self.joinSid)
        elseif self.sid == 108 then
            data:writeByte(self.joinSid) -- 领取下标0,1,2,3,...
        elseif self.sid == 202 then
			data:writeShort(self.joinSid.sid)
		elseif self.sid == 203 then
			data:writeByte(self.joinSid)
		elseif self.sid == 205 then
			data:writeByte(self.joinSid)
		elseif self.sid == 206 then
			data:writeByte(self.joinSid.index) -- 资源类型，分别1,2,3,4,5
			data:writeByte(self.joinSid.awardIndex) -- 对应奖励下标，0,1,2,3
        elseif self.sid == 207 then
			data:writeByte(self.joinSid)
		end

	end


	return data
end

function T:decode(data)
	local state=data:readUnsignedByte()
	local r = nil
	if state == ReturnCode.SUCCESS then
		r = {}
		if self.sid == 100 then -- 大转盘
			PlayerInstance:setDiamond(data:readInt()) -- 钻石刷新

			r.id = data:readByte() -- 获奖id
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放

			local bigWheelNumState = DailyStates.bigWheelNumState
			bigWheelNumState:addNum(1)

		elseif self.sid == 101 then
			r.diamond = data:readInt() -- 玩家剩余钻石数量
			r.showDiamond = data:readInt() -- 这次抽到的钻石数量,显示
			r.isLottery = data:readBoolean() -- 还能否继续抽取,如果为true,继续读取
			if r.isLottery then
				r.needGems = data:readInt() -- 当前抽取所需的钻石
			end
		elseif self.sid == 102 then -- 限时商店
			PlayerInstance:setDiamond(data:readInt())
			-- 前台自己加购买的道具数量
            if self.joinSid.propOrAircraftType == 0 then
                if self.joinSid.buyNumOfEvery > 1 then
                    PropsInfoMgr:addPlayerPropByID(self.joinSid.sid, self.joinSid.buyNumOfEvery)
                else
                    PropsInfoMgr:addPlayerPropByID(self.joinSid.sid, 1)
                end
			    
            else
                if self.joinSid.buyNumOfEvery > 1 then
                    PlayerInstance:addAircraftNum(self.joinSid.sid, self.joinSid.buyNumOfEvery)
                else
                    PlayerInstance:addAircraftNum(self.joinSid.sid, 1)
                end

            end


		elseif self.sid == 103 then -- 累计充值(领取的那个joinSid是从0到4)
			r.mark = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放
		elseif self.sid == 105 then -- 每日充值(领取的那个joinSid是从0到2)
			r.mark = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放
		elseif self.sid == 106 then -- 资源采集
			local awardTag = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r,然后那边成功后更新按钮的状态
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放
			ActivityManager.collectResourceInfo:setTaskFinish(self.joinSid.index,awardTag)
        elseif self.sid == 107 then -- 战争之王
			r.mark = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放

        elseif self.sid == 108 then -- 军备竞赛
            r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放

            -- 刷新已经领取了
            ActivityManager.armsRaceInfo:setHasGetAward(self.joinSid)


        elseif self.sid == 200 then -- 大转盘
			PlayerInstance:setDiamond(data:readInt()) -- 钻石刷新

			r.id = data:readByte() -- 获奖id
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放

			local bigWheelNumState = DailyStates.bigWheelNumState
			bigWheelNumState:addNum(1)

		elseif self.sid == 201 then
			r.diamond = data:readInt() -- 玩家剩余钻石数量
			r.showDiamond = data:readInt() -- 这次抽到的钻石数量,显示
			r.isLottery = data:readBoolean() -- 还能否继续抽取,如果为true,继续读取
			if r.isLottery then
				r.needGems = data:readInt() -- 当前抽取所需的钻石
			end
		elseif self.sid == 202 then -- 限时商店
			PlayerInstance:setDiamond(data:readInt())
			-- 前台自己加购买的道具数量
            if self.joinSid.propOrAircraftType == 0 then
                if self.joinSid.buyNumOfEvery > 1 then
                    PropsInfoMgr:addPlayerPropByID(self.joinSid.sid, self.joinSid.buyNumOfEvery)
                else
                    PropsInfoMgr:addPlayerPropByID(self.joinSid.sid, 1)
                end
			    
            else
                if self.joinSid.buyNumOfEvery > 1 then
                    PlayerInstance:addAircraftNum(self.joinSid.sid, self.joinSid.buyNumOfEvery)
                else
                    PlayerInstance:addAircraftNum(self.joinSid.sid, 1)
                end

            end

		elseif self.sid == 203 then -- 累计充值(领取的那个joinSid是从0到4)
			r.mark = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放
		elseif self.sid == 205 then -- 每日充值(领取的那个joinSid是从0到2)
			r.mark = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放
		elseif self.sid == 206 then -- 资源采集
			local awardTag = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r,然后那边成功后更新按钮的状态
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放
			ActivityManager.collectResourceInfo2:setTaskFinish(self.joinSid.index,awardTag)
        elseif self.sid == 207 then -- 战争之王
			r.mark = data:readInt()
			r.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
			self.AwardDataDecoder:addAWard(r.awardData) -- 发放
		end


	end

	return state,r
end

function T:exec(sid,callback,joinSid) -- sid:为活动的sid，joinSid是参加这项活动的具体每一项sid
	self.sid = sid
	self.joinSid = joinSid
	self.super.exec(self,callback)
end

return T
