--[[
    幸运抽奖
]]
local T = extend(AbstractC2SCommand)

T.type = 13

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


function T:ctor()
    self.super.ctor(self,ChannelIds.NORMAL_ACTIVITY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local showAwardData = nil
    if state == ReturnCode.SUCCESS then   
        showAwardData = LotteryDataDecoder:decode(data) -- 抽中的奖励品数据

        local awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
        self.AwardDataDecoder:addAWard(awardData) -- 发放

        -- 如果是免费抽奖的话
        local luckyLotteryState = SetStates.luckyLotteryState
        if luckyLotteryState:judgeIsLottrey() then -- 免费抽奖不扣除瓶盖
            luckyLotteryState:setYday(UnitConversion.getYday())
        else
            PropsInfoMgr:reducePlayerPropByID(205,1)
        end

    end

    return state,showAwardData
end

function T:exec(callback)
    self.super.exec(self,callback)
end

return T
