--[[
    连续签到
]]
local T = extend(AbstractC2SCommand)

T.type = 7

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


function T:ctor()
    self.super.ctor(self,ChannelIds.NORMAL_ACTIVITY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeByte(self.awardIndex)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then   
        awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
        self.AwardDataDecoder:addAWard(awardData) -- 发放
        
        -- 刷新数据
        local continueAttendanceGet = SetStates.signManager.continueAttendanceGet
        continueAttendanceGet:setTagValue(self.awardIndex)
        
    end

    return state,awardData
end

function T:exec(awardIndex,callback)  -- 奖励下标awardIndex：0到3
    self.awardIndex = awardIndex
    self.super.exec(self,callback)
end

return T
