--[[
    每日签到
]]
local T = extend(AbstractC2SCommand)

T.type = 1

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


function T:ctor()
    self.super.ctor(self,ChannelIds.NORMAL_ACTIVITY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then   
        awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
        self.AwardDataDecoder:addAWard(awardData) -- 发放

        local dailyAttendanceDate = SetStates.signManager.dailyAttendanceDate
        local dailyAttendanceCount = SetStates.signManager.dailyAttendanceCount
        dailyAttendanceDate:setYday(UnitConversion.getYday())
        dailyAttendanceCount:addCount(1)
        
        -- 连续签到次数刷新
        local continueAttendanceCount = SetStates.signManager.continueAttendanceCount
        continueAttendanceCount:addCount(1)

    end

    return state,awardData
end

function T:exec(callback)
    self.super.exec(self,callback)
end

return T
