--- 获取联盟排行榜信息列表
local T=Class.GetAllianceRankListCommand(AbstractC2SCommand1)

function T:def()
	--- 类型
	self.type=5
end

function T:ctor()
	AbstractC2SCommand1.ctor(self,ChannelIds.ALLIANCE,false)
end

function T:encode()
	local data=ByteArray:new();
	data:writeByte(self.type)
	data:writeByte(self.startIndex)
	data:writeBoolean(self.isGetMyApplyList)

	return data
end

function T:decode(data)
	local state=data:readUnsignedByte()
	if state == ReturnCode.SUCCESS then
		local aBox=UserInfo.allianceBox
	
		aBox.allianceRankBox:decode(data,self.startIndex)
		local applyListLen=data:readUnsignedByte()
		if applyListLen > 0 then
			local aList={}
			for i=1,applyListLen,1 do
				aList[data:readUnsignedInt()]=true
			end
			
			aBox.appliedAllianceIdList=aList
		end
	end

	return state,self.startIndex
end

--- 获取联盟排行榜信息列表
-- @param startIndex 开始索引(从1开始)
-- @param isGetMyApplyList 是否获取自己的申请列表
function T:exec(startIndex,isGetMyApplyList,callback)
	self.startIndex=startIndex
	self.isGetMyApplyList=isGetMyApplyList

	AbstractC2SCommand1.exec(self,callback)
end

return T