--- 联盟科技捐献
local T=Class.ScienceDonateCommand(AbstractC2SCommand1)

--- 奖励数据解析
T.AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")

function T:def()
	--- 类型
	self.type=25
end

function T:ctor()
	AbstractC2SCommand1.ctor(self,ChannelIds.ALLIANCE,false)
end

function T:encode()
	local data=ByteArray:new();
	data:writeByte(self.type)
	data:writeShort(self.scienceSid)
	data:writeByte(self.resourceType)
	data:writeByte(self.donateType)

	return data
end

function T:decode(data)
	local state=data:readUnsignedByte()
	if state == ReturnCode.SUCCESS then
		local mA=UserInfo.allianceBox.myAlliance

		local lv=data:readUnsignedByte()
		local sPoint=data:readUnsignedInt()

		AllianceManager:updateScienceInfo(self.scienceSid,lv,sPoint)

		local awards=self.AwardDataDecoder:decode(data)
		self.AwardDataDecoder:addAWard(awards)

        local diamond = data:readInt()
        PlayerInstance:setDiamond(diamond)


		--扣除资源
		local type=self.resourceType
		if type == 1 then
			mA.moneyDonateCount = mA.moneyDonateCount + 1

			if self.donateType == 0 then
				PlayerInstance:reduceGold(AllianceDonateConsume_temp[mA.moneyDonateCount].resConsume)
			else
				--PlayerInstance:reduceDiamond(AllianceDonateConsume_temp[mA.moneyDonateCount].diamondConsume)
			end
		elseif type == 2 then
			mA.steelDonateCount = mA.steelDonateCount + 1

			if self.donateType == 0 then
				PlayerInstance:reduceSteel(AllianceDonateConsume_temp[mA.steelDonateCount].resConsume)
			else
				--PlayerInstance:reduceDiamond(AllianceDonateConsume_temp[mA.steelDonateCount].diamondConsume)
			end
		elseif type == 3 then
			mA.oilDonateCount = mA.oilDonateCount + 1

			if self.donateType == 0 then
				PlayerInstance:reduceOil(AllianceDonateConsume_temp[mA.oilDonateCount].resConsume)
			else
				--PlayerInstance:reduceDiamond(AllianceDonateConsume_temp[mA.oilDonateCount].diamondConsume)
			end
		elseif type == 4 then
			mA.siliconDonateCount = mA.siliconDonateCount + 1

			if self.donateType == 0 then
				PlayerInstance:reduceSilicon(AllianceDonateConsume_temp[mA.siliconDonateCount].resConsume)
			else
				--PlayerInstance:reduceDiamond(AllianceDonateConsume_temp[mA.siliconDonateCount].diamondConsume)
			end
		elseif type == 5 then
			mA.titaniumDonateCount = mA.titaniumDonateCount + 1

			if self.donateType == 0 then
				PlayerInstance:reduceTati(AllianceDonateConsume_temp[mA.titaniumDonateCount].resConsume)
			else
				--PlayerInstance:reduceDiamond(AllianceDonateConsume_temp[mA.titaniumDonateCount].diamondConsume)
			end

		end



		return state,awards
	end

	return state,nil
end

--- 联盟捐献
-- @param scienceSid 科技项SID
-- @param resourceType 资源类型
-- @param donateType 捐献类型 0,资源;1钻石
function T:exec(scienceSid,resourceType,donateType,callback)
	self.scienceSid=scienceSid
	self.resourceType=resourceType
	self.donateType=donateType
	AbstractC2SCommand1.exec(self,callback)
end

return T
