--[[
    得到公告信息命令
]]
local T = extend(AbstractC2SCommand)

T.type = 1

function T:ctor()
    self.super.ctor(self,ChannelIds.ANNOUNCE)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.announceCrc)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then
        AnnounceManager.announceBox:decode(data)
    end

    return state
end

function T:exec(announceCrc,callback)
    self.announceCrc = announceCrc
    self.super.exec(self,callback)
end

return T
