--[[
    查看公告信息命令
]]
local T = extend(AbstractC2SCommand)

T.type = 2

function T:ctor()
    self.super.ctor(self,ChannelIds.ANNOUNCE)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.announceInfoId)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then
        AnnounceManager.announceContentBox:decode(data,self.announceInfoId)
    end

    return state
end

function T:exec(announceInfoId,callback)
    self.announceInfoId = announceInfoId
    self.super.exec(self,callback)
end

return T
