--- 挑战竞技场玩家
local T=Class.ChallengeCommand(AbstractC2SCommand1)

--- 战斗初始化数据解码器
T.FightInitDataDecoder=require("src.app.communication.fight.FightInitDataDecoder")

--- 奖励数据解析
T.AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")

function T:def()
	self.type=4
end

function T:ctor()
	AbstractC2SCommand1.ctor(self,ChannelIds.ARENA,false)
end

function T:encode()
	local data=ByteArray:new();
	data:writeByte(self.type)
	data:writeInt(self.desPlayerId)

	return data
end

function T:decode(data)
	local state=data:readUnsignedByte()
	print("收到竞技场挑战战斗数据:state=",state)
	
	if state == ReturnCode.SUCCESS then
		local r={}

		r.fightInitData=self.FightInitDataDecoder:decode(data)
		r.endData={isWinner = r.fightInitData.winner == Camp.CAMP1}
		r.endData.awardData=self.AwardDataDecoder:decode(data)
		
		--挑战失败时间(这里不做时区同步,因为它是存储在 States 中的,从 States 中取出时才做时区同步)
		SetStates:setArenaFailTime(data:readInt())
		
		return state,r
	end

	return state
end

function T:exec(desPlayerId,callback)
	self.desPlayerId=desPlayerId
	AbstractC2SCommand1.exec(self,callback)
end

return T
