--[[
    维修所有部队:返回端口会刷新修理的部队，还有刷新所有战机部队
]]
local T = extend(AbstractC2SCommand)

T.type = 3

function T:ctor()
    self.super.ctor(self,ChannelIds.CITY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeBoolean(self.isUseGems)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   

        local gems = data:readUnsignedInt()
        PlayerInstance:setDiamond(gems)

        local money = data:readUnsignedInt()
        UserInfo.city.money = money
        ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)


        -- 所有飞机部队
        UserInfo.city.aircraftBox:refreshAllAircraft(data)

        -- 这时候要把原来的防守部队加上，因为重新刷新了
--        local defenceAircrafts = UserInfo.city.aircraftBox:getDefend()
--        local infos = UserInfo.city.aircraftBox.infos
--        for i = 1,6,1 do
--            if defenceAircrafts[i] and defenceAircrafts[i].sid > 0 then
--                infos[defenceAircrafts[i].sid]:addNum(defenceAircrafts[i].count) 
--            end
--        end


        -- 维修部队
        UserInfo.city.aircraftBox:setRepair(data)
    end

    return state
end

function T:exec(isUseGems,callback)
    self.isUseGems = isUseGems
    self.super.exec(self,callback)
end

return T
