--[[
    维修单个部队:返回端口会刷新修理的部队，还有刷新所有战机部队
]]
local T = extend(AbstractC2SCommand)

T.type = 4

function T:ctor()
    self.super.ctor(self,ChannelIds.CITY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.sid)
    data:writeBoolean(self.isUseGems)


    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   
        
        local gems = data:readUnsignedInt()
        PlayerInstance:setDiamond(gems)

        local money = data:readUnsignedInt()
        UserInfo.city.money = money
        ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)

        -- 飞机的sid
        local sid = data:readUnsignedShort()

        -- 设置指定飞机中的数量
        local allNum = data:readUnsignedInt()
        UserInfo.city.aircraftBox.infos[sid]:setNum(allNum)

        -- 这时候要把原来的单个防守部队加上，因为重新刷新了
--        local defenceAircrafts = UserInfo.city.aircraftBox:getDefend()
--        local infos = UserInfo.city.aircraftBox.infos
--        for i = 1,6,1 do
--            if infos[sid] and defenceAircrafts[i] and sid == defenceAircrafts[i].sid then
--                infos[sid]:addNum(defenceAircrafts[i].count) 
--            end
--        end

        -- 设置指定维修飞机的数量
        local repairNum = data:readUnsignedInt()
        UserInfo.city.aircraftBox:setRepairForSid(sid,repairNum)

    end

    return state
end

function T:exec(sid,isUseGems,callback) -- sid是部队的sid，是否使用钻石
    self.sid = sid
    self.isUseGems = isUseGems
    self.super.exec(self,callback)
end

return T
