--[[
    派遣飞机部队
]]
local T = extend(AbstractC2SCommand)

T.type = 2

function T:ctor()
    self.super.ctor(self,ChannelIds.WORLDMAP)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.sendInfo.x)
    data:writeShort(self.sendInfo.y)
    data:writeInt(self.sendInfo.id)
    data:writeBoolean(self.state)

    local aircraftList = self.aircraftList
    for i = 1,6,1 do
    	local item = aircraftList[i]
    	if item then
    		data:writeShort(item.sid)
    		data:writeShort(item.count)
    	else
    		data:writeShort(0)
    	end
    end

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   
        local buffState = data:readBoolean() 
        if buffState == true then -- 去除防护罩
            BuffQueueInfoMgr:removeItem(13)
        end
        ArmyTaskQueueManager:addItem(data)
    end

    return state
end

function T:exec(sendInfo,state,aircraftList,callback)
    self.sendInfo = sendInfo
    self.state = state
    self.aircraftList = aircraftList
    self.super.exec(self,callback)
end

return T
