--[[
    设置防御部队
]]
local T = extend(AbstractC2SCommand)

T.type = 5

function T:ctor()
    self.super.ctor(self,ChannelIds.CITY,true)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    
    local aircraftList = self.aircraftList
    for i = 1,6,1 do
    	local item = aircraftList[i]
    	if item then
    		data:writeShort(item.sid)
    		data:writeShort(item.count)
    	else
    		data:writeShort(0)
    	end
    end

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then 
        --- 更新当前的防御部队
        UserInfo.city.aircraftBox:setDefend(self.aircraftList)
    end

    return state
end

function T:exec(aircraftList,callback) -- 队列id
    self.aircraftList = aircraftList
    self.super.exec(self,callback)
end

return T
