--- 服务器刷新客户端数据的侦听器
local T=extend(require("src.app.communication.broadcast.AbstractBroadcast"))

ChatManager = require("src.app.model.chat.ChatManager")()
--AircraftManager = require("src.app.model.aircraft.AircraftManager")

--- 刷钻石
T.RESET_GEMS=1000
--- 账号已在别处登陆
T.REPEAT_LOGIN=1001
--- 后端发送提示
T.BACK_TIP=1002
--- 刷新玩家单个每日状态
T.RESET_PLAYER_DAILYSTATE=1003
--- 刷新玩家每日状态,这个有数据返回
T.RESET_PLAYER_DAILYSTATES=1004
--- 刷新资源
T.RESET_RESOURCE=1005
--- 发送奖励品
T.SEND_AWARD=1006
--- 刷新玩家技能点
T.RESET_SKILL_POINT=1007
--- 发送精力
T.RESET_P_POINT=1008
--- 刷新指定道具数量
T.RESET_PROP=1009
--- 角色升级
T.SEND_LEVEL_UP=1012
--- buff时间刷新
T.REFRESH_BUFF = 1017
--- 邮件刷新
T.REFRESH_MAIL=1021
--- 关卡BUFF刷新
T.CHAPTER_BUFF=1022

--- 世界聊天刷新
T.REFRESH_WORLD_CHAT=2002
--- 军团聊天刷新
T.REFRESH_GROUP_CHAT=2003
--- 私人聊天刷新
T.REFRESH_PRIVATE_CHAT=2004

--- 刷新主城部队
T.REFRESH_SINGLE_FORCE = 1019

--- 刷新 部队开始驻扎
T.REFRESH_BATTLE_FORCE = 1026

--- 刷新部队回城
T.REFRESH_BACK_FORCE = 1027

--- 刷新维修部队
T.REFRESH_REPAIRE_FORCE = 1020

--- 刷新攻打NPC等级数据
T.REFRESH_ATTACK_NPC = 1010

--- 刷新联盟职位
T.RESET_ALLIANCE_POST = 1040

--- 刷新联盟科技信息
T.REFRESH_ALLIANCE_TECH=1041

--- 通知前台已加入联盟
T.NOTIFY_JOIN_ALLIANCE = 1042

--- 联盟状态改变
T.NOTIFY_ALLIANCE_INFO_CHANGE=1043

--- 活动增加端口
T.ADD_ACTIVITY_REFRESH = 2001

--- 刷新VIP
T.RESET_VIP_REFRESH = 1016

--- 刷新单个配件
T.RESET_ACCESSORY_REFRESH = 1014

--- 刷新竞技场积分
T.REFRESH_ARENA_POINT=1028

--- 刷新联盟贡献点
T.REFRESH_CONTRIBUTION=1029

--- 添加进攻队列(目标警告)
T.REFRESH_ADD_MARCH=1031

--- 移除进攻队列(目标警告)
T.REFRESH_REMOVE_MARCH=1032

--- 通知前台12点数据刷新:后面来写，这个里面不传入数据,我这边自己清空
T.REFRESH_DAILY_DATA = 1044

--- 刷新联盟关系列表
T.REFRESH_ALLIANCE_RELATION = 1045

--- 刷新防守部队
T.RESET_DEFENSE_TROOP=1011

--- 通知前台钻石购买
T.NOTIFY_BUY_GEMS_AWARD=1046

--- 刷新竞技场第一名
T.REFRESH_TOP_NAME=1030

--- 通知前台荣誉值
T.REFRESH_HONOR=1047

--- 通知前台复仇值
T.REFRESH_REVENGE=1048

--- 通知前台军衔
T.REFRESH_MILITARYRANK=1049

--- 通知前台ENJOY第三方内购
T.NOTIFY_ENJOY_IAP=1050

--- 刷新世界地图城市防护罩
T.REFRESH_WORLD_CITY_SAFE=1033

--- 注册侦听器
function T:receiveHandler(data)
	--解析广播数据
	local type=data:readUnsignedShort()
	if type == self.REPEAT_LOGIN then
		self:repeatLogin()
	elseif type == self.RESET_GEMS then
		self:resetGems(data)
	elseif type == self.RESET_RESOURCE then
		self:resetResource(data)
	elseif type == self.SEND_LEVEL_UP then
		self:levelUp(data)
	elseif type == self.RESET_P_POINT then
		self:resetPPoint(data)
	elseif type == self.RESET_SKILL_POINT then
		self:resetSkillPoint(data)
	elseif type == self.RESET_PROP then
		self:resetProp(data)
	elseif type == self.REFRESH_BUFF then
		self:resetBuff(data)
	elseif type == self.REFRESH_MAIL then
		self:resetMail(data)
	elseif type == self.REFRESH_WORLD_CHAT then
		self:resetWorldChat(data)
	elseif type == self.REFRESH_GROUP_CHAT then
		self:resetGroupChat(data)
	elseif type == self.REFRESH_PRIVATE_CHAT then
		self:resetPrivateChat(data)
	elseif type == self.REFRESH_SINGLE_FORCE then
		self:resetAircraft(data)
	elseif type == self.CHAPTER_BUFF then
		self:resetChapterBuff(data)
	elseif type == self.REFRESH_BATTLE_FORCE then
		self:resetStartBattle(data)
	elseif type == self.REFRESH_BACK_FORCE then
		self:resetBackOver(data)
	elseif type == self.REFRESH_REPAIRE_FORCE then
		self:resetRepaire(data)
	elseif type == self.REFRESH_ATTACK_NPC then
		self:resetAttackMaxNPCLvl(data)
	elseif type == self.RESET_ALLIANCE_POST then
		self:resetAlliancePost(data)
	elseif type == self.NOTIFY_JOIN_ALLIANCE then
		self:joinAllianceSuccess(data)
	elseif type == self.NOTIFY_ALLIANCE_INFO_CHANGE then
		self:allianceStateChange(data)
	elseif type == self.ADD_ACTIVITY_REFRESH then
		self:addActivityRefresh(data)
	elseif type == self.RESET_VIP_REFRESH then
		self:resetVipRefresh(data)
	elseif type == self.RESET_ACCESSORY_REFRESH then
		self:resetAccessoryRefresh(data)
	elseif type == self.REFRESH_ARENA_POINT then
		self:resetArenaIntegral(data)
	elseif type == self.REFRESH_CONTRIBUTION then
		self:resetAllianceContributionPoint(data)
	elseif type == self.RESET_PLAYER_DAILYSTATES then
		self:resetDailyStates(data)
	elseif type == self.REFRESH_ALLIANCE_TECH then
		self:resetAllianceTech(data)
	elseif type == self.REFRESH_DAILY_DATA then
		self:clearDailyState(data)
	elseif type == self.REFRESH_ALLIANCE_RELATION then
		self:refreshAllianceRelation(data)
	elseif type == self.REFRESH_ADD_MARCH then
		self:refreshAddMarch(data)
	elseif type == self.REFRESH_REMOVE_MARCH then
		self:refreshRemoveMarch(data)
	elseif type == self.RESET_DEFENSE_TROOP then
		self:refreshDefenceTeam(data)
	elseif type == self.NOTIFY_BUY_GEMS_AWARD then
		self:handleBuyGemsAwards(data)
	elseif type == self.REFRESH_TOP_NAME then
		self:refreshTopName(data)
	elseif type == self.REFRESH_HONOR then
		self:refreshHonor(data)
	elseif type == self.REFRESH_REVENGE then
		self:refreshRevenge(data)
	elseif type == self.REFRESH_MILITARYRANK then
		self:refreshMilitarRank(data)
	elseif type == self.NOTIFY_ENJOY_IAP then
		self:eg_handleThirdPayComplete(data)
	elseif type == self.REFRESH_WORLD_CITY_SAFE then
		self:setMapNodeProtectionState(data)
	end

	self:flushScene()
end

--- 账号已在别处登陆
function T:repeatLogin()
	print("账号已在别处登陆")

	--停止网络检测器
	NetDetector:stop()
	NetManager:close()

	MUIAlter.show({
		info=Language:get("ug23"),
		callback=function()

			--退回到登陆界面
			require("src.app.controler.Back2LoginScenceCommand")()
		end
	})
end

--- 刷新当前页面
function T:flushScene()
	local scene = cc.Director:getInstance():getRunningScene()
	local name = scene.name

end

--- 刷新钻石数
function T:resetGems(data)
	local newGems=data:readUnsignedInt()
	print("刷新钻石")
	PlayerInstance:setDiamond(newGems)
end

--- 刷新资源:按理说应该是5种一起刷(包括金币)
function T:resetResource(data)
	local newResourceTime = data:readInt()
	local newMoney=data:readUnsignedInt()
	local newSteel=data:readUnsignedInt()
	local newOil=data:readUnsignedInt()
	local newAluminium=data:readUnsignedInt()
	local newTitanium=data:readUnsignedInt()

	local city=UserInfo.city
	city.resourceTime=newResourceTime
	city.money=newMoney
	city.steel=newSteel
	city.oil=newOil
	city.aluminium=newAluminium
	city.titanium=newTitanium

	if ResourceManager then  -- 按理说应该存在的，不然有错
		ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH) -- 刷新资源，全部刷新，但是有可能其他刷过来的不变
	end
end

--- 刷新等级和经验
function T:levelUp(data)
	--    local str = data:readString()
	local newLv=data:readUnsignedInt()
	local newExp=data:readUnsignedInt()

	--UserInfo.level=newLv
	--UserInfo.exp=newExp
	PlayerInstance:setPlayerLevel(newLv)
	PlayerInstance:setPlayerExp(newExp)
end

--- 刷新精力值
function T:resetPPoint(data)
	local newPvePoint=data:readUnsignedByte()
	local newPveRecoverSec=GameUtils:modifyTimeZone(data:readUnsignedInt())

	UserInfo.pveRecoverSec=newPveRecoverSec
	PlayerInstance:addPlayerEnergy(newPvePoint-PlayerInstance:getPlayerEnergy())
end

--- 刷新技能点
function T:resetSkillPoint(data)
	local newSkillPoint=data:readUnsignedInt()

	UserInfo.skillPoint = newSkillPoint
end

--- 刷新物品数量(道具数量)
function T:resetProp(data)
	local sid = data:readUnsignedShort()
	local count = data:readUnsignedShort()

	PropsInfoMgr:setPlayerPropByID(sid, count)  -- 设置
end

--- 刷新BUFF
function T:resetBuff(data)
	local sid=data:readUnsignedShort()
	local endTimeSec=GameUtils:modifyTimeZone(data:readUnsignedInt())

	BuffQueueInfoMgr:addItem(sid,endTimeSec)
end

--- 刷新邮件
function T:resetMail(data)
	if MailManager then
		MailManager:receiveMailInfo(data)
	end
end

--- 刷新世界聊天信息
function T:resetWorldChat(data)
	local chatBox = ChatManager.chatBox
	local len = data:readUnsignedByte()  -- 同一时间发送的聊天条数
	local chatInfos = {}
	for i=1,len,1 do
		local chatInfo = mapping({}, require("src.app.model.chat.ChatInfo"))
		chatInfo:decode(data)
		chatInfos[i] = chatInfo
	end

	table.sort(chatInfos,function(x,y) return x.id < y.id end)

	chatBox.addChatWorldInfosQueue:clearT()
	-- 加入新增加的队列中去
	for i = 1,len,1 do
		chatBox.addChatWorldInfosQueue:push(chatInfos[i])
		chatBox.chatWorldInfosQueue:push(chatInfos[i])
	end

	local length = chatBox.chatWorldInfosQueue:getLength()
	if length > 50 then
		-- 最多循环加入的长度那么多
		local num = 0
		for i = 1,len,1 do
			num = num + 1
			chatBox.chatWorldInfosQueue:pop()
			local newLength = chatBox.chatWorldInfosQueue:getLength()
			if newLength == 50 then
				break
			end
		end
		chatBox.removeChatWorldInfosLength = num
	end

	-- 还要派发事件
	if ChatManager then
		ChatManager:luaDispatchEvent(ChatManager.EVT_TYPE_UPDATE_WORLD_CHAT)
	end

end

--- 刷新军团聊天信息
function T:resetGroupChat(data)
	local len = data:readUnsignedByte()  -- 同一时间发送的聊天条数
	local chatInfos = {}
	for i=1,len,1 do
		local chatInfo = mapping({}, require("src.app.model.chat.ChatInfo"))
		chatInfo:decode(data)
		chatInfos[i] = chatInfo
	end

	table.sort(chatInfos,function(x,y) return x.id < y.id end)

	ChatManager.addChatGroupInfosQueue:clearT()
	-- 加入新增加的队列中去
	for i = 1,len,1 do
		ChatManager.addChatGroupInfosQueue:push(chatInfos[i])
		ChatManager.chatGroupInfosQueue:push(chatInfos[i])
	end

	local length = ChatManager.chatGroupInfosQueue:getLength()
	if length > 50 then
		-- 最多循环加入的长度那么多
		local num = 0
		for i = 1,len,1 do
			num = num + 1
			ChatManager.chatGroupInfosQueue:pop()
			local newLength = ChatManager.chatGroupInfosQueue:getLength()
			if newLength == 50 then
				break
			end
		end
		ChatManager.removeChatGroupInfosLength = num
	end

	-- 还要派发事件
	if ChatManager then
		ChatManager:luaDispatchEvent(ChatManager.EVT_TYPE_UPDATE_GROUP_CHAT)
	end
end

--- 刷新私人聊天信息(每次只刷一条)
function T:resetPrivateChat(data)
	local chatInfos = {}
	local chatInfo = mapping({}, require("src.app.model.chat.ChatInfo"))
	chatInfo:decode(data)
	chatInfos[1] = chatInfo

	ChatManager.addChatPrivateInfosQueue:clearT()
	-- 加入新增加的队列中去
	ChatManager.addChatPrivateInfosQueue:push(chatInfos[1])
	ChatManager.chatPrivateInfosQueue:push(chatInfos[1])

	local length = ChatManager.chatPrivateInfosQueue:getLength()
	if length > 50 then
		-- 最多循环加入的长度那么多
		local num = 0
		for i = 1,1,1 do
			num = num + 1
			ChatManager.chatPrivateInfosQueue:pop()
			local newLength = ChatManager.chatPrivateInfosQueue:getLength()
			if newLength == 50 then
				break
			end
		end
		ChatManager.removeChatPrivateInfosLength = num
	end

	-- 还要派发事件
	if ChatManager then
		ChatManager:luaDispatchEvent(ChatManager.EVT_TYPE_UPDATE_PRIVATE_CHAT)
	end
end

--- 战机（部队）刷新
function T:resetAircraft(data)
	local sid = data:readUnsignedShort()
	local num = data:readUnsignedInt()

	--- 保存战机的最新数量,并且派发事件
	UserInfo.city.aircraftBox.infos[sid]:setAircraftNum(num)

end

--- 关卡buff刷新
function T:resetChapterBuff(data)
	BattlesInfoMgr:initChapterBuffsInfo(require("src.app.model2.battle.ChapterBuffsInfo")(data))
end

--- 部队开始驻扎（或者开始返回）：
function T:resetStartBattle(data)
	local over = data:readBoolean()
	local queueId = data:readUnsignedInt()

	local queueInfo = ArmyTaskQueueManager.queueInfos[queueId]
	if over == true then -- 表示进攻失败，这时把这个队列id删除了
		ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BATTLE_OVER,queueInfo)
		ArmyTaskQueueManager:removeItem(queueId)
	else -- 表示进攻成功，开始驻扎:驻扎剩余时间刷新
		queueInfo.status = data:readUnsignedByte()
		queueInfo.endTimeSec = GameUtils:modifyTimeZone(data:readUnsignedInt())
		queueInfo.resourceEfficiency = data:readUnsignedInt()
		--- 刷新队列里的战机数量（派遣的减去修理后的剩下的，用于显示）,就是真正的去打了的战机部队
		queueInfo.armyExpeditionAircrafts = nil
		local aircraft = {}
		for i = 1,6,1 do
			local modelAircraft = {}
			modelAircraft.sid = data:readUnsignedShort()
			if modelAircraft.sid <= 0 then
				modelAircraft.count = 0
			else
				modelAircraft.count = data:readUnsignedShort()
			end
			aircraft[i] = modelAircraft
		end
		queueInfo.armyExpeditionAircrafts = aircraft

		if queueInfo.status == 2 then
			-- 立即改变数据
			local syncSec = TimeUtils:getSyncMillis()/1000
			local realEndTime = ArmyTaskQueueManager:getStationAllTime(queueInfo) + queueInfo.endTimeSec
			queueInfo.remainingSec = realEndTime - syncSec

			-- 加速进攻完成
			ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BATTLE_OVER .. queueId,queueInfo)
			ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BATTLE_OVER,queueInfo)
			ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_HOMEPAGE_RIGHT_BAR)


			ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_STATION_REMAIN_TIME .. queueId,queueInfo)

		else
			ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BATTLE_OVER,queueInfo)
			ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_START_BACK_REFRESH,queueInfo)
			ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BACK_REMAIN_TIME .. queueId,queueInfo)
		end

	end

	PlayerInstance:setPlayerFightLogic()

end

--- 部队返回结束
function T:resetBackOver(data)
	local queueId = data:readUnsignedInt()
	ArmyTaskQueueManager:removeItem(queueId)

	-- 所有的飞机部队数据
	UserInfo.city.aircraftBox:refreshAllAircraft(data)

	-- 资源数据
	self:resetResource(data)
end

--- 刷新维修部队:这个端口只适用于派出的做任务的战机，不用算所有的战机数量
function T:resetRepaire(data)
	UserInfo.city.aircraftBox:refreshRepair(data)
end

--- 更新 攻击过的最大npc等级
function T:resetAttackMaxNPCLvl(data)
	local lvl = data:readUnsignedInt()
	PlayerInstance:setMaxAttackNPCLvl(lvl)
end

--- 刷新自己的联盟职位
function T:resetAlliancePost(data)
	AllianceManager:changePost(UserInfo.id,data:readUnsignedByte())
end

--- 加入联盟成功
function T:joinAllianceSuccess(data)
	UserInfo.allianceBox.myAlliance.id=data:readUnsignedInt()

	AllianceManager:joined()
end

--- 联盟状态改变
function T:allianceStateChange(data)
	local type=data:readUnsignedByte()

	if type == 1 then
		--申请列表发生改变
		AllianceManager:ApplyListChange()
	elseif type == 2 then
	--成员改变
	elseif type == 3 then
	--联盟信息改变
	elseif type == 8 then
		--被踢出联盟
		AllianceManager:byKickOut()
	end
end

--- 开发或者关闭活动,每次都是刷新所有活动，先把原来的动态活动情空
function T:addActivityRefresh(data)
	ActivityManager:clearAllDynamic()

	local length = data:readUnsignedByte()
	for i = 1,length,1 do
		local sid = data:readShort()
		local endTime = GameUtils:modifyTimeZone(data:readInt())
		ActivityManager:refreshOneAct(ActivityManager:getActInfoBySid(sid).info,endTime)
	end

end

function T:resetVipRefresh(data)
	local vipLevel = data:readUnsignedByte()
	local vipPoint = data:readInt()
	UserInfo.vipLevel = vipLevel
	VipManager:setPlayerVipPoint(vipPoint)

end

--- 刷新单个配件
function T:resetAccessoryRefresh(data)
	AccessorySystemManager:getAccessoryBox():refreshOneAccessory(data)
end

--- 刷新竞技场积分
function T:resetArenaIntegral(data)
	local newIntegral=data:readUnsignedInt()
	ArenaInfoMgr:addIntegral(newIntegral-ArenaInfoMgr:getIntegral())
end

--- 刷新联盟贡献点
function T:resetAllianceContributionPoint(data)
	local newContribution=data:readUnsignedInt()
	AllianceManager:addContributionPoint(newContribution-AllianceManager:getContributionPoint())
end

--- 刷新玩家每日状态
function T:resetDailyStates(data)
	DailyStates:reset(data)
end

--- 清除玩家每日状态
function T:clearDailyState()
	DailyStates:clear()
end

--- 刷新联盟科技信息
function T:resetAllianceTech(data)
	local sid=data:readUnsignedShort()
	local lv=data:readUnsignedByte()

	AllianceManager:updateScienceInfo(sid,lv)
end

--- 刷新联盟关系列表
function T:refreshAllianceRelation(data)
	UserInfo.allianceBox.myAlliance.allianceSocial:decode(data)
end

--- 添加进攻队列(目标警告)
function T:refreshAddMarch(data)
	WarnQueueManager.warnBox:addMarch(data)
end

--- 移除进攻队列(目标警告)
function T:refreshRemoveMarch(data)
	WarnQueueManager.warnBox:removeMarch(data)
end

--- 刷新防守阵形
function T:refreshDefenceTeam(data)
	UserInfo.city.aircraftBox:decodeDefend(data)
	AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_DEFENCE_ARMY)
end

--- 钻石购买完成后获得的数据
function T:handleBuyGemsAwards(data)
	local AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")

	local award=nil

	local p=data:getPosition()
	local type = data:readUnsignedInt()
	if type ~= 0 then
		data:setPosition(p)

		award = AwardDataDecoder:decode(data)
		AwardDataDecoder:addAWard(award)
	end

	IAPMgr:verifyPayComplete(award)
end

--- 刷新竞技场第一名
function T:refreshTopName(data)
	ArenaInfoMgr:setFirstName(data:readString())

end

--- 通知前台荣誉值
function T:refreshHonor(data)
	HonorManager:setHonor(data:readInt())
end

--- 通知前台复仇值
function T:refreshRevenge(data)
	HonorManager:setRevenge(data:readInt())
end

--- 通知前台军衔
function T:refreshMilitarRank(data)
	HonorManager:setMilitaryRank(data:readByte())

end

--- 英卓平台第三方支付完成
function T:eg_handleThirdPayComplete(data)
	local costUSD=data:readInt()/100 	--花费的美元数
	local getedGems=data:readInt()		--获得的钻石数

	IAPMgr:handleThiredPayComplete(costUSD,getedGems)
end

--- 设置地图节点保护罩状态
function T:setMapNodeProtectionState(data)
	local playerId=data:readUnsignedInt()
	local x=data:readUnsignedShort()
	local y=data:readUnsignedShort()
	local isProtectioning=data:readBoolean()
	
	if WorldMapMgr then
		WorldMapMgr:setNodeProtectionState(x,y,isProtectioning,playerId)
	end
end

return T
