--- 建造：从0级到1级
local TEMPLATE=extend(AbstractC2SCommand)

--- 类型
TEMPLATE.type = 5

--- 构造函数
function TEMPLATE:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口
    self.super.ctor(self,ChannelIds.UPGRADE)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.buildSid)
    data:writeByte(self.location) 
    data:writeBoolean(self.isUseDiamond)

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state=data:readUnsignedByte()
    if state==ReturnCode.SUCCESS then
        local buildingId =  data:readUnsignedInt() -- 建造物的唯一ID
        local queueId = data:readUnsignedInt()  -- 队列id
        local endTimeSec = GameUtils:modifyTimeZone(data:readUnsignedInt())  -- 结束时刻
        local diamond = data:readUnsignedInt()
        PlayerInstance:setDiamond(diamond)
        

        BuildingsInfoMgr:addQueueItem(queueId,endTimeSec,buildingId,self.location,self.buildSid) -- 要多传一个sid
    end

    return state
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(buildSid,location,isUseDiamond,callback)
    self.buildSid = buildSid
    self.location = location
    self.isUseDiamond = isUseDiamond
    self.super.exec(self,callback)
end

return TEMPLATE
