--- 升级:代表的是从1升级到以后
local TEMPLATE=extend(AbstractC2SCommand)

--- 类型,对应于服务器的BUILDING_LEVEL_UP
TEMPLATE.type = 1
--- id
TEMPLATE.id = nil
--- 是否使用钻石
TEMPLATE.isUseDiemond = nil

--- 服务器穿过来的数据
TEMPLATE.dataFromSever = nil

--- 构造函数
function TEMPLATE:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口
    self.super.ctor(self,ChannelIds.UPGRADE)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.dataFromSever.id)
    data:writeBoolean(self.isUseDiamond) -- 是否使用钻石

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state=data:readUnsignedByte()--是否处理成功
    local diamond = nil
    if state==ReturnCode.SUCCESS then
        local id=data:readUnsignedInt()  -- 队列id
        local endTimeSec=GameUtils:modifyTimeZone(data:readUnsignedInt())  -- 结束时刻
        diamond = data:readUnsignedInt() -- 返回的钻石

        BuildingsInfoMgr:addQueueItem(id,endTimeSec,self.dataFromSever.id,self.dataFromSever.location)
    end

    return state,diamond
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(data,isUseDiamond,callback)
    self.dataFromSever = data
    self.isUseDiamond = isUseDiamond
    self.super.exec(self,callback)
end

return TEMPLATE
