--- 战斗初始化数据解析
local T={}

function T:decode(data)
	local d={}
	
	d.seed=data:readUnsignedInt()--随机种子
	d.winner=data:readUnsignedByte()--胜利方
	d.first=data:readUnsignedByte()--先手方

	d.camp1=self:decodeCamp(data)--阵营1
	d.camp2=self:decodeCamp(data)--阵营2

    print("战斗初始化数据:")
    print(obj2str(d))
	
	return d
end

function T:decodeCamp(data)
	local camp={}
	
	camp.id=data:readUnsignedInt()--玩家/NPC编号
	camp.level=data:readUnsignedShort()--等级
	camp.name=data:readString()--名称
	camp.headPhotoId=data:readUnsignedByte()--头像
	camp.playerBuffCode=data:readUnsignedInt()--玩家战斗buff标志
	camp.continuesAT_1=data:readUnsignedByte()--攻击类型为1的战机,攻击后再次出手的概率(0-100)
	camp.continuesAT_2=data:readUnsignedByte()--攻击类型为2的战机,攻击后再次出手的概率(0-100)
	camp.continuesAT_3=data:readUnsignedByte()--攻击类型为3的战机,攻击后再次出手的概率(0-100)
	camp.continuesAT_4=data:readUnsignedByte()--攻击类型为4的战机,攻击后再次出手的概率(0-100)

	local aircrafts={}
	for i=0,5,1 do
		aircrafts[i]=self:decodeAircraft(data)
	end
	camp.aircrafts=aircrafts--战机列表

	return camp
end

function T:decodeAircraft(data)
	local sid=data:readUnsignedShort()
	if sid == 0 then
		return nil
	end
	
	local aircraft={}
	
	aircraft.sid=sid--战机SID
	aircraft.count=data:readUnsignedShort()--数量
	aircraft.singleAttack=data:readUnsignedInt()/100--单个战机的攻击值
	aircraft.singleHp=data:readUnsignedInt()/100--单个战机的生命值
	aircraft.baseHit=data:readUnsignedShort()/100--基础命中
	aircraft.baseDodge=data:readUnsignedShort()/100--基础闪避
	aircraft.baseCrit=data:readUnsignedShort()/100--基础暴击
	aircraft.baseCritResist=data:readUnsignedShort()/100--暴击抵抗
	aircraft.restraint=data:readUnsignedShort()/1000--克制(已乘以1000,表示精度为小数点后3位)
	aircraft.antiRestraint=data:readUnsignedShort()/1000--反克制(已乘以1000,表示精度为小数点后3位)
	aircraft.critIncr=data:readUnsignedShort()/1000--暴伤(已乘以1000,表示精度为小数点后3位)
	aircraft.critReduce=data:readUnsignedShort()/1000--暴免(已乘以1000,表示精度为小数点后3位)
	
	return aircraft
end

return T