--[[
    得到章节的奖励命令
]]

local T = extend(AbstractC2SCommand)

--- 奖励数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

T.type = 2

function T:ctor()
    self.super.ctor(self,ChannelIds.FIGHT)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.sid)
    data:writeByte(self.index)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then   
        awardData = self.AwardDataDecoder:decode(data)
        -- 发放奖励品
        self.AwardDataDecoder:addAWard(awardData)

        local battleBox = BattlesInfoMgr -- 并且要设置领取状态
        battleBox:setStarAwardIsGet(self.sid,self.index,battleBox:getStarAwardIsGet(self.sid,self.index))

    end

    return state,awardData
end

function T:exec(sid,index,callback)  -- 奖励的章节的sid，奖励品下标0,1,2
    self.sid = sid
    self.index = index
    self.super.exec(self,callback)
end

return T
