--- 获取关卡战斗数据
local T=Class.GetChapterFightDataCommand(AbstractC2SCommand1)

--- 战斗初始化数据解码器
T.FightInitDataDecoder=require("src.app.communication.fight.FightInitDataDecoder")

--- 奖励数据解析
T.AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")

--- 类型
T.type=1

--- 构造函数
function T:ctor()
    --调用父类的构造成数
    AbstractC2SCommand1.ctor(self,ChannelIds.FIGHT,true)
end

function T:encode()
    local data=ByteArray:new();
    data:writeByte(self.type)
    data:writeShort(self.chapterSid)
    
    local aircraftList=self.aircraftList
    for i=1,6,1 do
    	local item=aircraftList[i]
    	if item then
    		data:writeShort(item.sid)
    		data:writeShort(item.count)
    	else
    		data:writeShort(0)
    	end
    end
    
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()--是否处理成功
    if state == ReturnCode.SUCCESS then
    	local r={}
    
    	r.fightInitData=self.FightInitDataDecoder:decode(data)
        r.endData={}
    	r.endData.isWinner=data:readBoolean()
        print("<推图战斗>:","是否胜利=",tostring(r.isWinner))
    	if r.endData.isWinner then
    		r.endData.starNum=data:readUnsignedByte()
            print("<推图战斗>:","获得星级=",r.starNum)
    		r.endData.awardData=self.AwardDataDecoder:decode(data)
    	end
    
        return state,r
    end
    
    return state
end

--- 执行
-- @param chapterSid 章节sid
-- @param aircraftList 战机列表
function T:exec(chapterSid,aircraftList,callback)
    self.chapterSid=chapterSid
    self.aircraftList=aircraftList
    AbstractC2SCommand1.exec(self,callback)
end

return T
