--[[
    设置阵型命令
]]
local T = extend(AbstractC2SCommand)

T.type = 8

function T:ctor()
    self.super.ctor(self,ChannelIds.CITY)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeByte(self.formationId)

    local aircraftList = self.aircraftList
    for i = 1,6,1 do
    	local item = aircraftList[i]
    	if item then
    		data:writeShort(item.sid)
    		data:writeShort(item.count)
    	else
    		data:writeShort(0)
    	end
    end


    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   
        FormationManager.formationBox.formationBox[self.formationId]:setFormation(self.aircraftList)
    end

    return state
end

function T:exec(formationId,aircraftList,callback)   -- 阵型下标0,1,2,3,飞机部队
    self.formationId = formationId
    self.aircraftList = aircraftList
    self.super.exec(self,callback)
end

return T
