--- 购买某一个产品
local T = extend(AbstractC2SCommand)

T.type = 2

function T:ctor()
	self.super.ctor(self,ChannelIds.PAY_PORT,true)
end

function T:encode()
	local data = ByteArray:new()
	data:writeByte(self.type)
	data:writeString(self.verifyInfo.verifyInfo)
	return data
end

function T:decode(data)
	local state=data:readUnsignedByte()
	if state == ReturnCode.SUCCESS then
		self:removeMask()
		local awardBool = data:readBoolean()
		if awardBool then
			local AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")
			local award = AwardDataDecoder:decode(data)
			AwardDataDecoder:addAWard(award)
			AwardDataDecoder:showSuccessWindow(award)
			print("显示获得的奖励品")
		end

		print("收到服务器验证充值数据成功")
		DataStorage:delReceipt(UserInfo.id,self.verifyInfo)

		ActivityManager.firstRechargeInfo:setValue() -- 只要充值了就算首冲

		GoodsManager:setThreeMarkValue(self.verifyInfo.id)
		NewPackageManager:setIsBuy(self.verifyInfo.id)

	elseif state == 4 then -- 这一种不清楚订单,下一次登陆的时候继续发
		self:removeMask()
		print("状态码:::::::::::::::" .. state)
		print("后台没处理订单，登陆的时候重新发")
		MUIAlter.show({
			info = Language:get("uc816"),
			size = 30,
		})
	elseif state == 1 then
		self:removeMask()
		print("状态码:::::::::::::::" .. state)
		--        MUIAlter.show({
		--		    info = Language:get("uc813"),
		--		    size = 30,
		--	    })
		DataStorage:delReceipt(UserInfo.id,self.verifyInfo)

	elseif state == 2 then
		self:removeMask()
		print("状态码:::::::::::::::" .. state)
		MUIAlter.show({
			info = Language:get("uc814"),
			size = 30,
		})
		DataStorage:delReceipt(UserInfo.id,self.verifyInfo)

	elseif state == 3 then
		self:removeMask()
		print("状态码:::::::::::::::" .. state)
		MUIAlter.show({
			info = Language:get("uc815"),
			size = 30,
		})
		DataStorage:delReceipt(UserInfo.id,self.verifyInfo)
	else
		print(string.format("充值验证返回未知code,code:%d",state))
	end

	return state
end

function T:exec(verifyInfo,callback) -- 验证消息
	self.verifyInfo = verifyInfo
	self.super.exec(self,callback)
end

--- 移除遮罩
function T:removeMask()
	if GoodsManager and GoodsManager:judgeIsSelf(self.verifyInfo.id) then
		CommonBroadcast:luaDispatchEvent(EVENT_IAP_BUY_GOODS_COMPLETE)
	end

	if NewPackageManager and NewPackageManager:judgeIsSelf(self.verifyInfo.id) then
		CommonBroadcast:luaDispatchEvent(EVENT_IAP_BUY_NEW_RECHARGE_COMPLETE)
	end

end


return T
