--- 绑定账号
local T=Class.BindingAccountCommand(AbstractC2SCommand1)

--- 注册失败
T.REGISTER_FAIL=100

--- 用户名已存在
T.USER_NAME_EXIST=1

--- 设备注册数量已满
T.REGISTER_COUNT_FULL=2

function T:def()
	--- 类型
	self.type=2
end

--- 构造函数
function T:ctor()
	--调用父类的构造成数
	AbstractC2SCommand1.ctor(self,ChannelIds.CHANGENAME,false)
end

function T:encode()
	local data=ByteArray:new();
	data:writeByte(self.type)
	data:writeString(self.uid)
	data:writeString(self.pwd)

	return data
end

function T:decode(data)
	local state=data:readUnsignedByte()--是否处理成功
	if state == ReturnCode.SUCCESS then
		
	elseif state == self.REGISTER_FAIL then
		local errCode=data:readUnsignedByte()--错误码
		if errCode == self.REGISTER_COUNT_FULL then
			local eMailList={}
		
			--读取已注册的邮箱地址列表
			local len=data:readUnsignedByte()
			for i=1,len,1 do
				eMailList[#eMailList+1]=data:readString()
			end
			
			return state,errCode,eMailList
		end
		return stete,errCode,nil
	end

	return state,nil,nil
end

function T:exec(uid,pwd,callback)
	self.uid=uid
	self.pwd=pwd
	AbstractC2SCommand1.exec(self,callback)
end

return T
