--- 登陆数据解析
local T=Class.LoginDataDecoder()

function T:decode(data)
	--同步服务器时间>>---------------------------------------------------------------------
	--- 服务器时区
	local sTimeZone=data:readByte()
	--- 服务器当前的小时(相对于1天)
	local sHoursOfDay=data:readByte()
	--- 服务器的时间
	local sSec=data:readInt()

	print(string.format("服务器时区:%d,服务器小时:%d,服务器时间:%d",sTimeZone,sHoursOfDay,sSec))

	local sTimeZoneOffset=getServerTimeZoneOffset(sTimeZone * 3600,sSec,sHoursOfDay)
	print("服务器时区偏移(秒):",sTimeZoneOffset)

	local localTimeZoneOffset=getLocalTimeZoneOffset()--本地时区偏移(秒)
	print("本地时区偏移(秒):",tostring(localTimeZoneOffset))

	GameUtils:setTimeZoneOffset(sTimeZoneOffset-localTimeZoneOffset)

	local serverTimeSec=GameUtils:modifyTimeZone(sSec)--服务器时间
	TimeUtils:setServerMillis(serverTimeSec*1000)

	print("--程序启动>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>")
	print("服务器时间:",os.date("%Y-%m-%d %H:%M:%S",TimeUtils:getSyncMillis()/1000))
	print("<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<")
	--<<同步服务器时间---------------------------------------------------------------------

	--最新的客户端版本
	local curClientVersion=data:readString()
	print("从服务器获取的最新版本号:",curClientVersion)
	local rUpdateCheck=require("src.app.logic.ReloginUpdateCheck")
	if rUpdateCheck:isHasUpdate(curClientVersion) then
		rUpdateCheck:handleUpdate()

		return false
	end

	UserInfo:decode(data)
	UserInfoMgr:init(UserInfo)
	UserInfoMgr:startUpdateCheck()

	return true
end

return T
