--- 易接登陆
local T=Class.LoginWith1Command(AbstractC2SCommand1)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

function T:def()
	--- 类型
	self.type=1
end

--- 构造函数
function T:ctor()
	--调用父类的构造成数
	AbstractC2SCommand1.ctor(self,ChannelIds.LOGIN_1,false)
end

function T:encode()
	print("____________发送登陆请求____________")

	local data=ByteArray:new();
	data:writeByte(self.type)
	data:writeString(self.channelId)
	data:writeString(self.uid)
	data:writeString(self.accessToken)
	data:writeString(self.clientVersion)
	local languageId=require("src.app.utils.LanguageUtils"):getId()
	print("登陆语言:",languageId)
	data:writeByte(languageId)

	return data
end

function T:decode(data)
	local state=data:readBoolean()--是否处理成功
	if not state then
		local errInfo=data:readString()--错误信息
		local isForceUpdate=data:readBoolean()--是否需要强更
		local updataUrl=data:readString()--强理地址

		return state,errInfo,isForceUpdate,updataUrl
	end

	if require("src.app.communication.login.LoginDataDecoder"):decode(data) then
		return true,UserInfo
	else
		return false,"There is a need to update the content"
	end
end

function T:exec(channelId,uid,accessToken,clientVersion,callback)
	self.channelId=channelId
	self.uid=uid
	self.accessToken=accessToken
	self.clientVersion=clientVersion
	print(string.format("uid:%s,token:%s",self.uid,self.accessToken))
	AbstractC2SCommand1.exec(self,callback)
end

return T
