local _print=print
local function print(...)
	_print("\t<LoginWithEnjoyGameCommand>: ",table.concat({...},"\t"))
end

--- 游客登陆
local T=Class.LoginWithEnjoyGameCommand(AbstractC2SCommand1)

function T:def()
	--- 类型
	self.type=1
end

--- 构造函数
function T:ctor()
	--调用父类的构造成数
	AbstractC2SCommand1.ctor(self,ChannelIds.LOGIN_ENJOY_GAME,false)
end

function T:encode()
	print("____________发送登陆请求____________")

	local data=ByteArray:new();
	data:writeByte(self.type)
	data:writeString(self.accessToken)
	data:writeString(self.uid)
	local languageId=require("src.app.utils.LanguageUtils"):getId()
	print("登陆语言:",languageId)
	data:writeByte(languageId)

	return data
end

function T:decode(data)
	local state=data:readBoolean()--是否处理成功
	if not state then
		local errInfo=data:readString()--错误信息

		return state,errInfo
	end

	if require("src.app.communication.login.LoginDataDecoder"):decode(data) then
		return true,UserInfo
	else
		return false,"There is a need to update the content"
	end
end

function T:exec(uid,accessToken,callback)
	self.uid=uid
	self.accessToken=accessToken
	print(string.format("uid:%s,token:%s",self.uid,self.accessToken))
	AbstractC2SCommand1.exec(self,callback)
end

return T
