--[[
    批量删除邮件
]]
local T = extend(AbstractC2SCommand)

T.type = 11

function T:ctor()
    self.super.ctor(self,ChannelIds.MAIL)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeByte(self.msgType)

    local ids = self.ids
    local length = #ids
    data:writeShort(length)

    for i = 1,length,1 do
        data:writeInt(ids[i])
    end
    
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   
        MailManager:batchDeleteMail(self.msgType,self.ids)
    end

    return state
end

function T:exec(msgType,ids,callback)
    self.msgType = msgType
    self.ids = ids
    self.super.exec(self,callback)
end

return T
