--[[
    获得系统邮件奖励
]]
local T = extend(AbstractC2SCommand)

T.type = 6

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


function T:ctor()
    self.super.ctor(self,ChannelIds.MAIL)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.messageId)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local awardData = nil
    if state == ReturnCode.SUCCESS then   
       awardData = self.AwardDataDecoder:decode(data)
       self.AwardDataDecoder:addAWard(awardData)

       local mailItem = MailManager.mailContentBox.commonMailContentBox.commonMailContents[self.messageId]
       mailItem.isReward = true


    end

    return state,awardData
end

function T:exec(messageId,callback)
    self.messageId = messageId
    self.super.exec(self,callback)
end

return T
