--[[
    回放他人录像
]]
local T = Class.PlayBackOtherCommand(AbstractC2SCommand1)

--- 战斗初始化数据解码器
T.FightInitDataDecoder=require("src.app.communication.fight.FightInitDataDecoder")

T.type = 7

function T:ctor()
    AbstractC2SCommand1.ctor(self,ChannelIds.MAIL)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.otherId)
    data:writeInt(self.messageId)
    data:writeByte(self.fightReportType)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   
        local r={}
    
    	r.fightInitData = self.FightInitDataDecoder:decode(data)
    	
    	return state,r
    end

    return state
end

function T:exec(otherId,messageId,fightReportType,callback) -- otherId：玩家id，messageId：战报id
    self.otherId = otherId
    self.messageId = messageId
    self.fightReportType=fightReportType
    AbstractC2SCommand1.exec(self,callback)
end

return T
