--[[
    查看它人录像内容
]]
local T = extend(AbstractC2SCommand)

T.type = 10

function T:ctor()
    self.super.ctor(self,ChannelIds.MAIL)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.chatInfo.sourceId) -- sourceId：玩家id，battleReportId：战报id
    data:writeInt(self.chatInfo.battleReportId)
    data:writeByte(self.chatInfo.fightReportType)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   
        -- 缓存
        self.chatInfo.fightInfo = require("src.app.model.mail.mailContentBox.MailFightReportContent")()
        
        if self.chatInfo.fightReportType == 4 then
        	self.chatInfo.fightType=FightType.FIGHT_TYPE_ARENA
        else
        	
        end
        
        self.chatInfo.fightInfo:decode(data)
    end

    return state
end

function T:exec(chatInfo,callback) 
    self.chatInfo = chatInfo
    self.super.exec(self,callback)
end

return T
