--[[
    复仇
]]
local T = extend(AbstractC2SCommand)

T.type = 13

function T:ctor()
    self.super.ctor(self,ChannelIds.WORLDMAP)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.x)
    data:writeShort(self.y)
    data:writeInt(self.targetId)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local tb = nil

    if state == ReturnCode.SUCCESS then   
        tb = {}
        tb.type = data:readUnsignedByte()  -- 保留
        tb.lvl = data:readUnsignedByte()      -- 等级
        tb.x = data:readUnsignedShort()       -- x坐标
        tb.y = data:readUnsignedShort()       -- y坐标

        if tb.type == 1 then       -- 玩家
            tb.playerId = data:readUnsignedInt() -- 玩家id
            tb.headId = data:readUnsignedByte()  -- 头像
            tb.isProtection = data:readBoolean()       -- 是否上有保护套
            tb.fighting = data:readUnsignedInt() -- 战斗力
            tb.name = data:readString()         -- 名字
            tb.allianceId = data:readUnsignedInt() -- 联盟id
            if tb.allianceId ~= 0 then 
                tb.allianceName = data:readString() -- 联盟名字
            end

            tb.militaryRank = data:readByte() -- 军衔
            tb.honor = data:readInt() -- 荣誉

        end
    end

    return state,tb
end

function T:exec(x,y,targetId,callback)
    self.x = x
    self.y = y
    self.targetId = targetId
    self.super.exec(self,callback)
end

return T
