--region DominanceLevelUpCommand.lua
--Author    : YuDing
--Date      : 2014/12/03
--Introduce : 指挥升级命令

local TEMPLATE = extend(AbstractC2SCommand)

--- 类型,对应于服务器的
TEMPLATE.type = 1

--- 类型
TEMPLATE.data = false

--- 构造函数
function TEMPLATE:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口
    self.super.ctor(self,ChannelIds.SKILL)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeBoolean(self.data)

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()--是否处理成功

    local s = nil
    if state == ReturnCode.SUCCESS then    -- 处理消息成功（物品得要扣）
        s = data:readBoolean()
        local diamond = data:readUnsignedInt()   -- 砖石
        local dLvl = data:readUnsignedByte()     -- 统御等级
        local lucky = data:readUnsignedShort()   -- 幸运值  
        local dNum = data:readUnsignedInt()      -- 统御书

        SetStates.dominanceLuckyState:setDominanceLucky(lucky) -- 幸运值
        PlayerInstance:setDiamond(diamond)
        PlayerInstance:setDominanceBook(dNum)
        PlayerInstance:setDominanceLevel(dLvl)

        if s == true then -- 成功
            MUIAlter_singleLine.show( {info = Language:get("v34", PlayerInstance:getDominanceExtraPlane()),showSecond = 1 } )
        else
            MUIAlter_singleLine.show( {info = Language:get("fy1003"),showSecond = 1 } )
        end
    else -- 错误
        ErrorCode:popErrorCodeTip(state)
    end

    return state, s
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(data, callback)
    self.data = data
    self.super.exec(self, callback)
end

return TEMPLATE






--endregion
