--region SkillLevelUpCommand.lua
--Author    : YuDing
--Date      : 2014/12/02
--Introduce : 技能升级命令

local TEMPLATE = extend(AbstractC2SCommand)

--- 类型,对应于服务器
TEMPLATE.type = 2

--- 技能id
TEMPLATE.id = nil
--- 是否使用钻石升级
TEMPLATE.useDiamond = nil
--- 构造函数
function TEMPLATE:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口
    self.super.ctor(self, ChannelIds.SKILL)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.id)
    data:writeBoolean(self.useDiamond)

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()--是否处理成功
    local diamond = nil
    if state == ReturnCode.SUCCESS then
        -- 得到需要消耗的
        diamond = data:readUnsignedInt()

        local num = PlayerInstance:getSkillLevelupSkillPointNeedByID(self.id)
        -- 升级
        PlayerInstance:playerSkillLevelUp(self.id)
        -- 扣技能点
        PlayerInstance:reduceSkillPoint(num)
        -- 钻石
        PlayerInstance:setDiamond(diamond)
    else 
        ErrorCode:popErrorCodeTip(state)
    end

    return state, data
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(data, callback, useDiamond)
    self.id = data
    if not useDiamond then 
        self.useDiamond = false
    else 
        self.useDiamond = useDiamond
    end

    self.super.exec(self, callback)
end

return TEMPLATE

--endregion
