--region SkillResetCommand.lua
--Author    : YuDing
--Date      : 2014/12/02
--Introduce : 技能重置

local TEMPLATE = extend(AbstractC2SCommand)

--- 类型,对应于服务器的
TEMPLATE.type = 3

--- 构造函数
function TEMPLATE:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口
    self.super.ctor(self,ChannelIds.SKILL)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()--是否处理成功
    local diamond = false
    local point = 0

    if state == ReturnCode.SUCCESS then    -- 处理消息成功（物品得要扣）
        diamond = data:readUnsignedInt()
        --point = data:readUnsignedInt()

        -- 重置
        PlayerInstance:playerSkillReset()
        -- 技能点
        --PlayerInstance:setSkillPoint(point)
        -- 设置钻石
        PlayerInstance:setDiamond(diamond)
        PlayerInstance:luaDispatchEvent(PlayerInstance.noticeMessage.skillReset)
    else 
        ErrorCode:popErrorCodeTip(state)
    end

    return state, diamond
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(callback)
    self.super.exec(self, callback)
end

return TEMPLATE





--endregion
