--- 使用双倍充值道具
local T=extend(AbstractC2SCommand)

--- 类型
T.type = 4

--- 构造函数
function T:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口
    self.super.ctor(self,ChannelIds.PROP)
end

--- 封装发送的数据
function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.propSid)
    data:writeShort(self.iapSid)

    return data
end

--- 解码接收的数据并且处理数据
function T:decode(data)
    local state=data:readUnsignedByte()--是否处理成功
    if state == ReturnCode.SUCCESS then
        SetStates.threePurchaseState:setTypeValueNotGet(self.threeMarkValue)

        local num = PropsInfoMgr:getPlayerPropByID(self.propSid)
        PropsInfoMgr:setPlayerPropByID(self.propSid,num - 1)


    end

    return state
end

--- 请求时传入参数并且保存在这个文件中
function T:exec(propSid,iapSid,threeMarkValue,callback)
    self.propSid = propSid --  道具sid
    self.iapSid = iapSid -- 需要重置档位的商品sid
    self.threeMarkValue = threeMarkValue

    self.super.exec(self,callback)
end

return T
