--[[
    获得排行榜命令
]]
local T = extend(AbstractC2SCommand)

T.sendType = nil

function T:ctor()
    self.super.ctor(self,ChannelIds.RANK)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.sendType)
    data:writeByte(self.startPos)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    if state == ReturnCode.SUCCESS then   
        if self.sendType == 1 then
            RankManager.rankFight:decode(data)
            RankManager:luaDispatchEvent(RankManager.EVT_TYPE_FIGHT_REFRESH)
        elseif self.sendType == 2 then
            RankManager.rankCheckPoint:decode(data)
            RankManager:luaDispatchEvent(RankManager.EVT_TYPE_CHECKPOINT_REFRESH)
        else
            RankManager.rankAchieve:decode(data)
            RankManager:luaDispatchEvent(RankManager.EVT_TYPE_ACHIEVE_REFRESH)
        end
    end

    return state
end

function T:exec(sendType,startPos,callback)   -- 1:战力排行，2:关卡排行，3：荣誉排行
    self.sendType = sendType
    self.startPos = startPos
    self.super.exec(self,callback)
end

return T
