--[[
    查看角色信息
]]
local T = extend(AbstractC2SCommand)

T.type = 1

function T:ctor()
    self.super.ctor(self,ChannelIds.SOCIAL_CONTACT)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeInt(self.playerId)
    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local dataTable = nil
    if state == ReturnCode.SUCCESS then   
        dataTable = {}
        dataTable.playerId = self.playerId
        dataTable.playerLevel = data:readByte()
        dataTable.head = data:readByte()
        dataTable.name = data:readString()
        dataTable.allianceId = data:readInt()
        if dataTable.allianceId > 0 then
            dataTable.allianceName = data:readString()
        end
        dataTable.combatEffectiveness = data:readInt()

        dataTable.militaryRank = data:readByte() -- 军衔
        dataTable.honor = data:readInt() -- 荣誉值


    end

    return state,dataTable
end

function T:exec(playerId,callback)
    self.playerId = playerId
    self.super.exec(self,callback)
end

return T
