--region FinishTaskCommand.lua
--Author    : YuDing
--Date      : 2015/1/9
--Introduce : 完成任务

local TEMPLATE = extend(AbstractC2SCommand)

TEMPLATE.type = 1

TEMPLATE.AwardDataDecoder = require"src.app.communication.award.AwardDataDecoder"

--- 构造函数
function TEMPLATE:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口
    self.super.ctor(self, ChannelIds.TASK)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.data)

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()--是否处理成功

    local awardData = nil
    if state == ReturnCode.SUCCESS then -- 处理消息成功
        awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
    else
        ErrorCode:popErrorCodeTip(state)
    end

    -- 状态 奖励 sid
    return state, awardData, self.data
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(data, callback)
    self.data = data
    self.super.exec(self, callback)
end

return TEMPLATE







--endregion
