--region   FreshDailyTaskCommand.lua
--Author    : YuDing
--Date      : 2015/4/22
--Introduce : 刷新每日任务

local TEMPLATE = extend(AbstractC2SCommand)

TEMPLATE.type = 5

--- 构造函数
function TEMPLATE:ctor()
    self.super.ctor(self, ChannelIds.TASK)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)

    data:writeByte(self.taskType)
    data:writeBoolean(self.useDiamond)

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()   --是否处理成功

    if state == ReturnCode.SUCCESS then     -- 处理消息成功
        local diamond = data:readUnsignedInt()
        PlayerInstance:setDiamond(diamond)

        UserInfo.dailyTask:decode(data)     -- 重新解析一遍数据
        MUIAlter_singleLine.show( {info = Language:get("uy164"),showSecond = 1 } ) -- "刷新成功"
    else
        ErrorCode:popErrorCodeTip(state)
    end

    return state
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(taskType, useDiamond, callback)
    
    self.taskType = taskType
    self.useDiamond = useDiamond

    self.super.exec(self, callback)
end

return TEMPLATE



--endregion
