--region GetTaskCommand.lua
--Author    : YuDing
--Date      : 2015/1/9
--Introduce : 获得任务

local TEMPLATE = extend(AbstractC2SCommand)

TEMPLATE.type = 2

--- 构造函数
function TEMPLATE:ctor()
    self.super.ctor(self, ChannelIds.TASK)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    local length = #self.data
    data:writeByte(length)
    
    for i = 1, #self.data do 
        data:writeShort(self.data[i])
    end


    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()--是否处理成功
    local tb = {}
    if state == ReturnCode.SUCCESS then    -- 处理消息成功
        local size = data:readUnsignedByte()
        for i = 1, size do 
            table.insert(tb, data:readUnsignedShort())
        end
    else  -- 需不需要弹出框呢
        ErrorCode:popErrorCodeTip(state)
    end

    return state, tb
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(data, callback)
    
    for k, v in pairs(data) do 
        print("领取任务: " .. v)    
    end

    self.data = data
    self.super.exec(self, callback)
end

return TEMPLATE




--endregion
