--region SpeedDailyTaskCommand.lua
--Author    : YuDing
--Date      : 2015/4/23
--Introduce : 加速

local TEMPLATE = extend(AbstractC2SCommand)

TEMPLATE.type = 6

--- 构造函数
function TEMPLATE:ctor()
    self.super.ctor(self, ChannelIds.TASK)
end

--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)

    data:writeShort(self.id)

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()--是否处理成功

    if state == ReturnCode.SUCCESS then    -- 处理消息成功
        local diamond = data:readUnsignedInt()
        PlayerInstance:setDiamond(diamond)

        UserInfo.dailyTask:setTaskTime(self.id, 1) --  设置任务时间为1 始终很小
    else 
        ErrorCode:popErrorCodeTip(state)
    end

    return state
end

--- 请求时传入参数并且保存在这个文件中
-- @param data  sid 
-- @param useDiamond 是否使用钻石
function TEMPLATE:exec(id, callback)
    self.id = id
    self.super.exec(self, callback)
end

return TEMPLATE



--endregion
