local WorldMapInfo=require("src.app.model.WorldMap.WorldMapInfo")

--- 获取世界地图节点块数据
local T=Class.GetMapNodeBlockDataCommand(AbstractC2SCommand1)

function T:def()
	--- 类型
	self.type = 1
end

function T:ctor()
	AbstractC2SCommand1.ctor(self,ChannelIds.WORLDMAP,true)
end

function T:encode()
	local data=ByteArray:new();
	data:writeByte(self.type)
	data:writeShort(self.startX)
	data:writeShort(self.startY)
	data:writeShort(self.endX)
	data:writeShort(self.endY)

	return data
end

function T:decode(data)
	local state=data:readUnsignedByte()
	if state == ReturnCode.SUCCESS then
		local len=data:readUnsignedShort()

		local nodeInfoDict={}
		for i=1,len,1 do
			local nInfo=WorldMapInfo.decodeNode(data)
			nodeInfoDict[nInfo.x..","..nInfo.y]=nInfo
		end

		return state,nodeInfoDict
	end

	return state
end

function T:exec(startX,startY,endX,endY,callback)
	self.startX,self.startY,self.endX,self.endY=startX,startY,endX,endY
	AbstractC2SCommand1.exec(self,callback)
end

return T
