--Author    : YuDing
--Date      : 2015/1/31
--Introduce : 玩家迁移城市

local T = extend(AbstractC2SCommand)

T.type = 4

-- 坐标
T.p = nil
-- 钻石
T.isDiamond = nil

--- 构造函数
function T:ctor()
	--调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口, true代表不用黑色的遮罩
	self.super.ctor(self, ChannelIds.WORLDMAP, false)
end

--- 封装发送的数据
function T:encode()
	local data = ByteArray:new()
	data:writeByte(self.type)
	data:writeShort(self.p.x)
	data:writeShort(self.p.y)
	data:writeBoolean(self.isDiamond)

	return data
end

--- 解码接收的数据并且处理数据
function T:decode(data)
	local state = data:readUnsignedByte()

	if state == ReturnCode.SUCCESS then
		local descripe = Language:get("uc447",self.p.x,self.p.y)
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
	elseif state == 15 then
		local descripe = Language:get("uc445")
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
	elseif state == 16 then
		local descripe = Language:get("uc446")
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
	else
	-- 其它错误
	end

	return state
end

--- 请求时传入参数并且保存在这个文件中
function T:exec(p, isDiamond, callback)
	self.p = p
	self.isDiamond = isDiamond
	self.super.exec(self, callback)
end
return T
