--region NewFile_1.lua
--Author    : YuDing
--Date      : 2014/11/18
--Introduce : 获得收集信息

local TEMPLATE = extend(AbstractC2SCommand)

--- 类型,对应于服务器的
TEMPLATE.type = 9

--- 构造函数
function TEMPLATE:ctor()
    --调用父类的构造成数,UPGRADE通道，是逻辑端口,不是物理端口, true代表不用黑色的遮罩
    self.super.ctor(self, ChannelIds.WORLDMAP, false)
end


--- 封装发送的数据
function TEMPLATE:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)      -- 只有请求数据

    return data
end

--- 解码接收的数据并且处理数据
function TEMPLATE:decode(data)
    local state = data:readUnsignedByte()       --是否处理成功
    local length = nil
    local cc = {}

    if state == ReturnCode.SUCCESS then
        length = data:readUnsignedByte()

        if length > 0 then 
            for i = 1, length do
                local tmp = {}

                tmp.x = data:readUnsignedShort()         -- x坐标
                tmp.y = data:readUnsignedShort()         -- y坐标
                tmp.resType = data:readUnsignedByte()     -- 类型
                tmp.desc = data:readString()             -- 描述

                local index = tmp.x .. "," .. tmp.y

                cc[index] = tmp

            end
        end
        
    end

    return state, cc, length
end

--- 请求时传入参数并且保存在这个文件中
function TEMPLATE:exec(callback)
    self.super.exec(self, callback)
end

return TEMPLATE










--endregion
