--Date      : 2014/10/30
--Introduce : 世界地图获取位置数据命令
local T = Class.WorldMapPositionCommand(AbstractC2SCommand1)

--- 类型,对应于服务器的
T.type = 1

function T:def()
	--- 位置信息，
	--    初始坐标和结束坐标， 一般为 4 * 6的整数倍，目前最大为4倍
	--
	--    里面含有的元素 x, y , type, lvl, rType
	--    1,2,3,4,5分别代表金矿，铁矿，石油，硅矿，钛矿
	self.position = {}

	--- 遮罩
	-- _uiMask
end

--- 构造函数
function T:ctor()
	AbstractC2SCommand1.ctor(self,ChannelIds.WORLDMAP, true)
end

--- 封装发送的数据
function T:encode()
	self:addMask()

	local data = ByteArray:new()
	data:writeByte(self.type)
	data:writeShort(self.position[1].x)
	data:writeShort(self.position[1].y)
	data:writeShort(self.position[2].x)
	data:writeShort(self.position[2].y)
	return data
end

--- 解码接收的数据并且处理数据
function T:decode(data)
	local state = data:readUnsignedByte()       --是否处理成功
	local length = nil
	local rData = {}
	if state == ReturnCode.SUCCESS then
		length = data:readUnsignedShort()
		print("得到世界地图数据：")
		for i = 1, length do
			local tb = {}

			tb.type = data:readUnsignedByte()  -- 保留
			tb.lvl = data:readUnsignedByte()      -- 等级
			tb.x = data:readUnsignedShort()       -- x坐标
			tb.y = data:readUnsignedShort()       -- y坐标

			if tb.type == 1 then       -- 玩家
				tb.playerId = data:readUnsignedInt() -- 玩家id
				tb.headId = data:readUnsignedByte()  -- 头像
				tb.isProtection = data:readBoolean()       -- 是否上有保护套
				tb.fighting = data:readUnsignedInt() -- 战斗力
				tb.name = data:readString()         -- 名字
				tb.allianceId = data:readUnsignedInt() -- 联盟id
				if tb.allianceId ~= 0 then
					tb.allianceName = data:readString() -- 联盟名字
				end

                tb.militaryRank = data:readByte() -- 军衔
                tb.honor = data:readInt() -- 荣誉

			elseif tb.type == 2 then   -- 资源
				tb.resType = data:readUnsignedByte()    -- 资源类型
			end

			table.insert(rData, tb)

			--print(string.format("node(%d,%d):type:%d,level:%d",tb.x,tb.y,tb.type,tb.lvl))
		end

		self.manager:cacheMapData(rData, self.position[1], self.position[2])
	end

	self:rmvMask()
	return state
end

--- 请求时传入参数并且保存在这个文件中
function T:exec(data, callback, manager)
	self.position = data
	self.manager = manager          -- 传入管理器
	AbstractC2SCommand1.exec(self, callback)
end

--- 添加遮罩
function T:addMask()
	local uiMask=self._uiMask
	if not uiMask then
		uiMask=require("src.app.uiScript.components.common.CommunicationWaitingEff")()
		uiMask:retain()
		
		self._uiMask=uiMask
	end

	if not uiMask:getParent() then
		cc.Director:getInstance():getRunningScene():addChild(uiMask)
	end
end

--- 移除遮罩
function T:rmvMask()
	local uiMask=self._uiMask
	if uiMask then
		uiMask:removeFromParent(false)
	end
end

return T
