--[[
    侦查命令
]]
local T = extend(AbstractC2SCommand)

T.type = 6

function T:ctor()
    self.super.ctor(self,ChannelIds.WORLDMAP)
end

function T:encode()
    local data = ByteArray:new()
    data:writeByte(self.type)
    data:writeShort(self.x)
    data:writeShort(self.y)

    return data
end

function T:decode(data)
    local state=data:readUnsignedByte()
    local dataTable = nil
    if state == ReturnCode.SUCCESS then   
        local money = data:readInt()
        PlayerInstance:setGold(money)
        dataTable = {}

        dataTable.type = data:readByte()
        dataTable.id = data:readInt()
        dataTable.time = GameUtils:modifyTimeZone(data:readInt())
        dataTable.isRead = data:readBoolean()
        dataTable.scoutType = data:readByte()

        dataTable.x = data:readShort()
        dataTable.y = data:readShort()

        dataTable.resourceType = data:readByte() -- 资源类型
        dataTable.resourceEfficiency = data:readInt() -- 资源产出

        dataTable.targetName2 = data:readString()
        -- 处理地点(如果是资源点)
        if dataTable.scoutType == 2 then -- 玩家
            
        else
            local first,second = CommonMethod:getCharFromStr(dataTable.targetName2)
            local name = CommonMethod:getRealText(first)
            dataTable.targetName = name .. "Lv" .. second
            dataTable.targetName2 = name .. "Lv." .. second
        end

        dataTable.garrisonName = data:readString()  -- 驻军名字
        dataTable.fightValue = data:readInt()

        -- 驻守部队
        dataTable.defendAircrafts = {}
        local length = data:readByte()
        if length > 0 then
            for i = 1,6,1 do
                local modelData = {}
                modelData.sid = data:readShort()
                if modelData.sid <= 0 then
                    modelData.count = 0
                else
                    modelData.count = data:readShort()
                end
                dataTable.defendAircrafts[i] = modelData
            end
        else
            for i = 1,6,1 do
                local modelData = {}
                modelData.sid = 0
                modelData.count = 0
                dataTable.defendAircrafts[i] = modelData
            end
        end

        -- 掠夺资源
        dataTable.robResources = nil
        local length2 = data:readByte()
        if length2 > 0 then
            dataTable.robResources = {} 
            for i = 1,5,1 do -- 那5种资源
                dataTable.robResources[i] = data:readInt()
            end
        end
    end

    return state,dataTable
end

function T:exec(x,y,callback)  
    self.x = x
    self.y = y
    self.super.exec(self,callback)
end

return T
