--- 字符串转换为 color4b 对象
-- @param text 字符串
local str2c4b=Cocos2dxUtils.str2c4b

--- 字符串转换为 size
-- @param text 字符串
local str2Size=Cocos2dxUtils.str2Size

-- 窗口的标题颜色  一级切换按钮字体颜色  二级切换按钮字体颜色33f1fdff
local _titlecolor = str2c4b('0x33f1fdff')

-- 列表中的每一项的标题字体颜色
local _listViewTitle = str2c4b('0x03e6b9ff')

-- 拥有数量颜色
local _ownCount = str2c4b('0xe59818ff')

-- 数量加的颜色 +58 0x02f752ff
local _addCount = str2c4b('0x00fa96ff')

--- 白色
local _white = str2c4b('0xffffffff')

--- 橙色
local _orange = str2c4b('0xff7f24ff')

--- 黄色
local _yellow = str2c4b('0xffff00ff')

--- 浅蓝色
local _blue = str2c4b('0x01fff7ff')

--- 红色:原来0xe14843ff
local _red = str2c4b('0xfd0000ff')

-- 建造页面标题颜色
local _build = str2c4b('0xcffdfdff')

-- 聊天标题
local _chatTitle = str2c4b('0x7d949eff')

-- 聊天内容
local _chatContent = str2c4b('0xb3feffff')

-- 灰色
local _gray = str2c4b('0x7d949eff')

-- 聊天战报
local _chatFightReport = str2c4b('0xfe8a4bff')

-- 聊天系统
local _chatSystem = str2c4b('0xfcef80ff')

--品质颜色>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-- 品质等级-1级(白色)
local _qualityLv1 = str2c4b('0xffffffff')

-- 品质等级-2级(绿色)
local _qualityLv2 = str2c4b('0x77f9b3ff')

-- 品质等级-3级(蓝色)
local _qualityLv3 = str2c4b('0x70cbf7ff')

-- 品质等级-4级(紫色)
local _qualityLv4 = str2c4b('0xf254cfff')

-- 品质等级-5级(橙色)
local _qualityLv5 = str2c4b('0xfdda9aff')
--品质颜色<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

--- 公用CSS样式表
local T={}

--- 默认CSS样式表
T.default={
	size=24, -- 字号
	color=_white, 	-- 字体颜色, 形如: "0xaabbccdd" 等于 {r=0xaa,g=0xbb,b=0xcc,a=0xdd}
	fontName="Helvetica",	-- 字体名称
	outlineColor=nil, 		-- 描边颜色,
	outlineSize=nil, 		-- 描边粗细, 形如: "2" 等于 2像素,(必须设置 outlineColor )
	shadowColor=nil, 		-- 阴影颜色, 如果指定了 outlineColor ,则此值无效
	shadowOffset=nil 		-- 阴影偏移, 形如: "2,-2" 等于 cc.p(2,-2) (必须设置 shadowColor )
}

--- 提示框标题
T.alterTitle={
	size="30",
	color="0xffffffff",
	outlineColor="0xffffffff",
	outlineSize=1
}

T.alterConfirmButton={
	size="24",
	color="0xffffffff",
}

--- 主界面建筑名称
T.buildingName={
	size=22,
	color=_white,
	shadowColor = str2c4b("0x000000ff"),
	shadowOffset = str2Size("1,-2"),
}

------------------------------------------------------------- 陈立所加 ----------------------------------------------------

-- 透明度暂时为ff
--- 窗口标题
T.windowTitle={
	size = 30,
	color = _titlecolor,
	shadowColor = str2c4b("0x000000ff"),
	shadowOffset = str2Size("1,-2"),
}

--- 顶部框的钻石数量
T.gesNum24 = {
	size = 24,
	color= _white
}

T.gesNum20 = {
	size = 20,
	color= _white
}

--- 一级切换按钮的标题的标签页
T.switchTitleOne = {
	size = 28,
	color = _white,
--	outlineColor = _titlecolor,  -- windows上不管标题颜色改变问题
--	outlineSize = "1"
}

--- 二级切换按钮的标题的标签页
T.switchTitleTwo = {
	size = 28,
	color = _titlecolor
}

--- 默认颜色26有描边
T.default26WithOutline = {
	size = 26,
	color = _white,
	outlineColor = _white,
	outlineSize = "1"
}

--- 默认颜色24有描边
T.default24WithBlackOutline = {
	size = 24,
	color = _white,
	shadowColor="0x000000ff",
	shadowOffset="2,-2"
}

--- 默认颜色24有描边
T.default24WithOutline = {
	size = 24,
	color = _white,
	shadowColor="0xff0000ff",
	shadowOffset="2,-2"
}

--- 默认颜色
T.default50 = {
	size = 50,
	color = _white,
}

T.default28 = {
	size = 28,
	color = _white,
}

T.default26 = {
	size = 26,
	color = _white,
}

T.default24 = {
	size = 24,
	color = _white,
}

T.default22 = {
	size = 22,
	color = _white,
}

T.default20 = {
	size = 20,
	color = _white,
}

T.default14 = {
	size = 14,
	color = _white,
}

T.default10 = {
	size = 10,
	color = _white,
}


T.default18 = {
	size = 18,
	color = _white,
}

T.green20 = {
	size = 20,
	color = '0x00ff00ff',
}

T.green14 = {
	size = 14,
	color = '0x00ff00ff',
}

T.green18 = {
	size = 18,
	color = '0x00ff00ff',
}

T.red20 = {
	size = 20,
	color = _red,
}

T.red22 = {
	size = 22,
	color = _red,
}

T.red24 = {
	size = 24,
	color = _red,
}

T.red26 = {
	size = 26,
	color = _red,
}

--- 按钮上的字
T.buttonText={
	size = 22,
	color = _white,
--	shadowColor = "0x000000ff",
--	shadowOffset = "2,-2",
}

-- listview中的项的标题
T.itemTitle = {
	size = 20,
	color = _listViewTitle
}

T.itemTitle26 = {
	size = 26,
	color = _listViewTitle
}

T.itemTitle24 = {
	size = 24,
	color = _listViewTitle
}

T.itemTitle22 = {
	size = 22,
	color = _listViewTitle
}

--- 拥有
T.ownTitle = {
	size = 20,
	color = _ownCount
}

--- 数量增加-颜色
T.addCount_color={
	color=_addCount
}

--- 数量增加-字号和颜色
T.addCount = {
	size = 24,
	color = _addCount
}

T.addCount26 = {
	size = 26,
	color = _addCount
}

---
T.orange20 = {
	size = 20,
	color = _orange
}

T.orange24 = {
	size = 24,
	color = _orange
}

--- 26号黄色
T.yellow26 = {
	size = 26,
	color = _yellow
}
--- 24号黄色
T.yellow24 = {
	size = 24,
	color = _yellow
}

--- 16号黄色
T.yellow16 = {
	size = 16,
	color = _yellow
}

--- 20号黄色
T.yellow20 = {
	size = 20,
	color = _yellow
}


--- 浅蓝色,26号
T.blue26 ={
	size=26,
	color=_blue
}

--- 浅蓝色24
T.blue24 = {
	size = 24,
	color = _blue
}

--- 浅蓝色20
T.blue20 = {
	size = 20,
	color = _blue
}

--- 资源数
T.resNum={
	size=20,
	color="0xffffffff"
}

--- 弹出窗口的钻石颜色，大小
T.popGems28={
	size = 28,
	color = _yellow
}

T.popGems24={
	size = 24,
	color = _yellow
}

--- 绿色20
T.green20={
	size = 20,
	color = _addCount
}

--- 绿色22
T.green22={
	size = 22,
	color = _addCount
}


--- 绿色24
T.green24={
	size = 24,
	color = _addCount
}

--- 绿色26
T.green26={
	size = 26,
	color = _addCount
}


T.rank1={
	size = 24,
	color = '0x00ffc7ff'
}

T.rank2={
	size = 24,
	color = '0xfff550ff'
}

T.rank3={
	size = 24,
	color = '0xef7aef8ff'
}

T.rank4={
	size = 24,
	color = '0xb5ff9eff'
}

T.build26WithOutline={
	size = 26,
	color = _build,
	outlineColor = _build,
	outlineSize = "1"
}

T.chatName20={
	size = 24,
	color = _chatTitle
}

T.chatNamePrivate20={
	size = 24,
	color = '0xff00ffff'
}

T.chatNameAlliance20={
	size = 24,
	color = _addCount
}


T.chatName24={
	size = 24,
	color = _chatTitle
}

T.chatNameAlliance24={
	size = 24,
	color = _addCount
}

T.chatNamePrivate24={
	size = 24,
	color = '0xff00ffff'
}

T.chatContent20={
	size = 26,
	color = _white
}

T.chatContent24={
	size = 24,
	color = _white
}

T.chatSystem20={
	size = 26,
	color = _chatSystem
}

T.chatSystem24={
	size = 24,
	color = _chatSystem
}

T.chatFightReport20={
	size = 26,
	color = _chatFightReport
}

T.chatFightReport24={
	size = 24,
	color = _chatFightReport
}
-- 20号灰色
T.gray20={
	size = 20,
	color = _gray
}



T._drawCard1_26={
	size = 26,
	color = _qualityLv2
}

T._drawCard1_24={
	size = 24,
	color = _qualityLv2
}

T._drawCard2_26={
	size = 26,
	color = _qualityLv3
}
T._drawCard2_24={
	size = 24,
	color = _qualityLv3
}

T._drawCard3_26={
	size = 26,
	color = _qualityLv4
}
T._drawCard3_24={
	size = 24,
	color = _qualityLv4
}

T._drawCard4_26={
	size = 26,
	color = _qualityLv5
}
T._drawCard4_24={
	size = 24,
	color = _qualityLv5
}

--- 世界地图自己节点的用户名
T.worldMapSelfName = {
	size = 20,
	color = _white,
	shadowColor="0x000000ff",
	shadowOffset="2,-2"
}

--品质样式>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-- 品质等级-1级(白色)
T.qualityLv1={
	color=_qualityLv1
}

-- 品质等级-2级(绿色)
T.qualityLv2={
	color=_qualityLv2
}

-- 品质等级-3级(蓝色)
T.qualityLv3={
	color=_qualityLv3
}

-- 品质等级-4级(紫色)
T.qualityLv4={
	color=_qualityLv4
}

-- 品质等级-5级(橙色)
T.qualityLv5={
	color=_qualityLv5
}
--品质样式<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

------------------------------------------------------------- 陈立所加 ----------------------------------------------------

function T.span(text,className)
	return string.format("<span class='%s'>%s</span>",className,text);
end

return T
