local FightCfg={}

--- 分隔线公式参数
FightCfg.SEPARATE_LINE={a=-23,b=-40,c=31040}

--- 分隔线的旋转角度
FightCfg.SEP_ROTATION=30

--- 阵营1的炮弹旋转角度
FightCfg.BULLET_ROTATION_CAMP_1=-30

--- 阵营2的炮弹旋转角度
FightCfg.BULLET_ROTATION_CAMP_2=-30+180

--- 阵营1的战机位置
FightCfg.AIRCRAFT_LOCS_CAMP_1={
	[0]=cc.p(-214,-89),
	[1]=cc.p(-25,-207),
	[2]=cc.p(164,-325),
	[3]=cc.p(-267,-209),
	[4]=cc.p(-91,-317),
	[5]=cc.p(90,-423)
}

--- 阵营2的战机位置
FightCfg.AIRCRAFT_LOCS_CAMP_2={
	[2]=cc.p(213,79),
	[1]=cc.p(29,177),
	[0]=cc.p(-149,275),
	[5]=cc.p(276,198),
	[4]=cc.p(93,294),
	[3]=cc.p(-86,388)
}

--- 阵营1的战机zorder
FightCfg.AIRCRAFT_Z_ORDER_CAMP_1={
	[0]=1,
	[1]=2,
	[2]=3,
	[3]=4,
	[4]=5,
	[5]=6
}

--- 阵营2的战机zorder
FightCfg.AIRCRAFT_Z_ORDER_CAMP_2={
	[0]=4,
	[1]=5,
	[2]=6,
	[3]=1,
	[4]=2,
	[5]=3
}

function FightCfg:getMaskSize(width,height)
	local sW,sH=width,height
	local rad=math.rad(self.SEP_ROTATION)

	--分隔线的长
	local sepLen=sW/math.cos(rad)
	--经过分隔切分后，长边与短边之差
	local r=sW*math.tan(rad)

	--切分后的长边和短边
	local a,b=((sH+r)/2),((sH-r)/2)

	local h=math.cos(rad)*a
	local w=sepLen+math.sin(rad)*b

	return w,h,a,b
end

function FightCfg:getSepLength(width,height)
	local sW,sH=width,height
	local rad=math.rad(self.SEP_ROTATION)

	--分隔线的长
	local sepLen=sW/math.cos(rad)

	return sepLen
end

--- 
function FightCfg:getMaskSize2(width,height,angle)
	local rad1=math.rad(angle)
	local rad2=math.rad(90-angle)
	
	local a=width*math.cos(rad2)
	local b=width*math.sin(rad2)
	local c=height*math.cos(rad1)
	local d=height*math.sin(rad1)
	
	return b+d,a+c
end

return FightCfg
