--- 一些游戏配置
local T={}

--- 接入的 SDK 类型
SDKType=require("src.frameworks.platformSDKs.SDKType")
--- 当前接入平台
CUR_SDK=SDKType.PLATFORM_UC

--SDKType.PLATFORM_360 			--360
--SDKType.PLATFORM_ENJOY_GAME 	--英卓
--SDKType.PLATFORM_TENGLONG_1 			--易接
--SDKType.PLATFORM_UC 			--UC
--SDKType.PLATFORM_VIVO 		--VIVO

--- 服务器列表获取地址
local IS_TEST = false
if IS_TEST then
	if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
		T.GET_SERVER_LIST_URL="http://120.132.84.238:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"

		--- cpp更新地址
		T.CPP_UPDATE_URL="http://smarturl.it/warplane"
	else
		T.GET_SERVER_LIST_URL="http://120.132.84.238:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"

		--- cpp更新地址
		T.CPP_UPDATE_URL="https://itunes.apple.com/us/app/zhan-ji-di-guo/id1004391639?ls=1&mt=8"
	end

	--107.150.97.197 英卓
	--192.168.0.238 内网服务器
	--120.132.84.238 staging服务器

	--- 是否为测试服务器列表
	T.IS_STAGING=true
else
	if CUR_SDK == nil then
		T.GET_SERVER_LIST_URL="http://123.59.46.108:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"--正式服

		--- cpp更新地址
		T.CPP_UPDATE_URL="https://itunes.apple.com/us/app/zhan-ji-di-guo/id1004391639?ls=1&mt=8"
	elseif CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
		T.GET_SERVER_LIST_URL="http://107.150.97.197:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"--英卓正式服

		--- cpp更新地址
		T.CPP_UPDATE_URL="http://smarturl.it/warplane"
	elseif CUR_SDK == SDKType.PLATFORM_TENGLONG_1 then
		T.GET_SERVER_LIST_URL="http://123.59.84.232:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"--腾龙梦幻-易接正式服

		--- cpp更新地址
		T.CPP_UPDATE_URL="http://smarturl.it/warplane"
	elseif CUR_SDK == SDKType.PLATFORM_UC then
		T.GET_SERVER_LIST_URL="http://123.59.84.232:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"--腾龙梦幻-UC正式服

		--- cpp更新地址
		T.CPP_UPDATE_URL="http://smarturl.it/warplane"
	elseif CUR_SDK == SDKType.PLATFORM_VIVO then
		T.GET_SERVER_LIST_URL="http://123.59.84.232:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"--腾龙梦幻-VIVO正式服

		--- cpp更新地址
		T.CPP_UPDATE_URL="http://smarturl.it/warplane"
	elseif CUR_SDK == SDKType.PLATFORM_HUA_WEI then
		T.GET_SERVER_LIST_URL="http://123.59.84.232:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"--腾龙梦幻-华为

		--- cpp更新地址
		T.CPP_UPDATE_URL="http://smarturl.it/warplane"
	end

	--- 服务器列表获取地址(用于测试自动更新)
	T.GET_SERVER_LIST_URL_TEST_UPDATE="http://120.132.84.238:8580/action/servers_info?version={cpp_version}&sversion={lua_version}"

	--- 是否为测试服务器列表
	T.IS_STAGING=false
end

--- 建筑最高等级
T.BUILDING_MAX_LEVEL=60

--- 玩家名称字符数限制(中文字符为2个字符,英文字符为1个字符)
T.PLAYER_NAME_LIMIT={4,12}

--- 玩家密码字符数限制(中文字符为2个字符,英文字符为1个字符)
T.PLAYER_PWD_LIMIT={4,24}

--- 玩家pve精力点的最大值
T.PVE_POINT_LIMIT=20

--- 玩家pve精力点恢复的时间间隔(秒)
T.PVE_POINT_RECOVER_INTERVAL_SEC=30*60

--- 联盟创建需求
T.ALLIANCE_CREATE_NEED={{1,100000}}

--- 联盟名称字符数限制(中文字符为2个字符,英文字符为1个字符)
T.ALLIANCE_NAME_LIMIT={4,12}

--- 兑换码英文限制数目
T.EXCHANGE_LIMIT = 20

--- 联盟宣言最大字符数(中文字符为2个字符,英文字符为1个字符)
T.ALLIANCE_DEC_CHAR_LIMIT=400

--- 联盟公告最大字符数(中文字符为2个字符,英文字符为1个字符)
T.ALLIANCE_NOTICE_CHAR_LIMIT=400

--- 最大申请联盟数
T.ALLIANCE_MAX_APPLY_LIMIT=5

--- 联盟捐献的每日每种资源的最大捐献次数
T.ALLIANCE_DONATE_LIMIT=6

--- 联盟捐献中使用钻石捐献相对于普通资源的倍数
T.ALLIANCE_DIAMOND_DONATE_TIME=3

--- 联盟捐献公告最大字符数(中文字符为2个字符,英文字符为1个字符)
T.ALLIANCE_DONATE_NOTI_LIMIT=86

--- 联盟每日发送的邮件的最大次数
T.ALLIANCE_MAIL_LIMIT=20

--- 发送邮件内容数量（英文数量）
T.MAIL_CONTENT_LIMIT = 800

--- 发送邮件主题内容（英文数量）
T.MAIL_THEME_LIMIT = 32

--- 聊天信息输入的字符符数限制
T.CHAT_INPUT_LIMIT = 250

--- 战机类型的战略系数
T.AIRCRAFT_FIGHT_COEFFICIENT={25,10,15,40}

--- 技能最大数量
T.MAX_SKILL_NUM = 12

--- 侦查等级（1-60）耗费的金币数
T.SCOUNT_COST_MONEY = {20,40,92,136,192,252,324,408,504,608,724,850,1000,1150,1320,1510,1710,1930,2160,
	2420,2690,2980,3280,3610,3960,4330,4720,5130,5570,6020,6510,7020,7550,8100,8700,
	9300,9900,10600,11300,12000,12800,13600,14400,15200,16100,17000,18000,19000,20000,
	21000,22100,23300,24400,25600,26900,28100,29500,30800,32200,33700}

--- 竞技场挑战次数限制
T.ARENA_CHALLENGE_POINT_LIMIT=5

--- 购买购买一次挑战点花费的钻石
T.ARENA_CHALLENGE_POINT_COST_DIAMOND=20

--- 竞技场挑战失败后冷却时间(秒)
T.ARENA_CHALLENGE_FAIL_COOLDOWN_SEC=10 * 60

--- 竞技场挑战失败后冷却时间购买价格(X钻石/分钟)
T.ARENA_CHALLENGE_FAIL_COOLDOWN_PER_MIN_COST=1

--- 更换头像用的钻石
T.CHANGE_HEAD_DIAMOND = 200

--- 免费增加的声望经验值
T.FREE_ADD_REPUTATION = 20

--- 每次增加的声望经验值
T.ADD_REPUTATION = 1000

--- 消耗钻石 增加声望
T.COST_ADD_REPUTATION_DIAMOND = 100

--- 飞程
T.COST_FLY_COMMAND = 98

--- 能量罩 13
T.ENERGY_COVER_ID = 13

--- 获得重置技能所需要的钻石
T.GET_RESERT_GEMS = 100

--- 账号名长度限制
T.ACCOUNT_NAME_LEN_LIMIT={6,40}

--- 账号密码长度限制
T.ACCOUNT_PWD_LEN_LIMIT={6,20}

return T
