local AbstractEnterFightPlayCommand=require("src.app.controler.enterFight.AbstractEnterFightPlayCommand")

--- 进入竞技场挑战战斗演播
local T=Class.EnterArenaChallengeFightCommand(AbstractEnterFightPlayCommand)

function T:def()
	AbstractEnterFightPlayCommand.def(self)

	--- 目标玩家编号
	-- desPlayerId
end

--- 进入章节战斗演播
-- @param desPlayerId 目标玩家编号
function T:ctor(desPlayerId)
	self.desPlayerId=desPlayerId

	AbstractEnterFightPlayCommand.ctor(self,FightType.FIGHT_TYPE_ARENA)

	self:switchExcessiveWindow()
end

--- 获取战斗数据
function T:getFightData(getCompleteHandler)
	-- 向服务器请求战斗数据
	require("src.app.communication.arena.ChallengeCommand")():exec(
		self.desPlayerId,
		function(state,data)
			if state == ReturnCode.SUCCESS then
				DailyStates:addArenaFightNum(1)
				if data.endData.isWinner then
					require("src.app.communication.arena.GetArenaInfoCommand")():exec()
				end
				ArenaInfoMgr:getFightRecordListFromServer()

				if getCompleteHandler then
					getCompleteHandler(data)
				end
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state),
					callback=function(flag)
						self:_quitFightWindow()
					end
				})
			end
		end
	)
end

return T
