local AbstractEnterFightPlayCommand=require("src.app.controler.enterFight.AbstractEnterFightPlayCommand")

--- 进入竞技场挑战战斗回放
local T=Class.EnterArenaChallengeReplayFightCommand(AbstractEnterFightPlayCommand)

function T:def()
	AbstractEnterFightPlayCommand.def(self)

	--- 邮件编号
	-- self.mailSid=nil
end

--- 进入章节战斗演播
-- @param mailSid 邮件编号
function T:ctor(mailSid)
	self.mailSid=mailSid

	AbstractEnterFightPlayCommand.ctor(self,FightType.FIGHT_TYPE_MAIL_REPLAY)

	self:switchExcessiveWindow()
end

--- 获取战斗数据
function T:getFightData(getCompleteHandler)
	local mailFightReport=MailManager.mailContentBox.mailFightReportContentBox.mailFightReportContents[self.mailSid]
	if mailFightReport and mailFightReport.fightData then
		if getCompleteHandler then
			getCompleteHandler(mailFightReport.fightData)
		end
        return
	end

	require("src.app.communication.arena.AreanChallengeFightPlayBackCommand")():exec(
		self.mailSid,
		function(state,data)
			if state == ReturnCode.SUCCESS then
				if mailFightReport then
					mailFightReport.fightData=data
				end

				if getCompleteHandler then
					getCompleteHandler(data)
				end
			else
				MUIAlter.show({
					info = Language:get("ug420"),
					size = 30,
					callback=function(flag)
						self:_quitFightWindow()
					end
				})
			end
		end
	)
end

return T
