local AbstractEnterFightPlayCommand=require("src.app.controler.enterFight.AbstractEnterFightPlayCommand")

--- 进入章节战斗演播
local T=Class.EnterChapterFightCommand(AbstractEnterFightPlayCommand)

function T:def()
	AbstractEnterFightPlayCommand.def(self)

	--- 章节编号
	-- self.chapterSid=nil

	--- 战机列表
	-- self.aircraftList=nil
end

--- 进入章节战斗演播
-- @param chapterSid 章节编号
-- @param aircraftList 战机列表
function T:ctor(chapterSid,aircraftList)
	self.chapterSid=chapterSid
	self.aircraftList=aircraftList

	AbstractEnterFightPlayCommand.ctor(self,FightType.FIGHT_TYPE_CHAPTER)

	self:switchExcessiveWindow()
end

--- 获取战斗数据
function T:getFightData(getCompleteHandler)
	-- 向服务器请求战斗数据
	require("src.app.communication.fight.GetChapterFightDataCommand")():exec(
		self.chapterSid,
		self.aircraftList,
		function(state,data)
			if state == ReturnCode.SUCCESS then
				BattlesInfoMgr:setSelBattle(self.chapterSid)
				local starCount = BattlesInfoMgr:getStar(self.chapterSid)
				BattlesInfoMgr:setSelBattleStar(starCount)
				BattlesInfoMgr:setTeam(self.aircraftList)

				if data.endData.isWinner then
					PlayerInstance:addPlayerEnergy(-1)
				end


				if getCompleteHandler then
					getCompleteHandler(data)
				end

				if BGMgr:isGuide() then
					BGMgr:fire(BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_COMPLETE)
				end
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state),
					callback=function(flag)
						if BGMgr:isGuide() then
                            AbstractEnterFightPlayCommand._quitFightWindow(self,toWindowStr)

							BGMgr:fire(BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_FAIL)
                        else
                            self:_quitFightWindow()
						end
					end
				})
			end
		end
	)
end

--- 更新数据
function T:_updateData(endData)
	if endData and endData.isWinner then
		if self.fightType == FightType.FIGHT_TYPE_CHAPTER then
			BattlesInfoMgr:setBattleFinished(self.chapterSid,endData.starNum)
		end
	end
end

function T:_quitFightWindow(toWindowStr)
	if BGMgr:isGuide() then
		BGMgr:fire(BGMgr.EVT_CHAPTER_FIGHT_COMPLETE,function()
			AbstractEnterFightPlayCommand._quitFightWindow(self,toWindowStr)
		end)
	else
		AbstractEnterFightPlayCommand._quitFightWindow(self,toWindowStr)
	end
end

return T
