local AbstractEnterFightPlayCommand=require("src.app.controler.enterFight.AbstractEnterFightPlayCommand")

--- 进入章节战斗演播
local T=Class.EnterChapterFightCommand(AbstractEnterFightPlayCommand)

function T:def()
	AbstractEnterFightPlayCommand.def(self)

	--- 章节编号
	-- self.chapterSid=nil

	--- 战机列表
	-- self.aircraftList=nil
end

--- 进入章节战斗演播
-- @param chapterSid 章节编号
-- @param aircraftList 战机列表
function T:ctor(chapterSid,aircraftList)
	self.chapterSid=chapterSid
	self.aircraftList=aircraftList

	AbstractEnterFightPlayCommand.ctor(self,FightType.FIGHT_TYPE_FIRST)

	self:switchExcessiveWindow()
end

--- 获取战斗数据
function T:getFightData(getCompleteHandler)
	if getCompleteHandler then
		local data=require("res.data.beginnersGuide.firstFightData")
		local fightInitData=data.fightInitData
		local camp1,camp2=fightInitData.camp1,fightInitData.camp2
		camp1.name=UserInfoMgr:getPlayerName()
		camp1.level=PlayerInstance:getPlayerLevel()

		camp2.name=Language:get("ug1199")

		getCompleteHandler(data)
	end
end

--- 切换到战斗窗口
function T:_switchFightWindow()
	local fW=require("src.app.uiScript.components.fight.FightWindow").new()

	--初始化战斗演播器
	local fp=self.FightPlayer()
	fp:initFightScene(fW)

	--初始化战斗逻辑运算器
	local fl=self.FightLogicCalcer()
	fl:init(self.fightData)

	if self.uiFightLoading then
		self.uiFightLoading:stop(function()
			self.uiFightLoading:removeFromParent()
			self.uiFightLoading=nil

			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_FIRST_FIHGT_START_PREV,function()
					fl:start()
				end)
			end
		end)
	else
		if BGMgr:isGuide() then
			BGMgr:fire(BGMgr.EVT_FIRST_FIHGT_START_PREV,function()
				fl:start()
			end)
		end
	end

	WindowManager:push(fW)
end

--- 退出战斗窗口
function T:_showEndTip()
	if BGMgr:isGuide() then
		BGMgr:fire(BGMgr.EVT_CHAPTER_FIGHT_COMPLETE,function()
			AbstractEnterFightPlayCommand._showEndTip(self)
		end)
	else
		AbstractEnterFightPlayCommand._showEndTip(self)
	end
end

function T:skip()
	self:__quitFightHandler()
end

return T
