local AbstractEnterFightPlayCommand=require("src.app.controler.enterFight.AbstractEnterFightPlayCommand")

--- 进入邮件战斗回放他人命令
local T=Class.EnterMailReplayOtherFightCommand(AbstractEnterFightPlayCommand)

function T:def()
	AbstractEnterFightPlayCommand.def(self)
end

--- 聊天信息
function T:ctor(chatInfo)
    self.chatInfo = chatInfo

	AbstractEnterFightPlayCommand.ctor(self,FightType.FIGHT_TYPE_MAIL_REPLAY)

	self:switchExcessiveWindow()
end

--- 获取战斗数据
function T:getFightData(getCompleteHandler)
    local chatInfo = self.chatInfo

	if chatInfo and chatInfo.fightData then
		if getCompleteHandler then
			getCompleteHandler(chatInfo.fightData)   
		end
        return
	end

	require("src.app.communication.mail.PlayBackOtherCommand")():exec(
		chatInfo.sourceId,
        chatInfo.battleReportId,
        chatInfo.fightReportType,
		function(state,data)
			if state == ReturnCode.SUCCESS then
				if chatInfo then
					chatInfo.fightData = data
				end

				if getCompleteHandler then
					getCompleteHandler(data)
				end
			else
				MUIAlter.show({
					info = Language:get("ug420"),
					size = 30,
					callback=function(flag)
						self:_quitFightWindow()
					end
				})
			end
		end
	)
end

return T
