--- 心中检测器
local T=Class.HeartBeater(LuaEventDispatcher2)

--- 心跳超时时间
T.TIMEOUT_SEC=25

--- 心跳检测间隔
T.HEART_BEAT_CHECK_INTERVAL_SEC=5

function T:def()
	LuaEventDispatcher2.def(self)

	--- 心跳
	self.HeartBeatCommand=require("src.app.communication.HeartBeatCommand")()

	--- 最后一次向服务器发送请求的时间
	self.lastRequestTimeMs=0

	--- 最后一次收到服务器响应的时间
	self.lastResponseTimeMs=0

	--- 心中检测计时器ID
	self.heartBeatTimeoutID=nil

	--- 心跳延迟计时器ID
	self.heartBeatDelayID=nil
end

function T:ctor()
	LuaEventDispatcher2.ctor(self)
end

--- 开始心跳检测
function T:startHeartBeatCheck()
	if self.heartBeatDelayID then
		return
	end

	CommonBroadcast:luaAddEventListener("app_2_background",nil,function()
		--程序进入后台,停止心跳检测
		self:stop()
	end)
	CommonBroadcast:luaAddEventListener("app_2_foreground",nil,function()
		--程序进入前台,立即发送心跳,检测网络
		if self.heartBeatTimeoutID then
			Cocos2dxUtils:clearScheduler(self.heartBeatTimeoutID)
			self.heartBeatTimeoutID=nil
		end

		self:ping(
			function()
				self:_delayHearBeat()
			end
		)
	end)

	self:_delayHearBeat()
end

--- 延迟后检测心跳
function T:_delayHearBeat()
	self.heartBeatDelayID=Cocos2dxUtils:timeOut(
		function()
			self:ping(
				function()
					self:_delayHearBeat()
				end
			)
		end,
		self.HEART_BEAT_CHECK_INTERVAL_SEC
	)
end

--- 心跳
function T:ping(peng)
	self.heartBeatTimeoutID=Cocos2dxUtils:timeOut(
		function()
			print("心跳包超时")
			NetManager:close()
			self:luaDispatchEvent(NET_PING_TIMEOUT)

			self:stop()
		end,
		self.TIMEOUT_SEC
	)

	--	print("发送心跳包")
	self.HeartBeatCommand:exec(function()
		--		print("收到心跳包")
		if self.heartBeatTimeoutID then
			Cocos2dxUtils:clearScheduler(self.heartBeatTimeoutID)
			self.heartBeatTimeoutID=nil
		end

		if peng then
			peng()
		end
	end)
end

--- 结束
function T:stop()
	if self.heartBeatDelayID then
		Cocos2dxUtils:clearScheduler(self.heartBeatDelayID)
		self.heartBeatDelayID=nil
	end

	if self.heartBeatTimeoutID then
		Cocos2dxUtils:clearScheduler(self.heartBeatTimeoutID)
		self.heartBeatTimeoutID=nil
	end
end

return T
