--- 战斗buff计算器
local FightBuffCalcer={}

--- 增加伤害
FightBuffCalcer.TYPE_DAMAGE_INCR=1

--- 减免伤害
FightBuffCalcer.TYPE_DAMAGE_DECR=2

--- 命中
FightBuffCalcer.TYPE_HIT=3

--- 闪避
FightBuffCalcer.TYPE_DODGE=4

--- 暴击
FightBuffCalcer.TYPE_CRIT=5

--- 暴击抵抗
FightBuffCalcer.TYPE_CRIT_RESIST=6

--- 计算方式-相加
FightBuffCalcer.CLAC_TYPE_ADD=0

--- 计算方式-百分比
FightBuffCalcer.CLAC_TYPE_PERCENT=1

--- 获取buff列表
function FightBuffCalcer:getBuffList(aricrafts)
	local buffs={}

	for k,v in pairs(aricrafts) do
		local buff=BattleBuff_temp[v.sid]

		--- 计算互斥
		local buffType=buff.buffType
		local other=buffs[buffType]
		if not other or buff.value > other.value then
			buffs[buffType]=buff
		end
	end

	return buffs
end

--- 计算攻击伤害加成
-- @param buffs
-- @param damage
function FightBuffCalcer:calcAttackBuffAdd(buffs,damage,desAttackType)
	local add,rate=0,0--百分比不是累乘,而是一次性算完后计算
	for k,v in pairs(buffs) do
		local needDesAttackType=v.target or 0
		if v.attrType == self.TYPE_DAMAGE_INCR and (needDesAttackType == 0 or needDesAttackType == desAttackType) then
			if v.computeType == self.CLAC_TYPE_ADD then
				add=add+v.value
			else
				rate=rate+v.value
			end
		end
	end

	damage=damage*(1+rate/100)+add
	return damage
end

--- 计算防御伤害减免
-- @param buffs
-- @param damage
function FightBuffCalcer:calcDefenceBuffMin(buffs,damage,srcAttackType)
	local add,rate=0,0--百分比不是累乘,而是一次性算完后计算
	for k,v in pairs(buffs) do
		local needDesAttackType=v.target or 0
		if v.attrType == self.TYPE_DAMAGE_DECR and (needDesAttackType == 0 or needDesAttackType == srcAttackType) then
			if v.computeType == self.CLAC_TYPE_ADD then
				add=add-v.value
			else
				rate=rate+v.value
			end
		end
	end

	damage=damage*(1-rate/100)+add
	return damage
end

--- 计算攻击命中加成
function FightBuffCalcer:calcAttackHitAdd(buffs,desAttackType)
	local add,rate=0,0--百分比不是累乘,而是一次性算完后计算
	for k,v in pairs(buffs) do
		local needDesAttackType=v.target or 0
		if v.attrType == self.TYPE_HIT and (needDesAttackType == 0 or needDesAttackType == desAttackType) then
			if v.computeType == self.CLAC_TYPE_ADD then
				add=add+v.value
			else
				rate=rate+v.value
			end
		end
	end

	return add,rate
end

--- 计算防御闪避加成
function FightBuffCalcer:calcDefenceDodgeAdd(buffs,srcAttackType)
	local add,rate=0,0--百分比不是累乘,而是一次性算完后计算
	for k,v in pairs(buffs) do
		local needDesAttackType=v.target or 0
		if v.attrType == self.TYPE_DODGE and (needDesAttackType == 0 or needDesAttackType == srcAttackType) then
			if v.computeType == self.CLAC_TYPE_ADD then
				add=add+v.value
			else
				rate=rate+v.value
			end
		end
	end

	return add,rate
end

--- 计算攻击暴击加成
function FightBuffCalcer:calcAttackCritAdd(buffs,desAttackType)
	local add,rate=0,0--百分比不是累乘,而是一次性算完后计算
	for k,v in pairs(buffs) do
		local needDesAttackType=v.target or 0
		if v.attrType == self.TYPE_CRIT and (needDesAttackType == 0 or needDesAttackType == desAttackType) then
			if v.computeType == self.CLAC_TYPE_ADD then
				add=add+v.value
			else
				rate=rate+v.value
			end
		end
	end

	return add,rate
end

--- 计算防御抗暴击加成
function FightBuffCalcer:calcDefenceCritResistAdd(buffs,srcAttackType)
	local add,rate=0,0--百分比不是累乘,而是一次性算完后计算
	for k,v in pairs(buffs) do
		local needDesAttackType=v.target or 0
		if v.attrType == self.TYPE_CRIT_RESIST and (needDesAttackType == 0 or needDesAttackType == srcAttackType) then
			if v.computeType == self.CLAC_TYPE_ADD then
				add=add+v.value
			else
				rate=rate+v.value
			end
		end
	end

	return add,rate
end

return FightBuffCalcer
