local NetDetector=require("src.app.logic.NetDetector")

local T=Class.NetDetector_1(NetDetector)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

function T:def()
	NetDetector.def(self)
end

function T:ctor()
	NetDetector.ctor(self)
end

function T:_reconnect()
	SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_LOGIN_SUCCESS,self,self.sdkLoginSuccessHandler)
	SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_LOGIN_FAILURE,self,self.sdkLoginFailureHandler)
	SDK_Delegate:doLogin()
end

--- 使用SDK登陆完成
function T:sdkLoginSuccessHandler()
	print("重新登陆成功")

	SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_LOGIN_SUCCESS,self,self.sdkLoginSuccessHandler)
	SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_LOGIN_FAILURE,self,self.sdkLoginFailureHandler)

	NetDetector._reconnect(self)
end

--- 登陆失败
function T:sdkLoginFailureHandler()
	print("重新登陆失败")

	SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_LOGIN_SUCCESS,self,self.sdkLoginSuccessHandler)
	SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_LOGIN_FAILURE,self,self.sdkLoginFailureHandler)

	self:stop()

	MUIAlter.show({
		info=Language:get("ug_netException_reloginTip"),
		triggerCloseMethod="buttons",
		zOrder=TOP_ORDER + 201,
		callback=function()
			--退回到登陆界面
			require("src.app.controler.Back2LoginScenceCommand")()
		end
	})
end

return T
