--- 大转盘次数限制
local T = Class.BigWheelNumState(LuaEventDispatcher2)

--- 设置标记
T.mark = 100

--- 事件--次数刷新
T.EVT_BIG_WHEEL_NUM_REFRESH = "evt_big_wheel_num_refresh"

--- 最大次数
T.MAXCOUNT = 50

function T:def()
    LuaEventDispatcher2.def(self)


    --- 状态列表
	self.list = {}
end


function T:setList(list)
    self.list = list
end


--- 得到抽取的次数
function T:getNum()
    if self.list[self.mark] then 
        if self.list[self.mark] <= 0 then
            return 0
        else
            return self.list[self.mark]
        end     
    else
        return 0
    end

end

--- 设置抽取的次数
function T:setNum(num)
    self.list[self.mark] = num
    self:luaDispatchEvent(self.EVT_BIG_WHEEL_NUM_REFRESH)

    local bigWheelInfo = ActivityManager.bigWheelInfo
    bigWheelInfo:luaDispatchEvent(bigWheelInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. bigWheelInfo.sid)

    local bigWheelInfo2 = ActivityManager.bigWheelInfo2
    bigWheelInfo2:luaDispatchEvent(bigWheelInfo2.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. bigWheelInfo2.sid)

end

--- 增加抽取的次数
function T:addNum(addNum)
    local count = self:getNum()
    self:setNum(count + addNum)

end

--- 判断是否可以免费抽取,true:可以免费抽取，fasle:不能,指挥官等级大于等于15级可参与
function T:judgeIsFreeLottery()
    local num = self:getNum()
    if num == 0 then
        return true
    else
        return false
    end

end

--- 判断是否可以抽取，50次满了则不能
function T:judgeIsLottery()
    if self:getNum() < 50 then
        return true
    else
        return false
    end

end



return T
