--- 城市信息
local T=Class.CityInfo()

--- 建筑物集合信息
T.BuildingsInfo=require("src.app.model2.build.BuildingsInfo")

--- buff队列
T.BuffQueueInfo=require("src.app.model2.buff.BuffQueueInfo")

--- 技能队列
T.SkillBox = require "src.app.model.skill.SkillBox"

--- 科技信息
T.TechnologiesInfo=require("src.app.model2.technology.TechnologiesInfo")

--- 战机生产队列
T.AircraftProduceQueue=require("src.app.model2.aircraftFactory.AircraftProduceQueue")

--- 配件系统管理
AccessorySystemManager = require("src.app.model.accessory.AccessorySystemManager")()

--- 荣誉系统管理
HonorManager = require("src.app.model.honor.HonorManager")()


function T:def()
	--- 玩家的战斗力
	self.fighting = 0

	--- 玩家的成就点
	self.achieve = 0

	---资源上次恢复的时间(秒)
	self.resourceTime=0

	---金币
	self.money=0

	---铁矿
	self.steel=0

	---石油
	self.oil=0

	---铝矿
	self.aluminium=0

	---钛矿
	self.titanium=0

	--- 世界坐标x
	self.worldPositionX = nil

	--- 世界坐标y
	self.worldPositionY = nil

	---建筑物集合信息
	self.buildingsInfo=nil

	---建筑建造队列
	self.buildingQueue=nil

	--- 攻击过的npc最大等级
	self.npcMaxLvl = nil

	---BuffQueue
	self.buffQueue = nil

	--- 技能盒子
	self.skillBox = mapping({}, T.SkillBox)


	--- 战机信息
	self.aircraftBox = mapping({}, require("src.app.model.aircraft.AircraftBox"))

	--- 出征部队任务队列
	self.armyTask = mapping({}, require("src.app.model.army.armyTask.ArmyTaskQueue"))
end

--- 反序列化
function T:ctor(data)
	self.worldPositionX = data:readShort()    -- 有符号short， 游戏后期可能使用
	self.worldPositionY = data:readShort()
	self.npcMaxLvl = data:readUnsignedByte()   -- 攻击过的最大npc等级

	self.fighting = data:readUnsignedInt()  -- 战斗力

	self.achieve = data:readUnsignedInt()  -- 成就
	ArenaInfoMgr:addIntegral(data:readUnsignedInt()) --竞技场积分

	self.militaryRank = data:readUnsignedByte() -- 军衔
	self.seniorDLevel = data:readShort() -- 高级指挥
	self.honor = data:readInt() -- 荣誉
	self.revenge = data:readInt() -- 复仇
    self.showType = data:readByte() -- 城市当前的显示类型


	self.resourceTime=GameUtils:modifyTimeZone(data:readUnsignedInt())
	self.money=data:readUnsignedInt()
	self.steel=data:readUnsignedInt()
	self.oil=data:readUnsignedInt()
	self.aluminium=data:readUnsignedInt()
	self.titanium=data:readUnsignedInt()

	self.buildingsInfo=self.BuildingsInfo(data)

	---buff时间队列
	self.buffQueue=self.BuffQueueInfo(data)

	-- 关卡buff
	BattlesInfoMgr:initChapterBuffsInfo(require("src.app.model2.battle.ChapterBuffsInfo")(data))

	-- 技能
	self.skillBox:decode(data)

	---科技信息
	self.technologiesInfo=self.TechnologiesInfo(data)

	--- 招募队列反序列化
	self.aircraftProduceQueue=self.AircraftProduceQueue(data)

	--- 战机的数量反序列化
	self.aircraftBox:decode(data)
	self.aircraftBox:decodeRepair(data)
	self.aircraftBox:decodeDefend(data)

	--- 出征部队任务的序列化
	self.armyTask:decode(data)

	AircraftStrengManager.aircraftStrengBox:decode(data)

	--- 解析配件系统
	AccessorySystemManager:getSlotBox():decode(data)
	AccessorySystemManager:getAccessoryBox():decode(data)
	AccessorySystemManager:getSlotBox():setAccessoryAirType()
end

return T
