--- 城市信息管理器(单例)
local T=Class.CityInfoMgr(LuaEventDispatcher2)

--- 事件-数据被重置
T.EVT_TYPE_RESET="evt_type_reset"

function T:def()
	LuaEventDispatcher2.def(self)

	--- 玩家数据
	-- self.info=nil

	--- 更新计时器ID
	-- self.updateId = nil

	--- 距离下次回复的剩余时间
	self.pveRecoverRemaing=0
end

function T:ctor()
	LuaEventDispatcher2.ctor(self)
end

--- 初始化
-- @param cityInfo 玩家数据
function T:init(cityInfo)
	self.info=cityInfo

	BuildingsInfoMgr:init(cityInfo.buildingsInfo)
	BuffQueueInfoMgr:init(cityInfo.buffQueue)
	TechnologiesInfoMgr:init(cityInfo.technologiesInfo)
	AircraftProduceQueueMgr:init(cityInfo.aircraftProduceQueue)
	ArmyTaskQueueManager:init(cityInfo.armyTask.armyTaskQueue)

	self:luaDispatchEvent(self.EVT_TYPE_RESET)
end

--- 开始更新检查
function T:_startUpdateCheck()

end

--- 结束更新检查
function T:_stopUpdateCheck()

end

--- 开始更新检查
function T:startUpdateCheck()
	BuildingsInfoMgr:startUpdateCheck()
	BuffQueueInfoMgr:startUpdateCheck()
	ResourceManager:startUpdateCheck()
	TechnologiesInfoMgr:startUpdateCheck()
	AircraftProduceQueueMgr:startUpdateCheck()
	ArmyTaskQueueManager:startUpdateCheck()

	self:_startUpdateCheck()
end

--- 结束更新检查
function T:stopUpdateCheck()
	BuildingsInfoMgr:stopUpdateCheck()
	BuffQueueInfoMgr:stopUpdateCheck()
	ResourceManager:stopUpdateCheck()
	TechnologiesInfoMgr:stopUpdateCheck()
	AircraftProduceQueueMgr:stopUpdateCheck()
	ArmyTaskQueueManager:stopUpdateCheck()

	self:_stopUpdateCheck()
end

return T()
