--Author    : Yuding
--Date      : 2014/10/9
--Introduce : 通用玩家信息类

local T = Class.T(LuaEventDispatcher2)

--- 技能增加数值数组：（扩大100倍）
T.skillAddAttribute = {
	1,2,3,4,5,6,7,8,9,10,11,12,
	13,14,15,16,17,18,19,20,21,
	22,23,24,25,26,27,28,29,30,
	31,32,33,34,35,36,37,38,39,
	40,41,42,43,44,45,46,47,48,
	49,50,51,52,53,54,55,56,57,
	58,59,60,61,62,63,64,65,66,
	67,68,69,70
}

--- 声望的升级配置
T.reputationLvlCfg = {
	100,200,300,400,500,600,700,800,900,1000,1100,
	1200,1300,1400,1500,1600,1700,1800,1900,2000,
	2100,2200,2300,2400,2500,2600,2700,2800,2900,
	3000,3100,3200,3300,3400,3500,3600,3700,3800,
	3900,4000,4100,4200,4300,4400,4500,4600,4700,
	4800,4900,5000,5100,5200,5300,5400,5500,5600,
	5700,5800,5900,6000,6100,6200,6300,6400,6500,
	6600,6700,6800,6900,7000
}

--- 统率 幸运值 1-60
T.dominanceLuckyCfg = {
	1,1,1,1,1,2,2,2,2,2,3,3,3,3,3,4,
	4,4,4,4,5,5,5,6,6,6,7,7,7,8,8,
	8,9,9,9,10,12,14,16,18,20,20,25,
	30,35,40,45,50,55,60,65,70,75,80,
	90,100,100,100,100,100
}

--统帅等级初始为0级
--统帅等级上限=人物当前等级
--统帅等级带兵数量=当前指挥等级*2
--统帅升级消耗： 统帅书*1+成功率
--技能等级上限=人物当前等级
--技能升级消耗=人物当前等级
--人物当前带兵总量=当前指挥等级*2+当前等级人物基础带兵数量

-- 建筑对应的sid
--主基地   l=1
--1号机库  l=2
--2号机库  l=3
--研究所   l=4
--改造工厂 l=5
--仓库1   l=6
--仓库2   l=7
--金币    l=8

--1级开放 机库1
--3级开放 铸币厂
--5级开放 科研中心和联盟
--6级开放 仓库1
--11级开放 仓库2
--13级开放 机库2和改装车间

-- 石油的更新消息
T.noticeMessage =
	{
		oil = "oil",            -- 石油
		steel = "steel",        -- 铁矿
		tati = "tati",          -- 钛矿
		silicon = "silicon",    -- 硅矿
		gold = "gold",         -- 金矿
		energy = "energy",       -- 能量
		fighting = "fighting",   -- 战斗力
		exp = "exp",               -- 经验
		name = "name",            -- 名字
		dominanceLvl = "dominanceLvl",   -- 指挥
		dominanceNum = "dominanceNum",   -- 指挥书 数量
		diamond = "diamond", -- 钻石
		buildingLvl = "buildingLvl", -- 建筑
		unLock = "unLock",                  -- 建筑解锁
		playerLvl = "playerLvl",          -- 玩家等级
		medal = "skillPoint",                   -- 荣誉勋章（技能点）
		skillLvl = "skillLvl",                  -- 技能等级
		skillReset = "skillReset",              -- 技能重置
		prop = "prop",      -- 物品
		produceProp = "produceProp",                  -- 产生物品
		honor = "honor", -- 荣誉
		reputationLevel = "reputationLevel", -- 声望等级
		reputationExp = "reputationExp", -- 声望经验
		destroyBld = "destroyBld", -- 摧毁建筑 后面接建筑位置id 如 destroyBuilding .. id
		skillReset = "skillReset", -- 技能重置
		maxAttackNPC = "maxAttackNPC", -- 最大的攻击NPC
		changeWorldPositon = "changeWorldPositon", -- 改变世界坐标
		vipPoint = "vipPoint",  -- vip点数,经验值
		vipLvl = "vipLvl",      -- vip等级
		headId = "headId", --  玩家头像
		showType = "showType", --  玩家主城显示类型

	}

-- 固定的建筑物位置
T.fixedBldLocation ={
	center = 1,        	-- 指挥中心  sid = 1
	planeOne = 2,       -- 1号机库   sid = 2
	planeTwo = 3,       -- 2号机库   sid = 2
	study = 4,          -- 科研中心   sid = 3
	make = 5,           -- 改造工厂   sid = 4
	storeOne = 6,       -- 仓库1     sid = 5
	storeTwo = 7,       -- 仓库2     sid = 5
	gold = 8,           -- 铸币厂    sid = 6
	region = 9,         -- 联盟 无sid
	wish = 10,          -- 许愿池  无sid
	command = 11,       -- 作战中心  暂时无sid
	toResouce = 12,		-- 切换到郊外
	arena = 13,			-- 竞技场
}

T.resSid = {
	["gold"] = 6,
	["steel"] = 7,
	["oil"] = 8,
	["silicon"] = 9,
	["tati"] = 10,
}

-- 资源位置 101-134

function T:def()
	LuaEventDispatcher2.def(self)

	self.playerLvlDiff = false  -- 玩家等级变化值，默认为false

end

-- 构造函数
function T:ctor()

end

--- 得到玩家主城显示类型
function T:getPlayerShowType()
	return UserInfo.city.showType
end

--- 设置玩家主城显示类型:
function T:setPlayerShowType(value)
	UserInfo.city.showType = value

	local mapX, mapY = PlayerInstance:getWorldPosition()
	WorldMapMgr:updateNodesDataForced({
		{x = mapX, y = mapY},
	})

	self:luaDispatchEvent(self.noticeMessage.showType)
end


--- 得到玩家的名字
function T:getPlayerName()
	return UserInfo.name
end

--- 设置玩家名字
function T:setPlayerName(name)
	if name ~= nil then
		UserInfo.name = name
	end
end

function T:getFirstRankName()
	return "xixixixi"
end

function T:setFirstRankName(name)
	self:luaDispatchEvent(self.noticeMessage.firstRankName)
end


function T:addVipPoint(num)
	VipManager:addVipPoint(num)

end


--- 得到玩家的经验
-- @return 当前经验
function T:getPlayerExp()
	return UserInfo.exp
end
--- 设置经验值
function T:setPlayerExp(num)
	if num < 0 then
		return
	end

	UserInfo.exp = num
	self:luaDispatchEvent(self.noticeMessage.exp)
end
-- 当前等级最大经验
function T:getPlayerMaxExp()
	-- return PlayerDataCfg[UserInfo.level].lvlexp
	return User_temp[self:getPlayerLevel()].toNextExp
end

--- 增加经验
function T:addPlayerExp(num)
	if not num then num = 0 end
	UserInfo.exp = UserInfo.exp + num
	if UserInfo.exp >= User_temp[self:getPlayerLevel()].toNextExp then

		if self:getPlayerLevel() == #User_temp then -- 达到最大等级 结束递归
			UserInfo.exp = User_temp[self:getPlayerLevel()].toNextExp
			self:luaDispatchEvent(self.noticeMessage.exp)
			return
		end

		UserInfo.exp = UserInfo.exp - User_temp[self:getPlayerLevel()].toNextExp
		self:playerLevelUp() -- 升级
		self:addPlayerExp()   -- 递归， 因为可能会出现突然升两级的情况
	else --  结束递归  派发改变经验的事件
		self:luaDispatchEvent(self.noticeMessage.exp)
	end

end


--- 得到玩家的能量值
-- @return 当前能量
function T:getPlayerEnergy()
	return UserInfo.pvePoint
end
-- 增加能量值
-- @param num 数量
-- @sys bool 系统增加
function T:addPlayerEnergy(num, sys)
	local max=self:getPlayerMaxEnergy()

	local curVal=UserInfo.pvePoint + num
	-- 系统增加的 有最大值限制
	-- 玩家得奖励或者买的能量没有最大值限制
	UserInfo.pvePoint=math.max(0,sys and math.min(max,curVal) or curVal)

	UserInfoMgr:localNotiCheck_pvePoint()
	self:luaDispatchEvent(self.noticeMessage.energy)
end

-- 最大能量
function T:getPlayerMaxEnergy()
	return GameCfg.PVE_POINT_LIMIT
end

-- 荣誉
function T:getHonor()
	if not UserInfo.honor then UserInfo.honor = 0 end
	return UserInfo.honor
end
-- 增加荣誉
function T:addHonor(num)
	if not UserInfo.honor then UserInfo.honor = 0 end
	UserInfo.honor = UserInfo.honor + num
	self:luaDispatchEvent(self.noticeMessage.honor)
end
-- 设置荣誉值
function T:setHonor(num)
	if not UserInfo.honor then UserInfo.honor = 0 end
	UserInfo.honor = num
end
-- 获得声望等级
function T:getReputationLvl()
	if not UserInfo.reputationLevel then UserInfo.reputationLevel = 0 end
	return UserInfo.reputationLevel
end
-- 声望升级
function T:reputationLvlUp()
	if not UserInfo.reputationLevel then UserInfo.reputationLevel = 0 end
	UserInfo.reputationLevel = UserInfo.reputationLevel + 1
	self:luaDispatchEvent(self.noticeMessage.reputationLevel)
end
-- 设置等级
function T:setReputationLvl(lvl)
	UserInfo.reputationLevel = UserInfo.reputationLevel or 0
	if UserInfo.reputationLevel == lvl then return end
	UserInfo.reputationLevel = lvl
	self:luaDispatchEvent(self.noticeMessage.reputationLevel)
end
-- 声望值
function T:getReputationCurrentExp()
	UserInfo.reputationExp = UserInfo.reputationExp or 0
	return UserInfo.reputationExp
end
--- 设置声望值
function T:setReputationExp(num)
	if UserInfo.reputationExp == num then return end
	self:luaDispatchEvent(self.noticeMessage.reputationExp)
end

--- 增加声望经验值
--- 可能连续升多级的情况
function T:addReputationExp(num)
	if not num then num = 0 end
	UserInfo.reputationExp = UserInfo.reputationExp + num

	local lvl = self:getReputationLvl()

	if lvl == #self.reputationLvlCfg then -- 最大等级 结束递归
		UserInfo.reputationExp = 0 -- 经验置为0

		self:luaDispatchEvent(self.noticeMessage.reputationExp)
		return
	end

	if UserInfo.reputationExp >= self.reputationLvlCfg[lvl + 1] then

		if self:getPlayerLevel() == #self.reputationLvlCfg then -- 达到最大等级 结束递归
			UserInfo.reputationExp = 0
			self:luaDispatchEvent(self.noticeMessage.reputationExp)
			return
		end

		UserInfo.reputationExp = UserInfo.reputationExp - self.reputationLvlCfg[lvl + 1]
		self:reputationLvlUp()  -- 升级
		self:addReputationExp() -- 递归， 因为可能会出现突然升两级的情况
	else --  结束递归  派发改变经验的事件
		self:luaDispatchEvent(self.noticeMessage.reputationExp)
	end
end

-- 声望最大值
function T:getReputationCurrentMaxExp()
	local lvl = self:getReputationLvl()
	local max = #self.reputationLvlCfg
	if lvl >= max then -- 达到最大等级
		return self.reputationLvlCfg[lvl]
	else -- 获取下一级的经验
		return self.reputationLvlCfg[lvl + 1]
	end
end

function T:getVipLevel()
	return UserInfo.vipLevel
end

function T:setVipLevel(lvl)
	UserInfo.vipLevel = lvl
	self:luaDispatchEvent(self.noticeMessage.playerLvl) -- 派发
	self:luaDispatchEvent(self.noticeMessage.vipLvl) -- 派发
end

--- 获取玩家等级
function T:getPlayerLevel()
	return UserInfo.level
end
--- 升级
function T:playerLevelUp()
	if UserInfo.level == #User_temp then return end -- 最大等级

	self:setPlayerLvlDiff(true) -- 这种情况必然升级

	UserInfo.level = UserInfo.level + 1

	if CUR_SDK then
		if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
			SDK_Delegate:traking_roleLevel(UserInfo.level)
		elseif CUR_SDK == SDKType.PLATFORM_TENGLONG_1 or CUR_SDK == SDKType.PLATFORM_UC or CUR_SDK == SDKType.PLATFORM_HUA_WEI or CUR_SDK == SDKType.PLATFORM_VIVO then
			local serverInfo = ServerListMgr:getServerData(NetManager.data.serverId)

			SDK_Delegate:trakingUpdateUserInfo(UserInfo.id,UserInfo.name,UserInfo.level,serverInfo.id,serverInfo.name)
		end
	end

	self:luaDispatchEvent(self.noticeMessage.playerLvl) -- 派发
end
--- 设置玩家等级
function T:setPlayerLevel(lvl)
	if not lvl or lvl <= 0 then return end
	UserInfo.level = lvl

	if CUR_SDK then
		if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
			SDK_Delegate:traking_roleLevel(UserInfo.level)
		elseif CUR_SDK == SDKType.PLATFORM_TENGLONG_1 or CUR_SDK == SDKType.PLATFORM_UC or CUR_SDK == SDKType.PLATFORM_HUA_WEI or CUR_SDK == SDKType.PLATFORM_VIVO then
			local serverInfo = ServerListMgr:getServerData(self.data.serverId)

			SDK_Delegate:trakingUpdateUserInfo(UserInfo.id,UserInfo.name,UserInfo.level,serverInfo.id,serverInfo.name)
		end
	end

	self:luaDispatchEvent(self.noticeMessage.playerLvl) -- 派发
end

--- 设置玩家等级变化差异值,false:等级没上升，true:等级上升了
function T:setPlayerLvlDiff(judge)
	self.playerLvlDiff = judge
end

--- 设置玩家等级变化差异值
function T:getPlayerLvlDiff()
	return self.playerLvlDiff
end


--- 获取玩家战斗力
function T:getPlayerFight()
	if not UserInfo.city.fighting then UserInfo.city.fighting = 0 end
	return UserInfo.city.fighting
end

--- 设置玩家战斗力
function T:setPlayerFight(num)
	if not UserInfo.city.fighting then UserInfo.city.fighting = 0 end
	UserInfo.city.fighting = num
	self:luaDispatchEvent(self.noticeMessage.fighting)
end

--- 获取玩家战斗力方法:把现在主界面停的飞机和出征的飞机加上算最大战力
--派发事件:
--    在道具buff(BuffQueueInfoMgr)加成（这个去了，不加）
--    在战机强化加成（加了）
--    在技能升级完成(加了)
--    在科技升级完成(加了)
--    在统帅升级完成（加了）
--    在部队任务(加了)
--    在战机数据刷新（加了）
--    章节buff(BattlesInfoMgr)(加了)
--    联盟科技（加了）
--    配件系统(加了)]]
function T:setPlayerFightLogic(judge)
	if not UserInfo.city then return end -- 章节buff的时候还没有city
	local aircrafts = UserInfo.city.aircraftBox:getAllAircrafts() -- 空闲的战机和防守部队之和
	local armyAircrafts = ArmyTaskQueueManager:getAllAircraftTotal() -- 执行任务的飞机部队总和

	local maxFightTeam = self:getMaxFightTeam(self:getTeamAdd(aircrafts,armyAircrafts))
	--maxFightTeam = { {sid = 16,count = 10},{sid = 8,count = 41},{sid = 8,count = 41},{sid = 8,count = 41},{sid = 8,count = 41},{sid = 8,count = 36},}
	local fight = 0
	if maxFightTeam then
		for k,v in pairs(maxFightTeam) do
			if v.sid ~= 0 and v.count ~= 0 then
				local c = v.count
				fight = fight+self:getAircraftFight(v,c)
			end
		end
	end

	if fight >= 0 and fight < 1 then
		fight = 1
	else
		fight = math.floor(fight)
	end


	local lastFight = self:getPlayerFight()
	self.fightDiff = fight - lastFight  -- 战斗力差值

	if judge then
		self.fightDiff = nil
	end


	self:setPlayerFight(fight)

end

--- 把2个飞机部队合成一个部队,team1是放的飞机部队(num)，team2是任务的部队(team2有16个,count)
function T:getTeamAdd(team1,team2)
	local team = mapping({},team1)

	for i = 1,16,1 do
		if team2[i] and team2[i].sid == team[i].sid then
			team[i].num = team[i].num + team2[i].count
		end
	end

	return team
end


--- 获得玩家最大等级
function T:getPlayerMaxLevel()
	return User_temp[#User_temp].level
end

--- 最大等级
-- @return true 是最大等级 false 不是
function T:isPlayerMaxLevel()
	local n = self:getPlayerMaxLevel()
	if UserInfo.level == n then
		return true
	else
		return false
	end
end

--- 获得指挥等级
function T:getDominanceLevel()
	return UserInfo.dominanceLevel
end

--- 设置指挥等级
function T:setDominanceLevel(lvl)
	UserInfo.dominanceLevel = lvl
	self:luaDispatchEvent(self.noticeMessage.dominanceLvl)
	self:setPlayerFightLogic()
end

--- 得到统御的幸运值
function T:getDominanceLucky()
	local lvl = self:getDominanceLevel()
	local index = lvl + 1
	if index > #self.dominanceLuckyCfg then  -- 达到了统率最大等级
		return 0
	else
		return self.dominanceLuckyCfg[index]
	end
end

--- 获得指挥升级的钻石数
function T:getDominanceLevelUpDiamond()
	local lvl = self:getDominanceLevel()
	if lvl >= self:getMaxDominanceLvl() then return 0 end

	return Dominance_temp[lvl + 1].needDiamond
end
--- 得到指挥的最大等级
function T:getMaxDominanceLvl()
	return #Dominance_temp
end

--- 指挥升级（统率）
function T:dominanceLevelUp()
	UserInfo.dominanceLevel = UserInfo.dominanceLevel + 1
	self:luaDispatchEvent(self.noticeMessage.dominanceLvl)
	self:setPlayerFightLogic()
end
--- 指挥所额外带来的飞机数(统帅等级带兵数量=当前指挥等级*2)
function T:getDominanceExtraPlane()
	local lvl = self:getDominanceLevel()
	local num = lvl == 0 and 0 or Dominance_temp[lvl].extra
	return num
end
--- 检查是否满足等级限制
function T:checkDominanceLevelupLevel()
	--	local lv = self:getDominanceLevel()
	--	local dt=Dominance_temp[lv + 1]
	--	if dt then
	--		local n = dt.needLvl       -- 需要的人物等级
	--		if self:getPlayerLevel() < n then
	--			return false
	--		else
	--			return true
	--		end
	--	end

	local dl = self:getDominanceLevel()
	local pl = self:getPlayerLevel()

	local lvlEnable
	if dl >= pl then
		lvlEnable = false
	else
		lvlEnable = true
	end

	return lvlEnable
end
--- 检查是否满足指挥书限制
function T:checkDominanceLevelupBookNeed()
	local num = self:getDominanceLevelupBookNeed()
	local sid = self:getDominancePropID()

	if PropsInfoMgr:getPlayerPropByID(sid) < num then
		return false
	else
		return true
	end
end
--- 获得升级需要的指挥书
function T:getDominanceLevelupBookNeed()
	local num = 1
	return num
end
--- 增加指挥书
function T:addDominanceBook(num)
	PropsInfoMgr:addPlayerPropByID(self:getDominancePropID(), num)
	self:luaDispatchEvent(self.noticeMessage.dominanceNum)
end
--- 减少指挥书
function T:reduceDominanceBook(num)
	PropsInfoMgr:reducePlayerPropByID(self:getDominancePropID(), num)
	self:luaDispatchEvent(self.noticeMessage.dominanceNum)
end
--- 设置指挥书
function T:setDominanceBook(num)
	PropsInfoMgr:setPlayerPropByID(self:getDominancePropID(), num)
	self:luaDispatchEvent(self.noticeMessage.dominanceNum)
end
--- 获得数量
function T:getDominanceBook()
	return PropsInfoMgr:getPlayerPropByID(self:getDominancePropID())
end

--- 玩家普通的飞机数
function T:getPlayerOwnPlane()
	return User_temp[self:getPlayerLevel()].baseLeadTroopsNum
end
--- 获得玩家所有的飞机数目 （本身等级 + 指挥等级）
function T:getPlayerAllPlane()
	return self:getPlayerOwnPlane() + self:getDominanceExtraPlane()
end
--- 获取荣誉值(技能点) sid = 201
function T:getSkillPoint()
	local sid = self:getMedalPropID()
	return PropsInfoMgr:getPlayerPropByID(sid)
end

--- 获得技能芯片单价
function T:getSkillPointPrice()
	return Prop_temp[self:getMedalPropID()].price
end

----- 设置技能点
--function T:setSkillPoint(num)
--    local sid = 201
--    if not UserInfo.prop.propInfos[sid] then UserInfo.prop.propInfos[sid] = {sid = 0, num = 0}
--	UserInfo.prop.propInfos[sid].num = num
--    self:luaDispatchEvent(self.noticeMessage.medal)
--end

--- 得到技能芯片的物品id
function T:getMedalPropID()
	return 201
end
--- 得到指挥的物品id
function T:getDominancePropID()
	return 200
end

--- 增加技能点
function T:addSkillPoint(num)
	PropsInfoMgr:addPlayerPropByID(self:getMedalPropID(), num)
end

--- 减少技能点
function T:reduceSkillPoint(num)
	PropsInfoMgr:reducePlayerPropByID(self:getMedalPropID(), num)
end

--- 设置技能道具数目
function T:setSkillPoint(num)
	PropsInfoMgr:setPlayerPropByID(self:getMedalPropID(), num)
end


--- 获得钻石
function T:getDiamond()
	return UserInfo.gems
end
--- 设置钻石
function T:setDiamond(num)
	if not num or num < 0 then return end
	self:setDiffDiamond(num)
	UserInfo.gems = num
	self:luaDispatchEvent(self.noticeMessage.diamond)
end
--- 减少钻石
function T:reduceDiamond(num)
	if num == 0 then
		return
	end

	if UserInfo.gems < num then
		self.diffDiamond = -UserInfo.gems
		UserInfo.gems = 0
	else
		self.diffDiamond = -num
		UserInfo.gems = UserInfo.gems - num
	end
	self:luaDispatchEvent(self.noticeMessage.diamond)
end

--- 计算差异的钻石数目
function T:setDiffDiamond(num)
	-- 计算钻石的差异值
	local lastDiamond = UserInfo.gems
	local newDiamond = num

	self.diffDiamond = num - lastDiamond
end

function T:getDiffDiamond()
	if self.diffDiamond then
		return self.diffDiamond
	end
end

--- 是否第一次改名
-- @return false 表示还未改过名字 true 表示已经改过名字
function T:isFirstChangeName()
	return UserInfo.isChangeName
end

--- 获得技能的等级
-- @param self
-- @param id 技能id
function T:getPlayerSkillLevelByID(id)
	if UserInfo.city.skillBox.infos[id] then
		return UserInfo.city.skillBox.infos[id].level
	else
		return 0
	end

end

--- 获得技能表
-- @return tb 技能表
function T:getPlayerSkill()
	return UserInfo.city.skillBox.infos
end

--- 根据玩家技能id取得 技能名字
-- @param self
-- @param id 技能id
-- @return 技能id名字
function T:getPlayerSkillNameByID(id)
	if id < 1 then return end
	--return Language:get(Skill_temp[id].name)

	--local str = string.format("f%d", id + 17)
	local str = Skill_temp[id].name
	return Language:get(str)
end

--- 根据玩家技能id取得 技能对应等级的描述
-- @param self
-- @param id 技能id
-- @return 技能id的额外描述
function T:getPlayerSkillDesByID(id, level)
	if id < 1 then return end

	local lvl = nil
	if nil == level then
		lvl = self:getPlayerSkillLevelByID(id)     -- 等级
	else
		lvl = level
	end

	if lvl > self:getPlayerMaxLevel() then
		return Language:get("uy12")  -- 最大等级
	end

	--local add = Skill_temp[id].attributes[lvl]    -- 附加属性
	local add = self.skillAddAttribute[lvl] or 0

	local str = string.format("v%d", id + 3)
	-- return Language:get(Skill_temp[id].desc, add)
	return Language:get(str, add)
end

--- 根据技能id 获得最大等级 (上限为人物等级)
function T:getPlayerSkillMaxLevelByID(id)
	return self:getPlayerLevel()
end

--- 技能升级
function T:playerSkillLevelUp(id)
	local t=UserInfo.city.skillBox.infos[id]
	if not t then
		t={sid=id,level=0}
		UserInfo.city.skillBox.infos[id] = t
	end

	t.level = t.level + 1

	self:luaDispatchEvent(self.noticeMessage.skillLvl)
	self:luaDispatchEvent(self.noticeMessage.skillLvl .. id)

	self:setPlayerFightLogic()
end

--- 重置技能
function T:playerSkillReset()
	local n = self:getPlayerSkillNum()
	local skill = UserInfo.city.skillBox.infos
	for i = 1, n do
		if skill[i] then  -- 大于0的都派发消息
			if skill[i].level > 0 then
				skill[i].level = 0
				self:luaDispatchEvent(self.noticeMessage.skillLvl .. i) -- 派发技能等级的消息
		end
		end
	end

	self:luaDispatchEvent(self.noticeMessage.skillReset) -- 派发技能重置事件
end

--- 是否能洗点
-- @return false 表示没有技能升过级， 不能洗点
function T:checkPlayerSkillReset()
	local tb = {}
	local m = 0
	local n = self:getPlayerSkillNum()
	for i = 1, n do
		m = m + UserInfo.city.skillBox.infos[id].level
	end

	if m == 0 then     -- 没有技能升过级
		return false
	else
		return true
	end

end

--- 获得技能总数 12
function T:getPlayerSkillNum()
	return UserInfo.city.skillBox.total
end

--- 检查是否满足等级限制
-- @return false 达到当前最大等级
function T:checkSkillLevelupLevelByID(id)
	local lv = self:getPlayerSkillLevelByID(id)
	if lv >= self:getPlayerLevel() then
		return false
	else
		return true
	end
end

--- 检查是否满足技能点限制
-- @return false 技能点不够
function T:checkSkillLevelupSkillPointNeedByID(id)
	local num = self:getSkillPoint()
	local need = self:getSkillLevelupSkillPointNeedByID(id)
	if not num then num = 0 end
	if need > num then
		return false
	else
		return true
	end
end

--- 获得技能升级的消耗点数(技能升级消耗=人物当前等级) 于等级相等
function T:getSkillLevelupSkillPointNeedByID(id)
	return self:getPlayerSkillLevelByID(id) + 1
end

--- 获得技能升级的需要的等级
function T:getSkillLevelUpLevelNeedByID(id)
	local lv = self:getPlayerSkillLevelByID(id)
	return lv + 1
end

--- 获得重置技能所需要的钻石 28个钻石
function T:getSkillResetDiamondNum()
	return GameCfg.GET_RESERT_GEMS
end

--- 是否能重置技能
function T:isSkillCanReset()
--	local num = self:getDiamond()
--	if num < self:getSkillResetDiamondNum() then
--		return false
--	else
--		return true
--	end
end

-- 根据sid获得资源最大容量
-- @param sid 最大容量
function T:getMaxResourceCapacityBySid(sid)
	if not sid then return 0 end
	local output,capacity = self:getCapacityAndOutput(sid)
	local all = self:getNoResCapacity() + capacity
	return all
end

-- 得到铁矿 sid = 7
function T:getSteel()
	return UserInfo.city.steel
end
-- max
function T:getMaxSteel()
	return self:getMaxResourceCapacityBySid(self.resSid.steel)
end
-- 增加铁矿
function T:addSteel(num)
	UserInfo.city.steel = UserInfo.city.steel + num
	--self:luaDispatchEvent(self.noticeMessage.steel)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
-- 减少铁矿
function T:reduceSteel(num)
	if num > UserInfo.city.steel then return 0 end
	UserInfo.city.steel = UserInfo.city.steel - num
	--self:luaDispatchEvent(self.noticeMessage.steel)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end


-- 钛矿 sid = 10
function T:getTati()
	return UserInfo.city.titanium
end
function T:getMaxTati()
	return self:getMaxResourceCapacityBySid(self.resSid.tati)
end
function T:addTati(num)
	UserInfo.city.titanium = UserInfo.city.titanium + num
	--self:luaDispatchEvent(self.noticeMessage.tati)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
function T:reduceTati(num)
	if num > UserInfo.city.titanium then return end
	UserInfo.city.titanium = UserInfo.city.titanium - num
	--self:luaDispatchEvent(self.noticeMessage.tati)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end

-- 硅矿 sid = 9
function T:getSilicon()
	return UserInfo.city.aluminium
end
-- 硅矿 最大
function T:getMaxSilicon()
	return self:getMaxResourceCapacityBySid(self.resSid.silicon)
end
-- 增加数量
function T:addSilicon(num)
	UserInfo.city.aluminium = UserInfo.city.aluminium + num
	--self:luaDispatchEvent(self.noticeMessage.silicon)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
-- 减少数量
function T:reduceSilicon(num)
	if num > UserInfo.city.titanium then return end
	UserInfo.city.aluminium = UserInfo.city.aluminium - num
	--self:luaDispatchEvent(self.noticeMessage.silicon)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
--- 设置金币
function T:setGold(num)
	UserInfo.city.money = num
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
-- 金矿
function T:getGold()
	return UserInfo.city.money
end
-- 金矿最大
function T:getMaxGold()
	return self:getMaxResourceCapacityBySid(self.resSid.gold)
end
-- 增加
function T:addGold(num)
	UserInfo.city.money = UserInfo.city.money + num
	--self:luaDispatchEvent(self.noticeMessage.gold)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
-- 减少
function T:reduceGold(num)
	if num > UserInfo.city.titanium then return end
	UserInfo.city.money = UserInfo.city.money - num
	--self:luaDispatchEvent(self.noticeMessage.gold)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
-- 油矿
function T:getOil()
	return UserInfo.city.oil
end
-- 最大
function T:getMaxOil()
	return self:getMaxResourceCapacityBySid(self.resSid.oil)
end
-- 增加
function T:addOil(num)
	UserInfo.city.oil = UserInfo.city.oil + num
	--self:luaDispatchEvent(self.noticeMessage.oil)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end
-- 减少
function T:reduceOil(num)
	if num > UserInfo.city.oil then return end
	UserInfo.city.oil = UserInfo.city.oil - num
	--self:luaDispatchEvent(self.noticeMessage.oil)
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end

-- 设置建筑的等级
function T:setBuildingLvl(l, level)
	BuildingsInfoMgr:getBuildingInfos()[l].level = level
	self:luaDispatchEvent(self.noticeMessage.buildingLvl .. l)
end
-- 建筑升级
-- @param l location 位置
function T:buildingLvlUp(l)
	BuildingsInfoMgr:getBuildingInfos()[l].level = BuildingsInfoMgr:getBuildingInfos()[l].level + 1
	self:luaDispatchEvent(self.noticeMessage.buildingLvl .. l)
	self:luaDispatchEvent(self.noticeMessage.buildingLvl)
	-- 取消推送
	local list = BuildingsInfoMgr:getBuildQueue()
	local id = BuildingsInfoMgr:getBuildingInfos()[l].id
	if list[id] and list[id].pushId then
		LocalNoti:cancel(list[id].pushId)
		list[id].pushId = nil
	end

	local lvl = BuildingsInfoMgr:getBuildingInfos()[l].level
	local nm = self.noticeMessage
	local fix = self.fixedBldLocation
	if l == 1 then  -- 派发解锁事件      -- 机库1 在初始化的时候被判断， 所以这里无需处理
		if lvl == 3 then    -- 解锁 铸币厂,
			self:luaDispatchEvent(self.noticeMessage.unLock .. fix.gold)
	elseif lvl == 5 then -- 解锁 科研中心 和 联盟
		self:luaDispatchEvent(self.noticeMessage.unLock .. fix.study)
		self:luaDispatchEvent(self.noticeMessage.unLock .. fix.region)
	elseif lvl == 6 then -- 解锁 仓库1
		self:luaDispatchEvent(self.noticeMessage.unLock .. fix.storeOne)
	elseif lvl == 11 then -- 解锁 仓库2
		self:luaDispatchEvent(self.noticeMessage.unLock .. fix.storeTwo)
	elseif lvl == 13 then -- 解锁 机库2和改造工厂
		self:luaDispatchEvent(self.noticeMessage.unLock .. fix.planeTwo)
		self:luaDispatchEvent(self.noticeMessage.unLock .. fix.make)
	end
	end
end
-- 得到建筑的等级
-- @param l location 位置
function T:getBuildingLvl(l)
	if not BuildingsInfoMgr:getBuildingInfos()[l] then return 0 end
	return BuildingsInfoMgr:getBuildingInfos()[l].level
end

--- 得到指挥中心等级 （用得地方很多）
function T:getCenterBuildingLvl()
	return self:getBuildingLvl(self.fixedBldLocation.center)
end

--- 得到建筑物当前升级的时间
-- @param sid 建筑物sid， 查表使用
-- @param l 位置
function T:getBuildingCurrentUpgradeTime(l)
	local tb
	local sid = BuildingsInfoMgr:getBuildingInfos()[l].sid

	if sid == 1 then
		tb = CommandCentre_temp
	elseif sid == 2 then
		tb = Build_aircraftFactory_temp
	elseif sid == 3 then
		tb = Science_temp
	elseif sid == 4 then
		tb = TransformFactory_temp
	elseif sid == 5 then
		tb = Warehouse1_temp
	elseif sid == 6 then
		tb = Money_temp
	elseif sid == 7 then
		tb = Steel_temp
	elseif sid == 8 then
		tb = Oil_temp
	elseif sid == 9 then
		tb = Aluminium_temp
	elseif sid == 10 then
		tb = Titanium_temp
	end

	local lvl = self:getBuildingLvl(l) -- 得到等级

	return BuildingDiamondCalculation:BuildConstructActualTime(tb[lvl].upgradeTime)
end

--- 得到邮件数量
function T:getMailNum()
	return 20
end

function T:setMailNum()

end

--- 得到开放的建筑
function T:getOpenBuilding()
	local tb = {}
	for k, v in pairs(BuildingsInfoMgr:getBuildingInfos()) do
		if v.level >= 1 then
			tb[v.id] = v.level
		end
	end

	return tb
end

--- 获得建筑的sid
-- @param loc 位置
function T:getBuildingSid(loc)
	local qInfo=BuildingsInfoMgr:getBuildingInfos()[loc]
	if not qInfo then
		return 0
	end

	return qInfo.sid
end

--- 建筑物是否开放
-- @param l
function T:getBuildingIsOpen(l)
	local bLocs=self.fixedBldLocation

	-- 指挥中心
	if l == bLocs.center then
		return true
	end

	if l == bLocs.planeOne then
		-- 1号机库
		if self:getBuildingLvl(bLocs.center) < 1 then
			return false
		end
	elseif l == bLocs.planeTwo then
		-- 2号机库
		if self:getBuildingLvl(bLocs.center) < 13 then
			return false
		end
	elseif l == bLocs.study then
		-- 科研中心
		if self:getBuildingLvl(bLocs.center) < 5 then
			return false
		end
	elseif l == bLocs.make then
		-- 改造工厂
		if self:getBuildingLvl(bLocs.center) < 13 then
			return false
		end
	elseif l == bLocs.storeOne then
		-- 仓库1
		if self:getBuildingLvl(bLocs.center) < 6 then
			return false
		end
	elseif l == bLocs.storeTwo then
		-- 仓库2
		if self:getBuildingLvl(bLocs.center) < 11 then
			return false
		end
	elseif l == bLocs.gold then
		-- 铸币厂
		if self:getBuildingLvl(bLocs.center) < 3 then
			return false
		end
	elseif l == bLocs.region then
		-- 联盟
		if self:getBuildingLvl(bLocs.center) < 5 then
			return false
		end
	elseif l == bLocs.command then
		--战机实验室
		if PlayerInstance:getPlayerLevel() < 7 then
			return false
		end
	elseif l == bLocs.wish then
	--许愿池
	elseif l == bLocs.toResouce then
	--郊外
	elseif l == bLocs.arena then
		--竞技场
		if PlayerInstance:getPlayerLevel() < 15 then
			return false
		end
	end

	return true
end


--- 摧毁建筑物(暂时保留)
--　@param pid 建筑物id
function T:destroyBuilding(pid)
	-- do sth
	self:luaDispatchEvent(self.noticeMessage.destroyBld .. pid)
end

--- 根据sid获取资源建筑物的最大等级
function T:getBldLevelBySid(sid)
	local tb = {}
	local max = 0
	for k, v in pairs (BuildingsInfoMgr:getBuildingInfos()) do  -- 选出对应sid到一个tb
		if v.sid == sid then
			table.insert(tb, v.level)
	end
	end

	for i = 1, #tb do
		if tb[i] > max then
			max = tb[i]
		end
	end

	return max
end


--- 获得玩家在世界地图中的坐标
function T:getWorldPosition()
	return UserInfo.city.worldPositionX, UserInfo.city.worldPositionY
end

--- 修改玩家的世界坐标
function T:setWorldPosition(x, y)
	if not x or not y then
		return
	end
	UserInfo.city.worldPositionX = x
	UserInfo.city.worldPositionY = y
	self:luaDispatchEvent(self.noticeMessage.changeWorldPositon, x, y)
end

--- 获取最大上阵战机数
function T:getMaxAircraftCount()
	return User_temp[UserInfo.level].baseLeadTroopsNum+
		(UserInfo.dominanceLevel == 0 and 0 or Dominance_temp[UserInfo.dominanceLevel].extra) + HonorManager:getAddSoliders()
end

--- 获取最大战力阵容,aircrafts可以传进来，不传进来默认拷贝内存里面的数据
function T:getMaxFightTeam(aircraftsPram)
	-- 深拷贝,不影响源数据
	local aircrafts = nil
	if aircraftsPram then
		aircrafts = mapping({},aircraftsPram)
	else
		aircrafts = mapping({},UserInfo.city.aircraftBox.infos)
	end

	-- 最大上阵战机数
	local maxCount=self:getMaxAircraftCount()

	--获取当前最大战力的战机
	local function _getMaxFightAircraft()
		local maxFight,aircraft,count=0,nil,0

		for _,v in pairs(aircrafts) do
			local c=math.min(v:getNum(),maxCount)
			local fightValue,c=self:getAircraftFight(v,c)

			if fightValue > maxFight then
				maxFight,aircraft,count=fightValue,v,c
			end
		end

		if count > 0 then
			return aircraft,count
		end

		return nil,0
	end

	local l={}
	for i=1,6,1 do
		local aircraft,c=_getMaxFightAircraft()
		if aircraft then
			aircraft.num = aircraft.num - c
			l[#l+1]={sid=aircraft.sid,count=c}
		else
			break
		end
	end

	return l
end

--- 获取  攻击最大等级
function T:getMaxAttackNPCLvl()
	return UserInfo.city.npcMaxLvl
end

function T:setMaxAttackNPCLvl(lvl)
	if not lvl then return end
	UserInfo.city.npcMaxLvl = lvl
	self:luaDispatchEvent(self.noticeMessage.maxAttackNPC)
end


--- 获取战机战力 (单个攻击力*单个生命力*(1+命中+闪避+暴击+坚韧+连击)*数量*数量)开方
-- @param aircraftInfo 战机信息
-- @param count 数量
-- @return 战机战力,数量
function T:getAircraftFight(aircraftInfo,count)
	local c=count or 1
	if c > 0 then
		local d=Aircraft_temp[aircraftInfo.sid]
		local attType=d.attackType

		local t=self:getAircraftAttack(aircraftInfo)*
			self:getAircraftHp(aircraftInfo)*
			(
			100+
			self:getAircraftHit(aircraftInfo)+self:getAircraftDodge(aircraftInfo)+
			self:getAircraftCrit(aircraftInfo) + self:getAircraftArmor(aircraftInfo)
			)/100

		local t = math.sqrt(t * GameCfg.AIRCRAFT_FIGHT_COEFFICIENT[attType]) * c /50 --战力系数

		return t,c
	end

	return 0,0
end

--- 获取战机攻击力
function T:getAircraftAttack(aircraftInfo)
	--战机数据模板
	local d=Aircraft_temp[aircraftInfo.sid]

	local attack,addRate=d.attack,0

	--科研加成
	addRate=addRate+TechnologiesInfoMgr:getAttckAdd(d.attackType)

	--技能加成
	addRate=addRate+UserInfo.city.skillBox:getAttckAdd(d.attackType)

	--buff加成
	--	addRate=addRate+BuffQueueInfoMgr:getAttckAdd()

	--联盟科技加成
	addRate=addRate+AllianceManager:getAttckAdd()

	--关卡buff加成
	addRate=addRate+BattlesInfoMgr:getAttckAdd()

	--配件加成
	addRate=addRate+AccessorySystemManager:getAttackAddBySid(aircraftInfo.sid)

	--战机强化加成(数值)
	local addAttackValue = AircraftStrengManager:getAddAttackFormSid(aircraftInfo.sid)

	return attack*(1+addRate/100) + addAttackValue
end

--- 获取战机血量:固定数值最后加
function T:getAircraftHp(aircraftInfo)
	--战机数据模板
	local d=Aircraft_temp[aircraftInfo.sid]

	local hp,addRate=d.hp,0

	--科研加成
	addRate=addRate+TechnologiesInfoMgr:getHpAdd(d.attackType)

	--技能加成
	addRate=addRate+UserInfo.city.skillBox:getHpAdd(d.attackType)

	--buff加成
	--	addRate=addRate+BuffQueueInfoMgr:getHpAdd()

	--联盟科技加成
	addRate=addRate+AllianceManager:getHpAdd()

	--关卡buff加成
	addRate=addRate+BattlesInfoMgr:getHpAdd()

	--配件加成
	addRate=addRate+AccessorySystemManager:getLifeAddBySid(aircraftInfo.sid)

	--战机强化加成(数值)
	local addHpValue = AircraftStrengManager:getAddHpFormSid(aircraftInfo.sid)

	return hp*(1+addRate/100) + addHpValue
end

--- 获取战机命中
function T:getAircraftHit(aircraftInfo)
	--战机数据模板
	local d=Aircraft_temp[aircraftInfo.sid]

	local hit,addRate=d.hitRate,0

	--科研加成
	addRate=addRate+TechnologiesInfoMgr:getHitAdd(d.attackType)

	--技能加成
	addRate=addRate+UserInfo.city.skillBox:getHitAdd()

	--buff加成
	--	addRate=addRate+BuffQueueInfoMgr:getHitAdd()

	--联盟科技加成
	addRate=addRate+AllianceManager:getHitAdd()

	--关卡buff加成
	addRate=addRate+BattlesInfoMgr:getHitAdd()

	--配件加成
	addRate=addRate+AccessorySystemManager:getHitAddBySid(aircraftInfo.sid)

	return hit+addRate
end

--- 获取战机闪避
function T:getAircraftDodge(aircraftInfo)
	--战机数据模板
	local d=Aircraft_temp[aircraftInfo.sid]

	local dodge,addRate=d.dodge,0

	--科研加成
	addRate=addRate+TechnologiesInfoMgr:getDodgeAdd(d.attackType)

	--技能加成
	addRate=addRate+UserInfo.city.skillBox:getDodgeAdd()

	--buff加成
	--	addRate=addRate+BuffQueueInfoMgr:getDodgeAdd()

	--联盟科技加成
	addRate=addRate+AllianceManager:getDodgeAdd()

	--关卡buff加成
	addRate=addRate+BattlesInfoMgr:getDodgeAdd()

	--配件加成
	addRate=addRate+AccessorySystemManager:getDodgeAddBySid(aircraftInfo.sid)

	return dodge+addRate
end

--- 获取战机暴击
function T:getAircraftCrit(aircraftInfo)
	--战机数据模板
	local d=Aircraft_temp[aircraftInfo.sid]

	local crit,addRate=d.crit,0

	--科研加成
	addRate=addRate+TechnologiesInfoMgr:getCritAdd(d.attackType)

	--技能加成
	addRate=addRate+UserInfo.city.skillBox:getCritAdd()

	--buff加成
	--	addRate=addRate+BuffQueueInfoMgr:getCritAdd()

	--联盟科技加成
	addRate=addRate+AllianceManager:getCritAdd()

	--关卡buff加成
	addRate=addRate+BattlesInfoMgr:getCritAdd()

	return crit+addRate
end

--- 获取战机暴抗，也是暴击抵抗
function T:getAircraftArmor(aircraftInfo)
	local d = Aircraft_temp[aircraftInfo.sid]

	local critResist,addRate = d.critResist,0

	--科研加成
	addRate=addRate+TechnologiesInfoMgr:getArmorAdd(d.attackType)

	--技能加成
	addRate=addRate+UserInfo.city.skillBox:getArmorAdd()

	--buff加成
	--	addRate=addRate+BuffQueueInfoMgr:getArmorAdd()

	--联盟科技加成
	addRate=addRate+AllianceManager:getArmorAdd()

	--关卡buff加成
	addRate=addRate+BattlesInfoMgr:getArmorAdd()

	return critResist+addRate
end

--- 根据sid获取战机的数量
function T:getAircraftNumBySid(sid)
	if not sid then return 0 end

	if not UserInfo.city.aircraftBox.infos[sid] then return 0 end

	return UserInfo.city.aircraftBox.infos[sid].num
end

--- 增加飞机数量
function T:addAircraftNum(sid, num)
	if not sid or not num then return end
	UserInfo.city.aircraftBox.infos[sid] = UserInfo.city.aircraftBox.infos[sid] or {}
	UserInfo.city.aircraftBox.infos[sid].num = UserInfo.city.aircraftBox.infos[sid].num or 0

	UserInfo.city.aircraftBox.infos[sid].num = UserInfo.city.aircraftBox.infos[sid].num + num

	AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH) -- add by yuding
end


----- 获取战机击破:暴击抵抗
--function T:getAircraftDodge(aircraftInfo)
----    local d = Aircraft_temp[aircraftInfo.sid]

----    local break = d.break
----    -- 加成

----    return break
--    return 0
--end

----- 获取战机防护
--function T:getAircraftDodge(aircraftInfo)
----    local d = Aircraft_temp[aircraftInfo.sid]

----    local protection = d.protection
----    -- 加成

----    return protection
--    return 0
--end

----------------------------------------------------------  陈立所加  -------------------------------------------------

--- 得到建筑物升级的模板资源表,参数为sid
function T:getBuildingResTable(sid)
	local ModelResTable = nil

	if sid == 1 then
		ModelResTable = CommandCentre_temp
	elseif sid == 2 then
		ModelResTable = Build_aircraftFactory_temp
	elseif sid == 3 then
		ModelResTable = Science_temp
	elseif sid == 4 then
		ModelResTable = TransformFactory_temp
	elseif sid == 5 then
		ModelResTable = Warehouse1_temp
	elseif sid == 6 then
		ModelResTable = Money_temp
	elseif sid == 7 then
		ModelResTable = Steel_temp
	elseif sid == 8 then
		ModelResTable = Oil_temp
	elseif sid == 9 then
		ModelResTable = Aluminium_temp
	elseif sid == 10 then
		ModelResTable = Titanium_temp
	else
	-- 异常
	end

	return ModelResTable
end

--- 设置资源上次恢复的时间
function T:setResourceTime(time)
	UserInfo.city.resourceTime = time
end

--- 得到某一个资源项的所有容量或者产量:根据资源的模板sid来获得就可以了,产量是基本的，容量是加成了的
function T:getCapacityAndOutput(sid)
	local capacity = 0
	local output = 0

	local buidlerInfos = BuildingsInfoMgr:getBuildingInfos()
	for k,v in pairs(buidlerInfos) do
		if v then
			if v.sid == sid then
				local resTable = self:getBuildingResTable(sid)
				capacity = capacity + resTable[v.level].capacity   -- 具体数字
				output = output + resTable[v.level].output         -- 这是每分钟产的
			end
		end
	end

	local nowCapacity = capacity * ( 1 + (TechnologiesInfoMgr:getCapacityAdd() / 100))

	return output,nowCapacity
end

--- 得到玩家所有的产量，包括加成,这个是每分钟的
function T:getAllTrueOutput(sid)
	local output,capacity = self:getCapacityAndOutput(sid)
	local noResOutput = self:getNoResOutput()
	local allOutput = output + noResOutput

	-- buff加成,科技sid和buffsid一样
	local buffSid = self:getResBuffSid(sid)  -- 得到对应的buffsid
	local buffAdd = 0
	if BuffQueueInfoMgr:checkActive(buffSid) then
		buffAdd = 0.5
	end

	-- vip加成
	local vipAdd = 0
	if sid == 7 then
		vipAdd = VipManager:getVipSteelAdd()
	end
	if sid == 8 then
		vipAdd = VipManager:getVipOilAdd()
	end
	if sid == 9 then
		vipAdd = VipManager:getVipSiliconAdd()
	end

	-- 科技加成
	local scienceAdd = TechnologiesInfoMgr:getResOutputAdd(buffSid) / 100

	-- 关卡buff加成
	local chaterBuffSid = buffSid
	local chapteBuffBox = BattlesInfoMgr:getChapterBuffsInfo()
	local chaterLevel = chapteBuffBox.infos[chaterBuffSid] or 0
	local chaterAdd = chaterLevel * 0.05

	return allOutput * ( 1 + buffAdd + vipAdd + scienceAdd + chaterAdd )
end


--- 得到非资源的容量:数值,包括加成
function T:getNoResCapacity()
	local buidlerInfos = BuildingsInfoMgr:getBuildingInfos()
	-- 指挥中心的容量
	local commandCapacity = CommandCentre_temp[buidlerInfos[1].level].capacity * ( 1 + (TechnologiesInfoMgr:getCapacityAdd() / 100))

	local warHouseCapacity = self:getProtectedCapacity()

	return commandCapacity + warHouseCapacity
end

--- 得到保护容量，也叫不能被掠夺容量，就是2个仓库的容量之和，包括加成
function T:getProtectedCapacity()
	-- 仓库1和2的容量
	local buidlerInfos = BuildingsInfoMgr:getBuildingInfos()
	local warhouse1Level = nil
	local warhouse2Level = nil
	if buidlerInfos[6] then
		warhouse1Level = buidlerInfos[6].level
	else
		warhouse1Level = 0
	end

	if buidlerInfos[7] then
		warhouse2Level = buidlerInfos[7].level
	else
		warhouse2Level = 0
	end

	local warHouse1Capacity = Warehouse1_temp[warhouse1Level].capacity
	local warHouse2Capacity = Warehouse1_temp[warhouse2Level].capacity
	return (warHouse1Capacity + warHouse2Capacity) * ( 1 + (TechnologiesInfoMgr:getCapacityAdd() / 100))
end

--- 得到非资源的产量(基本的产量)：每分钟，
function T:getNoResOutput()
	local buidlerInfos = BuildingsInfoMgr:getBuildingInfos()
	-- 指挥中心的产量
	local commandOutput = CommandCentre_temp[buidlerInfos[1].level].output

	return commandOutput
end


--- 根据资源的模板数据sid获取对应的属性名字
function T:getAttributeNameFromSid(sid)
	local attributeName = nil

	if sid == 6 then
		attributeName = "money"
	elseif sid == 7 then
		attributeName = "steel"
	elseif sid == 8 then
		attributeName = "oil"
	elseif sid == 9 then
		attributeName = "aluminium"
	elseif sid == 10 then
		attributeName = "titanium"
	end

	return attributeName
end

--- 通过资源的模板数据的sid获得资源的buff队列的1到5的索引
function T:getResBuffSid(sid)
	local id = nil

	if sid == 6 then
		id = 1
	elseif sid == 7 then
		id = 2
	elseif sid == 8 then
		id = 3
	elseif sid == 9 then
		id = 4
	elseif sid == 10 then
		id = 5
	end

	return id
end

--- 根据资源的sid得到资源模板数据的sid
function T:getResModelSid(sid)
	local id = nil

	if sid == 1 then
		id = 6
	elseif sid == 2 then
		id = 7
	elseif sid == 3 then
		id = 8
	elseif sid == 4 then
		id = 9
	elseif sid == 5 then
		id = 10
	end

	return id
end

--- 根据vip等级获得同时建筑物队列升级个数
function T:getVipBuildQueueCount()
	local buildQueueCount = VipManager.getVipBuildQueueCount()
	return buildQueueCount
end

--- 得到所有的vip建筑队列数量和购买的数量总和，最多8个
function T:getBuildQueueAllCount()
	local buildQueueCount = self:getVipBuildQueueCount()

	local buildQueueNumState = SetStates.buildQueueNumState
	local buyCount = buildQueueNumState:getBuildQueueNum()

	return buildQueueCount + buyCount

end

--- 根据vip等级获得同时科研中心建筑物队列升级个数
function T:getVipTechQueueCount()
	local buildQueueCount = VipManager.getVipTechQueueCount()

	return buildQueueCount
end

--- 根据vip等级获得同时出战的部队个数
function T:getVipbattleQueueCount()
	local buildQueueCount = VipManager.getVipbattleQueueCount()

	return buildQueueCount
end

--- 得到头像的路径 headType为头像的id  0是默认头像
function T:getPlayerHead(headType)
	local headType = headType -- 服务端的头像是 1-8 客户端是 1-8

	local iconPath = IconManager.iconPath
	if headType then
		if PlayerHeadIcon_temp[headType] then
			return iconPath .. PlayerHeadIcon_temp[headType].icon
		else
			return iconPath .. PlayerHeadIcon_temp[0].icon
		end
	else
		return iconPath .. PlayerHeadIcon_temp[0].icon
	end
end

function T:getPlayerHeadId()
	return UserInfo.photoId
end

function T:setPlayerHeadId(id)
	UserInfo.photoId = id
	self:luaDispatchEvent(self.noticeMessage.headId)
end

--- 根据道具的sid得到具体的描述
function T:getPropDescripe(sid)
	local data = Prop_temp[sid]

	local time = data.time
	local percent = data.percent
	local resInfo = data.resInfo
	local propsInfo = data.propsInfo

	local description = nil
	if propsInfo ~= 0 then -- 现在暂时是1个数据
		description = Language:get(data.propDescription2,propsInfo[1][2])
	elseif resInfo ~= 0 then
		local num = #resInfo
		if num == 1 then
			description = Language:get(data.propDescription2,UnitConversion.unitTrans2(resInfo[1][2]))
		else
			description = Language:get(data.propDescription2,UnitConversion.unitTrans2(resInfo[2][2]),UnitConversion.unitTrans2(resInfo[1][2]))
		end
	elseif time ~= 0 then
		if percent ~= 0 then
			description = Language:get(data.propDescription2,percent,UnitConversion.handleTime(time))
		else
			description = Language:get(data.propDescription2,UnitConversion.handleTime(time))
		end
	else
		description = Language:get(data.propDescription2)
	end


	return description
end


--- 根据道具的sid得到具体的描述(这个是22号大小的)
function T:getPropDescripe2(sid)
	return Language:get("uc1013",self:getPropDescripe(sid))
end

----------------------------------------------------------  陈立所加  -------------------------------------------------

--- 检查是否有可升级的技能
function T:judgeIsSkillUpgrade()
	for i = 1, GameCfg.MAX_SKILL_NUM do
		if self:checkSkillLevelupLevelByID(i) == true and self:checkSkillLevelupSkillPointNeedByID(i) == true then -- 能升级
			return true
		end
	end
	return false
end

return T
