--- 玩家信息
local T=Class.UserInfo()

---城市信息
T.CityInfo=require("src.app.model.CityInfo")

--- 道具信息
T.PropsInfo=require("src.app.model2.prop.PropsInfo")

--- 战斗信息
T.BattlesInfo=require("src.app.model2.battle.BattlesInfo")

--- 联盟信息盒子
T.AllianceBox=require("src.app.model.alliance.AllianceBox")

 --- 活动管理
ActivityManager = require("src.app.model.allActivity.fixAndDynamic.ActivityManager")()

 --- 补给线管理
SupplyLineManager = require("src.app.model.supplyLine.SupplyLineManager")()

 --- 警告队列管理
WarnQueueManager = require("src.app.model.warn.WarnQueueManager")()

 --- 公告管理
AnnounceManager = require("src.app.model.announce.AnnounceManager")()

 --- 阵型设置管理
FormationManager = require("src.app.model.formation.FormationManager")()


function T:def()
	--- 账号名:一般为邮箱
	self.userName=nil

	--- 玩家ID
	self.id=nil

	--- 角色名:guest
	self.name=nil

	--- 等级
	self.level=0

	--- 当前经验值
	self.exp=0

	--- 钻石
	self.gems=0

	--- 能量(打NPC用)
	self.pvePoint=0

	--- 精力上次恢复的时间
	self.pveRecoverSec=0

	--- 技能点
	self.skillPoint = 0

	--- 玩家vip等级
	self.vipLevel = 0

	--- 玩家vip点数:升级vip用的，就比如经验一样:也叫vip积分
	self.vipPoint = 0

	--- 指挥等级
	self.dominanceLevel = 0

	--- 是否改名
	self.isChangeName = false

    --- 玩家建号的时间
    self.createTime = 0
    
    --- 新手引导索引
    self.guideIndex = 0
    
    --- 玩家头像Id
    self.photoId = 0

	--- 联盟信息盒子
	self.allianceBox = self.AllianceBox()

	--- 城市信息
	-- self.city=nil

	--- 用户拥有的道具信息
	self.propsInfo = nil

	--- 战斗数据
	-- self.battlesInfo=nil

	--- 任务信息
	self.TaskBoxInfo = require("src.app.model.task.TaskBox")
	self.task = mapping({}, self.TaskBoxInfo)

    --- 每日任务
    self.dailyTask = mapping({}, require("src.app.model.dailyTask.DailyTaskBox"))

end

--- 反序列化
function T:decode(data)
	ArenaInfoMgr:preInit()

	self.userName=data:readString()
	self.id=data:readUnsignedInt()
	self.name=data:readString()
	self.level=data:readUnsignedShort()
	self.exp=data:readUnsignedInt()
	self.gems=data:readUnsignedInt()
	self.pvePoint=data:readUnsignedByte()
	self.pveRecoverSec=GameUtils:modifyTimeZone(data:readUnsignedInt())

	self.dominanceLevel = data:readUnsignedShort()
	self.reputationLevel = data:readUnsignedByte()  -- 声望等级
	self.reputationExp = data:readUnsignedInt()   -- 声望经验
	self.vipLevel = data:readUnsignedByte()
	self.vipPoint = data:readUnsignedInt()
	self.isChangeName = data:readBoolean()
    self.createTime = GameUtils:modifyTimeZone(data:readInt())
    self.guideIndex = data:readInt()
    self.photoId = data:readUnsignedByte()

	self.propsInfo=self.PropsInfo(data)

	self.battlesInfo=self.BattlesInfo(data)

	local mA=self.allianceBox.myAlliance
	mA.id=data:readUnsignedInt()
	if mA.id > 0 then
		mA.level=data:readUnsignedByte()
		mA.name=data:readString()
		mA.post=data:readUnsignedByte()

		mA:decodeScienceList(data)
        mA:decodeSocial(data)
	end

	self.city=self.CityInfo(data)

	--- 任务反序列化
	self.task:decode(data)

    -- 每日任务反序列化
    self.dailyTask:decode(data)

	--- 解析状态(每日状态)
	DailyStates:decode(data)
	--- 设置获取(永久状态)
	SetStates:decode(data)
	local valueCategoryBuild = SetStates.setNoticeState:getClosedValue(SetStates.setNoticeState.CLOSE_BUILD_CONSTRUCE)
	if valueCategoryBuild then
		LocalNoti:excludeCategory(LocalNoti.CATEGORY_BUILD)
	else
		LocalNoti:includeCategory(LocalNoti.CATEGORY_BUILD)
	end

	local valuePVE = SetStates.setNoticeState:getClosedValue(SetStates.setNoticeState.CLOSE_POINT_RECOVERY)
	if valuePVE then
		LocalNoti:excludeCategory(LocalNoti.PVE_POINT_TIP)
	else
		LocalNoti:includeCategory(LocalNoti.PVE_POINT_TIP)
	end

	local valueProtect = SetStates.setNoticeState:getClosedValue(SetStates.setNoticeState.CLOSE_PROTECTION_COVER)
	if valueProtect then
		LocalNoti:excludeCategory(LocalNoti.PROTECT_COVER)
	else
		LocalNoti:includeCategory(LocalNoti.PROTECT_COVER)
	end

	--- 社交
	SocialManager.friendBox:decode(data)
	SocialManager.blackBox:decode(data)

    -- 活动
    ActivityManager:setFixList(SetStates:getList()) -- 设置状态表

    ActivityManager:clearAllDynamic()
    ActivityManager:initOpenActList()
    local length = data:readUnsignedByte()
    for i = 1,length,1 do
        local sid = data:readShort()
        local endTime = GameUtils:modifyTimeZone(data:readInt())
        if ActivityManager:getActInfoBySid(sid).info then
            ActivityManager:refreshOneAct(ActivityManager:getActInfoBySid(sid).info,endTime)
        end
        
    end

	ArenaInfoMgr:setFirstName(data:readString())


    -- 补给线
    SupplyLineManager:decode(data)

    -- 警告队列
    WarnQueueManager.warnBox:decode(data)
    WarnQueueManager.warnBox:startUpdateCheck()

    -- 公告校验值
    self.announceCrc = data:readInt()

    -- 玩家可以设置的阵型数据
    FormationManager.formationBox:decode(data)


end


return T
