local NodeInfo=require("src.app.model.WorldMap.NodeInfo")
local MapNodeType=require("src.app.model.WorldMap.MapNodeType")

--- 地图节点信息-玩家节点
local T=Class.NodeInfoPlayer(NodeInfo)

function T:def()
	NodeInfo.def(self)
	
	self.type=MapNodeType.PLAYER
	
	--- 玩家ID
	-- playerId
	
	--- 玩家名
	-- name
	
	--- 玩家头像编号
	-- headId
	
	--- 是否处理保护状态(免战)
	self.isProtection=false
	
	--- 战斗力
	self.fighting=0
	
	--- 联盟ID
	-- allianceId
	
	--- 联盟名
	-- allianceName
	
	--- 军衔
	-- militaryRank
	
	--- 荣誉
	-- honor
	
	--- 显示类型
	-- showType
end

function T:decode(data)
	NodeInfo.decode(self,data)
	
	self.playerId=data:readUnsignedInt()
	self.headId=data:readUnsignedByte()
	self.isProtection=data:readBoolean()
	self.fighting = data:readUnsignedInt()
	self.name = data:readString()
	self.allianceId=data:readUnsignedInt()
	if self.allianceId and self.allianceId ~= 0 then
		self.allianceName = data:readString()
	end
	self.militaryRank = data:readUnsignedByte()
	self.honor = data:readInt()
	self.showType = data:readUnsignedByte();
end

return T