local MapNodeType=require("src.app.model.WorldMap.MapNodeType")
local NodeInfoPlayer=require("src.app.model.WorldMap.NodeInfoPlayer")
local NodeInfoResLoc=require("src.app.model.WorldMap.NodeInfoResLoc")

local BoundaryType=require("src.app.model.WorldMap.BoundaryType")

--- 世办地图信息
local T=Class.WorldMapInfo()

function T:def()
	--- 地图节点列表
	self.nodes={}

	--- 地图区域列表
	self.arears={}

--	--- 区域边界字典
--	self.areaBoundaryDict={}
end

function T:ctor()

end

--- 设置节点数据
function T:setNodeData(x,y,data)
	local col=self.nodes[x]
	if not col then
		col={}
		self.nodes[x]=col
	end

	col[y]=data
end

--- 获取节点数据
function T:getNodeData(x,y)
	local col=self.nodes[x]
	if not col then
		return nil
	end
	return col[y]
end

--- 解析节点数据
function T.decodeNode(data)
	local nInfo

	local type=data:readUnsignedByte()
	if type == MapNodeType.PLAYER then
		nInfo=NodeInfoPlayer()
	elseif type == MapNodeType.RES_LOC then
		nInfo=NodeInfoResLoc()
	end
	nInfo:decode(data)

	return nInfo
end

----- 获取节点的边界数据
--function T:getNodeBoundaryVales(x,y)
--	return self.areaBoundaryDict[self._generateKey(x,y)] or {}
--end
--
----- 添加地图区域
--function T:addArea(sx,sy,ex,ey)
--	local k=self._generateKey(sx,sy,ex,ey)
--	if self.arears[k] then
--		return
--	end
--
--	self.arears[k]={sx=sx,sy=sy,ex=ex,ey=ey}
--	return self:_addArea(sx,sy,ex,ey)
--end
--
----- 删除地图区域
--function T:rmvArea(sx,sy,ex,ey)
--	local k=self._generateKey(sx,sy,ex,ey)
--	if not self.arears[k] then
--		return
--	end
--
--	self.arears[k]=nil
--	return self:_rmvArea(sx,sy,ex,ey)
--end
--
----- 生成区域边界
--function T:_addArea(sx,sy,ex,ey)
--	local aBDict=self.areaBoundaryDict
--	local gKey=self._generateKey
--
--	local l,r,t,b=BoundaryType.LEFT,BoundaryType.RIGHT,BoundaryType.TOP,BoundaryType.BOTTOM
--
--	--坐标列表
--	local cl={}
--
--	--左/加边界
--	for i=sy,ey do
--		local lk=gKey(sx,i)
--		local n=aBDict[lk] or {}
--		n[l]=(n[l] or 0)+1
--		aBDict[lk]=n
--		cl[#cl+1]={x=sx,y=i}
--
--		local rk=gKey(ex,i)
--		local n=aBDict[rk] or {}
--		n[r]=(n[r] or 0)+1
--		aBDict[rk]=n
--		cl[#cl+1]={x=ex,y=i}
--	end
--
--	--上/下边界
--	for i=sx,ex do
--		local tk=gKey(i,sy)
--		local n=aBDict[tk] or {}
--		n[t]=(n[t] or 0)+1
--		aBDict[tk]=n
--		cl[#cl+1]={x=i,y=sy}
--
--		local bk=gKey(i,ey)
--		local n=aBDict[bk] or {}
--		n[b]=(n[b] or 0)+1
--		aBDict[bk]=n
--		cl[#cl+1]={x=i,y=ey}
--	end
--
--	return cl
--end
--
----- 删除区域边界
--function T:_rmvArea(sx,sy,ex,ey)
--	local aBDict=self.areaBoundaryDict
--	local gKey=self._generateKey
--
--	local l,r,t,b=BoundaryType.LEFT,BoundaryType.RIGHT,BoundaryType.TOP,BoundaryType.BOTTOM
--
--	--坐标列表
--	local cl={}
--
--	--左/加边界
--	for i=sy,ey do
--		local n=aBDict[gKey(sx,i)]
--		if n and n[l] then
--			if n[l] <= 1 then
--				n[l]=nil
--			end
--			n[l]=n[l]-1
--			cl[#cl+1]={x=sx,y=i}
--		end
--
--		local n=aBDict[gKey(ex,i)]
--		if n and n[r] then
--			if n[r] <= 1 then
--				n[r]=nil
--			end
--			n[r]=n[r]-1
--			cl[#cl+1]={x=ex,y=i}
--		end
--	end
--
--	--上/下边界
--	for i=sx,ex do
--		local n=aBDict[gKey(i,sy)]
--		if n and n[t] then
--			if n[t] <= 1 then
--				n[t]=nil
--			end
--			n[t]=n[t]-1
--			cl[#cl+1]={x=i,y=sy}
--		end
--
--		local n=aBDict[gKey(i,ey)]
--		if n and n[b] then
--			if n[b] <= 1 then
--				n[b]=nil
--			end
--			n[b]=n[b]-1
--			cl[#cl+1]={x=i,y=ey}
--		end
--	end
--
--	return cl
--end

--- 生成KEY
function T._generateKey(...)
	return table.concat({...},",")
end

return T
