local T={}

--- sid是默认的配置表中的1到16。这个如果数量为0，则服务器那边还是会传数据给我，不会是nil
T.sid = nil

--- 数量
T.num = 0

--- 在战机的位置上有的飞机数量
T.locBusingNum = 0


--- 获取空闲状态的战机数
--- getFreeingNum,toBusingNum,toFreeingNum只是针对选择的战机改变的（只是为了计算来用的临时数据），不会对本身的飞机数量的
function T:getFreeingNum()
	return self.num - self.locBusingNum
end

--- 
function T:toBusingNum(value)
	self.locBusingNum = self.locBusingNum + value
end

--- 
function T:toFreeingNum(value)
	self.locBusingNum = self.locBusingNum - value
end

function T:setBusingNum(value)
    self.locBusingNum = value
end

function T:decode(data)
    self.num = data:readUnsignedInt()
end

--- 得到战机数
function T:getNum()
	return self.num
end

function T:setNum(num)
    self.num = num

    AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH)
    PlayerInstance:setPlayerFightLogic()
end

--- 设置战机数量
function T:setAircraftNum(num)
    self.num = num
    AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH)
    PlayerInstance:setPlayerFightLogic()
end

--- 增加战机数量
function T:addNum(value)
	self.num = self.num + value
    AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH)
    PlayerInstance:setPlayerFightLogic()
end

--- 减少战机数量
function T:minNum(value)
	self.num = self.num - value
    AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH)
    PlayerInstance:setPlayerFightLogic()
end


--- 只派发事件不派发战斗力的（战斗力在那边处理派发）(要把所有的部队设置完以后)
--- 减少战机数量
function T:minNum2(value)
	self.num = self.num - value
    AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH)
end


return T