--[[
    战机强化信息
]]

local T = extend()

--- 飞机等级(1,2,3,4)
T.fighterLevel = 0

---  攻击强化等级
T.atkLevel = 0

--- 血量强化等级
T.hpLevel = 0

function T:decode(data)
    self.fighterLevel = data:readUnsignedByte()
    self.atkLevel = data:readUnsignedByte()
    self.hpLevel = data:readUnsignedByte()
end

--- 得到这种飞机的升级的等级最高限制
function T:getMAXLevel()
    return self.fighterLevel * 10
end

--- 升级到下一级攻击所需要的道具数量
function T:getAttackNeedPropNum()
    local fighterLevel = self.fighterLevel
    local atkLevel = self.atkLevel + 1
    local allNum = math.floor(math.pow(fighterLevel,4) + math.pow(atkLevel,2.5))
    local num = (allNum)/10
    if num <= 1 then
        num = 1
    else
        num = math.floor(num)
    end
    
    
	return num
end

--- 升级到下一级血量所需要的道具数量
function T:getHpNeedPropNum()
    local fighterLevel = self.fighterLevel
    local hpLevel = self.hpLevel + 1
    local allNum = math.floor(math.pow(fighterLevel,4) + math.pow(hpLevel,2.5))
    local num = (allNum)/10
    if num <= 1 then
        num = 1
    else
        num = math.floor(num)
    end
    

	return num
end


--- 根据sid得到所加的攻击数值
function T:getAttackFromSid(sid)
    local data = Aircraft_temp[sid]
    local addAttack = data.addAttack
    return addAttack * self.atkLevel
end

--- 根据sid得到所加的血量数值
function T:getHpFromSid(sid)
    local data = Aircraft_temp[sid]
    local addHp = data.addHp
    return addHp * self.hpLevel
end

--- 升级攻击等级
function T:levelUPAttack()
    if self.atkLevel < self:getMAXLevel() then
        self.atkLevel = self.atkLevel + 1
    end
    AircraftStrengManager:luaDispatchEvent(AircraftStrengManager.EVT_ATTACK_STRENGTH)

    PlayerInstance:setPlayerFightLogic()
end

--- 升级血量等级
function T:levelUPHp()
    if self.hpLevel < self:getMAXLevel() then
        self.hpLevel = self.hpLevel + 1
    end
    AircraftStrengManager:luaDispatchEvent(AircraftStrengManager.EVT_HP_STRENGTH)

    PlayerInstance:setPlayerFightLogic()
end

return T