--[[
    战机强化管理
]]
local T = extend(LuaEventDispatcher)

T.sids = {{1,2,3,4},{5,6,7,8},{9,10,11,12},{13,14,15,16},{17,18,19,20}}


--- 战机强化盒子
T.AircraftStrengBox = require "src.app.model.aircraftStrength.AircraftStrengBox"

--- 战机强化
T.aircraftStrengBox = mapping({}, T.AircraftStrengBox)

--- 事件--攻击强化事件
T.EVT_ATTACK_STRENGTH = "evt_attack_strength"

--- 事件--血量强化事件
T.EVT_HP_STRENGTH = "evt_hp_strength"

--- 得到每个等级所对应的sid组合
function T:getSids()
    return self.sids
end

--- 根据飞机sid得到增加的攻击值
function T:getAddAttackFormSid(sid)
    local sids = self:getSids()
    local num = #sids
    local value = nil
    for i = 1,num,1 do
        if value then
            break
        end
        local num1 = #sids[i]
        for j = 1,num1,1 do
            if sids[i][j] == sid then
                value = i
                break
            end
        end
    end

    local info = self.aircraftStrengBox:getStrengInfo(value)
    local attackCount = info:getAttackFromSid(sid)

    return attackCount
end

--- 根据飞机sid得到增加的血量值
function T:getAddHpFormSid(sid)
    local sids = self:getSids()
    local num = #sids
    local value = nil
    for i = 1,num,1 do
        if value then
            break
        end
        local num1 = #sids[i]
        for j = 1,num1,1 do
            if sids[i][j] == sid then
                value = i
                break
            end
        end
    end

    local info = self.aircraftStrengBox:getStrengInfo(value)
    local hpCount = info:getHpFromSid(sid)

    return hpCount

end


return T