---活动管理（固定和动态的放到一起的）
local T = Class.ActivityManager(LuaEventDispatcher2)

AbstractActivityInfo = require("src.app.model.allActivity.fixAndDynamic.AbstractActivityInfo")

--- 开发活动的存储的表
T.openActivityList = nil

function T:def()
	LuaEventDispatcher2.def(self)

	self.openActivityList = {}
	--- 状态列表
	self.fixList = {}

	-- 首充大奖(固定)
	self.firstRechargeInfo = require("src.app.model.allActivity.fixAndDynamic.firstRecharge.FirstRechargeInfo")()


	--- 固定的
	-- (sid=1)(排序=1) 签到(固定)
	self.signInfo = require("src.app.model.allActivity.fixAndDynamic.sign.SignInfo")()

	-- (sid=2)(排序=3) 开服豪礼(固定)
	self.openServerGiftInfo = require("src.app.model.allActivity.fixAndDynamic.openServer.OpenServerGiftInfo")()

	-- (sid=3)(排序=4) 等级礼包(固定)
	self.gradePackageInfo = require("src.app.model.allActivity.fixAndDynamic.gradePackage.GradePackageInfo")()

	-- (sid=4)(排序=9999) 成长计划(固顶，最后)
	self.growthPlanInfo = require("src.app.model.allActivity.fixAndDynamic.growthPlan.GrowthPlanInfo")()

    -- (sid=5)(排序=2) 首冲大回馈(固顶)
	self.firstRechargeActivityInfo = require("src.app.model.allActivity.fixAndDynamic.firstRechargeActivity.FirstRechargeActivityInfo")()


	--- 动态的
	--(sid=100)(排序=100) 大转盘(动态)
	self.bigWheelInfo = require("src.app.model.allActivity.fixAndDynamic.bigWheel.BigWheelInfo")()

	--(sid=101)(排序=101) 钻石抽钻石(动态)
	self.drawDiamondInfo = require("src.app.model.allActivity.fixAndDynamic.drawDiamond.DrawDiamondInfo")()

	--(sid=102)(排序=102) 限时商店(动态)
	self.timeLimitBuyInfo = require("src.app.model.allActivity.fixAndDynamic.timeLimitBuy.TimeLimitBuyInfo")()

	--(sid=103)(排序=103) 累计充值(动态)
	self.cumulativeRechargeInfo = require("src.app.model.allActivity.fixAndDynamic.cumulativeRecharge.CumulativeRechargeInfo")()

	--(sid=104)(排序=104) 急速发展(动态)
	self.rapidDevelopmentInfo = require("src.app.model.allActivity.fixAndDynamic.rapidDevelopment.RapidDevelopmentInfo")()

	--(sid=105)(排序=105) 每日充值(动态)
	self.dailyRechargeInfo = require("src.app.model.allActivity.fixAndDynamic.dailyRecharge.DailyRechargeInfo")()

	--(sid=106)(排序=106) 收集资源(动态)
	self.collectResourceInfo = require("src.app.model.allActivity.fixAndDynamic.collectResource.CollectResourceInfo")()

    --(sid=107)(排序=107) 战争之王(动态)
	self.gameOfWarInfo = require("src.app.model.allActivity.fixAndDynamic.gameOfWar.GameOfWarInfo")()

    --(sid=108)(排序=108) 军备竞赛(动态)
	self.armsRaceInfo = require("src.app.model.allActivity.fixAndDynamic.armsRace.ArmsRaceInfo")()




    --200,202,203,205,206,207
    --(sid=200)(排序=100) 大转盘(动态)
	self.bigWheelInfo2 = require("src.app.model.allActivity.fixAndDynamic.bigWheel2.BigWheelInfo2")()

	--(sid=202)(排序=102) 限时商店(动态)
	self.timeLimitBuyInfo2 = require("src.app.model.allActivity.fixAndDynamic.timeLimitBuy2.TimeLimitBuyInfo2")()

	--(sid=203)(排序=103) 累计充值(动态)
	self.cumulativeRechargeInfo2 = require("src.app.model.allActivity.fixAndDynamic.cumulativeRecharge2.CumulativeRechargeInfo2")()

	--(sid=205)(排序=105) 每日充值(动态)
	self.dailyRechargeInfo2 = require("src.app.model.allActivity.fixAndDynamic.dailyRecharge2.DailyRechargeInfo2")()

	--(sid=206)(排序=106) 收集资源(动态)
	self.collectResourceInfo2 = require("src.app.model.allActivity.fixAndDynamic.collectResource2.CollectResourceInfo2")()

    --(sid=207)(排序=107) 战争之王(动态)
	self.gameOfWarInfo2 = require("src.app.model.allActivity.fixAndDynamic.gameOfWar2.GameOfWarInfo2")()


end

function T:setFixList(fixList)
	self.fixList = fixList

	self.firstRechargeInfo:setList(fixList)
	self.firstRechargeInfo:setOpenValue(self.firstRechargeInfo:judgeOpenValueLogic())

	self.signInfo:setList(fixList)
	self.signInfo:setOpenValue(self.signInfo:judgeOpenValueLogic())


	self.openServerGiftInfo:setList(fixList)
	self.openServerGiftInfo:setOpenValue(self.openServerGiftInfo:judgeOpenValueLogic())

	self.gradePackageInfo:setList(fixList)
	self.gradePackageInfo:setOpenValue(self.gradePackageInfo:judgeOpenValueLogic())

	self.growthPlanInfo:setList(fixList)
	self.growthPlanInfo:setOpenValue(self.growthPlanInfo:judgeOpenValueLogic()) -- 因为这里传了list才有值，才能判断

    self.firstRechargeActivityInfo:setList(fixList)
	self.firstRechargeActivityInfo:setOpenValue(self.firstRechargeActivityInfo:judgeOpenValueLogic())

end

--- 初始化活动表(等所有数据更新完毕后再初始化)
function T:initOpenActList()
	local list = self:getOpenActList()
	if self.firstRechargeInfo:getOpenValue() == true then
		self:judgeIsExistAndAdd(self.firstRechargeInfo)
	end

	if self.signInfo:getOpenValue() == true then
		self:judgeIsExistAndAdd(self.signInfo)
	end

	if self.openServerGiftInfo:getOpenValue() == true then
		self:judgeIsExistAndAdd(self.openServerGiftInfo)
	end

	if self.gradePackageInfo:getOpenValue() == true then
		self:judgeIsExistAndAdd(self.gradePackageInfo)
	end

	if self.growthPlanInfo:getOpenValue() == true then
		self:judgeIsExistAndAdd(self.growthPlanInfo)
	end

    if self.firstRechargeActivityInfo:getOpenValue() == true then
		self:judgeIsExistAndAdd(self.firstRechargeActivityInfo)
	end

	local list = self:getOpenActList()
	table.sort(list,function(x,y) return x.priority < y.priority end)

end

--- 判断某一个活动是否存在
function T:judgeIsExistAndAdd(activityInfo)
	local list = self:getOpenActList()
	local judge = false
	local i = nil
	for k,v in pairs(list) do
		if v and v == activityInfo then
			i = k
			judge = true
			break
		end
	end

	if judge and i then
		list[i] = activityInfo
	else
		table.insert(list,activityInfo)
	end

end

--- 得到开发活动表
function T:getOpenActList()
	return self.openActivityList
end

function T:setOpenActList(list)
	self.openActivityList = list
end

--- 刷新某一个活动,还有其他数据（如果这个活动不存在，则添加，如果存在则覆盖）(断线重连考虑到这里面来了的)
function T:refreshOneAct(activityInfo,endTimeSec)
	local list = self:getOpenActList()
	activityInfo:setOpenValue(true)
	activityInfo:setEndTimeSec(endTimeSec)

	local judge = false
	local i = nil
	for k,v in pairs(list) do
		if v and v == activityInfo then
			i = k
			judge = true
			break
		end
	end

	if judge and i then
		list[i] = activityInfo
	else
		table.insert(list,activityInfo)
	end


	table.sort(list,function(x,y) return x.priority < y.priority end)

	self:startUpdateCheck()  -- 开始更新检测动态活动剩余时间

end

--- 删除了某一个活动
function T:deleteOneAct(activityInfo)
	local list = self:getOpenActList()
	for k,v in pairs(list) do
		if v and v == activityInfo then
			v:setOpenValue(false) -- 并且设置
			list[k] = nil
		end
	end

	local tempList = {}
	for k,v in pairs(list) do
		if v then
			tempList[#tempList + 1] = v
		end
	end

	table.sort(tempList,function(x,y) return x.priority < y.priority end)  -- 删除了后重新排序
	self:setOpenActList(tempList)
end


--- 根据sid得到是哪个数据结构
function T:getActInfoBySid(sid)
	local data = {}
	data.page = nil -- 页面
	data.info = nil -- 信息

	if sid == 1 then
		data.info = self.signInfo
		data.page = require("src.app.uiScript.components.allActivity.sign.SignWindow")
	elseif sid == 2 then
		data.info = self.openServerGiftInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.openServer.OpenServerWindow")
	elseif sid == 3 then
		data.info = self.gradePackageInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.gradePackage.GradePackageWindow")
	elseif sid == 4 then
		data.info = self.growthPlanInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.growthPlan.GrowthPlanWindow")
    elseif sid == 5 then
		data.info = self.firstRechargeActivityInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.firstRechargeActivity.FirstRechargeActivityWindow")
	elseif sid ==100 then
		data.info = self.bigWheelInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.bigWheel.BigWheelWindow")
	elseif sid == 101 then
		data.info = self.drawDiamondInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.drawDiamond.DrawDiamondWindow")
	elseif sid == 102 then
		data.info = self.timeLimitBuyInfo
		data.page = require("src.app.uiScript.components.prop.PropWindow")
	elseif sid == 103 then
		data.info = self.cumulativeRechargeInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.cumulativeRecharge.CumulativeRechargeWindow")
	elseif sid == 104 then
		data.info = self.rapidDevelopmentInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.rapidDevelopment.RapidDevelopmentWindow")
	elseif sid == 105 then
		data.info = self.dailyRechargeInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.dailyRecharge.DailyRechargeWindow")
	elseif sid == 106 then
		data.info = self.collectResourceInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.collectResouce.CollectResouceWindow")
    elseif sid == 107 then
		data.info = self.gameOfWarInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.gameOfWar.GameOfWarWindow")
    elseif sid == 108 then
		data.info = self.armsRaceInfo
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.armsRace.ArmsRaceWindow")
    elseif sid == 200 then
		data.info = self.bigWheelInfo2
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.bigWheel.BigWheelWindow")
	elseif sid == 202 then
		data.info = self.timeLimitBuyInfo2
		data.page = require("src.app.uiScript.components.prop.PropWindow")
	elseif sid == 203 then
		data.info = self.cumulativeRechargeInfo2
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.cumulativeRecharge.CumulativeRechargeWindow")
	elseif sid == 205 then
		data.info = self.dailyRechargeInfo2
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.dailyRecharge.DailyRechargeWindow")
	elseif sid == 206 then
		data.info = self.collectResourceInfo2
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.collectResouce.CollectResouceWindow")
    elseif sid == 207 then
		data.info = self.gameOfWarInfo2
		data.page = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.gameOfWar.GameOfWarWindow")
	end
    

	return data
end

function T:startUpdateCheck()
	if self.updateId then
		return
	end

	local function update()
		local list = self:getOpenActList()
		local syncSec = TimeUtils:getSyncMillis()/1000

		for k,v in pairs(list) do  -- k是id
			if v and v.endTimeSec then -- 现在只有动态的有剩余时间
				v.remainingSec = v.endTimeSec - syncSec
				if v.endTimeSec <= syncSec then
					self:deleteOneAct(v)
					self:tryStopUpdate()
				else -- 派发事件
					v:luaDispatchEvent(v.EVT_ACTIVTIY_TIME_REFRESH .. v.sid)
				end
		end
		end
	end

	local list = self:getOpenActList()
	if list then
		for k,v in pairs(list) do
			if v and v.endTimeSec then -- 现在只有动态的有剩余时间
				self.updateId = Cocos2dxUtils:interval(update,1)
				break
			end

		end
	end
end

--- 尝试结束更新
function T:tryStopUpdate()
	if self.updateId then
		local list= self:getOpenActList()

		--如果队列为空,结束时间更新检查
		local isEmpty = true
		for k,v in pairs(list) do
			if v and v.endTimeSec then -- 现在只有动态的有剩余时间
				isEmpty=false
				break
			end
		end

		if isEmpty then
			Cocos2dxUtils:clearScheduler(self.updateId)
			self.updateId = nil
		end
	end
end

function T:judgeHomePage()
	local list = self:getOpenActList()

	local bool = false
	for k,v in pairs(list) do
		if v then
			if v:judgeHomePage() == true then
				bool = true
				break
			end
		end
	end

	return bool
end

--- 清除所有动态活动
function T:clearAllDynamic()
    local list = self:getOpenActList()

    for k,v in pairs(list) do
        if v then
            if v.sid >= 100 and v.sid <= 107 then -- 则为动态活动
                v:setOpenValue(false) -- 并且设置
			    list[k] = nil
            end

        end

    end

    local tempList = {}
	for k,v in pairs(list) do
		if v then
			tempList[#tempList + 1] = v
		end
	end
	table.sort(tempList,function(x,y) return x.priority < y.priority end)  -- 删除了后重新排序
	self:setOpenActList(tempList)

end


return T
