--- 抽奖显示的数据结构
local T = { }

function T:decode(data)
	local r = {}

    r.id = data:readByte()
    local type = data:readByte()
    if type == 1 then -- 钻石
        r.effType = data:readByte()
        r.count = data:readInt()
        
        local data = AwardTypes.gems
        r.name = data and Language:get(data.name) or "?"
        r.iconUrl = IconManager.iconPath ..(data and data.iconUrl or "propIcon/defalutIcon.png")
        r.des = Language:get(data.des)
    end

	if type == 2 then -- 道具
        r.effType = data:readByte()
        r.count = data:readInt()
        r.sid = data:readShort()
        
        local data = Prop_temp[r.sid]
        r.name = data and Language:get(data.prop) or "?"
        r.iconUrl = IconManager.iconPath ..(data and data.propIcon or "propIcon/defalutIcon.png")
        r.des = PlayerInstance:getPropDescripe(r.sid)
    end

    if type == 3 then -- 飞机
        r.effType = data:readByte()
        r.count = data:readInt()
        r.sid = data:readShort()
        
        local data = Aircraft_temp[r.sid]
        r.name = AircraftUtils:getRichName(data)
        r.iconUrl = IconManager.iconPath ..(data and data.icon or "propIcon/defalutIcon.png")
        r.des = Language:get(data.describe,data.capacity)
    end


	return r

end

--- 根据配置得到所有的数据
function T:getAllLotteryData()
    local temp = mapping({},LotteryData_temp)

    for k,v in pairs(temp) do
        if v.type == 1 then
            local data = AwardTypes.gems
            v.name = data and Language:get(data.name) or "?"
            v.iconUrl = IconManager.iconPath ..(data and data.iconUrl or "propIcon/defalutIcon.png")
            v.des = Language:get(data.des)
        end

        if v.type == 2 then
            local data = Prop_temp[v.sid]
            v.name = data and Language:get(data.prop) or "?"
            v.iconUrl = IconManager.iconPath ..(data and data.propIcon or "propIcon/defalutIcon.png")
            v.des = PlayerInstance:getPropDescripe(v.sid)
        end

        if v.type == 3 then
            local data = Aircraft_temp[v.sid]
            v.name = AircraftUtils:getRichName(data)
            v.iconUrl = IconManager.iconPath ..(data and data.icon or "propIcon/defalutIcon.png")
            v.des = Language:get(data.describe,data.capacity)
        end

    end

    return temp
end


return T
