--- 军备竞赛
local T = Class.ArmsRaceInfo(AbstractActivityInfo)

--- 事件-时间刷新
T.EVT_ACTIVTIY_TIME_REFRESH = "evt_activity_time_refresh"

--- 事件-是否领取刷新
T.EVT_IS_GET_REFRESH = "evt_is_get_refresh"

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


function T:def()
    AbstractActivityInfo:def(self)
    self.sid = 108
    self.priority = FixAndDynamicAct_temp[self.sid].priority

    --- 结束时间
    self.endTimeSec = nil
    --- 剩余时间
    self.remainingSec = nil

    --- 数据
    self.data = nil
end

--- 这个是临时的，每次都要重新获取
function T:decode(data)
    local tempData = {} 

    local length = data:readByte()
    for i = 1,length,1 do
        local temp = {}

        temp.recruitSid = data:readShort() -- 需要生产sid
        temp.needNum = data:readShort() -- 需要生产数量
        temp.recruitNum = data:readInt() -- 已生产数量
        temp.getSid = data:readShort() -- 可领取sid
        temp.getNum = data:readShort() -- 可领取数量
        temp.isGet = data:readBoolean() -- 是否已领取

        tempData[i] = temp

    end

    self.data = tempData

    return tempData

end

function T:setEndTimeSec(endTimeSec)
    self.endTimeSec = endTimeSec
end

--- 得到数据根据索引
function T:getDataByIndex(index)
    local data = self.data
    if data[index + 1] then
        
        return data[index + 1]

    end

end




--- 设置已经领取,领取下标0,1,2,3,...
function T:setHasGetAward(index)
    local data = self.data
    if data[index + 1] then
        data[index + 1].isGet = true

        self:luaDispatchEvent(self.EVT_IS_GET_REFRESH .. self.sid)

    end

end

--- 判断是否可以领取
function T:judgeIsGetAward(index)
    local data = self.data
    if data[index + 1] then
        if data[index + 1].recruitNum >= data[index + 1].needNum then
            return true
        else
            return false
        end

    end

    return false

end



--- 判断主界面是否可以转圈bool值
function T:judgeHomePage()   
    return false
end


return T