--- 采集资源
local T = Class.CollectResourceInfo(AbstractActivityInfo)

--- 事件-时间刷新
T.EVT_ACTIVTIY_TIME_REFRESH = "evt_activity_time_refresh"

--- 事件-任务已经领取刷新
T.EVT_ACTIVTIY_TASK_FINISH_REFRESH = "evt_activity_task_finish_refresh"

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


function T:def()
    AbstractActivityInfo:def(self)
    self.sid = 106
    self.priority = FixAndDynamicAct_temp[self.sid].priority

    --- 结束时间
    self.endTimeSec = nil
    --- 剩余时间
    self.remainingSec = nil
end

--- 这个是临时的，每次都要重新获取,这里每次都要更新内存里面的数据，因为是每次都是重新获取（这里目的是为了借用事件来刷新视图）
function T:decode(data)
    local dataTable = {}
    for i = 1,5,1 do
        local temp = {}
        temp.sid = i
        temp.hasCollectRes = data:readInt() -- 对应资源已采集数量
        temp.awardTag = data:readInt() -- 对应奖励领取标记
        temp.awards = {}
        temp.awards[0] = self.AwardDataDecoder:decode(data) -- 5M奖励
        temp.awards[1] = self.AwardDataDecoder:decode(data) -- 20M奖励
        temp.awards[2] = self.AwardDataDecoder:decode(data) -- 60M奖励
        temp.awards[3] = self.AwardDataDecoder:decode(data) -- 120M奖励

        dataTable[#dataTable + 1] = temp
    end

    self.tempData = dataTable

    return self.tempData

end

function T:setEndTimeSec(endTimeSec)
    self.endTimeSec = endTimeSec
end


--- 判断主界面是否可以转圈bool值
function T:judgeHomePage()   
    return false
end

--- 得到已经领取的任务数量
function T:getTaskNum(resSid)
    if self.tempData then
        local num = 0
        for i = 1,4,1 do
            if BitOperator:_and(self.tempData[resSid].awardTag, BitOperator:_ls(1, i - 1)) ~= 0 then -- 领取了
                num = num + 1
            end
        end
        return num
    else
        return 0
    end
end

--- 设置任务已经领取,把对应的标记刷新了
function T:setTaskFinish(resSid,awardTag)
    if self.tempData then
        self.tempData[resSid].awardTag = awardTag

        self:luaDispatchEvent(self.EVT_ACTIVTIY_TASK_FINISH_REFRESH)
    end
end


--- 判断任务是否已经领取,true:已经领取，false:未领取
function T:judgeTaskIsGet(resSid,awardIndex)
    if self.tempData then
        if BitOperator:_and(self.tempData[resSid].awardTag, BitOperator:_ls(1, awardIndex)) ~= 0 then -- 领取了
            return true
        else
            return false
        end

    else
        return false
    end
end

--- 得到任务领取的资源条件
function T:getTaskConditon(awardIndex)
    local awardIndex = awardIndex or 0
    if awardIndex == 0 then
        return 5 * 1000000
    elseif awardIndex == 1 then
        return 20 * 1000000
    elseif awardIndex == 2 then
        return 60 * 1000000
    else
        return 120 * 1000000
    end


end


return T