--- 等级礼包
local T = Class.GradePackageInfo(AbstractActivityInfo)

--- 事件--领取等级礼包刷新
T.EVT_GET_GRADE_PACKAGE_REFRESH = "evt_get_grade_package_refresh"

--- 等级礼包mark
T.LEVEL_GIFT_MARK = 116

T.ONE_TAG = BitOperator:_ls(1, 0)            -- 0 
T.TWO_TAG = BitOperator:_ls(1, 1)            -- 1
T.THREE_TAG = BitOperator:_ls(1, 2)          -- 2
T.FOUR_TAG = BitOperator:_ls(1, 3)           -- 3
T.FIVE_TAG = BitOperator:_ls(1, 4)           -- 4
T.SIX_TAG = BitOperator:_ls(1, 5)            -- 5
T.SEVEN_TAG = BitOperator:_ls(1, 6)          -- 6
T.EIGHT_TAG = BitOperator:_ls(1, 7)          -- 7
T.NINE_TAG = BitOperator:_ls(1, 8)           -- 8
T.TEN_TAG = BitOperator:_ls(1, 9)            -- 9
T.ELEVEN_TAG = BitOperator:_ls(1, 10)        -- 10
T.TWELVE_TAG = BitOperator:_ls(1, 11)        -- 11

function T:def()
    AbstractActivityInfo:def(self)
    self.sid = 3
    self.priority = FixAndDynamicAct_temp[self.sid].priority
end

function T:setList(list)
    self.list = list
end


function T:judgeOpenValueLogic()
    --- 如果所有的等级礼包都领完了，则关闭
    local bool = false
    for i = 0,11,1 do
        local TAG = BitOperator:_ls(1, i)
        if self:getGradePackValue(TAG) == false then
            bool = true 
            break
        end
    end

    return bool
end

--- 位如果是0表示未领取了，1表示领取,
function T:getGradePackValue(type)
    local value = self.list[self.LEVEL_GIFT_MARK] or 0
    return BitOperator:_and(value, type) ~= 0 -- true：1领取，false：0未领取
end

--- 把未领取的设置为领取了，就是0变为1
function T:setGradePackValue(type)
    local value = self.list[self.LEVEL_GIFT_MARK] or 0
    self.list[self.LEVEL_GIFT_MARK] = BitOperator:_or(type,value)

    self:luaDispatchEvent(self.EVT_GET_GRADE_PACKAGE_REFRESH)
    self:luaDispatchEvent(self.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. self.sid)

    if self:judgeOpenValueLogic() == false then
        ActivityManager:deleteOneAct(ActivityManager.gradePackageInfo) -- 把自己删除了
    end

end

--- 未领取的时候，判断角色等级是否满足，满足的话，则可以领取，否则不能领取:sid配置表的sid
function T:judgeIsGetAward(sid)
    local needLevel = GradePackage_temp[sid].level
    local nowLevel = UserInfo.level
    if nowLevel >= needLevel then
        return true -- 可以领取
    else
        return false -- 还不能领取
    end
end

--- 判断主界面是否可以转圈bool值
function T:judgeHomePage()
    if self:getOpenValue() == false then 
        return false 
    end

    local bool = false
    for i = 0,11,1 do
        local TAG = BitOperator:_ls(1, i)
        if self:getGradePackValue(TAG) == false then
            if self:judgeIsGetAward(i + 1) then
                bool = true
                break
            end
        end
    end

    return bool
end

return T