--- 成长计划
local T = Class.GrowthPlanInfo(AbstractActivityInfo)

--- 事件--购买成长计划件刷新
T.EVT_BUY_GROWTH_PLAN_REFRESH = "evt_buy_growth_plan_refresh"

--- 事件--钻石领取成长计划刷新
T.EVT_GEMS_GET_GROWTH_PLAN_REFRESH = "evt_gems_get_growth_plan_refresh"


--- 成长计划购买标记,1购买了
T.BUY_MARK = 117

--- 成长计划钻石领取标记,1:领取了
T.GEMS_AWARD_MARK = 118


T.ONE_TAG = BitOperator:_ls(1, 0)            -- 0 
T.TWO_TAG = BitOperator:_ls(1, 1)            -- 1
T.THREE_TAG = BitOperator:_ls(1, 2)          -- 2
T.FOUR_TAG = BitOperator:_ls(1, 3)           -- 3
T.FIVE_TAG = BitOperator:_ls(1, 4)           -- 4
T.SIX_TAG = BitOperator:_ls(1, 5)            -- 5
T.SEVEN_TAG = BitOperator:_ls(1, 6)          -- 6


function T:def()
    AbstractActivityInfo:def(self)
    self.sid = 4
    self.priority = FixAndDynamicAct_temp[self.sid].priority
end

function T:setList(list)
    self.list = list
end


function T:judgeOpenValueLogic()
    -- 如果全部领完了的话，就把这个活动关了
    local bool = false
    for i = 0,6,1 do
        local TAG = BitOperator:_ls(1, i)
        if self:getAwardValue(TAG) == false then  -- 只要有一个未领取,则活动开启
            bool = true
            break
        end
    end
    return bool

end


--- 得到成长计划购买标记,这个只验证买没有，不考虑vip等级
function T:getBuyValue()
    local value = self.list[self.BUY_MARK] or 0
    if value == 0 then
        return false -- 未买
    else
        return true -- 买了
    end
end

--- 设置成长计划购买标记,表示购买了
function T:setBuyValue()
    self.list[self.BUY_MARK] = 1
    self:luaDispatchEvent(self.EVT_BUY_GROWTH_PLAN_REFRESH)
    self:luaDispatchEvent(self.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. self.sid)
end


--- 位如果是0表示未领取了，1表示领取,由于每次进页面都要获取一次数据，所以是最新的数据
--- 获取相应的钻石领取数值
function T:getAwardValue(type)
    local value = self.list[self.GEMS_AWARD_MARK] or 0
    return BitOperator:_and(value, type) ~= 0 -- true：1领取，false：0未领取
end

--- 设置相应的钻石领取数值
--- 把未领取的设置为领取了，就是0变为1
function T:setAwardValue(type)
    local value = self.list[self.GEMS_AWARD_MARK] or 0
    self.list[self.GEMS_AWARD_MARK] = BitOperator:_or(type,value)

    self:luaDispatchEvent(self.EVT_GEMS_GET_GROWTH_PLAN_REFRESH)
    self:luaDispatchEvent(self.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. self.sid)

    if self:judgeOpenValueLogic() == false then
        ActivityManager:deleteOneAct(ActivityManager.growthPlanInfo) -- 把自己删除了
    end

end


--- 未领取的时候，判断角色等级是否满足，满足的话，则可以领取，否则不能领取:sid配置表的sid
function T:judgeIsGetAward(sid)
    local needLevel = GrowthPlan_temp[sid].playerLevel
    local nowLevel = UserInfo.level
    if nowLevel >= needLevel then
        return true -- 可以领取
    else
        return false -- 还不能领取(灰色领取)
    end
end


--- 判断主界面是否可以转圈bool值
function T:judgeHomePage()
    if self:getOpenValue() == false then 
        return false 
    end

    local buyBool = false
    local value = self.list[self.BUY_MARK] or 0
    if value == 0 then
        local vipLevel = UserInfo.vipLevel
        if vipLevel < 3 then -- 未买
            buyBool = not true 

        else -- 等级到3才提示
            buyBool = not false
        end
    else
        buyBool = not true -- 买了
    end

    local awardBool = false
    if self:getBuyValue() == true then -- 如果买了vip才有这个
        for i = 0,6,1 do
            local TAG = BitOperator:_ls(1, i)
            if self:getAwardValue(TAG) == false then
                if self:judgeIsGetAward(i + 1) then
                    awardBool = true
                    break
                end
            end
        end
    end

    return buyBool or awardBool
end


return T