--- 连续签到的标记
local T = Class.ContinueAttendanceGet()

--- 设置标记
T.mark = 113

function T:def()
    --- 状态列表
	self.list = {}

    self.ONE_TAG = BitOperator:_ls(1, 0)            -- 0
    self.TWO_TAG = BitOperator:_ls(1, 1)            -- 1
    self.THREE_TAG = BitOperator:_ls(1, 2)          -- 2
    self.FOUR_TAG = BitOperator:_ls(1, 3)           -- 3
end


function T:setList(list)
    self.list = list
end


--- 得到总值
function T:getTotalValue()
    return self.list[self.mark] or 0
end


--- 位如果是0表示未领取了，1表示领取
--- 获取相应的数值
function T:getValue(type)
    local value = self.list[self.mark] or 0
    return BitOperator:_and(value, type) ~= 0 -- true：1领取，false：0未领取
end

--- 设置相应的数值
--- 把未领取的设置为领取了，就是0变为1
function T:setValue(type)
    local value = self.list[self.mark] or 0
    self.list[self.mark] = BitOperator:_or(type,value)
    SetStates.signManager:luaDispatchEvent(SetStates.signManager.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH)
    ActivityManager.signInfo:refreshState()

end

--- 把未领取的设置为领取了，就是1变为0
function T:setTagValue(tagType)
    local type = nil
    if tagType == 0 then
        type = self.ONE_TAG
    elseif tagType == 1 then
        type = self.TWO_TAG
    elseif tagType == 2 then
        type = self.THREE_TAG
    else
        type = self.FOUR_TAG
    end
     
    self:setValue(type)

end

--- 根据1，2，3，4判断是否可以签到
function T:judgeIsContinueSign(tag)
    local type = nil
    if tag == 1 then
        type = self.ONE_TAG
    elseif tag == 2 then
        type = self.TWO_TAG
    elseif tag == 3 then
        type = self.THREE_TAG
    else
        type = self.FOUR_TAG
    end

    return self:getValue(type)
end

return T
