--[[
    签到管理
]]

local T = Class.SignManager(LuaEventDispatcher2)

--- 每日签到所有数据刷新(每日状态更新，直接监听每日状态的)
T.EVT_DAILY_ATTENDANCE_ALL_DATA_REFRESH = "evt_daily_attendance_all_data_refresh"

--- 连续签到次数和得到刷新
T.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH = "evt_continue_attendance_count_refresh"


function T:def()
    LuaEventDispatcher2.def(self)

    --- 状态列表
	self.list = { }

    --- 每日签到日期设置
    self.dailyAttendanceDate = require("src.app.model.allActivity.sign.DailyAttendanceDate")()
    --- 每日签到次数
    self.dailyAttendanceCount = require("src.app.model.allActivity.sign.DailyAttendanceCount")()
    --- 连续签到是否标记
    self.continueAttendanceGet = require("src.app.model.allActivity.sign.ContinueAttendanceGet")()
    --- 连续签到次数
    self.continueAttendanceCount = require("src.app.model.allActivity.sign.ContinueAttendanceCount")()
end

function T:setList(list)
    self.list = list

    self.dailyAttendanceDate:setList(self.list)
    self.dailyAttendanceCount:setList(self.list)
    self.continueAttendanceGet:setList(self.list)
    self.continueAttendanceCount:setList(self.list)

end

--- 判断所有的是否有签到:true:可以签到，false:不能签到
function T:judgeSign()
    local dailyAttendanceDate = self.dailyAttendanceDate
    local state1 = dailyAttendanceDate:judgeIsSign() -- true能签到

    local state2 = self:judgeContinueSign()

    return state1 or state2
end

--- 判断连续是否可以签到:true:可以签到，false:不能签到
function T:judgeContinueSign()
    local continueAttendanceGet = self.continueAttendanceGet
    local continueAttendanceCount = self.continueAttendanceCount

    local state2 = false
    local day = continueAttendanceCount:getCount()
    local num = #ContinueAttendance_temp
    for i = 1,num,1 do 
        if day >= ContinueAttendance_temp[i].day then -- 可以领取
            if continueAttendanceGet:judgeIsContinueSign(i) then -- 领取了
            else -- 未领取
                state2 = true
                break
            end
        end
    end

    return state2
end



return T
