local T=Class.AllianceBox()

--- 联盟信息
T.MyAllianceInfo=require("src.app.model.alliance.MyAllianceInfo")

--- 联盟排行榜信息
T.AllianceRankBox=require("src.app.model.alliance.AllianceRankBox")

--- 联盟商店商品信息
T.AllianceShopGoodsInfo=require("src.app.model.alliance.AllianceShopGoodsInfo")

function T:def()
	--- 自己所在的联盟
	self.myAlliance=self.MyAllianceInfo()

	--- 联盟排行榜
	self.allianceRankBox=self.AllianceRankBox()

	--- 已申请的联盟列表
	--	self.appliedAllianceIdList=nil

	--- 收到的邀请列表
	--	self.receiveInviteList=nil

	--- 联盟商店商品列表
	-- shopGoodesList
end

--- 解析邀请列表信息
function T:decodeInviteList(data)
	local len=data:readUnsignedByte()
	if len > 0 then
		local iList={}
		for i=1,len,1 do
			local iInfo={}
			iInfo.id=data:readUnsignedInt()
			iInfo.inviteSec=GameUtils:modifyTimeZone(data:readUnsignedInt())
			iInfo.level=data:readUnsignedByte()
			iInfo.name=data:readString()
			iInfo.inviterName=data:readString()

			iList[i]=iInfo
		end

		self.receiveInviteList=iList
	end
end

--- 解析联盟商店商品列表
function T:decodeShopGoodsList(byteArray)
	local gList={}
	
	local len=byteArray:readUnsignedByte()
	for i=1,len,1 do
		local gInfo=self.AllianceShopGoodsInfo(byteArray)
		
		gList[#gList+1]=gInfo
	end
	
	self.shopGoodesList=gList
end

--- 从邀请列表中删除
function T:removeFromInviteList(allianceId)
	local iList=self.receiveInviteList

	if iList then
		for k,v in ipairs(iList) do
			if v.id == allianceId then
				table.remove(iList,k)
				break
			end
		end
	end
end

return T
