--- 联盟社交信息
local T = Class.AllianceSocial(LuaEventDispatcher2)


--- 事件，添加好友
T.EVT_ADD_FRIEND_REFRESH = "evt_add_friend_refresh"

--- 事件，删除好友
T.EVT_DELETE_FRIEND_REFRESH = "evt_delete_friend_refresh"

--- 事件，添加敌对
T.EVT_ADD_ENEMY_REFRESH = "evt_add_enemy_refresh"

--- 事件，删除敌对
T.EVT_DELETE_ENEMY_REFRESH = "evt_delete_enemy_refresh"


function T:def()
    LuaEventDispatcher2.def(self)

    -- 友盟列表
    self.friendList = {}

    -- 敌对列表
    self.enemyList = {}

    -- 最大的数量
    self.MAX_COUTN = 20

end

function T:ctor()
    
end


function T:decode(data)
    self.friendList = {} -- 端口刷的时候要清楚数据
    self.enemyList = {}

    local friendCount = data:readUnsignedByte()
    for i = 1,friendCount,1 do
        local temp = {}
        temp.id = data:readInt()
        self.friendList[temp.id] = temp
    end

    local enemyCount = data:readUnsignedByte()
    for i = 1,enemyCount,1 do
        local temp = {}
        temp.id = data:readInt()
        self.enemyList[temp.id] = temp
    end
    

end

--- 得到友盟列表
function T:getFriendList()
    return self.friendList
end

--- 判断友盟数量是否达到最大值
function T:judgeFriendReachMax()
    local friendList = self:getFriendList()
    local i = 0 
    for k,v in pairs(friendList) do
        if v then
            i = i + 1
        end
    end

    if i < self.MAX_COUTN then
        return false
    else
        return true  -- 超过了最大数量，不能添加好友了
    end
end

--- 添加友盟,如果在敌对中，则删除
function T:addFriend(id)
    local friendList = self:getFriendList()

    local info = {}
    info.id = id
    friendList[info.id] = info

    if self:judgeIsAtEnemyList(id) then
        self:deleteEnemy(id)
    end

    self:luaDispatchEvent(self.EVT_ADD_FRIEND_REFRESH,info)
end

--- 判断是否在友盟中
function T:judgeIsAtFrendList(id)
    local friendList = self:getFriendList()
    for k,v in pairs(friendList) do
        if  v and v.id == id then
            return true
        end
    end
    return false
end

--- 移除友盟
function T:deleteFriend(id)
    local friendList = self:getFriendList()
    if friendList[id] then
        friendList[id] = nil
    end
    self:luaDispatchEvent(self.EVT_DELETE_FRIEND_REFRESH)
end

--- 得到友盟的数量
function T:getFriendCount()
    local friendList = self:getFriendList()
    local i = 0 
    for k,v in pairs(friendList) do
        if v then
            i = i + 1
        end
    end

    return i
end

-------------------------------------------------------------------
--- 得到敌对列表
function T:getEnemyList()
    return self.enemyList
end

--- 判断敌对数量是否达到最大值
function T:judgeEnemyReachMax()
    local enemyList = self:getEnemyList()
    local i = 0 
    for k,v in pairs(enemyList) do
        if v then
            i = i + 1
        end
    end

    if i < self.MAX_COUTN then
        return false
    else
        return true  -- 超过了最大数量，不能添加好友了
    end
end

--- 添加敌对
function T:addEnemy(id)
    local enemyList = self:getEnemyList()

    local info = {}
    info.id = id
    enemyList[info.id] = info

    if self:judgeIsAtFrendList(id) then
        self:deleteFriend(id)
    end

    self:luaDispatchEvent(self.EVT_ADD_ENEMY_REFRESH,info)
end

--- 判断是否在敌盟中
function T:judgeIsAtEnemyList(id)
    local enemyList = self:getEnemyList()
    for k,v in pairs(enemyList) do
        if  v and v.id == id then
            return true
        end
    end
    return false
end

--- 移除敌对
function T:deleteEnemy(id)
    local enemyList = self:getEnemyList()
    if enemyList[id] then
        enemyList[id] = nil
    end
    self:luaDispatchEvent(self.EVT_DELETE_ENEMY_REFRESH)
end

--- 得到敌对的数量
function T:getEnemyCount()
    local enemyList = self:getEnemyList()
    local i = 0 
    for k,v in pairs(enemyList) do
        if v then
            i = i + 1
        end
    end

    return i
end


return T
