--[[
    公告盒子
]]
local T = Class.AnnounceBox(LuaEventDispatcher2)

-- 公告信息
T.AnnounceInfo = require("src.app.model.announce.AnnounceInfo")


function T:def()
    LuaEventDispatcher2.def(self)

    -- 配件信息
    self.announceBox = {}

end

function T:decode(data)
    local annouceState = data:readBoolean()
    if annouceState == true then
        self.announceBox = {}
        local announceCrc = data:readInt()

        -- 并且存储起来
        DataStorage:putAnnounceSrc(UserInfo.id,announceCrc)

        AnnounceManager:setAnnounceCrc(announceCrc)
        AnnounceManager:setAnnounceCrcFront(announceCrc)


        local len = data:readUnsignedByte()

	    local infos = {}
	    for i = 1,len,1 do
		    local info = self.AnnounceInfo()
		    info:decode(data)
		    infos[info.id] = info
	    end

	    self.announceBox = infos

    else
        
    end
end

--- 得到显示的公告数据
function T:getShowAnnounceInfo()
    local infos = self.announceBox
    if infos then
        local dataTable = {}
        for k,v in pairs(infos) do
            local i = 1
            if v then
                dataTable[i] = v
                i = i + 1
            end
        end

        if #dataTable > 0 then
            table.sort(dataTable,function(x,y) return x.id > y.id end) -- 时间显示先后顺序
            return dataTable

        else
            return nil
        end


    else
        return nil
    end

end


return T