--- 公告管理
local T = Class.AnnounceManager(LuaEventDispatcher2)

--- 事件-公告校验值刷新
T.EVT_ANNOUNCECRC_REFRESH = "evt_announcecrc_refresh"


function T:def()
	LuaEventDispatcher2.def(self)

    -- 公告盒子
    self.announceBox = require("src.app.model.announce.AnnounceBox")()

    -- 公告内容盒子
    self.announceContentBox = require("src.app.model.announce.AnnounceContentBox")()


end

--- 设置公告校验值到内存中(要存到本地的)
function T:setAnnounceCrc(announceCrc)
    UserInfo.announceCrc = announceCrc
    self:luaDispatchEvent(self.EVT_ANNOUNCECRC_REFRESH)

end

--- 得到公告校验值（得到后台发的）
function T:getAnnounceCrc()
    return UserInfo.announceCrc
end


--- 设置公告校验值到内存中(是前端自己存储到内存中的，防止第一次没有数据)
function T:setAnnounceCrcFront(announceCrc)
    self.announceCrc = announceCrc
end

--- 得到公告校验值（是前端自己的）
function T:getAnnounceCrcFront()
    return self.announceCrc or 0
end


--- 判断是否有公告信息感叹号显示
function T:judgeIsAnnounceInfo()
    local newAnnounceCrc = self:getAnnounceCrc()
    local oldAnnoucneCrc = DataStorage:getAnnounceSrc(UserInfo.id)

    if newAnnounceCrc == 0 then -- 没有公告信息
        return false
    else
        if oldAnnoucneCrc == 0 then -- 第一次登陆不显示感叹号
            return false
        else
            if oldAnnoucneCrc == newAnnounceCrc then
                return false
            else
                return true
            end

        end
    end

end


return T
