--[[
    部队任务项
]]
local T={}

--- 队列id
T.id = nil

--- 结束时间
T.endTimeSec = nil

--- 源id
T.sourceId = nil

--- 目标id
T.targetId = nil

--- 目标名字+等级
T.targetName = nil

--- 状态(有1:飞机部队出征，2:飞机部队驻扎（采集），3:飞机部队返回)
T.status = nil

--- 坐标x
T.posX = nil

--- 坐标y
T.posY = nil

--- 移动消耗: 进攻和返回的总时间，采集没用
T.movingCost = nil

--- 资源产出速率速率，每分钟
T.resourceEfficiency = nil

--- 部队出征任务的战机信息（sid，数量）
T.armyExpeditionAircrafts = nil

--- 时间间隔
T.remainingSec = 0

function T:decode(data)
    self.id = data:readUnsignedInt()
    self.endTimeSec = GameUtils:modifyTimeZone(data:readUnsignedInt())
    self.sourceId = data:readUnsignedInt()
    self.targetId = data:readUnsignedInt()
    self.targetName = data:readString()
    self.status = data:readUnsignedByte()
    self.posX = data:readUnsignedShort()
    self.posY = data:readUnsignedShort()
    self.movingCost = data:readUnsignedInt()
    self.resourceEfficiency = data:readUnsignedInt()
    
    print(obj2str(self))

    local aircraft = {}
    for i = 1,6,1 do  -- 出征的战机,暂时先写从1到6,是位置
        local modelAircraft = {}
        modelAircraft.sid = data:readUnsignedShort()
        if modelAircraft.sid <= 0 then
            modelAircraft.count = 0
        else
            modelAircraft.count = data:readUnsignedShort()
        end
        aircraft[i] = modelAircraft
    end
    self.armyExpeditionAircrafts = aircraft

    if self.targetId <= 0 then -- 资源,重新设置名字
        local first,second = CommonMethod:getCharFromStr(self.targetName)

		local realTitle1 = CommonMethod:getRealText(first)
		self.targetName = realTitle1 .. " Lv." .. second

    end


end

return T