local T=Class.AbstractGuideStep()

T.GuideTipBox=require("src.app.uiScript.components.beginnersGuide.GuideTipBox")

function T:def()
	self._evtHandlers={}
end

function T:start()
end

function T:evtHandler(evt,...)
	local handler=self._evtHandlers[evt]
	if handler then
		return handler(...)
	end
end

function T:skip()
	self._evtHandlers={}
	
	BGMgr:hideHollowMask()
end

--- 设置 UI 的 touch 状态(是否可被点击)
-- @param uiObjName UI对象名
function T:setUITouchState(uiObjName,isEanbled)
	local uiObj=BGMgr:getRegedObj(uiObjName)
	if uiObj then
		if uiObj.setEnabled then
			uiObj:setEnabled(isEanbled)
		end
		if uiObj.setTouchEnabled then
			uiObj:setTouchEnabled(isEanbled)
		end
	end
end

--- 镂空主界面上的"关卡"按钮
function T:hollowHomepageChapterButton()
	local offsetPts=MathUtil:getPointsOfCycle(-3,10,34,20)
	BGMgr:hollowTrigger(BGMgr.TGR_HOMEPAGE_CHATPER_BUTTON,offsetPts,nil,nil,Language:get("ugG_tip_1"),{x=-3,y=10,scale=0.45})
end

--- 切换到战役信息窗口
function T:switchCampaignInfoWindow(campaignIndex)
	campaignIndex=campaignIndex or 1

	print("切换到战役信息窗口","战役索引为:"..campaignIndex)

	ResLoader:syncLoad(require("src.app.uiScript.components.battle.AllCampaignWindow").PRE_RES_LIST)

	--- 战役数据
	local Campaign_temp=require("res.data.battle.campaign")

	WindowManager:push(
		require("src.app.uiScript.components.battle.CampaignInfoWindow").new(Campaign_temp[campaignIndex])
	)
end

--- 移动显示对象到屏幕正中央
-- @param idUIName
-- @param completeCallback
-- @param sceneId
function T:moveObj2center(idUIName,completeCallback,sceneId)
	local host=BGMgr:getRegedObj(idUIName)
	if not host then
		return
	end

	local parent=host:getParent()
	if parent then
		local wp=parent:convertToWorldSpace(cc.p(host:getPosition()))
		local anchor,size=host:getAnchorPoint(),host:getContentSize()
		local sPtX=wp.x-size.width*anchor.x+size.width/2
		local sPtY=wp.y-size.height*anchor.y+size.height/2

		local ePtX,ePtY=O_PT.x+V_SZ.width/2,O_PT.y+V_SZ.height/2
		local sCount=MathUtil.pointToPointDistance(ePtX,ePtY,sPtX,sPtY)/10

		local stepx,stepy=(ePtX-sPtX)/sCount,(ePtY-sPtY)/sCount

		host.__lastX=wp.x
		host.__lastY=wp.y

		local i,act=0,nil
		act=AbstractUI.interval(host,function()
			if sceneId == 2 then
				HomePageManager:setHomeOutSideMove(stepx,stepy)
			else
				HomePageManager:setHomeBaseMove(stepx,stepy)
			end

			i=i+1
			local wp=parent:convertToWorldSpace(cc.p(host:getPosition()))
			--如果已到指定频数,或两次坐标未发生改变
			if i >= sCount or (wp.x == host.__lastX and wp.y == host.__lastY) then
				AbstractUI.clearScheduler(host,act)

				if completeCallback then
					completeCallback()
				end
			end

			host.__lastX=wp.x
			host.__lastY=wp.y
		end,0.04)
	end
end

return T
