local _print=print
local function print(...)
	_print("\t<Guide>: ",table.concat({...},"\t"))
end

local STEPS={
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_showWoldMap"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_firstFight"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_chapterBattle1"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_produceAircraft"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_dominanceLevelUp"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_chapterBattle2"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_commandCenterLvUp"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_BuildResLoc1"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_BuildResLoc2"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_BuildResLoc3"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_getTaskAward"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_attackResLoc"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_addSpeedTask"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_modifyRoleName"),
	require("src.app.model.beginnersGuide.guideSteps.GuideStep_complete"),
}

--- 新手引导管理器
local T=Class.BeginnersGuideMgr(
	LuaEventDispatcher2
)

--- 事件类型-新手引导完成
T.EVT_TYPE_GUIDE_COMPLETE="evt_type_guide_complete"

--- 设置当前新手引导步骤索引
T.SetGuideStepIndexCommand=require("src.app.communication.beginnersGuide.SetGuideStepIndexCommand")

--- 镂空遮罩
T.GuideHollowMask=require("src.app.uiScript.components.beginnersGuide.GuideHollowMask")

local id=1

--- 触发对象-主界面-基地/世界地图切换按钮
T.TGR_HOMEPAGE_SWITCH_BUTTON=id
id=id+1

--- 触发对象-世界地图页面
T.TGR_WORLD_MAP_VIEW=id
id=id+1

--- 触发对象-世界地图页面,节点信息页面的"攻击"按钮
T.TGR_WORLD_MAP_CELL_INFO_ATTACK_BUTTON=id
id=id+1

--- 触发对象-主界面-关卡按钮
T.TGR_HOMEPAGE_CHATPER_BUTTON=id
id=id+1

--- 触发对象-主界面-任务按钮
T.TGR_HOMEPAGE_TASK_BUTTON=id
id=id+1

--- 触发对象-主界面-行军任务按钮
T.TGR_HOMEPAGE_ARMY_TASK_BUTTON=id
id=id+1

--- 触发对象-行军任务第一项返回按钮
T.TGR_ARMY_TASK_ITEM_1_BACK_BUTTON=id
id=id+1

--- 触发对象-主界面-指挥中心
T.TGR_HOMEPAGE_COMMAND_CENTER=id
id=id+1

--- 触发对象-主界面-机库1
T.TGR_HOMEPAGE_AIRCRAFT_FACTORY_1=id
id=id+1

--- 触发对象-主界面-到资源页面
T.TGR_HOMEPAGE_OUTSIDE=id
id=id+1

--- 触发对象-主界面-玩家头像
T.TGR_HOMEPAGE_PLAYER_PHOTO=id
id=id+1

--- 触发对象-郊外-到主界面
T.TGR_OUTSIDE_HOMEPAGE=id
id=id+1

--- 触发对象-章节1-战役1
T.TGR_CHAPTER_1_BATTLE_1=id
id=id+1

--- 触发对象-章节1-战役2
T.TGR_CHAPTER_1_BATTLE_2=id
id=id+1

--- 触发对象-章节1-战役3
T.TGR_CHAPTER_1_BATTLE_3=id
id=id+1

--- 触发对象-章节1-战役4
T.TGR_CHAPTER_1_BATTLE_4=id
id=id+1

--- 触发对象-章节1-战役5
T.TGR_CHAPTER_1_BATTLE_5=id
id=id+1

--- 触发对象-章节1-战役6
T.TGR_CHAPTER_1_BATTLE_6=id
id=id+1

--- 触发对象-布阵页面"最大战略"按钮
T.TGR_ARMY_SET_MAX_FIGHT_BUTTON=id
id=id+1

--- 触发对象-布阵页面"出战"按钮
T.TGR_ARMY_SET_FIGHT_BUTTON=id
id=id+1

--- 触发对象-战机工厂-战机生产项-展开按钮
T.TGR_AIRCRAFT_PRODUCT_ITEM_1_EXPAND_BUTTON=id
id=id+1

--- 触发对象-战机工厂-战机生产项-"生产"按钮
T.TGR_AIRCRAFT_PRODUCT_ITEM_PRODUCT_BUTTON=id
id=id+1

--- 触发对象-战机工厂-战机生产中项-"加速"按钮
T.TGR_AIRCRAFT_PRODUCTING_ITEM_INCR_BUTTON=id
id=id+1

--- 触发对象-提示框"确定"按钮
T.TGR_MUI_ALTER_CONFIRM_BUTTON=id
id=id+1

--- 触发对象-提示框"取消"按钮
T.TGR_MUI_ALTER_CANCEL_BUTTON=id
id=id+1

--- 触发对象-窗口"关闭"按钮
T.TGR_WINDOW_CLOSE_BUTTON=id
id=id+1

--- 触发对象-"升级指挥"按钮
T.TGR_PLAYER_INFO_LV_UP_DOMINANCE_BUTTON=id
id=id+1

--- 触发对象-升级指挥对话框的"确定"按钮
T.TGR_PLAYER_INFO_LV_UP_DOMINANCE_CONFIRM_BUTTON=id
id=id+1

--- 触发对象-建筑-升级按钮
T.TGR_BUILDING_LV_UP_BUTTON=id
id=id+1

--- 触发对象-郊外-建筑位1
T.TGR_OUTSIDE_BUILD_LOC_1=id
id=id+1

--- 触发对象-郊外-建筑位2
T.TGR_OUTSIDE_BUILD_LOC_2=id
id=id+1

--- 触发对象-郊外-建筑位3
T.TGR_OUTSIDE_BUILD_LOC_3=id
id=id+1

--- 触发对象-郊外-资源建筑建造页面-第1项-展开按钮
T.TGR_OUTSIDE_RES_BUILD_1_EXPLAND_BUTTON=id
id=id+1

--- 触发对象-郊外-资源建筑建造页面-第2项-展开按钮
T.TGR_OUTSIDE_RES_BUILD_2_EXPLAND_BUTTON=id
id=id+1

--- 触发对象-郊外-资源建筑建造页面-第3项-展开按钮
T.TGR_OUTSIDE_RES_BUILD_3_EXPLAND_BUTTON=id
id=id+1

--- 触发对象-郊外-资源建筑建造页面-"建造"按钮
T.TGR_OUTSIDE_RES_BUILD_BUILD_BUTTON=id
id=id+1

--- 触发对象-任务界面-"完成"任务按钮
T.TGR_TASK_WINDOW_FINISH_BUTTON=id
id=id+1

--- 事件-触发UI
T.EVT_TGR_UI=id
id=id+1

--- 事件-切换到世界地图
T.EVT_SWTICH_TO_WORLD_MAP=id
id=id+1

--- 事件-切换到基地
T.EVT_SWTICH_TO_BASE=id
id=id+1

--- 事件-切换到郊外
T.EVT_SWITCH_TO_OUTSIDE=id
id=id+1

--- 事件-打开世界地图节点信息页面
T.EVT_OPEN_WORLD_MAP_CELL_INFO=id
id=id+1

--- 事件-开始攻击新手引导的资源点
T.EVT_ATTACK_GUIDE_WORLD_MAP_RES_LOC=id
id=id+1

--- 事件-打开行军任务界面
T.EVT_OPEN_ARMY_TASK_WINDOW=id
id=id+1

--- 事件-确认行军任务返程界面被打开
T.EVT_OPEN_ARMY_TASK_BACK_CONFIRM_TIP=id
id=id+1

--- 事件-确认行军任务返程界面
T.EVT_CONFIRM_ARMY_TASK_BACK_CONFIRM_TIP=id
id=id+1

--- 事件-进入章节信息页面
T.EVT_ENTER_CAMPAIGN_INFO_WINDOW=id
id=id+1

--- 事件-进入部队阵形设置页面
T.EVT_ENTER_ARMY_TEAM_SET_VIEW=id
id=id+1

--- 事件-获取章节战斗数据完成
T.EVT_GET_CHAPTER_FIGHT_DATA_COMPLETE=id
id=id+1

--- 事件-获取章节战斗数据失败
T.EVT_GET_CHAPTER_FIGHT_DATA_FAIL=id
id=id+1

--- 事件-第一场战斗开始前
T.EVT_FIRST_FIHGT_START_PREV=id
id=id+1

--- 事件-章节战斗完成
T.EVT_CHAPTER_FIGHT_COMPLETE=id
id=id+1

--- 事件-玩家改名完成
T.EVT_PLAYER_NAME_CHANGED=id
id=id+1

--- 事件-飞机生产项第1项被创建
T.EVT_AIRCRAFT_PRODUCT_1_CREATED=id
id=id+1

--- 事件-飞机生产项第1项被展开
T.EVT_AIRCRAFT_PRODUCT_1_EXPLANDED=id
id=id+1

--- 事件-战机生产开始
T.EVT_AIRCRAFT_PRODUCT_STARTED=id
id=id+1

--- 事件-窗口关闭前
T.EVT_WINDOW_CLOSE_PREV=id
id=id+1

--- 事件-窗口打开后
T.EVT_WINDOW_OPEN_AFTER=id
id=id+1

--- 事件-MUIAlter提示框被打开
T.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_OPEN=id
id=id+1

--- 事件-MUIAlter提示框被关闭
T.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_CLOSE=id
id=id+1

--- 事件-指挥升级页面被创建
T.EVT_LV_UP_DOMINANCE_VIEW_CREATED=id
id=id+1

--- 事件-指挥升级完成
T.EVT_LV_UP_DOMINANCE_COMPLETE=id
id=id+1

--- 事件-建筑建造视图被创建
T.EVT_BUILDING_BUILD_VIEW_CREATED=id
id=id+1

--- 事件-建筑建造免费加速完成
T.EVT_BUILDING_BUILD_FREE_ADD_SPEED_COMPLETED=id
id=id+1

--- 事件-资源建筑建筑项被展开
T.EVT_RES_BUILD_ITEM_EXPLAND=id
id=id+1

--- 事件-任务界面主任务项创建完成
T.EVT_TASK_MAIN_CREATED=id
id=id+1

--- 事件-任务完成
T.EVT_TASK_COMPLETED=id
id=id+1

--- 事件-任务奖励显示完成
T.EVT_TASK_AWARD_SHOW_COMPLETED=id
id=id+1

function T:def()
	LuaEventDispatcher2.def(self)

	--- 引导步数
	-- _guideSteps

	--- 当前的引导步骤索引
	self._guideIndex=nil

	--- 上一次保存的步骤索引
	self._lastSaveGuideIndex=0

	--- 设置当前新手引导步骤索引的命令
	-- _setGuideStepIndexCommand

	--- 镂空遮罩
	-- _hollowMask

	--- 引导触发器列表
	-- _guideTriggers

	--- 当前是否处理跳过状态
	self._isSkiping=false
end

function T:ctor()
	LuaEventDispatcher2.ctor(self)

	self._guideSteps=STEPS

	self._guideStepIns={}

	self._guideTriggers={}
end

--- 重置
function T:reset()
	self._guideIndex=nil
	self._lastSaveGuideIndex=0
	self._setGuideStepIndexCommand=nil
	self._guideTriggers={}
	self._isSkiping=false
end

--- 初始化
-- @param guideIndex 当前引导步骤索引
function T:init(guideIndex)
	--只能设置一次,
	--主要是因为断线重连的问题.因为有些步骤是在此步骤的执行中保存的索引,断线重连后索引会被设置到下一步去,
	--所以此时基于索引的所有处理就会出错,会导致当前步骤执行完成后不能进入下一步的bug.
	if self._guideIndex == nil then
		self._guideIndex=guideIndex or 0 --从下一步开始引导
	end
end

--- 是否进行新手引导
function T:isGuide()
	local i=self._guideIndex
	if i ~= nil then
		return self._guideIndex > 0 and self._guideIndex <= #self._guideSteps
	end
	return false
end

--- fire事件
-- @param evt 事件type
-- @param ... 参数
function T:fire(evt,...)
	if self._guideIndex == nil then
		return
	end

	local step=self._guideStepIns[self._guideIndex]
	if step then
		return step:evtHandler(evt,...)
	end
end

--- 开始引导
function T:start()
	if self._guideIndex == nil then
		return
	end

	local curStep=self._guideSteps[self._guideIndex]
	if curStep then
		if self._isSkiping then
			--如果当前步骤允许跳过
			if not curStep.isNotAllowSkip then
				self:next()

				return
			else
				self:complete(true)
			end
		end

		local stepIns=curStep()
		self._guideStepIns[self._guideIndex]=stepIns

		stepIns:start()
	end
end

--- 结束引导
function T:stop()
	self._guideIndex = 0

	self:complete(true)

	--新手引导结束,进行一些清理工作
	self:_releaseHollowMask()

	HomePageManager:setHomeBaseMoveEable(true)
	self:luaDispatchEvent(self.EVT_TYPE_GUIDE_COMPLETE)
end

--- 下一步
function T:next()
	if self._guideIndex == nil then
		return
	end

	local stepIndex=self._guideIndex + 1
	local curStep=self._guideSteps[stepIndex]
	if curStep then
		self._guideIndex=stepIndex

		self:start()
	else
		self:stop()
	end
end

--- 完成当前引导(保存当前引导步骤索引)
-- @param isPrevStep 存储上一步
function T:complete(isPrevStep)
	if self._guideIndex == nil then
		return
	end

	local stepIndex
	if isPrevStep then
		stepIndex=self._guideIndex
	else
		stepIndex=self._guideIndex + 1
	end

	if self._lastSaveGuideIndex == stepIndex then
		return
	end

	print("保存引导索引:"..stepIndex)
	if not self._setGuideStepIndexCommand then
		self._setGuideStepIndexCommand=self.SetGuideStepIndexCommand()
	end

	self._setGuideStepIndexCommand:exec(stepIndex)
	self._lastSaveGuideIndex=stepIndex
end

--- 跳过
function T:skip()
	self._isSkiping=true

	local curStepIns=self._guideStepIns[self._guideIndex]
	if curStepIns then
		curStepIns:skip()
	end

	self:next()
end

--- 创建镂空遮罩对象
function T:_createHollowMask()
	local uiMask=self.GuideHollowMask()
	uiMask:setLocalZOrder(TOP_ORDER + 200)
	uiMask:retain()

	self._hollowMask=uiMask

	return uiMask
end

function T:_releaseHollowMask()
	local uiMask=self._hollowMask
	if uiMask then
		if uiMask:getParent() then
			uiMask:removeFromParent()
		end
		uiMask:releaseAll()
		uiMask:release()
	end
	self._hollowMask=nil
end

--- 显示镂空遮罩
-- @param areas 镂空区域
function T:showHollowMask(areas)
	print("显示镂空遮罩")

	local uiMask=self._hollowMask or self:_createHollowMask()
	if not uiMask:getParent() then
		Director:getRunningScene():addChild(uiMask)
	end

	uiMask:setHollowAreas(areas)
end

--- 隐藏镂空遮罩
function T:hideHollowMask()
	print("隐藏镂空遮罩")

	local uiMask=self._hollowMask
	if uiMask then
		if uiMask:getParent() then
			uiMask:removeFromParent(false)
		end

		uiMask:hideGuideArrow()
	end
end

--- 获取镂空遮罩
function T:getHollowMask()
	return self._hollowMask
end

--- 注册新手引导中需要用到的对象
-- @param name 名称
-- @param triggerObj 按钮
function T:regGuideObj(name,triggerObj)
	self._guideTriggers[name]=triggerObj
end

--- 获取被注册对象
-- @param name 被注册对象名
function T:getRegedObj(name)
	return self._guideTriggers[name]
end

--- 镂空触发对象
-- @param tgrName 对象名
-- @param offsetPts 相对于对象的中心点偏移的 point 集合
-- @param arrowOffset 引导箭头相对于对象中心点的偏移
-- @param arrowCenterOffset 引导箭头中心点偏移
-- @param floatTipText 浮动提示文本
-- @param circleInfo 圆圈信息
function T:hollowTrigger(tgrName,offsetPts,arrowOffset,arrowCenterOffset,floatTipText,circleInfo)
	local uiObj=self._guideTriggers[tgrName]
	assert(uiObj,"镂空对象不存在:"..tgrName)

	local uiMask=self._hollowMask or self:_createHollowMask()
	if not uiMask:getParent() then
		Director:getRunningScene():addChild(uiMask)
	end
	uiMask:hollowTriggerObj(uiObj,offsetPts,arrowOffset,arrowCenterOffset,floatTipText,circleInfo)
end

--- 镂空触发对象
-- @param tgrUI 对象
-- @param offsetPts 相对于对象的中心点偏移的 point 集合
-- @param arrowOffset 引导箭头相对于对象中心点的偏移
-- @param arrowCenterOffset 引导箭头中心点偏移
-- @param floatTipText 浮动提示文本
-- @param circleInfo 圆圈信息
function T:hollowTriggerUI(tgrUI,offsetPts,arrowOffset,arrowCenterOffset,floatTipText,circleInfo)
	local uiObj=tgrUI
	assert(uiObj,"镂空对象不存在:"..tostring(tgrUI))

	local uiMask=self._hollowMask or self:_createHollowMask()
	if not uiMask:getParent() then
		Director:getRunningScene():addChild(uiMask)
	end
	uiMask:hollowTriggerObj(uiObj,offsetPts,arrowOffset,arrowCenterOffset,floatTipText,circleInfo)
end

--- 获取当前是否处于跳过步骤中
function T:getIsSkiping()
	return self._isSkiping
end

return T()
