local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-章节战斗抽象类
local T=Class.AbstractGuideStep_chapterBattle(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)

	--- 延迟进入下一步的计时器
	-- nextStepDelay
end

--- 引导进入战斗
function T:guide2Fight(battleSid,team,idUIFightBtn)
	idUIFightBtn=idUIFightBtn or BGMgr.TGR_ARMY_SET_FIGHT_BUTTON

	local evtHdl=self._evtHandlers

	--取得战斗数据成功
	evtHdl[BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_COMPLETE]=function(callback)
		evtHdl[BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_COMPLETE]=nil
		evtHdl[BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_FAIL]=nil

		self:setUITouchState(idUIFightBtn,true)

		BGMgr:complete()

		BGMgr:hideHollowMask()
		self:guideFight()
	end

	--取得战斗数据失败
	evtHdl[BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_FAIL]=function(callback)
		evtHdl[BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_COMPLETE]=nil
		evtHdl[BGMgr.EVT_GET_CHAPTER_FIGHT_DATA_FAIL]=nil

		self:setUITouchState(idUIFightBtn,true)

		--延迟后进入下一步
		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil

			if battleSid then
				self:guide2BattleSetView()
			else
				self:guide2Fight()
			end
		end,0)
	end

	if battleSid then
		--- 进入战斗
		require("src.app.controler.enterFight.EnterChapterFightCommand")(battleSid,team)
		BGMgr:hideHollowMask()
	else
		--触发切换事件-加遮罩,同时禁用切换按钮
		evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
			if triggeredUIName == idUIFightBtn then
				evtHdl[BGMgr.EVT_TGR_UI]=nil

				BGMgr:showHollowMask()

				self:setUITouchState(idUIFightBtn,false)
			end
		end

		BGMgr:hollowTrigger(idUIFightBtn,nil,nil,nil,Language:get("ugG_tip_4"),{x=0,y=0})
	end
end

--- 引导战斗
function T:guideFight()
	local evtHdl=self._evtHandlers

	--战斗完成
	evtHdl[BGMgr.EVT_CHAPTER_FIGHT_COMPLETE]=function(callback)
		if callback then
			callback()
		end

		BGMgr:next()
	end
end

--- 引导设置阵形
function T:guideSetTeam()
	--最大战力按钮
	local idUIMaxFightBtn=BGMgr.TGR_ARMY_SET_MAX_FIGHT_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIMaxFightBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			self:guide2Fight()
		end
	end

	BGMgr:hollowTrigger(idUIMaxFightBtn,nil,nil,nil,Language:get("ugG_tip_3"),{x=0,y=0})
end

--- 获得战斗项按钮
function T:_getBattleButton()
	return BGMgr.TGR_CHAPTER_1_BATTLE_1
end

--- 引导进入战斗1阵形设置页面
function T:guide2BattleSetView()
	--战斗1按钮
	local idUIBattle1Btn=self:_getBattleButton()

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName,battleSid)
		if triggeredUIName == idUIBattle1Btn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIBattle1Btn,false)

			--如果已有阵形,则直接进入战斗
			local team = BattlesInfoMgr:getTeam()
			if team then
				if PlayerInstance:getPlayerEnergy() > 0 then
					evtHdl[BGMgr.EVT_ENTER_ARMY_TEAM_SET_VIEW]=nil

					self:guide2Fight(battleSid,team)

					return true
				end
			end

			return false
		end
	end

	--进入布阵页面
	evtHdl[BGMgr.EVT_ENTER_ARMY_TEAM_SET_VIEW]=function(team)
		evtHdl[BGMgr.EVT_ENTER_ARMY_TEAM_SET_VIEW]=nil

		self:setUITouchState(idUIBattle1Btn,true)

		--如果已有阵形,则直接引导点击"出战"按钮
		if team and #team > 0 then
			self:guide2Fight()
		else
			self:guideSetTeam()
		end
	end

	local offsetPts=MathUtil:getPointsOfCycle(0,0,80,10)
	BGMgr:hollowTrigger(idUIBattle1Btn,offsetPts,nil,nil,Language:get("ugG_tip_2"),{x=0,y=0})
end

--- 引导进入战役1信息界面
function T:guide2Campaign1InfoWindow()
	local idUIEnterChapterBtn=BGMgr.TGR_HOMEPAGE_CHATPER_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIEnterChapterBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIEnterChapterBtn,false)

			--跳过战役列表界面进入战役1信息界面
			self:switchCampaignInfoWindow(1)

			return true
		end
	end

	--进入章节信息页面
	evtHdl[BGMgr.EVT_ENTER_CAMPAIGN_INFO_WINDOW]=function()
		evtHdl[BGMgr.EVT_ENTER_CAMPAIGN_INFO_WINDOW]=nil

		self:setUITouchState(idUIEnterChapterBtn,true)
		HomePageManager:setBottomBarMoveEable(true)

		self:guide2BattleSetView()
	end

	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug1202")),
		callback=function()
			HomePageManager:setBottomBarMoveEable(false)
			self:hollowHomepageChapterButton()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	local curWin=WindowManager:getCurrentWindow()
	if curWin then
		if curWin.__cname == "CampaignInfoWindow" then
			self:guide2BattleSetView()

			return
		else
			while WindowManager:getCurrentWindow() do
				WindowManager:pop()
			end
		end
	end

	self:guide2Campaign1InfoWindow()
end

function T:ship()
	HomePageManager:setBottomBarMoveEable(true)
	self:setUITouchState(BGMgr.TGR_HOMEPAGE_CHATPER_BUTTON,true)

	while WindowManager:getCurrentWindow() do
		WindowManager:pop()
	end

	if self.nextStepDelay then
		Cocos2dxUtils:clearScheduler(self.nextStepDelay)
		self.nextStepDelay=nil
	end
	AbstractGuideStep.skip(self)
end

return T
