local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-建造资源点2
local T=Class.GuideStep_BuildResLoc2(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)

	--- 延迟进入下一步的计时器
	-- nextStepDelay
end

--- 引导建造资源点
function T:guideBuildResLoc()
	--建造按钮
	local idUIBuild=BGMgr.TGR_OUTSIDE_RES_BUILD_BUILD_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIBuild then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIBuild,false)
		end
	end

	--建造成功后会自动关闭窗口
	--窗口关闭
	evtHdl[BGMgr.EVT_WINDOW_CLOSE_PREV]=function()
		BGMgr:hideHollowMask()

		BGMgr:complete()

		BGMgr:next()
	end

	BGMgr:hollowTrigger(idUIBuild,nil,nil,nil,Language:get("ugG_tip_18"),{x=0,y=0})
end

--- 引导展开资源项列表
function T:guideExpendItemList()
	--展开按钮
	local idUIExpendBtn=BGMgr.TGR_OUTSIDE_RES_BUILD_2_EXPLAND_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == BGMgr:getRegedObj(idUIExpendBtn) then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIExpendBtn,false)
		end
	end

	--资源建造项被展开
	evtHdl[BGMgr.EVT_RES_BUILD_ITEM_EXPLAND]=function()
		evtHdl[BGMgr.EVT_RES_BUILD_ITEM_EXPLAND]=nil

		self:setUITouchState(idUIExpendBtn,true)

		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil

			self:guideBuildResLoc()
		end,0.2)
	end

	BGMgr:hollowTrigger(
		idUIExpendBtn,
		{{x=-35,y=6},{x=-18,y=38},{x=18,y=38},{x=35,y=6},{x=18,y=-23},{x=-18,y=-23},},
		nil,
		nil,
		Language:get("ugG_tip_6"),
		{x=0,y=10,scale=0.6}
	)
end

--- 引导点击资源点
function T:guideResLoc()
	local idUIResLoc=BGMgr.TGR_OUTSIDE_BUILD_LOC_2

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == BGMgr:getRegedObj(idUIResLoc) then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIResLoc,false)
		end
	end

	--窗口被打开
	evtHdl[BGMgr.EVT_WINDOW_OPEN_AFTER]=function(clsName)
		if clsName == "ResourceWindow" then
			evtHdl[BGMgr.EVT_WINDOW_OPEN_AFTER]=nil

			HomePageManager:setOutSideMoveEable(true)

			self.resBuildList=WindowManager:getCurrentWindow().listView
			CppCocos2dxUtils:setIsScrollEnabled(self.resBuildList,false)

			self:guideExpendItemList()
		end
	end

	BGMgr:showHollowMask()

	HomePageManager:setOutSideMoveEable(false)
	self:moveObj2center(
		idUIResLoc,
		function()
			BGMgr:hollowTrigger(idUIResLoc,nil,nil,nil,Language:get("ugG_tip_17"),{x=0,y=0})
		end,
		2
	)
end

--- 引导进入郊外
function T:guide2outside()
	local idUIOutsideBtn=BGMgr.TGR_HOMEPAGE_OUTSIDE

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIOutsideBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()
		end
	end

	--切换到郊外
	evtHdl[BGMgr.EVT_SWITCH_TO_OUTSIDE]=function()
		evtHdl[BGMgr.EVT_SWITCH_TO_OUTSIDE]=nil

		HomePageManager:setHomeBaseMoveEable(true)
		HomePageManager:setOutSideMoveEable(false)

		self:guideResLoc()
	end

	HomePageManager:setHomeBaseMoveEable(false)

	self:moveObj2center(
		idUIOutsideBtn,
		function()
			local offsetPts=MathUtil:getPointsOfCycle(8,0,80,10)
			BGMgr:hollowTrigger(
				idUIOutsideBtn,
				offsetPts,
				{x=8,y=60},
				{x=8,y=0},
				Language:get("ugG_tip_16"),
				{x=8,y=0}
			)
		end,
		1
	)
end

--- 显示郊外介绍
function T:showOutsideIntroductionTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug1215")),
		callback=function()
			self:guide2outside()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	BGMgr:showHollowMask()

	while WindowManager:getCurrentWindow() do
		WindowManager:pop()
	end

	---如果未在郊外页面,需要引导进入郊外
	if HomePageManager.viewIndex ~= 2 then
		self:showOutsideIntroductionTip()
	else
		self:guideResLoc()
	end
end

function T:skip()
	HomePageManager:setHomeBaseMoveEable(true)
	HomePageManager:setOutSideMoveEable(true)

	while WindowManager:getCurrentWindow() do
		WindowManager:pop()
	end

	---如果未在郊外页面,需要引导进入郊外
	if HomePageManager.viewIndex ~= 1 then
		HomePageManager:switchViewToBase()
	end

	if self.nextStepDelay then
		Cocos2dxUtils:clearScheduler(self.nextStepDelay)
		self.nextStepDelay=nil
	end
	AbstractGuideStep.skip(self)
end

return T
