local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-加速任务完成
local T=Class.GuideStep_addSpeedTask(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)

	--- 延迟进入下一步的计时器
	-- nextStepDelay
end

--- 引导关闭窗口
function T:guideCloseWindow()
	local evtHdl=self._evtHandlers

	--窗口关闭
	evtHdl[BGMgr.EVT_WINDOW_CLOSE_PREV]=function(windowName)
		print("关闭窗口",windowName)
		if windowName == "ArmyWindow" then
			BGMgr:hideHollowMask()

			BGMgr:next()
		end
	end

	BGMgr:hollowTrigger(BGMgr.TGR_WINDOW_CLOSE_BUTTON,nil,nil,nil,Language:get("ugG_tip_10"),{x=0,y=0,scale=0.8})
end

--- 引导点击返程按钮
function T:guideClickBackButton()
	-- 行军任务返程按钮
	local idArmyBackBtn=BGMgr.TGR_ARMY_TASK_ITEM_1_BACK_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idArmyBackBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idArmyBackBtn,false)
		end
	end

	--进入行军任务页面-解除切换按钮的禁用
	evtHdl[BGMgr.EVT_CONFIRM_ARMY_TASK_BACK_CONFIRM_TIP]=function()
		evtHdl[BGMgr.EVT_CONFIRM_ARMY_TASK_BACK_CONFIRM_TIP]=nil

		self:setUITouchState(idArmyBackBtn,true)

		WorldMapMgr:addGuideBackTask()
		BGMgr:complete()
		
		self:guideCloseWindow()
	end

	BGMgr:hollowTrigger(idArmyBackBtn,nil,nil,nil,Language:get("ug_guide_clickArmyBack"),nil)
end

--- 引导点击"采集任务"按钮
function T:guideClickCollectionTaskBtn()
	-- 主界面行军任务按钮
	local idArmyTaskBtn=BGMgr.TGR_HOMEPAGE_ARMY_TASK_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idArmyTaskBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idArmyTaskBtn,false)
		end
	end

	--进入行军任务页面-解除切换按钮的禁用
	evtHdl[BGMgr.EVT_OPEN_ARMY_TASK_WINDOW]=function()
		evtHdl[BGMgr.EVT_OPEN_ARMY_TASK_WINDOW]=nil

		self:setUITouchState(idArmyTaskBtn,true)

		--延迟后进入下一步
		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil

			self:guideClickBackButton()
		end,0.2)
	end

	BGMgr:hollowTrigger(idArmyTaskBtn,nil,nil,nil,Language:get("ug_guide_tipOpenArmyTaskWindow"),nil)
end

--- 显示引导提示
function T:guideShowTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug_guide_cellectionComplete")),
		callback=function()
			self:guideClickCollectionTaskBtn()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	if not WorldMapMgr.isExtended_guide then
		--- 扩展新手引导的世界地图管理器
		mapping(WorldMapMgr,require("src.app.model.beginnersGuide.guideSteps.WorldMapMgr_guide"))
		WorldMapMgr:generateGuidNode()
	end
	WorldMapMgr:addGuideCollectionTask()

	BGMgr:showHollowMask()

	self:guideShowTip()
end

function T:skip()
	self:setUITouchState(BGMgr.TGR_HOMEPAGE_ARMY_TASK_BUTTON,true)

	if self.nextStepDelay then
		Cocos2dxUtils:clearScheduler(self.nextStepDelay)
		self.nextStepDelay=nil
	end

	AbstractGuideStep.skip(self)
end

return T
