local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-攻打资源点
local T=Class.GuideStep_attackResLoc(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)

	--- 延迟进入下一步的计时器
	-- nextStepDelay
end

--- 引导切换回基地
function T:guide2base()
	-- 主界面切换按钮
	local idSwitchBtn=BGMgr.TGR_HOMEPAGE_SWITCH_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idSwitchBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idSwitchBtn,false)
		end
	end

	--进入基地-解除切换按钮的禁用
	evtHdl[BGMgr.EVT_SWTICH_TO_BASE]=function()
		evtHdl[BGMgr.EVT_SWTICH_TO_BASE]=nil
		
		WorldMapMgr:destoryGuideNode()

		self:setUITouchState(idSwitchBtn,true)

		--延迟后进入下一步
		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil

			BGMgr:hideHollowMask()
			BGMgr:next()
		end,0.2)
	end

	local offsetPts=MathUtil:getPointsOfCycle(0,0,54,20)
	BGMgr:hollowTrigger(idSwitchBtn,offsetPts,nil,nil,Language:get("ug_guide_tip_2_base"),{x=0,y=0,scale=0.65})
end

--- 介绍行军时间
function T:showArmyTaskTimeIntrduction()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug_guide_armyTaskWaitTip")),
		callback=function()
			self:guide2base()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

--- 引导进入战斗
function T:guide2Fight()
	local idUIFightBtn=BGMgr.TGR_ARMY_SET_FIGHT_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIFightBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIFightBtn,false)
		end
	end

	--触发事件-开始攻打资源点
	evtHdl[BGMgr.EVT_ATTACK_GUIDE_WORLD_MAP_RES_LOC]=function()
		BGMgr:showHollowMask()

		self:setUITouchState(idUIFightBtn,true)

		WorldMapMgr:addGuideArmayTask()
		BGMgr:complete()

		self:showArmyTaskTimeIntrduction()
	end

	BGMgr:hollowTrigger(idUIFightBtn,nil,nil,nil,nil,{x=0,y=0})
end

--- 引导设置阵形
function T:guideSetTeam()
	--最大战力按钮
	local idUIMaxFightBtn=BGMgr.TGR_ARMY_SET_MAX_FIGHT_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIMaxFightBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			self:guide2Fight()
		end
	end

	BGMgr:hollowTrigger(idUIMaxFightBtn,nil,nil,nil,Language:get("ugG_tip_3"),{x=0,y=0})
end

--- 引导攻击资源点
function T:guideAttackResLoc()
	-- 世界地图节点信息页面"攻击"按钮
	local idAttackBtn=BGMgr.TGR_WORLD_MAP_CELL_INFO_ATTACK_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idAttackBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idAttackBtn,false)
		end
	end

	--进入布阵页面
	evtHdl[BGMgr.EVT_ENTER_ARMY_TEAM_SET_VIEW]=function(team)
		evtHdl[BGMgr.EVT_ENTER_ARMY_TEAM_SET_VIEW]=nil

		self:setUITouchState(idAttackBtn,true)

		--如果已有阵形,则直接引导点击"出战"按钮
		if team and #team > 0 then
			self:guide2Fight()
		else
			self:guideSetTeam()
		end
	end

	BGMgr:hollowTrigger(idAttackBtn,nil,nil,nil,nil,nil)
end

--- 引导点击引导用的资源点
function T:guideTriggerResLoc()
	local uiMapView=BGMgr:getRegedObj(BGMgr.TGR_WORLD_MAP_VIEW)

	if uiMapView then
		uiMapView:setIsScrollable(false)
		BGMgr:hollowTriggerUI(uiMapView:getMapNode(WorldMapMgr:getGuideNodePosition()),nil,nil,nil,Language:get("ug_guide_resLocTip"),nil)
	end

	local evtHdl=self._evtHandlers

	evtHdl[BGMgr.EVT_OPEN_WORLD_MAP_CELL_INFO]=function()
		uiMapView:setIsScrollable(true)
		BGMgr:showHollowMask()

		self:guideAttackResLoc()
	end
end

--- 引导进入世界地图
function T:guide2World()
	-- 主界面切换按钮
	local idSwitchBtn=BGMgr.TGR_HOMEPAGE_SWITCH_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idSwitchBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idSwitchBtn,false)
		end
	end

	--进入世界地图-解除切换按钮的禁用
	evtHdl[BGMgr.EVT_SWTICH_TO_WORLD_MAP]=function()
		evtHdl[BGMgr.EVT_SWTICH_TO_WORLD_MAP]=nil

		self:setUITouchState(idSwitchBtn,true)

		--延迟后进入下一步
		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil

			self:guideTriggerResLoc()
		end,0.2)
	end

	local offsetPts=MathUtil:getPointsOfCycle(0,0,54,20)
	BGMgr:hollowTrigger(idSwitchBtn,offsetPts,nil,nil,Language:get("ug_guide_tip_2_world"),{x=0,y=0,scale=0.65})
end

--- 显示引导进入世界地图的提示
function T:guide2WorldTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug_guide_resCollectionTip")),
		callback=function()
			self:guide2World()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	--- 扩展新手引导的世界地图管理器
	mapping(WorldMapMgr,require("src.app.model.beginnersGuide.guideSteps.WorldMapMgr_guide"))
	WorldMapMgr:generateGuidNode()

	self:guide2WorldTip()
end

function T:skip()
	if WorldMapMgr.isExtended_guide then
		WorldMapMgr:destoryGuideNode()
	end

	local uiMapView=BGMgr:getRegedObj(BGMgr.TGR_WORLD_MAP_VIEW)
	if uiMapView then
		uiMapView:setIsScrollable(true)
	end

	local index = HomePageManager:getSwitchView()
	self:setUITouchState(BGMgr.TGR_HOMEPAGE_SWITCH_BUTTON,true)

	--如果当前没有在基地,则切加基地
	if index ~= 1 then
		HomePageManager:switchViewToBase()
	end

	if self.nextStepDelay then
		Cocos2dxUtils:clearScheduler(self.nextStepDelay)
		self.nextStepDelay=nil
	end
	AbstractGuideStep.skip(self)
end

return T
