local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-指挥中心升级
local T=Class.GuideStep_commandCenterLvUp(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)
end

--- 引导关闭窗口
function T:guideCloseWindow()
	local evtHdl=self._evtHandlers

	--窗口关闭
	evtHdl[BGMgr.EVT_WINDOW_CLOSE_PREV]=function(clsName)
		if clsName == "BuildingWindow" then
			BGMgr:hideHollowMask()

			BGMgr:next()
		end
	end

	BGMgr:hollowTrigger(BGMgr.TGR_WINDOW_CLOSE_BUTTON,nil,nil,nil,Language:get("ugG_tip_10"),{x=0,y=0,scale=0.8})
end

--- 引导升级指挥中心
function T:guideLvUpCommandCenter()
	--升级按钮
	local idUILvBtn=BGMgr.TGR_BUILDING_LV_UP_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUILvBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUILvBtn,false)
		end
	end

	local lvUpCount=0

	--开始升级
	self.lvUpStartHandler=function()
		lvUpCount=lvUpCount+1
		if lvUpCount == 1 then
			BGMgr:complete()
		end
		BGMgr:hollowTrigger(idUILvBtn,nil,nil,nil,Language:get("ugG_tip_22"),{x=0,y=0})
	end

	--完成升级
	self.lvUpCompleteHandler=function()
		self:setUITouchState(idUILvBtn,true)
	
		if lvUpCount > 3 then
			BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_START_LEVEL_UP, self, self.lvUpStartHandler)
			BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE, self, self.lvUpCompleteHandler)

			self:guideCloseWindow()
		else
			BGMgr:hollowTrigger(idUILvBtn,nil,nil,nil,Language:get("ugG_tip_15"),{x=0,y=0})
		end
	end

	BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_START_LEVEL_UP, self, self.lvUpStartHandler)
	BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE, self, self.lvUpCompleteHandler)

	BGMgr:hollowTrigger(idUILvBtn,nil,nil,nil,Language:get("ugG_tip_15"),{x=0,y=0})
end

--- 引导进入指挥中心页面
function T:guide2CommandCenter()
	local idUICommandCenterBtn=BGMgr.TGR_HOMEPAGE_COMMAND_CENTER

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUICommandCenterBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()
		end
	end

	--指挥中心升级页面被创建
	evtHdl[BGMgr.EVT_BUILDING_BUILD_VIEW_CREATED]=function()
		evtHdl[BGMgr.EVT_BUILDING_BUILD_VIEW_CREATED]=nil

		HomePageManager:setHomeBaseMoveEable(true)

		self:guideLvUpCommandCenter()
	end

	BGMgr:showHollowMask()
	HomePageManager:setHomeBaseMoveEable(false)

	self:moveObj2center(
		idUICommandCenterBtn,
		function()
			local offsetPts=MathUtil:getPointsOfCycle(40,0,90,10)
			BGMgr:hollowTrigger(
				idUICommandCenterBtn,
				offsetPts,
				{x=40,y=80},
				{x=40,y=0},
				Language:get("ugG_tip_14"),
				{x=40,y=0,scale=1.1}
			)
		end,
		1
	)
end

function T:start()
	BGMgr:showHollowMask()

	while WindowManager:getCurrentWindow() do
		WindowManager:pop()
	end

	self:guide2CommandCenter()
end

function T:skip()
	HomePageManager:setHomeBaseMoveEable(true)

	if self.lvUpStartHandler then
		BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_START_LEVEL_UP, self, self.lvUpStartHandler)
	end
	if self.lvUpCompleteHandler then
		BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE, self, self.lvUpCompleteHandler)
	end

	AbstractGuideStep.skip(self)
end

return T
