local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-指挥升级
local T=Class.GuideStep_dominanceLevelUp(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)
end

--- 引导关闭窗口
function T:guideColseWindow()
	local evtHdl=self._evtHandlers

	--窗口关闭
	evtHdl[BGMgr.EVT_WINDOW_CLOSE_PREV]=function(windowName)
		if windowName == "PlayerInfoWindow" then
			BGMgr:hideHollowMask()

			BGMgr:next()
		end
	end

	BGMgr:hollowTrigger(BGMgr.TGR_WINDOW_CLOSE_BUTTON,nil,nil,nil,Language:get("ugG_tip_10"),{x=0,y=0,scale=0.8})
end

--- 引导点击确认升级按钮
function T:guideClickConfirmBtn()
	local idUIConfirmBtn=BGMgr.TGR_PLAYER_INFO_LV_UP_DOMINANCE_CONFIRM_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIConfirmBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:complete()
			BGMgr:showHollowMask()

			self:setUITouchState(idUIConfirmBtn,false)
		end
	end

	--指挥升级完成
	evtHdl[BGMgr.EVT_LV_UP_DOMINANCE_COMPLETE]=function()
		evtHdl[BGMgr.EVT_LV_UP_DOMINANCE_COMPLETE]=nil

		self:guideColseWindow()

		return true
	end

	BGMgr:hollowTrigger(
		idUIConfirmBtn,
		{{x=-58,y=42},{x=58,y=42},{x=58,y=-14},{x=-58,y=-14},},
		nil,
		nil,
		Language:get("ugG_tip_13"),
		{x=0,y=15,scale=0.8}
	)
end

--- 引导点击升级按钮
function T:guideClickDominanceBtn()
	--指挥升级按钮
	local idUILvUpBtn=BGMgr.TGR_PLAYER_INFO_LV_UP_DOMINANCE_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUILvUpBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUILvUpBtn,false)
		end
	end

	--指挥升级页面被创建
	evtHdl[BGMgr.EVT_LV_UP_DOMINANCE_VIEW_CREATED]=function()
		evtHdl[BGMgr.EVT_LV_UP_DOMINANCE_VIEW_CREATED]=nil

		self:setUITouchState(idUILvUpBtn,true)

		self:guideClickConfirmBtn()
	end

	BGMgr:hollowTrigger(
		idUILvUpBtn,
		{{x=-35,y=6},{x=-18,y=38},{x=18,y=38},{x=35,y=6},{x=18,y=-23},{x=-18,y=-23},},
		nil,
		nil,
		Language:get("ugG_tip_12"),
		{x=0,y=10,scale=0.6}
	)
end

--- 显示"指挥"介绍2
function T:showDominanceIntroductionTip2()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug1212")),
		callback=function()
			self:guideClickDominanceBtn()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

--- 引导进入指挥升级页面
function T:guide2dominance()
	local idUIPlayerPhoto=BGMgr.TGR_HOMEPAGE_PLAYER_PHOTO

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIPlayerPhoto then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()
		end
	end

	--玩家信息页面被打开
	evtHdl[BGMgr.EVT_WINDOW_OPEN_AFTER]=function(clsName)
		if clsName == "PlayerInfoWindow" then
			evtHdl[BGMgr.EVT_WINDOW_OPEN_AFTER]=nil

			self:guideClickDominanceBtn()
		end
	end

	BGMgr:hollowTrigger(idUIPlayerPhoto,nil,nil,nil,Language:get("ugG_tip_11"),{x=0,y=0})
end

--- 显示"指挥"介绍1
function T:showDominanceIntroductionTip1()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug1211")),
		callback=function()
			self:guide2dominance()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	self:showDominanceIntroductionTip1()
end

function T:skip()
	AbstractGuideStep.skip(self)
end

return T
