local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

local T=Class.GuideStep_firstFight(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)

	--- 进入第一场战斗的命令
	-- _enterFirstFightCommand
end

--- 引导
function T:guide()
	local evtHdl=self._evtHandlers

	--第一场战斗开始前
	evtHdl[BGMgr.EVT_FIRST_FIHGT_START_PREV]=function(callback)
		BGMgr:hideHollowMask()
		MUIAlter_custom.show({
			info=self.GuideTipBox(Language:get("ug1200")),
			callback=callback
		})
	end

	--第一场战斗结束
	evtHdl[BGMgr.EVT_CHAPTER_FIGHT_COMPLETE]=function(callback)
		self._enterFirstFightCommand=nil

		local __complete=function()
			BGMgr:complete()

			if callback then
				callback()
			end

			BGMgr:next()
		end

		--如果已触发跳过事件,则不显示第一场战斗完成的提示信息
		if BGMgr:getIsSkiping() then
			__complete()
		else
			BGMgr:hideHollowMask()
			MUIAlter_custom.show({
				info=self.GuideTipBox(Language:get("ug1201")),
				callback=__complete,
				beforeCloseCallback=function()
					BGMgr:showHollowMask()
				end
			})
		end
	end

	--进入第一场战斗
	self._enterFirstFightCommand=require("src.app.controler.enterFight.EnterFirstFightCommand")()
end

function T:start()
	self:guide()
end

function T:skip()
	local c=self._enterFirstFightCommand
	if c then
		c:skip()
		self._enterFirstFightCommand=nil
	else
		AbstractGuideStep.skip(self)
	end
end

return T
