local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-领取任务奖励
local T=Class.GuideStep_getTaskAward(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)
end

--- 引导关闭窗口
function T:guideColseWindow()
	local evtHdl=self._evtHandlers

	--窗口关闭
	evtHdl[BGMgr.EVT_WINDOW_CLOSE_PREV]=function()
		evtHdl[BGMgr.EVT_WINDOW_CLOSE_PREV]=nil
	
		BGMgr:hideHollowMask()

		BGMgr:next()
	end

	BGMgr:hollowTrigger(BGMgr.TGR_WINDOW_CLOSE_BUTTON,nil,nil,nil,Language:get("ugG_tip_10"),{x=0,y=0,scale=0.8})
end

--- 引导完成任务
function T:guideCompleteTask()
	--完成任务按钮
	local idUIFinshBtn=BGMgr.TGR_TASK_WINDOW_FINISH_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIFinshBtn then
			BGMgr:showHollowMask()

			self:setUITouchState(idUIFinshBtn,false)
		end
	end

	--完成任务的次数
	local completeCount=0

	local hollowTaskFinishButton=function()
		print("镂空")
	
		BGMgr:hollowTrigger(
			idUIFinshBtn,
			{{x=-58,y=42},{x=58,y=42},{x=58,y=-14},{x=-58,y=-14},},
			{x=0,y=28},
			{x=0,y=-14},
			Language:get("ugG_tip_21"),
			{x=0,y=15,scale=0.8}
		)
	end

	--任务完成
	evtHdl[BGMgr.EVT_TASK_COMPLETED]=function()
		completeCount=completeCount+1
		if completeCount == 1 then
			BGMgr:complete()
		end
		
		self:setUITouchState(idUIFinshBtn,true)
		BGMgr:hideHollowMask()
	end

	--任务奖励窗口被关闭
	evtHdl[BGMgr.EVT_TASK_AWARD_SHOW_COMPLETED]=function()
		if completeCount >= 3 then
			evtHdl[BGMgr.EVT_TGR_UI]=nil
			evtHdl[BGMgr.EVT_TASK_COMPLETED]=nil
			evtHdl[BGMgr.EVT_TASK_AWARD_SHOW_COMPLETED]=nil
		
			self:guideColseWindow()
		else
			hollowTaskFinishButton()
		end
	end

	hollowTaskFinishButton()
end

--- 引导点击"任务"按钮
function T:guideClickTaskBtn()
	local idUITaskBtn=BGMgr.TGR_HOMEPAGE_TASK_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUITaskBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUITaskBtn,false)
		end
	end

	--任务窗口主任务项被创建
	evtHdl[BGMgr.EVT_TASK_MAIN_CREATED]=function()
		evtHdl[BGMgr.EVT_TASK_MAIN_CREATED]=nil

		self:setUITouchState(idUITaskBtn,true)
		self:guideCompleteTask()
	end

	BGMgr:hollowTrigger(idUITaskBtn,nil,nil,nil,Language:get("ugG_tip_20"),{x=0,y=0,scale=0.6})
end

--- 显示引导提示
function T:guideShowTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug1216")),
		callback=function()
			self:guideClickTaskBtn()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	BGMgr:showHollowMask()

	self:guideShowTip()
end

function T:skip()
	self:setUITouchState(BGMgr.TGR_HOMEPAGE_TASK_BUTTON,true)
	
	AbstractGuideStep.skip(self)
end

return T
