local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-生产飞机
local T=Class.GuideStep_produceAircraft(AbstractGuideStep)

function T:def()
	AbstractGuideStep.def(self)

	--- 延迟进入下一步的计时器
	-- nextStepDelay
end

--- 引导关闭窗口
function T:guideCloseWindow()
	local evtHdl=self._evtHandlers

	--窗口关闭
	evtHdl[BGMgr.EVT_WINDOW_CLOSE_PREV]=function(windowName)
		print("关闭窗口",windowName)
		if windowName == "AircraftFactoryWindow" then
			BGMgr:hideHollowMask()

			BGMgr:next()
		end
	end

	BGMgr:hollowTrigger(BGMgr.TGR_WINDOW_CLOSE_BUTTON,nil,nil,nil,Language:get("ugG_tip_10"),{x=0,y=0,scale=0.8})
end

--- 战机生产完成
function T:aircraftProduceCompleteHandler()
	AircraftProduceQueueMgr:luaRemoveEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_PRODUCE_REFRESH,self,self.aircraftProduceCompleteHandler)

	BattlesInfoMgr:setTeam()
	BGMgr:complete()

	local evtHdl=self._evtHandlers

	self:guideCloseWindow()
end

--- 添加战机生产完成侦听
function T:addAircraftProduceComplete()
	AircraftProduceQueueMgr:luaAddEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_PRODUCE_REFRESH,self,self.aircraftProduceCompleteHandler)
end

--- 引导花费钻石进行加速
function T:guideCostDiamondIncr()
	local idUIConfirmBtn=BGMgr.TGR_MUI_ALTER_CONFIRM_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == BGMgr:getRegedObj(idUIConfirmBtn) then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIConfirmBtn,false)
		end
	end

	--MUIAlter提示框被关闭
	evtHdl[BGMgr.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_CLOSE]=function()
		evtHdl[BGMgr.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_CLOSE]=nil

		self:setUITouchState(idUIConfirmBtn,true)
	end

	BGMgr:hollowTrigger(idUIConfirmBtn,nil,nil,nil,Language:get("ugG_tip_9"),{x=0,y=15})
end

--- 引导加速战机生产
function T:guideIncrProduceAircaft()
	--加速按钮
	local idUIIncrBtn=BGMgr.TGR_AIRCRAFT_PRODUCTING_ITEM_INCR_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIIncrBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIIncrBtn,false)
		end
	end

	--加速付费窗口被打开
	evtHdl[BGMgr.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_OPEN]=function()
		evtHdl[BGMgr.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_OPEN]=nil

		self:setUITouchState(idUIIncrBtn,true)

		self:guideCostDiamondIncr()
	end

	BGMgr:hollowTrigger(
		idUIIncrBtn,
		{{x=-62,y=42},{x=50,y=42},{x=68,y=12},{x=50,y=-18},{x=-62,y=-18},},
		nil,
		nil,
		Language:get("ugG_tip_8"),
		{x=0,y=15}
	)
end

--- 显示加速生产介绍
function T:showIncrProduceIntroductionTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug1210")),
		callback=function()
			self:guideIncrProduceAircaft()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

--- 引导生产战机
function T:guideProduceAircraft()
	--生产按钮
	local idUIProduceBtn=BGMgr.TGR_AIRCRAFT_PRODUCT_ITEM_PRODUCT_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIProduceBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIProduceBtn,false)
		end
	end

	--战机生产开始
	evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_STARTED]=function(aircraftSid)
		evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_STARTED]=nil

		--解除生产列表的禁止滚动
		if self.aircraftProduceList then
			CppCocos2dxUtils:setIsScrollEnabled(self.aircraftProduceList,true)
		end
		self.aircraftProduceList=nil

		self:setUITouchState(idUIProduceBtn,true)

		self:addAircraftProduceComplete()
		self:showIncrProduceIntroductionTip()
	end

	BGMgr:hollowTrigger(idUIProduceBtn,nil,nil,nil,Language:get("ugG_tip_7"),{x=0,y=0})
end

--- 引导展开第一项生产项
function T:guideExpendProduceItem1()
	--第一项展开按钮
	local idUIExpandButton1=BGMgr.TGR_AIRCRAFT_PRODUCT_ITEM_1_EXPAND_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIExpandButton1 then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idUIExpandButton1,false)
		end
	end

	--战机生产项第一项被展开
	evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_1_EXPLANDED]=function()
		evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_1_EXPLANDED]=nil

		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil

			self:setUITouchState(idUIExpandButton1,true)

			self:guideProduceAircraft()
		end,0.1)
	end

	BGMgr:hollowTrigger(
		idUIExpandButton1,
		{{x=-35,y=6},{x=-18,y=38},{x=18,y=38},{x=35,y=6},{x=18,y=-23},{x=-18,y=-23},},
		nil,
		nil,
		Language:get("ugG_tip_6"),
		{x=0,y=10,scale=0.6}
	)
end

--- 引导进入飞机工作1
function T:guide2AircraftFactory1()
	--主界面"机库1"建筑
	local idUIAircraftFactory1=BGMgr.TGR_HOMEPAGE_AIRCRAFT_FACTORY_1

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idUIAircraftFactory1 then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			--如果有战机正在生产
			if AircraftProduceQueueMgr:checkPlaneFactoryProduce("one") then
				--战机生产开始
				evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_STARTED]=function(aircraftSid)
					evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_STARTED]=nil

					HomePageManager:setHomeBaseMoveEable(true)

					self:addAircraftProduceComplete()
					self:guideIncrProduceAircaft()
				end

				--切换到第3个分页(战机生产中)
				return 3
			else
				--战机生产项第一项被创建
				evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_1_CREATED]=function(list)
					evtHdl[BGMgr.EVT_AIRCRAFT_PRODUCT_1_CREATED]=nil

					HomePageManager:setHomeBaseMoveEable(true)

					CppCocos2dxUtils:setIsScrollEnabled(list,false)
					self.aircraftProduceList=list

					--延迟后进入下一步
					self.nextStepDelay=Cocos2dxUtils:timeOut(function()
						self.nextStepDelay=nil

						self:guideExpendProduceItem1()
					end,0)
				end

				--切换到第2个分页(战机生产)
				return 2
			end
		end
	end

	HomePageManager:setHomeBaseMoveEable(false)

	BGMgr:showHollowMask()
	self:moveObj2center(
		idUIAircraftFactory1,
		function()
			local offsetPts=MathUtil:getPointsOfCycle(20,0,80,20)
			BGMgr:hollowTrigger(
				idUIAircraftFactory1,
				offsetPts,
				{x=20,y=80},
				{x=20,y=0},
				Language:get("ugG_tip_5"),
				{x=20,y=0}
			)
		end,
		1
	)
end

--- 显示机库介绍
function T:showAircraftFactoryIntroductionTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug1209")),
		callback=function()
			self:guide2AircraftFactory1()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	BGMgr:showHollowMask()

	while WindowManager:getCurrentWindow() do
		WindowManager:pop()
	end

	self:showAircraftFactoryIntroductionTip()
end

function T:skip()
	HomePageManager:setHomeBaseMoveEable(true)
	while WindowManager:getCurrentWindow() do
		WindowManager:pop()
	end

	if self.aircraftProduceList then
		CppCocos2dxUtils:setIsScrollEnabled(self.aircraftProduceList,true)
		self.aircraftProduceList=nil
	end

	if self.nextStepDelay then
		Cocos2dxUtils:clearScheduler(self.nextStepDelay)
		self.nextStepDelay=nil
	end
	AbstractGuideStep.skip(self)
end

return T
