local AbstractGuideStep=require("src.app.model.beginnersGuide.AbstractGuideStep")

--- 新手引导-展示世界地图
local T=Class.GuideStep_showWoldMap(AbstractGuideStep)

--- 主界面切换按钮
local idSwitchBtn

function T:def()
	AbstractGuideStep.def(self)
	
	--- 延迟进入下一步的计时器
	-- nextStepDelay
end

--- 引导切换回基地
function T:guide2base()
	-- 主界面切换按钮
	local idSwitchBtn=BGMgr.TGR_HOMEPAGE_SWITCH_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idSwitchBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idSwitchBtn,false)
		end
	end

	--进入基地-解除切换按钮的禁用
	evtHdl[BGMgr.EVT_SWTICH_TO_BASE]=function()
		evtHdl[BGMgr.EVT_SWTICH_TO_BASE]=nil

		self:setUITouchState(idSwitchBtn,true)

		--延迟后进入下一步
		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil
		
			BGMgr:hideHollowMask()
			BGMgr:next()
		end,0.2)
	end

	local offsetPts=MathUtil:getPointsOfCycle(0,0,54,20)
	BGMgr:hollowTrigger(idSwitchBtn,offsetPts,nil,nil,Language:get("ug_guide_tip_2_base"),{x=0,y=0,scale=0.65})
end

--- 显示世界地图介绍提示框
function T:showWorldIntroductionTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug_guide_2_base")),
		callback=function()
			self:guide2base()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

--- 引导进入世界地图
function T:guide2World()
	-- 主界面切换按钮
	local idSwitchBtn=BGMgr.TGR_HOMEPAGE_SWITCH_BUTTON

	local evtHdl=self._evtHandlers

	--触发切换事件-加遮罩,同时禁用切换按钮
	evtHdl[BGMgr.EVT_TGR_UI]=function(triggeredUIName)
		if triggeredUIName == idSwitchBtn then
			evtHdl[BGMgr.EVT_TGR_UI]=nil

			BGMgr:showHollowMask()

			self:setUITouchState(idSwitchBtn,false)
		end
	end

	--进入世界地图-解除切换按钮的禁用
	evtHdl[BGMgr.EVT_SWTICH_TO_WORLD_MAP]=function()
		evtHdl[BGMgr.EVT_SWTICH_TO_WORLD_MAP]=nil

		self:setUITouchState(idSwitchBtn,true)

		BGMgr:complete()

		--延迟后进入下一步
		self.nextStepDelay=Cocos2dxUtils:timeOut(function()
			self.nextStepDelay=nil
		
			self:showWorldIntroductionTip()
		end,0.2)
	end

	local offsetPts=MathUtil:getPointsOfCycle(0,0,54,20)
	BGMgr:hollowTrigger(idSwitchBtn,offsetPts,nil,nil,Language:get("ug_guide_tip_2_world"),{x=0,y=0,scale=0.65})
end

--- 显示引导进入世界地图的提示
function T:guide2WorldTip()
	BGMgr:hideHollowMask()
	MUIAlter_custom.show({
		info=self.GuideTipBox(Language:get("ug_guide_2_world")),
		callback=function()
			self:guide2World()
		end,
		beforeCloseCallback=function()
			BGMgr:showHollowMask()
		end
	})
end

function T:start()
	self:guide2WorldTip()
end

function T:skip()
	local index = HomePageManager:getSwitchView()
	self:setUITouchState(BGMgr.TGR_HOMEPAGE_SWITCH_BUTTON,true)

	--如果当前没有在基地,则切加基地
	if index ~= 1 then
		HomePageManager:switchViewToBase()
	end

    if self.nextStepDelay then
		Cocos2dxUtils:clearScheduler(self.nextStepDelay)
		self.nextStepDelay=nil
	end
	AbstractGuideStep.skip(self)
end

return T
