local T={}

--- 是否已扩展到 WorldMapMgr 中
T.isExtended_guide=true

--- 任务队列ID
T.ARMY_QUEUE_ITEM_ID=-1

--- 引导节点坐标-x
-- _guideNodeX

--- 引导节点坐标-y
-- _guideNodeY

--- 引导节点的原信息
-- _guideNodeOriginalInfo

--- 存储设置节点信息的函数
T._setNodeData=WorldMapMgr.setNodeData

--- 设置地图节点信息
function T:setNodeData(x,y,nodeInfo)
	if BGMgr:isGuide() and x == self._guideNodeX and y == self._guideNodeY then
		self._guideNodeOriginalInfo=nodeInfo
		return
	end

	self:_setNodeData(x,y,nodeInfo)
end

--- 生成引导节点
function T:generateGuidNode()
	local MapNodeResLocType=require("src.app.model.WorldMap.MapNodeResLocType")

	local guideNInfo=require("src.app.model.WorldMap.NodeInfoResLoc")()
	guideNInfo.resType=MapNodeResLocType.RES_STEEL
	guideNInfo.lvl=2

	local x, y = PlayerInstance:getWorldPosition()

	local offsetX,offsetY=0,0
	if x + 1 >= WorldMapMgr.GRID_COL_NUM then
		offsetX=-1
	else
		offsetX = 1
	end
	if y + 1 >= WorldMapMgr.GRID_ROW_NUM then
		offsetY=-1
	else
		offsetY=1
	end

	guideNInfo.x,guideNInfo.y=x+offsetX,y+offsetY
	self._guideNodeX,self._guideNodeY=guideNInfo.x,guideNInfo.y

	self:_setNodeData(self._guideNodeX,self._guideNodeY,guideNInfo)
end

--- 摧毁引导节点
function T:destoryGuideNode()
	self:_setNodeData(self._guideNodeX,self._guideNodeY,self._guideNodeOriginalInfo)
	self._guideNodeX,self._guideNodeY=nil,nil

	self.getNodeData=self._getNodeData
end

--- 获取引导节点的坐标
-- @return x,y
function T:getGuideNodePosition()
	return self._guideNodeX,self._guideNodeY
end

--- 添加引导行军任务
function T:addGuideArmayTask()
	local qInfo = mapping({}, require("src.app.model.army.armyTask.ArmyTaskQueueItem"))
	qInfo.id=self.ARMY_QUEUE_ITEM_ID
	qInfo.endTimeSec=TimeUtils:getSyncMillis()/1000+2
	qInfo.sourceId=UserInfo.id
	qInfo.targetId=0
	qInfo.targetName="新手引导资源点"
	qInfo.status=1 --出征
	qInfo.posX,qInfo.posY=WorldMapMgr:getGuideNodePosition()
	qInfo.movingCost=2
	qInfo.resourceEfficiency=0
	qInfo.armyExpeditionAircrafts={}
	qInfo.remainingSec=qInfo.movingCost

	ArmyTaskQueueManager:addItem2(qInfo)

	Cocos2dxUtils:timeOut(function()
		self:addGuideCollectionTask()
	end,2)
end

--- 添加引导采集任务
function T:addGuideCollectionTask()
	local queueId=self.ARMY_QUEUE_ITEM_ID

	local qInfo=ArmyTaskQueueManager.queueInfos[queueId]
	if not qInfo then
		qInfo = mapping({}, require("src.app.model.army.armyTask.ArmyTaskQueueItem"))
		qInfo.id=self.ARMY_QUEUE_ITEM_ID
		qInfo.sourceId=UserInfo.id
		qInfo.targetId=0
		qInfo.targetName="新手引导资源点"
		qInfo.posX,qInfo.posY=WorldMapMgr:getGuideNodePosition()
		qInfo.resourceEfficiency=0
		qInfo.armyExpeditionAircrafts={}

		ArmyTaskQueueManager:addItem2(qInfo)
	end
	qInfo.status=2 --采集
	qInfo.endTimeSec=TimeUtils:getSyncMillis()/1000
	qInfo.movingCost=0
	qInfo.remainingSec=qInfo.movingCost

	-- 加速进攻完成
	ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BATTLE_OVER .. queueId,qInfo)
	ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BATTLE_OVER,qInfo)
	ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_HOMEPAGE_RIGHT_BAR)

	ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_STATION_REMAIN_TIME .. queueId,qInfo)
end

--- 添加返程任务
function T:addGuideBackTask()
	local queueId=self.ARMY_QUEUE_ITEM_ID

	local qInfo=ArmyTaskQueueManager.queueInfos[queueId]
	if qInfo then
		qInfo.status=3 --返程
		qInfo.endTimeSec=TimeUtils:getSyncMillis()/1000 + 2
		qInfo.movingCost=2
		qInfo.remainingSec=qInfo.movingCost

		ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BATTLE_OVER,qInfo)
		ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_START_BACK_REFRESH,qInfo)
		ArmyTaskQueueManager:luaDispatchEvent(ArmyTaskQueueManager.EVT_BACK_REMAIN_TIME .. queueId,qInfo)
	end
end

return T
