--[[
    聊天盒子
]]
local T=extend(LuaEventDispatcher)

--- 聊天信息
T.ChatInfo = require "src.app.model.chat.ChatInfo"

--- 世界聊天队列
T.chatWorldInfosQueue = Queue()

--- 移除的世界聊天的长度
T.removeChatWorldInfosLength = nil

--- 新添加的世界聊天队列
T.addChatWorldInfosQueue = Queue()

function T:decodeWorld(data)
    self.removeChatWorldInfosLength = nil
    self.addChatWorldInfosQueue:clearT()

    local len = data:readUnsignedByte()
    local chatInfos = {}
    local num = #chatInfos
	for i= 1,len,1 do
		local chatInfo = mapping({}, T.ChatInfo)
		chatInfo:decode(data)
		chatInfos[i] = chatInfo
	end

    table.sort(chatInfos,function(x,y) return x.id < y.id end)

    local length = self.chatWorldInfosQueue:getLength()
    if length == 0 then
        local num = #chatInfos
        for i = 1,num,1 do
            self.chatWorldInfosQueue:push(chatInfos[i])
        end
    else-- 判断id是否重复,因为有可能chatWorldInfosQueue有数据
        -- 如果重复则从数组中移除
        local judge = false
        for k,v in pairs(chatInfos) do
            if v then
                for i = 1,length,1 do
                    local info = self.chatWorldInfosQueue:look(i)
                    if v.id == info.id then
                        chatInfos[k] = nil
                        judge = true
                        break
                    end

                end
            end
        end
                    
        if judge == true then
            local temp = {}
            for k,v in pairs(chatInfos) do
                if v then
                    temp[#temp + 1] = v
                end

            end

            table.sort(temp,function(x,y) return x.id < y.id end)
            local num = #temp
            for i = 1,num,1 do
                
                self.chatWorldInfosQueue:push(temp[i])
            end

        else -- 有可能有断裂层
            table.sort(chatInfos,function(x,y) return x.id < y.id end)
            if self.chatWorldInfosQueue:look(length).id + 1 == chatInfos[1].id then -- 刚好连续
                local num = #chatInfos
                for i = 1,num,1 do
                    self.chatWorldInfosQueue:push(chatInfos[i])
                end
            else -- 把以前的数据清空，然后最新的15条加上
                self.chatWorldInfosQueue:clearT()
                local num = #chatInfos
                for i = 1,num,1 do
                    self.chatWorldInfosQueue:push(chatInfos[i])
                end
            end

        end
    end

    --- 处理断线重连的时候:最多50条
    local length = self.chatWorldInfosQueue:getLength()
	if length > 50 then
		-- 最多循环加入的长度那么多
		local num = 0
		for i = 1,len,1 do
			num = num + 1
			self.chatWorldInfosQueue:pop()
			local newLength = self.chatWorldInfosQueue:getLength()
			if newLength == 50 then
				break
			end
		end
	end

    -- 由于是异步，所以派发给主界面
    ChatManager:luaDispatchEvent(ChatManager.EVT_TYPE_GET_WORLD_QUEUE_CHAT)

end

return T