--- 管理
local T = Class.ChatManager(LuaEventDispatcher2)

--- 事件-刷新世界聊天
T.EVT_TYPE_UPDATE_WORLD_CHAT = "evt_type_update_world_chat"

--- 事件-第一次获得登陆的世界聊天信息的时候派发事件，然后给主界面显示
T.EVT_TYPE_GET_WORLD_QUEUE_CHAT = "evt_type_get_world_queue_chat"

--- 事件-刷新私人聊天
T.EVT_TYPE_UPDATE_PRIVATE_CHAT = "evt_type_update_private_chat"

--- 聊天信息
T.ChatBox = require "src.app.model.chat.ChatBox"

function T:def()
	LuaEventDispatcher2.def(self)

	self.chatBox = mapping({}, T.ChatBox)

	--- 军团的聊天信息队列
	self.chatGroupInfosQueue = Queue()

	--- 移除的军团聊天的长度
	self.removeChatGroupInfosLength = nil

	--- 新添加的军团聊天队列
	self.addChatGroupInfosQueue = Queue()

	--- 事件-刷新军团聊天
	self.EVT_TYPE_UPDATE_GROUP_CHAT = "evt_type_update_group_chat"


	--- 私人的聊天信息队列
	self.chatPrivateInfosQueue = Queue()

	--- 移除的私人聊天的长度
	self.removeChatPrivateInfosLength = nil

	--- 新添加的私人聊天队列
	self.addChatPrivateInfosQueue = Queue()
end


function T:clearAllChatData()
    local chatBox = self.chatBox
    chatBox.chatWorldInfosQueue:clearT()
    chatBox.removeChatWorldInfosLength = nil
    chatBox.addChatWorldInfosQueue:clearT()

    self.chatGroupInfosQueue:clearT()
    self.removeChatGroupInfosLength = nil
    self.addChatGroupInfosQueue:clearT()

    self.chatPrivateInfosQueue:clearT()
    self.removeChatPrivateInfosLength = nil
    self.addChatPrivateInfosQueue:clearT()


end


return T
