--Author    : YuDing
--Date      : 2015/4/21
--Introduce : 日常任务 盒子

local T={}

--- 普通 刷新时间
T.normalTime = nil

--- 军团 刷新时间
T.allianceTime = nil

--- vip 刷新时间
T.vipTime = nil

--- 任务
T.taskInfos = nil

--- 反序列化
function T:decode(data)
	self.taskInfos = self.taskInfos or {}

	self.normalTime = GameUtils:modifyTimeZone(data:readUnsignedInt())
	self.allianceTime = GameUtils:modifyTimeZone(data:readUnsignedInt())
	self.vipTime = GameUtils:modifyTimeZone(data:readUnsignedInt())

	-- 任务
	local infos = {}
	local len = data:readUnsignedByte()

	for i = 1, len do
		local sid = data:readUnsignedShort()
		local endTime = data:readUnsignedInt()
		endTime = endTime ~= 0 and GameUtils:modifyTimeZone(endTime) or 0
		infos[sid] = endTime
	end

	self.taskInfos = infos
end

--- 获取普通任务
function T:getNormalTask()
	if not self.taskInfos then
		return {}
	end

	local tb = {}
	for k, v in pairs(self.taskInfos) do
		if DailyTaskData[k].taskType == 0 then
			table.insert(tb, {k, v})
		end
	end
	if #tb > 1 then
		table.sort(tb, function(x, y) return x[1] < y[1] end)
	end

	return tb
end

--- 设置时间
function T:setTaskTime(sid, time)
	self.taskInfos[sid] = time
end

function T:getTaskTime(sid)
	return self.taskInfos[sid]
end

function T:getNormalTime()
	return self.normalTime or 0
end

function T:getAllianceTime()
	return self.allianceTime or 0
end

--- 删除任务
function T:removeTask(sid)
	self.taskInfos[sid] = nil  -- 删除当前任务
end

--- 获取军团任务
function T:getAllianceTask()
	local tb = {}
	if self.taskInfos then
		for k, v in pairs(self.taskInfos) do
			if DailyTaskData[k].taskType == 1 then
				table.insert(tb, {k, v})
			end
		end
		if #tb > 1 then
			table.sort(tb, function(x, y) return x[1] < y[1] end)
		end
	end

	return tb
end

function T:getInfos()
	return self.taskInfos
end


return T
