--[[
    阵型设置信息
]]
local T = Class.FormationInfo(LuaEventDispatcher2)

function T:def()
    LuaEventDispatcher2.def(self)
    self.aircrafts = nil
    self.id = nil  -- id是从0到3
    self.isDefault = false  -- 是否是默认阵型，false:不是默认，true:是默认阵型
end

function T:decode(data)
    local isHasFormation = data:readBoolean()
    if isHasFormation == false then -- 空的阵容不保存
    else
        local aircraft = {}
        for i = 1,6,1 do  -- 1到6是位置
            local modelAircraft = {}
            modelAircraft.sid = data:readUnsignedShort()
            if modelAircraft.sid <= 0 then
                modelAircraft.count = 0
            else
                modelAircraft.count = data:readUnsignedShort()
            end
            aircraft[i] = modelAircraft
        end
        self.aircrafts = aircraft

    end

end

--- 设置飞机的阵型
function T:setFormation(aircrafts)
    self.aircrafts = aircrafts

    FormationManager.formationBox:luaDispatchEvent(FormationManager.formationBox.EVT_SET_FORMATION_REFRESH)
    FormationManager.formationBox:luaDispatchEvent(FormationManager.formationBox.EVT_SET_FORMATION_REFRESH .. self.id)

end


--- 使用阵型
function T:useFormation()
    FormationManager.formationBox:luaDispatchEvent(FormationManager.formationBox.EVT_USE_FORMATION_REFRESH,self.aircrafts)
end



return T