--[[
    荣誉管理
]]
local T = Class.HonorManager(LuaEventDispatcher2)

--- 事件-军衔-改变
T.EVT_TYPE_MILITARYRANK_REFRESH = "evt_type_militaryrank_refresh"

--- 事件-高级指挥-改变
T.EVT_TYPE_SENIORDLEVEL_REFRESH = "evt_type_seniordlevel_refresh"

--- 事件-荣誉-改变
T.EVT_TYPE_HONOR_REFRESH = "evt_type_honor_refresh"

--- 事件-复仇-改变
T.EVT_TYPE_REVENGE_REFRESH = "evt_type_revenge_refresh"


function T:def()
    LuaEventDispatcher2.def(self)

end


--- 得到军衔值
function T:getMilitaryRank()
    return UserInfo.city.militaryRank or 0
end

--- 设置军衔值
function T:setMilitaryRank(value)
    UserInfo.city.militaryRank = value
    self:luaDispatchEvent(self.EVT_TYPE_MILITARYRANK_REFRESH)
end

--- 得到高级指挥
function T:getSeniorDLevel()
    return UserInfo.city.seniorDLevel or 0
end

--- 设置高级指挥
function T:setSeniorDLevel(value)
    UserInfo.city.seniorDLevel = value
    self:luaDispatchEvent(self.EVT_TYPE_SENIORDLEVEL_REFRESH)
    PlayerInstance:setPlayerFightLogic()

end

--- 得到荣誉
function T:getHonor()
    return UserInfo.city.honor or 0
end

--- 设置荣誉
function T:setHonor(value)
    UserInfo.city.honor = value
    self:luaDispatchEvent(self.EVT_TYPE_HONOR_REFRESH)
end

--- 得到复仇
function T:getRevenge()
    return UserInfo.city.revenge or 0
end

--- 设置复仇
function T:setRevenge(value)
    UserInfo.city.revenge = value
    self:luaDispatchEvent(self.EVT_TYPE_REVENGE_REFRESH)
end


--- 得到军衔的名字
function T:getMilitaryRankName(value)
    if value == 0 then
        return "uc983"
    else
        return MilitaryRank_temp[value].name
    end


end

--- 得到高级指挥的带兵量
function T:getAddSoliders()
    return SeniorDLevel_temp[self:getSeniorDLevel()].addSoldiers

end

--- 得到军衔图标的左右距离,当大小为0.8的时候
function T:getShowMilitaryOffset(id,scale)
    local scale = scale or 1
    if id == 1 or id == 2 or id == 3 then
        return 150 * 0.6 * scale
    elseif id == 4 or id == 5 or id == 6 then
        return 160 * 0.6 * scale
    elseif id == 7 or id == 8 or id == 9 then
        return 175 * 0.6 * scale
    elseif id == 10 or id == 11 or id == 12 then
        return 185 * 0.6 * scale
    elseif id == 13 then
        return 195 * 0.6 * scale
    else
        return 205 * 0.6 * scale
    end


end



function T:getShowLeftMilitaryOffset(id,scale)
    return 200 * 0.6 * scale - self:getShowMilitaryOffset(id,scale) -- 200是图片的大小

end


return T