local AbstractIAPMgr=require("src.app.model.iap.AbstractIAPMgr")

local T=Class.IAPMgr_android_1(AbstractIAPMgr)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

function T:def()
	AbstractIAPMgr.def(self)

	--- 当前正在购买的商品ID
	-- _productData

	--- 内购端口号
	-- iapPort

	--- 购买信息验证地址
	-- verifyUrl
end

function T:ctor()
	AbstractIAPMgr.ctor(self)
end

--- 商品编号
function T:pay(productData)

end

--- google支付
-- @param productData 商品数据
function T:pay(productData)
	self._productData=productData

	self._isPaying=true

	--	SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_PAY_SUCCESS,self,self.handlePayComplete)

	local cData=NetManager:getConnectData()
	local serverInfo = ServerListMgr:getServerData(cData.serverId)
	local ip = serverInfo.ip
	local port = serverInfo.port

	if self._productData then
		local data=productData

		local iapData=data.iapData
		local callbackInfo=string.format("%s:%s|%s|%s",ip,self.iapPort,UserInfo.id,data.productId)
		local callbackUrl=string.format("http://%s:%s%s",ip,self.iapPort,self.verifyUrl)
		SDK_Delegate:pay(Language:get("ug_payName",data.gems), iapData.price, 1, data.gems, callbackInfo,callbackUrl,data.productId)
	end
end

----- 支付完成
--function T:handlePayComplete()
--	SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_PAY_SUCCESS,self,self.handlePayComplete)
--
--	local data = self._productData
--	if data then
--		local pId=data.productId
--		GoodsManager:setThreeMarkValue(pId)
--		NewPackageManager:setIsBuy(pId)
--		ActivityManager.firstRechargeInfo:setValue() -- 只要充值了就算首冲
--	else
--
--	end
--
--	if self._isPaying then
--	--		self:addMask()
--	end
--end

--- 验证支付完成
function T:verifyPayComplete(award)
	if self._isPaying then
		self._isPaying=false

		--		self:rmvMask()
	end

	local data = self._productData
	if data then
		local pId=data.productId
		GoodsManager:setThreeMarkValue(pId)
		NewPackageManager:setIsBuy(pId)
		ActivityManager.firstRechargeInfo:setValue() -- 只要充值了就算首冲
	else

	end

	if award then
		local AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")
		AwardDataDecoder:addAWard(award)

		AwardDataDecoder:showSuccessWindow(award)
	end

	self:luaDispatchEvent(self.EVT_TYPE_PAY_SUCCESS)
end

--- 设置内购端口号
function T:setIapPort(value)
	self.iapPort=value
end
--- 获取内购端口号
function T:getIapPort()
	return self.iapPort
end

--- 设置购买信息验证地址
function T:setVerifyUrl(value)
	self.verifyUrl=value
end
--- 获取购买信息验证地址
function T:getVerifyUrl()
	return self.verifyUrl
end

return T()
