local AbstractIAPMgr=require("src.app.model.iap.AbstractIAPMgr")

local T=Class.IAPMgr_android_enjoyGame(AbstractIAPMgr)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

function T:def()
	AbstractIAPMgr.def(self)

	--- 当前正在购买的商品ID
	-- _productData

	--- 当前支付订单编号
	-- _orderId

	--- 内购端口号
	-- iapPort
end

function T:ctor()
	AbstractIAPMgr.ctor(self)
end

--- 商品编号
function T:pay(productData)

end

--- google支付
-- @param productData 商品数据
function T:pay(productData)
	self._productData=productData
	self._orderId=tostring(DataStorage:getIapOrderId())

	self._isPaying=true

	SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_PAY_SUCCESS,self,self.handlePayComplete)

	local cData=NetManager:getConnectData()
	local serverInfo = ServerListMgr:getServerData(cData.serverId)
	local ip = serverInfo.ip
	local port = serverInfo.port

	if self._productData then
		local data=productData

		SDK_Delegate:doPayGG(data.productId,ip..":"..self.iapPort.."|"..UserInfo.id)

		local iapData=data.iapData

		SDK_Delegate:traking_startPay(self._orderId, data.productId, iapData.price, "USD", data.gems, "enjoy game & Google")
	else
		SDK_Delegate:doPay(UserInfo.id,ip..":"..self.iapPort.."|"..UserInfo.id)
	end
end

--- 第三方支付
function T:payOther()
	self:pay()
end

--- 支付完成
function T:handlePayComplete()
	SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_PAY_SUCCESS,self,self.handlePayComplete)

	local data = self._productData
	if data then
		local pId=data.productId
		GoodsManager:setThreeMarkValue(pId)
		NewPackageManager:setIsBuy(pId)
		ActivityManager.firstRechargeInfo:setValue() -- 只要充值了就算首冲

		local iapData=data.iapData
		SDK_Delegate:traking_paySuccess(self._orderId, data.productId, iapData.price, "USD", data.gems, "enjoy game & Google")
	else

	end

	if self._isPaying then
	--		self:addMask()
	end
end

--- 第三方支付完成
-- @param costUSD 花费的美金数量
-- @param getedGems 获得的钻石数量
function T:handleThiredPayComplete(costUSD,getedGems)
	SDK_Delegate:traking_startPay(	self._orderId, 	"any", 	costUSD, 	"USD", 	getedGems, 	"enjoy game & Third party")
	SDK_Delegate:traking_paySuccess(	self._orderId,	"any",	costUSD,	"USD",	getedGems, 	"enjoy game & Third party")
end

--- 验证支付完成
function T:verifyPayComplete(award)
	if self._isPaying then
		self._isPaying=false

		--		self:rmvMask()
	end

	if award then
		local AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")
		AwardDataDecoder:addAWard(award)

		AwardDataDecoder:showSuccessWindow(award)
	end

	self:luaDispatchEvent(self.EVT_TYPE_PAY_SUCCESS)
end

--- 设置内购端口号
function T:setIapPort(value)
	self.iapPort=value
end

--- 获取内购端口号
function T:getIapPort()
	return self.iapPort
end

return T()
