local AbstractIAPMgr=require("src.app.model.iap.AbstractIAPMgr")

local T=Class.IAPMgr_ios(AbstractIAPMgr)

function T:def()
	AbstractIAPMgr.def(self)
end

function T:ctor()
	AbstractIAPMgr.ctor(self)
end

--- 商品编号
function T:pay(productData)
	self._isPaying=true

	CommonBroadcast:luaAddEventListener(EVENT_IAP_BUY_GOODS_COMPLETE,self,self.handlePayComplete)
	CommonBroadcast:luaAddEventListener(EVENT_IAP_BUY_NEW_RECHARGE_COMPLETE,self,self.handlePayComplete)

	self:addMask()
	Command:payIapGoods(productData.productId,1)
end

--- 支付完成
function T:handlePayComplete()
	CommonBroadcast:luaRemoveEventListener(EVENT_IAP_BUY_GOODS_COMPLETE,self,self.handlePayComplete)
	CommonBroadcast:luaRemoveEventListener(EVENT_IAP_BUY_NEW_RECHARGE_COMPLETE,self,self.handlePayComplete)
	
	self:rmvMask()
end

--- 验证支付完成
function T:verifyPayComplete(award)
	if award then
		local AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")
		AwardDataDecoder:addAWard(award)

        AwardDataDecoder:showSuccessWindow(award)
	end

    ActivityManager.firstRechargeInfo:setValue() -- 只要充值了就算首冲

	self:luaDispatchEvent(self.EVT_TYPE_PAY_SUCCESS)
end

return T()
