local AbstractIAPMgr=require("src.app.model.iap.AbstractIAPMgr")

local T=Class.IAPMgr_android_enjoyGame(AbstractIAPMgr)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

--- 支付平台-无(即默认支付平台)
T.PAY_PLATFORM_NONE=0

--- 支付平台-第三方支付
T.PAY_PLATFORM_OTHER=1

function T:def()
	AbstractIAPMgr.def(self)

	--- 支付平台
	self._payPlatform=self.PAY_PLATFORM_NONE

	--- 当前正在购买的商品ID
	-- _productData
end

function T:ctor()
	AbstractIAPMgr.ctor(self)
end

--- 商品编号
function T:pay(productData)
	self._productData=productData
	self._isPaying=true

	--	SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_PAY_SUCCESS,self,self.handlePayComplete)

	local cData=NetManager:getConnectData()
	local serverInfo = ServerListMgr:getServerData(cData.serverId)
	local ip = serverInfo.ip
	local port = serverInfo.port

	local pData=self._productData
	local iapData=pData.iapData
	if self._payPlatform == self.PAY_PLATFORM_OTHER then
		SDK_Delegate:doWebPay(
			pData.productId,
			UserInfo.id,
			1,
			pData.sid,
			Language:get("uc477",pData.gems),
			1,
			iapData.price,
			"USD",--iapData.currencySymbol
			ip..":"..self.iapPort.."|"..UserInfo.id
		)
	else
		SDK_Delegate:doAppstorePay(
			pData.productId,
			UserInfo.id,
			1,
			pData.productId,
			Language:get("uc477",pData.gems),
			1,
			iapData.price,
			"USD",--iapData.currencySymbol
			ip..":"..self.iapPort.."|"..UserInfo.id
		)
	end
end

--- 支付完成
function T:handlePayComplete()
	--	SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_PAY_SUCCESS,self,self.handlePayComplete)

	local data = self._productData
	if data then
		local pId=data.productId
		GoodsManager:setThreeMarkValue(pId)
		NewPackageManager:setIsBuy(pId)
		ActivityManager.firstRechargeInfo:setValue() -- 只要充值了就算首冲

		local iapData=data.iapData
		SDK_Delegate:traking_paySuccess(self._orderId, data.productId, iapData.price, "USD", data.gems, "enjoy game & Google")
	else

	end

	if self._isPaying then
	--		self:addMask()
	end
end

--- 第三方支付完成
-- @param costUSD 花费的美金数量
-- @param getedGems 获得的钻石数量
function T:handleThiredPayComplete(costUSD,getedGems)
	SDK_Delegate:traking_startPay(	self._orderId, 	"any", 	costUSD, 	"USD", 	getedGems, 	"enjoy game & Third party")
	SDK_Delegate:traking_paySuccess(	self._orderId,	"any",	costUSD,	"USD",	getedGems, 	"enjoy game & Third party")
end

--- 验证支付完成
function T:verifyPayComplete(award)
	if self._isPaying then
		self._isPaying=false

		--		self:rmvMask()
	end

	local data = self._productData
	if data then
		local pId=data.productId
		GoodsManager:setThreeMarkValue(pId)
		NewPackageManager:setIsBuy(pId)
		ActivityManager.firstRechargeInfo:setValue() -- 只要充值了就算首冲

		local iapData=data.iapData
		SDK_Delegate:traking_paySuccess(self._orderId, data.productId, iapData.price, "USD", data.gems, "enjoy game & Google")
	else

	end

	if award then
		local AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")
		AwardDataDecoder:addAWard(award)

		AwardDataDecoder:showSuccessWindow(award)
	end

	self:luaDispatchEvent(self.EVT_TYPE_PAY_SUCCESS)
end

--- 设置内购端口号
function T:setIapPort(value)
	self.iapPort=value
end

--- 获取内购端口号
function T:getIapPort()
	return self.iapPort
end
return T()
