--- 商品信息:有3部分数据：配置，服务器给我的，向苹果内购那里得到的信息
local T = Class.GoodsInfo()

function T:def()
    -- 配置sid
    self.configSid = nil

	-- 商品sid
	self.sid = nil

	-- 商品的id
	self.productId = nil

	-- 钻石数
	self.gems = nil

	-- 三倍充值标记;1,2,4,8,16,32(根据sid来排序的)
	self.threeMarkValue = nil

	-- iap（内购那里得到的数据表）
	self.iapData = nil

	--- 是否购买了:默认false是未购买，true购买了
	self.isBuy = false
end

--- 解码服务器数数据
function T:decodeServer(data)
	self.sid = data:readShort()
	self.productId = data:readString()
	self.gems = data:readInt()
	self.threeMarkValue = data:readInt()

	if CUR_SDK == nil then
		print(string.format(
			"充值商品信息:sid:%d,productId:%s,gems:%d,threeMarkValue:%d",
			self.sid,self.productId,self.gems,self.threeMarkValue
		))
	elseif CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
		local iapData={isValid=true}
		iapData.price=data:readInt()/100
		iapData.currencySymbol=data:readString()

		self.iapData=iapData
		
		print(string.format(
			"充值商品信息:sid:%d,productId:%s,gems:%d,threeMarkValue:%d,price:%s%.2f",
			self.sid,self.productId,self.gems,self.threeMarkValue,iapData.currencySymbol,iapData.price
		))
	elseif CUR_SDK == SDKType.PLATFORM_TENGLONG_1 or CUR_SDK == SDKType.PLATFORM_UC or CUR_SDK == SDKType.PLATFORM_HUA_WEI or CUR_SDK == SDKType.PLATFORM_VIVO then
		local iapData={isValid=true}
		iapData.price=data:readInt()/100
		iapData.currencySymbol=data:readString()

		self.iapData=iapData

		print(string.format(
			"充值商品信息:sid:%d,productId:%s,gems:%d,threeMarkValue:%d,price:%s%.2f",
			self.sid,self.productId,self.gems,self.threeMarkValue,iapData.currencySymbol,iapData.price
		))
	end
end

--- 设置iap内购数据
function T:setIapData(iapData)
	self.iapData = iapData
end

--- 设置是否购买了
function T:setIsBuy(value)
	self.isBuy = value

	GoodsManager:luaDispatchEvent(GoodsManager.EVT_BUY_GOODS_REFRESH)
end

return T
