--- 商品管理
local T = Class.GoodsManager(LuaEventDispatcher2)

--- 事件--购买后刷新
T.EVT_BUY_GOODS_REFRESH = "evt_buy_goods_refresh"


function T:def()
    LuaEventDispatcher2.def(self)

    --- 产品列表
    self.goodsList = {}

    --- 标记，是否请求了所有商品内购信息
    self.isGetAllList = nil
end

--- 得到产品列表
function T:getGoodsList()
    return self.goodsList
end

--- 得到排序后的产品列表
function T:getSortGoodsList()
    local goodsList = mapping({}, self.goodsList)

    local tempList = {}

    local i = 1
    for k,v in pairs(goodsList) do  -- 有可能中间是nil
        if v then
            tempList[i] = v
            i = i + 1
        end
    end        
    table.sort(tempList,function(x,y) return x.sid < y.sid end)

    return tempList

end

--- 解析服务器数据
function T:decodeServer(data)
    local length = data:readByte()
    for i = 1,length,1 do
        local goodsInfo = require("src.app.model.iap.goods.GoodsInfo")()
        goodsInfo:decodeServer(data)
        goodsInfo.configSid = i
        self.goodsList[i] = goodsInfo
    end
end

--- 根据iap字符串数据解析为每一个数据
function T:setGoodsList(allIapData)
    local listData = str2obj(allIapData)
    local goodsList = self:getGoodsList()
    for k,v in pairs(goodsList) do
        if v then
            for j,m in pairs(listData) do
                if m and v.productId == m.id then
                    goodsList[k]:setIapData(m)
                    break
                end
            end
        end
    end
    
    self.goodsList = goodsList
end


--- iap内购获取所有商品信息
function T:getAllIapData(finish)
    local goodsList = self:getGoodsList()
    local temp ={}
    for k,v in pairs(goodsList) do
        if v then
            temp[#temp + 1] = v.productId
        end
    end

    if #temp > 0 then
        Cashier:getProductListState(
            temp,
            function(isSuccess,data)
                if isSuccess then
                    if data then
                        self:setGoodsList(data)
                        NewPackageManager:getAllIapData(finish)
                    end
                end

            end
        )
    end

    

end


--- 判断商品id是否是属于当前这种类型,true:表示是这种类型，否则不是
function T:judgeIsSelf(productId)
    local goodsList = self:getGoodsList()
    local judge = false
    for k,v in pairs(goodsList) do
        if v.productId == productId then
            judge = true
            break
        end
    end

    return judge

end


--- 根据产品id设置3倍充值值
function T:setThreeMarkValue(productId)
    local goodsList = self:getGoodsList()
    local judge = false
    for k,v in pairs(goodsList) do
        if v.productId == productId then
            local threePurchaseState = SetStates.threePurchaseState
            threePurchaseState:setTypeValue(v.threeMarkValue)
            break
        end
    end
end

return T