--- 新手礼包管理
local T = Class.NewPackageManager(LuaEventDispatcher2)

--- 事件--购买礼包后刷新
T.EVT_BUY_NEW_RECHARGE_REFRESH = "evt_buy_new_recharge_refresh"

--- 事件--活动剩余时间
T.EVT_NEW_RECHARGE_REMAINING_TIME_REFRESH = "evt_new_recharge_remaining_time_refresh"


function T:def()
    LuaEventDispatcher2.def(self)

    --- 产品列表
    self.goodsList = {}

    --- 标记，是否请求了所有商品内购信息
    self.isGetAllList = nil

	--- 内购端口号
	-- iapPort
end

--- 得到产品列表
function T:getGoodsList()
    return self.goodsList
end

--- 解析服务器数据
function T:decodeServer(data)
    local length = data:readByte()
    for i = 1,length,1 do
        local goodsInfo = require("src.app.model.iap.newPackage.NewPackageInfo")()
        goodsInfo:decodeServer(data)
        self.goodsList[goodsInfo.sid] = goodsInfo
    end
end

--- 设置内购端口号
function T:setIapPort(value)
	self.iapPort=value
end

--- 根据iap字符串数据解析为每一个数据
function T:setGoodsList(allIapData)
    local listData = str2obj(allIapData)
    local goodsList = self:getGoodsList()
    for k,v in pairs(goodsList) do
        if v then
            for j,m in pairs(listData) do
                if m and v.productId == m.id then
                    goodsList[k]:setIapData(m)
                    break
                end
            end
        end
    end
    
    self.goodsList = goodsList
end


--- iap内购获取所有商品信息
function T:getAllIapData(finish)
    local goodsList = self:getGoodsList()
    local temp ={}
    for k,v in pairs(goodsList) do
        if v then
            temp[#temp + 1] = v.productId
        end
    end

    if #temp > 0 then
        Cashier:getProductListState(
            temp,
            function(isSuccess,data)
                if isSuccess then
                    if data then
                        self:setGoodsList(data)
                        self:startUpdateCheck()
                        finish()
                    end
                end

            end
        )
    else -- 礼包没有了    
        finish()
    end


end

--- 判断商品id是否是属于当前这种类型,true:表示是这种类型，否则不是
function T:judgeIsSelf(productId)
    local goodsList = self:getGoodsList()
    local judge = false
    for k,v in pairs(goodsList) do
        if v.productId == productId then
            --goodsList[k]:setIsBuy(true)
            judge = true
            break
        end
    end

    return judge

end

--- 设置购买
function T:setIsBuy(productId)
    local goodsList = self:getGoodsList()
    local judge = false
    for k,v in pairs(goodsList) do
        if v.productId == productId then
            goodsList[k]:setIsBuy(true)
        end
    end


end

--- 时间检测
function T:startUpdateCheck()
	if self.updateId then
		return
	end

	local function update()
		local list = self:getGoodsList()	    

		for k,v in pairs(list) do  
            if v.time > 0 then
                v.time = v.time - 1
                self:luaDispatchEvent(self.EVT_NEW_RECHARGE_REMAINING_TIME_REFRESH .. v.sid,v.time)
            else
                self:tryStopUpdate()
            end
           
		end
	end
	
	local list = self:getGoodsList()
	if list then
		for k,v in pairs(list) do
            if v and v.time > 0 then
                self.updateId = Cocos2dxUtils:interval(update,1)
			    break
            end

		end
	end
end

--- 尝试结束更新
function T:tryStopUpdate()
	if self.updateId then
		local list= self:getGoodsList()

		--如果队列为空,结束时间更新检查
		local isEmpty = true
		for k,v in pairs(list) do
            if v and v.time > 0 then 
                isEmpty=false
			    break
            end
		end

		if isEmpty then
			Cocos2dxUtils:clearScheduler(self.updateId)
			self.updateId = nil
		end
	end
end




return T