local FightMailInfo=require "src.app.model.mail.mailInfoBox.FightMailInfo"

--- 邮箱战报信息
local T = Class.MailFightReportContent(FightMailInfo)

--- 奖励品模板
T.AwardDataDecoder = require"src.app.communication.award.AwardDataDecoder"

function T:def()
	FightMailInfo.def(self)

	--- 荣誉
	-- honor = nil

	--- 攻击者名字（这里面有bool值）
	-- attackerName = nil

	--- 防御者名字
	-- defenderName = nil

	--- 第3方名字:如果为真，则有第3方名字
	-- thirdName = nil

	---- 如果攻击者id和防御者id都大于0则是玩家和玩家对打，否则打副本
	--- 攻击者id
	-- attackerId = nil

	--- 防御者id
	-- defenderId = nil

	--- 第三者
	-- thirdName = nil
	-- realThirdName = nil

	--- 攻击者头像
	-- attackerHead = nil

	--- 防御者头像
	-- defenderHead = nil

	--- 战斗地点
	-- battleField = nil

	--- 真正的战斗地点
	-- realBattleField = nil

	--- 战斗地点X
	-- battleFieldX = nil

	--- 战斗地点Y
	-- battleFieldY = nil

	--- 不合法的类型: 1：玩家城市不在原地，2：玩家城市处于保护状态，3：进攻已有己方驻扎资源点
	-- invalidType = nil

	--- 奖励品
	-- awardData = nil

	--- 资源变更
	-- resources = nil

	--- 攻击方损失
	-- attackerLose = nil

	--- 防御方损失
	-- defenderLose = nil

	--- bool值，如果为true，表示有战斗回放，否则没有战斗回放
	-- isplayBack = nil

	--- 战报数据
	-- fightData = nil
end

function T:decode(data)
	self.attackerName = data:readString()

	self.defenderName = data:readString()

	local bool = data:readBoolean()
	if bool == true then
		self.thirdName = data:readString()
		if self.thirdName ~= "" then
			self:thirdResouse()
		end

	end

	self.attackerId = data:readUnsignedInt()
	self.defenderId = data:readUnsignedInt()
	self.attackerHead = data:readUnsignedByte()
	self.defenderHead = data:readUnsignedByte()

	self.battleField = data:readString()

	self.battleFieldX = data:readUnsignedShort()
	self.battleFieldY = data:readUnsignedShort()

	--- 攻击者的x,y(主要用于反击的坐标)
	self.attackFieldX = data:readUnsignedShort()
	self.attackFieldY = data:readUnsignedShort()

	self.invalidType = data:readUnsignedByte()

    self.honor = data:readInt() -- 荣誉值
    self.revenge = data:readInt() -- 复仇值

	local isAwardData = data:readBoolean()
	if isAwardData == true then
		self.awardData = self.AwardDataDecoder:decode(data) -- 返回一个表r
	else
		self.awardData = nil
	end

	local resourcesLength = data:readUnsignedByte()
	if resourcesLength  == 0 then
		self.resources = 0
	else
		self.resources = {}
		for i = 1,resourcesLength,1 do
			self.resources[i] = data:readInt()
		end
	end

	--- 如果有数据，则是
	local attackerLoseLength = data:readUnsignedByte()
	if attackerLoseLength  == 0 then
		self.attackerLose = 0
	else
		self.attackerLose = {}
		local tempSid = nil
		for i = 1,attackerLoseLength,1 do
			if i%2 == 0 then
				self.insertToTable(self.attackerLose,tempSid,data:readUnsignedShort())
			else
				tempSid = data:readUnsignedShort()
			end

		end
	end

	local defenderLoseLength = data:readUnsignedByte()
	if defenderLoseLength  == 0 then
		self.defenderLose = 0
	else
		self.defenderLose = {}
		local tempSid = nil
		for i = 1,defenderLoseLength,1 do
			if i%2 == 0 then
				self.insertToTable(self.defenderLose,tempSid,data:readUnsignedShort())
			else
				tempSid = data:readUnsignedShort()
			end

		end
	end

	self.isplayBack = data:readBoolean()

end


--- 插入sid，num ......{{2,22},{1,90}}
function T.insertToTable(table,sid,num)
	local tempTable = {}
	tempTable[1] = sid
	tempTable[2] = num

	local length = #table
	table[length + 1] = tempTable
end

--- 设置真正的战斗地点
function T:setRealBattleField(judge)
	if judge then
		local first,second = CommonMethod:getCharFromStr(self.battleField)
		self.realBattleField = CommonMethod:getRealText(first) .. "Lv." .. second
	else
		self.realBattleField = self.battleField
	end

end

function T:thirdResouse()
	local first,second = CommonMethod:getCharFromStr(self.thirdName)
	self.realThirdName = CommonMethod:getRealText(first) .. "Lv." .. second
end

--- 进攻的时候防御者的返回
function T:realDefend(judge)
	if judge and not self.thirdName then -- npc
		local first,second = CommonMethod:getCharFromStr(self.defenderName)
		return CommonMethod:getRealText(first) .. "Lv." .. second,CommonMethod:getRealText(first)
	else
		return self.defenderName
	end

end


return T
