--- 邮件基本信息
local BaseMailInfo=require("src.app.model.mail.mailInfoBox.BaseMailInfo")

--- 战斗邮箱信息
local T = Class.FightMailInfo(BaseMailInfo)

function T:def()
	BaseMailInfo.def(self)

	--- 标记战斗类型
	-- fightType=nil

	--- 战斗结果:1:进攻胜利，2：进攻失败，4：防守胜利，8：防守失败，16：攻击NPC资源点，32：返回报告（进攻无效）
	-- result = nil

	--- 标题
	-- title = nil

	--- 战斗结果类型:1:进攻胜利，2：进攻失败，3：防守胜利，4：防守失败，5：攻击无效
	-- resultType = nil

	--- 真正的标题内容
	-- realTitle1 = nil
	-- realTitle2 = nil
end

function T:decode(data)
	BaseMailInfo.decode(self,data)

	self.result = data:readUnsignedByte()
	self.title = data:readString()

	self:setResultType()

	if self.title ~= "" then
		self:setRealTitle()
	end

end

--- 设置战斗结果类型
function T:setResultType()
	local result = self.result
	if BitOperator:_and(result, 1) ~= 0 then
		self.resultType = 1
	end

	if BitOperator:_and(result, 2) ~= 0 then
		self.resultType = 2
	end

	if BitOperator:_and(result, 4) ~= 0 then
		self.resultType = 3
	end

	if BitOperator:_and(result, 8) ~= 0 then
		self.resultType = 4
	end

	if BitOperator:_and(result, 32) ~= 0 then
		self.resultType = 5
	end

end


--- 真正的标题内容
function T:setRealTitle()
	if BitOperator:_and(self.result, 16) ~= 0 then -- npc了
		local first,second = CommonMethod:getCharFromStr(self.title)

		self.realTitle1 = CommonMethod:getRealText(first)
		self.realTitle2 = self.realTitle1 .. "Lv." .. second

	end

end

return T
