local T=Class.ResourceManager(LuaEventDispatcher2)

--- 事件-资源刷新
T.EVT_TYPE_RESOURCE_REFRESH = "evt_type_resource_refresh"

function T:def()
	LuaEventDispatcher2.def(self)

	--- 整个队列的id
	self.updateId = nil
end

function T:startUpdateCheck()
	local resource_num = #Resource_temp

	local function update()
		local syncSec=TimeUtils:getSyncMillis()/1000
		local resourceTime = UserInfo.city.resourceTime  -- 如果缓冲时间长了就有问题，所以后面要做检测
		local differ = syncSec - resourceTime -- 每分钟刷新数据，并且派发事件，并且检测是否有该资源的buff

		if differ >= 60 then
			--for i = 1,resource_num,1 do
			--if differ >= 60 then
			--                    local level = BuildingsInfoMgr:getBuildingInfos()[self.buildingSid[i]].level
			--                    local output = self:GetTable(i)[level].output -- 每分钟这种资源的产量
			--                    if BuffQueueInfoMgr:checkActive(i) then -- buff存在
			--                        UserInfo.city[Resource_temp[i].attributeName] = (UserInfo.city[Resource_temp[i].attributeName] + output)*(1 + 0.5) --这里为50%，到时读取表的数据
			--                    else
			--                        UserInfo.city[Resource_temp[i].attributeName] = UserInfo.city[Resource_temp[i].attributeName] + output
			--                    end
			--end
			--end
			for i = 6,10,1 do  -- 资源的sid从6到10:buff对产量增益，科研对容量增益  玩家的产量每分钟不长的
                -- 资源如果爆仓了就不长了
                local resOutput,resCapacity = PlayerInstance:getCapacityAndOutput(i)
                local noResCapacity = PlayerInstance:getNoResCapacity()
                local allCapacity = resCapacity + noResCapacity    -- 数值
                local nowCapacity = UserInfo.city[PlayerInstance:getAttributeNameFromSid(i)]
                if nowCapacity >= allCapacity then --  资源爆仓的情况
                else
                    local allOutput = PlayerInstance:getAllTrueOutput(i)
                    UserInfo.city[PlayerInstance:getAttributeNameFromSid(i)] = UserInfo.city[PlayerInstance:getAttributeNameFromSid(i)] + allOutput
                end
			end

			self:luaDispatchEvent(self.EVT_TYPE_RESOURCE_REFRESH)  -- 这里的资源统一派发事件，以这里为准就行了
			PlayerInstance:setResourceTime(UserInfo.city.resourceTime + 60)
		end

	end

	if self.updateId then
		return
	else
		self.updateId = Cocos2dxUtils:interval(update,1)
	end

end

function T:stopUpdateCheck()
	if self.updateId then
		Cocos2dxUtils:clearScheduler(self.updateId)
		self.updateId=nil
	end
end

--- 释放
function T:release()
	self:stopUpdateCheck()
	self:releaseEventListeners()
end

return T
