local T=Class.AccountMgr()

--- 最大记录历史账号数
T.MAX_RECORD_ACCOUNT_COUNT=5

function T:def()

end

function T:ctor()

end

--- 存储账号信息
function T:storageAccount(accountInfo)
	--上一次的登陆信息
	local lAccount=DataStorage:getLoginData()

	--存储当前登陆的账号信息
	DataStorage:putLoginData(accountInfo)
	
	--从历史登陆列表中移除当前登陆的账号信息
	local hAccounts=DataStorage:getHistoryLoginData() or {}
	for k,v in ipairs(hAccounts) do
		if v.uid == accountInfo.uid then
			table.remove(hAccounts,k)
			break
		end
	end

	--将上一次登陆的账号存入历史登陆列表中(游客账号不记录)
	if lAccount then
		if lAccount.uid ~= accountInfo.uid and not lAccount.isTourist then
            lAccount.pwd=nil
			table.insert(hAccounts,1,lAccount)
			
			if #hAccounts > self.MAX_RECORD_ACCOUNT_COUNT then
				table.remove(hAccounts)
			end
		end
	end
	
	DataStorage:putHistoryLoginData(hAccounts)
end

return T