--region T.lua
--Author    : YuDing
--Date      : 2014/10/9
--Introduce : 技能等级信息
local T = {}

--1 命中
--2 闪避
--3 暴击
--4 暴抗
--5 A类飞机伤害
--6 B类飞机伤害
--7 C类飞机伤害
--8 D类飞机伤害
--9 A类飞机血量
--10 B类飞机血量
--11 C类飞机血量
--12 D类飞机血量

--- 信息列表
T.infos = nil
--- 技能总数（写死）
T.total = 12

--- 技能反序列
function T:decode(data)
	local infos={}

	local len=data:readUnsignedByte()

	for i = 1, len, 1 do
		local sid = data:readUnsignedShort()
		local level = data:readUnsignedByte()

		infos[sid] = {sid = sid, level = level}
	end

	self.infos = infos

end

--- 获取对战机命中的加成
-- @return 加成比例
function T:getHitAdd()
	local info=self.infos[1]
	if info then
		return info.level or 0
	end

	return 0
end

--- 获取对战机闪避的加成
-- @return 加成比例
function T:getDodgeAdd()
	local info=self.infos[2]
	if info then
		return info.level or 0
	end

	return 0
end

--- 获取对暴击的加成
-- @return 加成比例
function T:getCritAdd()
	local info=self.infos[3]
	if info then
		return info.level or 0
	end

	return 0
end

--- 获取对暴抗的加成
-- @return 加成比例
function T:getArmorAdd()
	local info=self.infos[4]
	if info then
		return info.level or 0
	end

	return 0
end

--- 获取对战机攻击的加成
-- @param attackType 战机的攻击类型
-- @return 加成比例
function T:getAttckAdd(attackType,attack)
	local info
	if attackType == AttackType.AT_1 then
		info=self.infos[5]
	elseif attackType == AttackType.AT_2 then
		info=self.infos[6]
	elseif attackType == AttackType.AT_3 then
		info=self.infos[7]
	elseif attackType == AttackType.AT_4 then
		info=self.infos[8]
	end
	if info then
		return info.level or 0
	end

	return 0
end

--- 获取对战机血量的加成
-- @param attackType 战机的攻击类型
-- @return 加成比例
function T:getHpAdd(attackType)
	local info
	if attackType == AttackType.AT_1 then
		info=self.infos[9]
	elseif attackType == AttackType.AT_2 then
		info=self.infos[10]
	elseif attackType == AttackType.AT_3 then
		info=self.infos[11]
	elseif attackType == AttackType.AT_4 then
		info=self.infos[12]
	end
	if info then
		return info.level or 0
	end

	return 0
end

return T
































































--endregion
