--- 建造队列设置
local T = Class.BuildQueueNumState(LuaEventDispatcher2)

--- 设置标记
T.EXTRA_BUILDING_QUEUE_NUM = 111

--- 事件--购买成功后刷新
T.EVT_BUY_BUILD_QUEUE_REFRESH = "evt_buy_build_queue_refresh"

function T:def()
    LuaEventDispatcher2.def(self)

    --- 状态列表
    T.list = { }
end

function T:setList(list)
    self.list = list
end

--- 得到已经建造队列数量
function T:getBuildQueueNum()
    return self.list[self.EXTRA_BUILDING_QUEUE_NUM] or 0
end

--- 设置已经建造队列数量，最多为3个
function T:setBuildQueueNum(value)
    self.list[self.EXTRA_BUILDING_QUEUE_NUM] = value
    self:luaDispatchEvent(self.EVT_BUY_BUILD_QUEUE_REFRESH)
end

--- 判断是否可以购买,ture:可以购买，false:不能购买
function T:judgeIsBuy()
    local num = self:getBuildQueueNum()
    if num >= 3 then
        return false
    else
        return true
    end

end

--- 购买耗费的钻石数目
function T:getCost()
    local num = self:getBuildQueueNum()
    if num == 0 then
        return 498
    elseif num == 1 then
        return 1998
    elseif num == 2 then
        return 9998
    end

    return 9998 -- 错误情况
end



return T
