--region GiftState.lua
--Author    : YuDing
--Date      : 2015/3/6
--Introduce : 礼物的状态

-- 一般设置
local T = Class.GiftState(LuaEventDispatcher2)

--- 设置标记
T.mark = 105

--- 剩余时间的派发
T.REMAIN_TIME = "REMAIN_TIME"

--- 奖品
T.reward = nil

function T:def()
    LuaEventDispatcher2.def(self)

	--- 状态列表
	self.list = { }
    
    --- 任务schdule
    self.giftSchduleId = nil
end

function T:setList(list)
	self.list = list
     
    self:updateTime()
    

end

--- 更新时间
function T:updateTime()
    local func = function()
        if self:getTime() >= 0 then  -- 时间大于0才派发
            self:luaDispatchEvent(self.REMAIN_TIME, self:getTime()) -- 派发
            if self:getTime() == 0 then  -- 时间到到达0
                Cocos2dxUtils:clearScheduler(self.giftSchduleId)
                self.giftSchduleId = nil
            end
        end
    end
    
    if not self.giftSchduleId then 
        self.giftSchduleId = Cocos2dxUtils:interval(func, 1.0) -- 每一秒派发一个时间
    end

end

--- 获取剩余时间
function T:getTime()
    if not self.list[self.mark] then 
        return 0
    end

    local r = self.list[self.mark] - TimeUtils:getSyncMillis()/1000

    if r >= 0 then 
        return r 
    else 
        return 0
    end
end

--- 得到奖品
function T:getGift()
    return self.reward
end

--- 设置奖品
function T:setGift(r)
    self.reward = r
end

--- 设置时间
function T:setTime(t)
    self.list[self.mark] = t

    self:luaDispatchEvent(self.REMAIN_TIME) -- 先立即刷新

    self:updateTime()
end

return T







--endregion
