--- 充值档位奖励领取标记
local T = Class.ReChargeState(LuaEventDispatcher2)

--- 设置标记
T.SETTING_MARK = 137

--- 充值档位领取事件
T.EVT_RECHARGE_STATE_RESOURCE = "evt_recharge_state_resource"


function T:def()
    LuaEventDispatcher2.def(self)

    --- 状态列表
    T.list = { }

end

function T:setList(list)
    self.list = list
end

--- 得到总值
function T:getTotalValue()
    return self.list[self.SETTING_MARK] or 0
end

--- 判断所有的充值档位领取没有，如果领取了，就关闭首冲活动,true:打开活动（未领取完）, false:关闭活动（领取完了）
function T:judgeAllGetValue()
    local judge = false
    for i = 1,3,1 do
        if self:judgeGetValue(i - 1) == false then
            judge = true
            break
        end

    end
    return judge
end


--- 判断相应的档位数值领取没有（一共3个档位，0，1，2）
function T:judgeGetValue(tag)
    local value = self.list[self.SETTING_MARK] or 0
    return BitOperator:_and(value, BitOperator:_ls(1, tag)) ~= 0 -- true：1领取了，false：0未领取
end

--- 设置档位领取了
function T:setValue(tag)
    local value = self.list[self.SETTING_MARK] or 0
    self.list[self.SETTING_MARK] = BitOperator:_or(value,BitOperator:_ls(1, tag))

    self:luaDispatchEvent(self.EVT_RECHARGE_STATE_RESOURCE)

    ActivityManager.firstRechargeActivityInfo:deleteSelf()

end


--- 得到平台类型:国内安卓是0，其他都是1
function T:getCurSdkType()
    if CUR_SDK and CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
        return 1
    elseif C_PFM == cc.PLATFORM_OS_ANDROID then
        return 0
    elseif C_PFM == cc.PLATFORM_OS_IPHONE or C_PFM == cc.PLATFORM_OS_IPAD then
        return 1
    end 
end

--- 根据平台类型得到当前的档位
function T:getCurSdkStringValue(tag)
    if CUR_SDK and CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
        if tag == 0 then
            return Language:get("uc1045",0.99)
        elseif tag == 1 then
            return Language:get("uc1045",14.99)
        else
            return Language:get("uc1045",49.99)
        end
    elseif C_PFM == cc.PLATFORM_OS_ANDROID then
        if tag == 0 then
            return Language:get("uc1044",6)
        elseif tag == 1 then
            return Language:get("uc1044",98)
        else
            return Language:get("uc1044",198)
        end
    elseif C_PFM == cc.PLATFORM_OS_IPHONE or C_PFM == cc.PLATFORM_OS_IPAD then
        if tag == 0 then
            return Language:get("uc1044",6)
        elseif tag == 1 then
            return Language:get("uc1044",98)
        else
            return Language:get("uc1044",328)
        end
    end
    

end

--- 国内安卓的充值标记 有1,4,8的时候分别就可以领奖
--- 其他平台的充值标记 有1,8,16的 时候分别可以领奖
--- 判断档位是否可以领取:value是标记值，tag是传进来的0，1，2
function T:judgeIsGet(rechargeMark,tag)
    if self:getCurSdkType() == 0 then -- 国内安卓
        if tag == 0 then
            return BitOperator:_and(rechargeMark, BitOperator:_ls(1, 0)) ~= 0   -- true：1可以领取，false：0不能领取
        elseif tag == 1 then
            return BitOperator:_and(rechargeMark, BitOperator:_ls(1, 2)) ~= 0
        else
            return BitOperator:_and(rechargeMark, BitOperator:_ls(1, 3)) ~= 0
        end

    else
        if tag == 0 then
            return BitOperator:_and(rechargeMark, BitOperator:_ls(1, 0)) ~= 0 
        elseif tag == 1 then
            return BitOperator:_and(rechargeMark, BitOperator:_ls(1, 3)) ~= 0
        else
            return BitOperator:_and(rechargeMark, BitOperator:_ls(1, 4)) ~= 0
        end

    end

end



return T
