--region ReinforceState.lua
--Author    : YuDing
--Date      : 2015/3/12
--Introduce : 援军
-- 一般设置
local T = Class.ReinforceState(LuaEventDispatcher2)

--- 设置标记
T.mark = 115

--- 剩余时间的派发
T.REMAIN_TIME = "REMAIN_TIME"

--- 奖品
T.reward = nil

function T:def()
    LuaEventDispatcher2.def(self)

	--- 状态列表
	self.list = { }
    
    --- 任务schdule
    self.reinforceSchduleId = nil
end

function T:setList(list)
	self.list = list
     
    self:updateTime()
end

--- 更新时间
function T:updateTime()
    local func = function()
        if self:getTime() >= 0 then  -- 时间大于0才派发
            self:luaDispatchEvent(self.REMAIN_TIME, self:getTime()) -- 派发
            if self:getTime() == 0 then  -- 时间到到达0
                Cocos2dxUtils:clearScheduler(self.reinforceSchduleId)
                self.reinforceSchduleId = nil
            end
        end
    end
    
    if not self.reinforceSchduleId then 
        self.reinforceSchduleId = Cocos2dxUtils:interval(func, 1.0) -- 每一秒派发一个时间
    end

end

--- 获取剩余时间
function T:getTime()
    if not self.list[self.mark] then 
        return 0
    end

    local r = self.list[self.mark] - TimeUtils:getSyncMillis()/1000

    if r >= 0 then 
        return r 
    else 
        return 0
    end

end

--- 得到奖品
function T:getGift()
    return self.reward
end

--- 设置奖品
function T:setGift(r)
    self.reward = r
end

--- 设置时间
function T:setTime(t)
    self.list[self.mark] = t

    self:luaDispatchEvent(self.REMAIN_TIME) -- 先立即刷新    
end

function T:isReceive()
    local t = self.list[self.mark]

    if not t then 
        t = 0
    end

    if t == 0 then 
        return true
    else 
        return false
    end

end

----- 领取成功
--function T:setSuccess()
--    if self.giftSchduleId then  -- 如果定时器还在 取消定时器
--        Cocos2dxUtils:clearScheduler(self.giftSchduleId)
--        self.giftSchduleId = nil
--    end

--    self.list[self.mark] = 0 -- 设置时间为0

--    self:luaDispatchEvent(self.SUCCESS) -- 成功
--end


return T





--endregion
