-- 一般设置
local T = Class.SetCommonStates(LuaEventDispatcher2)

--- 设置标记
T.SETTING_MARK = 110

T.CLOSE_ATTACK_MINE = BitOperator:_ls(1, 0)          -- 攻打野矿 默认驻守
T.CLOSE_OPEN_NEW_RESOURCE = BitOperator:_ls(1, 1)    -- 开放新资源点提醒

T.CLOSE_SCIENCE_FAST = BitOperator:_ls(1, 2)    -- 科研快捷栏提醒
T.CLOSE_PRODUCE_FAST = BitOperator:_ls(1, 3)    -- 生产快捷栏提醒
T.CLOSE_BUILD_FAST = BitOperator:_ls(1, 4)    -- 建造快捷栏提醒

T.CLOSE_BACKGROUND_MUSIC = BitOperator:_ls(1, 5)     -- 音乐提示
T.CLOSE_MUSIC_EFFECT = BitOperator:_ls(1, 6)         -- 音效提示

T.CLOSE_BUILD_NAME = BitOperator:_ls(1, 7)         -- 始终显示建筑名字

--- 资源点事件
T.EVT_CLOSE_OPEN_NEW_RESOURCE = "evt_close_open_new_resource"
--- 建筑快捷栏
T.EVT_CLOSE_OPEN_BUILD_FAST = "evt_close_open_new_build_fast" -- add by yuding

--- 始终显示建筑名字
T.EVT_CLOSE_OPEN_BUILD_NAME = "evt_close_open_new_build_name"


function T:def()
    LuaEventDispatcher2.def(self)

	--- 状态列表
	T.list = { }
end

function T:setList(list)
	self.list = list
end

--- 得到总值
function T:getTotalValue()
	return self.list[self.SETTING_MARK] or 0
end

--- 获取关闭相应的数值
function T:getClosedValue(closeType)
	local value = self.list[self.SETTING_MARK] or 0
	return BitOperator:_and(value, closeType) ~= 0 -- true：1关闭，false：0打开
end

--- 设置关闭相应的数值
--- true:设置为关闭，false:设置为打开
function T:setClosedValue(boolValue,closeValue)
	local value = self.list[self.SETTING_MARK] or 0
	if boolValue == true then -- 设置为关闭
		self.list[self.SETTING_MARK] = BitOperator:_or(value,closeValue)
	else -- 设置为打开
		local notValue = BitOperator:_not(closeValue)
		self.list[self.SETTING_MARK] = BitOperator:_and(notValue,value)
	end

    if closeValue == self.CLOSE_OPEN_NEW_RESOURCE then
        self:luaDispatchEvent(self.EVT_CLOSE_OPEN_NEW_RESOURCE)
    end
    
    if closeValue == self.CLOSE_BUILD_FAST then -- 快捷建筑
        self:luaDispatchEvent(self.EVT_CLOSE_OPEN_BUILD_FAST)
    end
    
    if closeValue == self.CLOSE_BUILD_NAME then -- 始终显示建筑名字
        self:luaDispatchEvent(self.EVT_CLOSE_OPEN_BUILD_NAME)
    end


end

return T
