--- 通知设置
local T = Class.SetNoticeStates()

--- 设置标记
T.SETTING_MARK = 109

function T:def()
    --- 状态列表
    T.list = { }

    self.CLOSE_CITY_ATTACKED = BitOperator:_ls(1, 0)            -- 城市被攻击 
    self.CLOSE_BUILD_CONSTRUCE = BitOperator:_ls(1, 1)          -- 建造，生产完成 
    self.CLOSE_POINT_RECOVERY = BitOperator:_ls(1, 2)           -- 能量恢复满
    self.CLOSE_AWARD = BitOperator:_ls(1, 3)                    -- 神秘奖励
    self.CLOSE_PROTECTION_COVER = BitOperator:_ls(1, 4)         -- 防护罩状态 
    self.CLOSE_RESOURCE_COLLECT = BitOperator:_ls(1, 5)         -- 资源采集已满  
end

function T:setList(list)
    self.list = list
end

--- 得到总值
function T:getTotalValue()
    return self.list[self.SETTING_MARK] or 0
end

--- 获取关闭相应的数值
function T:getClosedValue(closeValue)
    local value = self.list[self.SETTING_MARK] or 0
    return BitOperator:_and(value, closeValue) ~= 0 -- true：1关闭，false：0打开
end

--- 设置关闭相应的数值
--- true:设置为关闭，false:设置为打开
function T:setClosedValue(boolValue,closeValue)
    local value = self.list[self.SETTING_MARK] or 0
    if boolValue == true then -- 设置为关闭
        self.list[self.SETTING_MARK] = BitOperator:_or(value,closeValue)
    else -- 设置为打开
        local notValue = BitOperator:_not(closeValue)
        self.list[self.SETTING_MARK] = BitOperator:_and(notValue,value)
    end

end

return T
