--- 付费提示设置
local T = Class.SetPayStates()

--- 设置标记
T.SETTING_MARK = 108

function T:def()
    --- 状态列表
    T.list = { }

    self.CLOSE_UPGRADE_COMMAND = BitOperator:_ls(1, 0)     -- 升级指挥
    self.CLOSE_BUY_POINT = BitOperator:_ls(1, 1)           -- 购买能量 
    self.CLOSE_BUY_GOODS = BitOperator:_ls(1, 2)           -- 购买商品
    self.CLOSE_TIME_BUILDIGN = BitOperator:_ls(1, 3)       -- 一键秒建筑 
    self.CLOSE_BUILD_SPEED = BitOperator:_ls(1, 4)         -- 建筑加速 
    self.CLOSE_PRODECE_SPEED = BitOperator:_ls(1, 5)       -- 生产飞机加速 
    self.CLOSE_SCIENCE_SPEED = BitOperator:_ls(1, 6)       -- 科研加速 
    self.CLOSE_MARCH_SPEED = BitOperator:_ls(1, 7)         -- 行军加速 
    self.CLOSE_DIAMOND_REPAIR = BitOperator:_ls(1, 8)      -- 钻石维修部队
    self.CLOSE_SKILL_LEVELUP = BitOperator:_ls(1, 9)       -- 技能升级提示
    self.CLOSE_SPEEDUP_DAILYTASK = BitOperator:_ls(1, 10)  -- 每日任务加速

end

function T:setList(list)
    self.list = list
end

--- 得到总值
function T:getTotalValue()
    return self.list[self.SETTING_MARK] or 0
end

--- 获取关闭相应的数值
function T:getClosedValue(closeValue)
    local value = self.list[self.SETTING_MARK] or 0
    return BitOperator:_and(value, closeValue) ~= 0 -- true：1关闭，false：0打开
end

--- 设置关闭相应的数值
--- true:设置为关闭，false:设置为打开
function T:setClosedValue(boolValue,closeValue)
    local value = self.list[self.SETTING_MARK] or 0
    if boolValue == true then -- 设置为关闭
        self.list[self.SETTING_MARK] = BitOperator:_or(value,closeValue)
    else -- 设置为打开
        local notValue = BitOperator:_not(closeValue)
        self.list[self.SETTING_MARK] = BitOperator:_and(notValue,value)
    end

end


return T
