--- vip管理
local T = Class.VipManager(LuaEventDispatcher2)

--- 打开窗口方式-push
local OPEN_WINDOW_WAY_PUSH=0

--- 打开窗口方式-switch
local OPEN_WINDOW_WAY_SWITCH=1

function T:def()
	LuaEventDispatcher2.def(self)
end

--- 进入内购界面
function T:_enterIapWindow(openWindowWay)
	--- 判断是否支付内购
	if cc.PLATFORM_OS_WINDOWS == C_PFM
		or
		(
		cc.PLATFORM_OS_ANDROID == C_PFM
		and
		CUR_SDK ~= SDKType.PLATFORM_ENJOY_GAME
		and
		CUR_SDK ~= SDKType.PLATFORM_TENGLONG_1
		and
		CUR_SDK ~= SDKType.PLATFORM_UC
		and
		CUR_SDK ~= SDKType.PLATFORM_HUA_WEI
		and
		CUR_SDK ~= SDKType.PLATFORM_VIVO
		)
	then
		print("此平台暂不支持充值功能")
		MUIAlter.show({
			info="此平台暂不支持充值功能"
		})

		return
	end

	if not GoodsManager then
		GoodsManager = require("src.app.model.iap.goods.GoodsManager")() -- 这是实例化，只能在这里进行
	end

	if not NewPackageManager then
		NewPackageManager = require("src.app.model.iap.newPackage.NewPackageManager")() -- 这是实例化，只能在这里进行
	end

	--- 打开IAP窗口
	local openIapWindow=function()
		if openWindowWay == OPEN_WINDOW_WAY_SWITCH then
			WindowManager:switch(
				require("src.app.uiScript.components.iap.IAPWindow").new()
			)
		else
			WindowManager:push(
				require("src.app.uiScript.components.iap.IAPWindow").new()
			)
		end
	end

	-- 先看数据是否有，如果没有则请求,这里还要考虑那个首冲状态是否首冲了
	if GoodsManager.isGetAllList then
		openIapWindow()
	else
		--请求遮罩>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
		local uiMask = require("src.app.uiScript.components.common.CommunicationWaitingMask")()
		Director:getRunningScene():addChild(uiMask)

		local timeoutSID
		timeoutSID=Cocos2dxUtils:timeOut(function()
			if timeoutSID then
				timeoutSID=nil
			end

			uiMask:removeFromParent()
			MUIAlter.show({
				info = Language:get("uc817"),
				size = 30,
			})
		end,15)
		--请求遮罩<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

		local function finish()
			local getIapDataComplete=function()
				if timeoutSID then
					Cocos2dxUtils:clearScheduler(timeoutSID)
					timeoutSID=nil

					uiMask:removeFromParent()

					GoodsManager.isGetAllList = true
					openIapWindow()
				end
			end

			if
				CUR_SDK == SDKType.PLATFORM_ENJOY_GAME --英卓的IOS充值和ANDROID的一样
				or
				CUR_SDK == SDKType.PLATFORM_TENGLONG_1
				or
				CUR_SDK == SDKType.PLATFORM_UC
				or
				CUR_SDK == SDKType.PLATFORM_HUA_WEI
				or
				CUR_SDK == SDKType.PLATFORM_VIVO
			then
				getIapDataComplete()
			else
				GoodsManager:getAllIapData(getIapDataComplete)
			end
		end
		Command:getGoodsListInfo(finish)
	end
end

--- 进入重置双倍充值窗口
function T:enterResetDoubleRechagerPopWindow()
    --- 判断是否支付内购
	if cc.PLATFORM_OS_WINDOWS == C_PFM
		or
		(
		cc.PLATFORM_OS_ANDROID == C_PFM
		and
		CUR_SDK ~= SDKType.PLATFORM_ENJOY_GAME
		and
		CUR_SDK ~= SDKType.PLATFORM_TENGLONG_1
		and
		CUR_SDK ~= SDKType.PLATFORM_UC
		)
	then
		print("此平台暂不支持充值功能")
		MUIAlter.show({
			info="此平台暂不支持充值功能"
		})

		return
	end

	if not GoodsManager then
		GoodsManager = require("src.app.model.iap.goods.GoodsManager")() -- 这是实例化，只能在这里进行
	end

	if not NewPackageManager then
		NewPackageManager = require("src.app.model.iap.newPackage.NewPackageManager")() -- 这是实例化，只能在这里进行
	end

	--- 打开IAP窗口
	local openIapWindow=function()
        local layout = require("src.app.uiScript.components.share.ResetDoubleRechargePopWindow").new()
        local muialter = MUIAlter.show(
                {
                    info = layout,
                    title = Language:get("uc1071"),
                    size = 30,
                    flag = 4,
                    isShowCloseButton = true
                }
            )

        layout:setMuialter(muialter)
	end

	-- 先看数据是否有，如果没有则请求,这里还要考虑那个首冲状态是否首冲了
	if GoodsManager.isGetAllList then
		openIapWindow()
	else
		--请求遮罩>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
		local uiMask = require("src.app.uiScript.components.common.CommunicationWaitingMask")()
		Director:getRunningScene():addChild(uiMask)

		local timeoutSID
		timeoutSID=Cocos2dxUtils:timeOut(function()
			if timeoutSID then
				timeoutSID=nil
			end

			uiMask:removeFromParent()
			MUIAlter.show({
				info = Language:get("uc817"),
				size = 30,
			})
		end,15)
		--请求遮罩<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

		local function finish()
			local getIapDataComplete=function()
				if timeoutSID then
					Cocos2dxUtils:clearScheduler(timeoutSID)
					timeoutSID=nil

					uiMask:removeFromParent()

					GoodsManager.isGetAllList = true
					openIapWindow()
				end
			end

			if
				CUR_SDK == SDKType.PLATFORM_ENJOY_GAME --英卓的IOS充值和ANDROID的一样
				or
				CUR_SDK == SDKType.PLATFORM_TENGLONG_1
				or
				CUR_SDK == SDKType.PLATFORM_UC
			then
				getIapDataComplete()
			else
				GoodsManager:getAllIapData(getIapDataComplete)
			end
		end
		Command:getGoodsListInfo(finish)
	end

end


--- 进入vip内购界面逻辑:考虑遮罩
function T:enterIapWindow()
	self._enterIapWindow(OPEN_WINDOW_WAY_PUSH)
end

--- 进入vip内购界面逻辑:考虑遮罩
function T:switchIapWindow()
	self._enterIapWindow(OPEN_WINDOW_WAY_SWITCH)
end


--- 得到玩家所拥有的vip积分
function T:getPlayerVipPoint()
	return UserInfo.vipPoint or 0
end

--- 增加vip点数
function T:addVipPoint(num)
	local vipPoint = self:getPlayerVipPoint()
	vipPoint = vipPoint + num
	self:setPlayerVipPoint(vipPoint)

end

--- 设置vip点数
function T:setPlayerVipPoint(num)
	UserInfo.vipPoint = num
	-- vip自动升级，判断是否达到下一等级的vip点数
	local vipLevel = UserInfo.vipLevel
	if vipLevel < 12 then
		if num >= Vip[vipLevel + 1].point then
			UserInfo.vipLevel = UserInfo.vipLevel + 1
			UserInfo.vipPoint = num - Vip[vipLevel + 1].point
		end
	end

	PlayerInstance:luaDispatchEvent(PlayerInstance.noticeMessage.vipPoint)    -- 这个事件也是vip等级监听的事件
end

--- 得到下一等级的vip点数
function T:getNextVipPoint()
	local vipLevel = UserInfo.vipLevel + 1
	local point = nil
	if vipLevel > 12 then
		point = Vip[12].point  -- 暂时先这么写吧
	else
		point = Vip[vipLevel].point
	end

	return point
end

----------------------------------------------------------------------------------------------------------------------------

function T.getVipFreeTime()
	local vipLevel = UserInfo.vipLevel
	local vipFreeTime = nil
	if vipLevel > 12 then -- 读取vip为10的放上就ok了
		vipFreeTime = Vip[12].freeTime
	else
		vipFreeTime = Vip[vipLevel].freeTime
	end

	return vipFreeTime
end


--- 得到阵型设置数量
function T.getFormationNum()
	local vipLevel = UserInfo.vipLevel
	local formationNum = nil
	if vipLevel > 12 then -- 读取vip为10的放上就ok了
		formationNum = Vip[12].formationNum
	else
		formationNum = Vip[vipLevel].formationNum
	end

	return formationNum
end



--- 根据vip等级获得同时建筑物队列升级个数
function T.getVipBuildQueueCount()
	local vipLevel = UserInfo.vipLevel
	local buildQueueCount = nil
	if vipLevel > 12 then
		buildQueueCount = Vip[12].buildQueueCount
	else
		buildQueueCount = Vip[vipLevel].buildQueueCount
	end

	return buildQueueCount
end

--- 根据vip等级获得同时科研中心建筑物队列升级个数
function T.getVipTechQueueCount()
	local vipLevel = UserInfo.vipLevel
	local buildQueueCount = nil
	if vipLevel > 12 then
		buildQueueCount = Vip[12].techQueueCount
	else
		buildQueueCount = Vip[vipLevel].techQueueCount
	end

	return buildQueueCount
end

--- 根据vip等级获得同时生产队列的个数
function T.getVipProduceQueueCount()
	local vipLevel = UserInfo.vipLevel
	local produceQueueCount = nil
	if vipLevel > 12 then
		produceQueueCount = Vip[12].produceQueueCount
	else
		produceQueueCount = Vip[vipLevel].produceQueueCount
	end

	return produceQueueCount
end

--- 根据vip等级获得同时出战的部队个数
function T.getVipbattleQueueCount()
	local vipLevel = UserInfo.vipLevel
	local battleQueueCount = nil
	if vipLevel > 12 then
		battleQueueCount = Vip[12].battleQueueCount
	else
		battleQueueCount = Vip[vipLevel].battleQueueCount
	end

	return battleQueueCount
end

--- 得到vip的精力点数
function T.getVipPoint()
	local vipLevel = UserInfo.vipLevel
	local pointCount = nil
	if vipLevel > 12 then
		pointCount = Vip[12].pointCount
	else
		pointCount = Vip[vipLevel].pointCount
	end

	return pointCount
end

--- 生产速度加成
function T.getVipProduceSpeed()
	local vipLevel = UserInfo.vipLevel
	local produceSpeed = nil
	if vipLevel > 12 then
		produceSpeed = Vip[12].produceSpeed
	else
		produceSpeed = Vip[vipLevel].produceSpeed
	end

	return produceSpeed/100
end

--- 改造速度加成
function T.getVipReconstructSpeed()
	local vipLevel = UserInfo.vipLevel
	local reconstructSpeed = nil
	if vipLevel > 12 then
		reconstructSpeed = Vip[12].reconstructSpeed
	else
		reconstructSpeed = Vip[vipLevel].reconstructSpeed
	end

	return reconstructSpeed/100
end

--- 行军速度加成
function T.getVipMarchSpeed()
	local vipLevel = UserInfo.vipLevel
	local marchSpeed = nil
	if vipLevel > 12 then
		marchSpeed = Vip[12].marchSpeed
	else
		marchSpeed = Vip[vipLevel].marchSpeed
	end

	return marchSpeed
end

--- 科研速度加成
function T.getVipTechSpeed()
	local vipLevel = UserInfo.vipLevel
	local techSpeed = nil
	if vipLevel > 12 then
		techSpeed = Vip[12].techSpeed
	else
		techSpeed = Vip[vipLevel].techSpeed
	end

	return techSpeed/100
end






--- 关卡经验加成
function T.getVipCheckPointExp()
	local vipLevel = UserInfo.vipLevel
	local checkPointExp = nil
	if vipLevel > 12 then
		checkPointExp = Vip[12].checkPointExp
	else
		checkPointExp = Vip[vipLevel].checkPointExp
	end

	return checkPointExp
end

--- 充值钻石额度
function T.getVipNeedGems()
	local vipLevel = UserInfo.vipLevel
	local needGems = nil
	if vipLevel > 12 then
		needGems = Vip[12].needGems
	else
		needGems = Vip[vipLevel].needGems
	end

	return needGems
end

--- 等级点数数组(vip升级经验)
function T.getVipPointsData()
	local vipLevel = UserInfo.vipLevel
	local point = nil
	if vipLevel > 12 then
		point = Vip[12].point
	else
		point = Vip[vipLevel].point
	end

	return point
end

--- 得到铁矿加成
function T.getVipSteelAdd()
	local vipLevel = UserInfo.vipLevel
	local steelAdd = nil
	if vipLevel > 12 then
		steelAdd = Vip[12].steelAdd
	else
		steelAdd = Vip[vipLevel].steelAdd
	end

	return steelAdd/100
end

--- 得到石油加成
function T.getVipOilAdd()
	local vipLevel = UserInfo.vipLevel
	local oilAdd = nil
	if vipLevel > 12 then
		oilAdd = Vip[12].oilAdd
	else
		oilAdd = Vip[vipLevel].oilAdd
	end

	return oilAdd/100
end

--- 得到硅矿加成
function T.getVipSiliconAdd()
	local vipLevel = UserInfo.vipLevel
	local siliconAdd = nil
	if vipLevel > 12 then
		siliconAdd = Vip[12].siliconAdd
	else
		siliconAdd = Vip[vipLevel].siliconAdd
	end

	return siliconAdd/100
end

--- VIP对应联盟捐献次数
function T.getVipDonateNum()
	local vipLevel = UserInfo.vipLevel
	local donateNum = nil
	if vipLevel > 12 then
		donateNum = Vip[12].donateNum
	else
		donateNum = Vip[vipLevel].donateNum
	end

	return donateNum
end


--- 存储的是vip等级所影响的签到的每日签到:暂时为双倍,传的是每日签到的sid,type是奖励品类型，awardSid为（如果为飞机或者道具，是它的sid）
function T:getDailySignVip(sid,type,awardSid) -- 返回的是vip等级
	if sid == 1 then
		return nil
elseif sid == 2 then
	if type == "gems" then
		return 4,2
	end
elseif sid == 3 then
	if type == "props" and awardSid and awardSid == 200 then
		return 5,2
	end
elseif sid == 4 then
	if type == "props" and awardSid and awardSid == 204 then
		return 6,2
	end
elseif sid == 5 then
	if type == "gems" then
		return 7,3
	end
end


return nil
end


--- 存储的是vip等级所影响的签到的连续签到:暂时为双倍,传的是连续签到的sid
function T:getContinueSignVip(sid,type,awardSid)
	if sid == 1 then
		return nil
	elseif sid == 2 then
		return nil
	elseif sid == 3 then
		if type == "props" and awardSid and awardSid == 201 then
			return 8,3
		end
	elseif sid == 4 then
		if type == "props" and awardSid and awardSid == 200 then
			return 9,3
		end
	end


	return nil
end

--- 获取竞技场挑战点数购买次数限制
function T.getArenaChallengePointBuyLimit()
	local vipLevel = UserInfo.vipLevel
	local buyLimit = nil
	if vipLevel > 12 then
		buyLimit = Vip[12].arenaChallengePointBuyNum
	else
		buyLimit = Vip[vipLevel].arenaChallengePointBuyNum
	end

	return buyLimit
end

--- 获取补给线重置次数购买限制
function T.getSupplyLineBuyNumLimit()
	local vipLevel = UserInfo.vipLevel
	local buyLimit = nil
	if vipLevel > 12 then
		buyLimit = Vip[12].supplyLineBuyNum
	else
		buyLimit = Vip[vipLevel].supplyLineBuyNum
	end

	return buyLimit
end


return T
