--[[
 *	配件升级和改造主窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)

T.LevelUpView = require("src.app.uiScript.components.accessory.accessoryRefromAndLevelUp.LevelUpView")
T.ReformView = require("src.app.uiScript.components.accessory.accessoryRefromAndLevelUp.ReformView")

--- 构造函数
function T:ctor(tag,id)
    self.tag = tag
    self.id = id

    local function callBack1()
        self:levelUp()
    end

    local function callBack2()
        self:reform()
    end
    
    -- 创建2个
    local switchButtonContainer = SwitchButtonContainer.new()
    self:addChild(switchButtonContainer)
    REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
    switchButtonContainer:init()
    switchButtonContainer:initButtons(
        2,
        {{"viewSwitchButton_normal.png","viewSwitchButton_down.png"},{"viewSwitchButton_normal.png","viewSwitchButton_down.png"}},
        {110,15},
        {callBack1,callBack2},
        {Language:get("uc568"),Language:get("uc569")},
        tag
    )
    self.switchButtonContainer = switchButtonContainer

    self:setWindowTitle(Language:get("uc567"))

    if self.tag == 1 then
        self:levelUp()
    else
        self:reform()
    end
    

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
	AbstractWindow.onEnter(self)
end

function T:onExit()
    AbstractWindow.onExit(self)
end

function T:levelUp()
    if self.levelUpView == nil then
        self.levelUpView = self.LevelUpView.new(self.id)
        self:addChild(self.levelUpView)
        REL:relOther(self.levelUpView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.levelUpView:init()
    end

    if self.levelUpView then  
        self.levelUpView:setVisible(true)
    end

    if self.reformView then  
        self.reformView:setVisible(false)
    end
    
end

function T:reform()
    if self.levelUpView then  
        self.levelUpView:setVisible(false)
    end

    if self.reformView == nil then
        self.reformView = self.ReformView.new(self.id)
        self:addChild(self.reformView)
        REL:relOther(self.reformView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.reformView:init()
    end


    if self.reformView then  
        self.reformView:setVisible(true)
    end
    
end


return T