--[[
 *	升级视图
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor(id) -- 配件id 
    self.id = id
    self.levelUpType = 0  -- 升级类型，0是金币升级，1是道具,默认是0

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )


    self:getWidget()
    self:refreshData()


    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)

    -- 金币资源监听
    ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.refreshData)

    -- 道具209添加监听
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. 209,self,self.refreshData)

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)

    ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.refreshData)

    -- 道具209移除监听
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. 209,self,self.refreshData)


end

function T:getWidget()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    local accessoryInfos = accessoryBox.accessoryInfos

    local info = accessoryInfos[self.id]
    local tempData = Accessory_temp[info.sid]


    -- 右边背景
    local rightBack = ccui.ImageView:create()
    rightBack:loadTexture("accessoryStrengthfBottom.png",ccui.TextureResType.plistType)
    self:addChild(rightBack)
    REL:toOther("center","top",rightBack,self,0,-40)

    -- icon背景
    local iconBack = ccui.ImageView:create()
    iconBack:loadTexture("accessoryPropBottom.png",ccui.TextureResType.plistType)
    self:addChild(iconBack)
    REL:toOther("left","middle",iconBack,rightBack,-20,0)


    -- 右边图片
    local rise = ccui.ImageView:create()
    rise:loadTexture("rise.png",ccui.TextureResType.plistType)
    self:addChild(rise)
    REL:toOther("right","middle",rise,rightBack,20,0)

    -- icon
    local icon = ccui.ImageView:create()
    icon:loadTexture(IconManager.iconPath .. tempData.icon)
    self:addChild(icon)
    REL:toOther("center","middle",icon,iconBack,0,0)


    -- name
    local name = XMLLabel()
    name:setAlign("center","top")
    name:setContentSize(cc.size(400,36))
    self:addChild(name)
    REL:toOther("center","top",name,iconBack,0,160)
    name:setString(Language:get(tempData.name))

    local stepHeight = 45
    -- 改造等级
    local reLevel = XMLLabel()
    reLevel:setAlign("left","middle")
    reLevel:setContentSize(cc.size(400,36))
    self:addChild(reLevel)
    REL:toOther("left","middle",reLevel,rightBack,150,stepHeight)
    self.reLevel = reLevel


    -- 强化等级
    stepHeight = stepHeight - 30
    local level = XMLLabel()
    level:setAlign("left","middle")
    level:setContentSize(cc.size(400,36))
    self:addChild(level)
    REL:toOther("left","middle",level,rightBack,150,stepHeight)
    self.level = level

    -- 血量还是攻击加成
    stepHeight = stepHeight - 30
    local add = XMLLabel()
    add:setAlign("left","middle")
    add:setContentSize(cc.size(400,36))
    self:addChild(add)
    REL:toOther("left","middle",add,rightBack,150,stepHeight)
    self.add = add

    -- 是反克制，克制，暴免，还是暴伤加成
    local judge = false
    if info:getAntiRestraintAdd() > 0 or info:getRestraintAdd() > 0 or info:getViolenceFreeAdd() > 0 or info:getViolenceInjuryAdd() > 0 then
        judge = true
        stepHeight = stepHeight - 30
        local addOther = XMLLabel()
        addOther:setAlign("left","middle")
        addOther:setContentSize(cc.size(400,36))
        self:addChild(addOther)
        REL:toOther("left","middle",addOther,rightBack,150,stepHeight)
        self.addOther = addOther

    end

    -- 成功几率
    stepHeight = stepHeight - 30
    local successRate = XMLLabel()
    successRate:setAlign("left","middle")
    successRate:setContentSize(cc.size(400,36))
    self:addChild(successRate)
    REL:toOther("left","middle",successRate,rightBack,150,stepHeight)
    self.successRate = successRate


    -- 有可能有闪避或者命中加成
    local hitOrDodgeData = info:judgeHitOrDodge()
    if hitOrDodgeData then -- 如果有则要显示出来，只是改造等级没达到而已，达到则显示出来
        --if info:getHitAdd() > 0 or info:getDodgeAdd() > 0 then 
            stepHeight = stepHeight - 30
            local hitOrDodge = XMLLabel()
            hitOrDodge:setAlign("left","middle")
            hitOrDodge:setContentSize(cc.size(400,36))
            self:addChild(hitOrDodge)
            REL:toOther("left","middle",hitOrDodge,rightBack,150,stepHeight)
            self.hitOrDodge = hitOrDodge
       -- end

    end


    -- 强化按钮
    local btn = Button.new("false","true")
	btn:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
    btn:setString(Language:get("uc630"))
	self:addChild(btn)
	REL:toOther("center","bottom",btn,self,0,20)
    btn:setTextCenter()
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local level = info.level
            local playerLevel = UserInfo.level
            if playerLevel <= level then
                local descripe = Language:get("uc642")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } ) 
                return
            end

            if self.levelUpType == 0 then
                local costCoin = info:levelUpCost()
                local playerCoin = PlayerInstance:getGold()
                if costCoin <= playerCoin then
                    self:upGradeLogic()
                else -- 金币不足
                    local descripe = Language:get("uc636")
		            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                end

             else -- 消耗道具(209)
                local costPropsNum = info:levelUpCostAccessoryPropNums()
                local playerPropsNum = PropsInfoMgr:getPlayerPropByID(209)

                if costPropsNum <= playerPropsNum then
                    self:upGradeLogic()
                else -- 金币不足
                    local descripe = Language:get("uc1061")
		            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                end


              end



        end
    end)
    self.btn = btn


    -- 分割线
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(self:getContentSize().width - 20,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, self, 0, 300)

    -- icon
    local bluePrintSid = Accessory_temp[info.sid].bluePrintSid
    local allNum = PropsInfoMgr:getPlayerPropByID(bluePrintSid)
    local costProp = info:reformCost()
    local propData = Prop_temp[bluePrintSid]


    -- icon背景
    local reformIconBack = ccui.ImageView:create()
    reformIconBack:loadTexture("accessoryPropBottom.png",ccui.TextureResType.plistType)
    self:addChild(reformIconBack)
    REL:toOther("left","top",reformIconBack,self,20,350)


    local blueIcon = ccui.ImageView:create()
    blueIcon:loadTexture(IconManager.iconPath .. Prop_temp[1].propIcon)
    self:addChild(blueIcon)
    REL:toOther("center","middle",blueIcon,reformIconBack,0,0)


    -- 名字
    local blueName = XMLLabel()
    blueName:setAlign("left","middle")
    blueName:setContentSize(cc.size(400,36))
    self:addChild(blueName)
    REL:toOther("left","middle",blueName,reformIconBack,200,20)
    blueName:setString(Language:get("uc763"))

    -- 需求
    local blueNeed = XMLLabel()
    blueNeed:setAlign("left","middle")
    blueNeed:setContentSize(cc.size(400,36))
    self:addChild(blueNeed)
    REL:toOther("left","middle",blueNeed,reformIconBack,200,-20)
    self.blueNeed = blueNeed


    local chooseFrame0 = ccui.ImageView:create()
    chooseFrame0:loadTexture("checkBottom.png",ccui.TextureResType.plistType)
    self:addChild(chooseFrame0)
    REL:toOther("left","middle",chooseFrame0,reformIconBack,500,0)
    chooseFrame0:setTouchEnabled(true)
    chooseFrame0:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
            self.chooseImg0:setVisible(true)
            self.chooseImg1:setVisible(false)
            self.levelUpType = 0
        end
    end)
    self.chooseFrame0 = chooseFrame0

    local chooseImg0 = ccui.ImageView:create()
    chooseImg0:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(chooseImg0)
    REL:toOther("center","middle",chooseImg0,chooseFrame0,0,0)
    chooseImg0:setVisible(true) -- 默认是显示
    self.chooseImg0 = chooseImg0


    -----------------------------------------------------------------------------------------
    --道具icon
    local propIconBack = ccui.ImageView:create()
    propIconBack:loadTexture("accessoryPropBottom.png",ccui.TextureResType.plistType)
    self:addChild(propIconBack)
    REL:toOther("left","top",propIconBack,self,20,520)


    local propIcon = ccui.ImageView:create()
    propIcon:loadTexture(IconManager.iconPath .. Prop_temp[209].propIcon)
    self:addChild(propIcon)
    REL:toOther("center","middle",propIcon,propIconBack,0,0)
    self.propIcon = propIcon

    -- 名字
    local propName = XMLLabel()
    propName:setAlign("left","middle")
    propName:setContentSize(cc.size(400,36))
    self:addChild(propName)
    REL:toOther("left","middle",propName,propIconBack,200,20)
    propName:setString(Language:get("uc1063",Language:get(Prop_temp[209].prop)))

    -- 需求
    local propNeed = XMLLabel()
    propNeed:setAlign("left","middle")
    propNeed:setContentSize(cc.size(400,36))
    self:addChild(propNeed)
    REL:toOther("left","middle",propNeed,propIconBack,200,-20)
    self.propNeed = propNeed


    -- 成功率
    local propSuccess = XMLLabel()
    propSuccess:setAlign("left","top")
    propSuccess:setContentSize(cc.size(400,36))
    self:addChild(propSuccess)
    REL:toOther("left","top",propSuccess,propIconBack,200,100)
    --propSuccess:setString(Language:get("uc1062"))
    self.propSuccess = propSuccess



    local chooseFrame1 = ccui.ImageView:create()
    chooseFrame1:loadTexture("checkBottom.png",ccui.TextureResType.plistType)
    self:addChild(chooseFrame1)
    REL:toOther("left","middle",chooseFrame1,propIconBack,500,0)
    chooseFrame1:setTouchEnabled(true)
    chooseFrame1:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
            self.chooseImg0:setVisible(false)
            self.chooseImg1:setVisible(true)
            self.levelUpType = 1
        end
    end)
    self.chooseFrame1 = chooseFrame1

    local chooseImg1 = ccui.ImageView:create()
    chooseImg1:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(chooseImg1)
    REL:toOther("center","middle",chooseImg1,chooseFrame1,0,0)
    chooseImg1:setVisible(false) -- 默认是不显示
    self.chooseImg1 = chooseImg1

end

function T:upGradeLogic()
    local function finish(levelUpSuccess)
        if levelUpSuccess and levelUpSuccess == true then -- 强化成功
            local descripe = Language:get("uc637")
		    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
        else -- 强化失败
            local descripe = Language:get("uc638")
		    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
        end
    end
    Command:levelUpAccessory(self.levelUpType,self.id,finish)

end


function T:refreshData()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    local accessoryInfos = accessoryBox.accessoryInfos

    local info = accessoryInfos[self.id]
    local tempData = Accessory_temp[info.sid]

    self.reLevel:setString(Language:get("uc625",info.reLevel))
    if info.level == 60 then
        self.level:setString(Language:get("uc626",info.level))
        if info:getLifeAdd() > 0 then
            self.add:setString(Language:get("uc627",UnitConversion.handleDecimal(info:getLifeAdd()/100)))
        else
            self.add:setString(Language:get("uc628",UnitConversion.handleDecimal(info:getAttackAdd()/100)))
        end

        self.successRate:setVisible(false)
        self.btn:setVisible(false)

        self.blueNeed:setVisible(false)


        if info:getAntiRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc771",UnitConversion.handleDecimal(info:getAntiRestraintAdd()/100)))
        elseif info:getRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc772",UnitConversion.handleDecimal(info:getRestraintAdd()/100)))
        elseif info:getViolenceFreeAdd() > 0 then
            self.addOther:setString(Language:get("uc773",UnitConversion.handleDecimal(info:getViolenceFreeAdd()/100)))
        elseif info:getViolenceInjuryAdd() > 0 then
            self.addOther:setString(Language:get("uc774",UnitConversion.handleDecimal(info:getViolenceInjuryAdd()/100)))
        end

        self.propNeed:setVisible(false)
        self.propSuccess:setVisible(false)

        self.chooseFrame0:setVisible(false)
        self.chooseImg0:setVisible(false)
        self.chooseFrame1:setVisible(false)
        self.chooseImg1:setVisible(false)

    else
        self.level:setString(Language:get("uc631",info.level))
        if info:getLifeAdd() > 0 then
            self.add:setString(Language:get("uc632",UnitConversion.handleDecimal(info:getLifeAdd()/100),UnitConversion.handleDecimal(info:getLevelLifeAddDiff()/100)))
        else
            self.add:setString(Language:get("uc633",UnitConversion.handleDecimal(info:getAttackAdd()/100),UnitConversion.handleDecimal(info:getLevelAttackAddDiff()/100)))
        end
        self.successRate:setString(Language:get("uc629",UnitConversion.handleDecimal(info:getSuccessRate())))

        self.blueNeed:setVisible(true)

        local allCoin = PlayerInstance:getGold()
        local costCoin = info:levelUpCost()

        if allCoin < costCoin then
            self.blueNeed:setString(Language:get("uc762",UnitConversion.unitTrans(allCoin),UnitConversion.unitTrans(costCoin)))
        else
            self.blueNeed:setString(Language:get("uc643",UnitConversion.unitTrans(allCoin),UnitConversion.unitTrans(costCoin)))
        end


        if info:getAntiRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc775",UnitConversion.handleDecimal(info:getAntiRestraintAdd()/100),UnitConversion.handleDecimal(info:getLevelAntiRestraintAddDiff()/100)))
        elseif info:getRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc776",UnitConversion.handleDecimal(info:getRestraintAdd()/100),UnitConversion.handleDecimal(info:getLevelRestraintAddDiff()/100)))
        elseif info:getViolenceFreeAdd() > 0 then
            self.addOther:setString(Language:get("uc777",UnitConversion.handleDecimal(info:getViolenceFreeAdd()/100),UnitConversion.handleDecimal(info:getLevelViolenceFreeAddDiff()/100)))
        elseif info:getViolenceInjuryAdd() > 0 then
            self.addOther:setString(Language:get("uc778",UnitConversion.handleDecimal(info:getViolenceInjuryAdd()/100),UnitConversion.handleDecimal(info:getLevelViolenceInjuryAddDiff()/100)))
        end


        self.propNeed:setVisible(true)
        self.propSuccess:setVisible(true)

        local costPropsNum = info:levelUpCostAccessoryPropNums()
        local playerPropsNum = PropsInfoMgr:getPlayerPropByID(209)

        if playerPropsNum < costPropsNum then
            self.propNeed:setString(Language:get("uc762",playerPropsNum,costPropsNum))
            self.propIcon:setIsGray(true)
        else
            self.propNeed:setString(Language:get("uc643",playerPropsNum,costPropsNum))
            self.propIcon:setIsGray(false)
        end


    end

    if self.hitOrDodge then
        local hitOrDodgeData = info:judgeHitOrDodge()
        local addValue = 0
        if info:getHitAdd() > 0 then
            addValue = info:getHitAdd()
        else
            addValue = info:getDodgeAdd()
        end
        if addValue > 0 then
            self.hitOrDodge:setVisible(true)
            self.hitOrDodge:setString(Language:get(hitOrDodgeData.uc1,UnitConversion.handleDecimal(addValue)))
        else
            self.hitOrDodge:setVisible(false)
        end
    end


    


end




return T