--[[
 *	改造视图
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor(id) -- 配件id
    self.id = id
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    
    self:getWidget()
    self:refreshData()

    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)
end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)
end


function T:getWidget()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    local accessoryInfos = accessoryBox.accessoryInfos

    local info = accessoryInfos[self.id]
    local tempData = Accessory_temp[info.sid]

    
    -- 右边背景
    local rightBack = ccui.ImageView:create()
    rightBack:loadTexture("accessoryStrengthfBottom.png",ccui.TextureResType.plistType)
    self:addChild(rightBack)
    REL:toOther("center","top",rightBack,self,0,-40)

    -- icon背景
    local iconBack = ccui.ImageView:create()
    iconBack:loadTexture("accessoryPropBottom.png",ccui.TextureResType.plistType)
    self:addChild(iconBack)
    REL:toOther("left","middle",iconBack,rightBack,-20,0)

    -- 右边图片
    local rise = ccui.ImageView:create()
    rise:loadTexture("rise.png",ccui.TextureResType.plistType)
    self:addChild(rise)
    REL:toOther("right","middle",rise,rightBack,20,0)


    -- icon
    local icon = ccui.ImageView:create()
    icon:loadTexture(IconManager.iconPath .. tempData.icon)
    self:addChild(icon)
    REL:toOther("center","middle",icon,iconBack,0,0)


    -- name
    local name = XMLLabel()
    name:setAlign("center","top")
    name:setContentSize(cc.size(400,36))
    self:addChild(name)
    REL:toOther("center","top",name,iconBack,0,160)
    name:setString(Language:get(tempData.name))


    -- 改造等级
    local stepHeight = 35
    local reLevel = XMLLabel()
    reLevel:setAlign("left","middle")
    reLevel:setContentSize(cc.size(400,36))
    self:addChild(reLevel)
    REL:toOther("left","middle",reLevel,rightBack,150,stepHeight)
    self.reLevel = reLevel


    -- 强化等级
    stepHeight = stepHeight - 30
    local level = XMLLabel()
    level:setAlign("left","middle")
    level:setContentSize(cc.size(400,36))
    self:addChild(level)
    REL:toOther("left","middle",level,rightBack,150,stepHeight)
    self.level = level

    -- 血量还是攻击加成
    stepHeight = stepHeight - 30
    local add = XMLLabel()
    add:setAlign("left","middle")
    add:setContentSize(cc.size(400,36))
    self:addChild(add)
    REL:toOther("left","middle",add,rightBack,150,stepHeight)
    self.add = add

    -- 是反克制，克制，暴免，还是暴伤加成
    local judge = false
    if info:getAntiRestraintAdd() > 0 or info:getRestraintAdd() > 0 or info:getViolenceFreeAdd() > 0 or info:getViolenceInjuryAdd() > 0 then
        judge = true
        stepHeight = stepHeight - 30
        local addOther = XMLLabel()
        addOther:setAlign("left","middle")
        addOther:setContentSize(cc.size(400,36))
        self:addChild(addOther)
        REL:toOther("left","middle",addOther,rightBack,150,stepHeight)
        self.addOther = addOther

    end


    -- 有可能有闪避或者命中加成
    local hitOrDodgeData = info:judgeHitOrDodge()
    if hitOrDodgeData then
        --if info:getHitAdd() > 0 or info:getDodgeAdd() > 0 then
            stepHeight = stepHeight - 30
            local hitOrDodge = XMLLabel()
            hitOrDodge:setAlign("left","middle")
            hitOrDodge:setContentSize(cc.size(400,36))
            self:addChild(hitOrDodge)
            REL:toOther("left","middle",hitOrDodge,rightBack,150,stepHeight)
            self.hitOrDodge = hitOrDodge
        --end

    end

   
    -- 改造按钮
    local btn = Button.new("false","true")
	btn:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
    btn:setString(Language:get("uc634"))
	self:addChild(btn)
	REL:toOther("center","bottom",btn,self,0,20)
    btn:setTextCenter()
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local costProp = info:reformCost()
            local sid = Accessory_temp[info.sid].bluePrintSid
            local num = PropsInfoMgr:getPlayerPropByID(sid)

            if costProp <= num then
                local function finish()
                    local descripe = Language:get("uc640")
		            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                end

                Command:reformAccessory(self.id,finish)

            else -- 道具不足
                local descripe = Language:get("uc639")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            end

        end
    end)
    self.btn = btn

    
    ------ 需要的对应蓝图道具数量

    -- 分割线
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(self:getContentSize().width - 20,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, self, 0, 300)


    -- icon
    local bluePrintSid = Accessory_temp[info.sid].bluePrintSid
    local allNum = PropsInfoMgr:getPlayerPropByID(bluePrintSid)
    local costProp = info:reformCost()
    local propData = Prop_temp[bluePrintSid]


    -- 改造icon背景
    local reformIconBack = ccui.ImageView:create()
    reformIconBack:loadTexture("accessoryPropBottom.png",ccui.TextureResType.plistType)
    self:addChild(reformIconBack)
    REL:toOther("left","top",reformIconBack,self,20,350)


    local blueIcon = ccui.ImageView:create()
    blueIcon:loadTexture(IconManager.iconPath .. propData.propIcon)
    self:addChild(blueIcon)
    REL:toOther("center","middle",blueIcon,reformIconBack,0,0)


    -- 名字
    local blueName = XMLLabel()
    blueName:setAlign("left","middle")
    blueName:setContentSize(cc.size(400,36))
    self:addChild(blueName)
    REL:toOther("left","middle",blueName,reformIconBack,200,20)
    blueName:setString(Language:get("uc644",Language:get(propData.prop)))

    -- 需求
    local blueNeed = XMLLabel()
    blueNeed:setAlign("left","middle")
    blueNeed:setContentSize(cc.size(400,36))
    self:addChild(blueNeed)
    REL:toOther("left","middle",blueNeed,reformIconBack,200,-20)
    self.blueNeed = blueNeed
    blueNeed:setString(Language:get("uc643",allNum,costProp))



end

function T:refreshData()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    local accessoryInfos = accessoryBox.accessoryInfos

    local info = accessoryInfos[self.id]
    local tempData = Accessory_temp[info.sid]

    local bluePrintSid = Accessory_temp[info.sid].bluePrintSid
    local allNum = PropsInfoMgr:getPlayerPropByID(bluePrintSid)
    local costProp = info:reformCost()

    self.level:setString(Language:get("uc626",info.level))
    if info.reLevel == 5 then
        self.reLevel:setString(Language:get("uc625",info.reLevel))
        if info:getLifeAdd() > 0 then
            self.add:setString(Language:get("uc627",UnitConversion.handleDecimal(info:getLifeAdd()/100)))
        else
            self.add:setString(Language:get("uc628",UnitConversion.handleDecimal(info:getAttackAdd()/100)))
        end
        self.btn:setVisible(false)

        self.blueNeed:setVisible(false)

        if info:getAntiRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc771",UnitConversion.handleDecimal(info:getAntiRestraintAdd()/100)))
        elseif info:getRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc772",UnitConversion.handleDecimal(info:getRestraintAdd()/100)))
        elseif info:getViolenceFreeAdd() > 0 then
            self.addOther:setString(Language:get("uc773",UnitConversion.handleDecimal(info:getViolenceFreeAdd()/100)))
        elseif info:getViolenceInjuryAdd() > 0 then
            self.addOther:setString(Language:get("uc774",UnitConversion.handleDecimal(info:getViolenceInjuryAdd()/100)))
        end


        if self.hitOrDodge then
            local hitOrDodgeData = info:judgeHitOrDodge()
            local addValue = 0
            if info:getHitAdd() > 0 then
                addValue = info:getHitAdd()
            else
                addValue = info:getDodgeAdd()
            end
            if addValue > 0 then
                self.hitOrDodge:setVisible(true)
                self.hitOrDodge:setString(Language:get(hitOrDodgeData.uc1,UnitConversion.handleDecimal(addValue)))
            else
                self.hitOrDodge:setVisible(false)
            end
        end


    else
        self.reLevel:setString(Language:get("uc635",info.reLevel))
        if info:getLifeAdd() > 0 then
            self.add:setString(Language:get("uc632",UnitConversion.handleDecimal(info:getLifeAdd()/100),UnitConversion.handleDecimal(info:getReLevelLifeAddDiff()/100)))
        else
            self.add:setString(Language:get("uc633",UnitConversion.handleDecimal(info:getAttackAdd()/100),UnitConversion.handleDecimal(info:getReLevelAttackAddDiff()/100)))
        end

        self.btn:setVisible(true)

        if allNum < costProp then
            self.blueNeed:setString(Language:get("uc762",allNum,costProp))
        else
            self.blueNeed:setString(Language:get("uc643",allNum,costProp))
        end

        
        self.blueNeed:setVisible(true)

        if info:getAntiRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc775",UnitConversion.handleDecimal(info:getAntiRestraintAdd()/100),UnitConversion.handleDecimal(info:getReLevelAntiRestraintAddDiff()/100)))
        elseif info:getRestraintAdd() > 0 then
            self.addOther:setString(Language:get("uc776",UnitConversion.handleDecimal(info:getRestraintAdd()/100),UnitConversion.handleDecimal(info:getReLevelRestraintAddDiff()/100)))
        elseif info:getViolenceFreeAdd() > 0 then
            self.addOther:setString(Language:get("uc777",UnitConversion.handleDecimal(info:getViolenceFreeAdd()/100),UnitConversion.handleDecimal(info:getReLevelViolenceFreeAddDiff()/100)))
        elseif info:getViolenceInjuryAdd() > 0 then
            self.addOther:setString(Language:get("uc778",UnitConversion.handleDecimal(info:getViolenceInjuryAdd()/100),UnitConversion.handleDecimal(info:getReLevelViolenceInjuryAddDiff()/100)))
        end


        if self.hitOrDodge then
            local hitOrDodgeData = info:judgeHitOrDodge()
            local addValue = 0
            local addValue2 = 0
            if info:getHitAdd() > 0 or info:getReLevelHitAddDiff() > 0 then
                addValue = info:getHitAdd()
                addValue2 = info:getReLevelHitAddDiff()
            else
                addValue = info:getDodgeAdd()
                addValue2 = info:getReLevelDodgeAddDiff()
            end
            if addValue2 > 0 then
                self.hitOrDodge:setVisible(true)
                self.hitOrDodge:setString(Language:get(hitOrDodgeData.uc2,UnitConversion.handleDecimal(addValue),UnitConversion.handleDecimal(addValue2)))
            else
                self.hitOrDodge:setVisible(false)
            end
        end


    end




end


return T