--[[
 *	蓝图弹出窗口：制造并且装配
]]
local T = class("T",function() return ccui.Layout:create() end)

T.airType = nil -- 要安装的飞机类型
T.slotType = nil -- 要安装的槽位


--- 构造函数
function T:ctor(blueSid,airType,slotType)
    self.airType = airType
    self.slotType = slotType
    self.blueSid = blueSid

    self:init()
end

function T:init()
    self:setContentSize(cc.size(400,400))
    
    self:getWidget()

end

--- 得到控件
function T:getWidget()
    local propData = Prop_temp[self.blueSid]
    local accessorySid = propData.makeAccessSid

    local tempData = Accessory_temp[accessorySid]

    -- icon
    local icon = ccui.ImageView:create()
    icon:loadTexture(IconManager.iconPath .. tempData.icon)
    --icon:setScale(IconManager.baseScale[1],IconManager.baseScale[2])
    self:addChild(icon)
    REL:toOther("left","top",icon,self,0,20)

    -- name
    local name = XMLLabel()
    name:setAlign("center","top")
    name:setContentSize(cc.size(150,36))
    self:addChild(name)
    REL:toOther("center","top",name,icon,0,105)
    name:setString(Language:get(tempData.name))

    -- 改造等级
    local reLevel = XMLLabel()
    reLevel:setAlign("left","middle")
    reLevel:setContentSize(cc.size(400,36))
    self:addChild(reLevel)
    REL:toOther("left","middle",reLevel,icon,130,30)
    reLevel:setString(Language:get("uc589",0))

    -- 强化等级
    local level = XMLLabel()
    level:setAlign("left","middle")
    level:setContentSize(cc.size(400,36))
    self:addChild(level)
    REL:toOther("left","middle",level,icon,130,0)
    level:setString(Language:get("uc590",0))

    -- 血量还是攻击加成
    local add = XMLLabel()
    add:setAlign("left","middle")
    add:setContentSize(cc.size(400,36))
    self:addChild(add)
    REL:toOther("left","middle",add,icon,130,-30)

    if tempData.life > 0 then
        add:setString(Language:get("uc591",tempData.life))
    else
        add:setString(Language:get("uc592",tempData.attack))
    end

    -- 描述
    local info = Language:get("uc1050",Language:get(propData.prop))
    local describe = XMLLabel()
    describe:setAlign("center","middle")
    describe:setContentSize(cc.size(500,36))
    self:addChild(describe)
    REL:toOther("center","middle",describe,icon,140,-140)
    describe:setString(info)


    -- 取消
    local levelUp = Button.new("false","true")
	levelUp:setButtonState("longButton_gray_normal.png","longButton_general_down.png")
    levelUp:setString(Language:get("ug102"))
	self:addChild(levelUp)
	REL:toOther("left","bottom",levelUp,self,-20,20)
    levelUp:setTextShadow()
    levelUp:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.muialter2:hide()
        end
    end)

    -- 确定
    local reform = Button.new("false","true")
	reform:setButtonState("longButton_green_normal.png","longButton_general_down.png")
    reform:setString(Language:get("ug101"))
	self:addChild(reform)
	REL:toOther("right","bottom",reform,self,-20,20)
    reform:setTextShadow()
    reform:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function finish()
                self.muialter2:hide()
                local descripe = Language:get("uc1051")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            end
            Command:makeAndInstallAccessory(self.blueSid,self.airType,self.slotType,finish)

        end
    end)

end


--- 得到标题
function T:getTitle()
    local title = Language:get("uc1062")

    return title
end


function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end



return T