--[[
 *	配件系统主窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)

T.AccessoryInfoView = require("src.app.uiScript.components.accessory.accessorySystem.accessoryInfo.AccessoryInfoView")
T.SupplyLineView = require("src.app.uiScript.components.accessory.accessorySystem.supplyLine.SupplyLineView")
T.WarhouseView = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.WarhouseView")

--- 构造函数
function T:ctor()

    local function callBack1()
        self:accessoryInfo()
    end

    local function callBack2()
        self:supplyLine()
    end

    local function callBack3()
        self:warhouse()
    end


    -- 创建3个
    local switchButtonContainer = SwitchButtonContainer.new()
    self:addChild(switchButtonContainer)
    REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
    switchButtonContainer:init()
    switchButtonContainer:initButtons(
        3,
        {{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"}},
        {70,15},
        {callBack1,callBack2,callBack3},
        {Language:get("uc564"),Language:get("uc565"),Language:get("uc566")}
    )
    self.switchButtonContainer = switchButtonContainer

    self:setWindowTitle(Language:get("uc567"))

    self:accessoryInfo()

    self:updateBtn2()
    self:updateBtn1()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
	AbstractWindow.onEnter(self)

    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_STARNUN_CHANGE,self,self.updateBtn2)
    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_SUPPLY_LINE_FINISH,self,self.updateBtn2)
    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_RESET_ALL_POINT,self,self.updateBtn2)

    DailyStates:luaAddEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.updateBtn2)



    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaAddEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.updateBtn1)
    slotBox:luaAddEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.updateBtn1)
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.updateBtn1)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.updateBtn1)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,self,self.updateBtn1)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_PORT_ACCESSORY_REFRESH,self,self.updateBtn1)
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop,self,self.updateBtn1)


end

function T:onExit()
    AbstractWindow.onExit(self)

    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_STARNUN_CHANGE,self,self.updateBtn2)
    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_SUPPLY_LINE_FINISH,self,self.updateBtn2)
    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_RESET_ALL_POINT,self,self.updateBtn2)

    DailyStates:luaRemoveEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.updateBtn2)



    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaRemoveEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.updateBtn1)
    slotBox:luaRemoveEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.updateBtn1)
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.updateBtn1)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.updateBtn1)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,self,self.updateBtn1)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_PORT_ACCESSORY_REFRESH,self,self.updateBtn1)
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop,self,self.updateBtn1)


end

function T:accessoryInfo()
    if self.accessoryInfoView == nil then
        self.accessoryInfoView = self.AccessoryInfoView.new()
        self:addChild(self.accessoryInfoView)
        REL:relOther(self.accessoryInfoView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.accessoryInfoView:init()
    end

    if self.accessoryInfoView then  
        self.accessoryInfoView:setVisible(true)
    end

    if self.supplyLineView then  
        self.supplyLineView:setVisible(false)
    end
    
    if self.warhouseView then
        self.warhouseView:setVisible(false)
    end

end

function T:supplyLine()
    if self.accessoryInfoView then  
        self.accessoryInfoView:setVisible(false)
    end

    if self.supplyLineView == nil then
        self.supplyLineView = self.SupplyLineView.new()
        self:addChild(self.supplyLineView)
        REL:relOther(self.supplyLineView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.supplyLineView:init()
    end

    if self.supplyLineView then  
        self.supplyLineView:setVisible(true)
    end
    
    if self.warhouseView then
        self.warhouseView:setVisible(false)
    end

end

function T:warhouse()
    if self.accessoryInfoView then  
        self.accessoryInfoView:setVisible(false)
    end

    if self.supplyLineView then  
        self.supplyLineView:setVisible(false)
    end
    
    if self.warhouseView == nil then
        self.warhouseView = self.WarhouseView.new()
        self:addChild(self.warhouseView)
        REL:relOther(self.warhouseView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.warhouseView:init()
    end


    if self.warhouseView then
        self.warhouseView:setVisible(true)
    end

end

--- 更新补给线标识
function T:updateBtn2()
    self.switchButtonContainer:updateButton2Tag(SupplyLineManager:judgeIsAttack())
end

function T:updateBtn1()
    self.switchButtonContainer:updateButton1Tag(AccessorySystemManager:judgeIsHasAccessoryOrBlueInstall())
end


return T