--[[
 *	批量分解配件显示窗口
]]
local T = class("T",function() return ccui.Layout:create() end)


--- 构造函数
function T:ctor()
    self:init()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.quality0 = nil
    self.quality1 = nil
    self.quality2 = nil
    --self.quality3 = nil


    self:setContentSize(cc.size(400,400))
    self:getWidget()
end

--- 进入
function T:onEnter()
    local function decompose()
        self.muialter2:hide()
    end
    self.decompose = decompose
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,nil,self.decompose)

end

--- 退出
function T:onExit()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,nil,self.decompose)
end


--- 得到控件
function T:getWidget()
    
end

--- 得到控件
function T:getWidget()
    -- 请选择要装配的某一种飞机类型
    local des = XMLLabel()
    des:setAlign("center","top")
    des:setContentSize(cc.size(600,36))
    self:addChild(des)
    REL:toOther("center","top",des,self,0,10)
    des:setString(Language:get("uc618"))

    -- 配件品质0
    local chooseFrame0 = ccui.ImageView:create()
    chooseFrame0:loadTexture("checkBottom.png",ccui.TextureResType.plistType)
    self:addChild(chooseFrame0)
    REL:toOther("left","top",chooseFrame0,self,120,50)
    chooseFrame0:setTouchEnabled(true)
    chooseFrame0:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
            if self.chooseImg0:isVisible() == false then
                self.chooseImg0:setVisible(true)
                self.quality0 = 0
            else
                self.chooseImg0:setVisible(false)
                self.quality0 = nil
            end
        end
    end)

    local name0 = XMLLabel()
    name0:setAlign("left","middle")
    name0:setContentSize(cc.size(400,36))
    self:addChild(name0)
    REL:toOther("left","middle",name0,chooseFrame0,50,0)
    name0:setString(Language:get("uc585"))

    local chooseImg0 = ccui.ImageView:create()
    chooseImg0:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(chooseImg0)
    REL:toOther("center","middle",chooseImg0,chooseFrame0,0,0)
    chooseImg0:setVisible(false)
    self.chooseImg0 = chooseImg0
    
    local accessorySeqLine0 = ccui.ImageView:create()
    accessorySeqLine0:loadTexture("accessorySeqLine.png",ccui.TextureResType.plistType)
    self:addChild(accessorySeqLine0)
    REL:toOther("left","top",accessorySeqLine0,chooseFrame0,-15,25)


    -- 配件品质1
    local chooseFrame1 = ccui.ImageView:create()
    chooseFrame1:loadTexture("checkBottom.png",ccui.TextureResType.plistType)
    self:addChild(chooseFrame1)
    REL:toOther("left","top",chooseFrame1,self,120,100)
    chooseFrame1:setTouchEnabled(true)
    chooseFrame1:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
            if self.chooseImg1:isVisible() == false then
                self.chooseImg1:setVisible(true)
                self.quality1 = 1
            else
                self.chooseImg1:setVisible(false)
                self.quality1 = nil
            end
        end
    end)

    local name1 = XMLLabel()
    name1:setAlign("left","middle")
    name1:setContentSize(cc.size(400,36))
    self:addChild(name1)
    REL:toOther("left","middle",name1,chooseFrame1,50,0)
    name1:setString(Language:get("uc586"))

    local chooseImg1 = ccui.ImageView:create()
    chooseImg1:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(chooseImg1)
    REL:toOther("center","middle",chooseImg1,chooseFrame1,0,0)
    chooseImg1:setVisible(false)
    self.chooseImg1 = chooseImg1

    local accessorySeqLine1 = ccui.ImageView:create()
    accessorySeqLine1:loadTexture("accessorySeqLine.png",ccui.TextureResType.plistType)
    self:addChild(accessorySeqLine1)
    REL:toOther("left","top",accessorySeqLine1,chooseFrame1,-15,25)

    -- 配件品质2
    local chooseFrame2 = ccui.ImageView:create()
    chooseFrame2:loadTexture("checkBottom.png",ccui.TextureResType.plistType)
    self:addChild(chooseFrame2)
    REL:toOther("left","top",chooseFrame2,self,120,150)
    chooseFrame2:setTouchEnabled(true)
    chooseFrame2:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
            if self.chooseImg2:isVisible() == false then
                self.chooseImg2:setVisible(true)
                self.quality2 = 2
            else
                self.chooseImg2:setVisible(false)
                self.quality2 = nil
            end
        end
    end)

    local name2 = XMLLabel()
    name2:setAlign("left","middle")
    name2:setContentSize(cc.size(400,36))
    self:addChild(name2)
    REL:toOther("left","middle",name2,chooseFrame2,50,0)
    name2:setString(Language:get("uc587"))

    local chooseImg2 = ccui.ImageView:create()
    chooseImg2:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(chooseImg2)
    REL:toOther("center","middle",chooseImg2,chooseFrame2,0,0)
    chooseImg2:setVisible(false)
    self.chooseImg2 = chooseImg2

    local accessorySeqLine2 = ccui.ImageView:create()
    accessorySeqLine2:loadTexture("accessorySeqLine.png",ccui.TextureResType.plistType)
    self:addChild(accessorySeqLine2)
    REL:toOther("left","top",accessorySeqLine2,chooseFrame2,-15,25)

--    -- 配件品质3
--    local chooseFrame3 = ccui.ImageView:create()
--    chooseFrame3:loadTexture("back_gray.png",ccui.TextureResType.plistType)
--    self:addChild(chooseFrame3)
--    REL:toOther("left","top",chooseFrame3,self,20,200)
--    chooseFrame3:setTouchEnabled(true)
--    chooseFrame3:addTouchEventListener(function(sender, eventType)
--        if eventType == ccui.TouchEventType.ended then
--            AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
--            if self.chooseImg3:isVisible() == false then
--                self.chooseImg3:setVisible(true)
--                self.quality3 = 3
--            else
--                self.chooseImg3:setVisible(false)
--                self.quality3 = nil
--            end
--        end
--    end)

--    local name3 = XMLLabel()
--    name3:setAlign("left","middle")
--    name3:setContentSize(cc.size(400,36))
--    self:addChild(name3)
--    REL:toOther("left","middle",name3,chooseFrame3,40,0)
--    name3:setString(Language:get("uc588"))

--    local chooseImg3 = ccui.ImageView:create()
--    chooseImg3:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
--    self:addChild(chooseImg3)
--    REL:toOther("center","middle",chooseImg3,chooseFrame3,0,0)
--    chooseImg3:setVisible(false)
--    self.chooseImg3 = chooseImg3

    -- 全选按钮
    local chooseBtn = Button.new("false","true")
	chooseBtn:setButtonState("longButton_green_normal.png","longButton_general_down.png")
    chooseBtn:setString(Language:get("uc619"))
	self:addChild(chooseBtn)
	REL:toOther("left","bottom",chooseBtn,self,-20,20)
    chooseBtn:setTextShadow()
    chooseBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.quality0 == nil or self.quality1 == nil or self.quality2 == nil then
                self.quality0 = 0
                self.quality1 = 1
                self.quality2 = 2
                --self.quality3 = 3

                self.chooseImg0:setVisible(true)
                self.chooseImg1:setVisible(true)
                self.chooseImg2:setVisible(true)
                --self.chooseImg3:setVisible(true)
            else
                self.quality0 = nil
                self.quality1 = nil
                self.quality2 = nil
                --self.quality3 = nil

                self.chooseImg0:setVisible(false)
                self.chooseImg1:setVisible(false)
                self.chooseImg2:setVisible(false)
                --self.chooseImg3:setVisible(false)
            end
        end
    end)


    -- 确定按钮
    local btn = Button.new("false","true")
	btn:setButtonState("longButton_yellow_normal.png","longButton_general_down.png")
    btn:setString(Language:get("uc611"))
	self:addChild(btn)
	REL:toOther("right","bottom",btn,self,-20,20)
    btn:setTextShadow()
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            -- 判断选择的分解的品质是否可以分解
            local accessoryBox = AccessorySystemManager:getAccessoryBox()
            local quality = {quality0 = self.quality0,quality1 = self.quality1,quality2 = self.quality2,quality3 = nil}
            if accessoryBox:judgeIsBatchDecomposeAccessory(quality) then
                -- 弹出窗口
                local blueFrags = accessoryBox:getBatchDecomposeAccessoryBlueFragNum(quality)
                local decomposeCoin = accessoryBox:getBatchDecomposeAccessoryCoinsByQuality(quality)
                local layout = require("src.app.uiScript.components.accessory.accessorySystem.DecomposeShowWindow").new(blueFrags,{type = 1,typeValue = quality},decomposeCoin)
	            local muialter2 = MUIAlter.show(
		            {
			            title = Language:get("uc621"),
			            info = layout,
                        isShowCloseButton = true,
			            flag = 4,
			            callback = function(flag)
			            end
		            }
	            )
	            layout:setMUIAlter2(muialter2)


            else
                local descripe = Language:get("uc620")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

            end
        end
    end)


end

function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end



return T