--[[
 *	分解显示可获得的蓝图碎片显示，这里有2种情况
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 构造函数,参数 {{sid = 206,num = 20},{sid = 207,num = 30}}，可能有1个或者2个
--- 第2个参数是分解的类型decomposeType = { type = 1,typeValue = id} type=1:批量分解配件，值是品质表，type=2:分解单个配件，值是分解的id；decomposeCoin:分解的金币数
function T:ctor(blueFrags,decomposeType,decomposeCoin)
    self.blueFrags = blueFrags
    self.decomposeType = decomposeType
    self.decomposeCoin = decomposeCoin

    self:init()

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local num = #self.blueFrags
    if num == 1 then
        self:setContentSize(cc.size(400,400))
    else
        self:setContentSize(cc.size(400,400 + 80))
    end
    

    self:getWidget()

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    
end


--- 得到控件
function T:getWidget()
    local blueFrags = self.blueFrags
    local decomposeType = self.decomposeType

    -- 描述
    local des = XMLLabel()
    des:setAlign("center","top")
    des:setContentSize(cc.size(500,36))
    self:addChild(des)
    REL:toOther("center","top",des,self,0,30)
    des:setString(Language:get("uc622"))


    -- 显示蓝图碎片
    local num = #blueFrags
    for i = 1,num,1 do
        local data = Prop_temp[blueFrags[i].sid]

        local icon = ccui.ImageView:create()
        local iconPath = IconManager.iconPath
        icon:loadTexture(iconPath .. data.propIcon)
        icon:setScale(IconManager.baseScale[1],IconManager.baseScale[2])
        self:addChild(icon)
        REL:toOther("left","top",icon,self,20,(i - 1) * 80 +  120)

        -- 名字
        local labelName = XMLLabel()
        labelName:setContentSize(cc.size(300,36))
        labelName:setVAlign("middle")
        self:addChild(labelName)
        REL:toOther("left","middle",labelName,icon,80,20)
        labelName:setString(Language:get(data.prop))

        -- 数量
        local labelNum = XMLLabel()
        labelNum:setContentSize(cc.size(300,36))
        labelNum:setVAlign("middle")
        self:addChild(labelNum)
        REL:toOther("left","middle",labelNum,icon,80,-20)
        labelNum:setString(Language:get("uc624",blueFrags[i].num))

    end

    -- 加一个分解可得的金币显示
    if self.decomposeCoin > 0 then
        local data = Prop_temp[1]

        local coinIcon = ccui.ImageView:create()
        local iconPath = IconManager.iconPath
        coinIcon:loadTexture(iconPath .. data.propIcon)
        coinIcon:setScale(IconManager.baseScale[1],IconManager.baseScale[2])
        self:addChild(coinIcon)
        REL:toOther("left","top",coinIcon,self,20,(num + 1 - 1) * 80 +  120)

        -- 名字
        local coinName = XMLLabel()
        coinName:setContentSize(cc.size(300,36))
        coinName:setVAlign("middle")
        self:addChild(coinName)
        REL:toOther("left","middle",coinName,coinIcon,80,20)
        coinName:setString(Language:get("uc865"))

        -- 数量
        local coinNum = XMLLabel()
        coinNum:setContentSize(cc.size(300,36))
        coinNum:setVAlign("middle")
        self:addChild(coinNum)
        REL:toOther("left","middle",coinNum,coinIcon,80,-20)
        coinNum:setString(Language:get("uc864",UnitConversion.unitTrans(self.decomposeCoin)))
    end



    -- 确定按钮
    local btn = Button.new("false","true")
	btn:setButtonState("longButton_yellow_normal.png","longButton_general_down.png")
    btn:setString(Language:get("uc611"))
	self:addChild(btn)
	REL:toOther("left","bottom",btn,self,-20,20)
    btn:setTextShadow()
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function finish(awardData)
                self.muialter2:hide()
                -- 显示奖励品
                self.AwardDataDecoder:showSuccessWindow(awardData)

            end
            if decomposeType.type == 1 then
                Command:batchDecomposeAccessory(decomposeType.typeValue,finish)
            elseif decomposeType.type == 2 then
                Command:decomposeAccessory(decomposeType.typeValue,finish)
            end
        end
    end)


    -- 取消按钮
    local cancle = Button.new("false","true")
	cancle:setButtonState("longButton_gray_normal.png","longButton_general_down.png")
    cancle:setString(Language:get("uc623"))
	self:addChild(cancle)
	REL:toOther("right","bottom",cancle,self,-20,20)
    cancle:setTextShadow()
    cancle:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.muialter2:hide()
        end
    end)
end



function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end



return T