--[[
 *	配件信息view
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 翻页项
T.PageItem = require("src.app.uiScript.components.accessory.accessorySystem.accessoryInfo.PageItem")

--- 构造函数
function T:ctor()
    
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
    self.pageTag = 1

    self.index = 1 -- 标志是分页中的哪一个（从0到3）
    self.pageItem = {}

    
    self:addSwitch()
    self:addBack()
    self:addPageView()
    self:addPageBtn()
    self:refreshSwitch()

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    local pageItem = self.pageItem
    for k,v in pairs(pageItem) do
        if v then
            v:release()
        end
    end
end

function T:addBack()
    local dark = ccui.ImageView:create()
    dark:setScale(2)
    dark:loadTexture("dark.png",ccui.TextureResType.plistType)
    self:addChild(dark)
    REL:toOther("center","bottom",dark,self.switchBottom,-5,-90)


end


--- 添加翻页控件
function T:addPageView()
    local pageView = ccui.PageView:create()
    pageView:setTouchEnabled(true)
    pageView:setCustomScrollThreshold(60)
    self:addChild(pageView)
    REL:relOther(pageView,self,0,0,-15,0)
    self.pageView = pageView

--	pageView:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	pageView:setBackGroundColor(cc.c3b(0xff,0,0))
--	pageView:setBackGroundColorOpacity(100)
    

    for i = 1,4,1 do
        local pageItem = self.PageItem.new(i,self.switchBottom)
        pageItem:setContentSize(pageView:getContentSize())
        pageItem:init()
        if i == 1 then
            pageView:insertPage(pageItem,1)
        elseif i == 2 then
            pageView:insertPage(pageItem,2)
        elseif i == 3 then
            pageView:insertPage(pageItem,3)
        else
            pageView:insertPage(pageItem,0)
        end

        pageItem:retain()
        self.pageItem[#self.pageItem + 1] = pageItem
    end 


    Cocos2dxUtils:timeOut(function()    
        self.pageView:scrollToPage(1)
        self.pageView:update(10) -- 防止一开始进入页面的时候就有那个动画，要闪一下
    end,0)      -- 0表示1帧


    local function pageViewEvent(sender, eventType)
        if eventType == ccui.PageViewEventType.turning then
            local index = pageView:getCurPageIndex()
            self:sroll(index)
            self:refreshSwitch()
        end
    end 

    pageView:addEventListener(pageViewEvent)

end


-- 添加翻页按钮
function T:addPageBtn()
    local leftBtn = Button.new("false","false")
	leftBtn:setButtonState("arrowLeft.png","arrowLeft.png")
    self:addChild(leftBtn)
    REL:toOther("left","bottom",leftBtn,self.switchBottom,-225,160)
    leftBtn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.index = self.index - 1
            self:sroll(self.index)
            self:refreshSwitch()
        end
    end)
    self.leftBtn = leftBtn

    local rightBtn = Button.new("false","false")
	rightBtn:setButtonState("arrowRight.png","arrowRight.png")
    self:addChild(rightBtn)
    REL:toOther("right","bottom",rightBtn,self.switchBottom,-225,160)
    rightBtn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.index = self.index + 1
            self:sroll(self.index)
            self:refreshSwitch()
        end
    end)
    self.rightBtn = rightBtn
end

--- 传入index循环滚动
function T:sroll(index)
    local pageView = self.pageView
    if index == 2 then
        local page0 = pageView:getPage(0)
        pageView:removePageAtIndex(0) -- 必须这样写，因为每移除一个就刷新一次位置

        pageView:addPage(page0)
        self.pageView:scrollToPage(1)
        self.pageView:update(10)
    end

    if index == 0 then
        local page0 = pageView:getPage(0)
        local page1 = pageView:getPage(1)
        local page2 = pageView:getPage(2)
        local page3 = pageView:getPage(3)

        pageView:removePageAtIndex(0)
        pageView:removePageAtIndex(0)
        pageView:removePageAtIndex(0)
        pageView:removePageAtIndex(0)


        pageView:addPage(page3)
        pageView:addPage(page0)
        pageView:addPage(page1)
        pageView:addPage(page2)

        self.pageView:scrollToPage(1)
        self.pageView:update(10)
    end

    local index = pageView:getCurPageIndex()
    self.index = index

end

function T:addSwitch()
    local switchBottom = ccui.ImageView:create()
    switchBottom:loadTexture("switchBottom.png",ccui.TextureResType.plistType)
    self:addChild(switchBottom)
    REL:toOther("center","middle",switchBottom,self,0,-100)
    self.switchBottom = switchBottom

    self.swithItems = {}

    for i = 1,4,1 do
        local offset = 37 + 30 * (i - 1)
        local item = ccui.ImageView:create()
        item:loadTexture("switchNotHight.png",ccui.TextureResType.plistType)
        self:addChild(item)
        REL:toOther("left","middle",item,switchBottom,offset,0)
        self.swithItems[#self.swithItems + 1] = item
    end


end


function T:refreshSwitch()
    local pageItem = self.pageView:getPage(1)


    local type = pageItem.airType
    local swithItems = self.swithItems
    for i = 1,4,1 do
        if i == type then
            swithItems[i]:loadTexture("switchLight.png",ccui.TextureResType.plistType)
        else
            swithItems[i]:loadTexture("switchNotHight.png",ccui.TextureResType.plistType)
        end
 
    end

    if cc.PLATFORM_OS_ANDROID == C_PFM then
        if self.pageView:getCurPageIndex() == 1 then -- 安卓上加的
            return
        end
    end


    if self.pageTag > 2 and pageItem then -- 防止第一次加载的时候相对位置出错
        pageItem:updateAircraft()
    end

    self.pageTag = self.pageTag + 1

end


return T