--[[
 *	配件项:这种只在配件信息里面用
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 槽位信息
T.slotInfo = nil

--- 事件标志:1:表示未解锁，2:解锁后，没有安装配件并且这时没有配件可以安装并且没有蓝图可以制造了，3:解锁后没有安装配件，并且这时有配件可以安装；4:安装了配件;5:解锁后，没有安装配件并且这时没有配件可以安装,并且这时有蓝图可以制造并且安装
T.tag = nil


--- 构造函数
function T:ctor(slotInfo)
    self.slotInfo = slotInfo

    self:init()

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:getWidget()
    self:refreshData()
    self:addEvent()
end

--- 进入
function T:onEnter()
    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaAddEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.refreshData)
    slotBox:luaAddEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.refreshData)

    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,self,self.refreshData)

    accessoryBox:luaAddEventListener(accessoryBox.EVT_PORT_ACCESSORY_REFRESH,self,self.refreshData)

    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop,self,self.refreshData)

end

--- 退出
function T:onExit()
    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaRemoveEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.refreshData)
    slotBox:luaRemoveEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.refreshData)


    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,self,self.refreshData)

    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_PORT_ACCESSORY_REFRESH,self,self.refreshData)

    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop,self,self.refreshData)

end

--- 得到控件
function T:getWidget()
    self:setContentSize(cc.size(100,100))

    -- 背景图片icon
    local icon = ccui.ImageView:create()
    icon:loadTexture("accessoryLockBottom.png",ccui.TextureResType.plistType)
    --icon:setScale(IconManager.baseScale[1],IconManager.baseScale[2])
    self:addChild(icon)
    REL:toOther("center","middle",icon,self,0,0)
    self.icon = icon

    -- 锁的图片
    local lockImg = ccui.ImageView:create()
    lockImg:loadTexture("accessoryLock.png",ccui.TextureResType.plistType)
    self:addChild(lockImg)
    REL:toOther("center","middle",lockImg,icon,0,0)
    self.lockImg = lockImg

    -- 锁的限制等级
    local lockLevel = XMLLabel()
    lockLevel:setAlign("center","bottom")
    lockLevel:setContentSize(cc.size(200,36))
    self:addChild(lockLevel)
    REL:toOther("center","bottom",lockLevel,icon,0,2)
    self.lockLevel = lockLevel
    
    -- 右上角红点点
    local rightRed = ccui.ImageView:create()
    rightRed:loadTexture("redTip.png",ccui.TextureResType.plistType)
    self:addChild(rightRed)
    REL:toOther("right","top",rightRed,icon,-10,-10)
    self.rightRed = rightRed

    -- 左上角改造等级图片
    local reLevelImg = ccui.ImageView:create()
    reLevelImg:loadTexture("levelBottom2.png",ccui.TextureResType.plistType)
    self:addChild(reLevelImg)
    REL:toOther("left","top",reLevelImg,icon,-5,-5)
    self.reLevelImg = reLevelImg

    -- 左上角改造等级字
    local reLevel = XMLLabel()
    reLevel:setAlign("center","middle")
    reLevel:setContentSize(cc.size(200,36))
    self:addChild(reLevel)
    REL:toOther("center","middle",reLevel,reLevelImg,0,0)
    self.reLevel = reLevel

    -- 右下角等级背景图片
    local levelImg = ccui.ImageView:create()
    levelImg:loadTexture("levelBottom1.png",ccui.TextureResType.plistType)
    self:addChild(levelImg)
    REL:toOther("right","bottom",levelImg,icon,0,0)
    self.levelImg = levelImg

    -- 右下角配件等级
    local level = XMLLabel()
    level:setAlign("center","middle")
    level:setContentSize(cc.size(200,36))
    self:addChild(level)
    REL:toOther("center","middle",level,levelImg,0,0)
    self.level = level

end


--- 刷新数据
function T:refreshData()
    local slotInfo = self.slotInfo

    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    local accessoryInfos = accessoryBox.accessoryInfos

    local playerLevel = UserInfo.level
    local lockLevel = slotInfo:getLockLevel()
    local id = slotInfo.id

    if playerLevel < lockLevel then     -- 未解锁
        self.tag = 1
        self.lockImg:setVisible(true)
        self.lockLevel:setVisible(true)
        self.rightRed:setVisible(false)
        self.reLevelImg:setVisible(false)
        self.reLevel:setVisible(false)
        self.level:setVisible(false)
        self.levelImg:setVisible(false)

        self.lockLevel:setString(Language:get("uc580",lockLevel))
        self.icon:loadTexture("accessoryLockBottom.png",ccui.TextureResType.plistType)

    else                                -- 解锁
        if id == 0 then                 -- 没有安装配件
            self.lockImg:setVisible(false)
            self.lockLevel:setVisible(false)
            self.reLevelImg:setVisible(false)
            self.reLevel:setVisible(false)
            self.level:setVisible(false)
            self.levelImg:setVisible(false)

            self.icon:loadTexture("accessoryLockBottom.png",ccui.TextureResType.plistType)
            -- 判断是否有配件可以安装
            if accessoryBox:getStrongestAccessory(slotInfo.slotType) == nil then
                -- 判断是否有蓝图可以制造
                local blueSids = slotInfo.blueSids
                local temp = {{},{},{},{}}
                for i = 1,4,1 do
                    local tables = PropsInfoMgr:getAllBluePrintSidsBySid(blueSids[i])
                    if tables then
                        temp[i] = tables
                    end
                end

                local list = {}
                for i = 1,4,1 do
                    if #temp[i] > 0 then
                        for k,v in pairs(temp[i]) do
                            if v then
                                list[#list + 1] = v  -- sid

                            end
                        end
                    end

                end

                if #list > 0 then
                    table.sort(list,function(a,b)
		                return a > b
	                end)

                    self.blueSid = list[1]
                    self.tag = 5
                    self.rightRed:setVisible(true)
                else             
                    self.tag = 2
                    self.rightRed:setVisible(false)
                end

            else
                self.tag = 3
                self.rightRed:setVisible(true)

            end

        else                            -- 安装了配件
            self.tag = 4
            self.lockImg:setVisible(false)
            self.lockLevel:setVisible(false)
            self.rightRed:setVisible(false)
            self.reLevelImg:setVisible(true)
            self.reLevel:setVisible(true)
            self.level:setVisible(true)
            self.levelImg:setVisible(true)

            local accessoryInfo = accessoryInfos[id]
            local reLevel = accessoryInfo.reLevel
            local level = accessoryInfo.level

            self.reLevel:setString(Language:get("uc581",reLevel))
            self.level:setString(Language:get("uc582",level))
            self.icon:loadTexture(IconManager.iconPath .. Accessory_temp[accessoryInfo.sid].icon)

        end
    end

end

function T:addEvent()
    self:setTouchEnabled(true)
    BaseButton:extend(self)

    self:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.tag == 1 then                
                local lockLevel = self.slotInfo:getLockLevel()
                local descripe = Language:get("uc583",lockLevel)
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            elseif self.tag == 2 then                
                local layout = require("src.app.uiScript.components.accessory.accessorySystem.accessoryInfo.InstallAccessoryChoosePopWindow").new(1,id,1,self.slotInfo.airType,self.slotInfo.slotType)
	            local muialter2 = MUIAlter.show(
		            {
			            title = Language:get("uc757"),
			            info = layout,
                        isShowCloseButton = true,
			            flag = 4,
			            callback = function(flag)
			            end
		            }
	            )
	            layout:setMUIAlter2(muialter2)
            elseif self.tag == 3 then
                local accessoryBox = AccessorySystemManager:getAccessoryBox()
                local id = accessoryBox:getStrongestAccessory(self.slotInfo.slotType).id

                local layout = require("src.app.uiScript.components.accessory.accessorySystem.AccessoryPopWindow").new(1,id,1,self.slotInfo.airType,self.slotInfo.slotType)
	            local muialter2 = MUIAlter.show(
		            {
			            title = layout:getTitle(),
			            info = layout,
                        isShowCloseButton = true,
			            flag = 4,
			            callback = function(flag)
			            end
		            }
	            )
	            layout:setMUIAlter2(muialter2)
            elseif self.tag == 4 then
                local layout = require("src.app.uiScript.components.accessory.accessorySystem.AccessoryPopWindow").new(1,self.slotInfo.id,2,self.slotInfo.airType,self.slotInfo.slotType)
	            local muialter2 = MUIAlter.show(
		            {
			            title = layout:getTitle(),
			            info = layout,
                        isShowCloseButton = true,
			            flag = 4,
			            callback = function(flag)
			            end
		            }
	            )
	            layout:setMUIAlter2(muialter2)
            elseif self.tag == 5 then
--                local sid = self.blueSid
--                local propData = Prop_temp[sid]

--                local info = Language:get("uc1050",Language:get(propData.prop))
--                local function confirm()
--                    local function finish()
--                        local descripe = Language:get("uc1051")
--		                MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
--                    end
--                    Command:makeAndInstallAccessory(sid,self.slotInfo.airType,self.slotInfo.slotType,finish)

--                end
--                MUIPop.MUIImmediate(info,confirm)

                local layout = require("src.app.uiScript.components.accessory.accessorySystem.AccessoryMakeAndInstallWindow").new(self.blueSid,self.slotInfo.airType,self.slotInfo.slotType)
	            local muialter2 = MUIAlter.show(
		            {
			            title = layout:getTitle(),
			            info = layout,
                        isShowCloseButton = true,
			            flag = 4,
			            callback = function(flag)
			            end
		            }
	            )
	            layout:setMUIAlter2(muialter2)


            end
            
        end
    end)

end


return T