--[[
 *	page项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 飞机类型
T.airType = nil

--- 配件项
T.AccessoryItem = require("src.app.uiScript.components.accessory.accessorySystem.accessoryInfo.AccessoryItem")

--- 构造函数
function T:ctor(airType,switchBottom)
    self.switchBottom = switchBottom     -- 翻页底部框
    self.airType = airType

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
    
    --- 每个飞机类型的数据
    self.airTypeData = { 
                            {name = Language:get("uc576"),airSid = 13},{name = Language:get("uc577"),airSid = 14},
                            {name = Language:get("uc578"),airSid = 15},{name = Language:get("uc579"),airSid = 16} 
                        }

    --- 每个槽位的数据槽位从左下到右边，1到6:生命，攻击，反克制，克制，暴免，暴伤； 还有一个名字在图片的后面
    --- 左边和底部，距离switchBottom
    self.slotData = {
                        {name = Language:get("uc570"),posLeft = -195,posTop = 30},{ name = Language:get("uc571"),posLeft = -205,posTop = 285},
                        {name = Language:get("uc959"),posLeft = -55,posTop = 405},{ name = Language:get("uc960"),posLeft = 132,posTop = 405},
                        {name = Language:get("uc961"),posLeft = 285,posTop = 285},{ name = Language:get("uc962"),posLeft = 260,posTop = 30}
                     }

    

    self:initWidget()
    self:addSlotItem()
    self:initBottom()
    self:refreshBottomData()
end

--- 进入
function T:onEnter()
    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaAddEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.refreshBottomData)
    slotBox:luaAddEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.refreshBottomData)

    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshBottomData)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshBottomData)
end

--- 退出
function T:onExit()
    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaRemoveEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.refreshBottomData)
    slotBox:luaRemoveEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.refreshBottomData)

    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshBottomData)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshBottomData)

end

--- 初始化控件
function T:initWidget()
    local airTypeData = self.airTypeData

    -- 名字
    local name = XMLLabel()
    name:setContentSize(cc.size(400,36))
    name:setAlign("center","bottom")
    self:addChild(name)
    if V_SZ.height > 960 then -- iphone 1920 还没考虑呢
        REL:toOther("center","bottom",name,self.switchBottom,0,532)
    else
        REL:toOther("center","bottom",name,self.switchBottom,0,502)
    end
    name:setString(airTypeData[self.airType].name)

    -- 战机icon
--    local iconPath = IconManager.iconPath
--	local data = Aircraft_temp[airTypeData[self.airType].airSid]
--	local iconUrl = data.picUrl
--	local airIcon = cc.Sprite:create()
--	airIcon:setSpriteFrame(ResLoader:getSpriteFrame(iconUrl .."_2.png"))
--	self:addChild(airIcon)
--	REL:toOther("center","top",airIcon,self,0,200)
    

    -- 战机icon上的accesoryBack
    local accesoryBack = ccui.ImageView:create()
    accesoryBack:loadTexture("accesoryBack.png",ccui.TextureResType.plistType)
    self:addChild(accesoryBack,101)
    REL:toOther("center","bottom",accesoryBack,self.switchBottom,0,65)
    self.accesoryBack = accesoryBack

    self:updateAircraft()

end

--- 添加槽位
function T:addSlotItem()
    local slotData = self.slotData

    local slotBox = AccessorySystemManager:getSlotBox()

    local slotInfos = slotBox.slotInfos[self.airType]

    for i = 1,6,1 do
        local accessoryItem = self.AccessoryItem.new(slotInfos[i])
        self:addChild(accessoryItem)
        REL:toOther("left","bottom",accessoryItem,self.switchBottom,slotData[i].posLeft,slotData[i].posTop)

        -- 名字
        local name = XMLLabel()
        name:setCssStyle(CssStyles.default22)
        name:setContentSize(cc.size(300,36))
        self:addChild(name,1000000 - 1)
        name:setString(slotData[i].name)
        --name:setLocalZOrder(1000000 - 1)

        if i == 1 then
            name:setContentSize(cc.size(300,36))
            name:setAlign("left","bottom")
            REL:toOther("left","bottom",name,accessoryItem,105,10)
        elseif i == 2 then
            name:setContentSize(cc.size(300,36))
            name:setAlign("left","bottom")
            REL:toOther("left","bottom",name,accessoryItem,105,10)
        elseif i == 3 then
            name:setContentSize(cc.size(300,36))
            name:setAlign("center","top")
            REL:toOther("center","top",name,accessoryItem,0,105)
        elseif i == 4 then
            name:setContentSize(cc.size(300,36))
            name:setAlign("center","top")
            REL:toOther("center","top",name,accessoryItem,0,105)
        elseif i == 5 then
            name:setContentSize(cc.size(300,36))
            name:setAlign("right","top")
            REL:toOther("right","top",name,accessoryItem,-10,105)
        elseif i == 6 then
            name:setContentSize(cc.size(300,36))
            name:setAlign("right","top")

	        name:updateView()
	        local contentWidth = name:getTextWidth()
            if contentWidth > 220 then
                REL:toOther("right","top",name,accessoryItem,-20,105)
            else
                REL:toOther("right","top",name,accessoryItem,-10,105)
            end

        end

    end

end

--- 初始化底部
function T:initBottom()
    local iconPath = IconManager.iconPath
    local resScale = IconManager.resScale
    
    -- 背景图片
    local backFrame = ResLoader:getSpriteFrame("taskMainFrame.png")
    local backSize = backFrame:getOriginalSize()
    local back = Scale9Sprite:createWithFrame(backFrame,cc.rect(backSize.width/2,backSize.height/2,1,1))
    back:setContentSize(cc.size(backSize.width,backSize.height + 30))
    self:addChild(back)
    REL:toOther("center","bottom",back,self,0,20)

    -- 增加属性
    local title = XMLLabel()
    title:setContentSize(cc.size(300,36))
    title:setAlign("center","top")
    self:addChild(title)
    REL:toOther("center","top",title,back,0,15)
    title:setString(Language:get("uc671"))

    -- 反克制
    local antiRestraintImg = ccui.ImageView:create()
    antiRestraintImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[7].icon)
    antiRestraintImg:setScale(resScale[1],resScale[2])
    self:addChild(antiRestraintImg)
    REL:toOther("center","bottom",antiRestraintImg,back,-70,20)

    local antiRestraintName = XMLLabel()
    antiRestraintName:setContentSize(cc.size(300,36))
    antiRestraintName:setAlign("left","middle")
    self:addChild(antiRestraintName)
    REL:toOther("left","middle",antiRestraintName,antiRestraintImg,60,15)
    antiRestraintName:setString(Language:get("uc672"))

    local antiRestraint = XMLLabel()
    antiRestraint:setContentSize(cc.size(300,36))
    antiRestraint:setAlign("left","middle")
    self:addChild(antiRestraint)
    REL:toOther("left","middle",antiRestraint,antiRestraintImg,60,-15)
    self.antiRestraint = antiRestraint


    -- 克制
    local restraintImg = ccui.ImageView:create()
    restraintImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[8].icon)
    restraintImg:setScale(resScale[1],resScale[2])
    self:addChild(restraintImg)
    REL:toOther("center","bottom",restraintImg,back,-70,100)

    local restraintName = XMLLabel()
    restraintName:setContentSize(cc.size(300,36))
    restraintName:setAlign("left","middle")
    self:addChild(restraintName)
    REL:toOther("left","middle",restraintName,restraintImg,60,15)
    restraintName:setString(Language:get("uc673"))

    local restraint = XMLLabel()
    restraint:setContentSize(cc.size(300,36))
    restraint:setAlign("left","middle")
    self:addChild(restraint)
    REL:toOther("left","middle",restraint,restraintImg,60,-15)
    self.restraint = restraint

    -- 生命
    local hpImg = ccui.ImageView:create()
    hpImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[5].icon)
    hpImg:setScale(resScale[1],resScale[2])
    self:addChild(hpImg)
    REL:toOther("left","bottom",hpImg,back,20,20)

    local hpName = XMLLabel()
    hpName:setContentSize(cc.size(300,36))
    hpName:setAlign("left","middle")
    self:addChild(hpName)
    REL:toOther("left","middle",hpName,hpImg,60,15)
    hpName:setString(Language:get("uc674"))

    local hp = XMLLabel()
    hp:setContentSize(cc.size(300,36))
    hp:setAlign("left","middle")
    self:addChild(hp)
    REL:toOther("left","middle",hp,hpImg,60,-15)
    self.hp = hp

    -- 攻击
    local attackImg = ccui.ImageView:create()
    attackImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[2].icon)
    attackImg:setScale(resScale[1],resScale[2])
    self:addChild(attackImg)
    REL:toOther("left","bottom",attackImg,back,20,100)

    local attackName = XMLLabel()
    attackName:setContentSize(cc.size(300,36))
    attackName:setAlign("left","middle")
    self:addChild(attackName)
    REL:toOther("left","middle",attackName,attackImg,60,15)
    attackName:setString(Language:get("uc675"))

    local attack = XMLLabel()
    attack:setContentSize(cc.size(300,36))
    attack:setAlign("left","middle")
    self:addChild(attack)
    REL:toOther("left","middle",attack,attackImg,60,-15)
    self.attack = attack

    -- 暴免
    local violenceFreeImg = ccui.ImageView:create()
    violenceFreeImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[9].icon)
    violenceFreeImg:setScale(resScale[1],resScale[2])
    self:addChild(violenceFreeImg)
    REL:toOther("right","bottom",violenceFreeImg,back,150,20)

    local violenceFreeName = XMLLabel()
    violenceFreeName:setContentSize(cc.size(300,36))
    violenceFreeName:setAlign("left","middle")
    self:addChild(violenceFreeName)
    REL:toOther("left","middle",violenceFreeName,violenceFreeImg,60,15)
    violenceFreeName:setString(Language:get("uc676"))


    local violenceFree = XMLLabel()
    violenceFree:setContentSize(cc.size(300,36))
    violenceFree:setAlign("left","middle")
    self:addChild(violenceFree)
    REL:toOther("left","middle",violenceFree,violenceFreeImg,60,-15)
    self.violenceFree = violenceFree

    -- 暴伤
    local violenceInjuryImg = ccui.ImageView:create()
    violenceInjuryImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[10].icon)
    violenceInjuryImg:setScale(resScale[1],resScale[2])
    self:addChild(violenceInjuryImg)
    REL:toOther("right","bottom",violenceInjuryImg,back,150,100)

    local violenceInjuryName = XMLLabel()
    violenceInjuryName:setContentSize(cc.size(300,36))
    violenceInjuryName:setAlign("left","middle")
    self:addChild(violenceInjuryName)
    REL:toOther("left","middle",violenceInjuryName,violenceInjuryImg,60,15)
    violenceInjuryName:setString(Language:get("uc677"))

    local violenceInjury = XMLLabel()
    violenceInjury:setContentSize(cc.size(300,36))
    violenceInjury:setAlign("left","middle")
    self:addChild(violenceInjury)
    REL:toOther("left","middle",violenceInjury,violenceInjuryImg,60,-15)
    self.violenceInjury = violenceInjury


end

--- 刷新底部数据
function T:refreshBottomData()
    self.antiRestraint:setString(Language:get("uc600",UnitConversion.handleDecimal(AccessorySystemManager:getAllAntiRestraintAddByAirType(self.airType))))
    self.restraint:setString(Language:get("uc600",UnitConversion.handleDecimal(AccessorySystemManager:getAllRestraintByAirAddType(self.airType))))
    self.hp:setString(Language:get("uc600",UnitConversion.handleDecimal(AccessorySystemManager:getAllLifeAddByAirType(self.airType))))
    self.attack:setString(Language:get("uc600",UnitConversion.handleDecimal(AccessorySystemManager:getAllAttackAddByAirType(self.airType))))
    self.violenceFree:setString(Language:get("uc600",UnitConversion.handleDecimal(AccessorySystemManager:getAllViolenceFreeAddByAirType(self.airType))))
    self.violenceInjury:setString(Language:get("uc600",UnitConversion.handleDecimal(AccessorySystemManager:getAllViolenceInjuryAddByAirType(self.airType))))
end

--- 更新战机显示
function T:updateAircraft()
    local sid = self.airTypeData[self.airType].airSid
	if self.airIcon then
		self.airIcon:removeFromParent()
	end

	local T=GameUtils:getAicraftModelUrl(Camp.CAMP2,sid)
	if T then
		local o=T()
		o:setScale(1.5)
		self:addChild(o,100)
        if self.airType == 4 then
            REL:toOther("center","bottom",o,self.switchBottom,30,200)
        else
            REL:toOther("center","bottom",o,self.switchBottom,0,200)
        end
		
        --self.accesoryBack:setLocalZOrder(101)
        --o:setLocalZOrder(100)

		self.airIcon=o
	end
end


return T