--[[
 *	补给线项
]]
local T = class("T",function() return ccui.Layout:create() end)


--- 构造函数
function T:ctor(sid)
    self.sid = sid -- 补给线sid

    self.stars = {} -- 星级图片控件

    self:init()
end


function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local _widget = ListItem4.new()
    self.size = _widget:getContentSize()
    self:setContentSize(self.size)
    _widget:setListItemAttribute(
        nil,
        nil,
        {{"infoButton_normal.png","iconButton_general_down.png","false","false"},{"buttonAim_normal.png","iconButton_general_down.png","false","false"}}
    )
    self:addChild(_widget)
    REL:toOther("left","top",_widget,self,0,0)
    self._widget = _widget

    -- 得到的控件
    self:GetWidget()
    self:setStar()
    self:createLockIcon()

    -- 设置数据
    self:SetData()

    self:setButton()

    -- 刷新星级
    self:refreshStar()

    -- 刷新是否可以攻打按钮
    self:refreshIsAttack()

    self:refreshLockIcon()

end

--- 进入
function T:onEnter()
    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_STARNUN_CHANGE .. self.sid,self,self.refreshStar)
    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_SUPPLY_LINE_FINISH .. self.sid,self,self.refreshIsAttack)
    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_RESET_ALL_POINT,self,self.resetPoint)

    DailyStates:luaAddEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.resetPoint)
end

--- 退出
function T:onExit()
    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_STARNUN_CHANGE .. self.sid,self,self.refreshStar)
    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_SUPPLY_LINE_FINISH .. self.sid,self,self.refreshIsAttack)
    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_RESET_ALL_POINT,self,self.resetPoint)

    DailyStates:luaRemoveEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.resetPoint)
end


function T:GetWidget()
    -- 资源头像
    self.imgHead = self._widget.leftHead
    
    -- 信息按钮
    self.infoBtn = self._widget.button1

    -- 进攻按钮
    self.attackBtn = self._widget.button2
    
    -- 标题
    self.title = self._widget.title
    

end


function T:SetData()
    local tempData = SupplyLine_temp[self.sid]

    local iconPath = IconManager.iconPath
    self.imgHead:loadTexture(iconPath .. Aircraft_temp[self.sid].icon)  -- 先暂时用飞机的图片

    self._widget:setString(self.title,Language:get(tempData.name))

end

--- 星级
function T:setStar()
    for i = 1,3,1 do
        local starImg = ccui.ImageView:create()
        starImg:loadTexture("star_enabled.png",ccui.TextureResType.plistType)
        self:addChild(starImg)
        local left = (i - 1) * 40 + 200
        REL:toOther("left","middle",starImg,self,left,-10)
        self.stars[#self.stars + 1] = starImg
    end


end

function T:setButton()
    local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
            if sender == self.infoBtn then
                local info = self:getDes()
                MUIAlter_noTitle.show(
                    {
                        info = info,
                        flag = 4,
                    }
                )
            else
                local playerLevel = UserInfo.level
                local openLevel = SupplyLine_temp[self.sid].openLevel
                if playerLevel >= SupplyLine_temp[self.sid].openLevel then -- 解锁了
                    local data = {}
                    data.id = self.sid
                    local armyWindow = require("src.app.uiScript.components.army.ArmyWindow").new({ ["tag"] = 5, ["detailInfo"] = data })
		            WindowManager:push(armyWindow)
                else
                    local descripe = Language:get("uc716",openLevel)
				    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

                end


            end
        end
    end

    self.infoBtn:addTouchEventListener(callback)
	self.attackBtn:addTouchEventListener(callback)

end


-- 刷新星级
function T:refreshStar()
    local starNum = SupplyLineManager:getSupplyInfoBySid(self.sid).starNum
    local stars = self.stars
    for i = 1,3,1 do
        if i <= starNum then
            stars[i]:loadTexture("star_enabled.png",ccui.TextureResType.plistType)
        else
            stars[i]:loadTexture("star_empty.png",ccui.TextureResType.plistType)
        end
    end
    self:refreshLockIcon()
end

-- 刷新是否可以攻打按钮
function T:refreshIsAttack()
    local playerLevel = UserInfo.level
    if playerLevel >= SupplyLine_temp[self.sid].openLevel then -- 解锁了
        if SupplyLineManager:judgeSupplyIsFinishBySid(self.sid) == false then -- 未完成
            self.attackBtn:setIsGray(false)
            self.attackBtn:setTouchEnabled(true)
        else -- 完成了
            self.attackBtn:setIsGray(true)
            self.attackBtn:setTouchEnabled(false)
        end
    else -- 未解锁
        self.attackBtn:setIsGray(true)
        self.attackBtn:setTouchEnabled(true)
    end
    self:refreshLockIcon()
end


--- 刷新关卡重置
function T:resetPoint()
    self:refreshStar()
    self:refreshIsAttack()
end

--- 得到描述
function T:getDes()
    if self.sid == 1 or self.sid == 2 then
        return Language:get("uc784")
    elseif self.sid == 3 or self.sid == 4 or self.sid == 5 or self.sid == 6 then
        return Language:get("uc785")
    elseif self.sid == 7 or self.sid == 8 or self.sid == 9 then
        return Language:get("uc786")
    else
        return Language:get("uc787")
    end


end


--- 创建锁定图标
function T:createLockIcon()
	--锁定遮罩
	local uiMask=ccui.Layout:create()
	uiMask:setTouchEnabled(true)
	uiMask:retain()
	self:addChild(uiMask)
	REL:relOther(uiMask,self, 0, 0, 0, 0)
	uiMask:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid )
	uiMask:setBackGroundColor(cc.c3b(0,0,0))
	uiMask:setBackGroundColorOpacity(140)
	self.uiMask=uiMask

	--锁定后的提示文本的背景
	local uiLockedTipBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("lockedBack.png"))
	uiMask:addChild(uiLockedTipBack)
	REL:toOther("center","middle",uiLockedTipBack,uiMask,0,0)

	--锁定后的提示文本
	local uiLockedTip=XMLLabel()
	uiLockedTip:setContentSize(cc.size(500,36))
	uiLockedTip:setAlign("center","middle")
	uiMask:addChild(uiLockedTip)
	REL:toOther("center","middle",uiLockedTip,uiLockedTipBack,0,-34)
	uiMask.uiLockedTip=uiLockedTip

    local openLevel = SupplyLine_temp[self.sid].openLevel
    uiLockedTip:setString(Language:get("uc820",openLevel))

end

function T:refreshLockIcon()
    local playerLevel = UserInfo.level
    local openLevel = SupplyLine_temp[self.sid].openLevel
    if playerLevel >= SupplyLine_temp[self.sid].openLevel then -- 解锁了
        self.uiMask:setVisible(false)
    else
        self.uiMask:setVisible(true)
    end

end


return T