--[[
 *	补给线view
]]
local T = class("T",function() return ccui.Layout:create() end)

T.SupplyLineItem = require("src.app.uiScript.components.accessory.accessorySystem.supplyLine.SupplyLineItem")

--- 构造函数
function T:ctor()
    
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )


    self:initTop()
    self:initCenter()
    self:initBottom()

    self:resetPointNum()
    self:resetRemainNum()

    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_RESET_ALL_POINT,self,self.resetPoint)
    SupplyLineManager:luaAddEventListener(SupplyLineManager.EVT_SUPPLY_LINE_FINISH,self,self.resetPointNum)

    -- 每日状态刷新
    DailyStates:luaAddEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.resetPoint)

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    SupplyLineManager:setSelCampaign(nil)

    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_RESET_ALL_POINT,self,self.resetPoint)
    SupplyLineManager:luaRemoveEventListener(SupplyLineManager.EVT_SUPPLY_LINE_FINISH,self,self.resetPointNum)

    DailyStates:luaRemoveEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.resetPoint)

end


function T:initTop()
    -- 背景图片
    local topBack = ccui.ImageView:create()
    topBack:loadTexture("exchangeBottom.png",ccui.TextureResType.plistType)
    self:addChild(topBack)
    REL:toOther("center","top",topBack,self,0,0)

    -- 可以打的关卡数
    local attackPoint = XMLLabel()
    attackPoint:setContentSize(cc.size(400,27))
    attackPoint:setVAlign("middle")
    self:addChild(attackPoint)
    REL:toOther("left","middle",attackPoint,topBack,20,0)
    attackPoint:setString(Language:get("uc709",0))
    self.attackPoint = attackPoint

    -- 弹出信息按钮
    local info = Button.new("false","false")
	info:setButtonState("infoButton_normal.png","iconButton_general_down.png")
	self:addChild(info)
	REL:toOther("right","middle",info,topBack,30,-10)
    info:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            
            local layout = ccui.Layout:create()
            layout:setContentSize(cc.size(544,226))

            local text = XMLLabel()
            text:setContentSize(cc.size(500,36))
            text:setVAlign("middle")
            layout:addChild(text)
            REL:toOther("left","middle",text,layout,20,-30)
            text:setString(Language:get("uc764"))

            MUIAlter_noTitle.show(
                {
                    info = layout,
                    flag = 4,
                }
            )
        end
    end)


end

function T:initCenter()
    local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,self,10,0,100,150)
	self.listView = MUIListTree.extend(listView)

    -- 有11项
    for i = 1,11,1 do
        local supplyLineItem = self.SupplyLineItem.new(i)
        self.listView:pushBackCustomItem(supplyLineItem)
    end

end

function T:initBottom()
    -- 今日剩余充值次数
    local remainCount = XMLLabel()
    remainCount:setContentSize(cc.size(400,27))
    remainCount:setHAlign("center")
    self:addChild(remainCount)
    REL:toOther("center","bottom",remainCount,self,0,100)
    remainCount:setString(Language:get("uc710",0))
    self.remainCount = remainCount

    -- 关卡重置
    local resertPoint = Button.new("false","true")
	resertPoint:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
    resertPoint:setString(Language:get("uc711"))
	self:addChild(resertPoint)
	REL:toOther("center","bottom",resertPoint,self,0,20)
    resertPoint:setTextCenter()
    resertPoint:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local num = SupplyLineManager:getRemainCount()
            if num == 0 then
                local descripe = Language:get("uc714")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            else
                
                local function confirm()
                    local nowDiamond = UserInfo.gems
                    if SupplyLineManager:getResetAllPointGems() <= nowDiamond then
                        require("src.app.communication.accessory.ResetSupplyLineCommand")():exec(
		                    function(state)
			                    if state == ReturnCode.SUCCESS then
                            
			                    else
                                    ErrorCode:popErrorCodeTip(state)
			                    end
		                end)

                    else -- 弹出充值页面
                        MUIPop.MUIToReCharge()
                    end

                end

                local info = Language:get("uc715",SupplyLineManager:getResetAllPointGems())
                MUIPop.MUIImmediate(info,confirm)

            end


        end
    end)

end


--- 刷新还有多少个关卡可打
function T:resetPointNum()
    self.attackPoint:setString(Language:get("uc709",SupplyLineManager:getAllPointCount()))
end

--- 刷新今日剩余充值次数
function T:resetRemainNum()
    self.remainCount:setString(Language:get("uc710",SupplyLineManager:getRemainCount()))
end

--- 刷新关卡重置
function T:resetPoint()
    self:resetPointNum()
    self:resetRemainNum()
end


return T