--[[
 *	配件项：这种只在仓库里面用
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor()
    self:init()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:setContentSize(cc.size(156,155))
    self:getWidget()
    self:addEvent()

end

--- 进入
function T:onEnter()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)
end

--- 退出
function T:onExit()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_LEVEL_UP_SUCCESS_REFRESH,self,self.refreshData)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_REFORM_SUCCESS_REFRESH,self,self.refreshData)
end

function T:getWidget()
    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("accessoryPropBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("center","middle",back,self,0,0)
    

    -- icon
    local icon = ccui.ImageView:create()
    icon:loadTexture("accessoryBack.png",ccui.TextureResType.plistType)
    self:addChild(icon)
    REL:toOther("center","middle",icon,back,0,0)
    self.icon = icon

    -- 左上角改造等级图片
    local reLevelImg = ccui.ImageView:create()
    reLevelImg:loadTexture("levelBottom2.png",ccui.TextureResType.plistType)
    self:addChild(reLevelImg)
    REL:toOther("left","top",reLevelImg,icon,-5,-5)
    self.reLevelImg = reLevelImg

    -- 左上角改造等级字
    local reLevel = XMLLabel()
    reLevel:setAlign("center","middle")
    reLevel:setContentSize(cc.size(200,36))
    self:addChild(reLevel)
    REL:toOther("center","middle",reLevel,reLevelImg,0,0)
    self.reLevel = reLevel

    -- 右下角等级背景图片
    local levelImg = ccui.ImageView:create()
    levelImg:loadTexture("levelBottom1.png",ccui.TextureResType.plistType)
    self:addChild(levelImg)
    REL:toOther("right","bottom",levelImg,icon,0,0)
    self.levelImg = levelImg

    -- 右下角配件等级
    local level = XMLLabel()
    level:setAlign("center","middle")
    level:setContentSize(cc.size(200,36))
    self:addChild(level)
    REL:toOther("center","middle",level,levelImg,0,0)
    self.level = level
end

function T:refreshData()
    if self.accessoryInfo then       
        local reLevel = self.accessoryInfo.reLevel
        local level = self.accessoryInfo.level

        self.reLevel:setString(Language:get("uc605",reLevel))
        self.level:setString(Language:get("uc606",level))
    end
end

--- 有配件的时候显示
function T:setAccessoryInfo(accessoryInfo)
    self.accessoryInfo = accessoryInfo

    self.reLevelImg:setVisible(true)
    self.reLevel:setVisible(true)
    self.level:setVisible(true)
    self.levelImg:setVisible(true)

    local reLevel = accessoryInfo.reLevel
    local level = accessoryInfo.level

    self.reLevel:setString(Language:get("uc605",reLevel))
    self.level:setString(Language:get("uc606",level))
    self.icon:loadTexture(IconManager.iconPath .. Accessory_temp[accessoryInfo.sid].icon)

end

--- 无配件的时候显示
function T:setNoAccessoryInfo()
    self.reLevelImg:setVisible(false)
    self.reLevel:setVisible(false)
    self.level:setVisible(false)
    self.levelImg:setVisible(false)

    self.icon:loadTexture("accessoryBack.png",ccui.TextureResType.plistType)

    self.accessoryInfo = nil
end

function T:addEvent()
    self:setTouchEnabled(true)
    BaseButton:extend(self)

    self:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.accessoryInfo then
                local layout = require("src.app.uiScript.components.accessory.accessorySystem.AccessoryPopWindow").new(2,self.accessoryInfo.id,1)
	            local muialter2 = MUIAlter.show(
		            {
			            title = layout:getTitle(),
			            info = layout,
                        isShowCloseButton = true,
			            flag = 4,
			            callback = function(flag)
			            end
		            }
	            )
	            layout:setMUIAlter2(muialter2)
            end

        end
    end)

end

return T