--[[
 *	配件信息视图
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 配件项
T.AccessoryItem = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.AccessoryItem")

--- 构造函数
function T:ctor()
    
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
    
    self.accessoryItems = {}

    self:addAccessoryItem()
    self:refreshData()

    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaAddEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.refreshData)
    slotBox:luaAddEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.refreshData)

    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaAddEventListener(accessoryBox.EVT_PORT_ACCESSORY_REFRESH,self,self.refreshData)
    accessoryBox:luaAddEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,self,self.refreshData)


    self:initBottom()
end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()
    local slotBox = AccessorySystemManager:getSlotBox()
    slotBox:luaRemoveEventListener(slotBox.EVT_INSTALL_ACCESSORY_REFRESH,self,self.refreshData)
    slotBox:luaRemoveEventListener(slotBox.EVT_UNLOAD_ACCESSORY_REFRESH,self,self.refreshData)

    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_PORT_ACCESSORY_REFRESH,self,self.refreshData)
    accessoryBox:luaRemoveEventListener(accessoryBox.EVT_DECOMPOSE_ACCESSORY_REFRESH,self,self.refreshData)

end

--- 添加项，48项
function T:addAccessoryItem()
    local scrollView = ccui.ScrollView:create()
	scrollView:setTouchEnabled(true)
	scrollView:setBounceEnabled(true)
	self:addChild(scrollView)
	REL:relOther(scrollView,self,10,10,-5,115)

    local container = scrollView:getInnerContainer()

    local height,width = 156,155
    local scrollWidth = scrollView:getContentSize().width

    local step = ( scrollWidth - 4 * width ) / 5  -- 4表示一行的个数

    local baseLeft = step
    local baseTop = 10

    scrollView:setInnerContainerSize(cc.size(scrollWidth,(48/4 - 1)*(height + step) + height + baseTop))

    for i = 1,48,1 do
        local accessoryItem = self.AccessoryItem.new()
        container:addChild(accessoryItem)
        self.accessoryItems[#self.accessoryItems + 1] = accessoryItem

        local left = 0
        if i%4 == 0 then
            left  = baseLeft + (4 - 1) * (width + step)
        else
            left = baseLeft + (i%4 - 1) * (width + step)
        end

        local top = 0
        if i%4 == 0 then
            top = baseTop + (i/4 - 1) * (height + step)
        else           
            top = baseTop + math.floor(i/4) * (height + step)
        end

        REL:toOther("left","top",accessoryItem,container,left,top)
    end
end


--- 刷新视图
function T:refreshData()
    local accessoryBox = AccessorySystemManager:getAccessoryBox()
    local temp = accessoryBox:getShowAccessoryInfos()

    local accessoryItems = self.accessoryItems

    if temp then
        for i = 1,48,1 do   -- 现在最多只放48个项
            if temp[i] then
                accessoryItems[i]:setAccessoryInfo(temp[i])
            else
                accessoryItems[i]:setNoAccessoryInfo()
            end
        end
    else
        for i = 1,48,1 do
            accessoryItems[i]:setNoAccessoryInfo()
        end
    end


end

function T:initBottom()
    -- 批量分解
    local decompose = Button.new("false","true")
	decompose:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
    decompose:setString(Language:get("uc607"))
	self:addChild(decompose)
	REL:toOther("center","bottom",decompose,self,0,35)
    decompose:setTextCenter()
    decompose:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then -- 弹窗
            local layout = require("src.app.uiScript.components.accessory.accessorySystem.BatchdecomposeAccessoryPopWindow").new()
	        local muialter2 = MUIAlter.show(
		        {
			        title = Language:get("uc617"),
			        info = layout,
                    isShowCloseButton = true,
			        flag = 4,
			        callback = function(flag)
			        end
		        }
	        )
	        layout:setMUIAlter2(muialter2)
        end
    end)


    -- 描述
    local des = XMLLabel()
    des:setAlign("center","middle")
    des:setContentSize(cc.size(600,36))
    self:addChild(des)
    REL:toOther("center","bottom",des,self,0,8)
    des:setString(Language:get("uc608"))

end

return T