--[[
 *	蓝图信息视图
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor()
    self.queue = Queue()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,6,0,0,0)
    self.listView = listView

    self:_addToListview() 

    self:_addEventListenr()

end

function T:_addEventListenr()
    local function produceProp(propInfo)
        local newPropList = PropsInfoMgr:getAllBluePrint()
        if self.propList ~= newPropList then
            local newNum = #newPropList
            local tag = nil
            for i = 1,newNum,1 do
                if newPropList[i].sid == propInfo.sid then
                    tag = i
                    break
                end
            end

            if tag then -- listview的开始索引是0
                local res = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.BluePrintItem").new(propInfo.sid,self.listView)
                self.listView:insertCustomItem(res,tag - 1)
                self.listView:refreshView()
            end

            self.propList = newPropList
        end
    end
    self.produceProp = produceProp 
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.produceProp,nil,self.produceProp)
end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.produceProp,nil,self.produceProp)
    self.queue:clearT()
    self.queue = nil
end


function T:_addToListview()
    local props = PropsInfoMgr:getAllBluePrint()
    self.propList = props
    if props then
        local num = #props
        for i = 1,num,1 do
            if props[i] and props[i].num > 0 then
                self.queue:push(props[i].sid)
            end
        end

        self:runAction(
            cc.RepeatForever:create(
                cc.Sequence:create(
		            cc.DelayTime:create(0.1),
		            cc.CallFunc:create( function()
			            self:addRes()
		            end)
		        )
            )
	    )
    end 

end

function T:addRes()
    local sid = self.queue:pop()
    if sid then
        local res = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.BluePrintItem").new(sid,self.listView)
        res:setOpacity(0)
        self.listView:pushBackCustomItem(res)
        res:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end

return T