--[[
 *	分解弹出窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 最小值
T.minValue = nil

--- 最大值
T.maxValue = nil

--- 选中的分解数量值
T.value = nil

--- 构造函数
function T:ctor(sid) -- 分解蓝图的sid
    self.sid = sid

    self:init()

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:setTouchEnabled(true)

    self:setContentSize(cc.size(500,400))

    self:getWidget()

    self:setMinAndMaxLogic()

    self:refreshMinAndMax(1)

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    
end

--- 得到控件
function T:getWidget()
    local sid = self.sid
    local propData = Prop_temp[sid]
    
    local decomposeData = PropsInfoMgr:getDecomposeBluePrint(sid)

    -- icon
    local icon = ccui.ImageView:create()
    local iconPath = IconManager.iconPath
    icon:loadTexture(iconPath .. propData.propIcon)
    icon:setScale(IconManager.baseScale[1],IconManager.baseScale[2])
    self:addChild(icon)
    REL:toOther("left","top",icon,self,100,20)


    -- 名字
    local name = XMLLabel()
    name:setContentSize(cc.size(300,36))
    name:setVAlign("middle")
    self:addChild(name)
    REL:toOther("left","middle",name,icon,80,0)
    name:setString(Language:get(propData.prop))

    -- 描述
    local des = XMLLabel()
    des:setContentSize(cc.size(400,36))
    des:setHAlign("center")
    self:addChild(des)
    REL:toOther("center","top",des,self,0,120)
    des:setString(Language:get("uc650",decomposeData.num,Language:get(Prop_temp[decomposeData.sid].prop)))

    -- 背景框
    local back = ccui.ImageView:create()
    back:loadTexture("accessorySeqLine.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("center","bottom",back,self,0,150)


    -- 左边图片
    local leftReduce = ccui.ImageView:create()
    leftReduce:loadTexture("reduce.png",ccui.TextureResType.plistType)
    self:addChild(leftReduce)
    REL:toOther("center","bottom",leftReduce,back,-150,0)
    self.leftReduce = leftReduce
    leftReduce:setTouchEnabled(true)
    leftReduce:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            self.value = self.value - 1

            self:refreshMinAndMax(self.value)
        end
    end)

    -- 右边图片
    local rightAdd = ccui.ImageView:create()
    rightAdd:loadTexture("add.png",ccui.TextureResType.plistType)
    self:addChild(rightAdd)
    REL:toOther("center","bottom",rightAdd,back,150,0)
    self.rightAdd = rightAdd
    rightAdd:setTouchEnabled(true)
    rightAdd:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            self.value = self.value + 1

            self:refreshMinAndMax(self.value)
        end
    end)

    -- 中间文本
    local text = XMLLabel()
    text:setContentSize(cc.size(400,36))
    text:setAlign("center","bottom")
    self:addChild(text)
    REL:toOther("center","bottom",text,back,0,20)
    self.text = text


    -- 最小按钮
    local minBtn = Button.new("false","false")
    minBtn:loadTextures("min.png","min.png","",ccui.TextureResType.plistType)
    REL:toOther("right", "middle", minBtn,leftReduce, 60, 0)
    self:addChild(minBtn)
    self.minBtn = minBtn
    minBtn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            self:refreshMinAndMax(self.minValue)
        end
    end)


    -- 最大按钮
    local maxBtn = Button.new("false","true")
    maxBtn:loadTextures("max.png","max.png","",ccui.TextureResType.plistType)
    REL:toOther("left", "middle", maxBtn,rightAdd, 60, 0)
    self:addChild(maxBtn)
    self.maxBtn = maxBtn
    maxBtn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            self:refreshMinAndMax(self.maxValue)
        end
    end)

    -- 使用按钮
    local useBtn = Button.new("false","true")
    useBtn:loadTextures("longButton_yellow_normal.png","longButton_general_down.png","",ccui.TextureResType.plistType)
    REL:toOther("center", "bottom", useBtn,self, 0, 20)
    useBtn:setTextShadow()
    useBtn:setString(Language:get("uc655"))
    self:addChild(useBtn)
    useBtn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            local function finish(awardData)
                self.muialter2:hide()
                require("src.app.communication.award.AwardDataDecoder"):showSuccessWindow(awardData)
            end
            Command:decomposeBluePrint(self.sid,self.value,finish)
        end
    end)

end

--- 设置最小最大逻辑
function T:setMinAndMaxLogic()
    local num = PropsInfoMgr:getPlayerPropByID(self.sid)

    self.minValue = 1
    self.maxValue = num

end

--- 刷新最大和最小值
function T:refreshMinAndMax(value)
    self.value = value

    self.text:setString(Language:get("uc652",value,self.maxValue))

    local minValue = self.minValue
    local maxValue = self.maxValue

    if minValue == maxValue then
        self.leftReduce:setTouchEnabled(false)
        self.leftReduce:setIsGray(true)
        self.rightAdd:setTouchEnabled(false)
        self.rightAdd:setIsGray(true)
    elseif minValue == value then
        self.leftReduce:setTouchEnabled(false)
        self.leftReduce:setIsGray(true)
        self.rightAdd:setTouchEnabled(true)
        self.rightAdd:setIsGray(false)
    elseif maxValue == value then
        self.leftReduce:setTouchEnabled(true)
        self.leftReduce:setIsGray(false)
        self.rightAdd:setTouchEnabled(false)
        self.rightAdd:setIsGray(true)
    else
        self.leftReduce:setTouchEnabled(true)
        self.leftReduce:setIsGray(false)
        self.rightAdd:setTouchEnabled(true)
        self.rightAdd:setIsGray(false)
    end


end


function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end


return T