--[[
 *	兑换项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor(sid,listView,btnTag)
    self.sid = sid
    self.listView = listView
    self.btnTag = btnTag

    self:init()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
    
    -- 得到json中的控件
    self:GetWidget()
    -- 设置数据
    self:SetData()


end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    
end

--- 得到json中的控件
function T:GetWidget()
    -- 背景图片
    local back = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("exchangeBlueBottom.png"))
    self:addChild(back)
    local size = back:getContentSize()
    self:setContentSize(size)
    REL:toOther("center","middle",back,self,-5,0)
    self.back = back

    -- 头像
    local icon = ccui.ImageView:create()
    local iconPath = IconManager.iconPath
    icon:loadTexture(iconPath .. Prop_temp[1].propIcon)
    self:addChild(icon)
    REL:toOther("left","top",icon,back,10,21)
    self._imgHead = icon


    -- 名字
    local title = XMLLabel()
    title:setContentSize(cc.size(450,27))
    self:addChild(title)
    REL:toOther("left","middle",title,back,110,75)
    self._labelName = title

    -- 描述
    local describe = XMLLabel()
    describe:setContentSize(cc.size(260,36))
    describe:setAlign("left","middle")
    self:addChild(describe)
    REL:toOther("left","top",describe,back,130,80)
    self._labelDescribe = describe


    -- 按钮
    local _btn = Button.new("false","true")
    _btn.buttonText:setHAlign("center")
    _btn.buttonText:setVAlign("middle")
    self:addChild(_btn)
    self._btn = _btn

     -- 兑换按钮
    self._btn:loadTextures("button_yellow_normal.png","button_general_down.png","",ccui.TextureResType.plistType)
    self._btn:setString(Language:get("uc656"))
    REL:toOther("right", "bottom", self._btn, self.back, 15, 10)
    self._btn:setTextShadow()
    self._btn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            local data = PropsInfoMgr:exchangeBluePrint(self.sid)
            if PropsInfoMgr:getPlayerPropByID(data.sid) < data.num then
                if self.btnTag == 1 then
                    local descripe = Language:get("uc657")
		            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                else
                    local descripe = Language:get("uc658")
		            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                end
            else
                local function finish(awardData)
                    require("src.app.communication.award.AwardDataDecoder"):showSuccessWindow(awardData)
                end
                Command:exchangeBluePrint(self.sid,finish)

            end
        end
    end)


    -- 消耗碎片图标
    local data = PropsInfoMgr:exchangeBluePrint(self.sid)
    local sid = data.sid

    local costIcon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    costIcon:loadTexture(iconPath .. Prop_temp[sid].propIcon)
    costIcon:setScale(30/100,30/100)

    self:addChild(costIcon)
    REL:toOther("center","bottom",costIcon,self._btn,-20,100)


    -- 显示消耗
    local cost = XMLLabel()
    cost:setHAlign("left")
    cost:setVAlign("middle")
    cost:setContentSize(cc.size(200,36))
    self:addChild(cost)
    REL:toOther("left","middle",cost,costIcon,35,0)
    cost:setString(Language:get("uc702",PropsInfoMgr:exchangeBluePrint(self.sid).num))


end


function T:SetData()
    local data = Prop_temp[self.sid]
    -- 头像
    local iconPath = IconManager.iconPath
    self._imgHead:loadTexture(iconPath .. data.propIcon)

    self._labelName:setString(Language:get("uc276",Language:get(data.prop)))


    local description = PlayerInstance:getPropDescripe2(self.sid)
    self._labelDescribe:setString(description)
end


return T