--[[
 *	兑换信息视图
]]
local T = class("T",function() return ccui.Layout:create() end)

T.ExchangeHighView = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.ExchangeHighView")
T.ExchangeNormalView = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.ExchangeNormalView")


--- 构造函数
function T:ctor()
    
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.btnTag = 1 -- 左边的按钮切换标签页的标记

    self:setTopWidget()
    self:refreshTopData()

    -- 添加底部
    self:addBottom()
    self:refreshBottom()


    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. 206,self,self.refreshTopData)
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. 207,self,self.refreshTopData)


end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. 206,self,self.refreshTopData)
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. 207,self,self.refreshTopData)


end

--- 设置顶部
function T:setTopWidget()
    -- 顶部背景框
    local exchangeBottom = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("exchangeBottom.png"))
    exchangeBottom:setContentSize(cc.size(614,91))
	self:addChild(exchangeBottom)
    REL:toOther("center","top",exchangeBottom,self,0,0)
    self.exchangeBottom = exchangeBottom

    -- 普通蓝图碎片图片
    local normalIcon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    normalIcon:loadTexture(iconPath .. Prop_temp[206].propIcon)
    normalIcon:setScale(IconManager.resScale[1],IconManager.resScale[2])

    self:addChild(normalIcon)
    REL:toOther("left","middle",normalIcon,exchangeBottom,50,0)


    -- 普通蓝图碎片数量
    local normalNum = XMLLabel()
    normalNum:setContentSize(cc.size(200,36))
    normalNum:setVAlign("middle")
    self:addChild(normalNum)
    REL:toOther("left","middle",normalNum,normalIcon,80,0)
    self.normalNum = normalNum

    -- 高级蓝图碎片图片
    local highIcon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    highIcon:loadTexture(iconPath .. Prop_temp[207].propIcon)
    highIcon:setScale(IconManager.resScale[1],IconManager.resScale[2])

    self:addChild(highIcon)
    REL:toOther("center","middle",highIcon,exchangeBottom,0,0)

    -- 高级蓝图碎片数量
    local highNum = XMLLabel()
    highNum:setContentSize(cc.size(200,36))
    highNum:setVAlign("middle")
    self:addChild(highNum)
    REL:toOther("left","middle",highNum,highIcon,80,0)
    self.highNum = highNum

    -- 描述按钮
    local btn = Button.new("false","false")
    btn:loadTextures("infoButton_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
    REL:toOther("right", "middle", btn, exchangeBottom, 50, -10)
    self:addChild(btn)
    btn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            local layout = ccui.Layout:create()
            layout:setContentSize(cc.size(544,226))

            local text = XMLLabel()
            text:setContentSize(cc.size(500,36))
            text:setVAlign("middle")
            layout:addChild(text)
            REL:toOther("left","middle",text,layout,20,-30)
            text:setString(Language:get("uc770"))

            MUIAlter_noTitle.show(
                {
                    info = layout,
                    flag = 4,
                }
            )
        end
    end)


end

--- 刷新顶部数据
function T:refreshTopData()
    self.normalNum:setString(PropsInfoMgr:getPlayerPropByID(206))
    self.highNum:setString(PropsInfoMgr:getPlayerPropByID(207))
end

--- 添加底部
function T:addBottom()
    self.switchTop = 90

    local btn1 = Button.new("false","false")
    btn1:loadTextures("notActived.png","notActived.png","",ccui.TextureResType.plistType)
    REL:toOther("left", "top", btn1, self.exchangeBottom, -13, self.switchTop)
    self:addChild(btn1)
    btn1:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            self.btnTag = 1
            self:refreshBottom()
        end
    end)
    self.btn1 = btn1

    local normalIcon = ccui.ImageView:create()
    local iconPath = IconManager.iconPath
    normalIcon:loadTexture(iconPath .. Prop_temp[206].propIcon)
    normalIcon:setScale(IconManager.resScale[1],IconManager.resScale[2])
    self:addChild(normalIcon)
    REL:toOther("center","middle",normalIcon,btn1,0,0)

    --
    local btn2 = Button.new("false","false")
    btn2:loadTextures("notActived.png","notActived.png","",ccui.TextureResType.plistType)
    REL:toOther("left", "top", btn2, self.exchangeBottom, -13, self.switchTop + 130)
    self:addChild(btn2)
    btn2:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            self.btnTag = 2
            self:refreshBottom()
        end
    end)
    self.btn2 = btn2

    --
    local highIcon = ccui.ImageView:create()
    local iconPath = IconManager.iconPath
    highIcon:loadTexture(iconPath .. Prop_temp[207].propIcon)
    highIcon:setScale(IconManager.resScale[1],IconManager.resScale[2])
    self:addChild(highIcon)
    REL:toOther("center","middle",highIcon,btn2,0,0)

    -- 右边的背景图片
    local needListBack = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("generalItemBack.png"))
    self:addChild(needListBack)
    REL:relOther(needListBack,self,90,10,self.switchTop + 10,5)
    self.needListBack = needListBack


end

function T:refreshBottom()
    if self.btnTag == 1 then
        self.btn1:loadTextureNormal("actived.png",ccui.TextureResType.plistType)
	    self.btn1:setTouchEnabled(false)

        self.btn2:loadTextureNormal("notActived.png",ccui.TextureResType.plistType)
	    self.btn2:setTouchEnabled(true)

        self:normalLogic()

    else
        self.btn1:loadTextureNormal("notActived.png",ccui.TextureResType.plistType)
	    self.btn1:setTouchEnabled(true)

        self.btn2:loadTextureNormal("actived.png",ccui.TextureResType.plistType)
	    self.btn2:setTouchEnabled(false)

        self:highLogic()
    end


end

--- 普通逻辑
function T:normalLogic()
    if self.exchangeNormalView == nil then
        self.exchangeNormalView = self.ExchangeNormalView.new(self.btnTag)
        self:addChild(self.exchangeNormalView)
        REL:relOther(self.exchangeNormalView,self.needListBack,0,0,0,0)
        self.exchangeNormalView:init()
    end

    if self.exchangeNormalView then  
        self.exchangeNormalView:setVisible(true)
    end

    if self.exchangeHighView then
        self.exchangeHighView:setVisible(false)
    end
end

--- 高级逻辑
function T:highLogic()
    if self.exchangeNormalView then  
        self.exchangeNormalView:setVisible(false)
    end

    if self.exchangeHighView == nil then
        self.exchangeHighView = self.ExchangeHighView.new(self.btnTag)
        self:addChild(self.exchangeHighView)
        REL:relOther(self.exchangeHighView,self.needListBack,0,0,0,0)
        self.exchangeHighView:init()
    end



    if self.exchangeHighView then
        self.exchangeHighView:setVisible(true)
    end
end


return T