--[[
 *	仓库view
]]
local T = class("T",function() return ccui.Layout:create() end)

T.AccessoryView = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.AccessoryView")
T.BluePrintView = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.BluePrintView")
T.ExchangeView = require("src.app.uiScript.components.accessory.accessorySystem.warhouse.ExchangeView")


--- 构造函数
function T:ctor()
    
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local function callBack1()
        self:accessoryViewLogic()
    end

    local function callBack2()
        self:bluePrintViewLogic()
    end

    local function callBack3()
        self:exchangeViewLogic()
    end

    local twoMenuContainer = SwitchButtonContainer.new(0)
    self:addChild(twoMenuContainer)
    REL:relOther(twoMenuContainer,self,0,0,0,0)
    twoMenuContainer:init()
    twoMenuContainer:initButtons(
        3,
        {{"panelSwitchButton_down.png","panelSwitchButton_normal.png"},{"panelSwitchButton_down.png","panelSwitchButton_normal.png"},{"panelSwitchButton_down.png","panelSwitchButton_normal.png"}},
        {50,13},
        {callBack1,callBack2,callBack3},
        {Language:get("uc602"),Language:get("uc603"),Language:get("uc604")}
    )
    self.twoMenuContainer = twoMenuContainer
    twoMenuContainer.viewBack:setVisible(false)
    self.twoMenuContainer = twoMenuContainer

    self:setBtnPos()

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    
end

function T:accessoryViewLogic()
    if self.accessoryView == nil then
        self.accessoryView = self.AccessoryView.new()
        self:addChild(self.accessoryView)
        REL:relOther(self.accessoryView,self,0,0,50,0)
        self.accessoryView:init()
    end

    if self.accessoryView then  
        self.accessoryView:setVisible(true)
    end

    if self.bluePrintView then  
        self.bluePrintView:setVisible(false)
    end
    
    if self.exchangeView then
        self.exchangeView:setVisible(false)
    end

end


function T:bluePrintViewLogic()
    if self.accessoryView then  
        self.accessoryView:setVisible(false)
    end

    if self.bluePrintView == nil then
        self.bluePrintView = self.BluePrintView.new()
        self:addChild(self.bluePrintView)
        REL:relOther(self.bluePrintView,self,0,0,50,0)
        self.bluePrintView:init()
    end

    if self.bluePrintView then  
        self.bluePrintView:setVisible(true)
    end
    
    if self.exchangeView then
        self.exchangeView:setVisible(false)
    end

end

function T:exchangeViewLogic()
    if self.accessoryView then  
        self.accessoryView:setVisible(false)
    end

    if self.bluePrintView then  
        self.bluePrintView:setVisible(false)
    end
    
    if self.exchangeView == nil then
        self.exchangeView = self.ExchangeView.new()
        self:addChild(self.exchangeView)
        REL:relOther(self.exchangeView,self,0,0,50,0)
        self.exchangeView:init()
    end


    if self.exchangeView then
        self.exchangeView:setVisible(true)
    end

end

--- 重新调整按钮的位置
function T:setBtnPos()
    local twoMenuContainer = self.twoMenuContainer
    REL:toOther("left","top",twoMenuContainer:getButton(1),twoMenuContainer,30,-15)
    REL:toOther("center","top",twoMenuContainer:getButton(2),twoMenuContainer,0,-15)
    REL:toOther("right","top",twoMenuContainer:getButton(3),twoMenuContainer,30,-15)
end


return T