--[[
 *	抽卡项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


--- 构造函数
function T:ctor(sid)
    self.sid = sid

    self:init()
end


function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:setContentSize(cc.size(639,207))

    self:getWidget()

    self:refreshBtn()
    self:refeshTime()

end

--- 进入
function T:onEnter()
    local accessoryDrawCardState = SetStates.accessoryDrawCardState
    accessoryDrawCardState:luaAddEventListener(accessoryDrawCardState.EVT_FREETIME_ENDTIME_REFRESH,self,self.refreshBtn)

    accessoryDrawCardState:luaAddEventListener(accessoryDrawCardState.EVT_FREETIME_ENDTIME_REFRESH,self,self.refeshTime)
    accessoryDrawCardState:luaAddEventListener(accessoryDrawCardState.EVT_TIME_CHANGE_REFRESH,self,self.refeshTime)
    accessoryDrawCardState:luaAddEventListener(accessoryDrawCardState.EVT_FREETIME_OVER,self,self.refeshTime)

end

--- 退出
function T:onExit()
    local accessoryDrawCardState = SetStates.accessoryDrawCardState
    accessoryDrawCardState:luaRemoveEventListener(accessoryDrawCardState.EVT_FREETIME_ENDTIME_REFRESH,self,self.refreshBtn)

    accessoryDrawCardState:luaRemoveEventListener(accessoryDrawCardState.EVT_FREETIME_ENDTIME_REFRESH,self,self.refeshTime)
    accessoryDrawCardState:luaRemoveEventListener(accessoryDrawCardState.EVT_TIME_CHANGE_REFRESH,self,self.refeshTime)
    accessoryDrawCardState:luaRemoveEventListener(accessoryDrawCardState.EVT_FREETIME_OVER,self,self.refeshTime)
end

--- 得到控件
function T:getWidget()
    local data_temp = AccessoryDrawCard_temp[self.sid]

    -- icon
    local icon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    icon:loadTexture(iconPath .. data_temp.icon)

    self:addChild(icon)
    REL:toOther("center","middle",icon,self,0,0)
    self.icon = icon
    
    -- 名字
    local labelName = XMLLabel()
    labelName:setContentSize(cc.size(300,36))
    labelName:setHAlign("center")
    self:addChild(labelName)
    REL:toOther("center","top",labelName,icon,0,13)

    if self.sid == 1 then
        labelName:setString(Language:get("uc718",Language:get(data_temp.name)))
    elseif self.sid == 2 then
        labelName:setString(Language:get("uc720",Language:get(data_temp.name)))
    elseif self.sid == 3 then
        labelName:setString(Language:get("uc722",Language:get(data_temp.name)))
    end


    -- 免费抽奖按钮
    local lotteryBtn = Button.new("false","true")
	lotteryBtn:setButtonState("button_green_normal.png","button_general_down.png")
    lotteryBtn:setString(Language:get("uc724"))
	self:addChild(lotteryBtn)
	REL:toOther("right","bottom",lotteryBtn,icon,50,40)
    lotteryBtn:setTextShadow()
    lotteryBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
           self:lotteryLogic()
        end
    end)
    self.lotteryBtn = lotteryBtn

     -- 钻石抽奖按钮
    local diamondLotteryBtn = Button.new("false","true")
	diamondLotteryBtn:setButtonState("useDiamonButton_normal.png","useDiamonButton_normal.png")
    diamondLotteryBtn:setString(Language:get("uc725"))
	self:addChild(diamondLotteryBtn)
    REL:toOther("right","bottom",diamondLotteryBtn,icon,30,30)
    diamondLotteryBtn.buttonText:setAlign("center","midddle")
    REL:toOther("center","middle",diamondLotteryBtn.buttonText,diamondLotteryBtn,0,-10)
    diamondLotteryBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self:lotteryLogic()
        end
    end)
    self.diamondLotteryBtn = diamondLotteryBtn

    -- 消耗钻石
    local labelCostDiamond = XMLLabel()
    labelCostDiamond:setHAlign("center")
    labelCostDiamond:setVAlign("middle")
    labelCostDiamond:setContentSize(cc.size(300, 27))
    self:addChild(labelCostDiamond)
    REL:toOther("center", "bottom", labelCostDiamond, self.diamondLotteryBtn, 15, 90)
    labelCostDiamond:setString(SetStates.accessoryDrawCardState:getCostDiamond(self.sid))
    self.labelCostDiamond = labelCostDiamond

    -- 时间
    local time = XMLLabel()
    time:setContentSize(cc.size(300,36))
    time:setAlign("center","bottom")
    self:addChild(time)
    REL:toOther("center","bottom",time,icon,0,8)
    self.time = time

    -- 品质描述
    local qualityDes = XMLLabel()
    qualityDes:setVAlign("middle")
    qualityDes:setContentSize(cc.size(200,36))
    self:addChild(qualityDes)
    REL:toOther("left","middle",qualityDes,icon,260,0)
    qualityDes:setString(SetStates.accessoryDrawCardState:getQualityDes(self.sid))


end

--- 抽奖逻辑
function T:lotteryLogic()
    local accessoryDrawCardState = SetStates.accessoryDrawCardState
    local function finish(awardData)
        self.AwardDataDecoder:showSuccessWindow(awardData)
    end

--    -- 看是否可以10连抽
--    if accessoryDrawCardState:judgeIsTenDraw(self.sid) then
--        -- 用钻石抽取
--        local layout = require("src.app.uiScript.components.accessoryDrawCard.AccessoryDrawCardPopWindow").new()
--	    local muialter2 = MUIAlter.show(
--		    {
--			    title = Language:get("uc729"),
--			    info = layout,
--                isShowCloseButton = true,
--			    flag = 4,
--			    callback = function(flag)
--			    end
--		    }
--	    )
--	    layout:setMUIAlter2(muialter2)
--    else
        if accessoryDrawCardState:judgeIsFree(self.sid) then -- 免费抽取
            Command:accessoryDrawCard(self.sid,false,false,nil,finish)
        else
            local diamond = accessoryDrawCardState:getCostDiamond(self.sid)
            local function confirm()
                Command:accessoryDrawCard(self.sid,true,false,diamond,finish)
            end

            local info = Language:get("uc730",diamond)
            MUIPop.MUIImmediate(info,confirm)

        end
    --end
end


--- 刷新按钮
function T:refreshBtn()
    if SetStates.accessoryDrawCardState:judgeIsFree(self.sid) then -- 免费抽取
        self.lotteryBtn:setVisible(true)
        self.diamondLotteryBtn:setVisible(false)
        self.labelCostDiamond:setVisible(false)
    else
        self.lotteryBtn:setVisible(false)
        self.diamondLotteryBtn:setVisible(true)
        self.labelCostDiamond:setVisible(true)
    end


end




--- 刷新时间
function T:refeshTime()
    local accessoryDrawCardState = SetStates.accessoryDrawCardState
    if accessoryDrawCardState:judgeIsFree(self.sid) then -- 免费
        self.time:setVisible(false)
    else
        self.time:setVisible(true)
        local remainTime = UnitConversion.timeCount2(accessoryDrawCardState:getRemainTime(self.sid))
        if self.sid == 1 then
            self.time:setString(Language:get("uc719",remainTime))
        elseif self.sid == 2 then
            self.time:setString(Language:get("uc721",remainTime))
        elseif self.sid == 3 then
            self.time:setString(Language:get("uc723",remainTime))
        end

      
    end

end



return T