--[[
 *	抽卡弹出窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


--- 构造函数
function T:ctor() 
    self:init()

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )


    self:setContentSize(cc.size(600,500))

    self:addTopItem()
    self:addBottomItem()

end

--- 进入
function T:onEnter()
   
end

--- 退出
function T:onExit()
 
end


function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end


function T:addTopItem()
    local sid = 3
    local data_temp = AccessoryDrawCard_temp[3]

    local accessoryDrawCardState = SetStates.accessoryDrawCardState
    local costGems = accessoryDrawCardState:getCostDiamond(sid)

    -- icon
    local icon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    icon:loadTexture("draw1.png",ccui.TextureResType.plistType)

    self:addChild(icon)
    REL:toOther("center","top",icon,self,0,20)

     -- 品质描述
    local qualityDes = XMLLabel()
    qualityDes:setVAlign("bottom")
    qualityDes:setContentSize(cc.size(300,36))
    self:addChild(qualityDes)
    REL:toOther("left","bottom",qualityDes,icon,203,80)
    qualityDes:setString(SetStates.accessoryDrawCardState:getQualityDes(sid))

    -- 1次抽卡
    local drawCardDes = XMLLabel()
    drawCardDes:setContentSize(cc.size(300,36))
    self:addChild(drawCardDes)
    REL:toOther("left","top",drawCardDes,icon,200,130)
    drawCardDes:setString(Language:get("uc731"))

    -- 抽奖按钮
    local lotteryBtn = Button.new("false","true")
	lotteryBtn:setButtonState("useDiamonButton_normal.png","useDiamonButton_normal.png")
    lotteryBtn:setString(Language:get("uc725"))
	self:addChild(lotteryBtn)
	REL:toOther("right","bottom",lotteryBtn,icon,20,25)
    lotteryBtn.buttonText:setAlign("center","midddle")
    REL:toOther("center","middle",lotteryBtn.buttonText,lotteryBtn,0,-10)
    lotteryBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function confirm()
                local function finish(awardData)
                    self.AwardDataDecoder:showSuccessWindow(awardData)
                end

                Command:accessoryDrawCard(sid,true,false,costGems,finish)
            end

            local info = Language:get("uc730",costGems)
            MUIPop.MUIImmediate(info,confirm)
        end
    end)

    -- 消耗钻石
    local costDiamond = XMLLabel()
    costDiamond:setContentSize(cc.size(300,27))
    costDiamond:setAlign("center","middle")
    self:addChild(costDiamond)
    REL:toOther("center","bottom",costDiamond,lotteryBtn,15,90)
    costDiamond:setString(costGems)

end

function T:addBottomItem()
    local sid = 3
    local data_temp = AccessoryDrawCard_temp[3]

    local accessoryDrawCardState = SetStates.accessoryDrawCardState
    local costGems = accessoryDrawCardState:getCostDiamond(sid) * 10 * 9/10    -- 打9折

     -- icon
    local icon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    icon:loadTexture("draw3.png",ccui.TextureResType.plistType)

    self:addChild(icon)
    REL:toOther("center","bottom",icon,self,0,50)

    -- 品质描述
    local qualityDes = XMLLabel()
    qualityDes:setVAlign("bottom")
    qualityDes:setContentSize(cc.size(300,36))
    self:addChild(qualityDes)
    REL:toOther("left","bottom",qualityDes,icon,203,80)
    qualityDes:setString(SetStates.accessoryDrawCardState:getQualityDes(sid))

    -- 10次抽卡
    local drawCardDes = XMLLabel()
    drawCardDes:setContentSize(cc.size(300,36))
    self:addChild(drawCardDes)
    REL:toOther("left","top",drawCardDes,icon,200,130)
    drawCardDes:setString(Language:get("uc732"))

    -- 抽奖按钮
    local lotteryBtn = Button.new("false","true")
	lotteryBtn:setButtonState("useDiamonButton_normal.png","useDiamonButton_normal.png")
    lotteryBtn:setString(Language:get("uc725"))
	self:addChild(lotteryBtn)
	REL:toOther("right","bottom",lotteryBtn,icon,20,25)
    lotteryBtn.buttonText:setAlign("center","midddle")
    REL:toOther("center","middle",lotteryBtn.buttonText,lotteryBtn,0,-10)
    lotteryBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function confirm()
                local function finish(awardData)
                    self.AwardDataDecoder:showSuccessWindow(awardData)
                end

                Command:accessoryDrawCard(sid,true,true,costGems,finish)
            end

            local info = Language:get("uc730",costGems)
            MUIPop.MUIImmediate(info,confirm)
        end
    end)

    -- 消耗钻石
    local costDiamond = XMLLabel()
    costDiamond:setContentSize(cc.size(300,27))
    costDiamond:setAlign("center","middle")
    self:addChild(costDiamond)
    REL:toOther("center","bottom",costDiamond,lotteryBtn,15,90)
    costDiamond:setString(costGems)

    -- 右上角打折的图标
    local sale = ccui.ImageView:create()
    sale:loadTexture("sale.png",ccui.TextureResType.plistType)
    self:addChild(sale)
    REL:toOther("right","top",sale,icon,-25,-32)


end



return T