--[[
 *	抽卡view
]]
local T = class("T",function() return ccui.Layout:create() end)

-- 项
T.accessoryDrawCardItem = require("src.app.uiScript.components.accessoryDrawCard.AccessoryDrawCardItem")

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")



--- 构造函数
function T:ctor()
    
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:addListView()

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()

end


function T:addListView()
    local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,self,0,0,20,0)
    self.listView = listView
    
    for i = 1,3,1 do
        local item = self.accessoryDrawCardItem.new(i)
        self.listView:pushBackCustomItem(item)
    end

    -- 下面加入10连抽

    local layout = ccui.Layout:create()
    layout:setContentSize(cc.size(639,207))


    -- icon
    local icon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    icon:loadTexture("res/images/icon/accessoryDrawCard/4.png",ccui.TextureResType.localType)

    layout:addChild(icon)
    REL:toOther("center","middle",icon,layout,0,0)
    
    -- 名字
    local labelName = XMLLabel()
    labelName:setContentSize(cc.size(300,36))
    labelName:setHAlign("center")
    layout:addChild(labelName)
    REL:toOther("center","top",labelName,icon,0,13)
    labelName:setString(Language:get("uc722",Language:get("uc1040")))

    -- 品质描述
    local qualityDes = XMLLabel()
    qualityDes:setHAlign("center")
    qualityDes:setVAlign("middle")
    qualityDes:setContentSize(cc.size(200,36))
    layout:addChild(qualityDes)
    REL:toOther("center","middle",qualityDes,icon,0,0)
    qualityDes:setString(Language:get("uc722",Language:get("uc1041")))

    -- 底部描述
    local bottomDes = XMLLabel()
    bottomDes:setContentSize(cc.size(300,36))
    bottomDes:setAlign("center","bottom")
    layout:addChild(bottomDes)
    REL:toOther("center","bottom",bottomDes,icon,0,8)
    bottomDes:setString(Language:get("uc722",Language:get("uc1042")))

    -- 钻石抽奖按钮
    local diamondLotteryBtn = Button.new("false","true")
	diamondLotteryBtn:setButtonState("useDiamonButton_normal.png","useDiamonButton_normal.png")
    diamondLotteryBtn:setString(Language:get("uc725"))
	layout:addChild(diamondLotteryBtn)
    REL:toOther("right","bottom",diamondLotteryBtn,icon,30,25)
    diamondLotteryBtn.buttonText:setAlign("center","midddle")
    REL:toOther("center","middle",diamondLotteryBtn.buttonText,diamondLotteryBtn,0,-10)
    diamondLotteryBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function confirm()
                local function finish(awardData)
                    self.AwardDataDecoder:showSuccessWindow(awardData)
                end

                Command:accessoryDrawCard(3,true,true,SetStates.accessoryDrawCardState:getTenDrawDiamond(),finish)
            end

            local info = Language:get("uc730",SetStates.accessoryDrawCardState:getTenDrawDiamond())
            MUIPop.MUIImmediate(info,confirm)
        end
    end)
    self.diamondLotteryBtn = diamondLotteryBtn

    -- 消耗钻石
    local labelCostDiamond = XMLLabel()
    labelCostDiamond:setHAlign("center")
    labelCostDiamond:setVAlign("middle")
    labelCostDiamond:setContentSize(cc.size(300, 27))
    layout:addChild(labelCostDiamond)
    REL:toOther("center", "bottom", labelCostDiamond, self.diamondLotteryBtn, 15, 90)
    labelCostDiamond:setString(SetStates.accessoryDrawCardState:getTenDrawDiamond())


    -- 右上角打折的图标
    local sale = ccui.ImageView:create()
    sale:loadTexture("sale.png",ccui.TextureResType.plistType)
    layout:addChild(sale)
    REL:toOther("right","top",sale,icon,-25,-32)


    self.listView:pushBackCustomItem(layout)


end



return T