--[[
 *	机库主窗口
]]
local T = class(
    "AircraftFactoryWindow",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)

--- 服务器数据
T.dataFromServer = nil

--- 建造变量
T.construct = nil

--- 生产变量
T.produce = nil

--- 生产中变量
T.isProduce = nil

--- 构造函数
-- @param tag 分页 -- add by yuding
function T:ctor(data, tag)
    self.dataFromServer = data  -- 浅拷贝的

    local function callBack1()
        self:Construct()
    end

    local function callBack2()
        self:Produce()
    end

    local function callBack3()
        self:Isproduce()
    end

    if not tag then 
        tag = 1
    end
    -- 创建3个
    local switchButtonContainer = SwitchButtonContainer.new()
    self:addChild(switchButtonContainer)
    REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
    switchButtonContainer:init()
    switchButtonContainer:initButtons(
        3,
        {{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"}},
        {70,15},
        {callBack1,callBack2,callBack3},
        {Language:get("uc1"),Language:get("uc109"),Language:get("uc110")},
        tag
    )
    self.switchButtonContainer = switchButtonContainer

    -- 初始化配置表
    self:init()

    -- 进入页面显示数据
    self:ShowData()

    if tag == 1 then 
        self:Construct()
    elseif tag == 2 then 
        self:Produce()
    elseif tag == 3 then 
        self:Isproduce()
    end
    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
	AbstractWindow.onEnter(self)
	
	local location = self.dataFromServer.location
    if location == 5 then  -- 改造工厂
    	AudioManager:playEffect(SoundRes.OPEN_REFIT_FACTORY)

        local function buildUpGradeFinish()
            self.switchButtonContainer:getButton(2):setVisible(true)
            self.switchButtonContainer:getButton(3):setVisible(true)
        end
        self.buildUpGradeFinish = buildUpGradeFinish
        PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.dataFromServer.location,nil,self.buildUpGradeFinish)

    else
		AudioManager:playEffect(SoundRes.OPEN_AIRCRAFT_FACTORY)
	end
end

function T:onExit()
    AbstractWindow.onExit(self)

    local location = self.dataFromServer.location
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.dataFromServer.location,nil,self.buildUpGradeFinish)
end

--- 初始化数据
function T:init()
    --- 建造
    self.aircraftFactoryConstruct = require "src.app.uiScript.components.building.BuildingConstruct"

    --- 生产
    self.aircraftFactoryProduce = require "src.app.uiScript.components.aircraftFactory.aircraftFactoryProduce.AircraftFactoryProduce"

    --- 生产中
    self.aircraftFactoryIsProduce = require "src.app.uiScript.components.aircraftFactory.aircraftFactoryIsProduce.AircraftFactoryIsProduce"

    self.modelResTable = PlayerInstance:getBuildingResTable(self.dataFromServer.sid)
end

--- 进入页面显示数据
function T:ShowData()
    self:setTitle(self.dataFromServer.level)

    local location = self.dataFromServer.location
    if location == 5 then  -- 改造工厂
        self.switchButtonContainer:setButtonText(2,Language:get("uc167"))
        if self.dataFromServer.level == 0 then
            self.switchButtonContainer:getButton(2):setVisible(false)
            self.switchButtonContainer:getButton(3):setVisible(false)
        end    
    else
        self.switchButtonContainer:setButtonText(2,Language:get("uc109"))
    end

end

--- 设置标题
function T:setTitle(level)
    local location = self.dataFromServer.location
    local data = Build_temp[self.dataFromServer.sid]
    if location == 2 then
        self:setWindowTitle(Language:get("uc150"),level)
    elseif location == 3 then
        self:setWindowTitle(Language:get("uc151"),level)
    else -- 改造工厂
        self:setWindowTitle(Language:get(data.name),level)
    end

end

function T:Construct()
    if self.construct == nil then
        self.construct = self.aircraftFactoryConstruct.new(self.dataFromServer,self)
        self:addChild(self.construct)
        REL:toOther("left","top",self.construct,self.uiContainer,2,95)
    end

    if self.construct then
        self.construct:setVisible(true)
    end

    if self.produce then
        self.produce:setVisible(false)
    end
         
    if self.isProduce then
        self.isProduce:removeFromParent()
        self.isProduce = nil
    end
end

function T:Produce()
    if self.construct then  
        self.construct:setVisible(false)
    end

    if self.produce == nil then
        self.produce = self.aircraftFactoryProduce.new(self.dataFromServer,self)  -- 把self传入进去
        self:addChild(self.produce)
        REL:relOther(self.produce,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.produce:init()
    end
         
    if self.produce then
        self.produce:setVisible(true)
    end 

    if self.isProduce then
        self.isProduce:removeFromParent()
        self.isProduce = nil
    end
end

function T:Isproduce()
    if self.construct then
        self.construct:setVisible(false)
    end

    if self.produce then
        self.produce:setVisible(false)
    end
         
    if self.isProduce == nil then
        self.isProduce = self.aircraftFactoryIsProduce.new(self.dataFromServer)
        self:addChild(self.isProduce)         
        REL:relOther(self.isProduce,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.isProduce:init()
    end

    if self.isProduce then
        self.isProduce:setVisible(true)
    end


end

return T