---机库正在制造项
local T = class("T",function() return ccui.Layout:create() end)

--- 这个窗口的大小
T.size = nil

--- id(队列的id)
T.id = nil

--- 建造物的唯一id
T.bid = nil

-- 类型
T.recruitType = nil

--- listview
T.listView = nil

--- 构造函数
function T:ctor(id,recruitType,listView,bid)
	self.id = id
	self.recruitType = recruitType
	self.listView = listView
	self.bid = bid

	--- 根据bid获得位置
	local buidlerInfos = BuildingsInfoMgr:getBuildingInfos()
	for k,v in pairs(buidlerInfos) do
		if v and v.id == self.bid then
			self.location = v.location
		end
	end

	self:registerScriptHandler(
		function(eventType)
			--print("ResourceListOpenItem:"..eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	local _widget = ListItem4.new()
	self.size = _widget:getContentSize()
	self:setContentSize(self.size)
	_widget:setListItemAttribute(
		"V",
		{"progress","label"},
		{{"canelButton2_normal.png","iconButton_general_down.png","false","false"},{"addSpeedButton_normal.png","addSpeedButton_normal.png","false","false"}}
	)
	self:addChild(_widget)
	REL:toOther("left","top",_widget,self,0,0)
	self._widget = _widget


	-- 得到控件
	self:GetWidget()

	self:SetData()
	self:SetButton()
end

function T:onEnter()
	-- 能进入这个说明肯定是在内存中的
	self:UpData()
	self:UpgradeHandle()
end

function T:UpgradeHandle()
	-- 每帧检测回调
	local function update(buildItem)
		if buildItem.remainingSec and buildItem.remainingSec <= 0 then    --生产飞机完成
			--self:produceFinishShow()
			-- 数量更新到内存了里面去，显示上这个项要移除
			--            local num = UserInfo.city.aircraftBox.infos[buildItem.unitType].num  --  sid
			--            UserInfo.city.aircraftBox.infos[buildItem.unitType].num = num + buildItem.unitNum

			--            AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH) -- add by yuding

			AircraftProduceQueueMgr:luaRemoveEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_REFRESH..self.id,nil,self.update)
			self:RemoveSelf()
		else
			self:UpData() -- 处理每帧变化的数据
		end
	end
	self.update = update
	AircraftProduceQueueMgr:luaAddEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_REFRESH..self.id,nil,self.update)
end
function T:onExit()
	AircraftProduceQueueMgr:luaRemoveEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_REFRESH..self.id,nil,self.update)
end

function T:cleanUp()

end

function T:GetWidget()
	-- 资源头像
	self._imgHead = self._widget.leftHead

	-- 取消按钮
	self._btnCancle = self._widget.button1
	self._btnCancle:setName("btnCancle")
	REL:toOther("left", "bottom", self._btnCancle, self._widget.back, 385,5)

	-- 加速按钮
	self._btnSpeed = self._widget.button2
	self._btnSpeed:setName("btnSpeed")
	REL:toOther("left", "bottom", self._btnSpeed, self._widget.back, 385 + 74,-3)
	local posy = self._btnSpeed:getPositionY()
	--self._btnSpeed:setPosition(cc.p(532,51.5))
	-- 名字
	self._labelName = self._widget.title

	-- 进度条
	self._progress = self._widget.loadingBar

	-- 时间
	self._labelTime = self._widget:getLabel(2)

	-- 显示的钻石
	local labelCostDiamond = XMLLabel()
	labelCostDiamond:setHAlign("center")
	labelCostDiamond:setVAlign("middle")
	labelCostDiamond:setContentSize(cc.size(300, 36))
	self._btnSpeed:addChild(labelCostDiamond)
	self._labelCostDiamond = labelCostDiamond

	REL:toOther("center", "middle", self._labelCostDiamond, self._btnSpeed, -34, 4)
	--self._labelCostDiamond:setPosition(cc.p(348,42))

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_AIRCRAFT_PRODUCTING_ITEM_INCR_BUTTON,self._btnSpeed)

		BGMgr:fire(BGMgr.EVT_AIRCRAFT_PRODUCT_STARTED,self.sid)
	end
end

--- 设置不变的数据
function T:SetData()
	local queueItem = AircraftProduceQueueMgr:getQueueItems()[self.id]
	local unitNum = queueItem.unitNum
	local sid = queueItem.unitType

	local dt=Aircraft_temp[sid]

	-- self._imgHead
	local iconPath = IconManager.iconPath
	self._imgHead:loadTexture(iconPath .. dt.icon)

	self._widget:setString(self._labelName,Language:get("uc44",AircraftUtils:getRichName(dt),unitNum))

end

--- 生产完成
function T:produceFinishShow()
--    local queueItem = AircraftProduceQueueMgr:getQueueItems()[self.id]
--    local unitNum = queueItem.unitNum
--    local sid = queueItem.unitType

--    local name = Aircraft_temp[sid].name

--    local descripe = Language:get("uc183",Language:get(name),unitNum)
--    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

end

--- 每帧刷新的数据
function T:UpData()
	local queueItem = AircraftProduceQueueMgr:getQueueItems()[self.id]
	local remainingSec = queueItem.remainingSec

	local upgradeTime = nil
	if self.recruitType == 0 then -- 生产
		upgradeTime = Aircraft_temp[queueItem.unitType].upgradeTime

	else
		upgradeTime = Aircraft_temp[queueItem.unitType].time
	end
	upgradeTime = BuildingDiamondCalculation:AircraftProActualTime(self.location,upgradeTime)

	local unitNum = queueItem.unitNum
	local allTime = unitNum * upgradeTime

	self._progress:setPercentage((allTime - remainingSec)/allTime*100)
	self._widget:setString(self._labelTime,Language:get("uc42",UnitConversion.handleTime2(remainingSec)))

	-- 钻石显示
	local needDiamond = BuildingDiamondCalculation.GetSpeedFinishDiamond(queueItem)
	self._labelCostDiamond:setString(Language:get("uc102",needDiamond))
end

function T:SetButton()
	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local name = sender:getName()
			if name == "btnCancle" then
				self:CancleLogic()
			elseif name == "btnSpeed" then
				if BGMgr:isGuide() then
					BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_AIRCRAFT_PRODUCTING_ITEM_INCR_BUTTON)
				end

				self:SpeedLogic()
			else
				print("按钮不对")
			end
		end
	end
	self._btnCancle:addTouchEventListener(callback)
	self._btnSpeed:addTouchEventListener(callback)
end

--- 取消逻辑
function T:CancleLogic()
	local info = Language:get("uc282") .. Language:get("uc946")
	local function confirm()
		local function finish()
			-- 计算返回资源
			--self:BackResLogic()
			-- 取消完成后从队列中移除
			AircraftProduceQueueMgr:removeItem(self.id) -- 队里id

			AircraftProduceQueueMgr:luaRemoveEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_REFRESH..self.id,nil,self.update)
			self:RemoveSelf()
		end

		BuildingCommand.CancleNomalRecruitCommand(self.id,finish)  -- 命令不要重复了
	end
	MUIPop.MUIImmediate(info,confirm)
end

--- 根据取消计算的返回资源数目:这个可能没用，但是先写到这里吧！！！！！！！！！！！！！！
function T:BackResLogic()
	local queueItem = AircraftProduceQueueMgr:getQueueItems()[self.id]
	local remainingSec = queueItem.remainingSec

	local upgradeTime = nil
	local buildCommandData = nil
	if self.recruitType == 0 then -- 生产
		upgradeTime = Aircraft_temp[queueItem.unitType].upgradeTime
		buildCommandData = Aircraft_temp[queueItem.unitType].upResourceCosts
	else
		upgradeTime = Aircraft_temp[queueItem.unitType].time
		buildCommandData = Aircraft_temp[queueItem.unitType].resourceCosts
	end
	upgradeTime = BuildingDiamondCalculation:AircraftProActualTime(self.location,upgradeTime)

	local unitNum = queueItem.unitNum
	local allTime = unitNum * upgradeTime

	local num = #buildCommandData

	for i = 1,num,1 do
		local resData = buildCommandData[i] -- {2,100}
		local nowNum = UserInfo.city[Resource_temp[resData[1]].attributeName]
		local maxNum = resData[2] * unitNum

		local backRes = math.floor(maxNum*remainingSec/allTime)
		UserInfo.city[Resource_temp[resData[1]].attributeName] = nowNum + backRes
	end
	ResourceManager:luaDispatchEvent(ResourceManager.EVT_TYPE_RESOURCE_REFRESH)
end

--- 加速逻辑
function T:SpeedLogic()
	local function finish()
		--      self:produceFinishShow()
		--        -- 数量更新到内存了里面去，显示上这个项要移除
		--        local queueItem = AircraftProduceQueueMgr:getQueueItems()[self.id]
		--        local num = UserInfo.city.aircraftBox.infos[queueItem.unitType].num  --  sid
		--        UserInfo.city.aircraftBox.infos[queueItem.unitType].num = num + queueItem.unitNum

		--        AircraftManager:luaDispatchEvent(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH) -- add by yuding

		-- 加速完成后从队列中移除
		AircraftProduceQueueMgr:removeItem(self.id) -- 队里id

		AircraftProduceQueueMgr:luaRemoveEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_REFRESH..self.id,nil,self.update)
		self:RemoveSelf()
	end

	local payState = SetStates.setPayState
	local value = payState:getClosedValue(payState.CLOSE_PRODECE_SPEED)

	local queueItem = AircraftProduceQueueMgr:getQueueItems()[self.id]
	local needDiamond = BuildingDiamondCalculation.GetSpeedFinishDiamond(queueItem)
	if value then
		BuildingCommand.SpeedNomalRecruitCommand(self.id,needDiamond,finish)
	else
		local info = Language:get("uc563",needDiamond)
		local layout = DiamondPopInfo.new(info)
		local function confirm()
			SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_PRODECE_SPEED)
			if layout.judge == true then
				Command:SetPayCommand()
			end
			BuildingCommand.SpeedNomalRecruitCommand(self.id,needDiamond,finish)
		end
		local alter=MUIPop.DiamondPopInfo(layout,confirm)

		if BGMgr and BGMgr:isGuide() then
			BGMgr:fire(BGMgr.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_OPEN)
		
			--此侦听可不手动移除,因为alter对象关闭后就被释放了
			alter:luaAddEventListener("onExit",nil,function()
				BGMgr:fire(BGMgr.EVT_ADD_SPEED_AIRCRAFT_PRODUCE_ALTER_CLOSE)
			end)
		end
	end
end

--- 从listview中移除self这项，并且更新listview
function T:RemoveSelf()
	local index = self.listView:getIndex(self)
	local listView = self.listView
	self.listView:removeItem(index)
	listView:refreshView()
end

return T
