--- 机库生产Layout
local T = class("T",function() return ccui.Layout:create() end)

--- 服务器数据
T.dataFromServer = nil

--- 战机项
T.aircraftFactoryProduceList = require "src.app.uiScript.components.aircraftFactory.aircraftFactoryProduce.AircraftFactoryProduceList"

--- 主窗口
T.airWindow = nil

--- 队列数据
T.queue = nil


--- 构造函数
function T:ctor(data,airWindow)
	self.dataFromServer = data
	self.airWindow = airWindow
	self.queue = Queue()

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)
end

function T:init()
	local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,self,10,0,0,0)
	self.listView = MUIListTree.extend(listView)

	self:_addToListview()
end

--- 进入
function T:onEnter()
	
end

--- 退出
function T:onExit()
	self.queue:clearT()
	self.queue = nil
end

function T:_addToListview()
	local temp = mapping({},Aircraft_temp)
	local num = #temp

	-- 这里要分是机库，还是改造工厂
	local location = self.dataFromServer.location
	if location == 5 then
		-- 改造工厂
		for i = 5,num,1 do
			if temp[i] then
				temp[i].sid = i
				self.queue:push(temp[i])
			end
		end
	else
		for i = 1,num,1 do
			if temp[i] then
				temp[i].sid = i
				self.queue:push(temp[i])
			end
		end
	end

	self:runAction(
		cc.RepeatForever:create(
			cc.Sequence:create(
				cc.DelayTime:create(0.1),
				cc.CallFunc:create( function()
					self:addRes()
				end)
			)
		)
	)
end

function T:addRes()
	local data = self.queue:pop()
	local list=self.listView
	if data then
		local node = list:getRootNode()
		local res = self.aircraftFactoryProduceList.new(data.sid,node,self.dataFromServer,self.airWindow)
		node:setContentSize(cc.size(res.size.width,res.size.height))
		node:addChild(res)
		node:setOpacity(0)

		node:runAction(
			cc.FadeIn:create(0.5)
		)

		if BGMgr:isGuide() and data.sid == 1 then
			BGMgr:regGuideObj(BGMgr.TGR_AIRCRAFT_PRODUCT_ITEM_1_EXPAND_BUTTON,res._btnOpen)

			BGMgr:fire(BGMgr.EVT_AIRCRAFT_PRODUCT_1_CREATED,list)
		end
	else
		self:stopAllActions()
	end
end

return T
