--- 机库生产的list
local T = class("T",function() return ccui.Layout:create() end)

--- 服务器数据
T.dataFromServer = nil

--- list（战机的sid）的sid
T.sid = nil

--- 这个窗口的大小
T.size = nil

--- node(是项的父节点，也是listview的孩子)
T.node = nil

--- 展开按钮和信息按钮的标记.1：是展开，2：提示信息
T.btnTag = nil

--- 打开的页面
T.aircraftFactoryProduceOpen = require "src.app.uiScript.components.aircraftFactory.aircraftFactoryProduce.AircraftFactoryProduceOpen"

--- 主窗口
T.airWindow = nil


--- 构造函数
function T:ctor(sid,node,dataFromServer,airWindow)
	self.sid = sid
	self.node = node
	self.dataFromServer = dataFromServer
	self.airWindow = airWindow

	self:registerScriptHandler(
		function(eventType)
			--print("ResourceListOpenItem:"..eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	local _widget = ListItem4.new()
	self.size = _widget:getContentSize()
	self:setContentSize(self.size)
	_widget:setListItemAttribute(
		"H",
		{"label","label"},
		{{"scaleOut_normal.png","iconButton_general_down.png","false","false"}}
	)
	self:addChild(_widget)
	REL:toOther("left","top",_widget,self,0,0)
	self._widget = _widget


	-- 得到的控件
	self:GetWidget()
	-- 设置数据
	self:SetData()
	-- 按钮回调设置
	self:SetButton()
	-- 添加展开事件处理
	self:AddListItem()

end

function T:onEnter()
	-- 监听飞机生产完成后更新这里的数据
	local function aircraftProduceFinish()
		local num = UserInfo.city.aircraftBox.infos[self.sid].num
		self._widget:setString(self._labelNowNeed,Language:get("uc31",num))
	end
	self.aircraftProduceFinish = aircraftProduceFinish
	AircraftManager:luaAddEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,nil,self.aircraftProduceFinish)

	-- 监听建筑物的等级，来更新解锁
	local function buildUpGradeFinish()
		-- 数据要重新刷新
		local location = self.dataFromServer.location
		self.dataFromServer = BuildingsInfoMgr:getBuildingInfos()[location]

		self:RefreshData1()
		self:AddListItem()
	end
	self.buildUpGradeFinish = buildUpGradeFinish
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.dataFromServer.location,nil,self.buildUpGradeFinish)

    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaAddEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)

end

function T:onExit()
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.dataFromServer.location,nil,self.buildUpGradeFinish)
	AircraftManager:luaRemoveEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,nil,self.aircraftProduceFinish)

    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaRemoveEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)

end

function T:cleanUp()

end

function T:GetWidget()
	-- 资源头像
	self._imgHead = self._widget.leftHead

	-- 展开按钮
	self._btnOpen = self._widget.button1

	self._btnOpen.tag = 1 -- 按钮加和减的标记
	self.node.tag = 1

	-- 名字（富文本）
	self._labelName = self._widget.title

	-- 当前拥有
	self._labelNowNeed = self._widget:getLabel(1)

	-- 描述（富文本）
	self._labelDescribe = self._widget:getLabel(2)

    -- 有活动的时候原来的时间
    local activivityTime = XMLLabel()
    activivityTime:setAlign("center","middle")
    activivityTime:setContentSize(cc.size(400,36))
    self:addChild(activivityTime)
    REL:toOther("center","middle",activivityTime,self._widget.back,135,-10)
    self.activivityTime = activivityTime

    local layer = CommonMethod:drawLine(50,50)
    activivityTime:addChild(layer)
    REL:toOther("center","middle",layer,activivityTime,0,0)
    activivityTime.layer = layer

end


function T:showActivityTime(time)
    if not time then
        return
    end

    self.activivityTime:setString(UnitConversion.handleTime4(time))

    local data = Aircraft_temp[self.sid]
	local needLevel = data.level
	local airLevel = nil
	if self.dataFromServer.location == 5 then -- 改造工厂
		local info1 = BuildingsInfoMgr:getBuildingInfos()[2]
		local info2 = BuildingsInfoMgr:getBuildingInfos()[3]

		local level1,level2
		if info1 then
			level1 = info1.level
		else
			level1 = 0
		end

		if info2 then
			level2 = info2.level
		else
			level2 = 0
		end

		airLevel = math.max(level1,level2)
	else
		airLevel = self.dataFromServer.level
	end

	if needLevel <= airLevel then  -- 解锁
        if ActivityManager.rapidDevelopmentInfo:getOpenValue() == true then
            self.activivityTime:setVisible(true)
	        self.activivityTime:updateView()
	        local contentWidth = self.activivityTime:getTextWidth()
	        local contentHeight = self.activivityTime:getTextHeight()
            local draw = self.activivityTime.layer.draw
            if draw then
                self.activivityTime:setVisible(true)
                draw:clear()
                draw:drawSegment(cc.p(-(contentWidth/2),contentHeight/2), cc.p(contentWidth/2, -contentHeight/2), 1.5, cc.c4f(1, 0, 0, 1))
            end
        else
            self.activivityTime:setVisible(false)
        end
	else
        self.activivityTime:setVisible(false)
	end


end


function T:SetData()
	-- 不变的,这个是资源的图片
	local iconPath = IconManager.iconPath
	local dt=Aircraft_temp[self.sid]
	self._imgHead:loadTexture(iconPath .. dt.icon)

	-- 名字
	self._widget:setString(self._labelName,AircraftUtils:getRichName(dt))
	self._btnOpen.tag = 1 -- 初始化

	-- 要变的
	self:RefreshData1()
end

--- 刷新数据显示
function T:RefreshData1()
	local data = Aircraft_temp[self.sid]

	local needLevel = data.level

	local upgradeTime = nil

	local airLevel = nil
	if self.dataFromServer.location == 5 then -- 改造工厂
		local info1 = BuildingsInfoMgr:getBuildingInfos()[2]
		local info2 = BuildingsInfoMgr:getBuildingInfos()[3]

		local level1,level2
		if info1 then
			level1 = info1.level
		else
			level1 = 0
		end

		if info2 then
			level2 = info2.level
		else
			level2 = 0
		end

		airLevel = math.max(level1,level2)

		upgradeTime = data.time
	else
		airLevel = self.dataFromServer.level
		upgradeTime = data.upgradeTime
	end

    self:showActivityTime(BuildingDiamondCalculation:AircraftProActualTimeNoAcitvity(self.dataFromServer.location,upgradeTime))

	local newTime = BuildingDiamondCalculation:AircraftProActualTime(self.dataFromServer.location,upgradeTime)

	if needLevel <= airLevel then  -- 解锁
		self._widget:setString(self._labelDescribe,Language:get("uc42",UnitConversion.handleTime4(newTime)))
        REL:toOther("left", "top", self._labelDescribe, self._widget.back,280,60)
		self._btnOpen:loadTextures("scaleOut_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
		self.btnTag = 1
	else
		self._labelDescribe:setString(Language:get("uc43",needLevel))
        REL:toOther("left", "top", self._labelDescribe, self._widget.back,280,60)
		self._btnOpen:loadTextures("infoButton_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
		self.btnTag = 2
	end

	local num = UserInfo.city.aircraftBox.infos[self.sid].num
	self._widget:setString(self._labelNowNeed,Language:get("uc31",num))
end

function T:SetButton()
	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			if self.btnTag == 1 then
				if BGMgr:isGuide() then
					BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_AIRCRAFT_PRODUCT_ITEM_1_EXPAND_BUTTON)
				end

				AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
				self.node:dispachEvent()
				self:OpenLogic(sender)
			else
				self:PromptInfo()
			end
		end
	end
	self._btnOpen:addTouchEventListener(callback)

	local function callback2(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			if self.btnTag == 1 then
				AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
				self.node:dispachEvent()
				self:OpenLogic(sender)
			end
		end
	end
	self.node:addTouchEventListener(callback2)

end

--- 打开逻辑
function T:OpenLogic(sender)
	if sender.tag == 2 then
		self._btnOpen:loadTextures("scaleOut_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
		self.node.tag = 1
		self._btnOpen.tag = 1
	else
		self._btnOpen:loadTextures("scaleIn_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
		self.node.tag = 2
		self._btnOpen.tag = 2
	end
end

--- 打开提示信息逻辑
function T:PromptInfo()
	local layout = AircraftPopInfo.new(self.sid)
	MUIAlter_noTitle.show(
		{
			info = layout,
			flag = 4,
		}
	)
end

-- 添加展开事件处理
function T:AddListItem()
	if self.btnTag == 1 then
		--打开展开页面
		self.node:addListener(function(leafContainer)
			local subItem = self.aircraftFactoryProduceOpen.new(self.sid,self.dataFromServer,self.airWindow,self) -- 传入的是战机的sid
			leafContainer:setContentSize(subItem:getContentSize())
			leafContainer:addChild(subItem)
		end)
	end

end

--- 一键完成后更新页面显示数据
function T:UpdateSidNum()
	-- 已经更新到内存中去了，是最新的数据
	local num = UserInfo.city.aircraftBox.infos[self.sid].num
	self._widget:setString(self._labelNowNeed,Language:get("uc31",num))
end

return T
