--[[
 *	机库一键生产Layout
]]
local T = class("T",function() return ccui.Layout:create() end)

--- list（战机的sid）的sid
T.sid = nil

--- 滑动条最小数量
T.smallCount = 1

--- 滑动条最大数量
T.maxCount = 1000

--- 战机的数量,现在暂时默认为1
T.num = 1

--- bid
T.dataFromServer = nil

--- 消耗的钻石
T.diamond = nil

--- list列表项
T.list = nil

--- 构造函数
function T:ctor(sid,dataFromServer,list)
    self.sid = sid
    self.dataFromServer = dataFromServer
    self.list = list

    self:registerScriptHandler(
        function(eventType)
            --print("Construct:"..eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
                
            end
        end
    )


    local size = cc.size(620,400)
    self.size = self:setContentSize(size)

    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
    -- 按钮回调设置
    self:SetButton()
end

function T:onEnter()

end

function T:onExit()
    self._slider:luaRemoveEventListener(EVENT_CHANGE,nil,self.percentChangedEvent)
end

function T:cleanUp()

end


function T:GetWidget()
    -- 战机名字
    local labelName = XMLLabel()
    labelName:setContentSize(cc.size(300, 27))
    self:addChild(labelName)
    REL:toOther("left", "top", labelName, self, 30, 20)
    self._labelName = labelName

    -- 滑动条下面的背景图片
    local imgImage_back3 = ccui.ImageView:create()
    imgImage_back3:loadTexture("productSilderBack.png",ccui.TextureResType.plistType)
    self:addChild(imgImage_back3)
    REL:toOther("center","top",imgImage_back3,self,0,70)
    self._imgImage_back3 = imgImage_back3

    -- 滑动条
    local slider = Slider("productSilderFore.png","h3","sliderButton.png","sliderButton.png")
    slider:setMaxValue(self.maxCount)
    self:addChild(slider)
    REL:relOther(slider,self._imgImage_back3,158,84,8,8)
    self._slider = slider

    -- 战机数量
    local labelNum = XMLLabel()
    labelNum:setContentSize(cc.size(150, 27))
    self:addChild(labelNum)
    REL:toOther("left", "middle", labelNum, self._imgImage_back3, 15, 0)
    self._labelNum = labelNum

    -- 一键生产按钮
    local btnImmediateProduce = Button.new("true","true")
    btnImmediateProduce:setName("Button_immediate_upgrade")
    btnImmediateProduce:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
    btnImmediateProduce:setButtonPic("oneKeyLevelUpIcon.png")
    self:addChild(btnImmediateProduce)
    REL:toOther("center","middle",btnImmediateProduce,self,0,-20)
    self._btnImmediateProduce = btnImmediateProduce

    -- 消耗钻石
    local labelCostGems = XMLLabel()
    labelCostGems:setContentSize(cc.size(300, 27))
    self:addChild(labelCostGems)
    REL:toOther("left", "top", labelCostGems, self, 30, 120)
    self._labelCostGems = labelCostGems

    -- 现有钻石
    local labelNowGems = XMLLabel()
    labelNowGems:setContentSize(cc.size(300, 27))
    self:addChild(labelNowGems)
    REL:toOther("left", "top", labelNowGems, self, 350, 120)
    self._labelNowGems = labelNowGems

    -- 描述1
    local labelDescrip1 = XMLLabel()
    labelDescrip1:setContentSize(cc.size(620, 27))
    self:addChild(labelDescrip1)
    REL:toOther("left", "bottom", labelDescrip1, self, 10, 65)
    self._labelDescrip1 = labelDescrip1

    -- 描述2
    local labelDescrip2 = XMLLabel()
    labelDescrip2:setContentSize(cc.size(620, 27))
    self:addChild(labelDescrip2)
    REL:toOther("left", "bottom", labelDescrip2, self, 10, 35)
    self._labelDescrip2 = labelDescrip2

    -- 左边-按钮
    local leftBtn = ccui.Button:create()
    leftBtn:setName("leftBtn")
    leftBtn:loadTextures("buttonRed_normal.png", "buttonRed_normal.png", "",ccui.TextureResType.plistType)
    imgImage_back3:addChild(leftBtn)
--    leftBtn:setScale(40,30)
    REL:toOther("left","middle",leftBtn,imgImage_back3,100,0)
    self.leftBtn = leftBtn
    -- 右边+按钮
    local rightBtn = ccui.Button:create()
    rightBtn:setName("rightBtn")
    rightBtn:loadTextures("buttonInc_normal.png", "buttonInc_normal.png", "",ccui.TextureResType.plistType)
    imgImage_back3:addChild(rightBtn)
--    rightBtn:setScale(40,30)
    REL:toOther("right","middle",rightBtn,imgImage_back3,20,0)
    self.rightBtn = rightBtn

end

function T:SetData()
    local data = Aircraft_temp[self.sid]

    self._labelName:setString(AircraftUtils:getRichName(data))
    self._labelDescrip1:setString(Language:get("uc56"))
    self._labelDescrip2:setString(Language:get("uc57"))
    
    self._labelNowGems:setString(Language:get("uc55",UserInfo.gems))

    self:RefreshData(1)  -- 默认百分比是1

    self._btnImmediateProduce:setString(Language:get("uc112"))
end

--- 滑动条改变则刷新数据
function T:RefreshData(per)
    local percent = nil
    if per == 0 then
        percent = 1
    else
        percent = per
    end

    local allNum = math.floor((percent * self.maxCount)/1000)

    if allNum < 1 then -- 0.555还是取1
        allNum = 1
    end

    if per == 0 then
        allNum = self.smallCount
    end

    self.num = allNum
    
    if allNum == self.smallCount then
        self.leftBtn:setIsGray(true)
        self.leftBtn:setTouchEnabled(false)
        self.rightBtn:setIsGray(false)
        self.rightBtn:setTouchEnabled(true)

    elseif allNum == self.maxCount then
        self.rightBtn:setIsGray(true)
        self.rightBtn:setTouchEnabled(false)
        self.leftBtn:setIsGray(false)
        self.leftBtn:setTouchEnabled(true)

    else
        self.leftBtn:setIsGray(false)
        self.rightBtn:setIsGray(false)
        self.leftBtn:setTouchEnabled(true)
        self.rightBtn:setTouchEnabled(true)
    end

    self._labelNum:setString(self.num)

    local diamond = BuildingDiamondCalculation.GemsNomalRecruitLogic(self.num,self.sid,self.dataFromServer.location)
    self.diamond = diamond
    self._labelCostGems:setString(Language:get("uc54",diamond))
end

function T:SetButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            self:BtnProduceLogic()
        end
    end
    self._btnImmediateProduce:addTouchEventListener(callback)
     
    -- slider的监听
    local function percentChangedEvent(t)
        local percent = t:getValue()
        self:RefreshData(percent)
    end  
    self.percentChangedEvent = percentChangedEvent
    self._slider:luaAddEventListener(EVENT_CHANGE,nil,percentChangedEvent)


    -- 按钮+和-
    local function callback1(sender, eventType)
        if eventType == ccui.TouchEventType.ended or eventType == "longDownTrigger" then 
            if self._slider:getEnabled() == false then
                return
            end
            local name = sender:getName()
            local value = self._slider:getValue()
            if name == "leftBtn" then  -- 减
                if value >= 1 then
                    value = value - 1
                end
                self:RefreshData(value)
                self._slider:setValue(value)
            else
                if value < 1 then  -- 要考虑0和1的情况
                    value = value + 2
                elseif value < 100 and value > 1 then
                    value = value + 1
                end
                self:RefreshData(value)
                self._slider:setValue(value)
            end
        end
    end

    BaseButton:extend(self.leftBtn)
    BaseButton:extend(self.rightBtn)
    self.leftBtn:addTouchEventListener(callback1) 
    self.rightBtn:addTouchEventListener(callback1) 
end

--- 按钮一键生产逻辑
function T:BtnProduceLogic()
    local function finish()
        if self and self._btnImmediateProduce then
            self._btnImmediateProduce:setTouchEnabled(false)
        end
        
        if self and self.list then -- 防止点击外面关闭窗口
            self.list:UpdateSidNum()
        end
        if self and self.muialter2 then
            self.muialter2:hide()
        end

        local descripe = Language:get("uc183",Language:get(Aircraft_temp[self.sid].name),self.num)
        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )   
    end

    BuildingCommand.GemsNomalRecruitCommand(self.sid,self.dataFromServer.id,self.num,self.diamond,finish,self)
end

--- 设置弹出窗口
function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end

return T