--[[
 * 活动主窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)


--- 构造函数 
function T:ctor()
    local function callBack1()
        self:activityLogic()
    end

    local function callBack2()
        self:noticeLogic()
    end

    -- 创建2个
    local switchButtonContainer = SwitchButtonContainer.new()
    self:addChild(switchButtonContainer)
    REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
    switchButtonContainer:init()
    switchButtonContainer:initButtons(
        2,
        {{"viewSwitchButton_normal.png","viewSwitchButton_down.png"},{"viewSwitchButton_normal.png","viewSwitchButton_down.png"}},
        {110,15},
        {callBack1,callBack2},
        {Language:get("uc428"),Language:get("uc429")}
    )
    self.switchButtonContainer = switchButtonContainer

    self:setWindowTitle(Language:get("uc806"))

    self:activityLogic()

    self:updateAnnounceTag()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    AnnounceManager:luaAddEventListener(AnnounceManager.EVT_ANNOUNCECRC_REFRESH , self, self.updateAnnounceTag)

end

function T:onExit()
    self.super.onExit(self)
    AnnounceManager:luaRemoveEventListener(AnnounceManager.EVT_ANNOUNCECRC_REFRESH , self, self.updateAnnounceTag)

end

--- 活动
function T:activityLogic()
    if self.activity == nil then
        self.activity = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.ActivityView").new()
        self:addChild(self.activity)       
        REL:relOther(self.activity,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.activity:init()
    end

    if self.activity then
        self.activity:setVisible(true)
    end

    if self.notice then
        self.notice:setVisible(false)
    end

end

--- 公告
function T:noticeLogic()
    if self.activity then
        self.activity:setVisible(false)
    end

    if self.notice == nil then
        local function finish()
            self.notice = require("src.app.uiScript.components.allActivity.fixAndDynamic.notice.NoticeView").new()
            self:addChild(self.notice)       
            REL:relOther(self.notice,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
            self.notice:init()
        end
        Command:getAnnounceInfo(AnnounceManager:getAnnounceCrcFront(),finish)

    end

    if self.notice then
        self.notice:setVisible(true)
    end

end


--- 更新公告标识
function T:updateAnnounceTag()
	self.switchButtonContainer:updateButton2Tag(AnnounceManager:judgeIsAnnounceInfo())
end



return T