--- 活动项
local T = class("T",function() return ccui.Layout:create() end)

--- 活动信息
T.actInfo = nil

--- activityListView
T.activityListView = nil

--- 构造函数
function T:ctor(activityListView,actInfo)
	self.activityListView = activityListView
	self.actInfo = actInfo

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	self.size = cc.size(300,248)
	self:setContentSize(self.size)

	self:init()

	self:addEvent()

	--- 判断标记
	self:judgeTag()

	self:refeshTime()

end

--- 进入
function T:onEnter()
	self.actInfo:luaAddEventListener(self.actInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.actInfo.sid,self,self.closeSelf)
	self.actInfo:luaAddEventListener(self.actInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. self.actInfo.sid , self, self.judgeTag)

	if self.actInfo.EVT_ACTIVTIY_TIME_REFRESH then -- 其它固定的活动没时间的
		self.actInfo:luaAddEventListener(self.actInfo.EVT_ACTIVTIY_TIME_REFRESH .. self.actInfo.sid , self, self.refeshTime)
	end

end

--- 退出
function T:onExit()
	self.actInfo:luaRemoveEventListener(self.actInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.actInfo.sid,self,self.closeSelf)
	self.actInfo:luaRemoveEventListener(self.actInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. self.actInfo.sid , self, self.judgeTag)

	if self.actInfo.EVT_ACTIVTIY_TIME_REFRESH then
		self.actInfo:luaRemoveEventListener(self.actInfo.EVT_ACTIVTIY_TIME_REFRESH .. self.actInfo.sid , self, self.refeshTime)
	end

end

function T:init()
	local actInfo = self.actInfo

	--- 背景图片
	local back = ccui.ImageView:create()
	back:loadTexture("activityBottom.png",ccui.TextureResType.plistType)
	self:addChild(back)
	REL:toOther("left","top",back,self,5,-6)
	self.back = back

	--- icon
	local icon = ccui.ImageView:create()
	local iconPath = IconManager.iconPath
	icon:loadTexture(iconPath .. FixAndDynamicAct_temp[actInfo.sid].icon)
	self:addChild(icon)
	REL:toOther("center","top",icon,self.back,0,10)
	self.icon = icon

	--- 名字
	local labelName = XMLLabel()
	labelName:setContentSize(cc.size(300,36))
	labelName:setAlign("center","bottom")
	self:addChild(labelName)
	REL:toOther("center","bottom",labelName,self.back,0,50)
	self.labelName = labelName
	labelName:setString(Language:get("uc276",Language:get(FixAndDynamicAct_temp[actInfo.sid].name)))

	-- 时间显示
	local time = XMLLabel()
	time:setContentSize(cc.size(300,36))
	time:setAlign("center","bottom")
	self:addChild(time)
	REL:toOther("center","bottom",time,self.back,0,12)
	self.time = time


end

function  T:closeSelf()
	if self.actInfo:getOpenValue() == false then
        --self:removeFromParent()
	end

end

function T:addEvent()
	self:setTouchEnabled(true)
	BaseButton:extend(self)

	-- 测试
	self:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			-- 根据sid得到是哪一个文件
			if self.actInfo.sid == 100 or self.actInfo.sid == 108 or self.actInfo.sid == 200 or self.actInfo.sid == 203 or self.actInfo.sid == 205 or self.actInfo.sid == 207 or self.actInfo.sid == 101 or self.actInfo.sid == 103 or self.actInfo.sid == 105 or self.actInfo.sid == 107 then
				local function finish(lotteryData)
					local page = ActivityManager:getActInfoBySid(self.actInfo.sid).page
					if page then
						WindowManager:push(page.new(self.actInfo,lotteryData))
					end
				end
				Command:getDynamicActData(self.actInfo.sid,finish)  -- 每次重新获取数据
			elseif self.actInfo.sid == 106 or self.actInfo.sid == 206 then
				local function finish(data)
					local page = ActivityManager:getActInfoBySid(self.actInfo.sid).page
					if page then
						WindowManager:push(page.new(self.actInfo))
					end
				end
				Command:getDynamicActData(self.actInfo.sid,finish)  -- 每次重新获取数据
			elseif self.actInfo.sid == 102 or self.actInfo.sid == 202 then -- 打开分页获取数据
				local function finish(lotteryData)
					local page = ActivityManager:getActInfoBySid(self.actInfo.sid).page
					if page then
						WindowManager:push(page.new(3,true,lotteryData))
					end
				end
				Command:getDynamicActData(self.actInfo.sid,finish)  -- 每次重新获取数据
			elseif self.actInfo.sid == 1 then
				local page = ActivityManager:getActInfoBySid(self.actInfo.sid).page
				if page then
					WindowManager:push(page.new()) -- 1是签到，后面加的，要特殊处理一下
				end
            elseif self.actInfo.sid == 5 then
                local function finish(data)
					local page = ActivityManager:getActInfoBySid(self.actInfo.sid).page
					if page then
						WindowManager:push(page.new(self.actInfo,data))
					end
				end
                Command:checkFirstRecharge(finish)  -- 每次重新获取数据
			else -- 104 也在这个里面
				local page = ActivityManager:getActInfoBySid(self.actInfo.sid).page
				if page then
					WindowManager:push(page.new(self.actInfo))
				end
			end

		end
	end)

end

--- 更新标识
function T:judgeTag()
	local state = self.actInfo:judgeHomePage()

	if state then
		if not self.armyTaskTag then
			self.armyTaskTag = self:getEff("promptEffect")
			self:addChild(self.armyTaskTag)
			REL:toOther("right", "top", self.armyTaskTag, self.icon, 18, 15)
		end
	else
		if self.armyTaskTag then
			self.armyTaskTag:removeFromParent()
			self.armyTaskTag = nil
		end
	end
end

--- 获得特效
function T:getEff(kind)
	local s = cc.Sprite:create()
	local ani = ResLoader:getAnimation(kind)
	if not ani then
		return
	end

	local ac = cc.RepeatForever:create(cc.Animate:create(ani))
	s:runAction(ac)
	return s

end



--- 刷新时间
function T:refeshTime()
	if self.actInfo.remainingSec and self.actInfo.remainingSec >= 0 then
		self.time:setVisible(true)

		self.time:setString(Language:get("uc768",UnitConversion.timeCount2(self.actInfo.remainingSec)))

	else
		self.time:setVisible(false)

	end

end



return T
