--[[
 *	活动视图
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 每项的信息
T.ActivityListItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.ActivityListItem")

--- 构造函数
function T:ctor()
end

function T:init()
    self.items = {}

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local scrollView = ccui.ScrollView:create()
	scrollView:setTouchEnabled(true)
	scrollView:setBounceEnabled(true)
	self:addChild(scrollView)
	REL:relOther(scrollView,self,0,0,0,0)
    self.scrollView = scrollView

    self:_addToListView()
end

--- 进入
function T:onEnter()
    -- 断线重连
    UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET, self, self._addToListView)

end

--- 退出
function T:onExit()
    UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET, self, self._addToListView)

end

function T:_addToListView()
    self.scrollView:removeAllChildren()

    self.items = {}

    local openList = ActivityManager:getOpenActList()
    local num = #openList

    -- 这里活动现在暂时最多6个,但是还是要动态写现在的活动个数
    local scrollView = self.scrollView
    local container = scrollView:getInnerContainer()

    local height = nil
    if num > 6 then
        local tempNum = num
        if num%2 == 1 then
            tempNum = tempNum + 1
        end
        height = (tempNum/2) * 250
    else
        height = scrollView:getContentSize().height
    end

    scrollView:setInnerContainerSize(cc.size(scrollView:getContentSize().width,height))

    --local posTemp = {{10,0},{310 + 10,0},{10,250},{310 + 10,250},{10,250*2},{310 + 10,250*2},{10,250*3},{310 + 10,250*3},{10,250*4},{310 + 10,250*4}}
    for i = 1,num,1 do
        local x = 0
        local y = 0
        if i % 2 == 1 then
            x = 10
        else
            x = 310 + 10
        end
        
        if i == 1 or i == 2 then
            y = 0
        else
            y = (math.floor( (i + 1)/2 ) - 1) * 250
        end


        local res = self.ActivityListItem.new(self,openList[i])
        container:addChild(res)
        REL:toOther("left","top",res,container,x,y)
        self.items[#self.items + 1] = res

    end

end


return T