--[[
 *	军备竞赛项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 构造函数
function T:ctor(cumulativeRechargeInfo,index)
    self.cumulativeRechargeInfo = cumulativeRechargeInfo
    self.index = index

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.tagInfo = 1  -- 表示第1次进来

    self:init()

end

--- 进入
function T:onEnter()
    self.cumulativeRechargeInfo:luaAddEventListener(self.cumulativeRechargeInfo.EVT_IS_GET_REFRESH .. self.cumulativeRechargeInfo.sid,self,self.refreshData)

    AircraftManager:luaAddEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,self,self.refreshData)

end

--- 退出
function T:onExit()
    self.cumulativeRechargeInfo:luaRemoveEventListener(self.cumulativeRechargeInfo.EVT_IS_GET_REFRESH .. self.cumulativeRechargeInfo.sid,self,self.refreshData)
    
    AircraftManager:luaRemoveEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,self,self.refreshData)

end


function T:init()
    local data = self.cumulativeRechargeInfo:getDataByIndex(self.index)

    local f=ResLoader:getSpriteFrame("famBack_big.png")
	local fs=f:getOriginalSize()

	self:setContentSize(fs)

    --背景图片
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	REL:toOther("center","middle",uiBack,self,0,0)
	self.uiBack=uiBack


    icon = Aircraft_temp[data.getSid].icon
    name = Aircraft_temp[data.getSid].name


	--物品图标
	local uiIcon=ccui.ImageView:create()
    uiIcon:loadTexture(IconManager.iconPath .. icon,ccui.TextureResType.localType)
	REL:toOther("left","top",uiIcon,self,4,21)
    self:addChild(uiIcon)
	self.uiIcon=uiIcon

	--标题
	local uiTitle=XMLLabel()
	uiTitle:setContentSize(cc.size(500,36))
	uiTitle:setAlign("left","middle")
	self:addChild(uiTitle)
	REL:toOther("left","top",uiTitle,self,110,2)
	self.uiTitle=uiTitle
    self.uiTitle:setString(Language:get("ug936_1",Language:get(name),data.getNum))

	--描述
	local uiDes=XMLLabel()
	uiDes:setContentSize(cc.size(340,36))
	uiDes:setAlign("left","middle")
	self:addChild(uiDes)
	REL:toOther("left","top",uiDes,self,130,80)
	self.uiDes=uiDes

    self.uiDes:setString(Language:get("uc1083",data.needNum,Language:get(Aircraft_temp[data.recruitSid].name)))


    -- 领取按钮
    local getBtn = Button.new("false","true")
	getBtn:setButtonState("button_yellow_normal.png","button_yellow_normal.png")
	getBtn:setString(Language:get("uc438"))
	self:addChild(getBtn)
    REL:toOther("right","middle",getBtn,self,20,-20)
    getBtn:setTextShadow()
    self.getBtn = getBtn
    getBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.tag == 1 then
            elseif self.tag == 2 then
            elseif self.tag == 3 then
                local function finish(data)
                    self.AwardDataDecoder:showSuccessWindow(data.awardData)
                    self:refreshData()
                end
                Command:joinDynamicAct(108,finish,self.index)

            end

        end
    end)

    -- 飞机数量显示
	local uiRevenge=XMLLabel()
	uiRevenge:setContentSize(cc.size(200,36))
	uiRevenge:setAlign("center","bottom")
	self:addChild(uiRevenge)
	REL:toOther("center","bottom",uiRevenge,getBtn,0,90)
	self.uiAircraftNum = uiRevenge

    -- 勾
    local right = ccui.ImageView:create()
    right:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(right)
    REL:toOther("center","middle",right,getBtn,0,0)
    self.right = right
    right:setVisible(false)

    self:refreshData()

end

--- 刷新领取数据
function T:refreshData()
    local data = self.cumulativeRechargeInfo:getDataByIndex(self.index)

    if self.tagInfo == 1 then -- 第1次进来
        self.uiAircraftNum:setString(Language:get("uc1084",data.recruitNum,data.needNum))
    else
        local lastNum = data.recruitNum
        local addNum = AircraftManager:getAddAircraftNumBySid(data.recruitSid)

        data.recruitNum = lastNum + addNum

        self.uiAircraftNum:setString(Language:get("uc1084",data.recruitNum,data.needNum))
    end

    AircraftManager:setAddAircraftNumBySid(data.recruitSid,0)
    

    local getBtn = self.getBtn
    local right = self.right

    local index = self.index

    -- 判断是否达到领取条件
    if self.cumulativeRechargeInfo:judgeIsGetAward(index) then -- 可以领取
        -- 判断是否已经领取没有
        if data.isGet == true then -- 领取了
            getBtn:setIsGray(true)
            getBtn:setTouchEnabled(false)
            getBtn:setVisible(false)
            right:setVisible(true)
            self:removeEff()
            self.tag = 2

        else -- 未领取
            getBtn:setIsGray(false)
            getBtn:setTouchEnabled(true)
            getBtn:setVisible(true)
            right:setVisible(false)
            self:addEff()
            self.tag = 3
        end

    else -- 不能领取
        getBtn:setIsGray(true)
        getBtn:setTouchEnabled(false)
        getBtn:setVisible(true)
        right:setVisible(false)
        self:removeEff()

        self.tag = 1

    end

    self.tagInfo = 0 -- 表示不是第1次进来

end


--- 添加特效
function T:addEff()
    if not self.btnEff then
        if ResLoader:getAnimation("buttonPolishingEff") then
            self.btnEff = ResLoader:createAnimationSprite("buttonPolishingEff")
            self:addChild(self.btnEff)
		    REL:toOther("center", "middle", self.btnEff, self.getBtn, -4, 13)
        end
    else
        
    end
end

--- 移除特效
function T:removeEff()
    if self.btnEff then
        self.btnEff:removeFromParent()
        self.btnEff = nil
    end
end

return T
