--[[
 * 军备竞赛窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new("windowBack.jpg")
        o.super = AbstractWindow
        return o
    end
)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 每日充值信息
T.cumulativeRechargeInfo = nil

--- 数据
T.rechargeData = nil 

--- 每一项
T.DailyRechargeItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.armsRace.ArmsRaceItem")


--- 构造函数 
function T:ctor(cumulativeRechargeInfo,rechargeData)
    self.cumulativeRechargeInfo = cumulativeRechargeInfo
    self.rechargeData = rechargeData
    
    self:setWindowTitle(Language:get("uc1081"))
    
    self:init()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    self.cumulativeRechargeInfo:luaAddEventListener(self.cumulativeRechargeInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.cumulativeRechargeInfo.sid,self,self.closeSelf)
end

function T:onExit()
    self.super.onExit(self)
    self.cumulativeRechargeInfo:luaRemoveEventListener(self.cumulativeRechargeInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.cumulativeRechargeInfo.sid,self,self.closeSelf)
end


--- 关闭当前窗口
function T:closeSelf()
    if self.cumulativeRechargeInfo:getOpenValue() == false then
        WindowManager:pop()
    end
    
end


--- 初始化
function T:init()
    self:initTop()
    self:initBottom()
end

--- 初始化顶部
function T:initTop()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 顶部背景图片
    local topBackFrame = ResLoader:getSpriteFrame("allianceScienceNotiBack.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(620,200))
    REL:toOther("center","top",topBack,self.viewBack,0,25)

    local secret = SecretaryGenerator:getBust("susy_clothing_1",SecretaryGenerator.DEFAULT_BUST_RECT)
    secret:setFlippedX(true)
    self:addChild(secret)
    secret:setAnchorPoint(cc.p(0, 0))
    secret:setScale(0.5)
    REL:toOther("right","bottom",secret,topBack,20,5)
    

    -- 小秘书内容
    local content = XMLLabel()
    content:setAlign("left","top")
    content:setContentSize(cc.size(400,36))
    self:addChild(content)
    REL:toOther("left","top",content,topBack,25,30)
    content:setString(Language:get("uc1082"))


end

--- 初始化底部
function T:initBottom()
    -- 底部背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self.uiContainer,8,6,230,CommonCfg.BOTTOM_CONTAINER_HEIGTH)

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,4,90)
    self.listView = listView

    local rechargeData = self.cumulativeRechargeInfo.data
    local num = #rechargeData
    for i = 1,num,1 do
        local item = self.DailyRechargeItem.new(self.cumulativeRechargeInfo,i - 1)
        listView:pushBackCustomItem(item)
    end

    -- 按钮
    local btnProduce = Button.new("false","true")
	btnProduce:setName("Button_upgrade")
	btnProduce:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
	btnProduce:setString(Language:get("uc1085"))
	self:addChild(btnProduce)
	REL:toOther("center","bottom",btnProduce,self,0,0)
    btnProduce:setTextCenter()

    btnProduce:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local list = AircraftProduceQueueMgr:getQueueItems()
		    local maxCount = VipManager.getVipProduceQueueCount()

		    --战机工厂1的位置,战机工厂2的位置
		    local af1Loc,af2Loc=PlayerInstance.fixedBldLocation.planeOne,PlayerInstance.fixedBldLocation.planeTwo

		    --战机工厂1正在生产的项目数,战机工厂2正在生产的项目数
		    local af1Count,af2Count=0,0
		    for k, v in pairs(list) do
			    if v.location == af1Loc then
				    af1Count = af1Count + 1
			    else
				    af2Count = af2Count + 1
			    end
		    end

		    --如果战机工厂1的等级>=战机工厂2的等级
		    if PlayerInstance:getBuildingLvl(af1Loc) >= PlayerInstance:getBuildingLvl(af2Loc) then
			    --如果战机工厂1生产队列已满,且战机工厂2生产队列未满
			    if af1Count >= maxCount and af2Count < maxCount then
				    HomeOpenWindowManager:openPlaneFacrtoryTwoEvent(nil, nil, 2)
			    else
				    HomeOpenWindowManager:openPlaneFactoryOneEvent(nil, nil, 2)
			    end
		    else
			    if af2Count >= maxCount and af1Count < maxCount then
				    HomeOpenWindowManager:openPlaneFactoryOneEvent(nil, nil, 2)
			    else
				    HomeOpenWindowManager:openPlaneFacrtoryTwoEvent(nil, nil, 2)
			    end
		    end


        end
    end)


end



return T