---大转盘窗口
local T = class(
    "BigWheelWindow",
    function() 
        local o = AbstractWindow.new("windowBack4.jpg")
        o.super = AbstractWindow
        return o
    end
)

----- 预加载资源列表
--T.PRE_RES_LIST={
--	"res/images/windowBack2.plist"
--}

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 大转盘信息
T.bigWheelInfo = nil

--- 所有的抽奖数据
T.lotteryData = nil 

--- 抽奖项
T.LotteryItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.bigWheel.LotteryItem")

--- 构造函数 
function T:ctor(bigWheelInfo,lotteryData)
--	ResLoader:syncLoad(self.PRE_RES_LIST)
	
    self.bigWheelInfo = bigWheelInfo
    self.lotteryData = lotteryData

    self:setWindowTitle(Language:get("uc504"))

    self:initTop()
    self:initBottom()

    self:refresh()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    self.bigWheelInfo:luaAddEventListener(self.bigWheelInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.bigWheelInfo.sid,self,self.closeSelf)
    local bigWheelNumState = DailyStates.bigWheelNumState
    bigWheelNumState:luaAddEventListener(bigWheelNumState.EVT_BIG_WHEEL_NUM_REFRESH,self,self.refresh)

    DailyStates:luaAddEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.refresh)
end

function T:onExit()
    self.super.onExit(self)
    self.bigWheelInfo:luaRemoveEventListener(self.bigWheelInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.bigWheelInfo.sid,self,self.closeSelf)
    local bigWheelNumState = DailyStates.bigWheelNumState
    bigWheelNumState:luaRemoveEventListener(bigWheelNumState.EVT_BIG_WHEEL_NUM_REFRESH,self,self.refresh)

    DailyStates:luaRemoveEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.refresh)
    
--    ResLoader:unloadReses(self.PRE_RES_LIST)
end


function T:initTop()
    --背景
	local uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("windowBack4.jpg"))
	self:addChild(uiBack)
	REL:relScreen(uiBack,0,0,65,0)
	self.uiBack = uiBack

    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 小秘书
    local sprite = SecretaryGenerator:getFelt("susy_clothing_1")
	self:addChild(sprite)
    if V_SZ.height > 960 then -- iphone 1920 还没考虑呢
        REL:toOther("left","top",sprite,viewBack,-20,10)
    else
        REL:toOther("left","top",sprite,viewBack,-20,-20)
    end
	
    self.sprite = sprite

    -- 文字显示框
    local textBackFrame = ResLoader:getSpriteFrame("chatBack2.png")
	local textBackSize = textBackFrame:getOriginalSize()
	local textBack = Scale9Sprite:createWithFrame(textBackFrame,cc.rect(textBackSize.width/2,70,1,1))
	self:addChild(textBack)
    --textBack:setContentSize(cc.size(404,200))
    REL:toOther("left","top",textBack,self.sprite,220,60)

    -- 小秘书内容
    local content = XMLLabel() 
    content:setCssStyle(CssStyles.default20) 
    content:setContentSize(cc.size(380,200))
    self:addChild(content)
    REL:toOther("left","top",content,textBack,40,8)
    content:setString(Language:get("uc549"))

    content:updateView()
	local contentHeight = content:getTextHeight()

    -- 最下面描述
    local des = XMLLabel()  
    des:setCssStyle(CssStyles.default20) 
    des:setContentSize(cc.size(380,200))
    des:setAlign("left","top")
    self:addChild(des)
    REL:toOther("left","top",des,textBack,40,8 + contentHeight + 5)
    des:setString(Language:get("uc696"))

    des:updateView()
	local desHeight = des:getTextHeight()

    -- 转动次数背景图片
    local goldenBottom = ccui.ImageView:create()
    goldenBottom:loadTexture("goldenBottom.png",ccui.TextureResType.plistType)
    self:addChild(goldenBottom)
    REL:toOther("center","top",goldenBottom,textBack,0,8 + contentHeight + 5 + desHeight)

    -- 转动次数
    local scrollCount = XMLLabel()  
    scrollCount:setContentSize(cc.size(380,200))
    scrollCount:setAlign("center","middle")
    self:addChild(scrollCount)
    REL:toOther("center","middle",scrollCount,goldenBottom,0,0)
    self.scrollCount = scrollCount

end


--- 初始化底部
function T:initBottom()
    -- 文字显示框
    local wheelBackFrame = ResLoader:getSpriteFrame("wheelBack.png")
	local wheelBackSize = wheelBackFrame:getOriginalSize()
	local wheelBack = Scale9Sprite:createWithFrame(wheelBackFrame,cc.rect(wheelBackSize.width/2,wheelBackSize.height/2,1,1))
	self:addChild(wheelBack)
    --wheelBack:setContentSize(cc.size(550,560))
    if V_SZ.height > 960 then
        REL:toOther("center","bottom",wheelBack,self.viewBack,0,50)
    else
        REL:toOther("center","bottom",wheelBack,self.viewBack,0,10)
    end
    
    self.wheelBack = wheelBack

    -- 坐标数组:离左边和顶部
    local baseLeft = 60
    local baseTop = 40
    local w,h = 118,118
    local step = 11

    self.pos = {
                {baseLeft,baseTop},{baseLeft + w + step,baseTop},{baseLeft + (w + step)*2,baseTop},{baseLeft + (w + step)*3,baseTop},
                {baseLeft + (w + step)*3,baseTop + (w + step)*1},{baseLeft + (w + step)*3,baseTop + (w + step)*2},{baseLeft + (w + step)*3,baseTop + (w + step)*3},
                {baseLeft + (w + step)*2,baseTop + (w + step)*3},{baseLeft + (w + step)*1,baseTop + (w + step)*3},{baseLeft,baseTop + (w + step)*3},
                {baseLeft,baseTop + (w + step)*2},{baseLeft,baseTop + (w + step)*1}
                }


    -- res数组
    self.res = {}

    -- 减速时间表
    local baseTime = 0.001
    self.reduceTime = { baseTime + 0.04, baseTime + 0.06,baseTime + 0.08,baseTime + 0.1,
                        baseTime + 0.1 + 0.01, baseTime + 0.1 + 0.02, baseTime + 0.1 + 0.04,baseTime + 0.1 + 0.06,baseTime + 0.1 + 0.07,
                        baseTime + 0.2 + 0.02, baseTime + 0.2 + 0.03, baseTime + 0.2 + 0.05,baseTime + 0.2 + 0.09,baseTime + 0.2 + 0.16,
                        baseTime + 0.5 + 0.03, baseTime + 0.5 + 0.06, baseTime + 0.5 + 0.1,baseTime + 0.5 + 0.15
                        }

    -- 50(开始减速id),67(结束id) 7(中奖id) 基准
    self.ids = {
    {44,61},
    {45,62},
    {46,63},
    {47,64},
    {48,65},
    {49,66},
    {50,67},
    {51,68},
    {52,69},
    {53,70},
    {54,71},
    {55,72},
    }
                          
    -- 添加抽奖项
    local lotteryData = self.lotteryData
    local i = 1
    for k,v in pairs(lotteryData) do
        if v then
            local res = self.LotteryItem.new(v)
            self:addChild(res)
            REL:toOther("left","top",res,self.wheelBack,self.pos[i][1],self.pos[i][2])
            self.res[#self.res + 1] = res

            i = i + 1
        end
    end

    -- 抽奖按钮:现在是耗费256钻石
    local btn = Button.new("false","true")
	btn:setButtonState("newButton.png","newButton.png")
	btn:setString(self.bigWheelInfo:getCostDiamond())
	self:addChild(btn)
	REL:toOther("center","bottom",btn,self.wheelBack,0,200)
    btn.buttonText:setAlign("center","middle")
    REL:toOther("center","middle",btn.buttonText,btn,10,0)
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local bigWheelNumState = DailyStates.bigWheelNumState
            local level = UserInfo.level
            if level < 15 then
                MUIAlter.show(
                    {
                        info = Language:get("uc554"),
                        size = 30
                    }
                )
                return
            else
                if bigWheelNumState:judgeIsLottery() == false then
                    MUIAlter.show(
                        {
                            info = Language:get("uc555"),
                            size = 30
                        }
                    )
                    return
                end
            end

            if bigWheelNumState:judgeIsFreeLottery() then
                local function finish(data)
                    self.data = data
                    self:startLogic()                
                end
                Command:joinDynamicAct(self.bigWheelInfo.sid,finish)
                return
            end
            
            local gems = UserInfo.gems
            if gems >= self.bigWheelInfo:getCostDiamond() then
                local function finish(data)
                    self.data = data
                    self:startLogic()       
                end
                Command:joinDynamicAct(self.bigWheelInfo.sid,finish)
            else
                MUIPop.MUIToReCharge()
            end


        end
    end)
    self.btn = btn

    --- 钻石图片
    local diamond = ccui.ImageView:create()
    diamond:loadTexture("diamond.png",ccui.TextureResType.plistType)
    btn:addChild(diamond)
    diamond:setScale(0.8)
    REL:toOther("center","middle",diamond,btn,-20,20)
    self.diamond = diamond

    --- 中间显示抽奖的物品
    local centerProp = ccui.ImageView:create()
    centerProp:loadTexture("centerProp.png",ccui.TextureResType.plistType)
    self:addChild(centerProp)
    REL:toOther("center","bottom",centerProp,self.wheelBack,0,295)
    self.centerProp = centerProp

end

--- 添加中间的图片显示
function T:addCenterImg(iconUrl)
    if not self.centerImg then
        local centerImg = ccui.ImageView:create()
        centerImg:loadTexture(iconUrl)
        self:addChild(centerImg)
        REL:toOther("center","middle",centerImg,self.centerProp,0,0)
        self.centerImg = centerImg
    else
        self.centerImg:loadTexture(iconUrl)
    end
end

--- 关闭当前窗口
function T:closeSelf()
    if self.bigWheelInfo:getOpenValue() == false then
        WindowManager:pop()
    end
    
end

function T:addAnimal()
    AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)

    local sprite = cc.Sprite:create()
    sprite:setSpriteFrame(ResLoader:getSpriteFrame("activeProp.png"))
    self:addChild(sprite)

    self.sprite = sprite
    self.i = 1
    self.allTag = 1

    REL:toOther("center","middle",sprite,self.res[self.i],0,0)
    self:addCenterImg(self.lotteryData[self.i].iconUrl)

    sprite:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.03),
		        cc.CallFunc:create( function()
			        self:runNormalAct()
		        end)
		    )
        )
	)

end

function T:runNormalAct()
    AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)

    self.i = self.i + 1
    self.allTag = self.allTag + 1
    if self.i > 12 then
        self.i = 1
    end

    local res = self.res
    local sprite = self.sprite

    REL:toOther("center","middle",sprite,res[self.i],0,0)
    self:addCenterImg(self.lotteryData[self.i].iconUrl)

    local id = self.data.id
    if self.allTag == self.ids[id][1] - 1 then
        sprite:runAction(
            cc.Sequence:create(
		        cc.DelayTime:create(self.reduceTime[1]),
		        cc.CallFunc:create( function()
		            sprite:stopAllActions()
                    self.indexTag = 2
                    self:reduceSpeedAct()
		        end)
		    )
	    )

    end

end


--- 从id为1到目标位置的时间动画
function T:reduceSpeedAct()
    local id = self.data.id
    if self.allTag == self.ids[id][2] - 1 then
        AudioManager:playEffect(SoundRes.SOUND_LOTTERY_STOP)
        print("最后一次")
    else
        AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
    end
    

    self.i = self.i + 1
    self.allTag = self.allTag + 1
   
    if self.i > 12 then
        self.i = 1
    end

    local res = self.res
    local sprite = self.sprite

    REL:toOther("center","middle",sprite,res[self.i],0,0)  
    self:addCenterImg(self.lotteryData[self.i].iconUrl)

    -- 加的圈数来减速的
    local reduceTime = self.reduceTime
    local time = reduceTime[self.indexTag] -- 从第2个索引开始减速
    self.indexTag = self.indexTag + 1

    sprite:runAction(
        cc.Sequence:create(
		    cc.DelayTime:create(time),
		    cc.CallFunc:create( function()
			    self:reduceSpeedAct()
		    end)
		)
	)

    
    if self.allTag == self.ids[id][2] then -- 暂定为18格停下来
        sprite:stopAllActions()                                                    
        self:endLogic()
    end

end

--- 开始转到逻辑
function T:startLogic()
    self.uiTopBorder.uiCloseButton:setIsGray(true)
    self.uiTopBorder.uiCloseButton:setTouchEnabled(false)
    self.uiTopBorder.uiDiamondButton:setIsGray(true)
    self.uiTopBorder.uiDiamondButton:setTouchEnabled(false)

    self.btn:setIsGray(true)
    self.btn:setTouchEnabled(false)
    self:addAnimal()
end

--- 结束转动逻辑
function T:endLogic()
    self.centerImg:setLocalZOrder(2000)
    -- 中间的图片加特效
--    local uiSp = cc.Sprite:create()
--    self:addChild(uiSp)
--    uiSp:setScale(1.3)
--	REL:toOther("center", "middle", uiSp, self.centerImg, 0, 0)
--    uiSp:setLocalZOrder(1900)

    local eff = HomePageManager:getEffWithOutRandom("iconLight")
    eff:setLocalZOrder(1900)
    eff:setScale(1.3)
    eff:setBlendFunc({src=0x0302, dst=1})
    self:addChild(eff)
    REL:toOther("center", "middle", eff, self.centerImg, 0, 0)

    local eff2 = HomePageManager:getEffWithOutRandom("iconStar")
    eff2:setLocalZOrder(3000)
    eff2:setBlendFunc({src=0x0302, dst=1})
    self:addChild(eff2)
    REL:toOther("center", "middle", eff2, self.centerImg, 0, 0)

--	local animation = ResLoader:getAnimation("iconLight")
--	if animation then
--        uiSp:runAction(
--            cc.Sequence:create(
--		        cc.Animate:create(animation),
--		        cc.CallFunc:create( function()
--			        uiSp:removeFromParent()

--		        end)
--		    )
--	    )
--	end

--    local uiSp2 = cc.Sprite:create()
--    self:addChild(uiSp2)
--	REL:toOther("center", "middle", uiSp2, self.centerImg, 0, 0)
--    uiSp2:setLocalZOrder(3000)

--	local animation = ResLoader:getAnimation("iconStar")
--	if animation then
--        uiSp2:runAction(
--            cc.Sequence:create(
--		        cc.Animate:create(animation),
--		        cc.CallFunc:create( function()
--			        uiSp2:removeFromParent()

--		        end)
--		    )
--	    )
--	end

    


    -- 延迟
    Cocos2dxUtils:timeOut(function()    
        self.uiTopBorder.uiCloseButton:setIsGray(false)
        self.uiTopBorder.uiCloseButton:setTouchEnabled(true)
        self.uiTopBorder.uiDiamondButton:setIsGray(false)
        self.uiTopBorder.uiDiamondButton:setTouchEnabled(true)

        self.btn:setIsGray(false)
        self.btn:setTouchEnabled(true)

        self.sprite:removeFromParent()
        self.sprite = nil

        -- 特效消失
        eff:removeFromParent()
        eff = nil 

        eff2:removeFromParent()
        eff2 = nil 

        self.AwardDataDecoder:showSuccessWindow(self.data.awardData)
        self.data = nil

    end,1.5)

end


--- 抽取奖励后刷新
function T:refresh()
    local bigWheelNumState = DailyStates.bigWheelNumState
    if bigWheelNumState:judgeIsFreeLottery() then
        self.diamond:setVisible(false)
        --self.btn:loadTextures("newButton.png","newButton.png", "",ccui.TextureResType.plistType)
        self.btn:setTextCenter()
        self.btn:setString(Language:get("uc553"))
        REL:toOther("center","middle",self.btn.buttonText,self.btn,0,18)
    else
        self.diamond:setVisible(true)
        self.btn:setString(self.bigWheelInfo:getCostDiamond())
        self.btn:setTextCenter()
        --self.btn:loadTextures("newButton.png","newButton.png", "",ccui.TextureResType.plistType)
        REL:toOther("center","middle",self.btn.buttonText,self.btn,20,18)
    end

    self.scrollCount:setString(Language:get("uc695",bigWheelNumState:getNum()))


end



return T