--[[
 *	采集资源项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 每一项
T.CollectResoucreOpenItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.collectResouce.CollectResoucreOpenItem")


--- 构造函数
function T:ctor(collectResourceInfo,sid,node)
    self.collectResourceInfo = collectResourceInfo
    self.sid = sid
    self.node = node
    
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.size = cc.size(622,143 - 3)
    self:setContentSize(self.size)

    self:init()
    -- 添加展开事件处理
    self:AddListItem()
    -- 按钮回调设置
    self:SetButton()

    self:refreshData()

end

--- 进入
function T:onEnter()
    self.collectResourceInfo:luaAddEventListener(self.collectResourceInfo.EVT_ACTIVTIY_TASK_FINISH_REFRESH,self,self.refreshData)
end

--- 退出
function T:onExit()
    self.collectResourceInfo:luaRemoveEventListener(self.collectResourceInfo.EVT_ACTIVTIY_TASK_FINISH_REFRESH,self,self.refreshData)
end


function T:init()
    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("showBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("left","top",back,self,2,0)
    self.back = back

    -- 描述
    local labelName = XMLLabel()
    labelName:setVAlign("middle")
    labelName:setContentSize(cc.size(300,36))
    self:addChild(labelName)
    REL:toOther("left","middle",labelName,self,50,0)
    self.labelName = labelName

end

--- 刷新数据
function T:refreshData()
    local des = nil
    local num = self.collectResourceInfo:getTaskNum(self.sid)
    if self.sid == 1 then
        des = Language:get("uc972",num)
    elseif self.sid == 2 then
        des = Language:get("uc973",num)
    elseif self.sid == 3 then
        des = Language:get("uc974",num)
    elseif self.sid == 4 then
        des = Language:get("uc975",num)
    else
        des = Language:get("uc976",num)
    end

    self.labelName:setString(des)

end


--- 展开页面的添加
function T:AddListItem()
    --打开展开页面
    self.node:addListener(function(leafContainer)
        local subItem = self.CollectResoucreOpenItem.new(self.collectResourceInfo,self.sid)
        leafContainer:setContentSize(cc.size(subItem:getContentSize().width,subItem:getContentSize().height))  
        leafContainer:addChild(subItem)
    end)
end

function T:SetButton()
    local _btnOpen = Button.new("false","false")
    _btnOpen:loadTextures("scaleOut_normal.png","iconButton_general_down.png" , "",ccui.TextureResType.plistType)
    self:addChild(_btnOpen)
    REL:toOther("right", "middle", _btnOpen, self.back, 15,-5)
    self._btnOpen = _btnOpen

    
    self._btnOpen.tag = 1
    self.node.tag = 1

    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
        	AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
            self.node:dispachEvent()
            self:OpenLogic(sender)
        end
    end
    self._btnOpen:addTouchEventListener(callback) 

    local function callback2(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
        	AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
            self.node:dispachEvent()
            self:OpenLogic(sender)
        end
    end
    self.node:addTouchEventListener(callback2) 


end

--- 打开逻辑
function T:OpenLogic(sender)
    if sender.tag == 2 then
        self._btnOpen:loadTextures("scaleOut_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
        self.node.tag = 1
        self._btnOpen.tag = 1
    else
        self._btnOpen:loadTextures("scaleIn_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
        self.node.tag = 2
        self._btnOpen.tag = 2
    end
end


return T
