--[[
 *	打开项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 构造函数
function T:ctor(collectResourceInfo,sid)
    self.collectResourceInfo = collectResourceInfo
    self.sid = sid


    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.size = cc.size(622,120 * 4)
    self:setContentSize(self.size)


    self:init()
    self:refreshData()

end

--- 进入
function T:onEnter()
    self.collectResourceInfo:luaAddEventListener(self.collectResourceInfo.EVT_ACTIVTIY_TASK_FINISH_REFRESH,self,self.refreshData)

end

--- 退出
function T:onExit()
    self.collectResourceInfo:luaRemoveEventListener(self.collectResourceInfo.EVT_ACTIVTIY_TASK_FINISH_REFRESH,self,self.refreshData)

end


--- 初始化
function T:init()
    local height = self.size.height/4
    self.tags = {}
    for i = 1,4,1 do
        -- 下划线
        local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
        local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
        local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
        seqLine1:setContentSize(self.size.width - 10,2)
	    self:addChild(seqLine1)
        REL:toOther("center", "top", seqLine1, self, 0, height*i - 10)
        
        self.tags[i] = seqLine1
        seqLine1.awardIndex = i - 1

        -- 描述
        local labelName = XMLLabel()
        labelName:setVAlign("bottom")
        labelName:setContentSize(cc.size(300,36))
        self:addChild(labelName)
        REL:toOther("left","bottom",labelName,seqLine1,10,45)
        labelName:setString(Language:get("uc977",UnitConversion.unitTrans(self.collectResourceInfo:getTaskConditon(i - 1))))
        
        -- 采集量
        local collectNum = XMLLabel()
        collectNum:setVAlign("bottom")
        collectNum:setContentSize(cc.size(300,36))
        self:addChild(collectNum)
        REL:toOther("left","bottom",collectNum,seqLine1,300,45)
        collectNum:setString(Language:get("uc978",UnitConversion.unitTrans(self.collectResourceInfo.tempData[self.sid].hasCollectRes),UnitConversion.unitTrans(self.collectResourceInfo:getTaskConditon(i - 1))))

        seqLine1.collectNum = collectNum


        -- 按钮
        local getBtn = Button.new("false","true")
	    getBtn:setButtonState("button_yellow_normal.png","button_yellow_normal.png")
	    getBtn:setString(Language:get("uc438"))
	    self:addChild(getBtn)
        REL:toOther("right","bottom",getBtn,seqLine1,20,5)
        getBtn:setTextShadow()
        getBtn:addTouchEventListener(function(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local num = self.collectResourceInfo:getTaskConditon(sender.awardIndex)
                local hasCollectRes = self.collectResourceInfo.tempData[self.sid].hasCollectRes
                if hasCollectRes < num then  --不能领取
                    -- 弹出任务领取详情窗口
                    local awardIndex = sender.awardIndex
                    local tempData = self.collectResourceInfo.tempData
                    local awards = tempData[self.sid].awards[awardIndex]
                    self:showRewardInfoWindow(awards,Language:get("uc977",UnitConversion.unitTrans(self.collectResourceInfo:getTaskConditon(i - 1))))

                    return
                end


                local joinSids = {}
                joinSids.index = self.sid
                joinSids.awardIndex = sender.awardIndex

                local function finish(data)
                    self.AwardDataDecoder:showSuccessWindow(data.awardData)
                end
                Command:joinDynamicAct(106,finish,joinSids)

            end
        end)
        seqLine1.getBtn = getBtn
        getBtn.awardIndex = i - 1

        -- 勾
        local right = ccui.ImageView:create()
        right:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
        self:addChild(right)
        REL:toOther("right","bottom",right,seqLine1,55,45)
        right:setVisible(false)

        seqLine1.right = right
    end

end

function T:refreshData()
    local tags = self.tags

    local collectResourceInfo = self.collectResourceInfo

    local hasCollectRes = collectResourceInfo.tempData[self.sid].hasCollectRes


    for i = 1,4,1 do
        local seqLine = tags[i]

        if collectResourceInfo:judgeTaskIsGet(self.sid,i - 1) then -- 已经领取
            seqLine.getBtn:setVisible(false)
            seqLine.right:setVisible(true)
            seqLine.collectNum:setVisible(false)

        else
            seqLine.getBtn:setVisible(true)
            seqLine.right:setVisible(false)
            seqLine.collectNum:setVisible(true)

            local num = collectResourceInfo:getTaskConditon(seqLine.awardIndex)
            if hasCollectRes >= num then -- 可以领取 
                seqLine.getBtn:setIsGray(false)
            else -- 不能领取
                seqLine.getBtn:setIsGray(true)
            end


        end

    end



end

--- 显示奖品信息
function T:showRewardInfoWindow(tb, name)
	local w,h=580,240
	local top=16

	local lay=ccui.Layout:create()
	lay:setContentSize(cc.size(w, h))

	--奖励显示项列表
	local uiAwardList=ccui.Layout:create()
	REL:relOther(uiAwardList,lay,10,10,10,16)
	lay:addChild(uiAwardList)

	local uiList=require("src.app.communication.award.AwardDataDecoder"):award2LayoutList(tb)
	local w,h=require("src.app.communication.award.AwardDataDecoder"):arrangeInLayout(uiList,uiAwardList)

	lay:setContentSize(cc.size(
		w,
		top+ --上边框
		36+20+ --名称
		36+20+ --进度
		36+4+ --奖励标题
		h+ --奖励列表
		top --下边框
	))

	--任务名称
	local uiName=XMLLabel(name or "")
	uiName:setAlign("left","middle")
	uiName:setHeight(36)
	lay:addChild(uiName)
	REL:relOther(uiName,lay,10,10,top,SIZE_NIL)

	top=top+uiName:getHeight()+20

	--分隔线1
	local uiSep1=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("seqLine1.png"))
	lay:addChild(uiSep1)
	REL:relOther(uiSep1,uiName,0,0,SIZE_NIL,-10)

	--进度
    local content = Language:get("uy62")

	local uiProgress=XMLLabel(content)
	uiProgress:setAlign("left","middle")
	uiProgress:setHeight(36)
	lay:addChild(uiProgress)
	REL:relOther(uiProgress,lay,10,10,top,SIZE_NIL)

	top=top+uiProgress:getHeight()+20

	--分隔线1
	local uiSep2=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("seqLine1.png"))
	lay:addChild(uiSep2)
	REL:relOther(uiSep2,uiProgress,0,0,SIZE_NIL,-10)

	--奖励标题
	local uiAwardCap=XMLLabel(Language:get("uy67"))
	uiAwardCap:setAlign("left","middle")
	uiAwardCap:setHeight(36)
	lay:addChild(uiAwardCap)
	REL:relOther(uiAwardCap,lay,10,10,top,SIZE_NIL)

	top=top+uiAwardCap:getHeight()+4

	REL:toOther("center","top",uiAwardList,lay,0,top)

	--- 显示窗口
	MUIAlter_noTitle.show({
		info = lay
	})

end


return T
