--[[
 *	累计充值项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 构造函数
function T:ctor(cumulativeRechargeInfo,everyRechargeData,mark,hasRechargeDiamond)
    self.cumulativeRechargeInfo = cumulativeRechargeInfo
    self.everyRechargeData = everyRechargeData
    self.mark = mark
    self.hasRechargeDiamond = hasRechargeDiamond

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.size = cc.size(622,143 - 3)
    self:setContentSize(self.size)

    self:init()

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    
end


function T:init()
    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("showBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("left","top",back,self,2,0)
    self.back = back

    -- 描述的背景图片
    local sepLineFrame = ResLoader:getSpriteFrame("daysBottom.png")
    local sepLineSize = sepLineFrame:getOriginalSize()
    local sepSize = cc.size(sepLineSize.width + 100,sepLineSize.height)

    local desBack = Scale9Sprite:createWithFrame(sepLineFrame,cc.rect(sepLineSize.width/2,sepLineSize.height/2,1,1))
    desBack:setContentSize(sepSize)
	self:addChild(desBack)
    REL:toOther("left","top",desBack,back,5,15)

    -- 累计描述
    local des = XMLLabel()
    des:setAlign("center","middle")
    des:setContentSize(cc.size(400,36))
    self:addChild(des)
    REL:toOther("center","middle",des,desBack,0,0)
    des:setString(Language:get("uc809",self.everyRechargeData.needDiamond))

    des:updateView()
	local contentWidth = des:getTextWidth()
    sepSize = cc.size(contentWidth + 20,sepLineSize.height)
    desBack:setContentSize(sepSize)
    REL:toOther("left","top",desBack,back,5,15)
    REL:toOther("center","middle",des,desBack,-5,0)


    -- 添加项 
    local showAward = self.everyRechargeData.showAward

    local awardList = self.AwardDataDecoder:awardResolve2(showAward)
    local num = #awardList
    for i = 1,num,1 do 
        local item = AwardItem.new({awardData = awardList[i],sizeScale = IconManager.baseScale})
        local width = item:getContentSize().width + 20
        local offset = (i - 1) * width + 30
        self:addChild(item)
        REL:toOther("left","top",item,self.back,offset,55)
    end

    -- 领取按钮
    local getBtn = Button.new("false","true")
	getBtn:setButtonState("button_yellow_normal.png","button_yellow_normal.png")
	getBtn:setString(Language:get("uc438"))
	self:addChild(getBtn)
    REL:toOther("right","middle",getBtn,self.back,20,-20)
    getBtn:setTextShadow()
    self.getBtn = getBtn
    getBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function finish(data)
                self.mark = data.mark
                self.AwardDataDecoder:showSuccessWindow(data.awardData)
                self:refreshData()
            end
            Command:joinDynamicAct(103,finish,self.everyRechargeData.sid)  -- 后面的sid是从0到4

        end
    end)


    -- 累计描述2
    local des2 = XMLLabel()
    des2:setAlign("right","bottom")
    des2:setContentSize(cc.size(300,36))
    self:addChild(des2)
    REL:toOther("right","bottom",des2,getBtn,0,90)
    des2:setString(Language:get("uc810",self.hasRechargeDiamond,self.everyRechargeData.needDiamond))


    -- 勾
    local right = ccui.ImageView:create()
    right:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(right)
    REL:toOther("right","middle",right,self.back,55,0)
    self.right = right
    right:setVisible(false)


    self:refreshData()

end

--- 刷新领取数据
function T:refreshData()
    local cumulativeRechargeInfo = self.cumulativeRechargeInfo
    local everyRechargeData = self.everyRechargeData
    local mark = self.mark
    local hasRechargeDiamond = self.hasRechargeDiamond

    local getBtn = self.getBtn
    local right = self.right

    local sid = everyRechargeData.sid
    -- 判断是否达到累计充值条件
    if hasRechargeDiamond >= everyRechargeData.needDiamond then -- 可以领取
        -- 判断是否已经领取没有
        if BitOperator:_and(mark, BitOperator:_ls(1, sid)) ~= 0 then -- 领取了
            getBtn:setIsGray(true)
            getBtn:setTouchEnabled(false)
            getBtn:setVisible(false)
            right:setVisible(true)
            self:removeEff()

        else -- 未领取
            getBtn:setIsGray(false)
            getBtn:setTouchEnabled(true)
            getBtn:setVisible(true)
            right:setVisible(false)
            self:addEff()

        end

    else -- 不能领取
        getBtn:setIsGray(true)
        getBtn:setTouchEnabled(false)
        getBtn:setVisible(true)
        right:setVisible(false)
        self:removeEff()

    end


end


--- 添加特效
function T:addEff()
    if not self.btnEff then
        if ResLoader:getAnimation("buttonPolishingEff") then
            self.btnEff = ResLoader:createAnimationSprite("buttonPolishingEff")
            self:addChild(self.btnEff)
		    REL:toOther("center", "middle", self.btnEff, self.getBtn, -4, 13)
        end
    else
        
    end
end

--- 移除特效
function T:removeEff()
    if self.btnEff then
        self.btnEff:removeFromParent()
        self.btnEff = nil
    end
end

return T
