--[[
 *	数字项
]]
local T = class("T",function() return ccui.Layout:create() end)

-- 序号:从左到右的1到5
T.id = nil

--- 构造函数
function T:ctor(id)
    self.id = id

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
    
    self:setContentSize(cc.size(112,213 - 7))

    self:init()

end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()

end

function T:init()
    self:setClippingEnabled(true) -- 设置裁剪开启，在区域外面的不显示

    -- 图片
    local back = ccui.ImageView:create()
    back:loadTexture("digitalBack.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("center","middle",back,self,0,0)
    self.back = back

    -- 字体图片
    local digitalFnt = ccui.TextBMFont:create(1,"res/images/activity/drawDiamond.fnt")
	self:addChild(digitalFnt)
    REL:toOther("center","middle",digitalFnt,back,0,15)
    self.digitalFnt = digitalFnt

end

--- 设置转动数据
function T:setScrollData(endValue,circleCount)
    self.cycleTag = 1 -- 循环标记，每次从0到9循环
    self.allCount = 1 -- 所有的循环次数
    self.endValue = endValue -- 结束数字
    self.circleCount = circleCount -- 转动数量 id=5为30
end

--- 转动
function T:runAct()
    if self.allCount == self.circleCount - 1 then
        AudioManager:playEffect(SoundRes.SOUND_LOTTERY_STOP)
        print("最后一次")
    else
        if self.id == 1 then
            AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
        end
        
    end
    


    local digitalFnt = self.digitalFnt

    self.cycleTag = self.cycleTag + 1
    if self.cycleTag > 9 then
        self.cycleTag = 0
    end

    self.allCount = self.allCount + 1
    if self.allCount == self.circleCount then
        digitalFnt:stopAllActions()
        digitalFnt:setString(self.endValue)
        REL:toOther("center","middle",digitalFnt,self.back,0,15)
        if self.id == 1 then
            -- 派发事件
            CommonBroadcast:luaDispatchEvent(EVENT_DRAW_DIAMOND_COMPLETE)
        end
        return
    else
        digitalFnt:setString(self.cycleTag)
        REL:toOther("center","top",digitalFnt,self.back,0,0)
    end

    digitalFnt:runAction(
		cc.Sequence:create(
			cc.MoveBy:create(0.06, cc.p(0,-110)),
			cc.CallFunc:create( function(target)
                self:runAct()
			end )
		)
	)

end




return T
