--[[
 * 战争之王窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new("windowBack.jpg")
        o.super = AbstractWindow
        return o
    end
)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 战争之王信息
T.gameOfWarInfo = nil

--- 数据
T.data = nil 

--- 每一项
T.GameOfWarItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.gameOfWar.GameOfWarItem")


--- 构造函数 
function T:ctor(gameOfWarInfo,data)
    self.gameOfWarInfo = gameOfWarInfo
    self.data = data
    
    self:setWindowTitle(Language:get("uc979"))
    
    self:init()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    self.gameOfWarInfo:luaAddEventListener(self.gameOfWarInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.gameOfWarInfo.sid,self,self.closeSelf)
end

function T:onExit()
    self.super.onExit(self)
    self.gameOfWarInfo:luaRemoveEventListener(self.gameOfWarInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.gameOfWarInfo.sid,self,self.closeSelf)
end


--- 关闭当前窗口
function T:closeSelf()
    if self.gameOfWarInfo:getOpenValue() == false then
        WindowManager:pop()
    end
    
end


--- 初始化
function T:init()
    self:initTop()
    self:initBottom()
end

--- 初始化顶部
function T:initTop()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 顶部背景图片
    local topBackFrame = ResLoader:getSpriteFrame("allianceScienceNotiBack.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(620,200))
    REL:toOther("center","top",topBack,self.viewBack,0,25)

    local secret = SecretaryGenerator:getBust("susy_clothing_1",SecretaryGenerator.DEFAULT_BUST_RECT)
    secret:setFlippedX(true)
    self:addChild(secret)
    secret:setAnchorPoint(cc.p(0, 0))
    secret:setScale(0.5)
    REL:toOther("right","bottom",secret,topBack,20,5)
    

    -- 小秘书内容
    local content = XMLLabel()
    content:setAlign("left","top")
    content:setContentSize(cc.size(400,36))
    self:addChild(content)
    REL:toOther("left","top",content,topBack,20,20)
    content:setString(Language:get("uc980"))

end

--- 初始化底部
function T:initBottom()
    -- 底部背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self.uiContainer,8,6,230,CommonCfg.BOTTOM_CONTAINER_HEIGTH)

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,4,0)
    self.listView = listView

    local data = self.data
    local award = data.award
    local num = #award
    for i = 1,num,1 do 
        local item = self.GameOfWarItem.new(self.gameOfWarInfo,award[i],data.awardMark,data.num)
        listView:pushBackCustomItem(item)
    end


end



return T