--[[
 *	等级礼包项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


--- 成长计划的sid
T.sid = nil

--- 等级礼包信息
T.gradePackageInfo = nil

--- 配置数据
T.gradePackage = nil

--- 构造函数
function T:ctor(sid,gradePackageInfo)
    self.sid = sid
    self.gradePackageInfo = gradePackageInfo

    self.gradePackage = mapping({}, GradePackage_temp[sid])


    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.size = cc.size(622,143 - 3)
    self:setContentSize(self.size)

    self:init()

end

--- 进入
function T:onEnter()
    self.gradePackageInfo:luaAddEventListener(self.gradePackageInfo.EVT_GET_GRADE_PACKAGE_REFRESH,self,self.refreshData)
end

--- 退出
function T:onExit()
    self.gradePackageInfo:luaRemoveEventListener(self.gradePackageInfo.EVT_GET_GRADE_PACKAGE_REFRESH,self,self.refreshData)
end

function T:init()
    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("showBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("left","top",back,self,2,0)
    self.back = back

    local data = self.gradePackage

    -- 领取等级
--    local levelImg = ccui.ImageView:create()
--    levelImg:loadTexture("homePageLvlFrame.png",ccui.TextureResType.plistType)
--    self:addChild(levelImg)
--    REL:toOther("left","middle",levelImg,self.back,20,0)

    local levelName = XMLLabel()
    levelName:setContentSize(cc.size(100,27))
    levelName:setAlign("center","middle")
    self:addChild(levelName)
    REL:toOther("center","middle",levelName,self.back,-260,0)
    levelName:setString(Language:get("uc437",data.level))

     --- 奖励品项
    self:addAward()

    -- 领取按钮
    local getBtn = Button.new("false","true")
	getBtn:setButtonState("button_yellow_normal.png","button_yellow_normal.png")
	getBtn:setString(Language:get("uc438"))
	self:addChild(getBtn)
    REL:toOther("right","middle",getBtn,self.back,20,-20)
    getBtn:setTextShadow()
    self.getBtn = getBtn
    getBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function finish(awardData)
                self.AwardDataDecoder:showSuccessWindow(awardData)
                self:refreshData()
            end
            Command:getGradePackageAward(self.sid - 1,finish)
        end
    end)

    -- 勾
    local right = ccui.ImageView:create()
    right:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(right)
    REL:toOther("right","middle",right,self.back,55,0)
    self.right = right
    right:setVisible(false)

    self:refreshData()
end

--- 奖励品项
function T:addAward()
    local gradePackage = self.gradePackage

    local awardList = self.AwardDataDecoder:awardResolve2(gradePackage)
    local num = #awardList
    for i = 1,num,1 do -- 从左到右也是位置
        local effType = nil
        if gradePackage["effType" .. i] then
            effType = gradePackage["effType" .. i]
        end
        local item = AwardItem.new({awardData = awardList[i],sizeScale = IconManager.baseScale,effType = effType})
        local width = item:getContentSize().width + 30
        local offset = (i - 1) * width + 100
        self:addChild(item)
        REL:toOther("left","middle",item,self.back,offset,0)
    end
end


--- 刷新领取数据
function T:refreshData()
    local sid = self.sid
    local gradePackageInfo = self.gradePackageInfo
    local getBtn = self.getBtn
    local right = self.right

    if gradePackageInfo:getGradePackValue(BitOperator:_ls(1, sid - 1)) == true then  -- 领取了
        getBtn:setString(Language:get("uc439"))
        getBtn:setIsGray(true)
        getBtn:setTouchEnabled(false)
        getBtn:setVisible(false)
        right:setVisible(true)
        self:removeEff()
    else -- 未领取
        getBtn:setVisible(true)
        right:setVisible(false)

        if gradePackageInfo:judgeIsGetAward(sid) == true then -- 可以领取
            getBtn:setString(Language:get("uc438"))
            getBtn:setIsGray(false)
            getBtn:setTouchEnabled(true)
            self:addEff()
        else -- 不能领取
            getBtn:setString(Language:get("uc438"))
            getBtn:setIsGray(true)
            getBtn:setTouchEnabled(false)
            self:removeEff()
        end
    end

end

--- 添加特效
function T:addEff()
    if not self.btnEff then
        if ResLoader:getAnimation("buttonPolishingEff") then
            self.btnEff = ResLoader:createAnimationSprite("buttonPolishingEff")
            self:addChild(self.btnEff)
		    REL:toOther("center", "middle", self.btnEff, self.getBtn, -4, 13)
        end
    else
        
    end
end

--- 移除特效
function T:removeEff()
    if self.btnEff then
        self.btnEff:removeFromParent()
        self.btnEff = nil
    end
end

return T
