--[[
 * 等级礼包窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(1)
        o.super = AbstractWindow
        return o
    end
)

--- 成长项
T.GradePackageItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.gradePackage.GradePackageItem")

--- 等级礼包信息
T.gradePackageInfo = nil

--- 队列数据
T.queue = nil

--- 构造函数 
function T:ctor(gradePackageInfo)
    self.gradePackageInfo = gradePackageInfo
    self.queue = Queue()

    self:setWindowTitle(Language:get("uc440"))

    self:initTop()
    self:initItem()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    self.gradePackageInfo:luaAddEventListener(self.gradePackageInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.gradePackageInfo.sid,self,self.closeSelf)
end

function T:onExit()
    self.super.onExit(self)
    self.gradePackageInfo:luaRemoveEventListener(self.gradePackageInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.gradePackageInfo.sid,self,self.closeSelf)
    self.queue:clearT()
    self.queue = nil
end

function T:initTop()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 顶部背景图片
    local topBackFrame = ResLoader:getSpriteFrame("allianceScienceNotiBack.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(620,200))
    REL:toOther("center","top",topBack,self.viewBack,0,25)


    -- 小秘书
--    local secret = ccui.ImageView:create()
--    secret:loadTexture("taskHeadBack.png",ccui.TextureResType.plistType)
--    self:addChild(secret)
--    REL:toOther("left","bottom",secret,topBack,-10,-10)
    local secret = SecretaryGenerator:getBust("susy_clothing_1",SecretaryGenerator.DEFAULT_BUST_RECT)
    self:addChild(secret)
    secret:setAnchorPoint(cc.p(0, 0))
    secret:setScale(0.5)
    REL:toOther("left","bottom",secret,topBack,20,5)

    -- 聊天背景图片
    local chatBackFrame = ResLoader:getSpriteFrame("chatBack.png")
	local chatBackSize = chatBackFrame:getOriginalSize()
	local chatBack = Scale9Sprite:createWithFrame(chatBackFrame,cc.rect(chatBackSize.width/2,chatBackSize.height/2,1,1))
	self:addChild(chatBack)
    chatBack:setContentSize(cc.size(404,99))
    REL:toOther("left","top",chatBack,topBack,256 - 60,20)

    -- 小秘书内容
    local content = XMLLabel()
    content:setAlign("left","middle")
    content:setContentSize(cc.size(380,36))
    self:addChild(content)
    REL:toOther("left","middle",content,chatBack,20,0)
    content:setString(Language:get("uc546"))

end


function T:initItem()
    -- 底部背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self.uiContainer,8,6,230,CommonCfg.BOTTOM_CONTAINER_HEIGTH)

    -- 描述背景图片
	local troopBack = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("taskTagBack.png"),"h3")
	self:addChild(troopBack)
	troopBack:setContentSize(cc.size(622,43)) -- 宽度到时来做适配
	REL:toOther("center", "top", troopBack, bottomBack, 0, 0)
    
    -- 角色等级
    local level = XMLLabel()
    level:setAlign("center","middle")
    level:setContentSize(cc.size(350,40))
    self:addChild(level)
    REL:toOther("center","middle",level,troopBack,-250,0)
    level:setString(Language:get("uc550"))

    level:updateView()
	local contentWidth = level:getTextWidth()

    if contentWidth > 100 then
        level:setAlign("left","middle")
        REL:toOther("left","middle",level,troopBack,5,0)
    end


    -- 奖励
    local award = XMLLabel()
    award:setAlign("center","middle")
    award:setContentSize(cc.size(350,40))
    self:addChild(award)
    REL:toOther("center","middle",award,troopBack,0,0)
    award:setString(Language:get("uc551"))

    -- 操作
    local operate = XMLLabel()
    operate:setAlign("center","middle")
    operate:setContentSize(cc.size(350,40))
    self:addChild(operate)
    REL:toOther("center","middle",operate,troopBack,230,0)
    operate:setString(Language:get("uc552"))


    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,45,0)
    self.listView = listView

    -- 添加项
    local num = #GradePackage_temp
    for i = 1,num,1 do
        local res = self.GradePackageItem.new(i,self.gradePackageInfo)
        listView:pushBackCustomItem(res)
    end

     --- 如果有领取的，把在要领取的放在前面
    local getIndex = nil  -- 领取的索引值
    local gradePackageInfo = self.gradePackageInfo
    for i = 0,11,1 do
        local TAG = BitOperator:_ls(1, i)
        if gradePackageInfo:getGradePackValue(TAG) == false then
            if gradePackageInfo:judgeIsGetAward(i + 1) then
                getIndex = i
                break
            end
        end
    end

    if getIndex then
        -- 延迟1帧
        Cocos2dxUtils:timeOut(function()    
            local innerContainer = self.listView:getInnerContainer() 
            local viewHeight = self.listView:getContentSize().height

            local posY = self.listView:getItem(getIndex):getPositionY()
            local itemHeight = self.listView:getItem(getIndex):getContentSize().height

            local offset = viewHeight - posY - itemHeight

            innerContainer:setPositionY(offset)
            self.listView:refreshView() -- 刷新位置

        end,0)  -- 0表示1帧

    end

end

--- 关闭当前窗口
function T:closeSelf()
    if self.gradePackageInfo:getOpenValue() == false then
        WindowManager:pop()
    end
    
end


return T