--[[
 *	成长计划项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 成长计划的sid
T.sid = nil

--- 成长计划信息
T.growthPlanInfo = nil

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 构造函数
function T:ctor(sid,growthPlanInfo)
    self.sid = sid
    self.growthPlanInfo = growthPlanInfo

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.size = cc.size(622,143 - 3)
    self:setContentSize(self.size)

    self:init()

end

--- 进入
function T:onEnter()
    self.growthPlanInfo:luaAddEventListener(self.growthPlanInfo.EVT_BUY_GROWTH_PLAN_REFRESH,self,self.refreshData)
    self.growthPlanInfo:luaAddEventListener(self.growthPlanInfo.EVT_GEMS_GET_GROWTH_PLAN_REFRESH,self,self.refreshData)

end

--- 退出
function T:onExit()
    self.growthPlanInfo:luaRemoveEventListener(self.growthPlanInfo.EVT_BUY_GROWTH_PLAN_REFRESH,self,self.refreshData)
    self.growthPlanInfo:luaRemoveEventListener(self.growthPlanInfo.EVT_GEMS_GET_GROWTH_PLAN_REFRESH,self,self.refreshData)

end

function T:init()
    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("showBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("left","top",back,self,2,0)
    self.back = back

    local data = GrowthPlan_temp[self.sid]

    -- 领取等级
--    local levelImg = ccui.ImageView:create()
--    levelImg:loadTexture("homePageLvlFrame.png",ccui.TextureResType.plistType)
--    self:addChild(levelImg)
--    REL:toOther("left","middle",levelImg,self.back,50,0)

    local levelName = XMLLabel()
    levelName:setContentSize(cc.size(100,27))
    levelName:setAlign("center","middle")
    self:addChild(levelName)
    REL:toOther("center","middle",levelName,self.back,-230,0)
    levelName:setString(Language:get("uc437",data.playerLevel))

    
    if ResLoader:getAnimation("diamondFlashEff") then
        local gemsImg = ResLoader:createAnimationSprite("diamondFlashEff")
        self:addChild(gemsImg)
        REL:toOther("center","middle",gemsImg,self.back,30,0)
    end    
     
    local coin = ccui.TextBMFont:create(data.gems,"res/images/activity/gems.fnt")
	self:addChild(coin)
    REL:toOther("center","middle",coin,self.back,-40,-10) 
	
    -- 领取按钮
    local getBtn = Button.new("false","true")
	getBtn:setButtonState("button_yellow_normal.png","button_yellow_normal.png")
	getBtn:setString(Language:get("uc438"))
	self:addChild(getBtn)
    REL:toOther("right","middle",getBtn,self.back,20,-20)
    getBtn:setTextShadow()
    self.getBtn = getBtn
    getBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function finish(awardData)
                self.AwardDataDecoder:showSuccessWindow(awardData)
                self:refreshData()
            end
            Command:getGrowthPlanGems(self.sid - 1,finish)
        end
    end)

    -- 勾
    local right = ccui.ImageView:create()
    right:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(right)
    REL:toOther("right","middle",right,self.back,55,0)
    self.right = right
    right:setVisible(false)


    self:refreshData()
end

--- 刷新领取数据
function T:refreshData()
    local sid = self.sid
    local growthPlanInfo = self.growthPlanInfo
    local getBtn = self.getBtn
    local right = self.right

    if growthPlanInfo:getBuyValue() == true then -- 购买了
        local type = BitOperator:_ls(1, sid - 1)
        if growthPlanInfo:getAwardValue(type) == true then  -- 领取了
            getBtn:setString(Language:get("uc439"))
            getBtn:setIsGray(true)
            getBtn:setTouchEnabled(false)
            self:removeEff()

            right:setVisible(true)
            getBtn:setVisible(false)
        else -- 未领取(未达到要求的按钮为灰色"领取"，达到要求的为"领取")
            right:setVisible(false)
            getBtn:setVisible(true)

            if growthPlanInfo:judgeIsGetAward(sid) == true then --可以领取
                getBtn:setString(Language:get("uc438"))
                getBtn:setIsGray(false)
                getBtn:setTouchEnabled(true)
                self:addEff()
            else
                getBtn:setString(Language:get("uc438"))
                getBtn:setIsGray(true)
                getBtn:setTouchEnabled(false)
                self:removeEff()
            end
        end

    else -- 没购买
        getBtn:setString(Language:get("uc438"))
        getBtn:setIsGray(true)
        getBtn:setTouchEnabled(false)
        self:removeEff()
    end
end

--- 添加特效
function T:addEff()
    if not self.btnEff then
        if ResLoader:getAnimation("buttonPolishingEff") then
            self.btnEff = ResLoader:createAnimationSprite("buttonPolishingEff")
            self:addChild(self.btnEff)
		    REL:toOther("center", "middle", self.btnEff, self.getBtn, -4, 13)
        end
    else
        
    end
end

--- 移除特效
function T:removeEff()
    if self.btnEff then
        self.btnEff:removeFromParent()
        self.btnEff = nil
    end
end

return T
