--[[
 * 成长计划窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(1)
        o.super = AbstractWindow
        return o
    end
)

--- 成长项
T.GrowthPlanItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.growthPlan.GrowthPlanItem")

--- 成长计划信息
T.growthPlanInfo = nil

--- 队列数据
T.queue = nil


--- 构造函数 
function T:ctor(growthPlanInfo)
    self.growthPlanInfo = growthPlanInfo
    self.queue = Queue()

    self:setWindowTitle(Language:get("uc431"))

    self:initTop()
    self:initAward()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    self.growthPlanInfo:luaAddEventListener(self.growthPlanInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.growthPlanInfo.sid,self,self.closeSelf)
    self.growthPlanInfo:luaAddEventListener(self.growthPlanInfo.EVT_BUY_GROWTH_PLAN_REFRESH,self,self.refreshBuy)
end

function T:onExit()
    self.super.onExit(self)
    self.growthPlanInfo:luaRemoveEventListener(self.growthPlanInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.growthPlanInfo.sid,self,self.closeSelf)
    self.growthPlanInfo:luaRemoveEventListener(self.growthPlanInfo.EVT_BUY_GROWTH_PLAN_REFRESH,self,self.refreshBuy)
    self.queue:clearT()
    self.queue = nil
end


function T:initTop()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 顶部背景图片
    local topBackFrame = ResLoader:getSpriteFrame("allianceScienceNotiBack.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(620,200))
    REL:toOther("center","top",topBack,self.viewBack,0,25)

    -- 钻石icon
    local diamond = ccui.ImageView:create()
    diamond:loadTexture(IconManager.iconPath .. PlayerAddAttributeIcon_temp[3].icon)
    self:addChild(diamond)
    REL:toOther("left","top",diamond,topBack,10,10)

    -- 描述1
    local describe1 = XMLLabel()
    describe1:setContentSize(cc.size(400,27))
    describe1:setVAlign("middle")
    self:addChild(describe1)
    REL:toOther("left","middle",describe1,diamond,110,20)
    describe1:setString(Language:get("uc500"))

    -- 描述2
    local describe2 = XMLLabel()
    describe2:setVAlign("middle")
    describe2:setContentSize(cc.size(400,27))
    self:addChild(describe2)
    REL:toOther("left","middle",describe2,diamond,110,-20)
    describe2:setString(Language:get("uc432"))

    
    -- 分隔线
    local seqLine = ccui.ImageView:create()
    seqLine:loadTexture("seqLine.png",ccui.TextureResType.plistType)
    self:addChild(seqLine)
    REL:toOther("center","bottom",seqLine,topBack,0,79)

    -- vip描述
    local vipDescribe = XMLLabel()
    vipDescribe:setContentSize(cc.size(400,27))
    vipDescribe:setHAlign("right")
    self:addChild(vipDescribe)
    REL:toOther("right","bottom",vipDescribe,topBack,60,80)
    vipDescribe:setString(Language:get("uc434"))

    -- 购买按钮
    local buy = Button.new("false","true")
	buy:setButtonState("bigButton_green_normal.png","bigButton_general_down.png")
	buy:setString(Language:get("uc433"))
	self:addChild(buy)
    REL:toOther("right","bottom",buy,topBack,20,0)
    buy:setTextCenter()
    self.buy = buy

    buy:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            -- vip等级限制为3
            local vipLevel = UserInfo.vipLevel
            if vipLevel < 3 then
                local descripe = Language:get("uc436")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            else
                local cost = 998
                local function confirm()
				    local gems = UserInfo.gems
				    if gems >= cost then
                        local function finish()
                            local descripe = Language:get("uc435")
		                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                        end
                        Command:buyGrowthPlan(finish)
				    else
					    MUIPop.MUIToReCharge()
				    end
			    end

			    MUIPop.MUIImmediate(Language:get("uc819",cost),confirm)
            end

        end
    end)

    -- 描述3
    local describe3 = XMLLabel()
    describe3:setContentSize(cc.size(400,27))
    describe3:setVAlign("bottom")
    self:addChild(describe3)
    REL:toOther("left","bottom",describe3,topBack,20,30)
    describe3:setString(Language:get("uc501"))

    describe3:updateView()
	local contentWidth = describe3:getTextWidth()

    -- 描述4
    local describe4 = XMLLabel()
    describe4:setContentSize(cc.size(400,27))
    describe4:setVAlign("middle")
    self:addChild(describe4)
    REL:toOther("left","middle",describe4,describe3,contentWidth + 20,0)
    describe4:setString(Language:get("uc502"))

    self:refreshBuy()

end

--- 刷新购买按钮
function T:refreshBuy()
    local buy = self.buy
    local growthPlanInfo = self.growthPlanInfo

    if growthPlanInfo:getBuyValue() == true then -- 买了
        buy:setIsGray(true)
        buy:setTouchEnabled(false)
    else
        buy:setIsGray(false)
        buy:setTouchEnabled(true)
    end
end

function T:initAward()
    -- 底部背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self.uiContainer,8,6,230,CommonCfg.BOTTOM_CONTAINER_HEIGTH)

    -- 描述背景图片
	local troopBack = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("taskTagBack.png"),"h3")
	self:addChild(troopBack)
	troopBack:setContentSize(cc.size(622,43)) -- 宽度到时来做适配
	REL:toOther("center", "top", troopBack, bottomBack, 0, 0)

    -- 角色等级
    local level = XMLLabel()
    level:setAlign("center","middle")
    level:setContentSize(cc.size(350,40))
    self:addChild(level)
    REL:toOther("center","middle",level,troopBack,-230,0)
    level:setString(Language:get("uc550"))

    level:updateView()
	local contentWidth = level:getTextWidth()

    if contentWidth > 100 then
        level:setAlign("left","middle")
        REL:toOther("left","middle",level,troopBack,5,0)
    end

    -- 奖励
    local award = XMLLabel()
    award:setAlign("center","middle")
    award:setContentSize(cc.size(350,40))
    self:addChild(award)
    REL:toOther("center","middle",award,troopBack,-20,0)
    award:setString(Language:get("uc551"))

    -- 操作
    local operate = XMLLabel()
    operate:setAlign("center","middle")
    operate:setContentSize(cc.size(350,40))
    self:addChild(operate)
    REL:toOther("center","middle",operate,troopBack,230,0)
    operate:setString(Language:get("uc552"))

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,45,0)
    self.listView = listView

    -- 添加项
    local num = #GrowthPlan_temp
    for i = 1,num,1 do
        local res = self.GrowthPlanItem.new(i,self.growthPlanInfo)
        listView:pushBackCustomItem(res)
    end

end

--- 关闭当前窗口
function T:closeSelf()
    if self.growthPlanInfo:getOpenValue() == false then
        WindowManager:pop()
    end
    
end


return T