--[[
 *	开服豪礼项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


--- 开服豪礼的sid
T.sid = nil

--- 开服豪礼信息
T.openServerInfo = nil

--- 开服豪礼配置数据
T.openServerData = nil

--- 构造函数
function T:ctor(sid,openServerInfo)
    self.sid = sid
    self.openServerInfo = openServerInfo

    self.openServerData = mapping({}, OpenServer_temp[sid])

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self.size = cc.size(622,143 - 3)
    self:setContentSize(self.size)

    self:init()

end

--- 进入
function T:onEnter()
    self.openServerInfo:luaAddEventListener(self.openServerInfo.EVT_GET_OPEN_SERVER_REFRESH,self,self.refreshData)
end

--- 退出
function T:onExit()
    self.openServerInfo:luaRemoveEventListener(self.openServerInfo.EVT_GET_OPEN_SERVER_REFRESH,self,self.refreshData)
end

function T:init()
    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("showBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("left","top",back,self,2,0)
    self.back = back

    local data = self.openServerData

--    -- 领取天数
--    local levelImg = ccui.ImageView:create()
--    levelImg:loadTexture("homePageLvlFrame.png",ccui.TextureResType.plistType)
--    self:addChild(levelImg)
--    REL:toOther("left","middle",levelImg,self.back,20,0)

--    local levelName = XMLLabel()
--    levelName:setContentSize(cc.size(100,27))
--    levelName:setAlign("center","middle")
--    self:addChild(levelName)
--    REL:toOther("center","middle",levelName,levelImg,0,0)
--    levelName:setString(Language:get("uc437",self.sid))

    -- 天数的背景图片
    local dayBack = ccui.ImageView:create()
    dayBack:loadTexture("daysBottom.png",ccui.TextureResType.plistType)
    self:addChild(dayBack)
    REL:toOther("left","top",dayBack,self.back,5,15)
    
    --- 天数文本
    local day = XMLLabel()
    day:setAlign("center","middle")
    day:setContentSize(cc.size(150,36))
    self:addChild(day)
    REL:toOther("center","middle",day,dayBack,0,0)
    day:setString(Language:get("uc423",self.sid))

     --- 奖励品项
    self:addAward()

    -- 领取按钮
    local getBtn = Button.new("false","true")
	getBtn:setButtonState("button_yellow_normal.png","button_yellow_normal.png")
	getBtn:setString(Language:get("uc438"))
	self:addChild(getBtn)
    REL:toOther("right","middle",getBtn,self.back,20,-20)
    getBtn:setTextShadow()
    self.getBtn = getBtn
    getBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function finish(awardData)
                self.AwardDataDecoder:showSuccessWindow(awardData)
                self:refreshData()
            end
            Command:getOpenServerAward(self.sid - 1,finish)
        end
    end)

    -- 勾
    local right = ccui.ImageView:create()
    right:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(right)
    REL:toOther("right","middle",right,self.back,55,0)
    self.right = right
    right:setVisible(false)


    self:refreshData()
end

--- 奖励品项
function T:addAward()
    local openServerData = self.openServerData

    local awardList = self.AwardDataDecoder:awardResolve2(openServerData)
    local num = #awardList
    for i = 1,num,1 do 
        local item = AwardItem.new({awardData = awardList[i],sizeScale = IconManager.baseScale})
        local width = item:getContentSize().width + 30
        local offset = (i - 1) * width + 30
        self:addChild(item)
        REL:toOther("left","top",item,self.back,offset,55)
    end
end


--- 刷新领取数据
function T:refreshData()
    local sid = self.sid
    local openServerInfo = self.openServerInfo
    local getBtn = self.getBtn
    local right = self.right

    if openServerInfo:judgeIsGetAward(sid) == true then -- 可以领取
        if openServerInfo:getOpenServerValue(BitOperator:_ls(1, sid - 1)) == false then
            getBtn:setString(Language:get("uc438"))
            getBtn:setIsGray(false)
            getBtn:setTouchEnabled(true)
            getBtn:setVisible(true)
            right:setVisible(false)
            self:addEff()
        else
            getBtn:setString(Language:get("uc439"))
            getBtn:setIsGray(true)
            getBtn:setTouchEnabled(false)
            getBtn:setVisible(false)
            right:setVisible(true)
            self:removeEff()
        end
    else -- 不能领取
        getBtn:setVisible(true)
        right:setVisible(false)
        getBtn:setString(Language:get("uc438"))
        getBtn:setIsGray(true)
        getBtn:setTouchEnabled(false)
        self:removeEff()
    end

end

--- 添加特效
function T:addEff()
    if not self.btnEff then
        if ResLoader:getAnimation("buttonPolishingEff") then
            self.btnEff = ResLoader:createAnimationSprite("buttonPolishingEff")
            self:addChild(self.btnEff)
		    REL:toOther("center", "middle", self.btnEff, self.getBtn, -4, 13)
        end
    else
        
    end
end

--- 移除特效
function T:removeEff()
    if self.btnEff then
        self.btnEff:removeFromParent()
        self.btnEff = nil
    end
end


return T
