--[[
 * 开服豪礼窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(1)
        o.super = AbstractWindow
        return o
    end
)

--- 成长项
T.OpenServerItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.openServer.OpenServerItem")

--- 开服豪礼信息
T.openServerInfo = nil

--- 队列数据
T.queue = nil

--- 构造函数 
function T:ctor(openServerInfo)
    self.openServerInfo = openServerInfo
    self.queue = Queue()

    self:setWindowTitle(Language:get("uc443"))

    self:initTop()
    self:initItem()
    --self:initItem2()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    self.openServerInfo:luaAddEventListener(self.openServerInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.openServerInfo.sid,self,self.closeSelf)
end

function T:onExit()
    self.super.onExit(self)
    self.openServerInfo:luaRemoveEventListener(self.openServerInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.openServerInfo.sid,self,self.closeSelf)
    self.queue:clearT()
    self.queue = nil
end


function T:initTop()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 顶部背景图片
    local topBackFrame = ResLoader:getSpriteFrame("allianceScienceNotiBack.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(620,200))
    REL:toOther("center","top",topBack,self.viewBack,0,25)


    -- 小秘书
--    local secret = ccui.ImageView:create()
--    secret:loadTexture("taskHeadBack.png",ccui.TextureResType.plistType)
--    self:addChild(secret)
--    REL:toOther("left","bottom",secret,topBack,-10,-10)
    local secret = SecretaryGenerator:getBust("susy_clothing_1",SecretaryGenerator.DEFAULT_BUST_RECT)
    self:addChild(secret)
    secret:setAnchorPoint(cc.p(0, 0))
    secret:setScale(0.5)
    REL:toOther("left","bottom",secret,topBack,20,5)


    -- 聊天背景图片
    local chatBackFrame = ResLoader:getSpriteFrame("chatBack.png")
	local chatBackSize = chatBackFrame:getOriginalSize()
	local chatBack = Scale9Sprite:createWithFrame(chatBackFrame,cc.rect(chatBackSize.width/2,chatBackSize.height/2,1,1))
	self:addChild(chatBack)
    chatBack:setContentSize(cc.size(404,99))
    REL:toOther("left","top",chatBack,topBack,256 - 60,20)

    -- 小秘书内容
    local content = XMLLabel()
    content:setAlign("left","middle")
    content:setContentSize(cc.size(380,36))
    self:addChild(content)
    REL:toOther("left","middle",content,chatBack,20,0)
    content:setString(Language:get("uc548"))

end


function T:initItem()
    -- 底部背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self.uiContainer,8,6,230,CommonCfg.BOTTOM_CONTAINER_HEIGTH)

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,4,0)
    self.listView = listView

    -- 添加项
    local num = #OpenServer_temp
    for i = 1,num,1 do
        local res = self.OpenServerItem.new(i,self.openServerInfo)
        listView:pushBackCustomItem(res)
    end

     --- 如果有领取的，把在要领取的放在前面
    local getIndex = nil  -- 领取的索引值
    local openServerInfo = self.openServerInfo
    for i = 0,14,1 do
        local TAG = BitOperator:_ls(1, i)
        if openServerInfo:judgeIsGetAward(i + 1) == true then -- 可以领取
            if openServerInfo:getOpenServerValue(TAG) == false then
                getIndex = i
                break
            end
        end
    end

    if getIndex then
        -- 延迟1帧
        Cocos2dxUtils:timeOut(function()    
            local innerContainer = self.listView:getInnerContainer() 
            local viewHeight = self.listView:getContentSize().height

            local posY = self.listView:getItem(getIndex):getPositionY()
            local itemHeight = self.listView:getItem(getIndex):getContentSize().height

            local offset = viewHeight - posY - itemHeight

            innerContainer:setPositionY(offset)
            self.listView:refreshView() -- 刷新位置

        end,0)      -- 0表示1帧

    end

end

function T:initItem2()
    -- 底部背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self.uiContainer,8,6,230,CommonCfg.BOTTOM_CONTAINER_HEIGTH)

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,4,0)
    self.listView = listView

    -- 添加项
    local num = #OpenServer_temp
    for i = 1,num,1 do
        self.queue:push(i)
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)
end

function T:addRes()
    local data = self.queue:pop()
    if data then
        local res = self.OpenServerItem.new(data,self.openServerInfo)
        self.listView:pushBackCustomItem(res)
        res:setOpacity(0)

        res:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end

--- 关闭当前窗口
function T:closeSelf()
    if self.openServerInfo:getOpenValue() == false then
        WindowManager:pop()
    end
    
end


return T