--[[
 * 急速发展窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(1)
        o.super = AbstractWindow
        return o
    end
)

--- 急速发展信息
T.rapidDevelopmentInfo = nil

--- 每一项
T.RapidDevelopmentItem = require("src.app.uiScript.components.allActivity.fixAndDynamic.activity.rapidDevelopment.RapidDevelopmentItem")


--- 构造函数 
function T:ctor(rapidDevelopmentInfo)
    self.rapidDevelopmentInfo = rapidDevelopmentInfo
    
    self:setWindowTitle(Language:get("uc812"))
    
    self:init()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
    self.rapidDevelopmentInfo:luaAddEventListener(self.rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.rapidDevelopmentInfo.sid,self,self.closeSelf)
end

function T:onExit()
    self.super.onExit(self)
    self.rapidDevelopmentInfo:luaRemoveEventListener(self.rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. self.rapidDevelopmentInfo.sid,self,self.closeSelf)
end


--- 关闭当前窗口
function T:closeSelf()
    if self.rapidDevelopmentInfo:getOpenValue() == false then
        WindowManager:pop()
    end
    
end


--- 初始化
function T:init()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 顶部背景图片
    local topBackFrame = ResLoader:getSpriteFrame("allianceScienceNotiBack.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(620,200))
    REL:toOther("center","top",topBack,self.viewBack,0,25)

    --小秘书
    local secret = SecretaryGenerator:getBust("susy_clothing_1",SecretaryGenerator.DEFAULT_BUST_RECT)
    self:addChild(secret)
    secret:setAnchorPoint(cc.p(0, 0))
    secret:setScale(0.5)
    REL:toOther("left","bottom",secret,topBack,20,5)


    -- 聊天背景图片
    local chatBackFrame = ResLoader:getSpriteFrame("chatBack.png")
	local chatBackSize = chatBackFrame:getOriginalSize()
	local chatBack = Scale9Sprite:createWithFrame(chatBackFrame,cc.rect(chatBackSize.width/2,chatBackSize.height/2 - 20,1,1))
	self:addChild(chatBack)
    chatBack:setContentSize(cc.size(404,99))
    REL:toOther("left","top",chatBack,topBack,256 - 60,20)

    -- 小秘书内容
    local content = XMLLabel()
    content:setAlign("left","middle")
    content:setContentSize(cc.size(380,36))
    self:addChild(content)
    REL:toOther("left","middle",content,chatBack,20,0)
    content:setString(Language:get("uc836"))

    content:updateView()
	local contentWidth = content:getTextWidth()
	local contentHeight = content:getTextHeight()
    if contentWidth < 404 then
        contentWidth = 404
    else
        contentWidth = contentWidth + 30
    end

    if contentHeight < 99 then
        contentHeight = 99
    else
        contentHeight = contentHeight + 10
    end

    chatBack:setContentSize(cc.size(contentWidth,contentHeight))
    REL:toOther("left","top",chatBack,topBack,256 - 60,20)
    REL:toOther("left","middle",content,chatBack,20,0)


    -- 底部背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self.uiContainer,8,6,230,CommonCfg.BOTTOM_CONTAINER_HEIGTH)

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,4,0)
    self.listView = listView

    for i = 1,3,1 do
        local res = self.RapidDevelopmentItem.new(i)
        listView:pushBackCustomItem(res)

    end


end



return T