--[[
 *	公告内容窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(2)
        o.super = AbstractWindow
        return o
    end
)

--- 构造函数
function T:ctor(announceInfo)
    self.announceInfo = announceInfo
        
    self:getWidget()

    self:setWindowTitle(Language:get("uc872"))

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end



function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)
end

function T:getWidget()
    local announceInfo = self.announceInfo

    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 标题
    local title = XMLLabel()
    title:setContentSize(cc.size(400,36))
    title:setHAlign("center")
    self:addChild(title)
    REL:toOther("center","top",title,viewBack,0,20)
    title:setString(Language:get("uc945",announceInfo.title))


    -- 时间
    local time = XMLLabel()
    time:setContentSize(cc.size(400,36))
    time:setHAlign("center")
    self:addChild(time)
    REL:toOther("center","top",time,viewBack,0,70)
    time:setString(Language:get("uc871",announceInfo.createTime))


    --- 下面背景图
    local bottomBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
    local bottomBackFrameSize = bottomBackFrame:getOriginalSize()
    local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackFrameSize.width/2,bottomBackFrameSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,viewBack,5,5,110,10)

    --- 内容文本
    local uiDesc = XMLTextArea()
    self:addChild(uiDesc) 
    REL:relOther(uiDesc,bottomBack,10,8,4,4)
    local text = AnnounceManager.announceContentBox:getAnnounceContentById(announceInfo.id).content
    if text then
        uiDesc:setString(text)
    end

end



return T