--[[
 *	公告项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor(announceInfo)
    self.announceInfo = announceInfo
    self:init()

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:_getWidget()


end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()

end

function T:_getWidget()
    local announceInfo = self.announceInfo
    --- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("mailNotRead.png",ccui.TextureResType.plistType)
    self:addChild(back)
    self.back = back

    self.size = cc.size(626,125)  -- 图片的大小为125
    self:setContentSize(self.size)
    REL:relOther(back,self,5,0,0,0)

    -- 通知图标
    local noticeIcon = ccui.ImageView:create()
    noticeIcon:loadTexture("noticeIcon.png",ccui.TextureResType.plistType)
    self:addChild(noticeIcon)
    REL:toOther("left","middle",noticeIcon,back,0,0)

    -- 标题
    local title = XMLLabel()
    title:setContentSize(cc.size(400,27))
    title:setVAlign("middle")
    self:addChild(title)
    REL:toOther("left","middle",title,back,140,22)
    title:setString(Language:get("uc963",announceInfo.title))


    -- 时间
    local time = XMLLabel()
    time:setContentSize(cc.size(400,27))
    time:setVAlign("middle")
    self:addChild(time)
    REL:toOther("left","middle",time,back,140,-20)
    time:setString(Language:get("uc871",announceInfo.createTime))

    -- 感叹号
    local btn = Button.new("false","false")
	btn:setButtonState("infoButton_normal.png","iconButton_general_down.png")
	self:addChild(btn)
	REL:toOther("right","bottom",btn,self,20,10)
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self:enterNoticeContentLogic()
        end
    end)

    BaseButton:extend(self)
    self:setTouchEnabled(true)
    self:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self:enterNoticeContentLogic()
        end
    end)


end

function T:enterNoticeContentLogic()
    local announceInfo = self.announceInfo
    local announceContentBox = AnnounceManager.announceContentBox
    if announceContentBox:getAnnounceContentById(announceInfo.id) then
        local noticeContentWindow = require("src.app.uiScript.components.allActivity.fixAndDynamic.notice.NoticeContentWindow").new(announceInfo)
        WindowManager:push(noticeContentWindow)
    else
        local function finish()
            local noticeContentWindow = require("src.app.uiScript.components.allActivity.fixAndDynamic.notice.NoticeContentWindow").new(announceInfo)
            WindowManager:push(noticeContentWindow)
        end
        Command:readAnnounceInfo(announceInfo.id,finish)
    end

end


return T