--[[
 *	公告视图
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor()
    self.queue = Queue()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,0,0,0,0)
    self.listView = listView

    self:_addToListview() 

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    self.queue:clearT()
    self.queue = nil
end


function T:_addToListview()
    local info = AnnounceManager.announceBox:getShowAnnounceInfo()
    if info == nil then
        return
    end
    local num = #info

    for i = 1,num,1 do
        if info[i] then
            self.queue:push(info[i])
        end
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)
end

function T:addRes()
    local announceInfo = self.queue:pop()
    if announceInfo then
        local res = require("src.app.uiScript.components.allActivity.fixAndDynamic.notice.NoticeItem").new(announceInfo)
        res:setOpacity(0)
        self.listView:pushBackCustomItem(res)
        res:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end


return T