--[[
 * 幸运抽奖窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new("windowBack4.jpg")
        o.super = AbstractWindow
        return o
    end
)


--- 构造函数 
function T:ctor()
    self:setWindowTitle(Language:get("uc535"))
    
    self:init()
    self:addNineGoodsView()
    self:refresh()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end


function T:onEnter()
    self.super.onEnter(self)
    
     AudioManager:playEffect(SoundRes.OPEN_LUCKY_LOTTERY)
end

function T:onExit()
    self.super.onExit(self)
end

function T:init()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 小秘书
    local sprite = SecretaryGenerator:getFelt("susy_clothing_1")
	self:addChild(sprite)
    if V_SZ.height > 960 then -- iphone 1920 还没考虑呢
        REL:toOther("left","top",sprite,viewBack,-20,10)
    else
        REL:toOther("left","top",sprite,viewBack,-20,-20)
    end
	self.sprite = sprite

    -- 文字显示框
	local textBack = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("chatBack2.png"))
	self:addChild(textBack)
    --textBack:setContentSize(cc.size(404,99))
    REL:toOther("left","top",textBack,self.sprite,220,60)
    self.textBack = textBack

    -- 文本
    local des = XMLLabel()
    des:setAlign("center","middle")
    des:setContentSize(cc.size(300,36))
    self:addChild(des)
    REL:toOther("center","middle",des,textBack,0,0)
    self.des = des

end

--- 添加9个物品显示视图
function T:addNineGoodsView()
    local nineGoodsView = require("src.app.uiScript.components.allActivity.luckyLottery.NineGoodsView").new(self)
    self:addChild(nineGoodsView)
    if V_SZ.height > 960 then
        REL:toOther("center","bottom",nineGoodsView,self.viewBack,0,25)
    else
        REL:toOther("center","bottom",nineGoodsView,self.viewBack,0,5)
    end
    self.nineGoodsView = nineGoodsView

end


--- 刷新数据
function T:refresh()
    local luckyLotteryState = SetStates.luckyLotteryState
    if luckyLotteryState:judgeIsLottrey() then
        self:freeLotteryAppend()
    else
        local num = PropsInfoMgr:getPlayerPropByID(205)
        if num > 0 then
            self:bottleLottery()
        else
            self:buyGemsLottery()
        end
    end
end

--- 免费抽取前
function T:freeLotteryAppend()
    self:setLotteryFalse()
    self.des:setVisible(true)

    self.des:setString(Language:get("uc543"))
    self.nineGoodsView:openMask()

    --描述
    local des = XMLLabel()
    des:setAlign("center","top")
    des:setContentSize(cc.size(300,36))
    self:addChild(des)
    REL:toOther("center","top",des,self.nineGoodsView,0,200)
    des:setString(Language:get("uc544",PropsInfoMgr:getPlayerPropByID(205)))

    --按钮
    local btn = Button.new("false","true")
	btn:setButtonState("bigButton_green_normal.png","bigButton_general_down.png")
	self:addChild(btn)
	REL:toOther("center","bottom",btn,self.nineGoodsView,0,50)
    btn:setTextCenter()
    btn:setString(Language:get("uc545"))
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            des:removeFromParent()
            btn:removeFromParent()
            self:freeLotteryLast()
        end
    end)

    if self.buyLayout then
        self.buyLayout:setVisible(false)
    end

end

--- 免费抽取后
function T:freeLotteryLast()
    self:setLotteryFalse()
    self.des:setVisible(true)

    self.des:setString(Language:get("uc536"))
    self.nineGoodsView:closeMask()

    if self.buyLayout then
        self.buyLayout:setVisible(false)
    end

end

--- 有瓶盖
function T:bottleLottery()
    --local num = PropsInfoMgr:getPlayerPropByID(205)
    --self.des:setString(Language:get("uc537",num))
    self:addBottleWidget()
    self:setLotteryTrue()
    self.des:setVisible(false)

    self.nineGoodsView:closeMask()

    if self.buyLayout then
        self.buyLayout:setVisible(false)
    end

end

--- 购买钻石抽取
function T:buyGemsLottery()
    if not self.buyLayout then
        local buyLayout = ccui.Layout:create() 
        buyLayout:setContentSize(cc.size(310,300))
        self:addChild(buyLayout)
        REL:toOther("center","middle",buyLayout,self.nineGoodsView,0,0)
        self.buyLayout = buyLayout

        -- 描述背景图片
        local f = ResLoader:getSpriteFrame("canvasBack.png")
	    local back = Scale9Sprite:createWithFrame(f)
        --back:setContentSize(cc.size(310,200))
	    buyLayout:addChild(back)
        REL:toOther("center","top",back,buyLayout,0,-20)

        -- 描述
        local des = XMLLabel()
        des:setAlign("center","middle")
        des:setContentSize(cc.size(300,36))
        buyLayout:addChild(des)
        REL:toOther("center","middle",des,back,0,0)
        local luckyLotteryState = SetStates.luckyLotteryState
        des:setString(Language:get("uc539",luckyLotteryState:getBuyGems()))

        -- 购买按钮
        local btn = Button.new("false","false")
	    btn:setButtonState("bigButton_purple_normal.png","bigButton_general_down.png")
	    buyLayout:addChild(btn)
	    REL:toOther("center","bottom",btn,buyLayout,0,-20)
        btn:addTouchEventListener(function(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                local function finish()
                    self:refresh()
                end
                Command:buyBottleCap(finish)
            end
        end)

        local diamondImg = ccui.ImageView:create()
        diamondImg:loadTexture("diamond.png",ccui.TextureResType.plistType)
        buyLayout:addChild(diamondImg)
        REL:toOther("left","middle",diamondImg,btn,30,5)

        local gems = XMLLabel()
        gems:setContentSize(cc.size(200,36))
        gems:setAlign("left","middle")
        buyLayout:addChild(gems)
        REL:toOther("left","middle",gems,btn,90,0)
        local luckyLotteryState = SetStates.luckyLotteryState
        gems:setString(luckyLotteryState:getBuyGems())

    else
        self.buyLayout:setVisible(true)
    end

    self:setLotteryFalse()
    self.des:setVisible(true)

    self.des:setString(Language:get("uc538"))
    self.nineGoodsView:openMask()
end

--- 抽奖成功后提示
function T:lotteryEnd()
    self:setLotteryFalse()
    self.des:setVisible(true)

    self.des:setString(Language:get("uc542"))
end


--- 有瓶盖的时候
function T:addBottleWidget()
    if not des1 then
        local des1 = XMLLabel()
        des1:setAlign("center","top")
        des1:setContentSize(cc.size(300,200))
        self:addChild(des1)
        REL:toOther("center","top",des1,self.textBack,0,20)
        des1:setString(Language:get("uc537"))
        self.des1 = des1

        -- 转动次数背景图片
        local goldenBottom = ccui.ImageView:create()
        goldenBottom:loadTexture("goldenBottom.png",ccui.TextureResType.plistType)
        self:addChild(goldenBottom)
        REL:toOther("center","top",goldenBottom,self.textBack,0,100)
        self.goldenBottom = goldenBottom

        -- 转动次数
        local scrollCount = XMLLabel()  
        scrollCount:setContentSize(cc.size(380,200))
        scrollCount:setAlign("center","middle")
        self:addChild(scrollCount)
        REL:toOther("center","middle",scrollCount,goldenBottom,0,0)
        self.scrollCount = scrollCount
    else
        self:setLotteryTrue()
    end


end

function T:setLotteryTrue()
    if self.des1 then
        self.des1:setVisible(true)
        self.goldenBottom:setVisible(true)
        self.scrollCount:setVisible(true)

        local num = PropsInfoMgr:getPlayerPropByID(205)
        self.scrollCount:setString(Language:get("uc697",num))
    end
end

function T:setLotteryFalse()
    if self.des1 then
        self.des1:setVisible(false)
        self.goldenBottom:setVisible(false)
        self.scrollCount:setVisible(false)
    end

end


return T