--[[
 *	9个物品显示窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 基础的tag值
T.baseTag = 1000

--- 主窗口
T.window = window

--- 构造函数
function T:ctor(window)
    self.window = window

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    --- 随机数对象
    local random = Random:new()
    random:setSeed(os.time())
    self.random = random

    self:init()

    -- 蒙版层
    local uiMask = ccui.Layout:create()
    self:addChild(uiMask)
    REL:relOther(uiMask,self, 10, 10, 15, 15)
	uiMask:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid )
	uiMask:setBackGroundColor(cc.c3b(0,0,0))
	uiMask:setBackGroundColorOpacity(150)
    uiMask:setLocalZOrder(1000)
    uiMask:setTouchEnabled(true)
    self.uiMask = uiMask
    self:closeMask()

end

function T:init()
    -- 背景图片
    local wheelBackFrame = ResLoader:getSpriteFrame("wheelBack.png")
	local wheelBackSize = wheelBackFrame:getOriginalSize()
	local wheelBack = Scale9Sprite:createWithFrame(wheelBackFrame,cc.rect(wheelBackSize.width/2,wheelBackSize.height/2,1,1))
	self:addChild(wheelBack)

    local size = cc.size(636,616)
    wheelBack:setContentSize(size)
    self:setContentSize(size)

    REL:toOther("center","middle",wheelBack,self,0,0)
    self.wheelBack = wheelBack

    -- 坐标数组:离左边和顶部
    local w,h = 138,159
    local leftStep = 40
    local topStep = 10

    local baseLeft = (636 -  3*138 - 2*leftStep)/2
    local baseTop = (616 -  3*159 - 2*topStep)/2 - 10

    

    self.pos = {
        {baseLeft,baseTop},{baseLeft + w + leftStep,baseTop},{baseLeft + (w + leftStep)*2,baseTop},
        {baseLeft,baseTop + h + topStep},{baseLeft + w + leftStep,baseTop + h + topStep},{baseLeft + (w + leftStep)*2,baseTop + h + topStep},
        {baseLeft,baseTop + (h + topStep)*2},{baseLeft + w + leftStep,baseTop + (h + topStep)*2},{baseLeft + (w + leftStep)*2,baseTop  + (h + topStep)*2}
    }

    self.res = {}

    for i = 1,9,1 do
        local back = ccui.ImageView:create()
        back:setTag(self.baseTag + i)
        back:loadTexture("luckeyBottom.png",ccui.TextureResType.plistType)
        self:addChild(back)
        REL:toOther("left","top",back,wheelBack,self.pos[i][1],self.pos[i][2])
        self.res[#self.res + 1] = back
        back:setLocalZOrder(100)
        

        -- 中间那张图片
        local icon = ccui.ImageView:create()
        icon:loadTexture("chest.png",ccui.TextureResType.plistType)
        self:addChild(icon)
        REL:toOther("center","middle",icon,back,0,0)
        back.icon = icon
        icon:setLocalZOrder(101)


        back:setTouchEnabled(true)
        back:addTouchEventListener(function (sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                self:openMask() -- 只要一点击就开启遮罩，防止2个一起点
                for i = 1,9,1 do
                    self.res[i]:setTouchEnabled(false)        
                end
                local function finish(data)
                    AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)            
                    self.showAwardData = data
                    local tag = sender:getTag() - self.baseTag
                    self:setShowAward(tag)                  
                    self:play(tag)
                end
                local function finish2() -- 通讯失败，移除遮罩
                    self:closeMask()
                    for i = 1,9,1 do
                        self.res[i]:setTouchEnabled(true)        
                    end
                end

                Command:luckyLottery(finish,finish2)

            end
        end)

    end

    
end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()

end

--- 播放动画
function T:play(tag)
    AudioManager:playEffect(SoundRes.SOUND_LOTTERY_STOP)

    local res = self.res
    --res[tag]:setLocalZOrder(2000)
	local scale = res[tag]:getScale()

    res[tag].icon:setLocalZOrder(2001)


    -- 移动前的特效
    local uiSp = cc.Sprite:create()
    self:addChild(uiSp)
    uiSp:setScale(1.3)
	REL:toOther("center", "middle", uiSp, res[tag].icon, 0, 0)
    uiSp:setLocalZOrder(1900)

	local animation = ResLoader:getAnimation("iconLight")
	if animation then
        uiSp:runAction(
            cc.Sequence:create(
		        cc.Animate:create(animation),
		        cc.CallFunc:create( function()
			        uiSp:removeFromParent()

		        end)
		    )
	    )
	end

    local uiSp2 = cc.Sprite:create()
    self:addChild(uiSp2)
	REL:toOther("center", "middle", uiSp2, res[tag].icon, 0, 0)
    uiSp2:setLocalZOrder(3000)

	local animation = ResLoader:getAnimation("iconStar")
	if animation then
        uiSp2:runAction(
            cc.Sequence:create(
		        cc.Animate:create(animation),
		        cc.CallFunc:create( function()
			        uiSp2:removeFromParent()

		        end)
		    )
	    )
	end



    -- 执行移动操作
    res[tag].icon:runAction(cc.Sequence:create(
        cc.DelayTime:create(0.7), -- 因为要设置图片，所以延迟了
		cc.MoveTo:create(0.3, cc.p(318,400)),
        cc.ScaleTo:create(0.15, 1.4),
        cc.ScaleTo:create(0.15, 1),
		cc.CallFunc:create( function(target)
            -- 设置小秘书说明
            self.window:lotteryEnd()

            local showAwardData = self.showAwardData
            --描述
            local des = XMLLabel()
            des:setLocalZOrder(2001)
            des:setAlign("center","top")
            des:setContentSize(cc.size(300,36))
            self:addChild(des)
            REL:toOther("center","top",des,res[tag].icon,0,130)
            des:setString(Language:get("uc540",showAwardData.name,showAwardData.count,showAwardData.des))
            self.des = des

            --按钮
            if not self.btn then
                local btn = Button.new("false","true")
                btn:setLocalZOrder(2002)
	            btn:setButtonState("bigButton_green_normal.png","bigButton_general_down.png")
	            self:addChild(btn)
	            REL:toOther("center","bottom",btn,self.wheelBack,0,100)
                btn:setTextCenter()
                btn:setString(Language:get("uc541"))
                btn:addTouchEventListener(function(sender, eventType)
                    if eventType == ccui.TouchEventType.ended then
                        self.des:removeFromParent()
                        self.des = nil
                        self.btn:setVisible(false)
                                       
                        self:closeMask()

                        for i = 1,9,1 do
                            --res[i]:loadTexture("luckeyBottom.png",ccui.TextureResType.plistType)
                            res[i].icon:loadTexture("chest.png",ccui.TextureResType.plistType)
                            REL:toOther("left","top",res[i],self.wheelBack,self.pos[i][1],self.pos[i][2])
                            res[i]:setLocalZOrder(100)
                            res[i]:setTouchEnabled(true)     
                            REL:toOther("center","middle",res[i].icon,res[i],0,0)   
                            res[i].icon:setLocalZOrder(101)

                        end

                        self.window:refresh()
                    end
                end)
                self.btn = btn
            else
                self.btn:setVisible(true)
            end

		end )
	))
end

--- 把所有的奖励品都显示出来
function T:setShowAward(tag)
    local allData = LotteryDataDecoder:getAllLotteryData()

    local showAwardData = self.showAwardData
    -- 产生从0到25中的除去中奖的id的8个随机数
    local queue = Queue()
    queue:push(showAwardData.id)
    local count = 0
    while true do
        if count == 8 then
            break
        end

        local length = queue:getLength()
        local randId = self.random:randomBetweenInt(0,25+1)
        for i = 1,length,1 do
            local queueId = queue:look(i)
            if queueId == randId then
                randId = nil
                break
            end
        end

        if randId then
            queue:push(randId)
            count = count + 1
        end

    end

    local res = self.res
    local length = queue:getLength()
    local index = 1
    for i = 1,length,1 do
        local popId = queue:pop() 
        if i == 1 then -- 弹出的第一个数为中奖的id
            --res[tag]:loadTexture(allData[popId].iconUrl)
            res[tag].icon:loadTexture(allData[popId].iconUrl)
        else
            if index == tag then
                index = index + 1
            end

            --res[index]:loadTexture(allData[popId].iconUrl)
            res[index].icon:loadTexture(allData[popId].iconUrl)
            index = index + 1

            
        end

    end

end


--- 开启蒙版层
function T:openMask()
    self.uiMask:setVisible(true)
end

--- 关闭蒙版层
function T:closeMask()
    self.uiMask:setVisible(false)
end

return T