--[[
 *	连续签到视图:不滑动
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 每项的信息
T.ContinueAttendanceDateItem = require("src.app.uiScript.components.allActivity.sign.ContinueAttendanceDateItem")


--- 构造函数
function T:ctor()
    
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:initTop()
    self:refreshVipData()
    self:addItems()


    -- 已经连续登陆描述
    local day = XMLLabel()
    day:setContentSize(cc.size(600,36))
    self:addChild(day)
    REL:toOther("left","top",day,self,6,self.topHeight + 80)
    self.day = day

    self:refresh()

    SetStates.signManager:luaAddEventListener(SetStates.signManager.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH,self,self.refresh)
    PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.vipPoint,self,self.refreshVipData)

end

function T:refresh()
    local continueAttendanceCount = SetStates.signManager.continueAttendanceCount
    local day = continueAttendanceCount:getCount()

    self.day:setString(Language:get("uc426",day))

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    SetStates.signManager:luaRemoveEventListener(SetStates.signManager.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH,self,self.refresh)
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.vipPoint,self,self.refreshVipData)
end

function T:initTop()
    -- 左边vip图片
    local leftVipImg = ccui.ImageView:create()
    leftVipImg:loadTexture("vip.png",ccui.TextureResType.plistType)
    self:addChild(leftVipImg)
    REL:toOther("left","top",leftVipImg,self,15,10)

    -- 左边vip等级
--    local leftVipLevel = XMLLabel()
--    leftVipLevel:setContentSize(cc.size(150,36))
--    leftVipLevel:setVAlign("middle")
--    self:addChild(leftVipLevel)
--    REL:toOther("left","middle",leftVipLevel,leftVipImg,55,0)
--    self.leftVipLevel = leftVipLevel

    local leftVipLevel = ccui.TextBMFont:create(1,"res/images/activity/vipFont.fnt")
	self:addChild(leftVipLevel)
    REL:toOther("left","middle",leftVipLevel,leftVipImg,55,-8)
    self.leftVipLevel = leftVipLevel

    -- vip进度条
    local backImg = ccui.ImageView:create()
    backImg:loadTexture("productProgressBack.png",ccui.TextureResType.plistType)
    self:addChild(backImg)
    REL:toOther("left","middle",backImg,leftVipImg,85,0)
    self.backImg = backImg

    local uiProgressFore = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("productProgressFore.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	backImg:addChild(uiProgressFore)
    REL:toOther("center","middle",uiProgressFore,backImg,0,0)
    self.uiProgressFore = uiProgressFore

    -- vip经验数字背景图片
    local vipDigitalImgFrame = ResLoader:getSpriteFrame("timeBack.png")
    local vipDigitalImgSize = vipDigitalImgFrame:getOriginalSize()
    local vipDigitalImg = Scale9Sprite:createWithFrame(vipDigitalImgFrame,cc.rect(vipDigitalImgSize.width/2,vipDigitalImgSize.height/2,1,1))
    vipDigitalImg:setContentSize(90,25)
	self:addChild(vipDigitalImg)
    REL:toOther("center","middle",vipDigitalImg,backImg,0,0)
    self.vipDigitalImg = vipDigitalImg

    -- vip数字
    local vipdigital = XMLLabel()
    vipdigital:setContentSize(cc.size(200,36))
    vipdigital:setAlign("center","middle")
    self:addChild(vipdigital)
    REL:toOther("center","middle",vipdigital,vipDigitalImg,0,0)
    self.vipdigital = vipdigital

    -- 右边vip图片
    local rightVipImg = ccui.ImageView:create()
    rightVipImg:loadTexture("vip.png",ccui.TextureResType.plistType)
    self:addChild(rightVipImg)
    REL:toOther("left","middle",rightVipImg,backImg,255,0)

    -- 右边vip等级
--    local rightVipLevel = XMLLabel()
--    rightVipLevel:setContentSize(cc.size(150,36))
--    rightVipLevel:setVAlign("middle")
--    self:addChild(rightVipLevel)
--    REL:toOther("left","middle",rightVipLevel,rightVipImg,55,0)
--    self.rightVipLevel = rightVipLevel

    local rightVipLevel = ccui.TextBMFont:create(1,"res/images/activity/vipFont.fnt")
	self:addChild(rightVipLevel)
    REL:toOther("left","middle",rightVipLevel,rightVipImg,55,-8)
    self.rightVipLevel = rightVipLevel

    -- vip限购
    local checkVip = Button.new("false","true")
	checkVip:setButtonState("bigButton_purple_normal.png","bigButton_general_down.png")
	checkVip:setString(Language:get("uc475"))
	self:addChild(checkVip)
    REL:toOther("right","top",checkVip,self,10,-10)
    checkVip:setTextCenter()
    checkVip:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            WindowManager:push(
		        require("src.app.uiScript.components.vip.VIPWindow").new()
	        )
        end
    end)

end

--- 刷新vip数据
function T:refreshVipData()
    local vipLevel = UserInfo.vipLevel
    self.leftVipLevel:setString(vipLevel)
    self.rightVipLevel:setString(vipLevel + 1)
    if vipLevel == 12 then
        self.rightVipLevel:setVisible(false)
    else
        self.rightVipLevel:setVisible(true)
    end

    local playerVipPoint = VipManager:getPlayerVipPoint()
    local allVipPoint = VipManager:getNextVipPoint()
    self.vipdigital:setString(Language:get("uc472",playerVipPoint,allVipPoint))
    if playerVipPoint < allVipPoint then
        self.uiProgressFore:setPercentage(playerVipPoint/allVipPoint * 100)
    else
        self.uiProgressFore:setPercentage(100)
    end
    
    -- 重新设置大小
    self.vipdigital:updateView()
    local width = self.vipdigital:getTextWidth()
    self.vipDigitalImg:setContentSize(width + 6,25)
    REL:toOther("center","middle",self.vipDigitalImg,self.backImg,0,0)
    REL:toOther("center","middle",self.vipdigital,self.vipDigitalImg,0,0)



end

function T:addItems()
    local offsetTop = nil

    local num = #ContinueAttendance_temp
    for i = 1,num,1 do 
        local item = self.ContinueAttendanceDateItem.new(i,ContinueAttendance_temp[i])  -- 天数
        local height = item:getContentSize().height
        local offset = (i - 1) * height + 80
        self:addChild(item)
        REL:toOther("left","top",item,self,6,offset)

        offsetTop = height
    end

    self.topHeight = offsetTop * num

end



return T