--[[
 * 签到窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)


--- 构造函数 
function T:ctor()
    local function callBack1()
        self:dailySignLogic()
    end

    local function callBack2()
        self:continueSignLogic()
    end

    -- 创建2个
    local switchButtonContainer = SwitchButtonContainer.new()
    self:addChild(switchButtonContainer)
    REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
    switchButtonContainer:init()
    switchButtonContainer:initButtons(
        2,
        {{"viewSwitchButton_normal.png","viewSwitchButton_down.png"},{"viewSwitchButton_normal.png","viewSwitchButton_down.png"}},
        {110,15},
        {callBack1,callBack2},
        {Language:get("uc419"),Language:get("uc420")}
    )
    self.switchButtonContainer = switchButtonContainer

    self:setWindowTitle(Language:get("uc421"))

    self:dailySignLogic()

    self:updateDailyTag()
	self:updateContinueTag()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 更新单日标识
function T:updateDailyTag()
    local dailyAttendanceDate = SetStates.signManager.dailyAttendanceDate
    local state = dailyAttendanceDate:judgeIsSign() -- true能签到
    self.switchButtonContainer:updateButton1Tag(state)
end

--- 更新连续标识
function T:updateContinueTag()
    local signManager = SetStates.signManager
    local state = signManager:judgeContinueSign() -- true能签到
    self.switchButtonContainer:updateButton2Tag(state)
end

--- 获得特效
function T:getEff(kind)
	local s = cc.Sprite:create()
	local ani = ResLoader:getAnimation(kind)
	if not ani then
		return
	end

	local ac = cc.RepeatForever:create(cc.Animate:create(ani))
	s:runAction(ac)
	return s

end

function T:onEnter()
    self.super.onEnter(self)
    SetStates.signManager:luaAddEventListener(SetStates.signManager.EVT_DAILY_ATTENDANCE_ALL_DATA_REFRESH,self,self.updateDailyTag)
    SetStates.signManager:luaAddEventListener(SetStates.signManager.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH,self,self.updateContinueTag)
end

function T:onExit()
    self.super.onExit(self)
    SetStates.signManager:luaRemoveEventListener(SetStates.signManager.EVT_DAILY_ATTENDANCE_ALL_DATA_REFRESH,self,self.updateDailyTag)
    SetStates.signManager:luaRemoveEventListener(SetStates.signManager.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH,self,self.updateContinueTag)
end

--- 每日签到奖励
function T:dailySignLogic()
    if self.dailySign == nil then
        self.dailySign = require("src.app.uiScript.components.allActivity.sign.DailyAttendanceDateView").new()
        self:addChild(self.dailySign)       
        REL:relOther(self.dailySign,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.dailySign:init()
    end

    if self.dailySign then
        self.dailySign:setVisible(true)
    end

    if self.continueSign then
        self.continueSign:setVisible(false)
    end

end

--- 连续签到奖励
function T:continueSignLogic()
    if self.dailySign then
        self.dailySign:setVisible(false)
    end

    if self.continueSign == nil then
        self.continueSign = require("src.app.uiScript.components.allActivity.sign.ContinueAttendanceDateView").new()
        self:addChild(self.continueSign)       
        REL:relOther(self.continueSign,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.continueSign:init()
    end

    if self.continueSign then
        self.continueSign:setVisible(true)
    end

end

return T