--[[
 *	主界面弹出联盟窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

--- 构造函数
function T:ctor()
    self:init()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:setTouchEnabled(true)
    
    self:setContentSize(cc.size(630,790))

    self:setWidget()
    self:refreshData()

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    
end

function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end


function T:setWidget()
    -- 背景图片
    local f = ResLoader:getSpriteFrame("worldPopFrame.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,216,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self,0,0,0,0)
	self.viewBack = viewBack

    -- 右上角按钮
    local close = Button.new("false","false")
	close:setButtonState("alterCoseButton_normal.png","alterCoseButton_normal.png")
	self:addChild(close)
	REL:toOther("right","top",close,viewBack,30,80)
    close:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.muialter2:hide()
        end
    end)

    -- 标题背景
    local worldPopTopTag = ccui.ImageView:create()
    worldPopTopTag:loadTexture("worldPopTopTag.png",ccui.TextureResType.plistType)
    self:addChild(worldPopTopTag)
    REL:toOther("center","top",worldPopTopTag,viewBack,0,75)

    -- 名字
    local title = XMLLabel()
    title:setHAlign("center")
    title:setContentSize(cc.size(400,36))
    self:addChild(title)
    REL:toOther("center","top",title,worldPopTopTag,0,5)
    title:setString(Language:get("uc684"))


    -- 领取框
    local worldPopMiddleFrame = ResLoader:getSpriteFrame("worldPopMiddleFrame.png")
	local worldPopMiddle = Scale9Sprite:createWithFrame(worldPopMiddleFrame)
    worldPopMiddle:setContentSize(cc.size(550,120))
	self:addChild(worldPopMiddle)
    REL:toOther("center","top",worldPopMiddle,viewBack,0,140)


    -- 资源图片
    local icon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    icon:loadTexture(iconPath .. Prop_temp[200].propIcon)
    self:addChild(icon)
    REL:toOther("left","middle",icon,worldPopMiddle,10,0)
    self.icon = icon


    -- 名字
    local name = XMLLabel()
    name:setVAlign("middle")
    name:setContentSize(cc.size(400,36))
    self:addChild(name)
    REL:toOther("left","middle",name,worldPopMiddle,115,-20)
    name:setString(Language:get("uc685"))

    -- 描述
    local des = XMLLabel()
    des:setVAlign("middle")
    des:setContentSize(cc.size(300,36))
    self:addChild(des)
    REL:toOther("left","middle",des,worldPopMiddle,115,20)
    des:setString(Language:get("uc686"))


    -- 领取按钮
    local getBtn = Button.new("false","true")
	getBtn:setButtonState("button_yellow_normal.png","button_general_down.png")
    getBtn:setString(Language:get("uc693"))
	self:addChild(getBtn)
	REL:toOther("right","middle",getBtn,worldPopMiddle,10,-10)
    getBtn:setTextShadow()
    getBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            require("src.app.communication.alliance.GetAllianceAwardCommand")():exec(function(state,awardData)
                    if state == ReturnCode.SUCCESS then
                        if awardData then
                            self.AwardDataDecoder:showSuccessWindow(awardData)
                            self:refreshData()
                            self.muialter2:hide()
                        end

                    else
                        ErrorCode:popErrorCodeTip(state)
                    end
            end)

        end
    end)
    self.getBtn = getBtn

    -- 中间背景图片
	local centerBack = Scale9Sprite:createWithFrame(worldPopMiddleFrame)
    centerBack:setContentSize(cc.size(550,330))
	self:addChild(centerBack)
    REL:toOther("center","top",centerBack,viewBack,0,270)
    self.centerBack = centerBack

    self:getBackAndDes(Language:get("uc687"),Language:get("uc688"),20)
    self:getBackAndDes(Language:get("uc689"),Language:get("uc690"),130)
    self:getBackAndDes(Language:get("uc691"),Language:get("uc692"),240)


    -- 添加分割线
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(530,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, centerBack, 0, 110)

    local seqLine2 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine2:setContentSize(530,2)
	self:addChild(seqLine2)
    REL:toOther("center", "top", seqLine2, centerBack, 0, 220)

    -- 加入联盟
    local joinAlliance = Button.new("false","true")
	joinAlliance:setButtonState("longButton_green_normal.png","longButton_general_down.png")
    joinAlliance:setString(Language:get("uc682"))
	self:addChild(joinAlliance)
	REL:toOther("left","bottom",joinAlliance,viewBack,70,80)
    joinAlliance:setTextShadow()
    joinAlliance:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if BuildingsInfoMgr:getBuildingInfos()[1].level < 5 then
                local descripe = Language:get("uc706")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            else
                self.muialter2:hide()
                WindowManager:push(require("src.app.uiScript.components.alliance.AllianceHasNotWindow").new(1))
            end

        end
    end)
    self.joinAlliance = joinAlliance

    -- 创建联盟
    local createAlliance = Button.new("false","true")
	createAlliance:setButtonState("longButton_yellow_normal.png","longButton_general_down.png")
    createAlliance:setString(Language:get("uc683"))
	self:addChild(createAlliance)
	REL:toOther("right","bottom",createAlliance,viewBack,70,80)
    createAlliance:setTextShadow()
    createAlliance:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if BuildingsInfoMgr:getBuildingInfos()[1].level < 5 then
                local descripe = Language:get("uc706")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            else
                self.muialter2:hide()
                WindowManager:push(require("src.app.uiScript.components.alliance.AllianceHasNotWindow").new(3))
            end

        end
    end)
    self.createAlliance = createAlliance

end


function T:getBackAndDes(name1,des1,posTop)
    local icon = ccui.ImageView:create()
    icon:loadTexture("fightStar_enabeled.png",ccui.TextureResType.plistType)
    self:addChild(icon)
    REL:toOther("left","top",icon,self.centerBack,20,posTop)


    -- 名字
    local name = XMLLabel()
    name:setVAlign("middle")
    name:setContentSize(cc.size(400,36))
    self:addChild(name)
    REL:toOther("left","middle",name,icon,80,20)
    name:setString(name1)

    -- 描述
    local des = XMLLabel()
    des:setVAlign("middle")
    des:setContentSize(cc.size(400,36))
    self:addChild(des)
    REL:toOther("left","middle",des,icon,80,-20)
    des:setString(des1)


end

function T:refreshData()
    local id = UserInfo.allianceBox.myAlliance.id
    if id and id > 0 then -- 有联盟
        self.joinAlliance:setVisible(false)
        self.createAlliance:setVisible(false)

        local joinAllianceAward = SetStates.joinAllianceAward
        if joinAllianceAward:getState() == 0 then -- 未领取
            
            self.getBtn:setIsGray(false)
            self.getBtn:setTouchEnabled(true)
        else
            
            self.getBtn:setIsGray(true)
            self.getBtn:setTouchEnabled(false)
        end

    else
        self.joinAlliance:setVisible(true)
        self.createAlliance:setVisible(true)

        self.getBtn:setIsGray(true)
        self.getBtn:setTouchEnabled(false)
    end

end


return T