--- 联盟创建视图
-- @author blank
local T = Class.CreateAllianceView(function() return ccui.Layout:create() end)

function T:def()

end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			print("CreateAllianceView=>evt:"..eventType)
		
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()
	ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.updateNeed)
end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local top=80

	---输入名称----------------------------------------------------------------------------

	local lLimit,uLimit=unpack(GameCfg.ALLIANCE_NAME_LIMIT)

	--"名称"输入框
	local uiNameInput=InputBox:create(cc.size(240,50))
	uiNameInput:setMaxLength(uLimit)
	self:addChild(uiNameInput)
	REL:toOther("center","top",uiNameInput,self,0,top)
	self.uiNameInput=uiNameInput

	top=top+uiNameInput:getContentSize().height+10

	--"输入联盟名称"提示
	local uiNameCap=XMLLabel(Language:get("ug700"))
	uiNameCap:setAlign("center","middle")
	uiNameCap:setContentSize(cc.size(68,36))
	self:addChild(uiNameCap)
	REL:relOther(uiNameCap,self,10,10,top,SIZE_NIL)
	--------------------------------------------------------------------------------------

	top=top+uiNameCap:getHeight()+10

	--"需求"提示
	local uiNeedTip=XMLLabel()
	uiNeedTip:setAlign("center","top")
	uiNeedTip:setContentSize(cc.size(68,72))
	self:addChild(uiNeedTip)
	REL:relOther(uiNeedTip,self,10,10,top,SIZE_NIL)
	self.uiNeedTip=uiNeedTip

	--"创建"按钮
	local uiCreateButton=BaseButton:getGeneralButton(Language:get("ug712"))
	self:addChild(uiCreateButton)
	REL:toOther("center","bottom",uiCreateButton,self,0,20)
	self.uiCreateButton=uiCreateButton

	uiCreateButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			--资源不足
			if not self:updateNeed() then
				MUIAlter.show({
					info=Language:get("ug708")
				},WindowManager:getCurrentWindow())
				return
			end

			local name=uiNameInput:getText()
			--联盟名为空
			if not name or string.trim(name) == "" then
				MUIAlter.show({
					info=Language:get("ug706")
				},WindowManager:getCurrentWindow())
				return
			end

			--联盟名长度验证
			local c=StringUtils.getCount(name)
			local lLimit,uLimit=unpack(GameCfg.ALLIANCE_NAME_LIMIT)
			if c < lLimit or c > uLimit then
				MUIAlter.show({
					info=Language:get("ug710",lLimit,uLimit)
				},WindowManager:getCurrentWindow())
				return
			end
			
			--敏感字验证
			if WordsFilters:contains(name,SensitiveWordsRoot) then
				MUIAlter.show({
					info=Language:get("er4")
				},WindowManager:getCurrentWindow())
			
				return
			end

			require("src.app.communication.alliance.CreateAllianceCommand")():exec(
				name,
				function(state,allianceId)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug707"),
							showSecond=1.5
						})

						--切换到联盟信息界面
						require("src.app.communication.alliance.GetMyAllianceInfoCommand")():exec(
							function(state)
								if state == ReturnCode.SUCCESS then
									WindowManager:switch(require("src.app.uiScript.components.alliance.AllianceWindow").new())
								else
									MUIAlter_singleLine.show({
										info=ErrorCode:getErrInfo(state)
									},WindowManager:getCurrentWindow())
								end
							end)
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end
	end)

	self:updateNeed()
	ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.updateNeed)
end

--- 更新需求
function T:updateNeed()
	local isMeet=true

	local needStr,hasStr
	local need=GameCfg.ALLIANCE_CREATE_NEED
	for _,v in pairs(need) do
		local r=Resource_temp[v[1]]
		local c=v[2]

		local hasCount=UserInfo.city[r.attributeName]
		if hasCount < c then
			isMeet=false
		end

		if needStr then
			needStr=needStr..Language:get("ug703",UnitConversion.unitTrans(c),Language:get(r.name))
			hasStr=hasStr..Language:get("ug703",UnitConversion.unitTrans(hasCount),Language:get(r.name))
		else
			needStr=Language:get("ug702",UnitConversion.unitTrans(c),Language:get(r.name))
			hasStr=Language:get("ug702",UnitConversion.unitTrans(hasCount),Language:get(r.name))
		end
	end

	self.uiNeedTip:setString(Language:get("ug701",needStr,hasStr))
	if isMeet then
		self.uiCreateButton:setIsGray(false)
		return true
	end
	return false
end

return T
