--- 联盟信息视图
-- @author blank
local T = Class.AllianceInfoView(function() return ccui.Layout:create() end)

--- 联盟科技窗口
T.AllianceScienceWindow=require("src.app.uiScript.components.alliance.AllianceScienceWindow")

function T:def()

end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.updateView)
end

--- 初始化
function T:init()
	local aInfo=UserInfo.allianceBox.myAlliance

	local left=10
	local top=10

	--值背景帧
	local valBackFrame=ResLoader:getSpriteFrame("inputBoxBack.png")

	--联盟名称>>----------------------------------------------------------------------
	--"联盟名称"标题
	local uiNameCap=XMLLabel(Language:get("ug640"))
	uiNameCap:setContentSize(cc.size(120,48))
	uiNameCap:setAlign("left","middle")
	self:addChild(uiNameCap)
	REL:toOther("left","top",uiNameCap,self,left,top)

	--"联盟名称"背景
	local uiNameBack=Scale9Sprite:createWithFrame(valBackFrame)
	self:addChild(uiNameBack)
	uiNameBack:setContentSize(cc.size(220,48))
	REL:toOther("left","top",uiNameBack,self,left+uiNameCap:getWidth(),top)

	--联盟名称
	local uiName=XMLLabel(aInfo.name or "")
	uiName:setAlign("center","middle")
	self:addChild(uiName)
	REL:relOther(uiName,uiNameBack,0,0,0,0)
	self.uiName=uiName
	--<<联盟名称----------------------------------------------------------------------

	---联盟排名>>----------------------------------------------------------------------
	--"联盟排名"标题
	local uiRankCap=XMLLabel(Language:get("ug642"))
	uiRankCap:setContentSize(cc.size(120,48))
	uiRankCap:setAlign("left","middle")
	self:addChild(uiRankCap)
	REL:toOther("left","top",uiRankCap,self,uiName:getPositionX()+uiName:getWidth()+20,top)

	--"联盟排名"背景
	local uiRankBack=Scale9Sprite:createWithFrame(valBackFrame)
	self:addChild(uiRankBack)
	uiRankBack:setContentSize(cc.size(120,48))
	REL:toOther("left","top",uiRankBack,self,uiRankCap:getPositionX()+uiRankCap:getWidth(),top)

	--联盟排名
	local uiRank=XMLLabel(aInfo.rank or "")
	uiRank:setAlign("center","middle")
	self:addChild(uiRank)
	REL:relOther(uiRank,uiRankBack,0,0,0,0)
	---<<联盟名称----------------------------------------------------------------------

	top=top+uiRank:getHeight()+4

	---联盟会长>>----------------------------------------------------------------------
	--"联盟会长"标题
	local uiChairmanCap=XMLLabel(Language:get("ug641"))
	uiChairmanCap:setContentSize(cc.size(120,48))
	uiChairmanCap:setAlign("left","middle")
	self:addChild(uiChairmanCap)
	REL:toOther("left","top",uiChairmanCap,self,left,top)

	--"联盟会长"背景
	local uiChairmanBack=Scale9Sprite:createWithFrame(valBackFrame)
	self:addChild(uiChairmanBack)
	uiChairmanBack:setContentSize(cc.size(220,48))
	REL:toOther("left","top",uiChairmanBack,self,uiChairmanCap:getPositionX()+uiChairmanCap:getWidth(),top)

	--联盟会长
	local uiChairman=XMLLabel(aInfo.leaderName or "")
	uiChairman:setAlign("center","middle")
	self:addChild(uiChairman)
	REL:relOther(uiChairman,uiChairmanBack,0,0,0,0)
	self.uiChairman=uiChairman
	---<<联盟名称----------------------------------------------------------------------

	-----联盟等级>>----------------------------------------------------------------------
	--"联盟等级"标题
	local uiLVCap=XMLLabel(Language:get("ug643"))
	uiLVCap:setContentSize(cc.size(120,48))
	uiLVCap:setAlign("left","middle")
	self:addChild(uiLVCap)
	REL:toOther("left","top",uiLVCap,self,uiChairman:getPositionX()+uiChairman:getWidth()+20,top)

	--"联盟等级"背景
	local uiLVBack=Scale9Sprite:createWithFrame(valBackFrame)
	self:addChild(uiLVBack)
	uiLVBack:setContentSize(cc.size(120,48))
	REL:toOther("left","top",uiLVBack,self,uiLVCap:getPositionX()+uiLVCap:getWidth(),top)

	--联盟等级
	local uiLV=XMLLabel(aInfo.level or "0")
	uiLV:setAlign("center","middle")
	self:addChild(uiLV)
	REL:relOther(uiLV,uiLVBack,0,0,0,0)
	---<<联盟名称----------------------------------------------------------------------

	top=top+uiLV:getHeight()+4

	---联盟战力>>----------------------------------------------------------------------
	--"联盟战力"标题
	local uiFightCap=XMLLabel(Language:get("ug644"))
	uiFightCap:setContentSize(cc.size(120,48))
	uiFightCap:setAlign("left","middle")
	self:addChild(uiFightCap)
	REL:toOther("left","top",uiFightCap,self,left,top)

	--"联盟战力"背景
	local uiFightBack=Scale9Sprite:createWithFrame(valBackFrame)
	self:addChild(uiFightBack)
	uiFightBack:setContentSize(cc.size(220,48))
	REL:toOther("left","top",uiFightBack,self,uiFightCap:getPositionX()+uiFightCap:getWidth(),top)

	--联盟战力
	local uiFight=XMLLabel(aInfo.fight or 0)
	uiFight:setAlign("center","middle")
	self:addChild(uiFight)
	REL:relOther(uiFight,uiFightBack,0,0,0,0)
	---<<联盟名称----------------------------------------------------------------------

	-----联盟人数>>----------------------------------------------------------------------
	--"联盟人数"标题
	local uiMemberCap=XMLLabel(Language:get("ug645"))
	uiMemberCap:setContentSize(cc.size(120,48))
	uiMemberCap:setAlign("left","middle")
	self:addChild(uiMemberCap)
	REL:toOther("left","top",uiMemberCap,self,uiFight:getPositionX()+uiFight:getWidth()+20,top)

	--"联盟人数"背景
	local uiMemberBack=Scale9Sprite:createWithFrame(valBackFrame)
	self:addChild(uiMemberBack)
	uiMemberBack:setContentSize(cc.size(120,48))
	REL:toOther("left","top",uiMemberBack,self,uiMemberCap:getPositionX()+uiMemberCap:getWidth(),top)

	--联盟人数
	local uiMember=XMLLabel(Language:get("ug652",aInfo.memberCount or 0,aInfo.memberLimit or 0))
	uiMember:setAlign("center","middle")
	self:addChild(uiMember)
	REL:relOther(uiMember,uiMemberBack,0,0,0,0)
	---<<联盟人数----------------------------------------------------------------------

	top=top+uiMember:getHeight()+4

	-----联盟公告>>----------------------------------------------------------------------
	--"联盟公告"标题
	local uiNoticeCap=XMLLabel(Language:get("ug648"))
	uiNoticeCap:setContentSize(cc.size(360,48))
	uiNoticeCap:setAlign("left","middle")
	self:addChild(uiNoticeCap)
	REL:toOther("left","top",uiNoticeCap,self,left,top)

	top=top+uiNoticeCap:getHeight()+4

	--"联盟公告"背景
	local uiNoticeBack=Scale9Sprite:createWithFrame(valBackFrame)
	self:addChild(uiNoticeBack)
	uiNoticeBack:setContentSize(cc.size(120,280))
	REL:relOther(uiNoticeBack,self,10,10,top,SIZE_NIL)

	--联盟公告
	local uiNotice=XMLTextArea(aInfo.notice or "")
	self:addChild(uiNotice)
	REL:relOther(uiNotice,uiNoticeBack,4,4,4,4)
	self.uiNotice=uiNotice
	---<<联盟公告----------------------------------------------------------------------

	top=top+uiNoticeBack:getContentSize().height+10

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	--- 创建"联盟邮件"按钮
	function T:createMailButton()
		local uiMailButton=BaseButton:createButton(Language:get("ug649"),"iconButton_allianceMail_normal.png")
		self:addChild(uiMailButton)
		uiMailButton.uiText:setHeight(36)
		REL:relOther(uiMailButton.uiText,uiMailButton,-20,-20,SIZE_NIL,-36)
		REL:toOther("center","top",uiMailButton,self,80,top)
		self.uiMailButton=uiMailButton
		uiMailButton:addTouchEventListener(function(t,e)
			if e == ccui.TouchEventType.ended then
				self:openAllianceMailWindow()
			end
		end)
	end

	--- 创建"设置"按钮
	function T:createEidtButton()
		local uiEditButton=BaseButton:createButton(Language:get("ug650"),"iconButton_allianceSet_normal.png")
		self:addChild(uiEditButton)
		uiEditButton.uiText:setHeight(36)
		REL:relOther(uiEditButton.uiText,uiEditButton,-20,-20,SIZE_NIL,-36)
		REL:toOther("center","top",uiEditButton,self,240,top)
		self.uiEditButton=uiEditButton
		uiEditButton:addTouchEventListener(function(t,e)
			if e == ccui.TouchEventType.ended then
				self:popAllianceSetBox()
			end
		end)
	end

	--- 创建"联盟科技"按钮
	function T:createScienceButton()
		local uiScienceButton=BaseButton:createButton(Language:get("ug901"),"iconButton_allianceTech_normal.png")
		self:addChild(uiScienceButton)
		uiScienceButton.uiText:setHeight(36)
		REL:relOther(uiScienceButton.uiText,uiScienceButton,-20,-20,SIZE_NIL,-36)
		REL:toOther("center","top",uiScienceButton,self,-240,top)
		uiScienceButton:addTouchEventListener(function(t,e)
			if e == ccui.TouchEventType.ended then
				self:openAllianceScienceWindow()
			end
		end)
	end

	--- 创建"联盟商店"按钮
	function T:createShopButton()
		local uiShopButton=BaseButton:createButton(Language:get("ug899"),"iconButton_allianceShop_noraml.png")
		self:addChild(uiShopButton)
		uiShopButton.uiText:setHeight(36)
		REL:relOther(uiShopButton.uiText,uiShopButton,-20,-20,SIZE_NIL,-36)
		REL:toOther("center","top",uiShopButton,self,-80,top)
		uiShopButton:addTouchEventListener(function(t,e)
			if e == ccui.TouchEventType.ended then
				self:openAllianceShopWindow()
			end
		end)
	end

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.updateView)
	self:updateView()
	self:createScienceButton()
	self:createShopButton()
end

--- 显示"联盟邮件"按钮
function T:showMailButton()
	if self.uiMailButton then
		self.uiMailButton:setVisible(true)
	else
		self:createMailButton()
	end
end
--- 隐藏"联盟邮件"按钮
function T:hideMailButton()
	if self.uiMailButton then
		self.uiMailButton:setVisible(false)
	end
end

--- 显示"设置"按钮
function T:showEditButton()
	if self.uiEditButton then
		self.uiEditButton:setVisible(true)
	else
		self:createEidtButton()
	end
end
--- 隐藏"设置"按钮
function T:hideEditButton()
	if self.uiEditButton then
		self.uiEditButton:setVisible(false)
	end
end

--- 刷新视图
function T:updateView()
	local aInfo=UserInfo.allianceBox.myAlliance

	self.uiChairman:setString(aInfo.leaderName or "")

	--联盟会长才能查看联盟邮件和设置联盟信息
	if aInfo.post == AlliancePost.LEADER then
		self:showMailButton()
		self:showEditButton()
	elseif aInfo.post == AlliancePost.VICE_CHAIRMAN then
		self:hideMailButton()
		self:showEditButton()
	else
		self:hideMailButton()
		self:hideEditButton()
	end
end

--- 打开联盟邮件发送窗口
function T:openAllianceMailWindow()
	if DailyStates:getAllianceMailCount() >= GameCfg.ALLIANCE_MAIL_LIMIT then
		MUIAlter.show({
			info=Language:get("ug940",GameCfg.ALLIANCE_MAIL_LIMIT)
		})
		return
	end

	local mWin=require("src.app.uiScript.components.mail.SendMailWindow").new(4)
	WindowManager:push(mWin)
end

--- 打开联盟科技窗口
function T:openAllianceScienceWindow()
	require("src.app.communication.alliance.GetAllianceScienceInfoCommand")():exec(
		function(state)
			if state == ReturnCode.SUCCESS then
				WindowManager:push(
					self.AllianceScienceWindow.new()
				)
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

--- 打开联盟商店窗口
function T:openAllianceShopWindow()
	require("src.app.communication.alliance.GetAllianceShopInfoCommand")():exec(
		function(state)
			if state == ReturnCode.SUCCESS then
				WindowManager:push(
					require("src.app.uiScript.components.alliance.AllianceShopWindow").new()
				)
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

--- 弹出联盟设置框
function T:popAllianceSetBox()
	local aInfo=UserInfo.allianceBox.myAlliance

	require("src.app.communication.alliance.GetAllianceDetailCommand")():exec(
		aInfo,
		function(state)
			if state == ReturnCode.SUCCESS then
				local setCvs=require("src.app.uiScript.components.alliance.info.AllianceSetCvs")()

				MUIAlter.show({
					info=setCvs,
					title=Language:get("ug726"),
					flag=4,
					isShowCloseButton=true,
					callback=function()
						self.uiNotice:setString(aInfo.notice)
					end
				},WindowManager:getCurrentWindow())
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

return T
