--- 联盟设置画布
local T=Class.AllianceSetCvs(function() return ccui.Layout:create() end)

function T:def()

end

function T:ctor()
	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local aInfo=UserInfo.allianceBox.myAlliance

	self:setContentSize(cc.size(582,741))
	self:setTouchEnabled(true)

	--输入框背景帧
	local inputBackFrame=ResLoader:getSpriteFrame("inputBoxBack.png")

	local top=10

	local uiInputBox=InputBox:create(cc.size(V_SZ.width-10,50))
	uiInputBox:setIsShowMask(true)
	self:addChild(uiInputBox,1000)
	uiInputBox:setPosition(65536,65536)

	-----联盟宣言>>----------------------------------------------------------------------
	--"联盟宣言"标题
	local uiDecCap=XMLLabel(Language:get("ug740"))
	uiDecCap:setHeight(36)
	uiDecCap:setAlign("left","middle")
	self:addChild(uiDecCap)
	REL:relOther(uiDecCap,self,10,10,top,SIZE_NIL)

	top=top+uiDecCap:getHeight()+4

	--"联盟宣言"背景
	local uiDecBack=Scale9Sprite:createWithFrame(inputBackFrame)
	self:addChild(uiDecBack)
	uiDecBack:setContentSize(cc.size(120,280))
	REL:relOther(uiDecBack,self,10,10,top,SIZE_NIL)

	--联盟宣言
	local uiDec=cc.Label:createWithSystemFont(aInfo.dec or "", defaultCssStyle.fontName, defaultCssStyle.size)
	uiDec:setAlignment(cc.TEXT_ALIGNMENT_LEFT,cc.VERTICAL_TEXT_ALIGNMENT_TOP)
	self:addChild(uiDec)
	REL:relOther(uiDec,uiDecBack,4,4,4,4)
	self.uiDec=uiDec

	--联盟宣言触发器
	local uiDecToucher=ccui.Layout:create()
	uiDecToucher:setTouchEnabled(true)
	self:addChild(uiDecToucher)
	REL:relOther(uiDecToucher,uiDecBack,0,0,0,0)

	uiDecToucher:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			REL:toScreen("center",nil,uiInputBox,0,0)
			REL:toOther(nil,"bottom",uiInputBox,uiDecBack,0,-uiInputBox:getContentSize().height)

			uiInputBox:setMaxLength(GameCfg.ALLIANCE_DEC_CHAR_LIMIT)
			uiInputBox:setText(uiDec:getString())

			local changedHandler,endedHandler
			changedHandler=function(t)
				uiDec:setString(t:getText())
			end
			endedHandler=function(t)
				t:luaRemoveEventListener("changed",nil,changedHandler)
				t:luaRemoveEventListener("ended",nil,endedHandler)

				t:setPosition(65536,65536)
			end

			uiInputBox:luaAddEventListener("changed",nil,changedHandler)
			uiInputBox:luaAddEventListener("ended",nil,endedHandler)

			CppCocos2dxUtils:activeEditBox(uiInputBox)
		end
	end)
	-----<<联盟宣言----------------------------------------------------------------------

	top=top+uiDecBack:getContentSize().height+10

	-----联盟公告>>----------------------------------------------------------------------
	--"联盟公告"标题
	local uiNoticeCap=XMLLabel(Language:get("ug741"))
	uiNoticeCap:setHeight(36)
	uiNoticeCap:setAlign("left","middle")
	self:addChild(uiNoticeCap)
	REL:relOther(uiNoticeCap,self,10,10,top,SIZE_NIL)

	top=top+uiNoticeCap:getHeight()+4

	--"联盟公告"背景
	local uiNoticeBack=Scale9Sprite:createWithFrame(inputBackFrame)
	self:addChild(uiNoticeBack)
	uiNoticeBack:setContentSize(cc.size(120,280))
	REL:relOther(uiNoticeBack,self,10,10,top,SIZE_NIL)

	--联盟公告
	local uiNotice=cc.Label:createWithSystemFont(aInfo.notice or "", defaultCssStyle.fontName, defaultCssStyle.size)
	uiNotice:setAlignment(cc.TEXT_ALIGNMENT_LEFT,cc.VERTICAL_TEXT_ALIGNMENT_TOP)
	self:addChild(uiNotice)
	REL:relOther(uiNotice,uiNoticeBack,4,4,4,4)
	self.uiNotice=uiNotice

	--联盟公告触发器
	local uiNoticeToucher=ccui.Layout:create()
	uiNoticeToucher:setTouchEnabled(true)
	self:addChild(uiNoticeToucher)
	REL:relOther(uiNoticeToucher,uiNoticeBack,0,0,0,0)
	uiNoticeToucher:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			REL:toScreen("center",nil,uiInputBox,0,0)
			REL:toOther(nil,"bottom",uiInputBox,uiNoticeBack,0,-uiInputBox:getContentSize().height)

			uiInputBox:setMaxLength(GameCfg.ALLIANCE_NOTICE_CHAR_LIMIT)
			uiInputBox:setText(uiNotice:getString())

			local changedHandler,endedHandler
			changedHandler=function(t)
				uiNotice:setString(t:getText())
			end
			endedHandler=function(t)
				t:luaRemoveEventListener("changed",nil,changedHandler)
				t:luaRemoveEventListener("ended",nil,endedHandler)

				t:setPosition({x=65536,y=65536})
			end

			uiInputBox:luaAddEventListener("changed",nil,changedHandler)
			uiInputBox:luaAddEventListener("ended",nil,endedHandler)

			CppCocos2dxUtils:activeEditBox(uiInputBox)
		end
	end)
	-----<<联盟公告----------------------------------------------------------------------

	top=top+uiNoticeBack:getContentSize().height+10

	--"设置"按钮
	local uiSaveButton=BaseButton:getGeneralButton(Language:get("ug742"))
	self:addChild(uiSaveButton)
	REL:toOther("center","top",uiSaveButton,self,0,top)
	uiSaveButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.SetAlliacneInfoCommand")():exec(
				self.uiDec:getString(),
				self.uiNotice:getString(),
				function(state)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug743"),
							showSecond=1.5
						})
						
						self.__hide__()
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state),
							showSecond=1.5
						})
					end
				end
			)
		end
	end)

	if not aInfo.dec then
		require("src.app.communication.alliance.GetAllianceDetailCommand")():exec(
			aInfo,
			function(state)
				if state == ReturnCode.SUCCESS then
					uiDec:setString(aInfo.dec)
				else
					MUIAlter_singleLine.show({
						info=ErrorCode:getErrInfo(state),
						showSecond=1.5
					})
				end
			end
		)
	end
end

--- 获取编辑后的联盟宣言
function T:getEditedDec()
	return self.uiDec:getString()
end

--- 获取编辑后的联盟公告
function T:getEditedNotice()
	return self.uiNotice:getString()
end

return T
