--- 联盟邀请项
local T=Class.AllianceInviteItem(function() return ccui.Layout:create() end)

--- 联盟信息查看画布
T.AllianceLookCvs=require("src.app.uiScript.components.alliance.invite.AllianceLookCvs")

function T:def()
--- 数据
-- self.data=nil
end

function T:ctor(data,changeCallback)
	self.data=data
	self.changeCallback=changeCallback
	
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
	self:setData(data)
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local data=self.data
	self:setContentSize(cc.size(600,72))

	--		self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--		self:setBackGroundColor(cc.c3b(0xff,0,0))
	--		self:setBackGroundColorOpacity(100)

	local left=6

	--"等级"
	local uiLVVal=XMLLabel(data.level)
	uiLVVal:setCssStyle(CssStyles.green20)
	uiLVVal:setContentSize(cc.size(66,36))
	uiLVVal:setAlign("center","middle")
	uiLVVal:setIsSingleLine(true)
	self:addChild(uiLVVal)
	REL:toOther("left","middle",uiLVVal,self,left,0)
	self.uiLVVal=uiLVVal
	left=left+uiLVVal:getWidth()

	--"联盟名"
	local uiANameVal=XMLLabel(data.name)
	uiANameVal:setCssStyle(CssStyles.default20)
	uiANameVal:setContentSize(cc.size(144,36))
	uiANameVal:setAlign("center","middle")
	uiANameVal:setIsSingleLine(true)
	self:addChild(uiANameVal)
	REL:toOther("left","middle",uiANameVal,self,left,0)
	self.uiANameVal=uiANameVal
	left=left+uiANameVal:getWidth()

	--"邀请人"
	local uiInviteVal=XMLLabel(data.inviterName)
	uiInviteVal:setCssStyle(CssStyles.green20)
	uiInviteVal:setContentSize(cc.size(144,36))
	uiInviteVal:setAlign("center","middle")
	uiInviteVal:setIsSingleLine(true)
	self:addChild(uiInviteVal)
	REL:toOther("left","middle",uiInviteVal,self,left,0)
	self.uiInviteVal=uiInviteVal
	left=left+uiInviteVal:getWidth()

	--"时间"
	local uiTimeVal=XMLLabel(GameUtils:lastLoginSec2String(data.inviteSec))
	uiTimeVal:setCssStyle(CssStyles.default20)
	uiTimeVal:setContentSize(cc.size(104,36))
	uiTimeVal:setAlign("center","middle")
	uiTimeVal:setIsSingleLine(true)
	self:addChild(uiTimeVal)
	REL:toOther("left","middle",uiTimeVal,self,left,0)
	self.uiTimeVal=uiTimeVal
	left=left+uiTimeVal:getWidth()

	--"操作"按钮
	local uiOptButton=BaseButton:createButton(Language:get("ug704"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiOptButton)
	REL:toOther("left","middle",uiOptButton,self,left,-10)
	self.uiOptButton=uiOptButton
	uiOptButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			MUIAlter.show({
				info=self.AllianceLookCvs(self.data,self.changeCallback),
				title=Language:get("ug726"),
				flag=4
			},WindowManager:getCurrentWindow())
		end
	end)
end

--- 更新视图
function T:updateView()
	local data=self.data
	if data then
		self.uiLVVal:setString(data.level)
		self.uiANameVal:setString(data.name)
		self.uiInviteVal:setString(data.inviterName)
		self.uiTimeVal:setString(GameUtils:lastLoginSec2String(data.inviteSec))
	end
end

function T:setData(value)
	if value ~= self.data then
		self.data=value

		self:updateView()
	end
end
function T:getData()
	return self.data
end

return T
