--- 联盟邀请视图
-- @author blank
local T = Class.AllianceInviteView(function() return ccui.Layout:create() end)

--- 联盟邀请项
T.AllianceInviteItem=require("src.app.uiScript.components.alliance.invite.AllianceInviteItem")

function T:def()

end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local left,top=16,10

	--标题"等级"
	local uiLVCap=XMLLabel(Language:get("ug800"))
	uiLVCap:setCssStyle(CssStyles.green20)
	uiLVCap:setContentSize(cc.size(70,36))
	uiLVCap:setAlign("center","middle")
	uiLVCap:setIsSingleLine(true)
	self:addChild(uiLVCap)
	REL:toOther("left","top",uiLVCap,self,left,top)
	self.uiLVCap=uiLVCap
	left=left+uiLVCap:getWidth()

	--标题"联盟名"
	local uiANameCap=XMLLabel(Language:get("ug801"))
	uiANameCap:setCssStyle(CssStyles.default20)
	uiANameCap:setContentSize(cc.size(144,36))
	uiANameCap:setAlign("center","middle")
	uiANameCap:setIsSingleLine(true)
	self:addChild(uiANameCap)
	REL:toOther("left","top",uiANameCap,self,left,top)
	self.uiANameCap=uiANameCap
	left=left+uiANameCap:getWidth()

	--标题"邀请人"
	local uiInviteCap=XMLLabel(Language:get("ug802"))
	uiInviteCap:setCssStyle(CssStyles.green20)
	uiInviteCap:setContentSize(cc.size(144,36))
	uiInviteCap:setAlign("center","middle")
	uiInviteCap:setIsSingleLine(true)
	self:addChild(uiInviteCap)
	REL:toOther("left","top",uiInviteCap,self,left,top)
	self.uiInviteCap=uiInviteCap
	left=left+uiInviteCap:getWidth()

	--标题"时间"
	local uiTimeCap=XMLLabel(Language:get("ug803"))
	uiTimeCap:setCssStyle(CssStyles.default20)
	uiTimeCap:setContentSize(cc.size(104,36))
	uiTimeCap:setAlign("center","middle")
	uiTimeCap:setIsSingleLine(true)
	self:addChild(uiTimeCap)
	REL:toOther("left","top",uiTimeCap,self,left,top)
	self.uiTimeCap=uiTimeCap
	left=left+uiTimeCap:getWidth()

	--	uiTimeCap:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiTimeCap:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiTimeCap:setBackGroundColorOpacity(100)

	--标题"操作"
	local uiOptCap=XMLLabel(Language:get("ug804"))
	uiOptCap:setCssStyle(CssStyles.green20)
	uiOptCap:setContentSize(cc.size(132,36))
	uiOptCap:setAlign("center","middle")
	uiOptCap:setIsSingleLine(true)
	self:addChild(uiOptCap)
	REL:toOther("left","top",uiOptCap,self,left,top)
	self.uiOptCap=uiOptCap

	--	uiOptCap:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiOptCap:setBackGroundColor(cc.c3b(random(1,255),0,0))
	--	uiOptCap:setBackGroundColorOpacity(100)

	top=top+uiLVCap:getHeight()+10

	-- 邀请项列表背景
	local uiInviteListBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("canvasBack.png"))
	self:addChild(uiInviteListBack)
	REL:relOther(uiInviteListBack,self,8,8,top,10)
	self.uiInviteListBack=uiInviteListBack

	--邀请项列表
	local uiInviteList=ccui.ListView:create()
	uiInviteList:setTouchEnabled(true)
	uiInviteList:setBounceEnabled(true)
	uiInviteList:setItemsMargin(10)
	self:addChild(uiInviteList)
	REL:relOther(uiInviteList,uiInviteListBack,4,4,8,8)
	self.uiInviteList=uiInviteList

	local aBox=UserInfo.allianceBox
	if not aBox.myAlliance or aBox.myAlliance.id == nil or aBox.myAlliance.id == 0 then
		require("src.app.communication.alliance.GetAllianceInviteListCommand")():exec(
			function(state)
				if state == ReturnCode.SUCCESS then
					self:updateInviteList()
				else
					MUIAlter_singleLine.show({
						info=ErrorCode:getErrInfo(state)
					},WindowManager:getCurrentWindow())
				end
			end
		)
	end
end

--- 显示没有申请的提示
function T:showNoInviteTip()
	local uiNoInviteTip=XMLLabel(Language:get("ug863"))
	uiNoInviteTip:setAlign("center","middle")
	uiNoInviteTip:setContentSize(cc.size(400,72))
	self:addChild(uiNoInviteTip)
	REL:toOther("center","middle",uiNoInviteTip,self.uiInviteList,0,0)
	self.uiNoInviteTip=uiNoInviteTip
end

--- 隐藏没有申请的提示
function T:hideNoInviteTip()
	if self.uiNoInviteTip then
		self.uiNoInviteTip:removeFromParent()
		self.uiNoInviteTip=nil
	end
end

--- 更新邀请列表
function T:updateInviteList()
	local uiList=self.uiInviteList
	uiList:removeAllItems()

	local changeCallback=function()
		self:updateInviteList()
	end

	local iList=UserInfo.allianceBox.receiveInviteList
	if iList and #iList > 0 then
		self:hideNoInviteTip()

		for _,v in pairs(iList) do
			local item=self.AllianceInviteItem(v,changeCallback)

			uiList:pushBackCustomItem(item)
		end
	else
		self:showNoInviteTip()
	end
end

return T
