--- 联盟信息查看画布
local T=Class.AllianceLookCvs(function() return ccui.Layout:create() end)

function T:def()

end

function T:ctor(data,changeCallback)
	self.data=data
	self.changeCallback=changeCallback

	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local data=self.data

	--如果有联盟不显示申请加入联盟的按钮
	local myAllianceId=UserInfo.allianceBox.myAlliance.id
	if not myAllianceId or myAllianceId == 0 then
		self:setContentSize(cc.size(522,518))
	else
		self:setContentSize(cc.size(522,448))
	end

	local left,top=10,10

	--"联盟名称"
	local uiName=XMLLabel(Language:get("ug720",data.name or ""))
	uiName:setContentSize(cc.size(280,48))
	uiName:setAlign("left","middle")
	self:addChild(uiName)
	REL:toOther("left","top",uiName,self,left,top)

	left=left+uiName:getWidth()+2

	--"联盟等级"
	local uiLv=XMLLabel(Language:get("ug721",data.level or 0))
	uiLv:setContentSize(cc.size(220,48))
	uiLv:setAlign("left","middle")
	self:addChild(uiLv)
	REL:toOther("left","top",uiLv,self,left,top)

	left,top=10,top+uiName:getHeight()+4

	--"联盟人数"
	local uiMemberCount=XMLLabel(Language:get("ug722",data.memberCount or 0,data.memberLimit or 0))
	uiMemberCount:setContentSize(cc.size(280,48))
	uiMemberCount:setAlign("left","middle")
	self:addChild(uiMemberCount)
	REL:toOther("left","top",uiMemberCount,self,left,top)

	left=left+uiMemberCount:getWidth()+2

	--"联盟排名"
	local uiRank=XMLLabel(Language:get("ug723",data.rank or 0))
	uiRank:setContentSize(cc.size(220,48))
	uiRank:setAlign("left","middle")
	self:addChild(uiRank)
	REL:toOther("left","top",uiRank,self,left,top)

	left,top=10,top+uiMemberCount:getHeight()+4

	--"联盟会长"
	local uiChairman=XMLLabel(Language:get("ug724",data.leaderName or ""))
	uiChairman:setContentSize(cc.size(480,48))
	uiChairman:setAlign("left","middle")
	self:addChild(uiChairman)
	REL:toOther("left","top",uiChairman,self,left,top)

	left,top=10,top+uiChairman:getHeight()+4

	--"联盟宣言"标题
	local uiDecCap=XMLLabel(Language:get("ug725"))
	uiDecCap:setContentSize(cc.size(280,48))
	uiDecCap:setAlign("left","middle")
	self:addChild(uiDecCap)
	REL:toOther("left","top",uiDecCap,self,left,top)

	left,top=10,top+uiDecCap:getHeight()+4

	--"联盟宣言"背景
	local uiDecBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("inputBoxBack.png"))
	self:addChild(uiDecBack)
	uiDecBack:setContentSize(cc.size(120,220))
	REL:relOther(uiDecBack,self,10,10,top,SIZE_NIL)

	--联盟宣言
	local uiDec=XMLTextArea()
	self:addChild(uiDec)
	REL:relOther(uiDec,uiDecBack,4,4,4,4)
	self.uiNotice=uiDec

	top=top+uiDecBack:getContentSize().height+10

	--接受邀请按钮
	local uiAcceptButton=BaseButton:createButton(Language:get("ug864"),"bigButton_green_normal.png")
	self:addChild(uiAcceptButton)
	REL:toOther("center","top",uiAcceptButton,self,-100,top)
	self.uiAcceptButton=uiAcceptButton
	uiAcceptButton:setIsGray(code == 2 and true or false)
	uiAcceptButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.AcceptAllianceInviteCommand")():exec(
				data.id,
				function(state)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug867"),
							showSecond=1.5
						})
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end
	end)

	--拒绝邀请按钮
	local uiRefuseButton=BaseButton:createButton(Language:get("ug865"),"bigButton_green_normal.png")
	self:addChild(uiRefuseButton)
	REL:toOther("center","top",uiRefuseButton,self,100,top)
	self.uiRefuseButton=uiRefuseButton
	uiRefuseButton:setIsGray(code == 2 and true or false)
	uiRefuseButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.RefuseAllianceInviteCommand")():exec(
				data.id,
				function(state)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug867"),
							showSecond=1.5
						})

						if self.changeCallback then
							self.changeCallback()
						end
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
					
					self.__hide__()
				end
			)
		end
	end)

	require("src.app.communication.alliance.GetAllianceMoreDetailCommand")():exec(
		data,
		function(state)
			if state == ReturnCode.SUCCESS then
				uiMemberCount:setString(Language:get("ug722",data.memberCount,data.memberLimit))
				uiRank:setString(data.rank)
				uiChairman:setString(Language:get("ug724",data.leaderName))
				uiDec:setString(data.dec)
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

return T
