--- 联盟列表信息项
local T=Class.AllianceListItem(function() return ccui.Layout:create() end)

--- 联盟信息查看画布
T.AllianceLookCvs=require("src.app.uiScript.components.alliance.list.AllianceLookCvs")

function T:def()
--- 数据
-- self.data=nil
end

function T:ctor(data)
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
	self:setData(data)
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	self:setContentSize(cc.size(600,72))

	--		self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--		self:setBackGroundColor(cc.c3b(0xff,0,0))
	--		self:setBackGroundColorOpacity(100)

	local left=2

	--标题"排名"
	local uiRankVal=XMLLabel()
	uiRankVal:setCssStyle(CssStyles.green20)
	uiRankVal:setContentSize(cc.size(72,36))
	uiRankVal:setAlign("center","middle")
	self:addChild(uiRankVal)
	REL:toOther("left","middle",uiRankVal,self,left,0)
	self.uiRankVal=uiRankVal
	left=left+uiRankVal:getWidth()

	--标题"联盟名"
	local uiANameVal=XMLLabel()
	uiANameVal:setCssStyle(CssStyles.default20)
	uiANameVal:setContentSize(cc.size(208,36))
	uiANameVal:setAlign("center","middle")
	self:addChild(uiANameVal)
	REL:toOther("left","middle",uiANameVal,self,left,0)
	self.uiANameVal=uiANameVal
	left=left+uiANameVal:getWidth()

	--标题"人数"
	local uiMemNumVal=XMLLabel()
	uiMemNumVal:setCssStyle(CssStyles.green20)
	uiMemNumVal:setContentSize(cc.size(74,36))
	uiMemNumVal:setAlign("center","middle")
	self:addChild(uiMemNumVal)
	REL:toOther("left","middle",uiMemNumVal,self,left,0)
	self.uiMemNumVal=uiMemNumVal
	left=left+uiMemNumVal:getWidth()

	--标题"战斗力"
	local uiFightVal=XMLLabel()
	uiFightVal:setCssStyle(CssStyles.default20)
	uiFightVal:setContentSize(cc.size(104,36))
	uiFightVal:setAlign("center","middle")
	self:addChild(uiFightVal)
	REL:toOther("left","middle",uiFightVal,self,left,0)
	self.uiFightVal=uiFightVal
	left=left+uiFightVal:getWidth()

	--"查看"按钮
	local uiLookButton=BaseButton:createButton(Language:get("ug704"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiLookButton)
	REL:toOther("left","middle",uiLookButton,self,left,-10)
	self.uiLookButton=uiLookButton
	uiLookButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			MUIAlter.show({
				info=self.AllianceLookCvs(self.data,function()self:updateView()end),
				title=Language:get("ug726"),
				flag=4
			},WindowManager:getCurrentWindow())
		end
	end)
end

--- 更新视图
function T:updateView()
	local data=self.data
	if data then
		self.uiRankVal:setString(data.rank)
		self.uiANameVal:setString(data.name)
		self.uiMemNumVal:setString(Language:get("ug785",data.memberCount,data.memberLimit))
		self.uiFightVal:setString(UnitConversion.unitTrans(data.fight))

		local aBox=UserInfo.allianceBox
		local mA=aBox.myAlliance
		if mA.id and mA.id > 0 then
			self.uiLookButton:setText(Language:get("ug704"))
		else
			local aList=aBox.appliedAllianceIdList
			if aList and aList[data.id] then
				self.uiLookButton:setText(Language:get("ug711"))
			else
				self.uiLookButton:setText(Language:get("ug704"))
			end
		end
	end
end

function T:setData(value)
	if value ~= self.data then
		self.data=value

		self:updateView()
	end
end
function T:getData()
	return self.data
end

return T
