--- 联盟列表视图
-- @author blank
local T = Class.AllianceListView(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 联盟信息列表项
T.AllianceListItem=require("src.app.uiScript.components.alliance.list.AllianceListItem")

--- 加载更多
T.LoadMoreItem=require("src.app.uiScript.components.alliance.list.LoadMoreItem")

--- 获取联盟排行榜
T.GetAllianceRankListCommand=require("src.app.communication.alliance.GetAllianceRankListCommand")

function T:def()
	AbstractUI.def(self)

	--- 正在加载更多数据
	self._isLoading=false

	--- 正在刷新数据项列表
	self._isUpdating=false
end

function T:ctor()
	AbstractUI.ctor(self)
end

function T:onExit()
	AbstractUI.onExit(self)
	
	UserInfo.allianceBox.allianceRankBox.rList=nil
end

--- 初始化
function T:init()
	local left,top=16,4

	-----联盟搜索>>----------------------------------------------------------------------
	local uiSearchCap=XMLLabel(Language:get("ug668"))
	uiSearchCap:setContentSize(cc.size(160,50))
	uiSearchCap:setAlign("center","middle")
	self:addChild(uiSearchCap)
	REL:toOther("left","top",uiSearchCap,self,left,top)
	self.uiSearchCap=uiSearchCap

	left=left+uiSearchCap:getWidth()

	local lLimit,uLimit=unpack(GameCfg.ALLIANCE_NAME_LIMIT)

	--"名称"输入框
	local uiNameInput=InputBox:create(cc.size(296,50))
	uiNameInput:setMaxLength(uLimit*3)
	self:addChild(uiNameInput)
	REL:toOther("left","top",uiNameInput,self,left,top)
	self.uiNameInput=uiNameInput

	--"搜索"按钮
	local uiSearchButton=BaseButton:createButton(Language:get("ug705"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiSearchButton)
	REL:toOther("left","middle",uiSearchButton,uiNameInput,uiNameInput:getContentSize().width+4,-10)
	-----<<联盟搜索----------------------------------------------------------------------

	left=18
	top=top+uiSearchCap:getHeight()+10

	--标题栏背景
	local uiCapBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("rankTip.png"))
	self:addChild(uiCapBack)
	REL:relOther(uiCapBack,self,left-4,left-4,top,SIZE_NIL)
	self.uiCapBack=uiCapBack

	--标题"排名"
	local uiRankCap=XMLLabel(Language:get("ug780"))
	uiRankCap:setCssStyle(CssStyles.green20)
	uiRankCap:setContentSize(cc.size(72,36))
	uiRankCap:setAlign("center","middle")
	self:addChild(uiRankCap)
	REL:toOther("left","top",uiRankCap,self,left,top)
	self.uiRankCap=uiRankCap
	left=left+uiRankCap:getWidth()

	--标题"联盟名"
	local uiANameCap=XMLLabel(Language:get("ug781"))
	uiANameCap:setCssStyle(CssStyles.default20)
	uiANameCap:setContentSize(cc.size(208,36))
	uiANameCap:setAlign("center","middle")
	self:addChild(uiANameCap)
	REL:toOther("left","top",uiANameCap,self,left,top)
	self.uiANameCap=uiANameCap
	left=left+uiANameCap:getWidth()

	--标题"人数"
	local uiMemNumCap=XMLLabel(Language:get("ug782"))
	uiMemNumCap:setCssStyle(CssStyles.green20)
	uiMemNumCap:setContentSize(cc.size(74,36))
	uiMemNumCap:setAlign("center","middle")
	self:addChild(uiMemNumCap)
	REL:toOther("left","top",uiMemNumCap,self,left,top)
	self.uiMemNumCap=uiMemNumCap
	left=left+uiMemNumCap:getWidth()

	--标题"战斗力"
	local uiFightCap=XMLLabel(Language:get("ug783"))
	uiFightCap:setCssStyle(CssStyles.default20)
	uiFightCap:setContentSize(cc.size(104,36))
	uiFightCap:setAlign("center","middle")
	self:addChild(uiFightCap)
	REL:toOther("left","top",uiFightCap,self,left,top)
	self.uiFightCap=uiFightCap
	left=left+uiFightCap:getWidth()

	--	uiFightCap:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiFightCap:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiFightCap:setBackGroundColorOpacity(100)

	--标题"查看"
	local uiLookCap=XMLLabel(Language:get("ug784"))
	uiLookCap:setCssStyle(CssStyles.green20)
	uiLookCap:setContentSize(cc.size(132,36))
	uiLookCap:setAlign("center","middle")
	self:addChild(uiLookCap)
	REL:toOther("left","top",uiLookCap,self,left,top)
	self.uiLookCap=uiLookCap

	--	uiLookCap:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiLookCap:setBackGroundColor(cc.c3b(random(1,255),0,0))
	--	uiLookCap:setBackGroundColorOpacity(100)

	top=top+uiRankCap:getHeight()+4

	-- 联盟列表背景
	local uiAlianceListBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("canvasBack.png"))
	self:addChild(uiAlianceListBack)
	REL:relOther(uiAlianceListBack,self,12,12,top,10)
	self.uiAlianceListBack=uiAlianceListBack

	--联盟列表
	local uiAllianceList=ccui.ListView:create()
	uiAllianceList:setTouchEnabled(true)
	uiAllianceList:setBounceEnabled(true)
	uiAllianceList:setItemsMargin(10)
	self:addChild(uiAllianceList)
	REL:relOther(uiAllianceList,uiAlianceListBack,4,4,8,8)
	self.uiAllianceList=uiAllianceList
	ccui.ScrollView.addEventListener(uiAllianceList,function (t,e)
		if t:getInnerContainer():getPositionY() >= 15 then
			if not self._isUpdating then
				self:loadMore()
			end
		end
	end)

	uiSearchButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:searchAlliance(uiNameInput:getText())
		end
	end)

	local rList=UserInfo.allianceBox.allianceRankBox.rList
	if not rList then
		require("src.app.communication.alliance.GetAllianceRankListCommand")():exec(
			1,
			true,
			function(state,startIndex)
				if state == ReturnCode.SUCCESS then
					self:updateList(startIndex)
				else
					MUIAlter_singleLine.show({
						info=ErrorCode:getErrInfo(state)
					},WindowManager:getCurrentWindow())
				end
			end
		)
	else
		self:updateList(1)
	end
end

--- 创建"取消搜索"按钮
function T:createCancelSearchButton()
	--"取消搜索"按钮
	local uiCancelSearchButton=BaseButton:createButton(nil,"worldCollectionDel.png")
	self:addChild(uiCancelSearchButton)
	REL:toOther("right","middle",uiCancelSearchButton,self.uiNameInput,4,0)
	self.uiCancelSearchButton=uiCancelSearchButton
	uiCancelSearchButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:switch2normalState()
		end
	end)
end

--- 搜索联盟
function T:searchAlliance(allianceName)
	--联盟名为空
	if not allianceName or string.trim(allianceName) == "" then
		MUIAlter.show({
			info=Language:get("ug706")
		},WindowManager:getCurrentWindow())
		return
	end

	require("src.app.communication.alliance.SearchAllianceCommand")():exec(allianceName,
		function(state,isSearched,allianceInfo)
			if state == ReturnCode.SUCCESS then
				self:stopAllActions()

				if isSearched then
					self:switch2searchedState(allianceInfo)
				else
					MUIAlter.show({
						info=Language:get("ug789")
					},WindowManager:getCurrentWindow())
				end
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

--- 切换到搜索到联盟状态
function T:switch2searchedState(allianceInfo)
	if not self.uiCancelSearchButton then
		self:createCancelSearchButton()
	else
		self.uiCancelSearchButton:setVisible(true)
	end

	if self.loadMoreItem then
		self.loadMoreItem=nil
	end
	local uiList=self.uiAllianceList
	uiList:removeAllItems()
	uiList:pushBackCustomItem(self.AllianceListItem(allianceInfo))
end

--- 切换到正常显示状态
function T:switch2normalState()
	if self.uiCancelSearchButton then
		self.uiCancelSearchButton:setVisible(false)
	end

	local uiList=self.uiAllianceList
	uiList:removeAllItems()
	self:updateList(1)
end

--- 更新排行榜列表
function T:updateList(startIndex)
	local rBox=UserInfo.allianceBox.allianceRankBox
	local uiList=self.uiAllianceList

	if not rBox.rList then
		uiList:removeAllItems()
	end

	local rList=rBox.rList

	local i,len=startIndex,#rList

	local itemAddEff=function(item)
		item:setOpacity(0)
		item:runAction(
			cc.FadeIn:create(0.5)
		)
	end

	--"加载更多"提示项在列表中的位置
	local moreItemIdx=nil
	local lItem=self.loadMoreItem
	if lItem then
		moreItemIdx=uiList:getIndex(lItem)
	end

	print("开始刷新列表")
	self._isUpdating=true
	self.pushListItemAct=self:interval(function()
		if i <= len then
			--添加数据项
			local vItem=self.AllianceListItem(rList[i])

			if moreItemIdx then
				uiList:insertCustomItem(vItem,moreItemIdx)
				moreItemIdx=moreItemIdx+1
			else
				uiList:pushBackCustomItem(vItem)
			end
			itemAddEff(vItem)
		elseif i == len + 1 then
			if rBox.isReadEnd then
				--已到列表末尾,移除"加载更多"提示
				if lItem then
					uiList:removeItem(uiList:getIndex(lItem))
				end
			elseif not lItem then
				--未到列表末尾,且无"加载更多"提示,创建一个"加载更多"提示到末尾
				lItem=self.LoadMoreItem()
				self.loadMoreItem=lItem
				lItem:setTouchEnabled(true)
				lItem:addTouchEventListener(function(t,e)
					if e == ccui.TouchEventType.ended then
						self:loadMore()
					end
				end)

				uiList:pushBackCustomItem(lItem)
			end
		else
			print("刷新列表完成")
			self._isUpdating=false

			self:clearScheduler(self.pushListItemAct)
		end

		i=i+1
	end,0.1)

	--	for i=startIndex,#rList,1 do
	--		local vItem=self.AllianceListItem(rList[i])
	--
	--		uiList:pushBackCustomItem(vItem)
	--	end
	--
	--	if not rBox.isReadEnd then
	--		uiList:pushBackCustomItem(lItem)
	--		lItem:release()
	--	end
end

--- 扩展排行榜列表(触发"点击加载更多")
function T:loadMore()
	if self._isLoading then
		return
	end

	local rBox=UserInfo.allianceBox.allianceRankBox
	if rBox.isReadEnd then
		return
	end

	print("开始加载更多数据")
	self._isLoading=true
	local rList=rBox.rList
	self.GetAllianceRankListCommand():exec(
		rList and #rList+1 or 1,
		true,
		function(state,startIndex)
			print("加载更多数据完成")
			self._isLoading=false

			if state == ReturnCode.SUCCESS then
				self:updateList(startIndex)
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

return T
