--- 联盟成员视图
local T=Class.AllianceMemberView(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 成员列表
T.MemberList=require("src.app.uiScript.components.alliance.member.MemberList")

--- 贡献列表
T.ContributionList=require("src.app.uiScript.components.alliance.member.ContributionList")

--- 申请列表
T.ApplyList=require("src.app.uiScript.components.alliance.member.ApplyList")

function T:def()
	AbstractUI.def(self)
end

function T:ctor()
	AbstractUI.ctor(self)
end

--- 内存清理
function T:cleanUp()
	AbstractUI.cleanUp(self)

	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.updateView)
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_CHANGE_MEMBER_LIST,self,self.updateMemberListCount)
end

--- 初始化
function T:init()
	--自己所在联盟信息
	local aInfo=UserInfo.allianceBox.myAlliance

	local function memberListTouchHandler()
		print("切换到当前成员列表页面")

		self:switch2MembverListView()
	end

	local function contributionListTouchHandler()
		print("切换到成员贡献列表页面")

		self:switchContributionListView()
	end


	local function applyListTouchHandler()
		print("切换到申请列表页面")

		self:switch2ApplyListView()
	end

	--按钮纹理
	local buttonTextures={"panelSwitchButton_down.png","panelSwitchButton_normal.png"}

	-- 二级菜单
	local uiSwitchButtons = SwitchButtonContainer.new(0)
	self:addChild(uiSwitchButtons)
	REL:relOther(uiSwitchButtons,self,0,0,6,0)
	uiSwitchButtons:init()

	--会长和副会长才有处理申请信息的权利
	uiSwitchButtons:initButtons(
		3,
		{buttonTextures,buttonTextures,buttonTextures},
		nil,
		{memberListTouchHandler,contributionListTouchHandler,applyListTouchHandler},
		{Language:get("ug620"),Language:get("uc789"),Language:get("ug621")}
	)
	self.uiSwitchButtons = uiSwitchButtons
	uiSwitchButtons.viewBack:setVisible(false)

	-- 联盟成员数
	local uiMemberCount=XMLLabel()
	uiMemberCount:setAlign("center","middle")
	uiMemberCount:setContentSize(cc.size(140,64))
	self:addChild(uiMemberCount)
	REL:toOther("right","top",uiMemberCount,self,0,6)
	self.uiMemberCount=uiMemberCount

	--默认切换到"联盟简介"页面
	memberListTouchHandler()

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.updateView)
	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_CHANGE_MEMBER_LIST,self,self.updateMemberListCount)
	self:updateView()
end

--- 刷新视图
function T:updateView()
	--自己所在联盟信息
	local aInfo=UserInfo.allianceBox.myAlliance

	self:updateMemberListCount()

	local applyButton=self.uiSwitchButtons:getButton(3)
	if applyButton then
		if aInfo.post == AlliancePost.LEADER or aInfo.post == AlliancePost.VICE_CHAIRMAN then
			applyButton:setVisible(true)
		else
			applyButton:setVisible(false)
		end
	end
end

--- 更新联盟成功数
function T:updateMemberListCount()
	--自己所在联盟信息
	local aInfo=UserInfo.allianceBox.myAlliance

	self.uiMemberCount:setString(Language:get("ug623",aInfo.memberCount,aInfo.memberLimit))
end

--- 切换到当前成员列表页面
function T:switch2MembverListView()
	local curView=self.curView
	if not curView or curView ~= self.uiMemberListView then
		if curView then
			curView:setVisible(false)
		end

		if not self.uiMemberListView then
			curView=self.MemberList()
			self:addChild(curView)
			REL:relOther(curView,self.uiSwitchButtons.viewBack,0,0,0,0)
			curView:init()
			self.uiMemberListView=curView
		end

		self.curView=self.uiMemberListView
		self.curView:setVisible(true)
	end
end

--- 切换到贡献列表列表页面
function T:switchContributionListView()
	local curView=self.curView
	if not curView or curView ~= self.uiContributionListView then
		if curView then
			curView:setVisible(false)
		end

		if not self.uiContributionListView then
			curView=self.ContributionList()
			self:addChild(curView)
			REL:relOther(curView,self.uiSwitchButtons.viewBack,0,0,0,0)
			curView:init()
			self.uiContributionListView=curView
		end

		self.curView=self.uiContributionListView
		self.curView:setVisible(true)
	end
end

--- 切换到申请加入列表页面
function T:switch2ApplyListView()
	local curView=self.curView
	if not curView or curView ~= self.uiApplyListView then
		if curView then
			curView:setVisible(false)
		end

		if not self.uiApplyListView then
			curView=self.ApplyList()
			self:addChild(curView)
			REL:relOther(curView,self.uiSwitchButtons.viewBack,0,0,0,0)
			curView:init()
			self.uiApplyListView=curView
		end

		self.curView=self.uiApplyListView
		self.curView:setVisible(true)
	end
end

return T
