local T=Class.ApplyItem(function() return ccui.Layout:create() end)

function T:def()

end

function T:ctor(data,changeCallback)
	self.data=data
	self.changeCallback=changeCallback

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local data=self.data or {}

	self:setContentSize(cc.size(620,64))

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	local left,middle=4,0

	--"用户名"
	local uiUNameVal=XMLLabel(data.name or "")
	uiUNameVal:setCssStyle(CssStyles.green20)
	uiUNameVal:setContentSize(cc.size(168,36))
	uiUNameVal:setAlign("center","middle")
	self:addChild(uiUNameVal)
	REL:toOther("left","middle",uiUNameVal,self,left,middle)
	self.uiUNameVal=uiUNameVal
	left=left+uiUNameVal:getWidth()

	--"等级"
	local uiLVVal=XMLLabel(data.level or 0)
	uiLVVal:setCssStyle(CssStyles.default20)
	uiLVVal:setContentSize(cc.size(60,36))
	uiLVVal:setAlign("center","middle")
	self:addChild(uiLVVal)
	REL:toOther("left","middle",uiLVVal,self,left,middle)
	self.uiLVVal=uiLVVal
	left=left+uiLVVal:getWidth()

	--"战斗力"
	local uiFightVal=XMLLabel(data.fight or 0)
	uiFightVal:setCssStyle(CssStyles.green20)
	uiFightVal:setContentSize(cc.size(104,36))
	uiFightVal:setAlign("center","middle")
	self:addChild(uiFightVal)
	REL:toOther("left","middle",uiFightVal,self,left,middle)
	self.uiFightVal=uiFightVal
	left=left+uiFightVal:getWidth()

	--"同意"按钮
	local uiAcceptButton=BaseButton:createButton(Language:get("ug821"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiAcceptButton)
	REL:toOther("left","middle",uiAcceptButton,self,left,middle-10)
	self.uiAcceptButton=uiAcceptButton
	uiAcceptButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.AcceptApplyCommand")():exec(
				data.id,
				function(state)
					--是否从申请列表中移除
					local isDel=true
				
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug825"),
							showSecond=1.5
						})
						
						UserInfo.allianceBox.myAlliance.memberList=nil
					else
						if state == 25 then
							isDel=false
						end
					
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end

					if self.changeCallback then
						self.changeCallback(self,isDel)
					end
				end
			)
		end
	end)
	left=left+uiAcceptButton:getContentSize().width

	--"同意"按钮
	local uiRefusetButton=BaseButton:createButton(Language:get("ug822"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiRefusetButton)
	REL:toOther("left","middle",uiRefusetButton,self,left,middle-10)
	self.uiRefusetButton=uiRefusetButton
	uiRefusetButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.RefuseApplyCommand")():exec(
				data.id,
				function(state)
					if state == ReturnCode.SUCCESS then
						if self.changeCallback then
							self.changeCallback(self,true)
						end

						MUIAlter_singleLine.show({
							info=Language:get("ug825"),
							showSecond=1.5
						})
					else
						MUIAlter.show({
							info=Language:get("ug824")
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end
	end)

end

return T
