local T=Class.ApplyList(function() return ccui.Layout:create() end)

--- 申请项
T.ApplyItem=require("src.app.uiScript.components.alliance.member.ApplyItem")

function T:def()

end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_APPLY_LIST_CHANGE,self,self.getApplyList)
end

--- 初始化
function T:init()
	local left,top=16,0

	--标题"用户名"
	local uiUNameCap=XMLLabel(Language:get("ug661"))
	uiUNameCap:setCssStyle(CssStyles.green20)
	uiUNameCap:setContentSize(cc.size(168,36))
	uiUNameCap:setAlign("center","middle")
	self:addChild(uiUNameCap)
	REL:toOther("left","top",uiUNameCap,self,left,top)
	self.uiUNameCap=uiUNameCap
	left=left+uiUNameCap:getWidth()

	--标题"等级"
	local uiLVCap=XMLLabel(Language:get("ug663"))
	uiLVCap:setCssStyle(CssStyles.default20)
	uiLVCap:setContentSize(cc.size(60,36))
	uiLVCap:setAlign("center","middle")
	self:addChild(uiLVCap)
	REL:toOther("left","top",uiLVCap,self,left,top)
	self.uiLVCap=uiLVCap
	left=left+uiLVCap:getWidth()

	--标题"战斗力"
	local uiFightCap=XMLLabel(Language:get("ug664"))
	uiFightCap:setCssStyle(CssStyles.green20)
	uiFightCap:setContentSize(cc.size(104,36))
	uiFightCap:setAlign("center","middle")
	self:addChild(uiFightCap)
	REL:toOther("left","top",uiFightCap,self,left,top)
	self.uiFightCap=uiFightCap
	left=left+uiFightCap:getWidth()

	--"全部拒绝"按钮
	local uiAllRefuseButton=BaseButton:createButton(Language:get("ug820"),"button_blue_normal.png","button_blue_normal.png")
	self:addChild(uiAllRefuseButton)
	REL:toOther("left","top",uiAllRefuseButton,self,left+uiAllRefuseButton:getContentSize().width/2,-18)
	self.uiAllRefuseButton=uiAllRefuseButton

	uiAllRefuseButton:setIsGray(true)
	uiAllRefuseButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			local pList=UserInfo.allianceBox.myAlliance.applyList

			if pList and #pList > 0 then
				require("src.app.communication.alliance.RefuseAllApplyCommand")():exec(function(state)
					if state == ReturnCode.SUCCESS then
						self:updateApplyList()
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end)
			else
				MUIAlter.show({
					info=Language:get("ug823")
				},WindowManager:getCurrentWindow())
			end
		end
	end)

	top=top+uiAllRefuseButton:getContentSize().height+10-46

	-- 联盟列表背景
	local uiApplyListBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("canvasBack.png"))
	self:addChild(uiApplyListBack)
	REL:relOther(uiApplyListBack,self,8,8,top,10)
	self.uiAlianceListBack=uiApplyListBack

	--联盟列表
	local uiApplyList=ccui.ListView:create()
	uiApplyList:setTouchEnabled(true)
	uiApplyList:setBounceEnabled(true)
	uiApplyList:setItemsMargin(10)
	self:addChild(uiApplyList)
	REL:relOther(uiApplyList,uiApplyListBack,4,4,8,8)
	self.uiApplyList=uiApplyList

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_APPLY_LIST_CHANGE,self,self.getApplyList)
	self:getApplyList()
end

--- 获取申请列表
function T:getApplyList()
	--- 获取申请列表
	require("src.app.communication.alliance.GetApplyListCommand")():exec(function(state)
		if state == ReturnCode.SUCCESS then
			self:updateApplyList()
		else
			MUIAlter_singleLine.show({
				info=ErrorCode:getErrInfo(state)
			},WindowManager:getCurrentWindow())
		end
	end)
end

--- 显示没有申请的提示
function T:showNoApplyTip()
	local uiNoApplyTip=XMLLabel(Language:get("ug823"))
	uiNoApplyTip:setAlign("center","middle")
	uiNoApplyTip:setContentSize(cc.size(400,72))
	self:addChild(uiNoApplyTip)
	REL:toOther("center","middle",uiNoApplyTip,self.uiApplyList,0,0)
	self.uiNoApplyTip=uiNoApplyTip
end

--- 隐藏没有申请的提示
function T:hideNoApplyTip()
	if self.uiNoApplyTip then
		self.uiNoApplyTip:removeFromParent()
		self.uiNoApplyTip=nil
	end
end

--- 刷新申请列表
function T:updateApplyList()
	local pList=UserInfo.allianceBox.myAlliance.applyList

	local itemChangeCallback=function(item,isDelete)
		if isDelete then
			self:removeItemForList(item)
		end
	end

	local uiApplyList=self.uiApplyList
	uiApplyList:removeAllItems()
	if pList and #pList > 0 then
		self.uiAllRefuseButton:setIsGray(false)
		self:hideNoApplyTip()

		for _,v in ipairs(pList) do
			local item=self.ApplyItem(v,itemChangeCallback)

			uiApplyList:pushBackCustomItem(item)
		end
	else
		self.uiAllRefuseButton:setIsGray(true)
		self:showNoApplyTip()
	end
end

--- 从列表中移除列表项
function T:removeItemForList(item)
	local uiApplyList=self.uiApplyList
	if uiApplyList then
		local idx=uiApplyList:getIndex(item)
		uiApplyList:removeItem(idx)

		if #uiApplyList:getItems() then
			self:updateApplyList()
		end
	end
end

return T
