local T=Class.MemberItem(function() return ccui.Layout:create() end)

function T:def()
--- 数据
-- self.data=nil
end

function T:ctor(data,changeCallback)
	self.data=data
	self.changeCallback=changeCallback

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(607,80))

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	local left,middle=0,0

	--"职务"
	local uiPostVal=XMLLabel()
	uiPostVal:setCssStyle(CssStyles.green20)
	uiPostVal:setContentSize(cc.size(72,36))
	uiPostVal:setAlign("center","middle")
	self:addChild(uiPostVal)
	REL:toOther("left","middle",uiPostVal,self,left,middle)
	self.uiPostVal=uiPostVal
	left=left+uiPostVal:getWidth()

	--"用户名"
	local uiUNameVal=XMLLabel()
	uiUNameVal:setCssStyle(CssStyles.default20)
	uiUNameVal:setContentSize(cc.size(168,36))
	uiUNameVal:setAlign("center","middle")
	self:addChild(uiUNameVal)
	REL:toOther("left","middle",uiUNameVal,self,left,middle)
	self.uiUNameVal=uiUNameVal
	left=left+uiUNameVal:getWidth()

	--"等级"
	local uiLVVal=XMLLabel()
	uiLVVal:setCssStyle(CssStyles.green20)
	uiLVVal:setContentSize(cc.size(52,36))
	uiLVVal:setAlign("center","middle")
	self:addChild(uiLVVal)
	REL:toOther("left","middle",uiLVVal,self,left,middle)
	self.uiLVVal=uiLVVal
	left=left+uiLVVal:getWidth()

	--"战斗力"
	local uiFightVal=XMLLabel()
	uiFightVal:setCssStyle(CssStyles.default20)
	uiFightVal:setContentSize(cc.size(104,36))
	uiFightVal:setAlign("center","middle")
	self:addChild(uiFightVal)
	REL:toOther("left","middle",uiFightVal,self,left,middle)
	self.uiFightVal=uiFightVal
	left=left+uiFightVal:getWidth()

	--"贡献点"
	local uiLastLoginVal=XMLLabel()
	uiLastLoginVal:setCssStyle(CssStyles.green20)
	uiLastLoginVal:setContentSize(cc.size(128,36))
	uiLastLoginVal:setAlign("center","middle")
	self:addChild(uiLastLoginVal)
	REL:toOther("left","middle",uiLastLoginVal,self,left,middle)
	self.uiLastLoginVal=uiLastLoginVal
	left=left+uiLastLoginVal:getWidth()

	--操作按钮
	local uiOptButton=BaseButton:createButton(nil,"infoButton_normal.png")
	self:addChild(uiOptButton)
	REL:toOther("left","middle",uiOptButton,self,left,middle)

	uiOptButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then

			local optCvs=require("src.app.uiScript.components.alliance.member.MemberOptCvs")(self.data,function()
				self:updateView()
				if self.changeCallback then
					self.changeCallback()
				end
			end)

			MUIAlter.show({
				info=optCvs,
				title=Language:get("ug682"),
				flag=4,
				callback=function()

				end
			},WindowManager:getCurrentWindow())
		end
	end)

	self:updateView()
end

--- 更新视图
function T:updateView()
	local data=self.data
	if data then
		local post=data.post
		if post == AlliancePost.VICE_CHAIRMAN then
			self.uiPostVal:setString(Language:get("ug673"))
		elseif post == AlliancePost.LEADER then
			self.uiPostVal:setString(Language:get("ug672"))
		else
			self.uiPostVal:setString(Language:get("ug674"))
		end

		self.uiUNameVal:setString(data.name)
		self.uiLVVal:setString(data.level)
		self.uiFightVal:setString(UnitConversion.unitTrans(data.fight))
		self.uiLastLoginVal:setString(data.weekContribution)
	end
end

function T:setData(value)
	if value ~= self.data then
		self.data=value

		self:updateView()
	end
end

function T:getData()
	return self.data
end

return T
