local T=Class.MemberList(
	function()
		local o=ccui.Layout:create()
		o._setVisible=o.setVisible

		return o
	end
)

--- 成员列表项
T.MemberItem=require("src.app.uiScript.components.alliance.member.MemberItem")

function T:def()
	--- 离开此页面的时间
	self._leaveTimeMs=TimeUtils:getSyncMillis()
end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

--- 进入场景
function T:onEnter()

end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.getMList)
end

--- 初始化
function T:init()
	--自己所在联盟信息
	local aInfo=UserInfo.allianceBox.myAlliance

	local left,top=12,0

	--标题"职务"
	local uiPostCap=XMLLabel(Language:get("ug662"))
	uiPostCap:setCssStyle(CssStyles.green20)
	uiPostCap:setContentSize(cc.size(72,36))
	uiPostCap:setAlign("center","middle")
	self:addChild(uiPostCap)
	REL:toOther("left","top",uiPostCap,self,left,top)
	self.uiPostCap=uiPostCap
	left=left+uiPostCap:getWidth()

	--标题"用户名"
	local uiUNameCap=XMLLabel(Language:get("ug661"))
	uiUNameCap:setCssStyle(CssStyles.default20)
	uiUNameCap:setContentSize(cc.size(168,36))
	uiUNameCap:setAlign("center","middle")
	self:addChild(uiUNameCap)
	REL:toOther("left","top",uiUNameCap,self,left,top)
	self.uiUNameCap=uiUNameCap
	left=left+uiUNameCap:getWidth()

	--标题"等级"
	local uiLVCap=XMLLabel(Language:get("ug663"))
	uiLVCap:setCssStyle(CssStyles.green20)
	uiLVCap:setContentSize(cc.size(52,36))
	uiLVCap:setAlign("center","middle")
	self:addChild(uiLVCap)
	REL:toOther("left","top",uiLVCap,self,left,top)
	self.uiLVCap=uiLVCap
	left=left+uiLVCap:getWidth()

	--标题"战斗力"
	local uiFightCap=XMLLabel(Language:get("ug664"))
	uiFightCap:setCssStyle(CssStyles.default20)
	uiFightCap:setContentSize(cc.size(104,36))
	uiFightCap:setAlign("center","middle")
	self:addChild(uiFightCap)
	REL:toOther("left","top",uiFightCap,self,left,top)
	self.uiFightCap=uiFightCap
	left=left+uiFightCap:getWidth()

	--标题"上次登陆时间"
	local uiLastLoginCap=XMLLabel(Language:get("ug660"))
	uiLastLoginCap:setCssStyle(CssStyles.green20)
	uiLastLoginCap:setContentSize(cc.size(128,36))
	uiLastLoginCap:setAlign("center","middle")
	self:addChild(uiLastLoginCap)
	REL:toOther("left","top",uiLastLoginCap,self,left,top)
	self.uiRankCap=uiLastLoginCap
	left=left+uiLastLoginCap:getWidth()

	--标题"操作"
	local uiOptCap=XMLLabel(Language:get("ug665"))
	uiOptCap:setCssStyle(CssStyles.default20)
	uiOptCap:setContentSize(cc.size(84,36))
	uiOptCap:setAlign("center","middle")
	self:addChild(uiOptCap)
	REL:toOther("left","top",uiOptCap,self,left,top)
	self.uiOptCap=uiOptCap
	--	left=left+uiOptCap:getWidth()

	top=top+uiPostCap:getHeight()+10

	-- 联盟列表背景
	local uiMBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("canvasBack.png"))
	self:addChild(uiMBack)
	REL:relOther(uiMBack,self,8,8,top,10)
	self.uiMBack=uiMBack

	--成员列表
	local uiMList=ccui.ListView:create()
	uiMList:setTouchEnabled(true)
	uiMList:setBounceEnabled(true)
	uiMList:setItemsMargin(10)
	self:addChild(uiMList)
	REL:relOther(uiMList,uiMBack,4,4,8,8)
	self.uiMList=uiMList

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.getMList)
	self:checkAndUpdate(true)
end

--获取联盟成员信息
function T:getMList()
	self._lastUpdateTimeMs=TimeUtils:getSyncMillis()

	require("src.app.communication.alliance.GetAlliacneMemberListCommand")():exec(
		function(state,updated)
			if state == ReturnCode.SUCCESS then
				if updated then
					self:updateMList()
				end
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

--- 刷新联盟成员列表
function T:updateMList()
	local itemAddEff=function(item)
		item:setOpacity(0)
		item:runAction(
			cc.FadeIn:create(0.5)
		)
	end

	--自己所在联盟信息
	local mList=mapping({},UserInfo.allianceBox.myAlliance.memberList)
	
	--排序
	table.sort(mList,function(a,b)
		--职位
		local dp=a.post-b.post
		if dp > 0 then
			return false
		elseif dp < 0 then
			return true
		end
	
		--战力
		local df=a.fight - b.fight
		if df > 0 then
			return true
		elseif df < 0 then
			return false
		end
		
		--等级
		local dl=a.level - b.level
		if dl > 0 then
			return true
		elseif dl < 0 then
			return false
		end
		
		--登陆时间
		local dt=a.lastLoginSec - b.lastLoginSec
		if dt > 0 then
			return true
		end
	
		return false
	end)

	local uiMList=self.uiMList
	uiMList:removeAllItems()
	
	self:stopAllActions()

	local i,len=1,#mList
	self:runAction(
		cc.RepeatForever:create(cc.Sequence:create(
			cc.DelayTime:create(0.1),
			cc.CallFunc:create( function()
				if i <= len then
					local item=self.MemberItem(mList[i],function()
						self:updateMList()
					end)
					uiMList:pushBackCustomItem(item)
					itemAddEff(item)
				else
					self:stopAllActions()
				end
				i=i+1
			end)
		))
	)
end

--- 检查被更新
-- @param isForceUpdate 是否强制刷新
function T:checkAndUpdate(isForceUpdate)
	--自己所在联盟信息
	local aInfo=UserInfo.allianceBox.myAlliance

	if
		not aInfo.memberList
		or
		TimeUtils:getSyncMillis() - aInfo.memberListLastUpdataTimeMs >= aInfo.MEMBER_LIST_UPDATE_INTERVAL_MS
	then
		self:getMList()
	elseif self._leaveTimeMs <= aInfo.memberListLastUpdataTimeMs or isForceUpdate then
		self:updateMList()
	end
end

function T:setVisible(value)
	if value == self:isVisible() then
		return
	end

	if value then
		self:checkAndUpdate()
	else
		self._leaveTimeMs=TimeUtils:getSyncMillis()
	end
	self:_setVisible(value)
end

return T
