--- 成员操作画布
local T=Class.MemberOptCvs(function() return ccui.Layout:create() end)

function T:def()
--- 数据
-- self.data=nil
end

function T:ctor(data,changeCallback)
	self.data=data
	self.changeCallback=changeCallback

	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local data=self.data
	--自己所在联盟信息
	local aInfo=UserInfo.allianceBox.myAlliance

	self:setContentSize(cc.size(580,360))

	local left,top=10,10

	--成员名称
	local uiName=XMLLabel(Language:get("ug679",data.name))
	uiName:setContentSize(cc.size(400,36))
	uiName:setAlign("left","middle")
	self:addChild(uiName)
	REL:toOther("left","top",uiName,self,left,top)
	self.uiName=uiName
	top=top+uiName:getHeight()+10

	--贡献度
	local uiContribution=XMLLabel(Language:get("ug680",data.contribution))
	uiContribution:setContentSize(cc.size(400,36))
	uiContribution:setAlign("left","middle")
	self:addChild(uiContribution)
	REL:toOther("left","top",uiContribution,self,left,top)
	self.uiContribution=uiContribution
	top=top+uiContribution:getHeight()+10

	--标题"设置职位"
	local uiSetPostCap=XMLLabel(Language:get("ug681"))
	uiSetPostCap:setContentSize(cc.size(240,36))
	uiSetPostCap:setAlign("left","middle")
	self:addChild(uiSetPostCap)
	REL:toOther("left","top",uiSetPostCap,self,left,top)
	self.uiSetPostCap=uiSetPostCap
	top=top+uiSetPostCap:getHeight()+10

	-----设置职位>>----------------------------------------------------------------------

	--会长
	local uiLeader=BaseButton:createButton(Language:get("ug672"),"longButton_blue_normal.png","longButton_general_down.png")
	self:addChild(uiLeader)
	REL:toOther("center","top",uiLeader,self,-190,top)
	self.uiLeader=uiLeader
	uiLeader:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.SetChairmanCommand")():exec(
				data.id,
				data.name,
				function(state)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug683",data.name),
							showSecond=1.5
						})

						self.__hide__()
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end
	end)

	--副会长
	local uiViceLeader=BaseButton:createButton(Language:get("ug673"),"longButton_blue_normal.png","longButton_general_down.png")
	self:addChild(uiViceLeader)
	REL:toOther("center","top",uiViceLeader,self,0,top)
	self.uiViceLeader=uiViceLeader
	uiViceLeader:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.SetViceChairmanCommand")():exec(
				data.id,
				true,
				function(state)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug684",data.name),
							showSecond=1.5
						})

						self.__hide__()
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end
	end)

	--成员
	local uiMember=BaseButton:createButton(Language:get("ug674"),"longButton_blue_normal.png","longButton_general_down.png")
	self:addChild(uiMember)
	REL:toOther("center","top",uiMember,self,190,top)
	self.uiMember=uiMember
	uiMember:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			require("src.app.communication.alliance.SetViceChairmanCommand")():exec(
				data.id,
				false,
				function(state)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug685",data.name),
							showSecond=1.5
						})

						self.__hide__()
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end
	end)

	-----<<设置职位----------------------------------------------------------------------

	top=top+uiLeader:getContentSize().height+10

	--"发送邮件"按钮
	local uiSendMail=BaseButton:createButton(Language:get("ug675"),"longButton_blue_normal.png","longButton_general_down.png")
	self:addChild(uiSendMail)
	REL:toOther("center","top",uiSendMail,self,-190,top)
	self.uiSendMail=uiSendMail
	uiSendMail:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			WindowManager:push(
				require("src.app.uiScript.components.mail.SendMailWindow").new(3,data.name)
			)
		end
	end)

	--"私聊"按钮
	local uiPriChat=BaseButton:createButton(Language:get("ug676"),"longButton_blue_normal.png","longButton_general_down.png")
	self:addChild(uiPriChat)
	REL:toOther("center","top",uiPriChat,self,0,top)
	self.uiPriChat=uiPriChat
	uiPriChat:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			local chatWindow = require("src.app.uiScript.components.chat.ChatWindow").new(3)
			chatWindow:setPrivateText(data.name)
			WindowManager:push(chatWindow)

		end
	end)

	--"移除联盟/退出联盟"按钮
	local uiQuit=BaseButton:createButton(Language:get("ug677"),"longButton_blue_normal.png","longButton_general_down.png")
	self:addChild(uiQuit)
	REL:toOther("center","top",uiQuit,self,190,top)
	self.uiQuit=uiQuit
	uiQuit:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:optButtonHandler()
		end
	end)

	self:updateView()
end

--操作"按钮被点击
function T:optButtonHandler()
	local data=self.data

	if data.id == UserInfo.id then
		local mA=UserInfo.allianceBox.myAlliance

		if mA.post ==  AlliancePost.LEADER then
			MUIAlter.show({
				info=require("src.app.uiScript.components.alliance.other.DismissConfirmCvs")(),
				flag=4
			},WindowManager:getCurrentWindow())
		else
			MUIAlter.show({
				info=require("src.app.uiScript.components.alliance.other.ExitConfirmCvs")(),
				flag=4
			},WindowManager:getCurrentWindow())
		end
	else
		require("src.app.communication.alliance.KickOutMemberCommand")():exec(
			data.id,
			function(state)
				if state == ReturnCode.SUCCESS then
					MUIAlter_singleLine.show({
						info=Language:get("ug687",data.name),
						showSecond=1.5
					})

					if self.changeCallback then
						self.changeCallback()
					end

					self.__hide__()
				else
					MUIAlter_singleLine.show({
						info=ErrorCode:getErrInfo(state)
					},WindowManager:getCurrentWindow())
				end
			end
		)
	end
end

--- 刷新视图
function T:updateView()
	local data=self.data
	--自己所在联盟信息
	local aInfo=UserInfo.allianceBox.myAlliance

	if data.id == UserInfo.id then
		self:setButtonState(self.uiLeader,false)
		self:setButtonState(self.uiViceLeader,false)
		self:setButtonState(self.uiMember,false)

		self:setButtonState(self.uiSendMail,false)
		self:setButtonState(self.uiPriChat,false)

		self:setButtonState(self.uiQuit,true)

		local mA=UserInfo.allianceBox.myAlliance
		if mA.post ==  AlliancePost.LEADER then
			self.uiQuit:setText(Language:get("ug691"))
		else
			self.uiQuit:setText(Language:get("ug678"))
		end
	else
		self.uiQuit:setText(Language:get("ug677"))

		self:setButtonState(self.uiSendMail,true)
		self:setButtonState(self.uiPriChat,true)

		if aInfo.post == AlliancePost.LEADER then
			--自己是会长
			if data.post == AlliancePost.VICE_CHAIRMAN then
				self:setButtonState(self.uiLeader,true)
				self:setButtonState(self.uiViceLeader,false)
				self:setButtonState(self.uiMember,true)
			elseif data.post == AlliancePost.LEADER then
			else
				self:setButtonState(self.uiLeader,true)
				self:setButtonState(self.uiViceLeader,true)
				self:setButtonState(self.uiMember,false)
			end

			self:setButtonState(self.uiQuit,true)
		else
			self:setButtonState(self.uiLeader,false)
			self:setButtonState(self.uiViceLeader,false)
			self:setButtonState(self.uiMember,false)

			if aInfo.post == AlliancePost.VICE_CHAIRMAN then
				--自己是副会长
				if data.post == AlliancePost.VICE_CHAIRMAN then
					self:setButtonState(self.uiQuit,false)
				elseif data.post == AlliancePost.LEADER then
					self:setButtonState(self.uiQuit,false)
				else
					self:setButtonState(self.uiQuit,true)
				end
			else
				self:setButtonState(self.uiQuit,false)
			end
		end
	end
end

--- 设置按钮状态
function T:setButtonState(button,isEnabled)
	button:setTouchEnabled(isEnabled)
	button:setIsGray(not isEnabled)
end

return T
