--- 联盟其它视图
local T=Class.AllianceOtherView(function() return ccui.Layout:create() end)

--- 联盟列表
T.AllianceListView=require("src.app.uiScript.components.alliance.list.AllianceListView")

function T:def()

end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.updateView)
end

--- 初始化
function T:init()
	local mA=UserInfo.allianceBox.myAlliance

	--上一次点击的按钮的索引
	local lastBtnIdx
	local eventTouchHandler=function(idx)
        if idx == lastBtnIdx then
            return
        end
		lastBtnIdx=idx
	end

	local donationStatisticsTouchHandler=function(idx)
        if idx == lastBtnIdx then
            return
        end
		lastBtnIdx=idx
	end

	local allianceListTouchHandler=function(idx)
        if idx == lastBtnIdx then
            return
        end
		lastBtnIdx=idx

		local rBox=UserInfo.allianceBox.allianceRankBox
		local rList=rBox.rList
		if not rList then
			require("src.app.communication.alliance.GetAllianceRankListCommand")():exec(
				1,
				true,
				function(state,startIndex)
					if state == ReturnCode.SUCCESS then
						self:switch2AllianceListView()
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		else
			self:switch2AllianceListView()
		end
	end

	local quitAllianceTouchHandler=function()
		--切换回上一次点击的按钮
		AbstractUI.timeout(
			self,
			function()
				self.uiSwitchButtons:switchButtonByIndex(lastBtnIdx or 1)
			end,
			0
		)
		
		self:quitAlliance()
	end

	--按钮纹理
	local buttonTextures={"panelSwitchButton_down.png","panelSwitchButton_normal.png"}

	-- 二级菜单
	local uiSwitchButtons = SwitchButtonContainer.new(0)
	self:addChild(uiSwitchButtons)
	REL:relOther(uiSwitchButtons,self,0,0,6,0)
	uiSwitchButtons:init()

	--会长和副会长才有处理申请信息和邀请成员的权利
	uiSwitchButtons:initButtons(
		2,
		{buttonTextures,buttonTextures--[[,buttonTextures,buttonTextures]]},
		nil,
		{--[[eventTouchHandler,donationStatisticsTouchHandler,]]allianceListTouchHandler,quitAllianceTouchHandler},
		{--[[Language:get("ug840"),Language:get("ug841"),]]Language:get("ug842"),mA.post ==  AlliancePost.LEADER and Language:get("ug844") or Language:get("ug843")}
	)
	self.uiSwitchButtons = uiSwitchButtons
	uiSwitchButtons.viewBack:setVisible(false)

	allianceListTouchHandler()

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_POST_CHANGE,self,self.updateView)
end

--- 刷新视图
function T:updateView()
	local mA=UserInfo.allianceBox.myAlliance

	local button4=self.uiSwitchButtons:getButton(4)
	if button4 then

		if mA.post ==  AlliancePost.LEADER then
			button4:setString(Language:get("ug844"))
		else
			button4:setString(Language:get("ug843"))
		end
	end
end

--- 切换到联盟列表视图
function T:switch2AllianceListView()
	local curView=self.curView
	if not curView or curView ~= self.uiAllianceListView then
		if curView then
			curView:setVisible(false)
		end

		if not self.uiAllianceListView then
			curView=self.AllianceListView()
			self:addChild(curView)
			REL:relOther(curView,self.uiSwitchButtons.viewBack,0,0,0,0)
			curView:init()
			self.uiAllianceListView=curView
		end

		self.curView=self.uiAllianceListView
		self.curView:setVisible(true)
	end
end

--- 退出联盟
function T:quitAlliance()
	local mA=UserInfo.allianceBox.myAlliance

	if mA.post ==  AlliancePost.LEADER then
		MUIAlter.show({
			info=require("src.app.uiScript.components.alliance.other.DismissConfirmCvs")(),
			flag=4
		},WindowManager:getCurrentWindow())
	else
		MUIAlter.show({
			info=require("src.app.uiScript.components.alliance.other.ExitConfirmCvs")(),
			flag=4
		},WindowManager:getCurrentWindow())
	end
end

return T
