--- 联盟科技项
local T=Class.AllianceScienceItem(function() return ccui.Layout:create() end)

--- 科技信息展开项
T.AllianceScienceExpand=require("src.app.uiScript.components.alliance.science.AllianceScienceExpand")

function T:def()

end

function T:ctor(node,dataTemplate)
	self.node=node
	self.dataTemplate=dataTemplate

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	if self.uiMask then
		self.uiMask:release()
		self.uiMask=nil
	end

	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_CHANGE_TECH_INFO,self,self.techInfoChangeHandler)
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_CHANGE_LEVEL,self,self.updateView)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.diamond,self,self.updateView)
end

--- 初始化
function T:init()
	local node=self.node
	local dt=self.dataTemplate

	local data
	local sL=UserInfo.allianceBox.myAlliance.scienceList
	if sL then
		data=sL[dt.id]
	end
	data=data or {id=dt.id,level=0,sciencePoint=0}

	local f = ResLoader:getSpriteFrame("frameBack_middle.png")
	local fs = f:getOriginalSize()
	self:setContentSize(f:getOriginalSize())
	self:setTouchEnabled(false)

	node:setContentSize(self:getContentSize())

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	---背景
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	REL:toOther("center","middle",uiBack,self,0,0)
	self.uiBack=uiBack

	local left=12

	--图标
	local uiIcon=cc.Sprite:create(IconManager.iconPath..dt.iconUrl)
	self:addChild(uiIcon)
	--	REL:relRect(uiIcon,cc.rect(0,0,100,100),0,0,0,0)
	REL:toOther("left","middle",uiIcon,self,0,2)
	self.uiIcon=uiIcon

	left=left+84+6

	--名称
	local uiName=XMLLabel()
	uiName:setAlign("left","middle")
	uiName:setHeight(36)
	self:addChild(uiName)
	REL:relOther(uiName,self,110,86,2,SIZE_NIL)
	self.uiName=uiName

	--进度条背景
	local uiProgressBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("productProgressBack.png"))
	self:addChild(uiProgressBack)
	REL:toOther("left","bottom",uiProgressBack,uiIcon,left,24)
	self.uiProgressBack=uiProgressBack

	--进度条
	local uiProgressFore=cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("productProgressFore.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	self:addChild(uiProgressFore)
	REL:toOther("center","middle",uiProgressFore,uiProgressBack,0,0)
	self.uiProgressFore=uiProgressFore

	--进度显示
	local uiProgress=XMLLabel()
	uiProgress:setAlign("center","middle")
	self:addChild(uiProgress)
	REL:relOther(uiProgress,uiProgressBack,0,0,0,0)
	self.uiProgress=uiProgress

	--"展开/收缩"按钮
	local uiExButton=ToggleButton("scaleOut_normal.png","scaleIn_normal.png")
	uiExButton.touchBeganSound = SoundRes.NONE
	self:addChild(uiExButton)
	REL:toOther("right","middle",uiExButton,self,8,-8)

	--创建叶子节点
	node:addListener(function(leafContainer)
		local ex=self.AllianceScienceExpand(dt)
		leafContainer:setContentSize(ex:getContentSize())

		leafContainer:addChild(ex)
	end)

	--侦听"展开/收缩"按钮改变事件
	uiExButton:luaAddEventListener("change",self,
		function()
			AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)

			node:dispachEvent()
		end
	)

	node:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			uiExButton:setIsSelected(not uiExButton:getIsSelected())
		end
	end)

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_CHANGE_TECH_INFO,self,self.techInfoChangeHandler)
	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_CHANGE_LEVEL,self,self.updateView)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.diamond,self,self.updateView)
	self:updateView()
end

--- 科技项信息发生改变
function T:techInfoChangeHandler(sid)
	local dt=self.dataTemplate
	if sid == dt.id then
		self:updateView()
	end
end

--- 创建锁定图标
function T:createLockIcon()
	--锁定遮罩
	local uiMask=ccui.Layout:create()
	uiMask:setTouchEnabled(true)
	uiMask:retain()
	self:addChild(uiMask)
	REL:relOther(uiMask,self, 0, 0, 0, 0)
	uiMask:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid )
	uiMask:setBackGroundColor(cc.c3b(0,0,0))
	uiMask:setBackGroundColorOpacity(140)
	self.uiMask=uiMask

	--锁定后的提示文本的背景
	local uiLockedTipBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("lockedBack.png"))
	uiMask:addChild(uiLockedTipBack)
	--	uiLockedTipBack:setIsGray(true)
	REL:toOther("center","middle",uiLockedTipBack,uiMask,0,0)

	--锁定后的提示文本
	local uiLockedTip=XMLLabel()
	uiLockedTip:setContentSize(cc.size(500,36))
	uiLockedTip:setAlign("center","middle")
	uiMask:addChild(uiLockedTip)
	REL:toOther("center","middle",uiLockedTip,uiLockedTipBack,0,-34)
	uiMask.uiLockedTip=uiLockedTip
end

--- 更新视图
function T:updateView()
	local dt=self.dataTemplate

	local data
	local sL=UserInfo.allianceBox.myAlliance.scienceList
	if sL then
		data=sL[dt.id]
	end
	data=data or {id=dt.id,level=0,sciencePoint=0}

	self.uiName:setString(Language:get("ug909",Language:get(dt.name),data and (data.level or 0) or 0))

	--第一项科技默认的等级就是1
	if data.id == 1 then
		if data.level == 0 then
			data.level=1
		end
	else
		--判断是否已到开放等级
		local mainLv=1
		local sL=UserInfo.allianceBox.myAlliance.scienceList
		if sL and sL[1] then
			mainLv=sL[1].level or 1
		end

		if mainLv < dt.unlockLevel then
			self.uiProgressBack:setVisible(false)
			self.uiProgressFore:setVisible(false)
			self.uiProgress:setVisible(false)
			--			self.uiProgress:setString(Language:get("ug925",dt.unlockLevel))

			if self.uiMask then
				if not self.uiMask:getParent() then
					self:addChild(self.uiMask)
				end
			else
				self:createLockIcon()
			end
			self.uiMask.uiLockedTip:setString(Language:get("ug925",dt.unlockLevel))

			return
		end
	end
	if self.uiMask then
		self.uiMask:removeFromParent(false)
	end

	self.uiProgressBack:setVisible(true)
	self.uiProgressFore:setVisible(true)
	self.uiProgress:setVisible(true)

	local maxSPoint=dt.lvUpNeedPoints[data.level+1]
	if maxSPoint then
		self.uiProgressFore:setPercentage(data.sciencePoint/maxSPoint*100)
		self.uiProgress:setString(Language:get("ug785",data.sciencePoint,maxSPoint))
	else
		self.uiProgressFore:setPercentage(100)
		self.uiProgress:setString(Language:get("ug912"))
	end
end

return T
