--- 联盟捐献画布
local T=Class.DonateCvs(function() return ccui.Layout:create() end)

function T:def()
--- 数据
-- self.data=nil
end

function T:ctor(data,scienceItem)
	self.data=data
	self.scienceItem=scienceItem

	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.updateView)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.diamond,self,self.updateView)
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(606,548))
	local data=self.data

	--输入框背景帧
	local inputBackFrame=ResLoader:getSpriteFrame("inputBoxBack.png")

	local top=10

	--剩余捐献次数
	local uiRemaingDonateCount=XMLLabel()
	uiRemaingDonateCount:setAlign("center","middle")
	uiRemaingDonateCount:setHeight(46)
	self:addChild(uiRemaingDonateCount)
	self.uiRemaingDonateCount=uiRemaingDonateCount
	REL:relOther(uiRemaingDonateCount,self,10,10,top,SIZE_NIL)

	--说明
	local uiCommentButton=BaseButton:createButton(nil,"infoButton_normal.png","iconButton_general_down.png")
	self:addChild(uiCommentButton)
	REL:toOther("left","top",uiCommentButton,self,16,-20)
	uiCommentButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			MUIAlter_noTitle.show({
				info=Language:get("ug924",GameCfg.ALLIANCE_DONATE_LIMIT,GameCfg.ALLIANCE_DIAMOND_DONATE_TIME)
			})
		end
	end)

	top=top+uiRemaingDonateCount:getHeight()+20

	---资源捐献>>--------------------------------------------------------------------------------------------------------

	--"资源捐献"背景
	local uiResBack=Scale9Sprite:createWithFrame(inputBackFrame)
	self:addChild(uiResBack)
	uiResBack:setContentSize(cc.size(120,220))
	REL:relOther(uiResBack,self,16,16,top,SIZE_NIL)

	--资源图标
	local uiResIcon=cc.Sprite:create(IconManager.iconPath..data.iconUrl)
	self:addChild(uiResIcon)
	REL:relRect(uiResIcon,cc.rect(0,0,82,82),0,0,0,0)
	REL:toOther("left","top",uiResIcon,uiResBack,6,10)
	self.uiResIcon=uiResIcon

	--资源需求
	local uiResNeed=XMLLabel()
	uiResNeed:setContentSize(cc.size(340,36))
	uiResNeed:setAlign("left","top")
	self:addChild(uiResNeed)
	REL:toOther("left","top",uiResNeed,uiResIcon,82+4,0)
	self.uiResNeed=uiResNeed

	--资源拥有
	local uiResOwn=XMLLabel()
	uiResOwn:setContentSize(cc.size(240,36))
	uiResOwn:setAlign("left","bottom")
	self:addChild(uiResOwn)
	REL:toOther("left","bottom",uiResOwn,uiResIcon,82+4,0)
	self.uiResOwn=uiResOwn

	--资源奖励标题
	local uiResAwardCap=XMLLabel(Language:get("ug915"))
	uiResAwardCap:setContentSize(cc.size(240,36))
	uiResAwardCap:setAlign("left","middle")
	self:addChild(uiResAwardCap)
	REL:toOther("left","bottom",uiResAwardCap,uiResBack,16,72+10)
	self.uiResAwardCap=uiResAwardCap

	local left=16

	--资源捐献的科技点奖励
	local uiResScienePointAdd=XMLLabel()
	uiResScienePointAdd:setContentSize(cc.size(190,36))
	uiResScienePointAdd:setAlign("left","middle")
	self:addChild(uiResScienePointAdd)
	REL:toOther("left","bottom",uiResScienePointAdd,uiResBack,left,46)
	self.uiResScienePointAdd=uiResScienePointAdd

	left=left+uiResScienePointAdd:getWidth()+40

	--资源捐献的贡献点奖励
	local uiResContributionAdd=XMLLabel()
	uiResContributionAdd:setContentSize(cc.size(190,36))
	uiResContributionAdd:setAlign("left","middle")
	self:addChild(uiResContributionAdd)
	REL:toOther("left","bottom",uiResContributionAdd,uiResBack,left,46)
	self.uiResContributionAdd=uiResContributionAdd

	left=16

	--资源捐献的声望点奖励
	local uiResPrestigeAdd=XMLLabel()
	uiResPrestigeAdd:setContentSize(cc.size(190,36))
	uiResPrestigeAdd:setAlign("left","middle")
	self:addChild(uiResPrestigeAdd)
	REL:toOther("left","bottom",uiResPrestigeAdd,uiResBack,left,10)
	self.uiResPrestigeAdd=uiResPrestigeAdd

	left=left+uiResPrestigeAdd:getWidth()+40

	--资源捐献的"技能芯片"奖励
	local uiResMedalAdd=XMLLabel()
	uiResMedalAdd:setContentSize(cc.size(190,36))
	uiResMedalAdd:setAlign("left","middle")
	self:addChild(uiResMedalAdd)
	REL:toOther("left","bottom",uiResMedalAdd,uiResBack,left,10)
	self.uiResMedalAdd=uiResMedalAdd

	--资源捐献按钮
	local uiResDonateButton=BaseButton:createButton(Language:get("ug910"),"button_yellow_normal.png","button_general_down.png")
	self:addChild(uiResDonateButton)
	REL:toOther("right","top",uiResDonateButton,uiResBack,6,10)
	self.uiResDonateButton=uiResDonateButton
	uiResDonateButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:donate(false)
		end
	end)

	---<<资源捐献--------------------------------------------------------------------------------------------------------

	top=top+uiResBack:getContentSize().height+14

	---钻石捐献>>--------------------------------------------------------------------------------------------------------
	--"钻石捐献"背景
	local uiDiamondBack=Scale9Sprite:createWithFrame(inputBackFrame)
	self:addChild(uiDiamondBack)
	uiDiamondBack:setContentSize(cc.size(120,220))
	REL:relOther(uiDiamondBack,self,16,16,top,SIZE_NIL)

	--钻石图标
	local uiDiamondIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("diamond.png"))
	self:addChild(uiDiamondIcon)
	REL:relRect(uiDiamondIcon,cc.rect(0,0,82,82),0,0,0,0)
	REL:toOther(nil,"top",uiDiamondIcon,uiDiamondBack,0,10)
	REL:toOther("center",nil,uiDiamondIcon,uiResIcon,0,0)
	self.uiDiamondIcon=uiDiamondIcon

	--钻石需求
	local uiDiamondNeed=XMLLabel()
	uiDiamondNeed:setContentSize(cc.size(340,36))
	uiDiamondNeed:setAlign("left","top")
	self:addChild(uiDiamondNeed)
	REL:toOther(nil,"top",uiDiamondNeed,uiDiamondIcon,0,0)
	REL:toOther("left",nil,uiDiamondNeed,uiResIcon,82+4,0)
	self.uiDiamondNeed=uiDiamondNeed

	--钻石拥有
	local uiDiamondOwn=XMLLabel()
	uiDiamondOwn:setContentSize(cc.size(240,36))
	uiDiamondOwn:setAlign("left","bottom")
	self:addChild(uiDiamondOwn)
	REL:toOther(nil,"bottom",uiDiamondOwn,uiDiamondIcon,0,0)
	REL:toOther("left",nil,uiDiamondOwn,uiResIcon,82+4,0)
	self.uiDiamondOwn=uiDiamondOwn

	--钻石奖励标题
	local uiDiamondAwardCap=XMLLabel(Language:get("ug915"))
	uiDiamondAwardCap:setContentSize(cc.size(240,36))
	uiDiamondAwardCap:setAlign("left","middle")
	self:addChild(uiDiamondAwardCap)
	REL:toOther("left","bottom",uiDiamondAwardCap,uiDiamondBack,16,72+10)
	self.uiDiamondAwardCap=uiDiamondAwardCap

	local left=16

	--钻石捐献的科技点奖励
	local uiDiamondScienePointAdd=XMLLabel()
	uiDiamondScienePointAdd:setContentSize(cc.size(190,36))
	uiDiamondScienePointAdd:setAlign("left","middle")
	self:addChild(uiDiamondScienePointAdd)
	REL:toOther("left","bottom",uiDiamondScienePointAdd,uiDiamondBack,left,46)
	self.uiDiamondScienePointAdd=uiDiamondScienePointAdd

	left=left+uiDiamondScienePointAdd:getWidth()+40

	--钻石捐献的贡献点奖励
	local uiDiamondContributionAdd=XMLLabel()
	uiDiamondContributionAdd:setContentSize(cc.size(190,36))
	uiDiamondContributionAdd:setAlign("left","middle")
	self:addChild(uiDiamondContributionAdd)
	REL:toOther("left","bottom",uiDiamondContributionAdd,uiDiamondBack,left,46)
	self.uiDiamondContributionAdd=uiDiamondContributionAdd

	left=16

	--钻石捐献的声望点奖励
	local uiDiamondPrestigeAdd=XMLLabel()
	uiDiamondPrestigeAdd:setContentSize(cc.size(190,36))
	uiDiamondPrestigeAdd:setAlign("left","middle")
	self:addChild(uiDiamondPrestigeAdd)
	REL:toOther("left","bottom",uiDiamondPrestigeAdd,uiDiamondBack,left,10)
	self.uiDiamondPrestigeAdd=uiDiamondPrestigeAdd

	left=left+uiDiamondPrestigeAdd:getWidth()+40

	--钻石捐献的"技能芯片"奖励
	local uiDiamondMedalAdd=XMLLabel()
	uiDiamondMedalAdd:setContentSize(cc.size(190,36))
	uiDiamondMedalAdd:setAlign("left","middle")
	self:addChild(uiDiamondMedalAdd)
	REL:toOther("left","bottom",uiDiamondMedalAdd,uiDiamondBack,left,10)
	self.uiDiamondMedalAdd=uiDiamondMedalAdd

	--钻石捐献按钮
	local uiDiamondDonateButton=BaseButton:createButton(Language:get("ug910"),"button_purple_normal.png","button_general_down.png")
	uiDiamondDonateButton.touchBeganSound=SoundRes.NONE
	self:addChild(uiDiamondDonateButton)
	REL:toOther("right","top",uiDiamondDonateButton,uiDiamondBack,6,10)
	self.uiDiamondDonateButton=uiDiamondDonateButton
	uiDiamondDonateButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:donate(true)
		end
	end)

	---<<钻石捐献--------------------------------------------------------------------------------------------------------

	ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.updateView)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.diamond,self,self.updateView)
	self:updateView()
end

function T:updateView()
	local data=self.data

	local mA=UserInfo.allianceBox.myAlliance

	local donateCount=self:getDonateCount()
	local cInfo
	if donateCount >= GameCfg.ALLIANCE_DONATE_LIMIT or mA:judgeDonateCountIsFinish() == true then  -- 只要次数限制或者vip限制满了
		cInfo=AllianceDonateConsume_temp[GameCfg.ALLIANCE_DONATE_LIMIT]

		self.uiResDonateButton:setTextures("button_yellow_normal.png","button_general_down.png")
		self.uiResDonateButton:setIsGray(true)
		self.uiDiamondDonateButton:setTextures("button_yellow_normal.png","button_general_down.png")
		self.uiDiamondDonateButton:setIsGray(true)
	else
		cInfo=AllianceDonateConsume_temp[donateCount + 1]

		self.uiResDonateButton:setTextures("button_yellow_normal.png","button_general_down.png")
		self.uiResDonateButton:setIsGray(false)
		self.uiDiamondDonateButton:setTextures("button_purple_normal.png","button_general_down.png")
		self.uiDiamondDonateButton:setIsGray(false)
	end

	self.uiRemaingDonateCount:setString(Language:get("ug922",Language:get(data.name),donateCount,GameCfg.ALLIANCE_DONATE_LIMIT))

	---资源捐献>>--------------------------------------------------------------------------------------------------------
	if cInfo.resConsume > UserInfo.city[data.attributeName] then
		self.uiResDonateButton:setTextures("button_yellow_normal.png","button_general_down.png")
		self.uiResDonateButton:setIsGray(true)
		self.uiResNeed:setString(Language:get("ug931",UnitConversion.unitTrans(cInfo.resConsume)))
	else
		self.uiResNeed:setString(Language:get("ug913",UnitConversion.unitTrans(cInfo.resConsume)))
	end
	self.uiResOwn:setString(Language:get("ug914",UnitConversion.unitTrans(UserInfo.city[data.attributeName])))

	self.uiResScienePointAdd:setString(Language:get("ug917",cInfo.scienceLevelAdd))
	self.uiResContributionAdd:setString(Language:get("ug918",cInfo.contributionAdd))
	self.uiResPrestigeAdd:setString(Language:get("ug919",cInfo.prestigeAdd))
	self.uiResMedalAdd:setString(Language:get("ug920",cInfo.medalAdd))
	---<<资源捐献--------------------------------------------------------------------------------------------------------

	---钻石捐献>>--------------------------------------------------------------------------------------------------------
	if cInfo.diamondConsume > UserInfo.gems then
		self.uiResDonateButton:setTextures("button_yellow_normal.png","button_general_down.png")
		self.uiDiamondDonateButton:setIsGray(true)
		self.uiDiamondNeed:setString(Language:get("ug932",UnitConversion.unitTrans(cInfo.diamondConsume)))
	else
		self.uiDiamondNeed:setString(Language:get("ug927",UnitConversion.unitTrans(cInfo.diamondConsume)))
	end
	self.uiDiamondOwn:setString(Language:get("ug914",UserInfo.gems))

	self.uiDiamondScienePointAdd:setString(Language:get("ug917",cInfo.scienceLevelAdd * GameCfg.ALLIANCE_DIAMOND_DONATE_TIME))
	self.uiDiamondContributionAdd:setString(Language:get("ug918",cInfo.contributionAdd * GameCfg.ALLIANCE_DIAMOND_DONATE_TIME))
	self.uiDiamondPrestigeAdd:setString(Language:get("ug919",cInfo.prestigeAdd))
	self.uiDiamondMedalAdd:setString(Language:get("ug920",cInfo.medalAdd))
	---<<钻石捐献--------------------------------------------------------------------------------------------------------
end

--- 获取捐献次数
function T:getDonateCount()
	local data=self.data

	local mA=UserInfo.allianceBox.myAlliance

	local donateCount,id=0,data.id
	if id == 1 then
		donateCount=mA.moneyDonateCount
	elseif id == 2 then
		donateCount=mA.steelDonateCount
	elseif id == 3 then
		donateCount=mA.oilDonateCount
	elseif id == 4 then
		donateCount=mA.siliconDonateCount
	elseif id == 5 then
		donateCount=mA.titaniumDonateCount
	end
	if donateCount < 0 then
		donateCount=0
	end

	return donateCount
end

--- 捐献
function T:donate(isDiamond)
	local data=self.data


    local mA = UserInfo.allianceBox.myAlliance
    if mA:judgeDonateCountIsFinish() == true then -- 联盟已经超过了vip的次数
        
        local describe1 = Language:get("uc1078",UserInfo.vipLevel)
	    local describe2 = Language:get("uc1079",UserInfo.vipLevel,VipManager:getVipDonateNum())
	    local describe3 = Language:get("uc1080")

	    local layout = VipTipsInfo.new(describe1,describe2,describe3)

	    MUIAlter.show({
		    info = layout,
		    size = 30,
		    flag = 1,
		    confirmText = Language:get("uc332"),
		    triggerCloseMethod = "buttons",
		    isShowCloseButton = true,
		    callback = function(flag)
			    -- 转到vip界面
			    if flag == 0 then
				    WindowManager:push(
					    require("src.app.uiScript.components.vip.VIPWindow").new()
				    )
			    end

		    end
	    })


        return
    end


	local cInfo

	local donateCount=self:getDonateCount()
	if donateCount >= GameCfg.ALLIANCE_DONATE_LIMIT then
		--捐献次数已满
		MUIAlter.show({
			info=Language:get("ug923",Language:get(data.name))
		},WindowManager:getCurrentWindow())

		return
	else
		cInfo=AllianceDonateConsume_temp[donateCount + 1]
	end

	--资源不足
	if not isDiamond then
		if cInfo.resConsume > UserInfo.city[data.attributeName] then
			MUIAlter.show({
				info=Language:get("ug933",Language:get(data.name))
			},WindowManager:getCurrentWindow())

			return
		end
	else
		--钻石不足
		if cInfo.diamondConsume > UserInfo.gems then
			MUIAlter.show({
				info=Language:get("ug934",Language:get(data.name))
			},WindowManager:getCurrentWindow())

			return
		end
	end


	require("src.app.communication.alliance.ScienceDonateCommand")():exec(
		self.scienceItem.id,
		data.id,
		isDiamond and 1 or 0,
		function(state,award)
			if state == ReturnCode.SUCCESS then
				MUIAlter_singleLine.show({
					info= require("src.app.communication.award.AwardDataDecoder"):award2HTML(award),
					showSecond=1.5,
					popSnd=SoundRes.SND_SND_GET_AWARD
				})
				
				self:updateView()
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end
	)
end

return T
