--- 联盟列表信息项
local T=Class.NeedItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 捐献画布
T.DonateCvs=require("src.app.uiScript.components.alliance.science.DonateCvs")

function T:def()
	AbstractUI.def(self)

	--- 数据
	-- resDt=nil
	
	--- 标题列表
	-- _captionUIList
end

function T:ctor(resDt,scienceDataTemplate,captionUIList)
	AbstractUI.ctor(self)

	self._captionUIList=captionUIList

	self:init()
	self:setData(resDt,scienceDataTemplate)
end

--- 内存清理
function T:cleanUp()
	AbstractUI.cleanUp(self)

	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_CHANGE_TECH_INFO,self,self.techInfoChangeHandler)
	ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.updateView)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.diamond,self,self.updateView)
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(580,72))

	--		self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--		self:setBackGroundColor(cc.c3b(0xff,0,0))
	--		self:setBackGroundColorOpacity(100)

	--标题"类别"
	local uiIcon=cc.Sprite:create(IconManager.iconPath..Resource_temp[1].iconUrl)
	self:addChild(uiIcon)
	REL:relRect(uiIcon,cc.rect(0,0,64,64),0,0,0,0)
	self.uiIcon=uiIcon

	--标题"需求"
	local uiNeedVal=XMLLabel()
	uiNeedVal:setCssStyle(CssStyles.default20)
	--标题项的宽-分隔线的宽(8)-右边距(4)
	uiNeedVal:setAlign("center","middle")
	uiNeedVal:setHeight(36)
	self:addChild(uiNeedVal)
	self.uiNeedVal=uiNeedVal

	--是否足够图标
	local uiIsEnoughIcon=cc.Sprite:create()
	self:addChild(uiIsEnoughIcon)
	self.uiIsEnoughIcon=uiIsEnoughIcon

	--标题"当前拥有"
	local uiOwnVal=XMLLabel()
	uiOwnVal:setCssStyle(CssStyles.default20)
	uiOwnVal:setAlign("right","middle")
	uiOwnVal:setHeight(36)
	self:addChild(uiOwnVal)
	self.uiOwnVal=uiOwnVal

	--标题"科技"
	local uiScienceVal=XMLLabel()
	uiScienceVal:setCssStyle(CssStyles.default20)
	uiScienceVal:setAlign("center","middle")
	uiScienceVal:setHeight(36)
	self:addChild(uiScienceVal)
	self.uiScienceVal=uiScienceVal

	--标题"贡献"
	local uiContributionVal=XMLLabel()
	uiContributionVal:setCssStyle(CssStyles.default20)
	uiContributionVal:setAlign("center","middle")
	uiContributionVal:setHeight(36)
	self:addChild(uiContributionVal)
	self.uiContributionVal=uiContributionVal

	--"捐献"按钮
	local uiDonateButton=BaseButton:createButton(Language:get("ug910"),"button_yellow_normal.png","button_general_down.png")
	self:addChild(uiDonateButton)
	self.uiDonateButton=uiDonateButton
	uiDonateButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
            local level = UserInfo.level
            if level < 12 then
                
	            MUIAlter_singleLine.show( {info = Language:get("uc1076"),showSecond = 1 } )

				return
            end

            if not self:isEnoughOfMainLv() then
				MUIAlter.show({
					info=Language:get("ug926",self.scienceDataTemplate.unlockLevel)
				})

				return
			end

            local mA = UserInfo.allianceBox.myAlliance
            if mA:judgeDonateCountIsFinish() == true then -- 联盟已经超过了vip的次数
                
                local describe1 = Language:get("uc1078",UserInfo.vipLevel)
		        local describe2 = Language:get("uc1079",UserInfo.vipLevel,VipManager:getVipDonateNum())
		        local describe3 = Language:get("uc1080")

		        local layout = VipTipsInfo.new(describe1,describe2,describe3)

		        MUIAlter.show({
			        info = layout,
			        size = 30,
			        flag = 1,
			        confirmText = Language:get("uc332"),
			        triggerCloseMethod = "buttons",
			        isShowCloseButton = true,
			        callback = function(flag)
				        -- 转到vip界面
				        if flag == 0 then
					        WindowManager:push(
						        require("src.app.uiScript.components.vip.VIPWindow").new()
					        )
				        end

			        end
		        })


                return
            end

			if self:getDonateCount() >= GameCfg.ALLIANCE_DONATE_LIMIT then
				MUIAlter.show({
					info=Language:get("ug923",Language:get(self.resDt.name))
				})

				return
			end

			if self:isFullLv() then
				MUIAlter.show({
					info=Language:get("ug912")
				})

				return
			end

			MUIAlter.show({
				info=self.DonateCvs(self.resDt,self.scienceDataTemplate),
				title=Language:get("ug916"),
				flag=4,
				isShowCloseButton=true,
				callback=function()
					self:updateView()
				end
			},WindowManager:getCurrentWindow())
		end
	end)

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_CHANGE_TECH_INFO,self,self.techInfoChangeHandler)
	ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.updateView)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.diamond,self,self.updateView)
end

--- 更新布局
function T:updateLayout()
	local cUIL=self._captionUIList
	
	REL:toOther(nil,"middle",self.uiIcon,self,0,0)
	REL:toOther("center",nil,self.uiIcon,cUIL[1],0,0)
	
	REL:relOther(self.uiNeedVal,cUIL[2],8,4,SIZE_NIL,SIZE_NIL)
	REL:toOther(nil,"middle",self.uiNeedVal,self,0,0)
	
	REL:toOther("left",nil,self.uiIsEnoughIcon,cUIL[3],8,0)
	REL:toOther(nil,"middle",self.uiIsEnoughIcon,self,0,0)
	
	REL:relOther(self.uiOwnVal,cUIL[3],8,4,SIZE_NIL,SIZE_NIL)
	REL:toOther(nil,"middle",self.uiOwnVal,self,0,0)
	
	REL:relOther(self.uiScienceVal,cUIL[4],8,4,SIZE_NIL,SIZE_NIL)
	REL:toOther(nil,"middle",self.uiScienceVal,self,0,0)
	
	REL:relOther(self.uiContributionVal,cUIL[5],8,4,SIZE_NIL,SIZE_NIL)
	REL:toOther(nil,"middle",self.uiContributionVal,self,0,0)
	
	REL:toOther("center",nil,self.uiDonateButton,cUIL[6],0,0)
	REL:toOther(nil,"middle",self.uiDonateButton,self,0,-10)
end

function T:techInfoChangeHandler(sid)
	if sid == self.scienceDataTemplate.id then
		self:updateView()
	end
end

--- 更新视图
function T:updateView()
	--资源
	local resDt=self.resDt
	if resDt then
		local mA=UserInfo.allianceBox.myAlliance

		local donateCount=self:getDonateCount()
		local cInfo=AllianceDonateConsume_temp[
			donateCount >= GameCfg.ALLIANCE_DONATE_LIMIT
			and
			GameCfg.ALLIANCE_DONATE_LIMIT
			or
			donateCount + 1
		]

		local hasVal=UserInfo.city[resDt.attributeName]

		self.uiIcon:setTexture(IconManager.iconPath..resDt.iconUrl)
		self.uiNeedVal:setString(UnitConversion.unitTrans(cInfo.resConsume))
		self.uiOwnVal:setString(UnitConversion.unitTrans(hasVal))
		if cInfo.resConsume > hasVal then
			self.uiIsEnoughIcon:setSpriteFrame(ResLoader:getSpriteFrame("needNotEnoughIcon.png"))
		else
			self.uiIsEnoughIcon:setSpriteFrame(ResLoader:getSpriteFrame("needEnoughIcon.png"))
		end
		REL:toOther("left","middle",self.uiIsEnoughIcon,self.uiOwnVal,0,0)
		self.uiScienceVal:setString("+"..cInfo.scienceLevelAdd)
		self.uiContributionVal:setString("+"..cInfo.contributionAdd)

		self:updateDonateButton()
	end
end

--- 获取捐献次数
function T:getDonateCount()
	local donateCount

	--资源
	local resDt=self.resDt
	if resDt then
		local mA=UserInfo.allianceBox.myAlliance

		local id=resDt.id
		if id == 1 then
			donateCount=mA.moneyDonateCount
		elseif id == 2 then
			donateCount=mA.steelDonateCount
		elseif id == 3 then
			donateCount=mA.oilDonateCount
		elseif id == 4 then
			donateCount=mA.siliconDonateCount
		elseif id == 5 then
			donateCount=mA.titaniumDonateCount
		end
		if donateCount < 0 then
			donateCount=0
		end
	end

	return donateCount
end

--- 判断联盟科技等级是否足够
function T:isEnoughOfMainLv()
	local sDt=self.scienceDataTemplate

	--id为1的科技为联盟等级,联盟等级默认为1级
	local mainLv=1
	local sL=UserInfo.allianceBox.myAlliance.scienceList
	if sL and sL[1] then
		mainLv=sL[1].level or 1
	end

	return mainLv >= sDt.unlockLevel
end

--- 是否满级了
function T:isFullLv()
	local sDt=self.scienceDataTemplate
	local data

	local sL=UserInfo.allianceBox.myAlliance.scienceList
	if sL then
		data=sL[sDt.id]
	end

	if data then
		return not sDt.lvUpNeedPoints[data.level+1]
	end
end

--- 刷新捐献按钮状态
-- @return 返回可捐献状态
function T:updateDonateButton()
    local level = UserInfo.level
    if level < 12 then
        self.uiDonateButton:setIsGray(true)
	else
        self.uiDonateButton:setIsGray(
            UserInfo.allianceBox.myAlliance:judgeDonateCountIsFinish() or
		    not self:isEnoughOfMainLv() or
		    self:isFullLv() or
		    self:getDonateCount() >= GameCfg.ALLIANCE_DONATE_LIMIT
	    )
    end

end

function T:setData(value,scienceDataTemplate)
	self.scienceDataTemplate=scienceDataTemplate

	if value ~= self.resDt then
		self.resDt=value

		self:updateView()
	end
end
function T:getData()
	return self.resDt
end

return T
