---竞技场挑战项
local T=Class.ArenaChallengeItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)
end

function T:ctor(data)
	self.data=data

	AbstractUI.ctor(self)

	self:_init()
end

function T:onEnter()
	AbstractUI.onEnter(self)

	self:updateButtonStates()
	DailyStates:luaAddEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.updateButtonStates)
	ArenaInfoMgr:luaAddEventListener(ArenaInfoMgr.EVT_TYPE_CHANGE_FAIL_COOLDOWN,self,self.updateButtonStates)
end

function T:onExit()
	AbstractUI.onExit(self)

	DailyStates:luaRemoveEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES,self,self.updateButtonStates)
	ArenaInfoMgr:luaRemoveEventListener(ArenaInfoMgr.EVT_TYPE_CHANGE_FAIL_COOLDOWN,self,self.updateButtonStates)
end

function T:_init()
	self:setContentSize(cc.size(600,82))

	--			self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--			self:setBackGroundColor(cc.c3b(random(0,255),0,0))
	--			self:setBackGroundColorOpacity(100)

	local left=10

	--列表标题"排名"
	local uiRank=XMLLabel()
	uiRank:setAlign("center","middle")
	uiRank:setContentSize(cc.size(96,36))
	self:addChild(uiRank,2)
	REL:toOther("left","middle",uiRank,self,left,0)
	self.uiRank=uiRank
	left=left+uiRank:getWidth()

	--列表标题"名称"
	local uiPName=XMLLabel()
	uiPName:setAlign("center","middle")
	uiPName:setContentSize(cc.size(180,36))
	self:addChild(uiPName,2)
	REL:toOther("left","middle",uiPName,self,left,0)
	self.uiPName=uiPName
	left=left+uiPName:getWidth()

	--列表标题"等级"
	local uiPLv=XMLLabel()
	uiPLv:setAlign("center","middle")
	uiPLv:setContentSize(cc.size(120,36))
	self:addChild(uiPLv,2)
	REL:toOther("left","middle",uiPLv,self,left,0)
	self.uiPLv=uiPLv
	left=left+uiPLv:getWidth()+4
	
--	--分隔线
--	local uiSep=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("seqLine1.png"))
--	self:addChild(uiSep)
--	REL:relOther(uiSep,self,10,10,SIZE_NIL,0)

	self:updateView()
end

--- 创建操作按钮
function T:createButtons()
	local right=10

	-- "挑战"按钮
	local uiChallengeBtn=BaseButton:createButton("","buttonAim_normal.png","iconButton_general_down.png")
	self:addChild(uiChallengeBtn,2)
	REL:toOther("right","middle",uiChallengeBtn,self,right,0)
	self.uiChallengeBtn=uiChallengeBtn
	uiChallengeBtn:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			if DailyStates:getArenaFightNum() >= GameCfg.ARENA_CHALLENGE_POINT_LIMIT then
				ArenaInfoMgr:buyChallengePoint()
				return
			end

			--是否在失败后的冷却时间中
			if ArenaInfoMgr:getFailCooldownSec() > 0 then
				ArenaInfoMgr:clearFailCooldown()
				return
			end

			if self.data and self.data.playerId then
				require("src.app.controler.enterFight.EnterArenaChallengeFightCommand")(self.data.playerId)
			end
		end
	end)
	right=right+uiChallengeBtn:getContentSize().width+4

	-- 信息按钮
	local uiInfoBtn=BaseButton:createButton("","infoButton_normal.png","iconButton_general_down.png")
	self:addChild(uiInfoBtn,2)
	REL:toOther("right","middle",uiInfoBtn,self,right,0)
	self.uiInfoBtn=uiInfoBtn
	uiInfoBtn:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			if not self.data then
				return 
			end
		
			local function finish(playerData)
				-- new的有大小
				local layout = require("src.app.uiScript.components.chat.ChatInfoPopView").new(playerData,nil,self.data.playerName)
				layout:setTouchEnabled(true)
				local muialter2 = MUIAlter.show({
					title = playerData.name,
					info = layout,
					flag = 4,
					callback = function(flag)
					end
				})
				layout:setMUIAlter2(muialter2)
			end
			BuildingCommand:CheckChatInfo(self.data.playerId,finish)
		end
	end)
end

--- 更新按钮状态
function T:updateButtonStates()
	local data = self.data or {}

	if data.playerId ~= UserInfo.id and self.uiChallengeBtn then
		if DailyStates:getArenaFightNum() >= GameCfg.ARENA_CHALLENGE_POINT_LIMIT then
			self.uiChallengeBtn:setIsGray(true)

			return
		end
		if ArenaInfoMgr:getFailCooldownSec() > 0 then
			self.uiChallengeBtn:setIsGray(true)

			return
		end

		self.uiChallengeBtn:setIsGray(false)
	end
end

--- 更新视图
function T:updateView()
	local data = self.data or {}

	if data.playerId == UserInfo.id then
		if not self.uiBack then
			local uiBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("itemBack.png"))
			self:addChild(uiBack,1)
			REL:relOther(uiBack,self,0,0,0,0)
			self.uiBack=uiBack
		end

		if self.uiChallengeBtn then
			self.uiChallengeBtn:setVisible(false)
			self.uiInfoBtn:setVisible(false)
		end
	else
		if self.uiChallengeBtn then
			self.uiChallengeBtn:setVisible(true)
			self.uiInfoBtn:setVisible(true)
		else
			self:createButtons()
		end

		if self.uiBack then
			self.uiBack:removeFromParent()
			self.uiBack=nil
		end

		self:updateButtonStates()
	end

	self.uiRank:setString(tostring(data.rank) or "-")
	self.uiPName:setString(data.playerName or "")
	self.uiPLv:setString(tostring(data.playerLv) or "0")
end

function T:setData(value)
	if value ~= self.data then
		self.data=value

		self:updateView()
	end
end
function T:getData()
	return self.data
end

return T
