local T=Class.FightRecordItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 数据
	-- _data
end

function T:ctor(data)
	self._data=data

	AbstractUI.ctor(self)

	self:_init()
end

--- 进入场景
function T:onEnter()
	AbstractWindow.onEnter(self)

	self:updateView()
	ArenaInfoMgr:luaAddEventListener(ArenaInfoMgr.EVT_TYPE_GETED_FIGHT_REPORT,self,self.getedFightReportHandler)
end

--- 退出场景
function T:onExit()
	AbstractWindow.onExit(self)

	ArenaInfoMgr:luaRemoveEventListener(ArenaInfoMgr.EVT_TYPE_GETED_FIGHT_REPORT,self,self.getedFightReportHandler)
end

--- 初始化
function T:_init()
	local f=ResLoader:getSpriteFrame("mailNotRead.png")
	local fs=f:getOriginalSize()
	self:setContentSize(fs)
	self:setTouchEnabled(true)

	--背景
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	REL:toOther("center","middle",uiBack,self,0,0)
	self.uiBack=uiBack

	--标题
	local uiTitle=XMLLabel()
	uiTitle:setContentSize(cc.size(440,36))
	uiTitle:setAlign("left","middle")
	self:addChild(uiTitle)
	REL:toOther("left","middle",uiTitle,self,120,22)
	self.uiTitle=uiTitle

	--排名变化
	local uiRankChange=XMLLabel()
	uiRankChange:setContentSize(cc.size(76,36))
	uiRankChange:setAlign("left","middle")
	self:addChild(uiRankChange)
	REL:toOther("left","middle",uiRankChange,self,120+uiTitle:getWidth(),22)
	self.uiRankChange=uiRankChange

	--描述
	local uiDes=XMLLabel()
	uiDes:setContentSize(cc.size(300,36))
	uiDes:setAlign("left","middle")
	self:addChild(uiDes)
	REL:toOther("left","bottom",uiDes,self,120,20)
	self.uiDes=uiDes

	--时间
	local uiTime=XMLLabel()
	uiTime:setContentSize(cc.size(160,36))
	uiTime:setAlign("right","middle")
	self:addChild(uiTime)
	REL:toOther("right","bottom",uiTime,self,20,20)
	self.uiTime=uiTime

	-- 不支持删除,所以不用有选择框
	--	--选择框
	--	local uiSelect=ccui.ImageView:create("checkBottom.png",ccui.TextureResType.plistType)
	--	uiSelect:setTouchEnabled(true)
	--	self:addChild(uiSelect)
	--	REL:toOther("right","middle",uiSelect,self,20,0)
	--	uiSelect:addTouchEventListener(function(t, e)
	--		if e == ccui.TouchEventType.ended then
	--			if self.isSelected then
	--				self.isSelected = false
	--
	--				if t.uiSelectIcon then
	--					t.uiSelectIcon:setVisible(false)
	--				end
	--			else
	--				self.isSelected = true
	--
	--				if not t.uiSelectIcon then
	--					local uiSelectIcon = ccui.ImageView:create()
	--					uiSelectIcon:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
	--					t:addChild(uiSelectIcon)
	--					REL:toOther("center","middle",uiSelectIcon,t,0,0)
	--					t.uiSelectIcon = uiSelectIcon
	--				else
	--					t.uiSelectIcon:setVisible(true)
	--				end
	--			end
	--		end
	--	end)

	self:addTouchEventListener(function(t, e)
		if e == ccui.TouchEventType.ended then
			self:enterFightReportWindow()
		end
	end)
end

--- 获取挑战记录详细信息成功
function T:getedFightReportHandler(recordId)
	local data=self._data
	if data then
		if data.id == recordId then
			self:updateView()
		end
	end
end

--- 更新视图
function T:updateView()
	local data=self._data
	if data then
		if data.isRead then
			self.uiBack:setSpriteFrame(ResLoader:getSpriteFrame("mailHasRead.png"))
		else
			self.uiBack:setSpriteFrame(ResLoader:getSpriteFrame("mailNotRead.png"))
		end

		if data.resultType == 1 then
			--进攻胜利
			self.uiTitle:setString(Language:get("ug1323",data.title))
			self.uiRankChange:setString(Language:get("ug1326",math.abs(data.attackOldRank-data.defenceOldRank)))
		elseif data.resultType == 2 then
			--进攻失败
			self.uiTitle:setString(Language:get("ug1325",data.title))
			self.uiRankChange:setString(Language:get("ug1328",""))
		elseif data.resultType == 3 then
			--防守胜利
			self.uiTitle:setString(Language:get("ug1324",data.title))
			self.uiRankChange:setString(Language:get("ug1328",""))
		elseif data.resultType == 4 then
			--防守失败
			self.uiTitle:setString(Language:get("ug1322",data.title))
			self.uiRankChange:setString(Language:get("ug1327",math.abs(data.attackOldRank-data.defenceOldRank)))
		end
		self.uiDes:setString(Language:get("uc82"))

		local date=os.date("*t",data.time)
		self.uiTime:setString(Language:get("uc78",UnitConversion.date(date.month),UnitConversion.date(date.day),UnitConversion.date(date.hour),UnitConversion.date(date.min)))
	end
end

--- 进入战报窗口
function T:enterFightReportWindow()
	local data=self._data
	if data then
		local fightContent = ArenaInfoMgr:getFightReport(data.id)
		if fightContent then
			WindowManager:push(require("src.app.uiScript.components.mail.fightReportContent.FightReportWindow").new(2,data,fightContent))
		else
			require("src.app.communication.arena.GetChallengeFightReportCommand")():exec(
				self._data.id,
				function(state)
					if state == ReturnCode.SUCCESS then
						local fightContent = ArenaInfoMgr:getFightReport(self._data.id)
						WindowManager:push(require("src.app.uiScript.components.mail.fightReportContent.FightReportWindow").new(2,data,fightContent))
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end


	end
end

function T:setData(value)
	if value ~= self._data then
		self._data=value

		self:updateView()
	end
end

function T:getData()
	return self._data
end

return T
