--- 竞技场战报列表窗口
-- @author blank
local T = class("FightRecordListWindow", function()
	return AbstractWindow.new(1)
end)

--- 战报项
T.FightRecordItem=require("src.app.uiScript.components.arena.fightRecord.FightRecordItem")

--- 构造函数
function T:ctor()
	self:init()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 进入场景
function T:onEnter()
	AbstractWindow.onEnter(self)

	self:updateRecordList()
	ArenaInfoMgr:luaAddEventListener(ArenaInfoMgr.EVT_TYPE_CHANGE_FIGHT_RECORD_LIST,self,self.updateRecordList)
end

--- 退出场景
function T:onExit()
	AbstractWindow.onExit(self)

	ArenaInfoMgr:luaRemoveEventListener(ArenaInfoMgr.EVT_TYPE_CHANGE_FIGHT_RECORD_LIST,self,self.updateRecordList)
end

--- 初始化
function T:init()
	self:setWindowTitle(Language:get("ug1329"))

	--边框
	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local uiContentBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(uiContentBack)
	REL:relOther(uiContentBack,self.uiContainer,2,2,2,2)
	self.uiContentBack=uiContentBack

	--邮件列表
	local uiMailList=ccui.ListView:create()
	uiMailList:setTouchEnabled(true)
	uiMailList:setBounceEnabled(true)
	uiMailList:setItemsMargin(8)
	uiMailList:setGravity(ccui.ListViewGravity.centerHorizontal)
	self:addChild(uiMailList)
	REL:relOther(uiMailList,self.uiContainer,4,0,20,4)
	self.uiMailList = uiMailList
end

--- 更新记录列表
function T:updateRecordList()
	self.uiMailList:removeAllItems()

	local recordList=ArenaInfoMgr:getFightRecordList()
	if not recordList then
		return
	end

	local rL={}
	for k,v in pairs(recordList) do
		rL[#rL+1]=v
	end
	table.sort(rL,function(a,b)
		return a.time > b.time
	end)

	for _,v in ipairs(rL) do
		local item=self.FightRecordItem(v)
		self.uiMailList:pushBackCustomItem(item)
	end
end

return T
