--- 竞技场积分商城窗口
-- @author blank
local T = class("IntegralShopWindow", function()
	return AbstractWindow.new(1)
end)

--- 竞技场积分兑换项
T.IntegralShopItem=require("src.app.uiScript.components.arena.integrelShop.IntegralShopItem")

--- 构造函数
function T:ctor()
	self:init()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 进入场景
function T:onEnter()
	AbstractWindow.onEnter(self)

	self:updateBaseInfo()
	self:updateGoodsList()
	ArenaInfoMgr:luaAddEventListener(ArenaInfoMgr.EVT_TYPE_CHANGE_INTEGRAL,self,self.updateBaseInfo)
end

--- 退出场景
function T:onExit()
	AbstractWindow.onExit(self)

	ArenaInfoMgr:luaRemoveEventListener(ArenaInfoMgr.EVT_TYPE_CHANGE_INTEGRAL,self,self.updateBaseInfo)
end

--- 初始化
function T:init()
	self:setWindowTitle(Language:get("ug1340"))

	--边框
	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local uiContentBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(uiContentBack)
	REL:relOther(uiContentBack,self.uiContainer,2,2,2,2)
	self.uiContentBack=uiContentBack

	--积分背景
	local uiIntegralBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("captionBack.png"))
	self:addChild(uiIntegralBack)
	REL:toOther("center","top",uiIntegralBack,self.uiContainer,0,8)
	self.uiIntegralBack=uiIntegralBack

	--积分
	local uiIntegral=XMLLabel()
	uiIntegral:setAlign("center","middle")
	self:addChild(uiIntegral)
	REL:relOther(uiIntegral,uiIntegralBack,0,0,0,0)
	self.uiIntegral=uiIntegral

	--商品列表
	local uiGoodsList=ccui.ListView:create()
	uiGoodsList:setTouchEnabled(true)
	uiGoodsList:setBounceEnabled(true)
	uiGoodsList:setItemsMargin(8)
	uiGoodsList:setGravity(ccui.ListViewGravity.centerHorizontal)
	self:addChild(uiGoodsList)
	REL:relOther(uiGoodsList,self.uiContainer,4,0,96,4)
	self.uiGoodsList = uiGoodsList
end

--- 更新基础信息
function T:updateBaseInfo()
	self.uiIntegral:setString(Language:get("ug1345",ArenaInfoMgr:getIntegral()))
end

--- 更新商品列表
function T:updateGoodsList()
	self.uiGoodsList:removeAllItems()

	local gList=ArenaInfoMgr:getIntegralExchangeList()
	if not gList then
		return
	end

	local itemAddEff=function(item)
		item:setOpacity(0)
		item:runAction(
			cc.FadeIn:create(0.5)
		)
	end

	local i,len=1,#gList
	self:runAction(
		cc.RepeatForever:create(cc.Sequence:create(
			cc.DelayTime:create(0.1),
			cc.CallFunc:create( function()
				if i <= len then
					local item=self.IntegralShopItem(gList[i])
					self.uiGoodsList:pushBackCustomItem(item)
					itemAddEff(item)
				else
					self:stopAllActions()
				end
				i=i+1
			end)
		))
	)
end

return T
