---竞技场挑战项
local T=Class.ArenaRankItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)
end

function T:ctor(data)
	self.data=data

	AbstractUI.ctor(self)

	self:_init()

	self:updateView()
end

function T:_init()
	local f=ResLoader:getSpriteFrame("rankBack.png")
	local fs=f:getOriginalSize()

	self:setContentSize(fs)

	--标题背景
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	REL:toOther("center","middle",uiBack,self,0,0)
	self.uiBack=uiBack

	--			self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--			self:setBackGroundColor(cc.c3b(random(0,255),0,0))
	--			self:setBackGroundColorOpacity(100)

	local left=10

	--列表标题"排名"
	local uiRank=XMLLabel()
	uiRank:setAlign("center","middle")
	uiRank:setContentSize(cc.size(120,36))
	self:addChild(uiRank,2)
	REL:toOther("left","middle",uiRank,self,left,0)
	self.uiRank=uiRank
	left=left+uiRank:getWidth()

	--列表标题"名称"
	local uiPName=XMLLabel()
	uiPName:setAlign("center","middle")
	uiPName:setContentSize(cc.size(240,36))
	self:addChild(uiPName,2)
	REL:toOther("left","middle",uiPName,self,left,0)
	self.uiPName=uiPName
	left=left+uiPName:getWidth()

	--列表标题"等级"
	local uiPLv=XMLLabel()
	uiPLv:setAlign("center","middle")
	uiPLv:setContentSize(cc.size(254,36))
	self:addChild(uiPLv,2)
	REL:toOther("left","middle",uiPLv,self,left,0)
	self.uiPLv=uiPLv
	left=left+uiPLv:getWidth()+4
end

--- 更新视图
function T:updateView()
	local data = self.data or {}
	local rank=data.rank
	
	local cssStyle=CssStyles.default24
	if rank then
		if rank <= 3 then
			local iconUrl,backUrl
			if rank == 1 then
				iconUrl,backUrl,cssStyle="LV1.png","rankFirst.png",CssStyles.rank2
			elseif rank == 2 then
				iconUrl,backUrl,cssStyle="LV2.png","rankSecond.png",CssStyles.rank3
			elseif rank == 3 then
				iconUrl,backUrl,cssStyle="LV3.png","rankThree.png",CssStyles.rank4
			end
			self.uiBack:setSpriteFrame(ResLoader:getSpriteFrame(backUrl))

			local uiIcon=self.uiIcon
			if not uiIcon then
				uiIcon=ccui.ImageView:create()
				self:addChild(uiIcon)
				REL:toOther("center","middle",uiIcon,self.uiRank,0,0)
				self.uiIcon=uiIcon
			else
				uiIcon:setVisible(true)
			end
			uiIcon:loadTexture(iconUrl,ccui.TextureResType.plistType)

			self.uiRank:setVisible(false)
		else
			self.uiRank:setString(tostring(rank))
			self.uiRank:setVisible(true)
		end
	else
		self.uiRank:setString("-")
		self.uiRank:setVisible(true)
	end
	
	self.uiRank:setCssStyle(cssStyle)
	self.uiPName:setCssStyle(cssStyle)
	self.uiPLv:setCssStyle(cssStyle)

	self.uiPName:setString(data.playerName or "")
	self.uiPLv:setString(tostring(data.playerLv) or "0")
end

function T:setData(value)
	if value ~= self.data then
		self.data=value

		self:updateView()
	end
end
function T:getData()
	return self.data
end

return T
