local T = Class.AircraftSelectItem(function() return ccui.Layout:create() end)

function T:def()
	---背景图片
	-- self.uiBack=nil

	---战机
	-- self.uiAircraft=nil

	--- 战机名称
	-- self.uiName=nil

	--- 战机数量
	-- self.uiCount=nil

	--- 战机剩余数量
	-- self.uiRemainingCount=nil

	--- 阵营
	self.camp=Camp.CAMP1

	--- 是否被选中
	self.isSelected=false

	--- 战机数据
	-- self.data=nil
end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	self:setContentSize(cc.size(200,248))

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0,0,0))
	--	self:setBackGroundColorOpacity(100)

	self:setTouchEnabled(true)

	--背景图片
	local uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("aircraftLocSelect.png"))
	self:addChild(uiBack)
	REL:toOther("center","top",uiBack,self,0,0)

	self.uiBack=uiBack

	--战机
	--	local uiAircraft=cc.Sprite:create()
	--	uiAircraft:setScale(0.8)
	--	self:addChild(uiAircraft)
	--	REL:toOther("center","middle",uiAircraft,self,0,40)
	--	self.uiAircraft=uiAircraft

	--战机名称
	local uiName=XMLLabel()
	uiName:setHeight(36)
	uiName:setAlign("center","middle")
	self:addChild(uiName,1)
	REL:relOther(uiName,self,2,2,SIZE_NIL,2)
	self.uiName=uiName

	--战机数量
	local uiCount=XMLLabel()
	uiCount:setHeight(36)
	uiCount:setAlign("center","middle")
	self:addChild(uiCount,1)
	REL:relOther(uiCount,uiBack,46,46,SIZE_NIL,8)
	self.uiCount=uiCount

	--剩余战机数量
	local uiRemainingCount=XMLLabel("999999")
	uiRemainingCount:setHeight(36)
	uiRemainingCount:setAlign("center","middle")
	self:addChild(uiRemainingCount,1)
	REL:relOther(uiRemainingCount,uiBack,46,46,SIZE_NIL,40)
	uiRemainingCount:setVisible(false)
	self.uiRemainingCount=uiRemainingCount


    --战力
	local uiFight=XMLLabel()
    uiFight:setContentSize(cc.size(500,36))
	self:addChild(uiFight)
    REL:toOther("left","top",uiFight,uiBack,15,15)
	self.uiFight=uiFight
    
end

--- 设置当前战机数量
function T:setCount(value)
	self.uiCount:setString(tostring(value))
end

--- 设置剩余战机数量
function T:setRemainingCount(value)
	self.uiRemainingCount:setString(tostring(value))
    local infos = UserInfo.city.aircraftBox.infos
    if infos[self.data.sid] then
        local fight = PlayerInstance:getAircraftFight(infos[self.data.sid],value)
        if fight >= 0 and fight < 1 then
            fight = 1
        end
        self.uiFight:setString(Language:get("uy193",UnitConversion.unitTrans(fight)))
    end
end

--- 设置uifgiht可见性
function T:setUiFightIsVisible(value)
    self.uiFight:setVisible(value)
end


--- 更新战机显示
function T:updateAircraft()
	if self.uiAircraft then
		self.uiAircraft:removeFromParent()
	end

	if self.data then
		local T=GameUtils:getAicraftModelUrl(Camp.CAMP1,self.data.sid)
		if T then
			local o=T()
			o:setScale(0.8)
			self:addChild(o)
			REL:toOther("center","middle",o,self,0,40)
			self.uiAircraft=o
		end
	end
end

function T:updateView()
	local data=self.data
	if data then
		self:updateAircraft()

		local d=Aircraft_temp[data.sid]
		self.uiName:setString(AircraftUtils:getRichName(d))

		local count=data:getFreeingNum()
		self:setCount(count)
		self:setRemainingCount(count)
                
	end
end

function T:setData(value)
	if value ~= self.data then
		self.data=value

		self:updateView()
	end
end

function T:getData()
	return self.data
end

function T:setIsSelected(value)
	if value ~= self.isSelected then
		self.isSelected=value

		if self.isSelected then
			self.uiRemainingCount:setVisible(true)
			self.uiBack:setSpriteFrame(ResLoader:getSpriteFrame("aircraftLocSelected.png"))
		else
			self.uiRemainingCount:setVisible(false)
			self.uiBack:setSpriteFrame(ResLoader:getSpriteFrame("aircraftLocSelect.png"))
		end
	end
end

function T:getIsSelected()
	return self.isSelected
end

function T:setCamp(value)
	if value ~= self.camp then
		self.camp=value

		self:updateView()
	end
end

function T:getCamp()
	return self.camp
end

return T
