local T=class("T",function()
	local t = AbstractWindow.new(1)
	t.super = AbstractWindow
	return t
end)

--- 战机选择项
T.AircraftSelectItem=require("src.app.uiScript.components.army.AircraftSelectItem")

--- 关闭按钮
T.uiCloseButton=nil

--- 标题
T.uiTitle=nil

--- 战机列表背景
T.uiAircreaftListBack=nil

--- 战机列表容器
T.uiAircraftListContainer=nil

--- 战机列表
T.uiAircraftList=nil

--- 当前战机数量
T.uiCurAircraftCount=nil

--- 减少按钮
T.uiRedButton=nil

--- 增加按钮
T.uiIncButton=nil

--- 当前战机数量滑块
T.uiCurAircraftCountSilder=nil

--- 确定按钮
T.uiSureButton=nil

--- 取消按钮
T.uiCancelButton=nil

--- 当前选择的战机项
T.curAircraftItem=nil

--- 可上阵的最大战机数
T.selMaxCount=0

--- 当前选择的数量
T.curSelCount=1

--- 关闭页面时的回调
T._closeCallback=nil

--- 构造函数
function T:ctor(closeCallback,aircraftInfos)
	self._closeCallback=closeCallback
	self.aircraftInfos = aircraftInfos

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
	self:initCompleteHandler()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	self:setWindowTitle(Language:get("ug340"))

	--战机项列表背景
	local uiAircreaftListBack=NeedBack()
	self:addChild(uiAircreaftListBack)
	REL:relOther(uiAircreaftListBack,self.uiContainer,4,4,4,180)
	self.uiBattleListBack=uiAircreaftListBack

	--战机列表项容器
	local uiAircraftListContainer=ccui.ScrollView:create()
	uiAircraftListContainer:setTouchEnabled(true)
	uiAircraftListContainer:setBounceEnabled(true)
	self:addChild(uiAircraftListContainer)
	REL:relOther(uiAircraftListContainer,uiAircreaftListBack,10,10,10,10)
	self.uiAircraftListContainer=uiAircraftListContainer

	--滑块背景
	local uiSliderBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("productSilderBack.png"))
	self:addChild(uiSliderBack)
	REL:toOther("center","bottom",uiSliderBack,self.uiContainer,0,120)
	self.uiSliderBack=uiSliderBack

	--当前战机数量显示
	local uiCurAircraftCount=XMLLabel("0")
	uiCurAircraftCount:setContentSize(cc.size(76,36))
	uiCurAircraftCount:setAlign("center","middle")
	self:addChild(uiCurAircraftCount)
	REL:toOther("left","middle",uiCurAircraftCount,uiSliderBack,8,0)
	self.uiCurAircraftCount=uiCurAircraftCount

	self:initRedAndIncButton()
	self:initCurAircraftCountSlider()

	self:initSureAndCancelButton()

	self.uiAircraftList={}
	self:updateAircraftList()
	self:updateRedAndIncButton()
	self:updateCurAircraftCountSlider()

	--选择第一项
	local firstItem=self.uiAircraftList[1]
	if firstItem then
		self:setCurAircraftItem(firstItem)
	end

    self:refreshUiFightState()
end

--- 刷新战力状态
function T:refreshUiFightState()
    local allChilden = self.uiAircraftListContainer:getChildren()
    for i = 1,#allChilden,1 do
        if self.curAircraftItem == allChilden[i] then
            allChilden[i]:setUiFightIsVisible(true)
        else
            allChilden[i]:setUiFightIsVisible(false)
        end
    end

end

--- 初始化增加和减少按钮
function T:initRedAndIncButton()
	local uiRedButton=BaseButton:createButton(nil,"buttonRed_normal.png")
	self:addChild(uiRedButton)
	REL:toOther("left","middle",uiRedButton,self.uiSliderBack,96,0)
	self.uiRedButton=uiRedButton
	uiRedButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended or e == "longDownTrigger" then
			if self.curSelCount > 1 then
				self.curSelCount=self.curSelCount - 1

				self:updateCurSelAircraftCount()
				self:updateRedAndIncButton()
				self:updateCurAircraftCountSlider()
			end
		end
	end)

	local uiIncButton=BaseButton:createButton(nil,"buttonInc_normal.png")
	self:addChild(uiIncButton)
	REL:toOther("right","middle",uiIncButton,self.uiSliderBack,18,0)
	self.uiIncButton=uiIncButton
	uiIncButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended or e == "longDownTrigger" then
			if self.curSelCount < self.selMaxCount then
				self.curSelCount=self.curSelCount + 1

				self:updateCurSelAircraftCount()
				self:updateRedAndIncButton()
				self:updateCurAircraftCountSlider()
			end
		end
	end)
end

--- 初始化当前战机数量滑块
function T:initCurAircraftCountSlider()
	local uiSlider=Slider("productSilderFore.png","h3","sliderButton.png","sliderButton.png")
	self:addChild(uiSlider)
	REL:relOther(uiSlider,self.uiSliderBack,158,84,8,8)
	self.uiCurAircraftCountSilder=uiSlider
	uiSlider:luaAddEventListener(EVENT_CHANGE,nil,function(t)
		local count=math.floor((self.selMaxCount-1)*t:getValue()/100)+1
		self.curSelCount=count

		self:updateCurSelAircraftCount()
		self:updateRedAndIncButton()
	end)
end

--- 初始确定和取消按钮
function T:initSureAndCancelButton()
	local uiSureButton=BaseButton:getGeneralButton(Language:get("ug101"))
	self:addChild(uiSureButton)
	REL:toOther("right","bottom",uiSureButton,self.uiContainer,60,20)
	self.uiSureButton=uiSureButton
	uiSureButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then

			if self._closeCallback then
				if self.curAircraftItem and self.curSelCount > 0 then
					self._closeCallback({
						sid=self.curAircraftItem:getData().sid,
						count=self.curSelCount
					})
				else
					self._closeCallback()
				end
			end

			WindowManager:pop()

		end
	end)

	local uiCancelButton=BaseButton:getGeneralButton(Language:get("ug102"))
	self:addChild(uiCancelButton)
	REL:toOther("left","bottom",uiCancelButton,self.uiContainer,60,20)
	self.uiCancelButton=uiCancelButton
	uiCancelButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self.curAircraftItem=nil
			self.curSelCount=0
			WindowManager:pop()
		end
	end)
end

--- 更新当前选择的战机数量
function T:updateCurSelAircraftCount()
	self.uiCurAircraftCount:setString(tostring(self.curSelCount))
	if self.curAircraftItem then
		local tNum=self.curAircraftItem:getData():getFreeingNum()
		--self.curAircraftItem:setRemainingCount(tNum-self.curSelCount)
		self.curAircraftItem:setRemainingCount(self.curSelCount)
		self.curAircraftItem:setCount(tNum-self.curSelCount)
        self:refreshUiFightState()
	end
end

--- 刷新增加和减少按钮的状态
function T:updateRedAndIncButton()
	if self.curSelCount <= 1 then
		self.uiRedButton:setEnabled(false)
		self.uiRedButton:setIsGray(true)
	else
		self.uiRedButton:setEnabled(true)
		self.uiRedButton:setIsGray(false)
	end

	if self.curSelCount >= self.selMaxCount then
		self.uiIncButton:setEnabled(false)
		self.uiIncButton:setIsGray(true)
	else
		self.uiIncButton:setEnabled(true)
		self.uiIncButton:setIsGray(false)
	end
end

--- 刷新当前战机数量滑块状态
function T:updateCurAircraftCountSlider()
	if self.selMaxCount <= 1 then
		self.uiCurAircraftCountSilder:setEnabled(false)
	else
		self.uiCurAircraftCountSilder:setEnabled(true)
	end
	if self.curSelCount == self.selMaxCount then
		self.uiCurAircraftCountSilder:setValue(100)
	else
		self.uiCurAircraftCountSilder:setValue((self.curSelCount-1)/(self.selMaxCount-1)*100)
	end
end

--- 创建战机列表中的战机
function T:createAircraftOfList(len)
	local l1=#self.uiAircraftList
	local container = self.uiAircraftListContainer:getInnerContainer()

	local h,w
	if len > l1 then
		for i=l1+1,len,1 do
			local item=self.AircraftSelectItem()

			item:addTouchEventListener(function(t,e)
				if e == ccui.TouchEventType.ended then
					if t == self.curAircraftItem then
						return false
					end
					-- 刷新所有战机显示，最大的还是最大的
					for k,v in pairs(self.uiAircraftList) do
						if v then
							local tNum = v:getData():getFreeingNum()
							v:setCount(tNum)
						end
					end
					self:setCurAircraftItem(t)

				end
			end)
			container:addChild(item)

			self.uiAircraftList[i]=item
		end
	elseif len < l1 then
		for i=l1,len+1,-1 do
			local item=self.uiAircraftList[i]

			item:removeFromParent()
			self.uiAircraftList[i]=nil
		end
	end

	--以下为刷新列表项的位置

	if not h then
		for _, v in pairs(self.uiAircraftList) do
			local s = v:getContentSize()
			w = s.width
			h = s.height
		end
	end
	if not h then
		return
	end

	--项与项之间的间隔

	local INTERVAL=0

	--更新显示的容器size
	local s=self.uiAircraftListContainer:getContentSize()
	local cW=s.width
	--列数
	local colsNum=math.floor(cW/(w+INTERVAL))
	local tW=(w+INTERVAL)*colsNum+INTERVAL
	if tW > cW then
		colsNum=colsNum-1
		tW=(w+INTERVAL)*colsNum+INTERVAL
	end
	local cH=math.ceil(len/colsNum)*(h+INTERVAL)+INTERVAL
	cH=cH<s.height and s.height or cH
	container:setContentSize(cc.size(cW,cH))

	--	container:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	container:setBackGroundColor(cc.c3b(100, 0, 0))
	--	container:setBackGroundColorOpacity(100)

	local offsetX=tW/2

	--更新项的显示位置
	local top
	for i=0,len-1,1 do
		local item=self.uiAircraftList[i+1]

		local m=i%colsNum
		if m==0 then
			top=(i/colsNum)*(h+INTERVAL)+INTERVAL
		end
		REL:toOther("center","top",item,container,(m*(w+INTERVAL)+INTERVAL+w/2)-offsetX,top)
	end
end

--- 刷新战机列表
function T:updateAircraftList()
	local aircrafts = self.aircraftInfos

	local l={}
	for _,v in pairs(aircrafts) do
		--		if v.num > 0 then
		--			l[#l+1]=v
		--		end
		if v:getFreeingNum() > 0 then
			l[#l+1]=v
		end
	end

	table.sort(l,function(x,y) return x.sid > y.sid end)

	self:createAircraftOfList(#l)
	for k,v in pairs(l) do
		local item=self.uiAircraftList[k]
		item:setData(v)
	end
end

--- 设置当前战机项
function T:setCurAircraftItem(aircraftItem)
	if self.curAircraftItem == aircraftItem then
		return
	end

	if self.curAircraftItem then
		self.curAircraftItem:setIsSelected(false)
	end

	aircraftItem:setIsSelected(true)
	local data=aircraftItem:getData()

	local maxAircraftCount=PlayerInstance:getMaxAircraftCount()
	self.selMaxCount=math.min(data:getFreeingNum(),maxAircraftCount)
	self.curSelCount=self.selMaxCount

	self.curAircraftItem=aircraftItem

	self:updateCurSelAircraftCount()
	self:updateRedAndIncButton()
	self:updateCurAircraftCountSlider()
end

return T
