--- 阵形设置
local T=Class.ArmyFormSet(
	function() return ccui.Layout:create() end,
	LuaEventDispatcher2
)

--- 战机位置
T.FormLoc = require("src.app.uiScript.components.army.FormLoc")

function T:def()
	LuaEventDispatcher2.def(self)

	--- 阵形位置列表
	self.formLocList={
		[1]={coordinate=cc.p(196,458),hitArea=nil,formLoc=nil},
		[2]={coordinate=cc.p(364,364),hitArea=nil,formLoc=nil},
		[3]={coordinate=cc.p(528,268),hitArea=nil,formLoc=nil},
		[4]={coordinate=cc.p(110,294),hitArea=nil,formLoc=nil},
		[5]={coordinate=cc.p(276,200),hitArea=nil,formLoc=nil},
		[6]={coordinate=cc.p(444,106),hitArea=nil,formLoc=nil}
	}

	--- 背景图片
	-- self.uiBack=nil

	--- 要布阵的阵营
	self.camp=Camp.CAMP1
end

function T:ctor(camp,aircraftInfos)
	LuaEventDispatcher2.ctor(self)

	self.camp=camp
	self.aircraftInfos = aircraftInfos

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()
end

--- 内存清理
function T:cleanUp()
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(626,382))
	self:setTouchEnabled(false)

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	--背景图片
--	local uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("formBack.png"))
--	self:addChild(uiBack)
--	REL:toOther("left","bottom",uiBack,self,0,0)
--	self.uiBack=uiBack

	self:initFormLocList()
	self:initTouchListener()
end

--- 阵位的数据被改变
function T:formLocDataChangeHandler(item)
	self:luaDispatchEvent("change",item)
end

--- 初始化阵形位置列表
function T:initFormLocList()
	for k,v in ipairs(self.formLocList) do
		local coordinate=v.coordinate

		local x,y=coordinate.x,coordinate.y
		v.hitArea={
			cc.p(x+6,y+88),
			cc.p(x+138,y+12),
			cc.p(x-18,y-102),
			cc.p(x-156,y-22)
		}

		--显示热点区域
--		local dn=cc.DrawNode:create()
--		dn:clear()
--		self:addChild(dn)
--		dn:drawPolygon(v.hitArea,4,cc.c4b(0xff,0x00,0xff,0x44),1,cc.c4b(0xff,0x00,0x00,0x44))

		--战机阵形位置显示项
		local formLoc=self.FormLoc(k,self.camp,self.aircraftInfos)
		formLoc:luaAddEventListener("change",self,self.formLocDataChangeHandler)
		self:addChild(formLoc)
		local s=formLoc:getContentSize()
		formLoc:setPosition(coordinate.x-s.width/2,coordinate.y-s.height/2)
		v.formLoc=formLoc
	end

	--	local tData={
	--		{x=random(100,400),y=random(100,400)},
	--		{x=random(100,400),y=random(100,400)},
	--		{x=random(100,400),y=random(100,400)}
	--	}
	--
	--	print(obj2str(tData))
	--
	--	local triangle=cc.DrawNode:create()
	--	triangle:clear()
	--	self:addChild(triangle)
	--	triangle:drawPolygon(tData,3,cc.c4b(0xff,0x00,0x00,0x44),1,cc.c4b(0xff,0x00,0x00,0x44))
	--
	--	for i=10,20,1 do
	--		local dot=cc.DrawNode:create()
	--		self:addChild(dot)
	--		dot:clear()
	--
	--		local t=MathUtil:randomInTriangle(unpack(tData))
	--		print(obj2str(t))
	--		dot:drawDot(t,2,cc.c4f(0, 1, 0, 1))
	--	end
end

--- 初始化 touch 事件侦听器
function T:initTouchListener()
	local listener = cc.EventListenerTouchOneByOne:create()
	listener:setSwallowTouches(true)

	---按下
	local onTouchBegan = function(t, e)
		local p=t:getLocation()
		local localP=self:convertToNodeSpace(p)

		for k,v in ipairs(self.formLocList) do
			if MathUtil.containsPointInPolygon(localP,v.hitArea) then
				return true
			end
		end

		return false
	end

	---移动
	local onTouchMoved = function(t, e)
		return true
	end

	--- 释放
	local onTouchEnded = function(t, e)
		local p=t:getLocation()
		local localP=self:convertToNodeSpace(p)

		for k,v in ipairs(self.formLocList) do
			if MathUtil.containsPointInPolygon(localP,v.hitArea) then
				local formLoc=v.formLoc
				formLoc:triggerTouch()

				return true
			end
		end

		return false
	end

	local onTouchCanceled = function(t, e)
		return true
	end

	listener:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN)
	listener:registerScriptHandler(onTouchMoved, cc.Handler.EVENT_TOUCH_MOVED)
	listener:registerScriptHandler(onTouchEnded, cc.Handler.EVENT_TOUCH_ENDED)
	listener:registerScriptHandler(onTouchCanceled, cc.Handler.EVENT_TOUCH_CANCELLED)
	local eventDispatcher = self:getEventDispatcher()
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)
end

--- 设置部队数据
function T:setTeam(team)
	if team then
		for k,v in ipairs(self.formLocList) do
			local loc=v.formLoc
			local data=team[k]
			if data and data.sid > 0 and data.count > 0 then
				loc:setData(data)
			else
				loc:setData(nil)
			end
		end
	else
		for k,v in ipairs(self.formLocList) do
			v.formLoc:setData(nil)
		end
	end
end

--- 获取部队数据
function T:getTeam()
	local team={}
	for k,v in ipairs(self.formLocList) do
		local loc=v.formLoc
		if loc then
			team[k]=loc:getData()
		end
	end

	return team
end

return T
