local T=Class.ArmyTeamSetView(
	function()
		return ccui.Layout:create()
	end
)

--- 战机阵形设置
T.ArmyFormSet=require("src.app.uiScript.components.army.ArmyFormSet")

--- 预加载资源列表
T.PRE_RES_LIST={
	"res/images/windowBack3.plist"
}

function T:def()
	--- 最大上阵数量
	-- self.uiMaxAircraft = nil

	--- 当前战力
	-- self.uiCurFight=nil

	--- 增益属性提示
	-- self.uiAddTip=nil

	--- 攻击图标
	-- self.uiAttackIcon=nil

	--- 攻击增益属性
	-- self.uiAttackAdd=nil

	--- 血量图标
	-- self.uiHPIcon=nil

	--- 血量增益属性
	-- self.uiHPAdd=nil

	--- 战机阵形设置
	-- self.uiFormSet=nil

	--- "最大战力"按钮
	-- self.uiMaxFightButton=nil

	--- "进攻"按钮
	-- self.uiFightButton=nil

	--- 表明是驻扎状态还是立即返回状态:在左下角的按钮
	-- self.uiLeftButton = nil
	self.state = false -- 按钮状态标记:true:返回状态 or false:驻扎状态

end

--- 构造函数
function T:ctor(info)
	self.info = info

	ResLoader:syncLoad(self.PRE_RES_LIST)

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self.aircraftInfos = mapping({},UserInfo.city.aircraftBox.infos) -- 这里深拷贝一份所有战机数据，并且只要有战机总数量改变，则这里改变

	self:init()
	self:setData()
end

-- 只要所有战机数量改变，则刷新拷贝函数
function T:finish()
	-- 还要改变对应的busingNum
	local tag = self.info.tag
	if tag == 1 then -- 进入的是防守页面
		local infos = UserInfo.city.aircraftBox.infos
		local aircraftInfos = self.aircraftInfos
		for k,v in pairs(infos) do
			if v then
				aircraftInfos[v.sid].num = v.num
			end
		end

		-- 防御部队
		local defenceAircrafts = UserInfo.city.aircraftBox:getDefend()
		--- 原来的防守战机先给回去
		for i = 1,6,1 do
			if defenceAircrafts[i] and defenceAircrafts[i].sid > 0 then
				aircraftInfos[defenceAircrafts[i].sid].num = aircraftInfos[defenceAircrafts[i].sid].num + defenceAircrafts[i].count
			end
		end
	end

	if tag == 3 then
		local infos = UserInfo.city.aircraftBox.infos
		local aircraftInfos = self.aircraftInfos
		for k,v in pairs(infos) do
			if v then
				aircraftInfos[v.sid].num = v.num
			end
		end
	end

	if tag == 2 then
		local infos = UserInfo.city.aircraftBox.infos
		local aircraftInfos = self.aircraftInfos
		for k,v in pairs(infos) do
			if v then
				aircraftInfos[v.sid].num = v.num
			end
		end

	end

	if tag == 4 then
		local infos = UserInfo.city.aircraftBox.infos
		local aircraftInfos = self.aircraftInfos
		for k,v in pairs(infos) do
			if v then
				aircraftInfos[v.sid].num = v.num
			end
		end

	end

	if tag == 5 then
		local infos = UserInfo.city.aircraftBox.infos
		local aircraftInfos = self.aircraftInfos
		for k,v in pairs(infos) do
			if v then
				aircraftInfos[v.sid].num = v.num
			end
		end

	end


end

--- 进入场景
function T:onEnter()
	AircraftManager:luaAddEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,self,self.finish)
	AircraftManager:luaAddEventListener(AircraftManager.EVT_TYPE_DEFENCE_ARMY,self,self.updateAllState)
	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)

	if BGMgr:isGuide() then
		BGMgr:fire(BGMgr.EVT_ENTER_ARMY_TEAM_SET_VIEW,self.uiFormSet:getTeam())
	end

	FormationManager.formationBox:luaAddEventListener(FormationManager.formationBox.EVT_USE_FORMATION_REFRESH,self,self.setFormation)

end

--- 退出场景
function T:onExit()
	AircraftManager:luaRemoveEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,self,self.finish)
	AircraftManager:luaRemoveEventListener(AircraftManager.EVT_TYPE_DEFENCE_ARMY,self,self.updateAllState)
	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)

	FormationManager.formationBox:luaRemoveEventListener(FormationManager.formationBox.EVT_USE_FORMATION_REFRESH,self,self.setFormation)

end

--- 内存清理
function T:cleanUp()
	ResLoader:unloadReses(self.PRE_RES_LIST)
end

--- 更新所有状态
function T:updateAllState()
	self:finish()
	self:setData()
end

--- 设置阵型的飞机部队
function T:setFormation(aircrafts)
	self.uiFormSet:setTeam(aircrafts)
end


--- 初始化
function T:init()
	REL:relScreen(self,6,6,162,0)

	--背景图片
	local uiBack = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("windowBack3.jpg"))
	self:addChild(uiBack)
	REL:relScreen(uiBack,0,0,142,0)
	self.uiBack = uiBack

	--最大上阵数量
	local uiMaxAircraft = XMLLabel(Language:get("ug322",PlayerInstance:getMaxAircraftCount()))
	uiMaxAircraft:setContentSize(cc.size(240,36))
	self:addChild(uiMaxAircraft)
	REL:toOther("left", "top", uiMaxAircraft, self, 20, 10)
	self.uiMaxAircraft = uiMaxAircraft

	--当前战力
	local uiCurFight=XMLLabel(Language:get("ug323",0))
	uiCurFight:setContentSize(cc.size(240,36))
	self:addChild(uiCurFight)
	REL:toOther("left", "top", uiCurFight, self, 20, 46)
	self.uiCurFight = uiCurFight

	-- 行军时间
	local uiMarchTime = XMLLabel()
	uiMarchTime:setContentSize(cc.size(300,36))
	self:addChild(uiMarchTime)
	REL:toOther("left", "top", uiMarchTime, self, 20, 82)
	self.uiMarchTime = uiMarchTime

	-- 部队载重
	local uiBattleLoad = XMLLabel()
	uiBattleLoad:setContentSize(cc.size(300,36))
	self:addChild(uiBattleLoad)
	REL:toOther("left", "top", uiBattleLoad, self, 20, 118)
	self.uiBattleLoad = uiBattleLoad

	-- 目标位置
	local uiTargetPos = XMLLabel()
	uiTargetPos:setContentSize(cc.size(500,36))
	self:addChild(uiTargetPos)
	REL:toOther("left", "top", uiTargetPos, self, 20, 154)
	self.uiTargetPos = uiTargetPos


	--增益属性提示
	local uiAddTip=XMLLabel(Language:get("ug324"))
	uiAddTip:setContentSize(cc.size(280,36))
	self:addChild(uiAddTip)
	REL:toOther("right", "top", uiAddTip, self, 20, 10)
	self.uiAddTip = uiAddTip


	--攻击图标
	local uiAttackIcon=cc.Sprite:create(IconManager.iconPath.."aircraft/aircraftBaseAttributeIcon/attack.png")
	self:addChild(uiAttackIcon)
	REL:relRect(uiAttackIcon,cc.rect(0,0,80,80),0,0,0,0)
	REL:toOther("left", "top", uiAttackIcon, uiAddTip, 0, uiAddTip:getContentSize().height+4)
	self.uiAttackIcon=uiAttackIcon
	local atkIconS=uiAttackIcon:getContentSize()

	--攻击增益属性标题
	local uiAttackAddCap=XMLLabel(Language:get("ug328",0,0))
	uiAttackAddCap:setAlign("left","middle")
	uiAttackAddCap:setContentSize(cc.size(240,36))
	self:addChild(uiAttackAddCap)
	REL:toOther("left", "top", uiAttackAddCap, uiAttackIcon, 80+8, 0)
	self.uiAttackAddCap=uiAttackAddCap

	--攻击增益属性
	local uiAttackAdd=XMLLabel(Language:get("ug325",0,0))
	uiAttackAdd:setAlign("left","middle")
	uiAttackAdd:setContentSize(cc.size(240,36))
	self:addChild(uiAttackAdd)
	REL:toOther("left", "bottom", uiAttackAdd, uiAttackIcon, 80+8, 0)
	self.uiAttackAdd=uiAttackAdd

	--血量图标
	local uiHPIcon=cc.Sprite:create(IconManager.iconPath.."aircraft/aircraftBaseAttributeIcon/hp.png")
	self:addChild(uiHPIcon)
	REL:relRect(uiHPIcon,cc.rect(0,0,80,80),0,0,0,0)
	REL:toOther("left", "top", uiHPIcon, uiAttackIcon, 0, 80+4)
	self.uiHPIcon=uiHPIcon
	local hpIconS=uiHPIcon:getContentSize()

	--血量增益属性标题
	local uiHPAddCap=XMLLabel(Language:get("ug329",0,0))
	uiHPAddCap:setAlign("left","middle")
	uiHPAddCap:setContentSize(cc.size(240,36))
	self:addChild(uiHPAddCap)
	REL:toOther("left", "top", uiHPAddCap, uiHPIcon, 80+8, 0)
	self.uiHPAddCap=uiHPAddCap

	--血量增益属性
	local uiHPAdd=XMLLabel(Language:get("ug326",0,0))
	uiHPAdd:setAlign("left","middle")
	uiHPAdd:setContentSize(cc.size(240,36))
	self:addChild(uiHPAdd)
	REL:toOther("left", "bottom", uiHPAdd, uiHPIcon, 80+8, 0)
	self.uiHPAdd=uiHPAdd

	--战机阵形设置
	local uiFormSet=self.ArmyFormSet(Camp.CAMP1,self.aircraftInfos)
	uiFormSet:luaAddEventListener("change",self,self.updateCurFight)
	self:addChild(uiFormSet)
	REL:toOther("center", "middle", uiFormSet, self, 0, -100)
	self.uiFormSet=uiFormSet

	--"最大战力"按钮
	local uiMaxFightButton=BaseButton:getGeneralButton(Language:get("ug320"))
	self:addChild(uiMaxFightButton)
	REL:toOther("right", "bottom", uiMaxFightButton, self, 190, 28)
	self.uiMaxFightButton=uiMaxFightButton
	uiMaxFightButton:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			local team = PlayerInstance:getMaxFightTeam(self.aircraftInfos)
			uiFormSet:setTeam(team)

			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_ARMY_SET_MAX_FIGHT_BUTTON)
			end
		end
	end )

	-- 一键撤防按钮
	local uiBackButton=BaseButton:getGeneralButton(Language:get("uc316"),4)
	self:addChild(uiBackButton)
	REL:toOther("right", "bottom", uiBackButton, self, 5, 28)
	self.uiBackButton=uiBackButton
	uiBackButton:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			uiFormSet:setTeam(nil)
		end
	end )


	--"进攻"按钮
	local uiFightButton=BaseButton:getGeneralButton(Language:get("ug321"),2)
	self:addChild(uiFightButton)
	REL:toOther("right", "bottom", uiFightButton, self, 5, 28)
	self.uiFightButton=uiFightButton
	uiFightButton:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_ARMY_SET_FIGHT_BUTTON)
			end

			self:uiFightButtonTouchHandler()
		end
	end )

	--"默认阵型"按钮
	local uiDefaultFormation=BaseButton:getGeneralButton(Language:get("uc944"),2)
	self:addChild(uiDefaultFormation)
	REL:toOther("right", "bottom", uiDefaultFormation, self, 190 + 185, 28)
	self.uiDefaultFormation=uiDefaultFormation
	uiDefaultFormation:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			local formationBox = FormationManager.formationBox
			-- 但是阵型不能超过战机数
			if formationBox:judgeAircraftNumIsEngough(formationBox.defaultFormationId) == true then
				local descripe = Language:get("uc948")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

			else
				formationBox:useFormation(formationBox.defaultFormationId)
				local descripe = Language:get("uc958")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

			end

		end
	end )

	-- 感叹号
	local btnInfo = Button.new("false","false")
	btnInfo:setButtonState("infoButton_normal.png","iconButton_general_down.png")
	self:addChild(btnInfo)
	REL:toOther("center","bottom",btnInfo,uiDefaultFormation,0,50)
	self.btnInfo = btnInfo
	btnInfo:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			-- 弹出阵型窗口
			local layout = require("src.app.uiScript.components.army.fromation.FormationPopWindow").new(self.uiFormSet:getTeam())
			local muialter = MUIAlter.show(
				{
					title = Language:get("uc950"),
					info = layout,
					flag = 4,
					isShowCloseButton = true,
					callback = function(flag)

					end
				}
			)
			layout:setMUIAlter(muialter)

		end
	end )

	-- 按钮： 玩家：不能驻留，直接返回，npc：可以驻留
	local uiPlayerOrNpc = Button.new("false","false")
	uiPlayerOrNpc:setButtonState("armyQuarteringIcom.png","armyQuarteringIcom.png")
	self:addChild(uiPlayerOrNpc)
	REL:toOther("left", "bottom", uiPlayerOrNpc, self, 10, 40)
	self.uiPlayerOrNpc = uiPlayerOrNpc
	uiPlayerOrNpc:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			if self.state == false then
				-- 是否将出征状态更换为进攻胜利后直接返回基地
				uiPlayerOrNpc:loadTextures("armyAttackIcon.png", "armyAttackIcon.png", "",ccui.TextureResType.plistType)
				self.state = true
				local descripe = Language:get("uc669")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

			else
				-- 是否将出征状态更换为进攻胜利后驻留采集资源
				uiPlayerOrNpc:loadTextures("armyQuarteringIcom.png", "armyQuarteringIcom.png", "",ccui.TextureResType.plistType)
				self.state = false
				local descripe = Language:get("uc670")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
			end
		end
	end)

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_ARMY_SET_MAX_FIGHT_BUTTON,uiMaxFightButton)
		BGMgr:regGuideObj(BGMgr.TGR_ARMY_SET_FIGHT_BUTTON,uiFightButton)
	end
end

function T:uiFightButtonTouchHandler()


	local team=self.uiFormSet:getTeam()
	local num = 0
	for k,v in pairs(team) do
		if v then
			num = num + 1
		end
	end
	if not team or num < 1 then
		MUIAlter.show({
			info=Language:get("ug327")
		})
		return
	end

	local tag = self.info.tag
	local detailInfo = self.info.detailInfo

	if tag == 5 then
		-- 首次消耗
		local id = detailInfo.id
		if SupplyLineManager:judgeEnergyIsCostBySid(id) == false then
			-- 第一次能量未消耗
			if PlayerInstance:getPlayerEnergy() > 0 then
				require("src.app.controler.enterFight.EnterSupplyLineFightCommand")(id,team)
			else
				self:pointNotEnough()
			end
		else
			require("src.app.controler.enterFight.EnterSupplyLineFightCommand")(id,team)
		end
	else
		if PlayerInstance:getPlayerEnergy() > 0 then
			if tag == 2 then
				--- 进入战斗
				require("src.app.controler.enterFight.EnterChapterFightCommand")(detailInfo.sid,team)
			elseif tag == 3 then
				if BGMgr:isGuide() then
					BGMgr:fire(BGMgr.EVT_ATTACK_GUIDE_WORLD_MAP_RES_LOC)

					WindowManager:pop()

					Cocos2dxUtils:timeOut(function()
						local descripe = Language:get("uc230",detailInfo.x,detailInfo.y)
						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
					end,0)

					return
				end

				-- 派遣任务
				if detailInfo.id > 0  and BuffQueueInfoMgr:checkActive(13) then -- 并且还有防护罩
					local function confirm()
						local function finish()
							WindowManager:pop()
						end
						Command:sendArmy(detailInfo, self.state,team,finish)
					end
					MUIPop.MUIImmediate(Language:get("uc214"),confirm)
				else
					if detailInfo.id > 0 then
						if ArmyTaskQueueManager:hasPlayerBattle(detailInfo) then
							MUIPop.NotSendArmyAgain()
							return
						end
					else
						if ArmyTaskQueueManager:hasNpcBattle(detailInfo) then
							MUIPop.NotSendArmyAgain()
							return
						end
					end

					local function finish()
						WindowManager:pop()
					end
					Command:sendArmy(detailInfo, self.state,team,finish)
				end
			elseif tag == 4 then
				-- 打运输线
				local detailInfo = self.info.detailInfo
				local id = detailInfo.id
				require("src.app.controler.enterFight.EnterTransportLineFightCommand")(id,team)
				-- 防守
			end
		else
			self:pointNotEnough()
		end

	end



end

--- 精力点不够的处理逻辑
function T:pointNotEnough()
	-- 后面要读配置，根据vip等级得到一个最大今日的精力点次数
	local vipPoint = VipManager.getVipPoint()
	local dailyPoint = DailyStates:getPointCount()
	if dailyPoint + 1 > vipPoint then
		local describe1 = Language:get("uc317",UserInfo.vipLevel)
		local describe2 = Language:get("uc318",UserInfo.vipLevel,vipPoint)
		local describe3 = Language:get("uc319")

		local layout = VipTipsInfo.new(describe1,describe2,describe3)

		MUIAlter.show({
			info = layout,
			size = 30,
			flag = 1,
			confirmText = Language:get("uc332"),
			callback = function() -- 转到vip界面
				local dd = 3
			end
		})

		return
	end

	local costGems = DailyStates:buyPointCostGems()

	local function confirm()
		local gems = UserInfo.gems
		if costGems > gems then
			-- 钻石不足,-- 弹出充值页面
			MUIPop.MUIToReCharge()
			return
		end

		BuyEnergyCommand.new():exec(function(s)
			if s == ReturnCode.SUCCESS then    -- 成功
				MUIAlter_singleLine.show( {info = Language:get("fy1009"),showSecond = 1 } )
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end)
	end

	MUIAlter.show({
		info = Language:get("uc293",costGems),
		size = 30,
		flag = 3,
		callback = function(flag)
			if flag == FLAG_OK then
				confirm()
			end
		end
	})
end


function T:setData()
	local tag = self.info.tag
	local detailInfo = self.info.detailInfo
	if tag == 3 then
		self.uiMarchTime:setVisible(true)
		self.uiBattleLoad:setVisible(true)
		self.uiTargetPos:setVisible(true)

		self.uiPlayerOrNpc:setVisible(true)


		local martchTime = ArmyTaskQueueManager:computeBattleTime(detailInfo.x,detailInfo.y,UserInfo.city.worldPositionX,UserInfo.city.worldPositionY)
		self.uiMarchTime:setString(Language:get("uc198",UnitConversion.handleTime4(martchTime)))
		self.uiBattleLoad:setString(Language:get("uc199",0))
		self.uiTargetPos:setString(Language:get("uc200",detailInfo.x,detailInfo.y))

		local npcType = detailInfo.id
		if npcType == 0 then -- npc
			local value = SetStates.setCommonState:getClosedValue(SetStates.setCommonState.CLOSE_ATTACK_MINE)
			if value then
				self.state = true
				self.uiPlayerOrNpc:loadTextures("armyAttackIcon.png", "armyAttackIcon.png", "",ccui.TextureResType.plistType)
				self.uiPlayerOrNpc:setTouchEnabled(true)
			else
				self.state = false
				self.uiPlayerOrNpc:loadTextures("armyQuarteringIcom.png", "armyQuarteringIcom.png", "",ccui.TextureResType.plistType)
				self.uiPlayerOrNpc:setTouchEnabled(true)
			end

		else -- 玩家
			self.state = true
			self.uiPlayerOrNpc:loadTextures("armyAttackIcon.png", "armyAttackIcon.png", "",ccui.TextureResType.plistType)
			self.uiPlayerOrNpc:setTouchEnabled(false)
		end

		-- 默认为最大战力
		local maxTeam = PlayerInstance:getMaxFightTeam(self.aircraftInfos)
		self.uiFormSet:setTeam(maxTeam)

	else
		self.uiMarchTime:setVisible(false)
		self.uiBattleLoad:setVisible(false)
		self.uiTargetPos:setVisible(false)

		self.uiPlayerOrNpc:setVisible(false)
	end

	if tag == 1 then
		REL:toOther("left", "bottom", self.uiMaxFightButton, self, 20, 28)
		REL:toOther("right", "bottom", self.uiBackButton, self, 20, 28)

	elseif tag == 3 then
	else
		REL:toOther("left", "bottom", self.uiDefaultFormation, self, 5, 28)
		REL:toOther("center", "bottom", self.uiMaxFightButton, self, 0, 28)
		REL:toOther("center","bottom",self.btnInfo,self.uiDefaultFormation,0,50)
	end

	if tag == 1 then
		self.uiFightButton:setVisible(false)
		-- 设置防御部队
		local team = UserInfo.city.aircraftBox:getDefend()
		self.uiFormSet:setTeam(team)

		--- 原来的防守战机先给回去
		local defenceAircrafts = team
		local aircraftInfos = self.aircraftInfos
		for i = 1,6,1 do
			if defenceAircrafts[i] and defenceAircrafts[i].sid > 0 then
				aircraftInfos[defenceAircrafts[i].sid].num = aircraftInfos[defenceAircrafts[i].sid].num + defenceAircrafts[i].count     -- 里面没事件
			end
		end

		self.uiDefaultFormation:setVisible(false)
		self.btnInfo:setVisible(false)
	else
		self.uiBackButton:setVisible(false)
	end

	if tag == 2 then -- 关卡，如果是再一次从关卡进去的话，要更新上一次最新的上阵战机
		local aircraftInfos = self.aircraftInfos
		local team = BattlesInfoMgr:getTeam()
		if team then
			self.uiFormSet:setTeam(team)  -- 这里就设置了busingNum的数量，不用重新设置
		else -- 默认为最大战力
			local maxTeam = PlayerInstance:getMaxFightTeam(self.aircraftInfos)
			self.uiFormSet:setTeam(maxTeam)
		end
	end

	if tag == 4 then -- 运输线，如果是再一次从关卡进去的话，要更新上一次最新的上阵战机
		local aircraftInfos = self.aircraftInfos
		local team = TransportLineManager:getSelCampaign()
		if team then
			self.uiFormSet:setTeam(team)  -- 这里就设置了busingNum的数量，不用重新设置
		else -- 默认为最大战力
			local maxTeam = PlayerInstance:getMaxFightTeam(self.aircraftInfos)
			self.uiFormSet:setTeam(maxTeam)
		end
	end

	if tag == 5 then -- 挑战线，如果是再一次从关卡进去的话，要更新上一次最新的上阵战机
		local aircraftInfos = self.aircraftInfos
		local team = SupplyLineManager:getSelCampaign()
		if team then
			self.uiFormSet:setTeam(team)  -- 这里就设置了busingNum的数量，不用重新设置
		else -- 默认为最大战力
			local maxTeam = PlayerInstance:getMaxFightTeam(self.aircraftInfos)
			self.uiFormSet:setTeam(maxTeam)
		end
	end

end

--- 更新当前战力:根据选择的阵型来刷新数据
function T:updateCurFight()
	local team=self.uiFormSet:getTeam()
	if team then
		local city=UserInfo.city

		local fight,allAtkB,allAtcA,allHPB,allHPA=0,0,0,0,0
		for k,v in pairs(team) do
			local c=v.count
			fight=fight+PlayerInstance:getAircraftFight(v,c)

			local d=Aircraft_temp[v.sid]

			local atkB=d.attack
			local atcA=PlayerInstance:getAircraftAttack(v)-atkB
			allAtkB,allAtcA=allAtkB+atkB*c,allAtcA+atcA*c

			local hpB=d.hp
			local hpA=PlayerInstance:getAircraftHp(v)-hpB
			allHPB,allHPA=allHPB+hpB*c,allHPA+hpA*c
		end

		if fight >= 0 and fight < 1 then
			fight = 1
		else
			fight = math.floor(fight)
		end

		self.uiCurFight:setString(Language:get("ug323",UnitConversion.unitTrans(fight)))
		self.uiAttackAdd:setString(Language:get("ug325",math.floor(allAtkB),math.floor(allAtcA)))
		self.uiHPAdd:setString(Language:get("ug326",math.floor(allHPB),math.floor(allHPA)))

		local allLoad = ArmyTaskQueueManager:getStationLoad(team)
		if self.uiBattleLoad then
			self.uiBattleLoad:setString(Language:get("uc199",UnitConversion.unitTrans(allLoad)))
		end

	end
end

return T
