--- 阵形位置
local T=Class.FormLoc(
	function() return ccui.Layout:create() end,
	LuaEventDispatcher2
)

--- 战机选择视图
T.AircraftSelectWindow=require("src.app.uiScript.components.army.AircraftSelectWindow")

function T:def()
	LuaEventDispatcher2.def(self)

	--- 位置索引
	--self.loc=nil

	--- 阵营
	self.camp=Camp.CAMP1

	--- 数据
	--self.data=nil
end

function T:ctor(loc,camp,aircraftInfos)
	self.loc=loc
	self.camp=camp
	self.aircraftInfos = aircraftInfos

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	BaseButton:extend(self)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()
	if self.data then
		self.aircraftInfos[self.data.sid]:setBusingNum(0)
	end
end

--- 内存清理
function T:cleanUp()
	self:releaseEventListeners()
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(224,114))
	self:setTouchEnabled(false)

	--背景图片
	local uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("formLocBack.png"))
	self:addChild(uiBack)
	REL:toOther("center","bottom",uiBack,self,-6,-48)
	--	uiBack:setOpacity(150)
	self.uiBack=uiBack

	local loc=self.loc or 1
	if self.loc < 1 then
		loc=1
	elseif self.loc > 6 then
		loc=6
	end
	local uiLocNum=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("formLocNum_"..loc..".png"))
	self:addChild(uiLocNum)
	REL:toOther("center","middle",uiLocNum,uiBack,-4,20)
	self.uiLocNum=uiLocNum

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	self:toUnaddStatus()
end

--- 初始化已添加状态
function T:initAddedStatus()
	local c=ccui.Layout:create()
	self:addChild(c)
	REL:relOther(c,self,0,0,0,0)

	--战机名称背景
	local uiNameBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("aircraftNameFormBack.png"))
	c:addChild(uiNameBack,1)
	REL:toOther("left","bottom",uiNameBack,self,-20,-40)

	--战机数量
	local uiCount=XMLLabel()
	uiCount:setAlign("center","middle")
	c:addChild(uiCount,2)
	REL:relOther(uiCount,uiNameBack,0,0,0,24)
	self.uiCount=uiCount

	--战机名称
	local uiName=XMLLabel()
	uiName:setAlign("center","middle")
	c:addChild(uiName,3)
	REL:relOther(uiName,uiNameBack,0,0,22,0)
	self.uiName=uiName

	--	uiCount:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiCount:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiCount:setBackGroundColorOpacity(100)

	--删除图标
	local uiRmIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("removeAircraft.png"))
	c:addChild(uiRmIcon,4)
	REL:toOther("right","middle",uiRmIcon,self,0,0)

	self.uiAddedStatusContainer=c
end

--- 初始化未添加状态
function T:initUnaddStatus()
	local c=ccui.Layout:create()
	self:addChild(c)
	REL:relOther(c,self,0,0,0,0)

	--提示文本
	--	local uiTip=XMLLabel()
	--	uiTip:setHAlign("center")
	--	uiTip:setVAlign("middle")
	--	c:addChild(uiTip)
	--	REL:relOther(uiTip,self,2,2,2,2)
	--	self.uiTip=uiTip

	self.uiUnaddStatusContainer=c
end

--- 切换到已添加状态
function T:toAddedStatus()
	if self.uiUnaddStatusContainer then
		self.uiUnaddStatusContainer:setVisible(false)
	end

	if self.uiAddedStatusContainer then
		self.uiAddedStatusContainer:setVisible(true)
	else
		self:initAddedStatus()
	end

	self:updateAircraft()
	local data=self.data
	if data then
		local d=Aircraft_temp[data.sid]

		self.uiName:setString(AircraftUtils:getRichName(d))
		self.uiCount:setString(data.count)
	end
end

--- 切换到未添加状态
function T:toUnaddStatus()
	if self.uiAddedStatusContainer then
		self.uiAddedStatusContainer:setVisible(false)
	end

	if self.uiUnaddStatusContainer then
		self.uiUnaddStatusContainer:setVisible(true)
	else
		self:initUnaddStatus()
	end
end

--- 刷新视图
function T:updateView()
	if self.data then
		self:toAddedStatus()
	else
		self:toUnaddStatus()
	end
end

--- 更新战机显示
function T:updateAircraft()
	if self.uiAircraft then
		self.uiAircraft:removeFromParent()
	end

	if self.data then
		local T=GameUtils:getAicraftModelUrl(self.camp,self.data.sid)
		if T then
			local o=T()
			o:setScale(0.8)
			self.uiAddedStatusContainer:addChild(o)
			REL:toOther("center","middle",o,self,-6,10)
			self.uiAircraft=o
		end
	end
end

--- 触发点击
function T:triggerTouch()
	if self.data then
		self:setData(nil)
		return
	end

	local oldData=self.data
	self:setData(nil)

	local aircraftSelectWindow=self.AircraftSelectWindow.new(function(data)
		if data then
			self:setData(data)
		else
			self:setData(oldData)
		end
	end,self.aircraftInfos)
	WindowManager:push(aircraftSelectWindow)
end

--- 设置数据
function T:setData(value)
	if value ~= self.data then
		if self.data then
			self.aircraftInfos[self.data.sid]:toFreeingNum(self.data.count)
		end

		self.data=value

		if self.data then
			self.aircraftInfos[self.data.sid]:toBusingNum(self.data.count)
		end

		self:updateView()

		self:luaDispatchEvent("change",self)
	end
end

--- 获取数据
function T:getData()
	return self.data
end

function T:setCamp(value)
	if value ~= self.camp then
		self.camp=value

		self:updateView()
	end
end

function T:getCamp()
	return self.camp
end

return T
