--- 战机修复项
local T = class("T",function() return ccui.Layout:create() end)

function T:ctor(repairItem)
    self.repairItem = repairItem

    self:setTouchEnabled(true)

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

    local _widget = ListItem4.new()
    self.size = _widget:getContentSize()
    self:setContentSize(self.size)
    _widget:setListItemAttribute(
        "H",
        {"label"},
        {{"moneyFixSingleButton_normal.png","diamondFixSingleButton_normal.png","false","false"},{"diamondFixSingleButton_normal.png","diamondFixSingleButton_normal.png","false","false"}}
    )
    self:addChild(_widget)
    REL:toOther("left","top",_widget,self,7,0)
    self._widget = _widget


    -- 得到的控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
    -- 按钮回调设置
    self:SetButton()

end

--- 进入场景
function T:onEnter()
    
end

--- 退出场景
function T:onExit()
    
end

--- 内存清理
function T:cleanUp()
    
end

function T:GetWidget()
    -- 资源头像
    self._imgHead = self._widget.leftHead
    
    -- 钻石
    self._btnDiamond = self._widget.button2
    self._btnDiamond:setName("money")
    REL:toOther("right","bottom",self._btnDiamond,self._widget.back,155,10)

    -- 金币
    self._btnMoney = self._widget.button1
    self._btnDiamond:setName("diamond")
    REL:toOther("right","bottom",self._btnMoney,self._widget.back,10,10)


    -- 名字（富文本）
    self._labelName = self._widget.title

    -- 当前拥有
    self._labelNowNeed = self._widget:getLabel(1)

    --- 金币修复文本
    local uiMoneyText = XMLLabel()
    uiMoneyText:setContentSize(cc.size(300,27))
	uiMoneyText:setHAlign("center")
	uiMoneyText:setVAlign("middle")
	self._btnMoney:addChild(uiMoneyText)
	REL:toOther("center","middle",uiMoneyText,self._btnMoney,-36,-15)
	self.uiMoneyText = uiMoneyText

    --- 钻石修复文本
    local uiDiamondText = XMLLabel()
    uiDiamondText:setContentSize(cc.size(300,27))
	uiDiamondText:setHAlign("center")
	uiDiamondText:setVAlign("middle")
	self._btnDiamond:addChild(uiDiamondText)
	REL:toOther("center","middle",uiDiamondText,self._btnDiamond,-35,-11)
	self.uiDiamondText = uiDiamondText
end

function T:SetData()
    local repairItem = self.repairItem

	local dt=Aircraft_temp[repairItem.sid]
    self._widget:setString(self._labelName,AircraftUtils:getRichName(dt))

    local iconPath = IconManager.iconPath
    self._imgHead:loadTexture(iconPath .. dt.icon)
    local num = repairItem.num
    self._widget:setString(self._labelNowNeed,Language:get("uc224",num))

    local diamond = BuildingDiamondCalculation:repairSingleAirGems(repairItem.sid)
    local money = BuildingDiamondCalculation:repairSingleAirMoney(repairItem.sid)

    self.uiMoneyText:setString(Language:get("uc225",UnitConversion.unitTrans(money)))
    self.uiDiamondText:setString(Language:get("uc225",diamond))

end


function T:SetButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then            
            local name = sender:getName()
            if name == "diamond" then
                local payState = SetStates.setPayState
                local value = payState:getClosedValue(payState.CLOSE_DIAMOND_REPAIR)

                local allDiamond = BuildingDiamondCalculation:repairSingleAirGems(self.repairItem.sid)
                if value then
                    Command:repairSingleAircraft(self.repairItem.sid,true)
                else
                    local info = Language:get("uc847",allDiamond)
                    local layout = DiamondPopInfo.new(info)
                    local function confirm()
                        SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_DIAMOND_REPAIR)
                        if layout.judge == true then
                            Command:SetPayCommand()
                        end
                        Command:repairSingleAircraft(self.repairItem.sid,true)
                    end
                    MUIPop.DiamondPopInfo(layout,confirm)
                end

                
            else
                Command:repairSingleAircraft(self.repairItem.sid,false)
            end
        end
    end
    self._btnDiamond:addTouchEventListener(callback) 
    self._btnMoney:addTouchEventListener(callback) 
end


return T
