--- 战机修复视图
-- @author blank
local T = Class.AircraftFixView(function() return ccui.Layout:create() end)

--- 使用金币修复全部战机按钮
T.MoneyFixAllButton=require("src.app.uiScript.components.army.aircraftFix.MoneyFixAllButton")

--- 使用钻石修复全部战机按钮
T.DiamdondFixAllButton=require("src.app.uiScript.components.army.aircraftFix.DiamdondFixAllButton")

--- 战机修复项
T.AircraftFixItem=require("src.app.uiScript.components.army.aircraftFix.AircraftFixItem")

--- 定义成员变量
function T:def()
--- 全部修复提示
-- self.uiAllFixTip=nil

--- 使用钻石修复按钮
--self.uiDiamondFixButton=nil

--- 使用游戏币修复按钮
--self.uiMoneyFixButton=nil

--- 需要修复战机列表
--self.uiNeedFixAircraftList=nil

--- 下边框
-- self.uiBottomBorder=nil

--- 修复说明
-- self.uiFixComment=nil
end

--- 构造函数
function T:ctor()
	self:setTouchEnabled(true)

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then

				self:cleanUp()
			end
		end
	)

	self:init()
	self:addListView()
	self:setData()

end

--- 进入场景
function T:onEnter()
	AircraftManager:luaAddEventListener(AircraftManager.EVT_TYPE_REPAIR_ARMY,self,self.refresh)
    -- 监听断线重连，刷新页面
    ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_TYPE_RESET,self,self.refresh)
end

--- 退出场景
function T:onExit()
	AircraftManager:luaRemoveEventListener(AircraftManager.EVT_TYPE_REPAIR_ARMY,self,self.refresh)
    -- 监听断线重连，刷新页面
    ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_TYPE_RESET,self,self.refresh)
end

--- 内存清理
function T:cleanUp()
end

--- 根据损失的飞机部队改变刷新数据
function T:refresh()
	self:addListView()
    self:setData()
end

--- 初始化
function T:init()
	REL:relScreen(self,6,6,162,0)

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	--全部修复提示
	local uiAllFixTip=XMLLabel(Language:get("ug361"))
	uiAllFixTip:setHAlign("left")
	uiAllFixTip:setVAlign("middle")
	self:addChild(uiAllFixTip)
	REL:toOther("left","top",uiAllFixTip,self,20,90)
	self.uiAllFixTip=uiAllFixTip

	--使用金币修复按钮
	local uiMoneyFixButton=self.MoneyFixAllButton()
	self:addChild(uiMoneyFixButton)
	REL:toOther("right","top",uiMoneyFixButton,self,10,10)
	self.uiMoneyFixButton=uiMoneyFixButton
	uiMoneyFixButton.button:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			Command:repairAllAircraft(false)
		end
	end )

	-- 金币修复文本
	local uiMoneyText = XMLLabel()
	uiMoneyText:setContentSize(cc.size(300,27))
	uiMoneyText:setHAlign("center")
	uiMoneyText:setVAlign("middle")
	uiMoneyFixButton.button:addChild(uiMoneyText)
	REL:toOther("center","middle",uiMoneyText,uiMoneyFixButton.button,20,27)
	self.uiMoneyText = uiMoneyText



	--使用钻石修复按钮
	local uiDiamondButton = self.DiamdondFixAllButton()
	self:addChild(uiDiamondButton)
	REL:toOther("right","top",uiDiamondButton,self,220,0)
	self.uiDiamondButton=uiDiamondButton
	uiDiamondButton.button:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
            local payState = SetStates.setPayState
            local value = payState:getClosedValue(payState.CLOSE_DIAMOND_REPAIR)

            local allDiamond = BuildingDiamondCalculation:repairAllAirGems()
            if allDiamond == 0 then
                Command:repairAllAircraft(true)
                return
            end
            if value then
                Command:repairAllAircraft(true)
            else
                local info = Language:get("uc848",allDiamond)
                local layout = DiamondPopInfo.new(info)
                local function confirm()
                    SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_DIAMOND_REPAIR)
                    if layout.judge == true then
                        Command:SetPayCommand()
                    end
                    Command:repairAllAircraft(true)
                end
                MUIPop.DiamondPopInfo(layout,confirm)
            end

			
		end
	end )

	-- 钻石修复文本
	local uiDiamondText = XMLLabel()
	uiDiamondText:setContentSize(cc.size(300,27))
	uiDiamondText:setHAlign("center")
	uiDiamondText:setVAlign("middle")
	uiDiamondButton.button:addChild(uiDiamondText)
	REL:toOther("center","middle",uiDiamondText,uiDiamondButton.button,20,26)
	self.uiDiamondText = uiDiamondText


	--战机列表
	local uiNeedFixAircraftList=ccui.ListView:create()
	uiNeedFixAircraftList:setBounceEnabled(true)
	uiNeedFixAircraftList:setTouchEnabled(true)
	self:addChild(uiNeedFixAircraftList)
	REL:relOther(uiNeedFixAircraftList,self,0,0,140,100)
	self.uiNeedFixAircraftList=uiNeedFixAircraftList

	--	uiNeedFixAircraftList:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiNeedFixAircraftList:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiNeedFixAircraftList:setBackGroundColorOpacity(100)


	--下边框
	local uiBottomBorder=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("fixViewBottomBorder.png"),cc.rect(118,0,1,105))
	self:addChild(uiBottomBorder)
	uiBottomBorder:setContentSize(cc.size(1,105))
	REL:relOther(uiBottomBorder,self,0,0,SIZE_NIL,0)
	
	local uiFixComment=XMLLabel(Language:get("ug362"))
	uiFixComment:setAlign("center","middle")
	self:addChild(uiFixComment)
	REL:relOther(uiFixComment,uiBottomBorder,10,10,24,40)

	--	uiFixComment:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiFixComment:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiFixComment:setBackGroundColorOpacity(100)
end

function T:setData()
	self.uiMoneyText:setString(Language:get("uc223",UnitConversion.unitTrans(BuildingDiamondCalculation:repairAllAirMoney())))
	self.uiDiamondText:setString(Language:get("uc223",BuildingDiamondCalculation:repairAllAirGems()))
end


function T:addListView()
	self.uiNeedFixAircraftList:removeAllItems()

	local repairAircrafts = UserInfo.city.aircraftBox:getRepair()
	for k,v in pairs(repairAircrafts) do
		if v and v.num > 0 then
			local item = self.AircraftFixItem.new(v)
			self.uiNeedFixAircraftList:pushBackCustomItem(item)
		end
	end
    
end


return T
