--- 部队详情窗口
local T = class("ArmyWindow", function()
	return AbstractWindow.new(1)
end)

--- 这一项的数据
T.queueInfo = queueInfo


function T:ctor(queueInfo)
	self.queueInfo = queueInfo

	--- 得到控件
	self:_getWidget()

	--- 显示数据
	self:_showData()


	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 得到控件
function T:_getWidget()
	-- 背景图片
	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
	REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

	-- 部队状态
	local battleState = XMLLabel()
	battleState:setContentSize(cc.size(300,36))
	self:addChild(battleState)
	REL:toOther("left", "top", battleState, viewBack, 20, 20)
	self.battleState = battleState

	-- 行军时间
	local uiMarchTime = XMLLabel()
	uiMarchTime:setContentSize(cc.size(300,36))
	self:addChild(uiMarchTime)
	REL:toOther("left", "top", uiMarchTime, viewBack, 20, 50)
	self.uiMarchTime = uiMarchTime

	-- 部队载重
	local uiBattleLoad = XMLLabel()
	uiBattleLoad:setContentSize(cc.size(300,36))
	self:addChild(uiBattleLoad)
	REL:toOther("left", "top", uiBattleLoad, viewBack, 20, 80)
	self.uiBattleLoad = uiBattleLoad

	--- 兵力信息背景图片
	local troopBack = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("taskTagBack.png"),"h3")
	self:addChild(troopBack)
	troopBack:setContentSize(cc.size(640 - 12,43)) -- 宽度到时来做适配
	REL:toOther("center", "top", troopBack, viewBack, 0, 130)
	self.troopBack = troopBack

	-- 兵力文本
	local troopText = XMLLabel()
	troopText:setContentSize(cc.size(300,36))
	troopText:setVAlign("middle")
	troopText:setHAlign("center")
	self:addChild(troopText)
	REL:toOther("center", "middle", troopText, troopBack, 0, 0)
	self.troopText = troopText

	--- 飞机详情的背景图片
	local needListBack = NeedBack()
	needListBack:setContentSize(640 - 20,650)
	self:addChild(needListBack)
	REL:toOther("center", "top", needListBack, troopBack, 0, troopBack:getContentSize().height + 2)
	self.needListBack = needListBack
end


--- 显示数据
function T:_showData()
	local queueInfo = self.queueInfo
	local status = self.queueInfo.status

	self:setWindowTitle(Language:get("uc221"))

	if status == 1 then
		self.battleState:setString(Language:get("uc216"))
	elseif status == 2 then
		self.battleState:setString(Language:get("uc218"))
	else
		self.battleState:setString(Language:get("uc219"))
	end

	local time = queueInfo.remainingSec
	if status == 2 then
		local syncSec = TimeUtils:getSyncMillis()/1000
		local realEndTime = ArmyTaskQueueManager:getStationAllTime(queueInfo) + queueInfo.endTimeSec
		local remainingSec = realEndTime - syncSec
		if remainingSec <= 0 then
			time = 0
		end
	end
	self.uiMarchTime:setString(Language:get("uc217",UnitConversion.handleTime4(time)))


	local allRes = ArmyTaskQueueManager:getStationLoad(queueInfo.armyExpeditionAircrafts)
	self.uiBattleLoad:setString(Language:get("uc199",UnitConversion.unitTrans(allRes)))

	self.troopText:setString(Language:get("uc220"))
	
	--- 以布阵的形式显示战机列表	
--	local teamFormLocs=require("src/app/uiScript/components/army/TeamFormLocs.lua")()
--	self:addChild(teamFormLocs)
--	teamFormLocs:setCamp(Camp.CAMP1)
--	teamFormLocs:setTeam(queueInfo.armyExpeditionAircrafts)
	
	-- 添加具体的战机
	--local pos = { {50,100},{350,100},{50,300},{350,300},{50,500},{350,500} } -- left,top,
	local pos = { {350,100},{350,300},{350,500},{50,100},{50,300},{50,500} } -- left,top,


	local aircraftList = queueInfo.armyExpeditionAircrafts
	for i = 1,6,1 do
		-- 背景图片
		local backImg=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("battleItemBottom.png"),"h3")
		backImg:setContentSize(cc.size(208,94))
		self:addChild(backImg)
		REL:toOther("left","top",backImg,self.needListBack,pos[i][1],pos[i][2])

		local data=aircraftList[i]
		if data and data.sid > 0 then
			local dt=Aircraft_temp[data.sid]

			local T=GameUtils:getAicraftModelUrl(Camp.CAMP1,data.sid)
			if T then
				local o=T()
				self:addChild(o)
				REL:toOther("center","middle",o,backImg,0,40)
			end

			-- 飞机名字
			local airName = XMLLabel()
			airName:setHAlign("center")
			airName:setVAlign("middle")
			airName:setContentSize(cc.size(300,36))
			self:addChild(airName)
			REL:toOther("center", "top", airName, backImg, 0, 98)
			airName:setString(Language:get("uc222",AircraftUtils:getRichName(dt),aircraftList[i].count))
		end
	end

end

return T
