--- 任务项
local T = Class.ArmyTaskItem(function() return ccui.Layout:create() end)

--- 每一项的任务数据
T.taskInfo = nil

--- 构造函数
function T:ctor(taskInfo)
	self.taskInfo = taskInfo

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	-- 设置项
	local _widget = ListItem4.new()
	self.size = _widget:getContentSize()
	self:setContentSize(self.size)
	_widget:setListItemAttribute(
		"V",
		{"progress","label"},
		{{"infoButton_normal.png","iconButton_general_down.png","false","false"},{"addSpeedButton_normal.png","addSpeedButton_normal.png","false","false"}}
	)
	self:addChild(_widget)
	REL:toOther("left","top",_widget,self,0,0)
	self._widget = _widget

	-- 得到控件
	self:GetWidget()
	-- 设置数据
	self:SetData()
	-- 按钮回调设置
	self:SetButton()

	if BGMgr:isGuide() and taskInfo.id == WorldMapMgr.ARMY_QUEUE_ITEM_ID then
		BGMgr:regGuideObj(BGMgr.TGR_ARMY_TASK_ITEM_1_BACK_BUTTON,self.backBtn)
	end
end

--- 进入场景
function T:onEnter()
	self:addEventListener()
end

--- 退出场景
function T:onExit()
	self:removeEventListener()
end

--- 内存清理
function T:cleanUp()

end

--- 添加监听
function T:addEventListener()
	local id = self.taskInfo.id
	ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_BATTLE_REMAIN_TIME .. id,self,self.battleProcess)
	ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_BATTLE_OVER .. id,self,self.battleOver)

	ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_STATION_REMAIN_TIME .. id,self,self.stationProcess)
	ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_STATION_OVER .. id,self,self.stationOver)

	ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_BACK_REMAIN_TIME .. id,self,self.backProcess)
	ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_BACK_OVER_TIME .. id,self,self.backOver)
end


--- 移除监听
function T:removeEventListener()
	local id = self.taskInfo.id
	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_BATTLE_REMAIN_TIME .. id,self,self.battleProcess)
	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_BATTLE_OVER .. id,self,self.battleOver)

	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_STATION_REMAIN_TIME .. id,self,self.stationProcess)
	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_STATION_OVER .. id,self,self.stationOver)

	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_BACK_REMAIN_TIME .. id,self,self.backProcess)
	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_BACK_OVER_TIME .. id,self,self.backOver)

	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_TYPE_RESET,self,self.SetData)
end

function T:GetWidget()
	-- 头像
	self._imgHead = self._widget.leftHead

	-- 名字
	self._labelName = self._widget.title

	-- 抵达时间
	self._labelReachTime = self._widget:getLabel(2)

	--- 进度条
	self.loadingBar = self._widget.loadingBar

	--- 进度条中间的文本
	local text = XMLLabel()
	text:setHAlign("center")
	text:setVAlign("middle")
	text:setContentSize(cc.size(400, 27))
	self:addChild(text)
	REL:toOther("center", "middle", text, self._widget.backImg, 0, 0)
	self.text = text

	--- 左边按钮:信息按钮
	self.btnLeft = self._widget.button1
	self.btnLeft:setName("left")
	REL:toOther("left", "bottom",  self.btnLeft, self._widget.back, self._widget.rightTwoPos2[1][1], self._widget.rightTwoPos2[1][2])

	--- 右边按钮：加速或者返回
	self.btnRight = self._widget.button2
	self.btnRight:setName("right")
	REL:toOther("left", "bottom",  self.btnRight, self._widget.back, self._widget.rightTwoPos2[2][1], self._widget.rightTwoPos2[2][2])

	-- 消耗钻石
	local labelCostDiamond = XMLLabel()
	labelCostDiamond:setHAlign("center")
	labelCostDiamond:setVAlign("middle")
	labelCostDiamond:setContentSize(cc.size(300, 27))
	self:addChild(labelCostDiamond)
	self._labelCostDiamond = labelCostDiamond
	REL:toOther("center", "middle", self._labelCostDiamond, self.btnRight, -34, 4)


	--- 返回按钮
	local backBtn = Button.new("false","false")
	backBtn:loadTextures("back.png", "back.png", "",ccui.TextureResType.plistType)
	REL:toOther("left", "bottom",  backBtn, self._widget.back, 385 + 80,8)
	self:addChild(backBtn)
	self.backBtn = backBtn
	backBtn:addTouchEventListener(function (sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			self.taskInfo = UserInfo.city.armyTask.armyTaskQueue[self.taskInfo.id]
			self:backLogic()
		end
	end)

end

function T:backState()
	self.backBtn:setVisible(true)
	self.btnRight:setVisible(false)
	self._labelCostDiamond:setVisible(false)
end

function T:otherState()
	self.backBtn:setVisible(false)
	self.btnRight:setVisible(true)
	self._labelCostDiamond:setVisible(true)
end

function T:SetData()
	-- 标题名字
	self._widget:setString(self._labelName,self.taskInfo.targetName)

	local taskInfo = self.taskInfo
	local status = taskInfo.status

	-- 还要立即刷新进度条
	if status == 1 then
		self:otherState()
		local remainingSec = taskInfo.remainingSec
		if remainingSec <= 0 then
			self.loadingBar:setPercentage(100)
			self:battleOver(taskInfo)
		else
			local allTime = taskInfo.movingCost
			local time = taskInfo.remainingSec
			self:showDiamond(time)
			local per = (allTime - time)/allTime*100
			self.loadingBar:setPercentage(per)

			self:battleProcess(taskInfo)
		end
	elseif status == 2 then
		self:backState()

		local syncSec = TimeUtils:getSyncMillis()/1000
		local realEndTime = ArmyTaskQueueManager:getStationAllTime(taskInfo) + taskInfo.endTimeSec
		local remainingSec = realEndTime - syncSec
		if remainingSec <= 0 then
			self.loadingBar:setPercentage(100)
			self:stationOver(taskInfo)
		else
			local allTime = ArmyTaskQueueManager:getStationAllTime(taskInfo)
			local time = taskInfo.remainingSec
			local per = (allTime - time)/allTime*100
			self.loadingBar:setPercentage(per)

			self:stationProcess(taskInfo)
		end

	else
		self:otherState()

		local allTime = taskInfo.movingCost
		local time = taskInfo.remainingSec
		self:showDiamond(time)
		local per = (allTime - time)/allTime*100
		self.loadingBar:setPercentage(per)

		self:backProcess(taskInfo)
	end
end

--- 得到加速所需要的钻石
function T:showDiamond(remainingSec)
	local item = {}
	item.remainingSec = remainingSec
	local diamond = BuildingDiamondCalculation.GetSpeedFinishDiamond(item)
	self._labelCostDiamond:setString(Language:get("uc111",diamond))
end

--- 出征过程状态
function T:battleProcess(item)
	self:otherState()

	self.taskInfo = item  -- 要刷新本地内存数据
	self._imgHead:loadTexture("armyAttackIcon.png",ccui.TextureResType.plistType)
	self._widget:setString(self._labelReachTime,Language:get("uc204"))

	local allTime = item.movingCost
	local time = item.remainingSec
	self:showDiamond(time)

	local lastPer = self.loadingBar:getPercentage()
	local newPer = (allTime - time)/allTime*100
	self.loadingBar:runAction(cc.ProgressFromTo:create(0.2,lastPer,newPer))

	self.text:setString(Language:get("uc207",UnitConversion.handleTime4(time)))
end

--- 出征结束状态
function T:battleOver(item)
	self:backState()

	self.taskInfo = item  -- 要刷新本地内存数据
	self._imgHead:loadTexture("armyAttackIcon.png",ccui.TextureResType.plistType)
	self._widget:setString(self._labelReachTime,Language:get("uc204"))

	self.loadingBar:setPercentage(100)
	self.text:setString(Language:get("uc207",UnitConversion.handleTime4(0)))

end


--- 驻扎过程状态
function T:stationProcess(item)
	self:backState()

	self.taskInfo = item  -- 要刷新本地内存数据
	self._imgHead:loadTexture("armyQuarteringIcom.png",ccui.TextureResType.plistType)
	self._widget:setString(self._labelReachTime,Language:get("uc205"))

	local allTime = ArmyTaskQueueManager:getStationAllTime(item)
	local time = item.remainingSec

	local lastPer = self.loadingBar:getPercentage()
	local newPer = (allTime - time)/allTime*100
	if lastPer == 100 then
		self.loadingBar:setPercentage(0)
	else
		self.loadingBar:runAction(cc.ProgressFromTo:create(0.2,lastPer,newPer))
	end


	local nowRes = ArmyTaskQueueManager:getHaveStationLoad(item,allTime - time)
	local allRes = ArmyTaskQueueManager:getStationLoad(item.armyExpeditionAircrafts)
	self.text:setString(Language:get("uc208",UnitConversion.unitTrans(nowRes),UnitConversion.unitTrans(allRes)))

end
--- 驻扎结束
function T:stationOver(item)
	self:backState()

	self.taskInfo = item  -- 要刷新本地内存数据
	self._imgHead:loadTexture("armyQuarteringIcom.png",ccui.TextureResType.plistType)
	self._widget:setString(self._labelReachTime,Language:get("uc430"))

	self.loadingBar:setPercentage(100)

	local allRes = ArmyTaskQueueManager:getStationLoad(item.armyExpeditionAircrafts)
	self.text:setString(Language:get("uc208",UnitConversion.unitTrans(allRes),UnitConversion.unitTrans(allRes)))

end


--- 返回过程状态
function T:backProcess(item)
	self:otherState()

	self.taskInfo = item  -- 要刷新本地内存数据
	self._imgHead:loadTexture("armyBackIcon.png",ccui.TextureResType.plistType)
	self._widget:setString(self._labelReachTime,Language:get("uc206"))


	local allTime = item.movingCost
	local time = item.remainingSec
	self:showDiamond(time)

	local lastPer = self.loadingBar:getPercentage()
	local newPer = (allTime - time)/allTime*100
	if lastPer == 100 then
		self.loadingBar:setPercentage(0)
	else
		self.loadingBar:runAction(cc.ProgressFromTo:create(0.2,lastPer,newPer))
	end

	self.text:setString(Language:get("uc207",UnitConversion.handleTime4(time)))

end

--- 返回结束
function T:backOver(item)
	self.taskInfo = item  -- 要刷新本地内存数据
	self:removeEventListener()
	self:removeFromParent()
end


function T:SetButton()
	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local name = sender:getName()
			if name == "left" then
				self:infoLogic()
			else
				-- 重新设置数据
				self.taskInfo = UserInfo.city.armyTask.armyTaskQueue[self.taskInfo.id]
				if self.taskInfo.status == 2 then
				--self:backLogic()
				else
					self:speedLogic()
				end
			end
		end
	end

	self.btnLeft:addTouchEventListener(callback)
	self.btnRight:addTouchEventListener(callback)
end

--- 信息
function T:infoLogic()
	local info = require("src.app.uiScript.components.army.armyTask.ArmyInfoView").new(self.taskInfo)
	WindowManager:push(info)
end

--- 加速
function T:speedLogic()
	local item = {}
	item.remainingSec = self.taskInfo.remainingSec -- 剩余时间
	local allDiamond = BuildingDiamondCalculation.GetSpeedFinishDiamond(item)

	local payState = SetStates.setPayState
	local value = payState:getClosedValue(payState.CLOSE_MARCH_SPEED)

	if value then
		Command:speedCollect(allDiamond,self.taskInfo.id)
	else
		local info = Language:get("uc209",allDiamond)
		local layout = DiamondPopInfo.new(info)
		local function confirm()
			SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_MARCH_SPEED)
			if layout.judge == true then
				Command:SetPayCommand()
			end
			Command:speedCollect(allDiamond,self.taskInfo.id)
		end
		MUIPop.DiamondPopInfo(layout,confirm)
	end


end

--- 返回（撤军）
function T:backLogic()
	local syncSec = TimeUtils:getSyncMillis()/1000
	local realEndTime = ArmyTaskQueueManager:getStationAllTime(self.taskInfo) + self.taskInfo.endTimeSec
	local remainingSec = realEndTime - syncSec
	if remainingSec <= 0 then
		if BGMgr:isGuide() then
			BGMgr:fire(BGMgr.EVT_CONFIRM_ARMY_TASK_BACK_CONFIRM_TIP)
			return
		end

		Command:withDrawArmy(self.taskInfo.id)
	else
		local info = Language:get("uc229")
		local function confirm()
			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_CONFIRM_ARMY_TASK_BACK_CONFIRM_TIP)
				return
			end

			Command:withDrawArmy(self.taskInfo.id)
		end
		MUIPop.MUIImmediate(info,confirm)

		if BGMgr:isGuide() then
			BGMgr:fire(BGMgr.EVT_OPEN_ARMY_TASK_BACK_CONFIRM_TIP)
		end
	end

end

return T
