--- 军队任务视图
-- @author blank
local T = Class.ArmyTaskView(function() return ccui.Layout:create() end)

--- 任务项
T.ArmyTaskItem = require("src.app.uiScript.components.army.armyTask.ArmyTaskItem")


--- 构造函数
function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
    ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_BACK_OVER_TIME,self,self.refresh)
    
    --断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
	
	if BGMgr:isGuide() then
		BGMgr:fire(BGMgr.EVT_OPEN_ARMY_TASK_WINDOW)
	end
end

--- 退出场景
function T:onExit()
    ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_BACK_OVER_TIME,self,self.refresh)
    
    UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
end

--- 内存清理
function T:cleanUp()
    
end

--- 初始化
function T:init()
	REL:relScreen(self,6,6,180,0)

--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	self:setBackGroundColor(cc.c3b(0xff,0,0))
--	self:setBackGroundColorOpacity(100)

    --- 战斗中出征的部队
    local text = XMLLabel()
    text:setContentSize(cc.size(300,27))
    self:addChild(text)
    REL:toOther("left","top",text,self,10,0)
    self.text = text


    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,7,0,30,0)
    self.listView = listView

    self:AddToListview()

    self:refresh()

end

function T:updateAllState()
	self.listView:removeAllItems()

	self:AddToListview()
    self:refresh()
end

function T:AddToListview()
    local list = UserInfo.city.armyTask.armyTaskQueue

    for k,v in pairs(list) do 
        if v then
            local temp = self.ArmyTaskItem(v)
            self.listView:pushBackCustomItem(temp)
        end
    end
    
end

function T:refresh()
    local list = UserInfo.city.armyTask.armyTaskQueue
    local allNum = PlayerInstance:getVipbattleQueueCount()

    local num = 0
    for k,v in pairs(list) do 
        if v then
            num = num + 1
        end
    end
    self.text:setString(Language:get("uc234",num,allNum))

end

return T
