--[[
    阵型弹项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor(id)  -- 阵型id
    self.id = id

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

    local size = cc.size(550,600)
    self.size = self:setContentSize(size)
    self.size = size


    self:init()

    local formationBox = FormationManager.formationBox
    formationBox:luaAddEventListener(formationBox.EVT_SET_FORMATION_REFRESH,self,self.aircraftChange)



end

function T:init()
    local formationBox = FormationManager.formationBox
    local formationInfo = formationBox.formationBox[self.id]

    local aircrafts = formationInfo.aircrafts

    local data = formationBox:getFormationIsOpen(self.id)

    -- 标题文本
	local titleLabel = XMLLabel()
	titleLabel:setContentSize(cc.size(450,36))
	titleLabel:setHAlign("center")
	self:addChild(titleLabel)
	REL:toOther("center","top",titleLabel,self,0,0)
    if data.isOpen == true then
        titleLabel:setString(Language:get("uc951",self.id + 1))
    else
        titleLabel:setString(Language:get("uc952",self.id + 1,data.limitVipLvl))
    end

    -- 添加具体的战机
	--local pos = { {20,50},{320,50},{20,250},{320,250},{20,450},{320,450} } -- left,top,
	local pos = { {320,50},{320,250},{320,450},{20,50},{20,250},{20,450} } -- left,top,

    self.backImgs = {}

	for i = 1,6,1 do
		-- 背景图片
		local backImg=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("battleItemBottom.png"),"h3")
		backImg:setContentSize(cc.size(208,94))
		self:addChild(backImg)
		REL:toOther("left","top",backImg,self,pos[i][1],pos[i][2])

        self.backImgs[i] = backImg

	end

    self:aircraftChange()


end

--- 进入场景
function T:onEnter()

end

--- 退出场景
function T:onExit()
    local formationBox = FormationManager.formationBox
    formationBox:luaRemoveEventListener(formationBox.EVT_SET_FORMATION_REFRESH,self,self.aircraftChange) 

end

--- 内存清理
function T:cleanUp()
    
end

--- 飞机部队刷新，把原来的移除掉，最新的设置上去 987654
function T:aircraftChange()
    local formationBox = FormationManager.formationBox
    local formationInfo = formationBox.formationBox[self.id]

    local aircraftList = formationInfo.aircrafts

    local backImgs = self.backImgs

    --- 先移除掉
    for i = 1,6,1 do
        if backImgs[i]:getChildByTag(1000) then
            backImgs[i]:getChildByTag(1000):removeFromParent()
        end
        if backImgs[i]:getChildByTag(1001) then
            backImgs[i]:getChildByTag(1001):setVisible(false)
        end

    end

    --- 重新添加
    for i = 1,6,1 do
        if aircraftList then
            local data=aircraftList[i]
            if data and data.sid and data.sid > 0 then
		        local dt=Aircraft_temp[data.sid]
			
		        local T=GameUtils:getAicraftModelUrl(Camp.CAMP2,data.sid)
		        if T then
			        local o=T()
			        backImgs[i]:addChild(o)
                    o:setTag(1000)
			        REL:toOther("center","middle",o,backImgs[i],0,40)
		        end

		        -- 飞机名字
                if not backImgs[i]:getChildByTag(1001) then
                    local airName = XMLLabel()
                    airName:setTag(1001)
		            airName:setHAlign("center")
		            airName:setVAlign("middle")
		            airName:setContentSize(cc.size(300,36))
		            backImgs[i]:addChild(airName)
		            REL:toOther("center", "top", airName, backImgs[i], 0, 98)
		        else
                    backImgs[i]:getChildByTag(1001):setVisible(true)
                end

                backImgs[i]:getChildByTag(1001):setString(Language:get("uc222",AircraftUtils:getRichName(dt),aircraftList[i].count))
	        end
        end
    end

end




return T
