local super=require("src.app.uiScript.components.share.AbstractFullScreenWindow")

---部队出征窗口
--@author blank
local T = class("AllCampaignWindow", function()
	local t = super.new()
	t.__setVisible__=t.setVisible

	return t
end)

--- 战役数据
T.Campaign_temp=require("res.data.battle.campaign")

--- 关卡buff
T.chapterBuff_temp=require("res.data.battle.chapterBuff")

--- 关卡buff显示项
T.ChapterBuffItem=require("src.app.uiScript.components.battle.ChapterBuffItem")

--- 战役项
T.CampaignItem=require("src.app.uiScript.components.battle.CampaignItem")

--- 预加载资源列表
T.PRE_RES_LIST={
	"res/images/battle/campaign.plist",
	"res/images/battle/icons/campaignIcons.plist",
	SoundRes.SOUND_STAR,
	{
		type = "animations",
		list = {
			{name = "starAnimations", url = "star" ,beginIndex = 0,endIndex = 7,extension=".png",delay = 0.05 }
		},
	}
}

--- 关闭按钮
--T.uiCloseButton=nil

--- 背景
T.uiBack=nil

--- 上边框
--T.uiTopBorder=nil

--- buff列表
--T.uiBuffListView=nil

--- 下边框
--T.uiBottomBorder=nil

--- 左下角边框
--T.uiLeftBottomBorder=nil

--- 右下角边框
--T.uiRightBottomBorder=nil

--- 内部容器
--T.uiContainer=nil

--- 战役项列表
--T.uiCampaignListView=nil

--- 上次播放的背景音乐的 url
--T._lastMusicUrl=nil

--- 构造函数
function T:ctor()
	mapping(self,require("src.app.uiScript.components.share.WindowEffTemplate"))

	ResLoader:syncLoad(self.PRE_RES_LIST)
	self:init()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
	super.onEnter(self)

	local lMusic=AudioManager:getCurrentMusicUrl()
	if lMusic ~= SoundRes.MUSIC_CHAPTER then
		self._lastMusicUrl=lMusic
		AudioManager:playMusic(SoundRes.MUSIC_CHAPTER,true)
	end
end

--- 退出场景
function T:onExit()
	super.onExit(self)

	-- 设置关卡战斗的前一次部队为nil
	BattlesInfoMgr:setTeam(nil)

	self:stopAllActions()

	if self._lastMusicUrl then
		AudioManager:playMusic(self._lastMusicUrl,self._lastMusicUrl ~= SoundRes.MUSIC_GENERAL)
	end
end

--- 内存清理
function T:cleanUp()
	super.cleanUp(self)

	ResLoader:unloadReses(self.PRE_RES_LIST)
end

--- 初始化
function T:init()
	--背景
	local uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("windowBack.jpg"))
	self:addChild(uiBack)
	REL:relScreen(uiBack,0,0,65,0)
	self.uiBack = uiBack

	--上边框
	local uiTopBorder=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("allCampaignTopBorder.png"),"h3")
	self:addChild(uiTopBorder)
	REL:relOther(uiTopBorder,self,0,0,0,SIZE_NIL)
	self.uiTopBorder=uiTopBorder

	--关闭按钮
	local uiCloseButton=BaseButton:createButton(nil,"closeWindowButton_normal.png")
	uiTopBorder:addChild(uiCloseButton)
	REL:toScreen("right","top",uiCloseButton,20,24)
	self.uiCloseButton=uiCloseButton
	uiCloseButton:addTouchEventListener(function(t,e)
		if e==ccui.TouchEventType.ended then
			self:close()
		end
	end)

	--buff列表
	local uiBuffListView=ccui.ListView:create()
	uiBuffListView:setDirection(ccui.ScrollViewDir.horizontal)
	uiTopBorder:addChild(uiBuffListView)
	REL:relOther(uiBuffListView,uiTopBorder,32,124,20,16)
	self.uiBuffListView=uiBuffListView

	--	uiLeftBottomBorder:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiLeftBottomBorder:setBackGroundColor(cc.c3b(0,0,0))
	--	uiLeftBottomBorder:setBackGroundColorOpacity(100)

	--内容容器
	local uiContainer = ccui.Layout:create()
	self:addChild(uiContainer)
	REL:relScreen(uiContainer,8,8,110,0)
	self.uiContainer = uiContainer

	--战役列表
	local uiCampaignListView=ccui.ListView:create()
	uiCampaignListView:setBounceEnabled(true)
	uiCampaignListView:setTouchEnabled(true)
	uiCampaignListView:setItemsMargin(2)
	uiCampaignListView:setGravity(ccui.ListViewGravity.centerHorizontal)
	self.uiContainer:addChild(uiCampaignListView)
	REL:relOther(uiCampaignListView,self,4,4,114,0)
	self.uiCampaignListView=uiCampaignListView

	--下边框
	local uiBottomBorder=ccui.Layout:create()
	uiBottomBorder:setContentSize(cc.size(1, 136))
	self:addChild(uiBottomBorder)
	REL:toScreen("center","bottom",uiBottomBorder,0,0)
	self.uiBottomBorder=uiBottomBorder

	--左下角边框
	local uiLeftBottomBorder=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("borderLeftBottom.png"))
	uiBottomBorder:addChild(uiLeftBottomBorder)
	REL:toScreen("left","bottom",uiLeftBottomBorder,0,0)
	self.uiLeftBottomBorder=uiLeftBottomBorder
	--右下角边框
	local uiRightBottomBorder=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("borderLeftBottom.png"))
	uiRightBottomBorder:setFlippedX(true)
	uiBottomBorder:addChild(uiRightBottomBorder)
	REL:toScreen("right","bottom",uiRightBottomBorder,0,0)
	self.uiRightBottomBorder=uiRightBottomBorder

	uiBottomBorder:setContentSize(cc.size(
		uiBottomBorder:getContentSize().width,
		math.max(uiLeftBottomBorder:getContentSize().height,uiRightBottomBorder:getContentSize().height)
	))

	self:updateChpaterBuffList()
	self:firstUpdateCampaignItemList()
end

--- 更新关卡buff列表
function T:updateChpaterBuffList()
	local uiC=self.uiBuffListView
	uiC:removeAllItems()

	for k,v in ipairs(self.chapterBuff_temp) do
		local item=self.ChapterBuffItem()
		item:setData(v)
		uiC:pushBackCustomItem(item)
	end
end


--- 获取最后完成的战役的SID
function T:getLastFinishedSid()
	local bMgr=BattlesInfoMgr
	local list=self.Campaign_temp

	local lastFinishedId=0
	for k,data in ipairs(list) do
		local battles=data.battles
		if bMgr:isBattleFinished(battles[#battles]) then
			lastFinishedId=k
		else
			break
		end
	end
	return lastFinishedId
end

--- 更新战役项列表
function T:firstUpdateCampaignItemList()
	local bMgr=BattlesInfoMgr

	local uiC=self.uiCampaignListView
	uiC:removeAllItems()

	local itemAddEff=function(item)
		item:setOpacity(0)
		item:runAction(
			cc.FadeIn:create(0.5)
		)
	end

	local list=self.Campaign_temp
	local i=self:getLastFinishedSid()+1
	i=i > #list and #list or i

	self:runAction(
		cc.RepeatForever:create(
			cc.Sequence:create(
				cc.DelayTime:create(0.1),
				cc.CallFunc:create( function()
					local data=list[i]

					local item=self.CampaignItem()
					itemAddEff(item)

					item:setData(data)
					item:setIsLock(false)

					uiC:pushBackCustomItem(item)

					i=i-1
					if i <= 0 then
						self:stopAllActions()
					end
				end)
			)
		)
	)

	--	local list=self.Campaign_temp
	--	local i,len=1,#list
	--
	--
	--	local lastFinishedId=0
	--	self:runAction(
	--		cc.RepeatForever:create(
	--			cc.Sequence:create(
	--				cc.DelayTime:create(0.1),
	--				cc.CallFunc:create( function()
	--					if i <= len then
	--						local data=list[i]
	--
	--						local battles=data.battles
	--						if bMgr:isBattleFinished(battles[#battles]) then
	--							lastFinishedId=i
	--						end
	--
	--						if i - 2 <= lastFinishedId then
	--							local item=self.CampaignItem()
	--							itemAddEff(item)
	--
	--							item:setData(data)
	--							item:setIsLock(i - 2 == lastFinishedId)
	--
	--							uiC:pushBackCustomItem(item)
	--						else
	--							self:stopAllActions()
	--						end
	--						uiC:scrollToBottom(i*0.05,false)
	--					else
	--						self:stopAllActions()
	--					end
	--
	--					i=i+1
	--				end)
	--			)
	--		)
	--	)
end

--- 第二次更新战役项列表
function T:secondupdateCampaignItemList()
	local bMgr=BattlesInfoMgr

	local uiC=self.uiCampaignListView

	local items=uiC:getItems()

	local list=self.Campaign_temp
	local len=self:getLastFinishedSid()+1
	len=len > #list and #list or len

	for i=len,1,-1 do
		local item=items[len-i+1]
		if not item then
			item=self.CampaignItem()
			uiC:pushBackCustomItem(item)
		end

		item:setData(list[i])
	end

	--	local list=self.Campaign_temp
	--	local i,lastFinishedId=0,0
	--	for k,data in ipairs(list) do
	--		i=i+1
	--
	--		local battles=data.battles
	--		if bMgr:isBattleFinished(battles[#battles]) then
	--			lastFinishedId=i
	--		end
	--
	--		if i - 2 <= lastFinishedId then
	--			local item=items[i]
	--			if not item then
	--				item=self.CampaignItem()
	--				uiC:pushBackCustomItem(item)
	--			end
	--
	--			item:setData(data)
	--			item:setIsLock(i - 2 == lastFinishedId)
	--		end
	--	end
end

function T:setVisible(value)
	if value ~= self:isVisible() then
		self:__setVisible__(value)

		if value then
			self:updateChpaterBuffList()
			self:secondupdateCampaignItemList()
		end
	end
end

return T
