--- 战斗项
local T = Class.BattleItem(function()
	return ccui.Layout:create()
end)

--- 出征设置
T.ArmyWindow = require("src.app.uiScript.components.army.ArmyWindow")

function T:def()
--- 战斗图标
-- self.uiAircraft=nil

--- 星级图标列表
-- self.uiStarIconList=nil

--- 战斗数据
-- self.data=nil

--- 锁定图标
-- self.uiLock=nil

--- 是否锁定
-- self.isLock=nil
end

function T:ctor()
	self:setContentSize(cc.size(152,152))
	self:setTouchEnabled(true)

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(random(0,255),0,0))
	--	self:setBackGroundColorOpacity(100)

	--- 下边框
	local uiBottomBorder=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("battleItemBottom.png"),"h3")
	self:addChild(uiBottomBorder)
	REL:relOther(uiBottomBorder,self,-4,-4,SIZE_NIL,-4)
	self.uiBottomBorder=uiBottomBorder

	--战斗图标
	local uiMainAircraftContainer = cc.Node:create()
	self:addChild(uiMainAircraftContainer)
	self.uiMainAircraftContainer=uiMainAircraftContainer

	--星级图标列表
	local l={}
	local c,INTERVAL,w,offset=3,4,nil,nil
	for i=1,c,1 do
		local uiStarIcon = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("star_empty.png"))
		if not w then
			w=uiStarIcon:getContentSize().width
			offset=(c*(w+INTERVAL)+INTERVAL)/2
		end
		self:addChild(uiStarIcon)
		REL:toOther("center","bottom",uiStarIcon,self,(i-1)*(w + INTERVAL)+INTERVAL+w/2-offset,9)

		l[#l+1]=uiStarIcon
	end
	self.uiStarIconList=l

	--touch事件侦听器
	self:addTouchEventListener(function (t,e)
		if e==ccui.TouchEventType.ended then
			if self.isLock then
				return
			end
			
			local data = t:getData()
			
			if BGMgr:isGuide() then
				if BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_CHAPTER_1_BATTLE_1,data.sid) then
					return
				end
			end
			
			local armyWindow=self.ArmyWindow.new({ tag = 2, detailInfo = data })
			WindowManager:push(armyWindow)
		end
	end)
end

--- 进入
function T:onEnter()
end

--- 退出
function T:onExit()
	if self.uiSight then
		self.uiSight:stopAllActions()
	end
end


--- 创建锁定图标
function T:createLockIcon()
	local uiLock=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("lockIcon.png"))
	self:addChild(uiLock)
	REL:toOther("center","middle",uiLock,self,0,6)
	self.uiLock=uiLock
end

--- 创建瞄准器图片
function T:createSlight()
	local uiSight= cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("Sight.png"))
	self:addChild(uiSight)
	REL:toOther("center","middle",uiSight,self,0,18)
	self.uiSight = uiSight
end

--- 更新战机显示
function T:updateAircraft()
	if self.uiAircraft then
		self.uiAircraft:removeFromParent()
	end

	if self.data then
		local T=GameUtils:getAicraftModelUrl(Camp.CAMP2,self.data.mainAircraftSid)
		if T then
			local o=T()
			o:setScale(0.6)
			self.uiMainAircraftContainer:addChild(o)
			REL:toOther("center","bottom",o,self,0,86)
			self.uiAircraft=o
		end
	end
end

--- 更新星级
function T:updateView()
	local battleBox=BattlesInfoMgr

	--更新战斗图标
--	local iconUrl=self.data.iconUrl
--	self.uiAircraft:setSpriteFrame(ResLoader:getSpriteFrame(iconUrl..".png"))
--	REL:relRect(self.uiAircraft,cc.rect(0,0,174,96),0,0,0,0)
--	REL:toOther("center","bottom",self.uiAircraft,self,0,46)
	
	self:updateAircraft()

	--更新星级
	local battleBox=BattlesInfoMgr
	local c=battleBox:getStar(self.data.sid)

	local l=self.uiStarIconList

	local chooseBattleSid = BattlesInfoMgr:getSelBattle()
	if chooseBattleSid and chooseBattleSid == self.data.sid then -- 动画
		local lastStar = BattlesInfoMgr:getSelBattleStar()
		self:_play(lastStar,c)  -- c是最新的星级数量

		BattlesInfoMgr:setSelBattle(nil)
		BattlesInfoMgr:setSelBattleStar(nil)
	else
		for i=1,3,1 do
			if i <= c then
				l[i]:setSpriteFrame(ResLoader:getSpriteFrame("star_enabled.png"))
			else
				l[i]:setSpriteFrame(ResLoader:getSpriteFrame("star_empty.png"))
			end
		end
	end

	-- 加瞄准器图片
	if c == 0 and self.isLock == false or self.isLock == nil then
		if not self.uiSight then
			self:createSlight()
		end
		self.uiSight:setVisible(true)

		-- 动画
		self.uiSight:runAction(
			cc.RepeatForever:create(
				cc.Sequence:create(
					cc.ScaleTo:create(1, 0.5),
					cc.ScaleTo:create(1, 1)
				)
			)
		)
	else
		if self.uiSight then
			self.uiSight:setVisible(false)
		end
	end


	if self.isLock then -- 没解锁
		self.uiBottomBorder:initWithFrame(ResLoader:getSpriteFrame("battleItemBottom_disabled.png"),"h3")
		self.uiAircraft:setIsGray(true)

		if not self.uiLock then
			self:createLockIcon()
		end
		self.uiLock:setVisible(true)

		if self.uiSight then
			self.uiSight:setVisible(false)
		end

	else -- 解锁了
		self.uiBottomBorder:initWithFrame(ResLoader:getSpriteFrame("battleItemBottom.png"),"h3")
		self.uiAircraft:setIsGray(false)
		if self.uiLock then
			self.uiLock:setVisible(false)
		end
	end
end

--- 设置数据
function T:setData(value)
	self.data=value

	self:updateView()
end
--- 获取数据
function T:getData()
	return self.data
end

--- 设置是否锁定
function T:setIsLock(value)
	if value ~= self.isLock then
		self.isLock=value

		self:updateView()
	end
end

--- 获取是否锁定
function T:getIsLock()
	return self.isLock
end

--- 播放
function T:_play(lastNum,newNum)
	local list = self.uiStarIconList

	for i=1,3,1 do
		if i <= lastNum then
			list[i]:setSpriteFrame(ResLoader:getSpriteFrame("star_enabled.png"))
		elseif i > newNum then
			list[i]:setSpriteFrame(ResLoader:getSpriteFrame("star_empty.png"))
		end
	end

	local offset = newNum - lastNum

	self:_playEffect(lastNum,offset)
end

function T:_playEffect(first,num)
	local list = self.uiStarIconList

	if first == 3 or num == 0 then
		-- 播放锁的动画
		return
	end

	list[first + 1]:runAction(
		cc.Sequence:create(
			cc.CallFunc:create(function() AudioManager:playEffect(SoundRes.SOUND_STAR,false) end),
			cc.Animate:create(ResLoader:getAnimation("starAnimations")),
			cc.CallFunc:create(
				function(target)
					self:_playEffect(first + 1,num - 1)
				end
			)
		)
	)

end

return T
