--- 战役信息窗口
-- @author blank
local T = class("CampaignInfoWindow", function()
	local t = AbstractWindow.new(1)
	t.__setVisible__=t.setVisible

	return t
end)

--- 战斗数据模板
T.Battle_temp = require("res.data.battle.battle")

--- 战斗项
T.BattleItem = require("src.app.uiScript.components.battle.BattleItem")

--- 战役信息奖励项
T.CampaignStarAwardItem=require("src.app.uiScript.components.battle.CampaignStarAwardItem")

--- 内容背景
--T.uiContentBack=nil

--- 战役名称背景
--T.uiCampaignNameBack = nil

--- 战役名
--T.uiCampaignName = nil

--- 星级图标
--T.uiStar=nil

--- 获得的总星级
--T.uiStarCount = nil

--- 战斗项列表背景
--T.uiBattleListBack=nil

--- pve点数图标
--T.uiPvePointIcon=nil

--- pve点数
--T.uiPvePoint = nil

--- 战斗项列表容器
--T.uiBattleItemListContainer = nil

--- 战斗项列表
--T.uiBattleItemList = nil

--- 星级奖励列表
--T.uiStarAwardListView=nil

--- 战役信息数据
--T.campaignInfo = nil

--- 上次播放的背景音乐的 url
--T._lastMusicUrl=nil

--- 构造函数
function T:ctor(campaignInfo)
	self.campaignInfo = campaignInfo
	BattlesInfoMgr:setSelCampaign(campaignInfo)

	self:init()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 进入场景
function T:onEnter()
	AbstractWindow.onEnter(self)

	self:updatePVEPoint()
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_UPDATE_PVE_POINT,self,self.updatePVEPoint)

	if BGMgr:isGuide() then
		BGMgr:fire(BGMgr.EVT_ENTER_CAMPAIGN_INFO_WINDOW)
	end
	
	local lMusic=AudioManager:getCurrentMusicUrl()
	if lMusic ~= SoundRes.MUSIC_CHAPTER then
		self._lastMusicUrl=lMusic
		AudioManager:playMusic(SoundRes.MUSIC_CHAPTER,true)
	end
end

--- 退出场景
function T:onExit()
	AbstractWindow.onExit(self)

	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_UPDATE_PVE_POINT,self,self.updatePVEPoint)
	BattlesInfoMgr:setSelCampaign(nil)
	
	if self._lastMusicUrl then
		AudioManager:playMusic(self._lastMusicUrl,self._lastMusicUrl ~= SoundRes.MUSIC_GENERAL)
	end
end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	self:setWindowTitle(Language:get("ug250"))

	--边框
	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local uiContentBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(uiContentBack)
	REL:relOther(uiContentBack,self.uiContainer,2,2,2,2)
	self.uiContentBack=uiContentBack

	--战役名称背景
	local uiCampaignNameBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("vipTag.png"))
	self:addChild(uiCampaignNameBack)
	REL:relOther(uiCampaignNameBack,self.uiContainer,6,6,6,SIZE_NIL)
	self.uiCampaignNameBack=uiCampaignNameBack

	--左侧装饰
	local uiLDecoration=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("decoration_2.png"))
	self:addChild(uiLDecoration)
	REL:toOther("left","middle",uiLDecoration,uiCampaignNameBack,4,0)
	self.uiLDecoration=uiLDecoration

	--右侧装饰
	local uiRDecoration=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("decoration_1.png"),cc.rect(200,0,1,48))
	uiRDecoration:setContentSize(cc.size(278,48))
	self:addChild(uiRDecoration)
	REL:toOther("right","middle",uiRDecoration,uiCampaignNameBack,4,0)
	self.uiRDecoration=uiRDecoration

	--战役名
	local uiCampaignName=XMLLabel()
	uiCampaignName:setWidth(348)
	uiCampaignName:setAlign("left","middle")
	self:addChild(uiCampaignName)
	REL:relOther(uiCampaignName,uiCampaignNameBack,66,SIZE_NIL,2,2)
	self.uiCampaignName=uiCampaignName

	--星级图标
	local uiStar=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("star_enabled.png"))
	self:addChild(uiStar)
	REL:toOther("right","middle",uiStar,uiCampaignNameBack,92,0)
	self.uiStar=uiStar

	--总星级
	local uiStarCount=XMLLabel()
	uiStarCount:setWidth(88)
	uiStarCount:setAlign("left","middle")
	self:addChild(uiStarCount)
	REL:relOther(uiStarCount,uiCampaignNameBack,SIZE_NIL,4,2,2)
	self.uiStarCount=uiStarCount

	--战斗项列表背景
	local uiBattleListBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("canvasBack.png"))
	self:addChild(uiBattleListBack)
	REL:relOther(uiBattleListBack,self.uiContainer,6,6,64,152)
	self.uiBattleListBack=uiBattleListBack

	--战斗列表项容器
	local uiBattleItemListContainer=ccui.ScrollView:create()
	self:addChild(uiBattleItemListContainer)
	REL:relOther(uiBattleItemListContainer,uiBattleListBack,0,0,0,0)
	self.uiBattleItemListContainer=uiBattleItemListContainer

	--底部区域背景
	local uiBottomAreaBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("cvsBack1.png"))
	self:addChild(uiBottomAreaBack)
	uiBottomAreaBack:setScaleY(1.2)
	REL:toOther("center","bottom",uiBottomAreaBack,self.uiContainer,0,6)
	self.uiBottomAreaBack=uiBottomAreaBack

	--pve点数图标
	local uiPvePointIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("powerIcon.png"))
	self:addChild(uiPvePointIcon)
	REL:toOther("left","middle",uiPvePointIcon,uiBottomAreaBack,10,0)
	self.uiPvePointIcon=uiPvePointIcon

	--pve点数
	local uiPvePoint=XMLLabel()
	uiPvePoint:setAlign("left","middle")
	uiPvePoint:setContentSize(cc.size(240,36))
	self:addChild(uiPvePoint)
	REL:toOther("left","middle",uiPvePoint,uiBottomAreaBack,66,0)
	self.uiPvePoint=uiPvePoint

	--星级奖励列表
	local uiStarAwardListView=ccui.ListView:create()
	uiStarAwardListView:setDirection(ccui.ScrollViewDir.horizontal)
	uiStarAwardListView:setGravity(ccui.ListViewGravity.centerHorizontal)
	uiStarAwardListView:setContentSize(cc.size(1,110))
	uiStarAwardListView:setItemsMargin(10)
	self:addChild(uiStarAwardListView)
	REL:relOther(uiStarAwardListView,uiBottomAreaBack,282,20,14,14)
	self.uiStarAwardListView=uiStarAwardListView

--	uiStarAwardListView:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	uiStarAwardListView:setBackGroundColor(cc.c3b(random(0,255),0,0))
--	uiStarAwardListView:setBackGroundColorOpacity(100)

	self.uiBattleItemList = { }
	self:updateCampaignInfo()
end

--- 创建战役列表项
function T:createBattleItems(len)
	local l1 = #self.uiBattleItemList
	local container = self.uiBattleItemListContainer:getInnerContainer()

	local h, w
	if len > l1 then
		for i = l1 + 1, len, 1 do
			local item = self.BattleItem()
			container:addChild(item)

			self.uiBattleItemList[i] = item
		end
	elseif len < l1 then
		for i = l1, len + 1, -1 do
			local item = self.uiBattleItemList[i]

			item:removeFromParent()
			self.uiBattleItemList[i] = nil
		end
	end

	-- 以下为刷新列表项的位置

	if not h then
		for _, v in pairs(self.uiBattleItemList) do
			local s = v:getContentSize()
			w = s.width
			h = s.height
		end
	end
	if not h then
		return
	end

	-- 项与项之间的间隔
	local W_INTERVAL,H_INTERVAL = -2, 10

	-- 更新显示的容器size
	local s=self.uiBattleItemListContainer:getContentSize()
	local cW = s.width
	-- 列数
	local colsNum = math.floor(cW /(w + W_INTERVAL))
	local tW =(w + W_INTERVAL) * colsNum + W_INTERVAL
	if tW > cW then
		colsNum = colsNum - 1
		tW =(w + W_INTERVAL) * colsNum + W_INTERVAL
	end
	local cH = math.ceil(len / colsNum) *(h + H_INTERVAL) + H_INTERVAL
	cH=cH<s.height and s.height or cH
	container:setContentSize(cc.size(cW, cH))
	--	container:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	container:setBackGroundColor(cc.c3b(100, 0, 0))
	--	container:setBackGroundColorOpacity(100)

	local offsetX = tW / 2

	-- 更新项的显示位置
	local top
	for i = 0, len - 1, 1 do
		local item = self.uiBattleItemList[i + 1]

		local m = i % colsNum
		if m == 0 then
			top =(i / colsNum) *(h + H_INTERVAL) + H_INTERVAL
		end
		REL:toOther("center", "top", item, container,(m *(w + W_INTERVAL) + W_INTERVAL + w / 2) - offsetX, top)
	end
end

--- 刷新PVE点数
function T:updatePVEPoint()
	if not self:isVisible() or not self:isRunning() then
		return
	end

	local v,mv=PlayerInstance:getPlayerEnergy(),PlayerInstance:getPlayerMaxEnergy()
	self.uiPvePoint:setString(Language:get(
		v < mv and "ug252" or "ug257",
		v,
		mv,
		UnitConversion.handleTime(UserInfoMgr.pveRecoverRemaing)
	))
end

--- 刷新战役信息
function T:updateCampaignInfo()
	local battleBox=BattlesInfoMgr

	self.uiCampaignName:setString(Language:get("ug251",Language:get(self.campaignInfo.name)))
	self:updatePVEPoint()

	local battles = self.campaignInfo.battles
	local l = { }
	for _, v in ipairs(battles) do
		l[#l + 1] = self.Battle_temp[v]
	end

	--更新战斗列表
	self:createBattleItems(#l)
	for k, v in ipairs(l) do
		local item = self.uiBattleItemList[k]
		item:setData(v)

		local sid=v.sid

		if battleBox:isBattleFinished(sid) then
			--已经完成
			item:setIsLock(false)
		else
			--未完成
			if sid == 1 or battleBox:isBattleFinished(sid-1) then
				--新解锁的战斗
				item:setIsLock(false)
			else
				item:setIsLock(true)
			end
		end
	end

	local curStarCount,totalStarCount=battleBox:getStar(battles),#l*3
	self.uiStarCount:setString(Language:get("ug201",curStarCount,totalStarCount))

	--刷新星级奖励列表>>----------------------------------------------
	local c=self.uiStarAwardListView
	c:removeAllItems()

	local awardProps=self.campaignInfo.awardProps

	local len=#awardProps
	local tag = 0
	for i=1,len,2 do
		local propData=Prop_temp[awardProps[i]]
		local awardCount=awardProps[i+1]

		local item=self.CampaignStarAwardItem()
		item:setData({
			campaignInfo = self.campaignInfo,
			propData=propData,
			awardCount=awardCount,
			needStarCount=(i+1)/2*16,
			curStarCount=curStarCount,
			index = tag
		})
		c:pushBackCustomItem(item)
		tag = tag + 1
	end
	--<<刷新星级奖励列表----------------------------------------------

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_CHAPTER_1_BATTLE_1,self.uiBattleItemList[1])
		BGMgr:regGuideObj(BGMgr.TGR_CHAPTER_1_BATTLE_2,self.uiBattleItemList[2])
		BGMgr:regGuideObj(BGMgr.TGR_CHAPTER_1_BATTLE_3,self.uiBattleItemList[3])
		BGMgr:regGuideObj(BGMgr.TGR_CHAPTER_1_BATTLE_4,self.uiBattleItemList[4])
		BGMgr:regGuideObj(BGMgr.TGR_CHAPTER_1_BATTLE_5,self.uiBattleItemList[5])
		BGMgr:regGuideObj(BGMgr.TGR_CHAPTER_1_BATTLE_6,self.uiBattleItemList[6])
	end
end

function T:setVisible(value)
	if value ~= self:isVisible() then
		self:__setVisible__(value)

		if value then
			self:updateCampaignInfo()
		end
	end
end

return T
