local T = Class.CampaignItem(function()
	return ccui.Layout:create()
end)

--- 战役信息窗口
T.CampaignInfoWindow=require("src.app.uiScript.components.battle.CampaignInfoWindow")

function T:def()
--- 图标
-- self.uiBack=nil

--- 战役名称
-- self.uiName=nil

--- 星级图标背景
-- self.uiStarBack=nil

--- 星级图标
-- self.uiStarIcon=nil

--- 星级数量
-- self.uiStarCount=nil

--- 锁定图标
-- self.uiLock=nil

--- 战役数据
-- self.data=nil

--- 是否锁定
-- self.isLock=nil
end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(630,202))
	self:setTouchEnabled(true)

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	local uiBack=ccui.ImageView:create()
	if C_PFM == cc.PLATFORM_OS_WP8 then
		uiBack:setScale(2)
	else
		uiBack:setScale(1/0.71)
	end
	self:addChild(uiBack)
	self.uiBack=uiBack

	local uiName=XMLLabel()
	uiName:setAlign("center","middle")
	uiName:setContentSize(cc.size(200,72))
	self:addChild(uiName)
	REL:toOther("left","top",uiName,self,32,2)
	self.uiName=uiName

	--星级图标背景
	local uiStarBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("campaignStarBack.png"))
	self:addChild(uiStarBack)
	REL:toOther("right","bottom",uiStarBack,self,20,26)
	self.uiStarBack=uiStarBack

	--星级图标
	local uiStarIcon=ccui.ImageView:create("star_disabled.png",ccui.TextureResType.plistType)
	self:addChild(uiStarIcon)
	REL:toOther("left","middle",uiStarIcon,uiStarBack,20,-3)
	self.uiStarIcon=uiStarIcon

	--星级数量
	local uiStarCount=XMLLabel("0/48")
	uiStarCount:setContentSize(cc.size(100,36))
	uiStarCount:setAlign("center","middle")
	self:addChild(uiStarCount)
	REL:toOther("center","middle",uiStarCount,uiStarBack,10,-4)
	self.uiStarCount=uiStarCount

	--锁定图标
	local uiLock=ccui.ImageView:create("campaignItemLock.png",ccui.TextureResType.plistType)
	self:addChild(uiLock)
	REL:toOther("center","middle",uiLock,self,0,0)
	self.uiLock=uiLock

	self:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			if not self.isLock then
				local infoWindow=self.CampaignInfoWindow.new(t:getData())
				WindowManager:push(infoWindow)
			end
		end
	end)
end

--- 更新icon
function T:updateIcon()
	self.uiBack:loadTexture(self.data.iconUrl,ccui.TextureResType.localType)
	REL:toOther("center","middle",self.uiBack,self,0,0)
end

--- 更新视图
function T:updateView()
	local data=self.data
	if not data then
		return
	end

	local battles = data.battles
	local curStarCount,totalStarCount=BattlesInfoMgr:getStar(battles),#battles*3

	--	self.uiBack:loadTexture(data.iconUrl,ccui.TextureResType.localType)
	self.uiBack:loadTexture(data.iconUrl,ccui.TextureResType.plistType)
	REL:toOther("center","middle",self.uiBack,self,0,0)
	if self.isLock then
		self.uiLock:setVisible(true)
		self.uiBack:setIsGray(true)

		self.uiStarBack:setVisible(false)
		self.uiStarIcon:setVisible(false)
		self.uiStarCount:setVisible(false)

		--self.uiStarIcon:loadTexture("star_disabled.png",ccui.TextureResType.plistType)
		self.uiName:setString(Language:get("ug202",data.sid,Language:get(data.name)))
		--self.uiStarCount:setString(Language:get("ug203",curStarCount,totalStarCount))
	else
		self.uiLock:setVisible(false)
		self.uiBack:setIsGray(false)

		if curStarCount == totalStarCount then
			self.uiStarIcon:loadTexture("star_enabled.png",ccui.TextureResType.plistType)
		else
			self.uiStarIcon:loadTexture("star_disabled.png",ccui.TextureResType.plistType)
		end

		self.uiName:setString(Language:get("ug200",data.sid,Language:get(data.name)))
		self.uiStarCount:setString(Language:get("ug201",curStarCount,totalStarCount))

		self.uiStarBack:setVisible(true)
		self.uiStarIcon:setVisible(true)
		self.uiStarCount:setVisible(true)
	end
end

--- 设置战役数据
function T:setData(value)
	self.data=value

	self:updateView()
end
--- 获取战役数据
function T:getData()
	return self.data
end

--- 设置是否锁定
function T:setIsLock(value)
	if value ~= self.isLock then
		self.isLock=value
		self:updateView()
	end
end
--- 获取是否锁定
function T:getIsLock()
	return self.isLock
end

return T
