--- 战役星级奖励项
local T=Class.CampaignStarAwardItem(function() return ccui.Layout:create() end)

--- 奖励数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")

function T:def()
--- 奖励图标
-- self.uiAwardIcon=nil

--- 奖励数量
-- self.uiAwardCount=nil

--- 星级图标
-- self.uiStarIcon=nil

--- 需要星级数量
-- self.uiNeedStarCount=nil

--- 奖励数据
-- self.propData=nil

--- 奖励数量
-- self.awardCount=nil

--- 是否已领取：1:领取了，2：未领取，3：星级没达到数量，未领取
-- self.isGeted=nil

--- 需要星级数量
-- self.needStarCount=nil

--- 当前星级数量
-- self.curStarCount=nil

--- 数据
-- self.data=nil
end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()
end

--- 内存清理
function T:cleanUp()
	if self.propData then
		ResLoader:unloadReses({IconManager.iconPath..self.propData.propIcon})
	end
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(84,116))
	self:setTouchEnabled(true)

--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	self:setBackGroundColor(cc.c3b(0,0,0))
--	self:setBackGroundColorOpacity(100)

	--奖励图标
	local uiAwardIcon=cc.Sprite:create()
	self:addChild(uiAwardIcon)
	self.uiAwardIcon=uiAwardIcon

	--奖励数量
	local uiAwardCount=XMLLabel("0")
	uiAwardCount:setContentSize(cc.size(72,36))
	uiAwardCount:setAlign("right","bottom")
	self:addChild(uiAwardCount)
	REL:toOther("right","bottom",uiAwardCount,self,4,38)
	self.uiAwardCount=uiAwardCount

	--	uiAwardCount:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiAwardCount:setBackGroundColor(cc.c3b(100, 110, 0))
	--	uiAwardCount:setBackGroundColorOpacity(100)

	--星级图标
	local uiStarIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("star_enabled.png"))
	self:addChild(uiStarIcon)
	REL:toOther("left","bottom",uiStarIcon,self,2,2)
	self.uiStarIcon=uiStarIcon

	--需要的星级数量
	local uiNeedStarCount=XMLLabel("0")
	uiNeedStarCount:setContentSize(cc.size(38,36))
	uiNeedStarCount:setAlign("left","middle")
	self:addChild(uiNeedStarCount)
	REL:toOther("left","bottom",uiNeedStarCount,self,46,0)
	self.uiNeedStarCount=uiNeedStarCount

	-- 添加监听事件
	self:setTouchEnabled(true)
	self:addTouchEventListener(function(s,e)
		if e == ccui.TouchEventType.ended then
			if self.isGeted == 2 then

				require("src.app.communication.fight.GetChapterAwardCommand"):new():exec(self.campaignInfo.sid,self.index,function(state,awardData)
					if state == ReturnCode.SUCCESS then
						self.isGeted = 3
						-- 移除动画
						self:removeAnimation()
						MUIAlter_singleLine.show({
							info = self.AwardDataDecoder:award2HTML(awardData),
							showSecond = 1,
							popSnd=SoundRes.SND_SND_GET_AWARD
						})

						self:updateView()
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end)

			else -- 弹出信息
				local iconUrl = self.propData.propIcon
				local name = Language:get(self.propData.prop)
				local num = self.awardCount

				-- 描述:这个要根据情况设置
				local description = PlayerInstance:getPropDescripe(self.propData.propSid)
				local layout = ItemPopInfo.new(iconUrl,name,num,description)
				MUIAlter_noTitle.show({
					info = layout,
					flag = 1
				})

			end
		end
	end
	)

end

--- 更新视图
function T:updateView()
	--更新图标
	local iconUrl=IconManager.iconPath..self.propData.propIcon
	if iconUrl and iconUrl ~= "0" then
		self.uiAwardIcon:setTexture(iconUrl)
		REL:relRect(self.uiAwardIcon,cc.rect(0,0,80,80),0,0,0,0)
		REL:toOther("center","top",self.uiAwardIcon,self,0,2)
	end

	--更新奖励数量
	self.uiAwardCount:setString(Language:get("ug254",self.awardCount or 0))

	--更新需要数量,数量不满足为红色
	local battleBox = BattlesInfoMgr
	local allStarNum = battleBox:getStar(self.campaignInfo.battles)
	if self.needStarCount <= allStarNum then
		self.uiNeedStarCount:setString(Language:get("ug255",self.needStarCount))
		local isGetAward = battleBox:getStarAwardIsGet(self.campaignInfo.sid,self.index)
		if isGetAward then
			self.isGeted = 1
			self:setIsGray(true)
		else
			self.isGeted = 2 -- 动画
			self:addAnimation()
		end

	else -- 没有达到星级数量
		self.uiNeedStarCount:setString(Language:get("uc312",self.needStarCount))
		self.isGeted = 3
	end

end

--- 添加动画
function T:addAnimation()
	if not self.awardAnimationTag then
		self.awardAnimationTag = self:getEff("iconEff_blue")
		self:addChild(self.awardAnimationTag)
		self.awardAnimationTag:setScale(0.8,0.8)
		REL:toOther("center", "middle", self.awardAnimationTag, self, 0, 15)
	end
end

--- 移除动画
function T:removeAnimation()
	if self.awardAnimationTag then
		self.awardAnimationTag:removeFromParent()
		self.awardAnimationTag = nil
	end
end

--- 获得特效
function T:getEff(kind)
	local s = cc.Sprite:create()
	local ani = ResLoader:getAnimation(kind)
	if not ani then
		return
	end
	local ac = cc.RepeatForever:create(cc.Animate:create(ani))
	s:runAction(ac)
	return s
end

--- 设置数据
function T:setData(value)
	if value ~= self.data then
		if self.propData then
			ResLoader:unloadReses({IconManager.iconPath..self.propData.propIcon})
		end
		self.data=value

		self.campaignInfo = value.campaignInfo -- 战役信息
		self.propData=value.propData
		self.awardCount=value.awardCount
		self.needStarCount=value.needStarCount
		self.curStarCount=value.curStarCount
		self.index = value.index  -- 从左到右的0，1，2

		self:updateView()
	end
end

----- 设置是否已领取
--function T:setIsGeted(value)
--	if value ~= self.isGeted then
--		self.isGeted=value

--		self:updateView()
--	end
--end
----- 获取是否已领取
--function T:getIsGeted()
--	return self.isGeted
--end


return T
