--- 关卡buff项
local T = Class.ChapterBuffInfoTip(function()
	return ccui.Layout:create()
end)

--- 关卡buff
T.chapterBuff_temp=require("res.data.battle.chapterBuff")

--- 战役数据
T.Campaign_temp=require("res.data.battle.campaign")

function T:def()
--- 数据
-- self.data=nil
end

function T:ctor(data)
	self.data=data

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
    self:refreshPos()

end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	if self.data then
		ResLoader:unloadReses({IconManager.iconPath..self.data.iconUrl})
	end
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(528,516 + 20))
	self:setTouchEnabled(false)

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	local data=self.data
	
	local left,top=10,10

	--图标
	local uiIcon=cc.Sprite:create(IconManager.iconPath..data.iconUrl)
	self:addChild(uiIcon)
	REL:relRect(uiIcon,cc.rect(0,0,80,80),0,0,0,0)
	REL:toOther("left","top",uiIcon,self,left,top)
	self.uiIcon=uiIcon
	
	left=left+80

	--名称
	local uiName=XMLLabel()
	uiName:setContentSize(cc.size(360,36))
	uiName:setAlign("left","middle")
	self:addChild(uiName)
	REL:toOther("left","top",uiName,uiIcon,left,0)
	uiName:setString(Language:get("ug220",Language:get(data.name)))
	self.uiName=uiName

	--等级
	local uiLv=XMLLabel()
	uiLv:setContentSize(cc.size(360,36))
	uiLv:setHAlign("left","middle")
	self:addChild(uiLv)
	REL:toOther("left","bottom",uiLv,uiIcon,left,0)
	self.uiLv=uiLv

	local chapteBuffBox=BattlesInfoMgr:getChapterBuffsInfo()
	local lv=chapteBuffBox.infos[data.buffId] or 0
	if lv == 0 then
		uiLv:setString(Language:get("ug224"))
	else
		uiLv:setString(Language:get("ug221",lv))
	end
	
	left=10
	top=top+80+20

	--横隔线1
	local sep1=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("seqLine1.png"))
	self:addChild(sep1)
	REL:relOther(sep1,self,left,left,top,SIZE_NIL)
	self.sep1=sep1
	
	top=top+10

	--等级1描述
	local lv1Des=XMLLabel()
	lv1Des:setHeight(98)
	lv1Des:setAlign("left","top")
	self:addChild(lv1Des)
	REL:relOther(lv1Des,self,left,left,top,SIZE_NIL)
	self.lv1Des=lv1Des

	lv1Des:setString(Language:get(
		lv == 1 and "ug223" or "ug222",
		Language:get(data.name),
		1,
		data.activeNeed[1],
		Language:get(self.Campaign_temp[data.activeNeed[1]].name),
		data.activeNeed[2],
		Language:get(data.des,data.levelEff[1])
	))
	
    lv1Des:updateView()
	top=top+lv1Des:getTextHeight() + 20

	--横隔线2
	local sep2=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("seqLine1.png"))
	self:addChild(sep2)
	REL:relOther(sep2,self,left,left,top,SIZE_NIL)
	self.sep2=sep2
	
	top=top+10

	--等级2描述
	local lv2Des=XMLLabel()
	lv2Des:setHeight(98)
	lv2Des:setAlign("left","top")
	self:addChild(lv2Des)
	REL:relOther(lv2Des,self,left,left,top,SIZE_NIL)
	self.lv2Des=lv2Des

	lv2Des:setString(Language:get(
		lv == 2 and "ug223" or "ug222",
		Language:get(data.name),
		2,
		data.activeNeed[3],
		Language:get(self.Campaign_temp[data.activeNeed[3]].name),
		data.activeNeed[4],
		Language:get(data.des,data.levelEff[2])
	))
	
    lv2Des:updateView()
	top=top+lv2Des:getTextHeight()+20

	--横隔线3
	local sep3=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("seqLine1.png"))
	self:addChild(sep3)
	REL:relOther(sep3,self,left,left,top,SIZE_NIL)
	self.sep3=sep3
	
	top=top+10

	--等级3描述
	local lv3Des=XMLLabel()
	lv3Des:setHeight(98)
	lv3Des:setAlign("left","top")
	self:addChild(lv3Des)
	REL:relOther(lv3Des,self,left,left,top,SIZE_NIL)
	self.lv3Des=lv3Des

	lv3Des:setString(Language:get(
		lv == 3 and "ug223" or "ug222",
		Language:get(data.name),
		3,
		data.activeNeed[5],
		Language:get(self.Campaign_temp[data.activeNeed[5]].name),
		data.activeNeed[6],
		Language:get(data.des,data.levelEff[3])
	))

    lv3Des:updateView()
	top=top+lv3Des:getTextHeight()
    self.top = top
end

function T:refreshPos()
    self:setContentSize(cc.size(528,self.top + 20))

    local left,top=10,10

	--图标
	REL:relRect(self.uiIcon,cc.rect(0,0,80,80),0,0,0,0)
	REL:toOther("left","top",self.uiIcon,self,left,top)

	left=left+80

	--名称
	REL:toOther("left","top",self.uiName,self.uiIcon,left,0)

	--等级
	REL:toOther("left","bottom",self.uiLv,self.uiIcon,left,0)

	left=10
	top=top+80+20

	--横隔线1
	REL:relOther(self.sep1,self,left,left,top,SIZE_NIL)

	top=top+10

	--等级1描述
	REL:relOther(self.lv1Des,self,left,left,top,SIZE_NIL)

    self.lv1Des:updateView()
	top=top+self.lv1Des:getTextHeight() + 20

	--横隔线2
	REL:relOther(self.sep2,self,left,left,top,SIZE_NIL)
	
	top=top+10

	--等级2描述
	REL:relOther(self.lv2Des,self,left,left,top,SIZE_NIL)

    self.lv2Des:updateView()
	top=top+self.lv2Des:getTextHeight()+20

	--横隔线3
	REL:relOther(self.sep3,self,left,left,top,SIZE_NIL)
	
	top=top+10

	--等级3描述
	REL:relOther(self.lv3Des,self,left,left,top,SIZE_NIL)

end

function T:updateView()
	if self.data then
		self.uiIcon:setTexture(self.data.iconUrl)
		REL:toOther("left","top",self.uiIcon,self,10,10)
	end
end

function T:setData(value)
	if value ~= self.data then
		if self.data then
			ResLoader:unloadReses({IconManager.iconPath..self.data.iconUrl})
		end

		self.data=value

		self:updateView()
	end
end

function T:getData()
	return self.data
end

return T
