--- 关卡buff项
local T = Class.ChapterBuffItem(function()
	return ccui.Layout:create()
end)

--- 关卡buff
T.chapterBuff_temp=require("res.data.battle.chapterBuff")

--- 关卡buff信息
T.ChapterBuffInfoTip=require("src.app.uiScript.components.battle.ChapterBuffInfoTip")

function T:def()
--- 数据
-- self.data=nil
end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入场景
function T:onEnter()
end

--- 退出场景
function T:onExit()

end

--- 内存清理
function T:cleanUp()
	if self.data then
		ResLoader:unloadReses({IconManager.iconPath..self.data.iconUrl})
	end
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(68,68))
	self:setTouchEnabled(true)
	self:addTouchEventListener(function(t,e)
		if e==ccui.TouchEventType.ended then
			if self.data then
				local uiTip=self.ChapterBuffInfoTip(self.data)
			
				MUIAlter_noTitle.show({
					info=uiTip,
					mask=true
				})
			end
		end
	end)

	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	self:setBackGroundColor(cc.c3b(0xff,0,0))
	self:setBackGroundColorOpacity(100)

	--图标
	local uiIcon=cc.Sprite:create()
	self:addChild(uiIcon)
	self.uiIcon=uiIcon
end

function T:updateView()
	local data=self.data

	if data then
		local chapteBuffBox=BattlesInfoMgr:getChapterBuffsInfo()
		local lv=chapteBuffBox.infos[data.buffId]
		if lv and lv > 0 then
			self:setIsGray(false)
		else
			self:setIsGray(true)
		end

		self.uiIcon:setTexture(IconManager.iconPath..data.iconUrl)
		local s=self:getContentSize()
		REL:relRect(self.uiIcon,cc.rect(0,0,s.width,s.height),0,0,0,0)
		REL:toOther("center","middle",self.uiIcon,self,0,0)
	end
end

function T:setData(value)
	if value ~= self.data then
		if self.data then
			--移除原图片
			ResLoader:unloadReses({IconManager.iconPath..self.data.iconUrl})
		end

		self.data=value

		self:updateView()
	end
end

function T:getData()
	return self.data
end

return T
