local super=require("src.app.uiScript.components.share.AbstractFullScreenWindow")

---部队出征窗口
--@author blank
local T = class("CreatePlayerWindow", function()
	local t = super.new()
	t.__setVisible__=t.setVisible

	return t
end)

T.RoleItem=require("src.app.uiScript.components.beginnersGuide.RoleItem")

--- 预加载资源列表
T.PRE_RES_LIST={
	"res/images/guide/roleCreate.plist",
--	"res/images/windowBack2.plist"
}

--- 构造函数
function T:ctor()
	mapping(self,require("src.app.uiScript.components.share.WindowEffTemplate"))

	ResLoader:syncLoad(self.PRE_RES_LIST)
	self:init()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 退出场景
function T:onExit()
	super.onExit(self)

	self:stopAllActions()
end

--- 内存清理
function T:cleanUp()
	super.cleanUp(self)

	ResLoader:unloadReses(self.PRE_RES_LIST)
end

--- 初始化
function T:init()
	--背景
	local uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("windowBack4.jpg"))
	self:addChild(uiBack)
	REL:relScreen(uiBack,0,0,0,0)
	self.uiBack = uiBack

	--上边框
	local uiTopBorder=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("roleSelectTopBorder.png"))
	self:addChild(uiTopBorder)
	self.uiTopBorder=uiTopBorder
	REL:toScreen("center","top",uiTopBorder,0,0)

	--标题
	local uiTitle=XMLLabel(Language:get("ug1220"))
	uiTitle:setCssStyle(CssStyles.windowTitle)
	uiTitle:setAlign("center","middle")
	self:addChild(uiTitle)
	REL:relOther(uiTitle,uiTopBorder,0,0,0,0)

	--角色1
	local uiRoloe1Photo=self.RoleItem(1)
	uiRoloe1Photo:setTouchEnabled(true)
	uiRoloe1Photo:setScale(0.75)
	uiRoloe1Photo:setColor(cc.c3b(150,150,150))
	uiRoloe1Photo:setAnchorPoint(cc.p(0.5,0.5))
	self:addChild(uiRoloe1Photo)
	REL:toOther("center","middle",uiRoloe1Photo,self,-140,100)

	uiRoloe1Photo:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:selectRole(t)
		end
	end)

	--角色2
	local uiRoloe2Photo=self.RoleItem(2)
	uiRoloe2Photo:setTouchEnabled(true)
	uiRoloe2Photo:setScale(0.75)
	uiRoloe2Photo:setColor(cc.c3b(150,150,150))
	uiRoloe2Photo:setAnchorPoint(cc.p(0.5,0.5))
	self:addChild(uiRoloe2Photo)
	REL:toOther("center","middle",uiRoloe2Photo,self,140,100)

	uiRoloe2Photo:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:selectRole(t)
		end
	end)

	self:selectRole(uiRoloe1Photo)
	
	--修改名称的提示
	local uiNotice=XMLLabel(Language:get("ug_changeNameNotice"))
	uiNotice:setCssStyle(CssStyles.red24)
	uiNotice:setContentSize(cc.size(480,72))
	uiNotice:setAlign("center","middle")
	self:addChild(uiNotice)
	REL:toOther("center","middle",uiNotice,self,0,-180)

	--玩家名称长度限制
	local lLimit,uLimit=unpack(GameCfg.PLAYER_NAME_LIMIT)

	--玩家名称输入框背景
	local uiNameInputBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("roleNameInputBox.png"))
	self:addChild(uiNameInputBack)
	uiNameInputBack:setContentSize(cc.size(300,60))
	REL:toOther("center","middle",uiNameInputBack,self,0,-280)

	--玩家名称输入框
	local f=ResLoader:getSpriteFrame("editBoxBack.png")
	local fs=f:getOriginalSize()
	local uiNameInput=InputBox:create(cc.size(280,50),ccui.Scale9Sprite:createWithSpriteFrame(f,cc.rect(fs.width/2,fs.height/2,1,1)))
	uiNameInput:setMaxLength(uLimit)
	self:addChild(uiNameInput)
	REL:toOther("center","middle",uiNameInput,uiNameInputBack,0,0)
	self.uiNameInput=uiNameInput

	--"确定"按钮
	local uiOkButton=BaseButton:createButton(Language:get("ug1205"),"roleOkButton_normal.png")
	self:addChild(uiOkButton)
	REL:toOther("center","middle",uiOkButton,self,0,-380)
	self.uiOkButton=uiOkButton

	uiOkButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			local name=uiNameInput:getText()
			--玩家名称为空验证
			if not name or string.trim(name) == "" then
				MUIAlter.show({
					info=Language:get("ug1206")
				},WindowManager:getCurrentWindow())
				return
			end

			--玩家名称长度验证
			local c=StringUtils.getCount(name)
			local lLimit,uLimit=unpack(GameCfg.ALLIANCE_NAME_LIMIT)
			if c < lLimit or c > uLimit then
				MUIAlter.show({
					info=Language:get("ug1207",lLimit,uLimit)
				},WindowManager:getCurrentWindow())
				return
			end
			
			--敏感字验证
			if WordsFilters:contains(name,SensitiveWordsRoot) then
				MUIAlter.show({
					info=Language:get("er4")
				},WindowManager:getCurrentWindow())
			
				return
			end

			require("src.app.communication.beginnersGuide.ChangePlayerNameCommand")():exec(
				name,self._uiRole:getId(),
				function(state)
					if state == ReturnCode.SUCCESS then
						MUIAlter_singleLine.show({
							info=Language:get("ug1208"),
							showSecond=1.5
						})

						WindowManager:pop()

						if BGMgr:isGuide() then
							BGMgr:fire(BGMgr.EVT_PLAYER_NAME_CHANGED)
						end
					else
						MUIAlter_singleLine.show({
							info=ErrorCode:getErrInfo(state)
						},WindowManager:getCurrentWindow())
					end
				end
			)
		end
	end)
end

--- 选择角色
function T:selectRole(uiRoloe)
	if not uiRoloe or uiRoloe == self._uiRole then
		return
	end

	local oldUiRole=self._uiRole
	if oldUiRole then
		oldUiRole:stopAllActions()
		oldUiRole:runAction(cc.ScaleTo:create(0.2,0.75))
		oldUiRole.__clrAct__=AbstractUI.interval(oldUiRole,function()
			local clr=(oldUiRole.__color__ or 255) - 4
			
			if clr <= 150 then
				clr =150
				
				AbstractUI.clearScheduler(oldUiRole,oldUiRole.__clrAct__)
			end
			
			oldUiRole:setColor(cc.c3b(clr,clr,clr))
			oldUiRole.__color__=clr
		end,0)
	end
	
	self._uiRole=uiRoloe
	
	uiRoloe:stopAllActions()
	uiRoloe:runAction(cc.ScaleTo:create(0.2,1))
	uiRoloe.__clrAct__=AbstractUI.interval(uiRoloe,function()
		local clr=(uiRoloe.__color__ or 150) + 4
		
		if clr >= 255 then
			clr=255
			AbstractUI.clearScheduler(uiRoloe,uiRoloe.__clrAct__)
		end
		
		uiRoloe:setColor(cc.c3b(clr,clr,clr))
		uiRoloe.__color__=clr
	end,0)
end

return T
