local T=Class.GuideTipBox(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 背景
	-- _uiBack

	--- 文本
	-- _uiText
end

function T:ctor(text)
	AbstractUI.ctor(self)

	self.text=text

	self:_init()
end

function T:_init()
	local uiBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("guideTipBack.png"))
	self:addChild(uiBack)
	self._uiBack=uiBack

	local uiText=XMLLabel()
	uiText:setAutoSizeLabel("width")
	self:addChild(uiText)
	self._uiText=uiText

	--跳过按钮
	local _uiSkipButton=BaseButton:createButton(nil,"guideCloseButton.png")
	self:addChild(_uiSkipButton,2)
	self._uiSkipButton=_uiSkipButton

	_uiSkipButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:skipButtonHandler()
		end
	end)
end

--- 跳过
function T:skipButtonHandler()
	MUIAlter.show({
		info=Language:get("ug1222"),
		flag=3,
		zOrder=TOP_ORDER + 300,
		callback=function(flag)
			if flag == FLAG_OK then
				BGMgr:skip()
			end
		end
	})
end

function T:setCoordinate(tipText,x,y,rotation)
	local uiText=self._uiText
	local uiBack=self._uiBack
	local _uiSkipButton=self._uiSkipButton

	uiText:setString(tipText)
	uiText:updateView()

	--设置背景的大小
	REL:relOther(uiBack,uiText,-60,-60,-20,-20)

	local hAlign,vAlign="right","top"
	if rotation == 0 then
		uiBack:setAnchorPoint({x=0.5,y=0})

		_uiSkipButton:setFlippedY(false)
		vAlign="top"
	elseif rotation == 180 then
		uiBack:setAnchorPoint({x=0.5,y=1})

		_uiSkipButton:setFlippedY(true)
		vAlign="bottom"
	end

	--如果背景超出了边界,则修正到边界之内
	local bs=uiBack:getContentSize()
	local w,h=bs.width,bs.height
	local l,r=O_PT.x + w / 2,O_PT.x+V_SZ.width-w/2
	if x < l then
		x=l
	elseif x > r then
		x=r
	end

	--如果背景图片靠左,则"跳过"按钮在右边,反之
	if x <= O_PT.x+V_SZ.width/2 then
		_uiSkipButton:setFlippedX(false)
		hAlign="right"
	else
		_uiSkipButton:setFlippedX(true)
		hAlign="left"
	end

	uiBack:setPosition(x,y)
	REL:toOther("center","middle",uiText,uiBack,0,0)

	REL:toOther(hAlign,vAlign,self._uiSkipButton,uiBack,-8,-self._uiSkipButton:getContentSize().height+8)
end

return T
