local T=Class.RoleItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

T.ROLES={
	[1]={id=1,photoUrl="res/images/role/rolePhoto1.png"},
	[2]={id=2,photoUrl="res/images/role/rolePhoto2.png"},
}

function T:def()
	AbstractUI.def(self)
end

function T:ctor(roleId)
	self.roleId=roleId
	AbstractUI.ctor(self)

	self:_init()
end

function T:cleanUp()
	AbstractUI.cleanUp(self)
	
	local role=self.ROLES[self.roleId or 1]
	if role then
		ResLoader:unloadReses({role.photoUrl})
	end
end

function T:_init()
    local f=ResLoader:getSpriteFrame("roleBack.png")

	--背景
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	self.uiBack=uiBack
	
	self:setContentSize(f:getOriginalSize())
	REL:toOther("center","middle",uiBack,self,0,0)

	local role=self.ROLES[self.roleId or 1]
	if role then
		local uiRolePhoto=cc.Sprite:create(role.photoUrl)
		self:addChild(uiRolePhoto)
		self.uiRolePhoto=uiRolePhoto
		REL:toOther("center","bottom",uiRolePhoto,self,0,18)
	end
end

function T:getId()
	local role=self.ROLES[self.roleId or 1]
	if role then
		return role.id
	end
	
	return 1
end

function T:setColor(c3b)
	self.uiBack:setColor(c3b)
	if self.uiRolePhoto then
		self.uiRolePhoto:setColor(c3b)
	end
end

return T
