--- 建造窗口
local T = class("BuildingConstruct",function() return ccui.Layout:create() end)

--- 服务器数据
T.dataFromServer = nil

--- size大小
T.size = nil

--- res的基础值
T.baseValue = 500

--- 升级或者加速标志： 1是升级，2是加速,3是免费加速
T.upTag = 1

--- 一健升级或者取消的标志： 1是一健升级，2是取消
T.immediateUpTag = 1

--- 进度条的tag值
T.PROGRESS_TAG = 2000

--- 父亲窗口
T.parent = nil


--- 构造函数
function T:ctor(data,parent)
	self.dataFromServer = data
	self.parent = parent

	self:registerScriptHandler(
		function(eventType)
			--print("Construct:"..eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	self.size = cc.size(630,770) -- 建造窗口的大小,暂时没有做适配
	self:setContentSize(self.size)

	-- 得到json中的控件
	self:GetWidget()
	-- 进入页面显示数据
	self:ShowData()
	-- 按钮回调设置
	self:SetButton()

	--- 检测等级，如果等级等于了指挥中心的等级就不能升级了
	self:_checkLevel()

end

function T:_checkLevel()
	local judge = false
	if self.dataFromServer.location ~= 1 then
		local level = self.dataFromServer.level
		local comandLevel = BuildingsInfoMgr:getBuildingInfos()[1].level
		if level >= comandLevel then
			self._btnUpgrade:setIsGray(true)
			--self._btnUpgrade:setTouchEnabled(false)
			self._btnImmediaUp:setIsGray(true)
			--self._btnImmediaUp:setTouchEnabled(false)
			judge = true
		end
	end
	return judge
end

function T:onEnter()
	if BGMgr:isGuide() then
		BGMgr:fire(BGMgr.EVT_BUILDING_BUILD_VIEW_CREATED)
	end

	-- 时间的检测
	if self.dataFromServer.id then
		local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]  -- 判断当前的建筑物是否在升级建筑物的队列中
		if item then  --立即刷新，因为添加侦听会下一步执行
			if item.remainingSec and item.remainingSec > 0 then    --升级过程
				-- 立刻按钮变了
				self:immediateCancelLogic()

				self:AddProgressBar()
				self:RefreshUpGradeData(item)
				self:UpgradeHandle()
		end
		end
	end

	self:addEventListener()
    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaAddEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)

    CommonBroadcast:luaAddEventListener("build_queue_pop_window_finish" .. self.dataFromServer.location,self,self.buildQueuePopFinish)

end

function T:onExit()
	self:removeEventListener()

    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaRemoveEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)

    CommonBroadcast:luaRemoveEventListener("build_queue_pop_window_finish" .. self.dataFromServer.location,self,self.buildQueuePopFinish)
end

function T:cleanUp()

end

function T:immediateCancelLogic()
	local btnImmediaUp=self._btnImmediaUp

	btnImmediaUp:loadTextures("bigButton_gray_normal.png","bigButton_general_down.png","",ccui.TextureResType.plistType)
	btnImmediaUp:setString(Language:get("ug941"))
	local uiText=btnImmediaUp.buttonText
	uiText:setContentSize(btnImmediaUp:getContentSize())
	uiText:setAlign("center","middle")
	uiText:setPosition(0,0)

	CCUIREL:toOther("left","bottom",self._btnImmediaUp,self,40,40)
	self.immediateDiamon:setVisible(false)
end

function T:immediateBtnLogic()
	self._btnImmediaUp:loadTextures("oneKeyLvUpButton_normal.png","oneKeyLvUpButton_normal.png","",ccui.TextureResType.plistType)
	self._btnImmediaUp.buttonText:setContentSize(cc.size(150,27))
	self._btnImmediaUp.buttonText:setAlign("left","top")
	CCUIREL:toOther("left","bottom",self._btnImmediaUp,self,40,50)
	REL:toOther("left","bottom",self._btnImmediaUp.buttonText,self._btnImmediaUp,80,18)
	self.immediateDiamon:setVisible(true)

end

function T:resetUpdate()

    -- 检查是否升级完成
    if self.dataFromServer.id == nil then
		local location = self.dataFromServer.location
		self.dataFromServer = BuildingsInfoMgr:getBuildingInfos()[location]
		self.parent.dataFromServer = self.dataFromServer
	end

    -- 时间的检测
	if self.dataFromServer.id then
		local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]  -- 判断当前的建筑物是否在升级建筑物的队列中
        local syncSec=TimeUtils:getSyncMillis()/1000

        if item then
            local remainingSec = item.endTimeSec - syncSec

		    if remainingSec > 0 then 
		    else -- 升级完成
                self:levelUpdate()
		    end
        else
            self:levelUpdate()
        end

	end

end

function T:levelUpdate()
	-- 如果是建造的话，要更新着份数据
	self:_checkLevel()
	if self.dataFromServer.id == nil then
		local location = self.dataFromServer.location
		self.dataFromServer = BuildingsInfoMgr:getBuildingInfos()[location]
		self.parent.dataFromServer = self.dataFromServer
	end
	local data = Build_temp[self.dataFromServer.sid]
	local level = self.dataFromServer.level
	self.parent:setTitle(level)
	-- 刷新其它数据
	self:UpGradeFinish()
	--MUIPop.MUIUpGradeSuccess() -- 升级完成就只有一个提示就行了
	--		local descripe = Language:get("uc12",Language:get(data.name),level)
	--		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

	if self.dataFromServer.level == 60 then
		self._btnUpgrade:setVisible(false)
		self._btnImmediaUp:setVisible(false)
        self.resView:setVisible(false)
	end

	self:buildEff()
end

--- 添加监听
function T:addEventListener()
	-- 添加资源管理数据刷新（每分钟）
	ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.RefreshData2)
	
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.dataFromServer.location,self,self.levelUpdate)
	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.resetUpdate)
end

--- 移除监听
function T:removeEventListener()
	ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,self,self.RefreshData2)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.dataFromServer.location,self,self.levelUpdate)
	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.resetUpdate)
	if self.dataFromServer.id then -- 防止没建造的时候退出
		BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.dataFromServer.id,nil,self.update)
	end
end

function T:GetWidget()
	-- 整个上面的背景图片
	local buildingInfoBackFrame = ResLoader:getSpriteFrame("buildingInfoBack.png")
	local buildingInfoBackFrameSize = buildingInfoBackFrame:getOriginalSize()
	local imgBuildingInfoBack = Scale9Sprite:createWithFrame(buildingInfoBackFrame,cc.rect(buildingInfoBackFrameSize.width/2,buildingInfoBackFrameSize.height/2,1,1))
	self:addChild(imgBuildingInfoBack)

	REL:toOther("left","top",imgBuildingInfoBack,self,5,0)
	self._imgBuildingInfoBack = imgBuildingInfoBack

	-- 头像
	local imgHead = ccui.ImageView:create()

	local iconPath = IconManager.iconPath
	imgHead:loadTexture(iconPath .. Build_temp[1].icon)

	self:addChild(imgHead)
	REL:toOther("left","top",imgHead,imgBuildingInfoBack,23,15)
	self._imgHead = imgHead

	-- 名字
	local labelName = XMLLabel()
	labelName:setContentSize(cc.size(300,27))
	labelName:setHAlign("left")
	labelName:setVAlign("middle")
	self:addChild(labelName)
	REL:toOther("left","middle",labelName,self._imgBuildingInfoBack,180,68)
	self._labelName = labelName

	-- 时间
	local labelTime = XMLLabel()
	labelTime:setContentSize(cc.size(200,27))
	labelTime:setHAlign("center")
	labelTime:setVAlign("middle")
	self:addChild(labelTime)
	--REL:toOther("left","top",labelTime,self._imgBuildingInfoBack,30,152)
	REL:toOther("center","middle",labelTime,self._imgBuildingInfoBack,-222,-68 - 10)
	self._labelTime = labelTime

    -- 有活动的时候原来的时间
    local activivityTime = XMLLabel()
    activivityTime:setAlign("center","middle")
    activivityTime:setContentSize(cc.size(400,36))
    self:addChild(activivityTime)
    REL:toOther("center","middle",activivityTime,self._imgBuildingInfoBack,-222,-68 + 15)
    self.activivityTime = activivityTime

    local layer = CommonMethod:drawLine(50,50)
    activivityTime:addChild(layer)
    REL:toOther("center","middle",layer,activivityTime,0,0)
    activivityTime.layer = layer


	-- 描述
	local labelDescription = XMLLabel()
	labelDescription:setContentSize(cc.size(430,100))
	self:addChild(labelDescription)
	REL:toOther("left","top",labelDescription,self._imgBuildingInfoBack,180,75)
	self._labelDescription = labelDescription

	-- 中间资源部分
	local level = self.dataFromServer.level
	if level < 70 then
		if self.dataFromServer.location == 1 then
			local resView = ResView.new(3)  -- 3是资源项目的数目

			local needResTable = self.parent.modelResTable[level].need
			resView:addResItem(nil,needResTable,nil)
			self:addChild(resView)
			REL:toOther("left","top",resView,self._imgBuildingInfoBack,3,buildingInfoBackFrameSize.height + 5) -- 顶部相对向下是正的
			self.resView = resView
		else
			local resView = ResView.new(4)  -- 1+3是资源项目的数目

			local needResTable = self.parent.modelResTable[level].need

			local name = Language:get("uc186")
			local nowLevel = BuildingsInfoMgr:getBuildingInfos()[1].level
			local iconUrl = IconManager.iconPath .. Build_temp[1].icon

			resView:addResItem({["iconUrl"] = iconUrl,["name"] = name,["needLevel"] = level + 1,["nowLevel"] = nowLevel },needResTable,nil)
			self:addChild(resView)
			REL:toOther("left","top",resView,self._imgBuildingInfoBack,3,buildingInfoBackFrameSize.height + 5) -- 顶部相对向下是正的
			self.resView = resView
		end

	end

	-- 升级按钮
	local btnUpgrade = Button.new("true","true")
	btnUpgrade:setName("Button_upgrade")
	btnUpgrade:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
	btnUpgrade:setButtonPic("levelUpIcon.png")
	btnUpgrade:setString(Language:get("uc7"))
	self:addChild(btnUpgrade)
	REL:toOther("right","bottom",btnUpgrade,self,60,40)
	self._btnUpgrade = btnUpgrade

	-- 立即完成按钮
	local btnImmediaUp = Button.new("false","true")
	btnImmediaUp:setName("Button_immediate_up")
	btnImmediaUp:setButtonState("oneKeyLvUpButton_normal.png","oneKeyLvUpButton_normal.png")
	--btnImmediaUp:setButtonPic("addSpeedIcon.png")
	btnImmediaUp:setString(Language:get("uc6"))
	self:addChild(btnImmediaUp)
	--REL:toOther("left","bottom",btnImmediaUp,self,60,40)
	CCUIREL:toOther("left","bottom",btnImmediaUp,self,40,50)
	self._btnImmediaUp = btnImmediaUp

	--    if self.dataFromServer.id then
	--        local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
	--        if item then
	--            REL:toOther("left","bottom",btnImmediaUp,self,40,26)
	--        end
	--    end
	REL:toOther("left","bottom",btnImmediaUp.buttonText,btnImmediaUp,80,18)

	-- 立刻完成钻石数量显示
	local immediateDiamon = XMLLabel()
	immediateDiamon:setContentSize(cc.size(200,27))
	immediateDiamon:setVAlign("middle")
	immediateDiamon:setHAlign("center")
	btnImmediaUp:addChild(immediateDiamon)
	REL:toOther("center","middle",immediateDiamon,btnImmediaUp,15,25)
	self.immediateDiamon = immediateDiamon
	immediateDiamon:setLocalZOrder(1000)

	if self.dataFromServer.id then
		local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
		if item then
			REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,5)
		else
			REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,0)
		end

	end

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_BUILDING_LV_UP_BUTTON,btnUpgrade)
	end
end

function T:ShowData()
	-- 从配置文件中读取数据显示数据
	local data = Build_temp[self.dataFromServer.sid]

	--self._imgHead
	local iconPath = IconManager.iconPath
	self._imgHead:loadTexture(iconPath .. data.icon)

	local sid = self.dataFromServer.sid
	local location = self.dataFromServer.location
	if sid == 5 then
		if location == 6 then
			self._labelName:setString(Language:get("uc699",Language:get("uc148")))
		else
			self._labelName:setString(Language:get("uc699",Language:get("uc149")))
		end
	elseif sid == 2 then
		if location == 2 then
			self._labelName:setString(Language:get("uc699",Language:get("uc150")))
		else
			self._labelName:setString(Language:get("uc699",Language:get("uc151")))
		end
	else
		self._labelName:setString(Language:get("uc699",Language:get(data.name)))
	end


	-- 服务器数据显示
	self:RefreshData1()
end

--- 升级过后根据等级更新数据显示
function T:RefreshData1()
	local ModelResTable = self.parent.modelResTable

	local data = Build_temp[self.dataFromServer.sid]
	local level = self.dataFromServer.level
	local capacity = ModelResTable[level].capacity -- 描述的处理，要根据等级来读取产量和容量
	local output = ModelResTable[level].output
	local accSpeed = ModelResTable[level].accSpeed -- 科研中心研发速度

	local levalInfosPara = data.levalInfosPara

	-- 科研中心是研发速度
	if self.dataFromServer.sid == 3 then
		if accSpeed then
			local info = Language:get(levalInfosPara,accSpeed)
			self._labelDescription:setString(info)
		end
	else
		if self.dataFromServer.sid == 5 then
			if capacity then
				local info = Language:get(levalInfosPara,UnitConversion.unitTrans(capacity))
				self._labelDescription:setString(info)
			end
		else
			if output and capacity then
				local info = Language:get(levalInfosPara,UnitConversion.unitTrans(output*60),UnitConversion.unitTrans(capacity))
				self._labelDescription:setString(info)
				-- 机库
			elseif self.dataFromServer.sid == 2 then
				local info = Language:get(levalInfosPara)
				self._labelDescription:setString(info)
			else
				self._labelDescription:setString(Language:get(levalInfosPara)) -- 这个是改造中心
			end

		end
	end

	-- 这是立刻完成所显示的文字
	self._btnImmediaUp:setString(Language:get("uc6"))
	-- 立刻完成所显示的钻石数字
	local ModelResTable = self.parent.modelResTable
	local allDiamond = BuildingDiamondCalculation.FreeTimeGetImmediateFinishDiamond(self.dataFromServer,ModelResTable)
	self.immediateDiamon:setString(Language:get("uc102",allDiamond))

	-- 时间
	local time = ModelResTable[level].upgradeTime
    self:showActivityTime(BuildingDiamondCalculation:BuildConstructActualTimeNoActivity(time))
	time = BuildingDiamondCalculation:BuildConstructActualTime(time)
	self._labelTime:setString(Language:get("uc185",UnitConversion.handleTime4(time)))

	if self.dataFromServer.id == nil then
		self._btnImmediaUp:setVisible(false)
		self.immediateDiamon:setVisible(false)
		self._btnUpgrade:setString(Language:get("uc147"))
		self._btnUpgrade:setName("Button_construct")
	else
		self._btnImmediaUp:setVisible(true)
		self.immediateDiamon:setVisible(true)
		self._btnUpgrade:setName("Button_upgrade")
		self._btnUpgrade:setString(Language:get("uc7"))
	end

end


function T:showActivityTime(time)
    if not time then
        return
    end

    self.activivityTime:setString(UnitConversion.handleTime4(time))

    if ActivityManager.rapidDevelopmentInfo:getOpenValue() == true then
        REL:toOther("center","middle",self._labelTime,self._imgBuildingInfoBack,-222,-68 - 15)
        self.activivityTime:setVisible(true)
	    self.activivityTime:updateView()
	    local contentWidth = self.activivityTime:getTextWidth()
	    local contentHeight = self.activivityTime:getTextHeight()
        local draw = self.activivityTime.layer.draw
        if draw then
            self.activivityTime:setVisible(true)
            draw:clear()
            draw:drawSegment(cc.p(-(contentWidth/2),contentHeight/2), cc.p(contentWidth/2, -contentHeight/2), 1.5, cc.c4f(1, 0, 0, 1))
        end
    else
        REL:toOther("center","middle",self._labelTime,self._imgBuildingInfoBack,-222,-68)
        self.activivityTime:setVisible(false)
    end

end

--- 升级过后根据等级更新滚动层里面的数据,下一等级的需求和勾叉(显示上设置)
function T:RefreshData2()
	local level = self.dataFromServer.level
	if level > 70 then
		return
	end
	local ModelResTable = self.parent.modelResTable
	local needResTable = ModelResTable[level].need
	local num = #needResTable
	for i = 1,num,1 do
		local resData = needResTable[i] -- {2,100}
		-- 服务器
		local nowNum = UserInfo.city[Resource_temp[resData[1]].attributeName]  -- 玩家当前拥有数量
		-- 本地
		local maxNum = resData[2] -- 等级资源需求数量
		self.resView:setResAttribute(i,nil,nil,maxNum,nowNum)
	end
end

function T:SetButton()

	if self.dataFromServer.level == 60 then
		self._btnUpgrade:setVisible(false)
		self._btnImmediaUp:setVisible(false)
        self.resView:setVisible(false)
	end

	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local judge = self:_checkLevel()
			if judge == true then
				local info = Language:get("uc233")
				local function confirm()
					local tempWindow = require("src.app.uiScript.components.building.BuildingWindow").new(BuildingsInfoMgr:getBuildingInfos()[1])
					WindowManager:switch(tempWindow)
				end
				MUIPop.MUIImmediate(info,confirm)
				return
			end

			local name = sender:getName()
			if name == "Button_immediate_up" then
				if self.immediateUpTag == 1 then
					self:ImmediateFinishLogic()
				else
					self:CancleUpGradeLogic()
				end
			elseif name == "Button_upgrade" then
				if self.upTag == 1 then
					self:UpGradeLogic()
				elseif self.upTag == 2 then
					self:SpeedUpGradeLogic()
				else -- 免费
					-- 如果是建造，从0到1，免费加速就不发通讯直接升级成功
					if self.dataFromServer.level == 0 then

						PlayerInstance:buildingLvlUp(self.dataFromServer.location)
						local name = BuildingsInfoMgr:_getBuildName(self.dataFromServer.id)
						local descripe = Language:get("uc12",name,self.dataFromServer.level)
						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

						Command:buildQueueTimeFinish()
                        BuildingsInfoMgr:remvoeQueueItem(self.dataFromServer.id)

				    else
					    SpeedUpgradeCommand:new():exec(self.dataFromServer,function(state,diamond)
						    if state == ReturnCode.SUCCESS then
							    if BGMgr:isGuide() then
								    BGMgr:fire(BGMgr.EVT_BUILDING_BUILD_FREE_ADD_SPEED_COMPLETED)
							    end

							    PlayerInstance:setDiamond(diamond)

							    local name = BuildingsInfoMgr:_getBuildName(self.dataFromServer.id)
							    local descripe = Language:get("uc12",name,self.dataFromServer.level)
							    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

							    Command:buildQueueTimeFinish()

						    else
							    MUIPop.SpeedUpGradeFail(state)
						    end

					    end)
				    end

				end
			elseif name == "Button_construct" then
				-- 下面是资源足够的情况，建造资源一般足够
				local function finish()
					-- 立即刷新状态值
					self._btnUpgrade:setName("Button_upgrade")
					self.upTag = 3
					-- 立刻按钮变了
					self:immediateCancelLogic()

					self:AddProgressBar() -- 添加进度条

					local location = self.dataFromServer.location
					self.dataFromServer = BuildingsInfoMgr:getBuildingInfos()[location]
					self.parent.dataFromServer = self.dataFromServer
					local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
					if item then
						self:RefreshUpGradeData(item) -- 立即刷新数据
					end


					self:UpgradeHandle() -- 添加升级处理
				end
				if self:judgeBuildQueue() then
					return
				end

				local resTable = {}
				local allDiamond = 0

				local ModelResTable = self.parent.modelResTable

				-- 先要判断资源是否足够
				resTable,allDiamond = BuildingDiamondCalculation.JudgeResIsEnough(self.dataFromServer,ModelResTable)
				local function confirm()
					BuildingCommand.constructBuildingHasDiamond(self.dataFromServer,self.parent.modelResTable,resTable,allDiamond,finish)
				end

				local info = Language:get("uc562",allDiamond)
				if allDiamond > 0 then
					MUIPop.MUIImmediate(info,confirm)
					return
				end

				-- 资源足够的情况下
				BuildingCommand.constructBuildingNoDiamond(self.dataFromServer,self.parent.modelResTable,finish)

			end
		end
	end

	self._btnUpgrade:addTouchEventListener(callback)
	self._btnImmediaUp:addTouchEventListener(callback)
end

------------------------------------------------------ 下面是建筑物升级相关的 ------------------------------------------------
--- 立刻完成逻辑
function T:ImmediateFinishLogic()
	local payState = SetStates.setPayState
	local value = payState:getClosedValue(payState.CLOSE_TIME_BUILDIGN)
	local ModelResTable = self.parent.modelResTable
	if value then
		BuildingCommand.ImmediateFinish(self.dataFromServer,ModelResTable)
	else
		local allDiamond = BuildingDiamondCalculation.FreeTimeGetImmediateFinishDiamond(self.dataFromServer,ModelResTable)
		local info = Language:get("uc561",allDiamond)
		local layout = DiamondPopInfo.new(info)
		local function confirm()
			SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_TIME_BUILDIGN)
			if layout.judge == true then
				Command:SetPayCommand()
			end
			BuildingCommand.ImmediateFinish(self.dataFromServer,ModelResTable)
		end
		MUIPop.DiamondPopInfo(layout,confirm)
	end

end

--- 判断建造个数已满逻辑
function T:judgeBuildQueue()
	-- 首先判断vip等级最多可以建造的数量
	local buildQueueNumState = SetStates.buildQueueNumState
	local buyCount = buildQueueNumState:getBuildQueueNum()

	local buildQueueCount = PlayerInstance:getVipBuildQueueCount()
	local buildingQueue = BuildingsInfoMgr:getBuildQueue()
	local i = 0
	for k,v in pairs(buildingQueue) do
		if v then
			i = i + 1
		end
	end
	if i >= buildQueueCount + buyCount then  -- 建造队列已满

		if buildQueueNumState:judgeIsBuy() then
            local layout = require("src.app.uiScript.components.share.BuildQueuePopWindow").new(buyCount,buildQueueCount,self.parent.modelResTable,self.dataFromServer.location)
            local muialter = MUIAlter.show(
                    {
                        info = layout,
                        title = Language:get("uc1064"),
                        size = 30,
                        flag = 4,
                        isShowCloseButton = true
                    }
                )

            layout:setMuialter(muialter)


--			local cost = buildQueueNumState:getCost()
--			local function confirm()
--				local gems = UserInfo.gems
--				if gems >= cost then
--					local function finish()
--						local descripe = Language:get("uc532")
--						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
--					end
--					BuildingCommand:BuyBuildQueue(finish)
--				else
--					MUIPop.MUIToReCharge()
--				end
--			end

--			local describe = Language:get("uc1012",buyCount,3 - buyCount,UserInfo.vipLevel,buildQueueCount)

--            local layout = ccui.Layout:create()
--            layout:setContentSize(cc.size(524,300))

--            local des = XMLLabel()
--            des:setVAlign("middle")
--            des:setContentSize(cc.size(450,36))
--            layout:addChild(des)
--            REL:toOther("left","middle",des,layout,30,20)
--            des:setString(Language:get("uc558",cost) .. "<br/>" .. describe)

--            MUIAlter.show(
--                    {
--                        info = layout,
--                        size = 30,
--                        flag = 3,
--                        callback = function(flag)
--                            if flag == 0 then
--                                confirm()
--                            end

--                        end
--                    }
--                )
	else
		if i == 8 then
			MUIPop.buildQueueFull()
		else
			local describe1 = Language:get("uc323",UserInfo.vipLevel)
			local describe2 = Language:get("uc324",UserInfo.vipLevel,buildQueueCount)
			local describe3 = Language:get("uc325")

			local layout = VipTipsInfo.new(describe1,describe2,describe3)

			MUIAlter.show(
				{
					info = layout,
					size = 30,
					flag = 1,
					confirmText = Language:get("uc332"),
					triggerCloseMethod = "buttons",
					isShowCloseButton = true,
					callback = function(flag)
						-- 转到vip界面
						if flag == 0 then
							WindowManager:push(
								require("src.app.uiScript.components.vip.VIPWindow").new()
							)
						end

					end
				}
			    )
		    end

	    end

	    return true

	end

	return false
end

function T:buildQueuePopFinish()
    if self:judgeBuildQueue() then
		return
	end

    if self.dataFromServer.level == 0 then

		PlayerInstance:buildingLvlUp(self.dataFromServer.location)
		local name = BuildingsInfoMgr:_getBuildName(self.dataFromServer.id)
		local descripe = Language:get("uc12",name,self.dataFromServer.level)
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

		Command:buildQueueTimeFinish()
        BuildingsInfoMgr:remvoeQueueItem(self.dataFromServer.id)

	else
        self:UpGradeLogic()

    end

end


--- 升级逻辑
function T:UpGradeLogic()
	if self:judgeBuildQueue() then
		return
	end

	local level = self.dataFromServer.level
	if level >= 70 then
		return
	end

	local resTable = {}
	local allDiamond = 0

	local ModelResTable = self.parent.modelResTable

	-- 先要判断资源是否足够
	resTable,allDiamond = BuildingDiamondCalculation.JudgeResIsEnough(self.dataFromServer,ModelResTable)
	local function confirm()
		self:SupplyDiomand(resTable,allDiamond)
	end

	local info = Language:get("uc562",allDiamond)
	if allDiamond > 0 then
		MUIPop.MUIImmediate(info,confirm)
		return
	end

	-- 下面是资源足够的情况
	local function finish()
		-- 立刻按钮变了
		self:immediateCancelLogic()

		self:AddProgressBar() -- 添加进度条
		local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
		if item then
			self:RefreshUpGradeData(item) -- 立即刷新数据
		end

		self:UpgradeHandle() -- 添加升级处理

		--        local time = item.remainingSec
		--        local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()
		--        if time <= vipFreeTime then  -- 免费的
		--            REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,0)
		--        else
		--            REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,5)
		--        end
	end
	BuildingCommand.UpGradeNoDiamond(self.dataFromServer,self.parent.modelResTable,finish)

end

--- 取消逻辑
function T:CancleUpGradeLogic()
	local info = Language:get("uc280") .. Language:get("uc946")
	local function confirm()
		local function finish()
			self:UpGradeFinish()
		end
		BuildingCommand.CancleUpGradeLogic(self.dataFromServer,self.parent.modelResTable,finish)
	end
	MUIPop.MUIImmediate(info,confirm)
end

--- 加速升级逻辑
function T:SpeedUpGradeLogic()
	local payState = SetStates.setPayState
	local value = payState:getClosedValue(payState.CLOSE_BUILD_SPEED)

	if value then
		local newItem = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]  -- 检测，防止用户点击了加速按钮后，不点击，然而升级还在进行中
		if newItem then
			BuildingCommand.SpeedUpGradeLogic(self.dataFromServer)
		else
			MUIPop.UpGradeSuccessNotClick()
		end
	else
		local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
		local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
		local info = Language:get("uc563",allDiamond)
		local layout = DiamondPopInfo.new(info)
		local function confirm()
			local newItem = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]  -- 检测，防止用户点击了加速按钮后，不点击，然而升级还在进行中
			if newItem then
				SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_BUILD_SPEED)
				if layout.judge == true then
					Command:SetPayCommand()
				end
				BuildingCommand.SpeedUpGradeLogic(self.dataFromServer)
			else
				MUIPop.UpGradeSuccessNotClick()
			end

		end
		MUIPop.DiamondPopInfo(layout,confirm)
	end
end

--- 补足钻石完成普通升级逻辑
function T:SupplyDiomand(resTable,allDiamond)
	local function finish()
		-- 立刻按钮变了
		self:immediateCancelLogic()

		self:AddProgressBar()
		local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
		if item then
			self:RefreshUpGradeData(item) -- 立即刷新数据
		end


		self:UpgradeHandle()

		--        local time = item.remainingSec
		--        local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()
		--        if time <= vipFreeTime then  -- 免费的
		--            REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,0)
		--        else
		--            REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,5)
		--        end

	end
	BuildingCommand.UpGradeHasDiamond(self.dataFromServer,self.parent.modelResTable,resTable,finish,allDiamond)
end

--- 普通升级处理函数
function T:UpgradeHandle()
	-- 每帧检测回调
	local function update(buildItem)
		if buildItem.remainingSec and buildItem.remainingSec <= 0 then    --升级完成
		else
			if buildItem then
				if buildItem then
					self:RefreshUpGradeData(buildItem) -- 处理每帧变化的数据
				end

			end

		end
	end
	self.update = update
	BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.dataFromServer.id,nil,update)
end

--- 升级过程的中数据的每帧刷新
function T:RefreshUpGradeData(buildItem)
	local ModelResTable = self.parent.modelResTable

	--local progress = self:getChildByTag(self.PROGRESS_TAG)
	local time = buildItem.remainingSec
	local allTime = ModelResTable[self.dataFromServer.level].upgradeTime
	allTime = BuildingDiamondCalculation:BuildConstructActualTime(allTime)
	--Cocos2dxUtils:getChildByName(progress,"ProgressBar_progress"):setPercent((allTime - time)/allTime*100)
	--Cocos2dxUtils:getChildByName(progress,"time"):setString(Language:get("uc104",UnitConversion.ShowTime(time)))
	--self.loadingBar:setPercent((allTime - time)/allTime*100)
	local lastPer = self.loadingBar:getPercentage()
	local newPer = (allTime - time)/allTime*100
	self.loadingBar:runAction(cc.ProgressFromTo:create(0.2,lastPer,newPer))

	self.labelProgressTime:setString(Language:get("uc104",UnitConversion.handleTime4(time)))

	self.immediateUpTag = 2

	local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()

	--    if time <= vipFreeTime then  -- 免费的
	--        self._btnUpgrade:loadTextures("bigButton_green_normal.png","bigButton_green_normal.png","",ccui.TextureResType.plistType)
	--        self._btnUpgrade:setButtonPic("addSpeedIcon.png")
	--        self._btnUpgrade:setString(Language:get("uc108"))

	--        self.upTag = 3

	--        REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,0)
	--    else
	--        self._btnUpgrade:loadTextures("bigButton_purple_normal.png","bigButton_purple_normal.png","",ccui.TextureResType.plistType)
	--        self._btnUpgrade:setButtonPic("addSpeedIcon.png")

	--        local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
	--        local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
	--        self._btnUpgrade:setString(Language:get("uc16",allDiamond))

	--        self.upTag = 2

	--        REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,5)
	--    end

	if time <= vipFreeTime then  -- 免费的
		self._btnUpgrade:setString(Language:get("uc108"))

		--if self.upTag ~= 3 then
		self._btnUpgrade:loadTextures("bigButton_green_normal.png","bigButton_green_normal.png","",ccui.TextureResType.plistType)
		self._btnUpgrade:setButtonPic("addSpeedIcon.png")

		if self.upTag ~= 3 then
			local uiText=self._btnUpgrade.buttonText
			uiText:setPosition(60,(self._btnUpgrade:getContentSize().height-uiText:getContentSize().height)/2)

			self.upTag = 3
		end
	else
		local item = BuildingsInfoMgr:getBuildQueue()[self.dataFromServer.id]
		local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
		self._btnUpgrade:setString(Language:get("uc16",allDiamond))

		--if self.upTag ~= 2 then
		self._btnUpgrade:loadTextures("bigButton_purple_normal.png","bigButton_purple_normal.png","",ccui.TextureResType.plistType)
		self._btnUpgrade:setButtonPic("addSpeedIcon.png")

		if self.upTag ~= 2 then
			local uiText=self._btnUpgrade.buttonText
			uiText:setPosition(60,(self._btnUpgrade:getContentSize().height-uiText:getContentSize().height)/2+5)

			self.upTag = 2
		end
	end

end

--- 添加进度条:这里的进度条要改成手写的
function T:AddProgressBar()
	-- 背景图片:到时移除的时候把这张图片移除就行了，并且2个变量设置为nil
	local backImg = ccui.ImageView:create()
	backImg:loadTexture("buldingBuildProjressBack.png",ccui.TextureResType.plistType)
	self:addChild(backImg)
	backImg:setPosition(cc.p(320,150))
	self.backImg = backImg

	-- 进度条图片
	--    local loadingBar = ccui.LoadingBar:create()
	--    loadingBar:loadTexture("buldingBuildProjressFore.png",ccui.TextureResType.plistType)
	--    loadingBar:setPercent(0)
	--    backImg:addChild(loadingBar)
	--    loadingBar:setPosition(cc.p(238,13))
	--    self.loadingBar = loadingBar

	local uiProgressFore = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("buldingBuildProjressFore.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	backImg:addChild(uiProgressFore)
	uiProgressFore:setPosition(cc.p(238,13))
	self.loadingBar = uiProgressFore


	-- 时间背景图片
	local timeBack = ccui.ImageView:create()
	timeBack:loadTexture("timeBack.png",ccui.TextureResType.plistType)
	backImg:addChild(timeBack)
	timeBack:setPosition(cc.p(250,13))
	self.timeBack = timeBack

	-- 时间，每帧刷新的
	local labelTime = XMLLabel()
	labelTime:setContentSize(cc.size(150,27))
	labelTime:setVAlign("middle")
	labelTime:setHAlign("center")
	--labelTime:setName("time")
	labelTime:setAnchorPoint(cc.p(0.5,0.5))
	labelTime:setPosition(cc.p(timeBack:getContentSize().width/2,timeBack:getContentSize().height/2))
	timeBack:addChild(labelTime)
	self.labelProgressTime = labelTime
end

--- 移除进度条
function T:RemoveProgressBar()
	--    if self:getChildByTag(self.PROGRESS_TAG) then
	--        local widget = self:getChildByTag(self.PROGRESS_TAG)
	--        if widget then
	--            widget:removeFromParent()
	--        end
	--    end
	if self.backImg ~= nil then
		self.backImg:removeFromParent()
		self.backImg = nil
		self.loadingBar = nil
		self.labelProgressTime = nil
		self.timeBack = nil
	end
end

--- 升级完成数据刷新
function T:UpGradeFinish()
	-- 资源里面的等级要刷新改变
	-- 指挥中心除外
	local nowLevel = BuildingsInfoMgr:getBuildingInfos()[1].level
	self.resView:setCommandAttribute(0,nil,self.dataFromServer.level + 1,nowLevel)

	-- 立刻按钮变了
	self:immediateBtnLogic()

	-- 升级的也要变
	self._btnUpgrade:loadTextures("bigButton_yellow_normal.png","bigButton_general_down.png","",ccui.TextureResType.plistType)
	self._btnUpgrade:setButtonPic("levelUpIcon.png")
	REL:toOther("left","middle",self._btnUpgrade.buttonText,self._btnUpgrade,60,0)

	self:RemoveProgressBar()
	self.upTag = 1
	self.immediateUpTag = 1

	self:RefreshData1()
	self:RefreshData2()

	BuildingsInfoMgr:remvoeQueueItem(self.dataFromServer.id)
	BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.dataFromServer.id,nil,self.update)
end

function T:buildEff()
	local uiSp = cc.Sprite:create()
	self:addChild(uiSp)
	REL:toOther("center", "middle", uiSp, self._imgHead, 0, 12)

	local animation = ResLoader:getAnimation("upGradeEff")
	if animation then
		uiSp:runAction(
			cc.Sequence:create(
				cc.Animate:create(animation),
				cc.CallFunc:create( function()
					uiSp:removeFromParent()

				end)
			)
		)
	end

end


return T
