--[[

 *	科技研究窗口

]]
local T = class("T",function() return ccui.Layout:create() end)

--- size大小
T.size = nil

--- res的基础值
T.baseValue = 500

--- 研究中的项
T.researchItem = require "src.app.uiScript.components.building.ScienceResearchItem"

--- 数据
T.dataFromServer = nil

--- 父亲窗口
T.parent = nil

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor(dataFromServer,parent)
	self.dataFromServer = dataFromServer
	self.parent = parent
	self.queue = Queue()

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

function T:init()
	local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,self,7,0,0,0)
	self.listView = listView

	--self:AddResearchItem()
	--self:RefreshListView()
	self:_addToListview()

	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateScienceList)
end


--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()
	self.queue:clearT()
	self.queue = nil
end

function T:cleanUp()
	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateScienceList)
end

--- 刷新科研项列表
function T:updateScienceList()
	self.listView:removeAllItems()
	self:_addToListview()
end

--- 添加到listview中去
function T:AddResearchItem()
	--local num = #Science_research_temp

	-- 要调整listview中的位置，先解锁的排在前面（这个在配置表中已经默认了从低到高），但是如果先点的升级要排在前面
	-- 应该从上到下，把第一个没有在队列中的存储起来，下次直接交换就可以了
	-- 这个i是科研项的sid
	local temp = {}
	local i = 1
	for k,v in pairs(Science_research_temp) do
		if v then
			temp[i] = v
			temp[i].k = k
			i = i + 1
		end
	end

	table.sort(temp,function(x,y) return x.hostLevelNeed < y.hostLevelNeed end)

	for k,v in pairs(temp) do
		if v then
			local res = self.researchItem.new(v.k,self.dataFromServer)
			res:setContentSize(cc.size(res.size.width,res.size.height + 5)) -- 这里要动态设置高度
			self.listView:pushBackCustomItem(res)
		end
	end

	--    for i = 1,num,1 do
	--        local res = self.researchItem.new(i,self.dataFromServer)
	--        --res:setTag(self.baseValue + i) -- 以后更新数据用
	--        res:setContentSize(cc.size(res.size.width,res.size.height + 5)) -- 这里要动态设置高度
	--        self.listView:pushBackCustomItem(res)
	--    end
end

--- 刷新listview中的项的顺序
function T:RefreshListView()

end

function T:_addToListview()
	local temp = {}
	local i = 1
	for k,v in pairs(Science_research_temp) do
		if v then
			temp[i] = v
			temp[i].k = k
			i = i + 1
		end
	end

	table.sort(temp,function(x,y) return x.hostLevelNeed < y.hostLevelNeed end)

	for k,v in pairs(temp) do
		if v then
			self.queue:push(v)
		end
	end

	self:runAction(
		cc.RepeatForever:create(
			cc.Sequence:create(
				cc.DelayTime:create(0.1),
				cc.CallFunc:create( function()
					self:addRes()
				end)
			)
		)
	)
end

function T:addRes()
	local data = self.queue:pop()
	if data then
		local res = self.researchItem.new(data.k,self.dataFromServer)
		res:setContentSize(cc.size(res.size.width,res.size.height + 5)) -- 这里要动态设置高度
		self.listView:pushBackCustomItem(res)
		res:setOpacity(0)

		res:runAction(
			cc.FadeIn:create(0.5)
		)
	else
		self:stopAllActions()
	end
end

return T
