--- 科技研究中的每一项
local T = class("T",function() return ccui.Layout:create() end)

--- 升级或者加速标志： 1是升级，2是加速
T.upTag = 1

--- 信息或者取消的标志： 1是信息，2是取消
T.infoTag = 1

--- 这个窗口的大小
T.size = nil

--- 这一项的sid
T.sid = nil

--- 数据
T.techBuildingInfo = nil

--- 构造函数:这个页面还要写免费那个功能模块,到时免费的资源图片给过来就加
function T:ctor(sid,techBuildingInfo)
	self.techBuildingInfo = techBuildingInfo
	self.sid = sid

	self:registerScriptHandler(
		function(eventType)
			--print("ScienceResearchItem:"..eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	-- 设置项
	local _widget = ListItem4.new()
	self.size = _widget:getContentSize()
	self:setContentSize(self.size)
	_widget:setListItemAttribute(
		"H",
		{"label","label"},
		{{"infoButton_normal.png","iconButton_general_down.png","false","false"},{"upgrade.png","upgrade.png","false","false"}}
	)
	self:addChild(_widget)
	REL:toOther("left","top",_widget,self,0,0)
	self._widget = _widget

	-- 得到控件
	self:GetWidget()
	-- 设置数据
	self:SetData()
	-- 按钮回调设置
	self:SetButton()
end

function T:onEnter()
	-- 时间的检测
	local item = TechnologiesInfoMgr:getQueue()[self.sid]
	if item then  --立即刷新，因为添加侦听会下一步执行
		if item.remainingSec and item.remainingSec > 0 then    --升级过程
			self:ImmediateChange()
			self:AddProgressBar()
			self:enterChange(item)
			self:RefreshUpGradeData(item)
			self:UpgradeHandle()
	end
	end

	-- 监听科研中心的等级
	local function tech()
		self.techBuildingInfo = BuildingsInfoMgr:getBuildingInfos()[4]
		if self.upTag == 1 then  -- 表示不在升级
			self:RefreshData1()
			-- 科技等级不能大于等于 科研中心等级
			local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
			local scienceLevel = self.techBuildingInfo.level
			if technologyInfo and technologyInfo.level >= scienceLevel then
				self._btnUpgrade:setIsGray(true)
			end
		end
	end
	self.tech = tech
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. 4,nil,self.tech)

	-- 监听玩家所拥有的资源是否足够刷新显示,升级过程中不处理
	local function resoure()
		if self.upTag == 1 then  -- 表示不在升级中
			self:RefreshData1()
		end
	end
	self.resoure = resoure
	ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,nil,self.resoure)

    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaAddEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)



end

--- 进入的时候调整
function T:enterChange(item)
	local time = item.remainingSec
	self._widget:setString(self._labelTime,UnitConversion.handleTime4(time))

	local allTime = nil
	local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	if technologyInfo then
		local technologyLevel = technologyInfo.level
		allTime = Science_research_temp[self.sid].studyNeedTime[technologyLevel + 1]
	else
		allTime = Science_research_temp[self.sid].studyNeedTime[1]
	end
	local newTime = BuildingDiamondCalculation:ScienceActualTime(allTime)
	self.loadingBar:setPercentage((newTime - time)/newTime*100) --初始值
end

function T:onExit()
	TechnologiesInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.sid,nil,self.update)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. 4,nil,self.tech)
	ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,nil,self.resoure)

    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaRemoveEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)


end

function T:cleanUp()

end

function T:showActivityTime(time)
    if not time then
        return
    end

    self.activivityTime:setString(UnitConversion.handleTime4(time))

    local judge = false
    -- 时间的检测
    local item = TechnologiesInfoMgr:getQueue()[self.sid]  -- 判断当前的建筑物是否在升级建筑物的队列中
    if item then
        if item.remainingSec and item.remainingSec > 0 then    --升级过程
            judge = false
        else
            judge = true
        end
    else
        judge = true
    end

    if judge == true then -- 不在升级的过程中
        if ActivityManager.rapidDevelopmentInfo:getOpenValue() == true then
            self.activivityTime:setVisible(true)
	        self.activivityTime:updateView()
	        local contentWidth = self.activivityTime:getTextWidth()
	        local contentHeight = self.activivityTime:getTextHeight()
            local draw = self.activivityTime.layer.draw
            if draw then
                draw:clear()
                draw:drawSegment(cc.p(-(contentWidth/2),contentHeight/2), cc.p(contentWidth/2, -contentHeight/2), 1.5, cc.c4f(1, 0, 0, 1))
            end


        else
            self.activivityTime:setVisible(false)
        end
    else
        self.activivityTime:setVisible(false)
    end

end

function T:buildEff()
	local uiSp = cc.Sprite:create()
	self:addChild(uiSp)
	REL:toOther("center", "middle", uiSp, self._imgHead, 0, 12)
	uiSp:setScale(0.8)

	local animation = ResLoader:getAnimation("upGradeEff")
	if animation then
		uiSp:runAction(
			cc.Sequence:create(
				cc.Animate:create(animation),
				cc.CallFunc:create( function()
					uiSp:removeFromParent()

				end)
			)
		)
	end



end

function T:GetWidget()
	-- 头像
	self._imgHead = self._widget.leftHead

	-- 信息或者取消
	self._btnInfo = self._widget.button1
	self._btnInfo:setName("Button_info")

	-- 升级或者加速
	self._btnUpgrade = self._widget.button2
	self._btnUpgrade:setName("Button_upgrade")

	-- 名字(创建富文本)
	self._labelName = self._widget.title

	-- 时间(创建富文本)
	self._labelTime = self._widget:getLabel(1)
	self._labelTime:setContentSize(cc.size(310, 36))  -- 要考虑换行的


	-- 消耗钻石
	local labelCostDiamond = XMLLabel()
	labelCostDiamond:setHAlign("center")
	labelCostDiamond:setVAlign("middle")
	labelCostDiamond:setContentSize(cc.size(300, 27))
	self._btnUpgrade:addChild(labelCostDiamond)
	--REL:toOther("center", "bottom", labelCostDiamond, self._btnUpgrade, 0, 9)
	self._labelCostDiamond = labelCostDiamond


	-- 免费时间显示
	self.vipFree = self._widget:getLabel(2)
    REL:toOther("left","top",self.vipFree,self._widget.back,130,95)

    -- 有活动的时候原来的时间
    local activivityTime = XMLLabel()
    activivityTime:setAlign("center","middle")
    activivityTime:setContentSize(cc.size(400,36))
    self:addChild(activivityTime)
    REL:toOther("center","middle",activivityTime,self._widget.back,0,-10)
    self.activivityTime = activivityTime

    local layer = CommonMethod:drawLine(50,50)
    activivityTime:addChild(layer)
    REL:toOther("center","middle",layer,activivityTime,0,0)
    activivityTime.layer = layer


end

function T:SetData()
	-- 不变的
	local iconPath = IconManager.iconPath
	self._imgHead:loadTexture(iconPath .. Science_research_temp[self.sid].iconUrl)


	-- 要变的
	self:RefreshData1()
end

--- 升级过后根据等级更新数据显示
function T:RefreshData1()
	local tp=Science_research_temp[self.sid]

	self.vipFree:setVisible(false)
	-- 根据是否解锁来设置时间和名字描述
	local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	local name = Science_research_temp[self.sid].name
	local scienceLevel = self.techBuildingInfo.level

	if technologyInfo and technologyInfo.level >= GameCfg.BUILDING_MAX_LEVEL then
		self._btnInfo:setVisible(false)
		self._btnUpgrade:setVisible(false)

		self._widget:setString(self._labelName,Language:get("uc24",Language:get(name),GameCfg.BUILDING_MAX_LEVEL))
		self._labelTime:setString(Language:get("ug912"))
		
		return
	end

	-- 本来是要这么设置的
	self._btnUpgrade:setIsGray(false)
	self._btnUpgrade:setTouchEnabled(true)

	-- 判断资源是否足够
	local cityRes = {}
	local allDiamond = 0
	cityRes,allDiamond = BuildingDiamondCalculation.JudgeResIsEnoughInScience(self.sid)
	if allDiamond > 0 then
		self._btnUpgrade:setIsGray(true)
		self._btnUpgrade:setTouchEnabled(true)
	end

	self._btnUpgrade:loadTextures("upgrade.png","upgrade.png","",ccui.TextureResType.plistType)

	if technologyInfo then
		local technologyLevel = technologyInfo.level
		local needCommandLevel = tp.hostLevelNeed

		self._widget:setString(self._labelName,Language:get("uc24",Language:get(name),technologyLevel))

		if needCommandLevel <= scienceLevel then -- 解锁
			-- 科技等级不能大于等于声望的等级
			local prestigeLevel = PlayerInstance:getReputationLvl()
			if technologyInfo and technologyInfo.level >= prestigeLevel then
				self._labelTime:setString(Language:get("uc928",prestigeLevel + 1))
				self._btnUpgrade:setIsGray(true)
				self._btnUpgrade:setTouchEnabled(false)
                self.activivityTime:setVisible(false)
			else
				local needTimes_t=tp.studyNeedTime
				-- 升级到下一次的时间
				local time = technologyLevel >= #needTimes_t and needTimes_t[#needTimes_t] or needTimes_t[technologyLevel + 1]
				local newTime = BuildingDiamondCalculation:ScienceActualTime(time)
				self._widget:setString(self._labelTime,Language:get("uc185",UnitConversion.handleTime4(newTime)))
				self:showVipTime(newTime)
                self:showActivityTime(BuildingDiamondCalculation:ScienceActualTimeNoActivity(time))
			end
		else -- 未解锁，但是有等级
			self._labelTime:setString(Language:get("uc23",needCommandLevel))
			self._btnUpgrade:setIsGray(true)
			self._btnUpgrade:setTouchEnabled(false)
            self.activivityTime:setVisible(false)
		end

	else -- 为0级（可能解锁或者没解锁）
		self._widget:setString(self._labelName,Language:get("uc24",Language:get(name),0))
		local needCommandLevel = tp.hostLevelNeed

		if needCommandLevel <= scienceLevel then -- 解锁
			-- 科技等级不能大于等于声望的等级
			local prestigeLevel = PlayerInstance:getReputationLvl()
			if 0 >= prestigeLevel then
				self._labelTime:setString(Language:get("uc928",prestigeLevel + 1))
				self._btnUpgrade:setIsGray(true)
				self._btnUpgrade:setTouchEnabled(false)
                self.activivityTime:setVisible(false)
			else
				local time = tp.studyNeedTime[1] -- 读取升级到下一级的时间
				local newTime = BuildingDiamondCalculation:ScienceActualTime(time)
				self._widget:setString(self._labelTime,Language:get("uc185",UnitConversion.handleTime4(newTime)))
				self:showVipTime(newTime)
                self:showActivityTime(BuildingDiamondCalculation:ScienceActualTimeNoActivity(time))
			end

		else
			self._labelTime:setString(Language:get("uc23",needCommandLevel))
			self._btnUpgrade:setIsGray(true)
			self._btnUpgrade:setTouchEnabled(false)
            self.activivityTime:setVisible(false)
		end

	end

	self._btnInfo:loadTextures("infoButton_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
	REL:toOther("right", "bottom", self._btnInfo, self._widget.back, 15 + 80,8)
	self._labelCostDiamond:setVisible(false)

	local posx,y = self._btnInfo:getPosition()

	-- 要设置相对位置
	REL:toOther("left","top",self._labelTime,self._widget.back,130,60)
	REL:toOther("right", "bottom", self._btnUpgrade, self._widget.back, 15,8)

	self.upTag = 1
	self.infoTag = 1



end

function T:showVipTime(time)
	-- 是否显示vipFreeTime
	local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()
	if vipFreeTime >= time then
		self.vipFree:setString(Language:get("uc533"))
		self.vipFree:setVisible(true)
	else
		self.vipFree:setVisible(false)
	end
end

--- 每帧刷新数据
function T:RefreshUpGradeData(item)
	self.vipFree:setVisible(false)

	local time = item.remainingSec
	self._widget:setString(self._labelTime,UnitConversion.handleTime4(time))

	local allTime = nil
	local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	if technologyInfo then
		local technologyLevel = technologyInfo.level
		allTime = Science_research_temp[self.sid].studyNeedTime[technologyLevel + 1]
	else
		allTime = Science_research_temp[self.sid].studyNeedTime[1]
	end
	local newTime = BuildingDiamondCalculation:ScienceActualTime(allTime)
	--self.loadingBar:setPercent((allTime - time)/allTime*100)
	local lastPer = self.loadingBar:getPercentage()
	local newPer = (newTime - time)/newTime*100
	self.loadingBar:runAction(cc.ProgressFromTo:create(0.2,lastPer,newPer))

	self.infoTag = 2

	local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()

	if time <= vipFreeTime then  -- 免费的
		self._btnUpgrade:loadTextures("speeButton_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
		self._labelCostDiamond:setString(Language:get("uc498"))
		self._btnUpgrade:setPosition(cc.p(532,51.5))
		self._labelCostDiamond:setVisible(true)
		self._labelCostDiamond:setPosition(cc.p(-111,45))

		self.upTag = 3
	else
		self._btnUpgrade:loadTextures("addSpeedButton_normal.png","addSpeedButton_normal.png","",ccui.TextureResType.plistType)
		self._btnUpgrade:setPosition(cc.p(532,51.5))
		self._labelCostDiamond:setPosition(cc.p(-111,45))

		-- 显示钻石
		self._labelCostDiamond:setVisible(true)
		local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
		self._labelCostDiamond:setString(Language:get("uc111",allDiamond))

		self.upTag = 2
	end

	self._btnUpgrade:setIsGray(false)

end

function T:SetButton()
	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local name = sender:getName()
			if name == "Button_info" then
				if self.infoTag == 1 then
					self:InfoLogic()
				else
					self:CancleUpGradeLogic()
				end
			elseif name == "Button_upgrade" then
				if self.upTag == 1 then
					self:UpGradeLogic()
				elseif self.upTag == 2 then
					self:SpeedUpGradeLogic()
				else -- 免费
					local function finish()
						self:upGradeFinishShow()
						self:RemoveProgressBar()
						self:RefreshData1()
						TechnologiesInfoMgr:luaRemoveEventListener(TechnologiesInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.sid,nil,self.update)
					end
					local item = TechnologiesInfoMgr:getQueue()[self.sid]
					ClearTechnologyTimeCammand.new():exec(item,function(state)
						if state == ReturnCode.SUCCESS then
							finish()
						else
							MUIPop.SpeedUpGradeFail(state)
						end
					end
					)


				end
			end
		end
	end
	self._btnInfo:addTouchEventListener(callback)
	self._btnUpgrade:addTouchEventListener(callback)
end

--- 信息提示逻辑
function T:InfoLogic()
	--科研中心建筑的信息
	local techBuildingLv = self.techBuildingInfo.level or 0

	--当前科研项的信息
	local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	--科研项升级需求相关信息
	local scienceResearchTemp=Science_research_temp[self.sid]

	--科研项等级
	local techLv=technologyInfo and technologyInfo.level or 0

	if techLv < GameCfg.BUILDING_MAX_LEVEL then
		local resView = nil
		local layout = ccui.Layout:create()
		layout:setTouchEnabled(false)

		--- 得到资源表
		local needResTable = {}
		local data = scienceResearchTemp
		local num = #Resource_temp

		local nextLv=techLv + 1
		for i = 1,num,1 do  -- 现在为3项
			local attributeName = Resource_temp[i].attributeName
			if data[attributeName] then -- 因为每种科技所需要的资源的种类是不一样的,所以要判断是否存在
				local maxNum = data[attributeName][nextLv] -- 等级资源需求数量
				needResTable[#needResTable + 1] = {i,maxNum}
			end
		end

		----
		resView = ResView.new(4)  -- 1+3是资源项目的数目
		layout:addChild(resView)
		layout:setContentSize(cc.size(550,300 + 100 + 70)) -- 再加70是声望
		local name = Language:get("uc194")
		local iconUrl = IconManager.iconPath .. Build_temp[3].icon
		local hostLvNeed=techBuildingLv >= scienceResearchTemp.hostLevelNeed and nextLv or scienceResearchTemp.hostLevelNeed
		resView:addResItem({["iconUrl"] = iconUrl,["name"] = name,["needLevel"] = hostLvNeed,["nowLevel"] = techBuildingLv },needResTable,nil)
		REL:toOther("center","middle",resView,layout,0,75)
		--- 下面加一个描述

		---
		local resItem1 = resView:getResItem(1)
		local resItem2 = resView:getResItem(2)
		local resItem3 = resView:getResItem(3)
		REL:toOther("center","top",resItem1,resView.needListBack,0,120 + 1 * 60)
		if resItem2 then
			REL:toOther("center","top",resItem2,resView.needListBack,0,120 + 2 * 60)
		end
		if resItem3 then
			REL:toOther("center","top",resItem3,resView.needListBack,0,120 + 3 * 60)
		end

		local prestigeIconUrl = IconManager.iconPath .. PlayerAddAttributeIcon_temp[2].icon
		local prestigeName = Language:get(PlayerAddAttributeIcon_temp[2].name)
		local prestigeLevel = PlayerInstance:getReputationLvl()
		resView:setResItem(prestigeIconUrl,prestigeName,nextLv,prestigeLevel,120)


		-- 下滑线图片
		local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
		local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
		local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
		seqLine1:setContentSize(500,2)
		layout:addChild(seqLine1)
		REL:toOther("center","bottom",seqLine1,layout,0,100)

		-- 图片
		local imgHead = ccui.ImageView:create()
		local iconPath = IconManager.iconPath
		imgHead:loadTexture(iconPath .. scienceResearchTemp.iconUrl)
		imgHead:setScale(IconManager.resScale[1],IconManager.resScale[2])

		layout:addChild(imgHead)
		REL:toOther("left","bottom",imgHead,layout,27,35)

		-- 描述
		local describe = XMLLabel()
		describe:setVAlign("middle")
		describe:setContentSize(cc.size(400, 36))
		layout:addChild(describe)
		REL:toOther("left", "middle", describe, imgHead, 80, 0)
		describe:setString(Language:get("uc315",Language:get(scienceResearchTemp.infoDescribe)))

		if resView then
			resView.needListBack:setVisible(false)

			MUIAlter_noTitle.show({
				info = layout,
				flag = 4
			})
		end
	else
		--已到最高等级
		MUIAlter_singleLine.show( {
			info = Language:get("ug912"),
			showSecond = 1
		} )
	end
end

--- 取消升级逻辑
function T:CancleUpGradeLogic()
	local info = Language:get("uc281") .. Language:get("uc946")
	local function confirm()
		local function finish()
			self:RemoveProgressBar()
			self:RefreshData1()
			TechnologiesInfoMgr:luaRemoveEventListener(TechnologiesInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.sid,nil,self.update)
		end
		local item = TechnologiesInfoMgr:getQueue()[self.sid]
		BuildingCommand.ScienceCancleUpGradeLogic(item,finish)
	end
	MUIPop.MUIImmediate(info,confirm)
end

--- 升级逻辑
function T:UpGradeLogic()
	-- 科技等级不能大于等于 科研中心等级
	local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	local scienceLevel = self.techBuildingInfo.level
	if technologyInfo and technologyInfo.level >= scienceLevel then
		local descripe = Language:get("uc333")
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
		return
	end

	-- 科技等级不能大于等于声望的等级
	local prestigeLevel = PlayerInstance:getReputationLvl()
	if technologyInfo and technologyInfo.level >= prestigeLevel then
		local descripe = Language:get("uc703")
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
		return
	end

	-- 首先判断vip等级最多可以建造的数量
	local buildQueueCount = PlayerInstance:getVipTechQueueCount()
	local buildingQueue = TechnologiesInfoMgr:getQueue()
	local i = 0
	for k,v in pairs(buildingQueue) do
		if v then
			i = i + 1
		end
	end
	if i >= buildQueueCount then  -- 建造队列已满
		--MUIPop.BuildQueueFull()

		local describe1 = Language:get("uc326",UserInfo.vipLevel)
		local describe2 = Language:get("uc327",UserInfo.vipLevel,buildQueueCount)
		local describe3 = Language:get("uc328")

		local layout = VipTipsInfo.new(describe1,describe2,describe3)

		MUIAlter.show({
			info = layout,
			size = 30,
			flag = 1,
			confirmText = Language:get("uc332"),
			triggerCloseMethod = "buttons",
			isShowCloseButton = true,
			callback = function(flag)
				-- 转到vip界面
				if flag == 0 then
					WindowManager:push(
						require("src.app.uiScript.components.vip.VIPWindow").new()
					)
				end

			end
		})

		return
	end


	local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	if technologyInfo then
		local level = technologyInfo.level
		if level >= 70 then
			return
		end
	end

	local cityRes = {}
	local allDiamond = 0
	-- 先要判断资源是否足够
	cityRes,allDiamond = BuildingDiamondCalculation.JudgeResIsEnoughInScience(self.sid)
	local function confirm()
		self:SupplyDiomand(cityRes,allDiamond)
	end

	local info = Language:get("uc562",allDiamond)
	if allDiamond > 0 then
		MUIPop.MUIImmediate(info,confirm)
		return
	end

	-- 下面是资源足够的情况:通过返回的cityRes来刷新内存中的资源数量
	local function finish()
		self:ImmediateChange()
		self:AddProgressBar() -- 添加进度条
		local item = TechnologiesInfoMgr:getQueue()[self.sid]
		self:RefreshUpGradeData(item) -- 立即刷新数据
		self:UpgradeHandle() -- 添加升级处理
	end
	BuildingCommand.ScienceUpGradeNoDiamond(self.sid,cityRes,finish)
end

--- 普通升级处理函数
function T:UpgradeHandle()
	-- 每帧检测回调
	local function update(item)
		if item.remainingSec and item.remainingSec <= 0 then    --升级完成
			self:RemoveProgressBar()
			self:RefreshData1()
			--MUIPop.MUIUpGradeSuccess()
			self:upGradeFinishShow()
			TechnologiesInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.sid,nil,self.update)
		else
			self:RefreshUpGradeData(item) -- 处理每帧变化的数据
		end
	end
	self.update = update
	TechnologiesInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.sid,nil,update)
end

--- 升级完成提示
function T:upGradeFinishShow()
	--    local name = Science_research_temp[self.sid].name
	--    local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	--    local technologyLevel = technologyInfo.level

	--    local descripe = Language:get("uc184",Language:get(name),technologyLevel)
	--    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

	self:buildEff()

end

--- 立即改变的数据（只改变一次的）,进入了这个肯定是解锁了的
function T:ImmediateChange()
	local technologyInfo = TechnologiesInfoMgr:getInfos()[self.sid]
	local name = Science_research_temp[self.sid].name
	if technologyInfo then
		local technologyLevel = technologyInfo.level
		self._widget:setString(self._labelName,Language:get("uc25",Language:get(name),technologyLevel,technologyLevel + 1))
	else
		self._widget:setString(self._labelName,Language:get("uc25",Language:get(name),0,1))
	end

	REL:toOther("left","top",self._labelTime,self._widget.back,150,85)
	self._btnInfo:loadTextures("canelButton2_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
	self._btnInfo:setPosition(cc.p(425.5,54.5))
	self.infoTag = 2
end

--- 添加进度条
function T:AddProgressBar()
	-- 背景图片:到时移除的时候把这张图片移除就行了，并且2个变量设置为nil
	local backImg = ccui.ImageView:create()
	backImg:loadTexture("productProgressBack.png",ccui.TextureResType.plistType)
	self._widget.back:addChild(backImg)
	--REL:toOther("left","top",backImg,self._widget.back,120,45)
	backImg:setPosition(cc.p(242.5,70))
	self.backImg = backImg

	-- 进度条图片
	--    local loadingBar = ccui.LoadingBar:create()
	--    loadingBar:loadTexture("productProgressFore.png",ccui.TextureResType.plistType)
	--    loadingBar:setPercent(0)
	--    backImg:addChild(loadingBar)
	--    REL:toOther("center","middle",loadingBar,backImg,0,0)
	--    self.loadingBar = loadingBar

	local uiProgressFore = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("productProgressFore.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	backImg:addChild(uiProgressFore)
	--REL:toOther("center","middle",uiProgressFore,backImg,0,0)
	uiProgressFore:setPosition(cc.p(122.5,14))
	self.loadingBar = uiProgressFore
end

--- 移除进度条
function T:RemoveProgressBar()
	if self.backImg ~= nil then
		self.backImg:removeFromParent()
		self.backImg = nil
		self.loadingBar = nil
	end
end

--- 补足钻石完成普通升级逻辑
function T:SupplyDiomand(cityRes,allDiamond)
	local function finish()
		self:ImmediateChange()
		self:AddProgressBar()
		local item = TechnologiesInfoMgr:getQueue()[self.sid]
		self:RefreshUpGradeData(item) -- 立即刷新数据
		self:UpgradeHandle()
	end
	BuildingCommand.ScienceUpGradeHasDiamond(self.sid,finish,cityRes,allDiamond)
end

--- 加速升级逻辑
function T:SpeedUpGradeLogic()
	local function finish()
		self:upGradeFinishShow()
		self:RemoveProgressBar()
		self:RefreshData1()
		TechnologiesInfoMgr:luaRemoveEventListener(TechnologiesInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.sid,nil,self.update)
	end

	local payState = SetStates.setPayState
	local value = payState:getClosedValue(payState.CLOSE_SCIENCE_SPEED)

	local item = TechnologiesInfoMgr:getQueue()[self.sid]
	if value then
		BuildingCommand.ScienceSpeedUpGradeLogic(item,finish)
	else
		local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
		local info = Language:get("uc563",allDiamond)
		local layout = DiamondPopInfo.new(info)
		local function confirm()
			SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_SCIENCE_SPEED)
			if layout.judge == true then
				Command:SetPayCommand()
			end
			BuildingCommand.ScienceSpeedUpGradeLogic(item,finish)
		end
		MUIPop.DiamondPopInfo(layout,confirm)
	end


end

return T
