--- 资源打开项
local T = class("T",function() return ccui.Layout:create() end)

--- 资源表
T.ModelResTable = nil

--- sid
T.sid = nil

--- 位置
T.location = nil

--- 构造函数
function T:ctor(sid,location,ModelResTable)
	self.sid = sid
	self.location = location
	self.ModelResTable = ModelResTable

	self:setContentSize(cc.size(630,500))

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(random(0,255),0,0))
	--	self:setBackGroundColorOpacity(100)

    self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)


	-- 得到控件
	self:GetWidget()
	-- 按钮回调设置
	self:SetButton()
end


function T:onEnter()
    CommonBroadcast:luaAddEventListener("build_queue_pop_window_finish" .. self.location,self,self.buildQueuePopFinish)
end

function T:onExit()
    CommonBroadcast:luaRemoveEventListener("build_queue_pop_window_finish" .. self.location,self,self.buildQueuePopFinish)
end

function T:GetWidget()
	-- 中间资源部分
	local resView = ResView.new(3)  -- 3是资源项目的数目
	local needResTable = self.ModelResTable[0].need
	resView:addResItem(nil,needResTable,nil)
	self:addChild(resView)
	REL:toOther("left","top",resView,self,10,0) -- 顶部相对向下是正的
	self.resView = resView

	-- 建造按钮
	local btnConstruct = Button.new("true","true")
	btnConstruct:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
	btnConstruct:setButtonPic("levelUpIcon.png")
	btnConstruct:setString(Language:get("uc147"))
	self:addChild(btnConstruct)
	REL:toOther("right","top",btnConstruct,self.resView,40,self.resView.size.height + 30)
	self.btnConstruct = btnConstruct

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_OUTSIDE_RES_BUILD_BUILD_BUTTON,btnConstruct)
	end
end

function T:SetButton()
	local info=require("src.app.model2.build.BuildingInfo")()
	info.sid = self.sid
	info.remainingSec = 0
	info.location = self.location
	info.level = 0
	info.id = nil

	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_OUTSIDE_RES_BUILD_BUILD_BUTTON)
			end

			local function finish()
				WindowManager:pop()
			end
			if self:judgeBuildQueue() then
				return
			end
			-- 判断资源是否足够
			local resTable = {}
			local allDiamond = 0

			-- 先要判断资源是否足够
			resTable,allDiamond = BuildingDiamondCalculation.JudgeResIsEnough(info,self.ModelResTable)
			local function confirm()
				BuildingCommand.constructBuildingHasDiamond(info,self.ModelResTable,resTable,allDiamond,finish)
			end

			local des = Language:get("uc562",allDiamond)
			if allDiamond > 0 then
				MUIPop.MUIImmediate(des,confirm)
				return
			end

			-- 这个是资源足够的情况下
			BuildingCommand.constructBuildingNoDiamond(info,self.ModelResTable,finish)

		end
	end
	self.btnConstruct:addTouchEventListener(callback)
end

function T:buildQueuePopFinish()
    local function finish()
		WindowManager:pop()
	end
	if self:judgeBuildQueue() then
		return
	end

    local info=require("src.app.model2.build.BuildingInfo")()
	info.sid = self.sid
	info.remainingSec = 0
	info.location = self.location
	info.level = 0
	info.id = nil


	-- 判断资源是否足够
	local resTable = {}
	local allDiamond = 0

	-- 先要判断资源是否足够
	resTable,allDiamond = BuildingDiamondCalculation.JudgeResIsEnough(info,self.ModelResTable)
	local function confirm()
		BuildingCommand.constructBuildingHasDiamond(info,self.ModelResTable,resTable,allDiamond,finish)
	end

	local des = Language:get("uc562",allDiamond)
	if allDiamond > 0 then
		MUIPop.MUIImmediate(des,confirm)
		return
	end

	-- 这个是资源足够的情况下
	BuildingCommand.constructBuildingNoDiamond(info,self.ModelResTable,finish)


end

--- 判断建造个数已满逻辑
function T:judgeBuildQueue()
	-- 首先判断vip等级最多可以建造的数量
	local buildQueueNumState = SetStates.buildQueueNumState
	local buyCount = buildQueueNumState:getBuildQueueNum()

	local buildQueueCount = PlayerInstance:getVipBuildQueueCount()
	local buildingQueue = BuildingsInfoMgr:getBuildQueue()
	local i = 0
	for k,v in pairs(buildingQueue) do
		if v then
			i = i + 1
		end
	end
	if i >= buildQueueCount + buyCount then  -- 建造队列已满

		if buildQueueNumState:judgeIsBuy() then
            local layout = require("src.app.uiScript.components.share.BuildQueuePopWindow").new(buyCount,buildQueueCount,self.ModelResTable,self.location)
            local muialter = MUIAlter.show(
                    {
                        info = layout,
                        title = Language:get("uc1064"),
                        size = 30,
                        flag = 4,
                        isShowCloseButton = true
                    }
                )

            layout:setMuialter(muialter)


--			local cost = buildQueueNumState:getCost()
--			local function confirm()
--				local gems = UserInfo.gems
--				if gems >= cost then
--					local function finish()
--						local descripe = Language:get("uc532")
--						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
--					end
--					BuildingCommand:BuyBuildQueue(finish)
--				else
--					MUIPop.MUIToReCharge()
--				end
--			end

--			local describe = Language:get("uc1012",buyCount,3 - buyCount,UserInfo.vipLevel,buildQueueCount)

--            local layout = ccui.Layout:create()
--            layout:setContentSize(cc.size(524,300))

--            local des = XMLLabel()
--            des:setVAlign("middle")
--            des:setContentSize(cc.size(450,36))
--            layout:addChild(des)
--            REL:toOther("left","middle",des,layout,30,20)
--            des:setString(Language:get("uc558",cost) .. "<br/>" .. describe)

--            MUIAlter.show(
--                    {
--                        info = layout,
--                        size = 30,
--                        flag = 3,
--                        callback = function(flag)
--                            if flag == 0 then
--                                confirm()
--                            end

--                        end
--                    }
--                )
	else
		if i == 8 then
			MUIPop.buildQueueFull()
		else
			local describe1 = Language:get("uc323",UserInfo.vipLevel)
			local describe2 = Language:get("uc324",UserInfo.vipLevel,buildQueueCount)
			local describe3 = Language:get("uc325")

			local layout = VipTipsInfo.new(describe1,describe2,describe3)

			MUIAlter.show(
				{
					info = layout,
					size = 30,
					flag = 1,
					confirmText = Language:get("uc332"),
					triggerCloseMethod = "buttons",
					isShowCloseButton = true,
					callback = function(flag) -- 转到vip界面
						if flag == 0 then
							WindowManager:push(
								require("src.app.uiScript.components.vip.VIPWindow").new()
							)
					end

					end
				}
			)
		end

	end

	return true
	end

	return false
end


return T
