--- 资源打开list
local T = class("T",function() return ccui.Layout:create() end)

--- 建造项的sid
T.sid = nil

--- 建造项的位置
T.location = nil

--- 这个窗口的大小
T.size = nil

--- node(是项的父节点，也是listview的孩子)
T.node = nil

--- 打开的页面
T.resourceOpen = require "src.app.uiScript.components.building.resource.ResourceOpen"

--- 资源表
T.ModelResTable = nil

function T:ctor(i,listView,sid,location,node)
	self.i = i
	self.listView = listView
	self.sid = sid
	self.location = location
	self.node = node

    self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	--    local _widget = ListItem1.new()
	--    self.size = _widget:getContentSize()
	--    self:setContentSize(self.size)
	--    _widget:setListItem1Attribute(
	--        "B.png",
	--        {"label","label","label"},
	--        {{"scaleOut_normal.png","iconButton_general_down.png","false","false"}}
	--    )
	--    self:addChild(_widget)
	--    REL:toOther("left","top",_widget,self,0,0)

	--    self._widget = _widget
	--self.size = cc.size(640,220 + 70)
	self.size = cc.size(640,220)
	self:setContentSize(self.size)

	-- 得到的控件
	self:GetWidget()
	-- 设置数据
	self:SetData()
	-- 按钮回调设置
	self:SetButton()
	-- 添加展开事件处理
	self:AddListItem()

end

function T:onEnter()
    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaAddEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)

end

function T:onExit()
    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaRemoveEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)

end


function T:GetWidget()
	--    -- 资源头像
	--    self._imgHead = self._widget.leftHead

	--    -- 展开按钮
	--    self._btnOpen = self._widget.button1

	--    self._btnOpen.tag = 1 -- 按钮加和减的标记
	--    self.node.tag = 1

	--    -- 名字（富文本）
	--    self._labelName = self._widget:getLabel(1)

	--    -- 描述
	--    self._labelNowNeed = self._widget:getLabel(2)

	--    -- 描述（时间）
	--    self._labelDescribe = self._widget:getLabel(3)

	-- 背景图像
	local buildingInfoBack = ccui.ImageView:create()
	buildingInfoBack:loadTexture("buildingInfoBack.png",ccui.TextureResType.plistType)
	self:addChild(buildingInfoBack)
	REL:toOther("left","middle",buildingInfoBack,self,0,0)
	self.buildingInfoBack = buildingInfoBack

	-- 头像
	local imgHead = ccui.ImageView:create()

	local iconPath = IconManager.iconPath
	imgHead:loadTexture(iconPath .. Build_temp[1].icon)

	self:addChild(imgHead)
	REL:toOther("left","top",imgHead,buildingInfoBack,22,15)
	self._imgHead = imgHead

	-- 名字
	local labelName = XMLLabel()
	labelName:setContentSize(cc.size(300,27))
	labelName:setHAlign("left")
	labelName:setVAlign("middle")
	self:addChild(labelName)
	REL:toOther("left","middle",labelName,buildingInfoBack,180,68)
	self._labelName = labelName


	-- 描述
	local labelDescription = XMLLabel()
	labelDescription:setContentSize(cc.size(350,100))
	self:addChild(labelDescription)
	REL:toOther("left","top",labelDescription,buildingInfoBack,185,80)
	self._labelNowNeed = labelDescription

	-- 时间
	local labelTime = XMLLabel()
	labelTime:setContentSize(cc.size(200,27))
	labelTime:setAlign("center","top")
	self:addChild(labelTime)
	REL:toOther("center","top",labelTime,buildingInfoBack,-222,170)
	self._labelDescribe = labelTime

    -- 有活动的时候原来的时间
    local activivityTime = XMLLabel()
    activivityTime:setAlign("center","middle")
    activivityTime:setContentSize(cc.size(400,36))
    self:addChild(activivityTime)
    REL:toOther("center","middle",activivityTime,self.buildingInfoBack,-222,-68 + 20)
    self.activivityTime = activivityTime

    local layer = CommonMethod:drawLine(50,50)
    activivityTime:addChild(layer)
    REL:toOther("center","middle",layer,activivityTime,0,0)
    activivityTime.layer = layer


	-- 打开按钮
	local btnOpen = Button.new("false","false")
	btnOpen:setButtonState("scaleOut_normal.png","iconButton_general_down.png")
	self:addChild(btnOpen)
	REL:toOther("right","middle",btnOpen,self,20,-10)
	self._btnOpen = btnOpen

	self._btnOpen.tag = 1 -- 按钮加和减的标记
	self.node.tag = 1
end

function T:SetData()
	self.ModelResTable = PlayerInstance:getBuildingResTable(self.sid)
	local ModelResTable = self.ModelResTable

	-- 不变的,这个是资源的图片
	local iconPath = IconManager.iconPath
	self._imgHead:loadTexture(iconPath .. Build_temp[self.sid].icon)

	-- 名字
	local buidlerInfos = BuildingsInfoMgr:getBuildingInfos()
	local num = 0
	for k,v in pairs(buidlerInfos) do
		if v then
			if v.sid == self.sid then
				num = num + 1
			end
		end
	end
	self._labelName:setString(Language:get("uc171",Language:get(Build_temp[self.sid].name),num))

	-- 描述
	local capacity = ModelResTable[1].capacity -- 描述的处理，要根据等级来读取产量和容量
	local output = ModelResTable[1].output
	local levalInfosPara = Build_temp[self.sid].levalInfosPara
	local info = Language:get(levalInfosPara,UnitConversion.unitTrans(output*60),UnitConversion.unitTrans(capacity))
	self._labelNowNeed:setString(info)

	-- 时间
	local time = ModelResTable[0].upgradeTime
    self:showActivityTime(BuildingDiamondCalculation:BuildConstructActualTimeNoActivity(time))
    time = BuildingDiamondCalculation:BuildConstructActualTime(time)
	self._labelDescribe:setString(Language:get("uc172",UnitConversion.handleTime4(time)))

end

function T:showActivityTime(time)
    if not time then
        return
    end

    self.activivityTime:setString(UnitConversion.handleTime4(time))

    if ActivityManager.rapidDevelopmentInfo:getOpenValue() == true then
        self.activivityTime:setVisible(true)
	    self.activivityTime:updateView()
	    local contentWidth = self.activivityTime:getTextWidth()
	    local contentHeight = self.activivityTime:getTextHeight()
        local draw = self.activivityTime.layer.draw
        if draw then
            self.activivityTime:setVisible(true)
            draw:clear()
            draw:drawSegment(cc.p(-(contentWidth/2),contentHeight/2), cc.p(contentWidth/2, -contentHeight/2), 1.5, cc.c4f(1, 0, 0, 1))
        end
    else
        self.activivityTime:setVisible(false)
    end

end

function T:SetButton()
	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,self._btnOpen)
			end

			AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
			self.node:dispachEvent()
			self:OpenLogic(sender)
		end
	end
	self._btnOpen:addTouchEventListener(callback)

	local function callback2(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
			self.node:dispachEvent()
			self:OpenLogic(sender)
		end
	end
	self.node:addTouchEventListener(callback2)
end

--- 打开逻辑
function T:OpenLogic(sender)
	if sender.tag == 2 then
		self._btnOpen:loadTextures("scaleOut_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
		self.node.tag = 1
		self._btnOpen.tag = 1
		self._btnOpen:setVisible(true)
	else
		self._btnOpen:loadTextures("scaleIn_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
		self.node.tag = 2
		self._btnOpen.tag = 2
		self._btnOpen:setVisible(true)
	end
end


-- 添加展开事件处理
function T:AddListItem()
	--打开展开页面
	self.node:addListener(function(leafContainer)
		local subItem = self.resourceOpen.new(self.sid,self.location,self.ModelResTable)
		leafContainer:setContentSize(subItem:getContentSize())
		leafContainer:addChild(subItem)

		if BGMgr:isGuide() then
			BGMgr:fire(BGMgr.EVT_RES_BUILD_ITEM_EXPLAND)

			if self.i == 3 then
				AbstractUI.interval(self.listView,function()
					self.listView:getInnerContainer():setPositionY(0)
				end,0)
			end
		end
	end)
end

return T
