--- 选择资源建造的窗口
local T = class(
	"ResourceWindow",
	function()
		local o = AbstractWindow.new()
		o.super = AbstractWindow
		return o
	end
)
--- 资源表数据
T.res = nil

--- 建筑物建造的位置
T.location = nil

--- 构造函数
function T:ctor(res,location)
	self.res = res
	self.location = location

	-- 测试标签页的例子
	local function callBack1()
	end

	-- 创建1个
	local switchButtonContainer = SwitchButtonContainer.new()
	self:addChild(switchButtonContainer)
	REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
	switchButtonContainer:init()
	switchButtonContainer:initButtons(
		1,
		{{"viewSwitchButton_normal.png","viewSwitchButton_down.png"}},
		{110,15},
		{callBack1},
		{Language:get("uc1")}
	)
	self.switchButtonContainer = switchButtonContainer

	-- 加入listview
	local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
	self.listView = MUIListTree.extend(listView)

	self:_addToListview()

	-- 进入页面显示数据
	self:ShowData()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 进入页面显示数据
function T:ShowData()
	self:setWindowTitle(Language:get("uc169"))
end

--- 加入到listview中去
function T:_addToListview()
	local list=self.listView

	local res = self.res
	local num = #res

	local l={}
	for i = 1,num,1 do
		local node = list:getRootNode()
		local res = require("src.app.uiScript.components.building.resource.ResourceOpenList").new(i,self.listView,res[i],self.location,node)
		node:setContentSize(cc.size(res.size.width,res.size.height))
		node:addChild(res)

		l[#l+1]=res
	end
	self.listItems=l

	if BGMgr:isGuide() then
		if l[1] then
			BGMgr:regGuideObj(BGMgr.TGR_OUTSIDE_RES_BUILD_1_EXPLAND_BUTTON,l[1]._btnOpen)
		end
		if l[2] then
			BGMgr:regGuideObj(BGMgr.TGR_OUTSIDE_RES_BUILD_2_EXPLAND_BUTTON,l[2]._btnOpen)
		end
		if l[3] then
			BGMgr:regGuideObj(BGMgr.TGR_OUTSIDE_RES_BUILD_3_EXPLAND_BUTTON,l[3]._btnOpen)
		end
	end
end

return T
