--- 聊天信息项
local T = class("T",function() return ccui.Layout:create() end)

--- 聊天信息的每一项的数据结构
T.chatInfo = nil

--- 标记,1:世界，2:联盟，3：私人
T.tag = nil

--- 主窗口：世界才有
T.chatWindow = nil

--- 构造函数
function T:ctor(tag,chatInfo,chatWindow)
	self.tag = tag
	self.chatInfo = chatInfo
	self.chatWindow = chatWindow

	self.size = cc.size(628,90)
	self:setContentSize(self.size)

    self.touchBeganSound=SoundRes.NONE
	self.touchEndedSound=SoundRes.SOUND_COMMON_BUTTON
	BaseButton:extend(self)
	-- 得到控件
	self:_getWidget()

	-- 显示数据
	self:_showData()

	-- 添加回调
	self:_addEvent()
end

--- 得到控件
function T:_getWidget()
	-- 头像
    local headId = self.chatInfo.head

	local iconPath = IconManager.iconPath
	local head = ccui.ImageView:create()
	head:loadTexture(PlayerInstance:getPlayerHead(headId))
	self:addChild(head)
    if headId == 255 then -- 系统头像
        head:setScale(68/130,68/130)
    else
        head:setScale(55/130,55/130)
    end
	head:setAnchorPoint(cc.p(0,1))
	head:setPosition(cc.p(20,80))
	self.head = head


	-- 名字 和 vip等级
	local nameAndVip = XMLLabel()
	nameAndVip:setContentSize(cc.size(500,27))
	self:addChild(nameAndVip)
	nameAndVip:setAnchorPoint(cc.p(0,1))
	nameAndVip:setPosition(cc.p(20 + 90,80))
	self.nameAndVip = nameAndVip

    if UserInfo.id == self.chatInfo.sourceId then -- 自己
        nameAndVip:setHAlign("right")
        nameAndVip:setAnchorPoint(cc.p(1,1))
    else
        nameAndVip:setHAlign("left")
        nameAndVip:setAnchorPoint(cc.p(0,1))
    end

    if self.chatInfo.militaryRank == 0 then
    else
        -- 加一个军衔图标
        local iconPath = IconManager.iconPath

        local militaryImg = ccui.ImageView:create()
        militaryImg:loadTexture(iconPath .. MilitaryRank_temp[1].icon)
        militaryImg:setScale(2/3)
        self:addChild(militaryImg)
        REL:toOther("left","middle",militaryImg,nameAndVip,-50,0)
        self.militaryImg = militaryImg
    end


	-- 内容的背景图片,九宫格图片
	local defalutSize = cc.size(480,42)
	local spriteFrame = ResLoader:getSpriteFrame("chatItemBack.png")
	local spriteFrameSize = spriteFrame:getOriginalSize()
	-- 这个Scale9Sprite是cocos2dx库所带的九宫格，因为前面有cc
	--local scale9Sprite = cc.Scale9Sprite:createWithSpriteFrame(spriteFrame,cc.rect(spriteFrameSize.width/2,37,1,1))
	local scale9Sprite = Scale9Sprite:createWithFrame(spriteFrame,cc.rect(spriteFrameSize.width/2,30,1,1))
	scale9Sprite:setContentSize(defalutSize)
	self:addChild(scale9Sprite)
	scale9Sprite:setAnchorPoint(cc.p(0,1))
	scale9Sprite:setPosition(cc.p(20 + 90,80 - 30))
	self.scale9Sprite = scale9Sprite


    --- 自己的
    local chatItemBackOwnFrame = ResLoader:getSpriteFrame("chatItemBackOwn.png")
	local chatItemBackOwnSize = chatItemBackOwnFrame:getOriginalSize()
	local chatItemBackOwn = Scale9Sprite:createWithFrame(chatItemBackOwnFrame,cc.rect(chatItemBackOwnSize.width/2,30,1,1))
	chatItemBackOwn:setContentSize(defalutSize)
	self:addChild(chatItemBackOwn)
	chatItemBackOwn:setAnchorPoint(cc.p(1,1))
	chatItemBackOwn:setPosition(cc.p(20 + 90,80 - 30))
	self.chatItemBackOwn = chatItemBackOwn

	---
	local btn = ccui.Layout:create()
	btn:setTouchEnabled(true)
	self:addChild(btn)
	REL:relOther(btn,scale9Sprite,0,0,0,0)
	self.btn = btn

	-- 文本内容
	local content = XMLLabel()
	content:setAutoSizeLabel("height")
	self:addChild(content)
    if UserInfo.id == self.chatInfo.sourceId then -- 自己
        REL:relOther(content,chatItemBackOwn,20,6,10,SIZE_NIL)
    else
        REL:relOther(content,scale9Sprite,20,6,10,SIZE_NIL)
    end
	content:setLocalZOrder(100000)

	self.content = content
end

--- 设置数据
function T:_showData()
	local chatInfo = self.chatInfo

--	local head = chatInfo.head
--	self.head:loadTexture(PlayerInstance:getPlayerHead(head))

    if chatInfo.sourceId <= 0 then
        self.nameAndVip:setString(Language:get("uc145",Language:get("uc922")))
	elseif self.tag == 3 then
		if UserInfo.id == chatInfo.sourceId then
			--self.nameAndVip:setString(Language:get("uc556",chatInfo.sourceName))
			local window = WindowManager:getCurrentWindow()
            if window.chatUserName then
                chatInfo.chatUserName = window.chatUserName -- 把目标用户名保存起来
            end
			self.nameAndVip:setString(Language:get("uc556",chatInfo.chatUserName))
		else
			self.nameAndVip:setString(Language:get("uc557",chatInfo.sourceName))
		end

	elseif self.tag == 2 then
        self.nameAndVip:setString(Language:get("uc825",chatInfo.sourceName))
    else
		self.nameAndVip:setString(Language:get("uc145",chatInfo.sourceName))
	end

	--捕获聊天信息错误
	local b,errStr=pcall(function()
		if chatInfo.contentType == 2 then
			if chatInfo.fightReportType == 4 then
				--竞技场战报
				self.content:setString(Language:get("ug1348", chatInfo:getContent()))
			else
				-- 战报
				if chatInfo.resultType == 1 or chatInfo.resultType == 2 then
					if chatInfo.realTitle1 then
						self.content:setString(Language:get("uc256",chatInfo.realTitle2))
					else
						self.content:setString(Language:get("uc256",chatInfo:getContent()))
					end
				elseif chatInfo.resultType == 3 or chatInfo.resultType == 4 then
					if chatInfo.realTitle1 then
						self.content:setString(Language:get("uc835",chatInfo.realTitle2))
					else
						self.content:setString(Language:get("uc257",chatInfo:getContent()))
					end
				else
					self.content:setString(Language:get("uc258"))
				end
			end
		elseif chatInfo.contentType == 1 then -- 系统信息
            self.content:setString(Language:get("uc707",chatInfo:getContent()))
        else -- 普通信息
			self.content:setString(Language:get("uc146",chatInfo:getContent()))
		end

	end)
	if not b then
		self.content:setString(Language:get("uc168"))
		__print__(errStr)
		LogRecorder:push(errStr,LOG_LEVEL_ERROR,"chatErr")
	end
end

--- 刷新这个层的大小，相对位置（文本背景的图片和文本）
function T:refresh()
    if UserInfo.id == self.chatInfo.sourceId then -- 自己
        self.scale9Sprite:setVisible(false)
        self.chatItemBackOwn:setVisible(true)
    else
        self.scale9Sprite:setVisible(true)
        self.chatItemBackOwn:setVisible(false)
    end

	-- 首先获取文本内容的高度，宽度
	self.content:updateView()
	local contentWidth = self.content:getTextWidth()
	local contentHeight = self.content:getTextHeight()

	local size = self.size
	local tempOffest = contentHeight - 25
	if tempOffest > 0 then
		self.size = cc.size(size.width,size.height + tempOffest)
		self:setContentSize(self.size)
	else
		tempOffest = 0
	end

    if UserInfo.id == self.chatInfo.sourceId then -- 自己
        self.chatItemBackOwn:setContentSize(cc.size(contentWidth + 40,contentHeight + 20))
        self.head:setPosition(cc.p(565,80 + tempOffest))
	    self.nameAndVip:setPosition(cc.p(545,75 + tempOffest))
        self.chatItemBackOwn:setPosition(cc.p(555,75 + tempOffest - 30))
	    REL:toOther("left","top",self.content,self.chatItemBackOwn,20,10)

	    REL:relOther(self.btn,self.chatItemBackOwn,0,0,0,0)
    else
        self.scale9Sprite:setContentSize(cc.size(contentWidth + 40,contentHeight + 20))
        if self.chatInfo.head == 255 then
            self.head:setPosition(cc.p(15,80 + tempOffest))
        else
            self.head:setPosition(cc.p(20,80 + tempOffest))
        end
    	
	    self.nameAndVip:setPosition(cc.p(20 + 75 + 0,75 + tempOffest))
        self.scale9Sprite:setPosition(cc.p(20 + 80 - 15,75 + tempOffest - 30))
	    REL:toOther("left","top",self.content,self.scale9Sprite,20,10)

	    REL:relOther(self.btn,self.scale9Sprite,0,0,0,0)
    end


    if UserInfo.id == self.chatInfo.sourceId then -- 自己
        if self.militaryImg then
            self.nameAndVip:updateView()
	        local contentWidth = self.nameAndVip:getTextWidth()
            self.militaryImg:loadTexture(IconManager.iconPath .. MilitaryRank_temp[self.chatInfo.militaryRank].icon)
            REL:toOther("right","middle",self.militaryImg,self.nameAndVip,contentWidth - HonorManager:getShowLeftMilitaryOffset(self.chatInfo.militaryRank,2/3) + 5,3)
        end
    else
        if self.militaryImg then
            self.nameAndVip:updateView()
	        local contentWidth = self.nameAndVip:getTextWidth()
            self.militaryImg:loadTexture(IconManager.iconPath .. MilitaryRank_temp[self.chatInfo.militaryRank].icon)
            REL:toOther("left","middle",self.militaryImg,self.nameAndVip,contentWidth - HonorManager:getShowLeftMilitaryOffset(self.chatInfo.militaryRank,2/3) + 5,3)
        end
    end



end


function T:_addEvent()
	local chatInfo = self.chatInfo
	self:setTouchEnabled(true)
	self:addTouchEventListener(function(s,e)
		if e == ccui.TouchEventType.ended then
			if self.tag == 1 then -- 世界
			    if chatInfo.contentType == 2 then -- 战报
					self:enterInfoPopView()
			    elseif chatInfo.contentType == 0 then  -- 普通邮件信息
				    self:enterInfoPopView()
			    end

			elseif self.tag == 2 then -- 联盟
                self:enterInfoPopView()

			else -- 私人
                self:enterInfoPopView()
			end
		end
	end
	)

	if (self.tag == 1 and chatInfo.contentType == 2) or (self.tag == 2 and chatInfo.contentType == 2 ) then
		self:addBtnEvent()
	else
		self.btn:setTouchEnabled(false)
	end

end

--- 进入战报界面
function T:enterFightReport()
	local chatInfo = self.chatInfo
	if chatInfo.fightInfo then
		-- 进入战报页面
		local tempWindow = require("src.app.uiScript.components.mail.fightReportContent.FightReportWindow").new(4,chatInfo,chatInfo.fightInfo)
		WindowManager:push(tempWindow) -- 压入窗口
	else
		local function finish()
			-- 进入战报页面
			local tempWindow = require("src.app.uiScript.components.mail.fightReportContent.FightReportWindow").new(4,chatInfo,chatInfo.fightInfo)
			WindowManager:push(tempWindow) -- 压入窗口
		end
		BuildingCommand:ReadOtherReport(chatInfo,finish)
	end
end

--- 进入聊天角色界面窗口
function T:enterInfoPopView()
	local function finish(dataTable)
		-- new的有大小
		local layout = require("src.app.uiScript.components.chat.ChatInfoPopView").new(dataTable,WindowManager:getCurrentWindow(),self.chatInfo.sourceName)
		layout:setTouchEnabled(true)
		local muialter2 = MUIAlter.show(
			{
				title = dataTable.name,
				info = layout,
				flag = 4,
				callback = function(flag)
				end
			}
		)
		layout:setMUIAlter2(muialter2)
	end
	BuildingCommand:CheckChatInfo(self.chatInfo.sourceId,finish)
end


function T:addBtnEvent()
	self.btn:addTouchEventListener(function(s,e)
		if e == ccui.TouchEventType.ended then
			self:enterFightReport()
		end
	end)
end


return T
