--[[

 *	聊天项弹出信息

]]

local T = class("T",function() return ccui.Layout:create() end)

--- 玩家数据
T.otherPlayerData = nil

--- 主窗口
T.chatWindow = nil

--- 用户名
T.sourceName = nil

--- 构造函数
function T:ctor(otherPlayerData,chatWindow,sourceName)
	self.otherPlayerData = otherPlayerData
	self.chatWindow = chatWindow
	self.sourceName = sourceName

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	self:init()
	self:update()

end
function T:onEnter()
	SocialManager:luaAddEventListener(SocialManager.EVT_ADD_FRIEND_REFRESH,self,self.update)
	SocialManager:luaAddEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self.update)
	SocialManager:luaAddEventListener(SocialManager.EVT_ADD_BLACK_REFRESH,self,self.update)
	SocialManager:luaAddEventListener(SocialManager.EVT_DELETE_BLACK_REFRESH,self,self.update)

    -- 联盟社交监听
    local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
    allianceSocial:luaAddEventListener(allianceSocial.EVT_ADD_FRIEND_REFRESH,self,self.updateAlliace)
    allianceSocial:luaAddEventListener(allianceSocial.EVT_DELETE_FRIEND_REFRESH,self,self.updateAlliace)
    allianceSocial:luaAddEventListener(allianceSocial.EVT_ADD_ENEMY_REFRESH,self,self.updateAlliace)
    allianceSocial:luaAddEventListener(allianceSocial.EVT_DELETE_ENEMY_REFRESH,self,self.updateAlliace)

end

function T:onExit()
	SocialManager:luaRemoveEventListener(SocialManager.EVT_ADD_FRIEND_REFRESH,self,self.update)
	SocialManager:luaRemoveEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self.update)
	SocialManager:luaRemoveEventListener(SocialManager.EVT_ADD_BLACK_REFRESH,self,self.update)
	SocialManager:luaRemoveEventListener(SocialManager.EVT_DELETE_BLACK_REFRESH,self,self.update)

    -- 联盟社交监听
    local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
    allianceSocial:luaRemoveEventListener(allianceSocial.EVT_ADD_FRIEND_REFRESH,self,self.updateAlliace)
    allianceSocial:luaRemoveEventListener(allianceSocial.EVT_DELETE_FRIEND_REFRESH,self,self.updateAlliace)
    allianceSocial:luaRemoveEventListener(allianceSocial.EVT_ADD_ENEMY_REFRESH,self,self.updateAlliace)
    allianceSocial:luaRemoveEventListener(allianceSocial.EVT_DELETE_ENEMY_REFRESH,self,self.updateAlliace)

end


function T:init()
	self:setContentSize(cc.size(400,400))

	local data = self.otherPlayerData
	-- 头像
	local imgHead = ccui.ImageView:create()
	imgHead:loadTexture(PlayerInstance:getPlayerHead(data.head))
	--imgHead:setScale(100/130,100/130)
	self:addChild(imgHead)
	REL:toOther("left", "top", imgHead, self, -10, 20)
    self.imgHead = imgHead

    -- 军衔
    local militaryLab = XMLLabel()
	militaryLab:setContentSize(cc.size(200,36))
	self:addChild(militaryLab)
	REL:toOther("left", "top", militaryLab, imgHead, 145, -20)
	militaryLab:setString(Language:get("uc1025"))

    militaryLab:updateView()
	local contentWidth = militaryLab:getTextWidth()
    if data.militaryRank == 0 then
        local lab = XMLLabel()
	    lab:setContentSize(cc.size(200,36))
	    self:addChild(lab)
	    REL:toOther("left", "middle", lab, militaryLab, contentWidth + 10, 0)
	    lab:setString(Language:get("uc983"))
    else
        -- 军衔图片
        local iconPath = IconManager.iconPath

        local militaryImg = ccui.ImageView:create()
        militaryImg:loadTexture(iconPath .. MilitaryRank_temp[data.militaryRank].icon)
        --militaryImg:setScale(0.6)
        self:addChild(militaryImg)
        REL:toOther("left","middle",militaryImg,militaryLab,contentWidth - HonorManager:getShowLeftMilitaryOffset(data.militaryRank,1) + 5,5)

        -- 军衔名字
        local militaryName = XMLLabel()
        militaryName:setVAlign("middle")
        militaryName:setContentSize(cc.size(300,36))
        self:addChild(militaryName)
        militaryName:setString(Language:get("uc1026",Language:get(HonorManager:getMilitaryRankName(data.militaryRank))))
        REL:toOther("left","middle",militaryName,militaryImg,HonorManager:getShowMilitaryOffset(data.militaryRank),0)

    end


	-- 等级
	local level = XMLLabel()
	level:setContentSize(cc.size(200,36))
	self:addChild(level)
	REL:toOther("left", "top", level, imgHead, 145, 15)
	level:setString(Language:get("uc285",data.playerLevel))


	-- 战力
	local combatEffectiveness = XMLLabel()
	combatEffectiveness:setContentSize(cc.size(200,36))
	self:addChild(combatEffectiveness)
	REL:toOther("left", "top", combatEffectiveness, imgHead, 145, 50)
	combatEffectiveness:setString(Language:get("uc286",UnitConversion.unitTrans(data.combatEffectiveness)))


    -- 荣誉值
	local honorValue = XMLLabel()
	honorValue:setContentSize(cc.size(300,36))
	self:addChild(honorValue)
	REL:toOther("left", "top", honorValue, imgHead, 145, 85)
	honorValue:setString(Language:get("uc1011",data.honor))


	-- 联盟名字
    local id = UserInfo.allianceBox.myAlliance.id or 0
	if data.allianceName then
        local allianceName = XMLLabel()
		allianceName:setContentSize(cc.size(400,36))
		self:addChild(allianceName)
		REL:toOther("left", "top", allianceName, imgHead, 145, 85 + 35)
		allianceName:setString(Language:get("uc287",data.allianceName))

        if data.allianceId == id then -- 自己联盟
            self:addLable()
            self.allianceSocial:loadTexture("allianceLabel_my.png",ccui.TextureResType.plistType)
        else
            local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
            if allianceSocial:judgeIsAtEnemyList(data.allianceId) then -- 判断是否是敌对
                self:addLable()
                self.allianceSocial:loadTexture("allianceLabel_hostile.png",ccui.TextureResType.plistType)
            elseif allianceSocial:judgeIsAtFrendList(data.allianceId) then -- 判断是否是好友 
                self:addLable()
                self.allianceSocial:loadTexture("allianceLabel_friendly.png",ccui.TextureResType.plistType)
            else -- 中立
                self:addLable()
                self.allianceSocial:loadTexture("allicanceCenter.png",ccui.TextureResType.plistType)
            end

            self.allianceSocial:setTouchEnabled(true)
            -- 如果是会长，后面加个按钮
            if UserInfo.allianceBox.myAlliance.post == AlliancePost.LEADER then
                self.allianceSocial:addTouchEventListener( function(t, e)
			        if e == ccui.TouchEventType.ended then
                        -- 自己联盟不点击
                        if data.allianceId == id then -- 自己联盟
                            return
                        end

                        local layout = AlliancePopSocial.new(data.allianceId)
                        local function confirm()
                            local state = layout.state
                            if state then
                                local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
                                if state == 1 then
                                    if allianceSocial:judgeIsAtEnemyList(data.allianceId) then
                                        return
                                    else
                                        if allianceSocial:judgeEnemyReachMax() then
                                            MUIPop.EnemyHasReachMax()
                                        else
                                            require("src.app.communication.alliance.social.AddEnemyAllianceCommand")():exec(data.allianceId,function(state) end)
                                        end                                  
                                    end
                                elseif state == 2 then
                                    if allianceSocial:judgeIsAtFrendList(data.allianceId) then
                                        return
                                    else
                                        if allianceSocial:judgeFriendReachMax() then
                                            MUIPop.FriendHasReachMax()
                                        else                                            
                                            require("src.app.communication.alliance.social.AddFriendAllianceCommand")():exec(data.allianceId,function(state) end)
                                        end                                    
                                    end
                                else
                                    if allianceSocial:judgeIsAtEnemyList(data.allianceId) then
                                        require("src.app.communication.alliance.social.DeleteEnemyAllianceCommand")():exec(data.allianceId,function(state) end)
                                    end
                                    if allianceSocial:judgeIsAtFrendList(data.allianceId) then
                                        require("src.app.communication.alliance.social.DeleteFriendAllianceCommand")():exec(data.allianceId,function(state) end)
                                    end
                                end

                            end
                        end

                        MUIPop.AllianceSocialPopInfo(layout,confirm)
                    end
                end)

            else
                self.allianceSocial:addTouchEventListener( function(t, e)
                    if e == ccui.TouchEventType.ended then
                        if allianceSocial:judgeIsAtEnemyList(data.allianceId) then -- 判断是否是敌对
                            local descripe = Language:get("uc780")
		                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                        elseif allianceSocial:judgeIsAtFrendList(data.allianceId) then -- 判断是否是好友 
                            local descripe = Language:get("uc781")
		                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                        else -- 中立
                            local descripe = Language:get("uc779")
		                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                        end
                    end
                end)
            end

        end
    else -- 没的联盟
        local notAllianceName = XMLLabel()
		notAllianceName:setContentSize(cc.size(400,36))
		self:addChild(notAllianceName)
		REL:toOther("left", "top", notAllianceName, imgHead, 145, 85 + 35)
		notAllianceName:setString(Language:get("uc824"))
        
	end

	-- 联盟按钮--联盟会长/副会长可以发出联盟邀请
    local mA = UserInfo.allianceBox.myAlliance
	if not data.allianceName and id and id > 0 and mA.post == AlliancePost.LEADER or mA.post == AlliancePost.VICE_CHAIRMAN then
        local alliance = ccui.ImageView:create()
        alliance:loadTexture("allianceInvite.png",ccui.TextureResType.plistType)
        self:addChild(alliance)
        REL:toOther("right","top",alliance,self,-50,85 + 35 + 5)
        alliance:setTouchEnabled(true)
		alliance:addTouchEventListener( function(t, e)
			if e == ccui.TouchEventType.ended then
				--发送联盟邀请
				local mA=UserInfo.allianceBox.myAlliance
				--联盟会长/副会长可以发出联盟邀请
				if mA and mA.id ~= 0 and (mA.post == AlliancePost.LEADER or mA.post == AlliancePost.VICE_CHAIRMAN) then
					require("src.app.communication.alliance.SendAllianceInviteCommand")():exec(data.playerId,function(state)
						if state == ReturnCode.SUCCESS then
							MUIAlter_singleLine.show({
								info=Language:get("ug860"),
								showSecond=1.5
							})
							self.muialter2:hide()
						else
							MUIAlter_singleLine.show({
								info=ErrorCode:getErrInfo(state)
							},WindowManager:getCurrentWindow())
						end
					end)
				end
			end
		end )

	end

	-- 私聊
	local chatPrivate = Button.new("false","true")
	chatPrivate:setButtonState("longButton_green_normal.png","longButton_general_down.png")
	chatPrivate:setString(Language:get("uc288"))
	self:addChild(chatPrivate)
	REL:toOther("left","bottom",chatPrivate,self,-20,120)
    chatPrivate:setTextShadow()
	chatPrivate:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			self.muialter2:hide()

            if self.chatWindow then
                if self.chatWindow.switchButtonContainer.lastLocation == 3 then
                    self.chatWindow:setPrivateText(self.sourceName)
                    return
                end
            end


			if self.chatWindow then
				local buttonlayout3 = self.chatWindow.switchButtonContainer.buttonLayouts[3]
				buttonlayout3:luaDispatchEvent("buttons_event",buttonlayout3)
				self.chatWindow:setPrivateText(self.sourceName)
			else -- 这里就要新建
				local chatWindow = require("src.app.uiScript.components.chat.ChatWindow").new(3)
				chatWindow:setPrivateText(self.sourceName)
				WindowManager:push(chatWindow)
			end

		end
	end)



	-- 写邮件
	local writeMail = Button.new("false","true")
	writeMail:setButtonState("longButton_gray_normal.png","longButton_general_down.png")
	writeMail:setString(Language:get("uc289"))
	self:addChild(writeMail)
	REL:toOther("right","bottom",writeMail,self,-20,120)
    writeMail:setTextShadow()

	writeMail:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			-- 回复邮件
			self.muialter2:hide()
			local temp = require("src.app.uiScript.components.mail.SendMailWindow").new(3,data.name)
			WindowManager:push(temp)

		end
	end)

	-- 加为好友
	local friend = Button.new("false","true")
	friend:setButtonState("longButton_green_normal.png","longButton_general_down.png")
	friend:setString(Language:get("uc290"))
	self:addChild(friend)
	REL:toOther("left","bottom",friend,self,-20,20)
    friend:setTextShadow()
	self.friend = friend
	friend:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			local id = data.playerId
			local name = data.name

			if self.friendTag == 1 then
				local function confirm()
					local function finish()
						local descripe = Language:get("uc410")
						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
					end
					BuildingCommand:DeleteFriend(id,finish) -- 删除后有事件派发的
				end
				MUIPop.MUIImmediate(Language:get("uc398",name),confirm)
			else
				local function confirm()
					local isMax = SocialManager:judgeFriendReachMax()
					if isMax then
						local descripe = Language:get("uc404")
						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
					else
						local function finish()
							local descripe = Language:get("uc408")
							MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
						end
						BuildingCommand:AddFriend(name,id,finish)
					end
				end
				MUIPop.MUIImmediate(Language:get("uc402",name),confirm)
			end

		end
	end)

	-- 加入黑名单
	local blackList = Button.new("false","true")
	blackList:setButtonState("longButton_green_normal.png","longButton_general_down.png")
	blackList:setString(Language:get("uc291"))
	self:addChild(blackList)
	REL:toOther("right","bottom",blackList,self,-20,20)
    blackList:setTextShadow()
	self.blackList = blackList
	blackList:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			local id = data.playerId
			local name = data.name

			if self.blackTag == 1 then
				local function confirm()
					local function finish()
						local descripe = Language:get("uc411")
						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
					end
					BuildingCommand:DeleteBlackList(id,finish) -- 删除后有事件派发的
				end
				MUIPop.MUIImmediate(Language:get("uc399",name),confirm)
			else
				local function confirm()
					local isMax = SocialManager:judgeBlackReachMax()
					if isMax then
						local descripe = Language:get("uc405")
						MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
					else
						local function finish()
							local descripe = Language:get("uc409")
							MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
						end
						BuildingCommand:AddBlackList(name,id,finish)
					end
				end
				MUIPop.MUIImmediate(Language:get("uc403",name),confirm)
			end

		end
	end)

	if self.sourceName == UserInfo.name then
		writeMail:setIsGray(true)
		writeMail:setTouchEnabled(false)

		chatPrivate:setIsGray(true)
		chatPrivate:setTouchEnabled(false)

		friend:setIsGray(true)
		friend:setTouchEnabled(false)

		blackList:setIsGray(true)
		blackList:setTouchEnabled(false)
	end
end

--- 设置弹出窗口
function T:setMUIAlter2(muialter2)
	self.muialter2 = muialter2
end

function T:update()
	local id = self.otherPlayerData.playerId
	local name = self.otherPlayerData.name
	-- 好友
	local judgeFriend = SocialManager:judgeIsAtFrendList(id)
	if judgeFriend then -- 在好友列表中
		self:deleteFriendUpdate()
		self.friendTag = 1
	else
		self:addFriendUpdate()
		self.friendTag = 2
	end

	-- 黑名单
	local judgeBlack = SocialManager:judgeIsAtBlackList(id)
	if judgeBlack then
		self:deleteBlackUpdate()
		self.blackTag = 1
	else
		self:addBlackUpdate()
		self.blackTag = 2
	end

end


--- 在好友列表中
function T:deleteFriendUpdate()
	self.friend:setString(Language:get("uc400"))
end

--- 不在好友列表中
function T:addFriendUpdate()
	self.friend:setString(Language:get("uc290"))
end


--- 在黑名单列表中
function T:deleteBlackUpdate()
	self.blackList:setString(Language:get("uc401"))
end

--- 不在黑名单列表中
function T:addBlackUpdate()
	self.blackList:setString(Language:get("uc291"))
end

function T:updateAlliace()
    local data = self.otherPlayerData
    local id = UserInfo.allianceBox.myAlliance.id
	if data.allianceName then
        if data.allianceId == id then -- 自己联盟
            self:addLable()
            self.allianceSocial:loadTexture("allianceLabel_my.png",ccui.TextureResType.plistType)
        else
            local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
            if allianceSocial:judgeIsAtEnemyList(data.allianceId) then -- 判断是否是敌对
                self:addLable()
                self.allianceSocial:loadTexture("allianceLabel_hostile.png",ccui.TextureResType.plistType)
            elseif allianceSocial:judgeIsAtFrendList(data.allianceId) then -- 判断是否是好友 
                self:addLable()
                self.allianceSocial:loadTexture("allianceLabel_friendly.png",ccui.TextureResType.plistType)
            else -- 中立
                self:addLable()
                self.allianceSocial:loadTexture("allicanceCenter.png",ccui.TextureResType.plistType)
            end
            
        end

	end
end

function T:addLable()
    if not self.allianceSocial then
        local allianceSocial = ccui.ImageView:create()
        allianceSocial:loadTexture("allianceLabel_my.png",ccui.TextureResType.plistType)
        self:addChild(allianceSocial)
        REL:toOther("right","top",allianceSocial,self,-50,85 + 35 + 5)
        self.allianceSocial = allianceSocial
    else
        self.allianceSocial:setVisible(true)
    end

end


return T
