---聊天主窗口
local T = class(
	"T",
	function()
		local o = AbstractWindow.new()
		o.super = AbstractWindow
		return o
	end
)

--- 3个标签的标志,1:世界，2：联盟，3：私聊
T.btnTag = nil

--- 聊天信息
T.chatInfo = nil

--- 世界窗口变量
T.worldWindow = nil

--- 军团窗口变量
T.groupWindow = nil

--- 私聊窗口变量
T.privateWindow = nil

--- 临时的聊天时间
T.chatTime = nil

--- 私聊的用户
T.chatUserName = nil

function T:ctor(btnTag)
	self.btnTag = btnTag or 1
	self.chatTime = TimeUtils:getSyncMillis()/1000 - 3 -- 取出来的就是秒,首先登陆的时候，这个设置为要减个3秒

	local function callBack1()
		self.btnTag = 1
		self:_worldLogic()
		self:refresh()
	end

	local function callBack2()
		self:_groupLogic()
		self:refresh()
	end

	local function callBack3()
		self.btnTag = 3
		self:_privateLogic()
		self:refresh()
	end

	-- 创建3个
	local switchButtonContainer = SwitchButtonContainer.new()
	self:addChild(switchButtonContainer)
	REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
	switchButtonContainer:init()
	switchButtonContainer:initButtons(
		3,
		{{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"}},
		{70,15},
		{callBack1,callBack2,callBack3},
		{Language:get("uc141"),Language:get("uc142"),Language:get("uc143")},
		self.btnTag
	)
	self.switchButtonContainer = switchButtonContainer

	self.viewBack = self.switchButtonContainer.viewBack

	if self.btnTag == 1 then
		self:_worldLogic()
	elseif self.btnTag == 2 then
		self:_groupLogic()
	else
		self:_privateLogic()
	end


	-- 这个函数不会把父类的函数替换掉
	self:_initBottomBorder()

	-- 进入页面显示数据
	self:_showData()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
	self.super.onEnter(self)
	SocialManager:luaAddEventListener(SocialManager.EVT_ONE_FRIEND_REFRESH,self,self.setPrivateText)
end

function T:onExit()
	self.super.onExit(self)
	SocialManager:luaRemoveEventListener(SocialManager.EVT_ONE_FRIEND_REFRESH,self,self.setPrivateText)
end

--- 初始化下边框
function T:_initBottomBorder()
	-- 先移除原来的那个底框
	self.uiBottomBorder:removeAllChildren()
	-- 背景图片
	local backPic = ccui.ImageView:create()
	backPic:loadTexture("chatInputBoxBack.png",ccui.TextureResType.plistType)
	self.uiBottomBorder:addChild(backPic)
	REL:toOther("left","bottom",backPic,self.uiBottomBorder,0,0)

	-- 文本输入框
	local size = cc.size(420,50)  -- 触摸范围和文本显示范围
	local inputEditBox = MyEditBox.new(size,"editBoxBack.png")
	self.uiBottomBorder:addChild(inputEditBox)
	REL:toOther("left","bottom",inputEditBox,self.uiBottomBorder,50,5)
	local editBox = inputEditBox.editBox

	--editBox:setOpacity(0)

	-- 文本显示label:内容
	--    local content = XMLLabel()
	--    content:setContentSize(size)
	--    content:setVAlign("middle")
	--    self.uiBottomBorder:addChild(content)
	--    REL:toOther("center","middle",content,inputEditBox,0,0)
	--    content:setClippingEnabled(true)

	-- 发送按钮
	local btnSend = Button.new("false","false")
	btnSend:setButtonState("chatSendButton_normal.png","chatSendButton_normal.png")
	self.uiBottomBorder:addChild(btnSend)
	REL:toOther("right","bottom",btnSend,self.uiBottomBorder,5,10)

	-- 发送文本
	local sendText = XMLLabel()
	sendText:setContentSize(cc.size(200,36))
	sendText:setHAlign("center")
	sendText:setVAlign("middle")
	btnSend:addChild(sendText)
	REL:toOther("center","middle",sendText,btnSend,17,0)
	self.sendText = sendText


	-- 私聊按钮
	local btnPrivate = Button.new("false","true")
	btnPrivate:setButtonState("privateBottom.png","privateBottom.png")
	self.uiBottomBorder:addChild(btnPrivate)
	REL:toOther("left","bottom",btnPrivate,backPic,8,size.height + 20)
	self.btnPrivate = btnPrivate
	btnPrivate:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			-- new的有大小
			local layout = FriendLsitView.new()
			local muialter2 = MUIAlter.show(
				{
					title = Language:get("uc415"),
					info = layout,
					flag = 4,
					isShowCloseButton = true,
					callback = function(flag)
					end
				}
			)
			layout:init(muialter2)
		end
	end)

	-- 私聊输入框背景
	local inputSize = cc.size(540,40)
	local inputBomBackFrame = ResLoader:getSpriteFrame("chatNameBottom.png")
	local inputBomBackFrameSize = inputBomBackFrame:getOriginalSize()
	local inputBomBack = Scale9Sprite:createWithFrame(inputBomBackFrame,cc.rect(inputBomBackFrameSize.width/2,inputBomBackFrameSize.height/2,1,1))
	inputBomBack:setContentSize(inputSize)
	self.uiBottomBorder:addChild(inputBomBack)
	REL:toOther("left","middle",inputBomBack,btnPrivate,btnPrivate:getContentSize().width + 2,0)
	self.inputBomBack = inputBomBack
	-- 私聊输入框
	local editBoxPrivateChat = MyEditBox.new(inputSize,"editBoxBack.png")
	inputBomBack:addChild(editBoxPrivateChat)
	REL:toOther("center","middle",editBoxPrivateChat,inputBomBack,0,0)
	self.editBoxPrivateChat = editBoxPrivateChat
	self._editBoxPrivateChat = editBoxPrivateChat.editBox
	--self._editBoxPrivateChat:setOpacity(0) -- 可以设置透明度让其看不见,可以来测试字体的大小
	--	-- 私聊输入框文本
	--	local privateText = XMLLabel()
	--	privateText:setContentSize(cc.size(inputSize.width,36))
	--	privateText:setVAlign("middle")
	--	inputBomBack:addChild(privateText)
	--	REL:toOther("center","middle",privateText,inputBomBack,2,0)
	--	self.privateText = privateText

	if C_PFM == cc.PLATFORM_OS_IPHONE or C_PFM == cc.PLATFORM_OS_IPAD then
		editBox:setReturnType(cc.KEYBOARD_RETURNTYPE_SEND)
	end


	local editBoxRegistCallBack = function(strEventName,t)
		if strEventName == "began" then
			self:addUIMask()
		elseif strEventName == "ended" then
			-- 延迟1帧移除
			AbstractUI.timeout(self,function()
				self:removeUIMask()
			end, 0)

		elseif strEventName == "changed" then
			local text=StringUtils.getCountChar(XMLDecoder:escape(t:getText()),GameCfg.CHAT_INPUT_LIMIT)
			text=WordsFilters:filter(text,SensitiveWordsRoot)
			t:setText((XMLDecoder:unescape(text)))

			self.chatInfo = text
		elseif strEventName == "return" then
			if C_PFM == cc.PLATFORM_OS_IPHONE or C_PFM == cc.PLATFORM_OS_IPAD then
				self.sendLogic()
			end
		end
	end

	editBox:registerScriptEditBoxHandler(editBoxRegistCallBack)


	self._editBoxPrivateChat:registerScriptEditBoxHandler(function(strEventName,t)
		if strEventName == "began" then
		elseif strEventName == "ended" then
		elseif strEventName == "changed" then
			local lLimit,uLimit=unpack(GameCfg.PLAYER_NAME_LIMIT)
			local text=StringUtils.getCountChar(t:getText(),uLimit)
			text=WordsFilters:filter(text,SensitiveWordsRoot)
			t:setText(text)

			self.chatUserName = text
			--privateText:setString(text)
		elseif strEventName == "return" then

		end
	end
	)

	self.sendLogic = function()
		if self.chatInfo and string.trim(self.chatInfo) ~= "" then
		else
			--MUIPop.InputEmptyChat()
			return
		end


		local newTime = TimeUtils:getSyncMillis()/1000
		local offsetTime = newTime - self.chatTime
		--print(offsetTime)
		if offsetTime < 3 then
			if offsetTime < 3 and offsetTime >= 2 then
				MUIPop.SendNextChatTime(1)
			else
				MUIPop.SendNextChatTime(2)
			end
		else
			self.chatTime = newTime
			local text=self.chatInfo

			if text and string.trim(text) ~= "" then
				local function finish1() -- 发送成功才清除数据
					self.chatInfo = nil
					editBox:setText('')
					--content:setString('')
				end
				local function finish2() -- 私聊的
					self.chatInfo = nil
					editBox:setText('')
					--content:setString('')

					-- 私聊的
					--self.chatUserName = nil
					--self._editBoxPrivateChat:setText('')
					--privateText:setString('')
				end
				if self.btnTag == 1 then
					BuildingCommand:SendWorldChat(text,finish1)  -- 这里还要考虑返回码的问题,这里暂时不考虑
				elseif self.btnTag == 2 then
					BuildingCommand:SendGroupChat(text,finish1)
				else
					-- 这里要从服务端那边验证用户名是否存在
					if self.chatUserName == UserInfo.name then
						MUIPop.NotSendSelf()
						return
					end

					if self.chatUserName and self.chatUserName ~= "" then
						local function confirm()
							local temp = require("src.app.uiScript.components.mail.SendMailWindow").new(3,self.chatUserName)
							WindowManager:push(temp)
						end
						BuildingCommand:SendPrivateChat(text,self.chatUserName,finish2,confirm)
					else
						MUIPop.InputUserName()
					end

				end

			else
				MUIPop.InputEmptyChat()
			end
		end

	end

	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			self.sendLogic()
		end
	end

	btnSend:addTouchEventListener(callback)


	local function callBackPrivate()
		if eventType == ccui.TouchEventType.ended then
		-- 弹出通讯录

		end
	end
	btnPrivate:addTouchEventListener(callBackPrivate)

end

--- 进入页面显示数据
function T:_showData()
	self:setWindowTitle(Language:get("uc144"))

	self.btnPrivate:setString(Language:get("uc157"))
	self.btnPrivate.buttonText:setHAlign("center")
	self.btnPrivate.buttonText:setVAlign("middle")
	REL:toOther("center","middle",self.btnPrivate.buttonText,self.btnPrivate,0,0)

	self.sendText:setString(Language:get("uc279"))

	self:_worldLogic()
	self:refresh()
end

--- 世界逻辑
function T:_worldLogic()
	if self.worldWindow == nil then
		self.worldWindow = require("src.app.uiScript.components.chat.World").new(self)
		self:addChild(self.worldWindow)
		REL:relOther(self.worldWindow,self.uiContainer,0,0,90,58)
		self.worldWindow:init()
	end

	if self.worldWindow then
		self.worldWindow:setVisible(true)
	end

	if self.groupWindow then
		self.groupWindow:setVisible(false)
	end

	if self.privateWindow then
		self.privateWindow:setVisible(false)
	end
end

--- 军团逻辑
function T:_groupLogic()
	if self.worldWindow then
		self.worldWindow:setVisible(false)
	end

	if self.privateWindow then
		self.privateWindow:setVisible(false)
	end

	if self.groupWindow == nil then
		-- 这里要判断是否加入军团，如果未加入，则提醒
		local id = UserInfo.allianceBox.myAlliance.id
		if id and id > 0 then -- 有联盟
			self.groupWindow = require("src.app.uiScript.components.chat.ArmyGroup").new()
			self:addChild(self.groupWindow)
			REL:relOther(self.groupWindow,self.uiContainer,0,0,90,58)
			self.groupWindow:init()
			self.btnTag = 2
		else
			if self.btnTag == 3 then
				self.switchButtonContainer:switchButtons(self.switchButtonContainer:getButton(self.btnTag),true)
			else
				self.switchButtonContainer:switchButtons(self.switchButtonContainer:getButton(self.btnTag))
			end

			-- 弹出窗口
			local layout = require("src.app.uiScript.components.chat.AboutAlliancePopWindow").new()
			local muialter2 = MUIAlter.show(
				{
					title = Language:get("uc679"),
					info = layout,
					isShowCloseButton = true,
					flag = 4,
					callback = function(flag)
					end
				}
			)

			layout:setMUIAlter2(muialter2)


		end


	end

	if self.groupWindow then
		self.btnTag = 2
		self.groupWindow:setVisible(true)
	end


end

--- 私聊逻辑
function T:_privateLogic()
	if self.worldWindow then
		self.worldWindow:setVisible(false)
	end

	if self.groupWindow then
		self.groupWindow:setVisible(false)
	end

	if self.privateWindow == nil then
		self.privateWindow = require("src.app.uiScript.components.chat.PrivateChat").new()
		self:addChild(self.privateWindow)
		REL:relOther(self.privateWindow,self.uiContainer,0,0,90,120) -- 高度要调
		self.privateWindow:init()
		self.privateWindow:setVisible(true)
	end

	if self.privateWindow then
		self.privateWindow:setVisible(true)
	end

end

--- 刷新控件
function T:refresh()
	if self.btnTag == 3 then
		self.btnPrivate:setVisible(true)
		self.inputBomBack:setVisible(true)

	else
		self.btnPrivate:setVisible(false)
		self.inputBomBack:setVisible(false)

	end
end

--- 设置私聊文本
function T:setPrivateText(text)
	self.chatUserName = text
	self._editBoxPrivateChat:setText(text)
end

--- 添加遮罩
function T:addUIMask()
	if not self.mask then
		local mask = ccui.Layout:create()
		self:addChild(mask)
		REL:relScreen(mask, 0, 0, 0, 0)
		mask:setLocalZOrder(1000000)
		mask:setTouchEnabled(true)
		self.mask = mask
	end
	self.mask:setVisible(true)
end

--- 移除遮罩
function T:removeUIMask()
	if self.mask then
		self.mask:setVisible(false)
	end
end


return T
