--[[
 *	世界
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 每项的信息
T.chatInfoItem = require("src.app.uiScript.components.chat.ChatInfoItem")

--- 主窗口
T.chatWindow = nil

--- 构造函数
function T:ctor(chatWindow)
    self.chatWindow = chatWindow
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,0,0,0,8)
    self.listView = listView

    self:_addToListview()
end

--- 进入
function T:onEnter()
    ChatManager:luaAddEventListener(ChatManager.EVT_TYPE_UPDATE_WORLD_CHAT,self,self._update)
    ChatManager:luaAddEventListener(ChatManager.EVT_TYPE_GET_WORLD_QUEUE_CHAT,self,self.refreshPage)
end

--- 退出
function T:onExit()
    ChatManager:luaRemoveEventListener(ChatManager.EVT_TYPE_UPDATE_WORLD_CHAT,self,self._update)
    ChatManager:luaRemoveEventListener(ChatManager.EVT_TYPE_GET_WORLD_QUEUE_CHAT,self,self.refreshPage)

end

--- 增加到滚动层
function T:_addToListview()
    local queue = ChatManager.chatBox.chatWorldInfosQueue

    local length = queue:getLength()
    for i = 1,length,1 do 
        local chatInfo = queue:look(i)  -- 由于是浅拷贝，所以不能pop()
        local res = self.chatInfoItem.new(1,chatInfo,self.chatWindow)
        res:refresh()
        res:setContentSize(cc.size(res.size.width,res.size.height)) 
        self.listView:pushBackCustomItem(res)
    end

--    self.listView:refreshView() -- 刷新位置
--    local innerContainer = self.listView:getInnerContainer() 
--    local posX = innerContainer:getPositionX()
--    --REL:toOther("left","bottom",innerContainer,self.listView,0,0) -- 貌似设置位置不行啊,到时再来
--    innerContainer:runAction(cc.MoveTo:create(0.01, cc.p(posX, 0)))

    -- 延迟1帧
    Cocos2dxUtils:timeOut(function()    
        self.listView:refreshView() -- 刷新位置
        local innerContainer = self.listView:getInnerContainer() 
        local posX = innerContainer:getPositionX()
        REL:toOther("left","bottom",innerContainer,self.listView,0,0) -- 必须延迟1帧才能成功的啊

    end,0)      -- 0表示1帧
end

--- 刷新函数
function T:_update()
    -- 知道移除的长度就可以了，然后从0开始索引移除就是了
    local removeChatWorldInfosLength = ChatManager.chatBox.removeChatWorldInfosLength
    if removeChatWorldInfosLength then
        for i = 0,removeChatWorldInfosLength - 1,1 do
            self.listView:removeItem(i)
        end
        self.listView:refreshView() -- 刷新索引
    end

    -- 添加新项
    local addChatWorldInfosQueue = ChatManager.chatBox.addChatWorldInfosQueue
    local length = addChatWorldInfosQueue:getLength()
    for i = 1,length,1 do
        local chatInfo = addChatWorldInfosQueue:pop()
        local res = self.chatInfoItem.new(1,chatInfo,self.chatWindow)
        res:refresh()
        res:setContentSize(cc.size(res.size.width,res.size.height))  -- 这里还要根据文本的高度宽度动态来设置每一项的高度
        self.listView:pushBackCustomItem(res)
    end

    self.listView:refreshView() -- 刷新位置
    local innerContainer = self.listView:getInnerContainer() 
    local posX = innerContainer:getPositionX()
    innerContainer:runAction(cc.MoveTo:create(0.1, cc.p(posX, 0)))


--    local lengtheee = ChatManager.chatBox.chatWorldInfosQueue:getLength()
--    print(lengtheee)
--    local dfdfad = self.listView:getItems()
--    print(#dfdfad)

end

function T:refreshPage()
    self.listView:removeAllItems()

    self:_addToListview()

end


return T
