local _print=print
local function print(...)
	_print("\t<AbstractAlter>: ",table.concat({...},"\t"))
end

local AbstractAlter = require("src.app.uiScript.components.common.AbstractAlter")

local T=Class.T(AbstractAlter)

--- 默认宽
T.DEFAULT_WIDTH=544

--- 默认高
T.DEFAULT_HEIGHT=226

function T:def()
	AbstractAlter.def(self)
end

function T:ctor(...)
	AbstractAlter.ctor(self,...)
end

function T:onEnter()
	AbstractAlter.onEnter(self)

	AudioManager:playEffect(self.data.popSnd or SoundRes.SND_TIP_POP)
end

--- 初始化
function T:init()
	AbstractAlter.init(self)

	self.uiContainer:setContentSize(cc.size(self.DEFAULT_WIDTH-16,self.DEFAULT_HEIGHT-10))
end

function T:addChild(child)
	self.uiContainer:addChild(child)
end

--- 创建"关闭"按钮
function T:createCloseButton()
	local uiCloseButton=BaseButton:createButton(nil,"alterCoseButton_normal.png")
	self.uiAlterContainer:addChild(uiCloseButton)
	self.uiCloseButton=uiCloseButton

	uiCloseButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self.flag=FLAG_NO

			self:hide()
		end
	end)
end

--- 更新背景
function T:updateBack()end

--- 更新对齐
function T:updateAlign()end

--- 设置容器大小
function T:setContainerSize(width,height)
	local uiContainer=self.uiContainer

	uiContainer:setContentSize(cc.size(
		width > self.DEFAULT_WIDTH and width or self.DEFAULT_WIDTH,
		height > self.DEFAULT_HEIGHT and height or self.DEFAULT_HEIGHT
	))

	self:updateAlign()
end

return T
