--- 预加载资源列表
local preResList={
	"res/images/generalTip.plist"
}

-- 加载所需要的plist
for _,v in pairs(preResList) do
	print("<load plist>:"..v)
	cc.SpriteFrameCache:getInstance():addSpriteFrames(v)
end

--- 通讯等待防误操作遮罩
local T = Class.CommunicationWaitingEff(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 动画背景
	-- self.uiMovBack=nil

	--- 动画前景
	-- self.uiMoveFore=nil
end

--- 构造函数
function T:ctor()
	AbstractUI.ctor(self)

	self:init()
end

function T:onEnter()
	AbstractUI.onEnter(self)

	REL:relScreen(self, 0, 0, 0, 0)

	self.uiMoveFore:runAction(cc.RepeatForever:create(cc.Sequence:create(
		cc.DelayTime:create(0.04),
		cc.CallFunc:create( function(target)
			target:setRotation((target:getRotation() + 10) % 360)
		end )
	)))
end

function T:onExit()
	AbstractUI.onExit(self)
end

function T:cleanUp()
	AbstractUI.cleanUp(self)
end

function T:init()
	-- 吞噬touch事件
	self:setTouchEnabled(true)
	self:setLocalZOrder(99999)

	self:initLoadingAni()
end

--- 初始化加载动画
function T:initLoadingAni()
	local uiMovBack = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("public_loading_background.png"))
	self:addChild(uiMovBack)
	REL:toScreen("center", "middle", uiMovBack, 0, 0)
	self.uiMovBack=uiMovBack

	local uiMoveFore = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("public_loading_light.png"))
	self:addChild(uiMoveFore)
	REL:toOther("center", "middle", uiMoveFore, uiMovBack, 0, 0)
	self.uiMoveFore=uiMoveFore
end

return T
