--- 预加载资源列表
local preResList={
	"res/images/generalTip.plist"
}

-- 加载所需要的plist
for _,v in pairs(preResList) do
	print("<load plist>:"..v)
	cc.SpriteFrameCache:getInstance():addSpriteFrames(v)
end

--- 通讯等待防误操作遮罩
local T = Class.CommunicationWaitingMask(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 显示
-- @param text 文本内容
-- @param closeCallback 关闭时的回调
-- @param callbackHost 关闭时回调的宿主
-- @param parent 显示的父对象
function T:show(text,closeCallback,callbackHost,parent)
    local ins=T()

	if not parent then
		parent=Director:getRunningScene()
	end
	parent:addChild(ins);
    return ins
end

--- 隐藏
function T:hide()
	self:removeFromParent()
end

function T:def()
	AbstractUI.def(self)

	--- 动画背景
	-- self.uiMovBack=nil

	--- 动画前景
	-- self.uiMoveFore=nil
end

--- 构造函数
function T:ctor()
	AbstractUI.ctor(self)

	self:init()
end

function T:onEnter()
	AbstractUI.onEnter(self)

	REL:relScreen(self, 0, 0, 0, 0)

	local uiMovBack,bFunc=self.uiMovBack
	bFunc=function()
		AbstractUI.timeout(uiMovBack,function()
			uiMovBack:runAction(cc.Sequence:create(
				cc.FadeTo:create(0.2, uiMovBack:getOpacity() < 150 and 255 or 100),
				cc.CallFunc:create(function(t)
					bFunc()
				end))
			)

		end,randomFloat(0.5,0.8))
	end
	bFunc()

	self.uiMoveFore:runAction(cc.RepeatForever:create(cc.Sequence:create(
		cc.DelayTime:create(0.04),
		cc.CallFunc:create( function(target)
			target:setRotation((target:getRotation() + 10) % 360)
		end )
	)))
end

function T:onExit()
	AbstractUI.onExit(self)
end

function T:cleanUp()
	AbstractUI.cleanUp(self)
end

function T:init()
	-- 设置背景色
	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	self:setBackGroundColor(cc.c3b(0, 0, 0))
	self:setBackGroundColorOpacity(140)

	-- 吞噬touch事件
	self:setTouchEnabled(true)
	self:setLocalZOrder(99999)

	self:initLoadingAni()
end

--- 初始化加载动画
function T:initLoadingAni()
	local uiMovBack = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("public_loading_background.png"))
	self:addChild(uiMovBack)
	REL:toScreen("center", "middle", uiMovBack, 0, 0)
	self.uiMovBack=uiMovBack

	local uiMoveFore = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("public_loading_light.png"))
	self:addChild(uiMoveFore)
	REL:toOther("center", "middle", uiMoveFore, uiMovBack, 0, 0)
	self.uiMoveFore=uiMoveFore
end

return T
