--弹窗确定
FLAG_OK = 0

--弹窗取消
FLAG_NO = 1

local AbstractClipBackAlter = require("src.app.uiScript.components.common.AbstractClipBackAlter")

local T=Class.MUIAlter(AbstractClipBackAlter)

function T:def()
	AbstractClipBackAlter.def(self)

	--- 上边框(标题背景)
	-- self.uiBorderTop=nil

	--- 标题
	-- self.uiTitle=nil

	--- 左下角边框
	-- self.uiBorderLeftBottom=nil

	--- 右下角边框
	-- self.uiBorderRightBottom=nil
end

function T:ctor(...)
	AbstractClipBackAlter.ctor(self,...)
end

--- 退出场景
function T:onExit()
	AbstractClipBackAlter.onExit(self)

	if self._closeCallback then
		local call=self._closeCallback
		local arg=self.flag
		Cocos2dxUtils:timeOut(function()
			call(arg or FLAG_NO)
		end,0)
	end
end

--- 初始化
function T:init()
	AbstractClipBackAlter.init(self)

	local uiAlterContainer=self.uiAlterContainer

	-- 背景
	local uiBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("alter_back.png"))
	uiAlterContainer:addChild(uiBack)
	self.uiBack=uiBack

	-- 标题
	local uiTitle=XMLLabel()
	if CssStyles then
		uiTitle:setCssStyle(CssStyles.alterTitle)
	end
	uiTitle:setAlign("center","middle")
	uiTitle:setHeight(36)
	uiAlterContainer:addChild(uiTitle)
	self.uiTitle=uiTitle
end

--- 设置标题文本
-- @param title
function T:setTitle(title)
	self.uiTitle:setString(title or Language:get("ug100"))
end

--- 更新对齐
function T:updateAlign()
	local uiAlterContainer=self.uiAlterContainer

	local cs=self.uiContainer:getContentSize()

	uiAlterContainer:setContentSize(cc.size(cs.width+16,cs.height+66+10))
	REL:toScreen("center","middle",uiAlterContainer,0,0)

	self:updateBack()
	REL:relOther(self.uiBack,uiAlterContainer,-2,-2,-44,-48)
	REL:relOther(self.uiTitle,uiAlterContainer,20,20,14,SIZE_NIL)
	REL:toOther("center","top",self.uiContainer,uiAlterContainer,0,66)
	if self.uiCloseButton then
		REL:toOther("right","top",self.uiCloseButton,uiAlterContainer,30,18)
	end
end

--- 更新按钮
function T:updateButtons()
	local data=self.data

	local uiButtons={}

	local uiConfirmButton
	local uiCancelButton

	local flag=data.flag
	if flag == 3 then
		--显示两个按钮

		uiCancelButton=self:createTextButton(
			data.cancelText or Language:get("ug102"),
			data.cancelType or 15
		)
		uiCancelButton.flag=FLAG_NO
		uiButtons[#uiButtons+1]=uiCancelButton

		uiConfirmButton=self:createTextButton(
			data.confirmText or Language:get("ug101"),
			data.confirTtype or 11
		)
		uiConfirmButton.flag=FLAG_OK
		uiButtons[#uiButtons+1]=uiConfirmButton
	elseif flag == 4 then
	--不显示按钮

	else
		--只显示一个按钮

		uiConfirmButton=self:createTextButton(
			data.confirmText or Language:get("ug101"),
			data.confirTtype or 11
		)
		uiConfirmButton.flag=FLAG_OK

		uiButtons[#uiButtons+1]=uiConfirmButton
	end

	self.uiButtons=uiButtons

	if BGMgr and BGMgr:isGuide() then
		if uiConfirmButton then
			BGMgr:regGuideObj(BGMgr.TGR_MUI_ALTER_CONFIRM_BUTTON,uiConfirmButton)
		end
		if uiCancelButton then
			BGMgr:regGuideObj(BGMgr.TGR_MUI_ALTER_CANCEL_BUTTON,uiCancelButton)
		end
	end
end

--- 显示
function T:_show(data)
	AbstractClipBackAlter._show(self,data,data.triggerCloseMethod or self.TRIGGER_CLOSE_METHOD_OUTSIDE)

	self._closeCallback=data.callback

	self:setTitle(data.title)
	if data.isShowCloseButton then
		self:createCloseButton()
	end
	self:updateCentent()
	self:updateButtons()

	local uiContainer=self.uiContainer

	local uiContent=self.uiContent
	local uiButtons=self.uiButtons

	self:setContainerSize(
		uiContent:getContentSize().width,
		uiContent:getContentSize().height+
		(#uiButtons > 0 and 68 + 10 or 0)
	)

	REL:toOther("center","top",uiContent,uiContainer,0,0)
	local n=#uiButtons
	if n == 1 then
		REL:toOther("center","bottom",uiButtons[1],uiContainer,0,0)
	elseif n == 2 then
		REL:toOther("center","bottom",uiButtons[1],uiContainer,-120,0)
		REL:toOther("center","bottom",uiButtons[2],uiContainer,120,0)
	end
end

function T:createTextButton(caption,type)
	local btn=require("src.app.utils.BaseButton"):getGeneralButton(caption,type)

	btn:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			if BGMgr and BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,t)
			end

			self.flag=t.flag
			self:hide()
		end
	end)
	self.uiContainer:addChild(btn)

	return btn
end

--- 通用提示框
-- 	弹窗接收一个table对象
-- 	{
-- 		info:显示信息（可以是纯文字，也可以是一个layout）
-- 		title：标题文字（默认为“提 示”）
-- 		vAlign：（只有当info为纯文字时，才有效，垂直对齐方式<默认居中>）
-- 		hAlign：（只有当info为纯文字时，才有效，水平对齐方式<默认居中>）
-- 		lineSpacing：行间距（默认为2）
-- 		callback：回调函数
-- 		confirmText：确认按钮文字
-- 		confirTtype:"确认"按钮的样式(默认为绿色,1为绿色,2为黄色,3为紫色,4为灰色)
-- 		cancelText：取消按钮文字
-- 		cancelType:"取消"按钮的样式(默认为绿色,1为绿色,2为黄色,3为紫色,4为灰色)
-- 		flag：标记参数（默认为1<可选1,2,3,4>；1：只显示一个按钮；2：只显示一个按钮；:3：显示两个按钮；4：不显示按钮）
-- 		isShowCloseButton:是否显示关闭按钮
-- 		triggerCloseMethod:触发关闭的方式(默认值为 "outside")
-- 			"any":点击任何地方(如果传入的对象是一个 Layout 可以设置 Layout 的 setTouchEnabled(true) 来截获关闭的触发)
-- 			"content":点击内容区域(如果传入的对象是一个 Layout 可以设置 Layout 的 setTouchEnabled(true) 来截获关闭的触发)
-- 			"outside":点击内容区域以外的地方
-- 			"buttons":点击按钮
--	}
function T.show(info,parent)
	return AbstractClipBackAlter.show(T,info,parent)
end

return T
