local AbstractAlter = require("src.app.uiScript.components.common.AbstractAlter")

--- 最小内容高度
local contentMinWidth=0

--- 最小内容高度
local contentMinHeight=0

local T=Class.T(AbstractAlter)

function T:def()
	AbstractAlter.def(self)

	--- 遮罩
	-- self.uiMask=nil

	--- 为了添加特效而添加的容器
	-- self.uiEffContainer=nil

	--- 提示框显示容器
	-- self.uiAlterContainer=nil

	--- 内容容器
	-- self.uiContainer=nil

	--- 显示时间(0表示 touch 触发关闭,-1表示程序触发关闭,大于0表示到时间后自动关闭)
	-- self.showSecond=0

	--- 是否不触发回调
	self.isNotCallback=false
end

--- 构造函数
function T:ctor()
	AbstractAlter.ctor(self)
end

function T:onEnter()
	AbstractAlter.onEnter(self)
	
	AudioManager:playEffect(self.data.popSnd or SoundRes.SND_TIP_POP)
end

--- 退出场景
function T:onExit()
	AbstractAlter.onExit(self)

	if self.isNotCallback then
		
	else
		if self._closeCallback then
			local call=self._closeCallback
			Cocos2dxUtils:timeOut(function()
				call()
			end,0)
		end
	end
end

--- 初始化
function T:init()
	AbstractAlter.init(self)
end

--- 更新对齐
function T:updateAlign()
	local uiAlterContainer=self.uiAlterContainer

	local cs=self.uiContainer:getContentSize()

	uiAlterContainer:setContentSize(cc.size(cs.width,cs.height))
	REL:toOther("center","middle",uiAlterContainer,self.uiEffContainer,0,0)

	REL:toOther("center","middle",self.uiContainer,uiAlterContainer,0,0)
end

function T:addChild(child)
	self.uiContainer:addChild(child)
end

--- 设置容器大小
function T:setContainerSize(width,height)
	width=width<contentMinWidth and contentMinWidth or width
	height=height<contentMinHeight and contentMinHeight or height

	local uiContainer=self.uiContainer

	uiContainer:setContentSize(cc.size(width,height))

	self:updateAlign()
end

--- 显示
function T:_show(data)
	AbstractAlter._show(self,data,data.triggerCloseMethod or self.TRIGGER_CLOSE_METHOD_ANY)

	self.showSecond=data.showSecond
	self._closeCallback=data.callback
	self._beforeCloseCallback=data.beforeCloseCallback

	self:updateCentent()
	if type(data.info) ~= "string" then
		function data.info.__hide__(isNotCallback)
			self.isNotCallback=isNotCallback
			self:hide()
		end
	end

	local uiContent=self.uiContent
	self:setContainerSize(uiContent:getContentSize().width,uiContent:getContentSize().height)

	REL:toOther("center","top",uiContent,self.uiContainer,0,0)
end

--- 无标题栏的通用提示框
-- 	弹窗接收一个table对象
-- 	{
-- 		info:显示信息（html文本或可显示对象）
-- 		isMask:是否显示遮罩
-- 		vAlign：（只有当info为纯文字时，才有效，垂直对齐方式<默认居中>）
-- 		hAlign：（只有当info为纯文字时，才有效，水平对齐方式<默认居中>）
-- 		lineSpacing：行间距（默认为2）
-- 		callback：回调函数,被关闭后触发
-- 		beforeCloseCallback:关闭事件前触发
-- 		triggerCloseMethod:触发关闭的方式(默认值为 "outside")
-- 			"any":点击任何地方(如果传入的对象是一个 Layout 可以设置 Layout 的 setTouchEnabled(true) 来截获关闭的触发)
-- 			"content":点击内容区域(如果传入的对象是一个 Layout 可以设置 Layout 的 setTouchEnabled(true) 来截获关闭的触发)
-- 			"outside":点击内容区域以外的地方
-- 			"buttons":点击按钮
--	}
function T.show(info,parent)
	return AbstractAlter.show(T,info,parent)
end

--- 隐藏时的特效
function T:hideEff()
	--屏蔽点击(关闭期间不应该响应事件)
	local uiMask=ccui.Layout:create()
	self:addChild(uiMask)
	REL:relOther(uiMask,self.uiContainer, 0, 0, 0, 0)
	self.uiMask=uiMask

	uiMask:setTouchEnabled(true)
	uiMask:addTouchEventListener(function(t,e)
--		print("屏蔽底层点击")
	end)
	
	if self._beforeCloseCallback then
		self._beforeCloseCallback()
	end

	AbstractAlter.hideEff(self)
end

return T
