local AbstractClipBackAlter = require("src.app.uiScript.components.common.AbstractClipBackAlter")

local T=Class.T(AbstractClipBackAlter)

--- 默认高
T.DEFAULT_HEIGHT=333

function T:def()
	AbstractClipBackAlter.def(self)

	--- 左上角边框
	-- self.uiBorderLeftTop=nil

	--- 右上角边框
	-- self.uiBorderRightTop=nil

	--- 左下角边框
	-- self.uiBorderLeftBottom=nil

	--- 右下角边框
	-- self.uiBorderRightBottom=nil
end

function T:ctor()
	AbstractClipBackAlter.ctor(self)
end

--- 退出场景
function T:onExit()
	AbstractClipBackAlter.onExit(self)

	if self._closeCallback then
		local call=self._closeCallback
		Cocos2dxUtils:timeOut(function()
			call()
		end,0)
	end
end

--- 初始化
function T:init()
	AbstractClipBackAlter.init(self)

	self:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:hide()
		end
	end)

	-- 背景
	local uiBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("alter_noTitle_back.png"))
	self.uiAlterContainer:addChild(uiBack)
	self.uiBack=uiBack
end

--- 更新对齐
function T:updateAlign()
	local uiAlterContainer=self.uiAlterContainer

	local cs=self.uiContainer:getContentSize()

	uiAlterContainer:setContentSize(cc.size(cs.width+16,cs.height+20))
	REL:toScreen("center","middle",uiAlterContainer,0,0)

	self:updateBack()
	REL:relOther(self.uiBack,uiAlterContainer,-20,-20,-64,-48)
	REL:toOther("center","middle",self.uiContainer,uiAlterContainer,0,0)
	if self.uiCloseButton then
		REL:toOther("right","top",self.uiCloseButton,uiAlterContainer,30,18)
	end
end

--- 显示
function T:_show(data)
	AbstractClipBackAlter._show(self,data,data.triggerCloseMethod or self.TRIGGER_CLOSE_METHOD_ANY)

	self._closeCallback=data.callback

	if data.isShowCloseButton then
		self:createCloseButton()
	end
	self:updateCentent()

	local uiContent=self.uiContent
	self:setContainerSize(uiContent:getContentSize().width,uiContent:getContentSize().height)

	REL:toOther("center","top",uiContent,self.uiContainer,0,0)
end

--- 无标题栏的通用提示框
-- 	弹窗接收一个table对象
-- 	{
-- 		info:显示信息（可以是纯文字，也可以是一个layout）
-- 		vAlign：（只有当info为纯文字时，才有效，垂直对齐方式<默认居中>）
-- 		hAlign：（只有当info为纯文字时，才有效，水平对齐方式<默认居中>）
-- 		lineSpacing：行间距（默认为2）
-- 		callback：回调函数
-- 		isShowCloseButton:是否显示关闭按钮
-- 		triggerCloseMethod:触发关闭的方式(默认值为 "any")
-- 			"any":点击任何地方(如果传入的对象是一个 Layout 可以设置 Layout 的 setTouchEnabled(true) 来截获关闭的触发)
-- 			"content":点击内容区域(如果传入的对象是一个 Layout 可以设置 Layout 的 setTouchEnabled(true) 来截获关闭的触发)
-- 			"outside":点击内容区域以外的地方
-- 			"buttons":点击按钮
--	}
function T.show(info,parent)
	return AbstractClipBackAlter.show(T,info,parent)
end

return T
