--- 小秘书生成器
local T=Class.SecretaryGenerator()

T.BODIES={
	["lolita"]={url="res/images/secretary/lolita.png"},
	["jayla"]={url="res/images/secretary/jayla.png"},
	["susy_clothing_1"]={url="res/images/secretary/susy_clothing_1.png",faceMountPt={x=181,y=103}},
	["susy_clothing_2"]={url="res/images/secretary/susy_clothing_2.png",faceMountPt={x=183,y=109}},
}

T.FACES={
	[1]={
		url="res/images/secretary/susy_face_1.png",
		refBodies={"susy_clothing_1","susy_clothing_1",},
		offset={x=0,y=2}
	},
	[2]={
		url="res/images/secretary/susy_face_2.png",
		refBodies={"susy_clothing_1","susy_clothing_1",},
		offset={x=0,y=10}
	},
}

--- 默认半身像截取矩形
T.DEFAULT_BUST_RECT={x=0,y=0,width=388,height=400}


--- 获取全身像
-- @param name 名字
-- @param faceId 表情
function T:getFelt(name,faceId)
	local uiBody=nil
	
	local body=self.BODIES[name]
	if body then
		uiBody=cc.Sprite:create(body.url)

		if faceId and body.faceMountPt then
			local pt=body.faceMountPt
		
			local face=self.FACES[faceId]
			if face then
				local offset=face.offset
			
				local uiFace=cc.Sprite:create(face.url)
				uiBody:addChild(uiFace)
				
				local faceS=uiFace:getContentSize()
				REL:toOther("left","top",uiFace,uiBody,pt.x-faceS.width/2+offset.x,pt.y-faceS.height/2+offset.y)
			end
		end
		
		reductionScale(uiBody)
	end

	return uiBody
end

--- 获取半身像
-- @param name 名字
-- @param rect 区域
-- @param faceId 表情
function T:getBust(name,rect,faceId)
	local uiBody=nil
	
	local body=self.BODIES[name]
	if body then
		local bodyFrame=cc.SpriteFrame:create(body.url,rect)
	
		uiBody=cc.Sprite:createWithSpriteFrame(bodyFrame)

		if faceId and body.faceMountPt then
			local pt=body.faceMountPt
		
			local face=self.FACES[faceId]
			if face then
				local offset=face.offset
			
				local uiFace=cc.Sprite:create(face.url)
				uiBody:addChild(uiFace)
				
				local faceS=uiFace:getContentSize()
				REL:toOther("left","top",uiFace,uiBody,pt.x+offset.x-faceS.width/2-rect.x,pt.y+offset.y-faceS.height/2-rect.y)
			end
		end
		
		reductionScale(uiBody)
	end

	return uiBody
end

return T()
