local T=Class.SwitchButton(ToggleButton)

function T:def()
	ToggleButton.def(self)

	--- 文本
	--self.uiText=nil

	--- 未选择时的文本
	self._unselectedText=Language:get("ug121")

	--- 选择时的文本
	self._selectedText=Language:get("ug120")
end

function T:ctor(unselectedText,selectedText)
	if unselectedText then
		self._unselectedText=unselectedText
	end
	if selectedText then
		self._selectedText=selectedText
	end

	ToggleButton.ctor(self,"toggleButton_closed.png","toggleButton_opened.png")
end

function T:_init()
	ToggleButton._init(self)

	local uiText=XMLLabel()
	uiText:setAlign("center","middle")
	self:addChild(uiText)
	uiText:setWidth(self:getContentSize().width/2)
	self.uiText=uiText

	uiText:setString(self._unselectedText)
	REL:relOther(uiText,self,SIZE_NIL,0,0,0)
end

function T:_switchStatus()
	ToggleButton._switchStatus(self)

	local uiText=self.uiText
	if self.isSelected then
		uiText:setString(self._selectedText)
		REL:relOther(uiText,self,0,SIZE_NIL,0,0)
	else
		uiText:setString(self._unselectedText)
		REL:relOther(uiText,self,SIZE_NIL,0,0,0)
	end
end

--- 未被选择时显示的文本
function T:setUnselectedText(text)
	if text ~= self._unselectedText then
		self._unselectedText=text

		self:_switchStatus()
	end
end
--- 未被选择时显示的文本
function T:getUnselectedText()
	return self._unselectedText
end

--- 已被选择时显示的文本
function T:setSelectedText(text)
	if text ~= self._selectedText then
		self._selectedText=text

		self:_switchStatus()
	end
end
--- 已被选择时显示的文本
function T:getSelectedText()
	return self._selectedText
end

return T
