local preResList={
	"res/images/generalTip.plist"
}

-- 加载所需要的plist
for _,v in pairs(preResList) do
	print("<load plist>:"..v)
	cc.SpriteFrameCache:getInstance():addSpriteFrames(v)
end

--- 弹出信息提示文本
local T=Class.WaitingMessageText(function()
	local t=ccui.Layout:create()

	t:setLocalZOrder(TOP_ORDER + 100)
	return t
end)

--- 显示
-- @param text 文本内容
-- @param closeCallback 关闭时的回调
-- @param callbackHost 关闭时回调的宿主
-- @param parent 显示的父对象
function T:show(text,closeCallback,callbackHost,parent)
    local ins=T()
	ins:_show(text,closeCallback,callbackHost)

	if not parent then
		parent=Director:getRunningScene()
	end
	parent:addChild(ins);
    return ins
end

--- 隐藏
function T:hide()
	self:hideEff()
end

function T:def()
	--- 背景
	-- self.uiTextBack=nil

	--- 内容文本
	-- self.uiTextBack.uiText=nil

	--- 回调函数的宿主
	-- self.uiTextBack._callbackHost=nil

	--- 关闭时的回调
	-- self.uiTextBack._closeCallback=nil
end

function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:showEff()
			elseif eventType == CocosEvent.EXIT then
				self:removeFromStageHandler()
			else

			end
		end
	)

	self:init()
end

function T:init()
	REL:relScreen(self,0,0,0,0)

	self:setTouchEnabled(true)
	self:setLocalZOrder(TOP_ORDER + 200)

	--背景
	local uiTextBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("singleTipBack.png"))
	self:addChild(uiTextBack)
	REL:toOther("center","middle",uiTextBack,self,0,0)
	self.uiTextBack=uiTextBack

	local uiText=XMLLabel()
	uiText:setHAlign("center")
	uiText:setVAlign("middle")
	self:addChild(uiText)
	REL:relOther(uiText,uiTextBack,0,0,0,0)
	self.uiText=uiText
end

function T:_show(text,closeCallback,callbackHost)
	self.uiText:setString(text)
	self._closeCallback=closeCallback
	self._callbackHost=callbackHost
end

function T:removeFromStageHandler()
	if self._closeCallback then
		if self._callbackHost then
			self._closeCallback(self._callbackHost)
		else
			self._closeCallback()
		end
	end
end

--- 显示时的特效
function T:showEff()
	local uiTextBack=self.uiTextBack
	uiTextBack:setScale(0.5)

	local uiText=self.uiText
	uiText:setVisible(false)

	uiTextBack:setScaleY(0)
	uiTextBack:runAction(cc.Sequence:create(
		cc.Spawn:create({
			cc.Sequence:create(
				cc.ScaleTo:create(0.1,1.05),
				cc.CallFunc:create(function()
					self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid )
					self:setBackGroundColor(cc.c3b(0,0,0))
					self:setBackGroundColorOpacity(100)

					uiText:setVisible(true)
				end),
				cc.ScaleTo:create(0.2,1)
			),
			cc.FadeIn:create(0.4)
		})
	))
end

--- 隐藏时的特效
function T:hideEff()
	local uiTextBack=self.uiTextBack
	local uiText=self.uiText

	uiText:runAction(cc.Sequence:create(
		cc.FadeOut:create(0.3),
		cc.CallFunc:create(function(target)
			self:setBackGroundColorType(ccui.LayoutBackGroundColorType.none)

			uiTextBack:runAction(cc.Sequence:create(
				cc.Spawn:create({
					cc.Sequence:create(cc.ScaleTo:create(0.2,1.05),cc.ScaleTo:create(0.1,0.75)),
					cc.FadeOut:create(0.3)
				}),
				cc.CallFunc:create(function(target)
					target:setScale(1)
					self:removeFromParent()
				end)
			))
		end)
	))
end

return T
