--- 战场菜单层
local T = Class.FightMenuLayer(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 战场配置
T.FightCfg=require("src.app.configs.FightCfg")

--- 玩家使用道具产生的buff,如(高爆炸弹等)
T.PropBuff_temp=require("res.data.aircraft.propBuff")

--- 对象池
T.bloodWordPool=Stack()

--- 最大回合数
T.MAX_ROUND=20

function T:def()
	AbstractUI.def(self)

	--- 战斗类型
	self.fightType=FightType.FIGHT_TYPE_CHAPTER

	--- 阵营1攻击已攻击次数
	self.camp1AttackCount=0

	--- 阵营2攻击已攻击次数
	self.camp2AttackCount=0

	--- 显示当前的回合数
	--self.uiRound=nil

	--- 阵营1名称
	--self.uiCamp1Name=nil

	--- 阵营2名称
	--self.uiCamp2Name=nil

	--- 跳过战斗按钮
	-- self.uiSkipFightButton=nil
end

--- 构造函数
function T:ctor()
	AbstractUI.ctor(self)

	self:init()
end

--- 内存清理
function T:cleanUp()
	AbstractUI.cleanUp(self)

	print("释放血量飘字对象池中的对象")
	local bwPool=self.bloodWordPool
	while not bwPool:isEmpty() do
		local node=bwPool:pop()
		if node then
			node:release()
		end
	end
	self.bloodWordPool=nil
end

--- 初始化
function T:init()
	REL:relScreen(self,0,0,0,0)

	---"跳过战斗"
	local uiSkipFightButton = BaseButton:createButton(Language:get("ug401"),"button_blue_normal.png","button_general_down.png")
	uiSkipFightButton:setVisible(false)
	self:addChild(uiSkipFightButton)
	REL:toScreen("right","bottom",uiSkipFightButton,10,10)
	self.uiSkipFightButton=uiSkipFightButton

	uiSkipFightButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			uiSkipFightButton:setTouchEnabled(false)
			--本地通讯
			require("src.app.communication.fight.SkipFightCommand")():exec()
		end
	end)

	--阵营1背景
	local uiCamp1Back=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("campBack.png"))
	self:addChild(uiCamp1Back)
	REL:toOther("left","top",uiCamp1Back,self,0,0)
	self.uiCamp1Back=uiCamp1Back

	--阵营1名称
	local uiCamp1Name=XMLLabel()
	uiCamp1Name:setCssStyle(CssStyles.default28)
	uiCamp1Name:setAlign("center","middle")
	self:addChild(uiCamp1Name)
	REL:relOther(uiCamp1Name,uiCamp1Back,2,48,2,44)
	self.uiCamp1Name=uiCamp1Name

	--	uiCamp1Name:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiCamp1Name:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiCamp1Name:setBackGroundColorOpacity(100)

	--阵营1等级
	local uiCamp1LV=XMLLabel()
	uiCamp1LV:setAlign("center","middle")
	self:addChild(uiCamp1LV)
	REL:relOther(uiCamp1LV,uiCamp1Back,2,172,50,12)
	self.uiCamp1LV=uiCamp1LV

	--	uiCamp1LV:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiCamp1LV:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiCamp1LV:setBackGroundColorOpacity(100)

	--阵营2背景
	local uiCamp2Back=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("campBack.png"))
	uiCamp2Back:setFlippedX(true)
	self:addChild(uiCamp2Back)
	REL:toOther("right","top",uiCamp2Back,self,0,0)
	self.uiCamp2Back=uiCamp2Back

	--阵营2名称
	local uiCamp2Name=XMLLabel()
	uiCamp2Name:setCssStyle(CssStyles.default28)
	uiCamp2Name:setAlign("center","middle")
	self:addChild(uiCamp2Name)
	REL:relOther(uiCamp2Name,uiCamp2Back,48,2,2,44)
	self.uiCamp2Name=uiCamp2Name

	--	uiCamp2Name:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiCamp2Name:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiCamp2Name:setBackGroundColorOpacity(100)

	--阵营2等级
	local uiCamp2LV=XMLLabel()
	uiCamp2LV:setAlign("center","middle")
	self:addChild(uiCamp2LV)
	REL:relOther(uiCamp2LV,uiCamp2Back,172,2,50,12)
	self.uiCamp2LV=uiCamp2LV

	--	uiCamp2LV:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiCamp2LV:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiCamp2LV:setBackGroundColorOpacity(100)

	--"vs"图标
	local uiVSIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightVSIcon.png"))
	self:addChild(uiVSIcon)
	REL:toOther("center","top",uiVSIcon,self,0,6)
	self.uiVSIcon=uiVSIcon

	--当前回合
	local uiRound=XMLLabel(Language:get("ug405",0,self.MAX_ROUND))
	uiRound:setAlign("center","middle")
	uiRound:setContentSize(cc.size(140,36))
	self:addChild(uiRound)
	REL:toScreen("center","top",uiRound,0,62)
	self.uiRound=uiRound

	--	uiRound:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiRound:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiRound:setBackGroundColorOpacity(100)

	--阵营分割线(用九格缩放在真机上显示有问题)
	local uiCampSepLine=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightSepLine.png"))
	self:addChild(uiCampSepLine)
	REL:relRect(uiCampSepLine,cc.rect(0,0,832,uiCampSepLine:getContentSize().height),0,0,0,0)
	uiCampSepLine:setAnchorPoint(cc.p(0.5,0.5))
	uiCampSepLine:setRotation(self.FightCfg.SEP_ROTATION)
	REL:toOther("center","middle",uiCampSepLine,self,0,0)
	self.uiCampSepLine=uiCampSepLine
end

function T:setFightType(fightType)
	self.fightType=fightType

	--第一场战斗不允许跳过
	if fightType == FightType.FIGHT_TYPE_FIRST then
		self.uiSkipFightButton:setVisible(false)
	else
		self.uiSkipFightButton:setVisible(true)
	end
end

--- 初始化玩家信息
function T:setPlayerInfo(name1,level1,name2,level2)
	if not name1 or string.trim(name1) == "" then
		name1=Language:get("ug403")
	end
	self.uiCamp1Name:setString(name1)
	self.uiCamp1LV:setString(Language:get("ug404",level1 or 0))

	if not name2 or string.trim(name2) == "" then
		name2=Language:get("ug403")
	end
	self.uiCamp2Name:setString(name2)
	self.uiCamp2LV:setString(Language:get("ug404",level2 or 0))
end

--- 创建阵营buff列表
function T:createPropBuffList(buffCode,camp)
	--阵营1道具buff
	local i,offsetX,t=0,2,80
	for k,v in ipairs(self.PropBuff_temp) do
		if BIT:_and(buffCode,BIT:_ls(1,v.bitShift)) > 0 then
			local p=Prop_temp[v.propId]
			if p then
				local uip = ccui.ImageView:create(IconManager.iconPath..p.propIcon,ccui.TextureResType.localType)
				self:addChild(uip)
				local s=uip:getContentSize()
				uip:setScale(50/s.width)
				REL:toOther(camp == Camp.CAMP1 and "left" or "right","top",uip,self,offsetX,t)

				BaseButton:extend(uip)
				uip.touchBeganSound=SoundRes.NONE
				uip:addTouchEventListener(function(t, e)
					if e == ccui.TouchEventType.ended then
						local itemInfoCvs=ItemPopInfo.new(
							p.propIcon,
							Language:get(p.prop),
							nil,
							PlayerInstance:getPropDescripe(p.propSid)
						)

						MUIAlter_noTitle.show({
							info = itemInfoCvs,
							flag = 1
						})
					end
				end)

				i=i+1
				if i % 4 == 0 then
					offsetX=2
					t=t+s.height*uip:getScaleY()
				else
					offsetX=offsetX+s.width*uip:getScaleX()
				end
			end
		end
	end
end

--- 设置道具buff code
function T:setPropBuffCode(camp1PlayerBuffCode,camp2PlayerBuffCode)
	self:createPropBuffList(camp1PlayerBuffCode,Camp.CAMP1)
	self:createPropBuffList(camp2PlayerBuffCode,Camp.CAMP2)
end

--- 设置当前的回合数
function T:setRound(round)
	self.uiRound:setString(Language:get("ug405",round,self.MAX_ROUND))
end

--- 某一阵营发起攻击
function T:attack(attackData)
--	local src=attackData.src
--	local camp=src.camp
--
--	local c1AttCount,c2AttCount=self.camp1AttackCount,self.camp2AttackCount
--
--	if
--		self.fightType == FightType.FIGHT_TYPE_CHAPTER
--		or
--		self.fightType == FightType.FIGHT_TYPE_ARENA
--	then
--		if c1AttCount >= 1 and c2AttCount >= 1 then
--			self.uiSkipFightButton:setVisible(true)
--		end
--	elseif self.fightType == FightType.FIGHT_TYPE_FIRST then
--	--第一场战斗不显示"跳过战斗"按钮
--	else
--		self.uiSkipFightButton:setVisible(true)
--	end
--
--	if camp == Camp.CAMP1 then
--		self.camp1AttackCount=c1AttCount+1
--	else
--		self.camp2AttackCount=c2AttCount+1
--	end
end

--- 某一阵营被攻击
function T:beAttack(beattack)

end

--- 播放减血飘字特效
-- @param value 减血值
-- @param worldLoc 世界坐标
-- @param camp 阵营
function T:playMinHPWordEff(value,worldLoc,camp,isCrit)
	local redBlood="-"..math.floor(value)

	--- 坐标转换
	local lLoc=self:convertToNodeSpace(worldLoc)

	local l=self.bloodWordPool:pop()
	if not l then
		l=ccui.TextBMFont:create(redBlood,"res/images/fight/number_attack_new.fnt")
		self:addChild(l)
	else
		l:setString(redBlood)
		self:addChild(l)
		l:release()
	end
	l:setScale(0.5)
	l:setPosition(lLoc)

	self:playEff(l,isCrit,function(target)
		target:setScale(1)
		target:setOpacity(255)
		target:retain()
		self.bloodWordPool:push(target)
	end)
end

function T:playMissEff(worldLoc,camp)
	--- 坐标转换
	local lLoc=self:convertToNodeSpace(worldLoc)

	local l=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("attackMiss.png"))
	l:setPosition(lLoc)
	self:playEff(l)

	self:addChild(l)
end

--- 上飘特效
function T:playEff(effSp,isCrit,completeCallback)
	local x,y=effSp:getPosition()

	effSp:runAction(cc.Sequence:create(
		isCrit
		and
		cc.Spawn:create(
			cc.MoveTo:create(0.15,cc.p(x,y+50)),
			cc.ScaleTo:create(0.15,1.25)
		)
		or
		cc.Spawn:create(
			cc.MoveTo:create(0.15,cc.p(x,y+50)),
			cc.ScaleTo:create(0.15,0.75)
		)
		,
		cc.MoveTo:create(0.6,cc.p(x,y+75)),
		cc.Spawn:create(
			cc.MoveTo:create(0.3,cc.p(x,y+165)),
			cc.FadeTo:create(0.3,0)
		),
		cc.CallFunc:create(function(target)
			target:removeFromParent()
			if completeCallback then
				completeCallback(target)
			end
		end)
	))
end

return T
