--- 战场演播层
local T = Class.FightPlayLayer(function() return ccui.Layout:create() end)

--- 阵营1演播器
T.Camp1PlayContainer=require("src.app.uiScript.components.fight.Camp1PlayContainer")

--- 阵营2演播器
T.Camp2PlayContainer=require("src.app.uiScript.components.fight.Camp2PlayContainer")

--- 攻击特效列表
T.AttackEffectList=require("src.app.uiScript.components.fight.attackEffects.AttackEffectList")

function T:def()
--- 阵营1演播器
--self.uiCamp1Player=nil

--- 阵营2演播器
--self.uiCamp2Player=nil
end

--- 构造函数
function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	REL:relScreen(self,0,0,0,0)

	local uiCamp1Player=self.Camp1PlayContainer()
	self:addChild(uiCamp1Player)
	self.uiCamp1Player=uiCamp1Player

	local uiCamp2Player=self.Camp2PlayContainer()
	self:addChild(uiCamp2Player)
	self.uiCamp2Player=uiCamp2Player
end

--- 初始化战机列表
function T:initAircrafts(camp1Aircrafts,camp2Aircrafts)
	self.uiCamp1Player:setCampData({
		camp=Camp.CAMP1,
		aircrafts=camp1Aircrafts
	})

	self.uiCamp2Player:setCampData({
		camp=Camp.CAMP2,
		aircrafts=camp2Aircrafts
	})
end

--- 攻击
function T:attack(attackData)
    local src=attackData.src
	T.AttackEffectList:getBulletEffect(src.attackEffName):playAttackEff(attackData)
end

--- 被攻击
function T:beAttack(beAttackData)
    local src=beAttackData.src
	T.AttackEffectList:getBulletEffect(src.attackEffName):playBeAttackEff(beAttackData)
end

return T
