--- 战机数量显示对象
local T=Class.FormLocCountBox(function()return cc.Node:create()end)

local greeceNumStr=Language:get("greece_num")
if greeceNumStr then
	--- 希腊数字列表
	T.GREECE_NUMS=StringUtils.split(greeceNumStr,",")
end

function T:def()
--- 所属阵营
-- camp

--- 战机等级
-- lv

--- 战机数据
-- count

--- 背景
-- uiBack

--- 战机等级
-- uiLv

--- 战机数量
-- uiCount
end

--- 构造函数
function T:ctor(camp)
	self.camp=camp

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)

	self:init()
end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	local uiBack=cc.Sprite:create()
	self:addChild(uiBack,200)
	self.uiBack=uiBack

	local uiLv=XMLLabel()
	uiLv:setFontSize(20)
	uiLv:setAlign("center","middle")
	uiLv:setContentSize(cc.size(24,36))
	self:addChild(uiLv,201)
	self.uiLv=uiLv

	--	uiLv:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiLv:setBackGroundColor(cc.c3b(random(0,255),0,0))
	--	uiLv:setBackGroundColorOpacity(100)

	local uiCount=XMLLabel()
	uiCount:setFontSize(18)
	uiCount:setAlign("center","middle")
	uiCount:setAnchorPoint(0.5,0.5)
	self:addChild(uiCount,202)
	self.uiCount=uiCount
	self:updateCountBox()

	--	uiCount:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiCount:setBackGroundColor(cc.c3b(random(0,255),0,0))
	--	uiCount:setBackGroundColorOpacity(100)
end

--- 更新数量框
function T:updateCountBox()
	local uiBack,uiLv,uiCount=self.uiBack,self.uiLv,self.uiCount
	if self.camp == Camp.CAMP1 then
		uiBack:setSpriteFrame(ResLoader:getSpriteFrame("camp1Count_back.png"))
		uiBack:setPosition(30,50)
	else
		uiBack:setSpriteFrame(ResLoader:getSpriteFrame("camp2Count_back.png"))
		uiBack:setPosition(-50,40)
	end
	REL:toOther("left","middle",uiLv,uiBack,8,0)
	REL:relOther(uiCount,uiBack,32,10,0,0)
end

--- 更新视图
function T:updateView()
	self:updateCountBox()

	local lv,uiLv=self.lv or 1,self.uiLv
	local lvValue=tostring(lv)
	if self.GREECE_NUMS and self.GREECE_NUMS[lv] then
		lvValue=self.GREECE_NUMS[lv]
	end
	uiLv:setString(lvValue)

	local uiCount=self.uiCount
	uiCount:setString(tostring(self.count))

	if self.needShowEff then
		uiCount:runAction(cc.Sequence:create(
			cc.ScaleTo:create(0.1,2),
			cc.ScaleTo:create(0.2,1)
		))
	end
end

--- 设置战机数据
function T:setAircraftData(camp,lv,count)
	if camp ~= self.camp or lv ~= self.lv or count ~= self.count then
		if self.count ~= nil then
			self.needShowEff=true
		end

		self.camp,self.lv,self.count=camp,lv,count

		self:updateView()
	end
end

--- 获取战机数据
function T:getAircraftData()
	return self.camp,self.count
end

return T
