--- 战机模型抽象类
local T=Class.AbstractAircraftModel(
	function()
		return cc.Node:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 阵营
	-- _camp
end

function T:ctor(camp)
	AbstractUI.ctor(self)

	self._camp=camp or Camp.CAMP1
end

--- 死亡
function T:act_die()
	self:removeAllChildren()

	--战机被摧毁了
	AudioManager:playEffect(SoundRes.FSND_COMM_AIRCRAFT_DEAD)

	local uiPieces=ResLoader:createAnimationSpriteRunOnce("aircraftPieces")
	uiPieces:setScale(2)
	self:addChild(uiPieces,200)
	if self._camp == Camp.CAMP1 then
		uiPieces:setRotation(180)
		uiPieces:setPosition({x=-150,y=-130})
	else
		uiPieces:setRotation(0)
		uiPieces:setPosition({x=150,y=130})
	end

	self.uiPieces=uiPieces

	local uiExp=cc.Sprite:create()
	uiExp:setScale(2)
	local animation=ResLoader:getAnimation("aircraftBoom")
	if animation then
		uiExp:runAction(cc.Sequence:create(
			cc.Animate:create(animation),
			cc.CallFunc:create(function(t)
				self:removeFromParent()
			end)
		))
	end

	self:addChild(uiExp,200)
	self.uiExp=uiExp
end

--- 获取炮火发射挂载点列表
function T:getFireMountPoints()
	return {
		{x=0,y=0}
	}
end

--- 获取导弹发射持载点的索引
function T:getFireMountChildIndex()
	return 50
end

--- 获取中弹点列表
function T:getHitPoints()
	return {
		{x=0,y=0},
		{x=10,y=0},
		{x=-10,y=0},
		{x=0,y=10},
		{x=0,y=-10},
		{x=10,y=10},
		{x=-10,y=-10},
		{x=10,y=-10},
	}
end

return T
