--- [静态]坐标定位器
local uiLocer=nil

--- 初始化坐标定位器
local function initLocer()
	local ui=ccui.Layout:create()
	ui:retain()
	ui:setContentSize(cc.size(1,1))
	uiLocer=ui
end
initLocer()

local T=Class.AbstractATKEff()

--- 战斗配置
T.FCfg=require("src.app.configs.FightCfg")

--- 对象池
T.pool=require("src.frameworks.base.Pool")()

--- 菜单显示层
--T.uiMenuLayer=nil

--- 阵营1的相关图层
T.camp1UIs={
	--- 阵营容器
	--uiCampContainer=nil,
	--- 背景显示层
	--uiBackLayer=nil,
	--- 底层特效显示层
	--uiBottomEffectLayer=nil,
	--- 战机阵位显示层
	--uiFormLocsLayer=nil,
	--- 顶层特效显示层
	--uiTopEffectLayer=nil,
	}

--- 阵营2的相关图层
T.camp2UIs={
	--- 阵营容器
	--uiCampContainer=nil,
	--- 背景显示层
	--uiBackLayer=nil,
	--- 底层特效显示层
	--uiBottomEffectLayer=nil,
	--- 战机阵位显示层
	--uiFormLocsLayer=nil,
	--- 顶层特效显示层
	--uiTopEffectLayer=nil,
	}

function T:def()
	--- 攻击挂载点之间的间隔
	self.attactIntervalInMount={0.1,0.2}
end

--- 菜单显示层
-- @param uiMenuLayer 菜单显示层
function T:setStaticUiMenuLayer(uiMenuLayer)
	self.uiMenuLayer=uiMenuLayer
end
--- 菜单显示层
function T:getStaticUiMenuLayer()
	return self.uiMenuLayer
end

--- 阵营1的相关图层
-- @param uiCampContainer 阵营容器
-- @param uiBackLayer 背景显示层
-- @param uiBottomEffectLayer 底层特效显示层
-- @param uiFormLocsLayer 战机阵位显示层
-- @param uiTopEffectLayer 顶层特效显示层
function T:setStaticCamp1UIs(uiCampContainer,uiBackLayer, uiBottomEffectLayer, uiFormLocsLayer, uiTopEffectLayer)
	self.camp1UIs={
		uiCampContainer=uiCampContainer,
		uiBackLayer=uiBackLayer,
		uiBottomEffectLayer=uiBottomEffectLayer,
		uiFormLocsLayer=uiFormLocsLayer,
		uiTopEffectLayer=uiTopEffectLayer
	}
end
--- 阵营1的相关图层
function T:getStaticCamp1UIs()
	return self.camp1UIs
end

--- 阵营2的相关图层
-- @param uiCampContainer 阵营容器
-- @param uiBackLayer 背景显示层
-- @param uiBottomEffectLayer 底层特效显示层
-- @param uiFormLocsLayer 战机阵位显示层
-- @param uiTopEffectLayer 顶层特效显示层
function T:setStaticCamp2UIs(uiCampContainer,uiBackLayer, uiBottomEffectLayer, uiFormLocsLayer, uiTopEffectLayer)
	self.camp2UIs={
		uiCampContainer=uiCampContainer,
		uiBackLayer=uiBackLayer,
		uiBottomEffectLayer=uiBottomEffectLayer,
		uiFormLocsLayer=uiFormLocsLayer,
		uiTopEffectLayer=uiTopEffectLayer
	}
end
--- 阵营2的相关图层
function T:getStaticCamp2UIs()
	return self.camp2UIs
end

--- 获取指定的战机
-- --@param camp 阵营
--@param loc 位置
function T:getFormLoc(camp,loc)
	local uiFormLocsLayer=camp == Camp.CAMP1 and self.camp1UIs.uiFormLocsLayer or self.camp2UIs.uiFormLocsLayer
	return uiFormLocsLayer:getFormLoc(loc)
end

--- 获取战机相对于指定的容器的坐标
--@param camp 阵营
--@param loc 位置
--@param container 容器
function T:getAircaraftCoordinate(camp,loc,container)
	local uiLocer=uiLocer
	uiLocer:retain()
	uiLocer:removeFromParent()

	container:addChild(uiLocer)
	uiLocer:release()

	local p
	if camp == Camp.CAMP1 then
		p=self.FCfg.AIRCRAFT_LOCS_CAMP_1[loc]
	else
		p=self.FCfg.AIRCRAFT_LOCS_CAMP_2[loc]
	end
	REL:toScreen("center","middle",uiLocer,p.x,p.y)

	return uiLocer:getPosition()
end

--- 播放攻击特效
-- @param 攻击数据
function T:playAttackEff(attackData)
	local src=attackData.src
	local srcCamp=src.camp
	local campUIs = srcCamp == Camp.CAMP1 and self.camp1UIs or self.camp2UIs

	--战机阵位
	local fLoc=campUIs.uiFormLocsLayer:getFormLoc(src.loc)
	if fLoc then
		--根据战机模型获取武器挂载点
		local aModel=fLoc:getAircaftModel()
		if aModel then
			local mPts=aModel:getFireMountPoints()

			--每隔100至200毫秒发射
			local i,len=1,#mPts
			local delayFunc
			delayFunc=function()
				campUIs.uiCampContainer:timeout(function()
					self:_playAttackEffect(srcCamp, aModel, mPts[i])

					i=i+1
					if i <= len then
						delayFunc()
					end
				end,randomFloat(self.attactIntervalInMount[1],self.attactIntervalInMount[2]))
			end
			delayFunc()
		end
	end
end

--- 播放被攻击数据
-- @param hitData 被攻击数据
function T:playBeAttackEff(hitData)
	local desList = hitData.desList
	local firstDes = desList[1]
	local campUIs = firstDes.camp == Camp.CAMP1 and self.camp1UIs or self.camp2UIs

	--每隔 X 毫秒攻击一个对象
	local i, c = 1, #desList
	local delayAct
	delayAct=campUIs.uiCampContainer:interval(function()
		self:_playBeAttackEff(desList[i])

		i = i + 1
		if i > c then
			campUIs.uiCampContainer:clearScheduler(delayAct)
		end
	end,0.2)
end

return T
