local AbstractGroundGrid=require("src.frameworks.cocos.ui.ground.AbstractGroundGrid")

--- 海面网格
local T=Class.CloudGrid(
	function()
		return cc.Node:create()
	end,
	AbstractGroundGrid
)

function T:def()
	AbstractGroundGrid.def(self)

	--- 单元格背景对象池
	self.cellBackPool = Stack()

	--- 网格数据
	self._cellsData={
		{{},},
	}
	self._colCount,self._rowCount=1,1
end

--- 构造函数
-- @param visibleRect 可见区域
-- @param cellSize 单元格尺寸
function T:ctor(visibleRect,cellSize)
	AbstractGroundGrid.ctor(self,visibleRect,{width=612,height=612})
end

--- 显示单元格
-- @param cell
-- @return cell
function T:_showCell(cell)
	cell.isShow=true

	local x,y=cell.x,cell.y
	local els={}

	local uiBack=self.cellBackPool:pop()
	if not uiBack then
		uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("cloudTest.png"))
		uiBack:setAnchorPoint(cc.p(0.5, 0.5))
		uiBack:setScale(4)
		self:addChild(uiBack)
	end
	uiBack:setPosition((x + 0.5) * self._cellSize.width, (y + 0.5) * self._cellSize.height)
	uiBack:setRotation(random(0,360))

	els.uiBack=uiBack
	cell.elements=els

	return cell
end

--- 隐藏单元格
-- @param cell
-- @return cell
function T:_hideCell(cell)
	cell.isShow=false

	local els=cell.elements
	if els then
		local uiBack=els.uiBack
		if uiBack then
			self.cellBackPool:push(uiBack)

			--			uiBack:removeFromParent()
			--			uiBack:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
			--			uiBack:setBackGroundColor(cc.c3b(random(100,255),0,0))
			--			uiBack:setBackGroundColorOpacity(255)

			els.uiBack=nil
		end
	end

	return cell
end

return T
