--- 地面特效播放器
local T=Class.CloudPlayer(function()
	return cc.Node:create()
end)

--- 战场配置
T.FightCfg=require("src.app.configs.FightCfg")

--- 最大云彩数量
T.MAX_COUNT=3

--- 云彩帧名列表
T.cloudFrameNames={
	"cloud1_top.png"
}

function T:def()
--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	self:setBackGroundColor(cc.c3b(0xff,0,0))
--	self:setBackGroundColorOpacity(100)
end

function T:ctor(cloudFrameNames)
	if cloudFrameNames then
		self.cloudFrameNames=cloudFrameNames
	end

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)
end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()
end

--- 内存清理
function T:cleanUp()

end

function T:playCloudEff()
	local resName=self.cloudFrameNames[random(1,#self.cloudFrameNames)]
	local eff=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame(resName))
	eff:setRotation(-self.FightCfg.SEP_ROTATION + (self.camp == Camp.CAMP1 and 180 or 0))
	eff:setScale(random(7,13)/10+4)
	self:addChild(eff)
	eff:setAnchorPoint(cc.p(0.5,0.5))

	local cS=self:getContentSize()
	local eS=eff:getContentSize()
	local eh=eS.height*eff:getScaleY()

	local sX,sY=random(-200,cS.width),isYRandom and random(-eh,cS.height+eh) or -eh
	local eX,eY=sX+(cS.height+eh*2)*0.4,cS.height+eh

	eff:setPosition(sX,sY)
	local mt=cc.MoveTo:create(1+random(1,2),cc.p(eX,eY))
	eff:runAction(cc.Sequence:create(
		mt,
		cc.CallFunc:create(function(target)
			target:removeFromParent()

			self:playCloudEff()
		end)
	))
end

function T:play()
	for i=1,self.MAX_COUNT,1 do
		self:playCloudEff(true)
	end
end

return T
