--- 战斗失败后的结果界面
local T=Class.FailCvs(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 提升项
T.UpgradeIcon=require("src.app.uiScript.components.fight.fightEnd.UpgradeIcon")

function T:def()
	AbstractUI.def(self)
end

function T:ctor(fightType,fightEndData,hasNeedFixAircaft,callback,originalFightType)
	self.fightType=fightType
	self.fightEndData=fightEndData
	self.hasNeedFixAircaft=hasNeedFixAircaft
	self.callback=callback
	self.originalFightType=originalFightType

	AbstractUI.ctor(self)

	self:_init()
end


--- 进入
function T:onEnter()
	AbstractUI.onEnter(self)

	AudioManager:playEffect(SoundRes.FSND_FIGHT_LOSE)
end

--- 退出
function T:onExit()
	AbstractUI.onExit(self)

	if self.callback then
		local call=self.callback
		local arg=self.toWindowStr
		Cocos2dxUtils:timeOut(function()
			call(arg)
		end,0)
	end
end

function T:_init()
	local fightEndData=self.fightEndData

	local f=ResLoader:getSpriteFrame("fightEndBack.png")
	local fs=f:getOriginalSize()
	self:setContentSize(cc.size(fs.width,fs.height+100))

	--背景
	local uiBack=Scale9Sprite:createWithFrame(f,cc.rect(0,272,fs.width,1))
	self:addChild(uiBack)
	REL:relOther(uiBack,self,0,0,0,0)
	self.uiBack=uiBack

	-- 关闭按钮
	local uiCloseButton=BaseButton:createButton(nil,"alterCoseButton_normal.png")
	self:addChild(uiCloseButton)
	REL:toOther("right","top",uiCloseButton,self,20,10)
	self.uiCloseButton=uiCloseButton

	uiCloseButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self.__hide__()
		end
	end)

	--失败图标
	local uiVictoryIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightFailIcon.png"))
	self:addChild(uiVictoryIcon)
	REL:toOther("left","top",uiVictoryIcon,self,190,118)
	self.uiVictoryIcon=uiVictoryIcon

	local myAircraftCount,enAircraftCount=0,0
    local camps=fightEndData.camps
	if camps then
		local camp1,camp2=camps.camp1,camps.camp2
		for _,v in pairs(camp1.aircrafts) do
			myAircraftCount=myAircraftCount+(v and v.count or 0)
		end
		for _,v in pairs(camp2.aircrafts) do
			enAircraftCount=enAircraftCount+(v and v.count or 0)
		end
	end

	--我方出战战机数量
	local uiMyAircraftNum=XMLLabel(Language:get("ug422",myAircraftCount))
	uiMyAircraftNum:setAlign("left","middle")
	uiMyAircraftNum:setContentSize(cc.size(350,36))
	self:addChild(uiMyAircraftNum)
	REL:toOther("right","top",uiMyAircraftNum,self,42,76)


	--敌方出战战机数量
	local uiEnAircraftNum=XMLLabel(Language:get("ug423",enAircraftCount))
	uiEnAircraftNum:setAlign("right","middle")
	uiEnAircraftNum:setContentSize(cc.size(350,36))
	self:addChild(uiEnAircraftNum)
	REL:toOther("right","top",uiEnAircraftNum,self,42,230)

	--星级图标列表背景
	local uiStarBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightFailDec.png"))
	self:addChild(uiStarBack)
	REL:toOther("center","top",uiStarBack,uiBack,6,1)

	-- 小秘书
	local uiSecretary=SecretaryGenerator:getBust("susy_clothing_2",cc.rect(0,0,388,554),1)
	uiSecretary:setScale(0.5)
	self:addChild(uiSecretary)
	REL:toOther("left","top",uiSecretary,self,6,-20)

	-- "回放"按钮
	local uiReplayButton=BaseButton:createButton(Language:get("ug421"),"fightAwardCaptionBack.png")
	self:addChild(uiReplayButton)
	REL:toOther("left","bottom",uiReplayButton,uiSecretary,0,-18)
	self.uiReplayButton=uiReplayButton
	uiReplayButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self.toWindowStr="toReplay"
			self.__hide__()
		end
	end)
	
	if BGMgr:isGuide() then
		uiReplayButton:setIsGray(true)
		uiReplayButton:setTouchEnabled(false)
	end

--	-- 奖励标题背景
--	local uiAwardCapBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightAwardCaptionBack.png"))
--	self:addChild(uiAwardCapBack)
--	uiAwardCapBack:setIsGray(true)
--	REL:toOther("left","bottom",uiAwardCapBack,uiSecretary,0,-18)
--
--	-- 奖励标题
--	local uiAwardCap=XMLLabel(Language:get("ug431"))
--	uiAwardCap:setAlign("center","middle")
--	self:addChild(uiAwardCap)
--	REL:relOther(uiAwardCap,uiAwardCapBack,0,0,0,0)

	-- 战力提升提示
	local uiUpgradeTip=XMLLabel(Language:get("ug424"))
	uiUpgradeTip:setAlign("left","middle")
	uiUpgradeTip:setContentSize(cc.size(520,36))
	self:addChild(uiUpgradeTip)
	REL:toOther("left","top",uiUpgradeTip,self,20,272)

	--提升项列表
	local c=self.hasNeedFixAircaft and #self.UpgradeIcon.UPGRADE_DATAS or #self.UpgradeIcon.UPGRADE_DATAS-1
	local INTERVAL,w=20,self.UpgradeIcon.SIZE.width
	local offset=(c*(w+INTERVAL)+INTERVAL)/2
	for i=1,c,1 do
		local upgradeIcon=self.UpgradeIcon(i)
		self:addChild(upgradeIcon)
		REL:toOther("center","top",upgradeIcon,self,(i-1)*(w + INTERVAL)+INTERVAL+w/2-offset,272+36+10)

		BaseButton:extend(upgradeIcon)
		upgradeIcon:addTouchEventListener(function(t,e)
			if e == ccui.TouchEventType.ended then
				self.toWindowStr=t:get2string()
				self.__hide__()
			end
		end)
	end
end

--- 更新奖励列表项
function T:updateAwardItemList(awardData)
	if not awardData then
		return
	end
	self.AwardDataDecoder:addAWard(awardData)

	local uiC=self.uiAwardContainer

	local uiList=self.AwardDataDecoder:award2LayoutList(awardData)
	local w,h=self.AwardDataDecoder:arrangeInLayout(uiList,uiC:getInnerContainer())

	if h >= 480 then
		uiC:setContentSize(cc.size(uiC:getContentSize().width,480))
	else
		uiC:setContentSize(cc.size(uiC:getContentSize().width,h))
	end
end

return T
