local T=Class.UpgradeIcon(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 提升数据列表
T.UPGRADE_DATAS={
	[1]={icon="icon_parts.png",name="ug425",str="toParts"},
	[2]={icon="icon_tech.png",name="ug426",str="toUpgradeScence"},
	[3]={icon="icon_aircraft.png",name="ug427",str="toProduceAircraft"},
	[4]={icon="icon_command.png",name="ug428",str="toUpgradeCommand"},
	[5]={icon="icon_skill.png",name="ug429",str="toUpgradeSkill"},
	[6]={icon="icon_aircraftFix.png",name="ug430",str="toFixAircraft"},
}

T.SIZE={width=74,height=106}

function T:def()
	AbstractUI.def(self)
end

function T:ctor(upgradeId)
	self.upgradeId=upgradeId

	AbstractUI.ctor(self)

	self:_init()
end

function T:_init()
	self:setContentSize(self.SIZE)

	local data=self.UPGRADE_DATAS[self.upgradeId or 1]
	if data then
		local uiIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame(data.icon))
		self:addChild(uiIcon)
		REL:toOther("center","top",uiIcon,self,0,0)
		
		local uiName=XMLLabel(Language:get(data.name))
		uiName:setFontSize(18)
		uiName:setIsSingleLine(true)
		uiName:setAlign("center","middle")
		self:addChild(uiName)
		REL:relOther(uiName,self,-20,-20,SIZE_NIL,0)
	end
end

function T:get2string()
	local data=self.UPGRADE_DATAS[self.upgradeId or 1]
	return data and data.str or ""
end

return T
