--- 战斗胜利后的结果界面
local T=Class.VictoryCvs(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 奖励数据解析器
T.AwardDataDecoder=require("src.app.communication.award.AwardDataDecoder")

--- 小提示信息列表
T.TIPS={
	"ug441"
}

function T:def()
	AbstractUI.def(self)
end

function T:ctor(fightType,fightEndData,hasNeedFixAircaft,callback,originalFightType)
	self.fightType=fightType
	self.fightEndData=fightEndData
	self.hasNeedFixAircaft=hasNeedFixAircaft
	self.callback=callback
	self.originalFightType=originalFightType

	AbstractUI.ctor(self)

	self:_init()
end

--- 进入
function T:onEnter()
	AbstractUI.onEnter(self)

	AudioManager:playEffect(SoundRes.FSND_FIGHT_WIN)
end

--- 退出
function T:onExit()
	AbstractUI.onExit(self)

	if self.callback then
		local call=self.callback
		local arg=self.toWindowStr
		Cocos2dxUtils:timeOut(function()
			call(arg)
		end,0)
	end
end

function T:_init()
	local fightEndData=self.fightEndData

	local f=ResLoader:getSpriteFrame("fightEndBack.png")
	local fs=f:getOriginalSize()

	--背景
	local uiBack=Scale9Sprite:createWithFrame(f,cc.rect(0,272,fs.width,1))
	self:addChild(uiBack)
	self.uiBack=uiBack

	--奖励列表项容器
	local uiAwardC=ccui.ScrollView:create()
	uiAwardC:setTouchEnabled(true)
	self:addChild(uiAwardC)
	REL:relOther(uiAwardC,uiBack,10,10,272,SIZE_NIL)
	self.uiAwardContainer=uiAwardC
	self:updateAwardItemList(fightEndData.awardData)

	local w,h=fs.width,fs.height
	local awardsH=uiAwardC:getContentSize().height
	if self.hasNeedFixAircaft then
		h=awardsH+272+10+46+96+40 -- 46为提示文本高,96为战机修理信息高,10为下边框高
	else
		h=awardsH+272+10+46+40
	end
	self:setContentSize(cc.size(w,h > fs.height and h or fs.height))
	REL:relOther(uiBack,self,0,0,0,0)

	-- 更新奖励列表位置
	REL:toOther("center","top",uiAwardC,uiBack,0,272)

	-- 关闭按钮
	local uiCloseButton=BaseButton:createButton(nil,"alterCoseButton_normal.png")
	self:addChild(uiCloseButton)
	REL:toOther("right","top",uiCloseButton,self,20,10)
	self.uiCloseButton=uiCloseButton

	uiCloseButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self.__hide__()
            Cocos2dxUtils:timeOut(function()
                local playerLvlDiff = PlayerInstance:getPlayerLvlDiff()
                if playerLvlDiff == true then
                    local layout = require("src.app.uiScript.components.share.PlayerLvlUpPopWindow").new()
	                local muialter = MUIAlter.show(
		                {
			                title = Language:get("uc930"),
			                info = layout,
			                flag = 4,
                            isShowCloseButton = true,
			                callback = function(flag)
			                end
		                }
	                )
	                layout:setMuialter(muialter)
                end
            end,0.5)

		end
	end)

	--旋转光束
	local uiXuanZhanGuangShu=ResLoader:createAnimationSprite("xuanzhuanguangshu")
	uiXuanZhanGuangShu:setScale(2)
	self:addChild(uiXuanZhanGuangShu)
	self.uiVictoryIcon=uiXuanZhanGuangShu

	--胜利图标
	local uiVictoryIcon=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightVictoryIcon.png"))
	self:addChild(uiVictoryIcon)
	REL:toOther("left","top",uiVictoryIcon,self,190,118)
	self.uiVictoryIcon=uiVictoryIcon

	uiXuanZhanGuangShu:setAnchorPoint(cc.p(0.5,0.2))
	REL:toOther("center","bottom",uiXuanZhanGuangShu,uiVictoryIcon,0,0)

	self:timeout(function()
		--溜光
		local uiLiuGuang=ResLoader:createAnimationSpriteRunOnce("liuguang")
		self:addChild(uiLiuGuang)
		REL:toOther("center","bottom",uiLiuGuang,uiVictoryIcon,0,0)
		self.uiLiuGuang=uiLiuGuang
	end,0.4)

	local myAircraftCount,enAircraftCount=0,0
	local camps=fightEndData.camps
	if camps then
		local camp1,camp2=camps.camp1,camps.camp2
		for _,v in pairs(camp1.aircrafts) do
			myAircraftCount=myAircraftCount+(v and v.count or 0)
		end
		for _,v in pairs(camp2.aircrafts) do
			enAircraftCount=enAircraftCount+(v and v.count or 0)
		end
	end

	--我方出战战机数量
	local uiMyAircraftNum=XMLLabel(Language:get("ug422",myAircraftCount))
	uiMyAircraftNum:setAlign("left","middle")
	uiMyAircraftNum:setContentSize(cc.size(350,36))
	self:addChild(uiMyAircraftNum)
	REL:toOther("right","top",uiMyAircraftNum,self,42,76)


	--敌方出战战机数量
	local uiEnAircraftNum=XMLLabel(Language:get("ug423",enAircraftCount))
	uiEnAircraftNum:setAlign("right","middle")
	uiEnAircraftNum:setContentSize(cc.size(350,36))
	self:addChild(uiEnAircraftNum)
	REL:toOther("right","top",uiEnAircraftNum,self,42,230)

	--星级图标列表背景
	local uiStarBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightVictoryDec.png"))
	self:addChild(uiStarBack)
	REL:toOther("center","top",uiStarBack,uiBack,6,1)

	--只有章节战斗才显示星级
	if self.fightType == FightType.FIGHT_TYPE_CHAPTER
		or
		self.fightType == FightType.FIGHT_TYPE_SUPPLY_LINE
		or
		(self.fightType == FightType.FIGHT_TYPE_REPLAY and self.originalFightType == FightType.FIGHT_TYPE_CHAPTER)
	then
		local starNum=fightEndData.starNum or 1
		--星级图标列表
		local l={}
		local c,INTERVAL,w,offset=3,4,nil,nil
		for i=1,c,1 do
			local uiStarIcon
			if i <= starNum then
				uiStarIcon = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightStar_enabeled.png"))
			else
				uiStarIcon = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightStar_disabled.png"))
			end
			if not w then
				w=uiStarIcon:getContentSize().width
				offset=(c*(w+INTERVAL)+INTERVAL)/2
			end
			self:addChild(uiStarIcon)
			REL:toOther("center","top",uiStarIcon,uiStarBack,(i-1)*(w + INTERVAL)+INTERVAL+w/2-offset,-18)

			l[#l+1]=uiStarIcon
		end
		self.uiStarIconList=l
	end

	-- 小秘书
	local uiSecretary=SecretaryGenerator:getBust("susy_clothing_1",cc.rect(0,0,388,554),2)
	uiSecretary:setScale(0.5)
	self:addChild(uiSecretary)
	REL:toOther("left","top",uiSecretary,self,6,-20)

	-- "回放"按钮
	local uiReplayButton=BaseButton:createButton(Language:get("ug421"),"fightAwardCaptionBack.png")
	self:addChild(uiReplayButton)
	REL:toOther("left","bottom",uiReplayButton,uiSecretary,0,-18)
	self.uiReplayButton=uiReplayButton
	uiReplayButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self.toWindowStr="toReplay"
			self.__hide__()
		end
	end)

	if BGMgr:isGuide() then
		uiReplayButton:setIsGray(true)
		uiReplayButton:setTouchEnabled(false)
	end


	--分隔线
	local uiSep=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("sepLine_black.png"))
	self:addChild(uiSep)
	REL:relOther(uiSep,uiAwardC,0,0,SIZE_NIL,-10)
	self.uiSep=uiSep

	--有战机需要修理
	if self.hasNeedFixAircaft then
        local num = UserInfo.city.aircraftBox:getRepairNum()
		local uiFixAircraftCap=XMLLabel(Language:get("ug407",num))
		uiFixAircraftCap:setAlign("left","middle")
		uiFixAircraftCap:setHeight(72)
		self:addChild(uiFixAircraftCap)
		REL:relOther(uiFixAircraftCap,uiSep,10,130,SIZE_NIL,-86)
		self.uiFixAircraftCap=uiFixAircraftCap

		local uiToFixAircraftButton=BaseButton:createButton(Language:get("ug408"),"button_blue_normal.png","button_general_down.png")
		self:addChild(uiToFixAircraftButton)
		REL:toOther("right","middle",uiToFixAircraftButton,uiFixAircraftCap,-130,-10)
		self.uiToFixAircraftButton=uiToFixAircraftButton
		uiToFixAircraftButton:addTouchEventListener(function(t,e)
			if e == ccui.TouchEventType.ended then
				self.toWindowStr="toFixAircraft"
				self.__hide__()
			end
		end)
	end

	--小提示
	local uiTip=XMLLabel(Language:get(self.TIPS[random(1,#self.TIPS)]))
	uiTip:setAlign("center","middle")
	uiTip:setHeight(36)
	self:addChild(uiTip)
	REL:relOther(uiTip,self,10,10,SIZE_NIL,10+40)
end

--- 更新奖励列表项
function T:updateAwardItemList(awardData)
	if not awardData then
		return
	end
	if self.fightType ~= FightType.FIGHT_TYPE_REPLAY then
		self.AwardDataDecoder:addAWard(awardData)
	end

	local uiC=self.uiAwardContainer

	local uiList=self.AwardDataDecoder:award2LayoutList(awardData)
	local w,h=self.AwardDataDecoder:arrangeInLayout(uiList,uiC:getInnerContainer())

	if h >= 480 then
		uiC:setContentSize(cc.size(uiC:getContentSize().width,480))
	else
		uiC:setContentSize(cc.size(uiC:getContentSize().width,h))
	end
end

return T
