local AbstractGroundGrid=require("src.frameworks.cocos.ui.ground.AbstractGroundGrid")

--- 海面网格
local T=Class.SeaGrid(
	function()
		return cc.Node:create()
	end,
	AbstractGroundGrid
)

function T:def()
	AbstractGroundGrid.def(self)

	--- 单元格背景对象池
	self.cellBackPool = Stack()
end

--- 构造函数
-- @param visibleRect 可见区域
-- @param cellSize 单元格尺寸
function T:ctor(visibleRect,cellSize)
	AbstractGroundGrid.ctor(self,visibleRect,{width=546,height=964})
end

--- 显示单元格
-- @param cell
-- @return cell
function T:_showCell(cell)
	cell.isShow=true

	local x,y=cell.x,cell.y

	local els={}

	local uiBack=self.cellBackPool:pop()
	if not uiBack then
		uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("fightGroundCell.png"))
		uiBack:setScale(2)
		self:addChild(uiBack)
		uiBack:setAnchorPoint(cc.p(0, 0))
	end
	uiBack:setPosition(x * self._cellSize.width, y * self._cellSize.height)
	els.uiBack=uiBack

	cell.elements=els

	return cell
end

--- 隐藏单元格
-- @param cell
-- @return cell
function T:_hideCell(cell)
	cell.isShow=false

	local els=cell.elements
	if els then
		local uiBack=els.uiBack
		if uiBack then
			self.cellBackPool:push(uiBack)

			els.uiBack=nil
		end
	end

	return cell
end

return T
