--[[
 *	帮助窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(1)
        o.super = AbstractWindow
        return o
    end
)

--- tag的基础值
T.baseTag = 10000

--- 构造函数
function T:ctor()
    local alliancePath =  "buildIcon/aircraftLaboratory.png"
    self.iconTb = {AwardTypes.gems.iconUrl,PlayerInstance:getPlayerHead(2),Aircraft_temp[6].icon,Build_temp[1].icon,alliancePath,Prop_temp[105].propIcon  } 
    self.iconPage = {}
    self.pageView = {
	    require("src.app.uiScript.components.help.VIPView"),
	    require("src.app.uiScript.components.help.PlayerAttributeView"),
	    require("src.app.uiScript.components.help.BattleView"),
	    require("src.app.uiScript.components.help.BuildView"),
	    require("src.app.uiScript.components.help.AllianceView"),
	    require("src.app.uiScript.components.help.FAQView")
    }

    self:leftWidget()
    self:refreshView(1 + self.baseTag)

    self:setWindowTitle(Language:get("uc452"))
    
    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end


function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)
end

--- 左边的按钮
function T:leftWidget()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    local iconTb = self.iconTb
    for i = 1,6,1 do
        -- 背景图片
        local back = ccui.ImageView:create()
        back:loadTexture("helpTip.png",ccui.TextureResType.plistType)
        self.uiContainer:addChild(back)
        back:setTag(self.baseTag * 2 + i)
        local offset = (i - 1) * 90 + 30
        REL:toOther("left","top",back,self.uiContainer,10,offset)

        -- icon按钮
        local icon = Button.new("false","false")
        icon:setTag(self.baseTag + i)
        local iconPath = IconManager.iconPath
        
        if i == 5 or i == 4 then
            icon:setScale(68/128,68/128)
            icon:loadTextures(iconPath .. iconTb[i], iconPath .. iconTb[i], "")
        elseif i == 2 then
            icon:setScale(68/130,68/130)
            icon:loadTextures(iconTb[i], iconTb[i], "")
        else
            icon:setScale(IconManager.baseScale[1],IconManager.baseScale[2])
            icon:loadTextures(iconPath .. iconTb[i], iconPath .. iconTb[i], "")
        end
        
	    self.uiContainer:addChild(icon)
	    REL:toOther("left","middle",icon,back,20,0)

        icon:addTouchEventListener(function (sender, eventType) 
            if eventType == ccui.TouchEventType.ended then
                local tag = icon:getTag()
                self:refreshView(tag)
            end
        end)


    end
end

--- 刷新视图
function T:refreshView(tag)
    local iconPage = self.iconPage
    local pageView = self.pageView

    for i = 1,6,1 do
        local index = tag  - self.baseTag
        if i == index then
            if iconPage[i] == nil then -- 创建
                if pageView[i] then
                    iconPage[i] = pageView[i].new()
		            self:addChild(iconPage[i])
		            REL:relOther(iconPage[i],self.uiContainer,180,10,30,20)
		            iconPage[i]:init()
                end

            else
                iconPage[i]:setVisible(true)
            end
            self.uiContainer:getChildByTag(self.baseTag * 2 + i):setVisible(true)
            self.uiContainer:getChildByTag(i + self.baseTag):setTouchEnabled(false)
            self.uiContainer:getChildByTag(i + self.baseTag):setLocalZOrder(1000)

        else
            if iconPage[i] then
                iconPage[i]:setVisible(false)
            end
            self.uiContainer:getChildByTag(self.baseTag * 2 + i):setVisible(false)
            self.uiContainer:getChildByTag(i + self.baseTag):setTouchEnabled(true)
        end

    end
end




return T