--- 砖石项
local T = class("T",function() return ccui.Layout:create() end)

--- 商品数据
T.goodsData = nil

--- 构造函数
function T:ctor(goodsData)
	self.goodsData = goodsData

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	self:init()
	self:_addEvent()
	self:refreshThreeValue()
end

--- 进入
function T:onEnter()
	local threePurchaseState = SetStates.threePurchaseState
	threePurchaseState:luaAddEventListener(threePurchaseState.EVT_THREE_PURCHASE_COMPLETE,self,self.refreshThreeValue)
end

--- 退出
function T:onExit()
	local threePurchaseState = SetStates.threePurchaseState
	threePurchaseState:luaRemoveEventListener(threePurchaseState.EVT_THREE_PURCHASE_COMPLETE,self,self.refreshThreeValue)
end


--- 初始化
function T:init()
	self:setContentSize(cc.size(298,140))  -- 和背景图片一样大

	local uiBack = ccui.ImageView:create()
	uiBack:loadTexture("vipBuy.png",ccui.TextureResType.plistType)
	self:addChild(uiBack)
	REL:toOther("center","top",uiBack,self,0,0)
	self.uiBack = uiBack

	local goodsData = self.goodsData
	local iapData = goodsData.iapData
	local configData = IapGoods_temp[goodsData.configSid]

	-- icon,configData.icon
	local icon = ccui.ImageView:create()
	local iconPath = IconManager.iconPath
	icon:loadTexture(iconPath .. configData.icon)
	self:addChild(icon)
	REL:toOther("left","middle",icon,uiBack,15,0)

	-- 钻石数量
	local gemsCount = XMLLabel()
	gemsCount:setContentSize(cc.size(200,36))
	self:addChild(gemsCount)
	REL:toOther("left","top",gemsCount,icon,110,5)
	gemsCount:setString(Language:get("uc477",goodsData.gems))

	-- 花费钱
	local costMoney = XMLLabel()
	costMoney:setContentSize(cc.size(200,36))
	costMoney:setHAlign("right")
	self:addChild(costMoney)
	REL:toOther("right","top",costMoney,uiBack,20,55)
	local currencySymbol = iapData.currencySymbol
	local price = string.format("%0.2f", iapData.price)
	costMoney:setString(Language:get("uc479",currencySymbol,price))


	-- 是否优惠数字saleCheap
	if configData.saleCheap then
		local saleCheap = XMLLabel()
		saleCheap:setContentSize(cc.size(200,36))
		saleCheap:setHAlign("right")
		self:addChild(saleCheap)
		REL:toOther("right","bottom",saleCheap,uiBack,60,25)
		saleCheap:setString(Language:get("uc478",configData.saleCheap))
	end

	-- 是否促销还是实惠
	if configData.bestSellersIcon then
		--        local img = nil
		--        if configData.bestSellersIcon == 1 then
		--            img = "vipHotOrange.png"
		--        else
		--            img = "vipHotPurple.png"
		--        end
		--        local bestSellersIcon = ccui.ImageView:create()
		--        bestSellersIcon:loadTexture(img,ccui.TextureResType.plistType)
		--        self:addChild(bestSellersIcon)
		--        REL:toOther("center","bottom",bestSellersIcon,uiBack,0,13)

		if configData.bestSellersIcon == 1 then -- 促销     放到右上角

		else -- 实惠

		end

	end

	-- 合法的话才能买
	if iapData.isValid and iapData.isValid == true then
		self:setIsGray(false)
		self:setTouchEnabled(true)
	else
		self:setIsGray(true)
		self:setTouchEnabled(false)
	end
end

--- 添加响应
function T:_addEvent()
	BaseButton:extend(self)
	self:addTouchEventListener(function(s,e)
		if e == ccui.TouchEventType.ended then
			IAPMgr:pay(self.goodsData)
		end
	end
	)
end

--- 刷新3倍充值值
function T:refreshThreeValue()
	local threePurchaseState = SetStates.threePurchaseState
	local value = threePurchaseState:getTypeValue(self.goodsData.threeMarkValue)
	if value then
		if self.threeAward then
			self.threeAward:setVisible(false)
			self.bestSellersIcon:setVisible(false)
		end
	else
		if not self.threeAward then

			local bestSellersIcon = ccui.ImageView:create()
			bestSellersIcon:loadTexture("vipHotOrange.png",ccui.TextureResType.plistType)
			self:addChild(bestSellersIcon)
			REL:toOther("center","bottom",bestSellersIcon,self.uiBack,0,13)
			self.bestSellersIcon = bestSellersIcon


			local threeAward = XMLLabel()
			threeAward:setContentSize(cc.size(200,36))
			threeAward:setAlign("left","midddle")
			self:addChild(threeAward)
			REL:toOther("left","middle",threeAward,bestSellersIcon,10,-5)
			threeAward:setString(Language:get("uc559"))
			self.threeAward = threeAward

		else
			self.threeAward:setVisible(true)
			self.bestSellersIcon:setVisible(true)
		end
	end

end



return T
