--- 购买钻石view
local T = class("T",function() return ccui.Layout:create() end)

--- 钻石项
T.GemsItem = require("src.app.uiScript.components.iap.GemsItem")

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


--- 构造函数
function T:ctor()

end

function T:init()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	self:initTop()
	self:initBottom()
	self:refreshAward()

end

--- 进入
function T:onEnter()
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.vipPoint,self,self.refreshVipData)

	local firstRechargeInfo = ActivityManager.firstRechargeInfo
	firstRechargeInfo:luaAddEventListener(firstRechargeInfo.EVT_FIRST_RECHARGE_REFRESH,self,self.refreshAward)


end

--- 退出
function T:onExit()
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.vipPoint,self,self.refreshVipData)

	local firstRechargeInfo = ActivityManager.firstRechargeInfo
	firstRechargeInfo:luaRemoveEventListener(firstRechargeInfo.EVT_FIRST_RECHARGE_REFRESH,self,self.refreshAward)


end

--- 初始化上面
function T:initTop()
	-- 背景图片
	local topBackFrame = ResLoader:getSpriteFrame("vipBottomFrame.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	topBack:setContentSize(632,148)
	self:addChild(topBack)
	REL:toOther("center","top",topBack,self,0,0)

	-- vip图片
	local vipImg = ccui.ImageView:create()
	vipImg:loadTexture("vip.png",ccui.TextureResType.plistType)
	self:addChild(vipImg)
	REL:toOther("left","top",vipImg,topBack,20,25)

	-- vip等级:后面换成字体
	--    local vipLevel = XMLLabel()
	--    vipLevel:setContentSize(cc.size(150,36))
	--    vipLevel:setVAlign("middle")
	--    self:addChild(vipLevel)
	--    REL:toOther("left","middle",vipLevel,vipImg,55,0)
	--    self.vipLevel = vipLevel

	local vipLevel = ccui.TextBMFont:create(1,"res/images/activity/vipFont.fnt")
	self:addChild(vipLevel)
	REL:toOther("left","middle",vipLevel,vipImg,55,-8)
	self.vipLevel = vipLevel


	-- vip进度条
	local backImg = ccui.ImageView:create()
	backImg:loadTexture("vipBottomBack.png",ccui.TextureResType.plistType)
	self:addChild(backImg)
	REL:toOther("left","middle",backImg,vipImg,90,0)
	self.backImg = backImg


	local uiProgressFore = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("vipBottomBack2.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	backImg:addChild(uiProgressFore)
	REL:toOther("center","middle",uiProgressFore,backImg,0,0)
	self.uiProgressFore = uiProgressFore

	-- vip经验数字背景图片
	local vipDigitalImgFrame = ResLoader:getSpriteFrame("timeBack.png")
	local vipDigitalImgSize = vipDigitalImgFrame:getOriginalSize()
	local vipDigitalImg = Scale9Sprite:createWithFrame(vipDigitalImgFrame,cc.rect(vipDigitalImgSize.width/2,vipDigitalImgSize.height/2,1,1))
	vipDigitalImg:setContentSize(90,25)
	self:addChild(vipDigitalImg)
	REL:toOther("center","middle",vipDigitalImg,backImg,0,0)
	self.vipDigitalImg = vipDigitalImg

	-- vip数字
	local vipdigital = XMLLabel()
	vipdigital:setContentSize(cc.size(200,36))
	vipdigital:setAlign("center","middle")
	self:addChild(vipdigital)
	REL:toOther("center","middle",vipdigital,vipDigitalImg,0,0)
	self.vipdigital = vipdigital

	local LanguageUtils=require("src.app.utils.LanguageUtils")
	if LanguageUtils:getId() == cc.LANGUAGE_CHINESE or LanguageUtils:getId() == cc.LANGUAGE_CHINESE_HANT then
		-- vip描述1
		local vipDescribe1 = XMLLabel()
		vipDescribe1:setContentSize(cc.size(400,36))
		vipDescribe1:setAlign("center","middle")
		self:addChild(vipDescribe1)
		REL:toOther("center","bottom",vipDescribe1,topBack,-80,40)
		self.vipDescribe1 = vipDescribe1

		-- vip描述2
		local vipDescribe2 = XMLLabel()
		vipDescribe2:setContentSize(cc.size(400,36))
		vipDescribe2:setAlign("center","middle")
		self:addChild(vipDescribe2)
		REL:toOther("center","top",vipDescribe2,vipDescribe1,0,25)
		vipDescribe2:setString(Language:get("uc474"))
		self.vipDescribe2 = vipDescribe2

	else
		-- vip描述1
		local vipDescribe1 = XMLLabel()
		vipDescribe1:setContentSize(cc.size(400,36))
		vipDescribe1:setAlign("left","top")
		self:addChild(vipDescribe1)
		REL:toOther("left","top",vipDescribe1,topBack,20,60)
		self.vipDescribe1 = vipDescribe1

		vipDescribe1:updateView()
		local contentHeight = vipDescribe1:getTextHeight()

		-- vip描述2
		local vipDescribe2 = XMLLabel()
		vipDescribe2:setContentSize(cc.size(400,36))
		vipDescribe2:setAlign("left","top")
		self:addChild(vipDescribe2)
		REL:toOther("left","top",vipDescribe2,vipDescribe1,0,contentHeight + 55)
		vipDescribe2:setString(Language:get("uc474"))
		self.vipDescribe2 = vipDescribe2

	end



	-- 查看vip详情按钮
	local checkVip = Button.new("false","true")
	checkVip:setButtonState("bigButton_purple_normal.png","bigButton_general_down.png")
	checkVip:setString(Language:get("uc475"))
	self:addChild(checkVip)
	REL:toOther("right","bottom",checkVip,topBack,20,10)
	checkVip:setTextCenter()
	checkVip:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			WindowManager:switch(
				require("src.app.uiScript.components.vip.VIPWindow").new()
			)
		end
	end)

	self:refreshVipData()
end


--- 刷新vip相关的数据
function T:refreshVipData()
	local vipLevel = UserInfo.vipLevel
	self.vipLevel:setString(vipLevel)

	local playerVipPoint = VipManager:getPlayerVipPoint()
	local allVipPoint = VipManager:getNextVipPoint()
	self.vipdigital:setString(Language:get("uc472",playerVipPoint,allVipPoint))
	if playerVipPoint < allVipPoint then
		self.uiProgressFore:setPercentage(playerVipPoint/allVipPoint * 100)
	else
		self.uiProgressFore:setPercentage(100)
	end

	-- 重新设置大小
	self.vipdigital:updateView()
	local width = self.vipdigital:getTextWidth()
	self.vipDigitalImg:setContentSize(width + 6,25)
	REL:toOther("center","middle",self.vipDigitalImg,self.backImg,0,0)
	REL:toOther("center","middle",self.vipdigital,self.vipDigitalImg,0,0)

	if vipLevel >= 12 then
		self.vipDescribe1:setVisible(false)
		self.vipDescribe2:setVisible(false)
	else
		self.vipDescribe1:setVisible(true)
		self.vipDescribe2:setVisible(true)
		self.vipDescribe1:setString(Language:get("uc473",allVipPoint - playerVipPoint,vipLevel + 1))
	end

end


--- 初始化下面
function T:initBottom()
	-- 背景图片
	local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
	local bottomBackSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
	REL:relOther(bottomBack,self,6,6,150,5)
	self.bottomBack = bottomBack

	-- 标题图片
	local vipTitle = ccui.ImageView:create()
	vipTitle:loadTexture("taskTitleBack.png",ccui.TextureResType.plistType)
	self:addChild(vipTitle)
	REL:toOther("center","top",vipTitle,bottomBack,0,0)
	self.titleBack = vipTitle

	-- 标题名字
	local titleName = XMLLabel()
	titleName:setContentSize(cc.size(400,36))
	titleName:setAlign("center","middle")
	self:addChild(titleName)
	REL:toOther("center","middle",titleName,vipTitle,0,0)
	titleName:setString(Language:get("uc476"))
	self.titleName = titleName

	-- 初始化奖励品
	self.awrardItems = {}
	local awardList = self.AwardDataDecoder:awardResolve2(FirstRecharge_temp[1])
	local num = #awardList
	for i = 1,num,1 do
		local item = AwardItem.new({awardData = awardList[i]})
		if i == 1 then
			item:setSpecial() -- 3倍钻石不显示
		end
		local width = item:getContentSize().width + 60
		local offset = (i - 1) * width + 25
		self:addChild(item)
		self.awrardItems[#self.awrardItems + 1] = item
		REL:toOther("left","top",item,bottomBack,offset,60)
	end

	local top=170

	--- 判断是否支付内购
	if cc.PLATFORM_OS_ANDROID == C_PFM and CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
		local uiMorePayBtn=BaseButton:createButton(
			Language:get("ug_morePay"),
			"longButton_yellow_normal.png",
			"longButton_general_down.png"
		)
		if uiMorePayBtn.uiText then
			uiMorePayBtn.uiText:setLineSpacing(0)
		end

		self:addChild(uiMorePayBtn)
		REL:toOther("center","top",uiMorePayBtn,bottomBack,0,top)
		self.uiMorePayBtn=uiMorePayBtn

		uiMorePayBtn:addTouchEventListener(function(s,e)
			if e == ccui.TouchEventType.ended then
				IAPMgr:payOther()
			end
		end)
		top=240
	end

	-- 初始化所有钻石项
	local scrollView = ccui.ScrollView:create()
	scrollView:setTouchEnabled(true)
	scrollView:setBounceEnabled(true)
	self:addChild(scrollView)
	REL:relOther(scrollView,bottomBack,0,0,top,0)
	self.scrollView = scrollView

	--- 先暂时这样，后面如果增加商品的话，要改变内部容器的大小
	local posTemp = {{10,0},{298 + 15,0},{10,145},{298 + 15,145},{10,145*2},{298 + 15,145*2}}
	self.posTemp = posTemp
	self.res = {}
	local container = scrollView:getInnerContainer()
	local goodsList = GoodsManager:getSortGoodsList()
	local num = #goodsList
	for i = 1,num,1 do
		local res = self.GemsItem.new(goodsList[i])
		container:addChild(res)
		REL:toOther("left","top",res,container,posTemp[i][1],posTemp[i][2])
		self.res[#self.res + 1] = res
	end

	self:refreshAward()
end


--- 刷新奖励品显示
function T:refreshAward()
	local awrardItems = self.awrardItems
	local num = #awrardItems

	local firstRechargeInfo = ActivityManager.firstRechargeInfo
	if firstRechargeInfo:getValue() == true then
		-- 已经领取
		for i = 1,num,1 do
			if awrardItems[i] then
				awrardItems[i]:setVisible(false)
			end
		end
		self.titleBack:setVisible(false)
		self.titleName:setVisible(false)

		if cc.PLATFORM_OS_ANDROID == C_PFM and CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
			REL:toOther("center","top",self.uiMorePayBtn,self.bottomBack,0,15)
			REL:relOther(self.scrollView,self.bottomBack,0,0,85,0)
		else
			REL:relOther(self.scrollView,self.bottomBack,0,0,15,0)
		end

		-- 调整物品位置
		local posTemp = self.posTemp
		local res = self.res
		local num = #res
		local container = self.scrollView:getInnerContainer()
		for i = 1,num,1 do
			local everyRes = res[i]
			REL:toOther("left","top",everyRes,container,posTemp[i][1],posTemp[i][2])
		end

	else
		for i = 1,num,1 do
			if awrardItems[i] then
				awrardItems[i]:setVisible(true)
			end
		end
		self.titleBack:setVisible(true)
		self.titleName:setVisible(true)
	end
end

return T
