--- 礼包项
local T = class("T",function() return ccui.Layout:create() end)

--- 数据
T.packageInfo = nil

--- 奖励品项
T.GiftAwardItem = require("src.app.uiScript.components.iap.GiftAwardItem")

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


--- 构造函数
function T:ctor(packageInfo,listView)
	self.packageInfo = packageInfo
	self.listView = listView


	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	self:setContentSize(cc.size(640,700))

	self:init()
end

--- 进入
function T:onEnter()
	NewPackageManager:luaAddEventListener(NewPackageManager.EVT_BUY_NEW_RECHARGE_REFRESH .. self.packageInfo.sid,self,self.closeSelf)
	NewPackageManager:luaAddEventListener(NewPackageManager.EVT_NEW_RECHARGE_REMAINING_TIME_REFRESH .. self.packageInfo.sid,self,self.refreshTime)
end

--- 退出
function T:onExit()
	NewPackageManager:luaRemoveEventListener(NewPackageManager.EVT_BUY_NEW_RECHARGE_REFRESH .. self.packageInfo.sid,self,self.closeSelf)
	NewPackageManager:luaRemoveEventListener(NewPackageManager.EVT_NEW_RECHARGE_REMAINING_TIME_REFRESH .. self.packageInfo.sid,self,self.refreshTime)
end


--- 初始化
function T:init()
	local packageInfo = self.packageInfo
	local data_temp = NewPackage_temp[packageInfo.sid]

	local iconPath = IconManager.iconPath

	-- 顶部icon
	local topIcon = ccui.ImageView:create()
	topIcon:loadTexture(iconPath .. data_temp.topIcon)
	self:addChild(topIcon)
	REL:toOther("center","top",topIcon,self,0,0)
	self.topIcon = topIcon

	-- 名字
	local labelName = XMLLabel()
	labelName:setContentSize(cc.size(200,36))
	labelName:setAlign("center","top")
	self:addChild(labelName)
	REL:toOther("center","top",labelName,topIcon,0,18)
	labelName:setString(Language:get(data_temp.name))

	-- 百分比
	local percent = ccui.TextBMFont:create(Language:get("uc519",packageInfo.greatValue),"res/images/activity/percent.fnt")
	self:addChild(percent)
	REL:toOther("center","top",percent,topIcon,0,55)

	-- 钻石背景图片
	local gemsBack = ccui.ImageView:create()
	gemsBack:loadTexture("gemsBottom.png",ccui.TextureResType.plistType)
	self:addChild(gemsBack)
	REL:toOther("right","top",gemsBack,topIcon,50,90)

	-- 可获得
	local getGems = XMLLabel()
	getGems:setContentSize(cc.size(100,36))
	getGems:setHAlign("right")
	self:addChild(getGems)
	REL:toOther("right","middle",getGems,gemsBack,210,0)
	getGems:setString(Language:get("uc534"))

	-- 钻石图片
	--    local gemsImg = ccui.ImageView:create()
	--    gemsImg:loadTexture("diamond.png",ccui.TextureResType.plistType)
	--    self:addChild(gemsImg)
	--    REL:toOther("left","middle",gemsImg,gemsBack,10,2)
	if ResLoader:getAnimation("diamondFlashEff") then
		local gemsImg = ResLoader:createAnimationSprite("diamondFlashEff")
		gemsImg:setScale(0.8)
		self:addChild(gemsImg)
		REL:toOther("left","middle",gemsImg,gemsBack,30,5)
	end



	-- 钻石显示
	local gems = ccui.TextBMFont:create(packageInfo.gems,"res/images/activity/gems.fnt")
	self:addChild(gems)
	REL:toOther("center","middle",gems,gemsBack,10,-10)

	-- 剩余时间文本
	local remainTimeText = XMLLabel()
	remainTimeText:setContentSize(cc.size(200,36))
	remainTimeText:setAlign("center","bottom")
	self:addChild(remainTimeText)
	REL:toOther("center","bottom",remainTimeText,topIcon,-80,0)
	remainTimeText:setString(Language:get("uc520"))
	self.remainTimeText = remainTimeText

	-- 剩余时间
	local remainTime = ccui.TextBMFont:create("00:00:00","res/images/activity/time.fnt")
	self:addChild(remainTime)
	REL:toOther("left","middle",remainTime,remainTimeText,155,-15)
	self.remainTime = remainTime

	self:refreshTime(packageInfo.time)

	-- 底部icon
	local bottomIcon = ccui.ImageView:create()
	bottomIcon:loadTexture(iconPath .. data_temp.bottomIcon)
	self:addChild(bottomIcon)
	REL:toOther("center","bottom",bottomIcon,self,0,30)


	-- 描述背景图片
	local desBack = ccui.ImageView:create()
	desBack:loadTexture("titleBottom.png",ccui.TextureResType.plistType)
	self:addChild(desBack)
	REL:toOther("center","top",desBack,topIcon,0,164)

	-- 描述
	local des = XMLLabel()
	des:setContentSize(cc.size(500,36))
	des:setAlign("center","middle")
	self:addChild(des)
	REL:toOther("center","middle",des,desBack,0,0)
	des:setString(Language:get("uc521"))

	-- 添加奖励品
	self:addAward()

	-- 添加按钮
	self:addBtn()
end

--- 添加奖励品
function T:addAward()
	local awardList = self.AwardDataDecoder:awardResolve3(self.packageInfo.award)
	local topIcon = self.topIcon

	local pos = {200,200 + 80*1,200 + 80*2,200 + 80*3} -- 反正最多显示4个，距离顶部

	local num = #awardList

	if num > 4  then
		num = 4
	end

	for i = 1,num,1 do
		local res = self.GiftAwardItem.new(awardList[i])
		self:addChild(res)
		REL:toOther("center","top",res,topIcon,0,pos[i])
	end

end

--- 添加按钮
function T:addBtn()
	--- 更多按钮
	local more = Button.new("false","true")
	more:setButtonState("bigButton_green_normal.png","bigButton_general_down.png")
	self:addChild(more)
	REL:toOther("center","bottom",more,self,0,100)
	more:setTextCenter()
	more:setString(Language:get("uc523"))

	more:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			self.AwardDataDecoder:showSuccessWindow(self.packageInfo.award,Language:get("uc526"),SoundRes.SND_TIP_POP)
		end
	end)


	--- 活动按钮
	local btn = Button.new("false","false")
	btn:setButtonState("bigButton.png","bigButton.png")
	self:addChild(btn)
	REL:toOther("center","bottom",btn,self,0,0)
	btn:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			IAPMgr:pay(self.packageInfo)
		end
	end)

	-- 买买买
	local buyText = XMLLabel()
	buyText:setContentSize(cc.size(500,27))
	buyText:setAlign("center","middle")
	btn:addChild(buyText)
	REL:toOther("center","top",buyText,btn,0,15)
	buyText:setString(Language:get("uc508"))

	-- 花费钱
	local costMoney = XMLLabel()
	costMoney:setContentSize(cc.size(200,36))
	costMoney:setHAlign("center")
	btn:addChild(costMoney)
	REL:toOther("center","bottom",costMoney,btn,0,20)
	local currencySymbol = self.packageInfo.iapData.currencySymbol
	local price = string.format("%0.2f", self.packageInfo.iapData.price)
	costMoney:setString(Language:get("uc524",currencySymbol,price))


	-- 合法的话才能买
	if self.packageInfo.iapData.isValid and self.packageInfo.iapData.isValid == true then
		btn:setIsGray(false)
		btn:setTouchEnabled(true)
	else
		btn:setIsGray(true)
		btn:setTouchEnabled(false)
	end
end

function T:refreshTime(time)
	if time == 0 then
		self.remainTimeText:setVisible(false)
		self.remainTime:setVisible(false)
	else
		self.remainTime:setString(UnitConversion.timeCount(time))
	end

end

function  T:closeSelf()
	if self.uiMask then
		self.uiMask:removeFromParent()
		self.uiMask = nil
	end

	local index = self.listView:getIndex(self)
	local listView = self.listView
	self.listView:removeItem(index)
	listView:refreshView()
end

return T
