--[[
 * 礼包view
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 钻石项
T.GiftItem = require("src.app.uiScript.components.iap.GiftItem")

--- 构造函数
function T:ctor()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
end

--- 进入
function T:onEnter()
    NewPackageManager:luaAddEventListener(NewPackageManager.EVT_BUY_NEW_RECHARGE_REFRESH,self,self.refresh)
end

--- 退出
function T:onExit()
    NewPackageManager:luaRemoveEventListener(NewPackageManager.EVT_BUY_NEW_RECHARGE_REFRESH,self,self.refresh)
end

function T:init()
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,0,0,-10,0)
    self.listView = listView

    local packInfo = NewPackageManager:getGoodsList()
    local temp = {}
    for k,v in pairs(packInfo) do
        temp[#temp + 1] = v
    end

    table.sort(temp,function(x,y) return x.sid < y.sid end)
    for k,v in pairs(temp) do
        if v.isBuy == false then -- 还没购买
            local res = self.GiftItem.new(v,listView)
            listView:pushBackCustomItem(res)
            judge = true
        end

    end

    self:refresh()

end


function T:refresh()
    local judge = false
    local packInfo = NewPackageManager:getGoodsList()
    for k,v in pairs(packInfo) do
        if v.isBuy == false then -- 还没购买
            judge = true
            break
        end

    end
    if judge == false then -- 暂无礼包
        local des = XMLLabel()
        des:setContentSize(cc.size(500,36))
        des:setAlign("center","middle")
        self:addChild(des)
        REL:toOther("center","middle",des,self,0,50)
        des:setString(Language:get("uc525"))
    end
end


return T