--[[
 *	商品内购主窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)


--- 构造函数
function T:ctor()
    self:setWindowTitle(Language:get("uc469"))

    -- 这里的钻石禁止点击
    self.uiTopBorder.uiDiamondButton:setTouchEnabled(false)

    local function callBack1()
        self:gemsLogic()
    end

    local function callBack2()
        self:giftLogic()
    end

    -- 创建2个
    local switchButtonContainer = SwitchButtonContainer.new()
    self:addChild(switchButtonContainer)
    REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
    switchButtonContainer:init()
    switchButtonContainer:initButtons(
        2,
        {{"viewSwitchButton_normal.png","viewSwitchButton_down.png"},{"viewSwitchButton_normal.png","viewSwitchButton_down.png"}},
        {110,15},
        {callBack1,callBack2},
        {Language:get("uc470"),Language:get("uc471")}
    )
    self.switchButtonContainer = switchButtonContainer

    self:gemsLogic()

    self:updateBtn2tag()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end


function T:onEnter()
    self.super.onEnter(self)
    NewPackageManager:luaAddEventListener(NewPackageManager.EVT_BUY_NEW_RECHARGE_REFRESH,self,self.updateBtn2tag)
end

function T:onExit()
    self.super.onExit(self)
    NewPackageManager:luaRemoveEventListener(NewPackageManager.EVT_BUY_NEW_RECHARGE_REFRESH,self,self.updateBtn2tag)
end

function T:gemsLogic()
    if self.gemsView == nil then
		self.gemsView = require("src.app.uiScript.components.iap.GemsView").new()
		self:addChild(self.gemsView)
		REL:relOther(self.gemsView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT - 10,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
		self.gemsView:init()
	end

	if self.gemsView then
		self.gemsView:setVisible(true)
	end


	if self.giftView then
		self.giftView:setVisible(false)
	end
end

function T:giftLogic()
	if self.gemsView then
		self.gemsView:setVisible(false)
	end

    if self.giftView == nil then
--        if not NewPackageManager then
--            NewPackageManager = require("src.app.model.iap.newPackage.NewPackageManager")() -- 这是实例化，只能在这里进行
--        end
--        if NewPackageManager.isGetAllList then
--            self.giftView = require("src.app.uiScript.components.iap.GiftView").new()
--		    self:addChild(self.giftView)
--		    REL:relOther(self.giftView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT - 10,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
--		    self.giftView:init()
--        else
--            local uiMask = require("src.app.uiScript.components.common.CommunicationWaitingMask")()
--            Director:getRunningScene():addChild(uiMask)
--            local function finish()
--                local function confirm()
--                    uiMask:removeFromParent()
--                    NewPackageManager.isGetAllList = true
--                    self.giftView = require("src.app.uiScript.components.iap.GiftView").new()
--		            self:addChild(self.giftView)
--		            REL:relOther(self.giftView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT - 10,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
--		            self.giftView:init()
--                end
--                NewPackageManager:getAllIapData(confirm)

--            end

--            Command:getNewRechargeListInfo(finish)

            self.giftView = require("src.app.uiScript.components.iap.GiftView").new()
		    self:addChild(self.giftView)
		    REL:relOther(self.giftView,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT - 10,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
		    self.giftView:init()

        --end
        
	end

	if self.giftView then
		self.giftView:setVisible(true)
	end
end

--- 更新礼包
function T:updateBtn2tag()
    local judge = false
    local packInfo = NewPackageManager:getGoodsList()
    for k,v in pairs(packInfo) do
        if v.isBuy == false then -- 还没购买
            judge = true
            break
        end

    end
    self.switchButtonContainer:updateButton2Tag(judge)
end

--- 获得特效
function T:getEff(kind)
	local s = cc.Sprite:create()
	local ani = ResLoader:getAnimation(kind)
	if not ani then
		return
	end

	local ac = cc.RepeatForever:create(cc.Animate:create(ani))
	s:runAction(ac)
	return s

end
return T