--[[
 *	战机强化每一项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 等级
T.fighterLevel = nil

--- sid
T.sid = nil

--- 构造函数
function T:ctor(fighterLevel,sid)
    self.fighterLevel = fighterLevel
    self.sid = sid

    self:setContentSize(cc.size(284,276))

    self:init()

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:_getWidget()
    self:_setData()

end

--- 进入
function T:onEnter()
    AircraftStrengManager:luaAddEventListener(AircraftStrengManager.EVT_ATTACK_STRENGTH,self,self.refreshAttack)
    AircraftStrengManager:luaAddEventListener(AircraftStrengManager.EVT_HP_STRENGTH,self,self.refreshHp)
end

--- 退出
function T:onExit()
    AircraftStrengManager:luaRemoveEventListener(AircraftStrengManager.EVT_ATTACK_STRENGTH,self,self.refreshAttack)
    AircraftStrengManager:luaRemoveEventListener(AircraftStrengManager.EVT_HP_STRENGTH,self,self.refreshHp)
end


function T:_getWidget()
    local iconPath = IconManager.iconPath

    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("labBottom.png",ccui.TextureResType.plistType) 
    self:addChild(back)
    REL:toOther("center","middle",back,self,0,0)
    self.back = back

    self:updateAircraft()

    -- 名字
    local name = XMLLabel()
    name:setContentSize(cc.size(300, 36))
    name:setHAlign("center")
    self:addChild(name)
    REL:toOther("center", "top", name, back, 0, 5)
    self.name = name


    -- 攻击图片
    local _imgAttack = ccui.ImageView:create()
    _imgAttack:loadTexture(iconPath .. Prop_temp[1].propIcon) 
    _imgAttack:setScale(IconManager.halfScale[1],IconManager.halfScale[2])
    self:addChild(_imgAttack)
    REL:toOther("left","bottom",_imgAttack,back,20,10)
    self._imgAttack = _imgAttack

    -- 攻击数值
    local labelAttack = XMLLabel()
    labelAttack:setContentSize(cc.size(300, 27))
    self:addChild(labelAttack)
    REL:toOther("left", "middle", labelAttack, _imgAttack,52,0)
    self._labelAttack = labelAttack

    -- 血量图片
    local _imgHp = ccui.ImageView:create()
    _imgHp:loadTexture(iconPath .. Prop_temp[1].propIcon) 
    _imgHp:setScale(IconManager.halfScale[1],IconManager.halfScale[2])
    self:addChild(_imgHp)
    REL:toOther("left","bottom",_imgHp,self,150,10)
    self._imgHp = _imgHp

    -- 血量数值
    local labelHp = XMLLabel()
    labelHp:setContentSize(cc.size(300, 27))
    self:addChild(labelHp)
    REL:toOther("left", "middle", labelHp, self._imgHp,52,0)
    self._labelHp = labelHp


end

function T:_setData()
    local iconPath = IconManager.iconPath
    local data = Aircraft_temp[self.sid]

    self.name:setString(Language:get("uc705",AircraftUtils:getRichName(data)))

    self._imgAttack:loadTexture(iconPath .. AircraftBaseAttribute_temp[2].icon)
    self._imgHp:loadTexture(iconPath .. AircraftBaseAttribute_temp[5].icon)

    self:refreshAttack()
    self:refreshHp()
end

function T:refreshAttack()
    local info = AircraftStrengManager.aircraftStrengBox:getStrengInfo(self.fighterLevel)

    local attackCount = info:getAttackFromSid(self.sid)
    self._labelAttack:setString(Language:get("uc374",string.format("%0.2f", attackCount)))
end

function T:refreshHp()
    local info = AircraftStrengManager.aircraftStrengBox:getStrengInfo(self.fighterLevel)

    local hpCount = info:getHpFromSid(self.sid)
    self._labelHp:setString(Language:get("uc374",string.format("%0.2f", hpCount)))
end

--- 更新战机显示
function T:updateAircraft()
    local sid = self.sid
	if self.airIcon then
		self.airIcon:removeFromParent()
	end

	local T=GameUtils:getAicraftModelUrl(Camp.CAMP2,sid)
	if T then
		local o = T()
		self:addChild(o)
        REL:toOther("center","middle",o,self.back,0,0)
		self.airIcon = o
	end
end



return T