--[[
 * 战机实验室窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)

--- 战机强化页面
T.aircraft = nil

--- 运输线
T.transport = nil


--- 构造函数
function T:ctor()

    local function callBack1()
        self:labAircraft()
    end

    local function callBack2()
        self:transportLine()
    end


    -- 创建2个
    local switchButtonContainer = SwitchButtonContainer.new()
    self:addChild(switchButtonContainer)
    REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
    switchButtonContainer:init()
    switchButtonContainer:initButtons(
        2,
        {{"viewSwitchButton_normal.png","viewSwitchButton_down.png"},{"viewSwitchButton_normal.png","viewSwitchButton_down.png"}},
        {110,15},
        {callBack1,callBack2},
        {Language:get("uc368"),Language:get("uc369")}
    )
    self.switchButtonContainer = switchButtonContainer

    self:setWindowTitle(Language:get("uc367"))
    self:labAircraft()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)

	AudioManager:playEffect(SoundRes.OPEN_AIRCRAFT_LAB)
end

function T:onExit()
    self.super.onExit(self)
end

--- 飞机
function T:labAircraft()    
    if self.aircraft == nil then
        self.aircraft = require("src.app.uiScript.components.laboratory.LabAircraftView").new()
        self:addChild(self.aircraft)       
        REL:relOther(self.aircraft,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.aircraft:init()
    end

    if self.aircraft then
        self.aircraft:setVisible(true)
    end

    if self.transport then
        self.transport:setVisible(false)
    end
            
end

-- 其它
function T:transportLine()
    if self.aircraft then
        self.aircraft:setVisible(false)
    end

    if self.transport == nil then
        -- 发送命令，得到传输线数据
        local function finish(data)
            self.transport = require("src.app.uiScript.components.laboratory.transportationLine.LabTransportationLineView").new(data)
            self:addChild(self.transport)       
            REL:relOther(self.transport,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
            self.transport:init() 
        end
        Command:getTransportInfo(finish)
    end

    if self.transport then
        self.transport:setVisible(true)
    end

end


return T