--[[
 *	运输线的每一项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 运输线id
T.id = nil

--- 服务器那边拿过来的运输线数据
T.transData = nil

--- 构造函数
function T:ctor(id,transData)
    self.id = id
    self.transData = transData

    self:setContentSize(cc.size(635,211 - 20))
    
    self:init()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:_getWidget()
    self:_refreshServerData()
    self:_addEventListener()

end

--- 进入
function T:onEnter()
    CommonBroadcast:luaAddEventListener(EVENT_FIGHT_COMPLETE,self,self._refreshServerData)
end

--- 退出
function T:onExit()
    CommonBroadcast:luaRemoveEventListener(EVENT_FIGHT_COMPLETE,self,self._refreshServerData)
end

function T:_getWidget()
    -- 背景图片
    local icon = ccui.ImageView:create()
    --icon:setScale(2)
    self:addChild(icon)
    local data = TransportLine_temp[self.id]
    local iconPath = IconManager.iconPath
    icon:loadTexture(iconPath .. data.icon) 
    REL:toOther("center","middle",icon,self,5,0)
    self.icon = icon

    -- 运输线名字
    local name = XMLLabel()
    name:setContentSize(cc.size(400, 36))
    name:setHAlign("center")
    self:addChild(name)
    REL:toOther("center", "top", name, icon, -200, 30)
    name:setString(Language:get(data.name))

    -- 描述
    local describe = XMLLabel()
    describe:setContentSize(cc.size(600, 36))
    describe:setAlign("center","bottom")
    self:addChild(describe)
    REL:toOther("center", "bottom", describe, icon, 0, 20)
    self.describe = describe

end

--- 设置服务器数据 
function T:_refreshServerData()
    local transData = self.transData
    transData.hasChallengeCount = TransportLineManager:getHasChallengeCount(transData.id)

    local userLevel = UserInfo.level
    local limitLevel = transData.limitLevel
    if userLevel >= limitLevel then -- 解锁了
        self:setTouchEnabled(true)
        self.icon:setIsGray(false)

        self.describe:setString(Language:get("uc385",transData.hasChallengeCount,transData.maxNum))
        
    else
        self:setTouchEnabled(false)
        self.icon:setIsGray(true)

        self.describe:setString(Language:get("uc384",limitLevel))

--      local descripe = Language:get("uc383")
--		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
        
    end

end

function T:_addEventListener()
    self:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local transData = self.transData
            if transData.hasChallengeCount < transData.maxNum then
                -- 进入派兵界面
                local data = {}
                data.id = transData.id
                local armyWindow = require("src.app.uiScript.components.army.ArmyWindow").new({ ["tag"] = 4, ["detailInfo"] = data })
		        WindowManager:push(armyWindow)

            else
                local descripe = Language:get("uc386")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            end
        end
    end)

end

return T