--[[
 *	运输线视图
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 传输数据
T.allTransData = nil

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor(allTransData)
    self.allTransData = allTransData
    self.queue = Queue()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
        
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,0,0,0,0)
    self.listView = listView

    self:_addListView()
end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    TransportLineManager:setSelCampaign(nil)
    TransportLineManager:setHasChallengeCount(1,nil)
    TransportLineManager:setHasChallengeCount(2,nil)
    TransportLineManager:setHasChallengeCount(3,nil)

    self.queue:clearT()
    self.queue = nil
end

function T:_addListView()
    local allTransData = self.allTransData
    local num = #TransportLine_temp
    for i = 1,num,1 do
        local info = {}
        info.id = TransportLine_temp[i].id
        info.transData = allTransData[i]
        self.queue:push(info)
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)
end

function T:addRes()
    local info = self.queue:pop()
    if info then
        local res = require("src.app.uiScript.components.laboratory.transportationLine.LabTransportationLineItem").new(info.id,info.transData)
        res:setOpacity(0)
        self.listView:pushBackCustomItem(res)
        res:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end

return T