local _print=print
local function print(...)
	_print("\t<AbstractLoginView>: ",table.concat({...},"\t"))
end

--- 登陆视图
local T=Class.AbstractLoginView(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 等待信息提示框
T.WaitingMessageText=require("src.app.uiScript.components.common.WaitingMessageText")

--- 等待提示框
T.CommunicationWaitingMask=require("src.app.uiScript.components.common.CommunicationWaitingMask")

--- 登陆输入框
T.LoginInputBox=require("src.app.uiScript.components.login.LoginInputBox")

function T:def()
	AbstractUI.def(self)

	self.loginTip=nil
end

function T:ctor()
	AbstractUI.ctor(self)

	self:init()
end

function T:onExit()
	AbstractUI.onExit(self)

	self:remvoeConnectListeners()
	self:removeLoginListeners()
end

function T:init()
	REL:relScreen(self,0,0,0,0)

	--登陆按钮
	local uiEnter=BaseButton:createButton(Language:get("ug17"),"loginButton_normal.png")
	uiEnter:setVisible(false)
	self:addChild(uiEnter)
	REL:toOther("center","bottom",uiEnter,self,-2,86)
	self.uiEnter=uiEnter
	uiEnter:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			self:enterGame()
		end
	end )

	--- 用户名
	local uiUName=BaseButton:createButton("user name","loadingGeneralButton_normal.png")
	uiUName:setVisible(false)
	self:addChild(uiUName)
	REL:toOther("center","bottom",uiUName,self,0,288)
	self.uiUName=uiUName
	uiUName:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			self:enterUNameInputView()
		end
	end )

	--- 服务器名
	local uiSName=BaseButton:createButton("server name","loadingGeneralButton_normal.png")
	uiSName:setVisible(false)
	self:addChild(uiSName)
	REL:toOther("center","bottom",uiSName,self,0,218)
	self.uiSName=uiSName
	uiSName:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			self:enterServerSelectView()
		end
	end )

	--- 语言包列表
	local uiLangSelButton=BaseButton:createButton("language select","loadingGeneralButton_normal.png")
	uiLangSelButton:setVisible(false)
	self:addChild(uiLangSelButton)
	REL:toOther("left","middle",uiLangSelButton,self,0,0)
	self.uiLangSelButton=uiLangSelButton
	uiLangSelButton:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			self:enterLanguageSelectView()
		end
	end )

	print("获取登陆数据")
	self:doGetLogin()
end

--- 获取登陆信息
function T:doGetLogin()

end

--- 获取登陆信息完成
function T:getLoginDataComplete()
	self.uiEnter:setVisible(true)
	self.uiUName:setVisible(true)
	self.uiSName:setVisible(true)

	self:updateUserInfo()
	self:playEnterEff()
end

--- 播放进入特效
function T:playEnterEff(completeCallback)
	local uiEnter,uiUName,uiSName=self.uiEnter,self.uiUName,self.uiSName

	local c=0
	local effComplete=function()
		c=c+1
		if c >= 3 then
			if completeCallback then
				completeCallback()
			end
		end
	end

	uiEnter:setOpacity(0)
	uiEnter:runAction(cc.Sequence:create(
		cc.DelayTime:create(0.7),
		cc.FadeIn:create(0.2),
		cc.CallFunc:create(effComplete)
	))

	REL:toOther("center","bottom",uiUName,self,0,288)
	local ex,ey=uiUName:getPosition()
	REL:toOther("left","bottom",uiUName,self,-uiUName:getContentSize().width,288)
	uiUName:runAction(cc.Sequence:create(
		cc.EaseBackInOut:create(
			cc.MoveTo:create(0.8,{x=ex,y=ey})
		),
		cc.CallFunc:create(effComplete)
	))

	REL:toOther("center","bottom",uiSName,self,0,218)
	local ex,ey=uiSName:getPosition()
	REL:toOther("right","bottom",uiSName,self,-uiSName:getContentSize().width,218)
	uiSName:runAction(cc.Sequence:create(
		cc.EaseBackInOut:create(
			cc.MoveTo:create(0.8,{x=ex,y=ey})
		),
		cc.CallFunc:create(effComplete)
	))
end

--- 播放退出特效
function T:playExitEff(completeCallback)
	local uiEnter,uiUName,uiSName=self.uiEnter,self.uiUName,self.uiSName

	local c=0
	local effComplete=function()
		c=c+1
		if c >= 3 then
			if completeCallback then
				completeCallback()
			end
		end
	end

	uiEnter:setOpacity(255)
	uiEnter:runAction(cc.Sequence:create(
		cc.FadeOut:create(0.2),
		cc.CallFunc:create(effComplete)
	))

	REL:toOther("left","bottom",uiUName,self,-uiUName:getContentSize().width,288)
	local ex,ey=uiUName:getPosition()
	REL:toOther("center","bottom",uiUName,self,0,288)
	uiUName:runAction(cc.Sequence:create(
		cc.MoveTo:create(0.2,{x=ex,y=ey}),
		cc.CallFunc:create(effComplete)
	))

	REL:toOther("right","bottom",uiSName,self,-uiSName:getContentSize().width,218)
	local ex,ey=uiSName:getPosition()
	REL:toOther("center","bottom",uiSName,self,0,218)
	uiSName:runAction(cc.Sequence:create(
		cc.MoveTo:create(0.2,{x=ex,y=ey}),
		cc.CallFunc:create(effComplete)
	))
end

--- 进入用户名输入视图
function T:enterUNameInputView()

end

--- 进入服务器选择视图
function T:enterServerSelectView()
	MUIAlter_custom.show({
		info=require("src.app.uiScript.components.login.ServerListCvs")(self.loginData),
		triggerCloseMethod="outside",
		callback=function()
			self:updateUserInfo()
		end
	})
end

--- 进入语言选择视图
function T:enterLanguageSelectView()
	MUIAlter.show({
		info=require("src.app.uiScript.components.login.LanguageListCvs")(),
		title=Language:get("uc338"),
		flag=4,
		callback=function()
			self:updateView()
		end
	})
end

--- 更新视图
function T:updateView()
	self.uiEnter:setString(Language:get("ug17"))
end

--- 设置"登陆"按钮是否可用
function T:setEnabledEnterButton(value)
	if value then
		self.uiEnter:setTouchEnabled(true)
		self.uiEnter:setIsGray(false)
	else
		self.uiEnter:setTouchEnabled(false)
		self.uiEnter:setIsGray(true)
	end
end

function T:enterGame()
	self:setEnabledEnterButton(false)
	self:playExitEff()

	self:timeout(function()
		AudioManager:playEffect(SoundRes.SND_CONNECTING)

		print("\t", "初始化语言包")
		require("src.app.utils.LanguageUtils"):loadSecondFiles()

		--	self.loginTip=self.WaitingMessageText:show(Language:get("ug20"))
		self.loginTip=self.CommunicationWaitingMask:show()

		self:initConnect()
	end,0.2)
end

--- 刷新用户信息的显示
function T:updateUserInfo()
	local ld=self.loginData
	local s=ServerListMgr:getServerData(ld.serverId)

	if ld.isTourist then
		self.uiUName:setString(Language:get("ug_tourist"))
	else
		self.uiUName:setString(ld.uid)
	end
	self.uiSName:setString(s.name)

	NetManager:init(self.loginData)
end

--- 初始化网络连接
function T:initConnect()
	NetManager:luaAddEventListener(NET_CONNECT_FAIL, self, self.connectFailHandler)
	NetManager:luaAddEventListener(NET_ENCYPTION_TIMEOUT, self, self.encyptionTimeoutHandler)

	NetManager:luaAddEventListener(NET_INIT_COMMUNICTION_COMPLETE, self, self.initCommunicationCompleteHandler)

	NetManager:connect()
end

--- 移除连接阶段的事件侦听器
function T:remvoeConnectListeners()
	NetManager:luaRemoveEventListener(NET_CONNECT_FAIL, self, self.connectFailHandler)
	NetManager:luaRemoveEventListener(NET_ENCYPTION_TIMEOUT, self, self.encyptionTimeoutHandler)

	NetManager:luaRemoveEventListener(NET_INIT_COMMUNICTION_COMPLETE, self, self.initCommunicationCompleteHandler)
end

--- 连接服务器失败
function T:connectFailHandler()
	self.loginTip:hide()

	MUIAlter.show( {
		info = Language:get("ug7"),
		callback=function()
			self:setEnabledEnterButton(true)
			self:playEnterEff()
		end
	} )
end

--- 等待密钥超时
function T:encyptionTimeoutHandler()
	self:remvoeConnectListeners()

	self.loginTip:hide()

	MUIAlter.show( {
		info = Language:get("ug9"),
		callback=function()
			self:setEnabledEnterButton(true)
			self:playEnterEff()
		end
	} )
end

--- 初始化网络连接完成
function T:initCommunicationCompleteHandler()
	self:remvoeConnectListeners()

	--	self.loginTip:hide()
	--	self.loginTip=self.WaitingMessageText:show(Language:get("ug22"))

	self:initDataRequires()

	self:login()
end

--- 初始化数据相关文件的引入
function T:initDataRequires()
	print("\t", "导入数据相关文件")
	require("src.app.DataRequires")

	--- 用户信息
	UserInfo = require("src.app.model.UserInfo")()
end

--- 移除登陆阶段的事件侦听
function T:removeLoginListeners()
	NetManager:luaRemoveEventListener(NET_LOGIN_SUCC, self, self.loginSuccHandler)
	NetManager:luaRemoveEventListener(NET_LOGIN_FAIL, self, self.loginFailHandler)

	CommonBroadcast:luaRemoveEventListener("net_decode_err",self,self.netDecodeErrHandler)
end

--- 登陆服务器
function T:login()
	print("登陆服务器")

	NetManager:luaAddEventListener(NET_LOGIN_SUCC, self, self.loginSuccHandler)
	NetManager:luaAddEventListener(NET_LOGIN_FAIL, self, self.loginFailHandler)

	CommonBroadcast:luaAddEventListener("net_decode_err",self,self.netDecodeErrHandler)

	NetManager:loginServer()
end

--- 登陆服务器成功
function T:loginSuccHandler()
	self:removeLoginListeners()

	self.loginTip:hide()

	AccountMgr:storageAccount(self.loginData)

	-- 启动网络监测器
	NetDetector:start()

	AudioManager:playMusic(SoundRes.MUSIC_GENERAL,false)
	CommonBroadcast:luaDispatchEvent(NET_LOGIN_SUCC)
end

--- 登陆服务器失败
-- @param errInfo 错误信息
function T:loginFailHandler(errInfo)
	self:removeLoginListeners()
	NetManager:close()

	self.loginTip:hide()

	self:setEnabledEnterButton(true)
	self:playEnterEff()

	if errInfo and type(errInfo) == "string" then
		MUIAlter.show({
			info=errInfo
		})
	end

	--	MUIAlter.show( {
	--		info = Language:get("ug12"),
	--		callback=function()
	--			self:setEnabledEnterButton(true)
	--		end
	--	} )
end

--- 解析服务器返回的数据错误
function T:netDecodeErrHandler(command)
	self:removeLoginListeners()
	NetManager:close()

	self.loginTip:hide()

	MUIAlter.show( {
		info = Language:get("ug14"),
		callback=function()
			self:setEnabledEnterButton(true)
		end
	} )
end

return T
