--- 语言选择列表显示项
local T=Class.LanguageItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

T.WIDTH,T.HEIGHT=124,136

function T:def()
	AbstractUI.def(self)

	--- 语言数据
	-- _data
	
	--- 是否被选择
	self._isSelected=false
end

function T:ctor()
	AbstractUI.ctor(self)

	self:_init()
end

function T:_init()
	self:setContentSize(cc.size(self.WIDTH,self.HEIGHT))

--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	self:setBackGroundColor(cc.c3b(random(0,255),0,0))
--	self:setBackGroundColorOpacity(100)

	--语言图标
	local uiIcon=cc.Sprite:create()
	uiIcon:setAnchorPoint({x=0.5,y=0.5})
	self:addChild(uiIcon)
	self.uiIcon=uiIcon

	--语言名称
	local uiName=XMLLabel()
	uiName:setAlign("center","middle")
	uiName:setHeight(36)
	self:addChild(uiName)
	REL:relOther(uiName,self,0,0,SIZE_NIL,4)
	self.uiName=uiName
end

--- 刷新视图
function T:updateView()
	local d=self._data

	local uiIcon=self.uiIcon
	uiIcon:setTexture(d.iconUrl)
	REL:toOther("center","top",uiIcon,self,0,4)

	local uiName=self.uiName
	uiName:setString(Language:get(d.name))
	
	if self._isSelected then
		uiIcon:setScale(1.2)
		uiName:setCssStyle(CssStyles.red24)
	else
		uiIcon:setScale(1)
		uiName:setCssStyle(CssStyles.default24)
	end
end

--- 设置数据
function T:setData(value)
	if value ~= self._data then
		self._data=value

		self:updateView()
	end
end

--- 获取数据
function T:getData()
	return self._data
end

--- 设置是否被选择
function T:setIsSelected(value)
	if value ~= self._isSelected then
		self._isSelected=value
		
		self:updateView()
	end
end

--- 获取是否被选择
function T:getIsSelected()
	return self._isSelected
end

return T
