--- 登陆历史记录项
local T=Class.LoginHistoryItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI,
	LuaEventDispatcher2
)

function T:def()
	AbstractUI.def(self)
	LuaEventDispatcher2.def(self)

	--- 数据
	-- _data

	--- 标题显示属性名
	-- _labelAttributeName

	--- 是否被选择
	self._isSelected=false
end

function T:ctor()
	AbstractUI.ctor(self)
	LuaEventDispatcher2.ctor(self)

	self:init()
end

function T:init()
	self:setContentSize(cc.size(340,50))
	self:setTouchEnabled(true)

	--删除按钮
	local uiDelButton=BaseButton:createButton(nil,"deleteIcon.png","deleteIcon.png")
	self:addChild(uiDelButton)
	REL:toOther("right","middle",uiDelButton,self,0,0)
	self.uiDelButton=uiDelButton
	
	uiDelButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:luaDispatchEvent("delete",self)
		end
	end)

	--文本
	local uiText=XMLLabel()
	uiText:setAlign("left","middle")
	self:addChild(uiText)
	REL:relOther(uiText,self,4,uiDelButton:getContentSize().width+4,0,0)
	self.uiText=uiText
end

--- 更新视图
function T:updateView()
	local d=self._data
	if d then
		if type(d) == "table" then
			local lns={"label","name","caption"}

			local lName=self._labelAttributeName
			if lName then
				table.insert(lns,1,lName)
			end

			local label=nil
			for k,v in ipairs(lns) do
				label=d[v]
				if label and type(label) ~= "table" then
					break
				end
			end

			if label then
				self.uiText:setString(tostring(label))
			else
				self.uiText:setString("[Object]")
			end
		else
			self.uiText:setString(tostring(d))
		end
	else
		self.uiText:setString()
	end
end

--- 设置数据
function T:setData(value)
	if value ~= self._data then
		self._data=value

		self:updateView()
	end
end
--- 获取数据
function T:getData()
	return self._data
end

--- 设置标题显示的属性名
function T:setLabelAttributeName(value)
	if value ~= self._labelAttributeName then
		self._labelAttributeName=value

		self:updateView()
	end
end
--- 获取标题显示的属性名
function T:getLabelAttributeName()
	return self._labelAttributeName
end

--- 设置是否被选择
function T:setSelected(value)
	if value ~= self._isSelected then
		self._isSelected=value
	end
end
--- 获取是否被选择
function T:getSelected()
	return self._isSelected
end

return T
