local T=Class.LoginInputBox(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 登陆历史记录项
T.LoginHistoryItem=require("src.app.uiScript.components.login.LoginHistoryItem")

--- 条目分隔线
T.ItemSep=require("src.app.uiScript.components.login.ItemSep")

function T:def()
	AbstractUI.def(self)

	--- 背景
	-- self.uiBack=nil

	--- 用户名
	-- self.uiName=nil

	--- 密码
	-- self.uiPwd=nil

	--- 确定按钮
	-- self.uiConfirmButton=nil
end

--- 构造函数
-- @param defalutLoginData 默认登陆数据
-- @param doneCallback 完成时的回调
function T:ctor(defalutLoginData,doneCallback)
	AbstractUI.ctor(self)
	self._doneCallback=doneCallback

	self:init()

	self:setData(defalutLoginData)
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(540,320))
	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid )
	--	self:setBackGroundColor(cc.c3b(0,0,0))
	--	self:setBackGroundColorOpacity(100)

	--"账号"标题
	local uiNameCap=XMLLabel(Language:get("ug_loginInput_nameCap"))
	uiNameCap:setFontSize(32)
	uiNameCap:setAlign("center","middle")
	uiNameCap:setContentSize(cc.size(120,50))
	self:addChild(uiNameCap)
	REL:toOther("left","top",uiNameCap,self,20,40)
	self.uiNameCap=uiNameCap

	--"账号"输入框背景
	local uiNameBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("downListBack.png"))
	uiNameBack:setContentSize(cc.size(360,50))
	self:addChild(uiNameBack)
	REL:toOther("left","top",uiNameBack,self,140,40)
	self.uiNameBack=uiNameBack

	--"账号"输入框
	local uiNameInput=require("src.app.uiScript.components.common.InputBox"):create(
		cc.size(290,50),
		ccui.Scale9Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("editBoxBack.png"),cc.rect(0,0,1,1))
	)
	uiNameInput:setInputMode(cc.EDITBOX_INPUT_MODE_EMAILADDR)
	self:addChild(uiNameInput)
	REL:toOther("left","middle",uiNameInput,uiNameBack,10,0)
	self.uiNameInput=uiNameInput

	uiNameInput:luaAddEventListener("changed",nil,
		function(t)
			self.loginData.isTourist=nil
			self.loginData.uid=t:getText()
		end
	)

	--下拉按钮
	local uiDnListButton=ToggleButton("arrow_dn.png","arrow_up.png")
	self:addChild(uiDnListButton)
	REL:toOther("right","middle",uiDnListButton,uiNameBack,0,0)
	self.uiDnListButton=uiDnListButton

	--侦听"展开/收缩"按钮改变事件
	uiDnListButton:luaAddEventListener("change",self,
		function()
			if uiDnListButton:getIsSelected() then
				self:showDnList()
			else
				self:hideDnList()
			end
		end
	)

	--"密码"标题
	local uiPWDCap=XMLLabel(Language:get("ug_loginInput_pwdCap"))
	uiPWDCap:setFontSize(32)
	uiPWDCap:setAlign("center","middle")
	uiPWDCap:setContentSize(cc.size(120,50))
	self:addChild(uiPWDCap)
	REL:toOther("left","top",uiPWDCap,self,20,120)
	self.uiPWDCap=uiPWDCap

	--"密码"输入框背景
	local uiPWDBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("downListBack.png"))
	uiPWDBack:setContentSize(cc.size(360,50))
	self:addChild(uiPWDBack)
	REL:toOther("left","top",uiPWDBack,self,140,120)
	self.uiPWDBack=uiPWDBack

	--"密码"输入框
	local uiPWDInput=require("src.app.uiScript.components.common.InputBox"):create(
		cc.size(340,50),
		ccui.Scale9Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("editBoxBack.png"),cc.rect(0,0,1,1))
	)
	uiPWDInput:setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD)
	self:addChild(uiPWDInput)
	REL:toOther("center","middle",uiPWDInput,uiPWDBack,0,0)
	self.uiPWDInput=uiPWDInput

	uiPWDInput:luaAddEventListener("changed",nil,
		function(t)
			self.loginData.isTourist=nil
			self.loginData.pwd=t:getText()
		end
	)

	--"找回密码"按钮
	local uiRetrievePWDButton=BaseButton:createButton(Language:get("ug_retPWD"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiRetrievePWDButton)
	REL:toOther("center","bottom",uiRetrievePWDButton,self,-100,20)
	self.uiRetrievePWDButton=uiRetrievePWDButton

	uiRetrievePWDButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			print("找回密码")
		end
	end)

	--"登陆"按钮
	local uiLoginButton=BaseButton:createButton(Language:get("ug_login"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiLoginButton)
	REL:toOther("center","bottom",uiLoginButton,self,100,20)
	self.uiLoginButton=uiLoginButton

	uiLoginButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:loginHandler()
		end
	end)

	--"游客登陆"按钮
	local uiTouristLoginButton=BaseButton:createButton(Language:get("ug_touristLogin"),"button_yellow_normal.png","button_general_down.png")
	self:addChild(uiTouristLoginButton)
	REL:toOther("center","bottom",uiTouristLoginButton,self,0,-120)
	self.uiTouristLoginButton=uiTouristLoginButton

	uiTouristLoginButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			local lD=self.loginData

			lD.isTourist=true
			lD.uid=DataStorage:getUniqueId()
			lD.pwd=nil

			print("游客登陆:uid=",lD.uid)

			if self._doneCallback then
				self._doneCallback()
			end
			self.__hide__()
		end
	end)
end

--- 登陆
function T:loginHandler()
	local uid,pwd=self.uiNameInput:getText(),self.uiPWDInput:getText()
	if not uid or string.trim(uid) == "" then
		MUIAlter_singleLine.show({
			info=Language:get("ug_uidIsEmpty"),
			showSecond=0.8
		})

		return
	end

	if not pwd or string.trim(pwd) == "" then
		MUIAlter_singleLine.show({
			info=Language:get("ug_pwdIsEmpty"),
			showSecond=0.8
		})

		return
	end

	local lD=self.loginData

	lD.isTourist,lD.uid,lD.pwd=nil,uid,pwd

	if self._doneCallback then
		self._doneCallback()
	end
	self.__hide__()
end

--- 创建历史登陆记录下拉列表
function T:createDnList()
	--下拉列表容器
	local uiDnListC=ccui.Layout:create()
	self:addChild(uiDnListC)
	uiDnListC:setContentSize(cc.size(100,200))
	REL:relOther(uiDnListC,self.uiNameBack,0,0,self.uiNameBack:getContentSize().height,SIZE_NIL)
	self.uiDnListC=uiDnListC

	--遮罩
	local uiMask=ccui.Layout:create()
	uiMask:setTouchEnabled(true)
	uiDnListC:addChild(uiMask)
	REL:relScreen(uiMask,0,0,0,0)
	uiDnListC.uiMask=uiMask

	uiMask:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self.uiDnListButton:setIsSelected(false)
		end
	end)

	--下拉列表背景
	local uiDnListBack=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("downListBack.png"))
	uiDnListC:addChild(uiDnListBack)
	REL:relOther(uiDnListBack,uiDnListC,0,0,0,0)
	uiDnListC.uiDnListBack=uiDnListBack

	--列表框
	local uiDnList=ccui.ListView:create()
	uiDnList:setTouchEnabled(true)
	uiDnList:setBounceEnabled(true)
	uiDnList:setItemsMargin(4)
	uiDnList:setGravity(ccui.ListViewGravity.centerHorizontal)
	uiDnListC:addChild(uiDnList)
	REL:relOther(uiDnList,uiDnListC,4,4,4,4)
	self.uiDnList=uiDnList
end

--- 显示下拉列表
function T:showDnList()
	if not self.uiDnListC then
		self:createDnList()
	else
		self.uiDnListC:setVisible(true)
	end

	self:updateDnList()
end

--- 隐藏下拉列表
function T:hideDnList()
	if self.uiDnListC then
		self.uiDnListC:setVisible(false)
	end
end

--- 更新下拉列表数据
function T:updateDnList()
	local uiDnList=self.uiDnList

	if uiDnList then
		uiDnList:removeAllItems()

		local hL=DataStorage:getHistoryLoginData() or {}

		local lAccount=DataStorage:getLoginData()
		if lAccount and not lAccount.isTourist then
			table.insert(hL,1,lAccount)
		end

		--正在输入的账号ID
		local inputingUid=self.uiNameInput:getText()

		for k,v in ipairs(hL) do
			if v.uid ~= inputingUid then

				if k ~= 1 then
					uiDnList:pushBackCustomItem(self.ItemSep())
				end

				uiDnList:pushBackCustomItem(self:createHistoryItem(v))
			end
		end
	end
end

--- 创建历史记录条目
function T:createHistoryItem(historyData)
	local uiItem=self.LoginHistoryItem()
	uiItem:setLabelAttributeName("uid")
	uiItem:setData(historyData)

	--选择条目
	uiItem:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self:selectHistoryItem(t)
		end
	end)

	--删除条目
	uiItem:luaAddEventListener("delete",self,self.deleteHistoryItem)
	
	return uiItem
end

--- 选择历史记录条目
-- @param selItem 被选择的条目
function T:selectHistoryItem(selItem)
	local data=selItem:getData()
	if data then
		self.uiNameInput:setText(data.uid)
		self.loginData.uid=data.uid

		self.uiPWDInput:setText(data.pwd)
		self.loginData.pwd=data.pwd

		--关闭下拉列表
		self.uiDnListButton:setIsSelected(false)
	end
end

--- 删除指定的历史记录条目
-- @param delItem 需要删除的历史记录条目
function T:deleteHistoryItem(delItem)
	local delData=delItem:getData()
	if delData then
		local delUID=delData.uid
		local hL=DataStorage:getHistoryLoginData() or {}
		
		local lAccount=DataStorage:getLoginData()
		if lAccount and not lAccount.isTourist and delUID == lAccount.uid then
			MUIAlter.show({
				info=Language:get("ug_lastLoginAccontDelTip"),
				flag=3,
				callback=function(flag)
					if flag == FLAG_OK then
						DataStorage:putLoginData(nil)
						
						self:updateDnList()
					end
				end
			})
			return
		end

		for k,v in ipairs(hL) do
			if v.uid == delUID then
				table.remove(hL,k)

				DataStorage:putHistoryLoginData(hL)
				self:updateDnList()

				break
			end
		end
	end
end

--- 设置数据
function T:setData(loginData)
	self.loginData=loginData

	if loginData and not loginData.isTourist then
		self.uiNameInput:setText(loginData.uid)
		self.uiPWDInput:setText(loginData.pwd)
	else
		self.uiNameInput:setText("")
		self.uiPWDInput:setText("")
	end
end
--- 获取数据
function T:getData()
	return {
		uid=self.uiNameInput:getText(),
		pwd=self.uiPWDInput:getText()
	}
end

return T
