--- 服务器列表项
local T=Class.ServerListItem(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 是否被选择
	self._isSelected=false

	--- 服务器数据
	-- _data
end

function T:ctor()
	AbstractUI.ctor(self)

	self:init()
end

function T:init()
	local f=ResLoader:getSpriteFrame("loadingGeneralButton_normal.png")
	local fs=f:getOriginalSize()

	self:setContentSize(fs)

	--背景
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	REL:toOther("center","middle",uiBack,self,0,0)
	self.uiBack=uiBack

	--服务器名
	local uiSName=XMLLabel()
	uiSName:setAlign("center","middle")
	self:addChild(uiSName)
	REL:relOther(uiSName,self,4,72,0,0)
	self.uiSName=uiSName

	--服务器状态
	local uiSState=XMLLabel()
	uiSState:setAlign("center","middle")
	self:addChild(uiSState)
	REL:relOther(uiSState,self,4+uiSName:getWidth(),4,0,0)
	self.uiSState=uiSState
end

--- 创建被选择图标
function T:createSelectedIcon()
	local uiSelIcon=cc.Sprite:createWithSpriteFrameName("needEnoughIcon.png")
	self:addChild(uiSelIcon)
	REL:toOther("left","bottom",uiSelIcon,self,-8,-8)
	self.uiSelIcon=uiSelIcon
end

--- 更新视图
function T:updateView()
	local data=self._data
	if data then
		self.uiSName:setString(data.name)

		if data.state == ServerListMgr.SERVER_STATE_RECOM then
			self.uiSState:setString(Language:get("ug_serverstate_recom"))
		else
			self.uiSState:setString(Language:get("ug_serverstate_busy"))
		end
	else
		self.uiSName:setString(nil)
		self.uiSState:setString(nil)
	end
end

--- 更新选择状态
function T:updateSelectedState()
	if self._isSelected then
		if self.uiSelIcon then
			self.uiSelIcon:setVisible(true)
		else
			self:createSelectedIcon()
		end
	else
		if self.uiSelIcon then
			self.uiSelIcon:setVisible(false)
		end
	end
end

--- 设置服务器数据
function T:setData(value)
	if value ~= self._data then
		self._data=value

		self:updateView()
	end
end
--- 获取服务器数据
function T:getData()
	return self._data
end

--- 设置是否被选择
function T:setIsSelected(value)
	if value ~= self._isSelected then
		self._isSelected=value

		self:updateSelectedState()
	end
end
--- 获取是否被选择
function T:getIsSelected()
	return self._isSelected
end

return T
