local _print=print
local function print(...)
	_print("\t<UpdateView>: ",table.concat({...},"\t"))
end

--- 更新视图
local T=Class.LoginView(
	function()
		return ccui.Layout:create()
	end
)

function T:def()

end

function T:ctor()
	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)

	self:init()
end

function T:onEnter()

end

function T:onExit()

end

function T:cleanUp()

end

function T:init()
	REL:relScreen(self,0,0,0,0)

	--进度条背景
	local uiProgressBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("loadingProgressBack.png"))
	self:addChild(uiProgressBack)
	REL:toScreen("center","middle",uiProgressBack,0,0)
	self.uiProgressBack=uiProgressBack

	--进度条
	local uiProgressFore=cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("loadingProgressFore.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	self:addChild(uiProgressFore)
	REL:toOther("center","middle",uiProgressFore,uiProgressBack,0,0)
	self.uiProgressFore=uiProgressFore

	--提示文本
	local uiTip=XMLLabel(Language:get("ug2"))
	uiTip:setAlign("center","middle")
	self:addChild(uiTip)
	REL:relOther(uiTip,uiProgressBack,0,0,0,0)
	self.uiTip=uiTip
end

--- 执行更新
function T:execUpdate(callback)
	local completeHandler=function()
		print("更新完成")

		self:removeFromParent()
		if callback then
			callback(0)
		end
	end

	local progressHandler=function(percent)
		--print("更新进度:"..percent)

		self.uiProgressFore:setPercentage(percent)
	end

	local errHandler=function(errCode)
		if errCode == cc.ASSETSMANAGER_NETWORK then
			MUIAlter.show({
				info = Language.get("ug18")
			})
		end
		if callback then
			callback(-1)
		end
	end

	ResUpdate:execUpdate(completeHandler,progressHandler,errHandler)
end

return T
