--[[
 *	邮件信息项
]]

local T = class("T",function() return ccui.Layout:create() end)

--- 邮箱中的每一项的数据结构
T.info = nil

--- 标记,1:普通邮件，2:报告，3.发件箱,4：显示后10个  
T.tag = nil

--- 构造函数
function T:ctor(tag,info,listView)
    self.tag = tag
    self.info = info
    self.listView = listView

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    -- 得到控件
    if tag ~= 4 then
        self:_getWidget()
    end
    

    -- 显示数据:里面有事件
    self:_showData()

end

function T:onEnter()
    if self.tag ~= 4 then
        -- 读取邮件
        local function readMailFinish()
            self:judgeIsRead()
        end
        self.readMailFinish = readMailFinish
        MailManager:luaAddEventListener(MailManager.EVT_TYPE_READ_MAIL .. self.tag .. self.info.id,nil,self.readMailFinish)

        -- 删除邮件
        local function deleteMailFinish()
            local index = self.listView:getIndex(self)
            local listView = self.listView
            self.listView:removeItem(index)
            listView:refreshView()
        end
        self.deleteMailFinish = deleteMailFinish
        MailManager:luaAddEventListener(MailManager.EVT_TYPE_DELETE_ONE_MAIL .. self.tag .. self.info.id,nil,self.deleteMailFinish)
    end

end

function T:onExit()
    if self.tag ~= 4 then
        MailManager:luaRemoveEventListener(MailManager.EVT_TYPE_READ_MAIL .. self.tag .. self.info.id,nil,self.readMailFinish)
        MailManager:luaRemoveEventListener(MailManager.EVT_TYPE_DELETE_ONE_MAIL .. self.tag .. self.info.id,nil,self.deleteMailFinish)
    end

end

function T:_getWidget()
    --- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("mailNotRead.png",ccui.TextureResType.plistType)
    self:addChild(back)
    self.back = back

    self.size = cc.size(626,125)  -- 图片的大小为125
    self:setContentSize(self.size)
    REL:relOther(back,self,5,0,0,0)

    --- 头像
--    local head = ccui.ImageView:create()
--    head:loadTexture("mailIconOpened.png",ccui.TextureResType.plistType)
--    self:addChild(head)
--    REL:toOther("left","middle",head,back,12,0)
--    self.head = head

    --- 标题
    local title = XMLLabel()
    title:setContentSize(cc.size(480,27))
    title:setVAlign("bottom")
    self:addChild(title)
    REL:toOther("left","bottom",title,back,120,70)
    self.title = title

    --- 简要描述
    local describe = XMLLabel()
    describe:setContentSize(cc.size(400,27))
    self:addChild(describe)
    REL:toOther("left","middle",describe,back,120,-20)
    self.describe = describe

    --- 时间
    local time = XMLLabel()
    time:setContentSize(cc.size(400,27))
    time:setHAlign("right")
    self:addChild(time)
    REL:toOther("right","middle",time,back,45,-20)
    self.time = time

    self.chooseBool = false -- 代表没选中
    --- 钩钩框
    local checkLayout = ccui.Layout:create()
    checkLayout:setContentSize(cc.size(60,60))
    self:addChild(checkLayout)
    REL:toOther("right","middle",checkLayout,time,-50,-3)

--    checkLayout:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	checkLayout:setBackGroundColor(cc.c3b(0xff,0,0))
--	checkLayout:setBackGroundColorOpacity(100)

    local checkBottom = ccui.ImageView:create()
    checkBottom:loadTexture("checkBottom.png",ccui.TextureResType.plistType)
    self:addChild(checkBottom)
    REL:toOther("center","middle",checkBottom,checkLayout,0,0)

    -- 加一个奖励的图标
    if self.info.isHasAward and self.info.isHasAward == true then
        local awardIcon = ccui.ImageView:create()
        awardIcon:loadTexture("barOfGift.png",ccui.TextureResType.plistType)
        awardIcon:setScale(50/72,50/71)
        self:addChild(awardIcon)
        REL:toOther("right","middle",awardIcon,back,200,-20)
        self.awardIcon = awardIcon

    end



    checkLayout:setTouchEnabled(true)
    checkLayout:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.chooseBool == false then
                self.chooseBool = true

                if not self.needEnoughIcon then
                    local needEnoughIcon = ccui.ImageView:create()
                    needEnoughIcon:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
                    self:addChild(needEnoughIcon)
                    REL:toOther("center","middle",needEnoughIcon,checkBottom,0,0)
                    self.needEnoughIcon = needEnoughIcon
                end

                self.needEnoughIcon:setVisible(true)

            else
                self.chooseBool = false

                if self.needEnoughIcon then
                    self.needEnoughIcon:setVisible(false)
                end


            end
        end
    end)

end

function T:_showData()
    self:setTouchEnabled(true)
    BaseButton:extend(self)

    local tag = self.tag
    local info = self.info
    if tag == 4 then
        -- 背景图片
        local backFrame = ResLoader:getSpriteFrame("taskTagBack.png")
        local backFrameSize = backFrame:getOriginalSize()
        local back = Scale9Sprite:createWithFrame(backFrame,cc.rect(backFrameSize.width/2,backFrameSize.height/2,1,1))
	    self:addChild(back)

        self.size = cc.size(640 - 12,backFrameSize.height)
        self:setContentSize(self.size)
        REL:relOther(back,self,0,0,0,0)

        --- 还有10个
        local uiMore = XMLLabel()
        uiMore:setContentSize(cc.size(400,27))
        uiMore:setHAlign("center")
        uiMore:setVAlign("middle")
        self:addChild(uiMore)
        REL:toOther("center","middle",uiMore,back,0,0)
        uiMore:setString(Language:get("uc126"))

        self:addTouchEventListener(function(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                BuildingCommand:GetTenMail(info[1],info[2])
            end
        end)

    else
        -- 这里日期要转化一下，到时写一个函数就行了
        local temp = os.date("*t",info.time) -- 这会生成一个表
        self.time:setString(Language:get("uc78",UnitConversion.date(temp.month),UnitConversion.date(temp.day),UnitConversion.date(temp.hour),UnitConversion.date(temp.min)))

        -- 判断是否已读
        self:judgeIsRead()

        if tag == 1 then 
            self.title:setString(Language:get("uc269",info.title))
            if info.type == 0 then
                self.describe:setString(Language:get("uc82"))
--                -- 加个附字
--                self:addAttach()
            else
                self.describe:setString(Language:get("uc80",info.sourceName))
            end

        elseif tag == 3 then
            self.title:setString(Language:get("uc269",info.title))
            if info.type == 0 then
                self.describe:setString(Language:get("uc84"))
--                self:addAttach()
            else
                self.describe:setString(Language:get("uc81",info.sourceName))
            end

        else -- 为tag == 2
            if info.type == 0 then
                self.describe:setString(Language:get("uc82"))
--                self:addAttach()
            else
                
            end

            if info.resourceType then -- 说明是侦查报告
                self.title:setString(Language:get("uc460",info.targetName2))

            else
                if info.resultType == 1 or info.resultType == 2 then
                    if info.realTitle1 then
                        self.title:setString(Language:get("uc240",info.realTitle2))
                    else
                        self.title:setString(Language:get("uc240",info.title))
                    end
            
                elseif info.resultType == 3 or info.resultType == 4 then
                    if info.realTitle1 then
                        self.title:setString(Language:get("uc833",info.realTitle2))
                    else
                        self.title:setString(Language:get("uc241",info.title))
                    end
                else
                    self.title:setString(Language:get("uc242"))
                end
            end



        end

        self:addTouchEventListener(function(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                -- 查看邮件
                local temp = nil
                if tag == 1 then
                    temp = MailManager.mailContentBox.commonMailContentBox.commonMailContents[info.id]
                elseif tag == 2 then
                    temp = MailManager.mailContentBox.mailFightReportContentBox.mailFightReportContents[info.id]
                else
                    temp = MailManager.mailContentBox.sendMailContentBox.sendMailContents[info.id]
                end
                
                if temp == nil then  -- 不能根据是否已读来判断，而是根据判断内容中这项是否存在，因为下次登录的时候全局数据为空
                    -- 考虑 侦查
                    if info.resourceType then
                        self:ReadMailLogic()
                    else
                        local function finish()
                            self:ReadMailLogic()
                        end
                        BuildingCommand:ReadMail(tag,info.id,finish)
                    end


                else
                    self:ReadMailLogic()
                end

            end
        end)


    end
end

--- 读取邮件逻辑
function T:ReadMailLogic()
    self:judgeIsRead()
    if self.tag == 1 or self.tag == 3 then     
        local tempWindow = require("src.app.uiScript.components.mail.ReadMailWindow").new(self.tag,self.info)
        WindowManager:push(tempWindow) -- 压入窗口
    else
        if self.info.resourceType then
            local temp = require("src.app.uiScript.scenes.scout.ScoutMainWindow").new(self.info)
			WindowManager:push(temp)
        else
            -- 进入战报页面
            local fightContent = MailManager.mailContentBox.mailFightReportContentBox.mailFightReportContents[self.info.id]
            local tempWindow = require("src.app.uiScript.components.mail.fightReportContent.FightReportWindow").new(self.tag,self.info,fightContent)
            WindowManager:push(tempWindow) -- 压入窗口
        end

    end
end

function T:judgeIsRead()
    if self.info.isRead == true then
        self.back:loadTexture("mailHasRead.png",ccui.TextureResType.plistType)
        --self.head:loadTexture("mailIconOpened.png",ccui.TextureResType.plistType)
    else
        self.back:loadTexture("mailNotRead.png",ccui.TextureResType.plistType)
        --self.head:loadTexture("mailIconClosed.png",ccui.TextureResType.plistType)
    end
end

--- 加个附字
function T:addAttach()
    self.describe:updateView()
    local contentWidth = self.describe:getTextWidth()
    
    local mailAttach = ccui.ImageView:create()
    mailAttach:loadTexture("mailAttach.png",ccui.TextureResType.plistType)
    self:addChild(mailAttach)
    REL:toOther("left","middle",mailAttach,self.back,140 + contentWidth + 10,-22)
    self.mailAttach = mailAttach

    
end

--- 得到是否被选中，然后如果是2类型的即报告类型的，可能存在侦查报告那种
function T:getChooseId()
    if self.chooseBool == true then
        if self.tag == 2 then
            if self.info.resourceType then -- 是侦查报告
                return { judge = true,value = self.info.id}
            else -- 是战斗报告
                return { judge = false,value = self.info.id}
            end

        else
            return self.info.id
        end
    else
        return nil
    end

end



return T
