--[[
 *	邮件view
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 每项的信息
T.MailItem = require("src.app.uiScript.components.mail.MailItem")

--- 构造函数
function T:ctor(tag)
    self.tag = tag
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,4,0,10,0)
    self.listView = listView

    self:_addToListview() 

    self:_addEventListenr() -- 添加 监听

    -- 增加滚动事件
    ccui.ScrollView.addEventListener(listView,function (t,e)
        if self.id then
            self:ScrollDownLogic()
        end
        
	end)

end

function T:ScrollDownLogic()
    local pos = self.listView:getInnerContainer():getPositionY()
    local size = self.listView:getContentSize()
    if pos < size.height / 5 + 10  and pos > size.height / 5 - 10 then
        BuildingCommand:GetTenMail(self.tag,self.id)
    end
end


function T:_addEventListenr()
    -- 删除所有邮件
    local function finish()
        self.listView:removeAllItems()
    end
    self.finish = finish
    MailManager:luaAddEventListener(MailManager.EVT_TYPE_DELETE_ALL_MAIL .. self.tag,nil,self.finish)

    -- 在listview的顶部加入一封邮件,listView的默认索引应该是从0开始的
    local function addMail(mailInfo)
        local data = mailInfo
        local mailItem = self.MailItem.new(self.tag,mailInfo)
        self.listView:insertCustomItem(mailItem,0)
        self.listView:refreshView()
    end
    self.addMail = addMail
    MailManager:luaAddEventListener(MailManager.EVT_TYPE_RECEIVE_MAIL .. self.tag,nil,self.addMail)

    -- 接下来最多10条数据刷新
    MailManager:luaAddEventListener(MailManager.EVT_TYPE_GET_TEN_MAIL .. self.tag,self,self.getTenMailLogic)
end
--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    MailManager:luaRemoveEventListener(MailManager.EVT_TYPE_DELETE_ALL_MAIL .. self.tag,nil,self.finish)
    MailManager:luaRemoveEventListener(MailManager.EVT_TYPE_RECEIVE_MAIL .. self.tag,nil,self.addMail)
    MailManager:luaRemoveEventListener(MailManager.EVT_TYPE_GET_TEN_MAIL .. self.tag,self,self.getTenMailLogic)
end

--- 增加到滚动层
function T:_addToListview()
    -- 存储的表的时候，按id从高到底进行排序，存储到表中，因为有时间顺序的
    local mailList = nil

    local tempList = {}
    local tempListIdFromHighToLow = {}

    local mailInfosTable = MailManager:getMailBoxByIndex(self.tag)
    tempList = mailInfosTable[1]
    local mailBool = mailInfosTable[2]

    if tempList ~= nil then
        local i = 1
        for k,v in pairs(tempList) do  -- 有可能中间是nil
            if v then
                tempListIdFromHighToLow[i] = v
                i = i + 1
            end
        end        
        table.sort(tempListIdFromHighToLow,function(x,y) return x.id > y.id end)

        mailList = tempListIdFromHighToLow

        local length = #mailList
        for i = 1,length,1 do 
            local info = mailList[i]
            if info then
                local res = self.MailItem.new(self.tag,info,self.listView)
                self.listView:pushBackCustomItem(res)
            end
        end

        if mailBool == true then  -- 如果有接下来的10个，那就在表后面添加一个数据；封装了一个bool值和结束的id(这个id是最小的id，上面已经排序了，是最小的id)
            local info = {self.tag,mailList[length].id}  -- 只管所以数据的最小id,不用更新
            local res = self.MailItem.new(4,info) 
            self.listView:pushBackCustomItem(res)
            self.moreRes = res
            self.id = mailList[length].id
        end
    end
    self.mailList = mailList
end

function T:getTenMailLogic()
    local lastList = self.mailList
    if not lastList then return end

    local count = self.listView:getChildrenCount()
    if not count or count < 0 then return end  
    local lastNum = count - 1  -- 因为最底部有1条数据
    
    local tempList = {}
    local tempListIdFromHighToLow = {}
    local mailInfosTable = MailManager:getMailBoxByIndex(self.tag)
    tempList = mailInfosTable[1]
    local mailBool = mailInfosTable[2]
    if tempList ~= nil then

        if self.moreRes then
            local index = self.listView:getIndex(self.moreRes)
            self.listView:removeItem(index)
            self.listView:refreshView()
            self.moreRes = nil
            self.id = nil
        end

        local i = 1
        for k,v in pairs(tempList) do  -- 有可能中间是nil
            if v then
                tempListIdFromHighToLow[i] = v
                i = i + 1
            end
        end        
        table.sort(tempListIdFromHighToLow,function(x,y) return x.id > y.id end)

        local newNum = #tempListIdFromHighToLow
        for i = lastNum + 1,newNum,1 do 
            local info = tempListIdFromHighToLow[i]
            if info then
                local res = self.MailItem.new(self.tag,info,self.listView) 
                self.listView:pushBackCustomItem(res)
            end
        end

        if mailBool == true then  
            local info = {self.tag,tempListIdFromHighToLow[newNum].id}
            local res = self.MailItem.new(4,info)
            self.listView:pushBackCustomItem(res)
            self.moreRes = res
            self.id = tempListIdFromHighToLow[newNum].id
        end
    end
    self.mailList = tempListIdFromHighToLow

end


--- 得到选择的id表
function T:getChooseIds()
    local listView = self.listView
    
    local count = self.listView:getChildrenCount()
    if not count or count < 0 then return nil end  -- 反正空值代表可以删除全部的邮件,但是这种情况应该不存在，因为在那边已经判断了

    if self.tag == 2 then
        local idScout = {}
        local idReport = {}


        for i = 0,count - 1,1 do
            local item = listView:getItem(i)
            local allValue = item:getChooseId()

            if allValue then
                if allValue.judge == true then
                    idScout[#idScout + 1] = allValue.value
                else
                    idReport[#idReport + 1] = allValue.value
                end
            end

        end

        return idScout,idReport


    else
        local ids = {}
        for i = 0,count - 1,1 do
            local item = listView:getItem(i)
            local value = item:getChooseId()
            if value then
                ids[#ids + 1] = value
            end
        end

        if #ids > 0 then
            return ids
        else
            return nil
        end

    end


end



return T