--[[
 *	普通和发件箱读取邮箱主窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)

--- 哪个标签页的标记,1:普通,3：发件箱
T.tag = nil

--- 邮箱信息
T.mailItem =  nil

--- 奖励品数据解析器
T.AwardDataDecoder = require("src.app.communication.award.AwardDataDecoder")


--- 构造函数
function T:ctor(tag,mailItem)
    self.tag = tag
    self.mailItem = mailItem

    self:init()

    self:addAward()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end


function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)
end

function T:init()
    self:setWindowTitle(Language:get("uc85"))

    --- 背景图片
    local viewBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
    local viewBackFrameSize = viewBackFrame:getOriginalSize()
    local viewBack = Scale9Sprite:createWithFrame(viewBackFrame,cc.rect(viewBackFrameSize.width/2,viewBackFrameSize.height/2,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)

    --- 上面背景图
    local topBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
    local topBackFrameSize = topBackFrame:getOriginalSize()
    local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackFrameSize.width/2,topBackFrameSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(620,100))
    REL:toOther("center","top",topBack,viewBack,0,5)

    --- 收件人
    local reveiveTitle = XMLLabel()
    reveiveTitle:setContentSize(cc.size(400,27))
    self:addChild(reveiveTitle)
    REL:toOther("left","top",reveiveTitle,topBack,20,18)
    if self.tag == 1 then
        reveiveTitle:setString(Language:get("uc128"))
    else
        reveiveTitle:setString(Language:get("uc129"))
    end
    

    --- 主题
    local themeTitle = XMLLabel()
    themeTitle:setContentSize(cc.size(400,27))
    self:addChild(themeTitle)
    REL:toOther("left","bottom",themeTitle,topBack,20,15)
    themeTitle:setString(Language:get("uc127"))

    --- 收件人背景图片
    local receiveBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
    local receiveBackFrameSize = receiveBackFrame:getOriginalSize()
    local receiveBack = Scale9Sprite:createWithFrame(receiveBackFrame,cc.rect(receiveBackFrameSize.width/2,receiveBackFrameSize.height/2,1,1))
	self:addChild(receiveBack)
    receiveBack:setContentSize(cc.size(350,44))
    REL:toOther("left","top",receiveBack,topBack,100,5)

    --- 收件人文本
    local receiveContent = XMLLabel()
    receiveContent:setContentSize(cc.size(350,27))
    receiveContent:setVAlign("middle")
    self:addChild(receiveContent)
    REL:toOther("left","middle",receiveContent,receiveBack,5,0)
    receiveContent:setString(self.mailItem.sourceName)

    --- 时间
    local time = XMLLabel()
    time:setContentSize(cc.size(400,27))
    time:setHAlign("right")
    self:addChild(time)
    REL:toOther("right","middle",time,topBack,20,0)
    local temp = os.date("*t",self.mailItem.time) -- 这会生成一个表
    time:setString(Language:get("uc270",UnitConversion.date(temp.month),UnitConversion.date(temp.day),UnitConversion.date(temp.hour),UnitConversion.date(temp.min)))


    --- 主题背景图片
    local themeBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
    local themeBackFrameSize = themeBackFrame:getOriginalSize()
    local themeBack = Scale9Sprite:createWithFrame(themeBackFrame,cc.rect(themeBackFrameSize.width/2,themeBackFrameSize.height/2,1,1))
	self:addChild(themeBack)
    themeBack:setContentSize(cc.size(350,44))
    REL:toOther("left","bottom",themeBack,topBack,100,5)

    --- 主题文本
    local themeContent = XMLLabel()
    themeContent:setContentSize(cc.size(350,27))
    themeContent:setVAlign("middle")
    self:addChild(themeContent)
    REL:toOther("left","middle",themeContent,themeBack,5,0)
    themeContent:setString(self.mailItem.title)

    --- 下面背景图
    local bottomBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
    local bottomBackFrameSize = bottomBackFrame:getOriginalSize()
    local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackFrameSize.width/2,bottomBackFrameSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,viewBack,5,5,107,100)
    self.bottomBack = bottomBack

    --- 内容文本
    local uiDesc = XMLTextArea()
    self:addChild(uiDesc) 
    REL:relOther(uiDesc,bottomBack,10,8,4,4)
    self.uiDesc = uiDesc

    -- 底部删除按钮
    local deleteMail = Button.new("true","false")
    deleteMail:setName("btnBottomDeleteMail")
    deleteMail:setButtonState("button_red_normal.png","button_general_down.png")
    self:addChild(deleteMail)
    deleteMail:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            -- 删除邮件
            local info = Language:get("uc849")
            local function confirm()
                local function finish()
                    WindowManager:pop()
                end
                BuildingCommand:DeleteMail(self.tag,self.mailItem.id,finish)
            end
            MUIPop.MUIImmediate(info,confirm)
        end
    end)

    if self.tag == 1 then
        local content = MailManager.mailContentBox.commonMailContentBox.commonMailContents[self.mailItem.id].content
        uiDesc:setString(content)

        REL:toOther("center","top",deleteMail,bottomBack,100,bottomBack:getContentSize().height + 5) 

        --- 底部回复按钮
        local reBack = Button.new("true","false")
        reBack:setName("btnBottomSendMail")
        reBack:setButtonState("button_yellow_normal.png","button_general_down.png")
        reBack:setButtonPic("editEMailIcon.png")
        self:addChild(reBack)
        REL:toOther("center","top",reBack,bottomBack,-100,bottomBack:getContentSize().height + 5)  
        REL:toOther("center","middle",reBack.buttonPic,reBack,0,15) 

        reBack:addTouchEventListener(function(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                -- 回复邮件
                local temp = require("src.app.uiScript.components.mail.SendMailWindow").new(2,self.mailItem)
                WindowManager:switch(temp)
            end
        end)

        if self.mailItem.type == 0 then -- 系统
            reBack:setIsGray(true)
            reBack:setTouchEnabled(false)
        end

    else -- 发件箱
        local content = MailManager.mailContentBox.sendMailContentBox.sendMailContents[self.mailItem.id].content
        uiDesc:setString(content)

        REL:toOther("center","top",deleteMail,bottomBack,0,bottomBack:getContentSize().height + 5) 

    end

    deleteMail:setButtonPic("delete.png") 
    REL:toOther("center","middle",deleteMail.buttonPic,deleteMail,0,15)

end

--- 只有读取如果有奖励品的话，还要加一个领取奖励品的结构
function T:addAward()
    if self.tag ~= 1 then
        return
    end  

    local mailItem = MailManager.mailContentBox.commonMailContentBox.commonMailContents[self.mailItem.id]
    if mailItem.awardData then
        local awardList = self.AwardDataDecoder:awardResolve2(mailItem.awardData)
        local num = #awardList
        if num > 0 then -- 这里最多3排，1排放5个，中对齐
            local layout = ccui.Layout:create()
            local topHeight = 50
            local itemOffset = 100
            local middleHeight = itemOffset * math.ceil(num/5)
            local bottomHeight = 100

            layout:setContentSize(cc.size(self.bottomBack:getContentSize().width,topHeight + middleHeight + bottomHeight))
            self:addChild(layout)
            REL:toOther("center","bottom",layout,self.bottomBack,0,0)

            REL:relOther(self.uiDesc,self.bottomBack,10,8,4,4 + topHeight + middleHeight + bottomHeight)

            -- 顶部
	        local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
	        local titleBackFrameSize = titleBackFrame:getOriginalSize()
	        local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
	        titleBack:setContentSize(626,43)
	        layout:addChild(titleBack)
	        REL:toOther("center","top",titleBack,layout,1,5)

	        local titleLabel = XMLLabel()
	        titleLabel:setAlign("center","middle")
	        layout:addChild(titleLabel)
            REL:relOther(titleLabel,titleBack,0,0,0,0)
            titleLabel:setString(Language:get("uc1018"))

            -- 中间
            if num >= 1 and num <= 5 then
                local middleLayout = ccui.Layout:create()
                middleLayout:setContentSize(cc.size(itemOffset * num,itemOffset))
                layout:addChild(middleLayout)
                REL:toOther("center","top",middleLayout,layout,0,70)
                for i = 1,num,1 do
                    if awardList[i] then
                        local item = AwardItem.new({awardData = awardList[i],sizeScale = IconManager.baseScale})
                        local offset = (i - 1) * itemOffset + 0
                        middleLayout:addChild(item)
                        REL:toOther("left","top",item,middleLayout,offset + 20,10)
                    end
                    
                end

            else
                local middleLayout = ccui.Layout:create()
                middleLayout:setContentSize(cc.size(itemOffset * 5,itemOffset * math.ceil(num/5)))
                layout:addChild(middleLayout)
                REL:toOther("center","top",middleLayout,layout,0,70)
                for i = 1,num,1 do
                    if awardList[i] then
                        local item = AwardItem.new({awardData = awardList[i],sizeScale = IconManager.baseScale})
                        
                        local left = 0
                        if i%5 == 0 then
                            left  = 0 + (5 - 1) * itemOffset
                        else
                            left = 0 + (i%5 - 1) * itemOffset
                        end

                        local top = 0
                        if i%5 == 0 then
                            top = 0 + (i/5 - 1) * itemOffset
                        else           
                            top = 0 + math.floor(i/5) * itemOffset
                        end


                        middleLayout:addChild(item)
                        REL:toOther("left","top",item,middleLayout,left + 20,top)

                    end
                    
                end
            end



            -- 底部
            local getBtn = Button.new("false","true")
	        getBtn:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
            getBtn:setString(Language:get("uc438"))
	        layout:addChild(getBtn)
	        REL:toOther("center","bottom",getBtn,layout,0,5)
            getBtn:setTextCenter()
            getBtn:addTouchEventListener(function(sender, eventType)
                if eventType == ccui.TouchEventType.ended then
                    local function finish(data)
                        self.AwardDataDecoder:showSuccessWindow(data)
                        self:refresh()
                    end
                    BuildingCommand:GetSysAward(self.mailItem.id,finish)

                end
            end)
            self.getBtn = getBtn
            self:refresh()

        end

    end

end

function T:refresh()
    if self.getBtn then
        local mailItem = MailManager.mailContentBox.commonMailContentBox.commonMailContents[self.mailItem.id]
        if mailItem.isReward and mailItem.isReward == true then
            self.getBtn:setTouchEnabled(false)
            self.getBtn:setIsGray(true)
        else
            self.getBtn:setTouchEnabled(true)
            self.getBtn:setIsGray(false)
        end

    end

end


return T