--- 发送和回复邮箱主窗口
local T = class(
	"T",
	function()
		local o = AbstractWindow.new()
		o.super = AbstractWindow
		return o
	end
)

--- 1：发送 2：普通邮件回复，3：战报回复,4:联盟邮件
T.tag = nil

--- 收件人名字
T.name = nil

--- 收件人主题
T.theme = nil

--- 内容
T.content = nil


--- 构造函数
function T:ctor(tag,mailItem)
	self.tag = tag
	-- 如果是回复的话，则有这条数据
	self.mailItem = mailItem

	self:_getWidget()

	self:_showData()

	self:_setButton()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end


function T:onEnter()
	self.super.onEnter(self)
	local function update(name)
		self.name = name
		self.receiveEditBox:setText(self.name)
	end
	self.update = update
	SocialManager:luaAddEventListener(SocialManager.EVT_ONE_FRIEND_REFRESH,nil,self.update)
end

function T:onExit()
	self.super.onExit(self)
	SocialManager:luaRemoveEventListener(SocialManager.EVT_ONE_FRIEND_REFRESH,nil,self.update)
end

function T:_getWidget()
	--- 背景图片
	local viewBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
	local viewBackFrameSize = viewBackFrame:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(viewBackFrame,cc.rect(viewBackFrameSize.width/2,viewBackFrameSize.height/2,1,1))
	self:addChild(viewBack)
	REL:relOther(viewBack,self.uiContainer,0,0,0,0)

	--- 上面背景图
	local topBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
	local topBackFrameSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackFrameSize.width/2,topBackFrameSize.height/2,1,1))
	self:addChild(topBack)
	topBack:setContentSize(cc.size(620,100))
	REL:toOther("center","top",topBack,viewBack,0,5)

	--FriendLsitView

	--	--- 收件人
	--	local reveiveTitle = XMLLabel()
	--	reveiveTitle:setContentSize(cc.size(400,27))
	--	self:addChild(reveiveTitle)
	--	REL:toOther("left","top",reveiveTitle,topBack,20,18)
	--	self.reveiveTitle = reveiveTitle

	-- 收件人按钮
	local receiveBtn = Button.new("false","true")
	receiveBtn:setButtonState("privateBottom.png","privateBottom.png")
	receiveBtn:setString(Language:get("uc129"))
	self:addChild(receiveBtn)
	REL:toOther("left","top",receiveBtn,topBack,8,8)
	receiveBtn:setTextCenter()

	receiveBtn:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			-- new的有大小
			local layout = FriendLsitView.new()
			local muialter2 = MUIAlter.show(
				{
					title = Language:get("uc415"),
					info = layout,
					flag = 4,
					isShowCloseButton = true,
					callback = function(flag)
					end
				}
			)
			layout:init(muialter2)
		end
	end)

	--- 主题
	local themeTitle = XMLLabel()
	themeTitle:setContentSize(cc.size(400,27))
	self:addChild(themeTitle)
	REL:toOther("left","bottom",themeTitle,topBack,20,15)
	self.themeTitle = themeTitle

	--- 收件人输入框
	local size = cc.size(480,44)  -- 触摸范围和文本显示范围
	local uiReceiveInputBox = InputBox:create(size)
	self:addChild(uiReceiveInputBox)
	REL:toOther("left","top",uiReceiveInputBox,topBack,100,5)
	self.receiveEditBox = uiReceiveInputBox

	--- 主题输入框
	local inputEditBox2 = InputBox:create(size)
	self:addChild(inputEditBox2)
	REL:toOther("left","bottom",inputEditBox2,topBack,100,5)
	self.themeEditBox = inputEditBox2

	--- 内容输入框
	local uiContentInputBox = InputBox:create(cc.size(V_SZ.width-10,50))
	uiContentInputBox:setIsShowMask(true)
	uiContentInputBox:setLocalZOrder(1000)
	uiContentInputBox:setPosition(65536,65536)
	self:addChild(uiContentInputBox)
	self.contentEditBox = uiContentInputBox

	--- 内容背景图片
	local bottomBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
	local bottomBackFrameSize = bottomBackFrame:getOriginalSize()
	local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackFrameSize.width/2,bottomBackFrameSize.height/2,1,1))
	self:addChild(bottomBack)
	REL:relOther(bottomBack,viewBack,5,5,107,100)
	self.bottomBack = bottomBack

	-- 具体的显示内容
	local uiNotice = XMLTextArea()
	self:addChild(uiNotice)
	REL:relOther(uiNotice,bottomBack,10,8,4,4)
	self.uiNotice = uiNotice

	--- 内容触发器
	local uiNoticeToucher = ccui.Layout:create()
	uiNoticeToucher:setTouchEnabled(true)
	self:addChild(uiNoticeToucher)
	REL:relOther(uiNoticeToucher,bottomBack,0,0,0,0)
	self.uiNoticeToucher = uiNoticeToucher

	--- 底部发送按钮
	local send = Button.new("true","false")
	send:setName("btnBottomSendMail")
	send:setButtonState("button_yellow_normal.png","button_general_down.png")
	send:setButtonPic("sendEMailIcon.png")
	self:addChild(send)
	REL:toOther("center","top",send,bottomBack,0,bottomBack:getContentSize().height + 5)
	REL:toOther("center","middle",send.buttonPic,send,0,15)
	self.send = send

end

function T:_showData()
	self:setWindowTitle(Language:get("uc86"))

	--self.reveiveTitle:setString(Language:get("uc129"))
	self.themeTitle:setString(Language:get("uc127"))

	if self.tag == 2 and self.mailItem then
		self.name = self.mailItem.sourceName
		self.theme = self.mailItem.title
		self.receiveEditBox:setText(self.name)
		self.themeEditBox:setText(self.theme)
	elseif self.tag == 3 and self.mailItem then
		self.name = self.mailItem
		self.receiveEditBox:setText(self.name)
	elseif self.tag == 4 then -- 联盟邮件
		self.receiveEditBox:setText(Language:get("uc274"))

		local layout = ccui.Layout:create()
		self:addChild(layout)
		REL:relOther(layout,self.receiveEditBox,0,0,0,0)
		layout:setTouchEnabled(true)
		layout:setLocalZOrder(1000)
	end

end


function T:_setButton()
	-- 发送
	self.send:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local info = Language:get("uc88")
			local function confirm()
				local function finish()
					WindowManager:pop()
					local descripe = Language:get("uc412")
					MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
				end
				if self.tag == 4 then
					BuildingCommand:SendAllianceMail(self.theme,self.content,finish)
				else
					BuildingCommand:SendMail(self.name,self.theme,self.content,finish)
				end
			end
			MUIPop.MUIImmediate(info,confirm)

		end
	end)
	
	self.receiveEditBox:luaAddEventListener("changed",nil,function(t)
		self.name = t:getText()
	end)
	
	self.themeEditBox:luaAddEventListener("changed",nil,function(t)
		self.theme = t:getText()
	end)

	-- 内容
	local uiInputBox = self.contentEditBox
	local uiNotice = self.uiNotice
	self.uiNoticeToucher:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			REL:toScreen("center",nil,uiInputBox,0,0)
			REL:toOther(nil,"bottom",uiInputBox,self.bottomBack,0,uiInputBox:getContentSize().height)

			uiInputBox:setText(uiNotice:getString())

			local changedHandler,endedHandler
			changedHandler=function(t)
				local text=t:getText()
				uiNotice:setString(text)
				self.content = text
			end
			endedHandler=function(t)
				t:luaRemoveEventListener("changed",nil,changedHandler)
				t:luaRemoveEventListener("ended",nil,endedHandler)

				t:setPosition(65536,65536)
			end

			uiInputBox:luaAddEventListener("changed",nil,changedHandler)
			uiInputBox:luaAddEventListener("ended",nil,endedHandler)

			CppCocos2dxUtils:activeEditBox(uiInputBox)
		end
	end)

end


return T
