--[[
 *	战利品
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 奖励品
T.awardData = nil

--- 位置队列
T.posQueue = nil

function T:ctor(awardData)   
    self.awardData = awardData

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:_setSize()

    self:_getWidget()
end

function T:onEnter()
    
end

function T:onExit()
    if self.posQueue then
        self.posQueue = nil
    end
end

--- 设置大小
function T:_setSize()
    local awardData = self.awardData
    local size = nil
    if awardData then
        local allNum = 0
        for k,v in pairs(awardData) do
            if v then
                allNum = allNum + 1
            end
        end

        if awardData.props then
            local num = #awardData.props
            allNum = num + allNum - 1
        end

        if awardData.aircrafts then
            local num = #awardData.aircrafts
            allNum = num + allNum - 1
        end

        local heightLength =  math.ceil(allNum/3)
        local topBase = 60
        local baseWidth = 70    -- 基准是70，到时还要看
        size = cc.size(626,baseWidth*heightLength + topBase)  

        -- 初始化位置表
        self.posQueue = Queue()
        for i = 1,allNum,1 do
            -- 商
            local business = math.floor(i/3)
            -- 余数
            local remainder = i%3
            
            local left = nil
            local top = nil
            if remainder == 1 then
                left = 20
            elseif remainder == 2 then
                left = 220
            else  -- 这是0的情况
                left = 420
            end

            if remainder == 0 then
                top = topBase + baseWidth * ( business - 1 )
            else
                top = topBase + baseWidth * business
            end
            local temp = {}
            temp.left = left
            temp.top = top
            self.posQueue:push(temp)
        end
    else
        size = cc.size(626,40)
    end
    self:setContentSize(size)
end

function T:_getWidget()
    -- 图片
    local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
    local titleBackFrameSize = titleBackFrame:getOriginalSize()
    local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
    titleBack:setContentSize(626,43)
    self:addChild(titleBack)
    REL:toOther("center","top",titleBack,self,0,5)

    -- 标题文本
    local titleLabel = XMLLabel()
    titleLabel:setContentSize(cc.size(150,27))
    titleLabel:setHAlign("center")
    titleLabel:setVAlign("middle")    
    self:addChild(titleLabel)
    REL:toOther("center","middle",titleLabel,titleBack,0,0)
    self.awardTitleLabel = titleLabel

    self.awardTitleLabel:setString(Language:get("uc132"))

    -- 信息内容
    if self.awardData then
        self:_addInfo()
    end
end


--- 添加信息内容
function T:_addInfo()
    local awardData = self.awardData
    local iconPath = IconManager.iconPath
    if awardData.exp then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. PlayerAddAttributeIcon_temp[1].icon)
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.exp))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
    end

    if awardData.reputation then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. PlayerAddAttributeIcon_temp[2].icon)
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.reputation))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)  
    end

    if awardData.gems then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. PlayerAddAttributeIcon_temp[2].icon)  -- 钻石图片还没有
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.gems))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
    end

    if awardData.money then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. Prop_temp[1].propIcon)
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.money))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
    end

    if awardData.steel then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. Prop_temp[2].propIcon)
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.steel))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
    end
    if awardData.oil then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. Prop_temp[3].propIcon)
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.oil))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1]+ 10,0)
    end

    if awardData.silicon then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. Prop_temp[4].propIcon)
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.silicon))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
    end

    if awardData.titanium then
        local img,info = self:_getImageAndLabel()
        img:loadTexture(iconPath .. Prop_temp[5].propIcon)
        img:setScale(IconManager.resScale[1],IconManager.resScale[2])
        info:setString(Language:get("uc165",awardData.titanium))
        local temp = self.posQueue:pop()
        REL:toOther("left","top",img,self,temp.left,temp.top)
        REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
    end

    if awardData.props then
        local num = #awardData.props
        for i = 1,num,1 do
            local sid = awardData.props[i].sid
            local count = awardData.props[i].count

            local img,info = self:_getImageAndLabel()
            img:loadTexture(iconPath .. Prop_temp[sid].propIcon)
            img:setScale(IconManager.resScale[1],IconManager.resScale[2])
            info:setString(Language:get("uc165",count))
            local temp = self.posQueue:pop()
            REL:toOther("left","top",img,self,temp.left,temp.top)
            REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
        end

    end
    if awardData.aircrafts then
        local num = #awardData.aircrafts
        for i = 1,num,1 do
            local sid = awardData.aircrafts[i].sid
            local count = awardData.aircrafts[i].count

            local img,info = self:_getImageAndLabel()
            img:loadTexture(iconPath .. Aircraft_temp[sid].icon)
            img:setScale(IconManager.resScale[1],IconManager.resScale[2])
            info:setString(Language:get("uc165",count))
            local temp = self.posQueue:pop()
            REL:toOther("left","top",img,self,temp.left,temp.top)
            REL:toOther("left","middle",info,img,img:getContentSize().width * IconManager.resScale[1] + 10,0)
        end
    end
end

function T:_getImageAndLabel()
    -- 图片
    local backImg = ccui.ImageView:create()
    self:addChild(backImg)

    -- 文字
    local info = XMLLabel()
    info:setContentSize(cc.size(150,27))
    self:addChild(info)

    return backImg,info
end

return T