--- 战斗信息
local T = class("T",function() return ccui.Layout:create() end)

--- 战斗信息
T.fightInfo = nil

--- 战斗内容
T.fightContent = nil


function T:ctor(fightInfo,fightContent)
	self.fightInfo = fightInfo
	self.fightContent = fightContent

	local size = cc.size(626,200)
	self:setContentSize(size)

	self:_getWidget()
	self:_showData()
end

function T:_getWidget()
	-- 图片
	local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
	local titleBackFrameSize = titleBackFrame:getOriginalSize()
	local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
	titleBack:setContentSize(626,43)
	self:addChild(titleBack)
	REL:toOther("center","top",titleBack,self,1,5)
    self.titleBack = titleBack

	-- 标题文本
	local titleLabel = XMLLabel()
	titleLabel:setContentSize(cc.size(150,27))
	titleLabel:setHAlign("center")
	titleLabel:setVAlign("middle")
	self:addChild(titleLabel)
	REL:toOther("center","middle",titleLabel,titleBack,0,0)
	self.fightTitleLabel = titleLabel

	-- 信息内容
	local infoLabel = XMLLabel()
	infoLabel:setContentSize(cc.size(600,200))
	self:addChild(infoLabel)
	REL:toOther("left","top",infoLabel,titleBack,20,titleBack:getContentSize().height + 2)
	self.fightInfoLabel = infoLabel
end

function T:_showData()
	local fightInfo = self.fightInfo
	local fightContent = self.fightContent

	self.fightTitleLabel:setString(Language:get("uc131"))
	local temp = os.date("*t",fightInfo.time) -- 这会生成一个表
	local time = Language:get("uc160",UnitConversion.date(temp.month),UnitConversion.date(temp.day),UnitConversion.date(temp.hour),UnitConversion.date(temp.min))

	local rtype=fightInfo.resultType
	if fightInfo.fightType == FightType.FIGHT_TYPE_ARENA then
		self.fightInfoLabel:setString(Language:get(
			"ug1330",
			(rtype == 1 or rtype == 2) and Language:get("ug1331",fightContent.defenderName) or Language:get("ug1332",fightContent.attackerName),
			time,
			rtype == 1 and Language:get("ug1333") or
			rtype == 2 and Language:get("ug1334") or
			rtype == 3 and Language:get("ug1335") or
			rtype == 4 and Language:get("ug1336")
		))
	else
        local honor = nil
        if fightContent.honor == 0 then
            honor = Language:get("uc1024",fightContent.honor)
        elseif fightContent.honor > 0 then
            honor = Language:get("uc1022",fightContent.honor)
        else
            honor = Language:get("uc1023",fightContent.honor)
        end


		if rtype == 1 or rtype == 2 then
			local name = fightContent:realDefend(fightInfo.realTitle1)

			if fightContent.thirdName then
				self.fightInfoLabel:setString(Language:get(
					"uc248",
					name,
					fightContent.realThirdName,
					fightContent.realBattleField,
					fightContent.battleFieldX,
					fightContent.battleFieldY,
					time,
					self:returnUTFByResult(rtype),
					honor
				))
			else
                if name == fightContent.defenderName then  -- 这里由于颜色要改变，表明打的不是npc
                    self.fightInfoLabel:setString(Language:get(
					    "uc130",
					    name,
					    fightContent.realBattleField,
					    fightContent.battleFieldX,
					    fightContent.battleFieldY,
					    time,
					    self:returnUTFByResult(rtype),
					    honor
				    ))
                else
                    self.fightInfoLabel:setString(Language:get(
					    "uc845",
					    name,
					    fightContent.realBattleField,
					    fightContent.battleFieldX,
					    fightContent.battleFieldY,
					    time,
					    self:returnUTFByResult(rtype),
					    honor
				    ))
                end
			end

		else
			if fightContent.thirdName then
				self.fightInfoLabel:setString(Language:get(
					"uc249",
					fightContent.realThirdName,
                    fightContent.attackerName,
					fightContent.realBattleField,
					fightContent.battleFieldX,
					fightContent.battleFieldY,
					time,
					self:returnUTFByResult(rtype),
					honor
				))
			else
				self.fightInfoLabel:setString(Language:get(
					"uc247",
					fightContent.attackerName,
					fightContent.realBattleField,
					fightContent.battleFieldX,
					fightContent.battleFieldY,
					time,
					self:returnUTFByResult(rtype),
					honor
				))
			end
		end
	end

    self.fightInfoLabel:updateView()
    local contentHeight = self.fightInfoLabel:getTextHeight()
    if fightContent.revenge > 0 then
        contentHeight = contentHeight + 30
    end

    self:setContentSize(cc.size(626,contentHeight + 60))
    REL:toOther("center","top",self.titleBack,self,1,5)
    REL:toOther("center","middle",self.fightTitleLabel,self.titleBack,0,0)
    REL:toOther("left","top",self.fightInfoLabel,self.titleBack,20,self.titleBack:getContentSize().height + 2)

    -- 加一个复仇值
    if fightContent.revenge > 0 then
        local revenge = XMLLabel()
	    revenge:setContentSize(cc.size(300,36))
	    self:addChild(revenge)
	    REL:toOther("left","top",revenge,self.fightInfoLabel,0,self.fightInfoLabel:getTextHeight() + 3)

        local revengeValue = nil
        if fightContent.revenge >= 0 then
            revengeValue = Language:get("uc1020",fightContent.revenge)
        else
            revengeValue = Language:get("uc1021",fightContent.revenge)
        end

        revenge:setString(revengeValue)
    end

end

--- 根据战斗结果的类型来返回字
function T:returnUTFByResult(resultType)
	local result = nil
	if resultType == 1 then
		result = Language:get("uc161")
	elseif resultType == 2 then
		result = Language:get("uc162")
	elseif resultType == 3 then
		result = Language:get("uc163")
	else
		result = Language:get("uc164")
	end

	return result
end

return T
