--[[
 *	战斗损失
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 战斗内容
T.fightContent = nil

function T:ctor(fightInfo,fightContent)
    self.fightInfo = fightInfo
    self.fightContent = fightContent

    self:_setSize()

    self:_getWidget()
end

--- 设置大小
function T:_setSize()
    local baseHeight = 150
    local headHeight = 50

    local fightContent = self.fightContent
    local numAttacker = nil
    if fightContent.attackerLose ~= 0 then
        numAttacker = #fightContent.attackerLose
    else
        numAttacker = 0
    end
    self.numAttacker = numAttacker

    local numDefender  = nil
    if fightContent.defenderLose ~= 0 then
        numDefender = #fightContent.defenderLose
    else
        numDefender = 0
    end
     self.numDefender = numDefender

    local num = math.max(numAttacker,numDefender) -- 得到大的那一个
    local height = 0
    if num == 0 then
        height = baseHeight + headHeight + 40
    else
        local addHeigth = (num - 1) * 30
        height = baseHeight + headHeight +  addHeigth + 40 -- 40是最后那句描述的高度
    end


    self.num = num
    local size = cc.size(626,height)
    self:setContentSize(size)
end
    

function T:_getWidget()
    local fightContent = self.fightContent
    -- 图片
    local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
    local titleBackFrameSize = titleBackFrame:getOriginalSize()
    local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
    titleBack:setContentSize(626,43)
    self:addChild(titleBack)
    REL:toOther("center","top",titleBack,self,0,5)

    -- 标题文本
    local titleLabel = XMLLabel()
    titleLabel:setContentSize(cc.size(200,27))
    titleLabel:setHAlign("center")
    titleLabel:setVAlign("middle")    
    self:addChild(titleLabel)
    REL:toOther("center","middle",titleLabel,titleBack,0,0)
    self.tankTitleLabel = titleLabel

    self.tankTitleLabel:setString(Language:get("uc134"))

    if self.numAttacker ~= 0 then 
        self:_addAttack()
    else
        self:_addNotAttack()
    end

    if self.numDefender ~= 0 then 
        self:_addDefend()
    else -- 没损失
        self:_addNotDefend()
    end

    -- 描述:属于飞机部队损失部分
    local bottomInfo = XMLLabel()
    bottomInfo:setContentSize(cc.size(600,27))
    bottomInfo:setHAlign("center")
    bottomInfo:setVAlign("middle")    
    self:addChild(bottomInfo)
    REL:toOther("center","bottom",bottomInfo,self,0,0)

    bottomInfo:setString(Language:get("uc139"))

    -- 攻击图标
    local attackIcon = ccui.ImageView:create()
    attackIcon:loadTexture("attackArrow.png",ccui.TextureResType.plistType)
    self:addChild(attackIcon)
    REL:toOther("center","top",attackIcon,self,0,130)

end

--- 添加攻击方
function T:_addAttack()
    local fightContent = self.fightContent
    local iconPath = IconManager.iconPath
    --- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("attackName.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("left","top",back,self,25,90)

    -- 攻击方
    local attackLabel = XMLLabel()
    attackLabel:setContentSize(cc.size(310,27))   
    attackLabel:setHAlign("center")
    attackLabel:setVAlign("middle")
    self:addChild(attackLabel)
    REL:toOther("center","bottom",attackLabel,back,0,10)
    attackLabel:setString(fightContent.attackerName)

    -- 攻击方头像
    local attackHead = ccui.ImageView:create()
    self:addChild(attackHead)

    local head = fightContent.attackerHead
    attackHead:loadTexture(PlayerInstance:getPlayerHead(head))

    attackHead:setScale(IconManager.chatScale[1],IconManager.chatScale[2])
    REL:toOther("center","top",attackHead,back,0,10)

    --- 攻击方战机
    local attackerLose = fightContent.attackerLose
    local num = #attackerLose
    for i = 1,num,1 do
        local sid = attackerLose[i][1]
        local num = attackerLose[i][2]

        if num > 0 then
            num = '-' .. num  -- 损失传的正，这里必定损失
        end

        local lose = XMLLabel()
        lose:setContentSize(cc.size(400,27))   
        self:addChild(lose)
        local height = attackHead:getContentSize().height * IconManager.chatScale[2]  + 30 * ( i - 1)
        if i == 1 then
            height = height + 5
        end

        REL:toOther("left","top",lose,attackHead,-50,height)
        lose:setString(Language:get("uc138",AircraftUtils:getRichName(Aircraft_temp[sid]),num))

    end


end


--- 添加没损失的攻击方
function T:_addNotAttack()
    local fightContent = self.fightContent
    local iconPath = IconManager.iconPath
    --- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("attackName.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("left","top",back,self,25,90)

    -- 攻击方
    local attackLabel = XMLLabel()
    attackLabel:setContentSize(cc.size(310,27))   
    attackLabel:setHAlign("center")
    attackLabel:setVAlign("middle")
    self:addChild(attackLabel)
    REL:toOther("center","bottom",attackLabel,back,0,10)
    attackLabel:setString(fightContent.attackerName)

    -- 攻击方头像
    local attackHead = ccui.ImageView:create()
    self:addChild(attackHead)

    local head = fightContent.attackerHead
    attackHead:loadTexture(PlayerInstance:getPlayerHead(head))

    attackHead:setScale(IconManager.chatScale[1],IconManager.chatScale[2])
    REL:toOther("center","top",attackHead,back,0,10)

end


--- 添加防守方
function T:_addDefend()
    local fightContent = self.fightContent
    local iconPath = IconManager.iconPath
    --- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("beAttackName.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("right","top",back,self,25,90)

    -- 防守方
    local defendLabel = XMLLabel()
    defendLabel:setContentSize(cc.size(310,27))  
    defendLabel:setHAlign("center")
    defendLabel:setVAlign("middle")
    self:addChild(defendLabel)
    REL:toOther("center","bottom",defendLabel,back,0,10)

    local rtype = self.fightInfo.resultType
    local name1 = nil
    local name2 = nil
    if rtype == 1 or rtype == 2 then        
        name1,name2 = fightContent:realDefend(self.fightInfo.realTitle1)
    else
        name1 = fightContent.defenderName
    end
    
    if name2 then
        defendLabel:setString(name2)
    else
        defendLabel:setString(name1)
    end
    

    -- 防守方头像
    local defendHead = ccui.ImageView:create()
    self:addChild(defendHead)

    local head = fightContent.defenderHead
    defendHead:loadTexture(PlayerInstance:getPlayerHead(head))

    defendHead:setScale(IconManager.chatScale[1],IconManager.chatScale[2])
    REL:toOther("center","top",defendHead,back,0,10)

    --- 防守方战机
    local defenderLose = fightContent.defenderLose
    local num = #defenderLose
    for i = 1,num,1 do
        local sid = defenderLose[i][1]
        local num = defenderLose[i][2]

        if num > 0 then
            num = '-' .. num  -- 损失传的正，这里必定损失
        end

        local lose = XMLLabel()
        lose:setContentSize(cc.size(400,27))   
        self:addChild(lose)
        local height = defendHead:getContentSize().height * IconManager.chatScale[2] + 30 * ( i - 1)
        if i == 1 then
            height = height + 5
        end
        REL:toOther("left","top",lose,defendHead,-50,height)
        lose:setString(Language:get("uc138",AircraftUtils:getRichName(Aircraft_temp[sid]),num))

    end

end

--- 没损失
function T:_addNotDefend()
    local fightContent = self.fightContent
    local iconPath = IconManager.iconPath
    --- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("beAttackName.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("right","top",back,self,25,90)

    -- 防守方
    local defendLabel = XMLLabel()
    defendLabel:setContentSize(cc.size(310,27))  
    defendLabel:setHAlign("center")
    defendLabel:setVAlign("middle")
    self:addChild(defendLabel)
    REL:toOther("center","bottom",defendLabel,back,0,10)

    local rtype = self.fightInfo.resultType
    local name1 = nil
    local name2 = nil
    if rtype == 1 or rtype == 2 then        
        name1,name2 = fightContent:realDefend(self.fightInfo.realTitle1)
    else
        name1 = fightContent.defenderName
    end
    
    if name2 then
        defendLabel:setString(name2)
    else
        defendLabel:setString(name1)
    end
    

    -- 防守方头像
    local defendHead = ccui.ImageView:create()
    self:addChild(defendHead)

    local head = fightContent.defenderHead
    defendHead:loadTexture(PlayerInstance:getPlayerHead(head))

    defendHead:setScale(IconManager.chatScale[1],IconManager.chatScale[2])
    REL:toOther("center","top",defendHead,back,0,10)

end


return T