--- 战斗报告窗口
local T = class(
	"FightReportWindow",
	function()
		local o = AbstractWindow.new()
		o.super = AbstractWindow
		return o
	end
)

--- 3个标签的标志,2：报告，4:代表查看他人战报
T.btnTag = nil

--- 数据表
T.fightInfo = nil

--- 构造函数,这个页面只加载listview的json文件，通过看是否存在这项数据，在listview中动态的加入那项；fightInfo是战报简要信息，fightContent是战报详细内容
function T:ctor(btnTag,fightInfo,fightContent)
	self.btnTag = btnTag
	self.fightInfo = fightInfo
	self.fightContent = fightContent

	self.chatTime = TimeUtils:getSyncMillis()/1000 - 15 -- 取出来的就是秒,首先登陆的时候，这个设置为要减个15秒

	--- 调用一下那个函数：设置真正的战斗地点
	self.fightContent:setRealBattleField(self.fightInfo.realTitle1)


	local resultType = self.fightInfo.resultType  -- 如果是聊天里面进来的，不可能出现5这种类型，因为都不会让你发到聊天频道去
	if resultType == 5 then  -- 只显示1个信息
		self:setWindowTitle(Language:get("uc927"))
		self:_result5()
	else
		self:setWindowTitle(Language:get("uc140"))
		self:_initWidget()
		self:_initConfig()
		self:_addToListView()
	end

	-- 底部
	self:_bottomInfo()
	self:_setData()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 初始化控件
function T:_initWidget()
	-- 最大的背景图片
	local viewBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
	local viewBackFrameSize = viewBackFrame:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(viewBackFrame,cc.rect(viewBackFrameSize.width/2,viewBackFrameSize.height/2,1,1))
	local size = self.uiContainer:getContentSize()
	viewBack:setContentSize(size)
	self:addChild(viewBack)
	REL:toOther("center","middle",viewBack,self.uiContainer,0,0)
	self.viewBack = viewBack

	-- 创建listview
	local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,viewBack,2,2,1,100)

	self.listView = listView

end

--- 战斗结果为5那种:攻击无效
function T:_result5()
	-- 最大的背景图片
	local viewBackFrame = ResLoader:getSpriteFrame("inputBoxBack.png")
	local viewBackFrameSize = viewBackFrame:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(viewBackFrame,cc.rect(viewBackFrameSize.width/2,viewBackFrameSize.height/2,1,1))
	local size = self.uiContainer:getContentSize()
	viewBack:setContentSize(size)
	self:addChild(viewBack)
	REL:toOther("center","middle",viewBack,self.uiContainer,0,0)
	self.viewBack = viewBack

	--- 内容
	local text = XMLLabel()
	text:setContentSize(cc.size(620,200))
	self:addChild(text)
	REL:toOther("left","top",text,viewBack,0,0)
	local fightContent = self.fightContent

	if self.fightContent.invalidType == 1 then
		text:setString(Language:get("uc244",fightContent.realBattleField,fightContent.battleFieldX,fightContent.battleFieldY))
	elseif self.fightContent.invalidType == 2 then
		text:setString(Language:get("uc245",fightContent.realBattleField,fightContent.battleFieldX,fightContent.battleFieldY))
	else
		text:setString(Language:get("uc246",fightContent.realBattleField,fightContent.battleFieldX,fightContent.battleFieldY))
	end
end

--- 初始化文件
function T:_initConfig()
	self.FightInfo = require("src.app.uiScript.components.mail.fightReportContent.FightInfo")
	self.FightAward = require("src.app.uiScript.components.mail.fightReportContent.FightAward")
	self.FightResInfo = require("src.app.uiScript.components.mail.fightReportContent.FightResInfo")
	self.FightLossInfo = require("src.app.uiScript.components.mail.fightReportContent.FightLossInfo")
end

--- 加到listview中去
function T:_addToListView()
	local fightInfo = self.fightInfo
	local fightContent = self.fightContent

	-- 加入战斗信息
	local fightInfoLay = self.FightInfo.new(fightInfo,fightContent)
	self.listView:pushBackCustomItem(fightInfoLay)

	-- 加入战利品
	local awardData = fightContent.awardData
	local fightAward = self.FightAward.new(awardData)
	self.listView:pushBackCustomItem(fightAward)

	-- 加入资源信息
	local resources = fightContent.resources
	local fightResInfo = self.FightResInfo.new(resources)
	self.listView:pushBackCustomItem(fightResInfo)

	-- 加入飞机部队损失
	local fightLossInfo = self.FightLossInfo.new(fightInfo,fightContent)
	self.listView:pushBackCustomItem(fightLossInfo)

end


--- 底部按钮和文本信息
function T:_bottomInfo()
	-- 5个按钮

	-- 播放动画
	local btnPlay = Button.new("true","false")
	btnPlay:setName("btnPlay")
	btnPlay:setButtonState("button_green_normal.png","button_general_down.png")
	btnPlay:setButtonPic("playIcon.png")
	self:addChild(btnPlay)
	self._btnPlay = btnPlay

	--- 回复攻击(当遭受攻击的时候)
	local reAttack = Button.new("true","false")
	reAttack:setName("reAttack")
	reAttack:setButtonState("button_yellow_normal.png","button_general_down.png")
	reAttack:setButtonPic("reBackAttack.png")
	self:addChild(reAttack)
	self._reAttack = reAttack

	-- 写邮件
	local btnWrite = Button.new("true","false")
	btnWrite:setName("btnWrite")
	btnWrite:setButtonState("button_green_normal.png","button_general_down.png")
	btnWrite:setButtonPic("sendEMailIcon.png")
	self:addChild(btnWrite)
	self._btnWrite = btnWrite

	-- 删除邮件
	local btnDeleteMail = Button.new("true","false")
	btnDeleteMail:setName("btnDeleteMail")
	btnDeleteMail:setButtonState("button_red_normal.png","button_general_down.png")
	self:addChild(btnDeleteMail)
	self._btnDeleteMail = btnDeleteMail
	btnDeleteMail:setButtonPic("delete.png")


	-- 发送至聊天频道
	local btnSendChat = Button.new("true","false")
	btnSendChat:setName("btnSendChat")
	btnSendChat:setButtonState("button_yellow_normal.png","button_general_down.png")
	btnSendChat:setButtonPic("sendEMailIcon.png")
	self:addChild(btnSendChat)
	self._btnSendChat = btnSendChat

	self:_setButton()

end

--- 设置按钮回调
function T:_setButton()
	local function callback(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local name = sender:getName()
			if name == "btnPlay" then
				if self.isplayBack  then
					local descripe = Language:get("uc309")
					MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
				else
					self:_playAnimation()
				end

			elseif name == "btnWrite" then
				self:_writeMail()
			elseif name == "btnDeleteMail" then
				self:_deleteMail()
			elseif name == "btnSendChat" then
				self:_sendChatChanel()
			else
				self:_reAttackLogic()
			end
		end
	end
	self._btnPlay:addTouchEventListener(callback)
	self._btnWrite:addTouchEventListener(callback)
	self._btnDeleteMail:addTouchEventListener(callback)
	self._btnSendChat:addTouchEventListener(callback)
	self._reAttack:addTouchEventListener(callback)
end

function T:_setData()
	local viewBack=self.viewBack
	local _btnPlay=self._btnPlay
	local _btnDeleteMail=self._btnDeleteMail
	local _reAttack = self._reAttack
	local _btnWrite=self._btnWrite
	local _btnSendChat=self._btnSendChat

	local fightInfo=self.fightInfo
	local fightContent=self.fightContent

	local btns={}

	-- 无战斗则置灰
	if fightContent.isplayBack ~= nil and fightContent.isplayBack == false then
		_btnPlay:setIsGray(true)
		self.isplayBack = true
		--_btnPlay:setTouchEnabled(false)
	end

	if self.btnTag == 4 then
		-- 查看它人的战报
		--		REL:toOther("center","bottom",_btnPlay,viewBack,0,10)
		REL:toOther("center","middle",_btnPlay.buttonPic,_btnPlay,0,15)
		btns[#btns+1]=_btnPlay

		_btnDeleteMail:setVisible(false)
		_btnWrite:setVisible(false)
		_btnSendChat:setVisible(false)
		_reAttack:setVisible(false)
	else
		-- 查看自己战报
		if fightInfo.resultType == 5 then
			-- 攻击无效
			btns[#btns+1]=_btnDeleteMail

			_btnPlay:setVisible(false)
			_btnWrite:setVisible(false)
			_btnSendChat:setVisible(false)
			_reAttack:setVisible(false)
		elseif fightInfo.realTitle1 then
			-- npc
			_btnWrite:setVisible(false)
			_reAttack:setVisible(false)

			btns[#btns+1]=_btnPlay
			btns[#btns+1]=_btnDeleteMail
			btns[#btns+1]=_btnSendChat

		else
			if fightInfo.resultType == 1 or fightInfo.resultType == 2 then
				-- 进攻
				_reAttack:setVisible(false)
				btns[#btns+1]=_btnPlay
				btns[#btns+1]=_btnWrite
				btns[#btns+1]=_btnDeleteMail
				btns[#btns+1]=_btnSendChat
			else
				btns[#btns+1]=_btnPlay

				--竞技场挑战不能复仇
				if fightInfo.fightType == FightType.FIGHT_TYPE_ARENA then
					_reAttack:setVisible(false)
				else
					btns[#btns+1]=_reAttack
				end

				btns[#btns+1]=_btnWrite
				btns[#btns+1]=_btnDeleteMail
				btns[#btns+1]=_btnSendChat
			end
		end
	end

	local tw=require("src.frameworks.cocos.Arrange"):totalWidth(btns,0)
	local left=(viewBack:getContentSize().width*viewBack:getScaleX()-tw)/2
	for k,v in ipairs(btns) do
		REL:toOther("left","bottom",v,viewBack,left ,0)
		left=left+v:getContentSize().width

		REL:toOther("center","middle",v.buttonPic,v,0,15)
	end

end

-- 复仇
function T:_reAttackLogic()
	local function finish(tb)
		local worldCellInfo = require("src.app.uiScript.scenes.homePage.world.HomePageWorldCellInfo")
		local cellInfo = worldCellInfo.new()
		cellInfo:initView(tb,self)
		MUIAlter_custom.show({
			info=cellInfo,
			flag=4,
			isShowCloseButton=true
		})
		cellInfo:setLocalZOrder(200)
	end
	local id = nil
	if self.fightInfo.resultType == 1 or self.fightInfo.resultType == 2 then
		id = self.fightContent.defenderId
	else
		id = self.fightContent.attackerId
	end
	BuildingCommand:RevengeLogic(self.fightContent.attackFieldX,self.fightContent.attackFieldY,id,finish)

end

--- 播放动画
function T:_playAnimation()
	if self.btnTag == 4 then -- 播放它人的
		require("src.app.controler.enterFight.EnterMailReplayOtherFightCommand")(self.fightInfo)
	else
		if self.fightInfo.fightType == FightType.FIGHT_TYPE_ARENA then
			require("src.app.controler.enterFight.EnterArenaChallengeReplayFightCommand")(self.fightInfo.id)
		else
			require("src.app.controler.enterFight.EnterMailReplayFightCommand")(self.fightInfo.id)
		end
	end
end
--- 写邮件
function T:_writeMail()
	local name = nil
	if self.fightInfo.resultType == 1 or self.fightInfo.resultType == 2 then
		name = self.fightContent.defenderName
	else
		name = self.fightContent.attackerName
	end
	local temp = require("src.app.uiScript.components.mail.SendMailWindow").new(3,name)
	WindowManager:switch(temp)
end
--- 删除邮件
function T:_deleteMail()
	local info = Language:get("uc849")
	local function confirm()
		local function finish()
			if self.fightInfo.fightType == FightType.FIGHT_TYPE_ARENA then
				ArenaInfoMgr:clearFightRecord(self.fightInfo.id)
			end

			WindowManager:pop()
		end
		if self.fightInfo.fightType == FightType.FIGHT_TYPE_ARENA then
			--删除竞技场战报
			BuildingCommand:DeleteMail(4,self.fightInfo.id,finish)
		else
			BuildingCommand:DeleteMail(self.btnTag,self.fightInfo.id,finish)
		end
	end
	MUIPop.MUIImmediate(info,confirm)
end
--- 发送至聊天频道
function T:_sendChatChanel()
	local newTime = TimeUtils:getSyncMillis()/1000
	local offsetTime = newTime - self.chatTime
	if offsetTime < 15 then
		MUIPop.SendNextChatTime(15 - math.floor(offsetTime))
		return
	end

	local layout = ccui.Layout:create()
	layout:setContentSize(cc.size(550,200))

	-- 世界
	local btnWorld = Button.new("false","true")
	btnWorld:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
	--btnWorld:setButtonPic("worldChannel.png")
	btnWorld:setString(Language:get("uc251"))
	layout:addChild(btnWorld)
	REL:toOther("center","middle",btnWorld,layout,0,0)
	btnWorld.buttonText:setAlign("center","middle")
	--REL:toOther("left","middle",btnWorld.buttonPic,btnWorld,15,0)
	REL:toOther("center","middle",btnWorld.buttonText,btnWorld,0,0)
	btnWorld:addTouchEventListener(function(s,e)
		if e == ccui.TouchEventType.ended then
			local function finish()
				local time = TimeUtils:getSyncMillis()/1000
				self.chatTime = time
				local descripe = Language:get("uc253")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
			end

			if self.fightInfo.fightType == FightType.FIGHT_TYPE_ARENA then
				BuildingCommand:ShareReport(0,self.fightInfo.id,4,finish)
			else
				BuildingCommand:ShareReport(0,self.fightInfo.id,2,finish)
			end

			if self.muiAlter then
				self.muiAlter:hide()
				self.muiAlter = nil
			end

		end
	end
	)

    local img1 = ccui.ImageView:create()
    img1:loadTexture("worldChannel.png",ccui.TextureResType.plistType)
    layout:addChild(img1)
    REL:toOther("right","middle",img1,btnWorld,200,0)

	local id = UserInfo.allianceBox.myAlliance.id
	if id and id > 0 then -- 有联盟
		REL:toOther("center","middle",btnWorld,layout,0,50)
		--REL:toOther("left","middle",btnWorld.buttonPic,btnWorld,15,0)
		REL:toOther("center","middle",btnWorld.buttonText,btnWorld,0,0)
        REL:toOther("right","middle",img1,btnWorld,200,0)

		-- 联盟,联盟
		local btnGroup = Button.new("false","true")
		btnGroup:setButtonState("bigButton_yellow_normal.png","bigButton_general_down.png")
		--btnGroup:setButtonPic("groupChannel.png")
		btnGroup:setString(Language:get("uc252"))
		layout:addChild(btnGroup)
		REL:toOther("center","middle",btnGroup,layout,0,-50)
		btnGroup.buttonText:setAlign("center","middle")
		--REL:toOther("left","middle",btnGroup.buttonPic,btnGroup,15,0)
		REL:toOther("center","middle",btnGroup.buttonText,btnGroup,0,0)
		btnGroup:addTouchEventListener(function(s,e)
			if e == ccui.TouchEventType.ended then
				local function finish()
					local time = TimeUtils:getSyncMillis()/1000
					self.chatTime = time
					local descripe = Language:get("uc253")
					MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
				end

				if self.fightInfo.fightType == FightType.FIGHT_TYPE_ARENA then
					BuildingCommand:ShareReport(1,self.fightInfo.id,4,finish)
				else
					BuildingCommand:ShareReport(1,self.fightInfo.id,2,finish)
				end

				if self.muiAlter then
					self.muiAlter:hide()
					self.muiAlter = nil
				end

			end
		end
		)

        local img2 = ccui.ImageView:create()
        img2:loadTexture("groupChannel.png",ccui.TextureResType.plistType)
        layout:addChild(img2)
        REL:toOther("right","middle",img2,btnGroup,200,0)

	end

	self.muiAlter = MUIAlter.show(
		{
			title = Language:get("uc250"),
			info = layout,
			flag = 4
		}
	)

end


return T
