--[[
 *	资源信息
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 战斗内容
T.resources = nil

function T:ctor(resources)
    self.resources = resources

    local size = nil
    if resources ~= 0 then
        size = cc.size(626,150)
    else
        size = cc.size(626,40)
    end

    self:setContentSize(size)

    self:_getWidget()
end


function T:_getWidget()
    -- 图片
    local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
    local titleBackFrameSize = titleBackFrame:getOriginalSize()
    local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
    titleBack:setContentSize(626,43)
    self:addChild(titleBack)
    REL:toOther("center","top",titleBack,self,0,5)

    -- 标题文本
    local titleLabel = XMLLabel()
    titleLabel:setContentSize(cc.size(150,27))
    titleLabel:setHAlign("center")
    titleLabel:setVAlign("middle")    
    self:addChild(titleLabel)
    REL:toOther("center","middle",titleLabel,titleBack,0,0)
    self.resTitleLabel = titleLabel

    self.resTitleLabel:setString(Language:get("uc133"))

    local iconPath = IconManager.iconPath

    local resources = self.resources
    if resources ~= 0 then
        for i = 1,5,1 do
            local img,info = self:_getImageAndLabel()
            img:loadTexture(iconPath .. Prop_temp[i].propIcon)
            img:setScale(IconManager.resScale[1],IconManager.resScale[2])
            if resources then
                if resources[i] > 0 then
                    info:setString(Language:get("uc166",UnitConversion.unitTrans(resources[i])))
                else
                    local data = math.abs(resources[i])
                    if data > 0 then
                        info:setString(Language:get("uc272",UnitConversion.unitTrans(data)))
                    else
                        info:setString("0")
                    end
                    
                end
                
            else
                info:setString("0")
            end
            local width = 20 + (img:getContentSize().width * IconManager.resScale[1]  + 70) * (i - 1)
            REL:toOther("left","top",img,self,width,60)
            REL:toOther("center","top",info,img,0,img:getContentSize().height * IconManager.resScale[2] + 2)
        end
    else
        
    end


end

function T:_getImageAndLabel()
    -- 图片
    local backImg = ccui.ImageView:create()
    self:addChild(backImg)

    -- 文字
    local info = XMLLabel()
    info:setContentSize(cc.size(150,27))
    info:setHAlign("center")
    self:addChild(info)

    return backImg,info
end

return T