--[[
 * 道具视图页面
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 1是背包，2是商城 一级菜单标志
T.oneMenuTag = nil

--- 二级菜单标志,1：所有，2：增益，3：宝箱，4：其他
T.twoMenuTag = 1

--- sid表
T.propList = nil

--- 队列数据
T.queue = nil

function T:ctor(oneMenuTag,twoMenuTag)
    self.oneMenuTag = oneMenuTag
    self.twoMenuTag = twoMenuTag
    local list = PropsInfoMgr:getPropOrShopList()
    self.propList = list[oneMenuTag][twoMenuTag]

    self.queue = Queue()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,6,0,0,0)
    self.listView = listView

    self:_addToListview() 

    -- 商城里面购买道具的时候刷新给玩家所拥有的物品，所有给物品刷新
    if self.oneMenuTag == 1 then
        self:_addEventListenr()
    end
    
end

function T:_addEventListenr()
    local function produceProp(propInfo)
        local list = PropsInfoMgr:getPropOrShopList()
        local newPropList = list[self.oneMenuTag][self.twoMenuTag]
        if self.propList ~= newPropList then
            local newNum = #newPropList
            local tag = nil
            for i = 1,newNum,1 do
                if newPropList[i] == propInfo.sid then
                    tag = i
                    break
                end
            end

            if tag then -- listview的开始索引是0
                local res = require("src.app.uiScript.components.prop.PropItem").new(propInfo.sid,self.oneMenuTag,self.listView)
                self.listView:insertCustomItem(res,tag - 1)
                self.listView:refreshView()
            end

            self.propList = newPropList
        end
    end
    self.produceProp = produceProp 
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.produceProp,nil,self.produceProp)
end
--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.produceProp,nil,self.produceProp)
    self.queue:clearT()
    self.queue = nil
end

function T:_addToListview()
    local propList = self.propList
    local num = #propList

    for i = 1,num,1 do
        if propList[i] then
            self.queue:push(propList[i])
        end
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)
end

function T:addRes()
    local sid = self.queue:pop()
    if sid then
        local res = require("src.app.uiScript.components.prop.PropItem").new(sid,self.oneMenuTag,self.listView)
        res:setOpacity(0)
        self.listView:pushBackCustomItem(res)
        res:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end

return T