--[[
 * 物品主窗口，有商城和背包窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end
)

--- 传入的data：1是背包，2是商城 一级菜单标志
T.oneMenuTag = nil

--- 二级菜单标志,默认为1,1：所有，2：增益，3：宝箱，4：其他
T.twoMenuTag = 1

--- 放的是页面所对应的tag值
T.viewTag = nil

--- 构造函数 
function T:ctor(oneMenuTag,openActivity,openActivityData) -- openActivityData开放活动数据
    self.oneMenuTag = oneMenuTag
    self.openActivity = openActivity
    self.openActivityData = openActivityData

    self.viewTag = {{},{}} -- 初始为空值

    if self.oneMenuTag == 3 then
        self.twoMenuTag = 5
    end

    local function callBack1()
        self.oneMenuTag = 1
        self:_swithPage()
    end

    local function callBack2()
        self.oneMenuTag = 2
        self:_swithPage()
    end

    local function callBack3()
        if self.twoMenuTag ~= 5 then
            self.twoMenuTag = 1
            self:_swithPage()
        end 
        self.twoMenuTag = 1
    end

    local function callBack4()
        self.twoMenuTag = 2
        self:_swithPage()
    end

    local function callBack5()
        self.twoMenuTag = 3
        self:_swithPage()
    end

    local function callBack6()
        self.twoMenuTag = 4
        self:_swithPage()
    end


    local function callBack7()
        self.oneMenuTag = 3
        self:buyPage()
    end

    -- 创建2个:这里的标签页的大小是基于容器的大小来设置的，以后可能要改
    if self.openActivity then
        local oneMenuContainer = SwitchButtonContainer.new()
        self:addChild(oneMenuContainer)
        REL:relOther(oneMenuContainer,self.uiContainer,0,0,0,0)
        oneMenuContainer:init()
        oneMenuContainer:initButtons(
            3,
            {{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"}},
            {70,15},
            {callBack1,callBack2,callBack7},
            {Language:get("uc60"),Language:get("uc61"),Language:get("uc799")},
            self.oneMenuTag
        )
        self.oneMenuContainer = oneMenuContainer

    else
        local oneMenuContainer = SwitchButtonContainer.new()
        self:addChild(oneMenuContainer)
        REL:relOther(oneMenuContainer,self.uiContainer,0,0,0,0)
        oneMenuContainer:init()
        oneMenuContainer:initButtons(
            2,
            {{"viewSwitchButton_normal.png","viewSwitchButton_down.png"},{"viewSwitchButton_normal.png","viewSwitchButton_down.png"}},
            {110,15},
            {callBack1,callBack2},
            {Language:get("uc60"),Language:get("uc61")},
            self.oneMenuTag
        )
        self.oneMenuContainer = oneMenuContainer
    end


    -- 二级菜单
    local twoMenuContainer = SwitchButtonContainer.new(0)
    self:addChild(twoMenuContainer)
    REL:relOther(twoMenuContainer,self.uiContainer,0,0,73,0)
    twoMenuContainer:init()
    twoMenuContainer:initButtons(
        4,
        {{"panelSwitchButton_down.png","panelSwitchButton_normal.png"},{"panelSwitchButton_down.png","panelSwitchButton_normal.png"},{"panelSwitchButton_down.png","panelSwitchButton_normal.png"},{"panelSwitchButton_down.png","panelSwitchButton_normal.png"}},
        {50,13},
        {callBack3,callBack4,callBack5,callBack6},
        {Language:get("uc114"),Language:get("uc115"),Language:get("uc116"),Language:get("uc117")}
    )
    self.twoMenuContainer = twoMenuContainer
    twoMenuContainer.viewBack:setVisible(false)

    -- 设置数据
    self:ShowData()

    -- 初始化页面
    if self.oneMenuTag == 3 then
        self:buyPage()
    else
        self:_swithPage()
    end

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:_swithPage()
    if self.timeBuyPage then
        self.timeBuyPage:setVisible(false)
    end

    self.twoMenuContainer:setVisible(true)

    local viewTag = self.viewTag
    local tempList = self.tempList

    for i = 1,2,1 do
        for j = 1,4,1 do
            if i == self.oneMenuTag and j == self.twoMenuTag then
                if viewTag[i][j] == nil then
                    local view = require("src.app.uiScript.components.prop.PropView").new(self.oneMenuTag,self.twoMenuTag)
                    viewTag[i][j] = view 
                    self:addChild(view)
                    REL:relOther(view,self.uiContainer,0,0,148,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
                    view:init()
                end
                if viewTag[i][j] then
                    viewTag[i][j]:setVisible(true)
                end
            else
                if viewTag[i][j] then
                    viewTag[i][j]:setVisible(false)
                end
            end
        end
    end
end

--- 切换到限时购买页面:打开这个分页数据只获取1次
function T:buyPage()
    if self.timeBuyPage == nil then
        if self.openActivityData then
            if ActivityManager.timeLimitBuyInfo:getOpenValue() == true then
                self.timeBuyPage = require("src.app.uiScript.components.prop.timeLimitBuy.TimeLimitBuyView").new(ActivityManager.timeLimitBuyInfo,self.openActivityData)
            else
                self.timeBuyPage = require("src.app.uiScript.components.prop.timeLimitBuy.TimeLimitBuyView").new(ActivityManager.timeLimitBuyInfo2,self.openActivityData)
            end
            self:addChild(self.timeBuyPage)
            REL:relOther(self.timeBuyPage,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
            self.timeBuyPage:init()
        else
            local function finish(data) 
                if ActivityManager.timeLimitBuyInfo:getOpenValue() == true then
                    self.timeBuyPage = require("src.app.uiScript.components.prop.timeLimitBuy.TimeLimitBuyView").new(ActivityManager.timeLimitBuyInfo,data)
                else
                    self.timeBuyPage = require("src.app.uiScript.components.prop.timeLimitBuy.TimeLimitBuyView").new(ActivityManager.timeLimitBuyInfo2,data)
                end
                self:addChild(self.timeBuyPage)
                REL:relOther(self.timeBuyPage,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
                self.timeBuyPage:init()
            end
            if ActivityManager.timeLimitBuyInfo:getOpenValue() == true then
                Command:getDynamicActData(102,finish)
            elseif ActivityManager.timeLimitBuyInfo2:getOpenValue() == true then
                Command:getDynamicActData(202,finish)
            end
            

        end 

    end
    
    if self.timeBuyPage then
        self.timeBuyPage:setVisible(true)
    end

    self.twoMenuContainer:setVisible(false)

    local viewTag = self.viewTag
    local tempList = self.tempList

    for i = 1,2,1 do
        for j = 1,4,1 do
            if viewTag[i][j] then
                viewTag[i][j]:setVisible(false)
            end
        end
    end
end


--- 进入页面显示数据
function T:ShowData()
    self:setWindowTitle(Language:get("uc59"))
end


return T