--[[
 *	限时商店项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 数据
T.data = nil

--- 构造函数
function T:ctor(timeLimitBuyInfo,data)  
    self.timeLimitBuyInfo = timeLimitBuyInfo
    self.data = data

    self.hasBuyNum = self.data.hasBuyNum

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
    
    self:init()

end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()
    
end

function T:init()
    -- 设置项
    local listItem = ListItem3.new()
    listItem:init()
    self:addChild(listItem)

    self.size = listItem:getContentSize()
    self:setContentSize(self.size)

    REL:toOther("left","top",listItem,self,0,0)
    self.listItem = listItem

    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
    self:SetButton()

end


function T:GetWidget()
    -- 头像
    self._imgHead = self.listItem.icon
    
    -- 购买按钮
    self._btnBuy = self.listItem.btnUse

    -- 名字
    self._labelName = self.listItem.title

    -- 描述
    self._labelDescribe = self.listItem.describe

    -- 拥有
    self._hasUse = self.listItem.hasUse

    -- 消耗钻石
    local labelCostDiamond = XMLLabel()
    labelCostDiamond:setHAlign("center")
    labelCostDiamond:setVAlign("middle")
    labelCostDiamond:setContentSize(cc.size(300, 36))
    self:addChild(labelCostDiamond)
    self._labelCostDiamond = labelCostDiamond
    

    -- 原来的价钱
    local lastCostDiamond = XMLLabel()
    lastCostDiamond:setHAlign("center")
    lastCostDiamond:setVAlign("middle")
    lastCostDiamond:setContentSize(cc.size(300, 36))
    self:addChild(lastCostDiamond)
    self.lastCostDiamond = lastCostDiamond

    local layer = CommonMethod:drawLine(40,40)
    lastCostDiamond:addChild(layer)
    REL:toOther("center","middle",layer,lastCostDiamond,0,0)
    lastCostDiamond.layer = layer


end

function T:SetData()
    local serverData = self.data
    
    -- 不变的
    local data = Aircraft_temp[serverData.sid]
    local iconPath = IconManager.iconPath
    self._imgHead:loadTexture(iconPath .. data.icon)

    if serverData.buyNumOfEvery > 1 then
        self._labelName:setString(Language:get("uc1074",Language:get(data.name),serverData.buyNumOfEvery))
    else
        self._labelName:setString(Language:get("uc276",Language:get(data.name)))
    end

    self._labelCostDiamond:setString(Language:get("uc111",serverData.price))

    self._labelDescribe:setString(Language:get(data.describe,data.capacity))

    self._btnBuy:loadTextures("useDiamonButton_normal.png","useDiamonButton_normal.png","",ccui.TextureResType.plistType)
    self._btnBuy:setString(Language:get("uc800"))

    REL:toOther("right", "bottom", self._btnBuy, self.listItem.back, 5, 25)
    REL:toOther("center","middle",self._btnBuy.buttonText,self._btnBuy,0,-10)

    self.lastCostDiamond:setString(serverData.lastPrice)
	self.lastCostDiamond:updateView()
	local contentWidth = self.lastCostDiamond:getTextWidth()
	local contentHeight = self.lastCostDiamond:getTextHeight()
    local draw = self.lastCostDiamond.layer.draw
    if draw then
        draw:clear()
        draw:drawSegment(cc.p(-(contentWidth/2),contentHeight/2), cc.p(contentWidth/2, -contentHeight/2), 1.5, cc.c4f(1, 0, 0, 1))
    end
    REL:toOther("center", "bottom", self.lastCostDiamond, self._btnBuy, 15, 120)
    REL:toOther("center","middle",self.lastCostDiamond.layer,self.lastCostDiamond,0,0)


    REL:toOther("center","middle",self._labelCostDiamond,self._btnBuy,15,38)

    self._hasUse:setHAlign("center")
    REL:toOther("center", "top", self._hasUse, self._imgHead, 0, 115)

    -- 要变的
    self:refreshData()
end

function T:refreshData()
    local serverData = self.data

    local hasBuyNum = self.hasBuyNum


    self._hasUse:setString(Language:get("uc801",hasBuyNum,serverData.allNum))

end

function T:SetButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            if self.hasBuyNum >= self.data.allNum then
                local descripe = Language:get("uc802")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            else
                local function confirm()
                    local nowDiamond = UserInfo.gems
                    local costDiamond = self.data.price
                    if costDiamond <= nowDiamond then

                        local function finish()
                            self.hasBuyNum = self.hasBuyNum + 1
                            if self.hasBuyNum >= self.data.allNum then
                                self.hasBuyNum = self.data.allNum
                            end
                            self:refreshData()

                            local descripe = Language:get("uc804")
				            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

                        end
                        local joinSids = {}
                        joinSids.sid = self.data.sid
                        joinSids.propOrAircraftType = self.data.propOrAircraftType
                        joinSids.buyNumOfEvery = self.data.buyNumOfEvery

                        Command:joinDynamicAct(self.timeLimitBuyInfo.sid,finish,joinSids)

                    else -- 弹出充值页面
                        MUIPop.MUIToReCharge()
                    end

                end

                MUIPop.MUIImmediate(Language:get("uc803",self.data.price),confirm)

            end

        end
    end
    self._btnBuy:addTouchEventListener(callback) 
end


return T
