---关卡排名
local T = class("T",function() return ccui.Layout:create() end)

--- 每项的信息
T.RankItem = require("src.app.uiScript.components.rank.RankItem")

--- 队列数据
T.queue = nil


--- 构造函数
function T:ctor()
	self.queue = Queue()

	--- 正在加载更多数据
	self._isLoading=false

	--- 正在刷新数据项列表
	self._isUpdating=false
end

function T:init()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,self,0,0,0,0)
	self.listView = listView
	self.rankPos = 1
	self:_addToListview()

	RankManager:luaAddEventListener(RankManager.EVT_TYPE_CHECKPOINT_REFRESH,self,self.update)
end


--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()
	RankManager:luaRemoveEventListener(RankManager.EVT_TYPE_CHECKPOINT_REFRESH,self,self.update)
	RankManager.rankCheckPoint.infosQueue:clearT()
	self.queue:clearT()
	self.queue = nil
end


function T:_addToListview()
	local rankInfos = RankManager.rankCheckPoint.infosQueue

	-- 自己的排名
	local info = {}
	info.selfRank = RankManager.rankCheckPoint.selfRank
	info.name = UserInfo.name
	info.level = UserInfo.level
	info.rankValue = BattlesInfoMgr:getTotalStar()
	info.typeData = 2
	self.queue:push(info)

	local length = rankInfos:getLength()
	for i = 1,length,1 do
		local info = rankInfos:pop(i)
		if info then
			info.selfRank = i
			info.typeData = 2
			self.queue:push(info)
		end
	end

	if RankManager.rankCheckPoint.more == true then
		local info = {}
		info.sendType = 2
		info.startPos = RankManager.rankCheckPoint.startPos
		info.typeData = 4
		self.queue:push(info)
	end

	self:runAction(
		cc.RepeatForever:create(
			cc.Sequence:create(
				cc.DelayTime:create(0.1),
				cc.CallFunc:create( function()
					self:addRes()
				end)
			)
		)
	)
end

function T:addRes()
	local info = self.queue:pop()
	if info then
		local res = self.RankItem.new(info.typeData,info,self.rankPos)
		res:setOpacity(0)
		self.listView:pushBackCustomItem(res)
		if info.typeData == 4 then
			self.info = info
		end
		res:runAction(
			cc.FadeIn:create(0.5)
		)
	else
		self:stopAllActions()

		ccui.ScrollView.addEventListener(self.listView,function(t,e)
			if t:getInnerContainer():getPositionY() >= 15 then
				if not self._isUpdating then
					self:loadMore()
				end
			end
		end)
	end

	self.rankPos = self.rankPos + 1
end

--- 扩展排行榜列表(触发"点击加载更多")
function T:loadMore()
	if self._isLoading then
		return
	end
	if not self.info then
		return
	end

	self._isLoading=true
	Command:SendRank(self.info.sendType,self.info.startPos) -- info 是开始位置
end

function T:update()
	self._isLoading=false
	local rankInfos = RankManager.rankCheckPoint.infosQueue

	local length = rankInfos:getLength()
	for i = 1,length,1 do
		local info = rankInfos:pop(i)
		info.selfRank = i + RankManager.rankCheckPoint.startPos - 21
		if info and  i == 1 then
			info.typeData = 5
		else
			info.typeData = 2
		end
		self.queue:push(info)
	end

	if RankManager.rankCheckPoint.more == true then
		local info = {}
		info.sendType = 2
		info.startPos = RankManager.rankCheckPoint.startPos
		info.typeData = 4
		self.queue:push(info)
	end

	self._isUpdating=true
	self:runAction(
		cc.RepeatForever:create(
			cc.Sequence:create(
				cc.DelayTime:create(0.1),
				cc.CallFunc:create( function()
					self:updateRes()
				end)
			)
		)
	)
end

function T:updateRes()
	local info = self.queue:pop()
	if info then
		local res = nil
		if info.typeData == 4 then
			res = self.RankItem.new(info.typeData,info)
			res:setOpacity(0)
			self.listView:pushBackCustomItem(res)
			self.info = info
		elseif info.typeData == 5 then
			local count = self.listView:getChildrenCount()
			res = self.listView:getItem(count - 1)
			res:setOpacity(0)
			res:upData(2,info)
			self.info = nil
		else
			res = self.RankItem.new(info.typeData,info)
			res:setOpacity(0)
			self.listView:pushBackCustomItem(res)
		end
		res:runAction(
			cc.FadeIn:create(0.5)
		)
	else
		self._isUpdating=false
		self:stopAllActions()
	end
end

return T
