--[[
 *	聊天信息项
]]

local T = class("T",function() return ccui.Layout:create() end)

--- 排行榜每一项的数据结构
T.info = nil

--- 标记,1:战斗力，2:关卡，3：荣誉,4：显示后20个  (1,2,3,的info数据结构一样,1,2,3也可以当成自己的排名)
T.tag = nil


--- 构造函数
function T:ctor(tag,info,rankPos)
    self.tag = tag
    self.info = info
    self.rankPos = rankPos


    -- 得到控件
    self:_getWidget()

    -- 显示数据
    self:_showData()

end

function T:_getWidget()
    -- 背景图片
--    local rankBackFrame = ResLoader:getSpriteFrame("rankBack.png")
--    local rankBackFrameSize = rankBackFrame:getOriginalSize()
--    local rankBack = Scale9Sprite:createWithFrame(rankBackFrame,cc.rect(rankBackFrameSize.width/2,rankBackFrameSize.height/2,1,1))
--	self:addChild(rankBack)
--	self.rankBack = rankBack

    self.size = cc.size(630,64)
    self:setContentSize(self.size)
    --REL:relOther(rankBack,self,6,0,0,0)

--  local rankBackFrame = ResLoader:getSpriteFrame("rankBack.png")
--  local rankBackFrameSize = rankBackFrame:getOriginalSize()
--  local rankBack = Scale9Sprite:createWithFrame(rankBackFrame,cc.rect(rankBackFrameSize.width/2,rankBackFrameSize.height/2,1,1))
--	self:addChild(rankBack)
--	self.rankBack = rankBack

    local rankBack = ccui.ImageView:create()
    rankBack:loadTexture("rankBack.png",ccui.TextureResType.plistType)
    self:addChild(rankBack)
    REL:toOther("left","middle",rankBack,self,3,0)
    self.rankBack = rankBack

    -- 排名
    local rank = XMLLabel()
    rank:setAlign("center","middle")
    rank:setContentSize(cc.size(100,36))
    self:addChild(rank)
    REL:toOther("center","middle",rank,rankBack,-250,0)
    self.rank = rank

    -- 姓名
    local name = XMLLabel()
    name:setAlign("center","middle")
    name:setContentSize(cc.size(200,36))
    self:addChild(name)
    REL:toOther("center","middle",name,rankBack,-80,0)
    self.name = name

    -- 等级
    local level = XMLLabel()
    level:setAlign("center","middle")
    level:setContentSize(cc.size(200,36))
    self:addChild(level)
    REL:toOther("center","middle",level,rankBack,100,0)
    self.level = level

    -- 第4个
    local lastText = XMLLabel()
    lastText:setAlign("center","middle")
    lastText:setContentSize(cc.size(100,36))
    self:addChild(lastText)
    REL:toOther("center","middle",lastText,rankBack,250,0)
    self.lastText = lastText

    local uiMore = XMLLabel()
    uiMore:setContentSize(cc.size(400,27))
    uiMore:setHAlign("center")
    uiMore:setVAlign("middle")
    self:addChild(uiMore)
    REL:toOther("center","middle",uiMore,rankBack,0,0)
    self.uiMore = uiMore
end

function T:upData(tag,info)
    self.tag = tag
    self.info = info
    self:_showData()
end

function T:_showData()
    self:setTouchEnabled(true)

    if self.tag == 4 then
        BaseButton:extend(self)

        self.rankBack:loadTexture("rankBack.png",ccui.TextureResType.plistType)

        self.rank:setVisible(false)
        self.name:setVisible(false)
        self.level:setVisible(false)
        self.lastText:setVisible(false)
        if self.medal then
            self.medal:setVisible(false)
        end

        self.uiMore:setVisible(true)

        self.uiMore:setString(Language:get("uc268"))

        self:addTouchEventListener(function(sender, eventType)
            if eventType == ccui.TouchEventType.ended then
                if self.info.sendType and self.info.startPos then
                    Command:SendRank(self.info.sendType,self.info.startPos) -- info 是开始位置
                end
            end
        end)

    else
        local info = self.info

        self.rank:setVisible(true)
        self.name:setVisible(true)
        self.level:setVisible(true)
        self.lastText:setVisible(true)
        self.uiMore:setVisible(false)
        
        if self.rankPos == 1 then
            self:setDataShow(1,"uc661","uc662")
        elseif self.rankPos == 2 then
            self:setDataShow(2,"uc663","uc664")
        elseif self.rankPos == 3 then
            self:setDataShow(3,"uc665","uc666")
        elseif self.rankPos == 4 then
            self:setDataShow(4,"uc667","uc668")
        else
            self:setDataShow(nil,"uc266","uc267")
        end



        --self:setTouchEnabled(true)
    end
end

function T:setDataShow(tagValue,uc1,uc2)
    local info = self.info
    if tagValue == 1 then
        self.rankBack:loadTexture("rankBack.png",ccui.TextureResType.plistType)
        self.rank:setString(Language:get(uc1,info.selfRank))
    elseif tagValue == 2 then
        self.rank:setVisible(false)

        local medal = ccui.ImageView:create()
        medal:loadTexture("LV1.png",ccui.TextureResType.plistType)
        self:addChild(medal)
        REL:toOther("center","middle",medal,self.rankBack,-250,0)
        self.medal = medal
--        medal:setScale(0.6)

        self.rankBack:loadTexture("rankFirst.png",ccui.TextureResType.plistType)
    elseif tagValue == 3 then
        self.rank:setVisible(false)

        local medal = ccui.ImageView:create()
        medal:loadTexture("LV2.png",ccui.TextureResType.plistType)
        self:addChild(medal)
        REL:toOther("center","middle",medal,self.rankBack,-250,0)
        self.medal = medal
--        medal:setScale(0.6)

        self.rankBack:loadTexture("rankSecond.png",ccui.TextureResType.plistType)
    elseif tagValue == 4 then
        self.rank:setVisible(false)

        local medal = ccui.ImageView:create()
        medal:loadTexture("LV3.png",ccui.TextureResType.plistType)
        self:addChild(medal)
        REL:toOther("center","middle",medal,self.rankBack,-250,0)
        self.medal = medal
--        medal:setScale(0.6)

        self.rankBack:loadTexture("rankThree.png",ccui.TextureResType.plistType)
    else
        self.rankBack:loadTexture("rankBack.png",ccui.TextureResType.plistType)
        self.rank:setString(Language:get(uc1,info.selfRank))
    end

    
    self.name:setString(Language:get(uc1,info.name))
    if self.tag == 3 then
        self.level:setString(Language:get(uc1,Language:get(HonorManager:getMilitaryRankName(info.level)))) -- 要改成荣誉对应的名字,并且没有LV,直接是uc1就可以了
    else
        self.level:setString(Language:get(uc2,info.level))
    end
    

    if self.tag == 1 then
        self.lastText:setString(Language:get(uc1,UnitConversion.unitTrans(info.rankValue)))
    elseif self.tag == 2 then
        self.lastText:setString(Language:get(uc1,info.rankValue))
    else
        self.lastText:setString(Language:get(uc1,UnitConversion.unitTrans(info.rankValue)))
    end
end


return T
