--[[
 * 改变密码视图
]]

local T = class(
    "T",
    function() 
        local o = AbstractWindow.new("windowBack2.jpg")
        o.super = AbstractWindow
        return o
    end
)

--- 构造函数 
function T:ctor()
    
    self:setWindowTitle(Language:get("uc850"))

    self:getWidget()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)

end

function T:getWidget()
    local account = DataStorage:getLoginData()

    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 账户
    local accountName = XMLLabel()
    accountName:setContentSize(cc.size(400,36))
    self:addChild(accountName)
    REL:toOther("left","top",accountName,self.viewBack,80,100)
    accountName:setString(Language:get("uc852",account.uid))


    -- 服务器
    local serverName = XMLLabel()
    serverName:setContentSize(cc.size(400,36))
    self:addChild(serverName)
    REL:toOther("left","top",serverName,self.viewBack,80,130)
    serverName:setString(Language:get("uc853",ServerListMgr:getServerData(account.serverId).name))


    -- 当前密码
    local oldName = XMLLabel()
    oldName:setContentSize(cc.size(400,36))
    self:addChild(oldName)
    REL:toOther("left","top",oldName,self.viewBack,80,200)
    oldName:setString(Language:get("uc854"))


    local lLimit,uLimit = unpack(GameCfg.ACCOUNT_PWD_LEN_LIMIT)

    local oldInput = InputBox:create(cc.size(340,50))
	self:addChild(oldInput)
    oldInput:setMaxLength(uLimit)
	REL:toOther("left","top",oldInput,self.viewBack,80,200 + 30)
    oldInput:setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD)
	self.oldInput = oldInput

    -- 新密码
    local newName = XMLLabel()
    newName:setContentSize(cc.size(400,36))
    self:addChild(newName)
    REL:toOther("left","top",newName,self.viewBack,80,200 + 150)
    newName:setString(Language:get("uc855"))

    local newInput = InputBox:create(cc.size(340,50))
	self:addChild(newInput)
    newInput:setMaxLength(uLimit)
	REL:toOther("left","top",newInput,self.viewBack,80,200 + 150 + 30)
    newInput:setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD)
	self.newInput = newInput

    -- 再次输入
    local inputAgain = XMLLabel()
    inputAgain:setContentSize(cc.size(400,36))
    self:addChild(inputAgain)
    REL:toOther("left","top",inputAgain,self.viewBack,80,200 + 150*2)
    inputAgain:setString(Language:get("uc856"))

    local againInput = InputBox:create(cc.size(340,50))
	self:addChild(againInput)
    againInput:setMaxLength(uLimit)
	REL:toOther("left","top",againInput,self.viewBack,80,200 + 150*2 + 30)
    againInput:setInputFlag(cc.EDITBOX_INPUT_FLAG_PASSWORD)
	self.againInput = againInput

    -- 修改按钮
    local change = Button.new("false","true")
	change:setButtonState("bigButton_green_normal.png","bigButton_general_down.png")
    change:setString(Language:get("uc857"))
	self:addChild(change)
	REL:toOther("center","bottom",change,self.viewBack,0,100)
    change:setTextCenter()
    change:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local account = DataStorage:getLoginData()
            local lLimit,uLimit = unpack(GameCfg.ACCOUNT_PWD_LEN_LIMIT)

            if oldInput:getText() == "" then
                MUIAlter.show(
		            {
			            info = Language:get("uc858"),
			            size = 30
		            }
	            )
                return
            end


            if oldInput:getText() ~= account.pwd then
                MUIAlter.show(
		            {
			            info = Language:get("uc859"),
			            size = 30
		            }
	            )
                return
            end


            if newInput:getText() == "" or againInput:getText() == "" then
                MUIAlter.show(
		            {
			            info = Language:get("uc860"),
			            size = 30
		            }
	            )
                return
            end


            local c = StringUtils.getCount(newInput:getText())
			if c > uLimit or c < lLimit then
                MUIAlter.show(
		            {
			            info = Language:get("uc861",lLimit,uLimit),
			            size = 30
		            }
	            )
				return
			end

            if newInput:getText()  ~= againInput:getText() then
                MUIAlter.show(
		            {
			            info = Language:get("uc862"),
			            size = 30
		            }
	            )
                return
            end

            local oldPwd = oldInput:getText()
            local newPwd = newInput:getText()

            local ChangePasswordCommand = require("src.app.communication.changePasssword.ChangePasswordCommand")
            ChangePasswordCommand():exec(
		        oldPwd,
		        newPwd,
		        function(state)
			        if state == ReturnCode.SUCCESS then
				        local account = DataStorage:getLoginData()
				        account.pwd = newPwd
				        DataStorage:putLoginData(account)

                        oldInput:setText("")
                        newInput:setText("")
                        againInput:setText("")

                        MUIAlter.show(
		                    {
			                    info = Language:get("uc863"),
			                    size = 30
		                    }
	                    )
			        else
                        ErrorCode:popErrorCodeTip(state)
                    end

		        end
	        )


        end
    end)


end


return T