--[[
 * 普通设置视图
]]

local T = class(
    "T",
    function() 
        local o = AbstractWindow.new("windowBack2.jpg")
        o.super = AbstractWindow
        return o
    end
)

--- 构造函数 
function T:ctor()
    
    self:_setData()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)
    Command:SetCommonCommand()

end

function T:_setData()
    self:setWindowTitle(Language:get("uc355"))

    -- 攻打野矿 默认驻守
    -- 开放新资源点提醒
    -- 音乐提示
    -- 音效提示 

    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 按钮背景图片
    local setBottom = ccui.ImageView:create()
    setBottom:loadTexture("setBottom.png",ccui.TextureResType.plistType)
    self:addChild(setBottom)
    REL:toOther("center","top",setBottom,self.uiContainer,0,80)
    self.setBottom = setBottom


    local setCommonState = SetStates.setCommonState

    -- 距离左边和顶部
    local step = 60
    local left = 60
    local pos = {
        {left,80},{left,step + 80},{left,step * 2 + 80},{left,step * 3 + 80},{left,step * 4 + 80},{left,step * 5 + 80},{left,step * 6 + 80},
        {left,step * 7 + 80}
    }

    local btnLeft = 380

    -- 攻打野矿 默认驻守
    local upgradeCommand = XMLLabel()
	upgradeCommand:setContentSize(cc.size(380,27))
	self:addChild(upgradeCommand)
	REL:toOther("left","top",upgradeCommand,self.setBottom,pos[1][1],pos[1][2])
    upgradeCommand:setString(Language:get("uc362"))

    local upgradeCommandSB = SwitchButton()
	self:addChild(upgradeCommandSB)
	REL:toOther("left","middle",upgradeCommandSB,upgradeCommand,btnLeft,0)
    upgradeCommandSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_ATTACK_MINE)) -- 取反
    upgradeCommandSB:luaAddEventListener("change",nil,function(o)
        local value = upgradeCommandSB:getIsSelected()  -- true是打开，false是关
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_ATTACK_MINE)
	end)
    
    self:addSeqLine(upgradeCommand)

    -- 开放新资源点提醒
    local buyPoint = XMLLabel()
	buyPoint:setContentSize(cc.size(380,27))
	self:addChild(buyPoint)
	REL:toOther("left","top",buyPoint,self.setBottom,pos[2][1],pos[2][2])
    buyPoint:setString(Language:get("uc363"))

    local buyPointSB = SwitchButton()
	self:addChild(buyPointSB)
	REL:toOther("left","middle",buyPointSB,buyPoint,btnLeft,0)
    buyPointSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_OPEN_NEW_RESOURCE)) 
    buyPointSB:luaAddEventListener("change",nil,function(o)
        local value = buyPointSB:getIsSelected()
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_OPEN_NEW_RESOURCE)
	end)

    self:addSeqLine(buyPoint)

    -- 科研快捷栏提醒
    local scienceFast = XMLLabel()
	scienceFast:setContentSize(cc.size(380,27))
	self:addChild(scienceFast)
	REL:toOther("left","top",scienceFast,self.setBottom,pos[3][1],pos[3][2])
    scienceFast:setString(Language:get("uc416"))

    local scienceFastSB = SwitchButton()
	self:addChild(scienceFastSB)
	REL:toOther("left","middle",scienceFastSB,scienceFast,btnLeft,0)
    scienceFastSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_SCIENCE_FAST)) 
    scienceFastSB:luaAddEventListener("change",nil,function(o)
        local value = scienceFastSB:getIsSelected()
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_SCIENCE_FAST)
	end)
    self:addSeqLine(scienceFast)
    -- 生产快捷栏提醒
    local produceFast = XMLLabel()
	produceFast:setContentSize(cc.size(380,27))
	self:addChild(produceFast)
	REL:toOther("left","top",produceFast,self.setBottom,pos[4][1],pos[4][2])
    produceFast:setString(Language:get("uc417"))

    local produceFastSB = SwitchButton()
	self:addChild(produceFastSB)
	REL:toOther("left","middle",produceFastSB,produceFast,btnLeft,0)
    produceFastSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_PRODUCE_FAST)) 
    produceFastSB:luaAddEventListener("change",nil,function(o)
        local value = produceFastSB:getIsSelected()
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_PRODUCE_FAST)
	end)
    self:addSeqLine(produceFast)
    -- 建造快捷栏提醒
    local buildFast = XMLLabel()
	buildFast:setContentSize(cc.size(380,27))
	self:addChild(buildFast)
	REL:toOther("left","top",buildFast,self.setBottom,pos[5][1],pos[5][2])
    buildFast:setString(Language:get("uc418"))

    local buildFastSB = SwitchButton()
	self:addChild(buildFastSB)
	REL:toOther("left","middle",buildFastSB,buildFast,btnLeft,0)
    buildFastSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_BUILD_FAST)) 
    buildFastSB:luaAddEventListener("change",nil,function(o)
        local value = buildFastSB:getIsSelected()
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_BUILD_FAST)
	end)
    self:addSeqLine(buildFast)

    -- 始终显示建筑名字
    local buildName = XMLLabel()
	buildName:setContentSize(cc.size(380,27))
	self:addChild(buildName)
	REL:toOther("left","top",buildName,self.setBottom,pos[6][1],pos[6][2])
    buildName:setString(Language:get("uc1019"))

    local buildSB = SwitchButton()
	self:addChild(buildSB)
	REL:toOther("left","middle",buildSB,buildName,btnLeft,0)
    buildSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_BUILD_NAME)) 
    buildSB:luaAddEventListener("change",nil,function(o)
        local value = buildSB:getIsSelected()
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_BUILD_NAME)
	end)
    self:addSeqLine(buildName)


    -- 音乐提示
    local buyGoods = XMLLabel()
	buyGoods:setContentSize(cc.size(380,27))
	self:addChild(buyGoods)
	REL:toOther("left","top",buyGoods,self.setBottom,pos[7][1],pos[7][2])
    buyGoods:setString(Language:get("uc364"))

    local buyGoodsSB = SwitchButton()
	self:addChild(buyGoodsSB)
	REL:toOther("left","middle",buyGoodsSB,buyGoods,btnLeft,0)
    buyGoodsSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_BACKGROUND_MUSIC))
    buyGoodsSB:luaAddEventListener("change",nil,function(o)
        local value = buyGoodsSB:getIsSelected()
        AudioManager:setEnabledMusic(value)
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_BACKGROUND_MUSIC)
        
        DataStorage:putAudioStatus()
	end)
    self:addSeqLine(buyGoods)
    -- 音效提示
    local buildTimeSpeed = XMLLabel()
	buildTimeSpeed:setContentSize(cc.size(380,27))
	self:addChild(buildTimeSpeed)
	REL:toOther("left","top",buildTimeSpeed,self.setBottom,pos[8][1],pos[8][2])
    buildTimeSpeed:setString(Language:get("uc365"))

    local buildTimeSpeedSB = SwitchButton()
	self:addChild(buildTimeSpeedSB)
	REL:toOther("left","middle",buildTimeSpeedSB,buildTimeSpeed,btnLeft,0)
    buildTimeSpeedSB:setIsSelected(not setCommonState:getClosedValue(setCommonState.CLOSE_MUSIC_EFFECT))
    buildTimeSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = buildTimeSpeedSB:getIsSelected()
        AudioManager:setEnabledPlayEffect(value)
        setCommonState:setClosedValue(not value,setCommonState.CLOSE_MUSIC_EFFECT)
        
        DataStorage:putAudioStatus()
	end)
    self:addSeqLine(buildTimeSpeed)
end


--- 添加分割线
function T:addSeqLine(widget)
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(500,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, widget, 60, 40)
end



return T