--[[
 * 通知提示视图
]]

local T = class(
    "T",
    function() 
        local o = AbstractWindow.new("windowBack2.jpg")
        o.super = AbstractWindow
        return o
    end
)

--- 构造函数 
function T:ctor()
    
    self:_setData()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)
    Command:SetNoticeCommand()

end

function T:_setData()
    self:setWindowTitle(Language:get("uc354"))

    -- 城市被攻击 
    -- 建造，生产完成 
    -- 能量恢复满
    -- 神秘奖励
    -- 防护罩状态 
    -- 资源采集已满  

    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 按钮背景图片
    local setBottom = ccui.ImageView:create()
    setBottom:loadTexture("setBottom.png",ccui.TextureResType.plistType)
    self:addChild(setBottom)
    REL:toOther("center","top",setBottom,self.uiContainer,0,80)
    self.setBottom = setBottom


    local setNoticeState = SetStates.setNoticeState

    -- 距离左边和顶部
    local step = 60
    local left = 60
    local pos = {
        {left,80},{left,step + 80},{left,step * 2 + 80},{left,step * 3 + 80},{left,step * 4 + 80},{left,step * 5 + 80}
    }

    local btnLeft = 380

    -- 城市被攻击
    local upgradeCommand = XMLLabel()
	upgradeCommand:setContentSize(cc.size(380,27))
	self:addChild(upgradeCommand)
	REL:toOther("left","top",upgradeCommand,self.setBottom,pos[1][1],pos[1][2])
    upgradeCommand:setString(Language:get("uc356"))

    local upgradeCommandSB = SwitchButton()
	self:addChild(upgradeCommandSB)
	REL:toOther("left","middle",upgradeCommandSB,upgradeCommand,btnLeft,0)
    upgradeCommandSB:setIsSelected(not setNoticeState:getClosedValue(setNoticeState.CLOSE_CITY_ATTACKED)) -- 取反
    upgradeCommandSB:luaAddEventListener("change",nil,function(o)
        local value = upgradeCommandSB:getIsSelected()  -- true是打开，false是关
        setNoticeState:setClosedValue(not value,setNoticeState.CLOSE_CITY_ATTACKED)
	end)
    
    self:addSeqLine(upgradeCommand)
    -- 建造，生产完成 
    local buyPoint = XMLLabel()
	buyPoint:setContentSize(cc.size(380,27))
	self:addChild(buyPoint)
	REL:toOther("left","top",buyPoint,self.setBottom,pos[2][1],pos[2][2])
    buyPoint:setString(Language:get("uc357"))

    local buyPointSB = SwitchButton()
	self:addChild(buyPointSB)
	REL:toOther("left","middle",buyPointSB,buyPoint,btnLeft,0)
    buyPointSB:setIsSelected(not setNoticeState:getClosedValue(setNoticeState.CLOSE_BUILD_CONSTRUCE)) 
    buyPointSB:luaAddEventListener("change",nil,function(o)
        local value = buyPointSB:getIsSelected()
        setNoticeState:setClosedValue(not value,setNoticeState.CLOSE_BUILD_CONSTRUCE)

        if value then -- 打开推送
            LocalNoti:includeCategory(LocalNoti.CATEGORY_BUILD)
        else
            LocalNoti:excludeCategory(LocalNoti.CATEGORY_BUILD)
        end

	end)
    self:addSeqLine(buyPoint)
    -- 能量恢复满
    local buyGoods = XMLLabel()
	buyGoods:setContentSize(cc.size(380,27))
	self:addChild(buyGoods)
	REL:toOther("left","top",buyGoods,self.setBottom,pos[3][1],pos[3][2])
    buyGoods:setString(Language:get("uc358"))

    local buyGoodsSB = SwitchButton()
	self:addChild(buyGoodsSB)
	REL:toOther("left","middle",buyGoodsSB,buyGoods,btnLeft,0)
    buyGoodsSB:setIsSelected(not setNoticeState:getClosedValue(setNoticeState.CLOSE_POINT_RECOVERY))
    buyGoodsSB:luaAddEventListener("change",nil,function(o)
        local value = buyGoodsSB:getIsSelected()
        setNoticeState:setClosedValue(not value,setNoticeState.CLOSE_POINT_RECOVERY)
        if value then
            LocalNoti:includeCategory(LocalNoti.PVE_POINT_TIP)
        else
            LocalNoti:excludeCategory(LocalNoti.PVE_POINT_TIP)
        end
	end)
    self:addSeqLine(buyGoods)
    -- 神秘奖励
    local buildTimeSpeed = XMLLabel()
	buildTimeSpeed:setContentSize(cc.size(380,27))
	self:addChild(buildTimeSpeed)
	REL:toOther("left","top",buildTimeSpeed,self.setBottom,pos[4][1],pos[4][2])
    buildTimeSpeed:setString(Language:get("uc359"))

    local buildTimeSpeedSB = SwitchButton()
	self:addChild(buildTimeSpeedSB)
	REL:toOther("left","middle",buildTimeSpeedSB,buildTimeSpeed,btnLeft,0)
    buildTimeSpeedSB:setIsSelected(not setNoticeState:getClosedValue(setNoticeState.CLOSE_AWARD))
    buildTimeSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = buildTimeSpeedSB:getIsSelected()
        setNoticeState:setClosedValue(not value,setNoticeState.CLOSE_AWARD)
	end)
    self:addSeqLine(buildTimeSpeed)
    -- 防护罩状态 
    local buildSpeed = XMLLabel()
	buildSpeed:setContentSize(cc.size(380,27))
	self:addChild(buildSpeed)
	REL:toOther("left","top",buildSpeed,self.setBottom,pos[5][1],pos[5][2])
    buildSpeed:setString(Language:get("uc360"))

    local buildSpeedSB = SwitchButton()
	self:addChild(buildSpeedSB)
	REL:toOther("left","middle",buildSpeedSB,buildSpeed,btnLeft,0)
    buildSpeedSB:setIsSelected(not setNoticeState:getClosedValue(setNoticeState.CLOSE_PROTECTION_COVER))
    buildSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = buildSpeedSB:getIsSelected()
        setNoticeState:setClosedValue(not value,setNoticeState.CLOSE_PROTECTION_COVER)
        if value then
            LocalNoti:includeCategory(LocalNoti.PROTECT_COVER)
        else
            LocalNoti:excludeCategory(LocalNoti.PROTECT_COVER)
        end
	end)
    self:addSeqLine(buildSpeed)
    -- 资源采集已满
    local produceSpeed = XMLLabel()
	produceSpeed:setContentSize(cc.size(380,27))
	self:addChild(produceSpeed)
	REL:toOther("left","top",produceSpeed,self.setBottom,pos[6][1],pos[6][2])
    produceSpeed:setString(Language:get("uc361"))

    local produceSpeedSB = SwitchButton()
	self:addChild(produceSpeedSB)
	REL:toOther("left","middle",produceSpeedSB,produceSpeed,btnLeft,0)
    produceSpeedSB:setIsSelected(not setNoticeState:getClosedValue(setNoticeState.CLOSE_RESOURCE_COLLECT))
    produceSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = produceSpeedSB:getIsSelected()
        setNoticeState:setClosedValue(not value,setNoticeState.CLOSE_RESOURCE_COLLECT)
	end)

   self:addSeqLine(produceSpeed)
end

--- 添加分割线
function T:addSeqLine(widget)
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(500,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, widget, 60, 40)
end




return T