--[[
 * 付费提示视图
]]

local T = class(
    "T",
    function() 
        local o = AbstractWindow.new("windowBack2.jpg")
        o.super = AbstractWindow
        return o
    end
)

--- 构造函数 
function T:ctor()
    
    self:_setData()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)
    Command:SetPayCommand()

end

function T:_setData()
    self:setWindowTitle(Language:get("uc343"))

    -- 升级指挥(功能暂时不做)
    -- 购买能量
    -- 购买商品
    -- 建筑加速
    -- 一键秒建筑
    -- 生产飞机加速
    -- 科研加速
    -- 行军加速
    -- 钻石维修部队
    -- 升级技能

    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    -- 按钮背景图片
    local setBottom = ccui.ImageView:create()
    setBottom:loadTexture("setBottom.png",ccui.TextureResType.plistType)
    self:addChild(setBottom)
    REL:toOther("center","top",setBottom,self.uiContainer,0,80)
    self.setBottom = setBottom


    local payState = SetStates.setPayState

    -- 距离左边和顶部
    local step = 60
    local left = 60
    local pos = {
        {left,80},{left,step + 80},{left,step * 2 + 80},{left,step * 3 + 80},{left,step * 4 + 80},{left,step * 5 + 80},{left,step * 6 + 80},
        {left,step * 7 + 80},{left,step * 8 + 80},{left,step * 9 + 80}
    }

    local btnLeft = 380


    -- 升级指挥(功能暂时不做)
    local upgradeCommand = XMLLabel()
	upgradeCommand:setContentSize(cc.size(380,27))
	self:addChild(upgradeCommand)
	REL:toOther("left","top",upgradeCommand,self.setBottom,pos[1][1],pos[1][2])
    upgradeCommand:setString(Language:get("uc344"))

    local upgradeCommandSB = SwitchButton()
	self:addChild(upgradeCommandSB)
	REL:toOther("left","middle",upgradeCommandSB,upgradeCommand,btnLeft,0)
    upgradeCommandSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_UPGRADE_COMMAND)) -- 取反
    upgradeCommandSB:luaAddEventListener("change",nil,function(o)
        local value = upgradeCommandSB:getIsSelected()  -- true是打开，false是关
        payState:setClosedValue(not value,payState.CLOSE_UPGRADE_COMMAND)
	end)
    
    self:addSeqLine(upgradeCommand)
    -- 购买能量
    local buyPoint = XMLLabel()
	buyPoint:setContentSize(cc.size(380,27))
	self:addChild(buyPoint)
	REL:toOther("left","top",buyPoint,self.setBottom,pos[2][1],pos[2][2])
    buyPoint:setString(Language:get("uc345"))

    local buyPointSB = SwitchButton()
	self:addChild(buyPointSB)
	REL:toOther("left","middle",buyPointSB,buyPoint,btnLeft,0)
    buyPointSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_BUY_POINT)) 
    buyPointSB:luaAddEventListener("change",nil,function(o)
        local value = buyPointSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_BUY_POINT)
	end)
    self:addSeqLine(buyPoint)
    -- 购买商品
    local buyGoods = XMLLabel()
	buyGoods:setContentSize(cc.size(380,27))
	self:addChild(buyGoods)
	REL:toOther("left","top",buyGoods,self.setBottom,pos[3][1],pos[3][2])
    buyGoods:setString(Language:get("uc346"))

    local buyGoodsSB = SwitchButton()
	self:addChild(buyGoodsSB)
	REL:toOther("left","middle",buyGoodsSB,buyGoods,btnLeft,0)
    buyGoodsSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_BUY_GOODS))
    buyGoodsSB:luaAddEventListener("change",nil,function(o)
        local value = buyGoodsSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_BUY_GOODS)
	end)
    self:addSeqLine(buyGoods)
    -- 一键秒建筑
    local buildTimeSpeed = XMLLabel()
	buildTimeSpeed:setContentSize(cc.size(380,27))
	self:addChild(buildTimeSpeed)
	REL:toOther("left","top",buildTimeSpeed,self.setBottom,pos[4][1],pos[4][2])
    buildTimeSpeed:setString(Language:get("uc352"))

    local buildTimeSpeedSB = SwitchButton()
	self:addChild(buildTimeSpeedSB)
	REL:toOther("left","middle",buildTimeSpeedSB,buildTimeSpeed,btnLeft,0)
    buildTimeSpeedSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_TIME_BUILDIGN))
    buildTimeSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = buildTimeSpeedSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_TIME_BUILDIGN)
	end)
    self:addSeqLine(buildTimeSpeed)
    -- 建筑加速
    local buildSpeed = XMLLabel()
	buildSpeed:setContentSize(cc.size(380,27))
	self:addChild(buildSpeed)
	REL:toOther("left","top",buildSpeed,self.setBottom,pos[5][1],pos[5][2])
    buildSpeed:setString(Language:get("uc347"))

    local buildSpeedSB = SwitchButton()
	self:addChild(buildSpeedSB)
	REL:toOther("left","middle",buildSpeedSB,buildSpeed,btnLeft,0)
    buildSpeedSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_BUILD_SPEED))
    buildSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = buildSpeedSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_BUILD_SPEED)
	end)
    self:addSeqLine(buildSpeed)
    -- 生产飞机加速
    local produceSpeed = XMLLabel()
	produceSpeed:setContentSize(cc.size(380,27))
	self:addChild(produceSpeed)
	REL:toOther("left","top",produceSpeed,self.setBottom,pos[6][1],pos[6][2])
    produceSpeed:setString(Language:get("uc348"))

    local produceSpeedSB = SwitchButton()
	self:addChild(produceSpeedSB)
	REL:toOther("left","middle",produceSpeedSB,produceSpeed,btnLeft,0)
    produceSpeedSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_PRODECE_SPEED))
    produceSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = produceSpeedSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_PRODECE_SPEED)
	end)
    self:addSeqLine(produceSpeed)
    -- 科研加速
    local scienceSpeed = XMLLabel()
	scienceSpeed:setContentSize(cc.size(380,27))
	self:addChild(scienceSpeed)
	REL:toOther("left","top",scienceSpeed,self.setBottom,pos[7][1],pos[7][2])
    scienceSpeed:setString(Language:get("uc349"))

    local scienceSpeedSB = SwitchButton()
	self:addChild(scienceSpeedSB)
	REL:toOther("left","middle",scienceSpeedSB,scienceSpeed,btnLeft,0)
    scienceSpeedSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_SCIENCE_SPEED))
    scienceSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = scienceSpeedSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_SCIENCE_SPEED)
	end)
    self:addSeqLine(scienceSpeed)
    -- 行军加速
    local marchSpeed = XMLLabel()
	marchSpeed:setContentSize(cc.size(380,27))
	self:addChild(marchSpeed)
	REL:toOther("left","top",marchSpeed,self.setBottom,pos[8][1],pos[8][2])
    marchSpeed:setString(Language:get("uc350"))

    local marchSpeedSB = SwitchButton()
	self:addChild(marchSpeedSB)
	REL:toOther("left","middle",marchSpeedSB,marchSpeed,btnLeft,0)
    marchSpeedSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_MARCH_SPEED))
    marchSpeedSB:luaAddEventListener("change",nil,function(o)
        local value = marchSpeedSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_MARCH_SPEED)
	end)
    self:addSeqLine(marchSpeed)
    -- 钻石维修部队
    local diamonRepair = XMLLabel()
	diamonRepair:setContentSize(cc.size(380,27))
	self:addChild(diamonRepair)
	REL:toOther("left","top",diamonRepair,self.setBottom,pos[9][1],pos[9][2])
    diamonRepair:setString(Language:get("uc351"))

    local diamonRepairSB = SwitchButton()
	self:addChild(diamonRepairSB)
	REL:toOther("left","middle",diamonRepairSB,diamonRepair,btnLeft,0)
    diamonRepairSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_DIAMOND_REPAIR))
    diamonRepairSB:luaAddEventListener("change",nil,function(o)
        local value = diamonRepairSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_DIAMOND_REPAIR)
	end)
    self:addSeqLine(diamonRepair)

    -- 升级技能
    local upgradeSkill = XMLLabel()
	upgradeSkill:setContentSize(cc.size(380,27))
	self:addChild(upgradeSkill)
	REL:toOther("left","top",upgradeSkill,self.setBottom,pos[10][1],pos[10][2])
    upgradeSkill:setString(Language:get("uc765"))

    local upgradeSkillSB = SwitchButton()
	self:addChild(upgradeSkillSB)
	REL:toOther("left","middle",upgradeSkillSB,upgradeSkill,btnLeft,0)
    upgradeSkillSB:setIsSelected(not payState:getClosedValue(payState.CLOSE_SKILL_LEVELUP))
    upgradeSkillSB:luaAddEventListener("change",nil,function(o)
        local value = upgradeSkillSB:getIsSelected()
        payState:setClosedValue(not value,payState.CLOSE_SKILL_LEVELUP)
	end)
    self:addSeqLine(upgradeSkill)


end


--- 添加分割线
function T:addSeqLine(widget)
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(500,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, widget, 60, 40)
end



return T