---系统设置主窗口
local T = class(
	"SystemSetWindow",
	function()
		local o = AbstractWindow.new("windowBack2.jpg")
		o.super = AbstractWindow
		return o
	end
)

--- 构造函数
function T:ctor()
	self:_getWidget()
	self:_setData()
	self:_setButton()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:onEnter()
	self.super.onEnter(self)
end

function T:onExit()
	self.super.onExit(self)
end

function T:_getWidget()
	-- 绑定账号   服务器列表
	-- 游戏设置   选择语言
	-- 付费提示   通知提示
	-- 修改密码   联系我们

	-- 背景图片
	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
	REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

	-- 按钮背景图片
	local setBottom = ccui.ImageView:create()
	setBottom:loadTexture("setBottom.png",ccui.TextureResType.plistType)
	self:addChild(setBottom)
	REL:toOther("center","top",setBottom,self.uiContainer,0,80)
	self.setBottom = setBottom

	-- 距离中间和顶部
	local step = 120
	local pos = {
		{-140,80},				{140,80},
		{-140,step + 80},		{140,step + 80},
		{-140,step * 2 + 80},	{140,step * 2 + 80},
		{-140,step * 3 + 80},	{140,step * 3 + 80},
		{-140,step * 4 + 80},	{140,step * 4 + 80}
	}

	local id=1

	if CUR_SDK ~= SDKType.PLATFORM_ENJOY_GAME then
		-- 更换账号
		local uiSwitchAccountBtn = Button.new("false","true")
		uiSwitchAccountBtn:setButtonState("button_set.png","button_set.png")
		uiSwitchAccountBtn:setString(Language:get("uc851"))
		uiSwitchAccountBtn:setTextCenter()
		self:addChild(uiSwitchAccountBtn)
		REL:toOther("center","top",uiSwitchAccountBtn,self.setBottom,pos[id][1],pos[id][2])
		uiSwitchAccountBtn:addTouchEventListener( function(t, e)
			if e == ccui.TouchEventType.ended then
				print("更换账号")

				if CUR_SDK == SDKType.PLATFORM_360 or
					CUR_SDK == SDKType.PLATFORM_ENJOY_GAME or
					CUR_SDK == SDKType.PLATFORM_TENGLONG_1 or
					CUR_SDK == SDKType.PLATFORM_UC or
					CUR_SDK == SDKType.PLATFORM_VIVO or
					CUR_SDK == SDKType.PLATFORM_HUA_WEI
				then
					SDK_Delegate:setLoginState(SDK_Delegate.LOGIN_STATE_SWITCH)
				end

				require("src.app.controler.Back2LoginScenceCommand")()
			end
		end)
		id=id+1
	end

	-- 服务器列表
	local uiShowServerListBtn = Button.new("false","true")
	uiShowServerListBtn:setButtonState("button_set.png","button_set.png")
	uiShowServerListBtn:setString(Language:get("uc336"))
	uiShowServerListBtn:setTextCenter()
	self:addChild(uiShowServerListBtn)
	REL:toOther("center","top",uiShowServerListBtn,self.setBottom,pos[id][1],pos[id][2])
	self.uiShowServerListBtn = uiShowServerListBtn
	uiShowServerListBtn:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			print("选择服务器")

			local loginData=DataStorage:getLoginData()

			MUIAlter_custom.show({
				info=require("src.app.uiScript.components.login.ServerListCvs")(loginData),
				triggerCloseMethod="outside",
				callback=function()
					local oldLd=DataStorage:getLoginData()
					if loginData.serverId ~= oldLd.serverId then
						DataStorage:putLoginData(loginData)

						require("src.app.controler.Back2LoginScenceCommand")()
					end
				end
			})
		end
	end )
	id=id+1

	-- 游戏设置
	local uiGameSetBtn = Button.new("false","true")
	uiGameSetBtn:setButtonState("button_set.png","button_set.png")
	uiGameSetBtn:setString(Language:get("uc337"))
	uiGameSetBtn:setTextCenter()
	self:addChild(uiGameSetBtn)
	REL:toOther("center","top",uiGameSetBtn,self.setBottom,pos[id][1],pos[id][2])
	self.uiGameSetBtn = uiGameSetBtn
	uiGameSetBtn:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			WindowManager:push(
				require("src.app.uiScript.components.set.CommonTipView").new()
			)
		end
	end )
	id=id+1

	-- 选择语言
	local uiShowLanguageListBtn = Button.new("false","true")
	uiShowLanguageListBtn:setButtonState("button_set.png","button_set.png")
	uiShowLanguageListBtn:setString(Language:get("uc338"))
	uiShowLanguageListBtn:setTextCenter()
	self:addChild(uiShowLanguageListBtn)
	REL:toOther("center","top",uiShowLanguageListBtn,self.setBottom,pos[id][1],pos[id][2])
	self.uiShowLanguageListBtn = uiShowLanguageListBtn
	uiShowLanguageListBtn:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			self:enterLanguageSelectView()
		end
	end )
	id=id+1

	-- 付费提示
	local uiPaymentTipSetBtn = Button.new("false","true")
	uiPaymentTipSetBtn:setButtonState("button_set.png","button_set.png")
	uiPaymentTipSetBtn:setString(Language:get("uc339"))
	uiPaymentTipSetBtn:setTextCenter()
	self:addChild(uiPaymentTipSetBtn)
	REL:toOther("center","top",uiPaymentTipSetBtn,self.setBottom,pos[id][1],pos[id][2])
	self.uiPaymentTipSetBtn = uiPaymentTipSetBtn
	uiPaymentTipSetBtn:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			WindowManager:push(
				require("src.app.uiScript.components.set.PayTipView").new()
			)
		end
	end)
	id=id+1

	-- 通知提示
	local uiNoticeTipSetBtn = Button.new("false","true")
	uiNoticeTipSetBtn:setButtonState("button_set.png","button_set.png")
	uiNoticeTipSetBtn:setString(Language:get("uc340"))
	uiNoticeTipSetBtn:setTextCenter()
	self:addChild(uiNoticeTipSetBtn)
	REL:toOther("center","top",uiNoticeTipSetBtn,self.setBottom,pos[id][1],pos[id][2])
	self.uiNoticeTipSetBtn = uiNoticeTipSetBtn
	uiNoticeTipSetBtn:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			WindowManager:push(
				require("src.app.uiScript.components.set.NoticeTipView").new()
			)
		end
	end)
	id=id+1

	if CUR_SDK == nil or CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
		-- 绑定账号/修改密码/个人中心/实名注册
		REL:toOther("center","top",self:createBindingAccountBtn(),self.setBottom,pos[id][1],pos[id][2])
		id=id+1
	end

	if CUR_SDK ~= SDKType.PLATFORM_ENJOY_GAME then
		-- 联系我们
		local contactUs = Button.new("false","true")
		contactUs:setButtonState("button_set.png","button_set.png")
		contactUs:setString(Language:get("uc342"))
		contactUs:setTextCenter()
		self:addChild(contactUs)
		REL:toOther("center","top",contactUs,self.setBottom,pos[id][1],pos[id][2])
		self.contactUs = contactUs

		contactUs:addTouchEventListener( function(t, e)
			if e == ccui.TouchEventType.ended then
				if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
					SDK_Delegate:doOpenUserCenter()
				else
					local layout = ccui.Layout:create()
					layout:setContentSize(cc.size(544,226))

					local text = XMLLabel()
					text:setContentSize(cc.size(500,36))
					text:setVAlign("middle")
					layout:addChild(text)
					REL:toOther("left","middle",text,layout,100,-30)
					text:setString(Language:get("uc818"))

					MUIAlter_noTitle.show({
						info = layout,
						flag = 4,
					})
				end
			end
		end)
		id=id+1
	end

	if (not CUR_SDK) or
		CUR_SDK == SDKType.PLATFORM_TENGLONG_1 or
		CUR_SDK == SDKType.PLATFORM_UC or
		CUR_SDK == SDKType.PLATFORM_VIVO or
		CUR_SDK == SDKType.PLATFORM_HUA_WEI
	then
		-- 兑换码
		local exchange = Button.new("false","true")
		exchange:setButtonState("button_set.png","button_set.png")
		exchange:setString(Language:get("uc841"))
		exchange:setTextCenter()
		self:addChild(exchange)
		REL:toOther("center","top",exchange,self.setBottom,pos[id][1],pos[id][2])
		exchange:addTouchEventListener( function(t, e)
			if e == ccui.TouchEventType.ended then
				local layout = require("src.app.uiScript.components.set.ExchangePopWindow").new()
				local muialter2 = MUIAlter.show({
					title = Language:get("uc841"),
					info = layout,
					flag = 4,
					isShowCloseButton = true,
					callback = function(flag)
					end
				})
				layout:setMUIAlter2(muialter2)

			end
		end )
		id=id+1
	end
end

--- 初始化绑定账号按钮
function T:createBindingAccountBtn()
	-- 绑定账号
	local uiBtn =BaseButton:createButton(Language:get("uc335"),"button_set.png")
	self:addChild(uiBtn)
	self.uiShowBindAccountWindowBtn = uiBtn

	self:updateBindingAccountBtnState()
	uiBtn:addTouchEventListener( function(t, e)
		if e == ccui.TouchEventType.ended then
			if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
				SDK_Delegate:doOpenUserCenter()
			elseif CUR_SDK == SDKType.PLATFORM_360 then
				self:realNameRegisiter()
			else
				-- 是否可绑定账号
				local account=DataStorage:getLoginData()
				if account.isTourist and account.isTourist == true then
					-- 未绑定
					MUIAlter.show({
						info=require("src.app.uiScript.components.set.BindingAccountCvs")(),
						flag=4,
						callback=function()
							self:updateBindingAccountBtnState()
						end
					})
				else
					WindowManager:push(
						require("src.app.uiScript.components.set.ChangePasswordView").new()
					)
				end
			end
		end
	end)

	return uiBtn
end

--- 更新绑定账号状态
function T:updateBindingAccountBtnState()
	local uiBtn=self.uiShowBindAccountWindowBtn

	if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
		if SDK_Delegate:getIsTourist() then
			uiBtn:setString(Language:get("uc335"))
		else
			uiBtn:setString(Language:get("ug_persionalCenter"))
		end
	else
		if CUR_SDK == SDKType.PLATFORM_360 then
			uiBtn:setString(Language:get("uc870"))
			if SDK_Delegate:isGetAnitAddictionDataSuccess() and SDK_Delegate:getAgeState() ~= SDK_Delegate.USER_AGE_STATE_NO_DATA then
				uiBtn:setTouchEnabled(false)
				uiBtn:setIsGray(true)
			end
		else
			-- 是否可绑定账号
			local account=DataStorage:getLoginData()
			if account.isTourist and account.isTourist == true then -- 未绑定
				uiBtn:setString(Language:get("uc335"))
			else
				uiBtn:setString(Language:get("uc341"))
			end
		end
	end
end

if CUR_SDK == SDKType.PLATFORM_360 then
	--- 第2次查询防沉迷数据成功
	function T:getAntiAddtionInfoSuccessHandler2()
		self:rmvGetAntiListeners2()

		if SDK_Delegate:getAgeState() ~= SDK_Delegate.USER_AGE_STATE_NO_DATA then
			MUIAlter_singleLine.show({
				info=Language:get("sdk_360_realNameInfoSuccess")
			})

			self.uiShowBindAccountWindowBtn:setTouchEnabled(false)
			self.uiShowBindAccountWindowBtn:setIsGray(true)
		else
			MUIAlter_singleLine.show({
				info=Language:get("sdk_360_realNameInfoFail")
			})

			self.uiShowBindAccountWindowBtn:setTouchEnabled(true)
			self.uiShowBindAccountWindowBtn:setIsGray(false)
		end
	end

	--- 第2次查询防沉迷数据失败
	function T:getAntiAddtionInfoFailureHandler2()
		self:rmvGetAntiListeners2()

		MUIAlter_singleLine.show({
			info=Language:get("sdk_360_getAntiAdditionInfoFail")
		})

		self.uiShowBindAccountWindowBtn:setTouchEnabled(true)
		self.uiShowBindAccountWindowBtn:setIsGray(false)
	end

	--- 实名注册成功
	function T:realNameSuccessHandler()
		self:rmvRealNameRegisterListeners()

		--再次查询防沉迷数据,以确定是否完成实名注册
		SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_SUCCESS,self,self.getAntiAddtionInfoSuccessHandler2)
		SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_FAILURE,self,self.getAntiAddtionInfoFailureHandler2)
		SDK_Delegate:doAntiAddictionQuery()
	end

	--- 移除防沉迷数据查询2的侦听器
	function T:rmvGetAntiListeners2()
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_SUCCESS,self,self.getAntiAddtionInfoSuccessHandler2)
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_FAILURE,self,self.getAntiAddtionInfoFailureHandler2)
	end

	--- 实名注册失败
	function T:realNameFailureHandler()
		self:rmvRealNameRegisterListeners()

		MUIAlter_singleLine.show({
			info=Language:get("sdk_360_realNameInfoFail")
		})

		self.uiShowBindAccountWindowBtn:setTouchEnabled(true)
		self.uiShowBindAccountWindowBtn:setIsGray(false)
	end

	--- 实名注册被取消
	function T:realNameCanceledHandler()
		self:rmvRealNameRegisterListeners()

		print("实名注册被取消")

		self.uiShowBindAccountWindowBtn:setTouchEnabled(true)
		self.uiShowBindAccountWindowBtn:setIsGray(false)
	end

	--- 执行实名注册
	function T:_realNameRegister()
		--如果已完成实名注册
		if SDK_Delegate:getAgeState() ~= SDK_Delegate.USER_AGE_STATE_NO_DATA then
			MUIAlter_singleLine.show({
				info=Language:get("sdk_360_alreadyRealName")
			})

			self.uiShowBindAccountWindowBtn:setTouchEnabled(false)
			self.uiShowBindAccountWindowBtn:setIsGray(true)

			return
		end

		SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_REAL_NAME_REGISTER_SUCCESS,self,self.realNameSuccessHandler)
		SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_REAL_NAME_REGISTER_FAILURE,self,self.realNameFailureHandler)
		SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_REAL_NAME_REGISTER_CANCEL,self,self.realNameCanceledHandler)
		SDK_Delegate:doRealNameRegister()
	end

	--- 移除实名注册的侦听器
	function T:rmvRealNameRegisterListeners()
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_REAL_NAME_REGISTER_SUCCESS,self,self.realNameSuccessHandler)
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_REAL_NAME_REGISTER_FAILURE,self,self.realNameFailureHandler)
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_REAL_NAME_REGISTER_CANCEL,self,self.realNameCanceledHandler)
	end

	---获取防沉迷数据成功
	function T:getAntiAddtionInfoSuccessHandler()
		self:rmvGetAntiDataListeners()

		self:_realNameRegister()
	end

	---获取防沉迷数据失败
	function T:getAntiAddtionInfoFailureHandler()
		self:rmvGetAntiDataListeners()

		MUIAlter_singleLine.show({
			info=Language:get("sdk_360_getAntiAdditionInfoFail")
		})
		self.uiShowBindAccountWindowBtn:setTouchEnabled(true)
	end

	--- 实名注册
	function T:realNameRegisiter()
		self.uiShowBindAccountWindowBtn:setTouchEnabled(false)

		--如果有防沉迷数据,则直接进入实名注册,否则获取防沉迷数据
		if SDK_Delegate:isGetAnitAddictionDataSuccess() then
			self:_realNameRegister()
		else
			SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_SUCCESS,self,self.getAntiAddtionInfoSuccessHandler)
			SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_FAILURE,self,self.getAntiAddtionInfoFailureHandler)
			SDK_Delegate:doAntiAddictionQuery()
		end
	end

	--- 移除防沉迷获取数据的侦听器
	function T:rmvGetAntiDataListeners()
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_SUCCESS,self,self.getAntiAddtionInfoSuccessHandler)
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_GET_ANTI_INFO_FAILURE,self,self.getAntiAddtionInfoFailureHandler)
	end
end

function T:_setData()
	self:setWindowTitle(Language:get("uc334"))

end

function T:_setButton()
end

--- 进入语言选择视图
function T:enterLanguageSelectView()
	local uiCvs=require("src.app.uiScript.components.login.LanguageListCvs")(function()
		print("选择语言")

		--- 退回到登陆界面
		require("src.app.controler.Back2LoginScenceCommand")()
	end)

	MUIAlter.show({
		info=uiCvs,
		title=Language:get("uc338"),
		flag=4
	})
end

return T
