--- 抽象全屏窗口
local T = class(
	"AbstractFullScreenWindow",
	function()
		local t = ccui.Layout:create()

		return t
	end
)

--- 是否显示 waitting 遮罩
T.isShowWaitingMask=false

--- 是否初始化完成
T.isInitComplete=false

--- 是否打开完成
T.isOpenComplete=false

--- 构造函数
function T:ctor()
	self.isInitComplete=false
	self.isOpenComplete=false

	mapping(self,LuaEventDispatcher)

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
				self:releaseEventListeners()
			end
		end
	)

	self:init()
end

--- 进入
function T:onEnter()end

--- 退出
function T:onExit()end

--- 内存清理
function T:cleanUp()end

--- 初始化
function T:init()
	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	REL:relScreen(self,0,0,0,0)
	self:setLocalZOrder(TOP_ORDER)
	self:setTouchEnabled(true)

	--屏蔽点击(关闭期间不应该响应事件)
	local uiMask=ccui.Layout:create()
	self:addChild(uiMask)
	REL:relScreen(uiMask, 0, 0, 0, 0)
	self.uiMask=uiMask
	
	uiMask:setTouchEnabled(true)
	uiMask:addTouchEventListener(function(t,e)
--		print("屏蔽底层点击")
	end)
end

--- 初始化完成
function T:initCompleteHandler()
	if self.isInitComplete then
		return
	end

	self.isInitComplete=true

	self:playOpenEffect()
end

--- 关闭
function T:close()
	WindowManager:pop()
end

--- 播放打开动画完成
function T:playOpenEffectComplete()
	self.isOpenComplete=true
	self:luaDispatchEvent(EVENT_OPEN_COMPLETE,self)
end

--- 播放打开动画
function T:playOpenEffect()
	self:luaDispatchEvent(EVENT_START_OPEN,self)

	self:playOpenEffectComplete()
end

--- 播放关闭动画完成
function T:playCloseEffectComplete()
	self:luaDispatchEvent(EVENT_CLOSE_COMPLETE,self)
end

--- 播放关闭动画
function T:playColseEffect()
	self:luaDispatchEvent(EVENT_START_CLOSE,self)

	self:playCloseEffectComplete()
end

--- 是否打开完成
function T:getIsOpenComplete()
	return self.isOpenComplete
end

return T
