--[[
 *	标签页的抽象按钮
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 大小
T.size = nil

--- 按钮在切换标签页的位置
T.location = nil

--- 按钮
T.button = nil

--- 正常状态
T.normalState = nil

--- 按下状态
T.downState = nil

--- 按钮文本
T.buttonText = nil

--- 按钮文本的相对位置
T.buttonTextPos = nil

--- 按钮里面的图片
--- 按钮右上角的图片和数字,这个暂时不写


function T:ctor(location)
	mapping(self,LuaEventDispatcher) -- self才能派发事件

    self.location = location
	-- 按钮
	local button = ccui.Button:create()
	button:setTouchEnabled(true)
	self:addChild(button)
	self.button = button

	-- 按钮文本
	local buttonText = XMLLabel()
	if CssStyles then
		buttonText:setCssStyle(CssStyles.switchTitleOne)
	end
	buttonText:setContentSize(cc.size(150,27))
	buttonText:setName("uiText")
	self.button:addChild(buttonText)
	self.buttonText = buttonText
end

--- 初始化按钮
function T:initButton(buttonState,buttonText,buttonTextPos,buttonCallBack)
	if buttonState then
		self.normalState = buttonState[1]
		self.downState = buttonState[2]
		self.button:loadTextures(self.normalState, self.downState, "",ccui.TextureResType.plistType)

		self.size = self.button:getContentSize()
		self:setContentSize(self.size)  -- 这里必须设置layout的大小，不然相对定位要错误

		REL:toOther("left","top",self.button,self,0,0)
	end

	if buttonText then
		self.buttonText:setString(buttonText)
	end

	if buttonTextPos then -- 现在按钮变了，都设置为中间
		--REL:toOther("left","top",self.buttonText,self.button,buttonTextPos[1],buttonTextPos[2])
        self.buttonText:setAlign("center","middle")
		REL:relOther(self.buttonText,self.button,0,0,0,0)
	else
		self.buttonText:setAlign("center","middle")
		REL:relOther(self.buttonText,self.button,0,0,0,0)
	end

	if buttonCallBack then
		local function callback(sender, eventType)
			if eventType == ccui.TouchEventType.ended then
				self:luaDispatchEvent("buttons_event",self)
			end
		end

		BaseButton:extend(self.button)
		self.button:addTouchEventListener(callback)
	end

end

--- 设置为正常状态
function T:setNormalState()
	self.button:loadTextureNormal(self.normalState,ccui.TextureResType.plistType)
	self.button:setTouchEnabled(true)
end

--- 设置为按下状态
function T:setDownState()
	self.button:loadTextureNormal(self.downState,ccui.TextureResType.plistType)
	self.button:setTouchEnabled(false)
end

--- 设置按钮文本
function T:setString(text)
	self.buttonText:setString(text)
end


return T
