--[[
 *	飞机弹出信息窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 战机的sid
T.sid = sid

--- 构造函数
function T:ctor(sid)
    self.sid = sid

    local size = cc.size(550,840)
    self.size = self:setContentSize(size)
    self.size = size

    self:setTouchEnabled(false)
    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
end

function T:GetWidget()
    local iconPath = IconManager.iconPath
    -- 战机头像
    local head = ccui.ImageView:create()
    head:loadTexture(iconPath .. Prop_temp[1].propIcon)
    self:addChild(head)
    REL:toOther("left","top",head,self,10,20)
    self.head = head

    -- 战机名字
    local name = XMLLabel()
    name:setContentSize(cc.size(300, 27))
    self:addChild(name)
    REL:toOther("left", "middle", name, head, head:getContentSize().width + 20, 20)
    self.name = name


    -- 战机数量
    local count = XMLLabel()
    count:setContentSize(cc.size(300, 27))
    self:addChild(count)
    REL:toOther("left", "middle", count, head, head:getContentSize().width + 20, -20)
    self.count = count

    -- 战机描述
    local describe = XMLLabel()
    describe:setContentSize(cc.size(500, 36))
    describe:setVAlign("middle")
    self:addChild(describe)
    REL:toOther("left", "middle", describe, self, 10, 220)
    self.describe = describe

    --横隔线1
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(self.size.width,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, self, 0, 285)

    --横隔线2
    local seqLine2 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine2:setContentSize(self.size.width,2)
	self:addChild(seqLine2)
    REL:toOther("center", "top", seqLine2, self, 0, 485)

    -- 攻击图片和攻击数值
    self.attackImg,self.attackName,self.attackCount = self:_getImgAndLabel({20,300})


    -- 攻击类型和攻击类型数值
    local attackTypeImg = ccui.ImageView:create()

    attackTypeImg:loadTexture(iconPath .. Prop_temp[1].propIcon)
    attackTypeImg:setScale(IconManager.baseScale[1],IconManager.baseScale[2])

    self:addChild(attackTypeImg)
    REL:toOther("left","top",attackTypeImg,self,300,300)
    self.attackTypeImg = attackTypeImg

    local attackTypeName = XMLLabel()  
    attackTypeName:setContentSize(cc.size(300, 27))
    attackTypeImg:addChild(attackTypeName)
    REL:toOther("left", "middle", attackTypeName, attackTypeImg, attackTypeImg:getContentSize().width * IconManager.baseScale[1] + 20, 0)
    self.attackTypeName = attackTypeName

    -- 血量和数值
    self.hpImg,self.hpName,self.hpCount = self:_getImgAndLabel({20,400})

    -- 精准和数值
    self.hitImg,self.hitName,self.hitCount = self:_getImgAndLabel({20,500})

    -- 闪避和数值
    self.dodgeImg,self.dodgeName,self.dodgeCount = self:_getImgAndLabel({300,500})

    -- 暴击和数值
    self.critImg,self.critName,self.critCount = self:_getImgAndLabel({20,600})

    -- 暴抗和数值
    self.armorImg,self.armorName,self.armorCount = self:_getImgAndLabel({300,600})


    -- 暴伤
    self.violenceInjuryImg,self.violenceInjuryName,self.violenceInjuryCount = self:_getImgAndLabel({20,700})


    -- 暴免
    self.violenceFreeImg,self.violenceFreeName,self.violenceFreeCount = self:_getImgAndLabel({300,700})

end

function T:SetData()
    local sid = self.sid
    local iconPath = IconManager.iconPath
    local data = Aircraft_temp[sid]
    local aircraftInfo = UserInfo.city.aircraftBox.infos[sid]
    

    self.head:loadTexture(iconPath .. data.icon)

    self.name:setString(AircraftUtils:getRichName(data))
    local num = aircraftInfo.num
    self.count:setString(Language:get("uc189",num))
    self.describe:setString(Language:get("uc497",Language:get(data.forbitDes),Language:get(data.describe2,data.capacity)))

    -- 攻击图片和攻击数值
    self.attackImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[2].icon)
    self.attackName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[2].name)))
    local attackOff = PlayerInstance:getAircraftAttack(aircraftInfo) - data.attack
    self.attackCount:setString(Language:get("uc192",data.attack,self:two(attackOff)))


    -- 攻击类型和攻击类型数值
    self.attackTypeImg:loadTexture(iconPath .. AircraftAttackType_temp[data.attackType].icon)
    self.attackTypeName:setString(Language:get("uc191",Language:get(AircraftAttackType_temp[data.attackType].name)))

    -- 血量和数值
    self.hpImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[5].icon)
    self.hpName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[5].name)))
    local hpOff = PlayerInstance:getAircraftHp(aircraftInfo) - data.hp
    self.hpCount:setString(Language:get("uc192",data.hp,self:two(hpOff)))

    -- 精准和数值
    self.hitImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[3].icon)
    self.hitName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[3].name)))
    local hitOff = PlayerInstance:getAircraftHit(aircraftInfo) - data.hitRate
    self.hitCount:setString(Language:get("uc193",data.hitRate,self:one(hitOff)))

    -- 闪避和数值
    self.dodgeImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[4].icon)
    self.dodgeName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[4].name)))
    local dodgeOff = PlayerInstance:getAircraftDodge(aircraftInfo) - data.dodge
    self.dodgeCount:setString(Language:get("uc193",data.dodge,self:one(dodgeOff)))

    -- 暴击和数值
    self.critImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[1].icon)
    self.critName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[1].name)))
    local critOff = PlayerInstance:getAircraftCrit(aircraftInfo) - data.crit
    self.critCount:setString(Language:get("uc193",data.crit,self:one(critOff)))

    -- 暴抗和数值
    self.armorImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[6].icon)
    self.armorName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[6].name)))
    local armorOff = PlayerInstance:getAircraftArmor(aircraftInfo) - data.critResist
    self.armorCount:setString(Language:get("uc193",data.critResist,self:one(armorOff)))


    -- 暴伤
    self.violenceInjuryImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[10].icon)
    self.violenceInjuryName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[10].name)))
--    local critOff = PlayerInstance:getAircraftCrit(aircraftInfo) - data.crit
--    self.violenceInjuryCount:setString(Language:get("uc193",data.crit,self:one(critOff)))
    self.violenceInjuryCount:setString(Language:get("uc193",0,self:one(AccessorySystemManager:getViolenceInjuryAddBySid(aircraftInfo.sid))))

    -- 暴免
    self.violenceFreeImg:loadTexture(iconPath .. AircraftBaseAttribute_temp[9].icon)
    self.violenceFreeName:setString(Language:get("uc191",Language:get(AircraftBaseAttribute_temp[9].name)))
--    local critOff = PlayerInstance:getAircraftCrit(aircraftInfo) - data.crit
--    self.violenceFreeCount:setString(Language:get("uc193",data.crit,self:one(critOff)))
    self.violenceFreeCount:setString(Language:get("uc193",0,self:one(AccessorySystemManager:getViolenceFreeAddBySid(aircraftInfo.sid))))


end

--- 得到一个图片和2个label（pos是得到的这个图片相对于self的位置）
function T:_getImgAndLabel(pos)
    local getImg = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    getImg:loadTexture(iconPath .. Prop_temp[1].propIcon)
    getImg:setScale(IconManager.baseScale[1],IconManager.baseScale[2])

    self:addChild(getImg)
    REL:toOther("left","top",getImg,self,pos[1],pos[2])

    local name = XMLLabel()  
    name:setContentSize(cc.size(300, 27))
    getImg:addChild(name)
    REL:toOther("left", "middle", name, getImg, getImg:getContentSize().width * IconManager.baseScale[1] + 20, 10)

    local count = XMLLabel() 
    count:setContentSize(cc.size(300, 27))
    getImg:addChild(count)
    REL:toOther("left", "middle", count, getImg, getImg:getContentSize().width * IconManager.baseScale[1] + 20, -10)    

    return getImg,name,count
end


--- 保留2位小数
function T:two(num)
    return string.format("%0.2f", num)
end

--- 保留1位小数
function T:one(num)
    return string.format("%0.1f", num)
end

return T
