--[[
 *	联盟弹出改变社交
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 状态，1：敌对，2：友好，3：中立
T.state = nil

--- 构造函数
function T:ctor(allianceId)
    self:setContentSize(cc.size(524,180))

    -- 敌对
    local layout1 = ccui.Layout:create()
    self:addChild(layout1)
    layout1:setContentSize(cc.size(50,150))
    REL:toOther("center","top",layout1,self,-100,20)
    self.layout1 = layout1

    local enemyImg = ccui.ImageView:create()
    enemyImg:loadTexture("allianceLabel_hostile.png",ccui.TextureResType.plistType)
    self:addChild(enemyImg)
    REL:toOther("center","top",enemyImg,layout1,0,2)

    local labEnemy = XMLLabel()
    labEnemy:setContentSize(cc.size(150,36))
    labEnemy:setAlign("center","middle")
    self:addChild(labEnemy)
    REL:toOther("center","top",labEnemy,enemyImg,0,45)
    labEnemy:setString(Language:get("uc463"))

    local btnEnemy = Button.new("false","false")
	btnEnemy:setButtonState("checkBottom.png","checkBottom.png")
	self:addChild(btnEnemy)
	REL:toOther("center","top",btnEnemy,labEnemy,0,50)
    self.btnEnemy = btnEnemy
    btnEnemy:setTouchEnabled(false)


    local enemyRight = ccui.ImageView:create()
    enemyRight:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(enemyRight)
    REL:toOther("center","middle",enemyRight,btnEnemy,0,0)
    self.enemyRight = enemyRight
    enemyRight:setVisible(false)

    -- 中立
    local layout2 = ccui.Layout:create()
    self:addChild(layout2)
    layout2:setContentSize(cc.size(50,150))
    REL:toOther("center","top",layout2,self,0,20)
    self.layout2 = layout2

    local centerImg = ccui.ImageView:create()
    centerImg:loadTexture("allicanceCenter.png",ccui.TextureResType.plistType)
    self:addChild(centerImg)
    REL:toOther("center","top",centerImg,layout2,0,-3)


    local labCenter = XMLLabel()
    labCenter:setContentSize(cc.size(150,36))
    labCenter:setAlign("center","middle")
    self:addChild(labCenter)
    REL:toOther("center","top",labCenter,centerImg,0,50)
    labCenter:setString(Language:get("uc466"))

    local btnCenter = Button.new("false","false")
	btnCenter:setButtonState("checkBottom.png","checkBottom.png")
	self:addChild(btnCenter)
	REL:toOther("center","top",btnCenter,labCenter,0,50)
    self.btnCenter = btnCenter
    btnCenter:setTouchEnabled(false)


    local centerRight = ccui.ImageView:create()
    centerRight:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(centerRight)
    REL:toOther("center","middle",centerRight,btnCenter,0,0)
    self.centerRight = centerRight
    centerRight:setVisible(false)

    -- 友好
    local layout3 = ccui.Layout:create()
    self:addChild(layout3)
    layout3:setContentSize(cc.size(50,150))
    REL:toOther("center","top",layout3,self,100,20)
    self.layout3 = layout3

    local friendImg = ccui.ImageView:create()
    friendImg:loadTexture("allianceLabel_friendly.png",ccui.TextureResType.plistType)
    self:addChild(friendImg)
    REL:toOther("center","top",friendImg,layout3,0,0)

    local labFriend = XMLLabel()
    labFriend:setContentSize(cc.size(150,36))
    labFriend:setAlign("center","middle")
    self:addChild(labFriend)
    REL:toOther("center","top",labFriend,friendImg,0,45)
    labFriend:setString(Language:get("uc462"))

    local btnFriend = Button.new("false","false")
	btnFriend:setButtonState("checkBottom.png","checkBottom.png")
	self:addChild(btnFriend)
	REL:toOther("center","top",btnFriend,labFriend,0,50)
    self.btnFriend = btnFriend
    btnFriend:setTouchEnabled(false)


    local friendRight = ccui.ImageView:create()
    friendRight:loadTexture("needEnoughIcon.png",ccui.TextureResType.plistType)
    self:addChild(friendRight)
    REL:toOther("center","middle",friendRight,btnFriend,0,0)
    self.friendRight = friendRight
    friendRight:setVisible(false)

    self:setButton()


    local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
    if allianceSocial:judgeIsAtEnemyList(allianceId) then -- 判断是否是敌对
        self:enemy()
    elseif allianceSocial:judgeIsAtFrendList(allianceId) then -- 判断是否是好友 
        self:friend()
    else -- 中立
        self:center()
    end


end

function T:setButton()
    self.layout1:setTouchEnabled(true)
    self.layout2:setTouchEnabled(true)
    self.layout3:setTouchEnabled(true)

    local function callback(sender,eventType) 
        if eventType == ccui.TouchEventType.ended then
            if sender == self.layout1 then
                self:enemy()
            elseif sender == self.layout3 then
                self:friend()
            else
                self:center()
            end
        end
    end


    self.layout1:addTouchEventListener(callback)
    self.layout2:addTouchEventListener(callback)
    self.layout3:addTouchEventListener(callback)
end

--- 敌对
function T:enemy()
    self.enemyRight:setVisible(true)
    self.state = 1
    self.centerRight:setVisible(false)
    self.friendRight:setVisible(false)
end

--- 中立
function T:center()
    self.centerRight:setVisible(true)
    self.state = 3
    self.enemyRight:setVisible(false)
    self.friendRight:setVisible(false)

end

--- 好友
function T:friend()
    self.friendRight:setVisible(true)
    self.state = 2
    self.enemyRight:setVisible(false)
    self.centerRight:setVisible(false)
end


return T
