-- *奖励品项，这个项可以动态变化高度和宽度，但是有一个默认值的，在IconManager的awardScale
--  name
--  iconUrl
--  count
--  des
--  orderPriority
local T = class("T",function() return ccui.Layout:create() end)


---
--  awardData:奖励品项,有name，iconUrl，count，des
--  sizeScale：为缩放比例因孿{ 100/100,100/100 } -- 分别代表X和Y
--  vipLevel：来控制显示的vip图标
--  effType:特效类型有0（普通，没特效），1，2，3，4，5
--  vipTimes:vip倍数
function T:ctor(info)
	self.awardData = info.awardData
	self.sizeScale = info.sizeScale or IconManager.awardScale
	self.size = cc.size(IconManager.iconSize[1] * self.sizeScale[1],IconManager.iconSize[2] * self.sizeScale[2])
	self.vipLevel = info.vipLevel or nil
	self.effType = info.effType or nil
	self.vipTimes = info.vipTimes or nil

	self:setContentSize(self.size)

	self:init()
	self:addEvent()

	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	self:setBackGroundColor(cc.c3b(random(0,255),0,0))
	self:setBackGroundColorOpacity(100)
end

function T:init()
	local awardData = self.awardData

	if self.vipLevel then
		-- vip背景
		local vipBack = cc.Sprite:createWithSpriteFrameName("vipBottom.png")
		self:addChild(vipBack)
		REL:toOther("center","middle",vipBack,self,0,16)

		-- vip数量
		local vipCount = XMLLabel()
		vipCount:setContentSize(cc.size(200,36))
		vipCount:setAlign("center","middle")
		self:addChild(vipCount)
		REL:toOther("center","top",vipCount,vipBack,0,8)

		if self.vipTimes == 3 then
			vipCount:setString(Language:get("uc511",self.vipLevel))
		else
			vipCount:setString(Language:get("uc495",self.vipLevel))
		end
	end

	-- 背景图片：和这个self一样大
	local back = cc.Sprite:create(awardData.iconUrl)
	back:setScale(self.sizeScale[1],self.sizeScale[2])
	self:addChild(back)
	REL:relOther(back,self,0,0,0,0)
	self.back = back

	-- 数量显示
	local count = XMLLabel()
	count:setContentSize(cc.size(150,36))
	count:setAlign("right","bottom")
	self:addChild(count)
	REL:toOther("right","bottom",count,self,2,2)
    if awardData.type == "money" or awardData.type == "steel" or awardData.type == "oil" or awardData.type == "silicon" or awardData.type == "titanium" then
        count:setString(Language:get("uc694",UnitConversion.unitTrans(awardData.count)))
    else
        count:setString(Language:get("uc694",awardData.count))
    end
	
	self.count = count

	-- 特效
	if self.effType and self.effType ~= 0 then -- 0的话没特效
		self:addAnimation()
	end
end

--- 添加动画
function T:addAnimation()
	if not self.awardAnimationTag then
		local name = ResLoader:getIconEffByType(self.effType)
		self.awardSpriteTag = ResLoader:createAnimationSprite(name)
		if self.sizeScale == IconManager.baseScale then
			self.awardSpriteTag:setScale(0.7,0.7)
		end

		self:addChild(self.awardSpriteTag)

		REL:toOther("center", "middle", self.awardSpriteTag, self.back, 0, 0)
	end
end

--- 移除动画
function T:removeAnimation()
	if self.awardAnimationTag then
		self.awardAnimationTag:removeFromParent()
		self.awardAnimationTag = nil
	end
end

--- 数量不显示的接口
function T:setSpecial()
	self.countTag = true
end

function T:addEvent()
	self:setTouchEnabled(true)
	BaseButton:extend(self)

	self:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local awardData = self.awardData
			local layout = ItemPopInfo.new(awardData.iconUrl,awardData.name,awardData.count,awardData.des)
			if self.countTag then
				layout.labelNum:setVisible(false)
			end

			local muialter2 = MUIAlter_noTitle.show({
				info = layout,
				flag = 1
			})
		end
	end)

end



return T
