--- 建筑队列是否足够
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor(buyCount,buildQueueCount,ModelResTable,location)
    self.buyCount = buyCount
    self.buildQueueCount = buildQueueCount
    self.ModelResTable = ModelResTable
    self.location = location


	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

    self:setTouchEnabled(true)

	self:setContentSize(cc.size(500,700))

    self.queueItem = BuildingsInfoMgr:getBuildQueueMostMinTime()
    local location = BuildingsInfoMgr:getLocation(self.queueItem.buildingId)
    local infos = BuildingsInfoMgr:getBuildingInfos()
    self.info = infos[location]


	self:init()

    self:update(self.queueItem)

end

--- 进入
function T:onEnter()
    BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.info.id,self,self.update)

end

--- 退出
function T:onExit()
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.info.id,self,self.update)

end


--- 刷新数据
function T:update(buildItem)
    if buildItem.remainingSec and buildItem.remainingSec <= 0 then    --升级完成

	else
		if buildItem then
			-- 处理每帧变化的数据
            local ModelResTable = self.ModelResTable

	        local time = buildItem.remainingSec
	        local allTime = ModelResTable[self.info.level].upgradeTime
	        allTime = BuildingDiamondCalculation:BuildConstructActualTime(allTime)

	        local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()


	        if time <= vipFreeTime then  -- 免费的
                self.speedDescribe:setString(Language:get("uc1069"))

                self.tag = 2
                self.speed:loadTextures("longButton_green_normal.png", "longButton_general_down.png", "",ccui.TextureResType.plistType)
	        else
                local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(buildItem)
                self.speedDescribe:setString(Language:get("uc1068",allDiamond))
                self.tag = 1
                self.speed:loadTextures("longButton_purple_normal.png", "longButton_general_down.png", "",ccui.TextureResType.plistType)

	        end
		end

	end

end


function T:init()
    -- 上面
    local secret = SecretaryGenerator:getBust("susy_clothing_1",SecretaryGenerator.DEFAULT_BUST_RECT)
    secret:setFlippedX(true)
    self:addChild(secret)
    secret:setAnchorPoint(cc.p(0, 0))
    secret:setScale(0.5)
    REL:toOther("right","top",secret,self,10,30)

    local describe = XMLLabel()
    describe:setContentSize(cc.size(340,36))
    self:addChild(describe)
    REL:toOther("left","top",describe,self,10,50)
    describe:setString(Language:get("uc1065"))

    -- 加速
    local speed = Button.new("false","true")
	speed:setButtonState("longButton_purple_normal.png","longButton_general_down.png")
    speed:setString(Language:get("uc1066"))
	self:addChild(speed)
	REL:toOther("left","top",speed,self,50,215)
    speed:setTextShadow()
    speed:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.tag == 1 then -- 钻石加速
                local item = self.queueItem
                local dataFromServer = self.info
                local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
                local nowDiamond = UserInfo.gems

                if allDiamond <= nowDiamond then
                    SpeedUpgradeCommand:new():exec(dataFromServer,function(state,diamond)
                        if state == ReturnCode.SUCCESS then
                            PlayerInstance:setDiamond(diamond)

                            Command:buildQueueTimeFinish()
                            self.muialter:hide()
                            CommonBroadcast:luaDispatchEvent("build_queue_pop_window_finish" .. self.location)
                        else
                            ErrorCode:popErrorCodeTip(state)
                            self.muialter:hide()
                        end

                    end)

                else -- 弹出充值页面
                    self.muialter:hide()
                    MUIPop.MUIToReCharge()
                end


            elseif self.tag == 2 then -- 免费加速
                local dataFromServer = self.info
                if not BuildingsInfoMgr:getBuildQueue()[dataFromServer.id] then  -- 处理时间走完了的情况
                    self.muialter:hide()
                    CommonBroadcast:luaDispatchEvent("build_queue_pop_window_finish" .. self.location)
                    return
                end

                SpeedUpgradeCommand:new():exec(dataFromServer,function(state,diamond)
                    if state == ReturnCode.SUCCESS then
                        PlayerInstance:setDiamond(diamond)

                        Command:buildQueueTimeFinish()
                        self.muialter:hide()
                        CommonBroadcast:luaDispatchEvent("build_queue_pop_window_finish" .. self.location)
                    else
                        ErrorCode:popErrorCodeTip(state)
                        self.muialter:hide()
                    end

                end)
            end


        end
    end)
    self.speed = speed

    -- 加速文本
    local speedDescribe = XMLLabel()
    speedDescribe:setAlign("center","bottom")
    speedDescribe:setContentSize(cc.size(340,36))
    self:addChild(speedDescribe)
    REL:toOther("center","bottom",speedDescribe,speed,0,100)
    speedDescribe:setString(Language:get("uc1068"))
    self.speedDescribe = speedDescribe



    --横隔线1
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(500,2)
	self:addChild(seqLine1)
    REL:toOther("center", "top", seqLine1, self, 0, 315)

    -- 下面
    local secretBottom = SecretaryGenerator:getBust("jayla",SecretaryGenerator.DEFAULT_BUST_RECT)
    secretBottom:setFlippedX(true)
    self:addChild(secretBottom)
    secretBottom:setAnchorPoint(cc.p(0, 0))
    secretBottom:setScale(0.5)
    REL:toOther("right","top",secretBottom,self,-15,320)



    local describeText = Language:get("uc1012",self.buyCount,3 - self.buyCount,UserInfo.vipLevel,self.buildQueueCount)
    local cost = SetStates.buildQueueNumState:getCost()

    local describe2 = XMLLabel()
    describe2:setContentSize(cc.size(340,36))
    self:addChild(describe2)
    REL:toOther("left","top",describe2,self,10,340)
    describe2:setString(Language:get("uc558",cost) .. "<br/>" .. describeText)

    -- 购买
    local buy = Button.new("false","true")
	buy:setButtonState("longButton_purple_normal.png","longButton_general_down.png")
    buy:setString(Language:get("uc1067"))
	self:addChild(buy)
	REL:toOther("left","top",buy,self,50,570)
    buy:setTextShadow()
    buy:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.muialter:hide()
            local gems = UserInfo.gems
            local cost = SetStates.buildQueueNumState:getCost() 
			if gems >= cost then
				local function finish()
					local descripe = Language:get("uc532")
					MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
				end
				BuildingCommand:BuyBuildQueue(finish)
			else
				MUIPop.MUIToReCharge()
			end


        end
    end)



end



function T:setMuialter(muialter)
	self.muialter = muialter
end


return T
