--[[
 *	按钮
]]
local T = class("T",function() return ccui.Button:create() end)

--- 按钮上的图片
T.buttonPic = nil

--- 按钮上的字
T.buttonText = nil

--- 是否有图片
T.isHasPic = nil

--- 是否有文字
T.isHasText = nil

--- 构造函数
function T:ctor(isHasPic,isHasText)  -- 参数第一个为是否有图片，第二个为是否有按钮文字
    self.isHasPic = isHasPic 
    self.isHasText = isHasText

    self:setTouchEnabled(true)

    -- 按钮图片
    if isHasPic == "true" then
        local buttonPic = ccui.ImageView:create()
        buttonPic:setName("uiIcon")
        self:addChild(buttonPic)
        self.buttonPic = buttonPic
    end

    -- 按钮文字(这个也可以是有图片的)
    if isHasText == "true" then
        local buttonText = XMLLabel()
        if CssStyles then
			buttonText:setCssStyle(CssStyles.buttonText)
		end
        buttonText:setName("uiText")
        buttonText:setContentSize(cc.size(200,27))

        self:addChild(buttonText)
        self.buttonText = buttonText
    end

    BaseButton:extend(self)

end

--- 设置正常和按下状态
function T:setButtonState(normalState,downState)
    if normalState and downState then
        self.normalState = normalState
        self.downState = downState

        self:loadTextures(normalState, downState, "",ccui.TextureResType.plistType)
        if self.isHasPic == "true" then
            REL:toOther("left","middle",self.buttonPic,self,40,0)
        end
        if self.isHasText == "true" then
            REL:toOther("left","middle",self.buttonText,self,60,0)
        end
    end
end

--- 设置按钮图片
function T:setButtonPic(icon)
    if icon and self.buttonPic then
        self.buttonPic:loadTexture(icon,ccui.TextureResType.plistType)
    end
end

--- 设置按钮文字
function T:setString(text)
    if text and self.buttonText then
        self.buttonText:setString(text)
    end
end

--- 设置按钮图片可见性
function T:setPicVisible(visible)
    if self.buttonPic then
        self.buttonPic:setVisible(visible)
    end
end

--- 设置按钮文字可见性
function T:setTextVisible(visible)
    if self.buttonText then
        self.buttonText:setVisible(visible)
    end
end

-- 设置文字居中
function T:setTextCenter()
    if not self.buttonText then 
        return 
    end

    self.buttonText:setAlign("center","middle")
    REL:toOther("center","middle",self.buttonText,self,0,0)
end

--- 有倒影的设置
function T:setTextShadow()
    if not self.buttonText then 
        return 
    end

    self.buttonText:setAlign("center","middle")
    REL:toOther("center","middle",self.buttonText,self,0,15)
end

--- 设置为正常状态
function T:setNormalState()
    self:loadTextureNormal(self.normalState,ccui.TextureResType.plistType)
    self:setTouchEnabled(true)
end

--- 设置为按下状态
function T:setDownState()
    self:loadTextureNormal(self.downState,ccui.TextureResType.plistType)
    self:setTouchEnabled(false)
end

return T
