--- 命令
local T = {}

--- 派遣部队
function T:sendArmy(sendInfo,state,aircraftList,finish)
    SendArmyCommand:new():exec(sendInfo,state,aircraftList,function(state)
        if state == ReturnCode.SUCCESS then
            -- 扣除精力
            PlayerInstance:addPlayerEnergy(-1)
            -- 扣除飞机
            local allAircraft = UserInfo.city.aircraftBox.infos
            for i = 1,6,1 do
    	        local item = aircraftList[i]
    	        if item then
                    allAircraft[item.sid]:minNum2(item.count)
    	        end
            end

            PlayerInstance:setPlayerFightLogic()

            if finish then
                finish()
            end

            -- 延迟1帧
            Cocos2dxUtils:timeOut(function()  
                local descripe = Language:get("uc230",sendInfo.x,sendInfo.y)
                MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )  
            end,0)      -- 0表示1帧

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 撤军 id:队列id
function T:withDrawArmy(id,finish) 
    WithdrawCommand:new():exec(id,function(state)
        if state == ReturnCode.SUCCESS then
            
            if finish then
                finish()
            end
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 加速进攻 和 返回加速 : dimaond:加速所需要的钻石，id:队列id
function T:speedCollect(diamond,id)
    local nowDiamond = UserInfo.gems
    if diamond < nowDiamond then
        SpeedCollectCommand:new():exec(id,function(state)
            if state == ReturnCode.SUCCESS then
                
                if finish then
                    finish()
                end
            else
                ErrorCode:popErrorCodeTip(state)
            end
        end)
    else -- 弹出充值页面
        MUIPop.MUIToReCharge()
    end
end

--- 设置防御部队
function T:setDefence(aircraftList,finish)
    SetDefenceCommand:new():exec(aircraftList,function(state)
        if state == ReturnCode.SUCCESS then
                
            if finish then
                finish()
            end
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 修理所有飞机部队
function T:repairAllAircraft(isUseGems,finish)
    if BuildingDiamondCalculation:repairAllAirGems() == 0 or BuildingDiamondCalculation:repairAllAirMoney() == 0 then
        MUIPop.NotReapairAircraft()
        return
    end

    local judge = false
    if isUseGems == true then
        local gems = UserInfo.gems
        local repairAircrafts = UserInfo.city.aircraftBox:getRepair()
        for k,v in pairs(repairAircrafts) do
            if v and v.num > 0 then
                local cost = BuildingDiamondCalculation:repairSingleAirGems(v.sid)
                local realCost = BuildingDiamondCalculation:getRealCost(cost)
                if realCost <= gems then
                    judge = true
                    break
                end
            end
        end
        if judge == false then
            MUIPop.DiamondIsNotEnough()
            return
        end
    else
        local money = UserInfo.city.money
        local repairAircrafts = UserInfo.city.aircraftBox:getRepair()
        for k,v in pairs(repairAircrafts) do
            if v and v.num > 0 then
                local cost = BuildingDiamondCalculation:repairSingleAirMoney(v.sid)
                local realCost = BuildingDiamondCalculation:getRealCost(cost)
                if realCost <= money then
                    judge = true
                    break
                end
            end
        end
        if judge == false then
            MUIPop.MoneyIsNotEnough()
            return
        end
    end



    RepairAllArmyCommand:new():exec(isUseGems,function(state)
        if state == ReturnCode.SUCCESS then
            
            if finish then
                finish()
            end

            local descripe = Language:get("uc232")
            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )  

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
    
end


--- 修理单个飞机部队
function T:repairSingleAircraft(sid,isUseGems,finish)
    local repairAircrafts = UserInfo.city.aircraftBox:getRepair()
    if repairAircrafts[sid] and repairAircrafts[sid].num == 0 then
        MUIPop.NotReapairAircraft()
        return
    end

    local judge = false
    if isUseGems == true then
        local gems = UserInfo.gems
        local repairAircrafts = UserInfo.city.aircraftBox:getRepair()
        if repairAircrafts[sid] and repairAircrafts[sid].num > 0 then
            local cost = BuildingDiamondCalculation:repairSingleAirGems(sid)
            local realCost = BuildingDiamondCalculation:getRealCost(cost)
            if realCost <= gems then
                judge = true
            end
        end 

        if judge == false then
            MUIPop.DiamondIsNotEnough()
            return
        end

    else
        local money = UserInfo.city.money
        local repairAircrafts = UserInfo.city.aircraftBox:getRepair()
        if repairAircrafts[sid] and repairAircrafts[sid].num > 0 then
            local cost = BuildingDiamondCalculation:repairSingleAirMoney(sid)
            local realCost = BuildingDiamondCalculation:getRealCost(cost)
            if realCost <= money then
                judge = true
            end
        end 

        if judge == false then
            MUIPop.MoneyIsNotEnough()
            return
        end
    end


    RepairSingleArmyCommand:new():exec(sid,isUseGems,function(state)
        if state == ReturnCode.SUCCESS then
            
            if finish then
                finish()
            end

            local name = Aircraft_temp[sid].name
            local descripe = Language:get("uc231",Language:get(name))
            MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )  

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
    
end

--- 获得排行榜
function T:SendRank(sendType,startPos,finish)
    SendRankCommand:new():exec(sendType,startPos,function(state)
        if state == ReturnCode.SUCCESS then
                
            if finish then
                finish()
            end
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 主界面底部按钮条点击获取
function T:SendThreeRank(finish)
    SendRankCommand:new():exec(1,1,function(state)
        if state == ReturnCode.SUCCESS then
                SendRankCommand:new():exec(2,1,function(state)
                    if state == ReturnCode.SUCCESS then
                            SendRankCommand:new():exec(3,1,function(state)
                                if state == ReturnCode.SUCCESS then
                                    if finish then
                                        finish()
                                    end
                                else
                                    ErrorCode:popErrorCodeTip(state)
                                end
                            end)
                    else
            
                    end
                end)
        else
            
        end
    end)

end

--- 设置付费提示
function T:SetPayCommand()
    require("src.app.communication.systemSet.SetPayTipCommand"):new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 设置通知提示
function T:SetNoticeCommand()
    require("src.app.communication.systemSet.SetNoticeCommand"):new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 设置普通设置
function T:SetCommonCommand()
    require("src.app.communication.systemSet.SetCommonCommand"):new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 升级飞机属性无钻石
function T:UpgradeAttrNoGmesCommand(fighterLevel,fighterAttr,needNum,finish)
    require("src.app.communication.aircraftStrength.StrengthUpgradeAttrCommand"):new():exec(fighterLevel,fighterAttr,false,function(state)
        if state == ReturnCode.SUCCESS then
            PropsInfoMgr:reducePlayerPropByID(204,needNum) -- 更新道具数量
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 升级飞机属性需要钻石
function T:UpgradeAttrNeedGmesCommand(fighterLevel,fighterAttr,needNum,needDiamond,finish)
    local nowDiamond = UserInfo.gems
    if needDiamond < nowDiamond then
        require("src.app.communication.aircraftStrength.StrengthUpgradeAttrCommand"):new():exec(fighterLevel,fighterAttr,true,function(state)
            if state == ReturnCode.SUCCESS then
                PropsInfoMgr:setPlayerPropByID(204,0) -- 更新道具数量
                if finish then
                    finish()
                end

            else
                ErrorCode:popErrorCodeTip(state)
            end
        end)
    else -- 弹出充值页面
        MUIPop.MUIToReCharge()
    end

end

--- 获得运输线数据
function T:getTransportInfo(finish)
    require("src.app.communication.aircraftStrength.GetTransInfoCommand"):new():exec(function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

---------------------活动---------------------------

--- 每日签到
function T:dailyAttendance(finish)
    DailyAttendanceCommand:new():exec(function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 连续签到:奖励下标awardIndex：0到3
function T:continueAttendance(awardIndex,finish)
    ContinueAttendanceCommand:new():exec(awardIndex,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

-- 购买成长计划
function T:buyGrowthPlan(finish)
    BuyGrowthPlanCommand:new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

-- 得到成长计划钻石
function T:getGrowthPlanGems(awardIndex,finish)
    GetGrowthPlanAwardCommand:new():exec(awardIndex,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

-- 得到等级礼包奖励
function T:getGradePackageAward(awardIndex,finish)
    GetGradePackageAwardCommand:new():exec(awardIndex,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

-- 得到开服豪礼奖励
function T:getOpenServerAward(awardIndex,finish)
    GetOpenServerAwardCommand:new():exec(awardIndex,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 得到某一个动态活动的数据
function T:getDynamicActData(sid,finish)
    GetDynamicDataCommand:new():exec(sid,function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 参加某一个动态活动（比如大转盘就是抽奖）
function T:joinDynamicAct(sid,finish,joinSid)
    JoinDynamicCommand:new():exec(sid,function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end,joinSid)

end


--- 购买瓶盖
function T:buyBottleCap(finish)
    BuyBottleCapCommand:new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)

end


--- 幸运抽奖,finish2是失败，移除遮罩
function T:luckyLottery(finish,finish2)
    LotteryCommand:new():exec(function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            else
                finish2()
            end

        else
            finish2()
            ErrorCode:popErrorCodeTip(state)
        end
    end)

end


---------------------活动---------------------------

--- 建筑时间完成，生产和改造飞机，科研完成，分别发送以上3个消息到后台（除了一键秒以外）
--- 生产时间完成，发送建筑队列
function T:buildQueueTimeFinish(finish)
    SendBuildQueueCommand:new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 生产时间完成，发送科研队列
function T:scienceQueueTimeFinish(finish)
    SendScienceQueueCommand:new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 生产时间完成，发送招募（飞机生产完成）队列
function T:aircraftQueueTimeFinish(finish)
    SendAircraftQueueCommand:new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


------------------------------- 内购 -----------------------------------------------
--- 得到所有商品内购消息
function T:getGoodsListInfo(finish)
    GetGoodsListInfoCommand():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 得到所有新手礼包内购消息
function T:getNewRechargeListInfo(finish)
    GetNewRechargeCommand:new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 购买某一件商品
function T:payGoods(verifyInfo,finish)
    PayGoodsCommand:new():exec(verifyInfo,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end
        else
            
        end
    end)
end

--- 内购购买产品
function T:payIapGoods(productId,productCount) -- productId产品id
    print("发送次数1111111111111111111111111111111111111111111111111111")
    Cashier:paymentWithProduct(productId,productCount or 1)
end
------------------------------- 内购 -----------------------------------------------


------------------------------- 配件 -----------------------------------------------
--- 制造并且安装配件
function T:makeAndInstallAccessory(sid,airType,slotType,finish)
    MakeAndInstallAccessoryCommand:new():exec(sid,airType,slotType,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 安装配件
function T:installAccessory(id,airType,slotType,finish)
    InstallAccessoryCommand:new():exec(id,airType,slotType,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 卸载配件
function T:unloadAccessory(airType,slotType,finish)
    UnloadAccessoryCommand:new():exec(airType,slotType,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 升级配件：这个是肯定要升级的，金钱判断已经在那边进行了
function T:levelUpAccessory(levelUpType,id,finish)
    LevelUpAccessoryCommand:new():exec(levelUpType,id,function(state,levelUpSuccess)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish(levelUpSuccess)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 改造配件,数量足够的时候
function T:reformAccessory(id,finish)
    ReformAccessoryCommand:new():exec(id,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 分解配件
function T:decomposeAccessory(id,finish)
    DecomposeAccessoryCommand:new():exec(id,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData) -- 奖励品用于显示用的
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 分解蓝图
function T:decomposeBluePrint(sid,num,finish)
    DecomposeBluePrintCommand:new():exec(sid,num,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData) -- 奖励品用于显示用的
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 用蓝图碎片兑换蓝图
function T:exchangeBluePrint(sid,finish)
    ExchangeBluePrintCommand:new():exec(sid,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData) -- 奖励品用于显示用的
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 批量分解配件
function T:batchDecomposeAccessory(quality,finish)
    BatchDecomposeAccessoryCommand:new():exec(quality,function(state,awardData)
        if state == ReturnCode.SUCCESS then
            if finish and awardData then
                finish(awardData) -- 奖励品用于显示用的
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 用蓝图制造配件
function T:makeAccessory(sid,finish)
    MakeAccessoryCommand:new():exec(sid,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end




------------------------------- 配件 -----------------------------------------------


--- 配件抽卡
function T:accessoryDrawCard(sid,useGems,ten,costDiamond,finish)
    if useGems then -- 使用钻石
        local nowDiamond = UserInfo.gems
        if costDiamond <= nowDiamond then

            AccessoryDrawCardCommand:new():exec(sid,useGems,ten,function(state,awardData)
                if state == ReturnCode.SUCCESS then
                    if finish and awardData then
                        finish(awardData)
                    end

                else
                    ErrorCode:popErrorCodeTip(state)
                end
            end)

        else -- 弹出充值页面
            MUIPop.MUIToReCharge()
        end

    else

        AccessoryDrawCardCommand:new():exec(sid,useGems,ten,function(state,awardData)
            if state == ReturnCode.SUCCESS then
                if finish and awardData then
                    finish(awardData)
                end

            else
                ErrorCode:popErrorCodeTip(state)
            end
        end)

    end

end

--- 得到公告信息
function T:getAnnounceInfo(announceCrc,finish)
    require("src.app.communication.announce.GetAnnounceInfoCommand"):new():exec(announceCrc,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 查看公告信息命令
function T:readAnnounceInfo(announceInfoId,finish)
    require("src.app.communication.announce.ReadAnnounceInfoCommand"):new():exec(announceInfoId,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


------------------------------- 设置阵型 -----------------------------------------------
--- 设置阵型命令
function T:setFormation(formationId,aircraftList,finish)
    require("src.app.communication.formation.SetFormationCommand"):new():exec(formationId,aircraftList,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end
 
 --- 设置默认阵型命令
function T:setDefalutFormation(formationId,finish)
    require("src.app.communication.formation.SetDefalutFormationCommand"):new():exec(formationId,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


------------------------------- 设置阵型 -----------------------------------------------

--- 升级高级指挥
function T:upgradeSeniorDLevel(finish)
    require("src.app.communication.honor.UpgradeSeniorDLevelCommand"):new():exec(function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 得到荣誉商品信息
function T:getHonorGoodsInfo(finish)
    require("src.app.communication.honor.GetGoodsInfoCommand"):new():exec(function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)

end

--- 兑换荣誉商品信息
function T:exchangeHonorGoods(goodsId,finish)
    require("src.app.communication.honor.ExchangeGoodsCommand"):new():exec(goodsId,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)

end


--- FackBookShare
function T:faceBookShare(finish)
    require("src.app.communication.share.FaceBookShareCommand"):new():exec(function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

			print("领取分享奖励成功")
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)

end


--- 查看得到的荣誉勋章
function T:checklGetMedal(finish)
    require("src.app.communication.honor.ChecklGetMedalCommand"):new():exec(function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end
        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)

end


--- 得到荣誉勋章
function T:getMedal(finish)
    require("src.app.communication.honor.GetMedalCommand"):new():exec(function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)

end


--- 查看奖励返回
function T:checkFirstRecharge(finish)
    require("src.app.communication.allActivity.fixAndDynamic.firstRecharge.CheckFirstRechargeCommand"):new():exec(function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 领取首次充值奖励
function T:getFirstRecharge(index,finish)
    require("src.app.communication.allActivity.fixAndDynamic.firstRecharge.GetFirstRechargeCommand"):new():exec(index,function(state,data)
        if state == ReturnCode.SUCCESS then
            if finish and data then
                finish(data)
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end


--- 替换主城样式
function T:changeCityShowType(showType,finish)
    require("src.app.communication.playerInfo.ChangeCityShowTypeCommand"):new():exec(showType,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end

--- 重置双倍标记
function T:useDoubleRechargeProp(propSid,iapSid,threeMarkValue,finish)
    require("src.app.communication.prop.UseDoubleRechargePropCommand"):new():exec(propSid,iapSid,threeMarkValue,function(state)
        if state == ReturnCode.SUCCESS then
            if finish then
                finish()
            end

        else
            ErrorCode:popErrorCodeTip(state)
        end
    end)
end



return T