--- 常用的方法
local T = {}

--- 形如这种 oil_mine.17,提前字符串，oil_mine,17
function T:getCharFromStr(str)
	local strArr=StringUtils.split(str,".")
	
	return string.gsub(strArr[1],"Lv",""),strArr[2]
end

--- 得到text
function T:getRealText(str)
    if str == "gold_mine" then
        return Language:get("uc235")
    elseif str == "steel_mine" then
        return Language:get("uc236")
    elseif str == "oil_mine" then
        return Language:get("uc237")
    elseif str == "silicon_mine" then
        return Language:get("uc238")
    elseif str == "titanium_mine" then
        return Language:get("uc239")
    else
        return str
    end

end


--- 钻石扣除或者增加特效:left:左边，right:右边;
function T:diamondEff(direction)
	local scence = Director:getRunningScene()

	local diamond = nil
	local diffDiamond = PlayerInstance:getDiffDiamond()
	if diffDiamond and diffDiamond > 0 then
		AudioManager:playEffect(SoundRes.SOUND_GEMS_CONSUMPTION)
		diamond = Language:get("uc766",diffDiamond)
	elseif diffDiamond and diffDiamond < 0 then
		AudioManager:playEffect(SoundRes.SOUND_GEMS_CONSUMPTION)
		diamond = Language:get("uc767",math.abs(diffDiamond))
	end


	if direction == "left" then
		local name = XMLLabel()
		name:setAlign("left","top")
		name:setContentSize(cc.size(150,36))
		scence:addChild(name)
		REL:toScreen("left", "top", name, 100, 40)
		name:setLocalZOrder(1000000)

		if diamond then
			name:setString(diamond)
		end

		local posX = name:getPositionX()
		local posY = name:getPositionY()

		name:runAction(cc.Sequence:create(
			cc.MoveTo:create(1, cc.p(posX,posY - 100)),
			cc.CallFunc:create( function(target)
				target:removeFromParent()
			end)
		))


	elseif direction == "right" then
		local name = XMLLabel()
		name:setAlign("right","top")
		name:setContentSize(cc.size(150,36))
		scence:addChild(name)
		REL:toScreen("right", "top", name, 100, 40)
		name:setLocalZOrder(1000000)

		if diamond then
			name:setString(diamond)
		end

		local posX = name:getPositionX()
		local posY = name:getPositionY()

		name:runAction(cc.Sequence:create(
			cc.MoveTo:create(1, cc.p(posX,posY - 100)),
			cc.CallFunc:create( function(target)
				target:removeFromParent()
			end)
		))

	end


end



--- 战斗力刷新特效显示
function T:fightRefresh()
	local scence = Director:getRunningScene()
	if PlayerInstance.fightDiff and math.floor(PlayerInstance.fightDiff) ~= 0 then
		if not UserInfo.fightEffList then
			UserInfo.fightEffList = {}
		end
		for k,v in pairs(UserInfo.fightEffList) do
			if v then
				v:removeSelf()
			end
		end

		local scence = Director:getRunningScene()
		local layout = require("src.app.uiScript.components.share.FightEff").new()
		scence:addChild(layout)
		REL:toScreen("center", "bottom", layout, 0, V_SZ.height/3)

		table.insert(UserInfo.fightEffList,layout)
	end

end

--- 画线
function T:drawLine(width,height)
    local layer = cc.Layer:create()

    local draw = cc.DrawNode:create()
    layer:addChild(draw)
    draw:drawSegment(cc.p(-(width/2 + 5),height/2), cc.p(width/2 + 5, -height/2), 1.5, cc.c4f(1, 0, 0, 1))  -- 动态得到宽度和高度
    REL:toOther("center","middle",draw,layer,0,0)
    layer.draw = draw
    --REL:toOther("center","middle",layer,self.uiContainer,0,0)
    return layer

end


return T
