--- facebook分享弹窗
local T = class("T",function() return ccui.Layout:create() end)

T.uiMask=nil

--- 构造函数
function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

	self:setContentSize(cc.size(550,120))


	self:init()

end

--- 进入
function T:onEnter()
	local function finish()
		if SetStates.faceBookShareAward:judgeIsShare() == false then
			if self.muialter then
				self.muialter:hide()
			end
		end

	end
	self.finish = finish
	SetStates.faceBookShareAward:luaAddEventListener(SetStates.faceBookShareAward.EVT_FACK_BOOK_SHARE_REFRESH,nil,self.finish)

end

--- 退出
function T:onExit()
	SetStates.faceBookShareAward:luaRemoveEventListener(SetStates.faceBookShareAward.EVT_FACK_BOOK_SHARE_REFRESH,nil,self.finish)

end


function T:init()
	local secret = SecretaryGenerator:getBust("susy_clothing_1",SecretaryGenerator.DEFAULT_BUST_RECT)
	self:addChild(secret)
	secret:setAnchorPoint(cc.p(0, 0))
	secret:setScale(0.5)
	REL:toOther("left","top",secret,self,20,5)

	-- 描述
	local des = XMLLabel()
	des:setContentSize(cc.size(500,36))
	self:addChild(des)
	REL:toOther("left","top",des,self,200,0)
	des:setString(Language:get("uc1017"))

	-- icon
	local icon = ccui.ImageView:create()
	icon:loadTexture(IconManager.iconPath .. PlayerAddAttributeIcon_temp[3].icon)
	icon:setScale(IconManager.resScale[1],IconManager.resScale[2])
	self:addChild(icon)
	REL:toOther("left","top",icon,self,200,50)

	local name = XMLLabel()
	name:setContentSize(cc.size(300,36))
	name:setAlign("left","middle")
	self:addChild(name)
	REL:toOther("left","middle",name,icon,70,15)
	name:setString(Language:get(PlayerAddAttributeIcon_temp[3].name))

	local count = XMLLabel()
	count:setContentSize(cc.size(300,36))
	count:setAlign("left","middle")
	self:addChild(count)
	REL:toOther("left","middle",count,icon,70,-15)
	count:setString(50)


	-- 图标
	local img = ccui.ImageView:create()
	img:loadTexture("faceBookIcon.png",ccui.TextureResType.plistType)
	self:addChild(img)
	REL:toOther("right","top",img,self,260,130)

	-- 分享按钮
	local shareBtn = Button.new("false","true")
	shareBtn:setButtonState("longButton_yellow_normal.png","longButton_general_down.png")
	shareBtn:setString(Language:get("uc1016"))
	self:addChild(shareBtn)
	REL:toOther("right","top",shareBtn,self,50,130)
	shareBtn:setTextShadow()
	shareBtn:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			self:share()
		end
	end)
end

function T:addMask()
	self.uiMask=require("src.app.uiScript.components.common.CommunicationWaitingMask"):show()
end

function T:rmvMask()
	if self.uiMask then
		self.uiMask:hide()
		self.uiMask=nil
	end
end

--- 分享
function T:share()
	if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
		self:addMask()

		self:addShareEvtListeners()
		SDK_Delegate:doShare_facebook(
			Language:get("ug_share"),
			Language:get("ug_share_text")
		)
	elseif C_PFM == cc.PLATFORM_OS_ANDROID and SDK_Android_weixin_Delegate then
		self:addMask()

		self:addShareEvtListeners()

		SDK_Android_weixin_Delegate:sendMsgToFriend(
			Language:get("ug_share"),
			Language:get("ug_share"),
			Language:get("ug_share_text")
		)
	end

end


---------------------------------------------facebookshare-----------------------------------------------------------------
if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then
	--- 分享成功
	function T:shareSuccessHandler()
		self:rmvShareEvtListeners()
		self:rmvMask()

		-- 先要去feacbook那边通讯，接收成功的回调才进下面的操作
		local function finish(data)
			require("src.app.communication.award.AwardDataDecoder"):showSuccessWindow(data)
			if self.muialter then
				self.muialter:hide()
			end

		end
		Command:faceBookShare(finish)
	end

	--- 分享失败
	function T:shareFailureHandler()
		self:rmvShareEvtListeners()
		self:rmvMask()

		MUIAlter_singleLine.show({
			info=Language:get("ug_share_failure"),
			showSecond = 1,
		})
	end

	--- 添加分享侦听器
	function T:addShareEvtListeners()
		SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_SHARE_SUCCESS,self,self.shareSuccessHandler)
		SDK_Delegate:luaAddEventListener(SDK_Delegate.EVT_TYPE_SHARE_FAILURE,self,self.shareFailureHandler)
	end

	--- 移除分享侦听器
	function T:rmvShareEvtListeners()
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_SHARE_SUCCESS,self,self.shareSuccessHandler)
		SDK_Delegate:luaRemoveEventListener(SDK_Delegate.EVT_TYPE_SHARE_FAILURE,self,self.shareFailureHandler)
	end
end
---------------------------------------------facebookshare-----------------------------------------------------------------


---------------------------------------------安卓微信分享-----------------------------------------------------------------
if C_PFM == cc.PLATFORM_OS_ANDROID and SDK_Android_weixin_Delegate then
	--- 分享成功
	function T:shareSuccessHandler()
		self:rmvShareEvtListeners()
		self:rmvMask()

		-- 先要去后台那边通讯，接收成功的回调才进下面的操作
		local function finish(data)
			--require("src.app.communication.award.AwardDataDecoder"):showSuccessWindow(data)
			if self.muialter then
				self.muialter:hide()
			end

		end
		--Command:faceBookShare(finish)
	end

	--- 分享失败
	function T:shareFailureHandler()
		self:rmvShareEvtListeners()
		self:rmvMask()

		MUIAlter_singleLine.show({
			info=Language:get("ug_share_failure"),
			showSecond = 1,
		})
	end

	--- 添加分享侦听器
	function T:addShareEvtListeners()
		SDK_Android_weixin_Delegate:luaAddEventListener(SDK_Android_weixin_Delegate.SHARE_SUCCESS,self,self.shareSuccessHandler)
		SDK_Android_weixin_Delegate:luaAddEventListener(SDK_Android_weixin_Delegate.SHARE_FAIL,self,self.shareFailureHandler)
		SDK_Android_weixin_Delegate:luaAddEventListener(SDK_Android_weixin_Delegate.UNKNOWN_ERROR,self,self.shareFailureHandler)
	end

	--- 移除分享侦听器
	function T:rmvShareEvtListeners()
		SDK_Android_weixin_Delegate:luaRemoveEventListener(SDK_Android_weixin_Delegate.SHARE_SUCCESS,self,self.shareSuccessHandler)
		SDK_Android_weixin_Delegate:luaRemoveEventListener(SDK_Android_weixin_Delegate.SHARE_FAIL,self,self.shareFailureHandler)
		SDK_Android_weixin_Delegate:luaRemoveEventListener(SDK_Android_weixin_Delegate.UNKNOWN_ERROR,self,self.shareFailureHandler)
	end

end



---------------------------------------------安卓微信分享-----------------------------------------------------------------







function T:setMuialter(muialter)
	self.muialter = muialter
end


return T
