--[[
 *	数字图片项
]]
local item = class("item",function() return ccui.Layout:create() end)

--- 构造函数
function item:ctor()
    self:setContentSize(cc.size(35,49))

    local digital = ccui.ImageView:create()
    digital:loadTexture("0.png",ccui.TextureResType.plistType)
    self:addChild(digital)
    REL:toOther("center","middle",digital,self,0,0)
    self.digital = digital

--    self.beforeNum = 0 -- 变化之前的数字值
--    self.afterNum = 0 -- 变化之后的数字值

--    self.beforeChangeVisible = false -- 变化之前的可见性
--    self.afterChangeVisible = false -- 变化之后的可见性
    

end

function item:loadTexture(num)
    self.digital:loadTexture(num ..".png",ccui.TextureResType.plistType)
end

function item:setVisible(visible)
    self.digital:setVisible(visible)
end

function item:setBeforeNum()
    self:loadTexture(self.data.beforeNum)
end

function item:setAfterNum()
    self:loadTexture(self.data.afterNum)
end

function item:setBeforeChangeVisible()
    self:setVisible(self.data.beforeChangeVisible)
end

function item:setAfterChangeVisible()
    self:setVisible(self.data.afterChangeVisible)
end


function item:setData(data)
    self.data = data
end

--- 翻转特效
function item:runAction()
    
end


--[[
 *	战斗力特效
]]
local T = class("T",function() return ccui.Layout:create() end)


--- 构造函数
function T:ctor()
    self.fightDiff = PlayerInstance.fightDiff  
    self.nowFight = PlayerInstance:getPlayerFight()
    self.lastFight = self.nowFight - self.fightDiff

    self.fightDiff = math.floor(self.fightDiff)
    self.nowFight = math.floor(self.nowFight)
    self.lastFight = math.floor(self.lastFight)

--    self.fightDiff = 5
--    self.nowFight = 10
--    self.lastFight = 562

    self:setLocalZOrder(1000000)

    self:setContentSize(cc.size(640,120))

    self:getWidget()

    self:addEff()

end


function T:getWidget()
    -- 背景图片（居中）
    local back = ccui.ImageView:create()
    back:loadTexture("digitalBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("center","middle",back,self,0,0)
    self.back = back


    local lastDataTable,lastLength = self:getNumGroup(self.lastFight)
    local nowDataTable,nowLength = self:getNumGroup(self.nowFight)

    self.showLength = nowLength -- 显示的长度

    if lastLength > nowLength then
        local diff = lastLength - nowLength
        local key = -1
        for i = 1,diff,1 do
            local data = {}
            data.key = key
            data.num = 0
            nowDataTable[#nowDataTable + 1] = data

            key = key - 1
        end

    elseif lastLength < nowLength then
        local diff = nowLength - lastLength
        local key = -1
        for i = 1,diff,1 do
            local data = {}
            data.key = key
            data.num = 0
            lastDataTable[#lastDataTable + 1] = data

            key = key - 1
        end
    end

    lastLength = #lastDataTable -- 现在长度应该相等了
    nowLength = #nowDataTable

    table.sort(lastDataTable,function(a,b) -- 从高位排
		return a.key < b.key
	end)

    table.sort(nowDataTable,function(a,b)
		return a.key < b.key
	end)


    local itemTable = {}
    for i = 1,9,1 do  -- 从高位到最个位
        local data = {}
        data.key = i


        if lastDataTable[i] then
            data.beforeNum = lastDataTable[i].num

            if lastDataTable[i].key < 1 then
                data.beforeChangeVisible = false 
            else
                data.beforeChangeVisible = true 
            end

        else
            data.beforeNum = 0 
            data.beforeChangeVisible = false 
        end


        if nowDataTable[i] then
            data.afterNum = nowDataTable[i].num

            if nowDataTable[i].key < 1 then
                data.afterChangeVisible = false 
            else
                data.afterChangeVisible = true 
            end

        else
            data.afterNum = 0 
            data.afterChangeVisible = false 
        end
       

       itemTable[#itemTable + 1] = data

    end


    -- 战斗力图片和9个背景layout
    local fightLayout = ccui.Layout:create()
    fightLayout:setContentSize(cc.size(200,120))
    self:addChild(fightLayout)
    REL:toOther("center","middle",fightLayout,back,0,0)
    self.fightLayout = fightLayout

--  fightLayout:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	fightLayout:setBackGroundColor(cc.c3b(0xff,0,0))
--	fightLayout:setBackGroundColorOpacity(100)

	local LanguageUtils=require("src.app.utils.LanguageUtils")

    -- 战斗力图片
    local fightBack = ccui.ImageView:create()
    fightBack:loadTexture("res/images/lang/"..LanguageUtils:getCode().."/fighting.png",ccui.TextureResType.localType)
    self:addChild(fightBack)
    REL:toOther("left","middle",fightBack,fightLayout,0,0)
    self.fightBack = fightBack

    -- 重新定位位置(考虑到多语言的图片问题)
    local fightBackWidth = fightBack:getContentSize().width
    local baseLeft = fightBackWidth + 5
    local step = 35
    local width = step * nowLength + baseLeft
    self.width = width
    REL:toOther("center","middle",fightLayout,back,0,0)
    REL:toOther("left","middle",fightBack,fightLayout,0,0)


    -- 添加那9张图片,距离fightLayout左边
    self.posLeft = { baseLeft, baseLeft + step, baseLeft + step*2, baseLeft + step*3, baseLeft + step*4, baseLeft + step*5,
                     baseLeft + step*6,baseLeft + step*7,baseLeft + step*8}


    
    self.items = {}
    self.startpos = nowLength -- 开始位置
    for i = 1,9,1 do
        local item = item.new()
        self:addChild(item)
        item:setData(itemTable[i])
        item:setBeforeNum()
        item:setBeforeChangeVisible()
        REL:toOther("left","middle",item,fightLayout,self.posLeft[i],0)

        self.items[#self.items + 1] = item
    end


end

--- 把一个数分解成各个数字，有从个位依次向高位排序,最多9位数
function T:getNumGroup(num)
    local num = num

    local numString = tostring(num)  -- 数字转字符串
    local numTable,c = StringUtils.str2WCharArray(numString)  -- 得到字符串数组和长度

    local dataTable = {}
    for i = 1,c,1 do
        local data = {}
        data.key = i
        data.num = tonumber(numTable[i])
        dataTable[#dataTable + 1] = data
    end

    table.sort(dataTable,function(a,b)
		return a.key > b.key
	end)

    return dataTable,c

end

function T:addEff()
    local s = cc.Sprite:create()
    s:setSpriteFrame(ResLoader:getSpriteFrame("fightValue.png"))
    s:setBlendFunc({src=0x0302, dst=1})
    self:addChild(s)
    s:setLocalZOrder(10000001)
    REL:toOther("right","middle",s,self,-200,0)
    self.s = s

    self.id = Cocos2dxUtils:interval(function()
        local sPos = s:convertToWorldSpace(cc.p(0,0))
        for i = 1,self.startpos,1 do
            local itemPos = self.items[i]:convertToWorldSpace(cc.p(0,0))
            if sPos.x - 5 < itemPos.x  and itemPos.x < sPos.x + 50 then
                self.items[i]:setAfterNum()
                self.items[i]:setAfterChangeVisible()
            end
        end

    end,1/60)

    local posY = s:getPositionY()
    s:runAction(
        cc.Sequence:create(
            cc.MoveTo:create(1, cc.p(-200,posY)),
		    cc.CallFunc:create( function()    
		    end)
	    )
	)

    -- 加上数字特效
    AbstractUI.timeout(self,function()
        local value = nil
        local fntPah = nil
        if self.fightDiff > 0 then
            value = Language:get("uc782",self.fightDiff)
            fntPah = "res/images/fight/fightAdd.fnt"
        else
            value = Language:get("uc783",math.abs(self.fightDiff))
            fntPah = "res/images/fight/fightMinus.fnt"
        end

        local layout = ccui.Layout:create()
        layout:setContentSize(cc.size(self.showLength * 35,1))
        self:addChild(layout)
        REL:toOther("right","middle",layout,self.fightLayout,0,0)

        local digitalFnt = ccui.TextBMFont:create(value,fntPah)
        self:addChild(digitalFnt)
        REL:toOther("center","bottom",digitalFnt,layout,0,30)

        local posX = digitalFnt:getPositionX()
        local posY = digitalFnt:getPositionY()
        digitalFnt:runAction(cc.Sequence:create(
	        cc.MoveTo:create(0.8, cc.p(posX,posY + 100)),
	        cc.CallFunc:create( function(target)
                self:removeSelf()
	        end)
        ))

    end,0.7)


end

function T:removeSelf()
    self.s:stopAllActions()

    if self.id then
        Cocos2dxUtils:clearScheduler(self.id)
    end
    
    for k,v in pairs(UserInfo.fightEffList) do
        if v == self then
            UserInfo.fightEffList[k] = nil
        end
    end

    self:removeFromParent()
end



return T
