--[[
 *	列表中的项,分为左中右3块，
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 这个窗口的大小
T.size = nil

--- 中间的3个位置表:离左边和顶部
T.centerThreePos = nil

--- 中间的2个位置表:离左边和顶部,还要测试
T.centerTwoPos = nil

--- lable的tag基础值
T.baseValue = 5000

--- 构造函数
function T:ctor()
    self:init()
end

function T:init(size)
    self.centerThreePos = {{75,10},{75,35},{75,60}}
    self.centerTwoPos = {{75,15},{75,45}}

    local defalutSize = cc.size(616,93)
    self.size = size or defalutSize

    -- 背景图片
    local generalItemBackFrame = ResLoader:getSpriteFrame("generalItemBack.png")
    local generalItemBackFrameSize = generalItemBackFrame:getOriginalSize()
    local generalItemBack = Scale9Sprite:createWithFrame(generalItemBackFrame,cc.rect(generalItemBackFrameSize.width/2,generalItemBackFrameSize.height/2,1,1))
    generalItemBack:setContentSize(self.size)
	self:addChild(generalItemBack)
    self:setContentSize(self.size)

    REL:toOther("left","top",generalItemBack,self,0,0)
	self.generalItemBack = generalItemBack

    --- 左边:就是一张图片
    local leftHead = ccui.ImageView:create()
    leftHead:loadTexture("A.png",ccui.TextureResType.plistType)
    self:addChild(leftHead)
    REL:toOther("left","middle",leftHead,self,20,0)
    self.leftHead = leftHead
               
end

--- 添加进度条:位置
function T:addLoadingBar(centerPos)
    -- 背景图片
    local backImg = ccui.ImageView:create()
    backImg:loadTexture("sliderBack.png",ccui.TextureResType.plistType)
    self:addChild(backImg)
    REL:toOther("left","top",backImg,self,centerPos[1],centerPos[2])
    self.backImg = backImg
    -- 进度条图片
    local loadingBar = ccui.LoadingBar:create()
    loadingBar:loadTexture("sliderFore.png",ccui.TextureResType.plistType)
    loadingBar:setPercent(0)
    self:addChild(loadingBar)
    REL:toOther("center","middle",loadingBar,backImg,0,0)
    self.loadingBar = loadingBar
end

--- 设置项的属性
--[[
    leftHead:左边的头像路径
    centerTable:中间的控件表：依次为上中下
    {
        "label",                   -- label为文本，progress为进度条，
        "progress",
        
    }
    rightTable:右边的控件表
    {
        {normalState="",downState="",isHasPic="true",isHasText="true"},   -- 最后2个表示，按钮是否有图片或者文字
        {normalState="",downState="",isHasPic="false",isHasText="false"},没有的话传入false
    }

]]
function T:setListItem1Attribute(leftHead,centerTable,rightTable)
    if leftHead then
        self.leftHead:loadTexture(leftHead,ccui.TextureResType.plistType)
    end

    if centerTable then
        local num = #centerTable  -- 一般是2个或者3个，但是后面来写1个的情况
        local centerPos = nil

        if num == 2 then
            centerPos = self.centerTwoPos
        elseif num == 3 then
            centerPos = self.centerThreePos
        end

        for i = 1,num,1 do   -- 这个i可以认为是对应位置上的lable
            if centerTable[i] == "label" then
                local label = XMLLabel()
                label:setContentSize(cc.size(500, 27))
                label:setTag(self.baseValue + i)
                self:addChild(label)
                REL:toOther("left", "top", label, self, centerPos[i][1], centerPos[i][2])
            elseif centerTable[i] == "progress" then
                -- 加入进度条
                self:addLoadingBar(centerPos[i])
            else
                -- 表有问题
            end

        end
    end

    if rightTable then
        local num = #rightTable  -- 现在只考虑2种情况
        if num == 1 then
            -- 按钮1
            local button1 = Button.new(rightTable[1][3],rightTable[1][4])
            button1:loadTextures(rightTable[1][1],rightTable[1][2] , "",ccui.TextureResType.plistType)
            self:addChild(button1)
            REL:toOther("right", "middle", button1, self, 20, 0)
            self.button1 = button1
        elseif num == 2 then
            local button1 = Button.new(rightTable[1][3],rightTable[1][4])
            button1:loadTextures(rightTable[1][1],rightTable[1][2] , "",ccui.TextureResType.plistType)
            self:addChild(button1)
            REL:toOther("right", "middle", button1, self, 20, 0)
            self.button1 = button1

            local button2 = Button.new(rightTable[2][3],rightTable[2][4])
            button2:loadTextures(rightTable[2][1],rightTable[2][2] , "",ccui.TextureResType.plistType)
            self:addChild(button2)
            REL:toOther("right", "middle", button2, self, 20 + button1:getContentSize().width + 10, 0) -- 这样更动态一点
            self.button2 = button2
        end
    end
end

--- 根据位置得到对应的label控件
function T:getLabel(location)
    if self:getChildByTag(self.baseValue + location) then
        local label = self:getChildByTag(self.baseValue + location)
        return label
    end

end


return T
