--[[
 *	资源中的每一项
]]
local ResItem = class("ResItem",function() return ccui.Layout:create() end)

--- 构造函数
function ResItem:ctor()
    self:setContentSize(cc.size(550,60))

    -- 资源图片
    local icon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    icon:loadTexture(iconPath .. Prop_temp[1].propIcon)
    icon:setScale(IconManager.resScale[1],IconManager.resScale[2])

    self:addChild(icon)
    REL:toOther("left","middle",icon,self,27,0)
    self.icon = icon

    -- 正确或者错误的图片
    local rightOrWrong = ccui.ImageView:create()
    rightOrWrong:loadTexture("A.png",ccui.TextureResType.plistType)
    self:addChild(rightOrWrong)
    REL:toOther("left","middle",rightOrWrong,self,415,0)
    self.rightOrWrong = rightOrWrong

    -- 名字
    local labelName = XMLLabel()
    labelName:setVAlign("middle")
    labelName:setContentSize(cc.size(100,36))
    self:addChild(labelName)
    REL:toOther("left","middle",labelName,self,150,0)
    self.labelName = labelName

    -- 需求
    local labelNeed = XMLLabel()
    labelNeed:setContentSize(cc.size(100,27))
    self:addChild(labelNeed)
    REL:toOther("left","middle",labelNeed,self,280,0)
    self.labelNeed = labelNeed

    -- 拥有
    local labelOwn = XMLLabel()
    labelOwn:setContentSize(cc.size(100,27))
    self:addChild(labelOwn)
    REL:toOther("left","middle",labelOwn,self,475,0)
    self.labelOwn = labelOwn

end

--- 设置名字
function ResItem:setName(name)
    if name then
        self.labelName:setString(name)
    end
end

--- 设置资源图片
function ResItem:setResImg(icon)
    if icon then
        local iconPath = IconManager.iconPath
        self.icon:loadTexture(iconPath .. icon)
    end
end

--- 设置正确或者错误的图片
function ResItem:setRightOrWrong(needOrNotNeed)
    if needOrNotNeed then
        self.rightOrWrong:loadTexture(needOrNotNeed,ccui.TextureResType.plistType)
    end
end

--- 设置需求量
function ResItem:setNeed(need)
    if need then
        self.labelNeed:setString(UnitConversion.unitTrans(need))
    end
end

--- 设置玩家拥有的量
function ResItem:setOwn1(own)
    if own then
        if self.type and self.type == true then -- 因为战机和道具的数量如果超过1000了，就显示数字1000，不显示k
            self.labelOwn:setString(own)
        else
            self.labelOwn:setString(UnitConversion.unitTrans(own))
        end
        
    end
end
--- 设置玩家拥有的量(红色)
function ResItem:setOwn2(own)
    if own then
        if self.type and self.type == true then
            self.labelOwn:setString(Language:get("uc173",own))
        else
            self.labelOwn:setString(Language:get("uc173",UnitConversion.unitTrans(own)))
        end
        
    end
end



--[[
 *	资源信息
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 窗口的大小
T.size = nil

--- tag的基础值
T.baseValue = 5000

--- num是资源条目的数量
T.num = nil

--- 构造函数
function T:ctor(num)
    self.num = num

    self:init()
end

function T:init()
    -- 背景图片
    local needListBack = NeedBack()
    needListBack:setAnchorPoint(cc.p(0,1))  -- 因为放大的时候从上向下增长
    needListBack:setContentSize(618,352)  -- 这个用本身图片的大小
	self:addChild(needListBack)

    local offsetHeight = 30
    self.size = needListBack:getContentSize()
    self:setContentSize(cc.size(self.size.width,self.size.height - offsetHeight))
    if self.num > 4 then
        local newWidth = self.size.width
        local newHeight = self.size.height + (self.num - 4)*60   -- 60是每一项的高度

        self.size = cc.size(newWidth,newHeight - offsetHeight)
        self:setContentSize(self.size)  
        needListBack:setContentSize(self.size)  -- 多了几个就在下面加几个就ok了
    end

    REL:toOther("left","top",needListBack,self,0,0)
	self.needListBack = needListBack

    -- 加入那3条分隔线
    local sepHeight = self.num * 60
    local sepLineFrame = ResLoader:getSpriteFrame("sepLine1.png")
    local sepLineSize = sepLineFrame:getOriginalSize()
    local sepSize = cc.size(sepLineSize.width,sepHeight - 10)

    local leftSepLine = Scale9Sprite:createWithFrame(sepLineFrame,cc.rect(sepLineSize.width/2,sepLineSize.height/2,1,1))
    leftSepLine:setContentSize(sepSize)
	self:addChild(leftSepLine)
    REL:toOther("left","top",leftSepLine,needListBack,160,60)

    local middleSepLine = Scale9Sprite:createWithFrame(sepLineFrame,cc.rect(sepLineSize.width/2,sepLineSize.height/2,1,1))
    middleSepLine:setContentSize(sepSize)
	self:addChild(middleSepLine)
    REL:toOther("left","top",middleSepLine,needListBack,290,60)

    local rightSepLine = Scale9Sprite:createWithFrame(sepLineFrame,cc.rect(sepLineSize.width/2,sepLineSize.height/2,1,1))
    rightSepLine:setContentSize(sepSize)
	self:addChild(rightSepLine)
    REL:toOther("left","top",rightSepLine,needListBack,430,60)

    -- 3个名字，需求，拥有的背景图
    local needBackImg = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("back_gray.png"),"h3")
    needBackImg:setContentSize(cc.size(446,30))
    self:addChild(needBackImg)
    REL:toOther("left","top",needBackImg,self.needListBack,145,13)
    self.needBackImg = needBackImg

    -- 类别
    local category = XMLLabel()
    category:setContentSize(cc.size(200,27))
    self:addChild(category)
    REL:toOther("left","top",category,self.needListBack,180,16)
    self.category = category

    -- 需求
    local need = XMLLabel()
    need:setContentSize(cc.size(200,27))
    self:addChild(need)
    REL:toOther("left","top",need,self.needListBack,310,16)
    self.need = need

    -- 当前拥有
    local own = XMLLabel()
    own:setContentSize(cc.size(200,27))
    self:addChild(own)
    REL:toOther("left","top",own,self.needListBack,445,16)
    self.own = own

    -- 设置属性
    self.category:setString(Language:get("uc3"))
    self.need:setString(Language:get("uc4"))
    self.own:setString(Language:get("uc5"))

end

--- 增加资源中的项
--[[
    下面中的每项都是表:

    fontItem:前面的项  {name,needLevel,nowLevel}
    middleResItem:中间的资源项，直接把表复制过来就行了,传入的是那个等级所需求的资源表
    backItem:后面的项{sid = 1,num = 1}，这个是战机项
    propItem:后面的项{sid = 1,num = 1}，这个是道具项

]]
function T:addResItem(fontItem,middleResItem,backItem,propItem)
    local locationTag = 0  -- 距离上面的距离标记

    local height = nil
    local toOtherHeight = 0

    if fontItem then  --
        local res = ResItem.new()
        self:addChild(res)

        if fontItem.iconUrl then
            res.icon:loadTexture(fontItem.iconUrl)
            res.icon:setScale(56/128,56/128)
        else
            res.icon:setVisible(false)
        end
        

        -- 得到每一项的高度
        height = res:getContentSize().height

        res:setTag(self.baseValue + locationTag)
        self:setCommandAttribute(locationTag,fontItem.name,fontItem.needLevel,fontItem.nowLevel)  -- 显示上读的等级+1，但是下面读的配置是needLevel的

        REL:toOther("center","top",res,self.needListBack,0,60)
        toOtherHeight = toOtherHeight + 60
    end
    locationTag = locationTag + 1

    if middleResItem then
        local num = #middleResItem
        for i = 1,num,1 do      -- 这里的i其实是和locationTag是相等的，后面刷新的话，不会出问题
            local res = ResItem.new()
            self:addChild(res)
            -- 得到每一项的高度
            height = res:getContentSize().height

            res:setTag(self.baseValue + locationTag)
                   
            local resData = middleResItem[i] -- {2,100}
            -- 服务器
            local own = UserInfo.city[Resource_temp[resData[1]].attributeName]  -- 玩家当前拥有数量
            -- 本地
            local icon = Resource_temp[resData[1]].iconUrl -- 资源图片
            local name = Language:get(Resource_temp[resData[1]].name) -- 资源名称
            local need = resData[2] -- 等级资源需求数量

            self:setResAttribute(locationTag,icon,name,need,own)
            REL:toOther("center","top",res,self.needListBack,0,toOtherHeight + locationTag * height)
            locationTag = locationTag + 1
        end
    end

    if backItem then -- 这里应该是战机的sid,num表(飞机)
        local res = ResItem.new()
        res.type = true
        self:addChild(res)

        res:setTag(self.baseValue + locationTag)
                   
        -- 服务器
        local own = UserInfo.city.aircraftBox.infos[backItem[1]].num  -- 玩家当前拥有的战机数量
        -- 本地
        local icon = Aircraft_temp[backItem[1]].icon  -- 资源图片,到时根据配置来读
        local name = Language:get(Aircraft_temp[backItem[1]].name) -- 资源名称
        local need = backItem[2] -- 等级需求数量

        self:setResAttribute(locationTag,icon,name,need,own)  -- 到时再根据飞机来读取设置
            
        REL:toOther("center","top",res,self.needListBack,0,toOtherHeight + locationTag * height)

        locationTag = locationTag + 1

    end


    if propItem then
        local res = ResItem.new()
        res.type = true
        self:addChild(res)
        res:setTag(self.baseValue + locationTag)

        -- 服务器
        local own = PropsInfoMgr:getPlayerPropByID(propItem[1])  -- 玩家当前拥有的道具数量
        -- 本地
        local icon = Prop_temp[propItem[1]].propIcon
        local name = Language:get(Prop_temp[propItem[1]].prop) 
        local need = propItem[2] -- 等级需求数量

        self:setResAttribute(locationTag,icon,name,need,own)  -- 到时再根据飞机来读取设置
            
        REL:toOther("center","top",res,self.needListBack,0,toOtherHeight + locationTag * height)

    end

end

--- 设置属性
--[[
    i:位置
    icon:资源的图片
    name:名字
    need:需求数量
    own:玩家当前拥有的数量
]]
function T:setResAttribute(i,icon,name,need,own)
    local res = self:getChildByTag(self.baseValue + i)

    res:setResImg(icon)
    res:setName(name)
    res:setNeed(need)

    -- 勾和叉图片
    if own and need then
        if own >= need then
            res:setOwn1(own)
            res:setRightOrWrong("needEnoughIcon.png")
        else
            res:setOwn2(own)  -- 这里还要设置颜色（资源不足的时候为红色,在html中体现就行了）
            res:setRightOrWrong("needNotEnoughIcon.png")
        end
    end

end

--- 设置指挥中心（最上面那一栏的属性）
function T:setCommandAttribute(i,name,need,own)
    if self:getChildByTag(self.baseValue + i) then
        local res = self:getChildByTag(self.baseValue + i)
            
        if name then
            res.labelName:setString(name)
            
        end
    
        if need then
            res.labelNeed:setString(Language:get("uc187",need))
        end

        --if own then
            --res.labelOwn:setString(Language:get("uc187",own))
        --end


        if own >= need then
            res:setRightOrWrong("needEnoughIcon.png")
            res.labelOwn:setString(Language:get("uc187",own))
        else
            res:setRightOrWrong("needNotEnoughIcon.png")
            res.labelOwn:setString(Language:get("uc678",own))
        end
    end

end

--- 得到resview中的项
function T:getResItem(locationTag)
    return self:getChildByTag(self.baseValue + locationTag)
end

--- 得到一个resItem:
function T:setResItem(iconUrl,name,needLevel,nowLevel,topOffset)
    local res = ResItem.new()
    self:addChild(res)

    if iconUrl then
        res.icon:loadTexture(iconUrl)
    else
        res.icon:setVisible(false)
    end
    res:setTag(self.baseValue + 10)
    self:setCommandAttribute(10,name,needLevel,nowLevel)
    REL:toOther("center","top",res,self.needListBack,0,topOffset)

end


return T
