--- 升级高级指挥弹窗
local T = class("T",function() return ccui.Layout:create() end)


--- 构造函数
function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

    self:setContentSize(cc.size(480,500))


    -- 顶部背景图片
    local topBackFrame = ResLoader:getSpriteFrame("allianceScienceNotiBack.png")
	local topBackSize = topBackFrame:getOriginalSize()
	local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
	self:addChild(topBack)
    topBack:setContentSize(cc.size(480,500))
    REL:toOther("center","middle",topBack,self,0,0)



	self:init()
    self:refresh()


end

--- 进入
function T:onEnter()
    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_SENIORDLEVEL_REFRESH,self,self.refresh)
    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_REVENGE_REFRESH,self,self.refresh)

end

--- 退出
function T:onExit()
    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_SENIORDLEVEL_REFRESH,self,self.refresh)
    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_REVENGE_REFRESH,self,self.refresh)

end


function T:init()
    -- 标题
    local title = XMLLabel()
    title:setHAlign("center")
    title:setContentSize(cc.size(300,36))
    self:addChild(title)
    REL:toOther("center","top",title,self,0,20)
    title:setString(Language:get("uc1030"))


    local des1 = XMLLabel()
    des1:setHAlign("center")
    des1:setContentSize(cc.size(450,36))
    self:addChild(des1)
    REL:toOther("center","top",des1,self,0,80)
    des1:setString(Language:get("uc1031"))

    local nowLevel = XMLLabel()
    nowLevel:setHAlign("center")
    nowLevel:setContentSize(cc.size(300,36))
    self:addChild(nowLevel)
    REL:toOther("center","top",nowLevel,self,0,150)
    self.nowLevel = nowLevel


    local maxLevel = XMLLabel()
    maxLevel:setHAlign("center")
    maxLevel:setContentSize(cc.size(300,36))
    self:addChild(maxLevel)
    REL:toOther("center","top",maxLevel,self,0,180)
    maxLevel:setString(Language:get("uc1033",UserInfo.level))

    -- 消耗勋章
    local medal = XMLLabel()
    medal:setHAlign("center")
    medal:setContentSize(cc.size(300,36))
    self:addChild(medal)
    REL:toOther("center","top",medal,self,0,230)
    self.medal = medal

    -- 消耗复仇
    local revenge = XMLLabel()
    revenge:setHAlign("center")
    revenge:setContentSize(cc.size(300,36))
    self:addChild(revenge)
    REL:toOther("center","top",revenge,self,0,270)
    self.revenge = revenge

    -- 带兵量
    local soliders = XMLLabel()
    soliders:setHAlign("center")
    soliders:setContentSize(cc.size(300,36))
    self:addChild(soliders)
    REL:toOther("center","top",soliders,self,0,330)
    self.soliders = soliders

    local levelUp = Button.new("false","true")
	levelUp:setButtonState("longButton_green_normal.png","longButton_general_down.png")
    levelUp:setString(Language:get("uc1037"))
	self:addChild(levelUp)
	REL:toOther("center","bottom",levelUp,self,0,25)
    levelUp:setTextShadow()
    levelUp:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            -- 不能超过角色等级
            if HonorManager:getSeniorDLevel() >= UserInfo.level then
                local descripe = Language:get("uc992")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

                return
            end


            local num = PropsInfoMgr:getPlayerPropByID(208)
            local costNum = SeniorDLevel_temp[HonorManager:getSeniorDLevel()].costMedal
            if costNum <= num then -- 可以升级

            else
                local descripe = Language:get("uc990")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                return

            end

            local revenge = HonorManager:getRevenge()
            local costRevenge = SeniorDLevel_temp[HonorManager:getSeniorDLevel()].costRevenge

            if costRevenge <= revenge then -- 可以升级

            else
                local descripe = Language:get("uc1038")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                return

            end

            local function finish()
                local descripe = Language:get("uc991")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

            end 
            Command:upgradeSeniorDLevel(finish)


        end
    end)

    self.levelUp = levelUp

end


--- 刷新
function T:refresh()
    self.nowLevel:setString(Language:get("uc1032",HonorManager:getSeniorDLevel()))

    local num = PropsInfoMgr:getPlayerPropByID(208)
    local costNum = SeniorDLevel_temp[HonorManager:getSeniorDLevel()].costMedal

    self.medal:setString(Language:get("uc1034",num,costNum))

    local costRevenge = SeniorDLevel_temp[HonorManager:getSeniorDLevel()].costRevenge
    self.revenge:setString(Language:get("uc1035",HonorManager:getRevenge(),costRevenge))


    self.soliders:setString(Language:get("uc1036",SeniorDLevel_temp[HonorManager:getSeniorDLevel()].addSoldiers))

    if HonorManager:getSeniorDLevel() == UserInfo.level then
        self.levelUp:setIsGray(true)
    else
        self.levelUp:setIsGray(false)
    end


end



return T
