---按钮的标签页
local T = class("SwitchButtonContainer",function() return ccui.Layout:create() end)

--- 保存的按钮组
T.buttonLayouts = nil

--- 回调函数
T.callbacks = nil

--- 上一次的按钮的按下位置
T.lastLocation = nil

--- 构造函数
function T:ctor(viewBackUrlOrType)
	self.viewBackUrlOrType=viewBackUrlOrType or 1
end

function T:init()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)
	self.buttonLayouts = {}  -- 防止浅拷贝
	self.callbacks = {}

	-- 背景图片
	self:setViewBack(self.viewBackUrlOrType)

	-- 视图显示层
	local viewLayer=cc.Node:create()
	self:addChild(viewLayer,3)
	self.viewLayer=viewLayer

	-- 边框
	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack,4)
	REL:relOther(viewBack,self,0,0,73 - 4,0)  -- 73是切换按钮的高度
	self.viewBack = viewBack
end

--- 设置背景图片
-- @param urlOrType 背景图片的url或类型
-- @param textureType 当 urlOrType 指定为url时,此值为纹理类型
function T:setViewBack(urlOrType,textureType)
	local uiBack=self.uiBack
	if uiBack then
		uiBack:removeFromParent()
	end

	local t=type(urlOrType)
	if t == "string" then
		if textureType == ccui.TextureResType.localType then
			uiBack = cc.Sprite:create(urlOrType)
		else
			uiBack = cc.Sprite:createWithSpriteFrameName(urlOrType)
		end
	else
		if urlOrType == 0 then
			return
		elseif urlOrType == 1 then
			uiBack = cc.Sprite:createWithSpriteFrameName("windowBack.jpg")
		elseif urlOrType == 2 then
			uiBack = cc.Sprite:createWithSpriteFrameName("windowBack2.jpg")
		elseif urlOrType == 3 then
			uiBack = cc.Sprite:createWithSpriteFrameName("windowBack3.jpg")
		elseif urlOrType == 4 then
			uiBack = cc.Sprite:createWithSpriteFrameName("windowBack4.jpg")
		end
	end

	self:addChild(uiBack,2)
	REL:relOther(uiBack,self,0,0,73 - 4,0)  -- 73是切换按钮的高度
	self.uiBack = uiBack
end

function T:onExit()
	local buttonLayouts = self.buttonLayouts
	for k,v in pairs(buttonLayouts) do
		v:luaRemoveEventListener("buttons_event", self, self.switchButtons)
	end
end

--传入的是哪个按钮被点击
function T:switchButtons(btn,judge) -- 可以根据位置来排序
	local buttonLayouts = self.buttonLayouts
	local num = #buttonLayouts
	if self.lastLocation == 3 then -- 针对这种情况特殊处理
		local i = num
		while true do
			if i == 0 then
				break
			end

			if buttonLayouts[i] == btn then
				buttonLayouts[i]:setDownState()

				if not judge then
					self.lastLocation = i
				end

				-- 执行回调函数
				if self.callbacks[i] then
					self.callbacks[i](i)
				end

				if judge then
					self.lastLocation = 3
				end

			else
				buttonLayouts[i]:setNormalState()
			end

			i = i - 1
		end
	else
		for i = 1,num,1 do
			if buttonLayouts[i] == btn then
				buttonLayouts[i]:setDownState()
				-- 执行回调函数
				if self.callbacks[i] then
					self.callbacks[i](i)
				end

				if judge then
					self.lastLocation = 3
				else
					self.lastLocation = i
				end

			else
				buttonLayouts[i]:setNormalState()
			end
		end

	end

end

--- 切换到指定索引的按钮
-- @param index 按钮的索引
function T:switchButtonByIndex(index)
	local btn=self.buttonLayouts[index]
	if btn then
		btn:luaDispatchEvent("buttons_event",btn)
	end
end

--- 初始化按钮:1,2,3依次代表从左到右:
--[[

    num:代表按钮数量

    buttonStates:为按钮的状态

    {

        buttonState1

        buttonState2

        buttonState3

    }

    buttonTextPos:按钮文本相对于按钮的位置,如果为nil，则为中间

    callBacks为:

    {   callBack1 = nil

        callBack2 = nil

        callback3 = nil

        .......

    }



    buttonTexts =

    {

        buttonText1 = nil

        buttonText2 = nil

        buttonText3 = nil

        .......

    }

    initButtonIndex:默认哪个按钮(索引)先显示出来,initButtonIndex不传入表示为1



]]
function T:initButtons(num,buttonStates,buttonTextPos,callBacks,buttonTexts,initButtonIndex)
	self.lastLocation = initButtonIndex

	self.callbacks = callBacks
	for i = 1,num,1 do
		local abstractSwitchButton = AbstractSwitchButton.new(i)
		abstractSwitchButton:initButton(buttonStates[i],buttonTexts[i],buttonTextPos,callBacks[i])
		self:addChild(abstractSwitchButton,1)
		local size = abstractSwitchButton.size
		if num == 2 then
			if i == 1 then
				REL:toOther("left","top",abstractSwitchButton,self,(size.width)*(i-1) + 8,0)
			else
				REL:toOther("left","top",abstractSwitchButton,self,(size.width)*(i-1) + 9,0)
			end

		elseif num == 3 then
			if i == 1 then
				REL:toOther("left","top",abstractSwitchButton,self,(size.width - 3)*(i-1) + 8,0)
			elseif i == 2 then
				REL:toOther("left","top",abstractSwitchButton,self,(size.width - 3)*(i-1) + 11,0)
			else
				REL:toOther("left","top",abstractSwitchButton,self,(size.width - 3)*(i-1) + 14,0)
			end

		elseif num == 1 then
			REL:toOther("left","top",abstractSwitchButton,self,(size.width)*(i-1) + 3,0)
		elseif num == 4 then
			if i == 1 then
				REL:toOther("left","top",abstractSwitchButton,self,(size.width)*(i-1) + 9,16)
			elseif i == 2 then
				REL:toOther("left","top",abstractSwitchButton,self,(size.width)*(i-1) + 6,16)
			elseif i == 3 then
				REL:toOther("left","top",abstractSwitchButton,self,(size.width)*(i-1) + 3,16)
			else
				REL:toOther("left","top",abstractSwitchButton,self,(size.width)*(i-1),16)
			end

		end

		self.buttonLayouts[i] = abstractSwitchButton  -- 放的是button的layout
		abstractSwitchButton:luaAddEventListener("buttons_event", self, self.switchButtons) -- 添加按钮切换的监听,事件派发在抽象按钮里面

	end

	-- 延迟1帧
	self:scheduleUpdateWithPriorityLua(function()
		self:unscheduleUpdate()

		self:switchButtonByIndex(initButtonIndex or 1)
	end,0)
end


--- 设置按钮的文本:传入按钮的id，按钮的文本
function T:setButtonText(id,text)
	local button = self.buttonLayouts[id]
	if button then
		button:setString(text)
	end
end

--- 获取指定按钮
-- @param index 索引
function T:getButton(index)
	return self.buttonLayouts[index]
end

--- 获取当前的按钮tag
function T:getClickTag()
	return self.lastLocation
end

--- 更新按钮1标识
function T:updateButton1Tag(judge)
	if judge then
		if not self.btn1Tag and self:getButton(1) then
			self.btn1Tag = ResLoader:createAnimationSprite("promptEffect")
			self:addChild(self.btn1Tag,5)
			REL:toOther("right", "top", self.btn1Tag, self:getButton(1), 20, 15)
		end
	else
		if self.btn1Tag then
			self.btn1Tag:removeFromParent()
			self.btn1Tag = nil
		end
	end
end

--- 更新按钮2标识
function T:updateButton2Tag(judge)
	if judge then
		if not self.btn2Tag and self:getButton(2) then
			self.btn2Tag = ResLoader:createAnimationSprite("promptEffect")
			self:addChild(self.btn2Tag,5)
			REL:toOther("right", "top", self.btn2Tag, self:getButton(2), 20, 15)
		end
	else
		if self.btn2Tag then
			self.btn2Tag:removeFromParent()
			self.btn2Tag = nil
		end
	end
end

--- 更新按钮3标识
function T:updateButton3Tag(judge)
	if judge then
		if not self.btn3Tag and self:getButton(3) then
			self.btn3Tag = ResLoader:createAnimationSprite("promptEffect")
			self:addChild(self.btn3Tag,5)
			REL:toOther("right", "top", self.btn3Tag, self:getButton(3), 20, 15)
		end
	else
		if self.btn3Tag then
			self.btn3Tag:removeFromParent()
			self.btn3Tag = nil
		end
	end
end

--- 重新更新位置
function T:setBtnPos()
	local size = self:getButton(1).size
	REL:toOther("left","top",self:getButton(1),self,20,0)
	REL:toOther("left","top",self:getButton(2),self,size.width + 20,0)
end


return T
