local T=Class.WindowTitleBar(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 背景
	-- self.uiBack=nil

	--- 关闭按钮
	-- self.uiCloseButton=nil

	--- 钻石按钮
	-- self.uiDiamondButton=nil

	--- 钻石数量
	-- self.uiDiamondCount=nil

	--- 标题文本框
	-- self.uiTitleText=nil
end

--- 构造函数
function T:ctor()
	AbstractUI.ctor(self)

	self:init()
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(640,150))

	local f=ResLoader:getSpriteFrame("borderTop.png")
	local size = f:getOriginalSize()
	self:setContentSize(cc.size(size.width,size.height - 10))

	--背景
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	REL:toOther("center","middle",uiBack,self,0,1)
	self.uiBack=uiBack

	--左边特效
	local uiLEff=ResLoader:createAnimationSpriteRandom("windowTitleEff",true)
	uiLEff:setOpacity(120)
	self:addChild(uiLEff)
	REL:toOther("center","middle",uiLEff,self,-140,40)

	--右边特效
	local uiREff=ResLoader:createAnimationSpriteRandom("windowTitleEff",true)
	uiREff:setOpacity(120)
	uiREff:setFlippedX(true)
	self:addChild(uiREff)
	REL:toOther("center","middle",uiREff,self,140,40)

	--关闭按钮
	local uiCloseButton=BaseButton:createButton(nil,"closeWindowButton_normal.png")
	self:addChild(uiCloseButton)
	REL:toOther("right","top",uiCloseButton,self,1,1)
	self.uiCloseButton=uiCloseButton

	--钻石按钮
	local uiDiamondButton=BaseButton:createButton(nil,"diamondButton_normal.png")
	self:addChild(uiDiamondButton)
	REL:toOther("left","top",uiDiamondButton,self,-2,-6)
	self.uiDiamondButton=uiDiamondButton
	uiDiamondButton:addTouchEventListener(function(sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			VipManager:enterIapWindow()
		end
	end)


	--钻石数量
	local uiDiamondCount = XMLLabel()
	uiDiamondCount:setAlign("center","middle")
	uiDiamondButton:addChild(uiDiamondCount)
	REL:relOther(uiDiamondCount,uiDiamondButton,0,0,70,SIZE_NIL)
	self.uiDiamondCount = uiDiamondCount

	--标题文本框
	local uiTitleText = XMLLabel()
	uiTitleText:setCssStyle(CssStyles.windowTitle)
	uiTitleText:setContentSize(cc.size(400, 40))
	uiTitleText:setAlign("center","middle")
	self:addChild(uiTitleText)
	REL:toOther("left", "top", uiTitleText, self, 120, 7)
	self.uiTitleText=uiTitleText

	self:updateDiamondCount()
end

--- 设置标题文本
function T:setTitle(value)
	self.uiTitleText:setString(value)
end

--- 获取标题文本
function T:getTitle()
	return self.uiTitleText:getString()
end

--- 获取关闭按钮
function T:getCloseButton()
	return self.uiCloseButton
end

--- 获取钻石按钮
function T:getDiamondButton()
	return self.uiDiamondButton
end

--- 更新钻石数量
-- @param count 不指定则从用户信息中获取
function T:updateDiamondCount(count)
	count = count or UserInfo.gems
	if count > 1000000 then
		self.uiDiamondCount:setString(Language:get("uc175",count))
	else
		self.uiDiamondCount:setString(Language:get("uc102",count))
	end

end

return T
