--region TaskDailyNode.lua
--Author    : YuDing
--Date      : 2015/1/10
--Introduce : 每日任务

local T = class("T", function()  
    local lay = ccui.Layout:create() 
    lay:setContentSize(UI_VSIZE)

--    lay:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	lay:setBackGroundColor(cc.c3b(random(0,255),0,0))
--	lay:setBackGroundColorOpacity(100)

    return lay

    end)


-- 底部 框的大小
T.frameSize = cc.size(424, 130)

function T:ctor()
    mapping(self, LuaEventDispatcher)
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
                self:cleanUp()
            end
        end
    )

    self:initUI()
end

function T:onEnter()

end

--- 打开界面要被移除
function T:onExit()
    
end

function T:cleanUp()
    self:clearAllianceTimeSchedule()
    self:clearNormalTimeSchedule()

    self:removeFlushTask()
    self:releasePublicEvent()
end

function T:registerPublicEvent()
   -- TaskManager:luaAddEventListener(TaskManager.noticeMessage.removeDailyTaskItem, self, self.removeListItem) 

    --TaskManager:luaAddEventListener(TaskManager.noticeMessage.dailyTaskFresh, self, self.updateTip) 
end

function T:releasePublicEvent()
   -- TaskManager:luaRemoveEventListener(TaskManager.noticeMessage.removeDailyTaskItem, self, self.removeListItem) 

    --TaskManager:luaRemoveEventListener(TaskManager.noticeMessage.dailyTaskFresh, self, self.updateTip) 
end

function T:initUI()
    self:initContainer()
    self:loadFreshJson()
    self:initFreshUI()
    self:registerPublicEvent()
    --self:updateTip() -- 更新 提示
    self:flushTask() 
end

--- 加载刷新json
function T:loadFreshJson()
    self.freshContainer = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.taskTimeFresh)
    self:addChild(self.freshContainer)
    REL:toOther("center", "bottom", self.freshContainer, self, 0, 5)
end

--- 初始化 刷新ui
function T:initFreshUI()
    local w = self.freshContainer

    self.freshBtn = Cocos2dxUtils:getChildByName(w, "freshBtn") -- 刷新按钮
    self.btnText = Cocos2dxUtils:getChildByName(w, "needDiamond") -- 刷新按钮 上的钻石 需求量

    self.freshBtnText = Cocos2dxUtils:getChildByName(w, "freshBtnText") -- 刷新按钮上的文字

    self.freshInfoText = Cocos2dxUtils:getChildByName(w, "freshInfoText") -- 文字信息
    self.labelPanel = Cocos2dxUtils:getChildByName(w, "labelPanel") -- 时间的panel

    self.freshLabel = XMLLabel()   -- 刷新文本
	self.freshLabel:setHAlign("center")
	self.freshLabel:setVAlign("middle")
	self.freshLabel:setContentSize(cc.size(200, 36))
    self.labelPanel:addChild(self.freshLabel)
    REL:toOther("center", "middle", self.freshLabel, self.labelPanel, 0, 0)

    Cocos2dxUtils:setTextFont({self.btnText, self.freshInfoText, self.freshInfoText}) -- 设置字体
    
    self.freshInfoText:setString(Language:get("uy187")) -- "刷新任务列表"
    self.freshBtnText:setString(Language:get("uy188")) -- "刷新"

    self:registerFreshEvent()  -- 注册按钮事件
end



--- 更新内容
function T:initContainer()

    local callBack = function()
        self:loadNormalTask()
    end

    local callBack2 = function()
        self:loadAllianceTask()
    end

    local twoMenuContainer = SwitchButtonContainer.new()
    self:addChild(twoMenuContainer)
    REL:relOther(twoMenuContainer,self, 0, 0, 155, 0)
    twoMenuContainer:init()
    twoMenuContainer:initButtons(
        2,
        {{"twoGuideNotActive.png", "twoGuideActive.png"},{"twoGuideNotActive.png", "twoGuideActive.png"}},
        {50,13},
        {callBack,callBack2},
        {Language:get("uy156"), Language:get("uy157")}
    )
    self.twoMenuContainer = twoMenuContainer
    twoMenuContainer.viewBack:setVisible(false)
end

function T:switchNormalListView()
    self:setTipVisible("normal", false)
    self:setTipVisible("alliance", true)

    if not self.normalListView then  -- 不存在
        local listView = ListView.new()
	    self:addChild(listView)
	    REL:relOther(listView, self.twoMenuContainer, 0, 0, 70, 140)
        listView:setItemsMargin(5) -- 设置间距

--        listView:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--        listView:setBackGroundColor(cc.c3b(0xff,0,0))
--        listView:setBackGroundColorOpacity(100)

        self.normalListView = listView  
        

        if self.allianceListView then 
            self.allianceListView:setVisible(false)
        end 

        self:updateListContent(UserInfo.dailyTask:getNormalTask(), listView)  
    else -- 存在
        self.normalListView:setVisible(true)
        if self.allianceListView then 
            self.allianceListView:setVisible(false)
        end
    end

    self:switchListViewTimeShow("normal") -- 切换到 normal
end

--- 切换
function T:switchAllianceListView()
    self:setTipVisible("normal", true)
    self:setTipVisible("alliance", false)

    if not self.allianceListView then  -- 不存在
        local listView = ListView.new()
	    self:addChild(listView)
	    REL:relOther(listView, self.twoMenuContainer, 0, 0, 70, 140)
        listView:setItemsMargin(5) -- 设置间距

--        listView:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--        listView:setBackGroundColor(cc.c3b(0,0,0xff))
--        listView:setBackGroundColorOpacity(100)

        self.allianceListView = listView

        if self.normalListView then 
            self.normalListView:setVisible(false)
        end 
        
        self:updateListContent(UserInfo.dailyTask:getAllianceTask(), listView)

    else -- 存在
        self.allianceListView:setVisible(true)
        if self.normalListView then 
            self.normalListView:setVisible(false)
        end
    end

    self:switchListViewTimeShow("alliance") -- 切换到 alliance
end

function T:updateListContent(task, list)
    list:removeAllItems()
    local tb = {}
    for i = 1, #task do 
        local item = require("src.app.uiScript.components.task.dailyTaskItem.TaskDailyItem").new(task[i][1], task[i][2], list)
        table.insert(tb, item)  
    end

    for i = 1, #tb do 
        list:pushBackCustomItem(tb[i]) -- 加入item
    end

    self:delayAddItem(tb)
end

function T:loadNormalTask()
    self:switchNormalListView()
end

function T:loadAllianceTask()
    self:switchAllianceListView()
end

--- 延迟加上item
function T:delayAddItem(delay)
    local itemAddEff = function(item)
		item:setOpacity(0)
		item:runAction(
			cc.FadeIn:create(0.5)
		)
	end

--    local tmp = {}
--    for k, v in pairs(delay) do 
--        table.insert(tmp, v)
--    end

    local len = #delay
   
    local i = 1

    self:runAction(
    	cc.RepeatForever:create(
    		cc.Sequence:create(
    			cc.DelayTime:create(0.1),
    			cc.CallFunc:create(function()
    				if i <= len then
                           delay[i]:initView() -- 更新ui
                           itemAddEff(delay[i])
--                           local tb = delay[i]:getEffRender()
--                           for k, v in pairs(tb) do 
--                               itemAddEff(v)
--                           end
--    				else
--    					self:stopAllActions()  -- 结束所有的动作
    				end
    				
    				i=i+1
    			end)
    		)
    	)
    )

end

function T:removeListItem(item)
    if not item then 
        return
    end

    if self.normalListView then 
        local index = self.normalListView:getIndex(item)
        if index and index > 0 then 
            self.normalListView:removeItem(index)
            self.normalListView:refreshView()
        end
    end
end

function T:updateNormalTimeState(state)
    self.normalTime = UserInfo.dailyTask:getNormalTime()
    self.normalState = state
    self.allianceState = nil 

    self:clearAllianceTimeSchedule()
    if state == "begin" then
        self:clearNormalTimeSchedule()
        
        self.btnText:setVisible(true) -- 可见
        self.freshBtn:loadTextures("useDiamonButton_normal.png","useDiamonButton_normal.png", "",ccui.TextureResType.plistType)

        REL:toOther("center", "middle", self.btnText, self.freshBtn, 7, 39) -- 钻石数目   
        REL:toOther("center", "middle", self.freshBtnText, self.freshBtn, 3, -8)

        local func = function()
            local sec = TimeUtils:getSyncMillis() / 1000
            local d = math.floor(self.normalTime - sec)  -- 还剩余的时间

            self.freshLabel:setString(Language:get("uc172",UnitConversion.handleTime4(d)))

            local needDiamond = self:getFinishDiamond("normal")
            self.btnText:setString(needDiamond) -- 刷新砖石

            if sec >= self.normalTime then 
                self:switchState("end")  
            end
        end
        

        self:createNormalTimeSchedule(func)

        if self.freeTag then
            self.freeTag:removeFromParent()
            self.freeTag = nil
		end


    elseif state == "end" then 
        
        self.btnText:setVisible(false) -- 可见
        self.freshBtn:loadTextures("button_green_normal.png", "button_general_down.png", "", ccui.TextureResType.plistType)

        -- 重定位
        REL:toOther("center", "middle", self.freshBtnText, self.freshBtn, 3, 17)

        if not self.freeTag then
			self.freeTag = ResLoader:createAnimationSprite("promptEffect")
			self:addChild(self.freeTag)
			REL:toOther("right", "top", self.freeTag, self.freshBtn, 15, 10)
		end

        self:clearNormalTimeSchedule()
    end
end

--- 更新 allicance 状态
function T:updateAllianceTimeState(state)
    self.allianceTime = UserInfo.dailyTask:getAllianceTime()
    self.allianceState = state -- 切换状态
    self.normalState = nil  -- 置为空

    self:clearNormalTimeSchedule()
    if state == "begin" then
        self:clearAllianceTimeSchedule()
        
        self.btnText:setVisible(true) -- 可见
        self.freshBtn:loadTextures("useDiamonButton_normal.png","useDiamonButton_normal.png", "",ccui.TextureResType.plistType)

        REL:toOther("center", "middle", self.btnText, self.freshBtn, 7, 39) -- 钻石数目   
        REL:toOther("center", "middle", self.freshBtnText, self.freshBtn, 3, -8)   

        local func = function()
            local sec = TimeUtils:getSyncMillis() / 1000
            local d = math.floor(self.allianceTime - sec)  -- 还剩余的时间

            self.freshLabel:setString(Language:get("uc172",UnitConversion.handleTime4(d)))

            local needDiamond = self:getFinishDiamond("alliance")
            self.btnText:setString(needDiamond) -- 刷新砖石

            if sec >= self.allianceTime then 
                self:switchState("end")  
            end
        end

        if self.freeTag then
            self.freeTag:removeFromParent()
            self.freeTag = nil
		end

        self:createAllianceTimeSchedule(func)

    elseif state == "end" then 
        
        self.freshBtn:loadTextures("button_green_normal.png", "button_general_down.png", "", ccui.TextureResType.plistType)

        self.btnText:setVisible(false) -- 可见
        -- 重定位
        REL:toOther("center", "middle", self.freshBtnText, self.freshBtn, 3, 17)

        if not self.freeTag then
			self.freeTag = ResLoader:createAnimationSprite("promptEffect")
			self:addChild(self.freeTag)
			REL:toOther("right", "top", self.freeTag, self.freshBtn, 15, 10)
		end

        self:clearAllianceTimeSchedule()
    end
end


function T:clearNormalTimeSchedule()
    if self.normalTimeId then 
        Cocos2dxUtils:clearScheduler(self.normalTimeId)
        self.normalTimeId = nil
    end
end

function T:createNormalTimeSchedule(func)
    self.normalTimeId = Cocos2dxUtils:interval(func, 1)
    func()
end

function T:clearAllianceTimeSchedule()
    if self.allianceTimeId then 
        Cocos2dxUtils:clearScheduler(self.allianceTimeId)
        self.allianceTimeId = nil
    end
end

function T:createAllianceTimeSchedule(func)
    self.allianceTimeId = Cocos2dxUtils:interval(func, 1)
    func()
end


--- 初始化 日常任务 提示
function T:updateTip()
    local normal = TaskManager:getDailyNormalTip()
    local alliance = TaskManager:getDailyAllianceTip()

    if normal == true then 
        self:createTip("normal")
    else 
        self:removeTip("normal")
    end

    if alliance == true then 
        self:createTip("alliance")
    else 
        self:removeTip("alliance")
    end

end

--- 创建 日常 提示
function T:createTip(kind)
    if kind == "normal" then 
        if self.normalTip then 
            return 
        end
        local tag = HomePageManager:getEff("promptEffect")
	    self:addChild(tag)
        --tag:setGlobalZOrder(1) -- 设置全局的位置
	    REL:toOther("right", "top", tag, self.twoMenuContainer:getButton(1), 10, 5)

        if self.twoMenuContainer:getClickTag() == 1 then
            --tag:setVisible(false)
        end

        self.normalTip = tag
    elseif kind == "alliance" then  
        if self.allianceTip then 
            return 
        end

        local tag = HomePageManager:getEff("promptEffect")
	    self:addChild(tag)
        --tag:setGlobalZOrder(1) -- 设置全局的位置
	    REL:toOther("right", "top", tag, self.twoMenuContainer:getButton(2), 10, 5)

        if self.twoMenuContainer:getClickTag() == 2 then
            --tag:setVisible(false)
        end

        self.allianceTip = tag
    end
end

--- 移除 日常提示
function T:removeTip(kind)
    if kind == "normal" then 
        if self.normalTip then 
            self.normalTip:removeFromParent()
            self.normalTip = nil
        end
    elseif kind == "alliance" then 
        if self.allianceTip then 
            self.allianceTip:removeFromParent()
            self.allianceTip = nil
        end
    end
end

--- 设置标记可见
function T:setTipVisible(kind, v)
    if kind == "normal" then 
        if self.normalTip then  
            --self.normalTip:setVisible(v)
        end
    elseif kind == "alliance" then 
        if self.allianceTip then 
            --self.allianceTip:setVisible(v)
        end
    end
end

function T:getFinishDiamond(taskType)
    local sec = TimeUtils:getSyncMillis() / 1000
    sec = math.floor(sec)

    local d = nil 

    if taskType == "normal" then 
        self.normalTime = UserInfo.dailyTask:getNormalTime()
        d = self.normalTime - sec 
    elseif taskType == "alliance" then 
        self.allianceTime = UserInfo.dailyTask:getAllianceTime()
        d = self.allianceTime - sec
    end
    return BuildingDiamondCalculation.TimeSpeedFinishDiamond(d)
end

--- 切换 时间的 显示
function T:switchListViewTimeShow(list)
    if not self.freshBtn then 
        self:registerFreshEvent() -- 注册事件
    end

    if list == "normal" then  -- 切换到 normal 页面
        self.normalTime = UserInfo.dailyTask:getNormalTime()
        local sec = math.floor(TimeUtils:getSyncMillis() / 1000)
        if sec < self.normalTime then 
            self:updateNormalTimeState("begin")
        else 
            self:updateNormalTimeState("end")
        end

    elseif list == "alliance" then -- 切换到 alliance 页面
        self.allianceTime = UserInfo.dailyTask:getAllianceTime()
        local sec = math.floor(TimeUtils:getSyncMillis() / 1000)
        if sec < self.allianceTime then 
            self:updateAllianceTimeState("begin")
        else 
            self:updateAllianceTimeState("end")
        end
    end
    
end

--- 因为时间的缘故
function T:flushTask()
	if self.taskSchduleId then
		return
	end

	local func = function()
		self:updateTip()
	end

	self.taskSchduleId = Cocos2dxUtils:interval(func, 0.5)
end

function T:removeFlushTask()
    if self.taskSchduleId then 
        Cocos2dxUtils:clearScheduler(self.taskSchduleId)
        self.taskSchduleId = nil
    end
end


function T:registerFreshEvent()
    local func = function(s, e)
        if e ~= ccui.TouchEventType.ended then
            return
        end

        if self.allianceState then 
            if self.allianceState == "begin" then 
                self:freshEvent("alliance", true)
            elseif self.allianceState == "end" then
                self:freshEvent("alliance", false)
            end
        elseif self.normalState then 
            if self.normalState == "begin" then 
                self:freshEvent("normal", true)
            elseif self.normalState == "end" then
                self:freshEvent("normal", false)
            end
        end
    end

    self.freshBtn:addTouchEventListener(func)
end

--- 刷新事件
function T:freshEvent(taskType, useDiamond) 

    local callback = function()
        if useDiamond == false then -- 时间到了  自然刷新
            self:sendFreshCommand(taskType, useDiamond, 0)  
            return
        end
        
        local needDiamond = self:getFinishDiamond(taskType)
        local diamond = PlayerInstance:getDiamond()
        
        local func = nil
        if needDiamond > diamond then -- 钻石不足
            func = function()
                MUIPop.MUIToReCharge()
            end
        else -- 钻石升级
            func = function()
                self:sendFreshCommand(taskType, useDiamond, needDiamond)
            end
        end 
        
        MUIPop.MUIImmediate(Language:get("uy161", needDiamond), func)
    end
    
    local exec, finish = self:checkTaskExec(taskType)
    if exec == true then  -- 有任务在执行
        if finish == true then -- 有任务已完成
            MUIPop.MUIImmediate(Language:get("uy163"), callback)
        else 
            MUIPop.MUIImmediate(Language:get("uy162"), callback)
        end
    else 
        callback()
    end


end

function T:sendFreshCommand(taskType, useDiamond, needDiamond)
    local task = nil  
    if taskType == "normal" then 
        task = 0 
    else 
        task = 1
    end

    FreshDailyTaskCommand.new():exec(task, useDiamond, function(state)
        if state == ReturnCode.SUCCESS then -- 完成成功
            if taskType == "normal" then  -- 重新刷新任务
                self:updateListContent(UserInfo.dailyTask:getNormalTask(), self.normalListView)
                self:switchListViewTimeShow("normal") -- 切换到 normal
            elseif taskType == "alliance" then 
                self:updateListContent(UserInfo.dailyTask:getAllianceTask(), self.allianceListView)
                self:switchListViewTimeShow("alliance")
            end

            TaskManager:luaDispatchEvent(TaskManager.noticeMessage.dailyTaskFresh) -- 派发事件

        end
    end)
end

--[[
    如果有任务在执行中，或者可以领奖没领，前台会提示:当前有任务正在执行中/可以领取奖励，刷新会导致任务重置，是否刷新？
]]
--- 检测是否有任务在执行
function T:checkTaskExec(taskType)
    local func = function(task)
        local sec = math.floor(TimeUtils:getSyncMillis() / 1000)

        local exec = false -- 是否有任务在执行
        local finish = false -- 完成任务
        for k, v in pairs(task) do 
            if v[2] > 1 then  -- 代表有任务在执行
                exec = true
                if v[2] < sec then  -- 任务已完成
                    finish = true    
                end 
                break
            end
        end    
        return exec, finish
    end
    
    local tb = {}

    if taskType == "normal" then 
        tb = UserInfo.dailyTask:getNormalTask()
    elseif taskType == "alliance" then 
        tb = UserInfo.dailyTask:getAllianceTask()
    end

    return func(tb)
end




return T

--endregion
