--region TaskDailyItem.lua
--Author    : YuDing
--Date      : 2015/4/22
--Introduce : 每日任务 条目


local T = class("T",function() return ccui.Layout:create() end)

--- 这个窗口的大小
T.size = nil

--- 任务id
T.id = nil

--- 父类的listview
T.listView = nil


--- 构造函数
function T:ctor(id, time, listView)
    mapping(self, LuaEventDispatcher)
    
	self:registerScriptHandler(
		function(eventType)
			--print("ResourceListOpenItem:"..eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
				self:cleanUp()
			end
		end
	)


    self.id = id
    self.time = time
    self.listView = listView

    --- 初始化 item 尺寸
    self:initItemSize()
end

function T:onEnter()
end

--- 没有对item做缓存
function T:onExit()
    if self.timeId then 
        Cocos2dxUtils:clearScheduler(self.timeId)
        self.timeId = nil
    end 

    self:releasePublicEvent()
end

function T:cleanUp()
    
end

function T:GetWidget()
	-- 资源头像
	self._imgHead = self._widget.leftHead

	-- 加速按钮
	self._btnSpeed = self._widget.button1
	self._btnSpeed:setName("btnSpeed")
	REL:toOther("left", "bottom", self._btnSpeed, self._widget.back, 385 + 74,-3)
    local posy = self._btnSpeed:getPositionY()
    --self._btnSpeed:setPosition(cc.p(532,51.5))
	-- 名字
	self._labelName = self._widget.title

    -- 信息按钮
    self._btnInfo = self._widget.button2
    self._btnInfo:setName("btnInfo")
    REL:toOther("left", "bottom", self._btnInfo, self._widget.back, 385, 8)

	-- 进度条
	--self._progress = self._widget.loadingBar

	-- 时间
	self._labelTime = self._widget:getLabel(1)

	-- 显示的文字
	local btnText = XMLLabel()
	btnText:setHAlign("center")
	btnText:setVAlign("middle")
	btnText:setContentSize(cc.size(300, 36))
	self._btnSpeed:addChild(btnText)
    self.btnText = btnText

--	self._labelCostDiamond = labelCostDiamond

--	REL:toOther("center", "middle", self._labelCostDiamond, self._btnSpeed, -34, 4)
    --self._labelCostDiamond:setPosition(cc.p(348,42))

end

function T:registerPublicEvent()
    TaskManager:luaAddEventListener(TaskManager.noticeMessage.dailyTaskFresh, self, self.freshSubmitState)
end

function T:releasePublicEvent()
    TaskManager:luaRemoveEventListener(TaskManager.noticeMessage.dailyTaskFresh, self, self.freshSubmitState)
end

--- 设置不变的数据
function T:SetData()
	local dataItem = DailyTaskData[self.id]
	local name = TaskManager:getDailyNameBySid(self.id)
    local res = dataItem.res

	-- 设置头像
	local iconPath = IconManager.iconPath
	self._imgHead:loadTexture(iconPath .. res)

    -- 设置名字
    --[[品质常量 Q_WHITE=0白色( 255, 255, 255),Q_GREEN=1绿色( 0, 255, 0) ,Q_BLUE=2蓝色( 0, 0, 255),Q_PURPLE=3紫色( 218, 112, 214),Q_ORANGE=4橙色(255   97   0) ]]
--    local color = nil
--    if dataItem.quality == 0 then 
--        --self._labelName:setColor(cc.c3b(255, 255, 255))
--        color = "0xffffffff"
--    elseif dataItem.quality == 1 then 
--        --self._labelName:setColor(cc.c3b(0, 255, 0))
--        color = "0x00ff00ff"
--    elseif dataItem.quality == 2 then 
--        --self._labelName:setColor(cc.c3b(0, 0, 255))
--        color = "0x0000ffff"
--    elseif dataItem.quality == 3 then 
--        --self._labelName:setColor(cc.c3b(218, 112, 214))
--        color = "0xda70d6ff"
--    elseif dataItem.quality == 4 then 
--        color = "0xff6100ff"
--    end
    
--    name = string.format(name, color)
    --self._labelName:setColor(cc.c3b(255, 97, 0))
    
    local _, __, oName = string.find(name, "<.->(.+)<.->") -- 找出名字 .任意字符 - 最短匹配 0个或者1个
    
    local wName = ' ' .. oName  -- 加空格
    name = string.gsub(name, oName, wName) -- 替换
    
	self._widget:setString(self._labelName, name)
end

--- 更新状态
function T:updateState()
    local syncSec = math.floor(TimeUtils:getSyncMillis() / 1000)
    local endTime = self.time
    if endTime == 0 then 
        self:switchState("notBegin")
    else 
        local sec = math.floor(TimeUtils:getSyncMillis() / 1000)
        if sec < self.time then -- 正在进行
            self:switchState("begin")
        else 
            self:switchState("end")
        end
    end
end

--- 切换状态
function T:switchState(state)
    self.state = state

    if state == "notBegin" then 
        --self._progress:setVisible(false) 

        self._widget:setString(self._labelTime, Language:get("uc172",UnitConversion.handleTime4(DailyTaskData[self.id].time)))
        -- 设置相对位置
        REL:toOther("left", "top", self._labelTime, self._widget.back,130, 60)
        
        

        if self.timeId then 
            Cocos2dxUtils:clearScheduler(self.timeId)
            self.timeId = nil
        end
    elseif state == "begin" then 
        --self._progress:setVisible(true)
        self:createBar()

        REL:toOther("left", "top", self._labelTime, self._widget.back, 150, 85) -- label 重排位置

        REL:toOther("center", "middle", self.btnText, self._btnSpeed, -34, 4) -- 钻石数目

        local func = function()
            local sec = math.floor(TimeUtils:getSyncMillis() / 1000)
            local d = self.time - sec  -- 还剩余的时间

            if d > DailyTaskData[self.id].time then  -- 可能时间有误差
               d = DailyTaskData[self.id].time
            end

            self.loadingBar:setPercentage((1 - d/DailyTaskData[self.id].time) * 100)
            self._labelTime:setString(UnitConversion.handleTime4(d))

            local needDiamond = self:getFinishDiamond()
            self.btnText:setString(Language:get("uc102", needDiamond)) -- 刷新砖石


            if sec >= self.time then 
                self:switchState("end")  
                --Cocos2dxUtils:clearScheduler(self.timeId)
                --self.timeId = nil
            end
        end

        if not self.timeId then 
            self.timeId = Cocos2dxUtils:interval(func, 1)
            func() -- 先执行一次
        end

    elseif state == "end" then -- 时间到了
        --self._progress:setVisible(true)
        --self._progress:setPercentage(100)
        self:createBar()
        self.loadingBar:setPercentage(100)

        self._labelTime:setString(UnitConversion.handleTime4(0))
        REL:toOther("left", "top", self._labelTime, self._widget.back, 150, 85) -- label 重排位置

        if self.timeId then 
            Cocos2dxUtils:clearScheduler(self.timeId)
            self.timeId = nil
        end 
    end

    self:switchBtnState(state)
end

--- 按钮的转换状态
function T:switchBtnState(state)
    if state == "notBegin" then 
        if self._btnSpeed.eff then -- 先移除特效 可能会出现特效 停止不动的现象
			self._btnSpeed.eff:removeFromParent()
			self._btnSpeed.eff = nil
		end

        self._btnSpeed:loadTextures("button_blue_normal.png", "button_general_down.png", "",ccui.TextureResType.plistType)
        REL:toOther("left", "bottom", self._btnSpeed, self._widget.back, 470, 7)

        self.btnText:setString(Language:get("uy159"))
        REL:toOther("center", "middle", self.btnText, self._btnSpeed, 0, 15)

    elseif state == "begin" then 
        if self._btnSpeed.eff then -- 先移除特效 可能会出现特效 停止不动的现象
			self._btnSpeed.eff:removeFromParent()
			self._btnSpeed.eff = nil
		end

        self._btnSpeed:loadTextures("addSpeedButton_normal.png","addSpeedButton_normal.png", "",ccui.TextureResType.plistType)
        REL:toOther("left", "bottom", self._btnSpeed, self._widget.back, 385 + 74,-3)

        REL:toOther("center", "middle", self.btnText, self._btnSpeed, -34, 4) -- 钻石数目

    elseif state == "end" then 
        
        if self._btnSpeed.eff then -- 先移除特效 可能会出现特效 停止不动的现象
			self._btnSpeed.eff:removeFromParent()
			self._btnSpeed.eff = nil
		end

		if not self._btnSpeed.eff then -- 调加特效
			self._btnSpeed.eff = HomePageManager:getEff("buttonPolishingEff", 1)
            self._btnSpeed:addChild(self._btnSpeed.eff)
            REL:toOther("center", "middle", self._btnSpeed.eff, self._btnSpeed, -17, 3)
		end


        self._btnSpeed:loadTextures("button_yellow_normal.png", "button_general_down.png", "",ccui.TextureResType.plistType)
        REL:toOther("left", "bottom", self._btnSpeed, self._widget.back, 470, 7)

        self.btnText:setString(Language:get("uy160"))
        REL:toOther("center", "middle", self.btnText, self._btnSpeed, 0, 15)
    end
end

function T:setTaskId(id)
    self.id = id 
end

function T:setTime(time)
    self.time = time
end

function T:registerSpeedBtnEvent()
    local function callback(sender, eventType)
	    if eventType == ccui.TouchEventType.ended then
            if self.state == "notBegin" then 

                if self.submitVisible == false then --  不能开始任务
                    MUIPop.CannotSubmitDailyTask()
                    return 
                end

                StartDailyTaskCommand.new():exec(self.id,
	            function(state)
	            	if state == ReturnCode.SUCCESS then
                         self:setTime(UserInfo.dailyTask:getTaskTime(self.id))
                         self:updateState() --  更新状态

                         TaskManager:luaDispatchEvent(TaskManager.noticeMessage.dailyTaskFresh) -- 派发事件

	            	end
	            end)
            elseif self.state == "begin" then 
                self:speedEvent()
            elseif self.state == "end" then 
                self:sendFinishCommand()
            end
		end
	end
    self._btnSpeed:addTouchEventListener(callback)


    local infoFunc = function(sender, eventType)
        if eventType ~= ccui.TouchEventType.ended then
            return
        end
        self:onInfoClickEvent()
    end

    self._btnInfo:addTouchEventListener(infoFunc)
end

--- 详细信息
function T:onInfoClickEvent()
    local finish = false 
    if self.state == "end" then 
        finish = true
    end

    local tb = TaskManager:getTaskReward(self.id, "daily")
	TaskManager:showRewardInfoWindow(self.id, finish, tb, "daily")
end

--- 加速
function T:speedEvent()
    local needDiamond = self:getFinishDiamond()
	local diamond = PlayerInstance:getDiamond()

    local func = nil
    if needDiamond > diamond then -- 钻石不足
        MUIPop.MUIToReCharge()
    else -- 钻石升级
        func = function()
            self:sendSpeedCommand(needDiamond)
        end

        local payState = SetStates.setPayState
		local value = payState:getClosedValue(payState.CLOSE_SPEEDUP_DAILYTASK)

		if value then
			func()
		else
			local info = Language:get("uy161", needDiamond)
			local layout = DiamondPopInfo.new(info)
			local function confirm()
				SetStates.setPayState:setClosedValue(layout.judge, SetStates.setPayState.CLOSE_SPEEDUP_DAILYTASK)
				if layout.judge == true then
					Command:SetPayCommand()
				end
				func()
			end
			MUIPop.DiamondPopInfo(layout,confirm)
		end
    end 

    --MUIPop.MUIImmediate(Language:get("uy161", needDiamond), func)
end

function T:getFinishDiamond()
    local sec = math.floor(TimeUtils:getSyncMillis() / 1000)
    local d = self.time - sec  -- 还剩余的时间
    return BuildingDiamondCalculation.TimeSpeedFinishDiamond(d)
end

--- 从listview中移除self这项，并且更新listview
function T:removeSelf()
   local index = self.listView:getIndex(self)
   local listView = self.listView
   self.listView:removeItem(index)
   listView:refreshView() 
end

function T:getItemSize()
    return self.size 
end

function T:initItemSize()
    local frame = ResLoader:getSpriteFrame("frameBack_middle.png")
    local size = frame:getOriginalSize()
    size = cc.size(UI_VSIZE.width, size.height)
    self:setContentSize(size)
    self.size = size
end

function T:createBar()
    if self.loadingBar then  -- 已存在
        return 
    end
    -- 背景图片:到时移除的时候把这张图片移除就行了，并且2个变量设置为nil
    local backImg = ccui.ImageView:create()
    backImg:loadTexture("productProgressBack.png",ccui.TextureResType.plistType)
    --self._widget:addChild(backImg)
    self._widget.back:addChild(backImg)
    --REL:toOther("left","top",backImg,self._widget.back,120,45)
    backImg:setPosition(cc.p(242.5,70))
    self.backImg = backImg

    local uiProgressFore = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("productProgressFore.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	backImg:addChild(uiProgressFore)
    --REL:toOther("center","middle",uiProgressFore,backImg,0,0)
    uiProgressFore:setPosition(cc.p(122.5,14))
    self.loadingBar = uiProgressFore
end

function T:removeBar()
    if self.loadingBar then
       self.backImg:removeFromParent()
       self.backImg = nil 
       self.loadingBar = nil
    end
end

--- 发送完成 命令
function T:sendFinishCommand()
    FinishDailyTaskCommand.new():exec(self.id, function(state)
        if state == ReturnCode.SUCCESS then -- 完成成功
            local decoder = require("src.app.communication.award.AwardDataDecoder") -- 解析器
            local tb = TaskManager:getTaskReward(self.id, "daily")

            decoder:showSuccessWindow(tb) -- 显示成功窗口
	        decoder:addAWard(tb)          -- 派发物品

            TaskManager:luaDispatchEvent(TaskManager.noticeMessage.dailyTaskFresh) -- 派发事件

            self:removeSelf() -- 删除自己
        end
    end)
end

--- 發送加速命令
function T:sendSpeedCommand(needDiamond)
    SpeedDailyTaskCommand.new():exec(self.id, function(state)
        if state == ReturnCode.SUCCESS then -- 完成成功
            self:setTime(UserInfo.dailyTask:getTaskTime(self.id))
            
            self:updateState()

            TaskManager:luaDispatchEvent(TaskManager.noticeMessage.dailyTaskFresh) -- 派发事件

        end
    end)
end


--- 检查是否可领取
function T:freshSubmitState()
    if DailyTaskData[self.id].taskType == 0 then  -- 日常
        local sid = TaskManager:checkNormalDailyTask()
        if sid > 0 then -- 有进行着的任务
            if sid == self.id then 
                self.submitVisible = false
                self._btnSpeed:setIsGray(false)
            else
                self.submitVisible = false
                self._btnSpeed:setIsGray(true)
            end
        else -- 没有可进行着的任务
            self.submitVisible = true
            self._btnSpeed:setIsGray(false)
        end
    elseif DailyTaskData[self.id].taskType == 1 then -- 军团
        local sid = TaskManager:checkAllianceDailyTask()
        if sid > 0 then -- 有进行着的任务
            if sid == self.id then 
                self.submitVisible = false
                self._btnSpeed:setIsGray(false)
            else
                self.submitVisible = false
                self._btnSpeed:setIsGray(true)
            end
        else -- 没有可进行着的任务
            self.submitVisible = true
            self._btnSpeed:setIsGray(false)
        end
    end
end

function T:initView()
	local _widget = ListItem4.new()
	_widget:setListItemAttribute(
		"V",
		{"label"},
		{{"addSpeedButton_normal.png","addSpeedButton_normal.png","false","false"}, {"infoButton_normal.png", "iconButton_general_down.png", "false", "false"}}
	)
	self:addChild(_widget)
	REL:toOther("center","middle",_widget,self,0,0)
	self._widget = _widget

	-- 得到控件
	self:GetWidget()
	self:SetData()

    self:registerSpeedBtnEvent()

    self:updateState()

    self:freshSubmitState()

    self:registerPublicEvent()
end

return T






--endregion
