local T=Class.FormLoc2(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 阵位编号
	-- _locId

	--- 阵营
	self.camp=Camp.CAMP1
end

function T:ctor(locId)
	AbstractUI.ctor(self)

	self._locId=locId

	self:init()
end

--- 初始化
function T:init()
	self:setContentSize(cc.size(224,114))
	self:setTouchEnabled(false)

	--背景图片
	local uiBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("formLocBack.png"))
	self:addChild(uiBack)
	REL:toOther("center","bottom",uiBack,self,-6,-48)
	self.uiBack=uiBack

	local _locId=self._locId or 1
	if _locId < 1 then
		_locId=1
	elseif _locId > 6 then
		_locId=6
	end
	local uiLocNum=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("formLocNum_".._locId..".png"))
	self:addChild(uiLocNum)
	REL:toOther("center","middle",uiLocNum,uiBack,-4,20)
	self.uiLocNum=uiLocNum

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0xff,0,0))
	--	self:setBackGroundColorOpacity(100)

	self:toUnaddStatus()
end

--- 初始化已添加状态
function T:initAddedStatus()
	local c=ccui.Layout:create()
	self:addChild(c)
	REL:relOther(c,self,0,0,0,0)

	--战机名称背景
	local uiNameBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("aircraftNameFormBack.png"))
	c:addChild(uiNameBack,1)
	REL:toOther("left","bottom",uiNameBack,self,-20,-40)

	--战机数量
	local uiCount=XMLLabel()
	uiCount:setAlign("center","middle")
	c:addChild(uiCount,2)
	REL:relOther(uiCount,uiNameBack,0,0,0,24)
	self.uiCount=uiCount

	--战机名称
	local uiName=XMLLabel()
	uiName:setAlign("center","middle")
	c:addChild(uiName,3)
	REL:relOther(uiName,uiNameBack,0,0,22,0)
	self.uiName=uiName

	--	uiCount:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	uiCount:setBackGroundColor(cc.c3b(0xff,0,0))
	--	uiCount:setBackGroundColorOpacity(100)

	self.uiAddedStatusContainer=c
end

--- 初始化未添加状态
function T:initUnaddStatus()
	local c=ccui.Layout:create()
	self:addChild(c)
	REL:relOther(c,self,0,0,0,0)

	self.uiUnaddStatusContainer=c
end

--- 更新战机显示
function T:updateAircraft()
	if self.uiAircraft then
		self.uiAircraft:removeFromParent()
        self.uiAircraft=nil
	end

	if self.data then
		local T=GameUtils:getAicraftModelUrl(self.camp,self.data.sid)
		if T then
			local o=T()
			o:setScale(0.8)
			self.uiAddedStatusContainer:addChild(o)
			REL:toOther("center","middle",o,self,-6,10)
			self.uiAircraft=o
		end
	end
end

--- 切换到已添加状态
function T:toAddedStatus()
	if self.uiUnaddStatusContainer then
		self.uiUnaddStatusContainer:setVisible(false)
	end

	if self.uiAddedStatusContainer then
		self.uiAddedStatusContainer:setVisible(true)
	else
		self:initAddedStatus()
	end

	local data=self.data

	local d=Aircraft_temp[data.sid]
	self.uiName:setString(AircraftUtils:getRichName(d))
	self.uiCount:setString(data.count)
end

--- 切换到未添加状态
function T:toUnaddStatus()
	if self.uiAddedStatusContainer then
		self.uiAddedStatusContainer:setVisible(false)
	end

	if self.uiUnaddStatusContainer then
		self.uiUnaddStatusContainer:setVisible(true)
	else
		self:initUnaddStatus()
	end
end

--- 设置数据
function T:setData(value)
	local data=self.data
	if value ~= data then
		self.data=value

		if value and value.sid ~= 0 and value.count ~= 0 then
			self:toAddedStatus()
		else
			self:toUnaddStatus()
		end
		if (data == nil and value ~= nil)
			or
			(data ~= nil and value == nil)
			or
			(data ~= nil and value ~= nil and data.sid ~= value.sid)
		then
			self:updateAircraft()
		end
	end
end

--- 获取数据
function T:getData()
	return self.data
end

function T:setCamp(value)
	if value ~= self.camp then
		self.camp=value

		if self.data then
			self:updateAircraft()
		end
	end
end

function T:getCamp()
	return self.camp
end

return T
