local T=Class.TeamFormLocs(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 战机位置
T.FormLoc = require("src.app.uiScript.components.team.FormLoc")

--- 阵形位置列表
T.FORM_LOC_LIST={
	[1]={coordinate=cc.p(196,458)},
	[2]={coordinate=cc.p(364,364)},
	[3]={coordinate=cc.p(528,268)},
	[4]={coordinate=cc.p(110,294)},
	[5]={coordinate=cc.p(276,200)},
	[6]={coordinate=cc.p(444,106)}
}

function T:def()
	AbstractUI.def(self)

	--- 阵形位置列表
	self.formLocList=mapping({},self.FORM_LOC_LIST)
end

function T:ctor(camp)
	self._camp=camp

	AbstractUI.ctor(self)

	self:init()
end

function T:init()
	self:setContentSize(cc.size(626,382))
	self:setTouchEnabled(false)

	self:initFormLocs()
end

--- 初始化战机阵位列表
function T:initFormLocs()
	for k,v in ipairs(self.formLocList) do
		local coordinate=v.coordinate

		local x,y=coordinate.x,coordinate.y

		--战机阵形位置显示项
		local formLoc=self.FormLoc(k)
		self:addChild(formLoc)
		local s=formLoc:getContentSize()
		formLoc:setPosition(coordinate.x-s.width/2,coordinate.y-s.height/2)
		v.formLoc=formLoc
	end
end

--- 设置部队数据
function T:setTeam(team)
	if team then
		for k,v in ipairs(self.formLocList) do
			local loc=v.formLoc
			local data=team[k]
			if data and data.sid > 0 and data.count > 0 then
				loc:setData(data)
			else
				loc:setData(nil)
			end
		end
	else
		for k,v in ipairs(self.formLocList) do
			v.formLoc:setData(nil)
		end
	end
end

--- 获取部队数据
function T:getTeam()
	local team={}
	for k,v in ipairs(self.formLocList) do
		local loc=v.formLoc
		if loc then
			team[k]=loc:getData()
		end
	end

	return team
end

--- 设置阵营
function T:setCamp(camp)
	if camp ~= self._camp then
		self._camp=camp
		
		for k,v in ipairs(self.formLocList) do
			v.formLoc:setCamp(camp)
		end
	end
end
--- 获取阵营
function T:getCamp()
	return self._camp
end

return T
