local T=Class.TeamSetView(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

--- 战机阵形设置
T.TeamFormLocsSetable=require("src.app.uiScript.components.team.TeamFormLocsSetable")

--- 预加载资源列表
T.PRE_RES_LIST={
	"res/images/windowBack3.plist"
}

function T:def()
	AbstractUI.def(self)
end

function T:ctor()
	AbstractUI.ctor(self)

	ResLoader:syncLoad(self.PRE_RES_LIST)
	self:_init()
end

function T:onEnter()
	AbstractUI.onEnter(self)

	-- 这里深拷贝一份所有战机数据，并且只要有战机总数量改变，则这里改变
	-- 注意:不能映射,只能重新创建一个
	self.uiTeamFormLocs:setSetableAircraftInfos(UserInfo.city.aircraftBox.infos)
	AircraftManager:luaAddEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,self,self.aircraftInfosUpdateHandler)
end

function T:onExit()
	AbstractUI.onExit(self)
	
	AircraftManager:luaRemoveEventListener(AircraftManager.EVT_TYPE_AIRCRAFT_REFRESH,self,self.aircraftInfosUpdateHandler)
end

--- 内存清理
function T:cleanUp()
	AbstractUI.cleanUp(self)

	ResLoader:unloadReses(self.PRE_RES_LIST)
end

function T:_init()
	REL:relScreen(self,6,6,162,0)

	--背景图片
	local uiBack = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("windowBack3.jpg"))
	self:addChild(uiBack)
	REL:relOther(uiBack,self,0,0,-20,0)
	self.uiBack = uiBack

	--最大上阵数量
	local uiMaxAircraft = XMLLabel(Language:get("ug322",PlayerInstance:getMaxAircraftCount()))
	uiMaxAircraft:setContentSize(cc.size(240,36))
	self:addChild(uiMaxAircraft)
	REL:toOther("left", "top", uiMaxAircraft, self, 20, 10)
	self.uiMaxAircraft = uiMaxAircraft

	--当前战力
	local uiCurFight=XMLLabel(Language:get("ug323",0))
	uiCurFight:setContentSize(cc.size(240,36))
	self:addChild(uiCurFight)
	REL:toOther("left", "top", uiCurFight, self, 20, 46)
	self.uiCurFight = uiCurFight

	--增益属性提示
	local uiAddTip=XMLLabel(Language:get("ug324"))
	uiAddTip:setContentSize(cc.size(280,36))
	self:addChild(uiAddTip)
	REL:toOther("right", "top", uiAddTip, self, 20, 10)
	self.uiAddTip = uiAddTip

	--攻击图标
	local uiAttackIcon=cc.Sprite:create(IconManager.iconPath.."aircraft/aircraftBaseAttributeIcon/attack.png")
	self:addChild(uiAttackIcon)
	REL:relRect(uiAttackIcon,cc.rect(0,0,80,80),0,0,0,0)
	REL:toOther("left", "top", uiAttackIcon, uiAddTip, 0, uiAddTip:getContentSize().height+4)
	self.uiAttackIcon=uiAttackIcon
	local atkIconS=uiAttackIcon:getContentSize()

	--攻击增益属性标题
	local uiAttackAddCap=XMLLabel(Language:get("ug328",0,0))
	uiAttackAddCap:setAlign("left","middle")
	uiAttackAddCap:setContentSize(cc.size(240,36))
	self:addChild(uiAttackAddCap)
	REL:toOther("left", "top", uiAttackAddCap, uiAttackIcon, 80+8, 0)
	self.uiAttackAddCap=uiAttackAddCap

	--攻击增益属性
	local uiAttackAdd=XMLLabel(Language:get("ug325",0,0))
	uiAttackAdd:setAlign("left","middle")
	uiAttackAdd:setContentSize(cc.size(240,36))
	self:addChild(uiAttackAdd)
	REL:toOther("left", "bottom", uiAttackAdd, uiAttackIcon, 80+8, 0)
	self.uiAttackAdd=uiAttackAdd

	--血量图标
	local uiHPIcon=cc.Sprite:create(IconManager.iconPath.."aircraft/aircraftBaseAttributeIcon/hp.png")
	self:addChild(uiHPIcon)
	REL:relRect(uiHPIcon,cc.rect(0,0,80,80),0,0,0,0)
	REL:toOther("left", "top", uiHPIcon, uiAttackIcon, 0, 80+4)
	self.uiHPIcon=uiHPIcon
	local hpIconS=uiHPIcon:getContentSize()

	--血量增益属性标题
	local uiHPAddCap=XMLLabel(Language:get("ug329",0,0))
	uiHPAddCap:setAlign("left","middle")
	uiHPAddCap:setContentSize(cc.size(240,36))
	self:addChild(uiHPAddCap)
	REL:toOther("left", "top", uiHPAddCap, uiHPIcon, 80+8, 0)
	self.uiHPAddCap=uiHPAddCap

	--血量增益属性
	local uiHPAdd=XMLLabel(Language:get("ug326",0,0))
	uiHPAdd:setAlign("left","middle")
	uiHPAdd:setContentSize(cc.size(240,36))
	self:addChild(uiHPAdd)
	REL:toOther("left", "bottom", uiHPAdd, uiHPIcon, 80+8, 0)
	self.uiHPAdd=uiHPAdd

	--战机阵形设置
	local uiTeamFormLocs=self.TeamFormLocsSetable(Camp.CAMP1)
	uiTeamFormLocs:luaAddEventListener("change",self,self.updateCurFight)
	self:addChild(uiTeamFormLocs)
	REL:toOther("center", "middle", uiTeamFormLocs, self, 0, -100)
	self.uiTeamFormLocs=uiTeamFormLocs
end

--- 战机列表更新
function T:aircraftInfosUpdateHandler()
	self.uiTeamFormLocs:setSetableAircraftInfos(UserInfo.city.aircraftBox.infos)
end

--- 更新当前战力:根据选择的阵型来刷新数据
function T:updateCurFight()
	local team=self.uiTeamFormLocs:getTeam()
	if team then
		local city=UserInfo.city

		local fight,allAtkB,allAtcA,allHPB,allHPA=0,0,0,0,0
		for k,v in pairs(team) do
			if v.sid ~= 0 and v.count ~= 0 then
				local c=v.count
				fight=fight+PlayerInstance:getAircraftFight(v,c)

				local d=Aircraft_temp[v.sid]

				local atkB=d.attack
				local atcA=PlayerInstance:getAircraftAttack(v)-atkB
				allAtkB,allAtcA=allAtkB+atkB*c,allAtcA+atcA*c

				local hpB=d.hp
				local hpA=PlayerInstance:getAircraftHp(v)-hpB
				allHPB,allHPA=allHPB+hpB*c,allHPA+hpA*c
			end
		end

		self.uiCurFight:setString(Language:get("ug323",math.floor(fight)))
		self.uiAttackAdd:setString(Language:get("ug325",math.floor(allAtkB),math.floor(allAtcA)))
		self.uiHPAdd:setString(Language:get("ug326",math.floor(allHPB),math.floor(allHPA)))
	end
end

return T
