--[[
 *	具体描述的vip项
]]

local T = class("T",function() return ccui.Layout:create() end)

--- sid
T.sid = nil

--- 数据
T.vipData = nil


--- 构造函数
function T:ctor(listView,sid,vipData)
    self.listView = listView
    self.sid = sid
    self.vipData = vipData

    if sid == 11 or sid == 12 then
        local vipLevel = UserInfo.vipLevel
        if vipLevel < 10 then
            self:initVip() -- VIP<10不显示11，12，显示锁
        else
            self:init()
        end

    else
        self:init()
    end

    
    
end

function T:initVip()
    self:setContentSize(cc.size(624,150))  -- 先暂时随便给一个

    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("vipTag.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("center","top",back,self,1,0)

    -- 标题
    local labelName = XMLLabel()
    labelName:setContentSize(cc.size(200,36))
    labelName:setVAlign("middle")
    self:addChild(labelName)
    REL:toOther("center","middle",labelName,back,0,0)
    labelName:setString(Language:get("uc483",self.sid))

    -- 锁的图片
    local lockIcon = ccui.ImageView:create()
    lockIcon:loadTexture("campaignItemLock.png",ccui.TextureResType.plistType)
    self:addChild(lockIcon)
    REL:toOther("center","top",lockIcon,self,1,60)
end


--- 初始化
function T:init()
    self:setContentSize(cc.size(624,57))  -- 先暂时随便给一个

    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("vipTag.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("center","top",back,self,1,0)

    -- 标题
    local labelName = XMLLabel()
    labelName:setContentSize(cc.size(200,36))
    labelName:setVAlign("middle")
    self:addChild(labelName)
    REL:toOther("center","middle",labelName,back,0,0)
    labelName:setString(Language:get("uc483",self.sid))

    --- 描述
    local describe = XMLLabel()
    describe:setWidth(self.listView:getContentSize().width - 50)
    self:addChild(describe)
    REL:toOther("left","top",describe,self,20,60)
    describe:setString(self:getHtml())

    describe:updateView()
    local contentHeight = describe:getTextHeight()
    self:setContentSize(cc.size(self.listView:getContentSize().width,100 + contentHeight))

    REL:toOther("center","top",back,self,1,0)
    REL:toOther("left","middle",labelName,back,20,0)
    REL:toOther("left","top",describe,self,20,60)
    

end

function T:getHtml()
    local seq = Language:get("ug1100")

    local vipData = self.vipData

    local html = nil

    if vipData.buildQueueCount and vipData.buildQueueCount > 0 then
        html = Language:get("uc484",vipData.buildQueueCount) .. seq
    end

    if vipData.techQueueCount and vipData.techQueueCount > 0 then
        html = html .. Language:get("uc485",vipData.techQueueCount) .. seq
    end

    if vipData.pointCount and vipData.pointCount > 0 then
        html = html .. Language:get("uc486",vipData.pointCount) .. seq
    end

    if vipData.battleQueueCount and vipData.battleQueueCount > 0 then
        html = html .. Language:get("uc487",vipData.battleQueueCount) .. seq
    end

    if vipData.supplyLineBuyNum and vipData.supplyLineBuyNum > 0 then
        html = html .. Language:get("uc712",vipData.supplyLineBuyNum) .. seq
    end

    if vipData.arenaChallengePointBuyNum and vipData.arenaChallengePointBuyNum > 0 then
        html = html .. Language:get("uc713",vipData.arenaChallengePointBuyNum) .. seq
    end

    if vipData.donateNum and vipData.donateNum > 0 then
        html = html .. Language:get("uc1077",vipData.donateNum) .. seq
    end


    if vipData.formationNum and vipData.formationNum > 0 then
        html = html .. Language:get("uc947",vipData.formationNum) .. seq
    end


    if vipData.marchSpeed and vipData.marchSpeed > 0 then
        html = html .. Language:get("uc488",vipData.marchSpeed) .. seq
    end

    if vipData.produceSpeed and vipData.produceSpeed > 0 then
        html = html .. Language:get("uc489",vipData.produceSpeed) .. seq
    end

    if vipData.reconstructSpeed and vipData.reconstructSpeed > 0 then
        html = html .. Language:get("uc490",vipData.reconstructSpeed) .. seq
    end

    if vipData.techSpeed and vipData.techSpeed > 0 then
        html = html .. Language:get("uc491",vipData.techSpeed) .. seq
    end

    if vipData.checkPointExp and vipData.checkPointExp > 0 then
        html = html .. Language:get("uc492",vipData.checkPointExp) .. seq
    end

    if vipData.steelAdd and vipData.steelAdd > 0 then
        html = html .. Language:get("uc529",vipData.steelAdd) .. seq
    end

    if vipData.oilAdd and vipData.oilAdd > 0 then
        html = html .. Language:get("uc530",vipData.oilAdd) .. seq
    end

    if vipData.siliconAdd and vipData.siliconAdd > 0 then
        html = html .. Language:get("uc531",vipData.siliconAdd) .. seq
    end

    if vipData.freeTime and vipData.freeTime > 0 then
        html = html .. Language:get("uc493",vipData.freeTime) .. seq
    end

    if vipData.needGems and vipData.needGems > 0 then
        html = html .. Language:get("uc494",vipData.needGems) .. seq
    end



    return html

end


return T
