--[[
 *	vipview
]]
local T = class("T",function() return ccui.Layout:create() end)

--- vip项
T.VIPItem = require("src.app.uiScript.components.vip.VIPItem")

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor()
    self.queue = Queue()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:initTop()
    self:initBottom()

end

--- 进入
function T:onEnter()
    PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.vipPoint,self,self.refreshVipData)
end

--- 退出
function T:onExit()
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.vipPoint,self,self.refreshVipData)
    self.queue:clearT()
    self.queue = nil
end

--- 初始化上面
function T:initTop()
    -- 背景图片
    local topBackFrame = ResLoader:getSpriteFrame("vipBottomFrame.png")
    local topBackSize = topBackFrame:getOriginalSize()
    local topBack = Scale9Sprite:createWithFrame(topBackFrame,cc.rect(topBackSize.width/2,topBackSize.height/2,1,1))
    topBack:setContentSize(632,148)
	self:addChild(topBack)
    REL:toOther("center","top",topBack,self,0,0)

    -- vip图片
    local vipImg = ccui.ImageView:create()
    vipImg:loadTexture("vip.png",ccui.TextureResType.plistType)
    self:addChild(vipImg)
    REL:toOther("left","top",vipImg,topBack,20,25)

    -- vip等级:后面换成字体
--    local vipLevel = XMLLabel()
--    vipLevel:setContentSize(cc.size(150,36))
--    vipLevel:setVAlign("middle")
--    self:addChild(vipLevel)
--    REL:toOther("left","middle",vipLevel,vipImg,55,0)
--    self.vipLevel = vipLevel

    local vipLevel = ccui.TextBMFont:create(1,"res/images/activity/vipFont.fnt")
	self:addChild(vipLevel)
    REL:toOther("left","middle",vipLevel,vipImg,55,-8)
    self.vipLevel = vipLevel


    -- vip进度条
    local backImg = ccui.ImageView:create()
    backImg:loadTexture("vipBottomBack.png",ccui.TextureResType.plistType)
    self:addChild(backImg)
    REL:toOther("left","middle",backImg,vipImg,90,0)
    self.backImg = backImg

    local uiProgressFore = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("vipBottomBack2.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	backImg:addChild(uiProgressFore)
    REL:toOther("center","middle",uiProgressFore,backImg,0,0)
    self.uiProgressFore = uiProgressFore

    -- vip经验数字背景图片
    local vipDigitalImgFrame = ResLoader:getSpriteFrame("timeBack.png")
    local vipDigitalImgSize = vipDigitalImgFrame:getOriginalSize()
    local vipDigitalImg = Scale9Sprite:createWithFrame(vipDigitalImgFrame,cc.rect(vipDigitalImgSize.width/2,vipDigitalImgSize.height/2,1,1))
    vipDigitalImg:setContentSize(90,25)
	self:addChild(vipDigitalImg)
    REL:toOther("center","middle",vipDigitalImg,backImg,0,0)
    self.vipDigitalImg = vipDigitalImg

    -- vip数字
    local vipdigital = XMLLabel()
    vipdigital:setContentSize(cc.size(200,36))
    vipdigital:setAlign("center","middle")
    self:addChild(vipdigital)
    REL:toOther("center","middle",vipdigital,vipDigitalImg,0,0)
    self.vipdigital = vipdigital

	local LanguageUtils=require("src.app.utils.LanguageUtils")
    if LanguageUtils:getId() == cc.LANGUAGE_CHINESE or LanguageUtils:getId() == cc.LANGUAGE_CHINESE_HANT then
        -- vip描述1
	    local vipDescribe1 = XMLLabel()
	    vipDescribe1:setContentSize(cc.size(400,36))
	    vipDescribe1:setAlign("center","middle")
	    self:addChild(vipDescribe1)
	    REL:toOther("center","bottom",vipDescribe1,topBack,-80,40)
	    self.vipDescribe1 = vipDescribe1

	    -- vip描述2
	    local vipDescribe2 = XMLLabel()
	    vipDescribe2:setContentSize(cc.size(400,36))
	    vipDescribe2:setAlign("center","middle")
	    self:addChild(vipDescribe2)
	    REL:toOther("center","top",vipDescribe2,vipDescribe1,0,25)
	    vipDescribe2:setString(Language:get("uc474"))
	    self.vipDescribe2 = vipDescribe2

    else
        -- vip描述1
        local vipDescribe1 = XMLLabel()
        vipDescribe1:setContentSize(cc.size(400,36))
        vipDescribe1:setAlign("left","top")
        self:addChild(vipDescribe1)
        REL:toOther("left","top",vipDescribe1,topBack,20,60)
        self.vipDescribe1 = vipDescribe1

        vipDescribe1:updateView()
	    local contentHeight = vipDescribe1:getTextHeight()

        -- vip描述2
        local vipDescribe2 = XMLLabel()
        vipDescribe2:setContentSize(cc.size(400,36))
        vipDescribe2:setAlign("left","top")
        self:addChild(vipDescribe2)
        REL:toOther("left","top",vipDescribe2,vipDescribe1,0,contentHeight + 55)
        vipDescribe2:setString(Language:get("uc474"))
        self.vipDescribe2 = vipDescribe2

    end



    -- vip限购
    local checkVip = Button.new("false","true")
	checkVip:setButtonState("bigButton_purple_normal.png","bigButton_general_down.png")
	checkVip:setString(Language:get("uc503"))
	self:addChild(checkVip)
    REL:toOther("right","bottom",checkVip,topBack,10,10)
    checkVip:setTextCenter()
    checkVip:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            VipManager:switchIapWindow()
        end
    end)

    self:refreshVipData()
end


--- 刷新vip相关的数据
function T:refreshVipData()
    local vipLevel = UserInfo.vipLevel
    self.vipLevel:setString(vipLevel)

    local playerVipPoint = VipManager:getPlayerVipPoint()
    local allVipPoint = VipManager:getNextVipPoint()
    self.vipdigital:setString(Language:get("uc472",playerVipPoint,allVipPoint))
    if playerVipPoint < allVipPoint then
        self.uiProgressFore:setPercentage(playerVipPoint/allVipPoint * 100)
    else
        self.uiProgressFore:setPercentage(100)
    end
    
    -- 重新设置大小
    self.vipdigital:updateView()
    local width = self.vipdigital:getTextWidth()
    self.vipDigitalImg:setContentSize(width + 6,25)
    REL:toOther("center","middle",self.vipDigitalImg,self.backImg,0,0)
    REL:toOther("center","middle",self.vipdigital,self.vipDigitalImg,0,0)

    if vipLevel >= 12 then
        self.vipDescribe1:setVisible(false)
        self.vipDescribe2:setVisible(false)
    else
        self.vipDescribe1:setVisible(true)
        self.vipDescribe2:setVisible(true)
        self.vipDescribe1:setString(Language:get("uc473",allVipPoint - playerVipPoint,vipLevel + 1))
    end
end


--- 初始化下面
function T:initBottom()
    -- 背景图片
    local bottomBackFrame = ResLoader:getSpriteFrame("vipBack.png")
    local bottomBackSize = bottomBackFrame:getOriginalSize()
    local bottomBack = Scale9Sprite:createWithFrame(bottomBackFrame,cc.rect(bottomBackSize.width/2,bottomBackSize.height/2,1,1))
	self:addChild(bottomBack)
    REL:relOther(bottomBack,self,6,6,150,5)

    -- listview
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,bottomBack,0,0,0,0)
    self.listView = listView

    local num = #Vip
    for i = 0,num,1 do
        local info = {}
        info.sid = i
        info.data = Vip[i]
        self.queue:push(info)
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)


end

function T:addRes()
    local info = self.queue:pop()
    if info then
        local res = self.VIPItem.new(self.listView,info.sid,info.data)
        self.listView:pushBackCustomItem(res)
    else
        self:stopAllActions()
    end
end


return T