--- 仓库储备主窗口
local T = class(
	"T",
	function()
		local o = AbstractWindow.new()
		o.super = AbstractWindow
		return o
	end
)

--- 资源页面变量
T.resourcePage = nil

--- 建筑页面变量
T.buildPage = nil

--- 状态页面变量
T.statePage = nil


--- 构造函数
function T:ctor(tag)
	local function callBack1()
		self:resourceLogic()
	end

	local function callBack2()
		self:stateLogic()
	end

	local function callBack3()
		self:buildLogic()
	end

	if not tag or tag > 3 then -- add by yuding
		tag = 1
	end

	-- 创建3个
	local switchButtonContainer = SwitchButtonContainer.new()
	self:addChild(switchButtonContainer)
	REL:relOther(switchButtonContainer,self.uiContainer,0,0,0,0)
	switchButtonContainer:init()
	switchButtonContainer:initButtons(
		3,
		{{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"},{"viewSwitchButton2_normal.png","viewSwitchButton2_down.png"}},
		{70,15},
		{callBack1,callBack2,callBack3},
		{Language:get("uc26"),Language:get("uc118"),Language:get("uc27")},
		tag
	)
	self.switchButtonContainer = switchButtonContainer

	-- 初始化配置表
	self:init()

	-- 进入页面显示数据
	self:ShowData()

	-- 这个必须要先加载一次，不然位置要出错
	if tag == 1 then  -- add by yuding
		self:resourceLogic()
	elseif tag == 2 then
		self:stateLogic()
	elseif tag == 3 then
		self:buildLogic()
	end

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

--- 进入场景
function T:onEnter()
    self.super.onEnter(self)
	--AudioManager:playEffect(SoundRes.OPEN_WAREHOUSE)
end

function T:onExit()
    self.super.onExit(self)
end

--- 初始化数据
function T:init()
	-- 资源页面
	self.warehousestorageResource = require "src.app.uiScript.components.warehousestorage.resource.WarehousestorageResource"
	-- 建筑页面
	self.warehousestorageBuild = require "src.app.uiScript.components.warehousestorage.build.WarHouseBuild"
	-- 状态页面
	self.warehousestorageState = require "src.app.uiScript.components.warehousestorage.state.WarhouseState"
end

--- 进入页面显示数据
function T:ShowData()
	self:setWindowTitle(Language:get("uc119"))
end

--- 资源逻辑
function T:resourceLogic()
	if self.resourcePage == nil then
		self.resourcePage = self.warehousestorageResource.new()
		self:addChild(self.resourcePage)
		REL:relOther(self.resourcePage,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
		self.resourcePage:init()
	end

	if self.resourcePage then
		self.resourcePage:setVisible(true)
	end

	if self.buildPage then
		self.buildPage:setVisible(false)
	end

	if self.statePage then
		self.statePage:setVisible(false)
	end
end

--- 建筑逻辑
function T:buildLogic()
	if self.resourcePage then
		self.resourcePage:setVisible(false)
	end

	if self.buildPage == nil then
		self.buildPage = self.warehousestorageBuild.new()
		self:addChild(self.buildPage)
		REL:relOther(self.buildPage,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
		self.buildPage:init()
	end

	if self.buildPage then
		self.buildPage:setVisible(true)
	end

	if self.statePage then
		self.statePage:setVisible(false)
	end
end

--- 状态逻辑
function T:stateLogic()
	if self.resourcePage then
		self.resourcePage:setVisible(false)
	end

	if self.buildPage then
		self.buildPage:setVisible(false)
	end

	if self.statePage == nil then
		self.statePage = self.warehousestorageState.new()
		self:addChild(self.statePage)
		REL:relOther(self.statePage,self.uiContainer,0,0,CommonCfg.TOP_CONTAINER_HEIGHT,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
		self.statePage:init()
	end

	if self.statePage then
		self.statePage:setVisible(true)
	end
end

return T
