--[[
 *	建筑窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor()
    self.queue = Queue()

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
end

function T:init()
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,10,0,0,160)
    self.listView = listView

    --self:RefreshListView()
    self:addItem()
    self:addBottom()

end

--- 进入
function T:onEnter()
    --断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.RefreshListView)
end

--- 退出
function T:onExit()
	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.RefreshListView)
    
    self.queue:clearT()
    self.queue = nil
end

--- 添加到listview中去
function T:addItem()
--    -- 添加其它项
--    local tempList = {}
--    local buildInfos = BuildingsInfoMgr:getBuildingInfos()

--    local i = 1
--    for k,v in pairs(buildInfos) do 
--        if v then
--            tempList[i] = v
--            i = i + 1
--        end
--    end

--    -- 排序，等级小的在前面
--    table.sort(tempList,function(x,y) return x.level < y.level end)

--    local num = #tempList
--    for i = 1,num,1 do 
--        local res = require("src.app.uiScript.components.warehousestorage.build.WarHouseBuildItem").new(tempList[i],self) -- 传入的是建筑物的那一项
--        self.listView:pushBackCustomItem(res)
--    end

    -- 添加其它项
    local tempList = {}
    local buildInfos = BuildingsInfoMgr:getBuildingInfos()

    local i = 0
    for k,v in pairs(buildInfos) do 
        if v then
            i = i + 1
            tempList[i] = v
        end
    end

    -- 排序，等级小的在前面
    table.sort(tempList,function(x,y) return x.level < y.level end)

    local newList = {}
    -- 再遍历，升级（等级低的）排在前面
    local k = 1
    for j = 1,i,1 do
        local item = BuildingsInfoMgr:getBuildQueue()[tempList[j].id]
        if item then
            newList[k] = tempList[j]  
            tempList[j] = nil
            k = k + 1
        end
    end

    local m = #newList + 1
    for k,v in pairs(tempList) do 
        if v then
            newList[m] = v
            m = m + 1
        end
    end

    local num = #newList
    for n = 1,num,1 do
        if newList[n] then
            self.queue:push(newList[n])
        end
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)

end

function T:addRes()
    local data = self.queue:pop()
    if data then
        local res = require("src.app.uiScript.components.warehousestorage.build.WarHouseBuildItem").new(data,self) -- 传入的是建筑物的那一项
        self.listView:pushBackCustomItem(res)
        res:setOpacity(0)

        res:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end

--- 排序
function T:RefreshListView()
    self.listView:removeAllItems()

    -- 添加其它项
    local tempList = {}
    local buildInfos = BuildingsInfoMgr:getBuildingInfos()

    local i = 0
    for k,v in pairs(buildInfos) do 
        if v then
            i = i + 1
            tempList[i] = v
        end
    end

    -- 排序，等级小的在前面
    table.sort(tempList,function(x,y) return x.level < y.level end)

    local newList = {}
    -- 再遍历，升级（等级低的）排在前面
    local k = 1
    for j = 1,i,1 do
        local item = BuildingsInfoMgr:getBuildQueue()[tempList[j].id]
        if item then
            newList[k] = tempList[j]  
            tempList[j] = nil
            k = k + 1
        end
    end

    local m = #newList + 1
    for k,v in pairs(tempList) do 
        if v then
            newList[m] = v
            m = m + 1
        end
    end

    local num = #newList
    for n = 1,num,1 do 
        local res = require("src.app.uiScript.components.warehousestorage.build.WarHouseBuildItem").new(newList[n],self) -- 传入的是建筑物的那一项
        self.listView:pushBackCustomItem(res)
    end
end


--- 添加底部项
function T:addBottom()
    local bottom = require("src.app.uiScript.components.warehousestorage.build.WarHouseBuildBottom").new()
    self:addChild(bottom)
    local size = self.listView:getContentSize()
    bottom:setContentSize(cc.size(640,150))
    REL:toOther("center","top",bottom,self.listView,0,size.height + 10)
    bottom:init()
end


return T