--[[
 *	建筑底部购买项
]]
local T = class("T",function() return ccui.Layout:create() end)


--- 构造函数
function T:ctor()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )


end

function T:init()
    -- 背景图片
    local backFrame = ResLoader:getSpriteFrame("generalItemBack.png")
    local back = Scale9Sprite:createWithFrame(backFrame)
	self:addChild(back)
    REL:relOther(back,self,8,15,0,0)

    -- lightBack
    local lightBack = ccui.ImageView:create()
    lightBack:loadTexture("lightBack.png",ccui.TextureResType.plistType)
    self:addChild(lightBack)
    REL:toOther("left","top",lightBack,back,10,5)

    -- icon
    local icon = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    icon:loadTexture("barOfBldList.png",ccui.TextureResType.plistType)

    self:addChild(icon)
    REL:toOther("left","top",icon,lightBack,4,4)


    -- 从左到右的位置表,left,top离lightBack
    local pos = {{90,12},{90 + 55,12},{90 + 55*2,12},{90 + 55*3,12},{90 + 55*4,12},{375,12},{375 + 55,12},{375 + 55*2,12}}
    self.res = {}
    for i = 1,8,1 do
        local lightLock = ccui.ImageView:create()
        lightLock:loadTexture("lightLock.png",ccui.TextureResType.plistType)
        self:addChild(lightLock)
        REL:toOther("left","top",lightLock,lightBack,pos[i][1],pos[i][2])
        self.res[#self.res + 1] = lightLock
    end

    -- 购买按钮
    local btn = Button.new("false","true")
	btn:setButtonState("bigButton_purple_normal.png","bigButton_general_down.png")
	btn:setString(Language:get("uc512"))
	self:addChild(btn)
	REL:toOther("right","bottom",btn,back,20,20)
    btn:setTextCenter()
	self.btn = btn
    btn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.tag == 1 then -- 购买
                local buildQueueNumState = SetStates.buildQueueNumState
                local cost = buildQueueNumState:getCost()

                local function confirm()
                    local gems = UserInfo.gems
                    if gems >= cost then
                        local function finish()
                            self:refreshData()
                            local descripe = Language:get("uc532")
		                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                        end
                        BuildingCommand:BuyBuildQueue(finish)
                    else
                        MUIPop.MUIToReCharge()
                    end
                end

                MUIPop.MUIImmediate(Language:get("uc515",cost),confirm)

            elseif self.tag == 2 then -- 转向vip界面
                local describe1 = Language:get("uc323",UserInfo.vipLevel)
                local describe2 = Language:get("uc324",UserInfo.vipLevel,PlayerInstance:getVipBuildQueueCount())
                local describe3 = Language:get("uc325")

                local layout = VipTipsInfo.new(describe1,describe2,describe3)

                MUIAlter.show(
                    {
                        info = layout,
                        size = 30,
                        flag = 1,
                        isShowCloseButton = true,
                        triggerCloseMethod = "buttons",
                        confirmText = Language:get("uc332"),
                        callback = function(flag) -- 转到vip界面
                            if flag == 0 then
                                WindowManager:push(
		                            require("src.app.uiScript.components.vip.VIPWindow").new()
	                            )
                            end

                        end
                    }
                )


            end
        end
    end)

    self:refreshData()


    -- 添加点击弹出信息
    local left = ccui.Layout:create()
    self:addChild(left)
    REL:relOther(left,lightBack,80,554-355,10,40)
    left:setTouchEnabled(true)
    left:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local vipBuildQueueCount = PlayerInstance:getVipBuildQueueCount()
            if vipBuildQueueCount >= 2 then
                vipBuildQueueCount = 2
            end
            local buildQueueNumState = SetStates.buildQueueNumState
            local buyCount = buildQueueNumState:getBuildQueueNum()


            local descripe = Language:get("uc517",vipBuildQueueCount + buyCount,3 - buyCount)
		    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
        end
    end)

    local right = ccui.Layout:create()
    self:addChild(right)
    right:setTouchEnabled(true)
    REL:relOther(right,lightBack,375,5,10,40)
    right:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local vipBuildQueueCount = PlayerInstance:getVipBuildQueueCount()
            if vipBuildQueueCount > 2 then
                vipBuildQueueCount = vipBuildQueueCount - 2
            else
                vipBuildQueueCount = 0
            end

            local descripe = Language:get("uc518",vipBuildQueueCount)
		    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
        end
    end)
    
end

--- 进入
function T:onEnter()
    BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_START_LEVEL_UP,self,self.refreshData)
    BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_CANCEL_LEVEL_UP,self,self.refreshData)
    BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE,self,self.refreshData)

    local buildQueueNumState = SetStates.buildQueueNumState
    buildQueueNumState:luaAddEventListener(buildQueueNumState.EVT_BUY_BUILD_QUEUE_REFRESH,self,self.refreshData)
end

--- 退出
function T:onExit()
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_START_LEVEL_UP,self,self.refreshData)
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_CANCEL_LEVEL_UP,self,self.refreshData)
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE,self,self.refreshData)

    local buildQueueNumState = SetStates.buildQueueNumState
    buildQueueNumState:luaRemoveEventListener(buildQueueNumState.EVT_BUY_BUILD_QUEUE_REFRESH,self,self.refreshData)
end


function T:refreshData()
    local buildQueueNumState = SetStates.buildQueueNumState

    -- 先解锁和未解锁的
	local vipBuildQueueCount = PlayerInstance:getVipBuildQueueCount()
    local buyCount = buildQueueNumState:getBuildQueueNum()
    local res = self.res
    for i = 1,8,1 do
        if i == 3 or i == 4 or i == 5 then
            if buyCount == 0 then 
                res[i]:loadTexture("lightLock.png",ccui.TextureResType.plistType)
                res[i].tag = 0
            else
                res[i]:loadTexture("lightBusy.png",ccui.TextureResType.plistType)
                res[i].tag = 1
                buyCount = buyCount - 1
            end
        else
            if vipBuildQueueCount == 0 then
                res[i]:loadTexture("lightLock.png",ccui.TextureResType.plistType)
                res[i].tag = 0
            else
                res[i]:loadTexture("lightBusy.png",ccui.TextureResType.plistType)
                res[i].tag = 1
                vipBuildQueueCount = vipBuildQueueCount - 1
            end
        end
    end


	local buildingQueue = BuildingsInfoMgr:getBuildQueue()
	local i = 0
	for k,v in pairs(buildingQueue) do
		if v then
			i = i + 1 -- i是代表几个正在使用
		end
	end

    for j = 1,8,1 do
        if res[j].tag == 1 and i > 0 then -- 表示可以使用的队列位置
            res[j]:loadTexture("lightFree.png",ccui.TextureResType.plistType)
            i = i - 1
        end
    end


    --- 设置按钮
    local vipBuildQueueCount = PlayerInstance:getVipBuildQueueCount()
    local buyCount = buildQueueNumState:getBuildQueueNum()
    local i = 0
	for k,v in pairs(buildingQueue) do
		if v then
			i = i + 1 -- i是代表几个正在使用
		end
	end

    self.btn:setVisible(true)
    if buildQueueNumState:judgeIsBuy() then
        self.tag = 1
        self.btn:loadTextures("bigButton_purple_normal.png", "bigButton_general_down.png", "",ccui.TextureResType.plistType)
        self.btn:setString(Language:get("uc512"))
    else
        if vipBuildQueueCount + buyCount < 8 then
            self.tag = 2
            self.btn:loadTextures("bigButton_yellow_normal.png", "bigButton_general_down.png", "",ccui.TextureResType.plistType)
            self.btn:setString(Language:get("uc513"))
        else
            self.tag = 0
            self.btn:setVisible(false)
        end
    end

end


return T