--[[
 *	建筑窗口:这个免费到时再加上就ok了
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 建筑物的项数据
T.buildInfo = nil

--- 升级或者加速标志： 1是升级，2是加速
T.upTag = 1

--- 信息或者取消的标志： 1是信息，2是取消
T.infoTag = 1


--- 构造函数
function T:ctor(buildInfo,parent)
    self.buildInfo = buildInfo
    self.parent = parent

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    -- 设置项
    local _widget = ListItem4.new()
    self.size = _widget:getContentSize()
    self:setContentSize(self.size)
    _widget:setListItemAttribute(
        "H",
        {"label","label"},
        {{"infoButton_normal.png","iconButton_general_down.png","false","false"},{"upgrade.png","upgrade.png","false","false"}}
    )
    self:addChild(_widget)
    REL:toOther("left","top",_widget,self,0,0)
    self._widget = _widget

    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
    -- 按钮回调设置
    self:SetButton()
end

function T:onEnter()
    -- 时间的检测
    local item = BuildingsInfoMgr:getBuildQueue()[self.buildInfo.id]  -- 判断当前的建筑物是否在升级建筑物的队列中
    if item then  --立即刷新，因为添加侦听会下一步执行
        if item.remainingSec and item.remainingSec > 0 then    --升级过程
--            -- 立刻按钮变了
--            self._btnImmediaUp:loadTextures("canelButton_normal.png","bigButton_general_down.png","",ccui.TextureResType.plistType)
--            self._btnImmediaUp:setPicVisible(false)
--            self._btnImmediaUp:setTextVisible(false)

            self:ImmediateChange()
            self:AddProgressBar()
            self:enterChange(item)
            self:RefreshUpGradeData(item)
            self:UpgradeHandle()
        end
    end


    self:addEventListener()

    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaAddEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)

    CommonBroadcast:luaAddEventListener("build_queue_pop_window_finish" .. self.buildInfo.location,self,self.buildQueuePopFinish)


end

--- 进入的时候调整
function T:enterChange(item)
    local time = item.remainingSec
    self._widget:setString(self._labelTime,UnitConversion.handleTime4(time))

    local buildInfo = self.buildInfo
    local ModelResTable = PlayerInstance:getBuildingResTable(buildInfo.sid)
    local allTime = ModelResTable[buildInfo.level].upgradeTime
    allTime = BuildingDiamondCalculation:BuildConstructActualTime(allTime)
    self.loadingBar:setPercentage((allTime - time)/allTime*100) --初始值
end

function T:onExit()
    self:removeEventListener()

    local rapidDevelopmentInfo = ActivityManager.rapidDevelopmentInfo
    rapidDevelopmentInfo:luaRemoveEventListener(rapidDevelopmentInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. rapidDevelopmentInfo:getSid(),self,self.showActivityTime)


    CommonBroadcast:luaRemoveEventListener("build_queue_pop_window_finish" .. self.buildInfo.location,self,self.buildQueuePopFinish)


end


--- 添加监听
function T:addEventListener()
    -- 等级监听
    local function levelUpdate()      
        self:UpGradeFinish()
        local data = Build_temp[self.buildInfo.sid]
        local level = self.buildInfo.level 
--        local descripe = Language:get("uc12",Language:get(data.name),level)
--        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

        if self.buildInfo.level == 60 then       
           self._btnInfo:setVisible(false)
           self._btnUpgrade:setVisible(false)
        end

        self:buildEff()

        self.parent:RefreshListView()

    end
    self.levelUpdate = levelUpdate
    PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.buildInfo.location,nil,levelUpdate)

    -- 监听指挥中心的等级
    local function command()
        if self.buildInfo.location ~= 1 then
            local level = self.buildInfo.level
            local comandLevel = BuildingsInfoMgr:getBuildingInfos()[1].level
            if level >= comandLevel then
                self._btnUpgrade:setIsGray(true)
                --self._btnUpgrade:setTouchEnabled(false)
            else
                self._btnUpgrade:setIsGray(false)
                --self._btnUpgrade:setTouchEnabled(true)
            end 

        end
    end 
    self.command = command
    PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. 1,nil,command)

    -- 监听玩家所拥有的资源是否足够刷新显示,升级过程中不处理
    local function resoure()
        if self.infoTag == 1 then  -- 表示不在升级中
            self:RefreshData1()
        end
    end
    self.resoure = resoure
    ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,nil,resoure)
end

function T:buildEff()  -- 这个特性没播放出来
    local uiSp = cc.Sprite:create()
    self:addChild(uiSp)
	REL:toOther("center", "middle", uiSp, self._imgHead, 0, 12)

	local animation = ResLoader:getAnimation("upGradeEff")
	if animation then
        uiSp:runAction(
            cc.Sequence:create(
		        cc.Animate:create(animation),
		        cc.CallFunc:create( function()
			        uiSp:removeFromParent()

		        end)
		    )
	    )
	end



end

--- 移除监听
function T:removeEventListener()
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. self.buildInfo.location,nil,self.levelUpdate)
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.buildInfo.id,nil,self.update)
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. 1,nil,self.command)
    ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH,nil,self.resoure)
end

function T:GetWidget()
    -- 头像
    self._imgHead = self._widget.leftHead

    -- 信息或者取消
    self._btnInfo = self._widget.button1
    self._btnInfo:setName("Button_info")

    -- 升级或者加速
    self._btnUpgrade = self._widget.button2
    self._btnUpgrade:setName("Button_upgrade")

    -- 名字(创建富文本)
    self._labelName = self._widget.title

    -- 时间(创建富文本)
    self._labelTime = self._widget:getLabel(1)

    -- 消耗钻石
    local labelCostDiamond = XMLLabel()
    labelCostDiamond:setHAlign("center")
    labelCostDiamond:setVAlign("middle")
    labelCostDiamond:setContentSize(cc.size(300, 27))
    self._btnUpgrade:addChild(labelCostDiamond)
    self._labelCostDiamond = labelCostDiamond

    -- 免费时间显示
    self.vipFree = self._widget:getLabel(2)
    REL:toOther("left","top",self.vipFree,self._widget.back,130,95)

    -- 有活动的时候原来的时间
    local activivityTime = XMLLabel()
    activivityTime:setAlign("center","middle")
    activivityTime:setContentSize(cc.size(400,36))
    self:addChild(activivityTime)
    REL:toOther("center","middle",activivityTime,self._widget.back,0,-10)
    self.activivityTime = activivityTime

    local layer = CommonMethod:drawLine(50,50)
    activivityTime:addChild(layer)
    REL:toOther("center","middle",layer,activivityTime,0,0)
    activivityTime.layer = layer
end

function T:SetData()
    -- 不变的
    local data = Build_temp[self.buildInfo.sid]
    local iconPath = IconManager.iconPath
    self._widget:iconLoadTexture(iconPath .. data.icon)

    -- 要变的
    self:RefreshData1()
end

--- 升级过后根据等级更新数据显示
function T:RefreshData1()
    self.vipFree:setVisible(false)

    local buildInfo = self.buildInfo
    local data = Build_temp[buildInfo.sid]
    local ModelResTable = PlayerInstance:getBuildingResTable(buildInfo.sid)

    local location = buildInfo.location
    if location == 2 then
        self._widget:setString(self._labelName,Language:get("uc24",Language:get("uc150"),buildInfo.level))
    elseif location == 3 then
        self._widget:setString(self._labelName,Language:get("uc24",Language:get("uc151"),buildInfo.level))
    elseif location == 6 then
        self._widget:setString(self._labelName,Language:get("uc24",Language:get("uc148"),buildInfo.level))
    elseif location== 7 then
        self._widget:setString(self._labelName,Language:get("uc24",Language:get("uc149"),buildInfo.level))
    else
        self._widget:setString(self._labelName,Language:get("uc24",Language:get(data.name),buildInfo.level))
    end

    local time = ModelResTable[buildInfo.level].upgradeTime
    self:showActivityTime(BuildingDiamondCalculation:BuildConstructActualTimeNoActivity(time))
    time = BuildingDiamondCalculation:BuildConstructActualTime(time)
    self:showVipTime(time)


    self._widget:setString(self._labelTime,Language:get("uc172",UnitConversion.handleTime4(time)))
    -- 设置相对位置
    REL:toOther("left","top",self._labelTime,self._widget.back,130,60)
    self._btnInfo:loadTextures("infoButton_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
    REL:toOther("right", "bottom", self._btnInfo, self._widget.back, 15 + 80,8)
    -- 先要判断资源是否足够
    self._btnUpgrade:loadTextures("upgrade.png","upgrade.png","",ccui.TextureResType.plistType)
    self._btnUpgrade:setIsGray(false)  -- 本来要这么设置的
    --self._btnUpgrade:setTouchEnabled(true)

    local resTable = nil
    local allDiamond = 0

    resTable,allDiamond = BuildingDiamondCalculation.JudgeResIsEnough(buildInfo,ModelResTable)
    if allDiamond > 0 then -- 表示资源不够了
        self._btnUpgrade:setIsGray(true)
        --self._btnUpgrade:setTouchEnabled(true)
    end
    -- 然后判断判断建筑物是否可以点击,指挥中心除外
    if buildInfo.location ~= 1 then
        local level = buildInfo.level
        local comandLevel = BuildingsInfoMgr:getBuildingInfos()[1].level
        if level >= comandLevel then
            self._btnUpgrade:setIsGray(true)
            --self._btnUpgrade:setTouchEnabled(false)
        end
    end

    self._labelCostDiamond:setVisible(false)

    self.upTag = 1
    self.infoTag = 1

end

function T:showActivityTime(time)
    if not time then
        return
    end

    self.activivityTime:setString(UnitConversion.handleTime4(time))

    local judge = false
    -- 时间的检测
    local item = BuildingsInfoMgr:getBuildQueue()[self.buildInfo.id]  -- 判断当前的建筑物是否在升级建筑物的队列中
    if item then
        if item.remainingSec and item.remainingSec > 0 then    --升级过程
            judge = false
        else
            judge = true
        end
    else
        judge = true
    end

    if judge == true then -- 不在升级的过程中
        if ActivityManager.rapidDevelopmentInfo:getOpenValue() == true then
            self.activivityTime:setVisible(true)
	        self.activivityTime:updateView()
	        local contentWidth = self.activivityTime:getTextWidth()
	        local contentHeight = self.activivityTime:getTextHeight()
            local draw = self.activivityTime.layer.draw
            if draw then
                draw:clear()
                draw:drawSegment(cc.p(-(contentWidth/2),contentHeight/2), cc.p(contentWidth/2, -contentHeight/2), 1.5, cc.c4f(1, 0, 0, 1))
            end


        else
            self.activivityTime:setVisible(false)
        end
    else
        self.activivityTime:setVisible(false)
    end

end


function T:showVipTime(time)
    -- 是否显示vipFreeTime
    local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()
    if vipFreeTime >= time then
        self.vipFree:setString(Language:get("uc533"))
        self.vipFree:setVisible(true)
    else
        self.vipFree:setVisible(false)
    end
end


function T:SetButton()

    if self.buildInfo.level == 60 then       
       self._btnInfo:setVisible(false)
       self._btnUpgrade:setVisible(false)
    end

    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            local name = sender:getName()
            if name == "Button_info" then  
                if self.infoTag == 1 then
                    self:InfoLogic()
                else
                    self:CancleUpGradeLogic()
                end             
            elseif name == "Button_upgrade" then         
                if self.upTag == 1 then
                    if self.buildInfo.location ~= 1 then
                        local level = self.buildInfo.level
                        local comandLevel = BuildingsInfoMgr:getBuildingInfos()[1].level
                        if level >= comandLevel then
                            local info = Language:get("uc233")
				            local function confirm()
					            local tempWindow = require("src.app.uiScript.components.building.BuildingWindow").new(BuildingsInfoMgr:getBuildingInfos()[1])
					            WindowManager:switch(tempWindow)
				            end
				            MUIPop.MUIImmediate(info,confirm)
				            return
                        end
                    end

                    self:UpGradeLogic()
                elseif self.upTag == 2 then
                    self:SpeedUpGradeLogic()
                else 
                    -- 免费
                    BuildingCommand:SpeedUpGradeFreeLogic(self.buildInfo)

                end             
            end
        end
     end
    self._btnInfo:addTouchEventListener(callback)
    self._btnUpgrade:addTouchEventListener(callback)
end

--- 信息提示逻辑
function T:InfoLogic()
    local buildInfo = self.buildInfo
    local level = buildInfo.level
    local modelResTable = PlayerInstance:getBuildingResTable(buildInfo.sid)
    local resView = nil
    local layout = ccui.Layout:create()
    if level < 70 then
        if buildInfo.location == 1 then
            resView = ResView.new(3)  -- 3是资源项目的数目
            layout:addChild(resView)
            layout:setContentSize(cc.size(550,250))

            local needResTable = modelResTable[level].need

            resView:addResItem(nil,needResTable,nil)

            REL:toOther("center","middle",resView,layout,0,-25)
        else
            resView = ResView.new(4)  -- 1+3是资源项目的数目
            layout:addChild(resView)
            layout:setContentSize(cc.size(550,300))

            local needResTable = modelResTable[level].need
            
            local name = Language:get("uc186")
            local nowLevel = BuildingsInfoMgr:getBuildingInfos()[1].level
            local iconUrl = IconManager.iconPath .. Build_temp[1].icon

            resView:addResItem({["iconUrl"] = iconUrl,["name"] = name,["needLevel"] = level + 1,["nowLevel"] = nowLevel },needResTable,nil)

            REL:toOther("center","middle",resView,layout,0,0)
        end

    end

    if resView then
        resView.needListBack:setVisible(false)
        
        MUIAlter_noTitle.show(
            {
                info = layout,
                flag = 4
            }
        )
    end
end

--- 取消逻辑
function T:CancleUpGradeLogic()
    local info = Language:get("uc280") .. Language:get("uc946")
    local function confirm()
        local function finish()
            self:UpGradeFinish()
            self.parent:RefreshListView()
        end
        local ModelResTable = PlayerInstance:getBuildingResTable(self.buildInfo.sid)
        BuildingCommand.CancleUpGradeLogic(self.buildInfo,ModelResTable,finish)
    end
    MUIPop.MUIImmediate(info,confirm)
end


function T:buildQueuePopFinish()
    self:UpGradeLogic()


end



--- 升级逻辑
function T:UpGradeLogic()
    -- 首先判断vip等级最多可以建造的数量
    local buildQueueNumState = SetStates.buildQueueNumState
    local buyCount = buildQueueNumState:getBuildQueueNum()

    local buildQueueCount = PlayerInstance:getVipBuildQueueCount()
    local buildingQueue = BuildingsInfoMgr:getBuildQueue()
    local i = 0
    for k,v in pairs(buildingQueue) do
        if v then
            i = i + 1
        end
    end
    if i >= buildQueueCount + buyCount then  -- 建造队列已满

        if buildQueueNumState:judgeIsBuy() then
            local ModelResTable = PlayerInstance:getBuildingResTable(self.buildInfo.sid)
            local layout = require("src.app.uiScript.components.share.BuildQueuePopWindow").new(buyCount,buildQueueCount,ModelResTable,self.buildInfo.location)
            local muialter = MUIAlter.show(
                    {
                        info = layout,
                        title = Language:get("uc1064"),
                        size = 30,
                        flag = 4,
                        isShowCloseButton = true
                    }
                )

            layout:setMuialter(muialter)

--            local cost = buildQueueNumState:getCost()
--            local function confirm()
--                local gems = UserInfo.gems
--                if gems >= cost then
--                    local function finish()
--                        local descripe = Language:get("uc532")
--		                MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
--                    end
--                    BuildingCommand:BuyBuildQueue(finish)
--                else
--                    MUIPop.MUIToReCharge()
--                end
--            end

--            local describe = Language:get("uc1012",buyCount,3 - buyCount,UserInfo.vipLevel,buildQueueCount)

--            local layout = ccui.Layout:create()
--            layout:setContentSize(cc.size(524,300))

--            local des = XMLLabel()
--            des:setVAlign("middle")
--            des:setContentSize(cc.size(450,36))
--            layout:addChild(des)
--            REL:toOther("left","middle",des,layout,30,20)
--            des:setString(Language:get("uc558",cost) .. "<br/>" .. describe)

--            MUIAlter.show(
--                    {
--                        info = layout,
--                        size = 30,
--                        flag = 3,
--                        callback = function(flag)
--                            if flag == 0 then
--                                confirm()
--                            end

--                        end
--                    }
--                )

        else
            if i == 8 then
                MUIPop.buildQueueFull()
            else
                local describe1 = Language:get("uc323",UserInfo.vipLevel)
                local describe2 = Language:get("uc324",UserInfo.vipLevel,buildQueueCount)
                local describe3 = Language:get("uc325")

                local layout = VipTipsInfo.new(describe1,describe2,describe3)

                MUIAlter.show(
                    {
                        info = layout,
                        size = 30,
                        flag = 1,
                        confirmText = Language:get("uc332"),
                        triggerCloseMethod = "buttons",
                        isShowCloseButton = true,
                        callback = function(flag) -- 转到vip界面
                            if flag == 0 then
                                WindowManager:push(
		                            require("src.app.uiScript.components.vip.VIPWindow").new()
	                            )
                            end

                        end
                    }
                )
            end
            
        end

        return
    end


    local buildInfo = self.buildInfo
    local level = buildInfo.level
    if level >= 70 then
        return
    end

    local resTable = {}
    local allDiamond = 0

    local ModelResTable = PlayerInstance:getBuildingResTable(buildInfo.sid)

    -- 先要判断资源是否足够
    resTable,allDiamond = BuildingDiamondCalculation.JudgeResIsEnough(buildInfo,ModelResTable)
    local function confirm()
        self:SupplyDiomand(resTable,allDiamond)
    end

    local info = Language:get("uc562",allDiamond)
    if allDiamond > 0 then
        MUIPop.MUIImmediate(info,confirm)
        return
    end


    -- 下面是资源足够的情况
    local function finish()
        self:AddProgressBar() -- 添加进度条
        local item = BuildingsInfoMgr:getBuildQueue()[buildInfo.id]
        self:ImmediateChange()
        self:RefreshUpGradeData(item) -- 立即刷新数据
        self:UpgradeHandle() -- 添加升级处理
        self.parent:RefreshListView()
    end
    
    BuildingCommand.UpGradeNoDiamond(buildInfo,ModelResTable,finish)
end

--- 补足钻石完成普通升级逻辑
function T:SupplyDiomand(resTable,allDiamond)
    local function finish()
        self:AddProgressBar() -- 添加进度条
        local item = BuildingsInfoMgr:getBuildQueue()[self.buildInfo.id]
        self:ImmediateChange()
        self:RefreshUpGradeData(item) -- 立即刷新数据
        self:UpgradeHandle() -- 添加升级处理
        self.parent:RefreshListView()

    end
    local ModelResTable = PlayerInstance:getBuildingResTable(self.buildInfo.sid)
    BuildingCommand.UpGradeHasDiamond(self.buildInfo,ModelResTable,resTable,finish,allDiamond)
end

--- 加速逻辑
function T:SpeedUpGradeLogic()
    local payState = SetStates.setPayState
    local value = payState:getClosedValue(payState.CLOSE_BUILD_SPEED)

    
    if value then
        local newItem = BuildingsInfoMgr:getBuildQueue()[self.buildInfo.id]  -- 检测，防止用户点击了加速按钮后，不点击，然而升级还在进行中
        if newItem then
            BuildingCommand.SpeedUpGradeLogic(self.buildInfo)
        else
            MUIPop.UpGradeSuccessNotClick()
        end
    else
        local item = BuildingsInfoMgr:getBuildQueue()[self.buildInfo.id]
        local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
        local info = Language:get("uc563",allDiamond)
        local layout = DiamondPopInfo.new(info)
        local function confirm()
            local newItem = BuildingsInfoMgr:getBuildQueue()[self.buildInfo.id]  -- 检测，防止用户点击了加速按钮后，不点击，然而升级还在进行中
            if newItem then
                SetStates.setPayState:setClosedValue(layout.judge,SetStates.setPayState.CLOSE_BUILD_SPEED)
                if layout.judge == true then
                    Command:SetPayCommand()
                end

                BuildingCommand.SpeedUpGradeLogic(self.buildInfo)
            else
                MUIPop.UpGradeSuccessNotClick()
            end
        
        end
        MUIPop.DiamondPopInfo(layout,confirm)
    end
end


--- 每帧刷新数据
function T:RefreshUpGradeData(item)
    self.vipFree:setVisible(false)
    self.activivityTime:setVisible(false)

    local time = item.remainingSec
    self._widget:setString(self._labelTime,UnitConversion.handleTime4(time))

    local buildInfo = self.buildInfo
    local ModelResTable = PlayerInstance:getBuildingResTable(buildInfo.sid)
    local allTime = ModelResTable[buildInfo.level].upgradeTime
    allTime = BuildingDiamondCalculation:BuildConstructActualTime(allTime)

    --self.loadingBar:setPercent((allTime - time)/allTime*100)
    local lastPer = self.loadingBar:getPercentage()
    local newPer = (allTime - time)/allTime*100
    self.loadingBar:runAction(cc.ProgressFromTo:create(0.2,lastPer,newPer))


    local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()
    if time <= vipFreeTime then  -- 免费的
        self._btnUpgrade:loadTextures("speeButton_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
        self._labelCostDiamond:setString(Language:get("uc498"))
        --REL:toOther("center", "middle", self._labelCostDiamond, self._btnUpgrade, -34, 4)

        self._btnUpgrade:setPosition(cc.p(532,51.5))
        self._labelCostDiamond:setVisible(true)
        self._labelCostDiamond:setPosition(cc.p(-111,45))

        self.upTag = 3
    else
        self._btnUpgrade:loadTextures("addSpeedButton_normal.png","addSpeedButton_normal.png","",ccui.TextureResType.plistType)
--        REL:toOther("right", "bottom", self._btnUpgrade, self._widget.back, 15,0)
--        REL:toOther("center", "middle", self._labelCostDiamond, self._btnUpgrade, -34, 4)
        self._btnUpgrade:setPosition(cc.p(532,51.5))
        self._labelCostDiamond:setPosition(cc.p(-111,45))
        -- 显示钻石
        self._labelCostDiamond:setVisible(true)
        local allDiamond = BuildingDiamondCalculation.FreeTimeGetSpeedFinishDiamond(item)
        self._labelCostDiamond:setString(Language:get("uc111",allDiamond))

        self.upTag = 2
    end

end

--- 普通升级处理函数
function T:UpgradeHandle()
    -- 每帧检测回调
    local function update(buildItem)
        if buildItem.remainingSec and buildItem.remainingSec <= 0 then    --升级完成
        else
            self:RefreshUpGradeData(buildItem) -- 处理每帧变化的数据
        end
    end
    self.update = update
    BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.buildInfo.id,nil,update)
end

--- 立即改变的数据
function T:ImmediateChange()
    -- 设置相对位置
    REL:toOther("left","top",self._labelTime,self._widget.back,150,85)

    self._btnInfo:loadTextures("canelButton2_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
    self._btnInfo:setPosition(cc.p(425.5,54.5))

    self._btnUpgrade:setIsGray(false)

    self.infoTag = 2

    self.activivityTime:setVisible(false)
end

--- 添加进度条
function T:AddProgressBar()
    -- 背景图片:到时移除的时候把这张图片移除就行了，并且2个变量设置为nil
    local backImg = ccui.ImageView:create()
    backImg:loadTexture("productProgressBack.png",ccui.TextureResType.plistType)
    --self._widget:addChild(backImg)
    self._widget.back:addChild(backImg)
    --REL:toOther("left","top",backImg,self._widget.back,120,45)
    backImg:setPosition(cc.p(242.5,70))
    self.backImg = backImg

    -- 进度条图片
--    local loadingBar = ccui.LoadingBar:create()
--    loadingBar:loadTexture("productProgressFore.png",ccui.TextureResType.plistType)
--    loadingBar:setPercent(0)
--    backImg:addChild(loadingBar)
--    REL:toOther("center","middle",loadingBar,backImg,0,0)
--    self.loadingBar = loadingBar

    local uiProgressFore = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("productProgressFore.png")))
	uiProgressFore:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiProgressFore:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiProgressFore:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiProgressFore:setPercentage(0)--初始值
	backImg:addChild(uiProgressFore)
    --REL:toOther("center","middle",uiProgressFore,backImg,0,0)
    uiProgressFore:setPosition(cc.p(122.5,14))
    self.loadingBar = uiProgressFore


    -- 免费时间点图片,总宽度245
    local freeImg = ccui.ImageView:create()
    freeImg:loadTexture("allianceLabel_friendly.png",ccui.TextureResType.plistType)
    backImg:addChild(freeImg)
    local pos = freeImg:getPosition()
    --backImg:setPosition(cc.p(242.5,70))
    self.freeImg = freeImg

    freeImg:setVisible(false)

    local vipFreeTime = BuildingDiamondCalculation.GetVipFreeTime()

    local ModelResTable = PlayerInstance:getBuildingResTable(self.buildInfo.sid)
    local time = ModelResTable[self.buildInfo.level].upgradeTime
    time = BuildingDiamondCalculation:BuildConstructActualTime(time)

    local pos = 0
    if vipFreeTime < time then
       pos = 245 - vipFreeTime/time * 245
    end
    REL:toOther("left","top",freeImg,backImg,pos,0)

end

--- 移除进度条
function T:RemoveProgressBar()
    if self.backImg ~= nil then
        self.backImg:removeFromParent()
        self.backImg = nil
        self.loadingBar = nil
        self.freeImg = nil
    end
end

--- 升级完成数据刷新
function T:UpGradeFinish()
    self:RefreshData1()
    self:RemoveProgressBar()
    BuildingsInfoMgr:remvoeQueueItem(self.buildInfo.id)
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME..self.buildInfo.id,nil,self.update)
end


return T