--[[
 *	资源中的每一项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- list（资源的sid）的sid
T.resSid = nil

--- 这个窗口的大小
T.size = nil

--- node(是项的父节点，也是listview的孩子)
T.node = nil

--- 每一种资源所对应的道具列表
T.propList = {}

--- 打开的页面
T.resourceListOpen = require "src.app.uiScript.components.warehousestorage.resource.ResourceListOpen"

--- 构造函数
function T:ctor(sid,node)
    self.resSid = sid
    self.node = node

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
                self:cleanUp()
            end
        end
    )

    local _widget = ListItem4.new()
    self.size = _widget:getContentSize()
    self:setContentSize(self.size)
    _widget:setListItemAttribute(
        "V",
        {"progress","label"},
        {{"scaleOut_normal.png","iconButton_general_down.png","false","false"}}
    )
    self:addChild(_widget)
    REL:toOther("left","top",_widget,self,0,0)

    self._widget = _widget

    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
    -- 按钮回调设置
    self:SetButton()
    -- 添加展开事件处理
    self:AddListItem()

    self:CheckBuffActived()
end

function T:onEnter()
    --self:CheckBuffActived() -- 暂时不管，这里这个资源项切换的时候必须移除，不然监听不到
    
    --断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.RefreshData1)
end

function T:onExit()
	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.RefreshData1)

    self:RemoveBuff()
end

function T:cleanUp()
    
end

function T:GetWidget()
    -- 资源头像
    self._imgHead = self._widget.leftHead
    -- 展开按钮
    self._btnOpen = self._widget.button1

    -- 名字(创建富文本)
    self._labelName = self._widget.title

    -- 产能(创建富文本)
    self._labelOutput = self._widget:getLabel(2)
    self._labelOutput:setContentSize(cc.size(500,36))

    -- 添加进度条
    self._progress = self._widget.loadingBar

    -- 容量名字
    local labelCapacityName = XMLLabel()
    labelCapacityName:setContentSize(cc.size(300, 36))
    self:addChild(labelCapacityName)
    REL:toOther("left", "top", labelCapacityName, self._widget.back, 150, 45)
    self._labelCapacityName = labelCapacityName

    -- 容量2个字
    self._labelCapacityName:setString(Language:get("uc121"))

    self._labelCapacityName:updateView()
	local contentWidth = self._labelCapacityName:getTextWidth()

    REL:toOther("left", "top", self._widget.backImg, labelCapacityName, contentWidth + 5, 0)
    REL:toOther("center","middle",self._progress,self._widget.backImg,0,0)
    -- 容量数值:显示在进度条的中间
    local labelCapacity = XMLLabel()
    labelCapacity:setContentSize(cc.size(300, 36))
    labelCapacity:setHAlign("center")
    labelCapacity:setVAlign("middle")
    self:addChild(labelCapacity)
    REL:toOther("center", "middle", labelCapacity, self._widget.backImg, 0, -0.5)
    self._labelCapacity = labelCapacity
end

function T:SetData()
    -- 不变的,这个是资源的图片
    local iconPath = IconManager.iconPath
    self._imgHead:loadTexture(iconPath .. Resource_temp[self.resSid].iconUrl)

    self._btnOpen.tag = 1
    self.node.tag = 1

    -- 要变的
    self:RefreshData1()
end

--- 道具使用完后更新数据显示
function T:RefreshData1()
    -- 名字
    self._widget:setString(self._labelName,Language:get(Resource_temp[self.resSid].name))
    
    -- 玩家所拥有的产量和容量
    local resOutput,resCapacity = PlayerInstance:getCapacityAndOutput(PlayerInstance:getResModelSid(self.resSid))
    local noResOutput = PlayerInstance:getNoResOutput()
    local noResCapacity = PlayerInstance:getNoResCapacity()

    local allOutput = PlayerInstance:getAllTrueOutput(PlayerInstance:getResModelSid(self.resSid))
    local output = allOutput*60     -- 分转化为小时

    local capacity = resCapacity + noResCapacity    -- 数值
    -- 产量
    self._widget:setString(self._labelOutput,Language:get("uc39",UnitConversion.unitTrans(output)))

    -- 容量
    local nowCapacity = UserInfo.city[Resource_temp[self.resSid].attributeName]
    local maxCapacity = capacity
    self._labelCapacity:setString(Language:get("uc41",UnitConversion.unitTrans(nowCapacity),UnitConversion.unitTrans(maxCapacity)))

    -- 进度条
    --self._progress:setPercent((maxCapacity - nowCapacity)/maxCapacity*100)
    if maxCapacity <= nowCapacity then
        self._progress:setPercentage(100)
    else
        local per = nowCapacity/maxCapacity*100
        self._progress:setPercentage(per)
    end
    
end

--- 每帧刷新数据:percent是buff的百分比
function T:RefreshData(percent,remainTime)
    -- 名字
    local name = Resource_temp[self.resSid].name
    local percent = percent
    local remainTime = remainTime

    self._widget:setString(self._labelName,Language:get("uc38",Language:get(name),percent,UnitConversion.handleTime4(remainTime)))

    -- 玩家所拥有的产量和容量
    local resOutput,resCapacity = PlayerInstance:getCapacityAndOutput(PlayerInstance:getResModelSid(self.resSid))
    local noResOutput = PlayerInstance:getNoResOutput()
    local noResCapacity = PlayerInstance:getNoResCapacity()

    local allOutput = PlayerInstance:getAllTrueOutput(PlayerInstance:getResModelSid(self.resSid))

    local output = allOutput*60     -- 分转化为小时
    local capacity = resCapacity + noResCapacity    -- 数值

    -- 产能:增加的buff显示
    local addOutput = (resOutput + noResOutput) * 60 * (percent/100) 
    self._widget:setString(self._labelOutput,Language:get("uc40",UnitConversion.unitTrans(output),UnitConversion.unitTrans(output - addOutput),UnitConversion.unitTrans(addOutput)))

    -- 容量
    local nowCapacity = UserInfo.city[Resource_temp[self.resSid].attributeName]
    local maxCapacity = capacity
    self._labelCapacity:setString(Language:get("uc41",UnitConversion.unitTrans(nowCapacity),UnitConversion.unitTrans(maxCapacity)))

    -- 进度条
    if maxCapacity <= nowCapacity then
        self._progress:setPercentage(100)
    else
        local per = nowCapacity/maxCapacity*100
        self._progress:setPercentage(per)
    end
end

function T:SetButton()   
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
        	AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
            self.node:dispachEvent()
            self:OpenLogic(sender)
        end
    end
    self._btnOpen:addTouchEventListener(callback) 

    local function callback2(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
        	AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
            self.node:dispachEvent()
            self:OpenLogic(sender)
        end
    end
    self.node:addTouchEventListener(callback2) 
end

--- 打开逻辑
function T:OpenLogic(sender)
    if sender.tag == 2 then
        self._btnOpen:loadTextures("scaleOut_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
        self.node.tag = 1
        self._btnOpen.tag = 1
    else
        self._btnOpen:loadTextures("scaleIn_normal.png","iconButton_general_down.png","",ccui.TextureResType.plistType)
        self.node.tag = 2
        self._btnOpen.tag = 2
    end
end

--- 展开页面的添加
function T:AddListItem()
    --打开展开页面
    self.node:addListener(function(leafContainer)
        local subItem = self.resourceListOpen.new(self.resSid,self) -- 传入的是资源的sid和本身的类，以便点击道具的时候来更新数据
        subItem:SetSize() -- 先根据弹出layout里面添加的数量动态设置高度
        leafContainer:setContentSize(cc.size(subItem:getContentSize().width,subItem:getContentSize().height))  
        leafContainer:addChild(subItem)
    end)
end

--- 检查所有资源的buff是否激活
function T:CheckBuffActived()
    local item = BuffQueueInfoMgr:getItem(self.resSid)
    if item then --buff存在，添加侦听
        --立即刷新
        local remainTime = item.remainingSec
        self:RefreshData(50,remainTime)

        BuffQueueInfoMgr:luaAddEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.resSid,self,self.update)        
    else
        self:RefreshData1()
        BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.resSid,self,self.update)
    end
end

function T:update(item) 
    if item.remainingSec and item.remainingSec <= 0 then    --时间走完了    
        BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.resSid,self,self.update)
        self:RefreshData1()
        BuffQueueInfoMgr:removeItem(self.resSid)
    else
        -- 处理每帧变化的数据
        local remainTime = item.remainingSec
        self:RefreshData(50,remainTime)
    end
end

--- 移除buff侦听
function T:RemoveBuff()
    BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.resSid,self,self.update)
end


return T