--[[
 *	弹出的打开页面的每一项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 道具的sid
T.propSid = nil

--- resourcesList 可以更新ResourcesList的页面显示，然后通过ResourcesList找到warehousestorageResource更新钻石的显示
T.resourcesList = nil

--- 每一项的大小
T.size = nil

--- 按钮的标记：1为购买并使用，2为使用道具
T.btnTag = 1

--- 构造函数
function T:ctor(sid,resourcesList)
    self.propSid = sid
    self.resourcesList = resourcesList

    local size = cc.size(640,200)
    self.size = size
    self:setContentSize(size)

    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
    -- 按钮回调设置
    self:SetButton()
end

function T:GetWidget()
    -- 下滑线图片
    local seqLine1Frame = ResLoader:getSpriteFrame("seqLine1.png")
    local seqLine1FrameSize = seqLine1Frame:getOriginalSize()
    local seqLine1 = Scale9Sprite:createWithFrame(seqLine1Frame,cc.rect(seqLine1FrameSize.width/2,seqLine1FrameSize.height/2,1,1))
    seqLine1:setContentSize(620,2)
	self:addChild(seqLine1)

    REL:toOther("center","bottom",seqLine1,self,-11,10)
	self.seqLine1 = seqLine1

    -- 头像
    local imgHead = ccui.ImageView:create()

    local iconPath = IconManager.iconPath
    imgHead:loadTexture(iconPath .. Prop_temp[1].propIcon)
    --imgHead:setScale(IconManager.baseScale[1],IconManager.baseScale[2]) 

    self:addChild(imgHead)
    REL:toOther("left","middle",imgHead,self,7,0)
    self._imgHead = imgHead

    -- 按钮
    local btnBuy = Button.new("false","true")
    --btnBuy:setButtonState("bigButton_green_normal.png","bigButton_general_down.png")
    --btnBuy:setButtonPic("levelUpIcon.png")
    self:addChild(btnBuy)
    --REL:toOther("right","middle",btnBuy,self,20,0) 
    self._btnBuy = btnBuy
    self._btnBuy.buttonText:setHAlign("center")

    -- 当前拥有的道具数量
    local labelNowNeed = XMLLabel()
    labelNowNeed:setContentSize(cc.size(300, 27))
    labelNowNeed:setHAlign("center")
    self:addChild(labelNowNeed)
    REL:toOther("left", "bottom", labelNowNeed, self, 385, 15)
    self._labelNowNeed = labelNowNeed

    -- 消耗的钻石数量
    local labelDiamondCount = XMLLabel()
    labelDiamondCount:setContentSize(cc.size(300, 36))
    labelDiamondCount:setHAlign("center")
    labelDiamondCount:setVAlign("middle")
    self:addChild(labelDiamondCount)
    --REL:toOther("center", "bottom", labelDiamondCount, self._btnBuy, 0, self._btnBuy:getContentSize().height + 4)
    self._labelDiamondCount = labelDiamondCount

    -- 名字
    local labelName = XMLLabel()
    labelName:setContentSize(cc.size(300, 36))
    self:addChild(labelName)
    REL:toOther("left", "top", labelName, self, 150, 30)
    self._labelName = labelName

    -- 描述
    local labelDescribe = XMLLabel()
    labelDescribe:setContentSize(cc.size(300, 200))
    labelDescribe:setVAlign("middle")
    self:addChild(labelDescribe)
    REL:toOther("left", "top", labelDescribe, self, 150, 20)
    self._labelDescribe = labelDescribe

end

function T:SetData()
    -- 不变的
    local data = Prop_temp[self.propSid]

    local iconPath = IconManager.iconPath
    self._imgHead:loadTexture(iconPath .. data.propIcon)

    self._labelName:setString(Language:get("uc278",Language:get(data.prop)))
    self._labelDiamondCount:setString(Language:get("uc111",data.price))

    local percent = data.percent
    local time = data.time
    local resInfo = data.resInfo
    local propDescription2 = data.propDescription2
    if percent > 0 then  --50%产量
        self._labelDescribe:setString(Language:get("uc195",Language:get(propDescription2,percent,time/3600)))
    else
        local getResCount = resInfo[1][2]
        self._labelDescribe:setString(Language:get(propDescription2,UnitConversion.unitTrans(getResCount)))
    end

    -- 要变的
    self:RefreshData1()  
end

--- 使用或者购买道具后要刷新
function T:RefreshData1()
    local num = PropsInfoMgr:getPlayerPropByID(self.propSid) or 0

    self._labelNowNeed:setString(Language:get("uc123",num))
    if num == 0 then
        self.btnTag = 1  -- 购买并使用
        self._btnBuy:setString(Language:get("uc32"))
        self._btnBuy:setButtonState("useDiamonButton_normal.png","useDiamonButton_normal.png")
        REL:toOther("right","middle",self._btnBuy,self,15,0) 
        REL:toOther("center","middle",self._btnBuy.buttonText,self._btnBuy,0,-10)
        self._labelDiamondCount:setVisible(true)
    else
        self.btnTag = 2  -- 使用道具
        self._btnBuy:setString(Language:get("uc33"))
        self._btnBuy:setButtonState("button_blue_normal.png","button_blue_normal.png","button_general_down.png")
        REL:toOther("right","middle",self._btnBuy,self,38,-10) 
        REL:toOther("center","middle",self._btnBuy.buttonText,self._btnBuy,0,12)
        self._labelDiamondCount:setVisible(false)
    end

    REL:toOther("center", "bottom", self._labelDiamondCount, self._btnBuy, 15, 86)
end

function T:SetButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            if self.btnTag == 1 then
                self:BuyProp()
            else
                self:UseProp()
            end
        end
    end
    self._btnBuy:addTouchEventListener(callback) 
end

--- 购买并且使用道具逻辑
function T:BuyProp()
    local function finish()
        self:RefreshData1()         --  一但成功就要立即刷新
        --self:ImmediateEffect() 
        self.resourcesList:CheckBuffActived()
    end
    BuildingCommand.BuyAndUseProp(self.propSid,Prop_temp[self.propSid].price,finish)
end

--- 使用道具逻辑
function T:UseProp()
    local function finish()
        self:RefreshData1()
        --self:ImmediateEffect()
        self.resourcesList:CheckBuffActived()

        -- 使用道具成功提示
        local descripe = Language:get("uc197",Language:get(Prop_temp[self.propSid].prop))
        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )

    end
    BuildingCommand.UseProp(self.propSid,finish)
end

--- 根据道具的sid对即时性的道具参数效果 sid为道具的sid
function T:ImmediateEffect()
    local data = Prop_temp[self.propSid]
    local res = data.resInfo
    --local name = Resource_temp[data.icon].attributeName
    --local getResCount = res[]
--    if res > 0 then
--        UserInfo.city[name] = UserInfo.city[name] + res
--    end
end


return T