--[[
 *	资源窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 资源的项
T.resourceList = require "src.app.uiScript.components.warehousestorage.resource.ResourceList"

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor()
    self.queue = Queue()

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    self.queue:clearT()
    self.queue = nil
end

function T:init()
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,10,0,0,0)
    self.listView = listView

    local _widget = ListItem4.new()
    _widget:setListItemAttribute(
        "H",
        {"label"}
    )
--    self:addChild(_widget)
--    REL:toOther("left","top",_widget,self,10,-15)
    
    -- 仓库icon
    local iconPath = IconManager.iconPath
    _widget:iconLoadTexture(iconPath .. Build_temp[5].icon)
    -- 仓库名字
    _widget:setString(_widget.title,Language:get("uc496"))
    -- 字
    _widget:getLabel(1):setContentSize(cc.size(450, 36))
    _widget:getLabel(1):setAlign("left","middle")
    REL:toOther("left", "top", _widget:getLabel(1), _widget.back, 130, 60)
    _widget:setString(_widget:getLabel(1),Language:get("uc124",UnitConversion.unitTrans(PlayerInstance:getProtectedCapacity())))
    
    listView:pushBackCustomItem(_widget)

    self:AddResearchItem2()
end

--- 添加到listview中去
function T:AddResearchItem()
    local list = MUIListTree.extend(self.listView)

    -- 添加其它项
    local num = #Resource_temp
    for i = 1,num,1 do
        local node = list:getRootNode()
        local res = self.resourceList.new(i,node) 
        node:setContentSize(cc.size(res.size.width,res.size.height)) -- 这里要动态设置高度
        node:addChild(res)
    end
end


--- 添加到listview中去
function T:AddResearchItem2()
    local temp = mapping({},Resource_temp)
    local num = #temp

    for i = 0,num,1 do
        if temp[i] then
            temp[i].sid = i
            self.queue:push(temp[i])
        end
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)
end

function T:addRes()
    local data = self.queue:pop()
    local list = MUIListTree.extend(self.listView)
    if data then
        local node = list:getRootNode()
        local res = self.resourceList.new(data.sid,node) 
        node:setContentSize(cc.size(res.size.width,res.size.height)) -- 这里要动态设置高度
        node:addChild(res)
        node:setOpacity(0)

        node:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end

return T