--[[
 *	显示皮肤窗口项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 当前选择的类型
T.chooseShowType = nil


--- 构造函数
function T:ctor()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:setContentSize(cc.size(500,400))
    self:setTouchEnabled(true)

    self:initItems()
    self:setButton()


end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()

end

--- 内存清理
function T:cleanUp()
    
end

function T:initItems()
    self.itemData = {}
    for i = 1,4,1 do
        self.itemData[i] = {}
        self.itemData[i].buffSid = i + 100
        self.itemData[i].propSid = BuffQueueInfoMgr:getPropSidByBuffSid(i + 100)
        self.itemData[i].isHasBuff = BuffQueueInfoMgr:checkActive(i + 100)
    end

    for i = 1,4,1 do
        local data = self.itemData[i]

        local icon = ccui.ImageView:create()
        local iconPath = IconManager.iconPath
        icon:loadTexture(iconPath .. Prop_temp[data.propSid].propIcon)
        self:addChild(icon)

        local left = 20 + (i - 1) * 120
        REL:toOther("left","top",icon,self,left,100)
        
        if data.isHasBuff then
            icon:setIsGray(false)
        else
            icon:setIsGray(true)
        end

        local function callback(sender, eventType)
            if eventType == ccui.TouchEventType.ended then 
                if BuffQueueInfoMgr:checkActive(sender.buffSid) then
                    self.chooseShowType = sender.buffSid
                    self.roleHeadChoose:setVisible(true)
                    REL:toOther("center","middle",self.roleHeadChoose,self.itemData[self.chooseShowType - 100].icon,0,0)
                else
                    local descripe = Language:get("uc1057")
                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                end
                                    
            end
        end
        icon:addTouchEventListener(callback) 
        icon:setTouchEnabled(true)

        icon.buffSid = self.itemData[i].buffSid
        self.itemData[i].icon = icon


    end


    -- roleHeadChoose
    local roleHeadChoose = ccui.ImageView:create()
    roleHeadChoose:loadTexture("roleHeadChoose.png",ccui.TextureResType.plistType)
    self:addChild(roleHeadChoose)
    REL:toOther("center","middle",roleHeadChoose,self,0,0)
    self.roleHeadChoose = roleHeadChoose

    self.chooseShowType = PlayerInstance:getPlayerShowType()
    if self.chooseShowType == 0 then
        self.roleHeadChoose:setVisible(false)
    else
        if BuffQueueInfoMgr:getPropSidByBuffSid(self.chooseShowType) then
            self.roleHeadChoose:setVisible(true)
            REL:toOther("center","middle",self.roleHeadChoose,self.itemData[self.chooseShowType - 100].icon,0,0)
        else
            self.roleHeadChoose:setVisible(false)
        end

    end


end


function T:setButton()  
    -- 替换按钮
    local btnChange = Button.new("false","true")
    btnChange.buttonText:setHAlign("center")
    btnChange.buttonText:setVAlign("middle")
    self:addChild(btnChange)
    btnChange:loadTextures("button_blue_normal.png","button_general_down.png","",ccui.TextureResType.plistType)
    btnChange:setString(Language:get("uc1052")) -- 按钮上的字设置为"替换"
    REL:toOther("center", "bottom", btnChange, self, 0, 20)
    REL:toOther("center","middle",btnChange.buttonText,btnChange,0,12)

    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            local function finish()
                self.__hide__()
                local descripe = Language:get("uc1056")
                MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
            end

            if self.chooseShowType == PlayerInstance:getPlayerShowType() then
                if self.chooseShowType == 0 then
                    self.__hide__()
                    local descripe = Language:get("uc1058")
                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                else
                    finish()
                end
                
                return
            end
            Command:changeCityShowType(self.chooseShowType,finish)

        end
    end
    btnChange:addTouchEventListener(callback) 


end


return T