--[[
 *	显示皮肤状态状态项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 每一项的大小
T.size = nil

--- 按钮的标记：1为购买并使用，2为使用道具
T.btnTag = 1


--- 构造函数
function T:ctor()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local listItem = ListItem3.new()
    listItem:init()
    self:addChild(listItem)

    self.size = listItem:getContentSize()
    self:setContentSize(self.size)

    REL:toOther("left","top",listItem,self,0,0)
    self.listItem = listItem

    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:setData()
    self:refreshData()
    -- 按钮回调设置
    self:SetButton()

    self:CheckBuffActived()

end

--- 进入
function T:onEnter()
    PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.showType,self,self.refresh)
end

--- 退出
function T:onExit()
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.showType,self,self.refresh)
    self:RemoveBuff()

end

--- 内存清理
function T:cleanUp()
    
end


function T:GetWidget()
    -- 头像
    self._imgHead = self.listItem.icon
    
    -- 使用按钮
    self.btnUse = self.listItem.btnUse

    -- 名字
    self._labelName = self.listItem.title

    -- 描述
    self._labelDescribe = self.listItem.describe

    -- 拥有
    self._hasUse = self.listItem.hasUse

     -- 百分比加剩余时间显示
    local remainTime = XMLLabel()
    remainTime:setContentSize(cc.size(300, 36))
    remainTime:setHAlign("center")
    remainTime:setVAlign("middle")
    self:addChild(remainTime)
    REL:toOther("center", "bottom", remainTime, self, 220, 0)
    self.remainTime = remainTime


end

function T:setData()
    -- 使用按钮
    self.btnUse:loadTextures("button_blue_normal.png","button_general_down.png","",ccui.TextureResType.plistType)
    self.btnUse:setString(Language:get("uc33")) -- 按钮上的字设置为"使用"
    REL:toOther("right", "bottom", self.btnUse, self.listItem.back, 32, 10)
    REL:toOther("center","middle",self.btnUse.buttonText,self.btnUse,0,12)

    -- 替换按钮
    local btnChange = Button.new("false","true")
    btnChange.buttonText:setHAlign("center")
    btnChange.buttonText:setVAlign("middle")
    self:addChild(btnChange)
    btnChange:loadTextures("button_blue_normal.png","button_general_down.png","",ccui.TextureResType.plistType)
    btnChange:setString(Language:get("uc1052")) -- 按钮上的字设置为"替换"
    REL:toOther("right", "bottom", btnChange, self.listItem.back, 32, 80)
    REL:toOther("center","middle",btnChange.buttonText,btnChange,0,12)
    self.btnChange = btnChange

end

--- 显示类型改变的时候
function T:refresh()
    self:RemoveBuff()
    self:refreshData()
    self:CheckBuffActived()

end

--- 数据刷新
function T:refreshData()
    local showType = PlayerInstance:getPlayerShowType()
    local iconPath = IconManager.iconPath

    self.remainTime:setVisible(false)

    if showType == 0 then
        self._hasUse:setVisible(false)
        self.btnUse:setVisible(false)
        self._imgHead:loadTexture(iconPath .. "propIcon/defaultBuild.png")

        self._labelDescribe:setString(Language:get("uc1053"))

        self._labelName:setString(Language:get("uc276",Language:get("uc1054")))

        self.buffSid = nil
        self.propSid = nil

        REL:toOther("right", "bottom", self.btnChange, self.listItem.back, 32, 30)
        REL:toOther("center","middle",self.btnChange.buttonText,self.btnChange,0,12)


    else
        self.buffSid = showType
        self.propSid = BuffQueueInfoMgr:getPropSidByBuffSid(self.buffSid)

        local num = PropsInfoMgr:getPlayerPropByID(self.propSid)
        self._hasUse:setString(Language:get("uc277",num))
        self._hasUse:setVisible(true)
        self.btnUse:setVisible(true)

        if num > 0 then
            self.btnUse:setIsGray(false)
            self.btnUse:setTouchEnabled(true)
        else
            self.btnUse:setIsGray(true)
            self.btnUse:setTouchEnabled(false)
        end

        local data = Prop_temp[self.propSid]
        self._imgHead:loadTexture(iconPath .. data.propIcon)

        self._labelDescribe:setString(Language:get(data.propDescription2,UnitConversion.handleTime4(data.time)))

        self._labelName:setString(Language:get("uc276",Language:get(data.prop)))

        REL:toOther("right", "bottom", self.btnChange, self.listItem.back, 32, 80)
        REL:toOther("center","middle",self.btnChange.buttonText,self.btnChange,0,12)


    end



end

function T:SetButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            if self.btnUse == sender then
                local function finish()
                    self:refreshData()
                    self:CheckBuffActived()

                    local descripe = Language:get("uc35",Language:get(Prop_temp[self.propSid].prop))
                    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                end
                BuildingCommand.UseProp(self.propSid,finish)
            else
                local layout = require("src.app.uiScript.components.warehousestorage.state.ChangeShowTypeWindow").new()
	            MUIAlter_noTitle.show({
		            info = layout
	            })

            end
        end
    end
    self.btnUse:addTouchEventListener(callback) 
    self.btnChange:addTouchEventListener(callback) 
end

--- 检查buff是否激活
function T:CheckBuffActived()
    if not self.buffSid then
        return
    end

    local item = BuffQueueInfoMgr:getItem(self.buffSid)
    if item then --buff存在，添加侦听
        --立即刷新
        local remainTime = item.remainingSec
        self.remainTime:setVisible(true)
        self:refreshRemainData(remainTime)

        BuffQueueInfoMgr:luaAddEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.buffSid,self,self.update)        
    end
end

--- 每帧刷新
function T:refreshRemainData(remainTime)
    self.remainTime:setString(Language:get("uc1055",UnitConversion.handleTime4(remainTime)))
end

function T:update(item)
    if item.remainingSec and item.remainingSec <= 0 then    --时间走完了    
        BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.buffSid,self,self.update)
        self.remainTime:setVisible(false)
        BuffQueueInfoMgr:removeItem(self.buffSid)
    else
        -- 处理每帧变化的数据
        local remainTime = item.remainingSec
        self:refreshRemainData(remainTime)
    end
end

--- 移除buff侦听
function T:RemoveBuff()
    if not self.buffSid then
        return
    end


    BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.buffSid,self,self.update)
end




return T