--[[
 *	状态窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 道具列表
T.propList = nil

--- 队列数据
T.queue = nil

--- 构造函数
function T:ctor()
    self.queue = Queue()

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
end
--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    
    self.queue:clearT()
    self.queue = nil
end

function T:init()
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,6,0,0,0)
    self.listView = listView

    self.propList = {106,107,108,109,110,111,112,113}

    -- 先添加主城皮肤项
    self:addBuildShowTypeItem()

    self:addItem2()
end

--- 主城皮肤添加到listview中去
function T:addBuildShowTypeItem()
    local res = require("src.app.uiScript.components.warehousestorage.state.ShowTypeStateItem").new()
    self.listView:pushBackCustomItem(res)
end


--- 添加到listview中去
function T:addItem()
    -- 添加其它项
    local num = #self.propList
    for i = 1,num,1 do
        local res = require("src.app.uiScript.components.warehousestorage.state.WarhouseStateItem").new(self.propList[i]) -- 传入的是道具的sid
        res:setContentSize(cc.size(res.size.width,res.size.height)) 
        self.listView:pushBackCustomItem(res)
    end
end

function T:addItem2()
    local num = #self.propList
    for n = 1,num,1 do
        if self.propList[n] then
            self.queue:push(self.propList[n])
        end
    end

    self:runAction(
        cc.RepeatForever:create(
            cc.Sequence:create(
		        cc.DelayTime:create(0.1),
		        cc.CallFunc:create( function()
			        self:addRes()
		        end)
		    )
        )
	)

end

function T:addRes()
    local data = self.queue:pop()
    if data then
        local res = require("src.app.uiScript.components.warehousestorage.state.WarhouseStateItem").new(data) -- 传入的是道具的sid
        res:setContentSize(cc.size(res.size.width,res.size.height)) 
        self.listView:pushBackCustomItem(res)
        res:setOpacity(0)

        res:runAction(
            cc.FadeIn:create(0.5)
        )
    else
        self:stopAllActions()
    end
end


return T