--[[
 *	状态项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 道具的sid
T.propSid = nil

--- 每一项的大小
T.size = nil

--- 按钮的标记：1为购买并使用，2为使用道具
T.btnTag = 1

--- buff的sid
T.buffSid = nil

--- 构造函数
function T:ctor(sid)
    self.propSid = sid

    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    local listItem = ListItem3.new()
    listItem:init()
    self:addChild(listItem)

    self.size = listItem:getContentSize()
    self:setContentSize(self.size)

    REL:toOther("left","top",listItem,self,0,0)
    self.listItem = listItem

    self.buffSid = self:getBuffSidByPropSid(self.propSid)

    -- 得到控件
    self:GetWidget()
    -- 设置数据
    self:SetData()
    -- 按钮回调设置
    self:SetButton()
end

--- 进入
function T:onEnter()
    self:CheckBuffActived()
    local function update1()
        local data = Prop_temp[self.propSid]
        local num = PropsInfoMgr:getPlayerPropByID(self.propSid)
        self._hasUse:setString(Language:get("uc277",num))
    end
    self.update1 = update1
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. self.propSid,nil,self.update1)
end

--- 退出
function T:onExit()
    self:RemoveBuff()
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. self.propSid,nil,self.update1)
end

--- 内存清理
function T:cleanUp()
    
end


function T:GetWidget()
    -- 头像
    self._imgHead = self.listItem.icon
    
    -- 购买并使用或者使用按钮
    self._btnBuy = self.listItem.btnUse

    -- 名字
    self._labelName = self.listItem.title

    -- 描述
    self._labelDescribe = self.listItem.describe

    -- 拥有
    self._hasUse = self.listItem.hasUse

    -- 消耗钻石
    local labelCostDiamond = XMLLabel()
    labelCostDiamond:setHAlign("center")
    labelCostDiamond:setVAlign("middle")
    labelCostDiamond:setContentSize(cc.size(300, 36))
    self:addChild(labelCostDiamond)
    self._labelCostDiamond = labelCostDiamond

    -- 百分比加剩余时间显示
    local remainTime = XMLLabel()
    remainTime:setContentSize(cc.size(300, 36))
    remainTime:setHAlign("center")
    remainTime:setVAlign("middle")
    self:addChild(remainTime)
    REL:toOther("center", "bottom", remainTime, self, 220, 0)
    self.remainTime = remainTime
end

function T:SetData()
    -- 不变的
    local data = Prop_temp[self.propSid]
    local iconPath = IconManager.iconPath
    self._imgHead:loadTexture(iconPath .. data.propIcon)

    self._labelCostDiamond:setString(Language:get("uc111",data.price))

    local percent = data.percent
    local time = data.time
    local propDescription2 = data.propDescription2
    if percent > 0 then  
        self._labelDescribe:setString(Language:get(propDescription2,percent,UnitConversion.handleTime(time)))
    else
        self._labelDescribe:setString(Language:get(propDescription2,UnitConversion.handleTime(time)))
    end

    self.remainTime:setVisible(false)

    -- 要变的
    self:RefreshData1()
end

--- 使用或者购买道具后要刷新
function T:RefreshData1()
    local num = PropsInfoMgr:getPlayerPropByID(self.propSid) or 0

    local data = Prop_temp[self.propSid]
    local num = PropsInfoMgr:getPlayerPropByID(self.propSid)
    self._labelName:setString(Language:get("uc276",Language:get(data.prop)))
    self._hasUse:setString(Language:get("uc277",num))

    if num == 0 then
        self.btnTag = 1  -- 购买并使用
        self._labelCostDiamond:setVisible(true)

        self._btnBuy:setString(Language:get("uc111",Language:get("uc32")))
        self._btnBuy:loadTextures("useDiamonButton_normal.png","useDiamonButton_normal.png","",ccui.TextureResType.plistType)

        REL:toOther("right", "bottom", self._btnBuy, self.listItem.back, 5, 25)
        REL:toOther("center","middle",self._btnBuy.buttonText,self._btnBuy,0,-10)
        REL:toOther("center", "bottom", self._labelCostDiamond, self._btnBuy, 15, 86)
    else
        self.btnTag = 2  -- 使用道具
        self._labelCostDiamond:setVisible(false)

        self._btnBuy:loadTextures("button_blue_normal.png","button_general_down.png","",ccui.TextureResType.plistType)
        self._btnBuy:setString(Language:get("uc33")) -- 按钮上的字设置为"使用"
        REL:toOther("right", "bottom", self._btnBuy, self.listItem.back, 32, 30)
        REL:toOther("center","middle",self._btnBuy.buttonText,self._btnBuy,0,12)
    end

end

function T:SetButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            if self.btnTag == 1 then
                self:BuyProp()
            else
                self:UseProp()
            end
        end
    end
    self._btnBuy:addTouchEventListener(callback) 
end

--- 购买并且使用道具逻辑
function T:BuyProp()
    local function finish()
        self:RefreshData1()         --  一但成功就要立即刷新
        self:CheckBuffActived()
    end
    BuildingCommand.BuyAndUseProp(self.propSid,Prop_temp[self.propSid].price,finish)
end

--- 使用道具逻辑
function T:UseProp()
    local function finish()
        self:RefreshData1()
        self:CheckBuffActived()

        local descripe = Language:get("uc35",Language:get(Prop_temp[self.propSid].prop))
        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
    end
    BuildingCommand.UseProp(self.propSid,finish)
end


--- 每帧刷新
function T:RefreshData(remainTime)
    -- 这里还要考虑是否有50
    self.remainTime:setString(Language:get("uc125",50,UnitConversion.handleTime4(remainTime)))
end

--- 检查所有资源的buff是否激活
function T:CheckBuffActived()
    local item = BuffQueueInfoMgr:getItem(self.buffSid)
    if item then --buff存在，添加侦听
        --立即刷新
        local remainTime = item.remainingSec
        self.remainTime:setVisible(true)
        self:RefreshData(remainTime)

        BuffQueueInfoMgr:luaAddEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.buffSid,self,self.update)        
    end
end

function T:update(item)
    if item.remainingSec and item.remainingSec <= 0 then    --时间走完了    
        BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.buffSid,self,self.update)
        self.remainTime:setVisible(false)
        BuffQueueInfoMgr:removeItem(self.buffSid)
    else
        -- 处理每帧变化的数据
        local remainTime = item.remainingSec
        self:RefreshData(remainTime)
    end
end

--- 移除buff侦听
function T:RemoveBuff()
    BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH..self.buffSid,self,self.update)
end


--- 根据道具的sid获取buff的sid
function T:getBuffSidByPropSid(propSid)
    local buffSid = nil
    if propSid == 106 then
        buffSid = 6
    elseif propSid == 107 then
        buffSid = 7
    elseif propSid == 108 then
        buffSid = 8
    elseif propSid == 109 then
        buffSid = 9
    elseif propSid == 110 then
        buffSid = 10
    elseif propSid == 111 then
        buffSid = 11
    elseif propSid == 112 then
        buffSid = 12
    elseif propSid == 113 then
        buffSid = 13
    else
    end

    return buffSid
end

return T