--[[
 *	警告项
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 警告信息
T.warnInfo = nil

--- 构造函数
function T:ctor(warnInfo,listView)
    self.warnInfo = warnInfo
    self.listView = listView


    self:init()

end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )
    
    self:setContentSize(cc.size(550,120))

    self:getWidget()

    local warnInfo = self.warnInfo
    local warnBox = WarnQueueManager.warnBox
    warnBox:luaAddEventListener(warnBox.EVT_REMOVE_SINGLE_QUEUE_REFRESH .. warnInfo.sourceId .. warnInfo.qid, self, self.removeSelf)
    warnBox:luaAddEventListener(warnBox.EVT_TIME_REFRESH .. warnInfo.sourceId .. warnInfo.qid, self, self.refreshTime)

end

--- 进入
function T:onEnter()
    
end

--- 退出
function T:onExit()
    local warnBox = WarnQueueManager.warnBox
    local warnInfo = self.warnInfo
    warnBox:luaRemoveEventListener(warnBox.EVT_REMOVE_SINGLE_QUEUE_REFRESH .. warnInfo.sourceId .. warnInfo.qid, self, self.removeSelf)
    warnBox:luaRemoveEventListener(warnBox.EVT_TIME_REFRESH .. warnInfo.sourceId .. warnInfo.qid, self, self.refreshTime)
end

function T:getWidget()
    local worldPopMiddleFrame = ResLoader:getSpriteFrame("worldPopMiddleFrame.png")
	local worldPopMiddle = Scale9Sprite:createWithFrame(worldPopMiddleFrame)
    worldPopMiddle:setContentSize(cc.size(550,120))
	self:addChild(worldPopMiddle)
    REL:toOther("center","middle",worldPopMiddle,self,0,0)

    local icon = ccui.ImageView:create()
    icon:loadTexture("barOfArmyAttack.png",ccui.TextureResType.plistType)
    self:addChild(icon)
    REL:toOther("left","middle",icon,worldPopMiddle,10,0)

    local warnInfo = self.warnInfo
    -- 描述1
    local des1 = XMLLabel()
    des1:setVAlign("middle")
    des1:setContentSize(cc.size(400,36))
    self:addChild(des1)
    REL:toOther("left","middle",des1,icon,80,30)
    des1:setString(Language:get("uc830",warnInfo.attackerName))

    -- 描述2
    local des2 = XMLLabel()
    des2:setVAlign("middle")
    des2:setContentSize(cc.size(400,36))
    self:addChild(des2)
    REL:toOther("left","middle",des2,icon,80,0)
    des2:setString(Language:get("uc831",warnInfo.x,warnInfo.y))

    -- 时间
    local time = XMLLabel()
    time:setVAlign("middle")
    time:setContentSize(cc.size(400,36))
    self:addChild(time)
    REL:toOther("left","middle",time,icon,80,-30)
    self.time = time

    self:refreshTime()
end

function T:refreshTime()
    local warnInfo = self.warnInfo
    local remainingSec = warnInfo.remainingSec
    self.time:setString(Language:get("uc832",UnitConversion.handleTime4(remainingSec)))
end

function T:removeSelf()
    local index = self.listView:getIndex(self)
	local listView = self.listView
	self.listView:removeItem(index)
	listView:refreshView()
end


return T