--[[
 *	警告弹出窗口
]]
local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor()
    self:init()
end

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:setTouchEnabled(true)
    
    self:setContentSize(cc.size(630,790))

    self:setWidget()

    self:addListItems()

end

--- 进入
function T:onEnter()
    local warnBox = WarnQueueManager.warnBox
    warnBox:luaAddEventListener(warnBox.EVT_REMOVE_SINGLE_QUEUE_REFRESH, self, self.removeSelf)
    warnBox:luaAddEventListener(warnBox.EVT_ADD_SINGLE_QUEUE_REFRESH, self, self.addMarch)


end

--- 退出
function T:onExit()
    local warnBox = WarnQueueManager.warnBox
    warnBox:luaRemoveEventListener(warnBox.EVT_REMOVE_SINGLE_QUEUE_REFRESH, self, self.removeSelf)
    warnBox:luaRemoveEventListener(warnBox.EVT_ADD_SINGLE_QUEUE_REFRESH, self, self.addMarch)


end

function T:setMUIAlter2(muialter2)
    self.muialter2 = muialter2
end


function T:setWidget()
    -- 背景图片
    local f = ResLoader:getSpriteFrame("worldPopFrame.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,216,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self,0,0,0,0)
	self.viewBack = viewBack

    -- 右上角按钮
    local close = Button.new("false","false")
	close:setButtonState("alterCoseButton_normal.png","alterCoseButton_normal.png")
	self:addChild(close)
	REL:toOther("right","top",close,viewBack,30,80)
    close:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            self.muialter2:hide()
        end
    end)

    -- 标题背景
    local worldPopTopTag = ccui.ImageView:create()
    worldPopTopTag:loadTexture("worldPopTopTag.png",ccui.TextureResType.plistType)
    self:addChild(worldPopTopTag)
    REL:toOther("center","top",worldPopTopTag,viewBack,0,75)

    -- 名字
    local title = XMLLabel()
    title:setHAlign("center")
    title:setContentSize(cc.size(400,36))
    self:addChild(title)
    REL:toOther("center","top",title,worldPopTopTag,0,5)
    title:setString(Language:get("uc829"))

end

--- 添加项
function T:addListItems()
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self.viewBack,50,50,130,100)
    self.listView = listView

    local warnBox = WarnQueueManager.warnBox.warnBox
    for k,v in pairs(warnBox) do
        if v then
            local res = require("src.app.uiScript.components.warn.WarnItem").new(v,listView)
            listView:pushBackCustomItem(res)
        end

    end

end

function T:removeSelf()
    local warnBox = WarnQueueManager.warnBox
    local judge = warnBox:judgeQueue()
    if judge == false then
        if self.muialter2 then
            self.muialter2:hide()
        end
    end
    
end

function T:addMarch(info)
    local listView = self.listView
    local res = require("src.app.uiScript.components.warn.WarnItem").new(info,listView)
    listView:pushBackCustomItem(res)
end



return T