--Author    : YuDing
--Date      : 2014/10/23
--Introduce : 主界面

local HomePageScene = class( "HomePage", function() return cc.Scene:create() end )

--- 管理器
HomePageManager = nil
--- 打开建筑管理器
HomeOpenWindowManager = nil

--- 子类容器
HomePageScene.container = nil

--- 构造函数
function HomePageScene:ctor()
	mapping( self, LuaEventDispatcher )

	local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function( eventType )
				print( "HomePage:" .. eventType )
				if CocosEvent.ENTER == eventType then
					self:onEnter()
				elseif CocosEvent.EXIT == eventType then
					self:onExit()
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				end

				self:luaDispatchEvent( eventType )
			end
		)
	end

	HomePageManager = require("src.app.uiScript.scenes.homePage.HomePageManager")()

	if not HomeOpenWindowManager then
		HomeOpenWindowManager = require("src.app.uiScript.scenes.homePage.OpenBuildingManager").new()
	end

	self:initView()             -- 初始化
end

function HomePageScene:onEnter()
	LogIcon:show()

	if BGMgr:isGuide() then
		local enterEffComplete
		enterEffComplete=function()
			HomePageManager:luaRemoveEventListener(HomePageManager.noticeMessage.enterEffectComplete, nil, enterEffComplete)

			BGMgr:start()
		end

		BGMgr:showHollowMask()
		HomePageManager:luaAddEventListener(HomePageManager.noticeMessage.enterEffectComplete, nil, enterEffComplete)
	end

	WindowManager:getCurrentSceneMgr():luaAddEventListener(EVENT_START_OPEN, self, self.windowStartOpenHandler)
	WindowManager:getCurrentSceneMgr():luaAddEventListener(EVENT_START_OPEN, self, self.windowStartOpenHandler)
	WindowManager:getCurrentSceneMgr():luaAddEventListener(EVENT_OPEN_COMPLETE, self, self.windowOpenCompleteHandler)
	WindowManager:getCurrentSceneMgr():luaAddEventListener(EVENT_START_CLOSE, self, self.windowStartCloseHandler)
	WindowManager:getCurrentSceneMgr():luaAddEventListener(EVENT_CLOSE_COMPLETE, self, self.windowCloseCompleteHandler)
end

function HomePageScene:windowStartOpenHandler(window)

end

function HomePageScene:windowOpenCompleteHandler(window)
	if WindowManager:getLength() == 1 then
		self:removeContainer()
	end
end

function HomePageScene:windowStartCloseHandler(window)
	if WindowManager:getLength() == 1 then
		self:addContainer()
	end
end

function HomePageScene:windowCloseCompleteHandler(window)

end

function HomePageScene:onExit()
end

function HomePageScene:cleanUp()
	if HomePageManager then
		HomePageManager:cleanUp()
	end

	--- 打开窗口管理器
	HomeOpenWindowManager = nil

	WindowManager:getCurrentSceneMgr():luaRemoveEventListener(EVENT_START_OPEN, self, self.windowStartOpenHandler)
	WindowManager:getCurrentSceneMgr():luaRemoveEventListener(EVENT_START_OPEN, self, self.windowStartOpenHandler)
	WindowManager:getCurrentSceneMgr():luaRemoveEventListener(EVENT_OPEN_COMPLETE, self, self.windowOpenCompleteHandler)
	WindowManager:getCurrentSceneMgr():luaRemoveEventListener(EVENT_START_CLOSE, self, self.windowStartCloseHandler)
	WindowManager:getCurrentSceneMgr():luaRemoveEventListener(EVENT_CLOSE_COMPLETE, self, self.windowCloseCompleteHandler)
end

--- 初始化
function HomePageScene:initView()
	self:createContainer()
	HomePageManager:setDelegete(self)
	HomePageManager:init()
	HomePageManager:setDefaultView()
end

--- 创建一个子类容器
function HomePageScene:createContainer()
	self.container = ccui.Layout:create()
	self.container:setContentSize(UI_VSIZE)
	self:addChild(self.container)
end

--- 暂时移除主界面上东西
function HomePageScene:removeContainer()
	self.container:retain()
	self:removeChild(self.container, false)
end

--- 加入主界面上东西
function HomePageScene:addContainer()
	if self.container:getParent() then
		local message="~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~重复添加了"
		__print__("closeWindowErr",message)
		LogRecorder:push(message,LOG_LEVEL_ERROR,"closeWindowErr")
		return
	end

	self:addChild(self.container)
	self.container:release()
end

--- 获取主界面容器
function HomePageScene:getContainer()
	return self.container
end

return HomePageScene





