--region openBuildingManager.lua
--Author    : YuDing
--Date      : 2014/12/26
--Introduce : 打开建筑管理器

local T = class("openBuildingManager")

T.darkColor = {120, 120, 120}

--- 打开建筑的特效
-- @param t 特效的宿主
-- @param func 回调函数
-- @param delay 延时打开
function T:openEffect(t, func, delay, noBuilding)
	--	if not func then
	--		local message="the argment whith \"open function\" is nil".."\n"..debug.traceback()

	--		__print__("openWindowErr", message)
	--		LogRecorder:push(message, LOG_LEVEL_ERROR, "openWindowErr")

	--		return
	--	end

	-- 容错函数
	local faultFunc = function()
		if func then
			xpcall(func,function(msg)
				local message=tostring(msg).."\n"..debug.traceback()

				__print__("openWindowErr", message)
				LogRecorder:push(message, LOG_LEVEL_ERROR, "openWindowErr")
			end)
		end

		-- 延迟0.1s 等待窗口 之后 移除遮罩  只要是界面出现需要时间
		Cocos2dxUtils:timeOut(function()
			HomePageManager:luaDispatchEvent(HomePageManager.noticeMessage.openWindow) -- 0.1s 之后移除遮罩
		end, 0.1)
	end

	if delay or not t then
		if noBuilding ~= true then
			faultFunc()
			return

		end
	end

	HomePageManager:addOpenBldMask() -- 打开遮罩

	if type(t) == "table" then
		for i = 1, #t do
			local old = t[i]:getColor()
			local ac
			if i == #t then
				ac = cc.Sequence:create(cc.TintTo:create(0.25, T.darkColor[1], T.darkColor[2], T.darkColor[3]), cc.TintBy:create(0.25, old.r - T.darkColor[1], old.g - T.darkColor[2], old.b - T.darkColor[3]), cc.CallFunc:create(faultFunc))
			else
				ac = cc.Sequence:create(cc.TintTo:create(0.25, T.darkColor[1], T.darkColor[2], T.darkColor[3]), cc.TintBy:create(0.25, old.r - T.darkColor[1], old.g - T.darkColor[2], old.b - T.darkColor[3]))
			end
			t[i]:runAction(ac)
		end

	else
		local old = t:getColor()
		local ac = cc.Sequence:create(cc.TintTo:create(0.25, T.darkColor[1], T.darkColor[2], T.darkColor[3]), cc.TintBy:create(0.25, old.r - T.darkColor[1], old.g - T.darkColor[2], old.b - T.darkColor[3]), cc.CallFunc:create(faultFunc))
		t:runAction(ac)
	end

end


--- 许愿池
-- @param t 对象
-- @param delay 是否延长打开
function T:openWishEvent(t, delay)
	local func = function()
		WindowManager:push(
			require("src.app.uiScript.components.allActivity.luckyLottery.LuckyLotteryWindow").new()
		)

		--		local remove = function()
		--		end

		--		MUIAlter.show(
		--			{
		--				info = "许愿池功能开发中！",
		--				size = 30,
		--				callback = remove,
		--			}
		--		)

	end

	self:openEffect(t, func, delay)
end
--- 指挥中心
function T:openCenterEvent(t, delay)
	local func = function()
		WindowManager:push(
			require("src.app.uiScript.components.building.BuildingWindow").new(BuildingsInfoMgr:getBuildingInfos()[1])
		)
	end

	self:openEffect(t, func, delay)
end
--- 作战中心
function T:openCommandEvent(t, delay)
	local func = function()
		--		local remove = function()
		--		end

		--		MUIAlter.show(
		--			{
		--				info = "作战中心功能开发中！",
		--				size = 30,
		--				callback = remove,
		--			}
		--		)
		WindowManager:push(
			require("src.app.uiScript.components.laboratory.LabWindow").new()
		)

	end

	self:openEffect(t, func, delay)

end
--- 仓库1
function T:openStoreHouseOneEvent(t, delay)
	local func = function()
		local info = require("src.app.model2.build.BuildingInfo")()
		if BuildingsInfoMgr:getBuildingInfos()[6] then
			info = BuildingsInfoMgr:getBuildingInfos()[6]
		else
			info.sid = 5
			info.remainingSec = 0
			info.location = 6
			info.level = 0
			info.id = nil
		end
		WindowManager:push(
			require("src.app.uiScript.components.building.BuildingWindow").new(info)
		)
	end

	self:openEffect(t, func, delay)

end
--- 仓库2
function T:openStoreHouseTwoEvent(t, delay)
	local func = function()
		local info = require("src.app.model2.build.BuildingInfo")()
		if BuildingsInfoMgr:getBuildingInfos()[7] then
			info = BuildingsInfoMgr:getBuildingInfos()[7]
		else
			info.sid = 5
			info.remainingSec = 0
			info.location = 7
			info.level = 0
			info.id = nil
		end
		WindowManager:push(
			require("src.app.uiScript.components.building.BuildingWindow").new(info)
		)
	end

	self:openEffect(t, func, delay)

end

--- 研究中心
function T:openStudyCenterEvent(t, delay, tag)
	local func = function()
		local info = require("src.app.model2.build.BuildingInfo")()
		if BuildingsInfoMgr:getBuildingInfos()[4] then
			info = BuildingsInfoMgr:getBuildingInfos()[4]
		else
			info.sid = 3
			info.remainingSec = 0
			info.location = 4
			info.level = 0
			info.id = nil
		end
		WindowManager:push(
			require("src.app.uiScript.components.building.BuildingWindow").new(info, tag)
		)
	end

	self:openEffect(t, func, delay)

end
--- 造钱厂
function T:openMoneyFactoryEvent(t, delay)


	local func = function()
		local info = require("src.app.model2.build.BuildingInfo")()
		if BuildingsInfoMgr:getBuildingInfos()[8] then
			info = BuildingsInfoMgr:getBuildingInfos()[8]
		else
			info.sid = 6
			info.remainingSec = 0
			info.location = 8
			info.level = 0
			info.id = nil
		end
		WindowManager:push(
			require("src.app.uiScript.components.building.BuildingWindow").new(info)
		)
	end

	self:openEffect(t, func, delay)


end
--- 机库1
function T:openPlaneFactoryOneEvent(t, delay, tag)
	local func = function()
		local info = require("src.app.model2.build.BuildingInfo")()
		if BuildingsInfoMgr:getBuildingInfos()[2] then
			info = BuildingsInfoMgr:getBuildingInfos()[2]
		else
			info.sid = 2
			info.remainingSec = 0
			info.location = 2
			info.level = 0
			info.id = nil
		end

		if BGMgr:isGuide() then
			tag=BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_HOMEPAGE_AIRCRAFT_FACTORY_1)
		end

		WindowManager:push(
			require("src.app.uiScript.components.aircraftFactory.AircraftFactoryWindow").new(info, tag)
		)
	end

	self:openEffect(t, func, delay)

end
--- 机库2
function T:openPlaneFacrtoryTwoEvent(t, delay, tag)
	local func = function()
		local info = require("src.app.model2.build.BuildingInfo")()
		if BuildingsInfoMgr:getBuildingInfos()[3] then
			info = BuildingsInfoMgr:getBuildingInfos()[3]
		else
			info.sid = 2
			info.remainingSec = 0
			info.location = 3
			info.level = 0
			info.id = nil
		end
		WindowManager:push(
			require("src.app.uiScript.components.aircraftFactory.AircraftFactoryWindow").new(info, tag)
		)
	end

	self:openEffect(t, func, delay)
end
--- 联盟
function T:openLegionEvent(t, delay)
	local func

	local id=UserInfo.allianceBox.myAlliance.id
	if id and id > 0 then
		local AllianceWindow=require("src.app.uiScript.components.alliance.AllianceWindow")

		local getDataSucc,openEffComp=false,false
		require("src.app.communication.alliance.GetMyAllianceInfoCommand")():exec(function(state)
			if state == ReturnCode.SUCCESS then
				if openEffComp then
					WindowManager:push(AllianceWindow.new())
				else
					getDataSucc=true
				end
			else
				MUIAlter.show({
					info=Language:get("ug791")
				})
			end
		end)

		func=function()
			if getDataSucc then
				WindowManager:push(AllianceWindow.new())
			else
				openEffComp=true
			end
		end
	else
		local AllianceHasNotWindow=require("src.app.uiScript.components.alliance.AllianceHasNotWindow")

		local getDataSucc,openEffComp=false,false
		local rBox=UserInfo.allianceBox.allianceRankBox
		rBox.rList=nil
		require("src.app.communication.alliance.GetAllianceRankListCommand")():exec(1,true,function(state)
			if state == ReturnCode.SUCCESS then
				if openEffComp then
					WindowManager:push(AllianceHasNotWindow.new())
				else
					getDataSucc=true
				end
			else
				MUIAlter_singleLine.show({
					info=ErrorCode:getErrInfo(state)
				},WindowManager:getCurrentWindow())
			end
		end)

		func=function()
			if getDataSucc then
				WindowManager:push(AllianceHasNotWindow.new())
			else
				openEffComp=true
			end
		end
	end
	self:openEffect(t, func, delay)
end

--- 改造工厂
function T:openMakeFactoryEvent(t, delay)
	local func = function()
		local info = require("src.app.model2.build.BuildingInfo")()
		if BuildingsInfoMgr:getBuildingInfos()[5] then
			info = BuildingsInfoMgr:getBuildingInfos()[5]
		else
			info.sid = 4
			info.remainingSec = 0
			info.location = 5
			info.level = 0
			info.id = nil
		end
		WindowManager:push(
			require("src.app.uiScript.components.aircraftFactory.AircraftFactoryWindow").new(info)
		)
	end

	self:openEffect(t, func, delay)
end

--- 竞技场
function T:openArenaEvent(t, delay)
	local func = function()
		require("src.app.communication.arena.GetArenaInfoCommand")():exec(
			function(state)
				WindowManager:push(
					require("src.app.uiScript.components.arena.ArenaWindow").new(state == ReturnCode.SUCCESS and 1 or 2)
				)
			end
		)
	end

	self:openEffect(t, func, delay)
end

--- 打开正要建的资源建筑    郊外
-- @param res table 一个sid组 可建造的
-- @param l 建造的位置
-- @param noBiuld
function T:openWaitBuildingResource(res, l, t, delay, noBuild)
	--     MUIAlter.show(
	--				{
	--					info = "打开正要建的资源建筑",
	--					size = 30,
	--				}
	--			)
	local func = nil
	if not res or not l then
		func = nil
		return
	else
		func = function()
			WindowManager:push(
				require("src.app.uiScript.components.building.resource.ResourceWindow").new(res,l)
			)
		end
	end


	self:openEffect(t, func, delay, true)
end

--- 打开已经建好了的资源建筑 郊外
function T:openBuildedResource(sid, l, t, delay)
	local func = function()
		local info = BuildingsInfoMgr:getBuildingInfos()[l]
		WindowManager:push(
			require("src.app.uiScript.components.building.BuildingWindow").new(info)
		)
	end

	self:openEffect(t, func, delay)
end

--- 跳转到主界面
function T:jumpToBase(t, delay)
	local func = function()
		HomePageManager:switchViewToBase()
	end

	self:openEffect(t, func, delay)
end

--- 切换到郊外
function T:jumpToOutSide(t, delay)
	local func = function()
		HomePageManager:switchViewToOutSide()
	end

	self:openEffect(t, func, delay)
end


function T:openTaskWindow(tag)

	WindowManager:push(
		require("src.app.uiScript.components.task.TaskWindow").new(tag)
	)
end

return T

--endregion
