--Author    : YuDing
--Date      : 2015/1/8
--Introduce : 左边工具条

local T = class("HomePageLeftBar", function() return ccui.Layout:create() end)

-- 本类派发的事件
T.nm = {
	["openTask"] = "openTask", -- 任务
	["openXX"] = "openXX",     -- 其他
}

--- 任务标记
T.taskTag = nil

T.textSize = cc.size(100, 26)

--- 进入主场景 特效时间
T.enterEffectTime = 0.5

--- 解锁 配件抽奖的等级
T.openPartLottery = 10

function T:ctor()
	mapping( self, LuaEventDispatcher)

	local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function( eventType )
				if CocosEvent.ENTER == eventType then
					self:onEnter()
				elseif CocosEvent.EXIT == eventType then
					self:onExit()
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				end

				self:luaDispatchEvent( eventType )
			end
		)
	end

	--self:setContentSize(cc.size(120, 500)) -- 自己设置的一个值 主要是要包括完vip按钮

	self:initConfig()
	self:initUI()
	self:registerEvent()
	self:flushTask()
	self:showGiftTime()
	--self:showReinforceTime()
	--self:showSignTag()
	self:showFixAndDynamicTag()
	self:updateArmyTask() -- 军队系列

	self:updateVipTag()

	self:updatePartLotteryTag()
	--self:initJoinAlliance()  -- 加入军团奖励

	self:updateWarnQueue()
	self:updateWarnInfo()
	self:updateMysteriousTag()

end

function T:onEnter()

end

function T:onExit()

end

function T:cleanUp()

	self:closeFlushTask()
	self:releasePulicEvent()

	if self.joinAlliance then
		self.joinAlliance:releaseEvent()
	end

end

function T:initConfig()
	if not self.cfg then
		self.cfg = require("src.app.uiScript.scenes.homePage.bar.LeftBarConfig")
	end
end

function T:initUI()
	local tb = {}

	local res = self.cfg.res

	-- 第一个（左边第一个）
	self.vip = ccui.Button:create()
	self.vip:loadTextures(res.vip[1], res.vip[2], "", ccui.TextureResType.plistType)
	self.vip.touchBeganSound=SoundRes.OPEN_FUNC_OF_BAR
	BaseButton:extend(self.vip)
	table.insert(tb, self.vip)

	--self.sign = ccui.Button:create()
	--self.sign:loadTextures(res.sign[1], res.sign[2], "", ccui.TextureResType.plistType)
	--self.sign.touchBeganSound=SoundRes.OPEN_FUNC_OF_BAR
	--BaseButton:extend(self.sign)
	--table.insert(tb, self.sign)


	self.task = ccui.Button:create()
	self.task:loadTextures(res.task[1], res.task[2], "", ccui.TextureResType.plistType)
	self.task.touchBeganSound=SoundRes.OPEN_FUNC_OF_BAR
	BaseButton:extend(self.task)

	table.insert(tb, self.task)

	self.activity = ccui.Button:create()
	self.activity:loadTextures(res.activity[1], res.activity[2], "", ccui.TextureResType.plistType)
	self.activity.touchBeganSound=SoundRes.OPEN_FUNC_OF_BAR
	BaseButton:extend(self.activity)
	table.insert(tb, self.activity)

	local l = PlayerInstance:getPlayerLevel()
	if l >= self.openPartLottery then -- 开放
		self.partLottery = self:createPartLottery()
	end

	if self.partLottery then
		table.insert(tb, self.partLottery)
	end

	self.gift = ccui.Button:create()
	self.gift:loadTextures(res.gift[1], res.gift[2], "", ccui.TextureResType.plistType)
	self.gift.touchBeganSound=SoundRes.NONE
	BaseButton:extend(self.gift)
	table.insert(tb, self.gift)

	self:addItemToContainer(tb)  -- 排序

	local giftText = XMLLabel()          -- 倒计时
	giftText:setContentSize(self.textSize)
	giftText:setHAlign("center")
	giftText:setVAlign("middle")
	giftText:setFontSize(16)

	self.gift:addChild(giftText)
	giftText:setString("")

	REL:toOther("center", "bottom", giftText, self.gift, 0, 0)
	self.gift.giftText = giftText

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_HOMEPAGE_TASK_BUTTON,self.task)
	end
end

-- 注册ui事件
function T:registerUIEvent()

	local clickHandler = function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		if t == self.task then
			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_HOMEPAGE_TASK_BUTTON)
			end

			self:onEventTaskClick()
		elseif t == self.gift then
			self:onEventMysteriousClick()
		elseif t == self.sign then
		--self:onEventSignClick()
		elseif t == self.vip then
			self:onEventVipClick()
		elseif t == self.activity then
			self:onEventActivityClick()
		end
	end

	self.task:addTouchEventListener(clickHandler)
	self.vip:addTouchEventListener(clickHandler)
	--self.sign:addTouchEventListener(clickHandler)
	self.gift:addTouchEventListener(clickHandler)
	self.activity:addTouchEventListener(clickHandler)
end

--- 注册派发的事件 本身的可以不用释放
function T:registerLocalEvent()
	self:luaAddEventListener(self.nm.openTask, self, self.onEventTaskClick)
	self:luaAddEventListener(self.nm.openXX, self, self.onEventClick)

end

--- 注册公用的事件 （需要释放）
function T:registerPublicEvent()
	-- 礼物时间
	SetStates.giftState:luaAddEventListener(SetStates.giftState.REMAIN_TIME, self, self.showGiftTime)
	SetStates.giftState:luaAddEventListener(SetStates.giftState.REMAIN_TIME, self, self.updateMysteriousTag)

	--SetStates.signManager:luaAddEventListener(SetStates.signManager.EVT_DAILY_ATTENDANCE_ALL_DATA_REFRESH, self, self.showSignTag)
	--SetStates.signManager:luaAddEventListener(SetStates.signManager.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH, self, self.showSignTag)

	-- 公告
	AnnounceManager:luaAddEventListener(AnnounceManager.EVT_ANNOUNCECRC_REFRESH , self, self.showFixAndDynamicTag)

	-- 活动
	local signInfo = ActivityManager.signInfo
	signInfo:luaAddEventListener(signInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. signInfo.sid , self, self.showFixAndDynamicTag)
	signInfo:luaAddEventListener(signInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. signInfo.sid , self, self.showFixAndDynamicTag)


	local openServerGiftInfo = ActivityManager.openServerGiftInfo
	openServerGiftInfo:luaAddEventListener(openServerGiftInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. openServerGiftInfo.sid , self, self.showFixAndDynamicTag)
	openServerGiftInfo:luaAddEventListener(openServerGiftInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. openServerGiftInfo.sid , self, self.showFixAndDynamicTag)


	local growthPlanInfo = ActivityManager.growthPlanInfo
	growthPlanInfo:luaAddEventListener(growthPlanInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. growthPlanInfo.sid , self, self.showFixAndDynamicTag)
	growthPlanInfo:luaAddEventListener(growthPlanInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. growthPlanInfo.sid , self, self.showFixAndDynamicTag)

	local gradePackageInfo = ActivityManager.gradePackageInfo
	gradePackageInfo:luaAddEventListener(gradePackageInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. gradePackageInfo.sid , self, self.showFixAndDynamicTag)
	gradePackageInfo:luaAddEventListener(gradePackageInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. gradePackageInfo.sid , self, self.showFixAndDynamicTag)

	local bigWheelInfo = ActivityManager.bigWheelInfo
	bigWheelInfo:luaAddEventListener(bigWheelInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. bigWheelInfo.sid , self, self.showFixAndDynamicTag)
	bigWheelInfo:luaAddEventListener(bigWheelInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. bigWheelInfo.sid , self, self.showFixAndDynamicTag)

    local bigWheelInfo2 = ActivityManager.bigWheelInfo2
	bigWheelInfo2:luaAddEventListener(bigWheelInfo2.EVT_ACTIVTIY_OPENVALUE_REFRESH .. bigWheelInfo2.sid , self, self.showFixAndDynamicTag)
	bigWheelInfo2:luaAddEventListener(bigWheelInfo2.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. bigWheelInfo2.sid , self, self.showFixAndDynamicTag)


	ArmyTaskQueueManager:luaAddEventListener(ArmyTaskQueueManager.EVT_HOMEPAGE_RIGHT_BAR, self, self.updateArmyTask)


	HomePageManager:luaAddEventListener(HomePageManager.noticeMessage.enterEffectMainStage, self, self.enterEffect) -- 开始进入特效
	HomePageManager:luaAddEventListener(HomePageManager.noticeMessage.enterEffectComplete, self, self.enterComplete) -- 完成进入特效



	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.vipPoint, self, self.updateVipTag) -- vip等级
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updatePartLottery) -- 配件抽奖

	SetStates.accessoryDrawCardState:luaAddEventListener(SetStates.accessoryDrawCardState.EVT_FREETIME_ENDTIME_REFRESH, self, self.updatePartLotteryTag) -- 配件抽奖提示
	SetStates.accessoryDrawCardState:luaAddEventListener(SetStates.accessoryDrawCardState.EVT_FREETIME_OVER, self, self.updatePartLotteryTag)

	local warnBox = WarnQueueManager.warnBox
	warnBox:luaAddEventListener(warnBox.EVT_ADD_SINGLE_QUEUE_REFRESH, self, self.updateWarnQueue)
	warnBox:luaAddEventListener(warnBox.EVT_REMOVE_SINGLE_QUEUE_REFRESH, self, self.updateWarnQueue)

	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
end
--- 释放公用的事件
function T:releasePulicEvent()
	SetStates.giftState:luaRemoveEventListener(SetStates.giftState.REMAIN_TIME, self, self.showGiftTime) -- 礼物时间
	SetStates.giftState:luaRemoveEventListener(SetStates.giftState.REMAIN_TIME, self, self.updateMysteriousTag)

	--SetStates.signManager:luaRemoveEventListener(SetStates.signManager.EVT_DAILY_ATTENDANCE_ALL_DATA_REFRESH, self, self.showSignTag)
	--SetStates.signManager:luaRemoveEventListener(SetStates.signManager.EVT_CONTINUE_ATTENDANCE_COUNT_REFRESH, self, self.showSignTag)

	-- 公告
	AnnounceManager:luaRemoveEventListener(AnnounceManager.EVT_ANNOUNCECRC_REFRESH , self, self.showFixAndDynamicTag)

	-- 活动
	local signInfo = ActivityManager.signInfo
	signInfo:luaRemoveEventListener(signInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. signInfo.sid , self, self.showFixAndDynamicTag)
	signInfo:luaRemoveEventListener(signInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. signInfo.sid , self, self.showFixAndDynamicTag)


	local openServerGiftInfo = ActivityManager.openServerGiftInfo
	openServerGiftInfo:luaRemoveEventListener(openServerGiftInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. openServerGiftInfo.sid , self, self.showFixAndDynamicTag)
	openServerGiftInfo:luaRemoveEventListener(openServerGiftInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. openServerGiftInfo.sid , self, self.showFixAndDynamicTag)

	local growthPlanInfo = ActivityManager.growthPlanInfo
	growthPlanInfo:luaRemoveEventListener(growthPlanInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. growthPlanInfo.sid , self, self.showFixAndDynamicTag)
	growthPlanInfo:luaRemoveEventListener(growthPlanInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. growthPlanInfo.sid , self, self.showFixAndDynamicTag)

	local gradePackageInfo = ActivityManager.gradePackageInfo
	gradePackageInfo:luaRemoveEventListener(gradePackageInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. gradePackageInfo.sid , self, self.showFixAndDynamicTag)
	gradePackageInfo:luaRemoveEventListener(gradePackageInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. gradePackageInfo.sid , self, self.showFixAndDynamicTag)

	local bigWheelInfo = ActivityManager.bigWheelInfo
	bigWheelInfo:luaRemoveEventListener(bigWheelInfo.EVT_ACTIVTIY_OPENVALUE_REFRESH .. bigWheelInfo.sid , self, self.showFixAndDynamicTag)
	bigWheelInfo:luaRemoveEventListener(bigWheelInfo.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. bigWheelInfo.sid , self, self.showFixAndDynamicTag)


    local bigWheelInfo2 = ActivityManager.bigWheelInfo2
	bigWheelInfo2:luaRemoveEventListener(bigWheelInfo2.EVT_ACTIVTIY_OPENVALUE_REFRESH .. bigWheelInfo2.sid , self, self.showFixAndDynamicTag)
	bigWheelInfo2:luaRemoveEventListener(bigWheelInfo2.EVT_ACTIVTIY_HOMEPAGE_TAG_REFRESH .. bigWheelInfo2.sid , self, self.showFixAndDynamicTag)


	ArmyTaskQueueManager:luaRemoveEventListener(ArmyTaskQueueManager.EVT_HOMEPAGE_RIGHT_BAR, self, self.updateArmyTask)

	HomePageManager:luaRemoveEventListener(HomePageManager.noticeMessage.enterEffectMainStage, self, self.enterEffect) -- 开始进入特效
	HomePageManager:luaRemoveEventListener(HomePageManager.noticeMessage.enterEffectComplete, self, self.enterComplete) -- 完成进入特效


	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.vipPoint, self, self.updateVipTag)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updatePartLottery)

	SetStates.accessoryDrawCardState:luaRemoveEventListener(SetStates.accessoryDrawCardState.EVT_FREETIME_ENDTIME_REFRESH, self, self.updatePartLotteryTag) -- 配件抽奖提示
	SetStates.accessoryDrawCardState:luaRemoveEventListener(SetStates.accessoryDrawCardState.EVT_FREETIME_OVER, self, self.updatePartLotteryTag)

	local warnBox = WarnQueueManager.warnBox
	warnBox:luaRemoveEventListener(warnBox.EVT_ADD_SINGLE_QUEUE_REFRESH, self, self.updateWarnQueue)
	warnBox:luaRemoveEventListener(warnBox.EVT_REMOVE_SINGLE_QUEUE_REFRESH, self, self.updateWarnQueue)

	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
end

-- 事件
function T:registerEvent()
	self:registerPublicEvent()
	self:registerLocalEvent()
	self:registerUIEvent()
end

--- 更新所有状态
function T:updateAllState()
	self:updateVipTag()
	self:showFixAndDynamicTag()
	self:updateArmyTask()
	--self:showSignTag()
	self:updatePartLottery()
	self:updatePartLotteryTag()

	TaskManager:flushData()
	self:showTaskTag()

	self:updateWarnQueue()
	self:updateWarnInfo()

	self:updateMysteriousTag()
end

--- 更新VIP状态
function T:updateVipTag()
	-- PlayerInstance:luaDispatchEvent(PlayerInstance.noticeMessage.vipPoint)

	local lvl = PlayerInstance:getVipLevel()

	local res = "vipNum%d.png"
	if lvl >= 10 then
		local ten = math.floor(lvl / 10)
		local unit = math.floor(lvl % 10)
		res = {string.format(res, ten), string.format(res, unit)}
	else
		res = string.format(res, lvl)
	end

	local loadRes = function(r)
		if type(r) == "table" then
			local ten = ccui.ImageView:create()
			ten:loadTexture(r[1], ccui.TextureResType.plistType)
			local size = ten:getContentSize()

			local unit = ccui.ImageView:create()
			unit:loadTexture(r[2], ccui.TextureResType.plistType)

			ten:addChild(unit)
			REL:toOther("left", "middle", unit, ten, size.width - 15, 0)

			return ten
		else
			local unit = ccui.ImageView:create()
			unit:loadTexture(r, ccui.TextureResType.plistType)

			return unit
		end
	end

	if not self.vipTag then
		self.vipTag = ccui.ImageView:create()
		self.vipTag:loadTexture("vipNumTag.png", ccui.TextureResType.plistType)
		self.vip:addChild(self.vipTag)
		REL:toOther("left", "middle", self.vipTag, self.vip, 0, 0)

		local size = self.vipTag:getContentSize()

		local vipNum = loadRes(res)
		self.vipTag:addChild(vipNum)
		if lvl >= 10 then
			REL:toOther("left", "middle", vipNum, self.vipTag, size.width - 12, 0) -- -2为微调
		else
			REL:toOther("left", "middle", vipNum, self.vipTag, size.width - 2, 0) -- -2为微调
		end

		self.vipTag.vipNum = vipNum
	else
		self.vipTag.vipNum:removeFromParent()

		local vipNum = loadRes(res)
		self.vipTag:addChild(vipNum)

		local size = self.vipTag:getContentSize()

		if lvl >= 10 then
			REL:toOther("left", "middle", vipNum, self.vipTag, size.width - 12, 0) -- -2为微调
		else
			REL:toOther("left", "middle", vipNum, self.vipTag, size.width - 2, 0) -- -2为微调
		end

		self.vipTag.vipNum = vipNum
	end

end

--- 更新任务状态
function T:showTaskTag(num)
	if not num then
		num = 0
		for k, v in pairs(UserInfo.task.onTaskInfos) do
			if v.finish == true then
				num = num + 1
				break -- 一旦有东西 就跳出循环
			end
		end
	end

	local normal = TaskManager:getDailyNormalTip()
	local alliance = TaskManager:getDailyAllianceTip()

	if num > 0 or normal == true or alliance == true then
		-- 有主线任务完成  或者是日常任务
		if not self.taskTag then
			local uiEff=ResLoader:createAnimationSpriteRandom("iconEff_blue",true)
			uiEff:setScale(0.66)
			self.task:addChild(uiEff)
			REL:toOther("center","middle",uiEff,self.task,0,0)
			self.taskTag2=uiEff

			self.taskTag = HomePageManager:getEff("promptEffect")
			self.task:addChild(self.taskTag)
			REL:toOther("right", "top", self.taskTag, self.task, self.cfg.tipDistance.x, self.cfg.tipDistance.y)
		end
	elseif num == 0 and normal == false and alliance == false then
		-- 没有任务完成
		if self.taskTag then
			self.taskTag:removeFromParent()
			self.taskTag = nil

			self.taskTag2:removeFromParent()
			self.taskTag2 = nil
		end
	end
end

--- 显示所有活动标识
function T:showFixAndDynamicTag()
	local state = ActivityManager:judgeHomePage()
	local announceState = AnnounceManager:judgeIsAnnounceInfo()

	if state == true or announceState == true then
		if not self.fixAndDynamicTag then
			self.fixAndDynamicTag = HomePageManager:getEff("promptEffect")
			self.activity:addChild(self.fixAndDynamicTag)

			REL:toOther("right", "top", self.fixAndDynamicTag, self.activity, self.cfg.tipDistance.x, self.cfg.tipDistance.y)
		end
	else
		if self.fixAndDynamicTag then
			self.fixAndDynamicTag:removeFromParent()
			self.fixAndDynamicTag = nil
		end
	end

end

--- 0.5s刷新一次任务
function T:flushTask()
	if self.taskSchduleId then
		return
	end

	local func = function()
		self:showTaskTag()
	end

	self.taskSchduleId = Cocos2dxUtils:interval(func, 0.5)
end

--- 礼物时间显示
function T:showGiftTime(t)
	if not t then
		t = SetStates.giftState:getTime()
	end

	self:generalSetTime(t, self.gift.giftText)
end

function T:generalSetTime(t, textNode)
	if not t then
		t = 0
	end

	local h = math.floor(t / 3600)
	local m = math.floor(math.floor(t % 3600) / 60)
	local n = math.floor(t % 60)

	if m == 60 then
		m = 59
	end

	if n == 60 then
		n = 59
	end

	if textNode then
		textNode:setString(string.format("%02d", h) .. ":" .. string.format("%02d", m) .. ":" .. string.format("%02d", n))
	end

end


function T:closeFlushTask()
	if self.taskSchduleId then
		Scheduler:unscheduleScriptEntry(self.taskSchduleId)
		self.taskSchduleId = nil
	end
end

--- 配件抽奖
function T:updatePartLottery()
	local l = PlayerInstance:getPlayerLevel()
	if l >= self.openPartLottery then
		if not self.partLottery then

			local tmp = self.gift:getContentSize()               -- 调整神秘礼物的位置
			local distance = self.cfg.distanceRes + tmp.height

			self.partLottery = self:createPartLottery()
			self:addChild(self.partLottery)
			REL:toOther("left", "top", self.partLottery, self.activity, 0, distance) -- 设置距离

			--local move = cc.EaseBackOut:create(cc.MoveBy:create(0.3, cc.p(0, distance)))

			REL:toOther("left", "top", self.gift, self.partLottery, 0, distance)
			--self.gift:runAction(move)

			if self.armyTask then -- 调整军队位置
				REL:toOther("left", "top", self.armyTask, self.gift, 0, distance)
				--self.armyTask:runAction(move)
			end


		end
	end
end

--- 更新标记
function T:updatePartLotteryTag()
	if self.partLottery then
		if SetStates.accessoryDrawCardState:judgeHomePage() then
			-- 有标记
			if not self.partLotteryTag then
				self.partLotteryTag = HomePageManager:getEff("promptEffect")
				self.partLottery:addChild(self.partLotteryTag)
				REL:toOther("right", "top", self.partLotteryTag, self.partLottery, self.cfg.tipDistance.x, self.cfg.tipDistance.y)
			end
		else
			if self.partLotteryTag then
				self.partLotteryTag:removeFromParent()
				self.partLotteryTag = nil
			end
		end
	end
end

--- 更新神秘奖励标记
function T:updateMysteriousTag()
	if SetStates.giftState:getTime() == 0 then
		-- 有标记
		if not self.mysteriousTag then
			self.mysteriousTag = HomePageManager:getEff("promptEffect")
			self.gift:addChild(self.mysteriousTag)
			REL:toOther("right", "top", self.mysteriousTag, self.gift, self.cfg.tipDistance.x, self.cfg.tipDistance.y)
		end
	else
		if self.mysteriousTag then
			self.mysteriousTag:removeFromParent()
			self.mysteriousTag = nil
		end
	end
end

--- 创建
function T:createPartLottery()
	local partLottery = ccui.Button:create()
	partLottery:loadTextures("homePartLottery.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
	partLottery.touchBeganSound = SoundRes.OPEN_FUNC_OF_BAR
	BaseButton:extend(partLottery)

	partLottery:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		self:onEventPartLotteryClick()

	end)

	return partLottery
end

--- 更新 军队系列功能
function T:updateArmyTask()
	local t = ArmyTaskQueueManager:getData()
	local res = self.cfg.res

	if not t then
		if self.armyTask then
			self.armyTask:removeFromParent()
			self.armyTask = nil
		end
	else
		if not self.armyTask then  -- 没有
			self.armyTask = ccui.Button:create()
			self.armyTask:loadTextures(res.armyTask[4], res.armyTask[4], "", ccui.TextureResType.plistType)
			BaseButton:extend(self.armyTask)

			if BGMgr:isGuide() then
				BGMgr:regGuideObj(BGMgr.TGR_HOMEPAGE_ARMY_TASK_BUTTON,self.armyTask)
			end

			self.armyTask:addTouchEventListener(function(t, e)
				if e ~= ccui.TouchEventType.ended then return end

				if BGMgr:isGuide() then
					BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_HOMEPAGE_ARMY_TASK_BUTTON)
				end

				WindowManager:push(
					require("src.app.uiScript.components.army.ArmyWindow").new({["tag"] = 1},2)
				)
			end)

			local distance = self.cfg.distanceRes  -- 两个组件之间的距离 5 个像素
			local tmp = self.activity:getContentSize()        -- 取vip图片的宽度
			self:addChild(self.armyTask)

			local armyTaskText = XMLLabel()          -- 倒计时
			armyTaskText:setContentSize(self.textSize)
			armyTaskText:setHAlign("center")
			armyTaskText:setVAlign("middle")
			armyTaskText:setFontSize(16)

			--self:createBarTextBack(self.armyTask)

			self.armyTask:addChild(armyTaskText)
			armyTaskText:setString("000")

			if self.warnTag then
				REL:toOther("left", "top", self.armyTask, self.warnTag, 0, distance + tmp.height) -- 设置距离
			else
				REL:toOther("left", "top", self.armyTask, self.gift, 0, distance + tmp.height) -- 设置距离
			end



			REL:toOther("center", "bottom", armyTaskText, self.armyTask, 0, 0)



			self.armyTask.armyTaskText = armyTaskText
		end

		if t.status == 1 then
			-- 图片为armyAttackIcon.png
			local time = t.remainingSec-- 显示时间
			self.armyTask:loadTextureNormal(res.armyTask[1], ccui.TextureResType.plistType)

			self:generalSetTime(time, self.armyTask.armyTaskText)

			REL:toOther("center", "bottom", self.armyTask.armyTaskText, self.armyTask, 0, 0)
		elseif t.status == 3 then
			-- 图片为armyBackIcon.png
			local time = t.remainingSec --显示时间
			self.armyTask:loadTextureNormal(res.armyTask[3], ccui.TextureResType.plistType)

			self:generalSetTime(time, self.armyTask.armyTaskText)

			REL:toOther("center", "bottom", self.armyTask.armyTaskText, self.armyTask, 0, 0)
		else
			-- 图片为armyQuarteringIcom.png
			self.armyTask:loadTextureNormal(res.armyTask[2], ccui.TextureResType.plistType)
			-- 显示百分比

			if t.remainingSec <= 0 then
				-- 直接显示100%
				self.armyTask.armyTaskText:setString("100%")
			else
				local allTime = ArmyTaskQueueManager:getStationAllTime(t)
				local time = t.remainingSec
				local nowRes = ArmyTaskQueueManager:getHaveStationLoad(t, allTime - time)  -- nowRes是百分比
				local allRes = ArmyTaskQueueManager:getStationLoad(t.armyExpeditionAircrafts)

				local percent = 0
				if math.floor(nowRes / allRes * 100) == 0 then
					percent = 1
				else
					percent = math.floor(nowRes / allRes * 100)
				end


				self.armyTask.armyTaskText:setString(percent .. "%")

			end

			REL:toOther("center", "bottom", self.armyTask.armyTaskText, self.armyTask, 0, 0)
		end


	end
end

--- 更新攻击警告
function T:updateWarnQueue()
	local warnBox = WarnQueueManager.warnBox
	local judge = warnBox:judgeQueue()
	if judge then
		if not self.warnTag then
			local warnTag = ccui.Button:create()
			local iconPath = IconManager.iconPath
			warnTag:loadTextures("beAttack.png","beAttack.png","",ccui.TextureResType.plistType)
			warnTag.touchBeganSound = SoundRes.OPEN_FUNC_OF_BAR
			BaseButton:extend(warnTag)
			self:addChild(warnTag)

			warnTag:addTouchEventListener(function(t, e)
				if e ~= ccui.TouchEventType.ended then return end
				-- 这个弹出窗口
				local layout = require("src.app.uiScript.components.warn.WarnPopWindow").new()
				local muialter2 = MUIAlter_custom.show(
					{
						info = layout,
						flag = 4,
						callback = function(flag)
						end
					}
				)

				layout:setMUIAlter2(muialter2)

			end)

			local tmp = self.gift:getContentSize()
			local distance = self.cfg.distanceRes + tmp.height
			REL:toOther("left", "top", warnTag, self.gift, 0, distance) -- 设置距离
			self.warnTag = warnTag

			if self.armyTask then -- 调整军队位置
				REL:toOther("left", "top", self.armyTask, self.warnTag, 0, distance)
			end


		end

	else
		if self.warnTag then
			self.warnTag:removeFromParent()
			self.warnTag = nil

			if self.armyTask then -- 调整军队位置
				local tmp = self.gift:getContentSize()
				local distance = self.cfg.distanceRes + tmp.height
				REL:toOther("left", "top", self.armyTask, self.gift, 0, distance)
			end

		end
	end

end

--- 更新警告弹出信息
function T:updateWarnInfo()
	local warnBox = WarnQueueManager.warnBox
	local judge = warnBox:judgeQueue()
	if judge then
		-- 添加警告信息
		local descripe = Language:get("uc866")
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1,popSnd = SoundRes.SOUND_WARNING } )
	end
end

function T:createBarTextBack(object, size)
	if not size then -- 默认
		size = cc.size(68, 22)
	end

	local back = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("homeBarTextBack.png"))
	--local back = ccui.ImageView:create()
	--back:loadTexture("homeBarTextBack.png", ccui.TextureResType.plistType)
	back:setContentSize(size)
	object:addChild(back)
	REL:toOther("center", "bottom", back, object, 0, 0)
end

--- 配件 抽奖
function T:onEventPartLotteryClick()
	WindowManager:push(
		require("src.app.uiScript.components.accessoryDrawCard.AccessoryDrawCardWindow").new()
	)
end

--- 打开任务
function T:onEventTaskClick()
	HomeOpenWindowManager:openTaskWindow()
end

function T:onEventActivityClick()
	WindowManager:push(
		require("src.app.uiScript.components.allActivity.fixAndDynamic.ActivityMainWindow").new()
	)
end

function T:onEventSignClick()
--WindowManager:push(
--require("src.app.uiScript.components.allActivity.sign.SignWindow").new()
--)
end

function T:onEventMysteriousClick()
	local m = require("src.app.uiScript.scenes.homePage.mysteriousGift.MysteriousGiftWindow").new()
	MUIAlter.show(
		{
			info = m,
			size = 30,
			flag = 4,
			title = Language:get("uy137"),
			isShowCloseButton = true,
		}
	)
end

--- vip 点击
function T:onEventVipClick()
	WindowManager:push(
		require("src.app.uiScript.components.vip.VIPWindow").new()
	)
end

-- 调位置
-- @param t 相对于t调位置
function T:initView(t)
	REL:toOther("left", "top", self, t, self.cfg.relDistance.x, self.cfg.relDistance.y)
	self:initEnterEffect()
end

function T:initEnterEffect()
	self:setTouchCanNotTouch()
	local size = self:getContentSize()
	local px, py = self:getPosition()
	self.oldWidgetPP = cc.p(px, py)

	self:setPosition(px - size.width - 10, py) -- 刚开始在实现之外
end

function T:enterEffect()
	local all = HomePageManager:getStartEffectTime()

	local ac = cc.Sequence:create(cc.DelayTime:create(all - self.enterEffectTime), cc.MoveTo:create(self.enterEffectTime, self.oldWidgetPP))
	self:runAction(ac)
end

--- 设置不能点击
--- 主容器 屏蔽下面的事件  就可以实现这个效果
function T:setTouchCanNotTouch()
	self:setTouchEnabled(true)
end

function T:setTouchCanTouch()
	self:setTouchEnabled(false)
end

--- 进入完成
function T:enterComplete()
	self:setTouchCanTouch()
end


function T:addItemToContainer(tb)
	local height = 0
	local distance = self.cfg.distanceRes -- 两个组件之间的距离 5 个像素
	local allDistance = 0
	if #tb == 0 then return end

	for i = 1, #tb do
		local sz = tb[i]:getContentSize()
		height = height + sz.height
	end

	if #tb > 1 then -- 加上距离
		allDistance = distance * (#tb - 1)
		height = allDistance + height
	end

	local tmp = tb[1]:getContentSize()

	self:setContentSize(cc.size(tmp.width, height))    -- tmp.width 取的图片的一个宽度，因为都相等 height 为总高度

	local s = self:getContentSize()

	-- 依次放入 self 中
	local n = #tb
	for i = 1, n do
		local sz = tb[i]:getContentSize()
		if i > 1 then
			s.height = s.height - sz.height - distance
		else
			s.height = s.height - sz.height
		end
		self:addChild(tb[i])
		--tb[i]:setPosition(cc.p(0, s.height))
		REL:toOther("left", "bottom", tb[i], self, 0, s.height)
	end
end
return T
