--region HomePageRightBar.lua
--Author    : YuDing
--Date      : 2015/1/15
--Introduce : 右边条目

local T = class("T", function() return ccui.Layout:create() end)

--资源BUFF0/5
--战斗BUFF0/8 
--科技0/1 *
--建造飞机0/(1或2，根据机库数量) *
--建造建筑0/2

--- 当前状态 0 hide 1 show
T.state = nil

--- 两个icon之间的距离
T.iconDistance = 72

--- 背景框的默认大小
T.backDefaultSize = cc.size(40, 22)

--- 时间的时候 大小
T.backTimeSize = cc.size(68, 22)

----- 晃动时间
--T.shakeTime = 0.1
----- 晃动角度
--T.shakeAngle = 10
----- 晃动次数
--T.shakeNum = 3

T.textSize = cc.size(100, 26)


-- 提示信息
T.noticeMessage = {
	hide = "hide",   -- 收起来
	show = "show",   -- 展示出来
}

T.showTaget = nil

T.pos = {
	resourceBuff = 1,
}

-- 资源buff
T.resourceBuff = nil
-- 战斗buff
T.battleBuff = nil
-- 科技
T.tech = nil
-- 建筑飞机
T.plane = nil
-- 建筑
T.bld = nil

T.enterEffectTime = 0.5

function T:ctor()
	mapping(self, LuaEventDispatcher)

	local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function( eventType )
				if CocosEvent.ENTER == eventType then
				elseif CocosEvent.EXIT == eventType then
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				end

				self:luaDispatchEvent( eventType )
			end
		)
	end

	self:initUI()
	self:registerPublicEvent()
	self:updateBuffText()
	self:updateTechText()
	self:updatePlaneText()
	self:updateBldText()
	self:updateSmoothRemind()

	self:onShowEvent()
end


function T:cleanUp()
	self:releasePublicEvent()

	--    if self.shakeSchduleId then  -- 移除侦听
	--        Cocos2dxUtils:clearScheduler(self.shakeSchduleId)
	--        self.shakeSchduleId = nil
	--    end

	if self.smoothSchduleId then
		Cocos2dxUtils:clearScheduler(self.smoothSchduleId)
		self.smoothSchduleId = nil
	end

end

function T:initUI()

	--    self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--    self:setBackGroundColor(cc.c3b(0xff,0,0))
	--    self:setBackGroundColorOpacity(100)


	self.mainBtn = ccui.ImageView:create() -- 主按钮
	self.mainBtn.touchBeganSound = SoundRes.SND_LIST_SCALE_IN_OUT
	--self.mainBtn:loadTextures("barOfPopUp.png", "barOfPopDown.png", "", ccui.TextureResType.plistType)
	self.mainBtn:loadTexture("barOfPopDown.png", ccui.TextureResType.plistType)


	self.mainBtn:setLocalZOrder(1)

	local size = self.mainBtn:getContentSize()

	self:setContentSize(cc.size(size.width, 500)) -- 500是取一个最大值
	--    		self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--			self:setBackGroundColor(cc.c3b(random(0,255),0,0))
	--			self:setBackGroundColorOpacity(100)


	BaseButton:extend(self.mainBtn)
	self:addChild(self.mainBtn)
	REL:toOther("left", "top", self.mainBtn, self, 0, 0)

	self.state = 0 -- 默认是 hide

	self.mainBtn:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then return end

		--        AudioManager:playEffect(SoundRes.SND_LIST_SCALE_IN_OUT)
		if self.state == 0 then
			self:onShowEvent()
		elseif self.state == 1 then
			self:onHideEvent()
		end
	end)


	self:createBuff()        -- 创建 ui
	self:createBattleBuff()
	if PlayerInstance:getBuildingLvl(PlayerInstance.fixedBldLocation.study) > 0 then -- 检测开放没有
		self:createTech()
	end
	if PlayerInstance:getBuildingLvl(PlayerInstance.fixedBldLocation.planeOne) > 0 or PlayerInstance:getBuildingLvl(PlayerInstance.fixedBldLocation.planeTwo) > 0 then
		self:createPlane()
	end
	self:createBld()

	self:updateShowTargetVisble(false) -- 刚开始是关闭状态
end

function T:initPosition()
	local tmp = {self.resourceBuff, self.battleBuff, self.tech, self.plane, self.bld}
	for k, v in pairs(tmp) do
		if v then
			REL:toOther("center", "middle", v, self.mainBtn, 0, 0) -- 置于mainbtn的中心点处
		end
	end
end

--- 创建
function T:createBuff()
	self.resourceBuff = ccui.Button:create() -- 资源buff
	BaseButton:extend(self.resourceBuff)
	self.resourceBuff:loadTextures("barOfResource.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
	self:addChild(self.resourceBuff)

	self.resourceBuff:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		WindowManager:push(
			require("src.app.uiScript.components.warehousestorage.WarehousestorageWindow").new()
		)
	end)

	self.resourceText = self:createText()
	self.resourceText:setString("0/5")

	--self:createBarTextBack(self.resourceBuff)

	self.resourceBuff:addChild(self.resourceText)

	REL:toOther("center", "bottom", self.resourceText, self.resourceBuff, 0, 0)
end

--- 更新 创建
function T:updateOpenTech()
	if self.tech then return end
	self:createTech()

	if self.state == 0 then  -- 关闭着的
		self:onShowEvent()
	elseif self.state == 1 then -- 打开着的

		self.tech.showPos = 3   -- 固定位置

		REL:toOther("center", "middle", self.tech, self.mainBtn, 0, -self.iconDistance * self.plane.showPos)


		if self.plane then
			self.plane.showPos = self.plane.showPos + 1
			self:updatePosition(self.plane, self.plane.showPos - 1, self.plane.showPos)
		end

		if self.bld then
			self.bld.showPos = self.bld.showPos + 1
			self:updatePosition(self.bld, self.bld.showPos - 1, self.bld.showPos)
		end

	end

end

function T:updateBuffText()
	local list=BuffQueueInfoMgr:getItems()
	local resourceBuff = 0
	local battleBuff = 0
	for k,v in pairs(list) do
		if v.remainingSec > 0 then
			if k <= 5 then
				resourceBuff = resourceBuff + 1
			elseif k > 5 and k <= 13 then
				battleBuff = battleBuff + 1
			end
		end
	end

	self.resourceText:setString(resourceBuff .. "/5")
	self.battleText:setString(battleBuff .. "/8")
end

function T:updateTechText(v)
	local num, max = 0, 0
	num, max = self:getCurrentNumByTag(self.tech)

	if max == 0 then
		return
	end

    local vipNum = VipManager:getVipTechQueueCount()
    local max = vipNum

	if num == max then
		if v then
			if TechnologiesInfoMgr:checkMinTimeId() == v.technologySid then -- 最小的时间
				self:generalSetTime(v.remainingSec, self.techText)
			end
		end
	else
		self.techText:setString(tostring(num) .. "/" .. tostring(max))
	end


end

function T:updatePlaneText(v)
	local num, max = 0, 0
	num, max = self:getCurrentNumByTag(self.plane)

	if max == 0 then
		return
	end

    local vipNum = VipManager:getVipTechQueueCount()
    local max = max * vipNum

	if num == max then
		if v then
			if AircraftProduceQueueMgr:checkMinTimeId() == v.id then -- 最小的时间
				self:generalSetTime(v.remainingSec, self.planeText)
			end
		end
	else
		self.planeText:setString(tostring(num) .. "/" .. tostring(max))
	end

end

function T:updateBldText(v)
    if type(v) ~= "table" then
        self.bldText:setString(Language:get("uc1043",PlayerInstance:getBuildQueueAllCount()))
        return
    end

	local num, max = 0, 0
	num, max = self:getCurrentNumByTag(self.bld)

	if max == 0 then
		return
	end

	if num == max then
		if v then
			if BuildingsInfoMgr:checkMinTimeId() == v.buildingId then -- 最小的时间
				self:generalSetTime(v.remainingSec, self.bldText)
			end
		end
	else
		self.bldText:setString(tostring(num) .. "/" .. tostring(max))
	end

end

function T:updateOpenPlane()
	if self.plane then return end
	self:createPlane()

	if self.state == 0 then  -- 关闭着的
		self:onShowEvent()
	elseif self.state == 1 then -- 打开着的
		if self.tech then
			self.plane.showPos = 4
	else
		self.plane.showPos = 3
	end

	REL:toOther("center", "middle", self.plane, self.mainBtn, 0, -self.iconDistance * self.plane.showPos)

	if self.bld then  -- 后退1格
		self.bld.showPos = self.bld.showPos + 1
		self:updatePosition(self.bld, self.bld.showPos - 1, self.bld.showPos)
	end
	end


end

--- 根据标识 获取当前的数量
function T:getCurrentNumByTag(t)
	if not t then
		return 0, 0, nil
	end

	if t == self.tech then
		local max = 1
		local queue = TechnologiesInfoMgr:getQueue()

		if not self.techText then
			return 0, 0, false
		end

		local b = 0
		if queue then
			for k, v in pairs(queue) do
				if v then
					b = b + 1
				end
			end
		end

		if b > 0 then
			return b, max, true -- 当前值 最大值 可以有晃动的特效
		else
			return 0, max, false
		end

	elseif t == self.plane then
		if not self.planeText then
			return 0, 0, false
		end
		local num = 0
		local lvl = PlayerInstance:getBuildingLvl(PlayerInstance.fixedBldLocation.planeOne)
		if lvl >= 1 then
			num = num + 1
		end

		lvl = PlayerInstance:getBuildingLvl(PlayerInstance.fixedBldLocation.planeTwo)
		if lvl >= 1 then
			num = num + 1
		end

		local list = AircraftProduceQueueMgr:getQueueItems()
		local tmp = {}
		for k,v in pairs(list) do  -- k是id
			local l = v:getLocation()
			if l == PlayerInstance.fixedBldLocation.planeOne or l == PlayerInstance.fixedBldLocation.planeTwo then
				tmp[l] = 1
			end
		end

		local nm = 0
		for k, v in pairs(tmp) do
			nm = nm + 1
			if nm > 2 then nm = 2 end
		end

		if nm >= num then
			return nm, num, true
		else
			return nm, num, false
		end

	elseif t == self.bld then
		local max = PlayerInstance:getBuildQueueAllCount()
		local list = BuildingsInfoMgr:getBuildQueue()
		local num  = 0

		for k, v in pairs(list) do
			num = num + 1
		end

		if num >= max then
			return num, max, true
		else
			return num, max, false
		end

	end
end

-- @param t 对象
-- @param b begin
-- @param e end
-- @param v 是否隐藏
function T:updatePosition(t, b, e, v)
	local distance = self.iconDistance
	local d = distance * (b - e)
	local move = cc.MoveBy:create(0.3, cc.p(0,d))

	t:getActionManager():removeActionByTag(11, t) -- 移除动作

	if v == false then  -- 有隐藏动作
		if e > b then
			move = cc.EaseBackOut:create(move)
	end

	local ac = cc.Sequence:create(
		move,
		cc.CallFunc:create(function()  -- 隐藏
			t:setTouchEnabled(false)
			t:setVisible(false)
			--self:removeBldRemindEff(t)
		end)
	)
	ac:setTag(11)

	t:runAction(ac)

	else -- 无隐藏动作

		if e > b then
			local easeBackOut = cc.EaseBackOut:create(move) -- 回弹
			easeBackOut:setTag(11)

			t:runAction(easeBackOut)
			--self:createBldRemindEff(t)
	else
		move:setTag(11)

		t:runAction(move)
	end
	end
end

function T:updatePos()
	local tmp = 1
	local tb = {self.resourceBuff, self.battleBuff, self.tech, self.plane, self.bld}

	for k, v in pairs(tb) do
		if v then
			v.showPos = tmp
			tmp = tmp + 1
		end
	end
end

function T:updateShowTargetVisble(v)
	local tmp = {self.resourceBuff, self.battleBuff, self.tech, self.plane, self.bld}

	for k, n in pairs(tmp) do
		if n then
			n:setTouchEnabled(v)
			n:setVisible(v)
		end
	end
end

--- 显示 事件
function T:onShowEvent()
	local tmp = {self.resourceBuff, self.battleBuff, self.tech, self.plane, self.bld}
	for k, v in pairs(tmp) do -- 防止bug出现
		if v then
			v:stopActionByTag(11)
	end
	end

	self:updateShowTargetVisble(true)
	self:updatePos()

	for k, v in pairs(tmp) do
		if v then
			REL:toOther("center", "middle", v, self.mainBtn, 0, 0)
			self:updatePosition(v, 0, v.showPos)
		end
	end


	self.state = 1

	--self.mainBtn:setDownState()
	self.mainBtn:loadTexture("barOfPopUp.png", ccui.TextureResType.plistType)

	REL:toOther("left", "top", self.mainBtn, self, 0, 0)
end

--- 收回 事件
function T:onHideEvent()
	local tmp = {self.resourceBuff, self.battleBuff, self.tech, self.plane, self.bld}
	for k, v in pairs(tmp) do -- 防止快速点击bug出现
		if v then
			v:stopActionByTag(11)
	end
	end


	for k, v in pairs(tmp) do
		if v then
			self:updatePosition(v, v.showPos, 0, false)
		end
	end

	--    self:runAction(cc.Sequence:create({
	--		cc.DelayTime:create(0.2),
	--		cc.CallFunc:create(function()
	--			self:updateShowTargetVisble(false)
	--		end)
	--	}))

	self.state = 0

	--self.mainBtn:setNormalState()
	self.mainBtn:loadTexture("barOfPopDown.png", ccui.TextureResType.plistType)
	REL:toOther("left", "top", self.mainBtn, self, 0, 0)
end

function T:createBattleBuff()
	self.battleBuff = ccui.Button:create() -- 战斗
	--self.battleBuff:setAnchorPoint(cc.p(0.5, 1))

	BaseButton:extend(self.battleBuff)
	self.battleBuff:loadTextures("homeBattleBuff.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
	self:addChild(self.battleBuff)

	self.battleBuff:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		WindowManager:push(
			require("src.app.uiScript.components.warehousestorage.WarehousestorageWindow").new(2)
		)
	end)

	self.battleText = self:createText()
	self.battleText:setString("0/8")

	--self:createBarTextBack(self.battleBuff)

	self.battleBuff:addChild(self.battleText)
	REL:toOther("center", "bottom", self.battleText, self.battleBuff, 0, 0)
end

function T:createBarTextBack(object, size)
	if not size then -- 默认
		size = self.backDefaultSize
	end

	local back = Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("homeBarTextBack.png"))
	--local back = ccui.ImageView:create()
	--back:loadTexture("homeBarTextBack.png", ccui.TextureResType.plistType)
	back:setContentSize(size)
	object:addChild(back)

	object.textBack = back
	REL:toOther("center", "bottom", back, object, 0, 0)
end

function T:createTech()
	self.tech = ccui.Button:create() -- 科技
	-- self.tech:setAnchorPoint(cc.p(0.5, 1))

	BaseButton:extend(self.tech)
	self.tech:loadTextures("barOfTechList.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
	self:addChild(self.tech)

	self.tech:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		HomeOpenWindowManager:openStudyCenterEvent(nil, nil, 2)
	end)

	self.techText = self:createText()
	self.techText:setString("0/1")

	--self:createBarTextBack(self.tech)

	self.tech:addChild(self.techText)
	REL:toOther("center", "bottom", self.techText, self.tech, 0, 0)
end

function T:createPlane()
	self.plane = ccui.Button:create() -- 飞机

	BaseButton:extend(self.plane)
	self.plane:loadTextures("barOfProducePlane.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
	self:addChild(self.plane)

	self.plane:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then
			return
		end

		local list = AircraftProduceQueueMgr:getQueueItems()
		local maxCount = VipManager.getVipProduceQueueCount()

		--战机工厂1的位置,战机工厂2的位置
		local af1Loc,af2Loc=PlayerInstance.fixedBldLocation.planeOne,PlayerInstance.fixedBldLocation.planeTwo

		--战机工厂1正在生产的项目数,战机工厂2正在生产的项目数
		local af1Count,af2Count=0,0
		for k, v in pairs(list) do
			if v.location == af1Loc then
				af1Count = af1Count + 1
			else
				af2Count = af2Count + 1
			end
		end

		--如果战机工厂1的等级>=战机工厂2的等级
		if PlayerInstance:getBuildingLvl(af1Loc) >= PlayerInstance:getBuildingLvl(af2Loc) then
			--如果战机工厂1生产队列已满,且战机工厂2生产队列未满
			if af1Count >= maxCount and af2Count < maxCount then
				HomeOpenWindowManager:openPlaneFacrtoryTwoEvent(nil, nil, 2)
			else
				HomeOpenWindowManager:openPlaneFactoryOneEvent(nil, nil, 2)
			end
		else
			if af2Count >= maxCount and af1Count < maxCount then
				HomeOpenWindowManager:openPlaneFactoryOneEvent(nil, nil, 2)
			else
				HomeOpenWindowManager:openPlaneFacrtoryTwoEvent(nil, nil, 2)
			end
		end
	end)

	self.planeText = self:createText()
	self.plane:addChild(self.planeText)
	REL:toOther("center", "bottom", self.planeText, self.plane, 0, 0)
end

function T:createBld()
	self.bld = ccui.Button:create() -- 建筑
	--self.bld:setAnchorPoint(cc.p(0.5, 1))
	BaseButton:extend(self.bld)
	self.bld:loadTextures("barOfBldList.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
	self:addChild(self.bld)

	self.bld:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		WindowManager:push(
			require("src.app.uiScript.components.warehousestorage.WarehousestorageWindow").new(3)
		)
	end)


	self.bldText = self:createText()
	self.bldText:setString(Language:get("uc1043",PlayerInstance:getBuildQueueAllCount()))

	self.bld:addChild(self.bldText)

	REL:toOther("center", "bottom", self.bldText, self.bld, 0, 0)
end

function T:createBldRemindEff(t)
	if not t then
		return
	end

	if t.shakeAction == true then  -- 已经存在
		return
	end
	t:getActionManager():removeActionByTag(12, t)

	local tb = {}
	for i = 1, self.shakeNum do
		table.insert(tb, cc.RotateTo:create(self.shakeTime, -self.shakeAngle))
		table.insert(tb, cc.RotateTo:create(self.shakeTime, 0))
		table.insert(tb, cc.RotateTo:create(self.shakeTime, self.shakeAngle))
		table.insert(tb, cc.RotateTo:create(self.shakeTime, 0))
	end

	table.insert(tb, cc.DelayTime:create(1))

	local ac = cc.RepeatForever:create(cc.Sequence:create(tb))
	ac:setTag(12)
	t:runAction(ac)


	t.shakeAction = true  -- 增加t.remindAction 字段
end

function T:removeBldRemindEff(t)
	if not t then
		return
	end

	if t.shakeAction == false then  -- 已经存在
		return
	end

	t:getActionManager():removeActionByTag(12, t) -- 移除动作
	t:getActionManager():removeActionByTag(13, t) -- 移除动作

	local r = cc.RotateTo:create(0.01, 0) -- 停止
	t:runAction(r)
	t:setTag(13)

	t.shakeAction = false
end

--- 增加溜光特效
function T:createSmoothEff(t)
	if not t then
		return
	end

	if not t.smoothEffect then
		t.smoothEffect = HomePageManager:addEffect(t, "smooth")
	end

end

--- 移除溜光特效
function T:removeSmoothEff(t)
	if t.smoothEffect then
		t.smoothEffect:removeFromParent()
		t.smoothEffect = nil
	end
end

--- 更新溜光提示
function T:updateSmoothRemind()
	if self.smoothSchduleId then
		return
	end

	local funcState = function(state, t)
		if t then  -- 如果存在
			if state == false then -- 设置是有效果的
				local v = t:isVisible()
				if v == true then --可见
					local _, max, r = self:getCurrentNumByTag(t)
					if r == true and max ~= 0  then -- 达到最大值
						self:removeSmoothEff(t)
					elseif r == false then
						self:createSmoothEff(t)
					end
				else -- 不可见
					self:removeSmoothEff(t)
				end
		else -- 设置
			self:removeSmoothEff(t)
		end
		end
	end

	local func = function()
		local stateTech = SetStates.setCommonState:getClosedValue(SetStates.setCommonState.CLOSE_SCIENCE_FAST) -- 科研
		local statePlane = SetStates.setCommonState:getClosedValue(SetStates.setCommonState.CLOSE_PRODUCE_FAST) -- 生产
		local stateBld = SetStates.setCommonState:getClosedValue(SetStates.setCommonState.CLOSE_BUILD_FAST)   -- 建造

		local tmp = {self.tech, self.plane, self.bld}

		if tmp[1] then
			funcState(stateTech, tmp[1])
		end

		if tmp[2] then
			funcState(statePlane, tmp[2])
		end

		if tmp[3] then
			funcState(stateBld, tmp[3])
		end

	end

	self.smoothSchduleId = Cocos2dxUtils:interval(func, 0.5)
end

--- 更新摇动提示
function T:updateShakeRemind()
	if self.shakeSchduleId then
		return
	end

	local funcState = function(state, t)
		if t then  -- 如果存在
			if state == false then -- 设置是有效果的
				local v = t:isVisible()
				if v == true then --可见
					local _, max, r = self:getCurrentNumByTag(t)
					if r == true and max ~= 0  then -- 达到最大值
						self:removeBldRemindEff(t)
					elseif r == false then
						self:createBldRemindEff(t)
					end
				else -- 不可见
					self:removeBldRemindEff(t)
				end
		else -- 设置
			self:removeBldRemindEff(t)
		end
		end
	end

	local func = function()
		local stateTech = SetStates.setCommonState:getClosedValue(SetStates.setCommonState.CLOSE_SCIENCE_FAST) -- 科研
		local statePlane = SetStates.setCommonState:getClosedValue(SetStates.setCommonState.CLOSE_PRODUCE_FAST) -- 生产
		local stateBld = SetStates.setCommonState:getClosedValue(SetStates.setCommonState.CLOSE_BUILD_FAST)   -- 建造

		local tmp = {self.tech, self.plane, self.bld}

		if tmp[1] then
			funcState(stateTech, tmp[1])
		end

		if tmp[2] then
			funcState(statePlane, tmp[2])
		end

		if tmp[3] then
			funcState(stateBld, tmp[3])
		end

	end

	self.shakeSchduleId = Cocos2dxUtils:interval(func, 0.5)
end

function T:createText()
	local text = XMLLabel()
	text:setHAlign("center")
	text:setVAlign("middle")
	text:setContentSize(self.textSize)
	text:setString("0/0")
	text:setFontSize(16)
	return text
end

function T:generalSetTime(t, textNode)
	if not t then
		t = 0
	end

	local h = math.floor(t / 3600)
	local m = math.floor(math.floor(t % 3600) / 60)
	local n = math.floor(t % 60)

	if m == 60 then
		m = 59
	end

	if n == 60 then
		n = 59
	end

	if textNode then
		textNode:setString(string.format("%02d", h) .. ":" .. string.format("%02d", m) .. ":" .. string.format("%02d", n))
	end

end


function T:initView(t)
	REL:toOther("right", "top", self, t, -2, 118)
	self:initPosition()
	self:initEnterEffect()
end

function T:initEnterEffect()
	self:setTouchCanNotTouch()
	local size = self:getContentSize()
	local px, py = self:getPosition()
	self.oldWidgetPP = cc.p(px, py)

	self:setPosition(px + size.width + 10, py) -- 刚开始在实现之外
end

function T:enterEffect()
	local all = HomePageManager:getStartEffectTime()

	local ac = cc.Sequence:create(cc.DelayTime:create(all - self.enterEffectTime), cc.MoveTo:create(self.enterEffectTime, self.oldWidgetPP))
	self:runAction(ac)
end

--- 设置不能点击
--- 主容器 屏蔽下面的事件  就可以实现这个效果
function T:setTouchCanNotTouch()
	self:setTouchEnabled(true)
end

function T:setTouchCanTouch()
	self:setTouchEnabled(false)
end

--- 进入完成
function T:enterComplete()
	self:setTouchCanTouch()
end



function T:registerPublicEvent()
	BuffQueueInfoMgr:luaAddEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH, self, self.updateBuffText)
	BuffQueueInfoMgr:luaAddEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_FINISH, self, self.updateBuffText) -- buff

	TechnologiesInfoMgr:luaAddEventListener(TechnologiesInfoMgr.EVT_TYPE_CANCEL_STUDY, self, self.updateTechText)
	TechnologiesInfoMgr:luaAddEventListener(TechnologiesInfoMgr.EVT_TYPE_STUDY_COMPLETE, self, self.updateTechText)
	TechnologiesInfoMgr:luaAddEventListener(TechnologiesInfoMgr.EVT_TYPE_START_STUDY, self, self.updateTechText)
	TechnologiesInfoMgr:luaAddEventListener(TechnologiesInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME, self, self.updateTechText) -- tech

	AircraftProduceQueueMgr:luaAddEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_REFRESH, self, self.updatePlaneText) -- plane

	BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_START_LEVEL_UP, self, self.updateBldText)
	BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_CANCEL_LEVEL_UP, self, self.updateBldText)
	BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE, self, self.updateBldText)
	BuildingsInfoMgr:luaAddEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME, self, self.updateBldText)

	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. PlayerInstance.fixedBldLocation.planeOne, self, self.updateOpenPlane)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. PlayerInstance.fixedBldLocation.planeTwo, self, self.updateOpenPlane)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl .. PlayerInstance.fixedBldLocation.study, self, self.updateOpenTech)


	HomePageManager:luaAddEventListener(HomePageManager.noticeMessage.enterEffectMainStage, self, self.enterEffect) -- 开始进入特效
	HomePageManager:luaAddEventListener(HomePageManager.noticeMessage.enterEffectComplete, self, self.enterComplete) -- 完成进入特效

	--SetStates.setCommonState:luaAddEventListener(SetStates.setCommonState.EVT_CLOSE_OPEN_BUILD_FAST, self, self.updateSecret)  -- 小秘书
	
	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
end

function T:releasePublicEvent()
	BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_REFRESH, self, self.updateBuffText)
	BuffQueueInfoMgr:luaRemoveEventListener(BuffQueueInfoMgr.EVT_TYPE_BUFF_FINISH, self, self.updateBuffText) -- buff

	TechnologiesInfoMgr:luaRemoveEventListener(TechnologiesInfoMgr.EVT_TYPE_CANCEL_STUDY, self, self.updateTechText)
	TechnologiesInfoMgr:luaRemoveEventListener(TechnologiesInfoMgr.EVT_TYPE_STUDY_COMPLETE, self, self.updateTechText)
	TechnologiesInfoMgr:luaRemoveEventListener(TechnologiesInfoMgr.EVT_TYPE_START_STUDY, self, self.updateTechText)
	TechnologiesInfoMgr:luaRemoveEventListener(TechnologiesInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME, self, self.updateTechText) -- tech

	AircraftProduceQueueMgr:luaRemoveEventListener(AircraftProduceQueueMgr.EVT_TYPE_AIRCRAFTFACTORY_REFRESH, self, self.updatePlaneText) -- plane

	BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_START_LEVEL_UP, self, self.updateBldText)
	BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_CANCEL_LEVEL_UP, self, self.updateBldText)
	BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE, self, self.updateBldText)
	BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME, self, self.updateBldText) -- bld

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. PlayerInstance.fixedBldLocation.planeOne, self, self.updateOpenPlane)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. PlayerInstance.fixedBldLocation.planeTwo, self, self.updateOpenPlane)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. PlayerInstance.fixedBldLocation.study, self, self.updateOpenTech)

	HomePageManager:luaRemoveEventListener(HomePageManager.noticeMessage.enterEffectMainStage, self, self.enterEffect) -- 开始进入特效
	HomePageManager:luaRemoveEventListener(HomePageManager.noticeMessage.enterEffectComplete, self, self.enterComplete) -- 完成进入特效

	--SetStates.setCommonState:luaRemoveEventListener(SetStates.setCommonState.EVT_CLOSE_OPEN_BUILD_FAST, self, self.updateSecret)  -- 小秘书

	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
end

function T:updateAllState()
	self:updateBuffText()
	self:updateTechText()
	self:updatePlaneText()
	self:updateBldText()
	self:updateOpenPlane()
end

return T

