local T=Class.HomePageTopBar(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI,
	LuaEventDispatcher2
)

--- 正常容量的颜色
T.normalCapacityColor = cc.c3b(255, 255, 255)
--- 大于保护容量的颜色
T.aboveProtectColor = cc.c3b(255, 153, 0)
--- 最大容量颜色
T.maxCapacityColor = cc.c3b(255, 0, 0)

--- 进入特效的时间
T.enterEffectTime = 0.5

function T:def()
	AbstractUI.def(self)
	LuaEventDispatcher2.def(self)

	--- 管理
	-- manager = nil

	--- ui组
	self.uiChild = {}
end

--- 构造函数
function T:ctor()
	AbstractUI.ctor(self)
	LuaEventDispatcher2.ctor(self)
	
	self:loadJson()
	self:loadUI()
end

--- 回收
function T:cleanUp()
	print("HomePageTopBar=>ect:cleanup")
	
	self:releaseDispatchEvent()

	self.joinAlliance:releaseEvent()
	self:releaseTimeSchdule()
end

--- 初始化
function T:initView()
	self:registerEvent()
	self:updateView()
	self:updateTime() -- 更新时间
	self:showReinforceTime()
	self:initJoinAlliance()
	self:initEnterEffect()
	self:initFackBookShare()
    self:initGetMedalAward()

end

--- 初始化UI 可点击的都可看成btn
function T:loadUI()
	local c = self.uiChild
	local w = self.widget

	c.labelLvl = Cocos2dxUtils:getChildByName(w, "labelLvl")                                    -- 等级
	c.labelName = Cocos2dxUtils:getChildByName(w, "labelName")                                  -- 名字
	c.imgPlayerHead = Cocos2dxUtils:getChildByName(w, "imgPlayerHead")                          -- 人物头像
	c.imgVip = Cocos2dxUtils:getChildByName(w, "imgVip")

	c.barExp = Cocos2dxUtils:getChildByName(w, "barExp")                                        -- 经验条
	c.barEnergy = Cocos2dxUtils:getChildByName(w, "barEnergy")                                  -- 能量条
	c.resourcePanel = Cocos2dxUtils:getChildByName(w, "resourcePanel")                           -- 资源背景
	c.barSteel = Cocos2dxUtils:getChildByName(w, "barSteel")                                      -- 铁矿条
	c.barSilicon = Cocos2dxUtils:getChildByName(w, "barSilicon")                                -- 硅矿条
	c.barTati = Cocos2dxUtils:getChildByName(w, "barTati")                                      -- 钛矿条
	c.barGold = Cocos2dxUtils:getChildByName(w, "barGold")                                      -- 金矿条
	c.barOil = Cocos2dxUtils:getChildByName(w, "barOil")                                        -- 石油条
	c.labelSteelNum = Cocos2dxUtils:getChildByName(w, "labelSteelNum")                            -- 铁矿数量
	c.labelSiliconNum = Cocos2dxUtils:getChildByName(w, "labelSiliconNum")                      -- 硅矿数量
	c.labelTatiNum = Cocos2dxUtils:getChildByName(w, "labelTatiNum")                            -- 钛矿数量
	c.labelGoldNum = Cocos2dxUtils:getChildByName(w, "labelGoldNum")                            -- 金币数量
	c.labelOilNum = Cocos2dxUtils:getChildByName(w, "labelOilNum")                              -- 石油数量

	c.diamondNum = Cocos2dxUtils:getChildByName(w, "diamondNum")                              -- 钻石

	c.panelHead = Cocos2dxUtils:getChildByName(w, "panelHead")   -- 头像点击的容器

	c.hour = Cocos2dxUtils:getChildByName(w, "hour")   -- 小时

	c.panelVip = Cocos2dxUtils:getChildByName(w, "panelVip")

	c.diamondText = Cocos2dxUtils:getChildByName(w, "diamondText")  -- 钻石文本

	c.panelActivity = Cocos2dxUtils:getChildByName(w, "panelActivity") -- 顶部活动容器

	c.panelReinforce = Cocos2dxUtils:getChildByName(w, "panelReinforce") -- 援军活动

	c.panelAllianceReward = Cocos2dxUtils:getChildByName(w, "panelAllianceReward") -- 军团奖励 活动


	c.panelShare = Cocos2dxUtils:getChildByName(w, "panelShare") -- 分享 活动

	c.labelFighting = Cocos2dxUtils:getChildByName(w, "labelFighting")

    c.panelRewardMedal = Cocos2dxUtils:getChildByName(w, "panelRewardMedal") -- 荣誉勋章


	self:initFixedUI()

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_HOMEPAGE_PLAYER_PHOTO,c.panelHead)
	end
end

--- 显示援军时间
function T:showReinforceTime(t)
	if not t then
		t = SetStates.reinforceState:getTime()
	end

	local c = self.uiChild

	local f = SetStates.reinforceState:isReceive()

	if f == true then -- 已经领取
		print("领取了 援军 奖励， 关闭援军提示！！！！！")
		if self.reinforce then
			self.reinforce:removeFromParent(true)
			self.reinforce = nil
		end
		return  -- 返回
	end

	if not self.reinforce then
		self.reinforce = ccui.Button:create()
		self.reinforce:loadTextures("reinforceActivity.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
		BaseButton:extend(self.reinforce)

		self.reinforce:addTouchEventListener(function(t, e)
			if e ~= ccui.TouchEventType.ended then return end
			local layout = require("src.app.uiScript.scenes.homePage.reinforce.HomePageReinforceWindow").new()
			local ma = MUIAlter_custom.show({
				info = layout
			})
			--layout:setMUIAlter2(layout)

		end)

		c.panelReinforce:addChild(self.reinforce)

		local reinforceText = XMLLabel()          -- 倒计时
		reinforceText:setContentSize(cc.size(100, 26))
		reinforceText:setHAlign("center")
		reinforceText:setVAlign("middle")
		reinforceText:setFontSize(16)

		--self:createBarTextBack(self.reinforce)

		self.reinforce:addChild(reinforceText)
		reinforceText:setString("")

		REL:toOther("left", "top", self.reinforce, c.panelReinforce, 0, 0) -- 设置距离
		--REL:toScreen("center","middle", self.reinforce, 121, 400)
		REL:toOther("center", "bottom", reinforceText, self.reinforce, 0, 0)

		self.reinforce.reinforceText = reinforceText
	end

	self:generalSetTime(t, self.reinforce.reinforceText)
end

----- 成功领取 援军
--function T:getReinforceSuccess()
--	if self.reinforce then
--		self.reinforce:removeFromParent(true)
--		self.reinforce = nil
--	end
--end

--- 通用的设置时间
-- @param t 时间
-- @param textNode 文本载体
function T:generalSetTime(t, textNode)
	if not t then
		t = 0
	end

	local h = math.floor(t / 3600)
	local m = math.floor(math.floor(t % 3600) / 60)
	local n = math.floor(t % 60)

	if m == 60 then
		m = 59
	end

	if n == 60 then
		n = 59
	end

	if textNode then
		textNode:setString(string.format("%02d", h) .. ":" .. string.format("%02d", m) .. ":" .. string.format("%02d", n))
	end

end

--- 初始化 军团奖励
function T:initJoinAlliance()
	self.joinAlliance = mapping({}, require("src.app.uiScript.scenes.homePage.bar.leftBar.JoinAllianceAward"))
	self.joinAlliance:initView(self.uiChild.panelAllianceReward)
end


--- 初始化 分享按钮
function T:initFackBookShare()
	if CUR_SDK == SDKType.PLATFORM_ENJOY_GAME then -- facebook分享
	    local faceBookShareAward = SetStates.faceBookShareAward
	    if faceBookShareAward:judgeIsShare() == true then
		     --未分享
            self:shareLogic()
	    else
		    -- 分享了
		    if self.fackBookShare then
			    self.fackBookShare:removeFromParent()
			    self.fackBookShare = nil
		    end
	    end
	end

    if C_PFM == cc.PLATFORM_OS_ANDROID and SDK_Android_weixin_Delegate then -- 安卓微信分享,后面加一个状态码,ios同理
        --local faceBookShareAward = SetStates.faceBookShareAward
	    --if faceBookShareAward:judgeIsShare() == true then
		     --未分享
            self:shareLogic()
--	    else
--		    -- 分享了
--		    if self.fackBookShare then
--			    self.fackBookShare:removeFromParent()
--			    self.fackBookShare = nil
--		    end
--	    end
    end


end

function T:shareLogic()
    if not self.fackBookShare then
	    local btn = ccui.Button:create()
	    btn:loadTextures("barOfShare.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)
	    self.uiChild.panelShare:addChild(btn)
	    REL:toOther("center", "middle", btn, self.uiChild.panelShare, 0, 0)

	    --- 添加特效
	    local eff = HomePageManager:getEffWithOutRandom("iconEff_purple")
	    eff:setScale(0.66)
	    btn:addChild(eff)
	    REL:toOther("center", "middle", eff, btn, 0, 0) -- 设置距离

	    BaseButton:extend(btn)

	    --- 注册事件
	    btn:addTouchEventListener(function(t, e)
		    if e ~= ccui.TouchEventType.ended then return end
		    local layout = require("src.app.uiScript.components.share.FaceBookSharePopWindow").new()
		    local muialter = MUIAlter.show({
			    title = Language:get("uc1016"),
			    info = layout,
			    flag = 4,
			    isShowCloseButton = true,
			    callback = function(flag)
			    end
		    })
		    layout:setMuialter(muialter)

	    end)

	    self.fackBookShare = btn

    end

end




--- 初始化 分享按钮
function T:initGetMedalAward()
    local level = UserInfo.level
    if level < 15 then
        return
    end 

    local getMedalAward = SetStates.getMedalAward
    if getMedalAward:judgeIsGet() == true then
        if not self.rewardMedal then
        	local url="res/images/icon/propIcon/honor.png"
        
            local btn = ccui.Button:create()
		    btn:loadTextures(url, url, "", ccui.TextureResType.localType)
            btn:setScale(0.68)
		    self.uiChild.panelRewardMedal:addChild(btn)
		    REL:toOther("center", "middle", btn, self.uiChild.panelRewardMedal, 0, 0)

		    --- 添加特效
		    local eff = HomePageManager:getEffWithOutRandom("iconEff_purple")
		    --eff:setScale(0.66)
		    btn:addChild(eff)
		    REL:toOther("center", "middle", eff, btn, 0, 0) -- 设置距离

		    BaseButton:extend(btn)

		    --- 注册事件
		    btn:addTouchEventListener(function(t, e)
			    if e ~= ccui.TouchEventType.ended then return end
                local function finish(data)
                    local layout = require("src.app.uiScript.components.share.MedalAwardPopWindow").new(data)
                    local muialter = MUIAlter_noTitle.show({
		                info = layout
	                })
                    layout:setMuialter(muialter)


                end

                Command:checklGetMedal(finish)

		    end)

		    self.rewardMedal = btn
        end

    else
        if self.rewardMedal then
			self.rewardMedal:removeFromParent()
			self.rewardMedal = nil
		end

    end

end


function T:initFixedUI()
	local c = self.uiChild

	local tb = {}
	for k, v in pairs(self.uiChild) do
		if v:getDescription() == "Label" then
			table.insert(tb, v)
		end
	end

	Cocos2dxUtils:setTextFont(tb)

	c.diamondText:setString(Language:get("uy140"))          -- 获取宝石
	c.hour:setString("00:00")
	--c.minute:setString("00")
	--c.colon:setString(":")
end

--- 更新时间
function T:updateTime()
	local c = self.uiChild

	local data
	local func = function()
		data = os.date("*t", TimeUtils:getSyncMillis() / 1000)
		c.hour:setString(string.format("%02d:%02d", data.hour, data.min))
	end

	self.timeSchduleId = Cocos2dxUtils:interval(func, 1.0)  -- 1 秒更新一次

	func() -- 先更新一次

end

function T:updateFighting()
	local c = self.uiChild
	local num = PlayerInstance:getPlayerFight()
	c.labelFighting:setString( Language:get("uy193", UnitConversion.unitTrans(num)))
end

--- 升级指挥 特效
function T:updateUpgradeDominance()
	local c = self.uiChild
	local lvlEnable = PlayerInstance:checkDominanceLevelupLevel() -- 等级是否满足

	local bookNum = PlayerInstance:getDominanceBook()

	if lvlEnable == true and bookNum > 0 then
		-- 添加特效
		if not c.imgPlayerHead.eff then
			c.imgPlayerHead.eff = HomePageManager:addEffect(c.imgPlayerHead, "rolePhotoTipEff")
			c.imgPlayerHead.eff:setScale(1.8)
		end
	else
		if c.imgPlayerHead.eff then
			c.imgPlayerHead.eff:removeFromParent()
			c.imgPlayerHead.eff = nil
		end
	end

end


--- 移除更新时间的计时器
function T:releaseTimeSchdule()
	if self.timeSchduleId then
		Cocos2dxUtils:clearScheduler(self.timeSchduleId)
		self.timeSchduleId = nil
	end
end


--- 注册事件
function T:registerEvent()

	local c = self.uiChild
	local clickHandler = function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		if t == c.panelHead then
			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_HOMEPAGE_PLAYER_PHOTO)
			end

			self:onEventHeadClick()
		elseif t == c.resourcePanel then
			self:onEventResourceClick()
		elseif t == c.imgVip then
			self:onEventVipClick()
		end
	end

	BaseButton:extend(c.panelHead)

	c.resourcePanel.touchBeganSound=SoundRes.NONE
	c.resourcePanel.touchEndedSound=SoundRes.OPEN_FUNC_OF_BAR
	BaseButton:extend(c.resourcePanel)

	BaseButton:extend(c.imgVip)

	c.resourcePanel:addTouchEventListener(clickHandler)
	c.panelHead:addTouchEventListener(clickHandler)
	c.imgVip:addTouchEventListener(clickHandler)

	self:registerDispatchEvent()
end

---　注册派发的事件
function T:registerDispatchEvent()

	ResourceManager:luaAddEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH, self, self.updateRes)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.buildingLvl, self, self.updateRes)



	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.fighting, self, self.updateFighting)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.exp, self, self.updateExp)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.energy, self, self.updateEnergy)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.name, self, self.updateName)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.diamond, self, self.updateDiamond)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updatePlayerLvl)

	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET, self, self.updateDiamond)

	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.headId, self, self.updatePlayerHead)

	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updateUpgradeDominance)  -- 统率
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.dominanceLvl, self, self.updateUpgradeDominance)
	PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. PlayerInstance:getDominancePropID(), self, self.updateUpgradeDominance)

	SetStates.reinforceState:luaAddEventListener(SetStates.reinforceState.REMAIN_TIME, self, self.showReinforceTime) -- 援军

	HomePageManager:luaAddEventListener(HomePageManager.noticeMessage.enterEffectMainStage, self, self.enterEffect) -- 开始进入特效
	HomePageManager:luaAddEventListener(HomePageManager.noticeMessage.enterEffectComplete, self, self.enterComplete) -- 完成进入特效


	SetStates.faceBookShareAward:luaAddEventListener(SetStates.faceBookShareAward.EVT_FACK_BOOK_SHARE_REFRESH,self,self.initFackBookShare)
    SetStates.getMedalAward:luaAddEventListener(SetStates.getMedalAward.EVT_GET_MEDAL_AWARD_REFRESH,self,self.initGetMedalAward)
    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_MILITARYRANK_REFRESH,self,self.initGetMedalAward)
    PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.playerLvl,self,self.initGetMedalAward)


	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
end

--- 释放事件
function T:releaseDispatchEvent()
	ResourceManager:luaRemoveEventListener(ResourceManager.EVT_TYPE_RESOURCE_REFRESH, self, self.updateRes)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl, self, self.updateRes)

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.fighting, self, self.updateFighting)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.energy, self, self.updateEnergy)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.exp, self, self.updateExp)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.name, self, self.updateName)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.diamond, self, self.updateDiamond)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updatePlayerLvl)

	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET, self, self.updateDiamond)

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.headId, self, self.updatePlayerHead)

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updateUpgradeDominance)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.dominanceLvl, self, self.updateUpgradeDominance)
	PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. PlayerInstance:getDominancePropID(), self, self.updateUpgradeDominance)

	SetStates.reinforceState:luaRemoveEventListener(SetStates.reinforceState.REMAIN_TIME, self, self.showReinforceTime) -- 援军

	HomePageManager:luaRemoveEventListener(HomePageManager.noticeMessage.enterEffectMainStage, self, self.enterEffect) -- 开始进入特效
	HomePageManager:luaRemoveEventListener(HomePageManager.noticeMessage.enterEffectComplete, self, self.enterComplete) -- 完成进入特效

	SetStates.faceBookShareAward:luaRemoveEventListener(SetStates.faceBookShareAward.EVT_FACK_BOOK_SHARE_REFRESH,self,self.initFackBookShare)
    SetStates.getMedalAward:luaRemoveEventListener(SetStates.getMedalAward.EVT_GET_MEDAL_AWARD_REFRESH,self,self.initGetMedalAward)
    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_MILITARYRANK_REFRESH,self,self.initGetMedalAward)
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.playerLvl,self,self.initGetMedalAward)

	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateAllState)
end

--- 更新所有状态
function T:updateAllState()
	self:updateRes()
	self:updateFighting()

	self:updateName()
	self:updatePlayerHead()
	self:updateEnergy()
	self:updateExp()

	self:updateDiamond()
end

-- 更新资源
function T:updateRes()
	self:updateSteel()
	self:updateTati()
	self:updateSilicon()
	self:updateGold()
	self:updateOil()
end

--- vip点击
function T:onEventVipClick()
	VipManager:enterIapWindow()
end

--- 资源点击
function T:onEventResourceClick()
	WindowManager:push(
		require("src.app.uiScript.components.warehousestorage.WarehousestorageWindow").new()
	)
end
--- 玩家信息
function T:onEventHeadClick()
	local view = require("src.app.uiScript.scenes.playerInfo.PlayerInfoWindow").new()

	WindowManager:push(view)
end

--- 更新界面
function T:updateView()
	self:updateSteel()
	self:updateTati()
	self:updateSilicon()
	self:updateGold()
	self:updateOil()
	self:updateFighting()
	self:updateExp()
	self:updateEnergy()
	self:updateName()
	self:updateDiamond()
	self:updatePlayerLvl()
	self:updatePlayerHead()
	self:updateFighting()

	self:updateUpgradeDominance()

	self:addDiamondEffect()
end

--- 增加砖石特效
function T:addDiamondEffect()
	local c = self.uiChild
	local diamondFlashEff = ResLoader:createAnimationSprite("diamondFlashEff")
	c.panelVip:addChild(diamondFlashEff)
	REL:toOther("center", "middle", diamondFlashEff, c.panelVip, 0, 10)
end

-- 更新铁矿
function T:updateSteel()
	local num = PlayerInstance:getSteel()
	local max = PlayerInstance:getMaxSteel()

	local c = self.uiChild
	c.labelSteelNum:setString(UnitConversion.unitTrans(num))

	c.labelSteelNum:setColor(self:getResourceColor(num, max))

	local p = num / max * 100
	if p >= 100 then p = 100 end

	--print("steel num = " .. num .. " max = " .. max)
	c.barSteel:setPercent(p)
end

--- 得到资源的颜色
function T:getResourceColor(num, max)
	local protect = PlayerInstance:getProtectedCapacity()

	if num < protect then       -- 白色
		return self.normalCapacityColor
	elseif num >= protect and num < max then   -- 橙色
		return self.aboveProtectColor
	elseif num >= max then       -- 红色
		return self.maxCapacityColor
	end
end

-- 更新钛矿
function T:updateTati()
	local num = PlayerInstance:getTati()
	local max = PlayerInstance:getMaxTati()
	self.uiChild.labelTatiNum:setString(UnitConversion.unitTrans(num))

	self.uiChild.labelTatiNum:setColor(self:getResourceColor(num, max))

	local p = num / max * 100
	if p >= 100 then p = 100 end

	--print("钛矿 num = " .. num .. " max = " .. max)
	self.uiChild.barTati:setPercent(p)
end
-- 更新硅矿
function T:updateSilicon()
	local num = PlayerInstance:getSilicon()
	local max = PlayerInstance:getMaxSilicon()
	self.uiChild.labelSiliconNum:setString(UnitConversion.unitTrans(num))

	self.uiChild.labelSiliconNum:setColor(self:getResourceColor(num, max))


	local p = num / max * 100
	if p >= 100 then p = 100 end

	--print("硅矿 num = " .. num .. " max = " .. max)
	self.uiChild.barSilicon:setPercent(p)
end
-- 更新金矿
function T:updateGold()
	local num = PlayerInstance:getGold()
	local max = PlayerInstance:getMaxGold()
	self.uiChild.labelGoldNum:setString(UnitConversion.unitTrans(num))

	self.uiChild.labelGoldNum:setColor(self:getResourceColor(num, max))

	local p = num / max * 100
	if p >= 100 then p = 100 end

	--print("金矿 num = " .. num .. " max = " .. max)
	self.uiChild.barGold:setPercent(p)
end
-- 更新油矿
function T:updateOil()
	local num = PlayerInstance:getOil()
	local max = PlayerInstance:getMaxOil()
	self.uiChild.labelOilNum:setString(UnitConversion.unitTrans(num))

	self.uiChild.labelOilNum:setColor(self:getResourceColor(num, max))

	local p = num / max * 100
	if p >= 100 then p = 100 end

	--print("油矿 num = " .. num .. " max = " .. max)
	self.uiChild.barOil:setPercent(p)
end

-- 更新经验
function T:updateExp()
	local num = PlayerInstance:getPlayerExp()
	local max = PlayerInstance:getPlayerMaxExp()
	local p = num / max * 100
	if p >= 100 then p = 100 end
	self.uiChild.barExp:setPercent(p)
end
-- 更新能量
function T:updateEnergy()
	local num = PlayerInstance:getPlayerEnergy()
	local max = PlayerInstance:getPlayerMaxEnergy()
	local p = num / max * 100
	if p >= 100 then p = 100 end
	self.uiChild.barEnergy:setPercent(p)
end
-- 更新名字
function T:updateName()
	local name = PlayerInstance:getPlayerName()
	self.uiChild.labelName:setString(name)
end
-- 更新钻石
function T:updateDiamond()
	local num = PlayerInstance:getDiamond()
	self.uiChild.diamondNum:setString(tostring(num))
end
-- 更新等级
function T:updatePlayerLvl()
	local lvl = PlayerInstance:getPlayerLevel()
	self.uiChild.labelLvl:setString("LV." .. lvl)
end

--- 更新玩家头像
function T:updatePlayerHead()
	local uiHead=self.uiChild.imgPlayerHead
	uiHead:loadTexture(PlayerInstance:getPlayerHead(PlayerInstance:getPlayerHeadId()))
	self.uiChild.imgPlayerHead:setScale(68/130,68/130)
end

function T:getHeight()
	local size = self.widget:getContentSize()
	return size.height
end

function T:loadJson()
	local widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.homePageTopBar)
	self.widget = widget
	self:setContentSize(widget:getContentSize())
	self:addChild(widget)

end

function T:setManager(m)
	self.manager = m
end

function T:initEnterEffect()
	self:setTouchCanNotTouch()
	local widget = self.uiChild.panelActivity

	local size = widget:getContentSize()
	local px, py = widget:getPosition()
	self.oldWidgetPP = cc.p(px, py)

	widget:setPosition(px, py + size.height + 10) -- 刚开始在实现之外
end

function T:enterEffect()
	if self.uiChild == nil then
		return
	end

	local all = HomePageManager:getStartEffectTime()
	local widget = self.uiChild.panelActivity
	local size = widget:getContentSize()

	widget:runAction(cc.Sequence:create(
		cc.DelayTime:create(all - self.enterEffectTime),
		cc.CallFunc:create(function()
			self:enterEffectSchdule()
		end)
	))
end

function T:enterEffectSchdule()
	local sid

	local widget = self.uiChild.panelActivity
	local size = widget:getContentSize()

	local a = 0.03 -- 每一次时间
	local d = size.height + 10 -- 距离
	local total = self.enterEffectTime -- 总时间

	local max = math.ceil(total / a) -- 运行的总次数

	local ad = d / max -- 每次运动移动的距离

	local num = 0
	local callback = function()
		local _, py = widget:getPosition()

		if math.abs(py - ad) >= math.abs(self.oldWidgetPP.y) then  -- 暂时这样
			widget:setPositionY(self.oldWidgetPP.y)
			Cocos2dxUtils:clearScheduler(sid)
			sid = nil
			return
		end
		widget:setPositionY(py - ad)

		num = num + 1
		if num == max then
			Cocos2dxUtils:clearScheduler(sid)
			sid = nil
		end
	end

	sid = Cocos2dxUtils:interval(callback, a)
end

--- 设置不能点击
--- 主容器 屏蔽下面的事件  就可以实现这个效果
function T:setTouchCanNotTouch()
	--    local ccui.Layout:create()
	self.widget:setTouchEnabled(true)
end

function T:setTouchCanTouch()
	self.widget:setTouchEnabled(false)
end

--- 进入完成
function T:enterComplete()
	self:setTouchCanTouch()
end

return T
