local T=Class.WorldMapTopBar(
	function()
		return ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.homePageTopWorldBar)
	end,
	AbstractUI,
	LuaEventDispatcher2
)

function T:def()
	AbstractUI.def(self)
	LuaEventDispatcher2.def(self)

	--- 管理器
	-- _manager
end

function T:ctor()
	AbstractUI.ctor(self)
	LuaEventDispatcher2.ctor(self)

	self:_init()
end

function T:_init()
	-- 定位按钮
	local uiLocationBtn=BaseButton:extend(Cocos2dxUtils:getChildByName(self, "uiLocationBtn"))
	uiLocationBtn:setString(Language:get("uy69"))
	uiLocationBtn.touchBeganSound=SoundRes.NONE
	uiLocationBtn.touchEndedSound=SoundRes.WORLD_LOCATION
	self.uiLocationBtn=uiLocationBtn

	-- 收藏按钮
	local uiCollectionBtn=BaseButton:extend(Cocos2dxUtils:getChildByName(self, "uiCollectionBtn"))
	uiCollectionBtn:setString(Language:get("uy70"))
	self.uiCollectionBtn=uiCollectionBtn

	-- "小地图"按钮
	local uiSmallMapBtn=BaseButton:extend(Cocos2dxUtils:getChildByName(self, "uiSmallMapBtn"))
	uiSmallMapBtn:setString(Language:get("uy71"))
	self.uiSmallMapBtn=uiSmallMapBtn

	-- "搜索"按钮
	local uiSearchBtn=BaseButton:extend(Cocos2dxUtils:getChildByName(self, "uiSearchBtn"))
	uiSearchBtn:setString(Language:get("uy72"))
	self.uiSearchBtn=uiSearchBtn

	-- 位置标题-X
	local uiPosXCap=Cocos2dxUtils:getChildByName(self, "uiPosXCap")
	uiPosXCap:setString(Language:get("uy73"))
	self.uiPosXCap=uiPosXCap

	-- 位置标题-Y
	local uiPosYCap=Cocos2dxUtils:getChildByName(self, "uiPosYCap")
	uiPosYCap:setString(Language:get("uy74"))
	self.uiPosYCap=uiPosYCap

	-- 位置输入框模板-X
	local uiPosXInputTemplate=Cocos2dxUtils:getChildByName(self, "uiPosXInput")
	self.uiPosXInputTemplate=uiPosXInputTemplate

	-- 位置输入框模板-Y
	local uiPosYInputTemplate=Cocos2dxUtils:getChildByName(self, "uiPosYInput")
	self.uiPosYInputTemplate=uiPosYInputTemplate

	-- 位置输入框-X
	local uiPosXInput=InputBox:create(uiPosXInputTemplate:getContentSize())
	uiPosXInput:setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC)
	self:addChild(uiPosXInput)
	REL:toOther("center","middle",uiPosXInput,uiPosXInputTemplate,0,0)
	self.uiPosXInput=uiPosXInput

	-- 位置输入框-Y
	local uiPosYInput=InputBox:create(uiPosYInputTemplate:getContentSize())
	uiPosYInput:setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC)
	self:addChild(uiPosYInput)
	REL:toOther("center","middle",uiPosYInput,uiPosYInputTemplate,0,0)
	self.uiPosYInput=uiPosYInput

	local inputBoxEvtHandler=function(e,t)
		if e == "began" then
			AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
		elseif e == "ended" then
			local valStr=t:getText()
			local val=0
			if valStr and string.trim(valStr) ~= "" then
				val=tonumber(valStr)
			end
		
			if val > 600 then
				val = 600
			end
			if val <= 0 then
				val = 1
			end

			t:setText(tostring(val))
		elseif e == "changed" then
			local valStr=t:getText()
			local val=0
			if valStr and string.trim(valStr) ~= "" then
				val=tonumber(valStr)
			end
		
			if val > 600 then
				val = 600
				
				t:setText(tostring(val))
			end
		elseif e == "return" then
		end
		self:luaDispatchEvent(e,t)
	end
	uiPosXInput:registerScriptEditBoxHandler(inputBoxEvtHandler)
	uiPosYInput:registerScriptEditBoxHandler(inputBoxEvtHandler)

	self.uiCurrentPos = Cocos2dxUtils:getChildByName(self, "uiCurrentPos")

	uiLocationBtn:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			AudioManager:playEffect(SoundRes.WORLD_LOCATION)

			local x, y = PlayerInstance:getWorldPosition()
			uiPosXInput:setText(x)
			uiPosYInput:setText(y)
			self._manager:gotoWorldPosition(x, y)
		end
	end)

	uiCollectionBtn:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			local node = require("src.app.uiScript.scenes.homePage.world.HomePageWorldCollectionView").new()
			node:initView()

			WindowManager:push(node)
		end
	end)

	uiSmallMapBtn:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			self._manager:switchSmallMap()
		end
	end)

	uiSearchBtn:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			local x,y=tonumber(uiPosXInput:getText()),tonumber(uiPosYInput:getText())
			self._manager:gotoWorldPosition(x,y)
		end
	end)

	local x, y = PlayerInstance:getWorldPosition()
	uiPosXInput:setText(x)
	uiPosYInput:setText(y)
end

--- 设置管理器
function T:setManager(m)
	self._manager = m
end

--- 设置当前坐标
function T:setCurrentPos(x,y)
	x, y = x or 1, y or 1

	self.uiCurrentPos:setString(Language:get("uy97", x, y))
end

return T
