--region JoinAllianceAward.lua
--Author    : YuDing
--Date      : 2015/5/21
--Introduce : 加入军团 奖励
local T = {}

--- 父类
T.parent = nil 

function T:initView(parent)
    self.parent = parent
    self:updateContent()
    self:registerEvent()
end

function T:registerEvent()
    SetStates.joinAllianceAward:luaAddEventListener(SetStates.joinAllianceAward.RECEIVE, self, self.updateContent)   -- 礼物时间
end

function T:releaseEvent()
    SetStates.joinAllianceAward:luaRemoveEventListener(SetStates.joinAllianceAward.RECEIVE, self, self.updateContent)   -- 礼物时间
end

--- 更新内容
function T:updateContent()
    local state = SetStates.joinAllianceAward:getState()
    if state == 0 then  -- 没有领取
        if not self.icon then 
            self:createIcon()
        end
    else 
        if self.icon then 
            self:removeIcon()
        end
    end
end

function T:createIcon()
    if self.icon then 
        return
    end

    local parent = self.parent

    local btn = ccui.Button:create()
    btn:loadTextures("homeJoinAlliance.png", "barOfNormalPressDown.png", "", ccui.TextureResType.plistType)

    --- 获得此存
    local size = ResLoader:getSpriteFrame("barOfNormalPressDown.png"):getOriginalSize()
    parent:addChild(btn)

    REL:toOther("left", "top", btn, self.parent, 0, 0) -- 设置距离

    --- 添加特效
    local eff = HomePageManager:getEffWithOutRandom("iconEff_purple")
    eff:setScale(0.66)

    btn:addChild(eff)
    REL:toOther("center", "middle", eff, btn, 0, 0) -- 设置距离

    BaseButton:extend(btn)

    --- 注册事件
    btn:addTouchEventListener(function(t, e)
        if e ~= ccui.TouchEventType.ended then return end
        self:onEventClick() 
    end)

    self.icon = btn
end

function T:removeIcon()
    if self.icon then 
        self.icon:removeFromParent()
        self.icon = nil 
    end
end

--- 按钮事件
function T:onEventClick()
    local layout = require("src.app.uiScript.components.alliance.HomePageAlliancePopWindow").new()
	local muialter2 = MUIAlter_custom.show(
		{
			info = layout,
			flag = 4,
			callback = function(flag)
			end
		}
	)

	layout:setMUIAlter2(muialter2)
end



return T

--endregion
