--- 战机位
local T=Class.AircraftLoc(
	function()
		return ccui.Layout:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 最小数量显示背景size
	-- _minCountBackSize

	--- 战机显示
	-- _uiAircraft

	--- 数量显示背景
	-- _uiCountBack

	--- 数量显示
	-- _uiCount
end

function T:ctor()
	AbstractUI.ctor(self)

	self:_init()
end

function T:_init()
	--战机显示
	local uiAircraft=cc.Sprite:create()
	uiAircraft:setScale(0.6)
	self:addChild(uiAircraft)
	self._uiAircraft=uiAircraft

	--数量显示背景
	local f=ResLoader:getSpriteFrame("homePagePlaneNum.png")
	self._minCountBackSize=f:getOriginalSize()

	--数量背景
	local uiCountBack=Scale9Sprite:createWithFrame(f)
	self:addChild(uiCountBack)
	self._uiCountBack=uiCountBack
	REL:toOther("center","middle",uiCountBack,self,0,-20)

	--数量显示
	local uiCount=XMLLabel()
	uiCount:setAlign("center","middle")
	uiCount:setAutoSizeLabel("width")
	uiCount:setFontSize(18)
	self:addChild(uiCount)
	self._uiCount=uiCount
	REL:toOther("center","middle",uiCount,uiCountBack,0,0)
end

--- 设置战机编号
function T:setAircraftId(aircraftId)
	local aircraftTemp=Aircraft_temp[aircraftId]
	if aircraftTemp then
		local f=ResLoader:getSpriteFrame(aircraftTemp.showPic..".png")
		self._uiAircraft:setSpriteFrame(f)
	end
end

--- 设置数量
function T:setCount(value)
	local valstr=tostring(value)

	local uiCount=self._uiCount
	local uiCountBack=self._uiCountBack
	if valstr ~= uiCount:getString() then
		uiCount:setString(valstr)
		uiCount:updateView()

		local s=uiCount:getContentSize()
		local ms=self._minCountBackSize
		local w,h,mw,mh=s.width,s.height,ms.width,ms.height
		uiCountBack:setContentSize(cc.size(w >= mw and w or mw,h >= mh and h or mh))

		REL:toOther("center","middle",uiCountBack,self,0,-20)
		REL:toOther("center","middle",uiCount,uiCountBack,0,0)
	end
end

return T
