--region HomeHalo.lua
--Author    : YuDing
--Date      : 2015/4/16
--Introduce : 主城光晕


-- 20 到 35

local T = class( "HomeHalo", function() return ccui.Layout:create() end )

T.min = nil 

T.max = nil

T.moveDistance = 15

--- 角度变化时间
T.changeTime = 0.03

function T:ctor(parent)
    local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function( eventType )
				if eventType == CocosEvent.EXIT then
					self:onExit()
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				end
			end
		)
	end
    
    local size = parent:getContentSize()
    self:setContentSize(size)
    parent:addChild(self)
    REL:toOther("center", "middle", self, parent, 0, 0)

    self:setMinAngle(40)
    self:setMaxAngle(52)
  

    self.kind = kind 
--  self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	self:setBackGroundColor(cc.c3b(random(0,255),0,0))
--	self:setBackGroundColorOpacity(100)

    self:loadJson()
    self:loadUI()
    self:initBackRotation()
end


function T:onExit()

end

function T:cleanUp()
    if self.shId then 
        Cocos2dxUtils:clearScheduler(self.shId)
        self.shId = nil 
    end
end

function T:loadJson()
   --self:setContentSize(UI_VSIZE)
    local widget
    
    widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.homeHale)

	self.widget = widget
	self:addChild(widget)

    REL:toOther("right", "top", widget, self, 0, 0)

    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:removeEventListenersForTarget(self.widget)  -- 删除这个节点上的listener.. 貌似加载的时候会加一个listener。
end

function T:loadUI()
    self.uiChild = self.uiChild or {}
    self.addUI = self.addUI or {}

    local c = self.uiChild 
    local w = self.widget

    c.back = Cocos2dxUtils:getChildByName(w, "back")
    local px, py = c.back:getPosition()
    c.back:setPositionY(py + 150)

    --c.haloInside = Cocos2dxUtils:getChildByName(w, "haloInside")
    --c.haloOutside = Cocos2dxUtils:getChildByName(w, "haloOutside")
    
    local ch = c.back:getChildren()

    local px, py
    for k, v in pairs(ch) do
        --if v ~= c.haloInside and v ~= c.haloOutside then 
            px, py = v:getPosition()
            if v:getDescription() == "ImageView" then 
                local r = v:getVirtualRenderer()
                r:setBlendFunc({src=0x0302, dst=1}) -- src_apha gl_one
                self:initOldOpacity(v) -- 初始化 透明度
            end

            table.insert(self.addUI, {v, py, py + self.moveDistance}) -- node min max
        --end
    end

    for i = 1, #self.addUI do  -- 加一点 误差
        self.addUI[i][3] = self.addUI[i][3] + i * 5  
    end

end

function T:initBlend()
    local ch = self.uiChild.back:getChildren()
    for k, v in pairs(ch) do 
        if v:getDescription() == "ImageView" then
            local r = v:getVirtualRenderer() 
            r:setBlendFunc({src=0x0302, dst=1})
        end
    end
end

--- 给ui 组件 增加 一个 oldOpacity关键字
function T:initOldOpacity(v)
    v.oldOpacity = v:getOpacity()
end

--- 透明度变化
--- @param s的 取值是 0 - 1的范围
--- 透明度的值 变化范围是 oldOpacity到0 之间
function T:excutOpacity(s)
    local ch = self.uiChild.back:getChildren()
    for k, v in pairs(ch) do
        v:setOpacity(v.oldOpacity * (1 - s))
    end
end

-- scale 0 -> 1
function T:excutMove(scale)
    local c = self.uiChild 

    --local scale = leftDistance / allDistance
   -- print("scale is .. " .. scale)
    if scale > 1 then 
        scale = 1
    end
    local factor = self:getAddFactor() 

    local angle = self.min + scale * factor
    if angle > self.max then 
        angle = self.max
    end

    local py = nil 
    for i = 1, #self.addUI do -- 坐标是正的
        py = self.addUI[i][2] + scale * (self.addUI[i][3] - self.addUI[i][2])
        if py > self.addUI[i][3] then
           py = self.addUI[i][3] 
        end
        self.addUI[i][1]:setPositionY(py)
    end

    --print("angle is .. " .. angle)
    c.back:setRotation(angle)
end

--- 获取增长因子
function T:getAddFactor()
    return math.abs(self.max - self.min)
end

--- 初始化back的旋转度
function T:initBackRotation()
    local c = self.uiChild 
    c.back:setRotation(self.min)
end

--- 展示时间
--- 自动 运行 跟主界面的滑动 无关
function T:startAutoShowHaloTime()
    local t = self.time
    local max = math.floor(t / self.changeTime) -- 改变角度的次数
    
    local num = 0 
    local shId
    
    local func = function()
        num = num + 1
        self:excutMove(num / max)
        self:excutOpacity(num / max)
        if num == max then -- 达到了最大值
            Cocos2dxUtils:clearScheduler(self.shId)
            self.shId = nil
            self:removeFromParent()
        end
    end

    self.shId = Cocos2dxUtils:interval(func, self.changeTime)
end

function T:setShowHaloTime(t)
    self.time = t
end

--- 设置最小的angle
function T:setMinAngle(angle)
    self.min = angle
end

--- 设置最大的angle
function T:setMaxAngle(angle)
    self.max = angle
end

return T



--endregion
