--region HomeHaloTwo.lua
--Author    : YuDing
--Date      : 2015/6/11
--Introduce : 主城另外一种光晕
local T = class( "HomeHaloTwo", function() return ccui.Layout:create() end )

T.min = nil 

T.max = nil

T.moveDistance = 5

--- 变化的临界点 在这个范围内 透明度和 位置不发生 变化 0-0.8 位置发生变化 透明度发生变化 0.8-0.85 不发生变化 0.85-1 这个点就是 
T.changeCriticalPoint = {0.8, 1.0}

function T:ctor(parent)
    local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function( eventType )
				if eventType == CocosEvent.EXIT then
					self:onExit()
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				end
			end
		)
	end
    
    local size = parent:getContentSize()
    self:setContentSize(size)
    parent:addChild(self)
    REL:toOther("center", "middle", self, parent, 0, 0)

    self:setMinAngle(20)
    self:setMaxAngle(30)

--  self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--	self:setBackGroundColor(cc.c3b(random(0,255),0,0))
--	self:setBackGroundColorOpacity(100)

    self:loadJson()
    self:loadUI()
    self:initBackRotation()
end


function T:onExit()

end

function T:cleanUp()
    
end

function T:loadJson()
   --self:setContentSize(UI_VSIZE)
    local widget
    
    widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.homeHaleTwo)

	self.widget = widget
	self:addChild(widget)

    REL:toOther("right", "top", widget, self, 0, 0)

    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:removeEventListenersForTarget(self.widget)  -- 删除这个节点上的listener.. 貌似加载的时候会加一个listener。
end

function T:loadUI()
    self.uiChild = self.uiChild or {}
    self.addUI = self.addUI or {}

    local c = self.uiChild 
    local w = self.widget

    c.back = Cocos2dxUtils:getChildByName(w, "back")
    local ch = c.back:getChildren()

    local px, py
    for k, v in pairs(ch) do
        --if v ~= c.haloInside and v ~= c.haloOutside then 
            px, py = v:getPosition()
            if v:getDescription() == "ImageView" then 
                local r = v:getVirtualRenderer()
                r:setBlendFunc({src=0x0302, dst=1}) -- src_apha gl_one
                self:initOldOpacity(v) -- 初始化 透明度
            end

            table.insert(self.addUI, {v, py, py + self.moveDistance}) -- node min max
    end

    for i = 1, #self.addUI do  -- 加一点 误差
        self.addUI[i][3] = self.addUI[i][3] + i * 2  
    end

end

function T:initBlend()
    local ch = self.uiChild.back:getChildren()
    for k, v in pairs(ch) do 
        if v:getDescription() == "ImageView" then
            local r = v:getVirtualRenderer() 
            r:setBlendFunc({src=0x0302, dst=1})
        end
    end
end

--- 给ui 组件 增加 一个 oldOpacity关键字
function T:initOldOpacity(v)
    v.oldOpacity = v:getOpacity()
end

--- 透明度变化
--- @param s的 取值是 0 - 1的范围
--- 透明度的值 变化范围是 oldOpacity到0 之间
function T:excutOpacity(s)
    local ch = self.uiChild.back:getChildren()
    for k, v in pairs(ch) do
        v:setOpacity(v.oldOpacity * (s))
    end
end

-- scale 0 -> 1
function T:excutMove(leftDistance, allDistance)
    local c = self.uiChild 

    local scale = leftDistance / allDistance
   -- print("scale is .. " .. scale)
    if scale > 1 then 
        scale = 1
    end

--    if scale <= self.changeCriticalPoint[1] then 
--        scale = scale / self.changeCriticalPoint[1] * 1 -- 转为为 0 - 1 之间的值
--        local factor = self:getAddFactor() 
--        local angle = self.min + scale * factor
--        if angle > self.max then 
--            angle = self.max
--        end

--        local py = nil 
--        for i = 1, #self.addUI do -- 坐标是正的
--            py = self.addUI[i][2] + scale * (self.addUI[i][3] - self.addUI[i][2])
--            if py > self.addUI[i][3] then
--               py = self.addUI[i][3] 
--            end
--            self.addUI[i][1]:setPositionY(py)
--        end

--        c.back:setRotation(angle)
--        self:excutOpacity(scale) -- 透明度变化
--    elseif scale > self.changeCriticalPoint[1] and scale <= self.changeCriticalPoint[2] then -- 这个范围内什么也不做

--    elseif scale > self.changeCriticalPoint[2] and scale <= 1 then -- 只有透明度变化
--        scale = 1 - scale -- 值 倒转
--        scale = scale / (1 - self.changeCriticalPoint[2]) * 1 -- 转为为 0 - 1 之间的值
--        self:excutOpacity(scale) -- 透明度变化
--    end

    local factor = self:getAddFactor() 
    local angle = self.min + scale * factor
    if angle > self.max then 
        angle = self.max
    end

    local py = nil 
    for i = 1, #self.addUI do -- 坐标是正的
        py = self.addUI[i][2] + scale * (self.addUI[i][3] - self.addUI[i][2])
        if py > self.addUI[i][3] then
           py = self.addUI[i][3] 
        end
        self.addUI[i][1]:setPositionY(py)
    end

    c.back:setRotation(angle)

    local o = scale / self.changeCriticalPoint[1] * 1  -- 0.8 之后就开始光晕就不再变暗
    if o >= 1 then 
        o = 1
    end

    self:excutOpacity(o) -- 透明度变化



end

--- 获取增长因子
function T:getAddFactor()
    return math.abs(self.max - self.min)
end

--- 初始化back的旋转度
function T:initBackRotation()
    local c = self.uiChild 
    c.back:setRotation(self.min)
end


--- 设置最小的angle
function T:setMinAngle(angle)
    self.min = angle
end

--- 设置最大的angle
function T:setMaxAngle(angle)
    self.max = angle
end

return T



--endregion
