--region HomeLight.lua
--Author    : YuDing
--Date      : 2015/5/11
--Introduce : 主城灯光特效


local T = {}


T.blinkNum = 1          -- 闪烁的次数
T.blinkTime = 4         -- 闪烁的间隔
T.circleTime = 0.15     -- 特效循环时间

function T:initView()
    self:startEffect()
end

function T:startEffect()
    local tb = self:getChildren()
    -- getVirtualRenderer
    for k, v in pairs(tb) do 
--        local render = v:getVirtualRenderer()
--        local old = self:getColor()
--	    --local ac = cc.RepeatForever:create(cc.Sequence:create(cc.TintTo:create(self.darkTime, T.darkColor[1], T.darkColor[2], T.darkColor[3]), cc.TintBy:create(self.brightTime, old.r - T.darkColor[1], old.g - T.darkColor[2], old.b - T.darkColor[3])))
--        local ac = cc.RepeatForever:create(cc.Blink:create(4, 1))
--	    render:runAction(ac)
        self:createEffect(v)
    end

end

function T:createEffect(node)
    local blinkNum = self.blinkNum          -- 闪烁的次数
    local blinkTime = self.blinkTime      -- 闪烁的间隔
    local circleTime = self.circleTime     -- 特效循环时间

    local blinkTb = {} 
    for i = 1, blinkNum do  -- 创建闪烁的动作
        table.insert(blinkTb, cc.FadeIn:create(blinkTime))
        table.insert(blinkTb, cc.FadeOut:create(blinkTime))
    end
    
    local blinkAc = cc.Sequence:create(blinkTb)

    local ac = cc.RepeatForever:create(cc.Sequence:create(blinkAc, cc.DelayTime:create(circleTime)))
    node:runAction(ac)
end


return T


--endregion
