local Direct=require("src.app.uiScript.scenes.homePage.base.RobotDirect")

local Robot=require("src.app.uiScript.scenes.homePage.base.Robot")

local T=mapping({}, LuaEventDispatcher)

T.ROBOT_TYPE_LEADER=0

T.ROBOT_TYPE_MEMBER=1

--- 巡逻的路径
T.PATH={{x=1188, y=880},{x=550, y=588},}

--- 团队成员偏移
T.TEAM_OFFSET={
	{type=T.ROBOT_TYPE_MEMBER,offset={x=-38,y=10}},
	{type=T.ROBOT_TYPE_LEADER,offset={x=0,y=0}},
	{type=T.ROBOT_TYPE_MEMBER,offset={x=-26,y=-10}},
}

--- 速度
T.SPEED=0.02

--- 团队显示对象列表
T.uiTeam={}

--- 路径的当前索引
T.curPathIndex=0

--- 当前的方向
T.curDirect=Direct.L

--- 待完成动作的机器人个数
T.uncompleteActionRobotCount=0

--- 创建
function T:create()
	--- 领队8向资源
local LEADER_DIRECT_8_RESES={
	[Direct.R]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_standing_rb")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_walk_rb")},
		turn={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_rotation_rb")},
	},
	[Direct.RT]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_standing_rt")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_walk_rt")},
		turn={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_rotation_rt")},
	},
	[Direct.T]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_standing_rt")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_walk_rt")},
		turn={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_rotation_rt")},
	},
	[Direct.LT]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_standing_rt")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_walk_rt")},
		turn={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_rotation_rt")},
	},
	[Direct.L]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_standing_rb")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_walk_rb")},
		turn={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_rotation_rb")},
	},
	[Direct.LB]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_standing_rb")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_walk_rb")},
		turn={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_rotation_rb")},
	},
	[Direct.B]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_standing_rb")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_walk_rb")},
		turn={isFlippedX=true,animation=ResLoader:getAnimation("robotLeader_rotation_rb")},
	},
	[Direct.RB]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_standing_rb")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_walk_rb")},
		turn={isFlippedX=false,animation=ResLoader:getAnimation("robotLeader_rotation_rb")},
	},
}

--- 成员8向资源
local MEMBER_DIRECT_8_RESES={
	[Direct.R]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_standing_rb")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_walk_rb")},
		squating={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_squating_rb")},
		squatDn={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_squat_rb")},
		standUp={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_stand_rb")},
	},
	[Direct.RT]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_standing_rt")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_walk_rt")},
		squating={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_squating_rt")},
		squatDn={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_squat_rt")},
		standUp={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_stand_rt")},
	},
	[Direct.T]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_standing_rt")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_walk_rt")},
		squating={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_squating_rt")},
		squatDn={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_squat_rt")},
		standUp={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_stand_rt")},
	},
	[Direct.LT]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_standing_rt")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_walk_rt")},
		squating={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_squating_rt")},
		squatDn={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_squat_rt")},
		standUp={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_stand_rt")},
	},
	[Direct.L]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_standing_rb")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_walk_rb")},
		squating={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_squating_rb")},
		squatDn={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_squat_rb")},
		standUp={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_stand_rb")},
	},
	[Direct.LB]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_standing_rb")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_walk_rb")},
		squating={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_squating_rb")},
		squatDn={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_squat_rb")},
		standUp={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_stand_rb")},
	},
	[Direct.B]={
		stand={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_standing_rb")},
		walk={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_walk_rb")},
		squating={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_squating_rb")},
		squatDn={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_squat_rb")},
		standUp={isFlippedX=true,animation=ResLoader:getAnimation("robotMember_2_stand_rb")},
	},
	[Direct.RB]={
		stand={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_standing_rb")},
		walk={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_walk_rb")},
		squating={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_squating_rb")},
		squatDn={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_squat_rb")},
		standUp={isFlippedX=false,animation=ResLoader:getAnimation("robotMember_2_stand_rb")},
	},
}

	local uiTeam=self.uiTeam

	--方向
	local direct=Direct.R
	--角度
	local angle=0
	--位置
	local sPt={x=0,y=0}

	local path=self.PATH
	if #path > 0 then
		sPt=path[1]
	end
	if #path >= 2 then
		angle=MathUtil.angleOfDoudlePoint(sPt,path[2])
		direct=Direct:angle2direct(angle)
	end

	for k,v in ipairs(self.TEAM_OFFSET) do
		local robotType=v.type
		local offset=v.offset

		local uiRobot
		if robotType == self.ROBOT_TYPE_LEADER then
			uiRobot=Robot(LEADER_DIRECT_8_RESES)
		else
			uiRobot=Robot(MEMBER_DIRECT_8_RESES)
		end
		uiRobot.robotType=robotType
		self:addChild(uiRobot,k)

		local pt=cc.p(self:calcOffsetedPosition(sPt,angle,offset))
		uiRobot:standing(pt,direct)

		uiTeam[k]=uiRobot
	end

	self.curDirect=direct
end

--- 巡逻
function T:patrol()
	if self.isRuning then
		return
	end

	local path=self.PATH
	local curIndex=self.curPathIndex + 1

	--开始点和结束点
	local sPt,ePt=nil,nil
	if #path < curIndex then
		curIndex=1
	end
	sPt,ePt=path[curIndex],(#path < curIndex + 1) and path[1] or path[curIndex + 1]

	self.curPathIndex=curIndex

	self.uncompleteActionRobotCount=0
	local angle=MathUtil.angleOfDoudlePoint(sPt,ePt)
	for k,uiRobot in ipairs(self.uiTeam) do
		self.uncompleteActionRobotCount=self.uncompleteActionRobotCount + 1
		uiRobot:luaAddEventListener(Robot.EVT_TYPE_WALK_STATUS_CHANGE,self,self.walkStatusChangeHandler)

		local pt=cc.p(self:calcOffsetedPosition(ePt,angle,self.TEAM_OFFSET[k].offset))
		uiRobot:walkTo(pt)
	end

	self.curDirect=Direct:angle2direct(angle)
end

--- 机器人的行走状态改变
-- @param target 改变行走状态的机器人对象
-- @param lastWalkStatus 上一次的状态
function T:walkStatusChangeHandler(target,lastWalkStatus)
	if lastWalkStatus == Robot.STATUS_WALK_WALKING and target:getWalkStatus() == Robot.STATUS_WALK_STANDING then
		target:luaRemoveEventListener(Robot.EVT_TYPE_WALK_STATUS_CHANGE,self,self.walkStatusChangeHandler)

		target:luaRemoveEventListener(Robot.EVT_TYPE_WALK_STATUS_CHANGE,self,self.walkStatusChangeHandler2)

		local uCount=self.uncompleteActionRobotCount-1
		if uCount <= 0 then
			self.uncompleteActionRobotCount=0

			self.isRuning=false
			AbstractUI.timeout(self,function()
				self:turn()
			end,0)
		else
			self.uncompleteActionRobotCount=uCount
		end
	end
end

--- 转向
function T:turn()
	if self.isRuning then
		return
	end

	local uiTeam=self.uiTeam

	local path=self.PATH
	local curIndex=self.curPathIndex + 1

	--开始点和结束点
	local sPt,ePt=nil,nil
	if #path < curIndex then
		curIndex=1
	end
	sPt,ePt=path[curIndex],(#path < curIndex + 1) and path[1] or path[curIndex + 1]

	local angle=MathUtil.angleOfDoudlePoint(sPt,ePt)
	local direct=Direct:angle2direct(angle)
	if math.abs(direct - self.curDirect) == 4 then
		local t=uiTeam[1]
		uiTeam[1]=uiTeam[3]
		uiTeam[3]=t
	end

	self.uncompleteActionRobotCount=0
	for k,uiRobot in ipairs(uiTeam) do
		if uiRobot.robotType == self.ROBOT_TYPE_LEADER then
			uiRobot:turnTo(direct)
		else
			self.uncompleteActionRobotCount=self.uncompleteActionRobotCount + 1
			uiRobot:luaAddEventListener(Robot.EVT_TYPE_WALK_STATUS_CHANGE,self,self.walkStatusChangeHandler2)

			local pt=cc.p(self:calcOffsetedPosition(sPt,angle,self.TEAM_OFFSET[k].offset))
			uiRobot:walkTo(pt)
		end
	end
end

--- 机器人的行走状态改变
-- @param target 改变行走状态的机器人对象
-- @param lastWalkStatus 上一次的状态
function T:walkStatusChangeHandler2(target,lastWalkStatus)
	if lastWalkStatus == Robot.STATUS_WALK_WALKING and target:getWalkStatus() == Robot.STATUS_WALK_STANDING then
		target:luaRemoveEventListener(Robot.EVT_TYPE_WALK_STATUS_CHANGE,self,self.walkStatusChangeHandler2)

		local uCount=self.uncompleteActionRobotCount-1
		if uCount <= 0 then
			self.uncompleteActionRobotCount=0

			self.isRuning=false
			AbstractUI.timeout(self,function()
				--if random(1,100) > 30 then
					self:patrol()
				--else
				--	self:squatDn()
				--end
			end,0)
		else
			self.uncompleteActionRobotCount=uCount
		end
	end
end

--- 蹲下
function T:squatDn()
	local uiTeam=self.uiTeam
	
	self.uncompleteActionRobotCount=0
	for k,uiRobot in ipairs(uiTeam) do
		uiRobot:squatDn()
	end
end

--- 计算偏移后的位置
-- @param refPosition 参照物位置
-- @param refAngle 参照物的角度
-- @param zeroAngleOffset 在参照物为0方向时的偏移
-- @param 根据参照物计算出的偏移
function T:calcOffsetedPosition(refPosition,refAngle,zeroAngleOffset)
	--偏移点到参照物的距离
	local d=MathUtil.pointToPointDistance(zeroAngleOffset.x,zeroAngleOffset.y,0,0)
	--当前偏移
	local offset=MathUtil.getPointOfCircle((MathUtil.angleOfDoudlePoint({x=0,y=0},zeroAngleOffset)+refAngle)/180*math.pi,d)

	return refPosition.x+offset.x,refPosition.y+offset.y
end

return T
