local BuildingNameBox_level=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox_level")

local AbstractBuilding=require("src.app.uiScript.scenes.homePage.base.building.AbstractBuilding")

--- 指挥中心
local T=Class.BuildingCenter(AbstractBuilding)

function T:def()
	AbstractBuilding.def(self)

	--- 空闲时的特效1
	-- _uiFreeEff1

	--- 空闲时的特效2
	-- _uiFreeEff2

	--- 升级时的特效
	-- _uiLevelupEff
end

--- 构造函数
-- @param buildLoc 建筑位置
-- @param uiContainer ui组件容器
function T:ctor(buildLoc,uiContainer)
	AbstractBuilding.ctor(self,buildLoc,uiContainer)
end

function T:_init()
	AbstractBuilding._init(self)
end

--- 创建建筑名称显示项
function T:createBuildingName()
	local uiC=self._uiContainer

	local uiBName=BuildingNameBox_level()
	uiBName:setBuildingName(Language:get("uy116"))
	uiC:addChild(uiBName,10)
	uiBName:setPosition(230,380)

	return uiBName
end

--- 创建建筑升级进度条
function T:createLvUpProgressBar()
	local uiPBar=AbstractBuilding.createLvUpProgressBar(self)
	uiPBar:setPosition(230,200)
	
	return uiPBar
end

--- 初始化触摸热点区域
function T:initTouchHitArea()
	local s=self._uiContainer:getContentSize()
	local ox,oy=s.width/2,s.height/2

	self._touchHitArea = {
		{x=118+ox, y=156+oy},
		{x=158+ox, y=-27+oy},
		{x=54+ox, y=-210+oy},
		{x=-41+ox, y=-149+oy},
		{x=-126+ox, y=110+oy},
		{x=0+ox, y=196+oy},
	}

	AbstractBuilding.initTouchHitArea(self)
end

--- 播放空闲状态时的特效
function T:playFreeEff()
	self:stopLevelUpingEff()

	local uiFEff1=self._uiFreeEff1
	if uiFEff1 then
		return
	end

	local uiC=self._uiContainer

	uiFEff1 = HomePageManager:getEffWithOutRandom("centerFreeTimeEff", 15)
	uiC:addChild(uiFEff1,1)
	uiFEff1:setPosition(176,266)
	self._uiFreeEff1=uiFEff1

	local uiFEff2 = HomePageManager:getEffWithOutRandom("centerFreeTimeEffTwo", 8)
	uiC:addChild(uiFEff2,1)
	uiFEff2:setPosition(172,236)
	self._uiFreeEff2=uiFEff2
end

--- 停止播放空闲状态时的特效
function T:stopFreeEff()
	local uiFEff1=self._uiFreeEff1
	if uiFEff1 then
		uiFEff1:removeFromParent()
		self._uiFreeEff1=nil
	end

	local uiFEff2=self._uiFreeEff2
	if uiFEff2 then
		uiFEff2:removeFromParent()
		self._uiFreeEff2=nil
	end
end

--- 播放升级状态中的特效
function T:playLevelUpingEff()
	self:playFreeEff()

	local uiLEff=self._uiLevelupEff
	if uiLEff then
		return
	end

	local uiC=self._uiContainer

	uiLEff = HomePageManager:getEffWithOutRandom("centerProduceEff")
	uiLEff:setBlendFunc({src=0x0302, dst=1})
	uiC:addChild(uiLEff)
	uiLEff:setPosition(282,240)
	self._uiLevelupEff=uiLEff
end

--- 停止播放升级状态中的特效
function T:stopLevelUpingEff()
	local uiLEff=self._uiLevelupEff
	if uiLEff then
		uiLEff:removeFromParent()
		self._uiLevelupEff=nil
	end
end

return T
