local BuildingNameBox=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox")

local AbstractBuilding=require("src.app.uiScript.scenes.homePage.base.building.AbstractBuilding")

--- 战机实验室
local T=Class.BuildingCommand(AbstractBuilding)

function T:def()
	AbstractBuilding.def(self)
end

--- 构造函数
-- @param buildLoc 建筑位置
-- @param uiContainer ui组件容器
function T:ctor(buildLoc,uiContainer)
	AbstractBuilding.ctor(self,buildLoc,uiContainer)
end

function T:_init()
	AbstractBuilding._init(self)
	
	HomePageManager:addEffect(self._uiContainer, "transfer")
end

--- 创建建筑名称显示项
function T:createBuildingName()
	local uiC=self._uiContainer

	local uiBName=BuildingNameBox()
	uiBName:setBuildingName(Language:get("uy126"))
	uiC:addChild(uiBName,10)
	uiBName:setPosition(110,160)

	return uiBName
end

--- 初始化触摸热点区域
function T:initTouchHitArea()
	local s=self._uiContainer:getContentSize()
	local ox,oy=s.width/2,s.height/2

	self._touchHitArea = {
		{x=67+ox, y=76+oy},
		{x=67+ox, y=-59+oy},
		{x=0+ox, y=-71+oy},
		{x=-69+ox, y=-59+oy},
		{x=-69+ox, y=77+oy}
	}

	AbstractBuilding.initTouchHitArea(self)
end

--- 切换到等待建造状态
function T:switchWaitBuildState()
	
end

return T
