local BuildingNameBox=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox")

local AbstractBuilding=require("src.app.uiScript.scenes.homePage.base.building.AbstractBuilding")

--- 战机实验室
local T=Class.BuildingLaboratory(AbstractBuilding)

function T:def()
	AbstractBuilding.def(self)

	--- 点击时的特效
	-- _uiClickEff
end

--- 构造函数
-- @param buildLoc 建筑位置
-- @param uiContainer ui组件容器
function T:ctor(buildLoc,uiContainer)
	AbstractBuilding.ctor(self,buildLoc,uiContainer)
end

function T:_init()
	self.stateIconPosition={x=120,y=90}

	AbstractBuilding._init(self)
end

--- 创建建筑名称显示项
function T:createBuildingName()
	local uiC=self._uiContainer

	local uiBName=BuildingNameBox()
	uiBName:setBuildingName(Language:get("uy118"))
	uiC:addChild(uiBName,10)
	uiBName:setPosition(120,146)

	return uiBName
end

--- 添加事件侦听器
function T:addEvtListeners()
	AbstractBuilding.addEvtListeners(self)

	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updateOpenState)
end

--- 移除事件侦听器
function T:rmvEvtListeners()
	AbstractBuilding.rmvEvtListeners(self)

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.playerLvl, self, self.updateOpenState)
end

--- 初始化触摸热点区域
function T:initTouchHitArea()
	local s=self._uiContainer:getContentSize()
	local ox,oy=s.width/2,s.height/2

	self._touchHitArea = {
		{x=36+ox, y=78+oy},
		{x=100+ox, y=17+oy},
		{x=92+ox, y=-46+oy},
		{x=10+ox, y=-54+oy},
		{x=-72+ox, y=-40+oy},
		{x=-27+ox, y=58+oy}
	}

	AbstractBuilding.initTouchHitArea(self)
end

--- 播放点击特效
function T:playClickEff()
	local uiCEff=self._uiClickEff
	if uiCEff then
		return
	end

	local uiC=self._uiContainer

	uiCEff = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("commandFreeTimeEff_00000.png"))
	uiC:addChild(uiCEff,1)
	uiCEff:setPosition(143.5,53)
	uiCEff:runAction(
		cc.Sequence:create(
			cc.FadeIn:create(0.15),
			cc.DelayTime:create(0.2),
			cc.FadeOut:create(0.15),
			cc.DelayTime:create(0.2),
			cc.CallFunc:create(function(t)
				t:removeFromParent()
				self._uiClickEff=nil
			end)
		)
	)
	self._uiClickEff=uiCEff
end

--- 切换到等待建造状态
function T:switchWaitBuildState()
	if self._build_state == self.BUILD_STATE_UNLOCK then
		return
	end

	self:releaseStateIconBack()
	self:releaseStateIcon()
	self:releaseSmoothEff()

	self._build_state = self.BUILD_STATE_UNLOCK
end

--- 检查点击
-- @param touchPt 点击位置
function T:checkTouch(touchPt)
	if AbstractBuilding.checkTouch(self,touchPt) then
		self:playClickEff()

		return true
	end

	return false
end

return T
