--- 建筑升级进度条
local T=Class.BuildingLvUpProgressBar(
	function()
		return cc.Node:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 进度条背景
	-- _uiProgressBarBack

	--- 进度条
	-- _uiProgressBar

	--- 剩余时间背景
	-- _uiRemainingTimeBack

	--- 剩余时间
	-- _uiRemainingTime
end

function T:ctor()
	AbstractUI.ctor(self)
end

--- 创建进度条相关的UI
function T:createProgressUIS()
	--进度条背景
	local uiPBBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("homePageBldLevelUpFrame.png"))
	self:addChild(uiPBBack)
	self._uiProgressBarBack=uiPBBack

	--进度条
	local uiPBar = cc.ProgressTimer:create(cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("homePageBldLevelupBar.png")))
	uiPBar:setBarChangeRate(cc.p(1,0))--进度条动画方向，（1,0）表示横方向，（0,1）表示纵方向
	uiPBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)--进度条类型
	uiPBar:setMidpoint(cc.p(0,1))--进度条的起始点，（0,y）表示最左边，（1,,y）表示最右边，（x,1）表示最上面，（x,0）表示最下面。
	uiPBar:setPercentage(0)--初始值
	self:addChild(uiPBar)
	uiPBar:setAnchorPoint(0.5, 0.5)
	self._uiProgressBar=uiPBar

	--剩余时间背景
	local uiRTimeBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("timeBack.png"))
	self:addChild(uiRTimeBack)
	uiRTimeBack:setPosition(0,-18)
	self._uiRemainingTimeBack=uiRTimeBack

	--剩余时间
	local uiRTime=XMLLabel()
	uiRTime:setAlign("center","middle")
	uiRTime:setFontSize(18)
	uiRTime:setContentSize(cc.size(108,36))
	uiRTime:setAnchorPoint(0.5, 0.5)
	self:addChild(uiRTime)
	uiRTime:setPosition(0,-18)
	self._uiRemainingTime=uiRTime
end

--- 设置进度(值范围为 0~100 )
-- @param percent 进度百分比
-- @param remainingSec 剩余时间(秒)
function T:setProgress(percent,remainingSec)
	if percent > 0 and percent < 100 then
		if not self._uiProgressBarBack then
			self:createProgressUIS()
		end

		self:setVisible(true)

		local curP=self._uiProgressBar:getPercentage()
		--如果当前值大于新值,会出现进度条倒走的情况,所以要先判断
		if curP > percent then
			self._uiProgressBar:setPercentage(0)
			curP=0
		end
		self._uiProgressBar:runAction(cc.ProgressFromTo:create(1,curP,percent))

		self._uiRemainingTime:setString(UnitConversion.handleTime4(remainingSec))
	else
		if self._uiProgressBarBack then
			self:setVisible(false)
		end
	end
end

return T
