local BuildingNameBox_level=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox_level")

local AbstractBuilding=require("src.app.uiScript.scenes.homePage.base.building.AbstractBuilding")

--- 铸币厂
local T=Class.BuildingMoney(AbstractBuilding)

function T:def()
	AbstractBuilding.def(self)
end

--- 构造函数
-- @param buildLoc 建筑位置
-- @param uiContainer ui组件容器
function T:ctor(buildLoc,uiContainer)
	AbstractBuilding.ctor(self,buildLoc,uiContainer)
end

function T:_init()
	self.stateIconPosition={x=110,y=100}

	AbstractBuilding._init(self)

	--- 空闲时的特效
	-- _uiFreeEff

	--- 升级时的特效
	-- _uiLevelupEff
end

--- 创建建筑名称显示项
function T:createBuildingName()
	local uiC=self._uiContainer

	local uiBName=BuildingNameBox_level()
	uiBName:setBuildingName(Language:get("uy125"))
	uiC:addChild(uiBName,10)
	uiBName:setPosition(110,156)

	return uiBName
end

--- 创建建筑升级进度条
function T:createLvUpProgressBar()
	local uiPBar=AbstractBuilding.createLvUpProgressBar(self)
	uiPBar:setPosition(110,10)
	
	return uiPBar
end

--- 初始化触摸热点区域
function T:initTouchHitArea()
	local s=self._uiContainer:getContentSize()
	local ox,oy=s.width/2,s.height/2

	self._touchHitArea = {
		{x=95+ox, y=67+oy},
		{x=88+ox, y=-78+oy},
		{x=-35+ox, y=-86+oy},
		{x=-19+ox, y=101+oy}
	}

	AbstractBuilding.initTouchHitArea(self)
end

--- 播放空闲状态时的特效
function T:playFreeEff()
    self:stopLevelUpingEff()

	local uiFEff=self._uiFreeEff
	if uiFEff then
		return
	end

	local uiC=self._uiContainer
	uiFEff = HomePageManager:getEffWithOutRandom("goldFreeTimeTwoEff", 2)
	uiC:addChild(uiFEff,1)
	uiFEff:setPosition(91.5,130.5)
	self._uiFreeEff=uiFEff
end

--- 停止播放空闲状态时的特效
function T:stopFreeEff()
	local uiFEff=self._uiFreeEff
	if uiFEff then
		uiFEff:removeFromParent()
		self._uiFreeEff=nil
	end
end

--- 播放升级状态中的特效
function T:playLevelUpingEff()
	self:playFreeEff()

	local uiLEff=self._uiLevelupEff
	if uiLEff then
		return
	end

	local uiC=self._uiContainer
	uiLEff = HomePageManager:getEffWithOutRandom("goldFreeTimeEff")
	uiLEff:setBlendFunc({src=0x0302, dst=1})
	self._uiContainer:addChild(uiLEff,1)
	uiLEff:setPosition(116.5,86.5)
	self._uiLevelupEff=uiLEff
end

--- 停止播放升级状态中的特效
function T:stopLevelUpingEff()
	local uiLEff=self._uiLevelupEff
	if uiLEff then
		uiLEff:removeFromParent()
		self._uiLevelupEff=nil
	end
end

return T
