local BuildingNameBox=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox")

--- 带等级的建筑名称显示框
local T=Class.BuildingNameBox_level(BuildingNameBox)

function T:def()
	BuildingNameBox.def(self)

	--- 等级容器
	-- _uiLvContainer

	--- 等级
	-- _uiLv

	--- 等级移动特效
	-- _lvMoveAct
end

function T:ctor()
	BuildingNameBox.ctor(self)
end

--- 创建等级相关的UI
function T:createLvUIS()
	--等级容器
	local uiLvC=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("homePageLvlFrame.png"))
	self:addChild(uiLvC)
	self._uiLvContainer=uiLvC

	--等级
	local uiLv=XMLLabel()
	uiLv:setAlign("center","middle")
	uiLv:setCssStyle(CssStyles.buildingName)
	uiLvC:addChild(uiLv)
	REL:relOther(uiLv,uiLvC,0,0,0,0)
	self._uiLv=uiLv

	self:updateLvContainerPosition()
end

--- 设置建筑名称
function T:setBuildingName(value)
	BuildingNameBox.setBuildingName(self,value)
	
	local uiNBack=self._uiNameBack
	REL:relOther(self._uiNameBBorder,uiNBack,-12,0,uiNBack:getContentSize().height-2,SIZE_NIL)
	
	if self._uiLvContainer then
		self:updateLvContainerPosition()
	end
end

--- 更新等级框位置
function T:updateLvContainerPosition()
	if self._lvMoveAct then
		return
	end

	if self._nameIsHided then
		self._uiLvContainer:setPosition(0,0)
	else
		self._uiLvContainer:setPosition(-self._uiNameBack:getContentSize().width/2-20,0)
	end
end

--- 设置建筑等级
function T:setBuildingLv(value)
	if tonumber(value) > 0 then
		if not self._uiLvContainer then
			self:createLvUIS()
		end

		self._uiLvContainer:setVisible(true)
		self._uiLv:setString(tostring(value))
	else
		if self._uiLvContainer then
			self._uiLvContainer:setVisible(false)
		end
	end
end

--- 显示建筑名称
function T:showBuildingName()
	if self._nameIsHided then
		local uiLC=self._uiLvContainer
		if uiLC then
			if self._lvMoveAct then
				uiLC:stopAction(self._lvMoveAct)
			end
			self._lvMoveAct=cc.Sequence:create(
				cc.MoveTo:create(0.15,{x=-self._uiNameBack:getContentSize().width/2-20,y=0}),
				cc.CallFunc:create(function()
					self._lvMoveAct=nil
				end)
			)
			uiLC:runAction(self._lvMoveAct)
		end
	end

	BuildingNameBox.showBuildingName(self)
end

--- 隐藏建筑名称
function T:hideBuildingName()
	if not self._nameIsHided then
		local uiLC=self._uiLvContainer

		if uiLC then
			if self._lvMoveAct then
				uiLC:stopAction(self._lvMoveAct)
			end
			self._lvMoveAct=cc.Sequence:create(
				cc.MoveTo:create(0.15,{x=0,y=0}),
				cc.CallFunc:create(function()
					self._lvMoveAct=nil
				end)
			)
			uiLC:runAction(self._lvMoveAct)
		end
	end

	BuildingNameBox.hideBuildingName(self)
end

return T
