local BuildingNameBox_level=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox_level")

local AbstractBuilding=require("src.app.uiScript.scenes.homePage.base.building.AbstractBuilding")

--- 联盟
local T=Class.BuildingRegion(AbstractBuilding)

function T:def()
	AbstractBuilding.def(self)
end

--- 构造函数
-- @param buildLoc 建筑位置
-- @param uiContainer ui组件容器
function T:ctor(buildLoc,uiContainer)
	AbstractBuilding.ctor(self,buildLoc,uiContainer)
end

function T:_init()
	self.stateIconPosition={x=120,y=100}

	AbstractBuilding._init(self)

	self:updateBuildLv()
end

--- 创建建筑名称显示项
function T:createBuildingName()
	local uiC=self._uiContainer

	local uiBName=BuildingNameBox_level()
	uiBName:setBuildingName(Language:get("uy78"))
	uiC:addChild(uiBName,10)
	uiBName:setPosition(120,156)

	return uiBName
end

--- 更新建筑等级
function T:updateBuildLv()
	local lv=AllianceManager:getAllianceLv() or 0

	if lv > 0 then
		if not self._uiBuildingName then
			self._uiBuildingName=self:createBuildingName()
		end
		
		self._uiBuildingName:setBuildingLv(lv)
	else
		if self._uiBuildingName then
			self._uiBuildingName:setBuildingLv(0)
		end
	end
end

--- 添加事件侦听器
function T:addEvtListeners()
	AbstractBuilding.addEvtListeners(self)

	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_CHANGE_LEVEL, self, self.updateBuildLv)
	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_BY_KICK_OUT, self, self.updateBuildLv)
	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_EXIT_ALLIANCE, self, self.updateBuildLv)
	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_JOINED_ALLIANCE, self, self.updateBuildLv)
	AllianceManager:luaAddEventListener(AllianceManager.EVT_TYPE_CREATED_ALLIANCE, self, self.updateBuildLv)

	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateFirstName)
end

--- 移除事件侦听器
function T:rmvEvtListeners()
	AbstractBuilding.rmvEvtListeners(self)

	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_CHANGE_LEVEL, self, self.updateBuildLv)
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_BY_KICK_OUT, self, self.updateBuildLv)
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_EXIT_ALLIANCE, self, self.updateBuildLv)
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_JOINED_ALLIANCE, self, self.updateBuildLv)
	AllianceManager:luaRemoveEventListener(AllianceManager.EVT_TYPE_CREATED_ALLIANCE, self, self.updateBuildLv)

	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateFirstName)
end

--- 初始化触摸热点区域
function T:initTouchHitArea()
	local s=self._uiContainer:getContentSize()
	local ox,oy=s.width/2,s.height/2

	self._touchHitArea = {
		{x=36+ox, y=108+oy},
		{x=89+ox, y=-97+oy},
		{x=-26+ox, y=-89+oy},
		{x=1+ox, y=102+oy}
	}

	AbstractBuilding.initTouchHitArea(self)
end

--- 切换到等待建造状态
function T:switchWaitBuildState()
	if self._build_state == self.BUILD_STATE_UNLOCK then
		return
	end

	self:releaseStateIconBack()
	self:releaseStateIcon()
	self:releaseSmoothEff()

	self._build_state = self.BUILD_STATE_UNLOCK
end

return T
