local BuildingNameBox_level=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox_level")

local AbstractBuilding=require("src.app.uiScript.scenes.homePage.base.building.AbstractBuilding")

--- 仓库
local T=Class.BuildingStore(AbstractBuilding)

function T:def()
	AbstractBuilding.def(self)
end

--- 构造函数
-- @param buildLoc 建筑位置
-- @param uiContainer ui组件容器
function T:ctor(buildLoc,uiContainer)
	AbstractBuilding.ctor(self,buildLoc,uiContainer)
end

function T:_init()
	self.stateIconPosition={x=90,y=70}

	AbstractBuilding._init(self)

	--- 升级时的特效
	-- _uiLevelupEff

	--- 升级时的特效-闪烁1
	-- _uiLevelupFlashEff1

	--- 升级时的特效-闪烁2
	-- _uiLevelupFlashEff2
end

--- 创建建筑名称显示项
function T:createBuildingName()
	local uiC=self._uiContainer

	local uiBName=BuildingNameBox_level()
	uiBName:setBuildingName(Language:get("uy143"))
	uiC:addChild(uiBName,10)
	uiBName:setPosition(90,126)

	return uiBName
end

--- 创建建筑升级进度条
function T:createLvUpProgressBar()
	local uiPBar=AbstractBuilding.createLvUpProgressBar(self)
	uiPBar:setPosition(90,10)
	
	return uiPBar
end

--- 初始化触摸热点区域
function T:initTouchHitArea()
	local s=self._uiContainer:getContentSize()
	local ox,oy=s.width/2,s.height/2

	self._touchHitArea = {
		{x=74+ox, y=60+oy},
		{x=68+ox, y=-60+oy},
		{x=0+ox, y=-68+oy},
		{x=-71+ox, y=-41+oy},
		{x=-51+ox, y=-6+oy},
		{x=40+ox, y=66+oy}
	}

	AbstractBuilding.initTouchHitArea(self)
end

--- 播放空闲状态时的特效
function T:playFreeEff()
	self:stopLevelUpingEff()
end

--- 播放升级状态中的特效
function T:playLevelUpingEff()
	local uiLEff=self._uiLevelupEff
	if uiLEff then
		return
	end

	local uiC=self._uiContainer

	uiLEff = HomePageManager:getEffWithOutRandom("storeBusyEff")
	self._uiContainer:addChild(uiLEff,1)
	uiLEff:setPosition(78.5,34.5)
	self._uiLevelupEff=uiLEff

	local flash=function(uiEff)
		uiEff:runAction(cc.RepeatForever:create(
			cc.Sequence:create(
				cc.FadeIn:create(0.15),
				cc.DelayTime:create(0.2),
				cc.FadeOut:create(0.15),
				cc.DelayTime:create(0.2)
			)
		))
	end

	local uiFEff1 = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("storeEffTwo_00000.png"))
	uiC:addChild(uiFEff1,1)
	uiFEff1:setPosition(34.5,34.5)
	flash(uiFEff1)
	self._uiLevelupFlashEff1=uiFEff1

	local uiFEff2 = cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("storeEff_00000.png"))
	uiC:addChild(uiFEff2,1)
	uiFEff2:setPosition(54.5,59.5)
	flash(uiFEff2)
	self._uiLevelupFlashEff2=uiFEff2
end

--- 停止播放升级状态中的特效
function T:stopLevelUpingEff()
	local uiLEff=self._uiLevelupEff
	if uiLEff then
		uiLEff:removeFromParent()
		self._uiLevelupEff=nil
	end

	local uiFEff1=self._uiLevelupFlashEff1
	if uiFEff1 then
		uiFEff1:removeFromParent()
		self._uiLevelupFlashEff1=nil
	end

	local uiFEff2=self._uiLevelupFlashEff2
	if uiFEff2 then
		uiFEff2:removeFromParent()
		self._uiLevelupFlashEff2=nil
	end
end

return T
