local BuildingNameBox=require("src.app.uiScript.scenes.homePage.base.building.BuildingNameBox")

local AbstractBuilding=require("src.app.uiScript.scenes.homePage.base.building.AbstractBuilding")

--- 许愿池
local T=Class.BuildingWish(AbstractBuilding)

function T:def()
	AbstractBuilding.def(self)

	--- 有瓶盖的特效
	-- _uiHasEff
end

--- 构造函数
-- @param buildLoc 建筑位置
-- @param uiContainer ui组件容器
function T:ctor(buildLoc,uiContainer)
	AbstractBuilding.ctor(self,buildLoc,uiContainer)
end

function T:_init()
	AbstractBuilding._init(self)

	self:updateLottery()

	if not self._uiBuildingName then
		self._uiBuildingName=self:createBuildingName()
	end
end

--- 创建建筑名称显示项
function T:createBuildingName()
	local uiC=self._uiContainer

	local uiBName=BuildingNameBox()
	uiBName:setBuildingName(Language:get("uy119"))
	uiC:addChild(uiBName,10)
	uiBName:setPosition(100,120)

	return uiBName
end

--- 添加事件侦听器
function T:addEvtListeners()
	AbstractBuilding.addEvtListeners(self)

	PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. "205", self, self.updateLottery)
	SetStates.luckyLotteryState:luaAddEventListener(SetStates.luckyLotteryState.EVT_FREE_LUCKY_LOTTERY_REFRESH, self, self.updateLottery)

	--断线重连/或重新登陆
	UserInfoMgr:luaAddEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateLottery)
end

--- 移除事件侦听器
function T:rmvEvtListeners()
	AbstractBuilding.rmvEvtListeners(self)

	PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. "205", self, self.updateLottery)
	SetStates.luckyLotteryState:luaRemoveEventListener(SetStates.luckyLotteryState.EVT_FREE_LUCKY_LOTTERY_REFRESH, self, self.updateLottery)

	UserInfoMgr:luaRemoveEventListener(UserInfoMgr.EVT_TYPE_RESET,self,self.updateLottery)
end

--- 初始化触摸热点区域
function T:initTouchHitArea()
	local s=self._uiContainer:getContentSize()
	local ox,oy=s.width/2,s.height/2

	self._touchHitArea = {
		{x=64+ox, y=52+oy},
		{x=84+ox, y=-35+oy},
		{x=10+ox, y=-60+oy},
		{x=-45+ox, y=-43+oy},
		{x=-47+ox, y=50+oy}
	}

	AbstractBuilding.initTouchHitArea(self)
end

--- 切换到等待建造状态
function T:switchWaitBuildState()

end

--- 播放有瓶盖的特效
function T:playHasEff()
	local uiEff=self._uiHasEff
	if uiEff then
		return
	end

	local uiC=self._uiContainer

	uiEff=HomePageManager:getEffWithOutRandom("wishFreeTimeEff")
	uiEff:setBlendFunc({src=0x0302, dst=1})
	uiC:addChild(uiEff,1)
	uiEff:setPosition(99.5,79.5)
	self._uiHasEff=uiEff
end

--- 停止有瓶盖的特效(没有瓶盖了)
function T:stopHasEff()
	local uiEff=self._uiHasEff
	if uiEff then
		uiEff:removeFromParent()
		self._uiHasEff=nil
	end
end

--- 更新
function T:updateLottery()
	if SetStates.luckyLotteryState:judgeIsLottrey() then
		self:playHasEff()
	else
		local num = PropsInfoMgr:getPlayerPropByID(205)
		if num > 0 then
			self:playHasEff()
		else
			self:stopHasEff()
		end
	end
end

return T
