--region HomePageOutSideConfig.lua
--Author    : YuDing
--Date      : 2014/12/19
--Introduce : 野外配置文件

-- 7 铁矿
-- 8 石油
-- 9 硅矿
-- 10 钛矿
-- @param lv 开放等级
-- @param p 在地图坐标
-- @res 资源id
-- @pid 位置标识
local T = {}
T.pos = { -- lv 达到多少等级开放 p 位于地图上坐标 res 可建造的资源 34个
    {lv = 1, p =  {x = 129, y = 804},    res = {7,8,9},  pId = 101, show = 13},
    {lv = 1, p =  {x = 301, y = 796},    res = {7,8,9},  pId = 102, show = 12},
    {lv = 1, p =  {x = 568, y = 789},    res = {7,8,9},   pId = 103, show = 5},
    {lv = 1, p =  {x = 752, y = 818},    res = {7,8,9},   pId = 104, show = 4},
    {lv = 2, p =  {x = 769, y = 641},    res = {7,8,9},   pId = 105, show = 9},
    {lv = 4, p =  {x = 151, y = 941},    res = {7,8,9},  pId = 106, show = 8},
    {lv = 6, p =  {x = 284, y = 879},    res = {7,8,9},  pId = 107, show = 7},
    {lv = 8, p =  {x = 438, y = 852},    res = {7,8,9},  pId = 108, show = 6},
    {lv = 10, p = {x = 619, y = 889},    res = {7,8,9},  pId = 109, show = 2}, 
    {lv = 12, p = {x = 411, y = 507},   res = {7,8,9}, pId = 110, show = 18},
    {lv = 14, p = {x = 450, y = 729},   res = {7,8,9},  pId = 111, show = 11},
    {lv = 16, p = {x = 262, y = 542},   res = {7,8,9},  pId = 112, show = 19},
    {lv = 18, p = {x = 392, y = 613},   res = {7,8,9},  pId = 113, show = 15},
    {lv = 20, p = {x = 636, y = 700},   res = {7,8,9},  pId = 114, show = 10},
    {lv = 22, p = {x = 100, y = 438},   res = {7,8,9},  pId = 115, show = 24},
    {lv = 24, p = {x = 291, y = 453},   res = {7,8,9},  pId = 116, show = 23},
    {lv = 26, p = {x = 546, y = 447},   res = {7,8,9},  pId = 117, show = 17},
    {lv = 28, p = {x = 598, y = 534},   res = {7,8,9},  pId = 118, show = 14},
    {lv = 30, p = {x = 686, y = 387},   res = {7,8,9},  pId = 119, show = 16},
    {lv = 32, p = {x = 108, y = 294},   res = {7,8,9},  pId = 120, show = 26},
    {lv = 34, p = {x = 244, y = 353},   res = {7,8,9},  pId = 121, show = 25},
    {lv = 36, p = {x = 424, y = 390},   res = {7,8,9},  pId = 122, show = 22},
    {lv = 38, p = {x = 556, y = 330},   res = {7,8,9},  pId = 123, show = 21},
    {lv = 40, p = {x = 731, y = 301},   res = {7,8,9},  pId = 124, show = 20},
    {lv = 42, p = {x = 221, y = 204},   res = {7,8,9},  pId = 125, show = 28},
    {lv = 44, p = {x = 115, y = 117},   res = {7,8,9},  pId = 126, show = 34},
    {lv = 46, p = {x = 279, y = 76},    res = {7,8,9},  pId = 127, show = 33},
    {lv = 48, p = {x = 450, y = 950},   res = {7,8,9}, pId = 128, show = 3},
    {lv = 50, p = {x = 727, y = 947},   res = {7,8,9}, pId = 129, show = 1},
    {lv = 10, p = {x = 429, y = 191},   res = {10},     pId = 130, show = 29},
    {lv = 20, p = {x = 461, y = 106},   res = {10},     pId = 131, show = 32},
    {lv = 30, p = {x = 611, y = 171},   res = {10},     pId = 132, show = 27},
    {lv = 40, p = {x = 661, y = 78},    res = {10},      pId = 133, show = 31},
    {lv = 50, p = {x = 789, y = 136},   res = {10},     pId = 134, show = 30},
}

--- 位置的起始和结束
T.posBegin = 101
T.posEnd = 134

-- 反查表
T.posReverse = {
    [101] = 1,
    [102] = 1,
    [103] = 1,
    [104] = 1,
    [105] = 2,
    [106] = 4,
    [107] = 6,
    [108] = 8,
    [109] = 10,
    [110] = 12,
    [111] = 14,
    [112] = 16,
    [113] = 18,
    [114] = 20,
    [115] = 22,
    [116] = 24,
    [117] = 26,
    [118] = 28,
    [119] = 30,
    [120] = 32,
    [121] = 34,
    [122] = 36,
    [123] = 38,
    [124] = 40,
    [125] = 42,
    [126] = 44,
    [127] = 46,
    [128] = 48,
    [129] = 50,
    [130] = 10,
    [131] = 20,
    [132] = 30,
    [133] = 40,
    [134] = 50,
}

--- 碎片图 坐标
T.fragWater = {
    {x = 0, y = 836, name = "outSideBaseWater1.png"},
    {x = 796, y = 888, name = "outSideBaseWater2.png"},
    {x = 0, y = 649, name = "outSideBaseWater3.png"},
    {x = 0, y = 330, name = "outSideBaseWater4.png"},
    {x = 141, y = 568, name = "outSideBaseWater5.png"},
    {x = 472, y = 571, name = "outSideBaseWater6.png"},
    {x = 834, y = 657, name = "outSideBaseWater7.png"},
    {x = 622, y = 118, name = "outSideBaseWater8.png"},
    {x = 749, y = 0, name = "outSideBaseWater9.png"},
    {x = 0, y = 46, name = "outSideBaseWater10.png"},
    {x = 302, y = 210, name = "outSideBaseWater11.png"},
    {x = 295, y = 45, name = "outSideBaseWater12.png"},
    {x = 0, y = 0, name = "outSideBaseWater13.png"},
}

--- 传送门坐标
T.centerPos = {p = cc.p(119, 688), pic = "homePageOutSideJump.png"}
--- 底框
T.bottomFrame = "homePageOutSideBottom.png"

--- 未开放遮罩
T.mask = "homePageOutSideMask.png"

--- 背景图 (地基)
T.backImg = "outSideBase.png"

--- 背景的水
T.backWaterImg = "outSideWaterFrame.png"

--- 资源图片资源
T.sidRes = { --[[ [sid] = "resource.png" ]]
    [7]  = "homePageOutSideSteel.png",
    [8]  = "homePageOutSideOil.png",
    [9]  = "homePageOutSideSilicon.png",
    [10] = "homePageOutSideTati.png",
}

-- 水纹特效 区域 水纹的大小是128 * 128 且特效中心点是128 / 2, 128 / 2
-- 相对于 水地图的坐标
T.waterEffArea = {
    {0, 0},
    {0, 128},
}

--- 建筑相对于地板的坐标
T.bldDs = cc.p(-18, -4)

--- 进度条资源
T.barRes = "homePageExpBar.png"

--- 等级资源
T.lvlRes = "homePageLvlFrame.png"

return T

--endregion

