--region SecretaryView.lua
--Author    : YuDing
--Date      : 2014/12/26
--Introduce : 小秘书功能

local T = class("SecretaryView", function() return cc.Node:create() end)

 -- 待开放
T.waitOpen = nil
-- 开放
T.open = nil    
-- 没有开放 
T.notOpen = nil  
-- 郊外建筑总数
T.max = nil
-- 郊外配置文件
T.cfg = nil

-- 开放状态 0 未开放 1 待开放 2 开放
T.openState = nil

--- 构造函数
function T:ctor()
    mapping(self, LuaEventDispatcher)
    local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function( eventType )
				if CocosEvent.ENTER == eventType then
					self:onEnter()
				elseif CocosEvent.EXIT == eventType then
					self:onExit()
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				end

				self:luaDispatchEvent(eventType)
			end
		)
	end
end

function T:onEnter()

end

function T:onExit()
    
end

--- 清理资源
function T:cleanUp()
    self:releaseEvent()
end

--- 初始化
function T:init()
    self.cfg = HomeManager.outCfg
    local lvl = nil

    self.openState = self.openState or {}

    local max = 0
    for k, v in pairs(cfg.pos) do
        max = max + 1 
        if self:getIsBuildedOpen(v.pId) then -- 开放
            lvl = PlayerInstance:getBuildingLvl(v.pId)
            if lvl == 0 then -- 待开放  [位置] = 可建造的资源列表
                self.openState[v.pid] = 1
            else  -- [位置] = sid
                self.openState[v.pid] = 2
            end
        else -- 未开放
            self.openState[v.pid] = 0
        end
    end

    self.max = max -- 全部
end

-- 注册
function T:registerEvent()  
    --[[
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. PlayerInstance.fixedBldLocation.center, t, t.updateOpen)
    PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.buildingLvl .. t.l, t, t.updateLvl) -- 更新等级监听
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_UPDATE_REMAINING_TIME .. t.l, t, t.upgrading) -- 剩余时间
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_LEVEL_UP_COMPLETE .. t.l, t, t.upgradingCompelte) -- 完成
    BuildingsInfoMgr:luaRemoveEventListener(BuildingsInfoMgr.EVT_TYPE_CANCEL_LEVEL_UP .. t.l, t, t.upgradingCancel) -- 取消升级
    ]]    
end

--- 释放
function T:releaseEvent()
    
end

function T:checkOpen()
    local cLvl = PlayerInstance:getCenterBuildingLvl()
    local tb = {}
    for k, v in pairs(self.cfg.posReverse) do 
        if v == cLvl then -- 将刚好达到等级的


            table.insert(tb, k)
        end
    end
end


--- 获得未开放的数目
function T:getNotOpenNum()
    local num = 0 
    for k, v in pairs(self.notOpen) do 
        num = num + 1
    end 
    return num
end

--- 开始升级
function T:startUpdateLvl(l)
    self:dispactch(start..l)
end

--- 更新等级
function T:updateLvl(l)
    self:dispatchlvl()
end

--- 正在升级
function T:upgrading(item, l)
    local percent = self:calculateTime(item.remainingSec, l)
    self:dipatch(remain..l, percent)
end

function T:calculateTime(remainSec, l)
     local allTime = PlayerInstance:getBuildingCurrentUpgradeTime(l) -- 总的时间
	 local percent = (allTime - remainSec) / allTime * 100
	 if percent > 100 then percent = 100 end

     return percent
end

function T:upgradingCompelte(l)
    
    if self.notOpen[l] == 0 then 
        self.notOpen[l] = nil
        local sid = PlayerInstance:getBuildingSid(v.pid)
        self.open[l] = sid
        --self:dispatch("解锁")
    end
    self:dispatch("完成")

end

function T:upgradingCancel(l)
    
end

-- 增加监听 切换的侦听

function T:getIsBuildedOpen(l)
    local cLvl = PlayerInstance:getBuildingLvl(PlayerInstance.fixedBldLocation.center)
    local lv = self.cfg.posReverse[l]
    if cLvl >= lv then 
        return true
    else 
        return false
    end
end

return T







--endregion
