--Author    : YuDing
--Date      : 2014/11/17
--Introduce : 地图上点信息

local T = class("HomePageWorldCellInfo", function() return ccui.Layout:create() end )

local cellTips = require("src.app.uiScript.scenes.homePage.world.HomePageWorldCellTips")

-- 关联的cell
T.nodeInfo = nil
T.widget = nil

T.uiChild = {}

T.parent = nil

-- 构造函数
function T:ctor()
	mapping(self, LuaEventDispatcher)
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

end

function T:onEnter()
	-- 联盟社交监听

	local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
	allianceSocial:luaAddEventListener(allianceSocial.EVT_ADD_FRIEND_REFRESH,self,self.updateAlliace)
	allianceSocial:luaAddEventListener(allianceSocial.EVT_DELETE_FRIEND_REFRESH,self,self.updateAlliace)
	allianceSocial:luaAddEventListener(allianceSocial.EVT_ADD_ENEMY_REFRESH,self,self.updateAlliace)
	allianceSocial:luaAddEventListener(allianceSocial.EVT_DELETE_ENEMY_REFRESH,self,self.updateAlliace)

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_WORLD_MAP_CELL_INFO_ATTACK_BUTTON,self.uiChild.btnAttack)

		BGMgr:fire(BGMgr.EVT_OPEN_WORLD_MAP_CELL_INFO)
	end
end

function T:onExit()
	-- 联盟社交监听
	local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
	allianceSocial:luaRemoveEventListener(allianceSocial.EVT_ADD_FRIEND_REFRESH,self,self.updateAlliace)
	allianceSocial:luaRemoveEventListener(allianceSocial.EVT_DELETE_FRIEND_REFRESH,self,self.updateAlliace)
	allianceSocial:luaRemoveEventListener(allianceSocial.EVT_ADD_ENEMY_REFRESH,self,self.updateAlliace)
	allianceSocial:luaRemoveEventListener(allianceSocial.EVT_DELETE_ENEMY_REFRESH,self,self.updateAlliace)

end

-- 加载ui
function T:loadJson()
	local widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.homePageWorldCellInfo)
	self.widget = widget
	self:addChild(widget)

	local size = widget:getContentSize()
	self:setContentSize(size)
end

-- 获得各个控件
function T:loadUI()
	local c = self.uiChild
	local w = self.widget

	--c.headText = Cocos2dxUtils:getChildByName(w, "headText")               -- "目标信息"
	c.btnInvest = Cocos2dxUtils:getChildByName(w, "btnInvest")              -- 侦查按钮
	c.investText = Cocos2dxUtils:getChildByName(w, "investText")            -- "侦查"
	c.btnAttack = Cocos2dxUtils:getChildByName(w, "btnAttack")              -- 攻击按钮
	c.attackText = Cocos2dxUtils:getChildByName(w, "attackText")            -- "攻击"
	c.coordinateText = Cocos2dxUtils:getChildByName(w, "coordinateText")    -- "坐标"
	c.coordinate = Cocos2dxUtils:getChildByName(w, "coordinate")            -- 坐标

	c.btnCollect = Cocos2dxUtils:getChildByName(w, "btnCollect")            -- 搜集按钮
	c.btnMail = Cocos2dxUtils:getChildByName(w, "btnMail")                  -- 发送邮件按钮
	c.name = Cocos2dxUtils:getChildByName(w, "name")                        -- 资源点名字
	c.headPic = Cocos2dxUtils:getChildByName(w, "headPic")                  -- 头像图片
	c.fightingText = Cocos2dxUtils:getChildByName(w, "fightingText")        -- "战斗力"
	c.fighting = Cocos2dxUtils:getChildByName(w, "fighting")                -- 战斗力

	c.regionText = Cocos2dxUtils:getChildByName(w, "regionText")            -- "联盟"
	c.region = Cocos2dxUtils:getChildByName(w, "region")                    -- 联盟

	--c.btnClose = Cocos2dxUtils:getChildByName(w, "btnClose")                -- 关闭按钮
	c.headName = Cocos2dxUtils:getChildByName(w, "headName")
	c.btnClose = Cocos2dxUtils:getChildByName(w, "btnClose")

	c.lineTwo = Cocos2dxUtils:getChildByName(w, "lineTwo")          -- 第二根 下划线

	c.allianceRelation = Cocos2dxUtils:getChildByName(w, "allianceRelation") -- 联盟关系

	c.honorCaption = Cocos2dxUtils:getChildByName(w, "honorCaption") -- 荣誉描述
	c.honorValue = Cocos2dxUtils:getChildByName(w, "honorValue") -- 荣誉值

	c.line4 = Cocos2dxUtils:getChildByName(w, "line4")
	c.line3 = Cocos2dxUtils:getChildByName(w, "line3")


	self:initFixedUI() -- 初始化固定的属性
end

--- 初始化固定的ui
function T:initFixedUI()
	local c = self.uiChild

	--c.headText:setString(Language:get("uy20")) -- "目标信息"

	c.investText:setString(Language:get("uy75")) -- "侦查"

	c.attackText:setString(Language:get("uy76")) -- "攻击"

	c.coordinateText:setString(Language:get("uy77")) -- "坐标"

	c.fightingText:setString(Language:get("uy19")) -- "战斗力"

	c.regionText:setString(Language:get("uy78")) -- "联盟"

	c.honorCaption:setString(Language:get("uc1027"))

	c.headName:setString(Language:get("uy186")) -- "目标信息"
	--    local tb = {
	--        c.headText, c.investText, c.attackText, c.coordinateText,
	--        c.coordinate, c.name, c.fightingText, c.fighting, c.regionText, c.region
	--    }

	local tb = {}
	for k, v in pairs(self.uiChild) do
		if v:getDescription() == "Label" then
			table.insert(tb, v)
		end
	end

	Cocos2dxUtils:setTextFont(tb)

	if self.nodeInfo.type == 2 then  -- 资源 移除一些不需要的控件
		c.btnMail:removeFromParent()
		c.regionText:removeFromParent()
		c.region:removeFromParent()
		c.headPic:removeFromParent()
		c.fightingText:removeFromParent()
		c.fighting:removeFromParent()
		c.lineTwo:removeFromParent()
		c.name:setAnchorPoint(cc.p(0.5, 0.5)) -- 居中
		c.allianceRelation:setVisible(false)  -- 先隐藏

		local px, py = c.name:getPosition()
		local parent = c.name:getParent()
		local psize = parent:getContentSize()
		c.name:setPosition(cc.p(psize.width / 2, py))
	end

	-- 添加军衔
	if self.nodeInfo.militaryRank and self.nodeInfo.militaryRank > 0 then
		-- 军衔图片
		local militaryRank = self.nodeInfo.militaryRank

		local iconPath = IconManager.iconPath

		local militaryImg = ccui.ImageView:create()
		militaryImg:loadTexture(iconPath .. MilitaryRank_temp[militaryRank].icon)
		--militaryImg:setScale(0.6)
		self:addChild(militaryImg)
		REL:toOther("center","middle",militaryImg,self.widget,-95,105)

		-- 军衔名字
		local militaryName = XMLLabel()
		militaryName:setVAlign("middle")
		militaryName:setContentSize(cc.size(300,36))
		self:addChild(militaryName)
		militaryName:setString(Language:get("uc1026",Language:get(HonorManager:getMilitaryRankName(militaryRank))))
		REL:toOther("left","middle",militaryName,militaryImg,HonorManager:getShowMilitaryOffset(militaryRank),0)

	end


end

--- 关闭
function T:closeEventClick()
	self.__hide__()
end

--- 获得资源的名字 名字从 "uy13" 开始
-- @param id 资源id序号
function T:getResoureName(id)
	local num = 12 + id
	local tag = "uy" .. num
	return Language:get(tag)
end

--- 注册事件
function T:registerEvent()
	local c = self.uiChild

	local function clickHandler(t, e)
		if e == ccui.TouchEventType.ended then
			if t == c.btnCollect then         -- 搜集
				self:collectEventClick()
				--elseif t == c.btnClose then       -- 关闭
				--self.__hide__()
			elseif t == c.btnMail then        -- 发邮件
				self:onMailEventClick()
			elseif t == c.btnAttack then      -- 攻击
				if BGMgr:isGuide() then
					BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_WORLD_MAP_CELL_INFO_ATTACK_BUTTON)
				end
			
				self:attackLogic()
				--elseif t == c.btnInvest then      -- 侦查
				--self:onInvestClick()
			elseif t == c.btnClose then
				self:onCloseClick()
			end
		end
	end
	--

	BaseButton:extend(c.btnCollect)
	--BaseButton:extend(c.btnClose)
	BaseButton:extend(c.btnAttack)
	BaseButton:extend(c.btnInvest)
	BaseButton:extend(c.btnClose)

	if self.nodeInfo.type == 1 then  -- 玩家
		BaseButton:extend(c.btnMail)
		c.btnMail:addTouchEventListener(clickHandler)
	end

	c.btnCollect:addTouchEventListener(clickHandler)
	--c.btnClose:addTouchEventListener(clickHandler)
	c.btnAttack:addTouchEventListener(clickHandler)
	--c.btnInvest:addTouchEventListener(clickHandler)
	c.btnClose:addTouchEventListener(clickHandler)


	BaseButton:extend(c.allianceRelation)
	c.allianceRelation:addTouchEventListener(function(t, e)
		if e ~= ccui.TouchEventType.ended then
			return
		end
		self:onEventAllianceRelationClick()
	end)
end

-- 收藏
function T:collectEventClick()
	local tips = cellTips.new() -- 加载tips
	tips:initView(self.nodeInfo, HomePageManager)

	MUIAlter.show({
		info=tips,
		title=Language:get("uy26"),
		flag=4,
		isShowCloseButton=true
	})

	local order = self:getLocalZOrder()
	tips:setLocalZOrder(order)          -- 保存同样的order， 因为触摸

	self.__hide__()
end

-- 发送邮件事件
function T:onMailEventClick()
	local name = self.nodeInfo.name
	local temp = require("src.app.uiScript.components.mail.SendMailWindow").new(3,name)
	WindowManager:push(temp)
	self.__hide__()
end

--- 侦查事件
function T:onInvestClick()
	-- 野矿点点侦察的时候，如果已经有自己的部队驻守在这个位置了，弹出提示:该区域已被己方驻守，无需侦察
	local data = {}
	data.x = self.nodeInfo.x
	data.y = self.nodeInfo.y

	local id = self.nodeInfo.playerId
	if id then
		data.id = id
	else
		data.id = 0
	end


	data.isProtection = nil
	if data.id ~= 0 then
		data.isProtection = self.nodeInfo.isProtection -- 玩家的防护罩时间
		data.allianceId = self.nodeInfo.allianceId -- 玩家的联盟id
	end

	-- data数据

	if data.id > 0 then
		if ArmyTaskQueueManager:hasPlayerBattle(data) then
			MUIPop.NotNeedScout()
			return
		end
	else
		if ArmyTaskQueueManager:hasNpcBattle(data) then
			MUIPop.NotNeedScout()
			return
		end
	end

	local nodeInfo=self.nodeInfo
	local costMoney = GameCfg.SCOUNT_COST_MONEY[nodeInfo.lvl]
	local info = Language:get("uc304",UnitConversion.unitTrans(costMoney))
	local function confirm()
		local nowMoney = UserInfo.city.money
		if nowMoney < costMoney then
			--- 金币不够
			MUIPop.MoneyIsNotEnough2()
		else
			WorldMapScoutComman:new():exec(nodeInfo.x,nodeInfo.y,function(state,dataTable)
				if state == ReturnCode.SUCCESS then
					if dataTable then
						-- 添加到邮件里去
						dataTable.data = data
						MailManager:addScoutInfo(dataTable)

						local temp = require("src.app.uiScript.scenes.scout.ScoutMainWindow").new(dataTable)
						WindowManager:push(temp)
						if self.__hide__ then
							self.__hide__()
						end
					end

				else
					ErrorCode:popErrorCodeTip(state)
				end
			end)
		end
	end
	MUIPop.MUIImmediate(info,confirm)


end

function T:onCloseClick()
	self.__hide__()
end

--- 关系按钮  被点击
function T:onEventAllianceRelationClick()
	local data = self.nodeInfo

	if data.type == 2 then  -- 资源点 是没有关系按钮的
		return
	end

	local id = UserInfo.allianceBox.myAlliance.id -- 自己联盟 的id

	if data.allianceId == id then -- 自己联盟 点击没反应
		return
	end

	if not data.allianceName then  -- 没有加入联盟 返回
		return
	end

	local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial

	--- 不是会长
	if UserInfo.allianceBox.myAlliance.post ~= AlliancePost.LEADER then  -- 如果不是会长 点击之后 无权修改
		if allianceSocial:judgeIsAtEnemyList(data.allianceId) then -- 判断是否是敌对
			local descripe = Language:get("uc780")
			MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
	elseif allianceSocial:judgeIsAtFrendList(data.allianceId) then -- 判断是否是好友
		local descripe = Language:get("uc781")
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
	else -- 中立
		local descripe = Language:get("uc779")
		MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
	end

	return --返回
	end

	--- 是会长
	local layout = AlliancePopSocial.new(data.allianceId)
	local function confirm()
		local state = layout.state
		if state then
			local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
			if state == 1 then
				if allianceSocial:judgeIsAtEnemyList(data.allianceId) then
					return
				else
					if allianceSocial:judgeEnemyReachMax() then
						MUIPop.EnemyHasReachMax()
					else
						require("src.app.communication.alliance.social.AddEnemyAllianceCommand")():exec(data.allianceId,function(state) end)
					end
				end
			elseif state == 2 then
				if allianceSocial:judgeIsAtFrendList(data.allianceId) then
					return
				else
					if allianceSocial:judgeFriendReachMax() then
						MUIPop.FriendHasReachMax()
					else
						require("src.app.communication.alliance.social.AddFriendAllianceCommand")():exec(data.allianceId,function(state) end)
					end
				end
			else
				if allianceSocial:judgeIsAtEnemyList(data.allianceId) then
					require("src.app.communication.alliance.social.DeleteEnemyAllianceCommand")():exec(data.allianceId,function(state) end)
				end
				if allianceSocial:judgeIsAtFrendList(data.allianceId) then
					require("src.app.communication.alliance.social.DeleteFriendAllianceCommand")():exec(data.allianceId,function(state) end)
				end
			end

		end
	end

	MUIPop.AllianceSocialPopInfo(layout, confirm)

end

--- 自身的信息
function T:updateOwnInfo(own)
	local c = self.uiChild

	if own == true then  -- 是自身
		c.btnCollect:removeFromParent()
		c.btnCollect = nil

		c.btnMail:removeFromParent()
		c.btnMail = nil

		c.btnAttack:removeFromParent()
		c.btnAttack = nil

		local size = self.widget:getContentSize()

		local btnInvest=c.btnInvest
		REL:toOther("center",nil,btnInvest,self.widget,0,0)
		c.investText:setString(Language:get("uy99")) -- "回到城市"

		btnInvest:addTouchEventListener(function(t, e)    -- 跳转到主城
			if e ~= ccui.TouchEventType.ended then
				return
		end

		self.__hide__()
		HomePageManager:switchViewToBase()
		end)
	else -- 不是自身 -- 侦查功能
		c.btnInvest:addTouchEventListener(function(t, e)    -- 跳转到主城
			if e ~= ccui.TouchEventType.ended then
				return
		end

		self:onInvestClick()
		end)
	end


end

--- 攻击逻辑
function T:attackLogic()
	local data = {}
	data.x = self.nodeInfo.x
	data.y = self.nodeInfo.y

	local id = self.nodeInfo.playerId
	if id then
		data.id = id
	else
		data.id = 0
	end


	data.isProtection = nil
	if data.id ~= 0 then
		data.isProtection = self.nodeInfo.isProtection -- 玩家的防护罩时间
		data.allianceId = self.nodeInfo.allianceId -- 玩家的联盟id
	end

	local function finsh()
		local armyWindow = require("src.app.uiScript.components.army.ArmyWindow").new({ ["tag"] = 3, ["detailInfo"] = data })
		WindowManager:push(armyWindow)
		self.__hide__()
	end
	local state = ArmyTaskQueueManager:judgeIsAttackInWorld(data,finsh)

	if state == true then
		local armyWindow = require("src.app.uiScript.components.army.ArmyWindow").new({ ["tag"] = 3, ["detailInfo"] = data })
		WindowManager:push(armyWindow)
		self.__hide__()
	end

end

-- 更新界面
function T:updateView()
	local c = self.uiChild

	c.coordinate:setString(Language:get("uy21", self.nodeInfo.x, self.nodeInfo.y)) -- 坐标

	if self.nodeInfo.type == 1 then  -- 玩家
		local lvl = self.nodeInfo.lvl
		c.name:setString(self.nodeInfo.name .. Language:get("uy80", lvl)) -- 名字
		c.fighting:setString(UnitConversion.unitTrans(self.nodeInfo.fighting)) -- 战斗力

		c.region:setString(self.nodeInfo.allianceName or Language:get("uy79")) -- 联盟 / "无"

		c.headPic:loadTexture(PlayerInstance:getPlayerHead(self.nodeInfo.headId))

		local x , y = PlayerInstance:getWorldPosition()

		if self.nodeInfo.x == x and self.nodeInfo.y == y then
			self:updateOwnInfo(true)
		else
			self:updateOwnInfo(false)
		end


		c.honorValue:setString(self.nodeInfo.honor)

	elseif self.nodeInfo.type == 2 then -- 资源
		self:updateOwnInfo(false)
		local rType = self:getResoureName(self.nodeInfo.resType)
		local lvl = self.nodeInfo.lvl

		c.name:setString(rType .. Language:get("uy80", lvl))    -- 等级

		c.honorValue:setString(Language:get("uc1028"))
		c.line4:setVisible(false)
		c.honorValue:setVisible(false)
		c.honorCaption:setVisible(false)
		c.line3:setVisible(false)

	end

end

-- 初始化
-- @param nodeinfo  节点信息
-- @param manager 管理类
function T:initView(nodeInfo, manager)
	self.nodeInfo = nodeInfo

	self:loadJson()             --  json

	self:loadUI()               -- ui
	self:registerEvent()        -- 事件
	self:updateView()           -- 更新界面

	-- 添加联盟社交
	self:updateAlliace()
end

--- 刷新联盟社交显示
function T:updateAlliace()
	local data = self.nodeInfo
	local id = UserInfo.allianceBox.myAlliance.id
	local c = self.uiChild

	if data.type == 2 then  -- 资源点 是不会出现的
		c.allianceRelation:setVisible(false)
		return
	end

	if id == 0 then  -- 联盟不存在
		c.allianceRelation:setVisible(false)
		return
	end

	if data.allianceName then  -- 有联盟
		if not data.allianceId then -- 没有联盟id
			c.allianceRelation:setVisible(false)
	end

	c.allianceRelation:setVisible(true)  -- 出现

	if data.allianceId == id then -- 自己联盟
		c.allianceRelation:loadTexture("allianceLabel_my.png",ccui.TextureResType.plistType)
	else
		local allianceSocial = UserInfo.allianceBox.myAlliance.allianceSocial
		if allianceSocial:judgeIsAtEnemyList(data.allianceId) then -- 判断是否是敌对
			c.allianceRelation:loadTexture("allianceLabel_hostile.png",ccui.TextureResType.plistType)
		elseif allianceSocial:judgeIsAtFrendList(data.allianceId) then -- 判断是否是好友
			c.allianceRelation:loadTexture("allianceLabel_friendly.png",ccui.TextureResType.plistType)
		else -- 中立
			c.allianceRelation:loadTexture("allicanceCenter.png",ccui.TextureResType.plistType)
		end

	end
	else -- 没有联盟
		c.allianceRelation:setVisible(false) -- 消失
	end

end

return T
