--Author    : YuDing
--Date      : 2014/11/17
--Introduce : 收藏tips

local T = class("HomePageWorldCellTips", function() return ccui.Layout:create() end )

local addCommand = require("src.app.communication.worldMap.WorldMapAddCollectionCommand")

-- 关联的cell
T.nodeInfo = nil
T.widget = nil
T.manager = nil
T.parent = nil
T.uiChild = {}


-- 选择的标识
T.chooseTag = nil


function T:ctor()
	mapping(self, LuaEventDispatcher)
end

-- 加载ui
function T:loadJson()
	local widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.homePageWorldCellTips)
	self.widget = widget
	self:addChild(widget)

	local size = widget:getContentSize()
	self:setContentSize(size)
end

-- 获得各个控件
function T:loadUI()
	local c = self.uiChild
	local w = self.widget

	--c.close = Cocos2dxUtils:getChildByName(w, "close")
	-- 关闭
	c.btnClose = Cocos2dxUtils:getChildByName(w, "btnClose")
	c.closeText = Cocos2dxUtils:getChildByName(w, "closeText")
	-- 收集
	c.btnOK = Cocos2dxUtils:getChildByName(w, "btnOK")
	c.okText = Cocos2dxUtils:getChildByName(w, "okText")
	-- 收藏点描述
	c.labelPosition = Cocos2dxUtils:getChildByName(w, "labelPosition")
	-- 资源
	c.imgResource = Cocos2dxUtils:getChildByName(w, "imgResource")
	-- 资源标识
	--c.imgResourceTag = Cocos2dxUtils:getChildByName(w, "imgResourceTag")
	-- 敌对
	c.imgAgainst = Cocos2dxUtils:getChildByName(w, "imgAgainst")
	-- 敌对标识
	-- c.imgAgainstTag = Cocos2dxUtils:getChildByName(w, "imgAgainstTag")
	-- 朋友
	c.imgFriend = Cocos2dxUtils:getChildByName(w, "imgFriend")
	-- 朋友标识
	--c.imgFriendTag = Cocos2dxUtils:getChildByName(w, "imgFriendTag")
	-- 标题（固定）
	--c.labelHead = Cocos2dxUtils:getChildByName(w, "labelHead")
	-- 地点描述（固定）
	c.labelLandInfoDes = Cocos2dxUtils:getChildByName(w, "labelLandInfoDes")
	-- 分类（固定）
	c.labelTypeDes = Cocos2dxUtils:getChildByName(w, "labelTypeDes")

	--c.labelHead:setString(Language:get("uy26"))
	c.labelLandInfoDes:setString(Language:get("uy27"))
	c.labelTypeDes:setString(Language:get("uy28"))
	c.closeText:setString(Language:get("uy87"))
	c.okText:setString(Language:get("uy88"))

	self:initFixedUI()

end

function T:initFixedUI()
	local c = self.uiChild

	local tb = {}
	for k, v in pairs(self.uiChild) do
		if v:getDescription() == "Label" then
			table.insert(tb, v)
		end
	end

	Cocos2dxUtils:setTextFont(tb)

end

--- 注册事件
function T:registerEvent()
	local c = self.uiChild

	local function clickHandler(t, e)
		if e == ccui.TouchEventType.ended then
			if t == c.btnClose then
				self:closeEventClick()
			elseif t == c.btnOK then
				self:okEventClick()
			elseif t == c.imgResource then
				self:imgResourceEventClick()
			elseif t == c.imgAgainst then
				self:imgAgainstEventClick()
			elseif t == c.imgFriend then
				self:imgFriendEventClick()
			end
		end
	end

	--BaseButton:extend(c.close)
	BaseButton:extend(c.btnClose)
	BaseButton:extend(c.btnOK)
	BaseButton:extend(c.imgResource)
	BaseButton:extend(c.imgAgainst)
	BaseButton:extend(c.imgFriend)

	--c.close:addTouchEventListener(clickHandler)
	c.btnClose:addTouchEventListener(clickHandler)
	c.btnOK:addTouchEventListener(clickHandler)
	c.imgResource:addTouchEventListener(clickHandler)
	c.imgAgainst:addTouchEventListener(clickHandler)
	c.imgFriend:addTouchEventListener(clickHandler)

end


--- 初始化选择标识
function T:initChooseTag()
	self.chooseTag =  self.chooseTag or {false, false, false}
	local c = self.uiChild

	local cfg = HomePageManager.wmCfg.collection

	if self.chooseTag[1] then
		c.imgResource:loadTexture(cfg.resource[2], ccui.TextureResType.plistType)
	else
		c.imgResource:loadTexture(cfg.resource[1], ccui.TextureResType.plistType)
	end

	if self.chooseTag[2] then
		c.imgAgainst:loadTexture(cfg.against[2], ccui.TextureResType.plistType)
	else
		c.imgAgainst:loadTexture(cfg.against[1], ccui.TextureResType.plistType)
	end

	if self.chooseTag[3] then
		c.imgFriend:loadTexture(cfg.friend[2], ccui.TextureResType.plistType)
	else
		c.imgFriend:loadTexture(cfg.friend[1], ccui.TextureResType.plistType)
	end

end

-- 收藏
function T:okEventClick()
	local resType = 0
	if self.chooseTag[1] == true then
		resType = resType + 1
	end
	if self.chooseTag[2] == true then
		resType = resType + 2
	end
	if self.chooseTag[3] == true then
		resType = resType + 4
	end

	if self.nodeInfo == nil then return end

	local p = {}
	p.resType = resType
	p.x = self.nodeInfo.x
	p.y = self.nodeInfo.y
	p.desc = self:getResoureName(self.nodeInfo) .. Language:get("uy29", self.nodeInfo.x, self.nodeInfo.y)

	if self.manager:checkWorldCollection(p.x, p.y) == true then  -- 已经加载得有
		MUIAlter.show(
			{
				info = Language:get("uy194"),
				size = 30
			})
	return
	else
		if self.manager:isWorldCollectionMax() == true then  -- 达到最大收集
			MUIAlter.show(
				{
					info = Language:get("uy195"),
					size = 30
				})
		return
		end
	end

	addCommand.new():exec(p,
		function(state, data)

			if state == ReturnCode.SUCCESS then     -- 成功， 加入数据到worldmanager中
				self.manager:addWorldCollection(p)

				local descripe = Language:get("uc964")
				MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
			end

			self.__hide__()
		end)

end

--- 获得资源的名字 名字从 "uy13" 开始
function T:getResoureName(info)
	if info.type == 1 then
		return info.name
	elseif info.type == 2 then
		local num = 12 + info.resType
		return Language:get("uy" .. num)
	end

end

--- 关闭
function T:closeEventClick()
	self.__hide__()
end
-- 资源
function T:imgResourceEventClick()
	local c = self.uiChild
	if  self.chooseTag[1] == false then
		self.chooseTag[1] = true
	else
		self.chooseTag[1] = false
	end


	local cfg = HomePageManager.wmCfg.collection

	if self.chooseTag[1] then
		c.imgResource:loadTexture(cfg.resource[2], ccui.TextureResType.plistType)
	else
		c.imgResource:loadTexture(cfg.resource[1], ccui.TextureResType.plistType)
	end

end
-- 敌对
function T:imgAgainstEventClick()
	local c = self.uiChild
	if  self.chooseTag[2] == false then
		self.chooseTag[2] = true
	else
		self.chooseTag[2] = false
	end
	local cfg = HomePageManager.wmCfg.collection

	if self.chooseTag[2] then
		c.imgAgainst:loadTexture(cfg.against[2], ccui.TextureResType.plistType)
	else
		c.imgAgainst:loadTexture(cfg.against[1], ccui.TextureResType.plistType)
	end

end
-- 朋友
function T:imgFriendEventClick()
	local c = self.uiChild
	if  self.chooseTag[3] == false then
		self.chooseTag[3] = true
	else
		self.chooseTag[3] = false
	end

	local cfg = HomePageManager.wmCfg.collection

	if self.chooseTag[3] then
		c.imgFriend:loadTexture(cfg.friend[2], ccui.TextureResType.plistType)
	else
		c.imgFriend:loadTexture(cfg.friend[1], ccui.TextureResType.plistType)
	end

end

-- 更新界面
function T:updateView()
	local c = self.uiChild
	c.labelPosition:setString(self:getResoureName(self.nodeInfo) .. Language:get("uy29", self.nodeInfo.x, self.nodeInfo.y)) -- 坐标
end

-- 初始化
function T:initView(nodeInfo, manager)
	self:loadJson()
	self.nodeInfo = nodeInfo
	self.manager = manager

	self:loadUI()
	self:registerEvent() -- 注册
	self:updateView()    -- 更新界面
	self:initChooseTag() -- 初始化选择标记
end

return T
