--Author    : YuDing
--Date      : 2014/11/19
--Introduce : 收集界面中的单元

local HomePageWorldCollectionCellView = class("HomePageWorldCollectionCellView", function()
	return ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.homePageWorldCollectionCellView)
end)

-- 节点信息
HomePageWorldCollectionCellView.nodeInfo = nil
HomePageWorldCollectionCellView.widget = nil
HomePageWorldCollectionCellView.resType = nil
HomePageWorldCollectionCellView.uiChild = nil
HomePageWorldCollectionCellView.delegete = nil


function HomePageWorldCollectionCellView:ctor()
	mapping(self, LuaEventDispatcher)  -- 初始化变量应该在这里
	self.resType = self.resType or {}
	self.uiChild = self.uiChild or {}
end

function HomePageWorldCollectionCellView:onEnter()

end

function HomePageWorldCollectionCellView:onExit()

end

-- 加载ui
function HomePageWorldCollectionCellView:loadJson()
end
--- 初始化
function HomePageWorldCollectionCellView:initView()
	self:loadJson()
	self:loadUI()
	self:registerEvent()
end
--- 加载
function HomePageWorldCollectionCellView:loadUI()
	-- local w = self.widget
	local w = self
	local c = self.uiChild

	c.panelEdit = Cocos2dxUtils:getChildByName(w, "panelEdit")                  -- 编辑代理

	c.labelPosition = Cocos2dxUtils:getChildByName(w, "labelPosition")          -- 坐标
	c.imgResource = Cocos2dxUtils:getChildByName(w, "imgResource")              -- 资源
	c.imgAgainst = Cocos2dxUtils:getChildByName(w, "imgAgainst")                -- 敌对
	c.imgFriend = Cocos2dxUtils:getChildByName(w, "imgFriend")                  -- 朋友
	c.imgSearch = Cocos2dxUtils:getChildByName(w, "imgSearch")                  -- 搜索
	c.imgDel = Cocos2dxUtils:getChildByName(w, "imgDel")                        -- 删除

	c.imgFix = Cocos2dxUtils:getChildByName(w, "imgFix")
	self:createEdit() -- 创建输入框
end
--- 注册
function HomePageWorldCollectionCellView:registerEvent()
	local clickHandler = function(t, e)
		local c = self.uiChild
		if ccui.TouchEventType.ended ~= e then return end
		--if c.panelEdit == t then
		--self:editEventClick()
		if c.imgResource == t then
			self:imgResourceEventClick()
		elseif c.imgAgainst == t then
			self:imgAgainstEventClick()
		elseif c.imgFriend == t then
			self:imgFriendEventClick()
		elseif c.imgSearch == t then
			self:searchEventClick()
		elseif c.imgDel == t then
			self:delEventClick()
		end
	end

	local c = self.uiChild

	BaseButton:extend(c.imgResource)
	BaseButton:extend(c.imgAgainst)
	BaseButton:extend(c.imgFriend)
	BaseButton:extend(c.imgSearch)
	BaseButton:extend(c.imgDel)
	--BaseButton:extend(c.imgFix)

	c.imgResource:addTouchEventListener(clickHandler)
	c.imgAgainst:addTouchEventListener(clickHandler)
	c.imgFriend:addTouchEventListener(clickHandler)
	c.imgSearch:addTouchEventListener(clickHandler)
	c.imgDel:addTouchEventListener(clickHandler)
end

function HomePageWorldCollectionCellView:createEdit()
	local c = self.uiChild
	c.edit = ccui.EditBox:create(c.panelEdit:getContentSize(), ccui.Scale9Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("editBoxBack.png"),cc.rect(1,1,1,1)))
	c.edit:setFontSize(26)
	c.edit:setFontName(defaultCssStyle.fontName)

	c.edit:setPlaceHolder("")
	c.edit:setText(current_positionX)
	--c.edit:setMaxLength(6)
	c.edit:setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC)

	c.panelEdit:addChild(c.edit)
	REL:toOther("center", "middle", c.edit, c.panelEdit, 0, 0)

	c.edit:registerScriptEditBoxHandler(function(e,t)
		if e == "began" then
			AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)
		elseif e == "ended" then
			local desc = t:getText()
			if not desc then -- 没有内容 还是为原来的内容
				t:setText(self.nodeInfo.desc)
				return
			end

			desc = string.gsub(desc,"^%s*(.-)%s*$", "%1")
			desc = StringUtils.getCountChar(desc, 30)
			t:setText(desc)
			self:changeNodeDesc(desc)
		elseif e == "changed" then
		elseif e == "return" then
		end
		self:luaDispatchEvent(e,t)
	end)

end

function HomePageWorldCollectionCellView:imgResourceEventClick()
	local c = self.uiChild
	if  self.resType[1] == false then
		self.resType[1] = true
	else
		self.resType[1] = false
	end

	local cfg = HomePageManager.wmCfg.collection

	if self.resType[1] then
		c.imgResource:loadTexture(cfg.resource[2], ccui.TextureResType.plistType)
	else
		c.imgResource:loadTexture(cfg.resource[1], ccui.TextureResType.plistType)
	end

	self:changeNodeCtype()

end

function HomePageWorldCollectionCellView:imgAgainstEventClick()
	local c = self.uiChild
	if  self.resType[2] == false then
		self.resType[2] = true
	else
		self.resType[2] = false
	end

	local cfg = HomePageManager.wmCfg.collection

	if self.resType[2] then
		c.imgAgainst:loadTexture(cfg.against[2], ccui.TextureResType.plistType)
	else
		c.imgAgainst:loadTexture(cfg.against[1], ccui.TextureResType.plistType)
	end

	self:changeNodeCtype()

end

function HomePageWorldCollectionCellView:imgFriendEventClick()
	local c = self.uiChild
	if  self.resType[3] == false then
		self.resType[3] = true
	else
		self.resType[3] = false
	end

	local cfg = HomePageManager.wmCfg.collection

	if self.resType[3] then
		c.imgFriend:loadTexture(cfg.friend[2], ccui.TextureResType.plistType)
	else
		c.imgFriend:loadTexture(cfg.friend[1], ccui.TextureResType.plistType)
	end

	self:changeNodeCtype()

end

function HomePageWorldCollectionCellView:reset(info)
	local c = self.uiChild
	--c.labelName:setString("")
	c.edit:setText("")
	c.labelPosition:setString("")

	local cfg = HomePageManager.wmCfg.collection

	c.imgFriend:loadTexture(cfg.friend[1], ccui.TextureResType.plistType)
	c.imgAgainst:loadTexture(cfg.against[1], ccui.TextureResType.plistType)
	c.imgResource:loadTexture(cfg.resource[1], ccui.TextureResType.plistType)

	self.resType = {false, false, false}

end

-- 更新内容
function HomePageWorldCollectionCellView:updateContent()
	self:reset()                        -- 重置
	local c = self.uiChild
	local info = self.nodeInfo
	--c.labelName:setString(info.desc)
	c.edit:setText(info.desc)
	local index = Language:get("uy29", info.x, info.y)
	c.labelPosition:setString(index)

	self.resType = {false, false, false}
	local ct = self.resType

	local cc = info.resType  -- 类型

	if cc == 1 or cc == 3 or cc == 5 or cc == 7 then
		ct[1] = true
	end
	if cc == 2 or cc == 3 or cc == 6 or cc == 7  then
		ct[2] = true
	end
	if cc == 4 or cc == 5 or cc == 6 or cc == 7 then
		ct[3] = true
	end

	local cfg = HomePageManager.wmCfg.collection

	if ct[1] then
		c.imgResource:loadTexture(cfg.resource[2], ccui.TextureResType.plistType)
	else
		c.imgResource:loadTexture(cfg.resource[1], ccui.TextureResType.plistType)
	end

	if ct[2] then
		c.imgAgainst:loadTexture(cfg.against[2], ccui.TextureResType.plistType)
	else
		c.imgAgainst:loadTexture(cfg.against[1], ccui.TextureResType.plistType)
	end

	if ct[3]then
		c.imgFriend:loadTexture(cfg.friend[2], ccui.TextureResType.plistType)
	else
		c.imgFriend:loadTexture(cfg.friend[1], ccui.TextureResType.plistType)
	end
end
-- 搜索
function HomePageWorldCollectionCellView:searchEventClick()
	local x = self.nodeInfo.x
	local y = self.nodeInfo.y
	local manager = self.delegete.manager

	self.delegete:closeEventClick()   -- 关闭当前页面

	manager:gotoWorldPosition(x, y)   -- 跳转
end

--- 删除条目
function HomePageWorldCollectionCellView:delEventClick()
	local infoX = self.nodeInfo.x
	local infoY = self.nodeInfo.y
	self.delegete:delItem(self.nodeInfo.x, self.nodeInfo.y)
end

--- 设置节点信息
function HomePageWorldCollectionCellView:setNodeInfo(info, delegete)
	self:reset()

	self.nodeInfo = mapping({}, info)
	self.delegete = delegete

	if not self.nodeInfo then return end
	self:updateContent()
end
-- 改变数据
function HomePageWorldCollectionCellView:changeNodeCtype()
	local cc = self.resType
	local n = 0

	if cc[1] == true then
		n = n + 1
	end
	if cc[2] == true then
		n = n + 2
	end
	if cc[3] == true then
		n = n + 4
	end

	self.nodeInfo.resType = n

	if self.nodeInfo.isDirty == nil then  -- 添加一个元表， 如果有就不添加
		local cls = {}
		cls.__index = cls
		cls.isDirty = true   -- 脏数据
		setmetatable(self.nodeInfo, cls)
	end

	self.delegete:changeCollectionData(self.nodeInfo) -- 传入到deleget

end
--- 改变节点描述
function HomePageWorldCollectionCellView:changeNodeDesc(desc)
	if desc == nil then return end
	if self.nodeInfo.desc == desc then -- 内容没有被修改
		return
	end

	self.nodeInfo.desc = desc

	if self.nodeInfo.isDirty == nil then  -- 添加一个元表， 如果有就不添加
		local cls = {}
		cls.__index = cls
		cls.isDirty = true   -- 脏数据
		setmetatable(self.nodeInfo, cls)
	end

	self.delegete:changeCollectionData(self.nodeInfo) -- 传入到deleget

end

function HomePageWorldCollectionCellView:getCellSize()
	return self.widget:getContentSize()
end

return HomePageWorldCollectionCellView
