--region ChangeHeadWindow.lua
--Author    : YuDing
--Date      : 2015/5/14
--Introduce : 改变头像 窗口

local T = class("ChangeHeadWindow", function() return ccui.Layout:create() end)

--- 头像容器
T.headContainer = nil

--- vip open的图片
T.vipOpen = nil

-- 当前选择的id
T.currentChoose = nil 


function T:ctor()
	mapping(self, LuaEventDispatcher)
	local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function(eventType)
				if CocosEvent.ENTER == eventType then
					self:onEnter()
				elseif CocosEvent.EXIT == eventType then
					self:onExit()
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				else

				end
				self:luaDispatchEvent(eventType)
			end
		)
	end

    self.vipOpen = self.vipOpen or {0, 0, 4, 5, 6, 7, 8, 10} -- 各个图片在vip等级的时候 开放

    self:loadJson()
    self:initUI()
    self:initHead()
    self:registerEvent()
end


function T:onEnter()
    
end

function T:onExit()

end

function T:cleanUp()

end



function T:loadJson()
    local widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.changeHeadWindow)
	self.widget = widget
    self:setContentSize(self.widget:getContentSize())
	self:addChild(widget)

    REL:toOther("left", "bottom", self.widget, self, 0, 0) -- 重合

end

function T:initUI()
    local w = self.widget 
    self.uiChild = self.uiChild or {}
    self.headContainer = self.headContainer or {}
    local c = self.uiChild 
    
    for i = 1, 8 do  -- head 1-8
        local str = "head"
        str = str .. i 
        local s = Cocos2dxUtils:getChildByName(w, str)
        table.insert(self.headContainer, s)
        c[str] = s
    end

    c.vipInfoText = Cocos2dxUtils:getChildByName(w, "vipInfoText") -- 头像的 vip描述
    c.needInfoText = Cocos2dxUtils:getChildByName(w, "needInfoText") -- 需求的钻石描述
    c.changHeadText = Cocos2dxUtils:getChildByName(w, "changHeadText") -- 改变头像 文字
    c.needDiamondNum = Cocos2dxUtils:getChildByName(w, "needDiamondNum") -- 需要的钻石

    c.changeHeadBtn = Cocos2dxUtils:getChildByName(w, "changeHeadBtn") -- 改变按钮

    c.headChooseTag = Cocos2dxUtils:getChildByName(w, "headChooseTag") -- 标记

    self:initFixedUI()
end

function T:initFixedUI()
	local c = self.uiChild

	local tb = {}
	for k, v in pairs(self.uiChild) do
		if v:getDescription() == "Label" then
			table.insert(tb, v)
		end
	end
	Cocos2dxUtils:setTextFont(tb)

    c.vipInfoText:setString(Language:get("uy167"))
    c.needInfoText:setString(Language:get("uy168", GameCfg.CHANGE_HEAD_DIAMOND))
    c.changHeadText:setString(Language:get("uy169"))
    c.changHeadText:setColor(cc.c3b(255, 255, 255))
    c.needDiamondNum:setString(tostring(GameCfg.CHANGE_HEAD_DIAMOND))

end

function T:initHead()
    local c = self.uiChild

    local open = self.vipOpen
    for i = 1, #self.headContainer do 
        self.headContainer[i]:loadTexture(PlayerInstance:getPlayerHead(i)) -- 路径
        local visible, needLvl = self:checkHeadOpen(i)
        if not visible then -- 置灰
            self.headContainer[i]:setIsGray(true)
            --  VIPXX,无法选取
--            local text = XMLLabel()
--            text:setHAlign("center")
--            text:setVAlign("middle")
--            text:setContentSize(cc.size(100, 22))
--            text:setFontSize(16)
--            text:setString(Language:get("uy170", needLvl))
--            self:addChild(text)
--            REL:toOther("center", "middle", text, self.headContainer[i], 0, 0)
        end
    end

    local nowIndex = PlayerInstance:getPlayerHeadId()
    
    local img = self.headContainer[nowIndex]
    REL:toOther("center", "middle", c.headChooseTag, img, 0, 0)

    self.currentChoose = nowIndex

end

function T:registerEvent()
    local c = self.uiChild

    local clickHandler = function(t, e)
        if e ~= ccui.TouchEventType.ended then return end
        if t == c.changeHeadBtn then 
            self:onChangeHeadEvent()
        else
            self:onHeadClickEvent(t)
        end
    end

    BaseButton:extend(c.changeHeadBtn)
    c.changeHeadBtn:addTouchEventListener(clickHandler)

    for i = 1, #self.headContainer do 
        BaseButton:extend(self.headContainer[i])
        self.headContainer[i]:addTouchEventListener(clickHandler)
    end

end

function T:onChangeHeadEvent()
	local costGems = GameCfg.CHANGE_HEAD_DIAMOND

    if self.currentChoose == PlayerInstance:getPlayerHeadId() then
        MUIAlter_singleLine.show({
			info = Language:get("uy174", needLvl),
			showSecond = 1.5
		})
        return
    end


	local function confirm()
		local gems = UserInfo.gems
		if costGems > gems then
			-- 钻石不足,-- 弹出充值页面
            self.__hide__()
			MUIPop.MUIToReCharge()
			return
		end

		ChangeHeadCommand.new():exec(self.currentChoose,
			function(state)
                self.__hide__()
				if state == ReturnCode.SUCCESS then    -- 成功
                    --PlayerInstance:reduceDiamond(GameCfg.CHANGE_HEAD_DIAMOND)
                    PlayerInstance:setPlayerHeadId(self.currentChoose)
					MUIAlter_singleLine.show({info = Language:get("uy173"), showSecond = 1})
				else
--					MUIAlter.show({
--						info = ErrorCode:getErrInfo(state)
--					},WindowManager:getCurrentWindow())
				end
			end)
	end

	MUIAlter.show({
		info = Language:get("uy172",costGems),
		size = 30,
		flag = 3,
		callback = function(flag)
			if flag == 0 then -- 0为确定，1为取消
				confirm()
			end
		end
	})
end

function T:onHeadClickEvent(t)
    local c = self.uiChild 
    local index = 0 
    for i = 1, #self.headContainer do 
        if self.headContainer[i] == t then 
            index = i 
            break
        end
    end

    if index == 0 then 
        return 
    end

    local visible, needLvl = self:checkHeadOpen(index)
    if not visible then  -- 未开放
        MUIAlter_singleLine.show({
			info = Language:get("uy171", needLvl),
			showSecond = 1.5
		})
    else -- 开放
        self.currentChoose = index
        REL:toOther("center", "middle", c.headChooseTag, t, 0, 0)
    end


end

--- 检查头像是否开放
function T:checkHeadOpen(index)
    local level = PlayerInstance:getVipLevel()
    if level < self.vipOpen[index] then
        return false, self.vipOpen[index]
    else 
        return true, self.vipOpen[index]
    end
end

return T

--endregion
