--[[
    朋友
]]
local T = class("T", function() return ccui.Layout:create() end)


function T:ctor() 
    
end 

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

    self:_getWidget()
    self:_setAllCount()
    self:_addListView()
    --self:_addSearch()
    self:judgeIsLabel()

    SocialManager:luaAddEventListener(SocialManager.EVT_ADD_FRIEND_REFRESH,self,self._setAllCount)
    SocialManager:luaAddEventListener(SocialManager.EVT_ADD_FRIEND_REFRESH,self,self.addItem)
    SocialManager:luaAddEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self._setAllCount)
    SocialManager:luaAddEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self.judgeIsLabel)
end

function T:onEnter()
    
end

function T:onExit()
    SocialManager:luaRemoveEventListener(SocialManager.EVT_ADD_FRIEND_REFRESH,self,self._setAllCount)
    SocialManager:luaRemoveEventListener(SocialManager.EVT_ADD_FRIEND_REFRESH,self,self.addItem)
    SocialManager:luaRemoveEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self._setAllCount)
    SocialManager:luaRemoveEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self.judgeIsLabel)
end

--- 得到控件
function T:_getWidget()
    -- 显示数量
    local count = XMLLabel()
    count:setHAlign("center")
    count:setContentSize(cc.size(400,36))
    self:addChild(count)
    REL:toOther("center","top",count,self,0,-17)
    self.count = count

    -- listview
    local listView = ListView.new()
    self:addChild(listView)
    REL:relOther(listView,self,0,0,20,100)
    self.listView = listView
end

--- 设置所有的数量
function T:_setAllCount()
    local count = SocialManager:getFriendCount()
    local allCount = SocialManager.MAX_FRIEND_COUNT
    self.count:setString(Language:get("uc395",count,allCount))
end

--- 把数据添加到列表中去
function T:_addListView()
    local list = SocialManager:getFriendList()
    for k,v in pairs(list) do
        if v then
            local res = require("src.app.uiScript.scenes.playerInfo.PlayerInfoFriendItem").new(v,self.listView)
            self.listView:pushBackCustomItem(res)
        end
    end
end

--- 模糊搜索功能
function T:_addSearch()
    local search = Button.new("false","true")
	search:setButtonState("bigButton_green_normal.png","bigButton_general_down.png")
	search:setString(Language:get("uc396"))
	self:addChild(search)
	REL:toOther("center","bottom",search,self,0,10)
    search:setTextCenter()
    search:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            
        end
    end)

end

--- 添加项
function T:addItem(info)
    if self.notHasLable then
        self.notHasLable:removeFromParent()
    end
    local res = require("src.app.uiScript.scenes.playerInfo.PlayerInfoFriendItem").new(info,self.listView)
    self.listView:pushBackCustomItem(res)
end

--- 如果数量为0加个文本显示
function T:judgeIsLabel()
    local count = SocialManager:getFriendCount()
    
    if count == 0 then -- 在空白处添加显示项
        if not self.notHasLable then
            local notHasLable = XMLLabel()
            notHasLable:setContentSize(cc.size(400,36))
            notHasLable:setAlign("center","middle")
            self:addChild(notHasLable)
            REL:toOther("center","middle",notHasLable,self,0,0)
            self.notHasLable = notHasLable
            notHasLable:setString(Language:get("uc406"))
        end
    end
end

return T

