--[[
    朋友项
]]
local T = class("T", function() return ccui.Layout:create() end)

--- 好友信息
T.info = nil

--- 滚动层
T.listView = nil


function T:ctor(info,listView) 
    self.info = info
    self.listView = listView

    self:init()
end 

function T:init()
    self:registerScriptHandler(
        function(eventType)
            if eventType == CocosEvent.ENTER then
                self:onEnter()
            elseif eventType == CocosEvent.EXIT then
                self:onExit()
            elseif eventType == CocosEvent.CLEAN_UP then
            end
        end
    )

--    local _widget = ListItem4.new()
--    self.size = _widget:getContentSize()
--    self:setContentSize(self.size)
--    _widget:setListItemAttribute(
--        nil,
--        nil,
--        {{"infoButton_normal.png","iconButton_general_down.png","false","false"},{"canelButton2_normal.png","iconButton_general_down.png","false","false"}}
--    )
--    self:addChild(_widget)
--    REL:toOther("left","top",_widget,self,0,0)
--    self._widget = _widget
    

    self:setContentSize(cc.size(636,119))
    

    -- 得到控件
    self:GetWidget()

    self:SetData()
    self:SetButton()
end

function T:onEnter()
    SocialManager:luaAddEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self.removeSelf)
end

function T:onExit()
    SocialManager:luaRemoveEventListener(SocialManager.EVT_DELETE_FRIEND_REFRESH,self,self.removeSelf)
end

--- 得到控件
function T:GetWidget()
--    -- 玩家头像
--    self._imgHead = self._widget.leftHead
--    -- 玩家名字
--    self._labelName = self._widget.title

--    -- 信息按钮
--    self.infoBtn = self._widget.button1
--    self.infoBtn:setName("infoBtn")

--    -- 删除按钮
--    self.deleteBtn = self._widget.button2
--    self.deleteBtn:setName("deleteBtn")


    -- 背景图片
    local back = ccui.ImageView:create()
    back:loadTexture("friendBottom.png",ccui.TextureResType.plistType)
    self:addChild(back)
    REL:toOther("center","middle",back,self,0,0)
    self.back = back

    -- 玩家名字
    local name = XMLLabel()
	name:setContentSize(cc.size(400,27))
	self:addChild(name)
	REL:toOther("left","top",name,self.back,80,40)
    self.name = name


    -- 信息按钮
    local infoBtn = Button.new("false","false")
	infoBtn:setButtonState("infoButton_normal.png","iconButton_general_down.png")
	self:addChild(infoBtn)
	REL:toOther("right","middle",infoBtn,self.back,15 + 80,-5)
	self.infoBtn = infoBtn
    self.infoBtn:setName("infoBtn")


    -- 删除按钮
    local deleteBtn = Button.new("false","false")
	deleteBtn:setButtonState("canelButton2_normal.png","iconButton_general_down.png")
	self:addChild(deleteBtn)
	REL:toOther("right","middle",deleteBtn,self.back,15,-5)
	self.deleteBtn = deleteBtn
    self.deleteBtn:setName("deleteBtn")

end


function T:SetData()
    local info = self.info

    self.name:setString(Language:get("uc698",info.name))

end


function T:SetButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            local name = sender:getName()
            if name == "infoBtn" then 
                self:infoLogic()
            elseif name == "deleteBtn" then
                self:deleteLogic()
            else
                print("按钮不对")
            end
        end
    end
    self.infoBtn:addTouchEventListener(callback) 
    self.deleteBtn:addTouchEventListener(callback) 
end

--- 信息逻辑
function T:infoLogic()
    local info = self.info
    local function finish(dataTable)
        -- new的有大小
        local layout = require("src.app.uiScript.components.chat.ChatInfoPopView").new(dataTable,nil,info.name)
        layout:setTouchEnabled(true)
        local muialter2 = MUIAlter.show(
                {
                    title = dataTable.name,
                    info = layout,
                    flag = 4,
                    callback = function(flag)
                    end
                }
            )
        layout:setMUIAlter2(muialter2)
    end
    BuildingCommand:CheckChatInfo(info.id,finish)
end

--- 删除逻辑
function T:deleteLogic()
    local info = self.info
    local function confirm()
        local function finish()
            local descripe = Language:get("uc410")
		    MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
        end
        BuildingCommand:DeleteFriend(info.id,finish) -- 删除后有事件派发的
    end
    MUIPop.MUIImmediate(Language:get("uc398",info.name),confirm)
end

function T:removeSelf()
    local index = self.listView:getIndex(self)
    local listView = self.listView
    self.listView:removeItem(index)
    listView:refreshView()
end


return T

