--Author    : YuDing
--Date      : 2014/11/29
--Introduce : 玩家介绍

local PlayerInfoIntroduce = class("PlayerInfoIntroduce", function() return ccui.Layout:create() end)

-- ui
PlayerInfoIntroduce.uiChild = nil
-- 买能量消耗的钻石 1 消耗的钻石 2 得到的能量
PlayerInfoIntroduce.buyEnergy = {5, 5}

function PlayerInfoIntroduce:ctor()
	mapping(self, LuaEventDispatcher)
	local handler = self.registerScriptHandler
	if handler then
		self:registerScriptHandler(
			function(eventType)
				if CocosEvent.ENTER == eventType then
					self:onEnter()
				elseif CocosEvent.EXIT == eventType then
					self:onExit()
				elseif eventType == CocosEvent.CLEAN_UP then
					self:cleanUp()
				else

				end

				self:luaDispatchEvent(eventType)
			end
		)
	end

	self:loadJson()
	self:loadUI()
	self:initContent()
	self:registerEvent()
	--self:updateReputationAddBtn() -- 更新按钮
	self:addHonor()

end

function PlayerInfoIntroduce:onEnter()
end

function PlayerInfoIntroduce:onExit()
end
--- 清理
function PlayerInfoIntroduce:cleanUp()
	self:releasePublicEvent()
end

function PlayerInfoIntroduce:addHonor()
	local layout = require("src.app.uiScript.scenes.playerInfo.honor.HonorLayout").new()
	REL:toOther("center","top",layout,self,0,220)
	self:addChild(layout)

end

function PlayerInfoIntroduce:initFixedUI()

	local c = self.uiChild

	local tb = {}
	for k, v in pairs(self.uiChild) do
		if v:getDescription() == "Label" then
			table.insert(tb, v)
		end
	end
	Cocos2dxUtils:setTextFont(tb)

	c.dominanceArmy:setString(Language:get("uy41"))
	c.energyLabel:setString(Language:get("uy39"))
	c.honorLabel:setString(Language:get("fy1008")) -- 带兵量
	c.fightingLabel:setString(Language:get("uy38"))
	c.changeHeadText:setString(Language:get("uy109"))

	-- 重新修正bar
	c.reputationBar = Cocos2dxUtils:fixedLoadingBar(c.reputationBar, "productProgressFore.png")
	c.energyBar = Cocos2dxUtils:fixedLoadingBar(c.energyBar, "powProgressFore.png")
	c.expBar = Cocos2dxUtils:fixedLoadingBar(c.expBar, "expProgressFore.png")

	c.name:setString(PlayerInstance:getPlayerName())

	local dominanceTemp=Prop_temp[PlayerInstance:getDominancePropID()]
	if dominanceTemp then
		c.dominanceHead:loadTexture(IconManager.iconPath..dominanceTemp.propIcon)
	end

	local reputationTemp=AwardTypes["reputation"]
	if reputationTemp then
		c.reputationHead:loadTexture(IconManager.iconPath..reputationTemp.iconUrl)
	end


	self:updatePlayerHead()
end

--- 更新玩家头像
function PlayerInfoIntroduce:updatePlayerHead()
	local c = self.uiChild
	local id = PlayerInstance:getPlayerHeadId()
	c.playerHead:loadTexture(PlayerInstance:getPlayerHead(id)) -- 头像
end

--- 加载json
function PlayerInfoIntroduce:loadJson()
	local widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.playerInfoIntroduce)
	self.widget = widget
	self:addChild(widget)
	self:setContentSize(widget:getContentSize())
end
--- 加载控件
function PlayerInfoIntroduce:loadUI()
	self.uiChild = self.uiChild or {}
	local c = self.uiChild
	local w = self.widget

	c.dominanceAdd = Cocos2dxUtils:getChildByName(w, "dominanceAdd")       -- 增加指挥等级按钮
	c.dominanceInfo = Cocos2dxUtils:getChildByName(w, "dominanceInfo")     -- 查看指挥等级信息按钮
	c.dominanceLvl = Cocos2dxUtils:getChildByName(w, "dominanceLvl")     -- 指挥名字等级
	c.dominanceArmy = Cocos2dxUtils:getChildByName(w, "dominanceArmy")     -- 指挥带兵数 标签
	c.dominanceNumber = Cocos2dxUtils:getChildByName(w, "dominanceNumber") -- 指挥带兵的数目
	c.reputationAdd = Cocos2dxUtils:getChildByName(w, "reputationAdd")     -- 增加声望按钮
	c.reputationInfo = Cocos2dxUtils:getChildByName(w, "reputationInfo")   -- 声望信息按钮
	c.reputationLvl = Cocos2dxUtils:getChildByName(w, "reputationLvl") -- 声望
	c.name = Cocos2dxUtils:getChildByName(w, "name")                       -- 玩家名字
	c.lvl = Cocos2dxUtils:getChildByName(w, "lvlLabel")               -- 等级标签
	c.energyLabel = Cocos2dxUtils:getChildByName(w, "energyLabel")         -- 能量标签
	c.expBar = Cocos2dxUtils:getChildByName(w, "expBar")                   -- 经验条
	c.energyBar = Cocos2dxUtils:getChildByName(w, "energyBar")             -- 能量条
	c.honorLabel = Cocos2dxUtils:getChildByName(w, "honorLabel")           -- 荣誉 标签
	c.honor = Cocos2dxUtils:getChildByName(w, "honor")                     -- 荣誉 数目  （改为带兵量）
	c.fightingLabel = Cocos2dxUtils:getChildByName(w, "fightingLabel")     -- 战斗力 标签
	c.fighting = Cocos2dxUtils:getChildByName(w, "fighting")               -- 战斗力数目
	c.energyAdd = Cocos2dxUtils:getChildByName(w, "energyAdd")             -- 增加能量值 按钮
	c.expNumber = Cocos2dxUtils:getChildByName(w, "expNumber")             -- 经验值
	c.energyNumber = Cocos2dxUtils:getChildByName(w, "energyNumber")       -- 能量值
	c.reputationExp = Cocos2dxUtils:getChildByName(w, "reputationExp") -- 声望经验
	c.reputationBar = Cocos2dxUtils:getChildByName(w, "reputationBar") -- 声望条

	c.dominanceHead = Cocos2dxUtils:getChildByName(w, "dominanceHead") -- 指挥头像
	c.reputationHead = Cocos2dxUtils:getChildByName(w, "reputationHead") -- 声望图片

	c.playerHead = Cocos2dxUtils:getChildByName(w, "playerHead") -- 玩家头像

	c.extra = Cocos2dxUtils:getChildByName(w, "extra") -- 额外带兵数

	c.changeHead = Cocos2dxUtils:getChildByName(w, "changeHead") -- 改变头像
	c.changeHeadText = Cocos2dxUtils:getChildByName(w, "changeHeadText") -- 改变头像文本


	c.reputationBarBack = Cocos2dxUtils:getChildByName(w, "reputationBarBack") -- 声望条的背景


	self:initFixedUI()

	if BGMgr:isGuide() then
		BGMgr:regGuideObj(BGMgr.TGR_PLAYER_INFO_LV_UP_DOMINANCE_BUTTON,c.dominanceAdd)
	end
end
--- 初始化内容
function PlayerInfoIntroduce:initContent()
	local c = self.uiChild


	self:updateLvl()
	--self:updateHonor()
	self:updateFighting()
	self:updateExp()
	self:updateEnergy()
	self:updateDoninanceLvl()
	self:updateReputationLvl()
	self:updateReputationNumber()
	self:updateTotalArmyNum()

	self:updateUpgradeDominance()
end
--- 注册事件
function PlayerInfoIntroduce:registerEvent()

	local c = self.uiChild

	local clickHandler = function(t, e)
		if e ~= ccui.TouchEventType.ended then return end
		if t == c.dominanceAdd then
			if BGMgr:isGuide() then
				BGMgr:fire(BGMgr.EVT_TGR_UI,BGMgr.TGR_PLAYER_INFO_LV_UP_DOMINANCE_BUTTON)
			end

			self:onEventDominanceAddClick()
		elseif t == c.dominanceInfo then
			self:onEventDominanceInfoClick()
		elseif t == c.reputationInfo then
			self:onEventReputationInfoClick()
		elseif t == c.reputationAdd then
			self:onEventReputationAddClick()
		elseif t == c.energyAdd then
			self:onEventEnergyAddClick()
		elseif t == c.changeHead then
			self:onEventChangeHead()
		end
	end

	BaseButton:extend(c.dominanceAdd)
	BaseButton:extend(c.dominanceInfo)
	BaseButton:extend(c.reputationInfo)
	BaseButton:extend(c.reputationAdd)
	BaseButton:extend(c.energyAdd)
	BaseButton:extend(c.changeHead)

	c.dominanceAdd:addTouchEventListener(clickHandler)
	c.dominanceInfo:addTouchEventListener(clickHandler)
	c.reputationInfo:addTouchEventListener(clickHandler)
	c.reputationAdd:addTouchEventListener(clickHandler)
	c.energyAdd:addTouchEventListener(clickHandler)
	c.changeHead:addTouchEventListener(clickHandler)

	self:registerPublicEvent()

end

function PlayerInfoIntroduce:registerPublicEvent()
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.playerLvl, self,  self.updateLvl)
	--PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.honor, self,  self.updateHonor)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.fighting, self,  self.updateFighting)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.exp, self,  self.updateExp)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.energy, self,  self.updateEnergy)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.dominanceLvl, self,  self.updateDoninanceLvl)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.reputationLevel, self,  self.updateReputationLvl)
	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.reputationExp, self,  self.updateReputationNumber)

	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.dominanceLvl, self,  self.updateTotalArmyNum)

	PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. PlayerInstance:getDominancePropID(), self, self.updateUpgradeDominance)

	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.dominanceLvl, self,  self.updateUpgradeDominance)

	PlayerInstance:luaAddEventListener(PlayerInstance.noticeMessage.headId, self, self.updatePlayerHead)

	--DailyStates:luaAddEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES, self, self.updateReputationAddBtn)
end

function PlayerInfoIntroduce:releasePublicEvent()
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.playerLvl, self,  self.updateLvl)
	--PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.honor, self,  self.updateHonor)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.fighting, self,  self.updateFighting)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.exp, self,  self.updateExp)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.energy, self,  self.updateEnergy)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.dominanceLvl, self,  self.updateDoninanceLvl)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.reputationLevel, self,  self.updateReputationLvl)
	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.reputationExp, self,  self.updateReputationNumber)

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.dominanceLvl, self,  self.updateTotalArmyNum)

	PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. PlayerInstance:getDominancePropID(), self, self.updateUpgradeDominance)

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.dominanceLvl, self,  self.updateUpgradeDominance)

	PlayerInstance:luaRemoveEventListener(PlayerInstance.noticeMessage.headId, self, self.updatePlayerHead)

	--DailyStates:luaRemoveEventListener(DailyStates.EVT_TYPE_UPDATE_DAILY_STATES, self, self.updateReputationAddBtn)

end

--- 指挥等级增加
function PlayerInfoIntroduce:onEventDominanceAddClick()
	local s = self:checkDominanceIsLevelUp()
	if s == false then -- 表示等级达到
		return
	end

	local layout = require("src.app.uiScript.scenes.playerInfo.PromoteCommandWindow").new()
	if BGMgr:isGuide() then
		MUIAlter_custom.show({
			info = layout,
			triggerCloseMethod="buttons"
		})
	else
		MUIAlter_custom.show({
			info = layout,
		})
	end
end
--- 指挥详情
function PlayerInfoIntroduce:onEventDominanceInfoClick()
	local lvInfo

	local lvl = PlayerInstance:getDominanceLevel()
	if lvl >= PlayerInstance:getMaxDominanceLvl() then -- 已达到最大等级
		lvInfo=Language:get("uy185")
	else
		local nextLv=lvl + 1
		local playerLv=PlayerInstance:getPlayerLevel()
		local bookCount=PlayerInstance:getDominanceBook()

		lvInfo=Language:get("uy179",
			nextLv,
			Dominance_temp[nextLv].extra,
			nextLv <= playerLv and nextLv or CssStyles.span(tostring(nextLv),"red24"),
			bookCount > 0 and bookCount or CssStyles.span(tostring(bookCount),"red24")
		)
	end

	MUIAlter_noTitle.show({
		info = Language:get("uy178",lvInfo),
		hAlign="left"
	})
end
--- 声望详情
function PlayerInfoIntroduce:onEventReputationInfoClick()
	MUIAlter_noTitle.show({
		info = Language:get("uy175"),
		hAlign="left",
		lineSpacing=6
	})
end
--- 声望增加
function PlayerInfoIntroduce:onEventReputationAddClick()
	-- WindowManager:push(require("src.app.uiScript.scenes.playerInfo.PlayerInfoReputationAdd").new())

	if PlayerInstance:getReputationLvl() < GameCfg.BUILDING_MAX_LEVEL then
		local layout = require("src.app.uiScript.scenes.playerInfo.ReputationAdd").new()
		local muialter2 = MUIAlter.show({
			title = Language:get("uc867"),
			info = layout,
			flag = 4,
			isShowCloseButton = true,
			callback = function(flag)
			end
		})
		layout:setMuialter(muialter2)
	else
		-- 已到最高等级
		MUIAlter_singleLine.show( {
			info = Language:get("ug912"),
			showSecond = 1
		} )
	end

	--    local state = SetStates.reputationState:getState()
	--    if state ~= UnitConversion.getYday() then  -- 与当前天数不同  免费领取
	--        ReputationAddCommand:new():exec(function(state)
	--            if state == ReturnCode.SUCCESS then -- 成功
	--                self:updateReputationAddBtn()
	--                MUIAlter_singleLine.show({info = Language:get("uy190", GameCfg.FREE_ADD_REPUTATION), showSecond = 1})
	--            end
	--        end)
	--    else -- 用钻石领取
	--        local confirm = function()
	--            local gems = UserInfo.gems
	--			if GameCfg.COST_ADD_REPUTATION_DIAMOND > gems then
	--				-- 钻石不足,-- 弹出充值页面
	--				MUIPop.MUIToReCharge()
	--				return
	--			end

	--            BuyReputationCommand:new():exec(function(state)
	--                if state == ReturnCode.SUCCESS then -- 成功
	--                    self:updateReputationAddBtn()
	--                    MUIAlter_singleLine.show({info = Language:get("uy190", GameCfg.ADD_REPUTATION), showSecond = 1})
	--                end
	--            end)
	--        end

	--        MUIAlter.show({
	--			info = Language:get("uy191", GameCfg.COST_ADD_REPUTATION_DIAMOND, GameCfg.ADD_REPUTATION),
	--			size = 30,
	--			flag = 3,
	--			callback = function(flag)
	--				if flag == FLAG_OK then
	--					confirm()
	--				end
	--			end
	--		})
	--    end
end

--- 改变头像
function PlayerInfoIntroduce:onEventChangeHead()
	local layout = require("src.app.uiScript.scenes.playerInfo.ChangeHeadWindow").new()
	MUIAlter_noTitle.show({
		info = layout
	})
end

--- 购买能量
function PlayerInfoIntroduce:onEventEnergyAddClick()
	-- 后面要读配置，根据vip等级得到一个最大今日的精力点次数
	local vipPoint = VipManager.getVipPoint()
	local dailyPoint = DailyStates:getPointCount()
	if dailyPoint + 1 > vipPoint then
		local describe1 = Language:get("uc317",UserInfo.vipLevel)
		local describe2 = Language:get("uc318",UserInfo.vipLevel,vipPoint)
		local describe3 = Language:get("uc319")

		local layout = VipTipsInfo.new(describe1,describe2,describe3)

		MUIAlter.show(
			{
				info = layout,
				size = 30,
				flag = 1,
				confirmText = Language:get("uc332"),
				callback = function() -- 转到vip界面
					WindowManager:push(
						require("src.app.uiScript.components.vip.VIPWindow").new()
					)
				end
			}
		)

		return
	end


	local costGems = DailyStates:buyPointCostGems()

	local function confirm()
		local gems = UserInfo.gems
		if costGems > gems then
			-- 钻石不足,-- 弹出充值页面
			MUIPop.MUIToReCharge()
			return
		end

		BuyEnergyCommand.new():exec(
			function(s)
				if s == ReturnCode.SUCCESS then    -- 成功
					MUIAlter_singleLine.show( {info = Language:get("fy1009"),showSecond = 1 } )
				else
					MUIAlter_singleLine.show({
						info=ErrorCode:getErrInfo(state)
					},WindowManager:getCurrentWindow())
				end
			end)
	end

	MUIAlter.show({
		info = Language:get("uc293",costGems),
		size = 30,
		flag = 3,
		callback = function(flag)
			if flag == 0 then -- 0为确定，1为取消
				confirm()
			end
		end
	})

end
--- 检查消耗的钻石
-- @param cost 消耗的钻石
-- @return false 钻石不够
function PlayerInfoIntroduce:checkDimondIsEnough(cost)
	local total = PlayerInstance:getDiamond()
	if cost > total then
		return false
	else
		return true
	end
end
--- 检查指挥是否能升级
function PlayerInfoIntroduce:checkDominanceIsLevelUp()
	return PlayerInstance:checkDominanceLevelupLevel()
end
--- 发送买能量信息
function PlayerInfoIntroduce:sendBuyEnergyMessage()
	BuyEnergyCommand.new():exec(
		function(s)
			if state == ReturnCode.SUCCESS then    -- 成功
				MUIAlter_singleLine.show( {info = Language:get("fy1009"),showSecond = 1 } )
			end
		end)
end
--- 发送指挥升级
-- @param s 是否是钻石
function PlayerInfoIntroduce:sendDominanceUpgradeCommand(s)
	DominanceLevelUpCommand.new():exec(s,
		function(state, s)
			if s == true then
				MUIAlter_singleLine.show( {info = Language:get("v34", PlayerInstance:getDominanceExtraPlane()),showSecond = 1 } )
			else -- 失败
				MUIAlter_singleLine.show( {info = Language:get("fy1003"),showSecond = 1 } )
			end
		end)
end

--- 等级
function PlayerInfoIntroduce:updateLvl()
	local lvl = PlayerInstance:getPlayerLevel()
	self.uiChild.lvl:setString("Lv." .. lvl)
end
----- 荣誉（改为带兵量）
--function PlayerInfoIntroduce:updateHonor()
--    local num = PlayerInstance:getHonor()
--    self.uiChild.honor:setString(tostring(num))
--end
--- 战斗力
function PlayerInfoIntroduce:updateFighting()
	local num = PlayerInstance:getPlayerFight()
	self.uiChild.fighting:setString(UnitConversion.unitTrans(num))
end
--- 经验
function PlayerInfoIntroduce:updateExp()
	local num = PlayerInstance:getPlayerExp()
	local max = PlayerInstance:getPlayerMaxExp()
	self.uiChild.expNumber:setString(UnitConversion.unitTrans(num) .. "/" .. UnitConversion.unitTrans(max))
	self.uiChild.expBar:setPercentage(num / max * 100)
end
--- 能量
function PlayerInfoIntroduce:updateEnergy()
	local num = PlayerInstance:getPlayerEnergy()
	local max = PlayerInstance:getPlayerMaxEnergy()
	self.uiChild.energyNumber:setString(num .. "/" .. max)
	local p = num / max * 100
	p = p >= 100 and 100 or p
	self.uiChild.energyBar:setPercentage(p)
end
--- 指挥
function PlayerInfoIntroduce:updateDoninanceLvl()
	local lvl = PlayerInstance:getDominanceLevel()
	if not lvl then
		lvl = 0
	end

	local c = self.uiChild
	c.dominanceLvl:setString(Language:get("uy89",Language:get("uy40"),lvl))

	--    local ownPlane = PlayerInstance:getPlayerOwnPlane()
	--    local extraPlane = PlayerInstance:getDominanceExtraPlane()

	--    self.uiChild.dominanceNumber:setString(ownPlane)
	--    self.uiChild.extra:setString("+" .. extraPlane)

	--    local size = self.uiChild.dominanceNumber:getContentSize()
	--    local p = self.uiChild.dominanceNumber:getPosition()


	--self.uiChild.extra:setPositionX(p + size.width + 10)

	self:updateDoninanceNum()

	local s = self:checkDominanceIsLevelUp() -- 其实这里还和人物等级有关， 因为此界面人物等级不变化 所以暂时不考虑
	if s == true then
		c.dominanceAdd:setTouchEnabled(true)
		c.dominanceAdd:setIsGray(false)
	else
		c.dominanceAdd:setTouchEnabled(false)
		c.dominanceAdd:setIsGray(true)
	end
end

function PlayerInfoIntroduce:updateDoninanceNum()
	local c = self.uiChild

	local ownPlane = PlayerInstance:getPlayerOwnPlane()
	local extraPlane = PlayerInstance:getDominanceExtraPlane()

	c.dominanceArmy:setString(Language:get("uy108") .. ownPlane)
	c.extra:setString("+" .. extraPlane)

	local size = c.dominanceArmy:getContentSize()
	local p = c.dominanceArmy:getPosition()

	c.extra:setPositionX(p + size.width + 2)

end


-- 所有带兵量
function PlayerInfoIntroduce:updateTotalArmyNum()
	local ownPlane = PlayerInstance:getPlayerOwnPlane()
	local extraPlane = PlayerInstance:getDominanceExtraPlane()
	local all = ownPlane + extraPlane
	self.uiChild.honor:setString(tostring(all))
end

--- 声望等级
function PlayerInfoIntroduce:updateReputationLvl()
	local lvl = PlayerInstance:getReputationLvl()
	self.uiChild.reputationLvl:setString(Language:get("uy89",Language:get("uy42"), lvl))

	if PlayerInstance:getReputationLvl() >= GameCfg.BUILDING_MAX_LEVEL then
		self.uiChild.reputationAdd:setIsGray(true)
	else
		self.uiChild.reputationAdd:setIsGray(false)
	end
end
--- 声望值
function PlayerInfoIntroduce:updateReputationNumber()
	local num = PlayerInstance:getReputationCurrentExp()
	local max = PlayerInstance:getReputationCurrentMaxExp()
	self.uiChild.reputationExp:setString(num .. "/" .. max)
	self.uiChild.reputationBar:setPercentage(num / max * 100)
end

--- 升级痛率 特效
function PlayerInfoIntroduce:updateUpgradeDominance()
	local c = self.uiChild
	local lvlEnable  -- 等级是否满足

	local dl = PlayerInstance:getDominanceLevel()
	local pl = PlayerInstance:getPlayerLevel()

	if dl >= pl then
		lvlEnable = false
	else
		lvlEnable = true
	end

	local bookNum = PlayerInstance:getDominanceBook()

	if lvlEnable == true and bookNum > 0 then -- 添加特效
		if not c.dominanceAdd.eff then
			c.dominanceAdd.eff = HomePageManager:addEffect(c.dominanceAdd, "button6TipEff")
	end
	else
		if c.dominanceAdd.eff then
			c.dominanceAdd.eff:removeFromParent()
			c.dominanceAdd.eff = nil
		end
	end

end

function PlayerInfoIntroduce:updateReputationAddBtn()
	local c = self.uiChild
	local state = SetStates.reputationState:getState()
	if state ~= UnitConversion.getYday() then
		c.reputationAdd:setIsGray(false)
	else
		c.reputationAdd:setIsGray(true)
	end
end

----- 因为时间的缘故
--function T:flushTask()
--	if self.taskSchduleId then
--		return
--	end

--	local func = function()
--		self:updateDailyTip()
--	end

--	self.taskSchduleId = Cocos2dxUtils:interval(func, 0.5)
--end

--function T:removeFlushTask()
--    if self.taskSchduleId then
--        Cocos2dxUtils:clearScheduler(self.taskSchduleId)
--        self.taskSchduleId = nil
--    end
--end



return PlayerInfoIntroduce
