--region PlayerInfoReputationAdd.lua
--Author    : YuDing
--Date      : 2014/12/6
--introduce : 玩家增加声望
local PlayerInfoReputationAdd = class("PlayerInfoReputationAdd", function() 
        local o = AbstractWindow.new()
        o.super = AbstractWindow
        return o
    end)

PlayerInfoReputationAdd.uiChild = {}
--- 是否使用过
PlayerInfoReputationAdd.use = false

PlayerInfoReputationAdd.cost = {[1] = {normalMoney = 1000, add = 20},
                                [2] = {copperDiamond = 10, add = 80},
                                [3] = {silverDiamond = 40, add = 400},
                                [4] = {goldDiamond = 90, add = 1000},}

-- 构造函数
function PlayerInfoReputationAdd:ctor() 
    mapping(self, LuaEventDispatcher)
--    self:loadRes()
    local handler = self.registerScriptHandler
    if handler then
        self:registerScriptHandler(
            function(eventType)
               if CocosEvent.ENTER == eventType then
                    self:onEnter()
               elseif CocosEvent.EXIT == eventType then
                    self:onExit()
               elseif eventType == CocosEvent.CLEAN_UP then
				    self:cleanUp()
               end
               
               self:luaDispatchEvent(eventType)
            end
         )    
    end


    self:initContent()
    self:updateAddState()


    self:initCompleteHandler() -- 透明度（目前是要需要这个接口）

--    self:loadJson()
--    self:loadUI()
--    self:registerEvent()
--    self:updateAddState()

end 

-- 加载json
function PlayerInfoReputationAdd:loadJson()
    self.widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.playerInfoReputationAdd)
    self:addChild(self.widget)
end
--- 加载ui
function PlayerInfoReputationAdd:loadUI()
    local c = self.uiChild
    local w = self.widget 

    c.normalMedal = Cocos2dxUtils:getChildByName(self, "normalMedal")
    c.normalMedalCost = Cocos2dxUtils:getChildByName(self, "normalMedalCost")
    c.copperMedal = Cocos2dxUtils:getChildByName(self, "copperMedal")
    c.copperMedalCost = Cocos2dxUtils:getChildByName(self, "copperMedalCost")
    c.silverMedal = Cocos2dxUtils:getChildByName(self, "silverMedal")
    c.silverMedalCost = Cocos2dxUtils:getChildByName(self, "silverMedalCost")
    c.goldMedal = Cocos2dxUtils:getChildByName(self, "goldMedal")
    c.goldMedalCost = Cocos2dxUtils:getChildByName(self, "goldMedalCost")
    c.head = Cocos2dxUtils:getChildByName(self, "head")
    c.normalAdd = Cocos2dxUtils:getChildByName(self, "normalAdd")
    c.copperAdd = Cocos2dxUtils:getChildByName(self, "copperAdd")
    c.silverAdd = Cocos2dxUtils:getChildByName(self, "silverAdd")
    c.goldAdd = Cocos2dxUtils:getChildByName(self, "goldAdd")

    self:initFixedUI()
    self:updateViewContent()
end
--- 注册事件
function PlayerInfoReputationAdd:registerEvent()
    local c = self.uiChild 
    local w = self.widget 

    local func = function(t, eventType)
          if ccui.TouchEventType.ended ~= eventType then return end
          if c.normalAdd == t then 
            self:onEventNormalAddClick()
          elseif c.copperAdd == t then 
            self:onEventCopperAddClick()
          elseif c.silverAdd == t then 
            self:onEventSilverAddClick()
          elseif c.goldAdd == t then 
            self:onEventGoldAddClick()
          end
    end

    BaseButton:extend(c.normalAdd)
    BaseButton:extend(c.copperAdd)
    BaseButton:extend(c.silverAdd)
    BaseButton:extend(c.goldAdd)

    c.normalAdd:addTouchEventListener(func)
    c.copperAdd:addTouchEventListener(func)
    c.silverAdd:addTouchEventListener(func)
    c.goldAdd:addTouchEventListener(func)

end
--- 更新界面
function PlayerInfoReputationAdd:updateViewContent()
    local c = self.uiChild 
    c.head:setString(Language:get("uy47"))

    local str = Language:get("uy43", self.cost[1].add)  -- 奇怪 这样就没问题
    c.normalMedal:setString(str)
    str = Language:get("uy49", self.cost[1].normalMoney) 
    c.normalMedalCost:setString(str)

    str = Language:get("uy44", self.cost[2].add)
    c.copperMedal:setString(str)
    str = Language:get("uy50", self.cost[2].copperDiamond)
    c.copperMedalCost:setString(str)

    str = Language:get("uy45", self.cost[3].add)
    c.silverMedal:setString(str)
    str = Language:get("uy50", self.cost[3].silverDiamond)
    c.silverMedalCost:setString(str)

    str = Language:get("uy46", self.cost[4].add)
    c.goldMedal:setString(str)
    str = Language:get("uy50", self.cost[4].goldDiamond)
    c.goldMedalCost:setString(str)

end

function PlayerInfoReputationAdd:initFixedUI()
    local c = self.uiChild

    local tb = {} 
    for k, v in pairs(self.uiChild) do 
        if v:getDescription() == "Label" then 
            table.insert(tb, v)
        end
    end
    Cocos2dxUtils:setTextFont(tb)
end

--- 创建条目
function PlayerInfoReputationAdd:createItem(titleStr, contentStr, headSrc, func)
    local widget = ListItem4.new()
    widget:setListItemAttribute(
        "H",
        {"label"},
        {{"upgrade.png", "upgrade.png", "false", "false"}}
    )
    widget.button1:addTouchEventListener(func) -- 回调
    widget:setString(widget:getLabel(1), contentStr) -- 内容
    widget:setString(widget.title, titleStr) -- 标题
    widget.leftHead:loadTexture(headSrc) -- 图片

    return widget
end


function PlayerInfoReputationAdd:initContent()
    
    self.normal = self:createItem(Language:get(ReputationData[1].name, ReputationData[1].add), 
        Language:get(ReputationData[1].desc, ReputationData[1].cost),
        IconManager.iconPath .. ReputationData[1].res,
        function(t, e)
             if ccui.TouchEventType.ended ~= e then return end
             self:onEventNormalAddClick()
        end
        )

    self.copper = self:createItem(Language:get(ReputationData[2].name, ReputationData[2].add), 
        Language:get(ReputationData[2].desc, ReputationData[2].cost),
        IconManager.iconPath .. ReputationData[2].res,
        function(t, e)
             if ccui.TouchEventType.ended ~= e then return end
             self:onEventCopperAddClick()
        end
        )

    self.silver = self:createItem(Language:get(ReputationData[3].name, ReputationData[3].add), 
        Language:get(ReputationData[3].desc, ReputationData[3].cost),
        IconManager.iconPath .. ReputationData[3].res,
        function(t, e)
             if ccui.TouchEventType.ended ~= e then return end
             self:onEventSilverAddClick()
        end
        )

    self.gold = self:createItem(Language:get(ReputationData[4].name, ReputationData[4].add), 
        Language:get(ReputationData[4].desc, ReputationData[4].cost),
        IconManager.iconPath .. ReputationData[1].res,
        function(t, e)
             if ccui.TouchEventType.ended ~= e then return end
             self:onEventGoldAddClick()
        end
        )
    

    self:addItemToContainer({self.normal, self.copper, self.silver, self.gold})
end

--- 将组件加入到container中
function PlayerInfoReputationAdd:addItemToContainer(tb)
    local container = ccui.Layout:create()

--    container:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--    container:setBackGroundColor(cc.c3b(random(0,255),0,0))
--    container:setBackGroundColorOpacity(100)

    local height = 0
    local distance = 5 -- 两个组件之间的距离 5 个像素
    local allDistance = 0
    if #tb == 0 then return end
   
    for i = 1, #tb do  
        local sz = tb[i]:getContentSize()
        height = height + sz.height
    end

    if #tb > 1 then -- 加上距离
        allDistance = distance * (#tb - 1)
        height = allDistance + height
    end

    local tmp = tb[1]:getContentSize() -- 先取一个宽度

    container:setContentSize(cc.size(tmp.width, height))    -- tmp.width 取的图片的一个宽度，因为都相等 height 为总高度
    self:addChild(container)
    container:setContentSize(cc.size(tmp.width, height)) 

    REL:toScreen("center", "middle", container, 0, 0)

    local s = container:getContentSize()

    -- 依次放入 self 中
    local n = #tb
    for i = 1, n do  
        local sz = tb[i]:getContentSize()
        if i > 1 then 
            s.height = s.height - sz.height - distance
        else
            s.height = s.height - sz.height
        end
        container:addChild(tb[i])
        --tb[i]:setPosition(cc.p(0, s.height))
        REL:toOther("left", "bottom", tb[i], container, 0, s.height)
    end
end

--- 更新按钮的状态
function PlayerInfoReputationAdd:updateAddState()

    local gary = false 
    local able = false
    if self.use == false then
        gary = false 
        able = true   
    else 
        gary = true 
        able = false
    end

    local tb = {self.normal, self.copper, self.silver, self.gold}

    for i = 1, #tb do 
        tb[i].button1:setIsGray(gary)
        tb[i].button1:setTouchEnabled(able)
    end
end

--- 普通点击
function PlayerInfoReputationAdd:onEventNormalAddClick()
    local m = PlayerInstance:getGold()
    if m < ReputationData[1].cost then 
        MUIAlter_singleLine.show( {info = Language:get("uc305"), showSecond = 1 } )
        return
    end

    self:sendAddMessage(0)
end

--- 铜
function PlayerInfoReputationAdd:onEventCopperAddClick()
    local diamond = PlayerInstance:getDiamond()
    if diamond < ReputationData[2].cost then 
        MUIAlter_singleLine.show( {info = Language:get("ug934"),showSecond = 1 } )
        return 
    end

    self:sendAddMessage(1)
end

--- 银
function PlayerInfoReputationAdd:onEventSilverAddClick()
    local diamond = PlayerInstance:getDiamond()
    if diamond < ReputationData[3].cost then 
        MUIAlter_singleLine.show( {info = Language:get("ug934"),showSecond = 1 } )
        return 
    end

    self:sendAddMessage(2)
end

--- 金
function PlayerInfoReputationAdd:onEventGoldAddClick()
    local diamond = PlayerInstance:getDiamond()
    if diamond < ReputationData[4].cost then 
        MUIAlter_singleLine.show( {info = Language:get("ug934"),showSecond = 1 } )
        return 
    end

    self:sendAddMessage(3)
end

--- 发送消息
function PlayerInfoReputationAdd:sendAddMessage(idx)
    ReputationAddCommand.new():exec(idx, 
    function(state) 
         if state == ReturnCode.SUCCESS then
            self.use = true
            self:updateAddState()
            MUIAlter_singleLine.show( {info = Language:get("uy138"), showSecond = 1 } )
        else 
            --MUIAlter_singleLine.show( {info = Language:get("uy139"), showSecond = 1 } )
        end
    end)
end

return PlayerInfoReputationAdd




--endregion
