--region NewFile_1.lua
--Author    : YuDing
--Date      : 2014/11/29
--Introduce : 技能

local PlayerInfoSkill = class("PlayerInfoSkill", function() 
        local lay = ccui.Layout:create() 
        lay:setContentSize(UI_VSIZE)
        return lay
    end)

-- ui组
PlayerInfoSkill.uiChild = {}

PlayerInfoSkill.isInitSkillItem = nil

-- item大小
PlayerInfoSkill.itemSize = cc.size(619, 129)  


local itemView = require("src.app.uiScript.scenes.playerInfo.PlayerInfoSkillItem")


function PlayerInfoSkill:ctor(d) 
    mapping(self, LuaEventDispatcher)
    local handler = self.registerScriptHandler
    if handler then
        self:registerScriptHandler(
            function(eventType)
               if CocosEvent.ENTER == eventType then
                    self:onEnter()
               elseif CocosEvent.EXIT == eventType then
                    self:onExit()
               elseif eventType == CocosEvent.CLEAN_UP then
				    self:cleanUp()
               else
               
               end
               
               self:luaDispatchEvent(eventType)
            end
         )    
    end

    self.delegete = d

    self:loadJson()
    self:loadUI()
    self:initSkillItem()    -- 初始化skillItem
    self:delayAddItem()
    self:registerEvent()    -- 注册事件
    self:updateMedalDes()  -- 更新勋章数目

end 

function PlayerInfoSkill:onEnter()
end



function PlayerInfoSkill:onExit()
end
--- 清除
function PlayerInfoSkill:cleanUp()
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. PlayerInstance:getMedalPropID(), self, self.updateMedalDes)
end

--- 加载ui
function PlayerInfoSkill:loadUI()
    local c = self.uiChild
    local w = self.widget

    c.btnReset = Cocos2dxUtils:getChildByName(w, "btnReset")      -- 重置按钮
    c.labelReset = Cocos2dxUtils:getChildByName(w, "labelReset")   -- 重置文本
    c.btnBuy = Cocos2dxUtils:getChildByName(w, "btnBuy")          -- 购买按钮
    c.labelBuy = Cocos2dxUtils:getChildByName(w, "labelBuy")       -- 购买文本
    c.medalDes = Cocos2dxUtils:getChildByName(w, "medalDes")      -- 勋章描述

    self:initScroll()
    self:initFixedUI()
end

function PlayerInfoSkill:initFixedUI()
    local c = self.uiChild

    local tb = {} 
    for k, v in pairs(self.uiChild) do 
        if v:getDescription() == "Label" then 
            table.insert(tb, v)
        end
    end

    Cocos2dxUtils:setTextFont(tb)

    
    c.labelReset:setString(Language:get("uy35"))
    c.labelBuy:setString(Language:get("uy36"))

end

-- 更新勋章描述
function PlayerInfoSkill:updateMedalDes()
    local num = PlayerInstance:getSkillPoint()
    local str = Language:get("uy34", num)
    self.uiChild.medalDes:setString(str)
end

function PlayerInfoSkill:initScroll()
    if not self.scroll then 
        self.scroll = ccui.ScrollView:create()
        self:addChild(self.scroll)
        self.scroll:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL)
        self.scroll:setClippingEnabled(true)
        self.scroll:setBounceEnabled(true)
        self.scroll:setTouchEnabled(true)

        -- scroll 232 的高度 left top toscreen 232

--        self.scroll:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
--		self.scroll:setBackGroundColor(cc.c3b(0xff,0,0))
--		self.scroll:setBackGroundColorOpacity(100)

        REL:relOther(self.scroll, self, 0, 0, 175, 145)       -- 上边180 下边200 相对于自身
    end
end


-- 检查技能是否能重置
--@return tb[1] 技能是否升过级
--@return tb[2] 钻石是否足够
function PlayerInfoSkill:checkPlayerSkillReset()
    local skill = PlayerInstance:getPlayerSkill()
    local tb = {}
	local m = 0
	local n = PlayerInstance:getPlayerSkillNum()
	for i = 1, n do
        if skill[i] then  -- 如果存在
		    m = m + skill[i].level
        end
	end

    if m == 0 then     -- 没有技能升过级
        tb[1] = false
    else 
	    tb[1] = true 
    end

    local d = PlayerInstance:getDiamond()
    local need = PlayerInstance:getSkillResetDiamondNum()
    if need > d then 
        tb[2] = false 
    else 
        tb[2] = true
    end

    return tb
end

-- 注册事件
function PlayerInfoSkill:registerEvent()
    local c = self.uiChild

    local func = function(t, eventType)
          if ccui.TouchEventType.ended ~= eventType then return end
          if c.btnReset == t then 
            self:onEventResetClick()
          elseif c.btnBuy == t then 
            self:onEventBuyClick()
          end
    end
    
    BaseButton:extend(c.btnReset)
    BaseButton:extend(c.btnBuy)

    c.btnReset:addTouchEventListener(func)
    c.btnBuy:addTouchEventListener(func)

    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. PlayerInstance:getMedalPropID(), self, self.updateMedalDes)
end

-- 技能重置被点击
function PlayerInfoSkill:onEventResetClick()
    local tb = self:checkPlayerSkillReset()
    if tb[1] == false then 
        MUIAlter_singleLine.show( {info = Language:get("fy1004"),showSecond = 1 } )
        return 
    end
        
    MUIAlter.show({
		    info = Language:get("fy1007",PlayerInstance:getSkillResetDiamondNum()),
		    size = 30,
            flag = 3,
            callback = 
            function(f)
                if 0 == f then -- 确定按钮
                    if tb[2] == false then 
                        MUIPop.MUIToReCharge()
                        return 
                    end

                     SkillResetCommand.new():exec(
                        function(state) 
                             if state == ReturnCode.SUCCESS then    -- success
                                MUIAlter_singleLine.show( {info = Language:get("fy1005"),showSecond = 1 } ) -- 成功
                             else 
                                MUIAlter_singleLine.show({
									info=ErrorCode:getErrInfo(state)
								},WindowManager:getCurrentWindow())
                             end
                        end)
                end
            end
	    }) 

end

--  打开商城
function PlayerInfoSkill:onEventBuyClick()
    if ActivityManager.timeLimitBuyInfo:getOpenValue() == true or ActivityManager.timeLimitBuyInfo2:getOpenValue() == true then
        WindowManager:push(
		    require("src.app.uiScript.components.prop.PropWindow").new(2,true)
	    )
    else
        WindowManager:push(
		    require("src.app.uiScript.components.prop.PropWindow").new(2)
	    )
    end

end

function PlayerInfoSkill:setDelegete(d)
    self.delegete = d
end

--[[

]]

-- 添加内容到scroll
function PlayerInfoSkill:addItemToScroll(scroll, tb)
    local height = 0
    local distance = 5 -- 两个组件之间的距离 5 个像素
    local allDistance = 0
    if #tb == 0 then return end
    --scroll:getInnerContainer():removeAllChildren()
   
    for i = 1, #tb do  
        local sz = tb[i]:getContentSize()
        height = height + sz.height
    end

    if #tb > 1 then -- 加上距离
        allDistance = distance * (#tb - 1)
        height = allDistance + height
    end

    local inner = scroll:getInnerContainer()
    local s = scroll:getContentSize()
    if height >= s.height then
        inner:setContentSize(cc.size(s.width, height))    -- 下一次进入这个函数 需要重置scroll的高度
    else
        inner:setContentSize(cc.size(s.width, s.height))
    end
    local s = inner:getContentSize()
    -- 依次放入 inner中
    local n = #tb
    for i = 1, n do  
        local sz = tb[i]:getContentSize()
        if i > 1 then 
            s.height = s.height - sz.height - distance
        else
            s.height = s.height - sz.height
        end
        inner:addChild(tb[i])
        tb[i]:setPosition(cc.p(8, s.height))
    end
    scroll:jumpToTop()   -- scroll到顶部
end

--- 初始化skill条目
function PlayerInfoSkill:initSkillItem()
    self.itemTmpTb = {} -- item临时的表

    local iSize = self.itemSize -- 框的宽度

    for i = 1, 12 do 
        local c = ccui.Layout:create()
        c:setContentSize(iSize)
        table.insert(self.itemTmpTb, c)
    end

    self:addItemToScroll(self.scroll, self.itemTmpTb)
end

--- 延迟加上item
function PlayerInfoSkill:delayAddItem()
    local itemAddEff = function(item)
		item:setOpacity(0)
		item:runAction(
			cc.FadeIn:create(0.5)
		)
	end

    local len = #self.itemTmpTb

    local i = 1
	self:runAction(
		cc.RepeatForever:create(
			cc.Sequence:create(
				cc.DelayTime:create(0.1),
				cc.CallFunc:create(function()
					if i <= len then
						local vItem = itemView.new()       -- 创建item
						vItem:initView(i, self.delegete)
                        self.itemTmpTb[i]:addChild(vItem)   -- 对应的容器加上item
                        REL:toOther("left", "bottom", vItem, self.itemTmpTb[i], 0, 0) -- 在容器的原点上

                        local tb = vItem:getEffRender()
                        for k, v in pairs(tb) do 
                            itemAddEff(v)
                        end
						
					else
						self:stopAllActions()  -- 结束所有的动作
					end
					
					i=i+1
				end)
			)
		)
	)
end

--- 加载json
function PlayerInfoSkill:loadJson()
    local widget = ccs.GUIReader:getInstance():widgetFromJsonFile(UIJsonMgr.playerInfoSkill)
    self.widget = widget
    self:addChild(widget)

    CCUIREL:toOther("left", "bottom", widget, self, 0, 0)

end



return PlayerInfoSkill


--endregion
