-- 荣誉layout

local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor()
	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

    self:setContentSize(cc.size(640,330))

    self:init()
    self:refreshMilitaryName()
    self:refreshHonor()
    self:refreshRevenge()
    self:refreshSeniorDLevel()


end


function T:onEnter()
    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_MILITARYRANK_REFRESH,self,self.refreshMilitaryName)
    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_HONOR_REFRESH,self,self.refreshHonor)
    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_REVENGE_REFRESH,self,self.refreshRevenge)
    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_SENIORDLEVEL_REFRESH,self,self.refreshSeniorDLevel)

end

function T:onExit()
    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_MILITARYRANK_REFRESH,self,self.refreshMilitaryName)
    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_HONOR_REFRESH,self,self.refreshHonor)
    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_REVENGE_REFRESH,self,self.refreshRevenge)
    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_SENIORDLEVEL_REFRESH,self,self.refreshSeniorDLevel)

end

--- 初始化
function T:init()
    local honorBack = ccui.ImageView:create()
    honorBack:loadTexture("honorBack.png",ccui.TextureResType.plistType)
    self:addChild(honorBack)
    REL:toOther("center","middle",honorBack,self,0,0)
    self.honorBack = honorBack


    -- 军衔图片
    local iconPath = IconManager.iconPath

    local militaryImg = ccui.ImageView:create()
    militaryImg:loadTexture(iconPath .. MilitaryRank_temp[1].icon)
    --militaryImg:setScale(0.6)
    self:addChild(militaryImg)
    REL:toOther("center","middle",militaryImg,honorBack,-50,128)
    self.militaryImg = militaryImg

    -- 军衔名字
    local militaryName = XMLLabel()
    militaryName:setVAlign("middle")
    militaryName:setContentSize(cc.size(300,36))
    self:addChild(militaryName)
    REL:toOther("left","middle",militaryName,militaryImg,120,0)
    self.militaryName = militaryName

    -- 荣誉
    local honorBottomBack = ccui.ImageView:create()
    honorBottomBack:loadTexture("honorBottom.png",ccui.TextureResType.plistType)
    self:addChild(honorBottomBack)
    REL:toOther("left","top",honorBottomBack,honorBack,25,75)
    self.honorBottomBack = honorBottomBack

    local honorName = XMLLabel()
    honorName:setVAlign("middle")
    honorName:setContentSize(cc.size(300,36))
    self:addChild(honorName)
    REL:toOther("left","middle",honorName,honorBottomBack,20,0)
    self.honorName = honorName
    honorName:setString(Language:get("uc985"))

    local honorValue = XMLLabel()
    honorValue:setAlign("center","middle")
    honorValue:setContentSize(cc.size(300,36))
    self:addChild(honorValue)
    REL:toOther("center","middle",honorValue,honorBottomBack,35,0)
    self.honorValue = honorValue


    -- 复仇
    local revengeBack = ccui.ImageView:create()
    revengeBack:loadTexture("honorBottom.png",ccui.TextureResType.plistType)
    self:addChild(revengeBack)
    REL:toOther("right","top",revengeBack,honorBack,25,75)
    self.revengeBack = revengeBack

    local revengeName = XMLLabel()
    revengeName:setVAlign("middle")
    revengeName:setContentSize(cc.size(300,36))
    self:addChild(revengeName)
    REL:toOther("left","middle",revengeName,revengeBack,15,0)
    self.revengeName = revengeName
    revengeName:setString(Language:get("uc987"))


    local revengeValue = XMLLabel()
    revengeValue:setAlign("center","middle")
    revengeValue:setContentSize(cc.size(300,36))
    self:addChild(revengeValue)
    REL:toOther("center","middle",revengeValue,revengeBack,35,0)
    self.revengeValue = revengeValue

    -- 指挥相关
    local honorHighCommand = ccui.ImageView:create()
    honorHighCommand:loadTexture("honorHighCommand.png",ccui.TextureResType.plistType)
    self:addChild(honorHighCommand)
    REL:toOther("left","top",honorHighCommand,honorBack,25,120)
    self.honorHighCommand = honorHighCommand


    local propIcon = ccui.ImageView:create()
    propIcon:loadTexture(iconPath .. Prop_temp[208].propIcon)
    self:addChild(propIcon)
    REL:toOther("left","middle",propIcon,honorHighCommand,0,0)
    self.propIcon = propIcon

    local seniorDLevel = XMLLabel()
    seniorDLevel:setVAlign("middle")
    seniorDLevel:setContentSize(cc.size(300,36))
    self:addChild(seniorDLevel)
    REL:toOther("left","middle",seniorDLevel,propIcon,120,20)
    self.seniorDLevel = seniorDLevel
    

    local hasSoliders = XMLLabel()
    hasSoliders:setVAlign("middle")
    hasSoliders:setContentSize(cc.size(300,36))
    self:addChild(hasSoliders)
    REL:toOther("left","middle",hasSoliders,propIcon,120,-20)
    self.hasSoliders = hasSoliders

    -- 升级指挥按钮
    local upgradeCommandbtn = Button.new("false","false")
	upgradeCommandbtn:setButtonState("playerInfoUpgrade.png","iconButton_general_down.png")
	self:addChild(upgradeCommandbtn)
	REL:toOther("right","bottom",upgradeCommandbtn,honorHighCommand,-20,-5)
    upgradeCommandbtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local layout = require("src.app.uiScript.components.share.SDlevelPopWindow").new()
            local muialter = MUIAlter_custom.show({
		        info = layout
	        })
        end
    end)

    if HonorManager:getSeniorDLevel() >= 60 then -- 指挥按钮不显示
        upgradeCommandbtn:setVisible(false)
    else
        upgradeCommandbtn:setVisible(true)
    end


    -- 商城按钮
    local honorShopbtn = Button.new("false","false")
	honorShopbtn:setButtonState("honorShop.png","honorShop.png")
	self:addChild(honorShopbtn)
	REL:toOther("left","bottom",honorShopbtn,honorBack,50,0)
    honorShopbtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local  function finish(data)
                local layout = require("src.app.uiScript.scenes.playerInfo.honor.HonorShopWindow").new(data)
                WindowManager:push(layout)
            end

            Command:getHonorGoodsInfo(finish)
        end
    end)


    -- 排行榜按钮
    local honorRankbtn = Button.new("false","false")
	honorRankbtn:setButtonState("honorRank.png","honorRank.png")
	self:addChild(honorRankbtn)
	REL:toOther("left","bottom",honorRankbtn,honorBack,150,0)
    honorRankbtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local function finish()
		        WindowManager:push(
			        require("src.app.uiScript.components.rank.RankWindow").new(3)
		        )
	        end
	        Command:SendRank(1,1,finish)

        end
    end)

    -- 军衔列表
    local militaryBtn = Button.new("false","true")
	militaryBtn:setButtonState("button_green_normal.png","button_general_down.png")
    militaryBtn:setString(Language:get("uc989"))
	self:addChild(militaryBtn)
	REL:toOther("right","bottom",militaryBtn,honorBack,30,0)
    militaryBtn:setTextShadow()
    militaryBtn:addTouchEventListener(function(sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            local layout = require("src.app.uiScript.scenes.playerInfo.honor.MilitaryRankWindow").new()
            WindowManager:push(layout)


        end
    end)


end

function T:refreshMilitaryName()
    self.militaryName:setString(Language:get("uc984",Language:get(HonorManager:getMilitaryRankName(HonorManager:getMilitaryRank()))))
    if HonorManager:getMilitaryRank() == 0 then -- 无军衔
        self.militaryName:setHAlign("center")
        self.militaryName:setVAlign("top")
        REL:toOther("center","top",self.militaryName,self.honorBack,0,18)
        self.militaryImg:setVisible(false)

    else
        self.militaryName:setHAlign("left")
        self.militaryName:setVAlign("middle")
        self.militaryImg:loadTexture(IconManager.iconPath .. MilitaryRank_temp[HonorManager:getMilitaryRank()].icon)
        REL:toOther("left","middle",self.militaryName,self.militaryImg,HonorManager:getShowMilitaryOffset(HonorManager:getMilitaryRank()),0)

        self.militaryImg:setVisible(true)

    end

end


function T:refreshHonor()
    self.honorValue:setString(HonorManager:getHonor())

end

function T:refreshRevenge()
    self.revengeValue:setString(HonorManager:getRevenge())

end

function T:refreshSeniorDLevel()
    self.seniorDLevel:setString(Language:get("uc986",HonorManager:getSeniorDLevel()))
    self.hasSoliders:setString(Language:get("uc988",SeniorDLevel_temp[HonorManager:getSeniorDLevel()].addSoldiers))


end


return T
