-- 荣誉商店项

local T = class("T",function() return ccui.Layout:create() end)

--- 构造函数
function T:ctor(data)
    self.data = data

	self:registerScriptHandler(
		function(eventType)
			if eventType == CocosEvent.ENTER then
				self:onEnter()
			elseif eventType == CocosEvent.EXIT then
				self:onExit()
			elseif eventType == CocosEvent.CLEAN_UP then
			end
		end
	)

    self:init()
    self:refreshAllData()
    self:show()

end


function T:onEnter()
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. 208,self,self.refreshBtnState)

end

function T:onExit()
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. 208,self,self.refreshBtnState)

end

--- 初始化
function T:init()
   	local f=ResLoader:getSpriteFrame("famBack_big.png")
	local fs=f:getOriginalSize()

	self:setContentSize(fs)

	--背景图片
	local uiBack=cc.Sprite:createWithSpriteFrame(f)
	self:addChild(uiBack)
	REL:toOther("center","middle",uiBack,self,0,0)
	self.uiBack=uiBack

	--物品图标
	local uiIcon=ccui.ImageView:create()
	self:addChild(uiIcon)
	self.uiIcon=uiIcon

	--标题
	local uiTitle=XMLLabel()
	uiTitle:setContentSize(cc.size(500,36))
	uiTitle:setAlign("left","middle")
	self:addChild(uiTitle)
	REL:toOther("left","top",uiTitle,self,110,2)
	self.uiTitle=uiTitle

	--描述
	local uiDes=XMLLabel()
	uiDes:setContentSize(cc.size(340,36))
	uiDes:setAlign("left","middle")
	self:addChild(uiDes)
	REL:toOther("left","top",uiDes,self,130,80)
	self.uiDes=uiDes

	--兑换需要的荣誉勋章
	local uiNeed=XMLLabel()
	uiNeed:setContentSize(cc.size(200,36))
	uiNeed:setAlign("center","middle")
	self:addChild(uiNeed)
	REL:toOther("center","top",uiNeed,self,230,16)
	self.uiNeed=uiNeed

    --兑换需要的复仇值
	local uiRevenge=XMLLabel()
	uiRevenge:setContentSize(cc.size(200,36))
	uiRevenge:setAlign("center","middle")
	self:addChild(uiRevenge)
	REL:toOther("center","top",uiRevenge,self,230,46)
	self.uiRevenge=uiRevenge


	--"兑换"按钮
	local uiExchangeButton=BaseButton:createButton(Language:get("ug1341"),"button_blue_normal.png","button_general_down.png")
	self:addChild(uiExchangeButton)
	REL:toOther("right","middle",uiExchangeButton,self,20,-40)
	self.uiExchangeButton=uiExchangeButton

	uiExchangeButton:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
            -- 判断道具是否足够
            local num = PropsInfoMgr:getPlayerPropByID(208)
            if self.data.medalNum <= num then -- 可以兑换
            else
                local descripe = Language:get("uc1006")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                return
            end

            local revenge = HonorManager:getRevenge()
            local costRevenge = self.data.revengeNum

            if costRevenge <= revenge then -- 可以兑换
            else
                local descripe = Language:get("uc1038")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                return
            end

            local function finish()
                local descripe = Language:get("uc1005")
		        MUIAlter_singleLine.show( {info = descripe,showSecond = 1 } )
                self:refreshAllData()
            end
            Command:exchangeHonorGoods(self.data,finish)


		end
	end)

end


--- 显示
function T:show()
    local data = self.data
    self.uiNeed:setString(Language:get("uc1004",data.medalNum))
    if data.revengeNum > 0 then
        self.uiRevenge:setString(Language:get("uc1039",data.revengeNum))
        self.uiRevenge:setVisible(true)
    else
        self.uiRevenge:setVisible(false)
    end
    
    

    local icon = nil
    local name = nil
    local des = nil

    icon = Prop_temp[data.sid].propIcon
    name = Prop_temp[data.sid].prop
    des = PlayerInstance:getPropDescripe2(Prop_temp[data.sid].propSid)

    if icon then
        self.uiIcon:loadTexture(IconManager.iconPath .. icon,ccui.TextureResType.localType)
	    REL:toOther("left","top",self.uiIcon,self,4,21)
    end

    if name then
        self.uiTitle:setString(Language:get("ug936_1",Language:get(name),data.num))
    end

    if des then
        self.uiDes:setString(des)
    end

end


--- 刷新所有数据
function T:refreshAllData()
    self:refreshBtnState()
end

--- 刷新按钮的状态,如果没有达到荣誉的指挥等级就加遮罩,次数限制先不写，数据结构得到了的
function T:refreshBtnState()
    local dlLevel = HonorManager:getSeniorDLevel()
    local data = self.data
    if data.limitLevel > dlLevel then -- 未解锁
        if not self.uiMask then
            --锁定遮罩
	        local uiMask=ccui.Layout:create()
	        uiMask:setTouchEnabled(true)
	        uiMask:retain()
	        self:addChild(uiMask)
	        REL:relOther(uiMask,self, 0, 0, 0, 0)
	        uiMask:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid )
	        uiMask:setBackGroundColor(cc.c3b(0,0,0))
	        uiMask:setBackGroundColorOpacity(140)
	        self.uiMask=uiMask

	        --锁定后的提示文本的背景
	        local uiLockedTipBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("lockedBack.png"))
	        uiMask:addChild(uiLockedTipBack)
	        --	uiLockedTipBack:setIsGray(true)
	        REL:toOther("center","middle",uiLockedTipBack,uiMask,0,0)

	        --锁定后的提示文本
	        local uiLockedTip=XMLLabel()
	        uiLockedTip:setContentSize(cc.size(500,36))
	        uiLockedTip:setAlign("center","middle")
	        uiMask:addChild(uiLockedTip)
	        REL:toOther("center","middle",uiLockedTip,uiLockedTipBack,0,-34)
	        uiMask.uiLockedTip=uiLockedTip
            uiLockedTip:setString(Language:get("uc1003",data.limitLevel))

        end

        self.uiExchangeButton:setIsGray(true)
    else
        if self.uiMask then
            self.uiMask:removeFromParent()
            self.uiMask = nil
        end


        -- 判断道具是否足够
        local num = PropsInfoMgr:getPlayerPropByID(208)
        if data.medalNum <= num then -- 可以兑换
            self.uiExchangeButton:setIsGray(false)
        else
            self.uiExchangeButton:setIsGray(true)
        end

    end
 
end



return T
