--[[
 *	帮助窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(1)
        o.super = AbstractWindow
        return o
    end
)

--- 构造函数
function T:ctor(gList)
    self.gList = gList

    self.data1 = {}  -- 4个数据
    self.data2 = {}  -- 4个数据
    self.data3 = {}  -- 4个数据
    self.data4 = {}  -- 4个数据

    for k,v in pairs(gList) do
        if v then
            if v.showType == 0 then
                self.data1[#self.data1 + 1] = v
            elseif v.showType == 1 then
                self.data2[#self.data2 + 1] = v
            elseif v.showType == 2 then
                self.data3[#self.data3 + 1] = v
            else
                self.data4[#self.data4 + 1] = v
            end

        end

    end





    self:setWindowTitle(Language:get("uc994"))
    
    self:init()
    self:updateBaseInfo()

    self:setDownState(self.btn2)
    self:setNormalState(self.btn1)
    self:setNormalState(self.btn3)
    self:setNormalState(self.btn4)

    self:_setButton()
    self:page2()


    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end


function T:onEnter()
    self.super.onEnter(self)
    PropsInfoMgr:luaAddEventListener(PlayerInstance.noticeMessage.prop .. 208,self,self.updateBaseInfo)

    HonorManager:luaAddEventListener(HonorManager.EVT_TYPE_REVENGE_REFRESH,self,self.updateBaseInfo)

end

function T:onExit()
    self.super.onExit(self)
    PropsInfoMgr:luaRemoveEventListener(PlayerInstance.noticeMessage.prop .. 208,self,self.updateBaseInfo)

    HonorManager:luaRemoveEventListener(HonorManager.EVT_TYPE_REVENGE_REFRESH,self,self.updateBaseInfo)

end

function T:init()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    --背景
	local uiContributionBack=cc.Sprite:createWithSpriteFrame(ResLoader:getSpriteFrame("captionBack.png"))
	self:addChild(uiContributionBack)
	REL:toOther("center","top",uiContributionBack,self.uiContainer,0,8)

    -- 标签按钮：配件
    local btn2 = Button.new("false","true")
    btn2:setName("point")
    btn2:loadTextures("panelSwitchButton_down.png","panelSwitchButton_normal.png","",ccui.TextureResType.plistType)
    self:addChild(btn2)
    REL:toOther("left", "top", btn2, viewBack,0,90)
    self.btn2 = btn2
    btn2.buttonText:setHAlign("center")
    btn2.buttonText:setVAlign("middle")
    REL:toOther("center", "middle", btn2.buttonText, btn2,0,0)
    btn2:setString(Language:get("uc1008"))


    -- 标签按钮：道具
    local btn1 = Button.new("false","true")
    btn1:loadTextures("panelSwitchButton_down.png","panelSwitchButton_normal.png","",ccui.TextureResType.plistType)
    self:addChild(btn1)
    REL:toOther("left", "top", btn1, viewBack,0 + 160,90)
    self.btn1 = btn1
    btn1.buttonText:setHAlign("center")
    btn1.buttonText:setVAlign("middle")
    REL:toOther("center", "middle", btn1.buttonText, btn1,0,0)
    btn1:setString(Language:get("uc1007"))

    -- 标签按钮：部队
    local btn3 = Button.new("false","true")
    btn3:setName("achieve")
    btn3:loadTextures("panelSwitchButton_down.png","panelSwitchButton_normal.png","",ccui.TextureResType.plistType)
    self:addChild(btn3)
    REL:toOther("left", "top", btn3, viewBack,0 + 160 * 2,90)
    self.btn3 = btn3
    btn3.buttonText:setHAlign("center")
    btn3.buttonText:setVAlign("middle")
    REL:toOther("center", "middle", btn3.buttonText, btn3,0,0)
    btn3:setString(Language:get("uc1009"))
    btn3:setVisible(false)

    -- 标签按钮：英雄
    local btn4 = Button.new("false","true")
    btn4:setName("achieve")
    btn4:loadTextures("panelSwitchButton_down.png","panelSwitchButton_normal.png","",ccui.TextureResType.plistType)
    self:addChild(btn4)
    REL:toOther("left", "top", btn4, viewBack,0 + 160 * 3,90)
    self.btn4 = btn4
    btn4.buttonText:setHAlign("center")
    btn4.buttonText:setVAlign("middle")
    REL:toOther("center", "middle", btn4.buttonText, btn4,0,0)
    btn4:setString(Language:get("uc1010"))
    btn4:setVisible(false)


	--勋章数目
	local uiContribution=XMLLabel()
	uiContribution:setContentSize(cc.size(400,36))
	uiContribution:setAlign("center","middle")
	self:addChild(uiContribution)
	REL:relOther(uiContribution,uiContributionBack,0,0,0,0)
	self.uiContribution=uiContribution





end

--- 更新勋章数量
function T:updateBaseInfo()
	self.uiContribution:setString(Language:get("uc1002",PropsInfoMgr:getPlayerPropByID(208),HonorManager:getRevenge()))

end

function T:_setButton()
    local function callback(sender, eventType)
        if eventType == ccui.TouchEventType.ended then 
            if sender == self.btn1 then
                self:setDownState(self.btn1)
                self:setNormalState(self.btn2)
                self:setNormalState(self.btn3)
                self:setNormalState(self.btn4)
                self:page1()
            elseif sender == self.btn2 then 
                self:setNormalState(self.btn1)
                self:setDownState(self.btn2)
                self:setNormalState(self.btn3)
                self:setNormalState(self.btn4)
                self:page2()
            elseif sender == self.btn3 then 
                self:setNormalState(self.btn1)
                self:setNormalState(self.btn2)
                self:setDownState(self.btn3)
                self:setNormalState(self.btn4)
                self:page3()
            else
                self:setNormalState(self.btn1)
                self:setNormalState(self.btn2)
                self:setNormalState(self.btn3)
                self:setDownState(self.btn4)
                self:page4()
            end
        end
    end
    self.btn1:addTouchEventListener(callback)
    self.btn2:addTouchEventListener(callback)
    self.btn3:addTouchEventListener(callback)
    self.btn4:addTouchEventListener(callback)

end


--- 设置为正常状态
function T:setNormalState(btn)
    if btn then
        btn:loadTextureNormal("panelSwitchButton_down.png",ccui.TextureResType.plistType)
        btn:setTouchEnabled(true)
    end
end


--- 设置为按下状态
function T:setDownState(btn)
    if btn then
        btn:loadTextureNormal("panelSwitchButton_normal.png",ccui.TextureResType.plistType)
        btn:setTouchEnabled(false)
    end
end


function T:page1()
    if self.pageView1 == nil then
        self.pageView1 = require("src.app.uiScript.scenes.playerInfo.honor.HonorShopListview").new(self.data1)
        self:addChild(self.pageView1)
        REL:relOther(self.pageView1,self.viewBack,0,0,160,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.pageView1:init()
    end

    if self.pageView1 then
        self.pageView1:setVisible(true)
    end

    if self.pageView2 then
        self.pageView2:setVisible(false)
    end

    if self.pageView3 then
        self.pageView3:setVisible(false)
    end


    if self.pageView4 then
        self.pageView4:setVisible(false)
    end


end

function T:page2()
    if self.pageView2 == nil then
        self.pageView2 = require("src.app.uiScript.scenes.playerInfo.honor.HonorShopListview").new(self.data2)
        self:addChild(self.pageView2)
        REL:relOther(self.pageView2,self.viewBack,0,0,160,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.pageView2:init()
    end

    if self.pageView1 then
        self.pageView1:setVisible(false)
    end

    if self.pageView2 then
        self.pageView2:setVisible(true)
    end

    if self.pageView3 then
        self.pageView3:setVisible(false)
    end


    if self.pageView4 then
        self.pageView4:setVisible(false)
    end


end


function T:page3()
    if self.pageView3 == nil then
        self.pageView3 = require("src.app.uiScript.scenes.playerInfo.honor.HonorShopListview").new(self.data3)
        self:addChild(self.pageView3)
        REL:relOther(self.pageView3,self.viewBack,0,0,160,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.pageView3:init()
    end

    if self.pageView1 then
        self.pageView1:setVisible(false)
    end

    if self.pageView2 then
        self.pageView2:setVisible(false)
    end

    if self.pageView3 then
        self.pageView3:setVisible(true)
    end


    if self.pageView4 then
        self.pageView4:setVisible(false)
    end


end

function T:page4()
    if self.pageView4 == nil then
        self.pageView4 = require("src.app.uiScript.scenes.playerInfo.honor.HonorShopListview").new(self.data4)
        self:addChild(self.pageView4)
        REL:relOther(self.pageView4,self.viewBack,0,0,160,CommonCfg.BOTTOM_CONTAINER_HEIGTH)
        self.pageView4:init()
    end

    if self.pageView1 then
        self.pageView1:setVisible(false)
    end

    if self.pageView2 then
        self.pageView2:setVisible(false)
    end

    if self.pageView3 then
        self.pageView3:setVisible(false)
    end


    if self.pageView4 then
        self.pageView4:setVisible(true)
    end


end

return T