--[[
 *	帮助窗口
]]
local T = class(
    "T",
    function() 
        local o = AbstractWindow.new(2)
        o.super = AbstractWindow
        return o
    end
)

--- 构造函数
function T:ctor()

    self:setWindowTitle(Language:get("uc993"))
    
    self:init()

    self.index = 0
    self:refreshData()

    -- 调用一次，透明度才没问题
	self:initCompleteHandler()
end


function T:onEnter()
    self.super.onEnter(self)
end

function T:onExit()
    self.super.onExit(self)
end

function T:init()
    -- 背景图片
   	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
    REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

    local pageView = ccui.PageView:create()
    pageView:setTouchEnabled(true)
    pageView:setCustomScrollThreshold(60)
    self:addChild(pageView)
    REL:relOther(pageView,viewBack,0,0,0,0)
    self.pageView = pageView

    local layout1 = require("src.app.uiScript.scenes.playerInfo.honor.MilitaryRankFirstPage").new()
    layout1:setContentSize(pageView:getContentSize())
    layout1:init()
    pageView:addPage(layout1)

    local layout2 = require("src.app.uiScript.scenes.playerInfo.honor.MilitaryRankSecondPage").new()
    layout2:setContentSize(pageView:getContentSize())
    layout2:init()
    pageView:addPage(layout2)



    local function pageViewEvent(sender, eventType)
        if eventType == ccui.PageViewEventType.turning then
            local index =  pageView:getCurPageIndex()
            self.index = index
            self:refreshData()
        end
    end 

    pageView:addEventListener(pageViewEvent)


    local leftBtn = Button.new("false","false")
	leftBtn:setButtonState("arrowLeft.png","arrowLeft.png")
    self:addChild(leftBtn)
    REL:toOther("left","middle",leftBtn,viewBack,0,0)
    leftBtn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.index == 1 then
                self.index = self.index - 1
            end

            self:refreshData()
        end
    end)
    self.leftBtn = leftBtn

    local rightBtn = Button.new("false","false")
	rightBtn:setButtonState("arrowRight.png","arrowRight.png")
    self:addChild(rightBtn)
    REL:toOther("right","middle",rightBtn,viewBack,0,0)
    rightBtn:addTouchEventListener(function (sender, eventType)
        if eventType == ccui.TouchEventType.ended then
            if self.index == 0 then
                self.index = self.index + 1
            end

            self:refreshData()
        end
    end)
    self.rightBtn = rightBtn
end

function T:refreshData()
    self.pageView:scrollToPage(self.index)

    if self.index == 0 then
        self.leftBtn:setVisible(false)
        self.rightBtn:setVisible(true)

    else
        self.leftBtn:setVisible(true)
        self.rightBtn:setVisible(false)

    end

end



return T