---侦查详情窗口
local T = class("ScoutMainWindow", function()
	return AbstractWindow.new(1)
end)

--- 这一项的数据
T.scoutInfo = scoutInfo

function T:ctor(scoutInfo)
	self.scoutInfo = scoutInfo

	self:init()

	-- 调用一次，透明度才没问题
	self:initCompleteHandler()
end

function T:init()
	self:setWindowTitle(Language:get("uc296"))

	-- 背景图片
	local f = ResLoader:getSpriteFrame("viewBack.png")
	local s = f:getOriginalSize()
	local viewBack = Scale9Sprite:createWithFrame(f,cc.rect(s.width/2,s.height-1,1,1))
	self:addChild(viewBack)
	REL:relOther(viewBack,self.uiContainer,0,0,0,0)
	self.viewBack = viewBack

	-- 滚动层
	local listView = ListView.new()
	self:addChild(listView)
	REL:relOther(listView,viewBack,2,2,10,80)
	self.listView = listView

	-- 目标信息
	self.listView:pushBackCustomItem(self:addTargetInfo())
	-- 资源信息
	self.listView:pushBackCustomItem(self:addResourceInfo())
	-- 兵力信息
	self.listView:pushBackCustomItem(self:addTroopInfo())

	-- 底部按钮，攻击，删除
	--- 攻击
	local reAttack = Button.new("true","false")
	reAttack:setName("reAttack")
	reAttack:setButtonState("button_yellow_normal.png","button_general_down.png")
	reAttack:setButtonPic("playIcon.png")
	self:addChild(reAttack)
	REL:toOther("center","bottom",reAttack,self,-100,-10)
	REL:toOther("center","middle",reAttack.buttonPic,reAttack,0,15)

	reAttack:addTouchEventListener(function (sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local state = ArmyTaskQueueManager:judgeIsAttackInWorld(self.scoutInfo.data)
			if state == true then
				local armyWindow = require("src.app.uiScript.components.army.ArmyWindow").new({ ["tag"] = 3, ["detailInfo"] = self.scoutInfo.data })
				WindowManager:switch(armyWindow)
			end
		end
	end)


	-- 删除邮件
	local btnDeleteMail = Button.new("true","false")
	btnDeleteMail:setName("btnDeleteMail")
	btnDeleteMail:setButtonState("button_red_normal.png","button_general_down.png")
	self:addChild(btnDeleteMail)
    btnDeleteMail:setButtonPic("delete.png")
	REL:toOther("center","bottom",btnDeleteMail,self,100,-10)
    REL:toOther("center","middle",btnDeleteMail.buttonPic,btnDeleteMail,0,15)

	btnDeleteMail:addTouchEventListener(function (sender, eventType)
		if eventType == ccui.TouchEventType.ended then
			local info = Language:get("uc87")
			local function confirm()
				MailManager:deleteOneMailByIndexAndId(2,self.scoutInfo.id)
				WindowManager:pop()
			end
			MUIPop.MUIImmediate(info,confirm)
		end
	end)

end

function T:addTargetInfo()
	local layout = ccui.Layout:create()
	layout:setContentSize(cc.size(626,150 + 30))

	local scoutInfo = self.scoutInfo

	-- 图片
	local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
	local titleBackFrameSize = titleBackFrame:getOriginalSize()
	local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
	titleBack:setContentSize(626,43)
	layout:addChild(titleBack)
	REL:toOther("center","top",titleBack,layout,1,5)

	-- 标题文本
	local titleLabel = XMLLabel()
	titleLabel:setContentSize(cc.size(200,36))
	titleLabel:setHAlign("center")
	titleLabel:setVAlign("middle")
	layout:addChild(titleLabel)
	REL:toOther("center","middle",titleLabel,titleBack,0,0)
	titleLabel:setString(Language:get("uc294"))

	-- 侦查地点
	local scoutPlace = XMLLabel()
	scoutPlace:setContentSize(cc.size(500,36))
	layout:addChild(scoutPlace)
	REL:toOther("left","top",scoutPlace,titleBack,20,50)
	scoutPlace:setString(Language:get("uc295",scoutInfo.targetName2,scoutInfo.x,scoutInfo.y))

	-- 侦查时间
	local scoutTime = XMLLabel()
	scoutTime:setContentSize(cc.size(500,36))
	layout:addChild(scoutTime)
	REL:toOther("left","top",scoutTime,titleBack,20,80)

	local temp = os.date("*t",self.scoutInfo.time) -- 这会生成一个表
	scoutTime:setString(Language:get("uc297",UnitConversion.date(temp.month),UnitConversion.date(temp.day),UnitConversion.date(temp.hour),UnitConversion.date(temp.min)))

	-- 侦查资源点逻辑
	--侦察类型常量 SCOUT_1=1侦察资源点,SCOUT_2=2侦察玩家城市,SCOUT_3=3侦察有人驻扎的资源点
	local scoutType = scoutInfo.scoutType
	if scoutType == 1 then
		local scout = XMLLabel()
		scout:setContentSize(cc.size(500,36))
		layout:addChild(scout)
		REL:toOther("left","top",scout,titleBack,20,110)
		scout:setString(Language:get("uc298"))
	elseif scoutType == 2 then -- 如果侦查的是玩家，暂时不管

	else
		local scout = XMLLabel()
		scout:setContentSize(cc.size(500,36))
		layout:addChild(scout)
		REL:toOther("left","top",scout,titleBack,20,110)
		scout:setString(Language:get("uc299",scoutInfo.garrisonName))
	end

    -- 战力
    local fight = XMLLabel()
	fight:setContentSize(cc.size(500,36))
	layout:addChild(fight)
	REL:toOther("left","top",fight,titleBack,20,140)
	fight:setString(Language:get("uy193",UnitConversion.unitTrans(scoutInfo.fightValue)))


	return layout
end

function T:addResourceInfo()
	local layout = ccui.Layout:create()
	local scoutInfo = self.scoutInfo
	if scoutInfo.scoutType == 1 or scoutInfo.scoutType == 3 then
		layout:setContentSize(cc.size(626,150))
	else
		local robResources = scoutInfo.robResources
		if robResources then
			layout:setContentSize(cc.size(626,400))
		else
			layout:setContentSize(cc.size(626,50))
		end

	end

	-- 图片
	local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
	local titleBackFrameSize = titleBackFrame:getOriginalSize()
	local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
	titleBack:setContentSize(626,43)
	layout:addChild(titleBack)
	REL:toOther("center","top",titleBack,layout,1,5)

	-- 标题文本
	local titleLabel = XMLLabel()
	titleLabel:setContentSize(cc.size(200,36))
	titleLabel:setHAlign("center")
	titleLabel:setVAlign("middle")
	layout:addChild(titleLabel)
	REL:toOther("center","middle",titleLabel,titleBack,0,0)
	titleLabel:setString(Language:get("uc300"))

	local scoutType = scoutInfo.scoutType
	if scoutType == 1 or scoutType == 3 then
		local describe = XMLLabel()
		describe:setContentSize(cc.size(600,36))
		layout:addChild(describe)
		REL:toOther("left","top",describe,titleBack,20,50)
		local name = Language:get(Resource_temp[scoutInfo.resourceType].name)
		describe:setString(Language:get("uc301",name,scoutInfo.resourceEfficiency))
	else
		local robResources = scoutInfo.robResources
		if robResources then
			for i = 1,5,1 do
				local icon = ccui.ImageView:create()
				local iconPath = IconManager.iconPath
				icon:loadTexture(iconPath .. Resource_temp[i].iconUrl)
				icon:setScale(IconManager.resScale[1],IconManager.resScale[2])
				layout:addChild(icon)
				REL:toOther("left","top",icon,titleBack,20,50 + (i - 1)*70)


				local describe = XMLLabel()
				describe:setContentSize(cc.size(550,36))
				layout:addChild(describe)
				REL:toOther("left","middle",describe,icon,70,0)
				local name = Language:get(Resource_temp[i].name)
				describe:setString(Language:get("uc302",name,UnitConversion.unitTrans(math.abs(robResources[i]))))

			end
		end

	end


	return layout
end

function T:addTroopInfo()
	local layout = ccui.Layout:create()
	layout:setContentSize(cc.size(626,700))

	local scoutInfo = self.scoutInfo

	-- 图片
	local titleBackFrame = ResLoader:getSpriteFrame("taskTagBack.png")
	local titleBackFrameSize = titleBackFrame:getOriginalSize()
	local titleBack = Scale9Sprite:createWithFrame(titleBackFrame,cc.rect(titleBackFrameSize.width/2,titleBackFrameSize.height/2,1,1))
	titleBack:setContentSize(626,43)
	layout:addChild(titleBack)
	REL:toOther("center","top",titleBack,layout,1,5)

	-- 标题文本
	local titleLabel = XMLLabel()
	titleLabel:setContentSize(cc.size(200,36))
	titleLabel:setHAlign("center")
	titleLabel:setVAlign("middle")
	layout:addChild(titleLabel)
	REL:toOther("center","middle",titleLabel,titleBack,0,0)
	titleLabel:setString(Language:get("uc303"))

	-- 添加具体的战机
	--local pos = { {50,120},{350,120},{50,320},{350,320},{50,520},{350,520} } -- left,top,
	local pos = { {350,120},{350,320},{350,520},{50,120},{50,320},{50,520} } -- left,top,

	local aircraftList = scoutInfo.defendAircrafts
	if aircraftList then
		for i = 1,6,1 do
			-- 背景图片
			local backImg=Scale9Sprite:createWithFrame(ResLoader:getSpriteFrame("battleItemBottom.png"),"h3")
			backImg:setContentSize(cc.size(208,94))
			layout:addChild(backImg)
			REL:toOther("left","top",backImg,layout,pos[i][1],pos[i][2])

			local data=aircraftList[i]
			if data and data.sid > 0 then
				local dt=Aircraft_temp[data.sid]
			
				local T=GameUtils:getAicraftModelUrl(Camp.CAMP2,data.sid)
				if T then
					local o=T()
					layout:addChild(o)
					REL:toOther("center","middle",o,backImg,0,40)
				end

				-- 飞机名字
				local airName = XMLLabel()
				airName:setHAlign("center")
				airName:setVAlign("middle")
				airName:setContentSize(cc.size(300,36))
				layout:addChild(airName)
				REL:toOther("center", "top", airName, backImg, 0, 98)
				airName:setString(Language:get("uc222",AircraftUtils:getRichName(dt),aircraftList[i].count))
			end
		end
	end

	return layout

end

return T
