local T = { }

--- 获取通用按钮
function T:getGeneralButton(htmlText,type,iconUrl,iconTextureResType)
	if type == 2 then
		return T:createButton(htmlText,"bigButton_yellow_normal.png","bigButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 3 then
		return T:createButton(htmlText,"bigButton_purple_normal.png","bigButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 4 then
		return T:createButton(htmlText,"bigButton_gray_normal.png","bigButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 5 then
		return T:createButton(htmlText,"button_blue_normal.png","button_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 6 then
		return T:createButton(htmlText,"button_green_normal.png","button_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 7 then
		return T:createButton(htmlText,"button_yellow_normal.png","button_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 8 then
		return T:createButton(htmlText,"button_purple_normal.png","button_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 9 then
		return T:createButton(htmlText,"button_gray_normal.png","button_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 10 then
		return T:createButton(htmlText,"longButton_green_normal.png","longButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 11 then
		return T:createButton(htmlText,"longButton_yellow_normal.png","longButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 12 then
		return T:createButton(htmlText,"longButton_purple_normal.png","longButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 13 then
		return T:createButton(htmlText,"longButton_red_normal.png","longButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 14 then
		return T:createButton(htmlText,"longButton_blue_normal.png","longButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	elseif type == 15 then
		return T:createButton(htmlText,"longButton_gray_normal.png","longButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	else
		return T:createButton(htmlText,"bigButton_green_normal.png","bigButton_general_down.png",ccui.TextureResType.plistType,iconUrl,iconTextureResType)
	end
end

function T:createButton(text,normalStatusUrl,downStatusUrl,textureResType,iconUrl,iconTextureResType)
	textureResType=textureResType or ccui.TextureResType.plistType

	local uiBtn=ccui.ImageView:create(normalStatusUrl,textureResType)
	uiBtn.__nImgUrl__=normalStatusUrl
	uiBtn.__dImgUrl__=downStatusUrl
	uiBtn.__resType__=textureResType

	local uiIcon
	if iconUrl then
		iconTextureResType=iconTextureResType or ccui.TextureResType.plistType

		uiIcon=ccui.ImageView:create(iconUrl,iconTextureResType)
		uiBtn:addChild(uiIcon)
		uiBtn.uiIcon=uiIcon

		REL:toOther("left","middle",uiIcon,uiBtn,10,0)
	end

	local uiText
	if text and string.trim(text) ~= "" then
		uiText=XMLLabel()

		uiText:setAlign("center","middle")
		uiText:setString(text)
		uiBtn:addChild(uiText)
		uiBtn.uiText=uiText

		if normalStatusUrl == "button_blue_normal.png"
			or
			normalStatusUrl == "button_green_normal.png"
			or
			normalStatusUrl == "button_yellow_normal.png"
			or
			normalStatusUrl == "button_purple_normal.png"
			or
			normalStatusUrl == "button_gray_normal.png"
		then
			if CssStyles then
				uiText:setCssStyle(CssStyles.buttonText)
			end
			REL:relOther(uiText,uiBtn,2,2,2,30)
		else
			if CssStyles then
				uiText:setCssStyle(CssStyles.buttonText)
			end

			REL:relOther(uiText,uiBtn,2,2,2,2)
		end
	end

    if downStatusUrl == "longButton_general_down.png" then -- 这个是弹窗加的长按钮
        REL:toOther("center","middle",uiText,uiBtn,0,15)
    end


	return T:extend(uiBtn)
end

-- 创建按钮(将ui组件转换为按钮)
-- @param ui
function T:extend(ui)
	mapping(ui, LuaEventDispatcher)

	ui:setTouchEnabled(true)
	local uiText = Cocos2dxUtils:getChildByName(ui, "uiText") or ui.uiText
	if uiText and uiText.setTouchEnabled then
		uiText:setTouchEnabled(false)
	end

	local uiIcon = Cocos2dxUtils:getChildByName(ui, "uiIcon") or ui.uiIcon
	if uiIcon and uiIcon.setTouchEnabled then
		uiIcon:setTouchEnabled(false)
	end

	--- 长点击检查的计时器ID
	--	ui.longClickChectSId = nil
	--- 长按间隔触发计时器ID
	--	ui.longDownTriggerSId = nil

	--- 清理长点击和长按间隔触发的计时器ID
	local function clearLongSid(t)
		if t.longClickChectSId then
			Cocos2dxUtils:clearScheduler(t.longClickChectSId)
			t.longClickChectSId = nil
		end
		if t.longDownTriggerSId then
			Cocos2dxUtils:clearScheduler(t.longDownTriggerSId)
			t.longDownTriggerSId = nil
		end
	end

	local beganEffect,endedEffect
	ui:registerScriptHandler(function(eventType)
		if eventType == CocosEvent.ENTER then
			if ui.onEnter then
				ui:onEnter()
			end
		elseif eventType == CocosEvent.EXIT then
			endedEffect(ui)
		
			clearLongSid(ui)
			if ui.onExit then
				ui:onExit()
			end
		elseif eventType == CocosEvent.CLEAN_UP then
			if ui.cleanUp then
				ui:cleanUp()
			end
		end
	end)

	beganEffect=function(t)
		if t.__dImgUrl__ then
			t:loadTexture(ui.__dImgUrl__,t.__resType__)
		else
			t:setColor(cc.c3b(100, 200, 255))
			local uiBack = Cocos2dxUtils:getChildByName(t, "uiBack") or ui.uiBack
			if uiBack then
				uiBack:setColor(cc.c3b(100, 200, 255))
			end
			
			local uiText = Cocos2dxUtils:getChildByName(t, "uiText") or ui.uiText
			if uiText then
				uiText:setColor(cc.c3b(100, 200, 255))
			end

			local uiIcon = Cocos2dxUtils:getChildByName(t, "uiIcon") or ui.uiIcon
			if uiIcon then
				uiIcon:setColor(cc.c3b(100, 200, 255))
			end
		end
	end

	endedEffect=function(t)
		if t.__dImgUrl__ then
			t:loadTexture(ui.__nImgUrl__,t.__resType__)
		else
			t:setColor(cc.c3b(255, 255, 255))
			local uiBack = Cocos2dxUtils:getChildByName(t, "uiBack") or ui.uiBack
			if uiBack then
				uiBack:setColor(cc.c3b(255, 255, 255))
			end
			
			local uiText = Cocos2dxUtils:getChildByName(t, "uiText") or ui.uiText
			if uiText then
				uiText:setColor(cc.c3b(255, 255, 255))
			end

			local uiIcon = Cocos2dxUtils:getChildByName(t, "uiIcon") or ui.uiIcon
			if uiIcon then
				uiIcon:setColor(cc.c3b(255, 255, 255))
			end
		end
	end

	ui._addTouchEventListener = ui.addTouchEventListener
	function ui:addTouchEventListener(callback)
		ui:luaAddEventListener("__touch_trigger", nil, callback)
	end

	ui.__state__="normal"
	ui:_addTouchEventListener(
		function(t, e)
			if e == ccui.TouchEventType.began then
				t.__state__="down"

				local snd=t.touchBeganSound or SoundRes.SOUND_COMMON_BUTTON
				if snd == "none" then
				else
					AudioManager:playEffect(snd)
				end

				beganEffect(t)

				--计时器判定长按
				t.longClickChectSId = Cocos2dxUtils:timeOut( function()
					t.longClickChectSId = nil

					--长按时,间隔触发按下事件
					t.longDownTriggerSId = Cocos2dxUtils:interval( function()
						if not pcall(function()
							t:luaDispatchEvent("__touch_trigger", t, "longDownTrigger")
						end) then
							endedEffect(t)
							clearLongSid(t)
						end
					end , 0.2)
				end , 0.5)

				t:luaDispatchEvent("__touch_trigger", t, e)
			elseif e == ccui.TouchEventType.ended then
				t.__state__="normal"

				if t.touchEndedSound then
					AudioManager:playEffect(t.touchEndedSound)
				end
				endedEffect(t)
				clearLongSid(t)

				t:luaDispatchEvent("__touch_trigger", t, e)
			elseif e == ccui.TouchEventType.moved then
				if t:isHighlighted() then

				else
					endedEffect(t)
					clearLongSid(t)
				end

				t:luaDispatchEvent("__touch_trigger", t, e)
			elseif e == ccui.TouchEventType.cancel then
				t:luaDispatchEvent("__touch_trigger", t, e)
				endedEffect(t)
				clearLongSid(t)
			end
		end
	)

	function ui:setText(text)
		local uiText = Cocos2dxUtils:getChildByName(self, "uiText") or self.uiText
		if uiText then
			if uiText.setText then
				uiText:setText(text)
			else
				uiText:setString(text)
			end
		end
	end
	function ui:getText()
		local uiText = Cocos2dxUtils:getChildByName(self, "uiText") or self.uiText
		if uiText then
			return uiText:getString()
		end
		return nil
	end
	ui.setString=ui.setText
	ui.getString=ui.getText

	function ui:setTextures(normalStatusUrl,downStatusUrl,textureResType)
		self.__nImgUrl__=normalStatusUrl
		self.__dImgUrl__=downStatusUrl
		self.__resType__=textureResType or ccui.TextureResType.plistType

		if self.__state__ and self.__state__ == "down" then
			beganEffect(self)
		else
			endedEffect(self)
		end

	end

	return ui
end

return T
