--- 此相对定位器,只实用于CCUI下的组件,且只能由子对象相对于父对象
local T={}

function T:toOther(horizontal,vertical ,target,other,offsetX, offsetY)
	if not target then
		local errStr="the target is null".."\n"

		__print__("RELErr",errStr)
		LogRecorder:push(errStr,LOG_LEVEL_ERROR,"RELErr")
		print("the target is null")
	end

	if not other then
		local errStr="the other is null".."\n"

		__print__("RELErr",errStr)
		LogRecorder:push(errStr,LOG_LEVEL_ERROR,"RELErr")
		print("the target is null")
	end

	local otherSize=other:getContentSize()

	self:toRect(horizontal,vertical,target,cc.rect(0,0,otherSize.width,otherSize.height),offsetX,offsetY)
end

function T:toRect(horizontal,vertical ,target,rect,offsetX,offsetY)
	if not target then
		local errStr="the target is null".."\n"

		__print__("RELErr",errStr)
		LogRecorder:push(errStr,LOG_LEVEL_ERROR,"RELErr")
		print("the target is null")
	end

	local x=rect.x
	local y=rect.y
	local w=rect.width
	local h=rect.height
	
	local size
	if target.getContentSize then
		size=target:getContentSize()
	else
		local cs=target:getContentSize()
		size={width=cs.width*target:getScaleX(),height=cs.height*target:getScaleY()}
	end
	local realSize=size
	local anchor=target:getAnchorPoint()

	local nX,nY=nil,nil
	if horizontal == "left" then--相对于屏幕左边距
		nX=x+offsetX+(realSize.width*anchor.x)
	elseif horizontal == "center" then--相对屏幕的水平中间点
		nX=x+(w-realSize.width)/2+offsetX+(realSize.width*anchor.x)
	elseif horizontal == "right" then--相对于屏幕右边距
		nX=x+w-offsetX-(realSize.width*(1-anchor.x))
	end

	if vertical == "top" then
		nY=y+h-offsetY-(realSize.height*(1-anchor.y))
	elseif vertical == "middle" then
		nY=y+(h-realSize.height)/2+offsetY+(realSize.height*anchor.y)
	elseif vertical == "bottom" then
		nY=y+offsetY+(realSize.height*anchor.y)
	end

	if nX ~= nil and nY == nil then
		target:setPositionX(nX)
	elseif nX == nil and nY ~= nil then
		target:setPositionY(nY)
	elseif nX ~= nil and nY ~= nil then
		target:setPosition(nX,nY)
	end
end

return T
