--- 关于游戏的一些工具方法
local T={}

--- 阵营转换
-- @param self
-- @param camp 需要转换的阵营
-- @param leftCamp 左方阵营的标识
-- @return 转换后的阵营
function T:campConvert(camp,leftCamp)
	if camp == leftCamp then
		return Camp.CAMP1
	else
		return Camp.CAMP2
	end
end

--- 将上次登陆的时间转换为字符串
-- @param lastLoginSec 上次登陆的时间(秒)
function T:lastLoginSec2String(lastLoginSec)
	local cSec=TimeUtils:getSyncMillis()/1000

	local lDate=os.date("*t",lastLoginSec)
	local cDate=os.date("*t",cSec)

	--判断是否是在1年前>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	local dYear=cDate.year - lDate.year
	if dYear > 1 then
		return Language:get("ug760",1)
	end

	local cMonth,lMonth,dMonth=cDate.month, lDate.month,0
	if dYear == 1 then
		dMonth=12 - lMonth + cMonth
		if dMonth >= 12 then
			return Language:get("ug760",1)
		end
	else
		dMonth=cMonth - lMonth
	end
	--判断是否是在1年前<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

	--判断在n月前>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	local dDay=cDate.day, lDate.day
	if dMonth > 1 then
		if dDay > 0 then
			return Language:get("ug761",dMonth)
		else
			return Language:get("ug761",dMonth - 1)
		end
	end
	
	if dMonth == 1 then
		if dDay > 0 then
			return Language:get("ug761",1)
		end
	end
	--判断在n月前<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	local dSec,secOfHour=cSec - lastLoginSec, 60 * 60
	if dSec <= secOfHour then
		return Language:get("ug763",1)
	end
	
	local dHour=math.ceil(dSec / secOfHour)
	if dHour <= 24 then
		return Language:get("ug763",dHour)
	end
	
	return Language:get("ug762",math.floor(dHour / 24))
end

--- 获取攻击特效url
function T:getAttackUrl(name)
	return "src.app.uiScript.components.fight.attackEffects."..name
end

--- 获取战机模型URL
function T:getAicraftModelUrl(camp,sid)
	local dt=Aircraft_temp[sid]
	if not dt then
		return nil
	end

	local url_temp="src.app.uiScript.components.fight.aircraftModels.{modelName}_camp{camp}"
	return require(
		url_temp:gsub("{modelName}",dt.modelName):gsub("{camp}",camp)
	)
end

--- 时区纠正时的偏移
T.timeZoneOffset=0

--- 设置时区偏移
function T:setTimeZoneOffset(offset)
	self.timeZoneOffset=offset
end

--- 修正时区偏移
function T:modifyTimeZone(sec)
	return sec+self.timeZoneOffset
end
--- 反修正时区偏移(即,TimeUtils:getSyncMillis() 获取的时间返回到服务器的时间,因为 TimeUtils:getSyncMillis() 获取的是做了时区偏移的时间)
function T:unmodifyTimeZone(sec)
	return sec-self.timeZoneOffset
end

return T
