--- 对象转为字符串
-- @param obj 对象
local obj2str=function(obj)
	local lua = ""
	local t = type(obj)
	if t == "number" then
		lua = lua .. obj
	elseif t == "boolean" then
		lua = lua .. tostring(obj)
	elseif t == "string" then
		lua = lua .. string.format("%q", obj)
	elseif t == "table" then
		lua = lua .. "{\n"
		for k, v in pairs(obj) do
			if type(k)=="function" or type(v)=="function" then
			else
				lua = lua .. "[" .. obj2str(k) .. "]=" .. obj2str(v) .. ",\n"
			end
		end
		local metatable = getmetatable(obj)
		if metatable ~= nil and type(metatable.__index) == "table" then
			for k, v in pairs(metatable.__index) do
				if type(k)=="function" or type(v)=="function" then
				else
					lua = lua .. "[" .. obj2str(k) .. "]=" .. obj2str(v) .. ",\n"
				end
			end
		end
		lua = lua .. "}"
	elseif t == "nil" then
		return nil
	else
		error("can not obj2str a " .. t .. " type.")
	end
	return lua
end
rawset(_G,"obj2str",obj2str)

--- 字符串转为对象
-- @param lua lua字符串
local str2obj=function(lua)
	local t = type(lua)
	if t == "nil" or lua == "" then
		return nil
	elseif t == "number" or t == "string" or t == "boolean" then
		lua = tostring(lua)
	else
		error("can not str2obj a " .. t .. " type.")
	end
	lua = "return " .. lua
	local func = loadstring(lua)
	if func == nil then
		return nil
	end
	return func()
end
rawset(_G,"str2obj",str2obj)