--[[
 *	虚拟键盘工具箱
]]
IMETools = {}
--控制参数
local status
--蒙版曾
local mask
local m_height
local m_target
--虚拟键盘显示
--@param target：调用对象
function IMETools.show(target,height)
	if not status then
		m_height = height or 0
		m_target = target
		status = true
		local runscene = cc.Director:getInstance():getRunningScene()
		mask = ccui.Layout:create()
		mask:setLocalZOrder(99999)
		mask:setTouchEnabled(true)
		mask:setContentSize(cc.size(UI_VSIZE.w,UI_VSIZE.h))
		mask:addTouchEventListener(function(t,e) 
			if e == ccui.TouchEventType.ended then
				IMETools.hide()
			end
		end)
		runscene:addChild(mask)
		if m_height > 0 then
			runscene:runAction(cc.MoveTo:create(0.3,cc.p(0,m_height)))
		end
	end
end

-- 显示调用father的函数
function IMETools.showWithAppointFather(target, father)
    if not status then
        m_height = 0
        m_target = target
        status = true
        --mask = ccui.Layout:create()
        mask = cc.Node:create()
		mask:setLocalZOrder(99999)

		mask:setContentSize(cc.size(UI_VSIZE.w,UI_VSIZE.h))
--		mask:addTouchEventListener(function(t,e) 
--			if e == ccui.TouchEventType.ended then
--				IMETools.hide()
--			end
--		end)

		father:addChild(mask)
   
        local onTouchBegan = function(touch, event)
            return true
        end

        local onTouchEnded = function(touch,event)
            IMETools.hide()
        end

        local listener = cc.EventListenerTouchOneByOne:create()
        listener:setSwallowTouches(true)
        listener:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN)
        listener:registerScriptHandler(onTouchEnded, cc.Handler.EVENT_TOUCH_ENDED)
        
        local eventDispatcher = mask:getEventDispatcher()
        eventDispatcher:addEventListenerWithSceneGraphPriority(listener, mask)

    end
end

--- 拦截全屏幕触摸的输入框
function IMETools.showFullScreenEdit(callBack)
    local runscene = cc.Director:getInstance():getRunningScene()
	mask = ccui.Layout:create()
	mask:setLocalZOrder(TOP_ORDER + 100)
	mask:setTouchEnabled(true)
	mask:setContentSize(cc.size(UI_VSIZE.width, UI_VSIZE.height))
    mask:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	mask:setBackGroundColor(cc.c3b(0,0,0))
	mask:setBackGroundColorOpacity(100)

	runscene:addChild(mask)

    local cursor = nil   -- 光标

    local updateCursur = function(t)
        t:stopAllActions()

        if cursor == nil then
            cursor = IMETools:getCursor(22)
            t:addChild(cursor)
        end

        local refreshCursor = function ()
            local size = t:getContentSize()
            if size.width > 0 then 
                cursor:setPosition(cc.p(size.width, 0))
            else
                cursor:setPosition(cc.p(size.width, -11))
            end
        end

        t:runAction(cc.CallFunc:create(function() 
	    		refreshCursor()
	    	end))
    end

    local function inputhandler(t, e) 			--输入文本监听
		if e == TEXTFIELD_EVENT_ATTACH_WITH_IME then
            print("打开输入法")
            updateCursur(t) -- 光标
		elseif e == TEXTFIELD_EVENT_INSERT_TEXT then
            updateCursur(t) -- 光标
		elseif e == TEXTFIELD_EVENT_DELETE_BACKWARD then
		elseif e == TEXTFIELD_EVENT_DETACH_WITH_IME then
            print("关闭输入法")
           
			return
        else 
            -- self:closeCursur() -- 关闭
		end		
	end

	local ed = ccui.TextField:create()
--    ed:setMaxLengthEnabled(true)
    ed:setAnchorPoint(cc.p(0, 0.5))
    ed:setMaxLength(40)
    ed:setTouchEnabled(true)
    ed:setFontSize(30)
    ed:setPlaceHolder("")
    ed:setPosition(cc.p(20, UI_VSIZE.height / 2))
    ed:addEventListenerTextField(inputhandler)    -- 更新光标
    ed:attachWithIME()

    updateCursur(ed)  -- 打开光标

    mask:addChild(ed)   -- 添加到mask中
    mask:addTouchEventListener(function(t,e)
		if e == ccui.TouchEventType.ended then
			callBack(ed:getStringValue())
            t:removeFromParent()
		end
	end)        --消息


end

function IMETools.hide()
	if status then
		status = false
		if mask then 
			mask:removeFromParent(true) 
			mask = nil
		end
		if m_target then m_target:didNotSelectSelf() end
		if m_height > 0 then
			cc.Director:getInstance():getRunningScene():runAction(cc.MoveTo:create(0.3,cc.p(0,0)))
		end
	end
end
--获取一个闪动光标
--@param size 字号
function IMETools:getCursor(size)
	local cursor = ccui.Layout:create()
	cursor:setContentSize(cc.size(3,size))
    cursor:setAnchorPoint(cc.p(0, 0))
	cursor:setBackGroundColorType(LAYOUT_COLOR_SOLID)
	cursor:setBackGroundColor(cc.c3b(0xff,0xff,0xff))
	cursor:runAction(cc.Blink:create(3600,9000))
	return cursor
end

