local strFind=string.find

--- 语言包
local Language = { }

Language.datas = { }

--- 初始化
function Language:init(...)
	self.datas = { }
    self:addLang(...)
end

function Language:addLang(...)
	local datas = self.datas

	for k, v in pairs({...}) do
		if type(v) == "string" then
			datas[k] = v
		else
			for k, v in pairs(v) do
				if type(v) == "string" then
					datas[k] = v
				else
					self:addLang(v)
				end
			end
		end
	end
end

--- 是否已初始化
function Language:isInited()
	return self.datas ~= nil;
end

--- 获取文本
-- @param self
-- @param id 文本编号
-- @param ... 参数列表,会自动依次替换文本中以 #+数字（从1开始递增） 的关键字
function Language:get(id, ...)
	if not id then return "" end

	local datas = self.datas

	local txt = datas[id]
	if txt then
		if ... then
			local args = { ...}

			return (string.gsub(txt,"#%d+",function(t)
				local ns=string.gsub(t,"%p","")
				local n=tonumber(ns)

				return args[n]
			end))
		end
		return txt
	else
		print("<Class Language>,id:< " .. id .. " >is wrong number,can not get info!")
		return "??"
	end
	return ""
end

return Language
