--- 循环/遍历相关工具方法
local T={}

--- 从原点(0,0)点进行扩散
-- @param floor 扩散的层数
-- @param everyOneCallback 每一项的回调:接受两个参数:offsetX,offsetY;返回值为true即表示扩散完成
function T.diffusion(floor,everyOneCallback)
		--基于原点进行扩展搜索
	--原理如下:
	-- -2,-2	-1,-2	0,-2	1,-2	2,-2
	-- -2,-1	-1,-1	0,-1	1,-1	2,-1
	-- -2,0		-1,0	0,0		1,0		2,0
	-- -2,1		-1,1	0,1		1,1		2,1
	-- -2,2		-1,2	0,2		1,2		2,2
	-- 1.由内而外进行扩展: for i=1,3,1 do 基中,i表示当前扩展的层数
	-- 2.遍历每一层,第一层:-1,-1->0,-1 => 1,-1->1,0 => 1,1->0,1 => -1,1->-1,0
	for i=1,floor,1 do
		for j=-i,i-1,1 do
			if everyOneCallback(j,-i) then
				return
			end

--			print(j,-i)
		end

		for j=-i,i-1,1 do
			if everyOneCallback(i,j) then
				return
			end

--			print(i,j)
		end

		for j=i,-i+1,-1 do
			if everyOneCallback(j,i) then
				return
			end

--			print(j,i)
		end

		for j=i,-i+1,-1 do
			if everyOneCallback(-i,j) then
				return
			end

--			print(-i,j)
		end
	end
end

return T
