local T=Class.T()

function T:def()
	--- 对象字典
	self.dic={}
end

--- 压入对象
-- @param self
-- @param name 对象名
-- @param obj 对象
function T:push(name,obj)
	local q=self.dic[name]
	if not q then
		q=Stack()
		self.dic[name]=q
	end

	q:push(obj)
end

--- 弹出对象,如果对象池中没有对象了,则返回为 nil
-- @param self
-- @param name 对象名
-- @return 对象
function T:pop(name)
	local q=self.dic[name]
	if q then
		return q:pop()
	end
	return nil
end

--- 清除对象
-- @param self
-- @param name 对象名
function T:clear(name)
	self.dic[name]=nil
end

--- 清除对象池中所有对象
-- @param self
function T:clearAll()
	self.dic={}
end

return T
