--- 日志级别-信息
LOG_LEVEL_INFO=0

--- 日志级别-调试
LOG_LEVEL_DEBUG=1

--- 日志级别-警告
LOG_LEVEL_WARNING=2

--- 日志级别-错误
LOG_LEVEL_ERROR=3

--- 日志级别-致命错误
LOG_LEVEL_FATAL=4

--- 当前ID
local id=0

--- 获取一个新的ID
local function getId()
	id=id+1
	return id
end

--- 日志项
local LogItem=Class.LogItem()

function LogItem:def()
	--- 编号
	-- self.id=nil

	--- 时间
	self.timeMillisec=0

	--- 信息
	-- self.message=nil

	--- 级别
	-- self.level=nil

	--- 分类
	-- self.category=nil
end

function LogItem:ctor(message,timeMillisec,level,category)
	timeMillisec=timeMillisec or 0
	level=level or LOG_LEVEL_INFO
	category=category or "normal"

	self.id=getId()
	self.timeMillisec=timeMillisec
	self.message=message
	self.level=level
	self.category=category
end

--- 日志记录器
local T=Class.LogRecorder(Queue,LuaEventDispatcher2)

function T:def()
	Queue.def(self)
	LuaEventDispatcher2.def(self)

	--- 是否启用
	self._isEnabled=false
end

function T:push(message,level,category)
	if self._isEnabled then
		if message then
			local item=LogItem(message,TimeUtils:getSyncMillis()/1000,level,category)
			Queue.push(self,item)

			self:luaDispatchEvent("push",item)
		end
	end
end

function T:pop()
	if self._isEnabled then
		local item=Queue.pop(self)
		if item then
			self:luaDispatchEvent("pop",item)
		end

		return item
	end
	return nil
end

function T:setIsEnabled(value)
	if value ~= self._isEnabled then
		self._isEnabled=value

		self:luaDispatchEvent("change_is_enabled")
	end
end

function T:getIsEnabled()
	return self._isEnabled
end


return T
