local T=Class.RecycleList(
	function() return ccui.ScrollView:create() end,
	LuaEventDispatcher2
)

function T:def()
	LuaEventDispatcher2.def(self)

	--- 对象池栈
	self.POOL_STACK = Stack()

	--- 条目对象模板
	-- self.uiItemTemplate=nil

	--- 条目对象池
	-- self.itemsContainer=nil

	--- 文本项列表
	self.itemsList = { }

	--- 文本项显示滚动容器的内部容器的当前Y坐标(用于判断是向上滚动还是向下滚动)
	-- self.curtxtItemsInnerCY=nil

	--- 数据列表
	-- self.dataList=nil

	--- 显示开始项索引
	self.showSIndex=0

	--- 显示结束项索引
	self.showEIndex=0

	--- 条目之间间隔
	self._itemMargin=4
end

function T:ctor()
	LuaEventDispatcher2.ctor(self)

	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)
end

--- 进入
function T:onEnter()

end

--- 退出
function T:onExit()
	local s=self.POOL_STACK
	while not s:isEmpty() do
		local item=s:pop()
	end
end

--- 内存清理
function T:cleanUp()

end

function T:init()
	local ic = self:getInnerContainer()
	self.curtxtItemsInnerCY = ic:getPositionY()

	local itemsContainer = ccui.Layout:create()
	self:addChild(itemsContainer)
	REL:toOther("center", "top", itemsContainer, self, 0, 0)
	self.itemsContainer = itemsContainer

	self:addEventListener( function(t,e)
		if e ~= ccui.ScrollviewEventType.scrolling then
			return
		end

		local wP = t:convertToWorldSpace(cc.p(0, t:getPositionY()))
		local b, t = wP.y, wP.y + t:getContentSize().height

		local y = ic:getPositionY()
		if y > self.curtxtItemsInnerCY then
			-- 向上移动
			self:toUpCalac(t, b)
		elseif y < self.curtxtItemsInnerCY then
			-- 向下移动
			self:toDnCalac(t, b)
		end
		self.curtxtItemsInnerCY = ic:getPositionY()
	end )
end

--- 向上移动,计算需要显示的项和移除的项
-- @param worldTLimit 上边
-- @param worldBLimit 下边
-- @param buffLimit 缓冲值
function T:toUpCalac(worldTLimit, worldBLimit, buffLimit)
	buffLimit=buffLimit or 300

	local t = worldTLimit + buffLimit
	local b = worldBLimit - buffLimit

	local items = self.itemsList

	local isUpdate=false
	-- 计算顶部元素是否应该被移除
	while true do
		local item = items[1]
		if not item then
			break
		end

		local wP = item:convertToWorldSpace({x=0,y=0})

		if wP.y <= t then
			break
		end

		self:_removeItem_t()
		isUpdate=true
	end

	-- 计算底部是否应该添加元素
	while true do
		local item = items[#items]
		if not item then
			break
		end

		local wP = item:convertToWorldSpace({x=0, y=item:getContentSize().height})

		if wP.y < b then
			break
		end

		if not self:_appendItem_b() then
			break
		end
		isUpdate=true
	end

	if isUpdate then
		self:calcHeight()
	end
end

--- 向下移动,计算需要显示的项和移除的项
-- @param worldTLimit 上边
-- @param worldBLimit 下边
-- @param buffLimit 缓冲值
function T:toDnCalac(worldTLimit, worldBLimit, buffLimit)
	buffLimit=buffLimit or 300

	local t = worldTLimit + buffLimit
	local b = worldBLimit - buffLimit

	local items = self.itemsList

	local isUpdate=false
	-- 计算底部元素是否应该被移除
	while true do
		local item = items[#items]
		if not item then
			break
		end

		local wP = item:convertToWorldSpace({x=0, y=item:getContentSize().height})

		if wP.y > b then
			break
		end

		self:_removeItem_b()
		isUpdate=true
	end

	-- 计算顶部是否应该添加元素
	while true do
		local item = items[1]
		if not item then
			break
		end

		local wP = item:convertToWorldSpace({x=0, y=0})

		if wP.y > t then
			break
		end

		if not self:_appendItem_t() then
			break
		end
		isUpdate=true
	end

	if isUpdate then
		self:calcHeight()
	end
end

--- 移除一个显示项,从顶部
function T:_removeItem_t()
	self.showSIndex = self.showSIndex + 1

	local items = self.itemsList
	local fItem=items[1]
	table.remove(items, 1)
	fItem:setVisible(false)

	self.POOL_STACK:push(fItem)
end

--- 移除一个显示项,从底部
function T:_removeItem_b()
	self.showEIndex = self.showEIndex - 1

	local items = self.itemsList
	local lItem=items[#items]
	table.remove(items)
	lItem:setVisible(false)

	self.POOL_STACK:push(lItem)
end

--- 添加一个显示项,从顶部
function T:_appendItem_t()
	local dl=self.dataList
	if dl and self.showSIndex > 1 then
		self.showSIndex = self.showSIndex - 1

		local uiItem=self.POOL_STACK:pop()
		if not uiItem then
			uiItem=self.uiItemTemplate(self)
			self.itemsContainer:addChild(uiItem)
		end

		uiItem:setData(dl[self.showSIndex])
		uiItem:setVisible(true)

		local items = self.itemsList
		local dnItem = items[1]
		if dnItem then
			REL:toOther("center", nil, uiItem, self, 0, 0)
			uiItem:setPositionY(dnItem:getPositionY() + dnItem:getContentSize().height + self._itemMargin)
		else
			REL:toOther("center", "top", uiItem, self, 0, 0)
		end

		table.insert(items,1,uiItem)

		return true
	end
	return false
end

--- 添加一个显示项,从底部
function T:_appendItem_b()
	local dl=self.dataList
	if dl and self.showEIndex < #dl then
		self.showEIndex = self.showEIndex + 1

		local uiItem=self.POOL_STACK:pop()
		if not uiItem then
			uiItem=self.uiItemTemplate(self)
			self.itemsContainer:addChild(uiItem)
			uiItem:retain()
		end

		uiItem:setData(dl[self.showEIndex])
		uiItem:setVisible(true)

		local items = self.itemsList
		local upItem = items[#items]
		if upItem then
			REL:toOther("center", nil, uiItem, self, 0, 0)
			uiItem:setPositionY(upItem:getPositionY() - uiItem:getContentSize().height - self._itemMargin)
		else
			REL:toOther("center", "top", uiItem, self, 0, 0)
		end

		table.insert(items, uiItem)

		return true
	end
	return false
end

--- 计算真实高度(应该只扩张,不收缩)
function T:calcHeight()
	local items = self.itemsList
	if #items <= 0 then
		return
	end

	local fItem = items[1]
	local lItem = items[#items]

	local t = fItem:getPositionY() + fItem:getContentSize().height
	local b = lItem:getPositionY()

	local iC = self:getInnerContainer()
	local h = math.abs(b - t)

	local itemC = self.itemsContainer

	local cS = self:getContentSize()
	if h >= cS.height then
		iC:setContentSize(cc.size(iC:getContentSize().width, h))

		local oldY = itemC:getPositionY()
		itemC:setPositionY(- b)
		iC:setPositionY(iC:getPositionY() -((- b) - oldY))
	else
		iC:setContentSize(cS)

		itemC:setPositionY(- b +(cS.height - h))
		iC:setPositionY(0)
	end
end

--- 尝试向下刷新数据项
function T:tryAddpend_b()
	local wP = self:convertToWorldSpace(cc.p(0, self:getPositionY()))
	local b, t = wP.y, wP.y + self:getContentSize().height
	self:toUpCalac(t,b)
end

--- 尝试向上刷新数据项
function T:tryAddpend_t()
	local wP = self:convertToWorldSpace(cc.p(0, self:getPositionY()))
	local b, t = wP.y, wP.y + self:getContentSize().height
	self:toDnCalac(t,b)
end

--- 更新视图
function T:updateView()
	for _ in pairs(self.itemsList) do
		self:_removeItem_b()
	end

	self:_appendItem_b()
	self.showSIndex=#self.itemsList > 0 and 1 or 0

	self:tryAddpend_b()
end

--- 设置条目对象模板
function T:setUiItemTemplate(value)
	if value ~= self.uiItemTemplate then
		self.uiItemTemplate=value
	end
end
--- 获取条目对象模板
function T:getUiItemTemplate()
	return self.uiItemTemplate
end

--- 设置数据列表(必须为标准的数组)
function T:setDataList(value)
	if value ~= self.dataList then
		for _ in pairs(self.itemsList) do
			self:_removeItem_b()
		end

		self.dataList=value

		if #self.dataList > 0 then
			self:_appendItem_b()
			self.showSIndex=#self.itemsList > 0 and 1 or 0

			local wP = self:convertToWorldSpace(cc.p(0, self:getPositionY()))
			local b, t = wP.y, wP.y + self:getContentSize().height
			self:toUpCalac(t,b)
		end
	end
end
--- 获取数据列表
function T:getDataList()
	return self.dataList
end

--- 条目之间的间隔
function T:setItemsMargin(value)
	if value ~= self._itemMargin then
		self._itemMargin=value

		---TODO 更新视图
	end
end
--- 条目之间的间隔
function T:getItemsMargin()
	return self._itemMargin
end

--- 在末尾追加一个数据项
function T:pushItemData(data)
	if self.dataList then
		self.dataList[#self.dataList+1]=data

		if #self.itemsList == 0 then
			self:_appendItem_b()
			self.showSIndex=#self.itemsList > 0 and 1 or 0
		end
		self:tryAddpend_b()
	end
end

--- 从末尾弹出一个数据项
function T:popItemData()
	if self.dataList then
		if self.showEIndex == #self.dataList and self.showEIndex > 0 then
			self:_removeItem_b()
			table.remove(self.dataList)

			self:calcHeight()

			local items=self.itemsList
			if #items <= 0 then
				return
			end

			local wP = self:convertToWorldSpace(cc.p(0, self:getPositionY()))
			local b = wP.y

			local item = items[#items]
			local wP = item:convertToWorldSpace({x=0, y=item:getContentSize().height})

			if wP.y > b then
				self:getInnerContainer():setPositionY(0)

				self:tryAddpend_t()
			end
		end
	end
end

--- 更新指定项的数据
function T:updateItemData(index,data)
	if index >= self.showSIndex and index <= self.showEIndex then
		self.itemsList[index-self.showSIndex+1]:setData(data)
	end
end

return T
