local _print = print
local function print(...)
	_print("<LogRecordUnlocker>: ", table.concat( { ...}, "\t"))
end

local T = Class.LogRecordUnlocker(
	function() return ccui.Layout:create() end
)

--T.STANDARD_RADIAN={30,30,90,180}

T.STANDARD_RADIAN={0,0,245,270}

function T:def()
end

function T:ctor()
	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)

	self:init()
end

--- 进入场景(播放声音,刷新数据等)
function T:onEnter()
end

--- 退出场景(关闭声音等)
function T:onExit()

end

--- 内存清理
function T:cleanUp()

end

--- 初始化
function T:init()
	self:setContentSize(cc.size(480,320))

	--	self:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	--	self:setBackGroundColor(cc.c3b(0,0,0))
	--	self:setBackGroundColorOpacity(100)

	self:initTouchListener()
end

--- 初始化 touch 事件侦听器
function T:initTouchListener()
	local listener = cc.EventListenerTouchOneByOne:create()
	listener:setSwallowTouches(true)

	local stardard=self.STANDARD_RADIAN
	local l=#stardard
	local lTime,isStarted=nil,false
	local index,sPt,ePt=nil,nil,nil

	---开始拖动
	local onTouchBegan = function(t, e)
		lTime=TimeUtils:getCurrentMillis()
		sPt=t:getLocation()

		return true
	end

	---拖动
	local onTouchMoved = function(t, e)
		local p=t:getLocation()

		return true
	end

	--- 拖动结束
	local onTouchEnded = function(t, e)
		if not isStarted then
			if TimeUtils:getCurrentMillis() - lTime >= 1000 then
				print("开始")

				index=1
				isStarted=true
			end
		else
			ePt=t:getLocation()

			local angle=(math.deg(math.atan2(ePt.y-sPt.y,ePt.x-sPt.x))+360)%360
			print("角度:",angle)
			local testAngle=stardard[index]
			if math.abs(angle-testAngle) <= 20 or math.abs(angle-360-testAngle) <= 20 then
				if index == l then
					print("解锁")

					LogRecorder:setIsEnabled(true)
					LogIcon:show()

					index=nil
					isStarted=false
					
					self:removeFromParent()
				else
					index=index+1
				end
			else
				print("错误")

				index=nil
				isStarted=false
			end
		end

		return true
	end

	listener:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN)
	listener:registerScriptHandler(onTouchMoved, cc.Handler.EVENT_TOUCH_MOVED)
	listener:registerScriptHandler(onTouchEnded, cc.Handler.EVENT_TOUCH_ENDED)
	local eventDispatcher = self:getEventDispatcher()
	eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)
end

return T
