--- UI抽象类
local T=Class.AbstractUI()

function T:def()

end

--- 构造函数
function T:ctor()
	self:registerScriptHandler(function(e)
		if e == CocosEvent.ENTER then
			self:onEnter()
		elseif e == CocosEvent.EXIT then
			self:onExit()
		elseif e == CocosEvent.CLEAN_UP then
			self:cleanUp()
		end
	end)
end

--- 被添加到父节点
function T:onEnter()end

--- 被从父节点移除
function T:onExit()end

--- 内存清理
function T:cleanUp()end

--- 间隔调用
-- @param self
-- @param callback 回调函数
-- @param delaySec 延迟的秒数
-- @return 任务ID
function T:interval(callback, delay)
	local r=cc.RepeatForever:create(
		cc.Sequence:create(
			cc.DelayTime:create(delay),
			cc.CallFunc:create(callback)
		)
	)
	self:runAction(r)

	return r
end

--- 延迟执行
-- @param self
-- @param callback 回调函数
-- @param delaySec 延迟的秒数
-- @return 任务ID
function T:timeout(callback, delay)
	local s=cc.Sequence:create(
		cc.DelayTime:create(delay),
		cc.CallFunc:create(callback)
	)
	self:runAction(s)

	return s
end

--- 清除任务(间隔调用/延迟执行)
-- @param self
-- @param action 任务ID
function T:clearScheduler(action)
	self:stopAction(action)
end

return T
