--- 单选按钮组
local T=Class.RadioButtonGroup(LuaEventDispatcher2)

function T:def()
	LuaEventDispatcher2.def(self)

	--- 按钮列表
	self.buttons={}

	--- 当前按钮
	-- self.curButton=nil
end

--- 单选按钮组
-- @param ... 按钮列表
function T:ctor(...)
	LuaEventDispatcher2.ctor(self)

	local btns={...}
	for k,v in pairs(btns) do
		self:addButton(v)
	end
end

--- 添加按钮
-- @param toggleButton 交换按钮
function T:addButton(toggleButton)
	if not toggleButton then
		return false
	end

	for k,v in pairs(self.buttons) do
		if v == toggleButton then
			return false
		end
	end
	table.insert(self.buttons,toggleButton)
	toggleButton:luaAddEventListener("change",self,self.button_statusChangeHandler)

	return true
end

--- 移除按钮
-- @param toggleButton 交换按钮
function T:rmButton(toggleButton)
	for k,v in pairs(self.buttons) do
		if v == toggleButton then
			table.remove(self.buttons,k)
			toggleButton:luaRemoveEventListener("change",self,self.button_statusChangeHandler)

			return true
		end
	end

	return false
end

--- 移除所有按钮
function T:rmAllButtons()
	for k,v in pairs(self.buttons) do
		v:luaRemoveEventListener("change",self,self.button_statusChangeHandler)
	end

	self.buttons={}
end

--- 按钮的状态发生改变
-- @param toggleButton 状态发生改变的按钮
function T:button_statusChangeHandler(toggleButton)
	if not toggleButton then
		return
	end

    if self.curButton == toggleButton then
		return
    end

	if self.curButton then
		self.curButton:setIsSelected(false)
        self.curButton:setTouchEnabled(true)
	end
	
	self.curButton=toggleButton
    toggleButton:setTouchEnabled(false)
	self:luaDispatchEvent("change",toggleButton)
end

--- 设置当前按钮
-- @param toggleButton 交换按钮
function T:setCurButton(toggleButton)
	if not toggleButton then
		return false
	end

	if self.curButton ~= toggleButton then
		if self.curButton then
		    self.curButton:setIsSelected(false)
            self.curButton:setTouchEnabled(true)
	    end
		toggleButton:setIsSelected(true)
        toggleButton:setTouchEnabled(false)
		self.curButton=toggleButton


		self:luaDispatchEvent("change",toggleButton)

		return true
	end
	return false
end

return T
