--- 交换按钮
local T=Class.ToggleButton(
	function()
		local o=ccui.ImageView:create()
		o.__addTouchEventListener__ = o.addTouchEventListener
		return o
	end,
	AbstractUI,
	LuaEventDispatcher2
)

function T:def()
	AbstractUI.def(self)
	LuaEventDispatcher2.def(self)

	--- 是否已被选择
	self.isSelected=false
end

--- 交换按钮
-- @param normalStatusUrl 未选择状态下的纹理URL
-- @param selectedStatusUrl 已选择状态下的纹理URL
-- @param textureResType 纹理URL类型(默认为plist)
function T:ctor(normalStatusUrl,selectedStatusUrl,textureResType)
	AbstractUI.ctor(self)
	LuaEventDispatcher2.ctor(self)

	self.__nImgUrl__=normalStatusUrl
	self.__sImgUrl__=selectedStatusUrl
	self.__resType__=textureResType or ccui.TextureResType.plistType

	self:_init()
end

--- 进入
function T:onEnter()
	AbstractUI.onEnter(self)
end

--- 退出
function T:onExit()
	AbstractUI.onExit(self)
end

--- 内存清理
function T:cleanUp()
	AbstractUI.cleanUp(self)
end

--- 初始化
function T:_init()
	self:setTouchEnabled(true)

	self:__addTouchEventListener__(
		function(t, e)
			if e == ccui.TouchEventType.began then
				AudioManager:playEffect(SoundRes.SOUND_COMMON_BUTTON)

				t:luaDispatchEvent("__touch_trigger", t, e)
			elseif e == ccui.TouchEventType.ended then
				t:luaDispatchEvent("__touch_trigger", t, e)

				self:_switchStatus()
			elseif e == ccui.TouchEventType.moved then
				t:luaDispatchEvent("__touch_trigger", t, e)
			elseif e == ccui.TouchEventType.cancel then
				t:luaDispatchEvent("__touch_trigger", t, e)
			end
		end
	)

	self:loadTexture(self.__nImgUrl__,self.__resType__)
end

function T:addTouchEventListener(callback)
	self:luaAddEventListener("__touch_trigger", nil, callback)
end

--- 切换状态
function T:_switchStatus()
	self.isSelected=not self.isSelected

	if self.isSelected then
		self:loadTexture(self.__sImgUrl__,self.__resType__)
	else
		self:loadTexture(self.__nImgUrl__,self.__resType__)
	end

	self:luaDispatchEvent("change",self)
end

--- 设置是否已被选择
function T:setIsSelected(value)
	if value ~= self.isSelected then
		self:_switchStatus()
	end
end

function T:getIsSelected()
	return self.isSelected
end

return T
