local _print=print
local function print(...)
	_print("\t<AbstractGroundPlayer>: ",table.concat({...},"\t"))
end

--- 地面特效播放器
local T=Class.AbstractGroundPlayer(
	function()
		return cc.Node:create()
	end,
	AbstractUI
)

function T:def()
	AbstractUI.def(self)

	--- 地面网格
	-- _gGrid

	--- 可视区域
	self._vRect=cc.rect(0,0,0,0)

	--- update 时 x 偏移
	self.offsetX=0

	--- update 时 y 偏移
	self.offsetY=0

	--- 移动的 action
	-- _moveAct
end

function T:ctor()
	AbstractUI.ctor(self)

	--- 地面网格
	self._gGrid=self:_createGroundGrid()
	self:addChild(self._gGrid)
end

--- 创建地面网格
function T:_createGroundGrid()

end

--- 更新视图
-- @param visibleRect 可视化区域(拷贝)
function T:updateView(visibleRect)
	if visibleRect then
		mapping(self._vRect,visibleRect)
	end

	self._gGrid:updateGrid()
end

--- 播放
-- @param visibleRect 可视化区域(拷贝)
function T:play(visibleRect)
	local _gGrid=self._gGrid
	local _vRect=self._vRect

	if visibleRect then
		mapping(_vRect,visibleRect)
	end
	_gGrid:updateGrid()

	self:stop()
	self._moveAct=self:interval(
		function()
			--修改可视化区域
			_vRect.x=_vRect.x-self.offsetX
			_vRect.y=_vRect.y-self.offsetY
			_gGrid:updateGrid()

			--实现移动效果
			local x,y=_gGrid:getPosition()
			_gGrid:setPosition(x+self.offsetX,y+self.offsetY)
		end,
		0
	)
end

--- 停止播放
function T:stop()
	if self._moveAct then
		self:clearScheduler(self._moveAct)
		self._moveAct=nil
	end
end

--- 获取当前可视化区域(拷贝)
function T:getVisibleRect()
	return mapping({},self._vRect)
end

--- 设置偏移量
function T:setOffset(x,y)
	self.offsetX,self.offsetY=x,y
end
--- 获取偏移量
function T:getOffset()
	return self.offsetX,self.offsetY
end

--- 获取地面网格
function T:getGround()
	return self._gGrid
end

return T
