--- 分享图片
local SHARE_BMP_URL="http://d2p8sb0y8ozx3t.cloudfront.net/image/warplane.jpg"

local luaj = LuaJavaBridge

local LuaInterface="org.cocos2dx.lua.LuaInterface"

local AbstractSDKDelegate=require("src.frameworks.platformSDKs.AbstractSDKDelegate")

local T=Class.SDK_Android_enjoyGame_Delegate(AbstractSDKDelegate)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

--- SDK事件类型-快速登陆成功
T.SDK_EVT_TYPE_QUICKLY_LOGIN_SUCCESS=0

--- SDK事件类型-登陆成功
T.SDK_EVT_TYPE_LOGIN_SUCCESS=1

--- SDK事件类型-注册成功
T.SDK_EVT_TYPE_REGISTER_SUCCESS=2

--- SDK事件类型-登陆失败
T.SDK_EVT_TYPE_LOGIN_FAIL=3

--- SDK事件类型-登出
T.SDK_EVT_TYPE_LOGINOUT=4

--- SDK事件类型-支付成功
T.SDK_EVT_TYPE_PAY_SUCCESS=5

--- SDK事件类型-支付失败
T.SDK_EVT_TYPE_PAY_FAILURE=6

--- SDK事件类型-google支付成功
T.SDK_EVT_TYPE_GG_PAY_SUCCESS=7

--- SDK事件类型-分享成功
T.SDK_EVT_TYPE_SHARE_SUCCESS=8

--- SDK事件类型-分享失败
T.SDK_EVT_TYPE_SHARE_FAILURE=9


--事件类型>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>



--事件类型<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

function T:def()
	AbstractSDKDelegate.def(self)

	--- 用户ID
	-- _uid

	--- 用户名
	-- _uName

	--- 登陆token
	-- _token

	--- 是否游客
	-- _isTourist
end

function T:ctor()
	AbstractSDKDelegate.ctor(self)

	self:init()
end

function T:init()
	print("初始化")

	local _execResultHandler=function(jsonstr)
		Cocos2dxUtils:timeOut(function()
			self:execResultHandler(jsonstr)
		end,0)
	end

	--设置回调
	luaj.callStaticMethod(
		LuaInterface,
		"set2luaCallback",
		{_execResultHandler},
		"(I)V"
	)

	CommonBroadcast:luaAddEventListener(EVT_TYPE_KEY_PRESSED,self,self.onKeyReseased)
	CommonBroadcast:luaAddEventListener(EVT_TYPE_KEY_RELEASED,self,self.onKeyReseased)
end

function T:execResultHandler(jsonstr)
	if not jsonstr then
		print("从java返回的事件数据为 nil")
		
		return
	end

	print(jsonstr)
	local result=json:decode(jsonstr)
	print(obj2str(result))

	local sdkEvtType=result.evtType
	print("sdkEvtType:",sdkEvtType)
	local data=result.data
	if sdkEvtType == self.SDK_EVT_TYPE_QUICKLY_LOGIN_SUCCESS then
		if not data.userName or string.trim(data.userName) == "" then
			self._isTourist=true
		else
			self._isTourist=false
			self._uName=data.userName
		end
		self._uid=data.uid
		self._token=data.token

		print(string.format("快速登陆=>uid:%s,uName:%s,token:%s",self._uid,self._uName,self._token))
		self:luaDispatchEvent(self.EVT_TYPE_LOGIN_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_LOGIN_SUCCESS then
		if not data.userName or string.trim(data.userName) == "" then
			self._isTourist=true
		else
			self._isTourist=false
			self._uName=data.userName
		end
		self._uid=data.uid
		self._token=data.token

		print(string.format("登陆=>uid:%s,uName:%s,token:%s",self._uid,self._uName,self._token))
		self:luaDispatchEvent(self.EVT_TYPE_LOGIN_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_REGISTER_SUCCESS then
		if not data.userName or string.trim(data.userName) == "" then
			self._isTourist=true
		else
			self._isTourist=false
			self._uName=data.userName
		end
		self._uid=data.uid
		self._token=data.token

		print(string.format("注册=>uid:%s,uName:%s,token:%s",self._uid,self._uName,self._token))
		self:luaDispatchEvent(self.EVT_TYPE_LOGIN_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_LOGIN_FAIL then
		print("登陆失败")
		self:luaDispatchEvent(self.EVT_TYPE_LOGIN_FAILURE)
	elseif sdkEvtType == self.SDK_EVT_TYPE_LOGINOUT then
		print("登出")
		self:luaDispatchEvent(self.EVT_TYPE_LOGINOUT)
	elseif sdkEvtType == self.SDK_EVT_TYPE_PAY_SUCCESS then
		print("第三方支付成功")
		self:luaDispatchEvent(self.EVT_TYPE_PAY_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_GG_PAY_SUCCESS then
		print("google支付成功")
		self:luaDispatchEvent(self.EVT_TYPE_PAY_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_PAY_FAILURE then
		print("支付失败")
		self:luaDispatchEvent(self.EVT_TYPE_PAY_FAILURE)

		CommonBroadcast:luaDispatchEvent(EVENT_IAP_BUY_GOODS_COMPLETE)
		CommonBroadcast:luaDispatchEvent(EVENT_IAP_BUY_NEW_RECHARGE_COMPLETE)
	elseif sdkEvtType == self.SDK_EVT_TYPE_SHARE_SUCCESS then
		print("分享成功")
		self:luaDispatchEvent(self.EVT_TYPE_SHARE_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_SHARE_FAILURE then
		print("分享失败")
		self:luaDispatchEvent(self.EVT_TYPE_SHARE_FAILURE)
	end
end

function T:onKeyPressed(keyCode,evt)

end

local uiCloseTip=nil

function T:onKeyReseased(keyCode,evt)
	if C_PFM == cc.PLATFORM_OS_ANDROID then
		if keyCode ~= cc.KeyCodeKey.KEY_BACK then
			return
		end

		if uiCloseTip then
			return
		end

		uiCloseTip=MUIAlter.show({
			info=Language:get("ug_quitTip"),
			flag=3,
			confirTtype=14,
			cancelType=11,
			callback=function(flag)
				uiCloseTip=nil

				if flag == FLAG_OK then
					luaj.callStaticMethod(LuaInterface,"doQuit",{},"()V")
				end
			end
		})
	end
end

function T:doLogin()
	luaj.callStaticMethod(LuaInterface,"login",{},"()V")
end

function T:doSwitchAccount()
	luaj.callStaticMethod(LuaInterface,"switchAccount",{},"()V")
end

function T:doOpenUserCenter()
	luaj.callStaticMethod(LuaInterface,"openUserCenter",{},"()V")
end

--- 第三方支付
function T:doPay(roleId,extraData)
	local jsonObj={
		uid=self:getUid(),
		productName="gems",
		roleId=roleId,
		extraData=extraData,
	}

	local jsonstr=json:encode(jsonObj)
	print(jsonstr)
	luaj.callStaticMethod(LuaInterface,"pay",{jsonstr,false},"(Ljava/lang/String;Z)V")
end

--- google支付
function T:doPayGG(productName,extraData)
	local jsonObj={
		uid=self:getUid(),
		sku=productName,
		extraData=extraData,
	}

	local jsonstr=json:encode(jsonObj)
	luaj.callStaticMethod(LuaInterface,"pay",{jsonstr,true},"(Ljava/lang/String;Z)V")
end

--- 分享-facebook
function T:doShare_facebook(title,desc)
	local jsonObj={
		title=title,
		desc=desc,
		url=GameCfg.CPP_UPDATE_URL,
		imageUrl=SHARE_BMP_URL
	}

	print(obj2str(jsonObj))

	local jsonstr=json:encode(jsonObj)
	luaj.callStaticMethod(LuaInterface,"shareFacebook",{jsonstr},"(Ljava/lang/String;)V")
end

function T:doOpenUrl(url)
	print("lua open url=>",url)

	luaj.callStaticMethod(LuaInterface,"luaOpenUrl",{url},"(Ljava/lang/String;)V")
end

--- 邀请-facebook
function T:invite_facebook(appLinkUrl, previewImageUrl)
	local jsonObj={
		appLinkUrl=appLinkUrl,
		previewImageUrl=previewImageUrl,
	}

	local jsonstr=json:encode(jsonObj)
	luaj.callStaticMethod(LuaInterface,"inviteFacebook",{jsonstr},"(Ljava/lang/String;)V")
end

--- 邀请2-facebook
function T:invite_facebook2(contentText)
	local jsonObj={
		contentText=contentText,
	}

	local jsonstr=json:encode(jsonObj)
	luaj.callStaticMethod(LuaInterface,"inviteFacebook2",{jsonstr},"(Ljava/lang/String;)V")
end

--- 跟踪-服务器名
function T:traking_gameServerName(value)
	luaj.callStaticMethod(LuaInterface,"traking_gameServerName",{value},"(Ljava/lang/String;)V")
end

--- 跟踪-角色等级
function T:traking_roleLevel(value)
	luaj.callStaticMethod(LuaInterface,"traking_roleLevel",{value},"(I)V")
end

--- 跟踪-开始支付
-- @param orderId 订单ID，最多64个字符。用于唯一标识一次交易。
-- @param iapId 充值包ID，最多32个字符。例如：VIP3礼包、500元10000宝石包
-- @param currencyAmount 充值的金额。
-- @param currencyType 货币类型(请使用国际标准组织ISO 4217中规范的3位字母代码标记货币类型.如:人民币CNY；美元USD；欧元EUR)
-- @param virtualCurrencyAmount 虚拟币金额
-- @param paymentType 支付的途径，最多16个字符。例如：“支付宝”“苹果官方”“XX支付SDK”
function T:traking_startPay(orderId, iapId, currencyAmount, currencyType, virtualCurrencyAmount, paymentType)
	local jsonObj={
		orderId=orderId,
		iapId=iapId,
		currencyAmount=currencyAmount,
		currencyType=currencyType,
		virtualCurrencyAmount=virtualCurrencyAmount,
		paymentType=paymentType,
	}

	local jsonstr=json:encode(jsonObj)
	luaj.callStaticMethod(LuaInterface,"traking_startPay",{jsonstr},"(Ljava/lang/String;)V")
end

--- 跟踪-支付完成
-- -- @param orderId 订单ID，最多64个字符。用于唯一标识一次交易。
-- @param iapId 充值包ID，最多32个字符。例如：VIP3礼包、500元10000宝石包
-- @param currencyAmount 充值的金额。
-- @param currencyType 货币类型(请使用国际标准组织ISO 4217中规范的3位字母代码标记货币类型.如:人民币CNY；美元USD；欧元EUR)
-- @param virtualCurrencyAmount 虚拟币金额
-- @param paymentType 支付的途径，最多16个字符。例如：“支付宝”“苹果官方”“XX支付SDK”
function T:traking_paySuccess(orderId, iapId, currencyAmount, currencyType, virtualCurrencyAmount, paymentType)
	local jsonObj={
		orderId=orderId,
		iapId=iapId,
		currencyAmount=currencyAmount,
		currencyType=currencyType,
		virtualCurrencyAmount=virtualCurrencyAmount,
		paymentType=paymentType,
	}

	local jsonstr=json:encode(jsonObj)
	luaj.callStaticMethod(LuaInterface,"traking_paySuccess",{jsonstr},"(Ljava/lang/String;)V")
end

--- 获取用户ID
function T:getUid()
	return self._uid
end

--- 获取用户名
function T:getUserName()
	return self._uName
end

--- 获取登陆token
function T:getAccessToken()
	return self._token
end

--- 获取是否是游客
function T:getIsTourist()
	return self._isTourist
end

return T()
