--- 分享图片
local SHARE_BMP_URL="http://d2p8sb0y8ozx3t.cloudfront.net/image/warplane.jpg"

local luaoc = require("src.cocos.cocos2d.l_oc")

local AbstractSDKDelegate=require("src.frameworks.platformSDKs.AbstractSDKDelegate")

local T=Class.SDK_IOS_enjoyGame_Delegate(AbstractSDKDelegate)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

--登陆状态>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--- 登陆状态-登陆
T.LOGIN_STATE_LOGIN=0

--- 登陆状态-重新登陆
T.LOGIN_STATE_RELOGIN=1

--- 登陆状态-切换账号
T.LOGIN_STATE_SWITCH=2
--登陆状态<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

--- SDK事件类型-快速登陆成功
T.SDK_EVT_TYPE_QUICKLY_LOGIN_SUCCESS=0

--- SDK事件类型-登陆成功
T.SDK_EVT_TYPE_LOGIN_SUCCESS=1

--- SDK事件类型-注册成功
T.SDK_EVT_TYPE_REGISTER_SUCCESS=2

--- SDK事件类型-开始切换账号
T.SDK_EVT_TYPE_SWITCH_ACCOUNT_START=3

--- SDK事件类型-关闭d9页面
T.SDK_EVT_TYPE_CLOSE_D9_VIEW=4

--- SDK事件类型-修改密码成功
T.SDK_EVT_TYPE_CHANGE_PWD_SUCCESS=5

--- SDK事件类型-绑定成功
T.SDK_EVT_TYPE_BIND_SUCCESS=6

--- SDK事件类型-分享成功
T.SDK_EVT_TYPE_SHARE_SUCCESS=7

--- SDK事件类型-分享失败
T.SDK_EVT_TYPE_SHARE_FAILURE=8

--- SDK事件类型-分享被取消
T.SDK_EVT_TYPE_SHARE_CANECL=9

--事件类型>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
--- 事件-切换账号开始
T.EVT_TYPE_SWITCH_ACCOUNT_START="evt_type_switch_account_start"

--事件类型<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

function T:def()
	AbstractSDKDelegate.def(self)

	--- 登陆状态
	self._login_state=self.LOGIN_STATE_LOGIN

	--- 用户ID
	-- _uid

	--- 用户名
	-- _uName

	--- 登陆token
	-- _token

	--- 是否游客
	-- _isTourist
end

function T:ctor()
	AbstractSDKDelegate.ctor(self)

	self:init()
end

function T:init()
	print("初始化")

	local _execResultHandler=function(sdkEvtType,jsonstr)
		Cocos2dxUtils:timeOut(function()
			self:execResultHandler(sdkEvtType,jsonstr)
		end,0)
	end

	luaoc.callStaticMethod("SDK_Delegate", "init", {
		callback=_execResultHandler
	})
	
	CommonBroadcast:luaAddEventListener(BACK_2_LOGIN_SCENCE,nil,function()
		self:rmvMask()
	end)
end

function T:execResultHandler(sdkEvtType,jsonstr)
	if not jsonstr then
		print("出错了")
	end

	print("sdkEvtType:",sdkEvtType)
	print(jsonstr)
	local result=json:decode(jsonstr)
	print(obj2str(result))

	if sdkEvtType == self.SDK_EVT_TYPE_QUICKLY_LOGIN_SUCCESS then
		self:rmvMask()

		self._isTourist=tonumber(result.binding) == 0
		self._uid=result.uid
		self._uName=result.userName
		self._token=result.token

		print(string.format("快速登陆=>uid:%s,uName:%s,token:%s",self._uid,self._uName,self._token))
		self:luaDispatchEvent(self.EVT_TYPE_LOGIN_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_LOGIN_SUCCESS then
		self:rmvMask()

		self._isTourist=false
		self._uid=result.userid
		self._uName=result.userName
		self._token=result.token

		print(string.format("登陆=>uid:%s,uName:%s,token:%s",self._uid,self._uName,self._token))
		self:luaDispatchEvent(self.EVT_TYPE_LOGIN_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_REGISTER_SUCCESS then
		self:rmvMask()

		self._isTourist=false
		self._uid=result.userid
		self._uName=result.userName
		self._token=result.token

		print(string.format("注册=>uid:%s,uName:%s,token:%s",self._uid,self._uName,self._token))
		self:luaDispatchEvent(self.EVT_TYPE_LOGIN_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_SWITCH_ACCOUNT_START then
		self:addMask()
		
		self:luaDispatchEvent(self.EVT_TYPE_SWITCH_ACCOUNT_START)
	elseif sdkEvtType == self.SDK_EVT_TYPE_CLOSE_D9_VIEW then
		self:rmvMask()
	elseif sdkEvtType == self.SDK_EVT_TYPE_CHANGE_PWD_SUCCESS then
		self:rmvMask()
	elseif sdkEvtType == self.SDK_EVT_TYPE_BIND_SUCCESS then
		self:rmvMask()
	elseif sdkEvtType == self.SDK_EVT_TYPE_SHARE_SUCCESS then
		print("分享成功")
		self:luaDispatchEvent(self.EVT_TYPE_SHARE_SUCCESS)
	elseif sdkEvtType == self.SDK_EVT_TYPE_SHARE_FAILURE then
		print("分享失败")
		self:luaDispatchEvent(self.EVT_TYPE_SHARE_FAILURE)
	elseif sdkEvtType == self.SDK_EVT_TYPE_SHARE_CANECL then
		print("分享被取消")
		self:luaDispatchEvent(self.EVT_TYPE_SHARE_FAILURE)
	end
end

function T:doLogin()
	self:addMask()
	luaoc.callStaticMethod("SDK_Delegate", "login", nil)
end

function T:doSwitchAccount()
	self:addMask()
	luaoc.callStaticMethod("SDK_Delegate", "switchAccount", nil)
end

function T:doOpenUserCenter()
	self:addMask()
	luaoc.callStaticMethod("SDK_Delegate", "bindAccount", nil)
end

function T:doAppstorePay(productId,uid,roleId,goodsId,goodsName,goodsCount,price,currency,description)
--	self:addMask()
	luaoc.callStaticMethod("SDK_Delegate", "appstorePay", {
		productId=productId,
		uid=uid,
		roleId=roleId,
		goodsId=goodsId,
		goodsName=goodsName,
		goodsCount=goodsCount,
		price=price,
		currency=currency,
		description=description,
	})
end

function T:doWebPay(productId,uid,roleId,goodsId,goodsName,goodsCount,price,currency,description)
--	self:addMask()
	luaoc.callStaticMethod("SDK_Delegate", "webPay", {
		productId=productId,
		uid=uid,
		roleId=roleId,
		goodsId=goodsId,
		goodsName=goodsName,
		goodsCount=goodsCount,
		price=price,
		currency=currency,
		description=description,
	})
end

--- 分享-facebook
function T:doShare_facebook(title,desc)
	luaoc.callStaticMethod("SDK_Delegate", "facebookShare", {
		title=title,
		desc=desc,
		url=GameCfg.CPP_UPDATE_URL,
		imageUrl=SHARE_BMP_URL
	})
end

--- 跟踪-服务器名
function T:traking_gameServerName(value)
	luaoc.callStaticMethod("SDK_Delegate", "traking_gameServerName", {
		serverName=value,
	})
end

--- 跟踪-角色等级
function T:traking_roleLevel(value)
	luaoc.callStaticMethod("SDK_Delegate", "traking_roleLevel", {
		roleLevel=value,
	})
end

--- 跟踪-开始支付
-- @param orderId 订单ID，最多64个字符。用于唯一标识一次交易。
-- @param iapId 充值包ID，最多32个字符。例如：VIP3礼包、500元10000宝石包
-- @param currencyAmount 充值的金额。
-- @param currencyType 货币类型(请使用国际标准组织ISO 4217中规范的3位字母代码标记货币类型.如:人民币CNY；美元USD；欧元EUR)
-- @param virtualCurrencyAmount 虚拟币金额
-- @param paymentType 支付的途径，最多16个字符。例如：“支付宝”“苹果官方”“XX支付SDK”
function T:traking_startPay(orderId, iapId, currencyAmount, currencyType, virtualCurrencyAmount, paymentType)
	luaoc.callStaticMethod("SDK_Delegate", "traking_startPay", {
		orderId=orderId,
		iapId=iapId,
		currencyAmount=currencyAmount,
		currencyType=currencyType,
		virtualCurrencyAmount=virtualCurrencyAmount,
		paymentType=paymentType,
	})
end

--- 跟踪-支付完成
-- -- @param orderId 订单ID，最多64个字符。用于唯一标识一次交易。
-- @param iapId 充值包ID，最多32个字符。例如：VIP3礼包、500元10000宝石包
-- @param currencyAmount 充值的金额。
-- @param currencyType 货币类型(请使用国际标准组织ISO 4217中规范的3位字母代码标记货币类型.如:人民币CNY；美元USD；欧元EUR)
-- @param virtualCurrencyAmount 虚拟币金额
-- @param paymentType 支付的途径，最多16个字符。例如：“支付宝”“苹果官方”“XX支付SDK”
function T:traking_paySuccess(orderId, iapId, currencyAmount, currencyType, virtualCurrencyAmount, paymentType)
	luaoc.callStaticMethod("SDK_Delegate", "traking_paySuccess", {
		orderId=orderId,
		iapId=iapId,
		currencyAmount=currencyAmount,
		currencyType=currencyType,
		virtualCurrencyAmount=virtualCurrencyAmount,
		paymentType=paymentType,
	})
end

--- 添加防误操作遮罩
function T:addMask()
	if self.uiMask then
		return
	end

	local uiMask=ccui.Layout:create()
	uiMask:setBackGroundColorType(ccui.LayoutBackGroundColorType.solid)
	uiMask:setBackGroundColor(cc.c3b(0,0,0))
	uiMask:setBackGroundColorOpacity(80)
	uiMask:setTouchEnabled(true)
	uiMask:setLocalZOrder(TOP_ORDER + 100)

	local p=Director:getRunningScene()
	if p then
		p:addChild(uiMask)

		REL:relScreen(uiMask,0,0,0,0)
		self.uiMask=uiMask
	end
end
--- 移除防误操作遮罩
function T:rmvMask()
	if self.uiMask then
		self.uiMask:removeFromParent()
		self.uiMask = nil
	end
end

--- 设置登陆状态
function T:setLoginState(value)
	if value ~= self._login_state then
		self._login_state=value
	end
end
--- 获取登陆状态
function T:getLoginState()
	return self._login_state
end

--- 获取用户ID
function T:getUid()
	return self._uid
end

--- 获取用户名
function T:getUserName()
	return self._uName
end

--- 获取登陆token
function T:getAccessToken()
	return self._token
end

--- 获取是否是游客
function T:getIsTourist()
	return self._isTourist
end

return T()
