local luaj = LuaJavaBridge

local LuaInterface="org.cocos2dx.lua.weixin.LuaInterface_wx"

local T=Class.SDK_Android_weixin_Delegate(LuaEventDispatcher2)

local _print=print
local function print(...)
	_print(string.format("\t<%s>:%s",T.__name,table.concat({...},"\t")))
end

--事件类型>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

--- SDK事件类型-启动微信成功
T.START_WX_SUCCESS=1

--- SDK事件类型-启动微信失败
T.START_WX_FAIL=2

--- SDK事件类型-微信版本过低
T.LOW_WX_SDK=3

--- SDK事件类型-分享成功
T.SHARE_SUCCESS=4

--- SDK事件类型-分享失败
T.SHARE_FAIL=5

--- SDK事件类型-未知错误
T.UNKNOWN_ERROR=6

--事件类型<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<


function T:def()
    LuaEventDispatcher2.def(self)
end

function T:ctor()

	self:init()
end

function T:init()
	print("初始化")

	local _execResultHandler=function(jsonstr)
		Cocos2dxUtils:timeOut(function()
			self:execResultHandler(jsonstr)
		end,0)
	end

	--设置回调
	luaj.callStaticMethod(
		LuaInterface,
		"setluaCallback",
		{_execResultHandler},
		"(I)V"
	)

end

function T:execResultHandler(jsonstr)
	if not jsonstr then
		print("出错了")
	end

	print(jsonstr)
	local result=json:decode(jsonstr)
	print(obj2str(result))

	local sdkEvtType=result.evtType
	print("sdkEvtType:",sdkEvtType)

	if sdkEvtType == self.START_WX_SUCCESS then
		print("启动微信成功")
		self:luaDispatchEvent(self.START_WX_SUCCESS)
	elseif sdkEvtType == self.START_WX_FAIL then
		print("启动微信失败")
		self:luaDispatchEvent(self.START_WX_FAIL)
	elseif sdkEvtType == self.LOW_WX_SDK then
		print("微信版本过低")
		self:luaDispatchEvent(self.LOW_WX_SDK)
	elseif sdkEvtType == self.SHARE_SUCCESS then
		print("分享成功")
		self:luaDispatchEvent(self.SHARE_SUCCESS)
	elseif sdkEvtType == self.SHARE_FAIL then
		print("分享失败")
		self:luaDispatchEvent(self.SHARE_FAIL)
	elseif sdkEvtType == self.UNKNOWN_ERROR then
		print("未知错误")
		self:luaDispatchEvent(self.UNKNOWN_ERROR)
	end
end

--- 分享给好友
function T:sendMsgToFriend(text,title,description)
	local jsonObj={
		text=text,
		title=title,
		description=description,
	}

	local jsonstr=json:encode(jsonObj)
	print(jsonstr)
	luaj.callStaticMethod(LuaInterface,"sendMsgToFriend",{jsonstr},"(Ljava/lang/String;)V")

end

--- 分享给好友
function T:sendMsgToTimeLine(text,title,description)
	local jsonObj={
		text=text,
		title=title,
		description=description,
	}

	local jsonstr=json:encode(jsonObj)
	print(jsonstr)
	luaj.callStaticMethod(LuaInterface,"sendMsgToTimeLine",{jsonstr},"(Ljava/lang/String;)V")

end


return T()
