cc.FileUtils:getInstance():addSearchPath("src")
cc.FileUtils:getInstance():addSearchPath("res")

require "cocos.init"

if cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_WINDOWS then
	local _print = print
	local f = io.open("lua_log", "w+")
	f:write("\n")
	f:close()
	function print(...)
		_print(...)

		-- 将日志打印到文件
		local f = io.open("lua_log", "a")
		f:write(table.concat( { ...}, "  "))
		f:write("\n")
		f:close()
	end
end

require("src.cfg.CFG")

--- 打印LUA错误信息
-- @param msg 信息
function __G__TRACKBACK__(msg)
	local message="LUA ERROR: "..tostring(msg).."\n"..debug.traceback()
	LogRecorder:push(message,LOG_LEVEL_ERROR)
	if __print__ then
		__print__(message)
	else
		print(message)
	end
end

--- 初始化
local function init()
	local d=cc.Director:getInstance()
	local glview = d:getOpenGLView()

	-- 初始屏幕尺寸
	if nil == glview then
		if cc.Application:getInstance():getTargetPlatform() == cc.PLATFORM_OS_WINDOWS then
			glview = cc.GLViewImpl:createWithRect("PlanesWar", cc.rect(0, 0, 640, 960))

			glview:setFrameZoomFactor(0.7)
		else
			glview = cc.GLViewImpl:createWithFullScreen("PlanesWar")
		end
		d:setOpenGLView(glview)
	end

	local winsize = d:getWinSize();
	local trade = winsize.width/winsize.height;
	if math.abs(trade - 640.0/960.0) <= math.abs(trade - 640.0/1136.0) then
		glview:setDesignResolutionSize(640, 960, cc.ResolutionPolicy.EXACT_FIT)
	else
		glview:setDesignResolutionSize(640, 1136, cc.ResolutionPolicy.EXACT_FIT)
	end

	--	glview:setDesignResolutionSize(640, 960, cc.ResolutionPolicy.NO_BORDER)
	-------------------------------------------------------------------------------------------------

	-- 设置是否显示 FPS
	--	d:setDisplayStats(true)
	-- 设置 FPS.
	d:setAnimationInterval(1.0 / 60)

	--- 无尺寸值
	SIZE_NIL=-65535

	--- 文件引入
	require("src.frameworks.Imports")

	__print__=print
	function print(...)
		LogRecorder:push(table.concat({...},"\t"))
		__print__(...)
	end

	--- 导演
	Director=cc.Director:getInstance()
	--- 计时器
	Scheduler=Director:getScheduler()
	--- 纹理缓存器
	TextureCache=Director:getTextureCache()
	--- 帧缓存器
	SpriteFrameCache=cc.SpriteFrameCache:getInstance()

	--- 可视区域尺寸
	visibleSize=Director:getVisibleSize()
	V_SZ=visibleSize
	--- 可视区原点
	origin=Director:getVisibleOrigin()
	O_PT=origin
	--- 设备屏幕尺寸
	screenSize=Director:getOpenGLView():getFrameSize()

	local gView=Director:getOpenGLView()
	--- 内容的绽放X比例
	contentScaleX=gView:getScaleX()
	--- 内容的绽放Y比例
	contentScaleY=gView:getScaleY()
end

local function main()
	-- 执行一次全垃圾收集循环
	collectgarbage("collect")

	-- 垃圾回收相关参数设定
	collectgarbage("setpause", 100) -- 设置 arg/100 的值作为暂定收集的时长
	collectgarbage("setstepmul", 5000) -- 设置 arg/100 的值，作为步长的增幅(即新步长=旧步长*arg/100)

	-- 指定资源搜索路径
	cc.FileUtils:getInstance():addSearchResolutionsOrder("src");
	cc.FileUtils:getInstance():addSearchResolutionsOrder("res");

	print("--程序启动--------------------------------------------------------")
	print("时间:",os.date())

	--- 当前平台
	curPlatform=cc.Application:getInstance():getTargetPlatform()
	C_PFM=curPlatform

	local platformName = "unknow"
	if cc.PLATFORM_OS_IPHONE == C_PFM then
		platformName = "iphone"
	elseif cc.PLATFORM_OS_IPAD == C_PFM then
		platformName = "ipad"
	elseif cc.PLATFORM_OS_ANDROID == C_PFM then
		platformName = "android"
	elseif cc.PLATFORM_OS_MAC == C_PFM then
		platformName = "mac"
	elseif cc.PLATFORM_OS_WINDOWS == C_PFM then
		platformName = "windows"
	elseif cc.PLATFORM_OS_WP8 == C_PFM then
		platformName = "wp8"
	end
	print(string.format("目标平台:%s(code=%d)",platformName,C_PFM))
	print("当前语言:",cc.Application:getInstance():getCurrentLanguage())
	print("------------------------------------------------------------------")

	init()

	require("src.app.App"):startup()
end

xpcall(main, __G__TRACKBACK__)
